/*===========================================================================*/
/*   (Ast/pragma.scm)                                                        */
/*   Bigloo (2.5b)                                                           */
/*   Manuel Serrano (c)       Fri Sep 6 09:43:28 CEST 2002                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_nodez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
} *BgL_nodez00_bglt;

typedef struct BgL_nodezf2effectzf2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
} *BgL_nodezf2effectzf2_bglt;

typedef struct BgL_atomz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_atomz00_bglt;

typedef struct BgL_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_varz00_bglt;

typedef struct BgL_closurez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_closurez00_bglt;

typedef struct BgL_kwotez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_kwotez00_bglt;

typedef struct BgL_sequencez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_nodesz00;
} *BgL_sequencez00_bglt;

typedef struct BgL_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
} *BgL_appz00_bglt;

typedef struct BgL_appzd2lyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_appzd2lyzd2_bglt;

typedef struct BgL_funcallz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_strengthz00;
} *BgL_funcallz00_bglt;

typedef struct BgL_externz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_externz00_bglt;

typedef struct BgL_pragmaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_formatz00;
} *BgL_pragmaz00_bglt;

typedef struct BgL_getfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_getfieldz00_bglt;

typedef struct BgL_setfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_setfieldz00_bglt;

typedef struct BgL_newz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_newz00_bglt;

typedef struct BgL_vallocz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2heapzd2formatz00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_vallocz00_bglt;

typedef struct BgL_vrefz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vrefz00_bglt;

typedef struct BgL_vsetz12z12_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vsetz12z12_bglt;

typedef struct BgL_vlengthz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vlengthz00_bglt;

typedef struct BgL_isaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   struct BgL_typez00_bgl * BgL_classz00;
} *BgL_isaz00_bglt;

typedef struct BgL_castz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_castz00_bglt;

typedef struct BgL_setqz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_setqz00_bglt;

typedef struct BgL_conditionalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   struct BgL_nodez00_bgl * BgL_truez00;
   struct BgL_nodez00_bgl * BgL_falsez00;
} *BgL_conditionalz00_bglt;

typedef struct BgL_failz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_procz00;
   struct BgL_nodez00_bgl * BgL_msgz00;
   struct BgL_nodez00_bgl * BgL_objz00;
} *BgL_failz00_bglt;

typedef struct BgL_selectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   obj_t BgL_clausesz00;
   struct BgL_typez00_bgl * BgL_itemzd2typezd2;
} *BgL_selectz00_bglt;

typedef struct BgL_letzd2funzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_localsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_letzd2funzd2_bglt;

typedef struct BgL_letzd2varzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_bindingsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
   bool_t BgL_removablezf3zf3;
} *BgL_letzd2varzd2_bglt;

typedef struct BgL_setzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_setzd2exzd2itz00_bglt;

typedef struct BgL_jumpzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_exitz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_jumpzd2exzd2itz00_bglt;

typedef struct BgL_makezd2boxzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_makezd2boxzd2_bglt;

typedef struct BgL_boxzd2refzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_varz00;
} *BgL_boxzd2refzd2_bglt;

typedef struct BgL_boxzd2setz12zc0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_boxzd2setz12zc0_bglt;


static obj_t BGl_methodzd2initzd2zzast_pragmaz00();
extern obj_t open_input_string(obj_t);
extern long BGl_classzd2numzd2zz__objectz00(obj_t);
extern obj_t BGl_readz00zz__readerz00(obj_t);
extern BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_pragmaz00zzast_nodez00;
extern bool_t rgc_fill_buffer(obj_t);
extern obj_t BGl_stringzd2ze3numberz31zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(obj_t);
extern BgL_nodez00_bglt BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(bool_t, BgL_typez00_bglt, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zzast_pragmaz00();
static obj_t BGl_importedzd2moduleszd2initz00zzast_pragmaz00();
extern obj_t BGl_findzd2locationzf2locz20zztools_locationz00(obj_t, obj_t);
extern obj_t rgc_buffer_substring(obj_t, int, int);
extern obj_t BGl_modulezd2initializa7ationz75zzast_pragmaz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
extern long bgl_list_length(obj_t);
static obj_t BGl_zc3anonymousza32740ze3z83zzast_pragmaz00(obj_t, obj_t);
extern BgL_nodez00_bglt BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zzast_pragmaz00 = BUNSPEC;
static obj_t BGl__pragmazf2typezd2ze3nodezc3zzast_pragmaz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_za2pragmazf3za2zf3zzengine_paramz00;
static obj_t BGl_libraryzd2moduleszd2initz00zzast_pragmaz00();
extern obj_t BGl_userzd2warningzf2locationz20zztools_errorz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_getzd2maxzd2indexz00zzast_pragmaz00(obj_t);
static obj_t __cnst[ 1 ] ;

DEFINE_STRING( BGl_string3371z00zzast_pragmaz00, BgL_bgl_string3371za700za7za7ast_pragmaza7003398z00, "value ", 6 );
DEFINE_STRING( BGl_string3370z00zzast_pragmaz00, BgL_bgl_string3370za700za7za7ast_pragmaza7003399z00, "Illegal range", 13 );
DEFINE_STRING( BGl_string3369z00zzast_pragmaz00, BgL_bgl_string3369za700za7za7ast_pragmaza7003400z00, "the-substring", 13 );
DEFINE_STRING( BGl_string3368z00zzast_pragmaz00, BgL_bgl_string3368za700za7za7ast_pragmaza7003401z00, "Illegal match", 13 );
DEFINE_STRING( BGl_string3367z00zzast_pragmaz00, BgL_bgl_string3367za700za7za7ast_pragmaza7003402z00, "regular-grammar", 15 );
DEFINE_STRING( BGl_string3365z00zzast_pragmaz00, BgL_bgl_string3365za700za7za7ast_pragmaza7003403z00, "Pragma ignored with this back-end", 33 );
DEFINE_STRING( BGl_string3364z00zzast_pragmaz00, BgL_bgl_string3364za700za7za7ast_pragmaza7003404z00, "pragma", 6 );
DEFINE_STRING( BGl_string3363z00zzast_pragmaz00, BgL_bgl_string3363za700za7za7ast_pragmaza7003405z00, "Illegal `pragma' form", 21 );
DEFINE_STRING( BGl_string3362z00zzast_pragmaz00, BgL_bgl_string3362za700za7za7ast_pragmaza7003406z00, "Wrong number of arguments in `pragma' form", 42 );
DEFINE_STATIC_PROCEDURE( BGl_proc3366z00zzast_pragmaz00, BgL_bgl_za7c3anonymousza7a32740za7e3za783za7za7ast_pragmaza7003407za7, BGl_zc3anonymousza32740ze3z83zzast_pragmaz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl_pragmazf2typezd2ze3nodezd2envz11zzast_pragmaz00, BgL_bgl__pragmaza7f2typeza7d2za7e3nodeza7c3za7za7ast_pragmaza7003408za7, BGl__pragmazf2typezd2ze3nodezc3zzast_pragmaz00, 0L, 6 );



/* module-initialization */
obj_t BGl_modulezd2initializa7ationz75zzast_pragmaz00(long BgL_checksumz00_2430, char * BgL_fromz00_2431)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzast_pragmaz00))
{ 
BGl_requirezd2initializa7ationz75zzast_pragmaz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzast_pragmaz00(); 
BGl_cnstzd2initzd2zzast_pragmaz00(); 
BGl_importedzd2moduleszd2initz00zzast_pragmaz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzast_pragmaz00()
{ AN_OBJECT;
{ /* Ast/pragma.scm 14 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "ast_pragma"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "ast_pragma"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "ast_pragma"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "ast_pragma"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzast_pragmaz00()
{ AN_OBJECT;
{ /* Ast/pragma.scm 14 */
{ /* Ast/pragma.scm 14 */
obj_t BgL_cportz00_2423;
BgL_cportz00_2423 = 
open_input_string(BGl_string3371z00zzast_pragmaz00); 
{ 
long BgL_iz00_2424;
BgL_iz00_2424 = ((long)0); 
BgL_loopz00_2425:
if(
(BgL_iz00_2424==((long)-1)))
{ /* Ast/pragma.scm 14 */
return BUNSPEC;}  else 
{ /* Ast/pragma.scm 14 */
{ /* Ast/pragma.scm 14 */
obj_t BgL_arg3375z00_2427;
{ /* Ast/pragma.scm 14 */
obj_t BgL_list3378z00_2428;
BgL_list3378z00_2428 = 
MAKE_PAIR(BgL_cportz00_2423, BNIL); 
BgL_arg3375z00_2427 = 
BGl_readz00zz__readerz00(BgL_list3378z00_2428); } 
{ /* Ast/pragma.scm 14 */
int BgL_auxz00_2447;
BgL_auxz00_2447 = 
(int)(BgL_iz00_2424); 
CNST_TABLE_SET(BgL_auxz00_2447, BgL_arg3375z00_2427); } } 
{ 
long BgL_iz00_2450;
{ /* Ast/pragma.scm 14 */
int BgL_auxz00_2451;
{ /* Ast/pragma.scm 14 */
long BgL_auxz00_2452;
BgL_auxz00_2452 = 
(BgL_iz00_2424-((long)1)); 
BgL_auxz00_2451 = 
(int)(BgL_auxz00_2452); } 
BgL_iz00_2450 = 
(long)(BgL_auxz00_2451); } 
BgL_iz00_2424 = BgL_iz00_2450; 
goto BgL_loopz00_2425;} } } } } 
}



/* pragma/type->node */
BgL_nodez00_bglt BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(bool_t BgL_freez00_1, BgL_typez00_bglt BgL_typez00_2, obj_t BgL_expz00_3, obj_t BgL_stackz00_4, obj_t BgL_locz00_5, obj_t BgL_sitez00_6)
{ AN_OBJECT;
{ /* Ast/pragma.scm 25 */
if(
CBOOL(BGl_za2pragmazf3za2zf3zzengine_paramz00))
{ 
obj_t BgL_formatz00_1227;obj_t BgL_valuesz00_1228;
if(
PAIRP(BgL_expz00_3))
{ /* Ast/pragma.scm 33 */
obj_t BgL_cdrzd2109zd2_1233;
BgL_cdrzd2109zd2_1233 = 
CDR(BgL_expz00_3); 
if(
PAIRP(BgL_cdrzd2109zd2_1233))
{ /* Ast/pragma.scm 33 */
obj_t BgL_carzd2112zd2_1235;
BgL_carzd2112zd2_1235 = 
CAR(BgL_cdrzd2109zd2_1233); 
if(
STRINGP(BgL_carzd2112zd2_1235))
{ /* Ast/pragma.scm 33 */
obj_t BgL_auxz00_2466;
BgL_formatz00_1227 = BgL_carzd2112zd2_1235; 
BgL_valuesz00_1228 = 
CDR(BgL_cdrzd2109zd2_1233); 
{ /* Ast/pragma.scm 35 */
obj_t BgL_maxzd2indexzd2_1238;obj_t BgL_locz00_1239;
BgL_maxzd2indexzd2_1238 = 
BGl_getzd2maxzd2indexz00zzast_pragmaz00(BgL_formatz00_1227); 
BgL_locz00_1239 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_3, BgL_locz00_5); 
{ /* Ast/pragma.scm 37 */
bool_t BgL_testz00_2469;
{ /* Ast/pragma.scm 37 */
long BgL_auxz00_2472;long BgL_auxz00_2470;
BgL_auxz00_2472 = 
bgl_list_length(BgL_valuesz00_1228); 
BgL_auxz00_2470 = 
(long)CINT(BgL_maxzd2indexzd2_1238); 
BgL_testz00_2469 = 
(BgL_auxz00_2470==BgL_auxz00_2472); } 
if(BgL_testz00_2469)
{ 
obj_t BgL_expsz00_1241;obj_t BgL_nodesz00_1242;
{ /* Ast/pragma.scm 42 */
BgL_pragmaz00_bglt BgL_auxz00_2475;
BgL_expsz00_1241 = BgL_valuesz00_1228; 
BgL_nodesz00_1242 = BNIL; 
BgL_loopz00_1243:
if(
NULLP(BgL_expsz00_1241))
{ /* Ast/pragma.scm 46 */
obj_t BgL_arg2683z00_1245;BgL_typez00_bglt BgL_arg2684z00_1246;bool_t BgL_arg2685z00_1247;obj_t BgL_arg2687z00_1249;obj_t BgL_arg2688z00_1250;
BgL_arg2683z00_1245 = BgL_locz00_1239; 
BgL_arg2684z00_1246 = BgL_typez00_2; 
if(BgL_freez00_1)
{ /* Ast/pragma.scm 48 */
BgL_arg2685z00_1247 = ((bool_t)0); }  else 
{ /* Ast/pragma.scm 48 */
BgL_arg2685z00_1247 = ((bool_t)1); } 
BgL_arg2687z00_1249 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_nodesz00_1242); 
BgL_arg2688z00_1250 = BgL_formatz00_1227; 
{ /* Ast/pragma.scm 45 */
BgL_pragmaz00_bglt BgL_res3294z00_1822;
{ /* Ast/pragma.scm 45 */
obj_t BgL_sidezd2effectzf31881z21_1797;obj_t BgL_key1882z00_1798;
BgL_sidezd2effectzf31881z21_1797 = 
BBOOL(BgL_arg2685z00_1247); 
BgL_key1882z00_1798 = 
BINT(((long)-1)); 
{ /* Ast/pragma.scm 45 */
BgL_pragmaz00_bglt BgL_new1885z00_1801;
{ /* Ast/pragma.scm 45 */
BgL_pragmaz00_bglt BgL_res3292z00_1807;
{ /* Ast/pragma.scm 45 */
BgL_pragmaz00_bglt BgL_new1887z00_1802;
BgL_new1887z00_1802 = 
((BgL_pragmaz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_pragmaz00_bgl) ))); 
{ /* Ast/pragma.scm 45 */
long BgL_arg3073z00_1803;
BgL_arg3073z00_1803 = 
BGl_classzd2numzd2zz__objectz00(BGl_pragmaz00zzast_nodez00); 
{ /* Ast/pragma.scm 45 */
BgL_objectz00_bglt BgL_auxz00_2484;
BgL_auxz00_2484 = 
(BgL_objectz00_bglt)(BgL_new1887z00_1802); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_2484, BgL_arg3073z00_1803); } } 
{ /* Ast/pragma.scm 45 */
BgL_objectz00_bglt BgL_auxz00_2487;
BgL_auxz00_2487 = 
(BgL_objectz00_bglt)(BgL_new1887z00_1802); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_2487, BFALSE); } 
{ /* Ast/pragma.scm 45 */
obj_t BgL_auxz00_2490;
BgL_auxz00_2490 = 
(obj_t)(BgL_new1887z00_1802); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_2490); } BUNSPEC; 
BgL_res3292z00_1807 = BgL_new1887z00_1802; } 
BgL_new1885z00_1801 = BgL_res3292z00_1807; } 
{ /* Ast/pragma.scm 45 */
BgL_pragmaz00_bglt BgL_res3293z00_1821;
((((BgL_pragmaz00_bglt)CREF(BgL_new1885z00_1801))->BgL_locz00) = ((obj_t)BgL_arg2683z00_1245), BUNSPEC); 
((((BgL_pragmaz00_bglt)CREF(BgL_new1885z00_1801))->BgL_typez00) = ((BgL_typez00_bglt)BgL_arg2684z00_1246), BUNSPEC); 
((((BgL_pragmaz00_bglt)CREF(BgL_new1885z00_1801))->BgL_sidezd2effectzf3z21) = ((obj_t)BgL_sidezd2effectzf31881z21_1797), BUNSPEC); 
((((BgL_pragmaz00_bglt)CREF(BgL_new1885z00_1801))->BgL_keyz00) = ((obj_t)BgL_key1882z00_1798), BUNSPEC); 
((((BgL_pragmaz00_bglt)CREF(BgL_new1885z00_1801))->BgL_exprza2za2) = ((obj_t)BgL_arg2687z00_1249), BUNSPEC); 
((((BgL_pragmaz00_bglt)CREF(BgL_new1885z00_1801))->BgL_formatz00) = ((obj_t)BgL_arg2688z00_1250), BUNSPEC); 
BgL_res3293z00_1821 = BgL_new1885z00_1801; BgL_res3293z00_1821; } 
BgL_res3294z00_1822 = BgL_new1885z00_1801; } } 
BgL_auxz00_2475 = BgL_res3294z00_1822; } }  else 
{ /* Ast/pragma.scm 51 */
obj_t BgL_arg2692z00_1251;obj_t BgL_arg2693z00_1252;
BgL_arg2692z00_1251 = 
CDR(BgL_expsz00_1241); 
{ /* Ast/pragma.scm 53 */
BgL_nodez00_bglt BgL_arg2697z00_1253;
{ /* Ast/pragma.scm 53 */
obj_t BgL_arg2700z00_1254;obj_t BgL_arg2701z00_1255;obj_t BgL_arg2702z00_1256;
BgL_arg2700z00_1254 = 
CAR(BgL_expsz00_1241); 
BgL_arg2701z00_1255 = 
BGl_findzd2locationzf2locz20zztools_locationz00(
CAR(BgL_expsz00_1241), BgL_locz00_1239); 
BgL_arg2702z00_1256 = 
CNST_TABLE_REF(((long)0)); 
BgL_arg2697z00_1253 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg2700z00_1254, BgL_stackz00_4, BgL_arg2701z00_1255, BgL_arg2702z00_1256); } 
{ /* Ast/pragma.scm 52 */
obj_t BgL_auxz00_2505;
BgL_auxz00_2505 = 
(obj_t)(BgL_arg2697z00_1253); 
BgL_arg2693z00_1252 = 
MAKE_PAIR(BgL_auxz00_2505, BgL_nodesz00_1242); } } 
{ 
obj_t BgL_nodesz00_2509;obj_t BgL_expsz00_2508;
BgL_expsz00_2508 = BgL_arg2692z00_1251; 
BgL_nodesz00_2509 = BgL_arg2693z00_1252; 
BgL_nodesz00_1242 = BgL_nodesz00_2509; 
BgL_expsz00_1241 = BgL_expsz00_2508; 
goto BgL_loopz00_1243;} } 
BgL_auxz00_2466 = 
(obj_t)(BgL_auxz00_2475); } }  else 
{ /* Ast/pragma.scm 38 */
BgL_nodez00_bglt BgL_auxz00_2511;
BgL_auxz00_2511 = 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string3362z00zzast_pragmaz00, BgL_expz00_3, BgL_locz00_1239); 
BgL_auxz00_2466 = 
(obj_t)(BgL_auxz00_2511); } } } 
return 
(BgL_nodez00_bglt)(BgL_auxz00_2466);}  else 
{ /* Ast/pragma.scm 33 */
BgL_tagzd2102zd2_1230:
return 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string3363z00zzast_pragmaz00, BgL_expz00_3, BgL_locz00_5);} }  else 
{ /* Ast/pragma.scm 33 */
goto BgL_tagzd2102zd2_1230;} }  else 
{ /* Ast/pragma.scm 33 */
goto BgL_tagzd2102zd2_1230;} }  else 
{ /* Ast/pragma.scm 26 */
BGl_userzd2warningzf2locationz20zztools_errorz00(BgL_locz00_5, BGl_string3364z00zzast_pragmaz00, BGl_string3365z00zzast_pragmaz00, BgL_expz00_3); 
return 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BUNSPEC, BgL_stackz00_4, BgL_locz00_5, BgL_sitez00_6);} } 
}



/* _pragma/type->node */
obj_t BGl__pragmazf2typezd2ze3nodezc3zzast_pragmaz00(obj_t BgL_envz00_2413, obj_t BgL_freez00_2414, obj_t BgL_typez00_2415, obj_t BgL_expz00_2416, obj_t BgL_stackz00_2417, obj_t BgL_locz00_2418, obj_t BgL_sitez00_2419)
{ AN_OBJECT;
{ /* Ast/pragma.scm 25 */
{ /* Ast/pragma.scm 26 */
BgL_nodez00_bglt BgL_auxz00_2519;
BgL_auxz00_2519 = 
BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(
CBOOL(BgL_freez00_2414), 
(BgL_typez00_bglt)(BgL_typez00_2415), BgL_expz00_2416, BgL_stackz00_2417, BgL_locz00_2418, BgL_sitez00_2419); 
return 
(obj_t)(BgL_auxz00_2519);} } 
}



/* get-max-index */
obj_t BGl_getzd2maxzd2indexz00zzast_pragmaz00(obj_t BgL_formatz00_7)
{ AN_OBJECT;
{ /* Ast/pragma.scm 64 */
{ /* Ast/pragma.scm 65 */
obj_t BgL_portz00_1260;
BgL_portz00_1260 = 
open_input_string(BgL_formatz00_7); 
{ 
obj_t BgL_expz00_1261;obj_t BgL_maxz00_1262;
{ /* Ast/pragma.scm 73 */
obj_t BgL_arg2721z00_1264;
BgL_arg2721z00_1264 = 
PROCEDURE_ENTRY(BGl_proc3366z00zzast_pragmaz00)(BGl_proc3366z00zzast_pragmaz00, BgL_portz00_1260, BEOA); 
BgL_expz00_1261 = BgL_arg2721z00_1264; 
BgL_maxz00_1262 = 
BINT(((long)0)); 
BgL_loopz00_1263:
{ /* Ast/pragma.scm 76 */
bool_t BgL_test2725z00_1266;
BgL_test2725z00_1266 = 
EOF_OBJECTP(BgL_expz00_1261); 
if(BgL_test2725z00_1266)
{ /* Ast/pragma.scm 76 */
return BgL_maxz00_1262;}  else 
{ /* Ast/pragma.scm 76 */
if(
CHARP(BgL_expz00_1261))
{ /* Ast/pragma.scm 78 */
{ /* Ast/pragma.scm 79 */
obj_t BgL_arg2728z00_1268;
BgL_arg2728z00_1268 = 
PROCEDURE_ENTRY(BGl_proc3366z00zzast_pragmaz00)(BGl_proc3366z00zzast_pragmaz00, BgL_portz00_1260, BEOA); 
{ 
obj_t BgL_expz00_2533;
BgL_expz00_2533 = BgL_arg2728z00_1268; 
BgL_expz00_1261 = BgL_expz00_2533; 
goto BgL_loopz00_1263;} } }  else 
{ /* Ast/pragma.scm 78 */
{ /* Ast/pragma.scm 81 */
obj_t BgL_arg2732z00_1269;
BgL_arg2732z00_1269 = 
PROCEDURE_ENTRY(BGl_proc3366z00zzast_pragmaz00)(BGl_proc3366z00zzast_pragmaz00, BgL_portz00_1260, BEOA); 
{ 
obj_t BgL_maxz00_2537;obj_t BgL_expz00_2536;
BgL_expz00_2536 = BgL_arg2732z00_1269; 
{ /* Ast/pragma.scm 81 */
bool_t BgL_testz00_2538;
{ /* Ast/pragma.scm 81 */
long BgL_auxz00_2541;long BgL_auxz00_2539;
BgL_auxz00_2541 = 
(long)CINT(BgL_maxz00_1262); 
BgL_auxz00_2539 = 
(long)CINT(BgL_expz00_1261); 
BgL_testz00_2538 = 
(BgL_auxz00_2539>BgL_auxz00_2541); } 
if(BgL_testz00_2538)
{ /* Ast/pragma.scm 81 */
BgL_maxz00_2537 = BgL_expz00_1261; }  else 
{ /* Ast/pragma.scm 81 */
BgL_maxz00_2537 = BgL_maxz00_1262; } } 
BgL_maxz00_1262 = BgL_maxz00_2537; 
BgL_expz00_1261 = BgL_expz00_2536; 
goto BgL_loopz00_1263;} } } } } } } } } 
}



/* <anonymous:2740> */
obj_t BGl_zc3anonymousza32740ze3z83zzast_pragmaz00(obj_t BgL_envz00_2421, obj_t BgL_inputzd2portzd2_2422)
{ AN_OBJECT;
{ /* Ast/pragma.scm 65 */
{ 
obj_t BgL_inputzd2portzd2_1273;
BgL_inputzd2portzd2_1273 = BgL_inputzd2portzd2_2422; 
{ 
long BgL_lastzd2matchzd2_1370;long BgL_lastzd2matchzd2_1362;long BgL_lastzd2matchzd2_1355;long BgL_lastzd2matchzd2_1347;long BgL_lastzd2matchzd2_1339;long BgL_minz00_1324;int BgL_maxz00_1325;
BgL_zc3anonymousza32742ze3z83_1296:
RGC_START_MATCH(BgL_inputzd2portzd2_1273); 
{ /* Ast/pragma.scm 65 */
int BgL_matchz00_1297;
{ /* Ast/pragma.scm 65 */
long BgL_auxz00_2546;
BgL_lastzd2matchzd2_1355 = ((long)2); 
BgL_zc3anonymousza32846ze3z83_1356:
{ /* Ast/pragma.scm 65 */
int BgL_currentzd2charzd2_1357;
BgL_currentzd2charzd2_1357 = 
RGC_BUFFER_GET_CHAR(BgL_inputzd2portzd2_1273); 
{ /* Ast/pragma.scm 65 */
bool_t BgL_testz00_2548;
{ /* Ast/pragma.scm 65 */
long BgL_auxz00_2549;
BgL_auxz00_2549 = 
(long)(BgL_currentzd2charzd2_1357); 
BgL_testz00_2548 = 
(BgL_auxz00_2549==((long)0)); } 
if(BgL_testz00_2548)
{ /* Ast/pragma.scm 65 */
{ /* Ast/pragma.scm 65 */
bool_t BgL_test2848z00_1359;
BgL_test2848z00_1359 = 
RGC_BUFFER_EMPTY(BgL_inputzd2portzd2_1273); 
if(BgL_test2848z00_1359)
{ /* Ast/pragma.scm 65 */
bool_t BgL_test2849z00_1360;
BgL_test2849z00_1360 = 
rgc_fill_buffer(BgL_inputzd2portzd2_1273); 
if(BgL_test2849z00_1360)
{ 

goto BgL_zc3anonymousza32846ze3z83_1356;}  else 
{ /* Ast/pragma.scm 65 */
BgL_auxz00_2546 = BgL_lastzd2matchzd2_1355
; } }  else 
{ /* Ast/pragma.scm 65 */
BgL_lastzd2matchzd2_1339 = BgL_lastzd2matchzd2_1355; 
BgL_zc3anonymousza32818ze3z83_1340:
{ /* Ast/pragma.scm 65 */
long BgL_newzd2matchzd2_1341;
RGC_STOP_MATCH(BgL_inputzd2portzd2_1273); 
BgL_newzd2matchzd2_1341 = ((long)1); 
{ /* Ast/pragma.scm 65 */
int BgL_currentzd2charzd2_1342;
BgL_currentzd2charzd2_1342 = 
RGC_BUFFER_GET_CHAR(BgL_inputzd2portzd2_1273); 
{ /* Ast/pragma.scm 65 */
bool_t BgL_testz00_2558;
{ /* Ast/pragma.scm 65 */
long BgL_auxz00_2559;
BgL_auxz00_2559 = 
(long)(BgL_currentzd2charzd2_1342); 
BgL_testz00_2558 = 
(BgL_auxz00_2559==((long)0)); } 
if(BgL_testz00_2558)
{ /* Ast/pragma.scm 65 */
{ /* Ast/pragma.scm 65 */
bool_t BgL_test2820z00_1344;
BgL_test2820z00_1344 = 
RGC_BUFFER_EMPTY(BgL_inputzd2portzd2_1273); 
if(BgL_test2820z00_1344)
{ /* Ast/pragma.scm 65 */
bool_t BgL_test2821z00_1345;
BgL_test2821z00_1345 = 
rgc_fill_buffer(BgL_inputzd2portzd2_1273); 
if(BgL_test2821z00_1345)
{ 

goto BgL_zc3anonymousza32818ze3z83_1340;}  else 
{ /* Ast/pragma.scm 65 */
BgL_auxz00_2546 = BgL_newzd2matchzd2_1341
; } }  else 
{ /* Ast/pragma.scm 65 */
BgL_lastzd2matchzd2_1347 = BgL_newzd2matchzd2_1341; 
BgL_zc3anonymousza32832ze3z83_1348:
{ /* Ast/pragma.scm 65 */
long BgL_newzd2matchzd2_1349;
RGC_STOP_MATCH(BgL_inputzd2portzd2_1273); 
BgL_newzd2matchzd2_1349 = ((long)1); 
{ /* Ast/pragma.scm 65 */
int BgL_currentzd2charzd2_1350;
BgL_currentzd2charzd2_1350 = 
RGC_BUFFER_GET_CHAR(BgL_inputzd2portzd2_1273); 
{ /* Ast/pragma.scm 65 */
bool_t BgL_testz00_2568;
{ /* Ast/pragma.scm 65 */
long BgL_auxz00_2569;
BgL_auxz00_2569 = 
(long)(BgL_currentzd2charzd2_1350); 
BgL_testz00_2568 = 
(BgL_auxz00_2569==((long)0)); } 
if(BgL_testz00_2568)
{ /* Ast/pragma.scm 65 */
{ /* Ast/pragma.scm 65 */
bool_t BgL_test2834z00_1352;
BgL_test2834z00_1352 = 
RGC_BUFFER_EMPTY(BgL_inputzd2portzd2_1273); 
if(BgL_test2834z00_1352)
{ /* Ast/pragma.scm 65 */
bool_t BgL_test2835z00_1353;
BgL_test2835z00_1353 = 
rgc_fill_buffer(BgL_inputzd2portzd2_1273); 
if(BgL_test2835z00_1353)
{ 

goto BgL_zc3anonymousza32832ze3z83_1348;}  else 
{ /* Ast/pragma.scm 65 */
BgL_auxz00_2546 = BgL_newzd2matchzd2_1349
; } }  else 
{ 
long BgL_lastzd2matchzd2_2576;
BgL_lastzd2matchzd2_2576 = BgL_newzd2matchzd2_1349; 
BgL_lastzd2matchzd2_1347 = BgL_lastzd2matchzd2_2576; 
goto BgL_zc3anonymousza32832ze3z83_1348;} } }  else 
{ /* Ast/pragma.scm 65 */
bool_t BgL_testz00_2577;
{ /* Ast/pragma.scm 65 */
long BgL_auxz00_2578;
BgL_auxz00_2578 = 
(long)(BgL_currentzd2charzd2_1350); 
BgL_testz00_2577 = 
(BgL_auxz00_2578==((long)36)); } 
if(BgL_testz00_2577)
{ /* Ast/pragma.scm 65 */
BgL_auxz00_2546 = BgL_newzd2matchzd2_1349; }  else 
{ /* Ast/pragma.scm 65 */
{ 
long BgL_lastzd2matchzd2_2581;
BgL_lastzd2matchzd2_2581 = BgL_newzd2matchzd2_1349; 
BgL_lastzd2matchzd2_1347 = BgL_lastzd2matchzd2_2581; 
goto BgL_zc3anonymousza32832ze3z83_1348;} } } } } } } } }  else 
{ /* Ast/pragma.scm 65 */
bool_t BgL_testz00_2582;
{ /* Ast/pragma.scm 65 */
long BgL_auxz00_2583;
BgL_auxz00_2583 = 
(long)(BgL_currentzd2charzd2_1342); 
BgL_testz00_2582 = 
(BgL_auxz00_2583==((long)36)); } 
if(BgL_testz00_2582)
{ /* Ast/pragma.scm 65 */
BgL_auxz00_2546 = BgL_newzd2matchzd2_1341; }  else 
{ /* Ast/pragma.scm 65 */
{ 
long BgL_lastzd2matchzd2_2586;
BgL_lastzd2matchzd2_2586 = BgL_newzd2matchzd2_1341; 
BgL_lastzd2matchzd2_1347 = BgL_lastzd2matchzd2_2586; 
goto BgL_zc3anonymousza32832ze3z83_1348;} } } } } } } } }  else 
{ /* Ast/pragma.scm 65 */
bool_t BgL_testz00_2587;
{ /* Ast/pragma.scm 65 */
long BgL_auxz00_2588;
BgL_auxz00_2588 = 
(long)(BgL_currentzd2charzd2_1357); 
BgL_testz00_2587 = 
(BgL_auxz00_2588==((long)36)); } 
if(BgL_testz00_2587)
{ /* Ast/pragma.scm 65 */
BgL_lastzd2matchzd2_1370 = BgL_lastzd2matchzd2_1355; 
BgL_zc3anonymousza32873ze3z83_1371:
{ /* Ast/pragma.scm 65 */
long BgL_newzd2matchzd2_1372;
RGC_STOP_MATCH(BgL_inputzd2portzd2_1273); 
BgL_newzd2matchzd2_1372 = ((long)2); 
{ /* Ast/pragma.scm 65 */
int BgL_currentzd2charzd2_1373;
BgL_currentzd2charzd2_1373 = 
RGC_BUFFER_GET_CHAR(BgL_inputzd2portzd2_1273); 
{ /* Ast/pragma.scm 65 */
bool_t BgL_testz00_2593;
{ /* Ast/pragma.scm 65 */
long BgL_auxz00_2594;
BgL_auxz00_2594 = 
(long)(BgL_currentzd2charzd2_1373); 
BgL_testz00_2593 = 
(BgL_auxz00_2594==((long)0)); } 
if(BgL_testz00_2593)
{ /* Ast/pragma.scm 65 */
{ /* Ast/pragma.scm 65 */
bool_t BgL_test2875z00_1375;
{ /* Ast/pragma.scm 65 */
bool_t BgL_res3300z00_1903;
{ /* Ast/pragma.scm 65 */
bool_t BgL__andtest_1011z00_1900;
BgL__andtest_1011z00_1900 = 
RGC_BUFFER_EMPTY(BgL_inputzd2portzd2_1273); 
if(BgL__andtest_1011z00_1900)
{ /* Ast/pragma.scm 65 */
BgL_res3300z00_1903 = 
rgc_fill_buffer(BgL_inputzd2portzd2_1273); }  else 
{ /* Ast/pragma.scm 65 */
BgL_res3300z00_1903 = ((bool_t)0); } } 
BgL_test2875z00_1375 = BgL_res3300z00_1903; } 
if(BgL_test2875z00_1375)
{ 

goto BgL_zc3anonymousza32873ze3z83_1371;}  else 
{ /* Ast/pragma.scm 65 */
BgL_auxz00_2546 = BgL_newzd2matchzd2_1372
; } } }  else 
{ /* Ast/pragma.scm 65 */
bool_t BgL_testz00_2601;
{ /* Ast/pragma.scm 65 */
bool_t BgL_testz00_2602;
{ /* Ast/pragma.scm 65 */
long BgL_auxz00_2603;
BgL_auxz00_2603 = 
(long)(BgL_currentzd2charzd2_1373); 
BgL_testz00_2602 = 
(BgL_auxz00_2603>=((long)48)); } 
if(BgL_testz00_2602)
{ /* Ast/pragma.scm 65 */
long BgL_auxz00_2606;
BgL_auxz00_2606 = 
(long)(BgL_currentzd2charzd2_1373); 
BgL_testz00_2601 = 
(BgL_auxz00_2606<((long)58)); }  else 
{ /* Ast/pragma.scm 65 */
BgL_testz00_2601 = ((bool_t)0)
; } } 
if(BgL_testz00_2601)
{ /* Ast/pragma.scm 65 */
BgL_lastzd2matchzd2_1362 = BgL_newzd2matchzd2_1372; 
BgL_zc3anonymousza32860ze3z83_1363:
{ /* Ast/pragma.scm 65 */
long BgL_newzd2matchzd2_1364;
RGC_STOP_MATCH(BgL_inputzd2portzd2_1273); 
BgL_newzd2matchzd2_1364 = ((long)0); 
{ /* Ast/pragma.scm 65 */
int BgL_currentzd2charzd2_1365;
BgL_currentzd2charzd2_1365 = 
RGC_BUFFER_GET_CHAR(BgL_inputzd2portzd2_1273); 
{ /* Ast/pragma.scm 65 */
bool_t BgL_testz00_2611;
{ /* Ast/pragma.scm 65 */
long BgL_auxz00_2612;
BgL_auxz00_2612 = 
(long)(BgL_currentzd2charzd2_1365); 
BgL_testz00_2611 = 
(BgL_auxz00_2612==((long)0)); } 
if(BgL_testz00_2611)
{ /* Ast/pragma.scm 65 */
{ /* Ast/pragma.scm 65 */
bool_t BgL_test2862z00_1367;
{ /* Ast/pragma.scm 65 */
bool_t BgL_res3299z00_1890;
{ /* Ast/pragma.scm 65 */
bool_t BgL__andtest_1011z00_1887;
BgL__andtest_1011z00_1887 = 
RGC_BUFFER_EMPTY(BgL_inputzd2portzd2_1273); 
if(BgL__andtest_1011z00_1887)
{ /* Ast/pragma.scm 65 */
BgL_res3299z00_1890 = 
rgc_fill_buffer(BgL_inputzd2portzd2_1273); }  else 
{ /* Ast/pragma.scm 65 */
BgL_res3299z00_1890 = ((bool_t)0); } } 
BgL_test2862z00_1367 = BgL_res3299z00_1890; } 
if(BgL_test2862z00_1367)
{ 

goto BgL_zc3anonymousza32860ze3z83_1363;}  else 
{ /* Ast/pragma.scm 65 */
BgL_auxz00_2546 = BgL_newzd2matchzd2_1364
; } } }  else 
{ /* Ast/pragma.scm 65 */
bool_t BgL_testz00_2619;
{ /* Ast/pragma.scm 65 */
bool_t BgL_testz00_2620;
{ /* Ast/pragma.scm 65 */
long BgL_auxz00_2621;
BgL_auxz00_2621 = 
(long)(BgL_currentzd2charzd2_1365); 
BgL_testz00_2620 = 
(BgL_auxz00_2621>=((long)48)); } 
if(BgL_testz00_2620)
{ /* Ast/pragma.scm 65 */
long BgL_auxz00_2624;
BgL_auxz00_2624 = 
(long)(BgL_currentzd2charzd2_1365); 
BgL_testz00_2619 = 
(BgL_auxz00_2624<((long)58)); }  else 
{ /* Ast/pragma.scm 65 */
BgL_testz00_2619 = ((bool_t)0)
; } } 
if(BgL_testz00_2619)
{ /* Ast/pragma.scm 65 */
{ 
long BgL_lastzd2matchzd2_2627;
BgL_lastzd2matchzd2_2627 = BgL_newzd2matchzd2_1364; 
BgL_lastzd2matchzd2_1362 = BgL_lastzd2matchzd2_2627; 
goto BgL_zc3anonymousza32860ze3z83_1363;} }  else 
{ /* Ast/pragma.scm 65 */
BgL_auxz00_2546 = BgL_newzd2matchzd2_1364; } } } } } }  else 
{ /* Ast/pragma.scm 65 */
BgL_auxz00_2546 = BgL_newzd2matchzd2_1372; } } } } } }  else 
{ /* Ast/pragma.scm 65 */
{ 
long BgL_lastzd2matchzd2_2628;
BgL_lastzd2matchzd2_2628 = BgL_lastzd2matchzd2_1355; 
BgL_lastzd2matchzd2_1339 = BgL_lastzd2matchzd2_2628; 
goto BgL_zc3anonymousza32818ze3z83_1340;} } } } } 
BgL_matchz00_1297 = 
(int)(BgL_auxz00_2546); } 
RGC_SET_FILEPOS(BgL_inputzd2portzd2_1273); 
{ 

switch( 
(long)(BgL_matchz00_1297)) { case ((long)2) : 

{ /* Ast/pragma.scm 65 */
bool_t BgL_test2771z00_1314;
{ /* Ast/pragma.scm 65 */
int BgL_arg2778z00_1317;
{ /* Ast/pragma.scm 65 */
int BgL_res3296z00_1834;
{ /* Ast/pragma.scm 65 */
long BgL_auxz00_2631;
BgL_auxz00_2631 = 
RGC_BUFFER_LENGTH(BgL_inputzd2portzd2_1273); 
BgL_res3296z00_1834 = 
(int)(BgL_auxz00_2631); } 
BgL_arg2778z00_1317 = BgL_res3296z00_1834; } 
{ /* Ast/pragma.scm 65 */
long BgL_auxz00_2634;
BgL_auxz00_2634 = 
(long)(BgL_arg2778z00_1317); 
BgL_test2771z00_1314 = 
(BgL_auxz00_2634==((long)0)); } } 
if(BgL_test2771z00_1314)
{ /* Ast/pragma.scm 65 */
return BCNST(256);}  else 
{ /* Ast/pragma.scm 65 */
obj_t BgL_arg2773z00_1315;
{ /* Ast/pragma.scm 65 */
int BgL_arg2812z00_1336;
{ /* Ast/pragma.scm 65 */
int BgL_res3298z00_1855;
{ /* Ast/pragma.scm 65 */
long BgL_auxz00_2638;
BgL_auxz00_2638 = 
RGC_BUFFER_LENGTH(BgL_inputzd2portzd2_1273); 
BgL_res3298z00_1855 = 
(int)(BgL_auxz00_2638); } 
BgL_arg2812z00_1336 = BgL_res3298z00_1855; } 
{ /* Ast/pragma.scm 65 */
int BgL_auxz00_2641;
BgL_auxz00_2641 = 
(int)(((long)0)); 
BgL_arg2773z00_1315 = 
rgc_buffer_substring(BgL_inputzd2portzd2_1273, BgL_auxz00_2641, BgL_arg2812z00_1336); } } 
{ /* Ast/pragma.scm 65 */
unsigned char BgL_auxz00_2644;
{ /* Ast/pragma.scm 65 */
int BgL_auxz00_2645;
BgL_auxz00_2645 = 
(int)(((long)0)); 
BgL_auxz00_2644 = 
STRING_REF(BgL_arg2773z00_1315, BgL_auxz00_2645); } 
return 
BCHAR(BgL_auxz00_2644);} } } break;case ((long)1) : 

goto BgL_zc3anonymousza32742ze3z83_1296;break;case ((long)0) : 

{ /* Ast/pragma.scm 67 */
obj_t BgL_arg2749z00_1301;
{ /* Ast/pragma.scm 67 */
int BgL_arg2754z00_1304;
{ /* Ast/pragma.scm 67 */
int BgL_res3295z00_1829;
{ /* Ast/pragma.scm 67 */
long BgL_auxz00_2649;
BgL_auxz00_2649 = 
RGC_BUFFER_LENGTH(BgL_inputzd2portzd2_1273); 
BgL_res3295z00_1829 = 
(int)(BgL_auxz00_2649); } 
BgL_arg2754z00_1304 = BgL_res3295z00_1829; } 
BgL_minz00_1324 = ((long)1); 
BgL_maxz00_1325 = BgL_arg2754z00_1304; 
{ /* Ast/pragma.scm 65 */
bool_t BgL_test2793z00_1327;
if(
(BgL_minz00_1324>=((long)0)))
{ /* Ast/pragma.scm 65 */
bool_t BgL_test2802z00_1332;
{ /* Ast/pragma.scm 65 */
int BgL_arg2805z00_1333;
{ /* Ast/pragma.scm 65 */
int BgL_res3297z00_1843;
{ /* Ast/pragma.scm 65 */
long BgL_auxz00_2654;
BgL_auxz00_2654 = 
RGC_BUFFER_LENGTH(BgL_inputzd2portzd2_1273); 
BgL_res3297z00_1843 = 
(int)(BgL_auxz00_2654); } 
BgL_arg2805z00_1333 = BgL_res3297z00_1843; } 
{ /* Ast/pragma.scm 65 */
long BgL_auxz00_2659;long BgL_auxz00_2657;
BgL_auxz00_2659 = 
(long)(BgL_arg2805z00_1333); 
BgL_auxz00_2657 = 
(long)(BgL_maxz00_1325); 
BgL_test2802z00_1332 = 
(BgL_auxz00_2657<=BgL_auxz00_2659); } } 
if(BgL_test2802z00_1332)
{ /* Ast/pragma.scm 65 */
long BgL_auxz00_2663;
BgL_auxz00_2663 = 
(long)(BgL_maxz00_1325); 
BgL_test2793z00_1327 = 
(BgL_auxz00_2663>=BgL_minz00_1324); }  else 
{ /* Ast/pragma.scm 65 */
BgL_test2793z00_1327 = ((bool_t)0); } }  else 
{ /* Ast/pragma.scm 65 */
BgL_test2793z00_1327 = ((bool_t)0); } 
if(BgL_test2793z00_1327)
{ /* Ast/pragma.scm 65 */
int BgL_auxz00_2667;
BgL_auxz00_2667 = 
(int)(BgL_minz00_1324); 
BgL_arg2749z00_1301 = 
rgc_buffer_substring(BgL_inputzd2portzd2_1273, BgL_auxz00_2667, BgL_maxz00_1325); }  else 
{ /* Ast/pragma.scm 65 */
obj_t BgL_arg2798z00_1330;
{ /* Ast/pragma.scm 65 */
obj_t BgL_auxz00_2672;obj_t BgL_auxz00_2670;
BgL_auxz00_2672 = 
BINT(BgL_maxz00_1325); 
BgL_auxz00_2670 = 
BINT(BgL_minz00_1324); 
BgL_arg2798z00_1330 = 
MAKE_PAIR(BgL_auxz00_2670, BgL_auxz00_2672); } 
FAILURE(BGl_string3369z00zzast_pragmaz00,BGl_string3370z00zzast_pragmaz00,BgL_arg2798z00_1330);} } } 
return 
BGl_stringzd2ze3numberz31zz__r4_numbers_6_5z00(BgL_arg2749z00_1301, BNIL);} break;
default: 
{ 
obj_t BgL_auxz00_2677;
BgL_auxz00_2677 = 
BINT(BgL_matchz00_1297); 
FAILURE(BGl_string3367z00zzast_pragmaz00,BGl_string3368z00zzast_pragmaz00,BgL_auxz00_2677);} } } } } } } 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzast_pragmaz00()
{ AN_OBJECT;
{ /* Ast/pragma.scm 14 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzast_pragmaz00()
{ AN_OBJECT;
{ /* Ast/pragma.scm 14 */
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19010), "ast_pragma"); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)28259), "ast_pragma"); 
BGl_modulezd2initializa7ationz75zzast_nodez00(((long)49436), "ast_pragma"); 
BGl_modulezd2initializa7ationz75zztools_errorz00(((long)17886), "ast_pragma"); 
BGl_modulezd2initializa7ationz75zztools_locationz00(((long)30714), "ast_pragma"); 
BGl_modulezd2initializa7ationz75zzast_sexpz00(((long)26966), "ast_pragma"); 
return 
BGl_modulezd2initializa7ationz75zzengine_paramz00(((long)189840), "ast_pragma");} 
}

