/*===========================================================================*/
/*   (Heap/restore.scm)                                                      */
/*   Bigloo (2.5b)                                                           */
/*   Manuel Serrano (c)       Fri Sep 6 09:43:28 CEST 2002                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;


extern obj_t BGl_modulezd2initializa7ationz75zzheap_restorez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_enginez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzinit_mainz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzread_jvmz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__hashz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__binaryz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
static obj_t BGl_zc3anonymousza31851ze3z83zzheap_restorez00(obj_t);
extern obj_t BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(obj_t, obj_t, obj_t);
static obj_t BGl_handlerz00zzheap_restorez00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_za2heapzd2dumpzd2namesza2z00zzengine_paramz00;
static obj_t BGl_zc3anonymousza31643ze3z83zzheap_restorez00(obj_t);
static obj_t BGl_methodzd2initzd2zzheap_restorez00();
extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
static obj_t BGl_zc3anonymousza31926ze3z83zzheap_restorez00(obj_t);
extern obj_t BGl_findzd2filezf2pathz20zz__osz00(obj_t, obj_t);
static obj_t BGl_escape_2262z00zzheap_restorez00(obj_t, obj_t);
static obj_t BGl_za2heapzd2markza2zd2zzheap_restorez00 = BUNSPEC;
static obj_t BGl_zc3anonymousza31645ze3z83zzheap_restorez00(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t BGl_za2additionalzd2includezd2foreignza2z00zzengine_paramz00;
extern obj_t BGl_za2libzd2dirza2zd2zzengine_paramz00;
static obj_t BGl_zc3anonymousza31649ze3z83zzheap_restorez00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_sfunz00zzast_varz00;
extern obj_t BGl_za2heapzd2nameza2zd2zzengine_paramz00;
extern obj_t BGl_setzd2genvz12zc0zzast_envz00(obj_t);
extern obj_t BGl_dynamiczd2windzd2zz__r4_control_features_6_9z00(obj_t, obj_t, obj_t);
extern obj_t bgl_reverse(obj_t);
extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
static obj_t BGl_zc3anonymousza31652ze3z83zzheap_restorez00(obj_t);
extern obj_t BGl_addzd2tenvz12zc0zztype_envz00(obj_t);
extern obj_t BGl_readz00zz__readerz00(obj_t);
extern bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
static obj_t BGl_handling_function1634z00zzheap_restorez00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_restorezd2additionalzd2heapsz00zzheap_restorez00();
static obj_t BGl_zc3anonymousza31865ze3z83zzheap_restorez00(obj_t, obj_t, obj_t);
static obj_t BGl_dumpzd2heapzd2zzheap_restorez00(obj_t, obj_t, obj_t);
extern obj_t BGl_shapez00zztools_shapez00(obj_t);
extern obj_t BGl_dumpzd2additionalzd2heapsz00zzheap_restorez00();
extern obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
extern obj_t input_obj(obj_t);
extern obj_t BGl_restorezd2heapzd2zzheap_restorez00();
extern obj_t BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00(obj_t);
extern obj_t BGl_cfunz00zzast_varz00;
extern obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t);
extern obj_t BGl_closezd2binaryzd2portz00zz__binaryz00(obj_t);
static obj_t BGl_unbindzd2callzf2ccz12z32zzheap_restorez00();
extern obj_t BGl_za2targetzd2languageza2zd2zzengine_paramz00;
static obj_t BGl_zc3anonymousza31950ze3z83zzheap_restorez00(obj_t, obj_t, obj_t);
extern obj_t BGl_za2additionalzd2heapzd2namesza2z00zzengine_paramz00;
extern obj_t BGl_putpropz12z12zz__r4_symbols_6_4z00(obj_t, obj_t, obj_t);
static obj_t BGl_za2heapzd2modulezd2listza2z00zzheap_restorez00 = BUNSPEC;
static obj_t BGl_escapez00zzheap_restorez00(obj_t, obj_t);
extern obj_t BGl_getpropz00zz__r4_symbols_6_4z00(obj_t, obj_t);
extern obj_t BGl_unbindzd2globalz12zc0zzast_envz00(obj_t, obj_t);
extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
extern obj_t BGl_removezd2errorzd2handlerz12z12zz__errorz00();
static obj_t BGl_zc3anonymousza31674ze3z83zzheap_restorez00(obj_t, obj_t);
static obj_t BGl__restorezd2additionalzd2heapsz00zzheap_restorez00(obj_t);
static obj_t BGl_restorezd2additionalzd2heapz00zzheap_restorez00(obj_t);
static obj_t BGl_zc3anonymousza32061ze3z83zzheap_restorez00(obj_t, obj_t, obj_t);
static obj_t BGl__restorezd2heapzd2zzheap_restorez00(obj_t);
extern obj_t BGl_addzd2genvz12zc0zzast_envz00(obj_t);
static obj_t BGl_cnstzd2initzd2zzheap_restorez00();
extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
extern obj_t bgl_append2(obj_t, obj_t);
extern obj_t BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
extern obj_t BGl_displayzd22zd2zz__r4_output_6_10_3z00(obj_t, obj_t);
extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
static obj_t BGl__heapzd2modulezd2listz00zzheap_restorez00(obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zzheap_restorez00();
extern obj_t BGl_setzd2tenvz12zc0zztype_envz00(obj_t);
extern obj_t BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00(obj_t);
static obj_t BGl_zc3anonymousza31689ze3z83zzheap_restorez00(obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zzheap_restorez00 = BUNSPEC;
extern obj_t BGl_heapzd2modulezd2listz00zzheap_restorez00(obj_t);
static obj_t BGl__dumpzd2additionalzd2heapsz00zzheap_restorez00(obj_t);
static obj_t BGl_handler_2266z00zzheap_restorez00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_zc3anonymousza31842ze3z83zzheap_restorez00(obj_t);
extern obj_t BGl_notifyzd2errorzd2zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zzheap_restorez00();
static obj_t BGl_zc3anonymousza31844ze3z83zzheap_restorez00(obj_t);
extern obj_t BGl_hashtablezd2forzd2eachz00zz__hashz00(obj_t, obj_t);
extern obj_t BGl_exitzd2bigloozd2zzinit_mainz00(obj_t);
static obj_t BGl_handling_function1834z00zzheap_restorez00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_addzd2errorzd2handlerz12z12zz__errorz00(obj_t, obj_t);
extern obj_t BGl_memberz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
extern obj_t BGl_za2callzf2cczf3za2z01zzengine_paramz00;
static obj_t BGl_toplevelzd2initzd2zzheap_restorez00();
static obj_t BGl_zc3anonymousza31848ze3z83zzheap_restorez00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t string_append_3(obj_t, obj_t, obj_t);
static obj_t __cnst[ 14 ] ;

DEFINE_EXPORT_PROCEDURE( BGl_dumpzd2additionalzd2heapszd2envzd2zzheap_restorez00, BgL_bgl__dumpza7d2additionalza7d2heapsza700za7za7heap_restoreza7002533z00, BGl__dumpzd2additionalzd2heapsz00zzheap_restorez00, 0L, 0 );
DEFINE_EXPORT_PROCEDURE( BGl_restorezd2heapzd2envz00zzheap_restorez00, BgL_bgl__restoreza7d2heapza7d2za7za7heap_restoreza7002534za7, BGl__restorezd2heapzd2zzheap_restorez00, 0L, 0 );
DEFINE_STRING( BGl_string2497z00zzheap_restorez00, BgL_bgl_string2497za700za7za7heap_restoreza7002535z00, "qualified-type module id variable native function name type call-with-current-continuation __r4_control_features_6_9 call/cc jvm pass-started heap-mark ", 152 );
DEFINE_STRING( BGl_string2496z00zzheap_restorez00, BgL_bgl_string2496za700za7za7heap_restoreza7002536z00, "   ", 3 );
DEFINE_STRING( BGl_string2495z00zzheap_restorez00, BgL_bgl_string2495za700za7za7heap_restoreza7002537z00, " ))\n", 4 );
DEFINE_STRING( BGl_string2493z00zzheap_restorez00, BgL_bgl_string2493za700za7za7heap_restoreza7002538z00, " (types", 7 );
DEFINE_STRING( BGl_string2492z00zzheap_restorez00, BgL_bgl_string2492za700za7za7heap_restoreza7002539z00, " )\n", 3 );
DEFINE_STRING( BGl_string2490z00zzheap_restorez00, BgL_bgl_string2490za700za7za7heap_restoreza7002540z00, " (variables", 11 );
DEFINE_STRING( BGl_string2489z00zzheap_restorez00, BgL_bgl_string2489za700za7za7heap_restoreza7002541z00, "(heap heap", 10 );
DEFINE_STRING( BGl_string2487z00zzheap_restorez00, BgL_bgl_string2487za700za7za7heap_restoreza7002542z00, "restore-additional-heap", 23 );
DEFINE_STRING( BGl_string2486z00zzheap_restorez00, BgL_bgl_string2486za700za7za7heap_restoreza7002543z00, "Library", 7 );
DEFINE_STRING( BGl_string2483z00zzheap_restorez00, BgL_bgl_string2483za700za7za7heap_restoreza7002544z00, "Target language mismatch", 24 );
DEFINE_STRING( BGl_string2482z00zzheap_restorez00, BgL_bgl_string2482za700za7za7heap_restoreza7002545z00, "Corrupted heap", 14 );
DEFINE_STRING( BGl_string2481z00zzheap_restorez00, BgL_bgl_string2481za700za7za7heap_restoreza7002546z00, "restore-heap", 12 );
DEFINE_STRING( BGl_string2480z00zzheap_restorez00, BgL_bgl_string2480za700za7za7heap_restoreza7002547z00, "\"", 1 );
DEFINE_STRING( BGl_string2479z00zzheap_restorez00, BgL_bgl_string2479za700za7za7heap_restoreza7002548z00, "Cannot open heap file \"", 23 );
DEFINE_STRING( BGl_string2478z00zzheap_restorez00, BgL_bgl_string2478za700za7za7heap_restoreza7002549z00, "      [reading ", 15 );
DEFINE_STRING( BGl_string2477z00zzheap_restorez00, BgL_bgl_string2477za700za7za7heap_restoreza7002550z00, "]", 1 );
DEFINE_STRING( BGl_string2476z00zzheap_restorez00, BgL_bgl_string2476za700za7za7heap_restoreza7002551z00, "failure during prelude hook", 27 );
DEFINE_STRING( BGl_string2475z00zzheap_restorez00, BgL_bgl_string2475za700za7za7heap_restoreza7002552z00, "   . ", 5 );
DEFINE_STRING( BGl_string2474z00zzheap_restorez00, BgL_bgl_string2474za700za7za7heap_restoreza7002553z00, "Heap", 4 );
DEFINE_EXPORT_PROCEDURE( BGl_heapzd2modulezd2listzd2envzd2zzheap_restorez00, BgL_bgl__heapza7d2moduleza7d2listza700za7za7heap_restoreza7002554z00, va_generic_entry, BGl__heapzd2modulezd2listz00zzheap_restorez00, -1 );
DEFINE_STATIC_PROCEDURE( BGl_proc2484z00zzheap_restorez00, BgL_bgl_za7c3anonymousza7a31674za7e3za783za7za7heap_restoreza7002555za7, BGl_zc3anonymousza31674ze3z83zzheap_restorez00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc2485z00zzheap_restorez00, BgL_bgl_za7c3anonymousza7a31689za7e3za783za7za7heap_restoreza7002556za7, BGl_zc3anonymousza31689ze3z83zzheap_restorez00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc2488z00zzheap_restorez00, BgL_bgl_za7c3anonymousza7a31865za7e3za783za7za7heap_restoreza7002557za7, BGl_zc3anonymousza31865ze3z83zzheap_restorez00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc2491z00zzheap_restorez00, BgL_bgl_za7c3anonymousza7a31950za7e3za783za7za7heap_restoreza7002558za7, BGl_zc3anonymousza31950ze3z83zzheap_restorez00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc2494z00zzheap_restorez00, BgL_bgl_za7c3anonymousza7a32061za7e3za783za7za7heap_restoreza7002559za7, BGl_zc3anonymousza32061ze3z83zzheap_restorez00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_restorezd2additionalzd2heapszd2envzd2zzheap_restorez00, BgL_bgl__restoreza7d2additionalza7d2heapsza700za7za7heap_restoreza7002560z00, BGl__restorezd2additionalzd2heapsz00zzheap_restorez00, 0L, 0 );



/* module-initialization */
obj_t BGl_modulezd2initializa7ationz75zzheap_restorez00(long BgL_checksumz00_1208, char * BgL_fromz00_1209)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzheap_restorez00))
{ 
BGl_requirezd2initializa7ationz75zzheap_restorez00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzheap_restorez00(); 
BGl_cnstzd2initzd2zzheap_restorez00(); 
BGl_importedzd2moduleszd2initz00zzheap_restorez00(); 
BGl_toplevelzd2initzd2zzheap_restorez00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzheap_restorez00()
{ AN_OBJECT;
{ /* Heap/restore.scm 15 */
BGl_modulezd2initializa7ationz75zz__osz00(((long)0), "heap_restore"); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)0), "heap_restore"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "heap_restore"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "heap_restore"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "heap_restore"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "heap_restore"); 
BGl_modulezd2initializa7ationz75zz__binaryz00(((long)0), "heap_restore"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "heap_restore"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "heap_restore"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "heap_restore"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "heap_restore"); 
BGl_modulezd2initializa7ationz75zz__hashz00(((long)0), "heap_restore"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzheap_restorez00()
{ AN_OBJECT;
{ /* Heap/restore.scm 15 */
{ /* Heap/restore.scm 15 */
obj_t BgL_cportz00_1201;
BgL_cportz00_1201 = 
open_input_string(BGl_string2497z00zzheap_restorez00); 
{ 
long BgL_iz00_1202;
BgL_iz00_1202 = ((long)13); 
BgL_loopz00_1203:
if(
(BgL_iz00_1202==((long)-1)))
{ /* Heap/restore.scm 15 */
return BUNSPEC;}  else 
{ /* Heap/restore.scm 15 */
{ /* Heap/restore.scm 15 */
obj_t BgL_arg2501z00_1205;
{ /* Heap/restore.scm 15 */
obj_t BgL_list2504z00_1206;
BgL_list2504z00_1206 = 
MAKE_PAIR(BgL_cportz00_1201, BNIL); 
BgL_arg2501z00_1205 = 
BGl_readz00zz__readerz00(BgL_list2504z00_1206); } 
{ /* Heap/restore.scm 15 */
int BgL_auxz00_1234;
BgL_auxz00_1234 = 
(int)(BgL_iz00_1202); 
CNST_TABLE_SET(BgL_auxz00_1234, BgL_arg2501z00_1205); } } 
{ 
long BgL_iz00_1237;
{ /* Heap/restore.scm 15 */
int BgL_auxz00_1238;
{ /* Heap/restore.scm 15 */
long BgL_auxz00_1239;
BgL_auxz00_1239 = 
(BgL_iz00_1202-((long)1)); 
BgL_auxz00_1238 = 
(int)(BgL_auxz00_1239); } 
BgL_iz00_1237 = 
(long)(BgL_auxz00_1238); } 
BgL_iz00_1202 = BgL_iz00_1237; 
goto BgL_loopz00_1203;} } } } } 
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zzheap_restorez00()
{ AN_OBJECT;
{ /* Heap/restore.scm 15 */
BGl_za2heapzd2modulezd2listza2z00zzheap_restorez00 = BNIL; 
return ( 
BGl_za2heapzd2markza2zd2zzheap_restorez00 = 
CNST_TABLE_REF(((long)0)), BUNSPEC) ;} 
}



/* restore-heap */
obj_t BGl_restorezd2heapzd2zzheap_restorez00()
{ AN_OBJECT;
{ /* Heap/restore.scm 35 */
{ /* Heap/restore.scm 36 */
bool_t BgL_test1575z00_421;
{ /* Heap/restore.scm 36 */
obj_t BgL_objz00_834;
BgL_objz00_834 = BGl_za2heapzd2nameza2zd2zzengine_paramz00; 
BgL_test1575z00_421 = 
STRINGP(BgL_objz00_834); } 
if(BgL_test1575z00_421)
{ /* Heap/restore.scm 36 */
{ /* Heap/restore.scm 38 */
obj_t BgL_list1577z00_422;
{ /* Heap/restore.scm 38 */
obj_t BgL_arg1581z00_424;
{ /* Heap/restore.scm 38 */
obj_t BgL_arg1586z00_426;
{ /* Heap/restore.scm 38 */
obj_t BgL_auxz00_1246;
BgL_auxz00_1246 = 
BCHAR(((unsigned char)'\n')); 
BgL_arg1586z00_426 = 
MAKE_PAIR(BgL_auxz00_1246, BNIL); } 
BgL_arg1581z00_424 = 
MAKE_PAIR(BGl_string2474z00zzheap_restorez00, BgL_arg1586z00_426); } 
BgL_list1577z00_422 = 
MAKE_PAIR(BGl_string2475z00zzheap_restorez00, BgL_arg1581z00_424); } 
BGl_verbosez00zztools_speekz00(
BINT(((long)1)), BgL_list1577z00_422); } 
BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 = 
BINT(((long)0)); 
BGl_za2currentzd2passza2zd2zzengine_passz00 = BGl_string2474z00zzheap_restorez00; 
{ 
obj_t BgL_hooksz00_427;obj_t BgL_hnamesz00_428;
BgL_hooksz00_427 = BNIL; 
BgL_hnamesz00_428 = BNIL; 
BgL_loopz00_429:
if(
NULLP(BgL_hooksz00_427))
{ /* Heap/restore.scm 38 */
CNST_TABLE_REF(((long)1)); }  else 
{ /* Heap/restore.scm 38 */
bool_t BgL_test1597z00_434;
{ /* Heap/restore.scm 38 */
obj_t BgL_fun1614z00_440;
BgL_fun1614z00_440 = 
CAR(BgL_hooksz00_427); 
{ /* Heap/restore.scm 38 */
obj_t BgL_auxz00_1258;
BgL_auxz00_1258 = 
PROCEDURE_ENTRY(BgL_fun1614z00_440)(BgL_fun1614z00_440, BEOA); 
BgL_test1597z00_434 = 
CBOOL(BgL_auxz00_1258); } } 
if(BgL_test1597z00_434)
{ /* Heap/restore.scm 38 */
{ 
obj_t BgL_hnamesz00_1265;obj_t BgL_hooksz00_1263;
BgL_hooksz00_1263 = 
CDR(BgL_hooksz00_427); 
BgL_hnamesz00_1265 = 
CDR(BgL_hnamesz00_428); 
BgL_hnamesz00_428 = BgL_hnamesz00_1265; 
BgL_hooksz00_427 = BgL_hooksz00_1263; 
goto BgL_loopz00_429;} }  else 
{ /* Heap/restore.scm 38 */
BGl_internalzd2errorzd2zztools_errorz00(BGl_string2474z00zzheap_restorez00, BGl_string2476z00zzheap_restorez00, 
CAR(BgL_hnamesz00_428)); } } } 
{ /* Heap/restore.scm 39 */
obj_t BgL_fnamez00_441;
BgL_fnamez00_441 = 
BGl_findzd2filezf2pathz20zz__osz00(BGl_za2heapzd2nameza2zd2zzengine_paramz00, BGl_za2libzd2dirza2zd2zzengine_paramz00); 
if(
STRINGP(BgL_fnamez00_441))
{ /* Heap/restore.scm 41 */
obj_t BgL_portz00_443;
BgL_portz00_443 = 
BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00(BgL_fnamez00_441); 
{ /* Heap/restore.scm 43 */
obj_t BgL_handlerz00_1099;
{ 
int BgL_auxz00_1275;int BgL_auxz00_1273;
BgL_auxz00_1275 = 
(int)(((long)1)); 
BgL_auxz00_1273 = 
(int)(((long)4)); 
BgL_handlerz00_1099 = 
make_fx_procedure(BGl_handlerz00zzheap_restorez00, BgL_auxz00_1273, BgL_auxz00_1275); } 
{ /* Heap/restore.scm 43 */
int BgL_auxz00_1278;
BgL_auxz00_1278 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_handlerz00_1099, BgL_auxz00_1278, BgL_portz00_443); } 
{ /* Heap/restore.scm 42 */

if(
BINARY_PORTP(BgL_portz00_443))
{ /* Heap/restore.scm 46 */
{ /* Heap/restore.scm 54 */
obj_t BgL_list1620z00_446;
{ /* Heap/restore.scm 54 */
obj_t BgL_arg1624z00_448;
{ /* Heap/restore.scm 54 */
obj_t BgL_arg1627z00_449;
{ /* Heap/restore.scm 54 */
obj_t BgL_arg1631z00_451;
{ /* Heap/restore.scm 54 */
obj_t BgL_auxz00_1283;
BgL_auxz00_1283 = 
BCHAR(((unsigned char)'\n')); 
BgL_arg1631z00_451 = 
MAKE_PAIR(BgL_auxz00_1283, BNIL); } 
BgL_arg1627z00_449 = 
MAKE_PAIR(BGl_string2477z00zzheap_restorez00, BgL_arg1631z00_451); } 
BgL_arg1624z00_448 = 
MAKE_PAIR(BgL_fnamez00_441, BgL_arg1627z00_449); } 
BgL_list1620z00_446 = 
MAKE_PAIR(BGl_string2478z00zzheap_restorez00, BgL_arg1624z00_448); } 
BGl_verbosez00zztools_speekz00(
BINT(((long)2)), BgL_list1620z00_446); } 
{ /* Heap/restore.scm 57 */
obj_t BgL_armed1553z00_452;obj_t BgL_handler1550z00_453;
BgL_armed1553z00_452 = 
MAKE_CELL(BUNSPEC); 
BgL_handler1550z00_453 = 
MAKE_CELL(BUNSPEC); 
{ /* Heap/restore.scm 57 */
obj_t BgL_zc3anonymousza31652ze3z83_1095;obj_t BgL_zc3anonymousza31649ze3z83_1097;
{ 
int BgL_auxz00_1293;int BgL_auxz00_1291;
BgL_auxz00_1293 = 
(int)(((long)1)); 
BgL_auxz00_1291 = 
(int)(((long)0)); 
BgL_zc3anonymousza31652ze3z83_1095 = 
make_fx_procedure(BGl_zc3anonymousza31652ze3z83zzheap_restorez00, BgL_auxz00_1291, BgL_auxz00_1293); } 
{ 
int BgL_auxz00_1298;int BgL_auxz00_1296;
BgL_auxz00_1298 = 
(int)(((long)2)); 
BgL_auxz00_1296 = 
(int)(((long)4)); 
BgL_zc3anonymousza31649ze3z83_1097 = 
make_fx_procedure(BGl_zc3anonymousza31649ze3z83zzheap_restorez00, BgL_auxz00_1296, BgL_auxz00_1298); } 
{ /* Heap/restore.scm 57 */
int BgL_auxz00_1301;
BgL_auxz00_1301 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31652ze3z83_1095, BgL_auxz00_1301, BgL_portz00_443); } 
{ /* Heap/restore.scm 57 */
int BgL_auxz00_1304;
BgL_auxz00_1304 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31649ze3z83_1097, BgL_auxz00_1304, BgL_armed1553z00_452); } 
{ /* Heap/restore.scm 57 */
int BgL_auxz00_1307;
BgL_auxz00_1307 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_zc3anonymousza31649ze3z83_1097, BgL_auxz00_1307, BgL_handler1550z00_453); } 
CELL_SET(BgL_handler1550z00_453, BgL_handlerz00_1099); 
CELL_SET(BgL_armed1553z00_452, BTRUE); 
return 
BGl_handling_function1634z00zzheap_restorez00(BgL_zc3anonymousza31652ze3z83_1095, BgL_zc3anonymousza31649ze3z83_1097, BgL_handler1550z00_453, BgL_armed1553z00_452);} } }  else 
{ /* Heap/restore.scm 46 */
{ /* Heap/restore.scm 48 */
obj_t BgL_arg1714z00_507;
BgL_arg1714z00_507 = 
string_append_3(BGl_string2479z00zzheap_restorez00, BgL_fnamez00_441, BGl_string2480z00zzheap_restorez00); 
{ /* Heap/restore.scm 48 */
obj_t BgL_objectz00_868;
BgL_objectz00_868 = BGl_za2libzd2dirza2zd2zzengine_paramz00; 
FAILURE(BGl_string2481z00zzheap_restorez00,BgL_arg1714z00_507,BgL_objectz00_868);} } 
return 
BGl_exitzd2bigloozd2zzinit_mainz00(
BINT(((long)-5)));} } } }  else 
{ /* Heap/restore.scm 40 */
{ /* Heap/restore.scm 100 */
obj_t BgL_arg1727z00_515;
BgL_arg1727z00_515 = 
string_append_3(BGl_string2479z00zzheap_restorez00, BGl_za2heapzd2nameza2zd2zzengine_paramz00, BGl_string2480z00zzheap_restorez00); 
{ /* Heap/restore.scm 100 */
obj_t BgL_objectz00_871;
BgL_objectz00_871 = BGl_za2libzd2dirza2zd2zzengine_paramz00; 
FAILURE(BGl_string2481z00zzheap_restorez00,BgL_arg1727z00_515,BgL_objectz00_871);} } 
return 
BGl_exitzd2bigloozd2zzinit_mainz00(
BINT(((long)-5)));} } }  else 
{ /* Heap/restore.scm 36 */
return BFALSE;} } } 
}



/* handling_function1634 */
obj_t BGl_handling_function1634z00zzheap_restorez00(obj_t BgL_zc3anonymousza31652ze3z83_1199, obj_t BgL_zc3anonymousza31649ze3z83_1198, obj_t BgL_handler1550z00_1197, obj_t BgL_armed1553z00_1196)
{ AN_OBJECT;
{ /* Heap/restore.scm 57 */
jmp_buf jmpbuf; 
obj_t BgL_an_exit1554z00_457;
if( SET_EXIT(BgL_an_exit1554z00_457) ) { RESTORE_TRACE(); 
return 
_exit_value_;
} else {
BgL_an_exit1554z00_457 = 
(obj_t)jmpbuf; 
{ /* Heap/restore.scm 57 */

PUSH_EXIT(BgL_an_exit1554z00_457, ((bool_t)1)); 
{ /* Heap/restore.scm 57 */
obj_t BgL_an_exitd1555z00_458;
BgL_an_exitd1555z00_458 = 
BGL_GET_EXITD_TOP(); 
{ /* Heap/restore.scm 57 */
obj_t BgL_escapez00_1096;
{ 
int BgL_auxz00_1325;int BgL_auxz00_1323;
BgL_auxz00_1325 = 
(int)(((long)1)); 
BgL_auxz00_1323 = 
(int)(((long)1)); 
BgL_escapez00_1096 = 
make_fx_procedure(BGl_escapez00zzheap_restorez00, BgL_auxz00_1323, BgL_auxz00_1325); } 
{ /* Heap/restore.scm 57 */
int BgL_auxz00_1328;
BgL_auxz00_1328 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_escapez00_1096, BgL_auxz00_1328, BgL_an_exitd1555z00_458); } 
{ /* Heap/restore.scm 57 */
obj_t BgL_res1557z00_461;
{ /* Heap/restore.scm 57 */
obj_t BgL_zc3anonymousza31645ze3z83_1092;obj_t BgL_zc3anonymousza31643ze3z83_1098;
{ 
int BgL_auxz00_1333;int BgL_auxz00_1331;
BgL_auxz00_1333 = 
(int)(((long)1)); 
BgL_auxz00_1331 = 
(int)(((long)0)); 
BgL_zc3anonymousza31645ze3z83_1092 = 
make_fx_procedure(BGl_zc3anonymousza31645ze3z83zzheap_restorez00, BgL_auxz00_1331, BgL_auxz00_1333); } 
{ 
int BgL_auxz00_1338;int BgL_auxz00_1336;
BgL_auxz00_1338 = 
(int)(((long)5)); 
BgL_auxz00_1336 = 
(int)(((long)0)); 
BgL_zc3anonymousza31643ze3z83_1098 = 
make_fx_procedure(BGl_zc3anonymousza31643ze3z83zzheap_restorez00, BgL_auxz00_1336, BgL_auxz00_1338); } 
{ /* Heap/restore.scm 57 */
int BgL_auxz00_1341;
BgL_auxz00_1341 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31645ze3z83_1092, BgL_auxz00_1341, BgL_armed1553z00_1196); } 
{ /* Heap/restore.scm 57 */
int BgL_auxz00_1344;
BgL_auxz00_1344 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31643ze3z83_1098, BgL_auxz00_1344, BgL_an_exitd1555z00_458); } 
{ /* Heap/restore.scm 57 */
int BgL_auxz00_1347;
BgL_auxz00_1347 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_zc3anonymousza31643ze3z83_1098, BgL_auxz00_1347, BgL_armed1553z00_1196); } 
{ /* Heap/restore.scm 57 */
int BgL_auxz00_1350;
BgL_auxz00_1350 = 
(int)(((long)2)); 
PROCEDURE_SET(BgL_zc3anonymousza31643ze3z83_1098, BgL_auxz00_1350, BgL_handler1550z00_1197); } 
{ /* Heap/restore.scm 57 */
int BgL_auxz00_1353;
BgL_auxz00_1353 = 
(int)(((long)3)); 
PROCEDURE_SET(BgL_zc3anonymousza31643ze3z83_1098, BgL_auxz00_1353, BgL_zc3anonymousza31649ze3z83_1198); } 
{ /* Heap/restore.scm 57 */
int BgL_auxz00_1356;
BgL_auxz00_1356 = 
(int)(((long)4)); 
PROCEDURE_SET(BgL_zc3anonymousza31643ze3z83_1098, BgL_auxz00_1356, BgL_escapez00_1096); } 
BgL_res1557z00_461 = 
BGl_dynamiczd2windzd2zz__r4_control_features_6_9z00(BgL_zc3anonymousza31643ze3z83_1098, BgL_zc3anonymousza31652ze3z83_1199, BgL_zc3anonymousza31645ze3z83_1092); } 
POP_EXIT(); 
return BgL_res1557z00_461;} } } } 
} } 
}



/* _restore-heap */
obj_t BGl__restorezd2heapzd2zzheap_restorez00(obj_t BgL_envz00_1100)
{ AN_OBJECT;
{ /* Heap/restore.scm 35 */
return 
BGl_restorezd2heapzd2zzheap_restorez00();} 
}



/* <anonymous:1645> */
obj_t BGl_zc3anonymousza31645ze3z83zzheap_restorez00(obj_t BgL_envz00_1101)
{ AN_OBJECT;
{ /* Heap/restore.scm 57 */
{ /* Heap/restore.scm 57 */
obj_t BgL_armed1553z00_1102;
{ /* Heap/restore.scm 57 */
int BgL_auxz00_1362;
BgL_auxz00_1362 = 
(int)(((long)0)); 
BgL_armed1553z00_1102 = 
PROCEDURE_REF(BgL_envz00_1101, BgL_auxz00_1362); } 
{ 

{ /* Heap/restore.scm 57 */
bool_t BgL_testz00_1365;
{ /* Heap/restore.scm 57 */
obj_t BgL_auxz00_1366;
BgL_auxz00_1366 = 
CELL_REF(BgL_armed1553z00_1102); 
BgL_testz00_1365 = 
CBOOL(BgL_auxz00_1366); } 
if(BgL_testz00_1365)
{ /* Heap/restore.scm 57 */
CELL_SET(BgL_armed1553z00_1102, BFALSE); 
return 
BGl_removezd2errorzd2handlerz12z12zz__errorz00();}  else 
{ /* Heap/restore.scm 57 */
return BFALSE;} } } } } 
}



/* <anonymous:1652> */
obj_t BGl_zc3anonymousza31652ze3z83zzheap_restorez00(obj_t BgL_envz00_1104)
{ AN_OBJECT;
{ /* Heap/restore.scm 57 */
{ /* Heap/restore.scm 57 */
obj_t BgL_portz00_1105;
{ /* Heap/restore.scm 57 */
int BgL_auxz00_1369;
BgL_auxz00_1369 = 
(int)(((long)0)); 
BgL_portz00_1105 = 
PROCEDURE_REF(BgL_envz00_1104, BgL_auxz00_1369); } 
{ 

{ /* Heap/restore.scm 57 */
bool_t BgL_auxz00_1372;
{ /* Heap/restore.scm 57 */
obj_t BgL_envsz00_474;
BgL_envsz00_474 = 
input_obj(BgL_portz00_1105); 
{ /* Heap/restore.scm 57 */
obj_t BgL_dummyz00_475;
{ /* Heap/restore.scm 58 */
bool_t BgL_test1702z00_500;
if(
VECTORP(BgL_envsz00_474))
{ /* Heap/restore.scm 59 */
int BgL_arg1706z00_502;
BgL_arg1706z00_502 = 
VECTOR_LENGTH(BgL_envsz00_474); 
{ /* Heap/restore.scm 59 */
long BgL_auxz00_1377;
BgL_auxz00_1377 = 
(long)(BgL_arg1706z00_502); 
BgL_test1702z00_500 = 
(BgL_auxz00_1377==((long)3)); } }  else 
{ /* Heap/restore.scm 58 */
BgL_test1702z00_500 = ((bool_t)0); } 
if(BgL_test1702z00_500)
{ /* Heap/restore.scm 58 */
BgL_dummyz00_475 = BFALSE; }  else 
{ /* Heap/restore.scm 60 */
obj_t BgL_procz00_849;
BgL_procz00_849 = BGl_za2heapzd2nameza2zd2zzengine_paramz00; 
FAILURE(BgL_procz00_849,BGl_string2482z00zzheap_restorez00,BgL_envsz00_474);} } 
{ /* Heap/restore.scm 58 */
obj_t BgL_targetz00_476;
{ /* Heap/restore.scm 63 */
int BgL_kz00_853;
BgL_kz00_853 = 
(int)(((long)0)); 
BgL_targetz00_476 = 
VECTOR_REF(BgL_envsz00_474,BgL_kz00_853); } 
{ /* Heap/restore.scm 63 */
obj_t BgL_genvz00_477;
{ /* Heap/restore.scm 64 */
int BgL_kz00_855;
BgL_kz00_855 = 
(int)(((long)1)); 
BgL_genvz00_477 = 
VECTOR_REF(BgL_envsz00_474,BgL_kz00_855); } 
{ /* Heap/restore.scm 64 */
obj_t BgL_tenvz00_478;
{ /* Heap/restore.scm 65 */
int BgL_kz00_857;
BgL_kz00_857 = 
(int)(((long)2)); 
BgL_tenvz00_478 = 
VECTOR_REF(BgL_envsz00_474,BgL_kz00_857); } 
{ /* Heap/restore.scm 65 */

{ /* Heap/restore.scm 67 */
bool_t BgL_test1653z00_479;
BgL_test1653z00_479 = 
(BgL_targetz00_476==BGl_za2targetzd2languageza2zd2zzengine_paramz00); 
if(BgL_test1653z00_479)
{ /* Heap/restore.scm 67 */((bool_t)0); }  else 
{ /* Heap/restore.scm 68 */
obj_t BgL_arg1658z00_481;
BgL_arg1658z00_481 = 
MAKE_PAIR(BgL_targetz00_476, BGl_za2targetzd2languageza2zd2zzengine_paramz00); 
{ /* Heap/restore.scm 68 */
obj_t BgL_procz00_858;
BgL_procz00_858 = BGl_za2heapzd2nameza2zd2zzengine_paramz00; 
FAILURE(BgL_procz00_858,BGl_string2483z00zzheap_restorez00,BgL_arg1658z00_481);} } } 
BGl_closezd2binaryzd2portz00zz__binaryz00(BgL_portz00_1105); 
BGl_setzd2genvz12zc0zzast_envz00(BgL_genvz00_477); 
BGl_setzd2tenvz12zc0zztype_envz00(BgL_tenvz00_478); 
{ /* Heap/restore.scm 77 */
bool_t BgL_test1665z00_482;
if(
CBOOL(BGl_za2callzf2cczf3za2z01zzengine_paramz00))
{ /* Heap/restore.scm 77 */
BgL_test1665z00_482 = ((bool_t)0); }  else 
{ /* Heap/restore.scm 78 */
bool_t BgL_test1668z00_483;
{ /* Heap/restore.scm 78 */
obj_t BgL_auxz00_1397;
BgL_auxz00_1397 = 
CNST_TABLE_REF(((long)2)); 
BgL_test1668z00_483 = 
(BGl_za2targetzd2languageza2zd2zzengine_paramz00==BgL_auxz00_1397); } 
if(BgL_test1668z00_483)
{ /* Heap/restore.scm 78 */
BgL_test1665z00_482 = ((bool_t)0); }  else 
{ /* Heap/restore.scm 78 */
BgL_test1665z00_482 = ((bool_t)1); } } 
if(BgL_test1665z00_482)
{ /* Heap/restore.scm 77 */
BGl_unbindzd2callzf2ccz12z32zzheap_restorez00(); }  else 
{ /* Heap/restore.scm 77 */BFALSE; } } 
{ /* Heap/restore.scm 82 */
bool_t BgL_test1670z00_484;
{ /* Heap/restore.scm 82 */
obj_t BgL_auxz00_1403;
BgL_auxz00_1403 = 
CNST_TABLE_REF(((long)2)); 
BgL_test1670z00_484 = 
(BGl_za2targetzd2languageza2zd2zzengine_paramz00==BgL_auxz00_1403); } 
if(BgL_test1670z00_484)
{ /* Heap/restore.scm 82 */
BGl_forzd2eachzd2globalz12z12zzast_envz00(BGl_proc2484z00zzheap_restorez00); }  else 
{ /* Heap/restore.scm 82 */BFALSE; } } 
BGl_forzd2eachzd2globalz12z12zzast_envz00(BGl_proc2485z00zzheap_restorez00); 
{ /* Heap/restore.scm 95 */
bool_t BgL_test1696z00_499;
{ /* Heap/restore.scm 95 */
obj_t BgL_auxz00_1409;
BgL_auxz00_1409 = 
BGl_memberz00zz__r4_pairs_and_lists_6_3z00(BGl_za2heapzd2nameza2zd2zzengine_paramz00, BGl_za2heapzd2dumpzd2namesza2z00zzengine_paramz00); 
BgL_test1696z00_499 = 
CBOOL(BgL_auxz00_1409); } 
if(BgL_test1696z00_499)
{ /* Heap/restore.scm 95 */
BGl_dumpzd2heapzd2zzheap_restorez00(BGl_za2heapzd2nameza2zd2zzengine_paramz00, BgL_genvz00_477, BgL_tenvz00_478); }  else 
{ /* Heap/restore.scm 95 */BFALSE; } } 
BgL_auxz00_1372 = ((bool_t)1); } } } } } } 
return 
BBOOL(BgL_auxz00_1372);} } } } 
}



/* <anonymous:1643> */
obj_t BGl_zc3anonymousza31643ze3z83zzheap_restorez00(obj_t BgL_envz00_1106)
{ AN_OBJECT;
{ /* Heap/restore.scm 57 */
{ /* Heap/restore.scm 57 */
obj_t BgL_zc3anonymousza31649ze3z83_1110;obj_t BgL_escapez00_1111;
{ /* Heap/restore.scm 57 */
int BgL_auxz00_1415;
BgL_auxz00_1415 = 
(int)(((long)3)); 
BgL_zc3anonymousza31649ze3z83_1110 = 
PROCEDURE_REF(BgL_envz00_1106, BgL_auxz00_1415); } 
{ /* Heap/restore.scm 57 */
int BgL_auxz00_1418;
BgL_auxz00_1418 = 
(int)(((long)4)); 
BgL_escapez00_1111 = 
PROCEDURE_REF(BgL_envz00_1106, BgL_auxz00_1418); } 
{ 

return 
BGl_addzd2errorzd2handlerz12z12zz__errorz00(BgL_zc3anonymousza31649ze3z83_1110, BgL_escapez00_1111);} } } 
}



/* escape */
obj_t BGl_escapez00zzheap_restorez00(obj_t BgL_envz00_1112, obj_t BgL_val1556z00_1114)
{ AN_OBJECT;
{ /* Heap/restore.scm 57 */
{ /* Heap/restore.scm 57 */
obj_t BgL_an_exitd1555z00_1113;
{ /* Heap/restore.scm 57 */
int BgL_auxz00_1422;
BgL_auxz00_1422 = 
(int)(((long)0)); 
BgL_an_exitd1555z00_1113 = 
PROCEDURE_REF(BgL_envz00_1112, BgL_auxz00_1422); } 
{ 
obj_t BgL_val1556z00_459;
BgL_val1556z00_459 = BgL_val1556z00_1114; 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1555z00_1113, BgL_val1556z00_459);} } } 
}



/* <anonymous:1649> */
obj_t BGl_zc3anonymousza31649ze3z83zzheap_restorez00(obj_t BgL_envz00_1115, obj_t BgL_escz00_1118, obj_t BgL_objz00_1119, obj_t BgL_procz00_1120, obj_t BgL_msgz00_1121)
{ AN_OBJECT;
{ /* Heap/restore.scm 57 */
{ /* Heap/restore.scm 57 */
obj_t BgL_armed1553z00_1116;obj_t BgL_handler1550z00_1117;
{ /* Heap/restore.scm 57 */
int BgL_auxz00_1426;
BgL_auxz00_1426 = 
(int)(((long)0)); 
BgL_armed1553z00_1116 = 
PROCEDURE_REF(BgL_envz00_1115, BgL_auxz00_1426); } 
{ /* Heap/restore.scm 57 */
int BgL_auxz00_1429;
BgL_auxz00_1429 = 
(int)(((long)1)); 
BgL_handler1550z00_1117 = 
PROCEDURE_REF(BgL_envz00_1115, BgL_auxz00_1429); } 
{ 
obj_t BgL_escz00_468;obj_t BgL_objz00_469;obj_t BgL_procz00_470;obj_t BgL_msgz00_471;
BgL_escz00_468 = BgL_escz00_1118; 
BgL_objz00_469 = BgL_objz00_1119; 
BgL_procz00_470 = BgL_procz00_1120; 
BgL_msgz00_471 = BgL_msgz00_1121; 
CELL_SET(BgL_armed1553z00_1116, BFALSE); 
BGl_removezd2errorzd2handlerz12z12zz__errorz00(); 
{ /* Heap/restore.scm 57 */
obj_t BgL_auxz00_1434;
BgL_auxz00_1434 = 
CELL_REF(BgL_handler1550z00_1117); 
return 
PROCEDURE_ENTRY(BgL_auxz00_1434)(
CELL_REF(BgL_handler1550z00_1117), BgL_escz00_468, BgL_objz00_469, BgL_procz00_470, BgL_msgz00_471, BEOA);} } } } 
}



/* handler */
obj_t BGl_handlerz00zzheap_restorez00(obj_t BgL_envz00_1123, obj_t BgL_escapez00_1125, obj_t BgL_procz00_1126, obj_t BgL_mesz00_1127, obj_t BgL_objz00_1128)
{ AN_OBJECT;
{ /* Heap/restore.scm 42 */
{ /* Heap/restore.scm 43 */
obj_t BgL_portz00_1124;
{ /* Heap/restore.scm 43 */
int BgL_auxz00_1435;
BgL_auxz00_1435 = 
(int)(((long)0)); 
BgL_portz00_1124 = 
PROCEDURE_REF(BgL_envz00_1123, BgL_auxz00_1435); } 
{ 
obj_t BgL_escapez00_508;obj_t BgL_procz00_509;obj_t BgL_mesz00_510;obj_t BgL_objz00_511;
BgL_escapez00_508 = BgL_escapez00_1125; 
BgL_procz00_509 = BgL_procz00_1126; 
BgL_mesz00_510 = BgL_mesz00_1127; 
BgL_objz00_511 = BgL_objz00_1128; 
BGl_notifyzd2errorzd2zz__errorz00(BgL_procz00_509, BgL_mesz00_510, BgL_objz00_511); 
BGl_closezd2binaryzd2portz00zz__binaryz00(BgL_portz00_1124); 
return 
BGl_exitzd2bigloozd2zzinit_mainz00(
BINT(((long)-5)));} } } 
}



/* <anonymous:1689> */
obj_t BGl_zc3anonymousza31689ze3z83zzheap_restorez00(obj_t BgL_envz00_1129, obj_t BgL_newz00_1130)
{ AN_OBJECT;
{ /* Heap/restore.scm 91 */
{ 
obj_t BgL_newz00_494;
BgL_newz00_494 = BgL_newz00_1130; 
{ /* Heap/restore.scm 92 */
obj_t BgL_list1693z00_864;
{ /* Heap/restore.scm 92 */
obj_t BgL_auxz00_1442;
{ /* Heap/restore.scm 92 */
BgL_globalz00_bglt BgL_obj1171z00_865;
BgL_obj1171z00_865 = 
(BgL_globalz00_bglt)(BgL_newz00_494); 
BgL_auxz00_1442 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1171z00_865))->BgL_modulez00); } 
BgL_list1693z00_864 = 
MAKE_PAIR(BgL_auxz00_1442, BNIL); } 
return 
BGl_heapzd2modulezd2listz00zzheap_restorez00(BgL_list1693z00_864);} } } 
}



/* <anonymous:1674> */
obj_t BGl_zc3anonymousza31674ze3z83zzheap_restorez00(obj_t BgL_envz00_1131, obj_t BgL_newz00_1132)
{ AN_OBJECT;
{ /* Heap/restore.scm 84 */
{ 
obj_t BgL_newz00_486;
BgL_newz00_486 = BgL_newz00_1132; 
{ /* Heap/restore.scm 86 */
obj_t BgL_arg1676z00_488;obj_t BgL_arg1677z00_489;obj_t BgL_arg1678z00_490;
{ /* Heap/restore.scm 86 */
BgL_globalz00_bglt BgL_obj1171z00_861;
BgL_obj1171z00_861 = 
(BgL_globalz00_bglt)(BgL_newz00_486); 
BgL_arg1676z00_488 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1171z00_861))->BgL_modulez00); } 
{ /* Heap/restore.scm 87 */
BgL_globalz00_bglt BgL_obj1192z00_862;
BgL_obj1192z00_862 = 
(BgL_globalz00_bglt)(BgL_newz00_486); 
BgL_arg1677z00_489 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1192z00_862))->BgL_jvmzd2typezd2namez00); } 
BgL_arg1678z00_490 = 
BGl_shapez00zztools_shapez00(BgL_newz00_486); 
{ /* Heap/restore.scm 85 */
obj_t BgL_list1680z00_491;
BgL_list1680z00_491 = 
MAKE_PAIR(BgL_arg1678z00_490, BNIL); 
return 
BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(BgL_arg1676z00_488, BgL_arg1677z00_489, BgL_list1680z00_491);} } } } 
}



/* unbind-call/cc! */
obj_t BGl_unbindzd2callzf2ccz12z32zzheap_restorez00()
{ AN_OBJECT;
{ /* Heap/restore.scm 110 */
{ /* Heap/restore.scm 111 */
bool_t BgL_test1734z00_516;
{ /* Heap/restore.scm 111 */
obj_t BgL_auxz00_1454;
BgL_auxz00_1454 = 
BGl_findzd2globalzf2modulez20zzast_envz00(
CNST_TABLE_REF(((long)3)), 
CNST_TABLE_REF(((long)4))); 
BgL_test1734z00_516 = 
CBOOL(BgL_auxz00_1454); } 
if(BgL_test1734z00_516)
{ /* Heap/restore.scm 111 */
BGl_unbindzd2globalz12zc0zzast_envz00(
CNST_TABLE_REF(((long)3)), 
CNST_TABLE_REF(((long)4))); }  else 
{ /* Heap/restore.scm 111 */BFALSE; } } 
{ /* Heap/restore.scm 113 */
bool_t BgL_test1737z00_517;
{ /* Heap/restore.scm 113 */
obj_t BgL_auxz00_1463;
BgL_auxz00_1463 = 
BGl_findzd2globalzf2modulez20zzast_envz00(
CNST_TABLE_REF(((long)5)), 
CNST_TABLE_REF(((long)4))); 
BgL_test1737z00_517 = 
CBOOL(BgL_auxz00_1463); } 
if(BgL_test1737z00_517)
{ /* Heap/restore.scm 113 */
return 
BGl_unbindzd2globalz12zc0zzast_envz00(
CNST_TABLE_REF(((long)5)), 
CNST_TABLE_REF(((long)4)));}  else 
{ /* Heap/restore.scm 113 */
return BFALSE;} } } 
}



/* restore-additional-heaps */
obj_t BGl_restorezd2additionalzd2heapsz00zzheap_restorez00()
{ AN_OBJECT;
{ /* Heap/restore.scm 121 */
{ /* Heap/restore.scm 122 */
bool_t BgL_test1740z00_518;
{ /* Heap/restore.scm 122 */
obj_t BgL_objz00_872;
BgL_objz00_872 = BGl_za2additionalzd2heapzd2namesza2z00zzengine_paramz00; 
BgL_test1740z00_518 = 
PAIRP(BgL_objz00_872); } 
if(BgL_test1740z00_518)
{ /* Heap/restore.scm 122 */
{ /* Heap/restore.scm 124 */
obj_t BgL_list1742z00_519;
{ /* Heap/restore.scm 124 */
obj_t BgL_arg1747z00_521;
{ /* Heap/restore.scm 124 */
obj_t BgL_arg1752z00_523;
{ /* Heap/restore.scm 124 */
obj_t BgL_auxz00_1474;
BgL_auxz00_1474 = 
BCHAR(((unsigned char)'\n')); 
BgL_arg1752z00_523 = 
MAKE_PAIR(BgL_auxz00_1474, BNIL); } 
BgL_arg1747z00_521 = 
MAKE_PAIR(BGl_string2486z00zzheap_restorez00, BgL_arg1752z00_523); } 
BgL_list1742z00_519 = 
MAKE_PAIR(BGl_string2475z00zzheap_restorez00, BgL_arg1747z00_521); } 
BGl_verbosez00zztools_speekz00(
BINT(((long)1)), BgL_list1742z00_519); } 
BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 = 
BINT(((long)0)); 
BGl_za2currentzd2passza2zd2zzengine_passz00 = BGl_string2486z00zzheap_restorez00; 
{ 
obj_t BgL_hooksz00_524;obj_t BgL_hnamesz00_525;
BgL_hooksz00_524 = BNIL; 
BgL_hnamesz00_525 = BNIL; 
BgL_loopz00_526:
if(
NULLP(BgL_hooksz00_524))
{ /* Heap/restore.scm 124 */
CNST_TABLE_REF(((long)1)); }  else 
{ /* Heap/restore.scm 124 */
bool_t BgL_test1764z00_531;
{ /* Heap/restore.scm 124 */
obj_t BgL_fun1780z00_537;
BgL_fun1780z00_537 = 
CAR(BgL_hooksz00_524); 
{ /* Heap/restore.scm 124 */
obj_t BgL_auxz00_1486;
BgL_auxz00_1486 = 
PROCEDURE_ENTRY(BgL_fun1780z00_537)(BgL_fun1780z00_537, BEOA); 
BgL_test1764z00_531 = 
CBOOL(BgL_auxz00_1486); } } 
if(BgL_test1764z00_531)
{ /* Heap/restore.scm 124 */
{ 
obj_t BgL_hnamesz00_1493;obj_t BgL_hooksz00_1491;
BgL_hooksz00_1491 = 
CDR(BgL_hooksz00_524); 
BgL_hnamesz00_1493 = 
CDR(BgL_hnamesz00_525); 
BgL_hnamesz00_525 = BgL_hnamesz00_1493; 
BgL_hooksz00_524 = BgL_hooksz00_1491; 
goto BgL_loopz00_526;} }  else 
{ /* Heap/restore.scm 124 */
BGl_internalzd2errorzd2zztools_errorz00(BGl_string2486z00zzheap_restorez00, BGl_string2476z00zzheap_restorez00, 
CAR(BgL_hnamesz00_525)); } } } 
{ 
obj_t BgL_l1558z00_538;
{ /* Heap/restore.scm 126 */
obj_t BgL_arg1784z00_540;
BgL_arg1784z00_540 = 
bgl_reverse(BGl_za2additionalzd2heapzd2namesza2z00zzengine_paramz00); 
{ /* Heap/restore.scm 125 */
bool_t BgL_auxz00_1498;
BgL_l1558z00_538 = BgL_arg1784z00_540; 
BgL_lname1559z00_539:
if(
PAIRP(BgL_l1558z00_538))
{ /* Heap/restore.scm 125 */
BGl_restorezd2additionalzd2heapz00zzheap_restorez00(
CAR(BgL_l1558z00_538)); 
{ 
obj_t BgL_l1558z00_1503;
BgL_l1558z00_1503 = 
CDR(BgL_l1558z00_538); 
BgL_l1558z00_538 = BgL_l1558z00_1503; 
goto BgL_lname1559z00_539;} }  else 
{ /* Heap/restore.scm 125 */
BgL_auxz00_1498 = ((bool_t)1); } 
return 
BBOOL(BgL_auxz00_1498);} } } }  else 
{ /* Heap/restore.scm 122 */
return BFALSE;} } } 
}



/* _restore-additional-heaps */
obj_t BGl__restorezd2additionalzd2heapsz00zzheap_restorez00(obj_t BgL_envz00_1135)
{ AN_OBJECT;
{ /* Heap/restore.scm 121 */
return 
BGl_restorezd2additionalzd2heapsz00zzheap_restorez00();} 
}



/* dump-additional-heaps */
obj_t BGl_dumpzd2additionalzd2heapsz00zzheap_restorez00()
{ AN_OBJECT;
{ /* Heap/restore.scm 131 */
{ 
obj_t BgL_l1560z00_544;
{ /* Heap/restore.scm 132 */
bool_t BgL_auxz00_1507;
BgL_l1560z00_544 = BGl_za2additionalzd2heapzd2namesza2z00zzengine_paramz00; 
BgL_lname1561z00_545:
if(
PAIRP(BgL_l1560z00_544))
{ /* Heap/restore.scm 132 */
{ /* Heap/restore.scm 133 */
obj_t BgL_heapz00_547;
BgL_heapz00_547 = 
CAR(BgL_l1560z00_544); 
{ /* Heap/restore.scm 133 */
bool_t BgL_test1800z00_548;
{ /* Heap/restore.scm 133 */
obj_t BgL_auxz00_1511;
BgL_auxz00_1511 = 
BGl_memberz00zz__r4_pairs_and_lists_6_3z00(BgL_heapz00_547, BGl_za2heapzd2dumpzd2namesza2z00zzengine_paramz00); 
BgL_test1800z00_548 = 
CBOOL(BgL_auxz00_1511); } 
if(BgL_test1800z00_548)
{ /* Heap/restore.scm 134 */
obj_t BgL_fnamez00_549;
BgL_fnamez00_549 = 
BGl_findzd2filezf2pathz20zz__osz00(BgL_heapz00_547, BGl_za2libzd2dirza2zd2zzengine_paramz00); 
{ /* Heap/restore.scm 135 */
obj_t BgL_portz00_550;
BgL_portz00_550 = 
BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00(BgL_fnamez00_549); 
{ /* Heap/restore.scm 136 */
obj_t BgL_envsz00_551;
BgL_envsz00_551 = 
input_obj(BgL_portz00_550); 
{ /* Heap/restore.scm 136 */
obj_t BgL_genvz00_552;
{ /* Heap/restore.scm 137 */
int BgL_kz00_887;
BgL_kz00_887 = 
(int)(((long)1)); 
BgL_genvz00_552 = 
VECTOR_REF(BgL_envsz00_551,BgL_kz00_887); } 
{ /* Heap/restore.scm 137 */
obj_t BgL_tenvz00_553;
{ /* Heap/restore.scm 138 */
int BgL_kz00_889;
BgL_kz00_889 = 
(int)(((long)2)); 
BgL_tenvz00_553 = 
VECTOR_REF(BgL_envsz00_551,BgL_kz00_889); } 
{ /* Heap/restore.scm 138 */

BGl_dumpzd2heapzd2zzheap_restorez00(BgL_heapz00_547, BgL_genvz00_552, BgL_tenvz00_553); } } } } } }  else 
{ /* Heap/restore.scm 133 */BFALSE; } } } 
{ 
obj_t BgL_l1560z00_1523;
BgL_l1560z00_1523 = 
CDR(BgL_l1560z00_544); 
BgL_l1560z00_544 = BgL_l1560z00_1523; 
goto BgL_lname1561z00_545;} }  else 
{ /* Heap/restore.scm 132 */
BgL_auxz00_1507 = ((bool_t)1); } 
return 
BBOOL(BgL_auxz00_1507);} } } 
}



/* _dump-additional-heaps */
obj_t BGl__dumpzd2additionalzd2heapsz00zzheap_restorez00(obj_t BgL_envz00_1136)
{ AN_OBJECT;
{ /* Heap/restore.scm 131 */
return 
BGl_dumpzd2additionalzd2heapsz00zzheap_restorez00();} 
}



/* restore-additional-heap */
obj_t BGl_restorezd2additionalzd2heapz00zzheap_restorez00(obj_t BgL_heapz00_1)
{ AN_OBJECT;
{ /* Heap/restore.scm 145 */
{ /* Heap/restore.scm 146 */
obj_t BgL_fnamez00_555;
BgL_fnamez00_555 = 
BGl_findzd2filezf2pathz20zz__osz00(BgL_heapz00_1, BGl_za2libzd2dirza2zd2zzengine_paramz00); 
if(
STRINGP(BgL_fnamez00_555))
{ /* Heap/restore.scm 148 */
obj_t BgL_portz00_557;
BgL_portz00_557 = 
BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00(BgL_fnamez00_555); 
{ /* Heap/restore.scm 150 */
obj_t BgL_handlerz00_1143;
{ 
int BgL_auxz00_1533;int BgL_auxz00_1531;
BgL_auxz00_1533 = 
(int)(((long)1)); 
BgL_auxz00_1531 = 
(int)(((long)4)); 
BgL_handlerz00_1143 = 
make_fx_procedure(BGl_handler_2266z00zzheap_restorez00, BgL_auxz00_1531, BgL_auxz00_1533); } 
{ /* Heap/restore.scm 150 */
int BgL_auxz00_1536;
BgL_auxz00_1536 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_handlerz00_1143, BgL_auxz00_1536, BgL_portz00_557); } 
{ /* Heap/restore.scm 149 */

if(
BINARY_PORTP(BgL_portz00_557))
{ /* Heap/restore.scm 153 */
{ /* Heap/restore.scm 161 */
obj_t BgL_list1817z00_560;
{ /* Heap/restore.scm 161 */
obj_t BgL_arg1822z00_562;
{ /* Heap/restore.scm 161 */
obj_t BgL_arg1825z00_563;
{ /* Heap/restore.scm 161 */
obj_t BgL_arg1831z00_565;
{ /* Heap/restore.scm 161 */
obj_t BgL_auxz00_1541;
BgL_auxz00_1541 = 
BCHAR(((unsigned char)'\n')); 
BgL_arg1831z00_565 = 
MAKE_PAIR(BgL_auxz00_1541, BNIL); } 
BgL_arg1825z00_563 = 
MAKE_PAIR(BGl_string2477z00zzheap_restorez00, BgL_arg1831z00_565); } 
BgL_arg1822z00_562 = 
MAKE_PAIR(BgL_fnamez00_555, BgL_arg1825z00_563); } 
BgL_list1817z00_560 = 
MAKE_PAIR(BGl_string2478z00zzheap_restorez00, BgL_arg1822z00_562); } 
BGl_verbosez00zztools_speekz00(
BINT(((long)2)), BgL_list1817z00_560); } 
{ /* Heap/restore.scm 164 */
obj_t BgL_armed1565z00_566;obj_t BgL_handler1562z00_567;
BgL_armed1565z00_566 = 
MAKE_CELL(BUNSPEC); 
BgL_handler1562z00_567 = 
MAKE_CELL(BUNSPEC); 
{ /* Heap/restore.scm 164 */
obj_t BgL_zc3anonymousza31851ze3z83_1139;obj_t BgL_zc3anonymousza31848ze3z83_1141;
{ 
int BgL_auxz00_1551;int BgL_auxz00_1549;
BgL_auxz00_1551 = 
(int)(((long)2)); 
BgL_auxz00_1549 = 
(int)(((long)0)); 
BgL_zc3anonymousza31851ze3z83_1139 = 
make_fx_procedure(BGl_zc3anonymousza31851ze3z83zzheap_restorez00, BgL_auxz00_1549, BgL_auxz00_1551); } 
{ 
int BgL_auxz00_1556;int BgL_auxz00_1554;
BgL_auxz00_1556 = 
(int)(((long)2)); 
BgL_auxz00_1554 = 
(int)(((long)4)); 
BgL_zc3anonymousza31848ze3z83_1141 = 
make_fx_procedure(BGl_zc3anonymousza31848ze3z83zzheap_restorez00, BgL_auxz00_1554, BgL_auxz00_1556); } 
{ /* Heap/restore.scm 164 */
int BgL_auxz00_1559;
BgL_auxz00_1559 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31851ze3z83_1139, BgL_auxz00_1559, BgL_portz00_557); } 
{ /* Heap/restore.scm 164 */
int BgL_auxz00_1562;
BgL_auxz00_1562 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_zc3anonymousza31851ze3z83_1139, BgL_auxz00_1562, BgL_heapz00_1); } 
{ /* Heap/restore.scm 164 */
int BgL_auxz00_1565;
BgL_auxz00_1565 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31848ze3z83_1141, BgL_auxz00_1565, BgL_armed1565z00_566); } 
{ /* Heap/restore.scm 164 */
int BgL_auxz00_1568;
BgL_auxz00_1568 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_zc3anonymousza31848ze3z83_1141, BgL_auxz00_1568, BgL_handler1562z00_567); } 
CELL_SET(BgL_handler1562z00_567, BgL_handlerz00_1143); 
CELL_SET(BgL_armed1565z00_566, BTRUE); 
return 
BGl_handling_function1834z00zzheap_restorez00(BgL_zc3anonymousza31851ze3z83_1139, BgL_zc3anonymousza31848ze3z83_1141, BgL_handler1562z00_567, BgL_armed1565z00_566);} } }  else 
{ /* Heap/restore.scm 153 */
{ /* Heap/restore.scm 155 */
obj_t BgL_arg1902z00_618;
BgL_arg1902z00_618 = 
string_append_3(BGl_string2479z00zzheap_restorez00, BgL_fnamez00_555, BGl_string2480z00zzheap_restorez00); 
{ /* Heap/restore.scm 155 */
obj_t BgL_objectz00_921;
BgL_objectz00_921 = BGl_za2libzd2dirza2zd2zzengine_paramz00; 
FAILURE(BGl_string2487z00zzheap_restorez00,BgL_arg1902z00_618,BgL_objectz00_921);} } 
return 
BGl_exitzd2bigloozd2zzinit_mainz00(
BINT(((long)-6)));} } } }  else 
{ /* Heap/restore.scm 147 */
{ /* Heap/restore.scm 207 */
obj_t BgL_arg1914z00_626;
BgL_arg1914z00_626 = 
string_append_3(BGl_string2479z00zzheap_restorez00, BgL_heapz00_1, BGl_string2480z00zzheap_restorez00); 
{ /* Heap/restore.scm 207 */
obj_t BgL_objectz00_924;
BgL_objectz00_924 = BGl_za2libzd2dirza2zd2zzengine_paramz00; 
FAILURE(BGl_string2487z00zzheap_restorez00,BgL_arg1914z00_626,BgL_objectz00_924);} } 
return 
BGl_exitzd2bigloozd2zzinit_mainz00(
BINT(((long)-6)));} } } 
}



/* handling_function1834 */
obj_t BGl_handling_function1834z00zzheap_restorez00(obj_t BgL_zc3anonymousza31851ze3z83_1195, obj_t BgL_zc3anonymousza31848ze3z83_1194, obj_t BgL_handler1562z00_1193, obj_t BgL_armed1565z00_1192)
{ AN_OBJECT;
{ /* Heap/restore.scm 164 */
jmp_buf jmpbuf; 
obj_t BgL_an_exit1569z00_571;
if( SET_EXIT(BgL_an_exit1569z00_571) ) { RESTORE_TRACE(); 
return 
_exit_value_;
} else {
BgL_an_exit1569z00_571 = 
(obj_t)jmpbuf; 
{ /* Heap/restore.scm 164 */

PUSH_EXIT(BgL_an_exit1569z00_571, ((bool_t)1)); 
{ /* Heap/restore.scm 164 */
obj_t BgL_an_exitd1570z00_572;
BgL_an_exitd1570z00_572 = 
BGL_GET_EXITD_TOP(); 
{ /* Heap/restore.scm 164 */
obj_t BgL_escapez00_1140;
{ 
int BgL_auxz00_1586;int BgL_auxz00_1584;
BgL_auxz00_1586 = 
(int)(((long)1)); 
BgL_auxz00_1584 = 
(int)(((long)1)); 
BgL_escapez00_1140 = 
make_fx_procedure(BGl_escape_2262z00zzheap_restorez00, BgL_auxz00_1584, BgL_auxz00_1586); } 
{ /* Heap/restore.scm 164 */
int BgL_auxz00_1589;
BgL_auxz00_1589 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_escapez00_1140, BgL_auxz00_1589, BgL_an_exitd1570z00_572); } 
{ /* Heap/restore.scm 164 */
obj_t BgL_res1572z00_575;
{ /* Heap/restore.scm 164 */
obj_t BgL_zc3anonymousza31844ze3z83_1137;obj_t BgL_zc3anonymousza31842ze3z83_1142;
{ 
int BgL_auxz00_1594;int BgL_auxz00_1592;
BgL_auxz00_1594 = 
(int)(((long)1)); 
BgL_auxz00_1592 = 
(int)(((long)0)); 
BgL_zc3anonymousza31844ze3z83_1137 = 
make_fx_procedure(BGl_zc3anonymousza31844ze3z83zzheap_restorez00, BgL_auxz00_1592, BgL_auxz00_1594); } 
{ 
int BgL_auxz00_1599;int BgL_auxz00_1597;
BgL_auxz00_1599 = 
(int)(((long)5)); 
BgL_auxz00_1597 = 
(int)(((long)0)); 
BgL_zc3anonymousza31842ze3z83_1142 = 
make_fx_procedure(BGl_zc3anonymousza31842ze3z83zzheap_restorez00, BgL_auxz00_1597, BgL_auxz00_1599); } 
{ /* Heap/restore.scm 164 */
int BgL_auxz00_1602;
BgL_auxz00_1602 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31844ze3z83_1137, BgL_auxz00_1602, BgL_armed1565z00_1192); } 
{ /* Heap/restore.scm 164 */
int BgL_auxz00_1605;
BgL_auxz00_1605 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31842ze3z83_1142, BgL_auxz00_1605, BgL_an_exitd1570z00_572); } 
{ /* Heap/restore.scm 164 */
int BgL_auxz00_1608;
BgL_auxz00_1608 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_zc3anonymousza31842ze3z83_1142, BgL_auxz00_1608, BgL_armed1565z00_1192); } 
{ /* Heap/restore.scm 164 */
int BgL_auxz00_1611;
BgL_auxz00_1611 = 
(int)(((long)2)); 
PROCEDURE_SET(BgL_zc3anonymousza31842ze3z83_1142, BgL_auxz00_1611, BgL_handler1562z00_1193); } 
{ /* Heap/restore.scm 164 */
int BgL_auxz00_1614;
BgL_auxz00_1614 = 
(int)(((long)3)); 
PROCEDURE_SET(BgL_zc3anonymousza31842ze3z83_1142, BgL_auxz00_1614, BgL_zc3anonymousza31848ze3z83_1194); } 
{ /* Heap/restore.scm 164 */
int BgL_auxz00_1617;
BgL_auxz00_1617 = 
(int)(((long)4)); 
PROCEDURE_SET(BgL_zc3anonymousza31842ze3z83_1142, BgL_auxz00_1617, BgL_escapez00_1140); } 
BgL_res1572z00_575 = 
BGl_dynamiczd2windzd2zz__r4_control_features_6_9z00(BgL_zc3anonymousza31842ze3z83_1142, BgL_zc3anonymousza31851ze3z83_1195, BgL_zc3anonymousza31844ze3z83_1137); } 
POP_EXIT(); 
return BgL_res1572z00_575;} } } } 
} } 
}



/* <anonymous:1844> */
obj_t BGl_zc3anonymousza31844ze3z83zzheap_restorez00(obj_t BgL_envz00_1144)
{ AN_OBJECT;
{ /* Heap/restore.scm 164 */
{ /* Heap/restore.scm 164 */
obj_t BgL_armed1565z00_1145;
{ /* Heap/restore.scm 164 */
int BgL_auxz00_1622;
BgL_auxz00_1622 = 
(int)(((long)0)); 
BgL_armed1565z00_1145 = 
PROCEDURE_REF(BgL_envz00_1144, BgL_auxz00_1622); } 
{ 

{ /* Heap/restore.scm 164 */
bool_t BgL_testz00_1625;
{ /* Heap/restore.scm 164 */
obj_t BgL_auxz00_1626;
BgL_auxz00_1626 = 
CELL_REF(BgL_armed1565z00_1145); 
BgL_testz00_1625 = 
CBOOL(BgL_auxz00_1626); } 
if(BgL_testz00_1625)
{ /* Heap/restore.scm 164 */
CELL_SET(BgL_armed1565z00_1145, BFALSE); 
return 
BGl_removezd2errorzd2handlerz12z12zz__errorz00();}  else 
{ /* Heap/restore.scm 164 */
return BFALSE;} } } } } 
}



/* <anonymous:1851> */
obj_t BGl_zc3anonymousza31851ze3z83zzheap_restorez00(obj_t BgL_envz00_1147)
{ AN_OBJECT;
{ /* Heap/restore.scm 164 */
{ /* Heap/restore.scm 164 */
obj_t BgL_portz00_1148;obj_t BgL_heapz00_1149;
{ /* Heap/restore.scm 164 */
int BgL_auxz00_1629;
BgL_auxz00_1629 = 
(int)(((long)0)); 
BgL_portz00_1148 = 
PROCEDURE_REF(BgL_envz00_1147, BgL_auxz00_1629); } 
{ /* Heap/restore.scm 164 */
int BgL_auxz00_1632;
BgL_auxz00_1632 = 
(int)(((long)1)); 
BgL_heapz00_1149 = 
PROCEDURE_REF(BgL_envz00_1147, BgL_auxz00_1632); } 
{ 

{ /* Heap/restore.scm 164 */
bool_t BgL_auxz00_1635;
{ /* Heap/restore.scm 164 */
obj_t BgL_envsz00_588;
BgL_envsz00_588 = 
input_obj(BgL_portz00_1148); 
{ /* Heap/restore.scm 164 */
obj_t BgL_dummyz00_589;
{ /* Heap/restore.scm 165 */
bool_t BgL_test1889z00_610;
{ /* Heap/restore.scm 165 */
bool_t BgL_test1891z00_611;
{ /* Heap/restore.scm 165 */
obj_t BgL_v1566z00_614;
{ 
int BgL_auxz00_1637;
BgL_auxz00_1637 = 
(int)(((long)1)); 
BgL_v1566z00_614 = 
create_vector(BgL_auxz00_1637); } 
{ /* Heap/restore.scm 165 */
int BgL_kz00_895;
BgL_kz00_895 = 
(int)(((long)0)); 
VECTOR_SET(BgL_v1566z00_614,BgL_kz00_895,BgL_envsz00_588); } 
BgL_test1891z00_611 = ((bool_t)1); } 
if(BgL_test1891z00_611)
{ /* Heap/restore.scm 166 */
int BgL_arg1893z00_612;
BgL_arg1893z00_612 = 
VECTOR_LENGTH(BgL_envsz00_588); 
{ /* Heap/restore.scm 166 */
long BgL_auxz00_1644;
BgL_auxz00_1644 = 
(long)(BgL_arg1893z00_612); 
BgL_test1889z00_610 = 
(BgL_auxz00_1644==((long)4)); } }  else 
{ /* Heap/restore.scm 165 */
BgL_test1889z00_610 = ((bool_t)0); } } 
if(BgL_test1889z00_610)
{ /* Heap/restore.scm 165 */
BgL_dummyz00_589 = BFALSE; }  else 
{ /* Heap/restore.scm 165 */
FAILURE(BgL_heapz00_1149,BGl_string2482z00zzheap_restorez00,BgL_envsz00_588);} } 
{ /* Heap/restore.scm 165 */
obj_t BgL_targetz00_590;
{ /* Heap/restore.scm 171 */
int BgL_kz00_904;
BgL_kz00_904 = 
(int)(((long)0)); 
BgL_targetz00_590 = 
VECTOR_REF(BgL_envsz00_588,BgL_kz00_904); } 
{ /* Heap/restore.scm 171 */
obj_t BgL_genvz00_591;
{ /* Heap/restore.scm 172 */
int BgL_kz00_906;
BgL_kz00_906 = 
(int)(((long)1)); 
BgL_genvz00_591 = 
VECTOR_REF(BgL_envsz00_588,BgL_kz00_906); } 
{ /* Heap/restore.scm 172 */
obj_t BgL_tenvz00_592;
{ /* Heap/restore.scm 173 */
int BgL_kz00_908;
BgL_kz00_908 = 
(int)(((long)2)); 
BgL_tenvz00_592 = 
VECTOR_REF(BgL_envsz00_588,BgL_kz00_908); } 
{ /* Heap/restore.scm 173 */
obj_t BgL_includesz00_593;
{ /* Heap/restore.scm 174 */
int BgL_kz00_910;
BgL_kz00_910 = 
(int)(((long)3)); 
BgL_includesz00_593 = 
VECTOR_REF(BgL_envsz00_588,BgL_kz00_910); } 
{ /* Heap/restore.scm 174 */

{ /* Heap/restore.scm 176 */
bool_t BgL_test1852z00_594;
BgL_test1852z00_594 = 
(BgL_targetz00_590==BGl_za2targetzd2languageza2zd2zzengine_paramz00); 
if(BgL_test1852z00_594)
{ /* Heap/restore.scm 176 */((bool_t)0); }  else 
{ /* Heap/restore.scm 177 */
obj_t BgL_arg1855z00_596;
BgL_arg1855z00_596 = 
MAKE_PAIR(BgL_targetz00_590, BGl_za2targetzd2languageza2zd2zzengine_paramz00); 
FAILURE(BgL_heapz00_1149,BGl_string2483z00zzheap_restorez00,BgL_arg1855z00_596);} } 
BGl_closezd2binaryzd2portz00zz__binaryz00(BgL_portz00_1148); 
BGl_addzd2tenvz12zc0zztype_envz00(BgL_tenvz00_592); 
BGl_addzd2genvz12zc0zzast_envz00(BgL_genvz00_591); 
BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_genvz00_591, BGl_proc2488z00zzheap_restorez00); 
BGl_za2additionalzd2includezd2foreignza2z00zzengine_paramz00 = 
bgl_append2(BGl_za2additionalzd2includezd2foreignza2z00zzengine_paramz00, BgL_includesz00_593); 
BgL_auxz00_1635 = ((bool_t)1); } } } } } } } 
return 
BBOOL(BgL_auxz00_1635);} } } } 
}



/* <anonymous:1842> */
obj_t BGl_zc3anonymousza31842ze3z83zzheap_restorez00(obj_t BgL_envz00_1150)
{ AN_OBJECT;
{ /* Heap/restore.scm 164 */
{ /* Heap/restore.scm 164 */
obj_t BgL_zc3anonymousza31848ze3z83_1154;obj_t BgL_escapez00_1155;
{ /* Heap/restore.scm 164 */
int BgL_auxz00_1667;
BgL_auxz00_1667 = 
(int)(((long)3)); 
BgL_zc3anonymousza31848ze3z83_1154 = 
PROCEDURE_REF(BgL_envz00_1150, BgL_auxz00_1667); } 
{ /* Heap/restore.scm 164 */
int BgL_auxz00_1670;
BgL_auxz00_1670 = 
(int)(((long)4)); 
BgL_escapez00_1155 = 
PROCEDURE_REF(BgL_envz00_1150, BgL_auxz00_1670); } 
{ 

return 
BGl_addzd2errorzd2handlerz12z12zz__errorz00(BgL_zc3anonymousza31848ze3z83_1154, BgL_escapez00_1155);} } } 
}



/* escape_2262 */
obj_t BGl_escape_2262z00zzheap_restorez00(obj_t BgL_envz00_1156, obj_t BgL_val1571z00_1158)
{ AN_OBJECT;
{ /* Heap/restore.scm 164 */
{ /* Heap/restore.scm 164 */
obj_t BgL_an_exitd1570z00_1157;
{ /* Heap/restore.scm 164 */
int BgL_auxz00_1674;
BgL_auxz00_1674 = 
(int)(((long)0)); 
BgL_an_exitd1570z00_1157 = 
PROCEDURE_REF(BgL_envz00_1156, BgL_auxz00_1674); } 
{ 
obj_t BgL_val1571z00_573;
BgL_val1571z00_573 = BgL_val1571z00_1158; 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1570z00_1157, BgL_val1571z00_573);} } } 
}



/* <anonymous:1848> */
obj_t BGl_zc3anonymousza31848ze3z83zzheap_restorez00(obj_t BgL_envz00_1159, obj_t BgL_escz00_1162, obj_t BgL_objz00_1163, obj_t BgL_procz00_1164, obj_t BgL_msgz00_1165)
{ AN_OBJECT;
{ /* Heap/restore.scm 164 */
{ /* Heap/restore.scm 164 */
obj_t BgL_armed1565z00_1160;obj_t BgL_handler1562z00_1161;
{ /* Heap/restore.scm 164 */
int BgL_auxz00_1678;
BgL_auxz00_1678 = 
(int)(((long)0)); 
BgL_armed1565z00_1160 = 
PROCEDURE_REF(BgL_envz00_1159, BgL_auxz00_1678); } 
{ /* Heap/restore.scm 164 */
int BgL_auxz00_1681;
BgL_auxz00_1681 = 
(int)(((long)1)); 
BgL_handler1562z00_1161 = 
PROCEDURE_REF(BgL_envz00_1159, BgL_auxz00_1681); } 
{ 
obj_t BgL_escz00_582;obj_t BgL_objz00_583;obj_t BgL_procz00_584;obj_t BgL_msgz00_585;
BgL_escz00_582 = BgL_escz00_1162; 
BgL_objz00_583 = BgL_objz00_1163; 
BgL_procz00_584 = BgL_procz00_1164; 
BgL_msgz00_585 = BgL_msgz00_1165; 
CELL_SET(BgL_armed1565z00_1160, BFALSE); 
BGl_removezd2errorzd2handlerz12z12zz__errorz00(); 
{ /* Heap/restore.scm 164 */
obj_t BgL_auxz00_1686;
BgL_auxz00_1686 = 
CELL_REF(BgL_handler1562z00_1161); 
return 
PROCEDURE_ENTRY(BgL_auxz00_1686)(
CELL_REF(BgL_handler1562z00_1161), BgL_escz00_582, BgL_objz00_583, BgL_procz00_584, BgL_msgz00_585, BEOA);} } } } 
}



/* handler_2266 */
obj_t BGl_handler_2266z00zzheap_restorez00(obj_t BgL_envz00_1167, obj_t BgL_escapez00_1169, obj_t BgL_procz00_1170, obj_t BgL_mesz00_1171, obj_t BgL_objz00_1172)
{ AN_OBJECT;
{ /* Heap/restore.scm 149 */
{ /* Heap/restore.scm 150 */
obj_t BgL_portz00_1168;
{ /* Heap/restore.scm 150 */
int BgL_auxz00_1687;
BgL_auxz00_1687 = 
(int)(((long)0)); 
BgL_portz00_1168 = 
PROCEDURE_REF(BgL_envz00_1167, BgL_auxz00_1687); } 
{ 
obj_t BgL_escapez00_619;obj_t BgL_procz00_620;obj_t BgL_mesz00_621;obj_t BgL_objz00_622;
BgL_escapez00_619 = BgL_escapez00_1169; 
BgL_procz00_620 = BgL_procz00_1170; 
BgL_mesz00_621 = BgL_mesz00_1171; 
BgL_objz00_622 = BgL_objz00_1172; 
BGl_notifyzd2errorzd2zz__errorz00(BgL_procz00_620, BgL_mesz00_621, BgL_objz00_622); 
BGl_closezd2binaryzd2portz00zz__binaryz00(BgL_portz00_1168); 
return 
BGl_exitzd2bigloozd2zzinit_mainz00(
BINT(((long)-6)));} } } 
}



/* <anonymous:1865> */
obj_t BGl_zc3anonymousza31865ze3z83zzheap_restorez00(obj_t BgL_envz00_1173, obj_t BgL_kz00_1174, obj_t BgL_bucketz00_1175)
{ AN_OBJECT;
{ /* Heap/restore.scm 195 */
{ 
obj_t BgL_kz00_598;obj_t BgL_bucketz00_599;
{ /* Heap/restore.scm 196 */
bool_t BgL_auxz00_1694;
BgL_kz00_598 = BgL_kz00_1174; 
BgL_bucketz00_599 = BgL_bucketz00_1175; 
{ 
obj_t BgL_l1567z00_601;
BgL_l1567z00_601 = 
CDR(BgL_bucketz00_599); 
BgL_lname1568z00_602:
if(
PAIRP(BgL_l1567z00_601))
{ /* Heap/restore.scm 196 */
{ /* Heap/restore.scm 197 */
obj_t BgL_list1875z00_607;
{ /* Heap/restore.scm 197 */
obj_t BgL_auxz00_1697;
{ /* Heap/restore.scm 198 */
BgL_globalz00_bglt BgL_obj1171z00_917;
{ /* Heap/restore.scm 198 */
obj_t BgL_auxz00_1698;
BgL_auxz00_1698 = 
CAR(BgL_l1567z00_601); 
BgL_obj1171z00_917 = 
(BgL_globalz00_bglt)(BgL_auxz00_1698); } 
BgL_auxz00_1697 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1171z00_917))->BgL_modulez00); } 
BgL_list1875z00_607 = 
MAKE_PAIR(BgL_auxz00_1697, BNIL); } 
BGl_heapzd2modulezd2listz00zzheap_restorez00(BgL_list1875z00_607); } 
{ 
obj_t BgL_l1567z00_1704;
BgL_l1567z00_1704 = 
CDR(BgL_l1567z00_601); 
BgL_l1567z00_601 = BgL_l1567z00_1704; 
goto BgL_lname1568z00_602;} }  else 
{ /* Heap/restore.scm 196 */
BgL_auxz00_1694 = ((bool_t)1); } } 
return 
BBOOL(BgL_auxz00_1694);} } } 
}



/* dump-heap */
obj_t BGl_dumpzd2heapzd2zzheap_restorez00(obj_t BgL_heapz00_2, obj_t BgL_genvz00_3, obj_t BgL_tenvz00_4)
{ AN_OBJECT;
{ /* Heap/restore.scm 217 */
{ /* Heap/restore.scm 218 */
obj_t BgL_arg1921z00_627;
BgL_arg1921z00_627 = 
GET_CURRENT_ERROR_PORT(); 
{ /* Heap/restore.scm 219 */
obj_t BgL_zc3anonymousza31926ze3z83_1180;
{ 
int BgL_auxz00_1711;int BgL_auxz00_1709;
BgL_auxz00_1711 = 
(int)(((long)2)); 
BgL_auxz00_1709 = 
(int)(((long)0)); 
BgL_zc3anonymousza31926ze3z83_1180 = 
make_fx_procedure(BGl_zc3anonymousza31926ze3z83zzheap_restorez00, BgL_auxz00_1709, BgL_auxz00_1711); } 
{ /* Heap/restore.scm 219 */
int BgL_auxz00_1714;
BgL_auxz00_1714 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31926ze3z83_1180, BgL_auxz00_1714, BgL_genvz00_3); } 
{ /* Heap/restore.scm 219 */
int BgL_auxz00_1717;
BgL_auxz00_1717 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_zc3anonymousza31926ze3z83_1180, BgL_auxz00_1717, BgL_tenvz00_4); } 
return 
BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(BgL_arg1921z00_627, BgL_zc3anonymousza31926ze3z83_1180);} } } 
}



/* <anonymous:1926> */
obj_t BGl_zc3anonymousza31926ze3z83zzheap_restorez00(obj_t BgL_envz00_1181)
{ AN_OBJECT;
{ /* Heap/restore.scm 219 */
{ /* Heap/restore.scm 219 */
obj_t BgL_genvz00_1182;obj_t BgL_tenvz00_1183;
{ /* Heap/restore.scm 219 */
int BgL_auxz00_1721;
BgL_auxz00_1721 = 
(int)(((long)0)); 
BgL_genvz00_1182 = 
PROCEDURE_REF(BgL_envz00_1181, BgL_auxz00_1721); } 
{ /* Heap/restore.scm 219 */
int BgL_auxz00_1724;
BgL_auxz00_1724 = 
(int)(((long)1)); 
BgL_tenvz00_1183 = 
PROCEDURE_REF(BgL_envz00_1181, BgL_auxz00_1724); } 
{ 

{ /* Heap/restore.scm 219 */
unsigned char BgL_auxz00_1727;
{ /* Heap/restore.scm 220 */
obj_t BgL_arg1930z00_631;
BgL_arg1930z00_631 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string2489z00zzheap_restorez00, BgL_arg1930z00_631); } 
{ /* Heap/restore.scm 220 */
obj_t BgL_arg1935z00_632;
BgL_arg1935z00_632 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg1935z00_632); } 
{ /* Heap/restore.scm 221 */
obj_t BgL_arg1940z00_634;
BgL_arg1940z00_634 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string2490z00zzheap_restorez00, BgL_arg1940z00_634); } 
{ /* Heap/restore.scm 221 */
obj_t BgL_arg1944z00_635;
BgL_arg1944z00_635 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg1944z00_635); } 
BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_genvz00_1182, BGl_proc2491z00zzheap_restorez00); 
{ /* Heap/restore.scm 242 */
obj_t BgL_arg2041z00_682;
BgL_arg2041z00_682 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string2492z00zzheap_restorez00, BgL_arg2041z00_682); } 
{ /* Heap/restore.scm 242 */
obj_t BgL_arg2045z00_683;
BgL_arg2045z00_683 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2045z00_683); } 
{ /* Heap/restore.scm 243 */
obj_t BgL_arg2051z00_685;
BgL_arg2051z00_685 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string2493z00zzheap_restorez00, BgL_arg2051z00_685); } 
{ /* Heap/restore.scm 243 */
obj_t BgL_arg2055z00_686;
BgL_arg2055z00_686 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2055z00_686); } 
BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_tenvz00_1183, BGl_proc2494z00zzheap_restorez00); 
{ /* Heap/restore.scm 250 */
obj_t BgL_arg2096z00_707;
BgL_arg2096z00_707 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string2495z00zzheap_restorez00, BgL_arg2096z00_707); } 
{ /* Heap/restore.scm 250 */
obj_t BgL_arg2100z00_708;
BgL_arg2100z00_708 = 
GET_CURRENT_OUTPUT_PORT(); 
BgL_auxz00_1727 = 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2100z00_708); } 
return 
BCHAR(BgL_auxz00_1727);} } } } 
}



/* <anonymous:2061> */
obj_t BGl_zc3anonymousza32061ze3z83zzheap_restorez00(obj_t BgL_envz00_1184, obj_t BgL_kz00_1185, obj_t BgL_newz00_1186)
{ AN_OBJECT;
{ /* Heap/restore.scm 246 */
{ 
obj_t BgL_kz00_688;obj_t BgL_newz00_689;
{ /* Heap/restore.scm 247 */
unsigned char BgL_auxz00_1751;
BgL_kz00_688 = BgL_kz00_1185; 
BgL_newz00_689 = BgL_newz00_1186; 
{ /* Heap/restore.scm 247 */
obj_t BgL_idz00_691;
{ /* Heap/restore.scm 247 */
BgL_typez00_bglt BgL_obj1003z00_941;
BgL_obj1003z00_941 = 
(BgL_typez00_bglt)(BgL_newz00_689); 
BgL_idz00_691 = 
(((BgL_typez00_bglt)CREF(BgL_obj1003z00_941))->BgL_idz00); } 
{ /* Heap/restore.scm 247 */
obj_t BgL_namez00_692;
{ /* Heap/restore.scm 248 */
BgL_typez00_bglt BgL_obj1004z00_942;
BgL_obj1004z00_942 = 
(BgL_typez00_bglt)(BgL_newz00_689); 
BgL_namez00_692 = 
(((BgL_typez00_bglt)CREF(BgL_obj1004z00_942))->BgL_namez00); } 
{ /* Heap/restore.scm 248 */

{ /* Heap/restore.scm 249 */
obj_t BgL_arg2064z00_694;
BgL_arg2064z00_694 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string2496z00zzheap_restorez00, BgL_arg2064z00_694); } 
{ /* Heap/restore.scm 249 */
obj_t BgL_arg2068z00_695;obj_t BgL_arg2069z00_696;
{ /* Heap/restore.scm 249 */
obj_t BgL_arg2072z00_697;obj_t BgL_arg2073z00_698;
BgL_arg2072z00_697 = 
CNST_TABLE_REF(((long)6)); 
{ /* Heap/restore.scm 249 */
obj_t BgL_arg2076z00_699;
{ /* Heap/restore.scm 249 */
obj_t BgL_arg2079z00_700;
{ /* Heap/restore.scm 249 */
obj_t BgL_arg2083z00_702;obj_t BgL_arg2084z00_703;
BgL_arg2083z00_702 = 
CNST_TABLE_REF(((long)7)); 
BgL_arg2084z00_703 = 
MAKE_PAIR(BgL_namez00_692, BNIL); 
BgL_arg2079z00_700 = 
MAKE_PAIR(BgL_arg2083z00_702, BgL_arg2084z00_703); } 
BgL_arg2076z00_699 = 
MAKE_PAIR(BgL_arg2079z00_700, BNIL); } 
BgL_arg2073z00_698 = 
MAKE_PAIR(BgL_idz00_691, BgL_arg2076z00_699); } 
BgL_arg2068z00_695 = 
MAKE_PAIR(BgL_arg2072z00_697, BgL_arg2073z00_698); } 
BgL_arg2069z00_696 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg2068z00_695, BgL_arg2069z00_696); } 
{ /* Heap/restore.scm 249 */
obj_t BgL_arg2089z00_704;
BgL_arg2089z00_704 = 
GET_CURRENT_OUTPUT_PORT(); 
BgL_auxz00_1751 = 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2089z00_704); } } } } 
return 
BCHAR(BgL_auxz00_1751);} } } 
}



/* <anonymous:1950> */
obj_t BGl_zc3anonymousza31950ze3z83zzheap_restorez00(obj_t BgL_envz00_1187, obj_t BgL_kz00_1188, obj_t BgL_bucketz00_1189)
{ AN_OBJECT;
{ /* Heap/restore.scm 224 */
{ 
obj_t BgL_kz00_637;obj_t BgL_bucketz00_638;
{ /* Heap/restore.scm 225 */
bool_t BgL_auxz00_1770;
BgL_kz00_637 = BgL_kz00_1188; 
BgL_bucketz00_638 = BgL_bucketz00_1189; 
{ 
obj_t BgL_l1573z00_640;
BgL_l1573z00_640 = 
CDR(BgL_bucketz00_638); 
BgL_lname1574z00_641:
if(
PAIRP(BgL_l1573z00_640))
{ /* Heap/restore.scm 225 */
{ /* Heap/restore.scm 226 */
obj_t BgL_newz00_644;
BgL_newz00_644 = 
CAR(BgL_l1573z00_640); 
{ /* Heap/restore.scm 226 */
obj_t BgL_modulez00_645;
{ /* Heap/restore.scm 226 */
BgL_globalz00_bglt BgL_obj1171z00_930;
BgL_obj1171z00_930 = 
(BgL_globalz00_bglt)(BgL_newz00_644); 
BgL_modulez00_645 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1171z00_930))->BgL_modulez00); } 
{ /* Heap/restore.scm 226 */
obj_t BgL_idz00_646;
{ /* Heap/restore.scm 227 */
BgL_globalz00_bglt BgL_obj1149z00_931;
BgL_obj1149z00_931 = 
(BgL_globalz00_bglt)(BgL_newz00_644); 
BgL_idz00_646 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1149z00_931))->BgL_idz00); } 
{ /* Heap/restore.scm 227 */
obj_t BgL_qtz00_647;
BgL_qtz00_647 = 
BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00(BgL_modulez00_645); 
{ /* Heap/restore.scm 228 */

{ /* Heap/restore.scm 229 */
obj_t BgL_arg1958z00_649;
BgL_arg1958z00_649 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string2496z00zzheap_restorez00, BgL_arg1958z00_649); } 
{ /* Heap/restore.scm 230 */
obj_t BgL_arg1962z00_650;obj_t BgL_arg1963z00_651;
{ /* Heap/restore.scm 230 */
obj_t BgL_arg1967z00_652;obj_t BgL_arg1968z00_653;
{ /* Heap/restore.scm 230 */
bool_t BgL_test1970z00_654;
{ /* Heap/restore.scm 230 */
obj_t BgL_auxz00_1781;
{ /* Heap/restore.scm 230 */
BgL_valuez00_bglt BgL_auxz00_1782;
{ /* Heap/restore.scm 230 */
BgL_globalz00_bglt BgL_obj1156z00_932;
BgL_obj1156z00_932 = 
(BgL_globalz00_bglt)(BgL_newz00_644); 
BgL_auxz00_1782 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1156z00_932))->BgL_valuez00); } 
BgL_auxz00_1781 = 
(obj_t)(BgL_auxz00_1782); } 
BgL_test1970z00_654 = 
BGl_iszd2azf3z21zz__objectz00(BgL_auxz00_1781, BGl_sfunz00zzast_varz00); } 
if(BgL_test1970z00_654)
{ /* Heap/restore.scm 230 */
BgL_arg1967z00_652 = 
CNST_TABLE_REF(((long)8)); }  else 
{ /* Heap/restore.scm 232 */
bool_t BgL_test1971z00_655;
{ /* Heap/restore.scm 232 */
obj_t BgL_auxz00_1789;
{ /* Heap/restore.scm 232 */
BgL_valuez00_bglt BgL_auxz00_1790;
{ /* Heap/restore.scm 232 */
BgL_globalz00_bglt BgL_obj1156z00_934;
BgL_obj1156z00_934 = 
(BgL_globalz00_bglt)(BgL_newz00_644); 
BgL_auxz00_1790 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1156z00_934))->BgL_valuez00); } 
BgL_auxz00_1789 = 
(obj_t)(BgL_auxz00_1790); } 
BgL_test1971z00_655 = 
BGl_iszd2azf3z21zz__objectz00(BgL_auxz00_1789, BGl_cfunz00zzast_varz00); } 
if(BgL_test1971z00_655)
{ /* Heap/restore.scm 232 */
BgL_arg1967z00_652 = 
CNST_TABLE_REF(((long)9)); }  else 
{ /* Heap/restore.scm 232 */
BgL_arg1967z00_652 = 
CNST_TABLE_REF(((long)10)); } } } 
{ /* Heap/restore.scm 236 */
obj_t BgL_arg1981z00_658;obj_t BgL_arg1982z00_659;
BgL_arg1981z00_658 = 
BGl_shapez00zztools_shapez00(BgL_newz00_644); 
{ /* Heap/restore.scm 237 */
obj_t BgL_arg1986z00_660;obj_t BgL_arg1987z00_661;
{ /* Heap/restore.scm 237 */
obj_t BgL_arg1990z00_662;obj_t BgL_arg1991z00_663;
BgL_arg1990z00_662 = 
CNST_TABLE_REF(((long)11)); 
BgL_arg1991z00_663 = 
MAKE_PAIR(BgL_idz00_646, BNIL); 
BgL_arg1986z00_660 = 
MAKE_PAIR(BgL_arg1990z00_662, BgL_arg1991z00_663); } 
{ /* Heap/restore.scm 238 */
obj_t BgL_arg1995z00_664;obj_t BgL_arg1996z00_665;
{ /* Heap/restore.scm 238 */
obj_t BgL_arg1999z00_666;obj_t BgL_arg2000z00_667;
BgL_arg1999z00_666 = 
CNST_TABLE_REF(((long)12)); 
BgL_arg2000z00_667 = 
MAKE_PAIR(BgL_modulez00_645, BNIL); 
BgL_arg1995z00_664 = 
MAKE_PAIR(BgL_arg1999z00_666, BgL_arg2000z00_667); } 
{ /* Heap/restore.scm 239 */
obj_t BgL_arg2004z00_668;obj_t BgL_arg2005z00_669;
{ /* Heap/restore.scm 239 */
obj_t BgL_arg2008z00_670;obj_t BgL_arg2009z00_671;
BgL_arg2008z00_670 = 
CNST_TABLE_REF(((long)7)); 
{ /* Heap/restore.scm 239 */
obj_t BgL_auxz00_1806;
{ /* Heap/restore.scm 239 */
BgL_globalz00_bglt BgL_obj1150z00_936;
BgL_obj1150z00_936 = 
(BgL_globalz00_bglt)(BgL_newz00_644); 
BgL_auxz00_1806 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1150z00_936))->BgL_namez00); } 
BgL_arg2009z00_671 = 
MAKE_PAIR(BgL_auxz00_1806, BNIL); } 
BgL_arg2004z00_668 = 
MAKE_PAIR(BgL_arg2008z00_670, BgL_arg2009z00_671); } 
{ /* Heap/restore.scm 240 */
obj_t BgL_arg2017z00_674;
{ /* Heap/restore.scm 240 */
obj_t BgL_arg2021z00_676;obj_t BgL_arg2022z00_677;
BgL_arg2021z00_676 = 
CNST_TABLE_REF(((long)13)); 
BgL_arg2022z00_677 = 
MAKE_PAIR(BgL_qtz00_647, BNIL); 
BgL_arg2017z00_674 = 
MAKE_PAIR(BgL_arg2021z00_676, BgL_arg2022z00_677); } 
BgL_arg2005z00_669 = 
MAKE_PAIR(BgL_arg2017z00_674, BNIL); } 
BgL_arg1996z00_665 = 
MAKE_PAIR(BgL_arg2004z00_668, BgL_arg2005z00_669); } 
BgL_arg1987z00_661 = 
MAKE_PAIR(BgL_arg1995z00_664, BgL_arg1996z00_665); } 
BgL_arg1982z00_659 = 
MAKE_PAIR(BgL_arg1986z00_660, BgL_arg1987z00_661); } 
BgL_arg1968z00_653 = 
MAKE_PAIR(BgL_arg1981z00_658, BgL_arg1982z00_659); } 
BgL_arg1962z00_650 = 
MAKE_PAIR(BgL_arg1967z00_652, BgL_arg1968z00_653); } 
BgL_arg1963z00_651 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg1962z00_650, BgL_arg1963z00_651); } 
{ /* Heap/restore.scm 229 */
obj_t BgL_arg2027z00_678;
BgL_arg2027z00_678 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2027z00_678); } } } } } } 
{ 
obj_t BgL_l1573z00_1824;
BgL_l1573z00_1824 = 
CDR(BgL_l1573z00_640); 
BgL_l1573z00_640 = BgL_l1573z00_1824; 
goto BgL_lname1574z00_641;} }  else 
{ /* Heap/restore.scm 225 */
BgL_auxz00_1770 = ((bool_t)1); } } 
return 
BBOOL(BgL_auxz00_1770);} } } 
}



/* heap-module-list */
obj_t BGl_heapzd2modulezd2listz00zzheap_restorez00(obj_t BgL_argsz00_5)
{ AN_OBJECT;
{ /* Heap/restore.scm 268 */
if(
NULLP(BgL_argsz00_5))
{ /* Heap/restore.scm 270 */
return BGl_za2heapzd2modulezd2listza2z00zzheap_restorez00;}  else 
{ /* Heap/restore.scm 272 */
bool_t BgL_testz00_1830;
{ /* Heap/restore.scm 272 */
obj_t BgL_auxz00_1831;
BgL_auxz00_1831 = 
BGl_getpropz00zz__r4_symbols_6_4z00(
CAR(BgL_argsz00_5), BGl_za2heapzd2markza2zd2zzheap_restorez00); 
BgL_testz00_1830 = 
CBOOL(BgL_auxz00_1831); } 
if(BgL_testz00_1830)
{ /* Heap/restore.scm 272 */
return BFALSE;}  else 
{ /* Heap/restore.scm 272 */
BGl_putpropz12z12zz__r4_symbols_6_4z00(
CAR(BgL_argsz00_5), BGl_za2heapzd2markza2zd2zzheap_restorez00, BTRUE); 
{ /* Heap/restore.scm 274 */
obj_t BgL_auxz00_1837;
BgL_auxz00_1837 = 
CAR(BgL_argsz00_5); 
return ( 
BGl_za2heapzd2modulezd2listza2z00zzheap_restorez00 = 
MAKE_PAIR(BgL_auxz00_1837, BGl_za2heapzd2modulezd2listza2z00zzheap_restorez00), BUNSPEC) ;} } } } 
}



/* _heap-module-list */
obj_t BGl__heapzd2modulezd2listz00zzheap_restorez00(obj_t BgL_envz00_1190, obj_t BgL_argsz00_1191)
{ AN_OBJECT;
{ /* Heap/restore.scm 268 */
return 
BGl_heapzd2modulezd2listz00zzheap_restorez00(BgL_argsz00_1191);} 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzheap_restorez00()
{ AN_OBJECT;
{ /* Heap/restore.scm 15 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzheap_restorez00()
{ AN_OBJECT;
{ /* Heap/restore.scm 15 */
BGl_modulezd2initializa7ationz75zztools_speekz00(((long)23545), "heap_restore"); 
BGl_modulezd2initializa7ationz75zztools_errorz00(((long)17886), "heap_restore"); 
BGl_modulezd2initializa7ationz75zzengine_passz00(((long)12444), "heap_restore"); 
BGl_modulezd2initializa7ationz75zzengine_paramz00(((long)189840), "heap_restore"); 
BGl_modulezd2initializa7ationz75zzengine_enginez00(((long)45452), "heap_restore"); 
BGl_modulezd2initializa7ationz75zzinit_mainz00(((long)7934), "heap_restore"); 
BGl_modulezd2initializa7ationz75zzast_envz00(((long)73271), "heap_restore"); 
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19010), "heap_restore"); 
BGl_modulezd2initializa7ationz75zztype_envz00(((long)25262), "heap_restore"); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)28259), "heap_restore"); 
BGl_modulezd2initializa7ationz75zzread_jvmz00(((long)34896), "heap_restore"); 
return 
BGl_modulezd2initializa7ationz75zztools_shapez00(((long)30825), "heap_restore");} 
}

