/*===========================================================================*/
/*   (Jvm/compile.scm)                                                       */
/*   Bigloo (2.5b)                                                           */
/*   Manuel Serrano (c)       Fri Sep 6 09:43:28 CEST 2002                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_nodez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
} *BgL_nodez00_bglt;

typedef struct BgL_nodezf2effectzf2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
} *BgL_nodezf2effectzf2_bglt;

typedef struct BgL_atomz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_atomz00_bglt;

typedef struct BgL_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_varz00_bglt;

typedef struct BgL_closurez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_closurez00_bglt;

typedef struct BgL_kwotez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_kwotez00_bglt;

typedef struct BgL_sequencez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_nodesz00;
} *BgL_sequencez00_bglt;

typedef struct BgL_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
} *BgL_appz00_bglt;

typedef struct BgL_appzd2lyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_appzd2lyzd2_bglt;

typedef struct BgL_funcallz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_strengthz00;
} *BgL_funcallz00_bglt;

typedef struct BgL_externz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_externz00_bglt;

typedef struct BgL_pragmaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_formatz00;
} *BgL_pragmaz00_bglt;

typedef struct BgL_getfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_getfieldz00_bglt;

typedef struct BgL_setfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_setfieldz00_bglt;

typedef struct BgL_newz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_newz00_bglt;

typedef struct BgL_vallocz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2heapzd2formatz00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_vallocz00_bglt;

typedef struct BgL_vrefz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vrefz00_bglt;

typedef struct BgL_vsetz12z12_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vsetz12z12_bglt;

typedef struct BgL_vlengthz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vlengthz00_bglt;

typedef struct BgL_isaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   struct BgL_typez00_bgl * BgL_classz00;
} *BgL_isaz00_bglt;

typedef struct BgL_castz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_castz00_bglt;

typedef struct BgL_setqz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_setqz00_bglt;

typedef struct BgL_conditionalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   struct BgL_nodez00_bgl * BgL_truez00;
   struct BgL_nodez00_bgl * BgL_falsez00;
} *BgL_conditionalz00_bglt;

typedef struct BgL_failz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_procz00;
   struct BgL_nodez00_bgl * BgL_msgz00;
   struct BgL_nodez00_bgl * BgL_objz00;
} *BgL_failz00_bglt;

typedef struct BgL_selectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   obj_t BgL_clausesz00;
   struct BgL_typez00_bgl * BgL_itemzd2typezd2;
} *BgL_selectz00_bglt;

typedef struct BgL_letzd2funzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_localsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_letzd2funzd2_bglt;

typedef struct BgL_letzd2varzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_bindingsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
   bool_t BgL_removablezf3zf3;
} *BgL_letzd2varzd2_bglt;

typedef struct BgL_setzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_setzd2exzd2itz00_bglt;

typedef struct BgL_jumpzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_exitz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_jumpzd2exzd2itz00_bglt;

typedef struct BgL_makezd2boxzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_makezd2boxzd2_bglt;

typedef struct BgL_boxzd2refzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_varz00;
} *BgL_boxzd2refzd2_bglt;

typedef struct BgL_boxzd2setz12zc0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_boxzd2setz12zc0_bglt;

typedef struct BgL_tclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   struct BgL_globalz00_bgl * BgL_holderz00;
   obj_t BgL_wideningz00;
   long BgL_depthz00;
   bool_t BgL_finalzf3zf3;
   obj_t BgL_constructorz00;
   obj_t BgL_virtualzd2slotszd2numberz00;
   bool_t BgL_abstractzf3zf3;
} *BgL_tclassz00_bglt;

typedef struct BgL_jclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   obj_t BgL_packagez00;
} *BgL_jclassz00_bglt;

typedef struct BgL_slotz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_srcz00;
   obj_t BgL_classzd2ownerzd2;
   obj_t BgL_typez00;
   bool_t BgL_readzd2onlyzf3z21;
   obj_t BgL_defaultzd2valuezd2;
   obj_t BgL_virtualzd2numzd2;
   obj_t BgL_getterz00;
   obj_t BgL_setterz00;
   obj_t BgL_indexedz00;
   obj_t BgL_userzd2infozd2;
} *BgL_slotz00_bglt;

typedef struct BgL_ccompz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_producerz00;
   obj_t BgL_consumerz00;
   obj_t BgL_finaliza7erza7;
} *BgL_ccompz00_bglt;

typedef struct BgL_envz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_declarationsz00;
   obj_t BgL_declaredtypez00;
   obj_t BgL_declaredclassz00;
   obj_t BgL_declaredmodulez00;
   obj_t BgL_currentzd2modulezd2;
   obj_t BgL_declaredfieldsz00;
   obj_t BgL_declaredglobalz00;
   obj_t BgL_libdeclaredz00;
   obj_t BgL_proceduresz00;
   obj_t BgL_clinitzd2codezd2;
   obj_t BgL_currentzd2methodzd2;
   obj_t BgL_vcountz00;
   obj_t BgL_localsz00;
   obj_t BgL_freelocalsz00;
   obj_t BgL_maplocalsz00;
   obj_t BgL_stackz00;
   obj_t BgL_codez00;
} *BgL_envz00_bglt;


extern obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zzjvm_compilez00();
extern obj_t open_input_string(obj_t);
extern long BGl_classzd2numzd2zz__objectz00(obj_t);
extern obj_t BGl_envz00zzjvm_envz00;
extern obj_t BGl_getzd2classeszd2tozd2bezd2compiledz00zzjvm_externz00();
extern obj_t BGl_ppz00zz__ppz00(obj_t, obj_t);
extern obj_t BGl_readz00zz__readerz00(obj_t);
extern obj_t BGl_tclasszd2idzd2manglingz00zzjvm_externz00(BgL_tclassz00_bglt);
extern bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
static obj_t BGl_compilezd2mainzd2zzjvm_compilez00(obj_t);
extern obj_t BGl_envzd2declarezd2zzjvm_envz00(BgL_envz00_bglt, obj_t, obj_t);
extern obj_t BGl_za2moduleza2z00zzmodule_modulez00;
extern obj_t BGl_compilezd2typezd2zzjvm_envz00(obj_t, BgL_envz00_bglt);
static obj_t BGl_compilezd2formalszd2zzjvm_compilez00(obj_t, obj_t);
extern obj_t BGl_gensymz00zz__r4_symbols_6_4z00;
extern obj_t BGl_debugzd2declarezd2varzd2fromzd2zzjvm_externz00(BgL_envz00_bglt, BgL_localz00_bglt, obj_t, obj_t);
extern obj_t BGl_globalz00zzast_varz00;
extern BgL_nodez00_bglt BGl_compilezd2compresszd2zzjvm_compressz00(BgL_nodez00_bglt);
extern bool_t BGl_widezd2classzf3z21zzobject_classz00(obj_t);
extern obj_t BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(obj_t);
extern obj_t BGl_za2jvmzd2purifyza2zd2zzengine_paramz00;
static obj_t BGl_cnstzd2initzd2zzjvm_compilez00();
static obj_t BGl_compilezd2dlopenzd2zzjvm_compilez00(obj_t);
extern obj_t BGl_compilezd2typezd2nowideningz00zzjvm_envz00(obj_t, BgL_envz00_bglt);
static obj_t BGl_importedzd2moduleszd2initz00zzjvm_compilez00();
extern obj_t BGl_envzd2setzd2namez12z12zzjvm_envz00(BgL_envz00_bglt, BgL_localz00_bglt, obj_t);
extern obj_t BGl__checkcastz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl_jvm_peepholez00zzjvm_peepholez00(obj_t);
extern obj_t BGl__returnz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_compilez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_slotsz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_externz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_instrz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_exprz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_compilerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_initz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_constrz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_closurez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_preludez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_peepholez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_compressz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_lispz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
static obj_t BGl_compilezd2globalfun1zd2zzjvm_compilez00(obj_t, obj_t);
static obj_t BGl_compilezd2modulezd2zzjvm_compilez00(obj_t);
extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
extern obj_t bgl_reverse(obj_t);
extern obj_t BGl_jvmzd2constructorszd2zzjvm_constrz00(BgL_envz00_bglt, obj_t, obj_t);
extern obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_compilezd2fieldszd2zzjvm_compilez00(obj_t);
static obj_t BGl__jvmzd2compilezd2zzjvm_compilez00(obj_t, obj_t);
extern bool_t BGl_slotzd2virtualzf3z21zzobject_slotsz00(BgL_slotz00_bglt);
extern obj_t BGl_za2mainza2z00zzmodule_modulez00;
extern obj_t BGl_envzd2declarezd2fieldz00zzjvm_envz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_compilezd2classzd2zzjvm_compilez00(obj_t);
extern obj_t BGl_jvmzd2funcallerszd2zzjvm_closurez00(BgL_envz00_bglt, obj_t, obj_t);
extern obj_t BGl_getzd2globalzd2namez00zzjvm_envz00(BgL_envz00_bglt, BgL_globalz00_bglt);
static obj_t BGl_compilez00zzjvm_compilez00(obj_t);
extern obj_t BGl_compilezd2preludezd2zzjvm_preludez00(BgL_nodez00_bglt);
static obj_t BGl_requirezd2initializa7ationz75zzjvm_compilez00 = BUNSPEC;
static obj_t BGl_compilezd2classzd2fieldsz00zzjvm_compilez00(BgL_envz00_bglt, obj_t, obj_t);
extern obj_t BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl_getzd2sourcefilezd2zzjvm_externz00();
extern obj_t BGl_compilezd2initzd2zzjvm_initz00;
static obj_t BGl_libraryzd2moduleszd2initz00zzjvm_compilez00();
extern obj_t BGl__labelz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl_compilerzd2bodyzd2zzjvm_compilerz00(BgL_nodez00_bglt, BgL_envz00_bglt);
extern obj_t BGl_jvmzd2compilezd2zzjvm_compilez00(obj_t);
static obj_t __cnst[ 43 ] ;

DEFINE_STRING( BGl_string4487z00zzjvm_compilez00, BgL_bgl_string4487za700za7za7jvm_compileza7004515z00, "_ (double long) reg2 reg1 end begin P module-initialization aconst_null iconst_0 internalerror pop bigloo_main invokestatic jthrowable catch to from handler argv listargv sourcefile vector constants static field __the_module_name__ module jstring j_procedure return invokespecial aload t fields sinit0 void public method init0 declare class jobject ", 349 );
DEFINE_STRING( BGl_string4486z00zzjvm_compilez00, BgL_bgl_string4486za700za7za7jvm_compileza7004516z00, "is not empty", 12 );
DEFINE_STRING( BGl_string4485z00zzjvm_compilez00, BgL_bgl_string4485za700za7za7jvm_compileza7004517z00, "stack", 5 );
DEFINE_STRING( BGl_string4484z00zzjvm_compilez00, BgL_bgl_string4484za700za7za7jvm_compileza7004518z00, "BGL_DYNAMIC_LOAD_INIT", 21 );
DEFINE_STRING( BGl_string4483z00zzjvm_compilez00, BgL_bgl_string4483za700za7za7jvm_compileza7004519z00, "main", 4 );
DEFINE_STRING( BGl_string4482z00zzjvm_compilez00, BgL_bgl_string4482za700za7za7jvm_compileza7004520z00, "constants", 9 );
DEFINE_STRING( BGl_string4481z00zzjvm_compilez00, BgL_bgl_string4481za700za7za7jvm_compileza7004521z00, "__the_module_name__", 19 );
DEFINE_STRING( BGl_string4480z00zzjvm_compilez00, BgL_bgl_string4480za700za7za7jvm_compileza7004522z00, "<init>", 6 );
DEFINE_EXPORT_PROCEDURE( BGl_jvmzd2compilezd2envz00zzjvm_compilez00, BgL_bgl__jvmza7d2compileza7d2za7za7jvm_compileza7004523za7, BGl__jvmzd2compilezd2zzjvm_compilez00, 0L, 1 );



/* module-initialization */
obj_t BGl_modulezd2initializa7ationz75zzjvm_compilez00(long BgL_checksumz00_3189, char * BgL_fromz00_3190)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzjvm_compilez00))
{ 
BGl_requirezd2initializa7ationz75zzjvm_compilez00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzjvm_compilez00(); 
BGl_cnstzd2initzd2zzjvm_compilez00(); 
BGl_importedzd2moduleszd2initz00zzjvm_compilez00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzjvm_compilez00()
{ AN_OBJECT;
{ /* Jvm/compile.scm 1 */
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "jvm_compile"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "jvm_compile"); 
BGl_modulezd2initializa7ationz75zz__ppz00(((long)0), "jvm_compile"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "jvm_compile"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "jvm_compile"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzjvm_compilez00()
{ AN_OBJECT;
{ /* Jvm/compile.scm 1 */
{ /* Jvm/compile.scm 1 */
obj_t BgL_cportz00_3182;
BgL_cportz00_3182 = 
open_input_string(BGl_string4487z00zzjvm_compilez00); 
{ 
long BgL_iz00_3183;
BgL_iz00_3183 = ((long)42); 
BgL_loopz00_3184:
if(
(BgL_iz00_3183==((long)-1)))
{ /* Jvm/compile.scm 1 */
return BUNSPEC;}  else 
{ /* Jvm/compile.scm 1 */
{ /* Jvm/compile.scm 1 */
obj_t BgL_arg4491z00_3186;
{ /* Jvm/compile.scm 1 */
obj_t BgL_list4494z00_3187;
BgL_list4494z00_3187 = 
MAKE_PAIR(BgL_cportz00_3182, BNIL); 
BgL_arg4491z00_3186 = 
BGl_readz00zz__readerz00(BgL_list4494z00_3187); } 
{ /* Jvm/compile.scm 1 */
int BgL_auxz00_3207;
BgL_auxz00_3207 = 
(int)(BgL_iz00_3183); 
CNST_TABLE_SET(BgL_auxz00_3207, BgL_arg4491z00_3186); } } 
{ 
long BgL_iz00_3210;
{ /* Jvm/compile.scm 1 */
int BgL_auxz00_3211;
{ /* Jvm/compile.scm 1 */
long BgL_auxz00_3212;
BgL_auxz00_3212 = 
(BgL_iz00_3183-((long)1)); 
BgL_auxz00_3211 = 
(int)(BgL_auxz00_3212); } 
BgL_iz00_3210 = 
(long)(BgL_auxz00_3211); } 
BgL_iz00_3183 = BgL_iz00_3210; 
goto BgL_loopz00_3184;} } } } } 
}



/* jvm-compile */
obj_t BGl_jvmzd2compilezd2zzjvm_compilez00(obj_t BgL_globalsz00_1)
{ AN_OBJECT;
{ /* Jvm/compile.scm 14 */
return 
BGl_compilez00zzjvm_compilez00(BgL_globalsz00_1);} 
}



/* _jvm-compile */
obj_t BGl__jvmzd2compilezd2zzjvm_compilez00(obj_t BgL_envz00_3180, obj_t BgL_globalsz00_3181)
{ AN_OBJECT;
{ /* Jvm/compile.scm 14 */
return 
BGl_jvmzd2compilezd2zzjvm_compilez00(BgL_globalsz00_3181);} 
}



/* compile */
obj_t BGl_compilez00zzjvm_compilez00(obj_t BgL_globalsz00_2)
{ AN_OBJECT;
{ /* Jvm/compile.scm 21 */
{ /* Jvm/compile.scm 22 */
obj_t BgL_mz00_1554;
BgL_mz00_1554 = 
BGl_compilezd2modulezd2zzjvm_compilez00(BgL_globalsz00_2); 
{ /* Jvm/compile.scm 23 */
obj_t BgL_arg3076z00_1555;
{ /* Jvm/compile.scm 23 */
obj_t BgL_l3052z00_1556;
BgL_l3052z00_1556 = 
BGl_getzd2classeszd2tozd2bezd2compiledz00zzjvm_externz00(); 
if(
NULLP(BgL_l3052z00_1556))
{ /* Jvm/compile.scm 23 */
BgL_arg3076z00_1555 = BNIL; }  else 
{ /* Jvm/compile.scm 23 */
obj_t BgL_head3054z00_1558;
{ /* Jvm/compile.scm 23 */
obj_t BgL_arg3099z00_1569;
BgL_arg3099z00_1569 = 
BGl_compilezd2classzd2zzjvm_compilez00(
CAR(BgL_l3052z00_1556)); 
BgL_head3054z00_1558 = 
MAKE_PAIR(BgL_arg3099z00_1569, BNIL); } 
{ 
obj_t BgL_l3052z00_1559;obj_t BgL_tail3055z00_1560;
BgL_l3052z00_1559 = 
CDR(BgL_l3052z00_1556); 
BgL_tail3055z00_1560 = BgL_head3054z00_1558; 
BgL_lname3053z00_1561:
if(
NULLP(BgL_l3052z00_1559))
{ /* Jvm/compile.scm 23 */
BgL_arg3076z00_1555 = BgL_head3054z00_1558; }  else 
{ /* Jvm/compile.scm 23 */
obj_t BgL_newtail3056z00_1564;
{ /* Jvm/compile.scm 23 */
obj_t BgL_arg3090z00_1566;
BgL_arg3090z00_1566 = 
BGl_compilezd2classzd2zzjvm_compilez00(
CAR(BgL_l3052z00_1559)); 
BgL_newtail3056z00_1564 = 
MAKE_PAIR(BgL_arg3090z00_1566, BNIL); } 
SET_CDR(BgL_tail3055z00_1560, BgL_newtail3056z00_1564); 
{ 
obj_t BgL_tail3055z00_3233;obj_t BgL_l3052z00_3231;
BgL_l3052z00_3231 = 
CDR(BgL_l3052z00_1559); 
BgL_tail3055z00_3233 = BgL_newtail3056z00_1564; 
BgL_tail3055z00_1560 = BgL_tail3055z00_3233; 
BgL_l3052z00_1559 = BgL_l3052z00_3231; 
goto BgL_lname3053z00_1561;} } } } } 
return 
MAKE_PAIR(BgL_mz00_1554, BgL_arg3076z00_1555);} } } 
}



/* compile-class */
obj_t BGl_compilezd2classzd2zzjvm_compilez00(obj_t BgL_classz00_3)
{ AN_OBJECT;
{ /* Jvm/compile.scm 28 */
{ /* Jvm/compile.scm 29 */
BgL_envz00_bglt BgL_envz00_1572;
{ /* Jvm/compile.scm 29 */
BgL_envz00_bglt BgL_res4382z00_2447;
{ /* Jvm/compile.scm 29 */
obj_t BgL_vcount3042z00_2398;
BgL_vcount3042z00_2398 = 
BINT(((long)0)); 
{ /* Jvm/compile.scm 29 */
BgL_envz00_bglt BgL_new3048z00_2404;
{ /* Jvm/compile.scm 29 */
BgL_envz00_bglt BgL_res4380z00_2410;
{ /* Jvm/compile.scm 29 */
BgL_envz00_bglt BgL_new3050z00_2405;
BgL_new3050z00_2405 = 
((BgL_envz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_envz00_bgl) ))); 
{ /* Jvm/compile.scm 29 */
long BgL_arg3887z00_2406;
BgL_arg3887z00_2406 = 
BGl_classzd2numzd2zz__objectz00(BGl_envz00zzjvm_envz00); 
{ /* Jvm/compile.scm 29 */
BgL_objectz00_bglt BgL_auxz00_3239;
BgL_auxz00_3239 = 
(BgL_objectz00_bglt)(BgL_new3050z00_2405); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_3239, BgL_arg3887z00_2406); } } 
{ /* Jvm/compile.scm 29 */
BgL_objectz00_bglt BgL_auxz00_3242;
BgL_auxz00_3242 = 
(BgL_objectz00_bglt)(BgL_new3050z00_2405); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_3242, BFALSE); } 
{ /* Jvm/compile.scm 29 */
obj_t BgL_auxz00_3245;
BgL_auxz00_3245 = 
(obj_t)(BgL_new3050z00_2405); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_3245); } BUNSPEC; 
BgL_res4380z00_2410 = BgL_new3050z00_2405; } 
BgL_new3048z00_2404 = BgL_res4380z00_2410; } 
{ /* Jvm/compile.scm 29 */
BgL_envz00_bglt BgL_res4381z00_2446;
((((BgL_envz00_bglt)CREF(BgL_new3048z00_2404))->BgL_declarationsz00) = ((obj_t)BNIL), BUNSPEC); 
((((BgL_envz00_bglt)CREF(BgL_new3048z00_2404))->BgL_declaredtypez00) = ((obj_t)BNIL), BUNSPEC); 
((((BgL_envz00_bglt)CREF(BgL_new3048z00_2404))->BgL_declaredclassz00) = ((obj_t)BNIL), BUNSPEC); 
((((BgL_envz00_bglt)CREF(BgL_new3048z00_2404))->BgL_declaredmodulez00) = ((obj_t)BNIL), BUNSPEC); 
((((BgL_envz00_bglt)CREF(BgL_new3048z00_2404))->BgL_currentzd2modulezd2) = ((obj_t)BNIL), BUNSPEC); 
((((BgL_envz00_bglt)CREF(BgL_new3048z00_2404))->BgL_declaredfieldsz00) = ((obj_t)BNIL), BUNSPEC); 
((((BgL_envz00_bglt)CREF(BgL_new3048z00_2404))->BgL_declaredglobalz00) = ((obj_t)BNIL), BUNSPEC); 
((((BgL_envz00_bglt)CREF(BgL_new3048z00_2404))->BgL_libdeclaredz00) = ((obj_t)BNIL), BUNSPEC); 
((((BgL_envz00_bglt)CREF(BgL_new3048z00_2404))->BgL_proceduresz00) = ((obj_t)BNIL), BUNSPEC); 
((((BgL_envz00_bglt)CREF(BgL_new3048z00_2404))->BgL_clinitzd2codezd2) = ((obj_t)BNIL), BUNSPEC); 
((((BgL_envz00_bglt)CREF(BgL_new3048z00_2404))->BgL_currentzd2methodzd2) = ((obj_t)BNIL), BUNSPEC); 
((((BgL_envz00_bglt)CREF(BgL_new3048z00_2404))->BgL_vcountz00) = ((obj_t)BgL_vcount3042z00_2398), BUNSPEC); 
((((BgL_envz00_bglt)CREF(BgL_new3048z00_2404))->BgL_localsz00) = ((obj_t)BNIL), BUNSPEC); 
((((BgL_envz00_bglt)CREF(BgL_new3048z00_2404))->BgL_freelocalsz00) = ((obj_t)BNIL), BUNSPEC); 
((((BgL_envz00_bglt)CREF(BgL_new3048z00_2404))->BgL_maplocalsz00) = ((obj_t)BNIL), BUNSPEC); 
((((BgL_envz00_bglt)CREF(BgL_new3048z00_2404))->BgL_stackz00) = ((obj_t)BNIL), BUNSPEC); 
((((BgL_envz00_bglt)CREF(BgL_new3048z00_2404))->BgL_codez00) = ((obj_t)BNIL), BUNSPEC); 
BgL_res4381z00_2446 = BgL_new3048z00_2404; BgL_res4381z00_2446; } 
BgL_res4382z00_2447 = BgL_new3048z00_2404; } } 
BgL_envz00_1572 = BgL_res4382z00_2447; } 
{ /* Jvm/compile.scm 29 */
obj_t BgL__z00_1573;
BgL__z00_1573 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_1572, 
CNST_TABLE_REF(((long)0))); 
{ /* Jvm/compile.scm 30 */
obj_t BgL_mez00_1574;
BgL_mez00_1574 = 
BGl_compilezd2typezd2nowideningz00zzjvm_envz00(BgL_classz00_3, BgL_envz00_1572); 
{ /* Jvm/compile.scm 31 */
obj_t BgL_superz00_1575;
{ /* Jvm/compile.scm 32 */
bool_t BgL_test3261z00_1644;
BgL_test3261z00_1644 = 
BGl_widezd2classzf3z21zzobject_classz00(BgL_classz00_3); 
if(BgL_test3261z00_1644)
{ /* Jvm/compile.scm 32 */
BgL_superz00_1575 = 
CNST_TABLE_REF(((long)0)); }  else 
{ /* Jvm/compile.scm 34 */
obj_t BgL_auxz00_3271;
{ /* Jvm/compile.scm 34 */
BgL_tclassz00_bglt BgL_obj2713z00_2448;
BgL_obj2713z00_2448 = 
(BgL_tclassz00_bglt)(BgL_classz00_3); 
{ 
obj_t BgL_auxz00_3273;
{ /* Jvm/compile.scm 34 */
BgL_objectz00_bglt BgL_auxz00_3274;
BgL_auxz00_3274 = 
(BgL_objectz00_bglt)(BgL_obj2713z00_2448); 
BgL_auxz00_3273 = 
BGL_OBJECT_WIDENING(BgL_auxz00_3274); } 
BgL_auxz00_3271 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_3273))->BgL_itszd2superzd2); } } 
BgL_superz00_1575 = 
BGl_compilezd2typezd2zzjvm_envz00(BgL_auxz00_3271, BgL_envz00_1572); } } 
{ /* Jvm/compile.scm 32 */
obj_t BgL_fieldsz00_1576;
BgL_fieldsz00_1576 = 
BGl_compilezd2classzd2fieldsz00zzjvm_compilez00(BgL_envz00_1572, BgL_classz00_3, BgL_mez00_1574); 
{ /* Jvm/compile.scm 35 */

{ /* Jvm/compile.scm 37 */
obj_t BgL_arg3110z00_1577;obj_t BgL_arg3111z00_1578;
{ /* Jvm/compile.scm 37 */
obj_t BgL_arg3114z00_1579;obj_t BgL_arg3115z00_1580;
BgL_arg3114z00_1579 = 
CNST_TABLE_REF(((long)1)); 
{ /* Jvm/compile.scm 37 */
obj_t BgL_arg3118z00_1581;
BgL_arg3118z00_1581 = 
BGl_tclasszd2idzd2manglingz00zzjvm_externz00(
(BgL_tclassz00_bglt)(BgL_classz00_3)); 
BgL_arg3115z00_1580 = 
MAKE_PAIR(BgL_arg3118z00_1581, BNIL); } 
BgL_arg3110z00_1577 = 
MAKE_PAIR(BgL_arg3114z00_1579, BgL_arg3115z00_1580); } 
{ /* Jvm/compile.scm 37 */
obj_t BgL_arg3123z00_1583;
{ /* Jvm/compile.scm 37 */
obj_t BgL_arg3126z00_1584;
{ /* Jvm/compile.scm 37 */
obj_t BgL_arg3130z00_1586;
{ /* Jvm/compile.scm 39 */
obj_t BgL_arg3133z00_1587;obj_t BgL_arg3134z00_1588;
{ /* Jvm/compile.scm 39 */
obj_t BgL_arg3137z00_1589;obj_t BgL_arg3138z00_1590;
BgL_arg3137z00_1589 = 
CNST_TABLE_REF(((long)2)); 
{ /* Jvm/compile.scm 40 */
obj_t BgL_arg3141z00_1591;obj_t BgL_arg3142z00_1592;
BgL_arg3141z00_1591 = 
bgl_reverse(
(((BgL_envz00_bglt)CREF(BgL_envz00_1572))->BgL_declarationsz00)); 
{ /* Jvm/compile.scm 41 */
obj_t BgL_arg3149z00_1594;obj_t BgL_arg3150z00_1595;
{ /* Jvm/compile.scm 41 */
obj_t BgL_arg3153z00_1596;obj_t BgL_arg3154z00_1597;
BgL_arg3153z00_1596 = 
CNST_TABLE_REF(((long)3)); 
{ /* Jvm/compile.scm 41 */
obj_t BgL_arg3157z00_1598;
{ /* Jvm/compile.scm 41 */
obj_t BgL_arg3161z00_1600;obj_t BgL_arg3162z00_1601;
BgL_arg3161z00_1600 = 
CNST_TABLE_REF(((long)4)); 
{ /* Jvm/compile.scm 41 */
obj_t BgL_arg3165z00_1602;
{ /* Jvm/compile.scm 41 */
obj_t BgL_arg3168z00_1603;obj_t BgL_arg3169z00_1604;
{ /* Jvm/compile.scm 41 */
obj_t BgL_auxz00_3290;
BgL_auxz00_3290 = 
CNST_TABLE_REF(((long)5)); 
BgL_arg3168z00_1603 = 
MAKE_PAIR(BgL_auxz00_3290, BNIL); } 
{ /* Jvm/compile.scm 41 */
obj_t BgL_arg3174z00_1605;obj_t BgL_arg3175z00_1606;
BgL_arg3174z00_1605 = 
CNST_TABLE_REF(((long)6)); 
BgL_arg3175z00_1606 = 
MAKE_PAIR(BGl_string4480z00zzjvm_compilez00, BNIL); 
BgL_arg3169z00_1604 = 
MAKE_PAIR(BgL_arg3174z00_1605, BgL_arg3175z00_1606); } 
BgL_arg3165z00_1602 = 
MAKE_PAIR(BgL_arg3168z00_1603, BgL_arg3169z00_1604); } 
BgL_arg3162z00_1601 = 
MAKE_PAIR(BgL_mez00_1574, BgL_arg3165z00_1602); } 
BgL_arg3157z00_1598 = 
MAKE_PAIR(BgL_arg3161z00_1600, BgL_arg3162z00_1601); } 
BgL_arg3154z00_1597 = 
MAKE_PAIR(BgL_arg3157z00_1598, BNIL); } 
BgL_arg3149z00_1594 = 
MAKE_PAIR(BgL_arg3153z00_1596, BgL_arg3154z00_1597); } 
{ /* Jvm/compile.scm 42 */
obj_t BgL_arg3179z00_1607;
{ /* Jvm/compile.scm 42 */
obj_t BgL_arg3183z00_1609;obj_t BgL_arg3184z00_1610;
BgL_arg3183z00_1609 = 
CNST_TABLE_REF(((long)7)); 
{ /* Jvm/compile.scm 42 */
obj_t BgL_arg3187z00_1611;
{ /* Jvm/compile.scm 42 */
obj_t BgL_arg3191z00_1613;obj_t BgL_arg3192z00_1614;
BgL_arg3191z00_1613 = 
CNST_TABLE_REF(((long)4)); 
{ /* Jvm/compile.scm 42 */
obj_t BgL_arg3195z00_1615;
{ /* Jvm/compile.scm 42 */
obj_t BgL_arg3198z00_1616;obj_t BgL_arg3199z00_1617;
{ /* Jvm/compile.scm 42 */
obj_t BgL_auxz00_3303;
BgL_auxz00_3303 = 
CNST_TABLE_REF(((long)5)); 
BgL_arg3198z00_1616 = 
MAKE_PAIR(BgL_auxz00_3303, BNIL); } 
{ /* Jvm/compile.scm 42 */
obj_t BgL_arg3203z00_1618;obj_t BgL_arg3204z00_1619;
BgL_arg3203z00_1618 = 
CNST_TABLE_REF(((long)6)); 
BgL_arg3204z00_1619 = 
MAKE_PAIR(BGl_string4480z00zzjvm_compilez00, BNIL); 
BgL_arg3199z00_1617 = 
MAKE_PAIR(BgL_arg3203z00_1618, BgL_arg3204z00_1619); } 
BgL_arg3195z00_1615 = 
MAKE_PAIR(BgL_arg3198z00_1616, BgL_arg3199z00_1617); } 
BgL_arg3192z00_1614 = 
MAKE_PAIR(BgL_superz00_1575, BgL_arg3195z00_1615); } 
BgL_arg3187z00_1611 = 
MAKE_PAIR(BgL_arg3191z00_1613, BgL_arg3192z00_1614); } 
BgL_arg3184z00_1610 = 
MAKE_PAIR(BgL_arg3187z00_1611, BNIL); } 
BgL_arg3179z00_1607 = 
MAKE_PAIR(BgL_arg3183z00_1609, BgL_arg3184z00_1610); } 
BgL_arg3150z00_1595 = 
MAKE_PAIR(BgL_arg3179z00_1607, BNIL); } 
BgL_arg3142z00_1592 = 
MAKE_PAIR(BgL_arg3149z00_1594, BgL_arg3150z00_1595); } 
BgL_arg3138z00_1590 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg3141z00_1591, BgL_arg3142z00_1592); } 
BgL_arg3133z00_1587 = 
MAKE_PAIR(BgL_arg3137z00_1589, BgL_arg3138z00_1590); } 
{ /* Jvm/compile.scm 43 */
obj_t BgL_arg3208z00_1620;obj_t BgL_arg3209z00_1621;
{ /* Jvm/compile.scm 43 */
obj_t BgL_auxz00_3320;obj_t BgL_auxz00_3318;
BgL_auxz00_3320 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_fieldsz00_1576, BNIL); 
BgL_auxz00_3318 = 
CNST_TABLE_REF(((long)8)); 
BgL_arg3208z00_1620 = 
MAKE_PAIR(BgL_auxz00_3318, BgL_auxz00_3320); } 
{ /* Jvm/compile.scm 44 */
obj_t BgL_arg3217z00_1624;
{ /* Jvm/compile.scm 44 */
obj_t BgL_arg3221z00_1626;obj_t BgL_arg3222z00_1627;
BgL_arg3221z00_1626 = 
CNST_TABLE_REF(((long)4)); 
{ /* Jvm/compile.scm 44 */
obj_t BgL_arg3225z00_1628;obj_t BgL_arg3226z00_1629;
BgL_arg3225z00_1628 = 
CNST_TABLE_REF(((long)3)); 
{ /* Jvm/compile.scm 44 */
obj_t BgL_arg3229z00_1630;obj_t BgL_arg3230z00_1631;
{ /* Jvm/compile.scm 44 */
obj_t BgL_auxz00_3325;
BgL_auxz00_3325 = 
CNST_TABLE_REF(((long)9)); 
BgL_arg3229z00_1630 = 
MAKE_PAIR(BgL_auxz00_3325, BNIL); } 
{ /* Jvm/compile.scm 44 */
obj_t BgL_arg3235z00_1633;
{ /* Jvm/compile.scm 45 */
obj_t BgL_arg3238z00_1634;obj_t BgL_arg3239z00_1635;
{ /* Jvm/compile.scm 45 */
obj_t BgL_arg3242z00_1636;obj_t BgL_arg3243z00_1637;
BgL_arg3242z00_1636 = 
CNST_TABLE_REF(((long)10)); 
{ /* Jvm/compile.scm 45 */
obj_t BgL_auxz00_3329;
BgL_auxz00_3329 = 
CNST_TABLE_REF(((long)9)); 
BgL_arg3243z00_1637 = 
MAKE_PAIR(BgL_auxz00_3329, BNIL); } 
BgL_arg3238z00_1634 = 
MAKE_PAIR(BgL_arg3242z00_1636, BgL_arg3243z00_1637); } 
{ /* Jvm/compile.scm 46 */
obj_t BgL_arg3247z00_1638;obj_t BgL_arg3248z00_1639;
{ /* Jvm/compile.scm 46 */
obj_t BgL_arg3251z00_1640;obj_t BgL_arg3252z00_1641;
BgL_arg3251z00_1640 = 
CNST_TABLE_REF(((long)11)); 
{ /* Jvm/compile.scm 46 */
obj_t BgL_auxz00_3334;
BgL_auxz00_3334 = 
CNST_TABLE_REF(((long)7)); 
BgL_arg3252z00_1641 = 
MAKE_PAIR(BgL_auxz00_3334, BNIL); } 
BgL_arg3247z00_1638 = 
MAKE_PAIR(BgL_arg3251z00_1640, BgL_arg3252z00_1641); } 
{ /* Jvm/compile.scm 47 */
obj_t BgL_arg3256z00_1642;
{ /* Jvm/compile.scm 47 */
obj_t BgL_auxz00_3338;
BgL_auxz00_3338 = 
CNST_TABLE_REF(((long)12)); 
BgL_arg3256z00_1642 = 
MAKE_PAIR(BgL_auxz00_3338, BNIL); } 
BgL_arg3248z00_1639 = 
MAKE_PAIR(BgL_arg3256z00_1642, BNIL); } 
BgL_arg3239z00_1635 = 
MAKE_PAIR(BgL_arg3247z00_1638, BgL_arg3248z00_1639); } 
BgL_arg3235z00_1633 = 
MAKE_PAIR(BgL_arg3238z00_1634, BgL_arg3239z00_1635); } 
BgL_arg3230z00_1631 = 
MAKE_PAIR(BNIL, BgL_arg3235z00_1633); } 
BgL_arg3226z00_1629 = 
MAKE_PAIR(BgL_arg3229z00_1630, BgL_arg3230z00_1631); } 
BgL_arg3222z00_1627 = 
MAKE_PAIR(BgL_arg3225z00_1628, BgL_arg3226z00_1629); } 
BgL_arg3217z00_1624 = 
MAKE_PAIR(BgL_arg3221z00_1626, BgL_arg3222z00_1627); } 
BgL_arg3209z00_1621 = 
MAKE_PAIR(BgL_arg3217z00_1624, BNIL); } 
BgL_arg3134z00_1588 = 
MAKE_PAIR(BgL_arg3208z00_1620, BgL_arg3209z00_1621); } 
BgL_arg3130z00_1586 = 
MAKE_PAIR(BgL_arg3133z00_1587, BgL_arg3134z00_1588); } 
BgL_arg3126z00_1584 = 
MAKE_PAIR(BNIL, BgL_arg3130z00_1586); } 
BgL_arg3123z00_1583 = 
MAKE_PAIR(BgL_superz00_1575, BgL_arg3126z00_1584); } 
BgL_arg3111z00_1578 = 
MAKE_PAIR(BgL_mez00_1574, BgL_arg3123z00_1583); } 
return 
MAKE_PAIR(BgL_arg3110z00_1577, BgL_arg3111z00_1578);} } } } } } } } 
}



/* compile-class-fields */
obj_t BGl_compilezd2classzd2fieldsz00zzjvm_compilez00(BgL_envz00_bglt BgL_envz00_4, obj_t BgL_classz00_5, obj_t BgL_ownerz00_6)
{ AN_OBJECT;
{ /* Jvm/compile.scm 50 */
{ /* Jvm/compile.scm 51 */
obj_t BgL_rz00_1646;
BgL_rz00_1646 = BNIL; 
{ 
obj_t BgL_l3058z00_1647;
{ /* Jvm/compile.scm 60 */
BgL_tclassz00_bglt BgL_obj2716z00_2450;
BgL_obj2716z00_2450 = 
(BgL_tclassz00_bglt)(BgL_classz00_5); 
{ 
obj_t BgL_auxz00_3383;
{ /* Jvm/compile.scm 60 */
BgL_objectz00_bglt BgL_auxz00_3384;
BgL_auxz00_3384 = 
(BgL_objectz00_bglt)(BgL_obj2716z00_2450); 
BgL_auxz00_3383 = 
BGL_OBJECT_WIDENING(BgL_auxz00_3384); } 
BgL_l3058z00_1647 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_3383))->BgL_slotsz00); } } 
BgL_lname3059z00_1648:
if(
PAIRP(BgL_l3058z00_1647))
{ /* Jvm/compile.scm 52 */
{ /* Jvm/compile.scm 53 */
obj_t BgL_slotz00_1651;
BgL_slotz00_1651 = 
CAR(BgL_l3058z00_1647); 
{ /* Jvm/compile.scm 53 */
obj_t BgL_typez00_1652;
{ /* Jvm/compile.scm 53 */
obj_t BgL_auxz00_3358;
{ /* Jvm/compile.scm 53 */
obj_t BgL__ortest_3060z00_2454;
{ /* Jvm/compile.scm 53 */
BgL_slotz00_bglt BgL_obj2874z00_2455;
BgL_obj2874z00_2455 = 
(BgL_slotz00_bglt)(BgL_slotz00_1651); 
BgL__ortest_3060z00_2454 = 
(((BgL_slotz00_bglt)CREF(BgL_obj2874z00_2455))->BgL_indexedz00); } 
if(
CBOOL(BgL__ortest_3060z00_2454))
{ /* Jvm/compile.scm 53 */
BgL_auxz00_3358 = BgL__ortest_3060z00_2454
; }  else 
{ /* Jvm/compile.scm 53 */
BgL_slotz00_bglt BgL_obj2861z00_2456;
BgL_obj2861z00_2456 = 
(BgL_slotz00_bglt)(BgL_slotz00_1651); 
BgL_auxz00_3358 = 
(((BgL_slotz00_bglt)CREF(BgL_obj2861z00_2456))->BgL_typez00); } } 
BgL_typez00_1652 = 
BGl_compilezd2typezd2zzjvm_envz00(BgL_auxz00_3358, BgL_envz00_4); } 
{ /* Jvm/compile.scm 54 */
bool_t BgL_test3275z00_1653;
{ /* Jvm/compile.scm 54 */
bool_t BgL_test3281z00_1656;
BgL_test3281z00_1656 = 
BGl_slotzd2virtualzf3z21zzobject_slotsz00(
(BgL_slotz00_bglt)(BgL_slotz00_1651)); 
if(BgL_test3281z00_1656)
{ /* Jvm/compile.scm 54 */
BgL_test3275z00_1653 = ((bool_t)0); }  else 
{ /* Jvm/compile.scm 55 */
obj_t BgL_auxz00_3369;
{ /* Jvm/compile.scm 55 */
BgL_slotz00_bglt BgL_obj2860z00_2457;
BgL_obj2860z00_2457 = 
(BgL_slotz00_bglt)(BgL_slotz00_1651); 
BgL_auxz00_3369 = 
(((BgL_slotz00_bglt)CREF(BgL_obj2860z00_2457))->BgL_classzd2ownerzd2); } 
BgL_test3275z00_1653 = 
(BgL_classz00_5==BgL_auxz00_3369); } } 
if(BgL_test3275z00_1653)
{ /* Jvm/compile.scm 58 */
obj_t BgL_arg3277z00_1655;
{ /* Jvm/compile.scm 58 */
obj_t BgL_auxz00_3374;
{ /* Jvm/compile.scm 56 */
BgL_slotz00_bglt BgL_obj2857z00_2458;
BgL_obj2857z00_2458 = 
(BgL_slotz00_bglt)(BgL_slotz00_1651); 
BgL_auxz00_3374 = 
(((BgL_slotz00_bglt)CREF(BgL_obj2857z00_2458))->BgL_namez00); } 
BgL_arg3277z00_1655 = 
BGl_envzd2declarezd2fieldz00zzjvm_envz00(
(obj_t)(BgL_envz00_4), BgL_auxz00_3374, BgL_typez00_1652, BgL_ownerz00_6); } 
BgL_rz00_1646 = 
MAKE_PAIR(BgL_arg3277z00_1655, BgL_rz00_1646); }  else 
{ /* Jvm/compile.scm 54 */BFALSE; } } } } 
{ 
obj_t BgL_l3058z00_3380;
BgL_l3058z00_3380 = 
CDR(BgL_l3058z00_1647); 
BgL_l3058z00_1647 = BgL_l3058z00_3380; 
goto BgL_lname3059z00_1648;} }  else 
{ /* Jvm/compile.scm 52 */((bool_t)1); } } 
return BgL_rz00_1646;} } 
}



/* compile-module */
obj_t BGl_compilezd2modulezd2zzjvm_compilez00(obj_t BgL_globalsz00_8)
{ AN_OBJECT;
{ /* Jvm/compile.scm 69 */
{ /* Jvm/compile.scm 70 */
obj_t BgL_envz00_1661;
BgL_envz00_1661 = 
PROCEDURE_ENTRY(BGl_compilezd2initzd2zzjvm_initz00)(BGl_compilezd2initzd2zzjvm_initz00, BgL_globalsz00_8, BEOA); 
{ /* Jvm/compile.scm 70 */
obj_t BgL_mez00_1662;
{ /* Jvm/compile.scm 71 */
BgL_envz00_bglt BgL_obj2954z00_2463;
BgL_obj2954z00_2463 = 
(BgL_envz00_bglt)(BgL_envz00_1661); 
BgL_mez00_1662 = 
(((BgL_envz00_bglt)CREF(BgL_obj2954z00_2463))->BgL_currentzd2modulezd2); } 
{ /* Jvm/compile.scm 71 */
obj_t BgL_superz00_1663;
BgL_superz00_1663 = 
BGl_jlibzd2declarezd2zzjvm_envz00(
(BgL_envz00_bglt)(BgL_envz00_1661), 
CNST_TABLE_REF(((long)13))); 
{ /* Jvm/compile.scm 72 */
obj_t BgL_mainz00_1664;
BgL_mainz00_1664 = 
BGl_compilezd2mainzd2zzjvm_compilez00(BgL_envz00_1661); 
{ /* Jvm/compile.scm 73 */
obj_t BgL_dlopenz00_1665;
BgL_dlopenz00_1665 = 
BGl_compilezd2dlopenzd2zzjvm_compilez00(BgL_envz00_1661); 
{ /* Jvm/compile.scm 74 */
obj_t BgL_funsz00_1666;
if(
NULLP(BgL_globalsz00_8))
{ /* Jvm/compile.scm 75 */
BgL_funsz00_1666 = BNIL; }  else 
{ /* Jvm/compile.scm 75 */
obj_t BgL_head3063z00_1736;
BgL_head3063z00_1736 = 
MAKE_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l3061z00_1737;obj_t BgL_tail3064z00_1738;
BgL_l3061z00_1737 = BgL_globalsz00_8; 
BgL_tail3064z00_1738 = BgL_head3063z00_1736; 
BgL_lname3062z00_1739:
if(
NULLP(BgL_l3061z00_1737))
{ /* Jvm/compile.scm 75 */
BgL_funsz00_1666 = 
CDR(BgL_head3063z00_1736); }  else 
{ /* Jvm/compile.scm 75 */
obj_t BgL_newtail3065z00_1741;
{ /* Jvm/compile.scm 75 */
obj_t BgL_arg3462z00_1743;
{ /* Jvm/compile.scm 75 */
obj_t BgL_mz00_2472;
BgL_mz00_2472 = 
BGl_compilezd2globalfun1zd2zzjvm_compilez00(
CAR(BgL_l3061z00_1737), BgL_envz00_1661); 
BGl_jvm_peepholez00zzjvm_peepholez00(BgL_mz00_2472); 
BgL_arg3462z00_1743 = BgL_mz00_2472; } 
BgL_newtail3065z00_1741 = 
MAKE_PAIR(BgL_arg3462z00_1743, BNIL); } 
SET_CDR(BgL_tail3064z00_1738, BgL_newtail3065z00_1741); 
{ 
obj_t BgL_tail3064z00_3410;obj_t BgL_l3061z00_3408;
BgL_l3061z00_3408 = 
CDR(BgL_l3061z00_1737); 
BgL_tail3064z00_3410 = BgL_newtail3065z00_1741; 
BgL_tail3064z00_1738 = BgL_tail3064z00_3410; 
BgL_l3061z00_1737 = BgL_l3061z00_3408; 
goto BgL_lname3062z00_1739;} } } } 
{ /* Jvm/compile.scm 75 */
obj_t BgL_constructorsz00_1667;
BgL_constructorsz00_1667 = 
BGl_jvmzd2constructorszd2zzjvm_constrz00(
(BgL_envz00_bglt)(BgL_envz00_1661), BgL_mez00_1662, BgL_superz00_1663); 
{ /* Jvm/compile.scm 76 */
obj_t BgL_funcallersz00_1668;
BgL_funcallersz00_1668 = 
BGl_jvmzd2funcallerszd2zzjvm_closurez00(
(BgL_envz00_bglt)(BgL_envz00_1661), BgL_mez00_1662, BgL_superz00_1663); 
{ /* Jvm/compile.scm 77 */

BGl_jlibzd2declarezd2zzjvm_envz00(
(BgL_envz00_bglt)(BgL_envz00_1661), 
CNST_TABLE_REF(((long)14))); 
{ /* Jvm/compile.scm 79 */
obj_t BgL_arg3301z00_1669;obj_t BgL_arg3302z00_1670;
BgL_arg3301z00_1669 = 
CNST_TABLE_REF(((long)15)); 
{ /* Jvm/compile.scm 79 */
obj_t BgL_arg3305z00_1671;
{ /* Jvm/compile.scm 79 */
obj_t BgL_arg3308z00_1672;
{ /* Jvm/compile.scm 79 */
obj_t BgL_arg3312z00_1674;
{ /* Jvm/compile.scm 80 */
obj_t BgL_arg3315z00_1675;obj_t BgL_arg3316z00_1676;
{ /* Jvm/compile.scm 80 */
obj_t BgL_arg3319z00_1677;obj_t BgL_arg3320z00_1678;
BgL_arg3319z00_1677 = 
CNST_TABLE_REF(((long)2)); 
{ /* Jvm/compile.scm 81 */
obj_t BgL_arg3323z00_1679;obj_t BgL_arg3324z00_1680;
{ /* Jvm/compile.scm 81 */
obj_t BgL_auxz00_3420;
{ /* Jvm/compile.scm 81 */
BgL_envz00_bglt BgL_obj2942z00_2478;
BgL_obj2942z00_2478 = 
(BgL_envz00_bglt)(BgL_envz00_1661); 
BgL_auxz00_3420 = 
(((BgL_envz00_bglt)CREF(BgL_obj2942z00_2478))->BgL_declarationsz00); } 
BgL_arg3323z00_1679 = 
bgl_reverse(BgL_auxz00_3420); } 
{ /* Jvm/compile.scm 82 */
obj_t BgL_arg3331z00_1682;obj_t BgL_arg3332z00_1683;
{ /* Jvm/compile.scm 82 */
obj_t BgL_arg3335z00_1684;obj_t BgL_arg3336z00_1685;
BgL_arg3335z00_1684 = 
CNST_TABLE_REF(((long)16)); 
{ /* Jvm/compile.scm 82 */
obj_t BgL_arg3339z00_1686;
{ /* Jvm/compile.scm 82 */
obj_t BgL_arg3343z00_1688;obj_t BgL_arg3344z00_1689;
BgL_arg3343z00_1688 = 
CNST_TABLE_REF(((long)17)); 
{ /* Jvm/compile.scm 82 */
obj_t BgL_arg3347z00_1690;
{ /* Jvm/compile.scm 82 */
obj_t BgL_arg3350z00_1691;obj_t BgL_arg3351z00_1692;
{ /* Jvm/compile.scm 82 */
obj_t BgL_arg3354z00_1693;obj_t BgL_arg3355z00_1694;
BgL_arg3354z00_1693 = 
CNST_TABLE_REF(((long)5)); 
{ /* Jvm/compile.scm 82 */
obj_t BgL_auxz00_3427;
BgL_auxz00_3427 = 
CNST_TABLE_REF(((long)18)); 
BgL_arg3355z00_1694 = 
MAKE_PAIR(BgL_auxz00_3427, BNIL); } 
BgL_arg3350z00_1691 = 
MAKE_PAIR(BgL_arg3354z00_1693, BgL_arg3355z00_1694); } 
{ /* Jvm/compile.scm 82 */
obj_t BgL_arg3359z00_1695;obj_t BgL_arg3360z00_1696;
BgL_arg3359z00_1695 = 
CNST_TABLE_REF(((long)14)); 
BgL_arg3360z00_1696 = 
MAKE_PAIR(BGl_string4481z00zzjvm_compilez00, BNIL); 
BgL_arg3351z00_1692 = 
MAKE_PAIR(BgL_arg3359z00_1695, BgL_arg3360z00_1696); } 
BgL_arg3347z00_1690 = 
MAKE_PAIR(BgL_arg3350z00_1691, BgL_arg3351z00_1692); } 
BgL_arg3344z00_1689 = 
MAKE_PAIR(BgL_mez00_1662, BgL_arg3347z00_1690); } 
BgL_arg3339z00_1686 = 
MAKE_PAIR(BgL_arg3343z00_1688, BgL_arg3344z00_1689); } 
BgL_arg3336z00_1685 = 
MAKE_PAIR(BgL_arg3339z00_1686, BNIL); } 
BgL_arg3331z00_1682 = 
MAKE_PAIR(BgL_arg3335z00_1684, BgL_arg3336z00_1685); } 
{ /* Jvm/compile.scm 84 */
obj_t BgL_arg3364z00_1697;
{ /* Jvm/compile.scm 84 */
obj_t BgL_arg3369z00_1699;obj_t BgL_arg3370z00_1700;
BgL_arg3369z00_1699 = 
CNST_TABLE_REF(((long)19)); 
{ /* Jvm/compile.scm 84 */
obj_t BgL_arg3373z00_1701;
{ /* Jvm/compile.scm 84 */
obj_t BgL_arg3377z00_1703;obj_t BgL_arg3378z00_1704;
BgL_arg3377z00_1703 = 
CNST_TABLE_REF(((long)17)); 
{ /* Jvm/compile.scm 84 */
obj_t BgL_arg3381z00_1705;
{ /* Jvm/compile.scm 84 */
obj_t BgL_arg3384z00_1706;obj_t BgL_arg3385z00_1707;
{ /* Jvm/compile.scm 84 */
obj_t BgL_arg3388z00_1708;obj_t BgL_arg3389z00_1709;
BgL_arg3388z00_1708 = 
CNST_TABLE_REF(((long)5)); 
{ /* Jvm/compile.scm 84 */
obj_t BgL_auxz00_3442;
BgL_auxz00_3442 = 
CNST_TABLE_REF(((long)18)); 
BgL_arg3389z00_1709 = 
MAKE_PAIR(BgL_auxz00_3442, BNIL); } 
BgL_arg3384z00_1706 = 
MAKE_PAIR(BgL_arg3388z00_1708, BgL_arg3389z00_1709); } 
{ /* Jvm/compile.scm 85 */
obj_t BgL_arg3393z00_1710;obj_t BgL_arg3394z00_1711;
{ /* Jvm/compile.scm 85 */
obj_t BgL_arg3397z00_1712;obj_t BgL_arg3398z00_1713;
BgL_arg3397z00_1712 = 
CNST_TABLE_REF(((long)20)); 
{ /* Jvm/compile.scm 85 */
obj_t BgL_auxz00_3447;
BgL_auxz00_3447 = 
CNST_TABLE_REF(((long)0)); 
BgL_arg3398z00_1713 = 
MAKE_PAIR(BgL_auxz00_3447, BNIL); } 
BgL_arg3393z00_1710 = 
MAKE_PAIR(BgL_arg3397z00_1712, BgL_arg3398z00_1713); } 
BgL_arg3394z00_1711 = 
MAKE_PAIR(BGl_string4482z00zzjvm_compilez00, BNIL); 
BgL_arg3385z00_1707 = 
MAKE_PAIR(BgL_arg3393z00_1710, BgL_arg3394z00_1711); } 
BgL_arg3381z00_1705 = 
MAKE_PAIR(BgL_arg3384z00_1706, BgL_arg3385z00_1707); } 
BgL_arg3378z00_1704 = 
MAKE_PAIR(BgL_mez00_1662, BgL_arg3381z00_1705); } 
BgL_arg3373z00_1701 = 
MAKE_PAIR(BgL_arg3377z00_1703, BgL_arg3378z00_1704); } 
BgL_arg3370z00_1700 = 
MAKE_PAIR(BgL_arg3373z00_1701, BNIL); } 
BgL_arg3364z00_1697 = 
MAKE_PAIR(BgL_arg3369z00_1699, BgL_arg3370z00_1700); } 
BgL_arg3332z00_1683 = 
MAKE_PAIR(BgL_arg3364z00_1697, BNIL); } 
BgL_arg3324z00_1680 = 
MAKE_PAIR(BgL_arg3331z00_1682, BgL_arg3332z00_1683); } 
BgL_arg3320z00_1678 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg3323z00_1679, BgL_arg3324z00_1680); } 
BgL_arg3315z00_1675 = 
MAKE_PAIR(BgL_arg3319z00_1677, BgL_arg3320z00_1678); } 
{ /* Jvm/compile.scm 86 */
obj_t BgL_arg3403z00_1714;obj_t BgL_arg3404z00_1715;
{ /* Jvm/compile.scm 86 */
obj_t BgL_arg3407z00_1716;obj_t BgL_arg3408z00_1717;
BgL_arg3407z00_1716 = 
CNST_TABLE_REF(((long)8)); 
{ /* Jvm/compile.scm 86 */
obj_t BgL_arg3412z00_1718;obj_t BgL_arg3413z00_1719;
BgL_arg3412z00_1718 = 
CNST_TABLE_REF(((long)19)); 
{ /* Jvm/compile.scm 86 */
obj_t BgL_arg3416z00_1720;obj_t BgL_arg3417z00_1721;
BgL_arg3416z00_1720 = 
CNST_TABLE_REF(((long)16)); 
{ /* Jvm/compile.scm 86 */
obj_t BgL_arg3420z00_1722;
BgL_arg3420z00_1722 = 
BGl_compilezd2fieldszd2zzjvm_compilez00(BgL_envz00_1661); 
BgL_arg3417z00_1721 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg3420z00_1722, BNIL); } 
BgL_arg3413z00_1719 = 
MAKE_PAIR(BgL_arg3416z00_1720, BgL_arg3417z00_1721); } 
BgL_arg3408z00_1717 = 
MAKE_PAIR(BgL_arg3412z00_1718, BgL_arg3413z00_1719); } 
BgL_arg3403z00_1714 = 
MAKE_PAIR(BgL_arg3407z00_1716, BgL_arg3408z00_1717); } 
{ /* Jvm/compile.scm 87 */
obj_t BgL_arg3425z00_1724;obj_t BgL_arg3426z00_1725;
{ /* Jvm/compile.scm 87 */
obj_t BgL_arg3429z00_1726;obj_t BgL_arg3430z00_1727;
BgL_arg3429z00_1726 = 
CNST_TABLE_REF(((long)21)); 
{ /* Jvm/compile.scm 87 */
obj_t BgL_arg3433z00_1728;
BgL_arg3433z00_1728 = 
BGl_getzd2sourcefilezd2zzjvm_externz00(); 
BgL_arg3430z00_1727 = 
MAKE_PAIR(BgL_arg3433z00_1728, BNIL); } 
BgL_arg3425z00_1724 = 
MAKE_PAIR(BgL_arg3429z00_1726, BgL_arg3430z00_1727); } 
BgL_arg3426z00_1725 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_constructorsz00_1667, 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_funcallersz00_1668, 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_mainz00_1664, 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_dlopenz00_1665, 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_funsz00_1666, BNIL))))); 
BgL_arg3404z00_1715 = 
MAKE_PAIR(BgL_arg3425z00_1724, BgL_arg3426z00_1725); } 
BgL_arg3316z00_1676 = 
MAKE_PAIR(BgL_arg3403z00_1714, BgL_arg3404z00_1715); } 
BgL_arg3312z00_1674 = 
MAKE_PAIR(BgL_arg3315z00_1675, BgL_arg3316z00_1676); } 
BgL_arg3308z00_1672 = 
MAKE_PAIR(BNIL, BgL_arg3312z00_1674); } 
BgL_arg3305z00_1671 = 
MAKE_PAIR(BgL_superz00_1663, BgL_arg3308z00_1672); } 
BgL_arg3302z00_1670 = 
MAKE_PAIR(BgL_mez00_1662, BgL_arg3305z00_1671); } 
return 
MAKE_PAIR(BgL_arg3301z00_1669, BgL_arg3302z00_1670);} } } } } } } } } } } 
}



/* compile-main */
obj_t BGl_compilezd2mainzd2zzjvm_compilez00(obj_t BgL_envz00_9)
{ AN_OBJECT;
{ /* Jvm/compile.scm 94 */
{ /* Jvm/compile.scm 95 */
bool_t BgL_test3475z00_1746;
{ /* Jvm/compile.scm 95 */
obj_t BgL_obj1248z00_2479;
BgL_obj1248z00_2479 = BGl_za2mainza2z00zzmodule_modulez00; 
BgL_test3475z00_1746 = 
BGl_iszd2azf3z21zz__objectz00(BgL_obj1248z00_2479, BGl_globalz00zzast_varz00); } 
if(BgL_test3475z00_1746)
{ /* Jvm/compile.scm 96 */
obj_t BgL_namez00_1747;
BgL_namez00_1747 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, BGl_string4483z00zzjvm_compilez00, BEOA); 
BGl_jlibzd2declarezd2zzjvm_envz00(
(BgL_envz00_bglt)(BgL_envz00_9), 
CNST_TABLE_REF(((long)22))); 
{ /* Jvm/compile.scm 99 */
obj_t BgL_arg3478z00_1748;
{ /* Jvm/compile.scm 99 */
obj_t BgL_arg3481z00_1749;obj_t BgL_arg3482z00_1750;
BgL_arg3481z00_1749 = 
CNST_TABLE_REF(((long)4)); 
{ /* Jvm/compile.scm 99 */
obj_t BgL_arg3485z00_1751;obj_t BgL_arg3486z00_1752;
{ /* Jvm/compile.scm 99 */
BgL_envz00_bglt BgL_obj2954z00_2480;
BgL_obj2954z00_2480 = 
(BgL_envz00_bglt)(BgL_envz00_9); 
BgL_arg3485z00_1751 = 
(((BgL_envz00_bglt)CREF(BgL_obj2954z00_2480))->BgL_currentzd2modulezd2); } 
{ /* Jvm/compile.scm 100 */
obj_t BgL_arg3491z00_1753;obj_t BgL_arg3492z00_1754;
{ /* Jvm/compile.scm 100 */
obj_t BgL_arg3495z00_1755;obj_t BgL_arg3496z00_1756;
BgL_arg3495z00_1755 = 
CNST_TABLE_REF(((long)5)); 
{ /* Jvm/compile.scm 100 */
obj_t BgL_auxz00_3497;
BgL_auxz00_3497 = 
CNST_TABLE_REF(((long)18)); 
BgL_arg3496z00_1756 = 
MAKE_PAIR(BgL_auxz00_3497, BNIL); } 
BgL_arg3491z00_1753 = 
MAKE_PAIR(BgL_arg3495z00_1755, BgL_arg3496z00_1756); } 
{ /* Jvm/compile.scm 99 */
obj_t BgL_arg3500z00_1757;obj_t BgL_arg3501z00_1758;
BgL_arg3500z00_1757 = 
CNST_TABLE_REF(((long)6)); 
{ /* Jvm/compile.scm 99 */
obj_t BgL_arg3505z00_1760;
{ /* Jvm/compile.scm 100 */
obj_t BgL_arg3508z00_1761;
{ /* Jvm/compile.scm 100 */
obj_t BgL_arg3513z00_1763;obj_t BgL_arg3514z00_1764;
BgL_arg3513z00_1763 = 
CNST_TABLE_REF(((long)20)); 
{ /* Jvm/compile.scm 100 */
obj_t BgL_auxz00_3503;
BgL_auxz00_3503 = 
CNST_TABLE_REF(((long)14)); 
BgL_arg3514z00_1764 = 
MAKE_PAIR(BgL_auxz00_3503, BNIL); } 
BgL_arg3508z00_1761 = 
MAKE_PAIR(BgL_arg3513z00_1763, BgL_arg3514z00_1764); } 
BgL_arg3505z00_1760 = 
MAKE_PAIR(BgL_arg3508z00_1761, BNIL); } 
BgL_arg3501z00_1758 = 
MAKE_PAIR(BGl_string4483z00zzjvm_compilez00, BgL_arg3505z00_1760); } 
BgL_arg3492z00_1754 = 
MAKE_PAIR(BgL_arg3500z00_1757, BgL_arg3501z00_1758); } 
BgL_arg3486z00_1752 = 
MAKE_PAIR(BgL_arg3491z00_1753, BgL_arg3492z00_1754); } 
BgL_arg3482z00_1750 = 
MAKE_PAIR(BgL_arg3485z00_1751, BgL_arg3486z00_1752); } 
BgL_arg3478z00_1748 = 
MAKE_PAIR(BgL_arg3481z00_1749, BgL_arg3482z00_1750); } 
BGl_envzd2declarezd2zzjvm_envz00(
(BgL_envz00_bglt)(BgL_envz00_9), BgL_namez00_1747, BgL_arg3478z00_1748); } 
{ /* Jvm/compile.scm 101 */
obj_t BgL_arg3518z00_1765;
{ /* Jvm/compile.scm 101 */
obj_t BgL_arg3522z00_1767;obj_t BgL_arg3523z00_1768;
BgL_arg3522z00_1767 = 
CNST_TABLE_REF(((long)4)); 
{ /* Jvm/compile.scm 101 */
obj_t BgL_arg3526z00_1769;
{ /* Jvm/compile.scm 101 */
obj_t BgL_arg3529z00_1770;obj_t BgL_arg3530z00_1771;
{ /* Jvm/compile.scm 101 */
obj_t BgL_auxz00_3516;
BgL_auxz00_3516 = 
CNST_TABLE_REF(((long)23)); 
BgL_arg3529z00_1770 = 
MAKE_PAIR(BgL_auxz00_3516, BNIL); } 
{ /* Jvm/compile.scm 101 */
obj_t BgL_arg3535z00_1773;
{ /* Jvm/compile.scm 102 */
obj_t BgL_arg3538z00_1774;obj_t BgL_arg3539z00_1775;
{ /* Jvm/compile.scm 102 */
obj_t BgL_arg3542z00_1776;obj_t BgL_arg3544z00_1777;
BgL_arg3542z00_1776 = 
CNST_TABLE_REF(((long)24)); 
{ /* Jvm/compile.scm 102 */
obj_t BgL_arg3547z00_1778;obj_t BgL_arg3548z00_1779;
BgL_arg3547z00_1778 = 
CNST_TABLE_REF(((long)25)); 
{ /* Jvm/compile.scm 102 */
obj_t BgL_arg3551z00_1780;obj_t BgL_arg3552z00_1781;
BgL_arg3551z00_1780 = 
CNST_TABLE_REF(((long)26)); 
{ /* Jvm/compile.scm 102 */
obj_t BgL_arg3555z00_1782;obj_t BgL_arg3556z00_1783;
BgL_arg3555z00_1782 = 
CNST_TABLE_REF(((long)27)); 
{ /* Jvm/compile.scm 102 */
obj_t BgL_arg3559z00_1784;
BgL_arg3559z00_1784 = 
BGl_jlibzd2declarezd2zzjvm_envz00(
(BgL_envz00_bglt)(BgL_envz00_9), 
CNST_TABLE_REF(((long)28))); 
BgL_arg3556z00_1783 = 
MAKE_PAIR(BgL_arg3559z00_1784, BNIL); } 
BgL_arg3552z00_1781 = 
MAKE_PAIR(BgL_arg3555z00_1782, BgL_arg3556z00_1783); } 
BgL_arg3548z00_1779 = 
MAKE_PAIR(BgL_arg3551z00_1780, BgL_arg3552z00_1781); } 
BgL_arg3544z00_1777 = 
MAKE_PAIR(BgL_arg3547z00_1778, BgL_arg3548z00_1779); } 
BgL_arg3538z00_1774 = 
MAKE_PAIR(BgL_arg3542z00_1776, BgL_arg3544z00_1777); } 
{ /* Jvm/compile.scm 101 */
obj_t BgL_arg3564z00_1786;obj_t BgL_arg3565z00_1787;
BgL_arg3564z00_1786 = 
CNST_TABLE_REF(((long)25)); 
{ /* Jvm/compile.scm 104 */
obj_t BgL_arg3568z00_1788;obj_t BgL_arg3569z00_1789;
{ /* Jvm/compile.scm 104 */
obj_t BgL_arg3572z00_1790;obj_t BgL_arg3573z00_1791;
BgL_arg3572z00_1790 = 
CNST_TABLE_REF(((long)10)); 
{ /* Jvm/compile.scm 104 */
obj_t BgL_auxz00_3533;
BgL_auxz00_3533 = 
CNST_TABLE_REF(((long)23)); 
BgL_arg3573z00_1791 = 
MAKE_PAIR(BgL_auxz00_3533, BNIL); } 
BgL_arg3568z00_1788 = 
MAKE_PAIR(BgL_arg3572z00_1790, BgL_arg3573z00_1791); } 
{ /* Jvm/compile.scm 105 */
obj_t BgL_arg3577z00_1792;obj_t BgL_arg3578z00_1793;
{ /* Jvm/compile.scm 105 */
obj_t BgL_arg3581z00_1794;obj_t BgL_arg3582z00_1795;
BgL_arg3581z00_1794 = 
CNST_TABLE_REF(((long)29)); 
{ /* Jvm/compile.scm 105 */
obj_t BgL_auxz00_3538;
BgL_auxz00_3538 = 
CNST_TABLE_REF(((long)22)); 
BgL_arg3582z00_1795 = 
MAKE_PAIR(BgL_auxz00_3538, BNIL); } 
BgL_arg3577z00_1792 = 
MAKE_PAIR(BgL_arg3581z00_1794, BgL_arg3582z00_1795); } 
{ /* Jvm/compile.scm 106 */
obj_t BgL_arg3586z00_1796;obj_t BgL_arg3588z00_1797;
{ /* Jvm/compile.scm 106 */
obj_t BgL_arg3591z00_1798;obj_t BgL_arg3592z00_1799;
BgL_arg3591z00_1798 = 
CNST_TABLE_REF(((long)29)); 
{ /* Jvm/compile.scm 108 */
obj_t BgL_arg3595z00_1800;
{ /* Jvm/compile.scm 108 */
obj_t BgL_arg3599z00_1802;
{ /* Jvm/compile.scm 108 */
obj_t BgL_list3602z00_1803;
BgL_list3602z00_1803 = 
MAKE_PAIR(BGl_za2moduleza2z00zzmodule_modulez00, BNIL); 
BgL_arg3599z00_1802 = 
BGl_findzd2globalzd2zzast_envz00(
CNST_TABLE_REF(((long)30)), BgL_list3602z00_1803); } 
BgL_arg3595z00_1800 = 
BGl_getzd2globalzd2namez00zzjvm_envz00(
(BgL_envz00_bglt)(BgL_envz00_9), 
(BgL_globalz00_bglt)(BgL_arg3599z00_1802)); } 
BgL_arg3592z00_1799 = 
MAKE_PAIR(BgL_arg3595z00_1800, BNIL); } 
BgL_arg3586z00_1796 = 
MAKE_PAIR(BgL_arg3591z00_1798, BgL_arg3592z00_1799); } 
{ /* Jvm/compile.scm 109 */
obj_t BgL_arg3605z00_1804;obj_t BgL_arg3606z00_1805;
{ /* Jvm/compile.scm 109 */
obj_t BgL_auxz00_3551;
BgL_auxz00_3551 = 
CNST_TABLE_REF(((long)31)); 
BgL_arg3605z00_1804 = 
MAKE_PAIR(BgL_auxz00_3551, BNIL); } 
{ /* Jvm/compile.scm 101 */
obj_t BgL_arg3610z00_1806;obj_t BgL_arg3611z00_1807;
BgL_arg3610z00_1806 = 
CNST_TABLE_REF(((long)26)); 
{ /* Jvm/compile.scm 111 */
obj_t BgL_arg3614z00_1808;obj_t BgL_arg3615z00_1809;
{ /* Jvm/compile.scm 111 */
obj_t BgL_auxz00_3555;
BgL_auxz00_3555 = 
CNST_TABLE_REF(((long)12)); 
BgL_arg3614z00_1808 = 
MAKE_PAIR(BgL_auxz00_3555, BNIL); } 
{ /* Jvm/compile.scm 101 */
obj_t BgL_arg3619z00_1810;obj_t BgL_arg3620z00_1811;
BgL_arg3619z00_1810 = 
CNST_TABLE_REF(((long)27)); 
{ /* Jvm/compile.scm 113 */
obj_t BgL_arg3623z00_1812;obj_t BgL_arg3624z00_1813;
{ /* Jvm/compile.scm 113 */
obj_t BgL_arg3627z00_1814;obj_t BgL_arg3628z00_1815;
BgL_arg3627z00_1814 = 
CNST_TABLE_REF(((long)29)); 
{ /* Jvm/compile.scm 113 */
obj_t BgL_arg3631z00_1816;
BgL_arg3631z00_1816 = 
BGl_jlibzd2declarezd2zzjvm_envz00(
(BgL_envz00_bglt)(BgL_envz00_9), 
CNST_TABLE_REF(((long)32))); 
BgL_arg3628z00_1815 = 
MAKE_PAIR(BgL_arg3631z00_1816, BNIL); } 
BgL_arg3623z00_1812 = 
MAKE_PAIR(BgL_arg3627z00_1814, BgL_arg3628z00_1815); } 
{ /* Jvm/compile.scm 114 */
obj_t BgL_arg3636z00_1818;
{ /* Jvm/compile.scm 114 */
obj_t BgL_auxz00_3565;
BgL_auxz00_3565 = 
CNST_TABLE_REF(((long)12)); 
BgL_arg3636z00_1818 = 
MAKE_PAIR(BgL_auxz00_3565, BNIL); } 
BgL_arg3624z00_1813 = 
MAKE_PAIR(BgL_arg3636z00_1818, BNIL); } 
BgL_arg3620z00_1811 = 
MAKE_PAIR(BgL_arg3623z00_1812, BgL_arg3624z00_1813); } 
BgL_arg3615z00_1809 = 
MAKE_PAIR(BgL_arg3619z00_1810, BgL_arg3620z00_1811); } 
BgL_arg3611z00_1807 = 
MAKE_PAIR(BgL_arg3614z00_1808, BgL_arg3615z00_1809); } 
BgL_arg3606z00_1805 = 
MAKE_PAIR(BgL_arg3610z00_1806, BgL_arg3611z00_1807); } 
BgL_arg3588z00_1797 = 
MAKE_PAIR(BgL_arg3605z00_1804, BgL_arg3606z00_1805); } 
BgL_arg3578z00_1793 = 
MAKE_PAIR(BgL_arg3586z00_1796, BgL_arg3588z00_1797); } 
BgL_arg3569z00_1789 = 
MAKE_PAIR(BgL_arg3577z00_1792, BgL_arg3578z00_1793); } 
BgL_arg3565z00_1787 = 
MAKE_PAIR(BgL_arg3568z00_1788, BgL_arg3569z00_1789); } 
BgL_arg3539z00_1775 = 
MAKE_PAIR(BgL_arg3564z00_1786, BgL_arg3565z00_1787); } 
BgL_arg3535z00_1773 = 
MAKE_PAIR(BgL_arg3538z00_1774, BgL_arg3539z00_1775); } 
BgL_arg3530z00_1771 = 
MAKE_PAIR(BNIL, BgL_arg3535z00_1773); } 
BgL_arg3526z00_1769 = 
MAKE_PAIR(BgL_arg3529z00_1770, BgL_arg3530z00_1771); } 
BgL_arg3523z00_1768 = 
MAKE_PAIR(BgL_namez00_1747, BgL_arg3526z00_1769); } 
BgL_arg3518z00_1765 = 
MAKE_PAIR(BgL_arg3522z00_1767, BgL_arg3523z00_1768); } 
return 
MAKE_PAIR(BgL_arg3518z00_1765, BNIL);} }  else 
{ /* Jvm/compile.scm 95 */
return BNIL;} } } 
}



/* compile-dlopen */
obj_t BGl_compilezd2dlopenzd2zzjvm_compilez00(obj_t BgL_envz00_10)
{ AN_OBJECT;
{ /* Jvm/compile.scm 118 */
{ /* Jvm/compile.scm 119 */
obj_t BgL_namez00_1820;
BgL_namez00_1820 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, BGl_string4484z00zzjvm_compilez00, BEOA); 
{ /* Jvm/compile.scm 121 */
obj_t BgL_arg3643z00_1821;
{ /* Jvm/compile.scm 121 */
obj_t BgL_arg3646z00_1822;obj_t BgL_arg3647z00_1823;
BgL_arg3646z00_1822 = 
CNST_TABLE_REF(((long)4)); 
{ /* Jvm/compile.scm 121 */
obj_t BgL_arg3650z00_1824;obj_t BgL_arg3651z00_1825;
{ /* Jvm/compile.scm 121 */
BgL_envz00_bglt BgL_obj2954z00_2481;
BgL_obj2954z00_2481 = 
(BgL_envz00_bglt)(BgL_envz00_10); 
BgL_arg3650z00_1824 = 
(((BgL_envz00_bglt)CREF(BgL_obj2954z00_2481))->BgL_currentzd2modulezd2); } 
{ /* Jvm/compile.scm 122 */
obj_t BgL_arg3655z00_1826;obj_t BgL_arg3656z00_1827;
{ /* Jvm/compile.scm 122 */
obj_t BgL_arg3660z00_1828;obj_t BgL_arg3661z00_1829;
BgL_arg3660z00_1828 = 
CNST_TABLE_REF(((long)5)); 
{ /* Jvm/compile.scm 122 */
obj_t BgL_auxz00_3590;
BgL_auxz00_3590 = 
CNST_TABLE_REF(((long)18)); 
BgL_arg3661z00_1829 = 
MAKE_PAIR(BgL_auxz00_3590, BNIL); } 
BgL_arg3655z00_1826 = 
MAKE_PAIR(BgL_arg3660z00_1828, BgL_arg3661z00_1829); } 
{ /* Jvm/compile.scm 121 */
obj_t BgL_arg3665z00_1830;obj_t BgL_arg3666z00_1831;
BgL_arg3665z00_1830 = 
CNST_TABLE_REF(((long)6)); 
BgL_arg3666z00_1831 = 
MAKE_PAIR(BGl_string4484z00zzjvm_compilez00, BNIL); 
BgL_arg3656z00_1827 = 
MAKE_PAIR(BgL_arg3665z00_1830, BgL_arg3666z00_1831); } 
BgL_arg3651z00_1825 = 
MAKE_PAIR(BgL_arg3655z00_1826, BgL_arg3656z00_1827); } 
BgL_arg3647z00_1823 = 
MAKE_PAIR(BgL_arg3650z00_1824, BgL_arg3651z00_1825); } 
BgL_arg3643z00_1821 = 
MAKE_PAIR(BgL_arg3646z00_1822, BgL_arg3647z00_1823); } 
BGl_envzd2declarezd2zzjvm_envz00(
(BgL_envz00_bglt)(BgL_envz00_10), BgL_namez00_1820, BgL_arg3643z00_1821); } 
{ /* Jvm/compile.scm 123 */
obj_t BgL_arg3670z00_1832;
{ /* Jvm/compile.scm 123 */
obj_t BgL_arg3674z00_1834;obj_t BgL_arg3675z00_1835;
BgL_arg3674z00_1834 = 
CNST_TABLE_REF(((long)4)); 
{ /* Jvm/compile.scm 123 */
obj_t BgL_arg3678z00_1836;
{ /* Jvm/compile.scm 123 */
obj_t BgL_arg3683z00_1838;
{ /* Jvm/compile.scm 123 */
obj_t BgL_arg3687z00_1840;
{ /* Jvm/compile.scm 124 */
obj_t BgL_arg3690z00_1841;obj_t BgL_arg3691z00_1842;
{ /* Jvm/compile.scm 124 */
obj_t BgL_auxz00_3603;
BgL_auxz00_3603 = 
CNST_TABLE_REF(((long)33)); 
BgL_arg3690z00_1841 = 
MAKE_PAIR(BgL_auxz00_3603, BNIL); } 
{ /* Jvm/compile.scm 125 */
obj_t BgL_arg3695z00_1843;obj_t BgL_arg3696z00_1844;
{ /* Jvm/compile.scm 125 */
obj_t BgL_auxz00_3606;
BgL_auxz00_3606 = 
CNST_TABLE_REF(((long)34)); 
BgL_arg3695z00_1843 = 
MAKE_PAIR(BgL_auxz00_3606, BNIL); } 
{ /* Jvm/compile.scm 126 */
obj_t BgL_arg3700z00_1845;obj_t BgL_arg3701z00_1846;
{ /* Jvm/compile.scm 126 */
obj_t BgL_arg3704z00_1847;obj_t BgL_arg3705z00_1848;
BgL_arg3704z00_1847 = 
CNST_TABLE_REF(((long)29)); 
{ /* Jvm/compile.scm 128 */
obj_t BgL_arg3708z00_1849;
{ /* Jvm/compile.scm 128 */
obj_t BgL_arg3712z00_1851;
{ /* Jvm/compile.scm 128 */
obj_t BgL_list3715z00_1852;
BgL_list3715z00_1852 = 
MAKE_PAIR(BGl_za2moduleza2z00zzmodule_modulez00, BNIL); 
BgL_arg3712z00_1851 = 
BGl_findzd2globalzd2zzast_envz00(
CNST_TABLE_REF(((long)35)), BgL_list3715z00_1852); } 
BgL_arg3708z00_1849 = 
BGl_getzd2globalzd2namez00zzjvm_envz00(
(BgL_envz00_bglt)(BgL_envz00_10), 
(BgL_globalz00_bglt)(BgL_arg3712z00_1851)); } 
BgL_arg3705z00_1848 = 
MAKE_PAIR(BgL_arg3708z00_1849, BNIL); } 
BgL_arg3700z00_1845 = 
MAKE_PAIR(BgL_arg3704z00_1847, BgL_arg3705z00_1848); } 
{ /* Jvm/compile.scm 129 */
obj_t BgL_arg3718z00_1853;obj_t BgL_arg3719z00_1854;
{ /* Jvm/compile.scm 129 */
obj_t BgL_auxz00_3618;
BgL_auxz00_3618 = 
CNST_TABLE_REF(((long)31)); 
BgL_arg3718z00_1853 = 
MAKE_PAIR(BgL_auxz00_3618, BNIL); } 
{ /* Jvm/compile.scm 130 */
obj_t BgL_arg3723z00_1855;
{ /* Jvm/compile.scm 130 */
obj_t BgL_auxz00_3621;
BgL_auxz00_3621 = 
CNST_TABLE_REF(((long)12)); 
BgL_arg3723z00_1855 = 
MAKE_PAIR(BgL_auxz00_3621, BNIL); } 
BgL_arg3719z00_1854 = 
MAKE_PAIR(BgL_arg3723z00_1855, BNIL); } 
BgL_arg3701z00_1846 = 
MAKE_PAIR(BgL_arg3718z00_1853, BgL_arg3719z00_1854); } 
BgL_arg3696z00_1844 = 
MAKE_PAIR(BgL_arg3700z00_1845, BgL_arg3701z00_1846); } 
BgL_arg3691z00_1842 = 
MAKE_PAIR(BgL_arg3695z00_1843, BgL_arg3696z00_1844); } 
BgL_arg3687z00_1840 = 
MAKE_PAIR(BgL_arg3690z00_1841, BgL_arg3691z00_1842); } 
BgL_arg3683z00_1838 = 
MAKE_PAIR(BNIL, BgL_arg3687z00_1840); } 
BgL_arg3678z00_1836 = 
MAKE_PAIR(BNIL, BgL_arg3683z00_1838); } 
BgL_arg3675z00_1835 = 
MAKE_PAIR(BgL_namez00_1820, BgL_arg3678z00_1836); } 
BgL_arg3670z00_1832 = 
MAKE_PAIR(BgL_arg3674z00_1834, BgL_arg3675z00_1835); } 
return 
MAKE_PAIR(BgL_arg3670z00_1832, BNIL);} } } 
}



/* compile-fields */
obj_t BGl_compilezd2fieldszd2zzjvm_compilez00(obj_t BgL_envz00_11)
{ AN_OBJECT;
{ /* Jvm/compile.scm 132 */
{ /* Jvm/compile.scm 133 */
obj_t BgL_rz00_1857;obj_t BgL_mez00_1858;
BgL_rz00_1857 = BNIL; 
{ /* Jvm/compile.scm 133 */
BgL_envz00_bglt BgL_obj2954z00_2482;
BgL_obj2954z00_2482 = 
(BgL_envz00_bglt)(BgL_envz00_11); 
BgL_mez00_1858 = 
(((BgL_envz00_bglt)CREF(BgL_obj2954z00_2482))->BgL_currentzd2modulezd2); } 
{ 
obj_t BgL_l3066z00_1859;
{ /* Jvm/compile.scm 140 */
BgL_envz00_bglt BgL_obj2942z00_2483;
BgL_obj2942z00_2483 = 
(BgL_envz00_bglt)(BgL_envz00_11); 
BgL_l3066z00_1859 = 
(((BgL_envz00_bglt)CREF(BgL_obj2942z00_2483))->BgL_declarationsz00); } 
BgL_lname3067z00_1860:
if(
PAIRP(BgL_l3066z00_1859))
{ /* Jvm/compile.scm 134 */
{ /* Jvm/compile.scm 136 */
obj_t BgL_slotz00_1863;
BgL_slotz00_1863 = 
CAR(BgL_l3066z00_1859); 
{ /* Jvm/compile.scm 136 */
obj_t BgL_valz00_1864;
{ /* Jvm/compile.scm 136 */
obj_t BgL_auxz00_3639;
BgL_auxz00_3639 = 
CDR(BgL_slotz00_1863); 
BgL_valz00_1864 = 
CAR(BgL_auxz00_3639); } 
{ /* Jvm/compile.scm 137 */
bool_t BgL_testz00_3642;
{ /* Jvm/compile.scm 137 */
bool_t BgL_testz00_3643;
{ /* Jvm/compile.scm 137 */
obj_t BgL_auxz00_3646;obj_t BgL_auxz00_3644;
BgL_auxz00_3646 = 
CNST_TABLE_REF(((long)17)); 
BgL_auxz00_3644 = 
CAR(BgL_valz00_1864); 
BgL_testz00_3643 = 
(BgL_auxz00_3644==BgL_auxz00_3646); } 
if(BgL_testz00_3643)
{ /* Jvm/compile.scm 138 */
obj_t BgL_auxz00_3649;
{ /* Jvm/compile.scm 138 */
obj_t BgL_auxz00_3650;
BgL_auxz00_3650 = 
CDR(BgL_valz00_1864); 
BgL_auxz00_3649 = 
CAR(BgL_auxz00_3650); } 
BgL_testz00_3642 = 
(BgL_auxz00_3649==BgL_mez00_1858); }  else 
{ /* Jvm/compile.scm 137 */
BgL_testz00_3642 = ((bool_t)0)
; } } 
if(BgL_testz00_3642)
{ /* Jvm/compile.scm 139 */
obj_t BgL_auxz00_3654;
BgL_auxz00_3654 = 
CAR(BgL_slotz00_1863); 
BgL_rz00_1857 = 
MAKE_PAIR(BgL_auxz00_3654, BgL_rz00_1857); }  else 
{ /* Jvm/compile.scm 137 */BFALSE; } } } } 
{ 
obj_t BgL_l3066z00_3657;
BgL_l3066z00_3657 = 
CDR(BgL_l3066z00_1859); 
BgL_l3066z00_1859 = BgL_l3066z00_3657; 
goto BgL_lname3067z00_1860;} }  else 
{ /* Jvm/compile.scm 134 */((bool_t)1); } } 
return BgL_rz00_1857;} } 
}



/* compile-globalfun1 */
obj_t BGl_compilezd2globalfun1zd2zzjvm_compilez00(obj_t BgL_varz00_14, obj_t BgL_envz00_15)
{ AN_OBJECT;
{ /* Jvm/compile.scm 152 */
{ /* Jvm/compile.scm 154 */
BgL_valuez00_bglt BgL_instance3070z00_1874;
{ /* Jvm/compile.scm 155 */
BgL_globalz00_bglt BgL_obj1156z00_2498;
BgL_obj1156z00_2498 = 
(BgL_globalz00_bglt)(BgL_varz00_14); 
BgL_instance3070z00_1874 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1156z00_2498))->BgL_valuez00); } 
{ /* Jvm/compile.scm 155 */
BgL_envz00_bglt BgL_obj2976z00_2499;
BgL_obj2976z00_2499 = 
(BgL_envz00_bglt)(BgL_envz00_15); 
((((BgL_envz00_bglt)CREF(BgL_obj2976z00_2499))->BgL_currentzd2methodzd2) = ((obj_t)BgL_varz00_14), BUNSPEC); } 
{ /* Jvm/compile.scm 156 */
BgL_envz00_bglt BgL_obj2979z00_2501;obj_t BgL_val2978z00_2502;
BgL_obj2979z00_2501 = 
(BgL_envz00_bglt)(BgL_envz00_15); 
BgL_val2978z00_2502 = 
BINT(((long)0)); 
((((BgL_envz00_bglt)CREF(BgL_obj2979z00_2501))->BgL_vcountz00) = ((obj_t)BgL_val2978z00_2502), BUNSPEC); } 
{ /* Jvm/compile.scm 157 */
BgL_envz00_bglt BgL_obj2994z00_2503;
BgL_obj2994z00_2503 = 
(BgL_envz00_bglt)(BgL_envz00_15); 
((((BgL_envz00_bglt)CREF(BgL_obj2994z00_2503))->BgL_codez00) = ((obj_t)BNIL), BUNSPEC); } 
{ /* Jvm/compile.scm 158 */
BgL_envz00_bglt BgL_obj2982z00_2505;
BgL_obj2982z00_2505 = 
(BgL_envz00_bglt)(BgL_envz00_15); 
((((BgL_envz00_bglt)CREF(BgL_obj2982z00_2505))->BgL_localsz00) = ((obj_t)BNIL), BUNSPEC); } 
{ /* Jvm/compile.scm 159 */
BgL_envz00_bglt BgL_obj2985z00_2507;
BgL_obj2985z00_2507 = 
(BgL_envz00_bglt)(BgL_envz00_15); 
((((BgL_envz00_bglt)CREF(BgL_obj2985z00_2507))->BgL_freelocalsz00) = ((obj_t)BNIL), BUNSPEC); } 
{ /* Jvm/compile.scm 160 */
BgL_envz00_bglt BgL_obj2988z00_2509;
BgL_obj2988z00_2509 = 
(BgL_envz00_bglt)(BgL_envz00_15); 
((((BgL_envz00_bglt)CREF(BgL_obj2988z00_2509))->BgL_maplocalsz00) = ((obj_t)BNIL), BUNSPEC); } 
{ /* Jvm/compile.scm 161 */
BgL_envz00_bglt BgL_obj2991z00_2511;
BgL_obj2991z00_2511 = 
(BgL_envz00_bglt)(BgL_envz00_15); 
((((BgL_envz00_bglt)CREF(BgL_obj2991z00_2511))->BgL_stackz00) = ((obj_t)BNIL), BUNSPEC); } 
{ 
obj_t BgL_l3072z00_1875;
{ /* Jvm/compile.scm 162 */
BgL_sfunz00_bglt BgL_obj1370z00_2513;
BgL_obj1370z00_2513 = 
(BgL_sfunz00_bglt)(BgL_instance3070z00_1874); 
BgL_l3072z00_1875 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1370z00_2513))->BgL_argsz00); } 
BgL_lname3073z00_1876:
if(
PAIRP(BgL_l3072z00_1875))
{ /* Jvm/compile.scm 162 */
{ /* Jvm/compile.scm 164 */
obj_t BgL_az00_1879;
BgL_az00_1879 = 
CAR(BgL_l3072z00_1875); 
BGl_envzd2setzd2namez12z12zzjvm_envz00(
(BgL_envz00_bglt)(BgL_envz00_15), 
(BgL_localz00_bglt)(BgL_az00_1879), 
CNST_TABLE_REF(((long)36))); 
BGl_debugzd2declarezd2varzd2fromzd2zzjvm_externz00(
(BgL_envz00_bglt)(BgL_envz00_15), 
(BgL_localz00_bglt)(BgL_az00_1879), 
CNST_TABLE_REF(((long)37)), 
CNST_TABLE_REF(((long)38))); } 
{ 
obj_t BgL_l3072z00_3690;
BgL_l3072z00_3690 = 
CDR(BgL_l3072z00_1875); 
BgL_l3072z00_1875 = BgL_l3072z00_3690; 
goto BgL_lname3073z00_1876;} }  else 
{ /* Jvm/compile.scm 162 */((bool_t)1); } } 
{ /* Jvm/compile.scm 168 */
BgL_nodez00_bglt BgL_arg3781z00_1881;
{ /* Jvm/compile.scm 168 */
BgL_nodez00_bglt BgL_auxz00_3694;
{ /* Jvm/compile.scm 168 */
obj_t BgL_auxz00_3695;
{ /* Jvm/compile.scm 168 */
BgL_sfunz00_bglt BgL_obj1373z00_2517;
BgL_obj1373z00_2517 = 
(BgL_sfunz00_bglt)(BgL_instance3070z00_1874); 
BgL_auxz00_3695 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1373z00_2517))->BgL_bodyz00); } 
BgL_auxz00_3694 = 
(BgL_nodez00_bglt)(BgL_auxz00_3695); } 
BgL_arg3781z00_1881 = 
BGl_compilezd2compresszd2zzjvm_compressz00(BgL_auxz00_3694); } 
{ /* Jvm/compile.scm 168 */
BgL_sfunz00_bglt BgL_obj1375z00_2518;obj_t BgL_val1374z00_2519;
BgL_obj1375z00_2518 = 
(BgL_sfunz00_bglt)(BgL_instance3070z00_1874); 
BgL_val1374z00_2519 = 
(obj_t)(BgL_arg3781z00_1881); 
((((BgL_sfunz00_bglt)CREF(BgL_obj1375z00_2518))->BgL_bodyz00) = ((obj_t)BgL_val1374z00_2519), BUNSPEC); } } 
{ /* Jvm/compile.scm 169 */
BgL_nodez00_bglt BgL_auxz00_3703;
{ /* Jvm/compile.scm 169 */
obj_t BgL_auxz00_3704;
{ /* Jvm/compile.scm 169 */
BgL_sfunz00_bglt BgL_obj1373z00_2520;
BgL_obj1373z00_2520 = 
(BgL_sfunz00_bglt)(BgL_instance3070z00_1874); 
BgL_auxz00_3704 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1373z00_2520))->BgL_bodyz00); } 
BgL_auxz00_3703 = 
(BgL_nodez00_bglt)(BgL_auxz00_3704); } 
BGl_compilezd2preludezd2zzjvm_preludez00(BgL_auxz00_3703); } 
{ /* Jvm/compile.scm 170 */
BgL_nodez00_bglt BgL_auxz00_3709;
{ /* Jvm/compile.scm 170 */
obj_t BgL_auxz00_3710;
{ /* Jvm/compile.scm 170 */
BgL_sfunz00_bglt BgL_obj1373z00_2521;
BgL_obj1373z00_2521 = 
(BgL_sfunz00_bglt)(BgL_instance3070z00_1874); 
BgL_auxz00_3710 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1373z00_2521))->BgL_bodyz00); } 
BgL_auxz00_3709 = 
(BgL_nodez00_bglt)(BgL_auxz00_3710); } 
BGl_compilerzd2bodyzd2zzjvm_compilerz00(BgL_auxz00_3709, 
(BgL_envz00_bglt)(BgL_envz00_15)); } 
BGl__labelz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_15), 
CNST_TABLE_REF(((long)38))); 
{ /* Jvm/compile.scm 172 */
obj_t BgL_rtypez00_1885;
{ /* Jvm/compile.scm 172 */
obj_t BgL_auxz00_3719;
{ /* Jvm/compile.scm 172 */
BgL_typez00_bglt BgL_auxz00_3720;
{ /* Jvm/compile.scm 172 */
BgL_globalz00_bglt BgL_obj1153z00_2522;
BgL_obj1153z00_2522 = 
(BgL_globalz00_bglt)(BgL_varz00_14); 
BgL_auxz00_3720 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1153z00_2522))->BgL_typez00); } 
BgL_auxz00_3719 = 
(obj_t)(BgL_auxz00_3720); } 
BgL_rtypez00_1885 = 
BGl_compilezd2typezd2zzjvm_envz00(BgL_auxz00_3719, 
(BgL_envz00_bglt)(BgL_envz00_15)); } 
if(
CBOOL(BGl_za2jvmzd2purifyza2zd2zzengine_paramz00))
{ /* Jvm/compile.scm 173 */
BGl__checkcastz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_15), BgL_rtypez00_1885); }  else 
{ /* Jvm/compile.scm 173 */BFALSE; } 
BGl__returnz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_15), BgL_rtypez00_1885); } 
{ /* Jvm/compile.scm 175 */
bool_t BgL_testz00_3732;
{ /* Jvm/compile.scm 175 */
obj_t BgL_auxz00_3733;
{ /* Jvm/compile.scm 175 */
BgL_envz00_bglt BgL_obj2989z00_2523;
BgL_obj2989z00_2523 = 
(BgL_envz00_bglt)(BgL_envz00_15); 
BgL_auxz00_3733 = 
(((BgL_envz00_bglt)CREF(BgL_obj2989z00_2523))->BgL_stackz00); } 
BgL_testz00_3732 = 
NULLP(BgL_auxz00_3733); } 
if(BgL_testz00_3732)
{ /* Jvm/compile.scm 175 */((bool_t)0); }  else 
{ /* Jvm/compile.scm 175 */
{ /* Jvm/compile.scm 177 */
obj_t BgL_auxz00_3737;
{ /* Jvm/compile.scm 177 */
obj_t BgL_auxz00_3738;
{ /* Jvm/compile.scm 177 */
BgL_envz00_bglt BgL_obj2992z00_2525;
BgL_obj2992z00_2525 = 
(BgL_envz00_bglt)(BgL_envz00_15); 
BgL_auxz00_3738 = 
(((BgL_envz00_bglt)CREF(BgL_obj2992z00_2525))->BgL_codez00); } 
BgL_auxz00_3737 = 
bgl_reverse(BgL_auxz00_3738); } 
BGl_ppz00zz__ppz00(BgL_auxz00_3737, BNIL); } 
{ 
obj_t BgL_auxz00_3743;
{ /* Jvm/compile.scm 178 */
BgL_envz00_bglt BgL_obj2989z00_2526;
BgL_obj2989z00_2526 = 
(BgL_envz00_bglt)(BgL_envz00_15); 
BgL_auxz00_3743 = 
(((BgL_envz00_bglt)CREF(BgL_obj2989z00_2526))->BgL_stackz00); } 
FAILURE(BGl_string4485z00zzjvm_compilez00,BGl_string4486z00zzjvm_compilez00,BgL_auxz00_3743);} } } 
{ /* Jvm/compile.scm 182 */
obj_t BgL_arg3822z00_1895;obj_t BgL_arg3823z00_1896;
BgL_arg3822z00_1895 = 
CNST_TABLE_REF(((long)4)); 
{ /* Jvm/compile.scm 182 */
obj_t BgL_arg3826z00_1897;obj_t BgL_arg3827z00_1898;
BgL_arg3826z00_1897 = 
BGl_getzd2globalzd2namez00zzjvm_envz00(
(BgL_envz00_bglt)(BgL_envz00_15), 
(BgL_globalz00_bglt)(BgL_varz00_14)); 
{ /* Jvm/compile.scm 183 */
obj_t BgL_arg3831z00_1899;obj_t BgL_arg3832z00_1900;
{ /* Jvm/compile.scm 183 */
obj_t BgL_auxz00_3751;
{ /* Jvm/compile.scm 183 */
BgL_sfunz00_bglt BgL_obj1370z00_2530;
BgL_obj1370z00_2530 = 
(BgL_sfunz00_bglt)(BgL_instance3070z00_1874); 
BgL_auxz00_3751 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1370z00_2530))->BgL_argsz00); } 
BgL_arg3831z00_1899 = 
BGl_compilezd2formalszd2zzjvm_compilez00(BgL_auxz00_3751, BgL_envz00_15); } 
{ /* Jvm/compile.scm 184 */
obj_t BgL_arg3839z00_1902;obj_t BgL_arg3840z00_1903;
{ /* Jvm/compile.scm 184 */
obj_t BgL_arg3843z00_1904;obj_t BgL_arg3844z00_1905;
BgL_arg3843z00_1904 = 
CNST_TABLE_REF(((long)39)); 
{ /* Jvm/compile.scm 184 */
obj_t BgL_arg3847z00_1906;obj_t BgL_arg3848z00_1907;
BgL_arg3847z00_1906 = 
CNST_TABLE_REF(((long)40)); 
{ /* Jvm/compile.scm 184 */
obj_t BgL_arg3851z00_1908;
{ /* Jvm/compile.scm 184 */
obj_t BgL_auxz00_3757;
{ /* Jvm/compile.scm 184 */
BgL_envz00_bglt BgL_obj2980z00_2531;
BgL_obj2980z00_2531 = 
(BgL_envz00_bglt)(BgL_envz00_15); 
BgL_auxz00_3757 = 
(((BgL_envz00_bglt)CREF(BgL_obj2980z00_2531))->BgL_localsz00); } 
BgL_arg3851z00_1908 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_auxz00_3757); } 
BgL_arg3848z00_1907 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg3851z00_1908, BNIL); } 
BgL_arg3844z00_1905 = 
MAKE_PAIR(BgL_arg3847z00_1906, BgL_arg3848z00_1907); } 
BgL_arg3839z00_1902 = 
MAKE_PAIR(BgL_arg3843z00_1904, BgL_arg3844z00_1905); } 
{ /* Jvm/compile.scm 185 */
obj_t BgL_arg3859z00_1911;
{ /* Jvm/compile.scm 185 */
obj_t BgL_auxz00_3764;
{ /* Jvm/compile.scm 185 */
BgL_envz00_bglt BgL_obj2992z00_2532;
BgL_obj2992z00_2532 = 
(BgL_envz00_bglt)(BgL_envz00_15); 
BgL_auxz00_3764 = 
(((BgL_envz00_bglt)CREF(BgL_obj2992z00_2532))->BgL_codez00); } 
BgL_arg3859z00_1911 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_auxz00_3764); } 
BgL_arg3840z00_1903 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg3859z00_1911, BNIL); } 
BgL_arg3832z00_1900 = 
MAKE_PAIR(BgL_arg3839z00_1902, BgL_arg3840z00_1903); } 
BgL_arg3827z00_1898 = 
MAKE_PAIR(BgL_arg3831z00_1899, BgL_arg3832z00_1900); } 
BgL_arg3823z00_1896 = 
MAKE_PAIR(BgL_arg3826z00_1897, BgL_arg3827z00_1898); } 
return 
MAKE_PAIR(BgL_arg3822z00_1895, BgL_arg3823z00_1896);} } } 
}



/* compile-formals */
obj_t BGl_compilezd2formalszd2zzjvm_compilez00(obj_t BgL_lz00_16, obj_t BgL_envz00_17)
{ AN_OBJECT;
{ /* Jvm/compile.scm 187 */
if(
NULLP(BgL_lz00_16))
{ /* Jvm/compile.scm 188 */
return BgL_lz00_16;}  else 
{ /* Jvm/compile.scm 190 */
obj_t BgL_vz00_1915;obj_t BgL_restz00_1916;
BgL_vz00_1915 = 
CAR(BgL_lz00_16); 
BgL_restz00_1916 = 
BGl_compilezd2formalszd2zzjvm_compilez00(
CDR(BgL_lz00_16), BgL_envz00_17); 
{ /* Jvm/compile.scm 191 */
obj_t BgL_typez00_1917;obj_t BgL_namez00_1918;
BgL_typez00_1917 = 
BGl_compilezd2typezd2zzjvm_envz00(BgL_vz00_1915, 
(BgL_envz00_bglt)(BgL_envz00_17)); 
{ /* Jvm/compile.scm 191 */
BgL_localz00_bglt BgL_obj1250z00_2536;
BgL_obj1250z00_2536 = 
(BgL_localz00_bglt)(BgL_vz00_1915); 
BgL_namez00_1918 = 
(((BgL_localz00_bglt)CREF(BgL_obj1250z00_2536))->BgL_namez00); } 
{ /* Jvm/compile.scm 192 */
bool_t BgL_testz00_3782;
{ /* Jvm/compile.scm 192 */
obj_t BgL_auxz00_3783;
BgL_auxz00_3783 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_typez00_1917, 
CNST_TABLE_REF(((long)41))); 
BgL_testz00_3782 = 
CBOOL(BgL_auxz00_3783); } 
if(BgL_testz00_3782)
{ /* Jvm/compile.scm 193 */
obj_t BgL_arg3870z00_1920;
{ /* Jvm/compile.scm 193 */
obj_t BgL_auxz00_3787;
BgL_auxz00_3787 = 
CNST_TABLE_REF(((long)42)); 
BgL_arg3870z00_1920 = 
MAKE_PAIR(BgL_auxz00_3787, BgL_restz00_1916); } 
return 
MAKE_PAIR(BgL_namez00_1918, BgL_arg3870z00_1920);}  else 
{ /* Jvm/compile.scm 192 */
return 
MAKE_PAIR(BgL_namez00_1918, BgL_restz00_1916);} } } } } 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzjvm_compilez00()
{ AN_OBJECT;
{ /* Jvm/compile.scm 1 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzjvm_compilez00()
{ AN_OBJECT;
{ /* Jvm/compile.scm 1 */
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19010), "jvm_compile"); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)28259), "jvm_compile"); 
BGl_modulezd2initializa7ationz75zzast_nodez00(((long)49436), "jvm_compile"); 
BGl_modulezd2initializa7ationz75zzengine_paramz00(((long)189840), "jvm_compile"); 
BGl_modulezd2initializa7ationz75zzobject_classz00(((long)19348), "jvm_compile"); 
BGl_modulezd2initializa7ationz75zzobject_slotsz00(((long)83931), "jvm_compile"); 
BGl_modulezd2initializa7ationz75zzast_envz00(((long)73271), "jvm_compile"); 
BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long)12859), "jvm_compile"); 
BGl_modulezd2initializa7ationz75zzjvm_externz00(((long)54304), "jvm_compile"); 
BGl_modulezd2initializa7ationz75zzjvm_envz00(((long)47084), "jvm_compile"); 
BGl_modulezd2initializa7ationz75zzjvm_instrz00(((long)9877), "jvm_compile"); 
BGl_modulezd2initializa7ationz75zzjvm_exprz00(((long)25448), "jvm_compile"); 
BGl_modulezd2initializa7ationz75zzjvm_compilerz00(((long)63858), "jvm_compile"); 
BGl_modulezd2initializa7ationz75zzjvm_initz00(((long)48164), "jvm_compile"); 
BGl_modulezd2initializa7ationz75zzjvm_constrz00(((long)26095), "jvm_compile"); 
BGl_modulezd2initializa7ationz75zzjvm_closurez00(((long)30597), "jvm_compile"); 
BGl_modulezd2initializa7ationz75zzjvm_preludez00(((long)43252), "jvm_compile"); 
BGl_modulezd2initializa7ationz75zzjvm_peepholez00(((long)1133), "jvm_compile"); 
BGl_modulezd2initializa7ationz75zzjvm_compressz00(((long)55131), "jvm_compile"); 
return 
BGl_modulezd2initializa7ationz75zzjvm_lispz00(((long)19887), "jvm_compile");} 
}

