/*===========================================================================*/
/*   (Jvm/jdump.scm)                                                         */
/*   Bigloo (2.5b)                                                           */
/*   Manuel Serrano (c)       Fri Sep 6 09:43:28 CEST 2002                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_nodez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
} *BgL_nodez00_bglt;

typedef struct BgL_nodezf2effectzf2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
} *BgL_nodezf2effectzf2_bglt;

typedef struct BgL_atomz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_atomz00_bglt;

typedef struct BgL_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_varz00_bglt;

typedef struct BgL_closurez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_closurez00_bglt;

typedef struct BgL_kwotez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_kwotez00_bglt;

typedef struct BgL_sequencez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_nodesz00;
} *BgL_sequencez00_bglt;

typedef struct BgL_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
} *BgL_appz00_bglt;

typedef struct BgL_appzd2lyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_appzd2lyzd2_bglt;

typedef struct BgL_funcallz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_strengthz00;
} *BgL_funcallz00_bglt;

typedef struct BgL_externz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_externz00_bglt;

typedef struct BgL_pragmaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_formatz00;
} *BgL_pragmaz00_bglt;

typedef struct BgL_getfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_getfieldz00_bglt;

typedef struct BgL_setfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_setfieldz00_bglt;

typedef struct BgL_newz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_newz00_bglt;

typedef struct BgL_vallocz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2heapzd2formatz00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_vallocz00_bglt;

typedef struct BgL_vrefz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vrefz00_bglt;

typedef struct BgL_vsetz12z12_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vsetz12z12_bglt;

typedef struct BgL_vlengthz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vlengthz00_bglt;

typedef struct BgL_isaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   struct BgL_typez00_bgl * BgL_classz00;
} *BgL_isaz00_bglt;

typedef struct BgL_castz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_castz00_bglt;

typedef struct BgL_setqz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_setqz00_bglt;

typedef struct BgL_conditionalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   struct BgL_nodez00_bgl * BgL_truez00;
   struct BgL_nodez00_bgl * BgL_falsez00;
} *BgL_conditionalz00_bglt;

typedef struct BgL_failz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_procz00;
   struct BgL_nodez00_bgl * BgL_msgz00;
   struct BgL_nodez00_bgl * BgL_objz00;
} *BgL_failz00_bglt;

typedef struct BgL_selectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   obj_t BgL_clausesz00;
   struct BgL_typez00_bgl * BgL_itemzd2typezd2;
} *BgL_selectz00_bglt;

typedef struct BgL_letzd2funzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_localsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_letzd2funzd2_bglt;

typedef struct BgL_letzd2varzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_bindingsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
   bool_t BgL_removablezf3zf3;
} *BgL_letzd2varzd2_bglt;

typedef struct BgL_setzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_setzd2exzd2itz00_bglt;

typedef struct BgL_jumpzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_exitz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_jumpzd2exzd2itz00_bglt;

typedef struct BgL_makezd2boxzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_makezd2boxzd2_bglt;

typedef struct BgL_boxzd2refzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_varz00;
} *BgL_boxzd2refzd2_bglt;

typedef struct BgL_boxzd2setz12zc0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_boxzd2setz12zc0_bglt;

typedef struct BgL_tclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   struct BgL_globalz00_bgl * BgL_holderz00;
   obj_t BgL_wideningz00;
   long BgL_depthz00;
   bool_t BgL_finalzf3zf3;
   obj_t BgL_constructorz00;
   obj_t BgL_virtualzd2slotszd2numberz00;
   bool_t BgL_abstractzf3zf3;
} *BgL_tclassz00_bglt;

typedef struct BgL_jclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   obj_t BgL_packagez00;
} *BgL_jclassz00_bglt;

typedef struct BgL_ccompz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_producerz00;
   obj_t BgL_consumerz00;
   obj_t BgL_finaliza7erza7;
} *BgL_ccompz00_bglt;


extern obj_t BGl_openzd2outputzd2binaryzd2filezd2zz__binaryz00(obj_t);
static obj_t BGl_jvmzd2dirnamezd2zzjvm_jdumpz00(obj_t);
static obj_t BGl_methodzd2initzd2zzjvm_jdumpz00();
extern obj_t open_input_string(obj_t);
extern obj_t BGl_za2srczd2filesza2zd2zzengine_paramz00;
extern obj_t BGl_makezd2filezd2namez00zz__osz00(obj_t, obj_t);
static obj_t BGl_jvmzd2checkzd2packagez00zzjvm_jdumpz00(obj_t, obj_t);
extern obj_t BGl_ppz00zz__ppz00(obj_t, obj_t);
extern obj_t BGl_readz00zz__readerz00(obj_t);
static obj_t BGl_addsuffixz00zzjvm_jdumpz00(obj_t);
extern bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
extern obj_t BGl_za2moduleza2z00zzmodule_modulez00;
extern obj_t string_to_bstring(char *);
extern obj_t BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00(obj_t);
extern bool_t directoryp(char *);
static obj_t BGl_cnstzd2initzd2zzjvm_jdumpz00();
extern obj_t BGl_basenamez00zz__osz00(obj_t);
extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
static obj_t BGl_importedzd2moduleszd2initz00zzjvm_jdumpz00();
static obj_t BGl__jvmzd2dump3691zd2zzjvm_jdumpz00(obj_t, obj_t);
extern obj_t BGl_za2ppzd2widthza2zd2zz__ppz00;
static obj_t BGl_toplevelzd2initzd2zzjvm_jdumpz00();
extern obj_t string_append_3(obj_t, obj_t, obj_t);
extern bool_t BGl_2zc3zc3zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_jdumpz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_typeofz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_compilez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjas_asz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzread_jvmz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzcgen_mainz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzcgen_prototypez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__binaryz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
extern obj_t close_output_port(obj_t);
extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
extern obj_t BGl_makezd2bigloozd2mainz00zzcgen_mainz00();
static obj_t BGl_emitz00zzjvm_jdumpz00(obj_t, obj_t);
static obj_t BGl_jvmzd2filenamezd2zzjvm_jdumpz00(obj_t);
extern obj_t string_append(obj_t, obj_t);
extern obj_t BGl_jvmzd2dumpzd2zzjvm_jdumpz00(obj_t);
extern bool_t BGl_makezd2directorieszd2zz__r4_ports_6_10_1z00(obj_t);
extern obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
extern obj_t BGl_jvmzd2aszd2zzjas_asz00(obj_t, obj_t);
extern obj_t BGl_closezd2binaryzd2portz00zz__binaryz00(obj_t);
extern obj_t BGl_za2mainza2z00zzmodule_modulez00;
extern obj_t BGl_za2destza2z00zzengine_paramz00;
static obj_t BGl__startzd2jvmzd2emissionz12z12zzjvm_jdumpz00(obj_t);
static obj_t BGl_startzd2jvmzd2emissionz12z12zzjvm_jdumpz00();
extern obj_t BGl_za2passza2z00zzengine_paramz00;
extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
extern obj_t open_output_file(obj_t);
extern bool_t bigloo_strcmp(obj_t, obj_t);
static obj_t BGl_jasnamez00zzjvm_jdumpz00(obj_t);
extern obj_t BGl_dirnamez00zz__osz00(obj_t);
extern bool_t fexists(char *);
extern obj_t BGl_warningz00zz__errorz00(obj_t);
static obj_t BGl_requirezd2initializa7ationz75zzjvm_jdumpz00 = BUNSPEC;
extern obj_t BGl_za2jvmzd2directoryza2zd2zzengine_paramz00;
extern obj_t BGl_za2ppzd2caseza2zd2zz__ppz00;
extern obj_t BGl_prefixz00zz__osz00(obj_t);
static obj_t BGl_jvmasdumpz00zzjvm_jdumpz00(obj_t, obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zzjvm_jdumpz00();
static obj_t BGl_za2jvmzd2dirzd2nameza2z00zzjvm_jdumpz00 = BUNSPEC;
extern obj_t BGl_jvmzd2compilezd2zzjvm_compilez00(obj_t);
static obj_t __cnst[ 8 ] ;

DEFINE_EXPORT_PROCEDURE( BGl_jvmzd2dumpzd2envz00zzjvm_jdumpz00, BgL_bgl__jvmza7d2dump3691za7d2za7za7jvm_jdumpza7003810za7, BGl__jvmzd2dump3691zd2zzjvm_jdumpz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_startzd2jvmzd2emissionz12zd2envzc0zzjvm_jdumpz00, BgL_bgl__startza7d2jvmza7d2emissionza712za712za7za7jvm_jdumpza7003811za7, BGl__startzd2jvmzd2emissionz12z12zzjvm_jdumpz00, 0L, 0 );
DEFINE_STRING( BGl_string3777z00zzjvm_jdumpz00, BgL_bgl_string3777za700za7za7jvm_jdumpza7003812z00, "class jast lower jvmas ld (ld distrib) (start-jvm-emission!) pass-started ", 74 );
DEFINE_STRING( BGl_string3776z00zzjvm_jdumpz00, BgL_bgl_string3776za700za7za7jvm_jdumpza7003813z00, "Can't write dest file because directory doesn't exist", 53 );
DEFINE_STRING( BGl_string3775z00zzjvm_jdumpz00, BgL_bgl_string3775za700za7za7jvm_jdumpza7003814z00, "start-jvm-emission!", 19 );
DEFINE_STRING( BGl_string3774z00zzjvm_jdumpz00, BgL_bgl_string3774za700za7za7jvm_jdumpza7003815z00, "Incompatible package name and class path.", 41 );
DEFINE_STRING( BGl_string3773z00zzjvm_jdumpz00, BgL_bgl_string3773za700za7za7jvm_jdumpza7003816z00, "Package name for module ", 24 );
DEFINE_STRING( BGl_string3772z00zzjvm_jdumpz00, BgL_bgl_string3772za700za7za7jvm_jdumpza7003817z00, " is `", 5 );
DEFINE_STRING( BGl_string3771z00zzjvm_jdumpz00, BgL_bgl_string3771za700za7za7jvm_jdumpza7003818z00, "', class path is `", 18 );
DEFINE_STRING( BGl_string3770z00zzjvm_jdumpz00, BgL_bgl_string3770za700za7za7jvm_jdumpza7003819z00, "'.", 2 );
DEFINE_STRING( BGl_string3769z00zzjvm_jdumpz00, BgL_bgl_string3769za700za7za7jvm_jdumpza7003820z00, "", 0 );
DEFINE_STRING( BGl_string3768z00zzjvm_jdumpz00, BgL_bgl_string3768za700za7za7jvm_jdumpza7003821z00, "Can't open file for output", 26 );
DEFINE_STRING( BGl_string3767z00zzjvm_jdumpz00, BgL_bgl_string3767za700za7za7jvm_jdumpza7003822z00, "jvm-dump", 8 );
DEFINE_STRING( BGl_string3766z00zzjvm_jdumpz00, BgL_bgl_string3766za700za7za7jvm_jdumpza7003823z00, "/a.class", 8 );
DEFINE_STRING( BGl_string3765z00zzjvm_jdumpz00, BgL_bgl_string3765za700za7za7jvm_jdumpza7003824z00, "/", 1 );
DEFINE_STRING( BGl_string3764z00zzjvm_jdumpz00, BgL_bgl_string3764za700za7za7jvm_jdumpza7003825z00, "a.class", 7 );
DEFINE_STRING( BGl_string3763z00zzjvm_jdumpz00, BgL_bgl_string3763za700za7za7jvm_jdumpza7003826z00, "      [module: ", 15 );
DEFINE_STRING( BGl_string3762z00zzjvm_jdumpz00, BgL_bgl_string3762za700za7za7jvm_jdumpza7003827z00, " qualified type name: ", 22 );
DEFINE_STRING( BGl_string3761z00zzjvm_jdumpz00, BgL_bgl_string3761za700za7za7jvm_jdumpza7003828z00, "]", 1 );
DEFINE_STRING( BGl_string3760z00zzjvm_jdumpz00, BgL_bgl_string3760za700za7za7jvm_jdumpza7003829z00, "failure during prelude hook", 27 );
DEFINE_STRING( BGl_string3759z00zzjvm_jdumpz00, BgL_bgl_string3759za700za7za7jvm_jdumpza7003830z00, "   . ", 5 );
DEFINE_STRING( BGl_string3758z00zzjvm_jdumpz00, BgL_bgl_string3758za700za7za7jvm_jdumpza7003831z00, "Jvm", 3 );
DEFINE_STRING( BGl_string3757z00zzjvm_jdumpz00, BgL_bgl_string3757za700za7za7jvm_jdumpza7003832z00, ".", 1 );



/* module-initialization */
obj_t BGl_modulezd2initializa7ationz75zzjvm_jdumpz00(long BgL_checksumz00_2679, char * BgL_fromz00_2680)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzjvm_jdumpz00))
{ 
BGl_requirezd2initializa7ationz75zzjvm_jdumpz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzjvm_jdumpz00(); 
BGl_cnstzd2initzd2zzjvm_jdumpz00(); 
BGl_importedzd2moduleszd2initz00zzjvm_jdumpz00(); 
BGl_toplevelzd2initzd2zzjvm_jdumpz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzjvm_jdumpz00()
{ AN_OBJECT;
{ /* Jvm/jdump.scm 71 */
BGl_modulezd2initializa7ationz75zz__binaryz00(((long)0), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)0), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zz__ppz00(((long)0), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "jvm_jdump"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzjvm_jdumpz00()
{ AN_OBJECT;
{ /* Jvm/jdump.scm 71 */
{ /* Jvm/jdump.scm 71 */
obj_t BgL_cportz00_2672;
BgL_cportz00_2672 = 
open_input_string(BGl_string3777z00zzjvm_jdumpz00); 
{ 
long BgL_iz00_2673;
BgL_iz00_2673 = ((long)7); 
BgL_loopz00_2674:
if(
(BgL_iz00_2673==((long)-1)))
{ /* Jvm/jdump.scm 71 */
return BUNSPEC;}  else 
{ /* Jvm/jdump.scm 71 */
{ /* Jvm/jdump.scm 71 */
obj_t BgL_arg3781z00_2676;
{ /* Jvm/jdump.scm 71 */
obj_t BgL_list3784z00_2677;
BgL_list3784z00_2677 = 
MAKE_PAIR(BgL_cportz00_2672, BNIL); 
BgL_arg3781z00_2676 = 
BGl_readz00zz__readerz00(BgL_list3784z00_2677); } 
{ /* Jvm/jdump.scm 71 */
int BgL_auxz00_2702;
BgL_auxz00_2702 = 
(int)(BgL_iz00_2673); 
CNST_TABLE_SET(BgL_auxz00_2702, BgL_arg3781z00_2676); } } 
{ 
long BgL_iz00_2705;
{ /* Jvm/jdump.scm 71 */
int BgL_auxz00_2706;
{ /* Jvm/jdump.scm 71 */
long BgL_auxz00_2707;
BgL_auxz00_2707 = 
(BgL_iz00_2673-((long)1)); 
BgL_auxz00_2706 = 
(int)(BgL_auxz00_2707); } 
BgL_iz00_2705 = 
(long)(BgL_auxz00_2706); } 
BgL_iz00_2673 = BgL_iz00_2705; 
goto BgL_loopz00_2674;} } } } } 
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zzjvm_jdumpz00()
{ AN_OBJECT;
{ /* Jvm/jdump.scm 71 */
return ( 
BGl_za2jvmzd2dirzd2nameza2z00zzjvm_jdumpz00 = BGl_string3757z00zzjvm_jdumpz00, BUNSPEC) ;} 
}



/* jvm-dump */
obj_t BGl_jvmzd2dumpzd2zzjvm_jdumpz00(obj_t BgL_globalsz00_19)
{ AN_OBJECT;
{ /* Jvm/jdump.scm 96 */
{ /* Jvm/jdump.scm 98 */
obj_t BgL_list2920z00_1444;
{ /* Jvm/jdump.scm 98 */
obj_t BgL_arg2923z00_1446;
{ /* Jvm/jdump.scm 98 */
obj_t BgL_arg2927z00_1448;
{ /* Jvm/jdump.scm 98 */
obj_t BgL_auxz00_2711;
BgL_auxz00_2711 = 
BCHAR(((unsigned char)'\n')); 
BgL_arg2927z00_1448 = 
MAKE_PAIR(BgL_auxz00_2711, BNIL); } 
BgL_arg2923z00_1446 = 
MAKE_PAIR(BGl_string3758z00zzjvm_jdumpz00, BgL_arg2927z00_1448); } 
BgL_list2920z00_1444 = 
MAKE_PAIR(BGl_string3759z00zzjvm_jdumpz00, BgL_arg2923z00_1446); } 
BGl_verbosez00zztools_speekz00(
BINT(((long)1)), BgL_list2920z00_1444); } 
BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 = 
BINT(((long)0)); 
BGl_za2currentzd2passza2zd2zzengine_passz00 = BGl_string3758z00zzjvm_jdumpz00; 
{ 
obj_t BgL_hooksz00_1449;obj_t BgL_hnamesz00_1450;
{ /* Jvm/jdump.scm 98 */
obj_t BgL_arg2931z00_1452;obj_t BgL_arg2932z00_1453;
{ /* Jvm/jdump.scm 98 */
obj_t BgL_list2935z00_1454;
BgL_list2935z00_1454 = 
MAKE_PAIR(BGl_startzd2jvmzd2emissionz12zd2envzc0zzjvm_jdumpz00, BNIL); 
BgL_arg2931z00_1452 = BgL_list2935z00_1454; } 
BgL_arg2932z00_1453 = 
CNST_TABLE_REF(((long)1)); 
BgL_hooksz00_1449 = BgL_arg2931z00_1452; 
BgL_hnamesz00_1450 = BgL_arg2932z00_1453; 
BgL_loopz00_1451:
if(
NULLP(BgL_hooksz00_1449))
{ /* Jvm/jdump.scm 98 */
CNST_TABLE_REF(((long)0)); }  else 
{ /* Jvm/jdump.scm 98 */
bool_t BgL_test2938z00_1456;
{ /* Jvm/jdump.scm 98 */
obj_t BgL_fun2953z00_1462;
BgL_fun2953z00_1462 = 
CAR(BgL_hooksz00_1449); 
{ /* Jvm/jdump.scm 98 */
obj_t BgL_auxz00_2725;
BgL_auxz00_2725 = 
PROCEDURE_ENTRY(BgL_fun2953z00_1462)(BgL_fun2953z00_1462, BEOA); 
BgL_test2938z00_1456 = 
CBOOL(BgL_auxz00_2725); } } 
if(BgL_test2938z00_1456)
{ /* Jvm/jdump.scm 98 */
{ 
obj_t BgL_hnamesz00_2732;obj_t BgL_hooksz00_2730;
BgL_hooksz00_2730 = 
CDR(BgL_hooksz00_1449); 
BgL_hnamesz00_2732 = 
CDR(BgL_hnamesz00_1450); 
BgL_hnamesz00_1450 = BgL_hnamesz00_2732; 
BgL_hooksz00_1449 = BgL_hooksz00_2730; 
goto BgL_loopz00_1451;} }  else 
{ /* Jvm/jdump.scm 98 */
BGl_internalzd2errorzd2zztools_errorz00(BGl_string3758z00zzjvm_jdumpz00, BGl_string3760z00zzjvm_jdumpz00, 
CAR(BgL_hnamesz00_1450)); } } } } 
{ /* Jvm/jdump.scm 99 */
obj_t BgL_arg2960z00_1466;
BgL_arg2960z00_1466 = 
BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00(BGl_za2moduleza2z00zzmodule_modulez00); 
{ /* Jvm/jdump.scm 99 */
obj_t BgL_list2963z00_1468;
{ /* Jvm/jdump.scm 99 */
obj_t BgL_arg2965z00_1469;
{ /* Jvm/jdump.scm 99 */
obj_t BgL_arg2968z00_1470;
{ /* Jvm/jdump.scm 99 */
obj_t BgL_arg2971z00_1471;
{ /* Jvm/jdump.scm 99 */
obj_t BgL_arg2974z00_1472;
{ /* Jvm/jdump.scm 99 */
obj_t BgL_arg2977z00_1473;
{ /* Jvm/jdump.scm 99 */
obj_t BgL_auxz00_2737;
BgL_auxz00_2737 = 
BCHAR(((unsigned char)'\n')); 
BgL_arg2977z00_1473 = 
MAKE_PAIR(BgL_auxz00_2737, BNIL); } 
BgL_arg2974z00_1472 = 
MAKE_PAIR(BGl_string3761z00zzjvm_jdumpz00, BgL_arg2977z00_1473); } 
BgL_arg2971z00_1471 = 
MAKE_PAIR(BgL_arg2960z00_1466, BgL_arg2974z00_1472); } 
BgL_arg2968z00_1470 = 
MAKE_PAIR(BGl_string3762z00zzjvm_jdumpz00, BgL_arg2971z00_1471); } 
BgL_arg2965z00_1469 = 
MAKE_PAIR(BGl_za2moduleza2z00zzmodule_modulez00, BgL_arg2968z00_1470); } 
BgL_list2963z00_1468 = 
MAKE_PAIR(BGl_string3763z00zzjvm_jdumpz00, BgL_arg2965z00_1469); } 
BGl_verbosez00zztools_speekz00(
BINT(((long)2)), BgL_list2963z00_1468); } } 
{ /* Jvm/jdump.scm 103 */
bool_t BgL_test2981z00_1474;
if(
CBOOL(BGl_za2mainza2z00zzmodule_modulez00))
{ /* Jvm/jdump.scm 103 */
BgL_test2981z00_1474 = ((bool_t)0); }  else 
{ /* Jvm/jdump.scm 103 */
obj_t BgL_auxz00_2749;
BgL_auxz00_2749 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BGl_za2passza2z00zzengine_paramz00, 
CNST_TABLE_REF(((long)2))); 
BgL_test2981z00_1474 = 
CBOOL(BgL_auxz00_2749); } 
if(BgL_test2981z00_1474)
{ /* Jvm/jdump.scm 103 */
BGl_za2mainza2z00zzmodule_modulez00 = 
BGl_makezd2bigloozd2mainz00zzcgen_mainz00(); }  else 
{ /* Jvm/jdump.scm 103 */BFALSE; } } 
BGl_jvmzd2checkzd2packagez00zzjvm_jdumpz00(BGl_za2moduleza2z00zzmodule_modulez00, BGl_za2jvmzd2dirzd2nameza2z00zzjvm_jdumpz00); 
{ /* Jvm/jdump.scm 125 */
obj_t BgL_lza2za2_1475;obj_t BgL_bnamez00_1476;
BgL_lza2za2_1475 = 
BGl_jvmzd2compilezd2zzjvm_compilez00(BgL_globalsz00_19); 
{ /* Jvm/jdump.scm 127 */
bool_t BgL_test3005z00_1485;
{ /* Jvm/jdump.scm 127 */
obj_t BgL_auxz00_2757;
BgL_auxz00_2757 = 
CNST_TABLE_REF(((long)3)); 
BgL_test3005z00_1485 = 
(BGl_za2passza2z00zzengine_paramz00==BgL_auxz00_2757); } 
if(BgL_test3005z00_1485)
{ /* Jvm/jdump.scm 127 */
{ /* Jvm/jdump.scm 128 */
bool_t BgL_test3006z00_1486;
{ /* Jvm/jdump.scm 128 */
obj_t BgL_objz00_2031;
BgL_objz00_2031 = BGl_za2srczd2filesza2zd2zzengine_paramz00; 
BgL_test3006z00_1486 = 
PAIRP(BgL_objz00_2031); } 
if(BgL_test3006z00_1486)
{ /* Jvm/jdump.scm 129 */
obj_t BgL_arg3008z00_1487;
{ /* Jvm/jdump.scm 129 */
obj_t BgL_arg3011z00_1488;
{ /* Jvm/jdump.scm 129 */
obj_t BgL_arg3014z00_1489;
{ /* Jvm/jdump.scm 129 */
obj_t BgL_pairz00_2032;
BgL_pairz00_2032 = BGl_za2srczd2filesza2zd2zzengine_paramz00; 
BgL_arg3014z00_1489 = 
CAR(BgL_pairz00_2032); } 
BgL_arg3011z00_1488 = 
BGl_basenamez00zz__osz00(BgL_arg3014z00_1489); } 
BgL_arg3008z00_1487 = 
BGl_prefixz00zz__osz00(BgL_arg3011z00_1488); } 
BgL_bnamez00_1476 = 
BGl_addsuffixz00zzjvm_jdumpz00(BgL_arg3008z00_1487); }  else 
{ /* Jvm/jdump.scm 128 */
BgL_bnamez00_1476 = BGl_string3764z00zzjvm_jdumpz00; } } }  else 
{ /* Jvm/jdump.scm 131 */
bool_t BgL_test3018z00_1490;
{ /* Jvm/jdump.scm 131 */
obj_t BgL_objz00_2033;
BgL_objz00_2033 = BGl_za2destza2z00zzengine_paramz00; 
BgL_test3018z00_1490 = 
STRINGP(BgL_objz00_2033); } 
if(BgL_test3018z00_1490)
{ /* Jvm/jdump.scm 131 */
{ /* Jvm/jdump.scm 136 */
obj_t BgL_arg3020z00_1491;
{ /* Jvm/jdump.scm 136 */
obj_t BgL_arg3023z00_1492;
BgL_arg3023z00_1492 = 
BGl_basenamez00zz__osz00(BGl_za2destza2z00zzengine_paramz00); 
BgL_arg3020z00_1491 = 
BGl_prefixz00zz__osz00(BgL_arg3023z00_1492); } 
BgL_bnamez00_1476 = 
BGl_addsuffixz00zzjvm_jdumpz00(BgL_arg3020z00_1491); } }  else 
{ /* Jvm/jdump.scm 131 */
{ /* Jvm/jdump.scm 132 */
bool_t BgL_test3026z00_1493;
{ /* Jvm/jdump.scm 132 */
obj_t BgL_objz00_2034;
BgL_objz00_2034 = BGl_za2srczd2filesza2zd2zzengine_paramz00; 
BgL_test3026z00_1493 = 
PAIRP(BgL_objz00_2034); } 
if(BgL_test3026z00_1493)
{ /* Jvm/jdump.scm 133 */
obj_t BgL_arg3028z00_1494;
{ /* Jvm/jdump.scm 133 */
obj_t BgL_arg3031z00_1495;
{ /* Jvm/jdump.scm 133 */
obj_t BgL_arg3034z00_1496;
{ /* Jvm/jdump.scm 133 */
obj_t BgL_pairz00_2035;
BgL_pairz00_2035 = BGl_za2srczd2filesza2zd2zzengine_paramz00; 
BgL_arg3034z00_1496 = 
CAR(BgL_pairz00_2035); } 
BgL_arg3031z00_1495 = 
BGl_basenamez00zz__osz00(BgL_arg3034z00_1496); } 
BgL_arg3028z00_1494 = 
BGl_prefixz00zz__osz00(BgL_arg3031z00_1495); } 
BgL_bnamez00_1476 = 
BGl_addsuffixz00zzjvm_jdumpz00(BgL_arg3028z00_1494); }  else 
{ /* Jvm/jdump.scm 132 */
BgL_bnamez00_1476 = BFALSE; } } } } } 
BGl_emitz00zzjvm_jdumpz00(
CAR(BgL_lza2za2_1475), BgL_bnamez00_1476); 
{ 
obj_t BgL_l2879z00_1478;
{ /* Jvm/jdump.scm 138 */
bool_t BgL_auxz00_2780;
BgL_l2879z00_1478 = 
CDR(BgL_lza2za2_1475); 
BgL_lname2880z00_1479:
if(
PAIRP(BgL_l2879z00_1478))
{ /* Jvm/jdump.scm 138 */
{ /* Jvm/jdump.scm 138 */
obj_t BgL_cfz00_1482;
BgL_cfz00_1482 = 
CAR(BgL_l2879z00_1478); 
{ /* Jvm/jdump.scm 138 */
obj_t BgL_arg2995z00_1483;
BgL_arg2995z00_1483 = 
BGl_jasnamez00zzjvm_jdumpz00(BgL_cfz00_1482); 
BGl_emitz00zzjvm_jdumpz00(BgL_cfz00_1482, BgL_arg2995z00_1483); } } 
{ 
obj_t BgL_l2879z00_2786;
BgL_l2879z00_2786 = 
CDR(BgL_l2879z00_1478); 
BgL_l2879z00_1478 = BgL_l2879z00_2786; 
goto BgL_lname2880z00_1479;} }  else 
{ /* Jvm/jdump.scm 138 */
BgL_auxz00_2780 = ((bool_t)1); } 
return 
BBOOL(BgL_auxz00_2780);} } } } 
}



/* emit */
obj_t BGl_emitz00zzjvm_jdumpz00(obj_t BgL_classfilez00_1497, obj_t BgL_destz00_1498)
{ AN_OBJECT;
{ /* Jvm/jdump.scm 123 */
{ /* Jvm/jdump.scm 107 */
obj_t BgL_dirz00_1500;
BgL_dirz00_1500 = BGl_za2jvmzd2dirzd2nameza2z00zzjvm_jdumpz00; 
{ /* Jvm/jdump.scm 108 */
bool_t BgL_test3041z00_1501;
{ /* Jvm/jdump.scm 108 */
obj_t BgL_auxz00_2790;
BgL_auxz00_2790 = 
CNST_TABLE_REF(((long)4)); 
BgL_test3041z00_1501 = 
(BGl_za2passza2z00zzengine_paramz00==BgL_auxz00_2790); } 
if(BgL_test3041z00_1501)
{ /* Jvm/jdump.scm 109 */
obj_t BgL_portz00_1502;
if(
STRINGP(BgL_destz00_1498))
{ /* Jvm/jdump.scm 112 */
obj_t BgL_arg3051z00_1506;
BgL_arg3051z00_1506 = 
string_append_3(BgL_dirz00_1500, BGl_string3765z00zzjvm_jdumpz00, BgL_destz00_1498); 
BgL_portz00_1502 = 
open_output_file(BgL_arg3051z00_1506); }  else 
{ /* Jvm/jdump.scm 109 */
BgL_portz00_1502 = 
GET_CURRENT_OUTPUT_PORT(); } 
BGl_jvmasdumpz00zzjvm_jdumpz00(BgL_classfilez00_1497, BgL_portz00_1502); 
{ /* Jvm/jdump.scm 114 */
bool_t BgL_test3043z00_1503;
{ /* Jvm/jdump.scm 114 */
obj_t BgL_arg3046z00_1504;
BgL_arg3046z00_1504 = 
GET_CURRENT_OUTPUT_PORT(); 
BgL_test3043z00_1503 = 
(BgL_portz00_1502==BgL_arg3046z00_1504); } 
if(BgL_test3043z00_1503)
{ /* Jvm/jdump.scm 114 */
return BFALSE;}  else 
{ /* Jvm/jdump.scm 114 */
return 
close_output_port(BgL_portz00_1502);} } }  else 
{ /* Jvm/jdump.scm 116 */
obj_t BgL_cnamez00_1507;
if(
STRINGP(BgL_destz00_1498))
{ /* Jvm/jdump.scm 116 */
BgL_cnamez00_1507 = 
string_append_3(BgL_dirz00_1500, BGl_string3765z00zzjvm_jdumpz00, BgL_destz00_1498); }  else 
{ /* Jvm/jdump.scm 116 */
BgL_cnamez00_1507 = 
string_append(BgL_dirz00_1500, BGl_string3766z00zzjvm_jdumpz00); } 
{ /* Jvm/jdump.scm 116 */
obj_t BgL_portz00_1508;
BgL_portz00_1508 = 
BGl_openzd2outputzd2binaryzd2filezd2zz__binaryz00(BgL_cnamez00_1507); 
{ /* Jvm/jdump.scm 119 */

if(
BINARY_PORTP(BgL_portz00_1508))
{ /* Jvm/jdump.scm 120 */((bool_t)0); }  else 
{ /* Jvm/jdump.scm 120 */
FAILURE(BGl_string3767z00zzjvm_jdumpz00,BGl_string3768z00zzjvm_jdumpz00,BgL_cnamez00_1507);} 
BGl_jvmzd2aszd2zzjas_asz00(BgL_classfilez00_1497, BgL_portz00_1508); 
return 
BGl_closezd2binaryzd2portz00zz__binaryz00(BgL_portz00_1508);} } } } } } 
}



/* _jvm-dump3691 */
obj_t BGl__jvmzd2dump3691zd2zzjvm_jdumpz00(obj_t BgL_envz00_2668, obj_t BgL_globalsz00_2669)
{ AN_OBJECT;
{ /* Jvm/jdump.scm 96 */
return 
BGl_jvmzd2dumpzd2zzjvm_jdumpz00(BgL_globalsz00_2669);} 
}



/* jvm-check-package */
obj_t BGl_jvmzd2checkzd2packagez00zzjvm_jdumpz00(obj_t BgL_modulez00_20, obj_t BgL_pathz00_21)
{ AN_OBJECT;
{ /* Jvm/jdump.scm 147 */
{ 
obj_t BgL_basez00_1532;obj_t BgL_pathz00_1533;
{ /* Jvm/jdump.scm 164 */
obj_t BgL_qtypez00_1513;
BgL_qtypez00_1513 = 
BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00(BgL_modulez00_20); 
{ /* Jvm/jdump.scm 164 */
obj_t BgL_basez00_1514;
{ /* Jvm/jdump.scm 165 */
obj_t BgL_prez00_1529;
BgL_prez00_1529 = 
BGl_prefixz00zz__osz00(BgL_qtypez00_1513); 
{ /* Jvm/jdump.scm 167 */
bool_t BgL_test3100z00_1530;
BgL_test3100z00_1530 = 
bigloo_strcmp(BgL_prez00_1529, BGl_string3769z00zzjvm_jdumpz00); 
if(BgL_test3100z00_1530)
{ /* Jvm/jdump.scm 167 */
BgL_basez00_1514 = BGl_string3757z00zzjvm_jdumpz00; }  else 
{ /* Jvm/jdump.scm 169 */
bool_t BgL_test3101z00_1531;
BgL_test3101z00_1531 = 
bigloo_strcmp(BgL_prez00_1529, BgL_qtypez00_1513); 
if(BgL_test3101z00_1531)
{ /* Jvm/jdump.scm 169 */
BgL_basez00_1514 = BGl_string3757z00zzjvm_jdumpz00; }  else 
{ /* Jvm/jdump.scm 169 */
BgL_basez00_1514 = BgL_prez00_1529; } } } } 
{ /* Jvm/jdump.scm 165 */

{ /* Jvm/jdump.scm 173 */
bool_t BgL_test3067z00_1515;
{ /* Jvm/jdump.scm 173 */
obj_t BgL_arg3097z00_1528;
BgL_arg3097z00_1528 = 
BGl_jvmzd2filenamezd2zzjvm_jdumpz00(BgL_basez00_1514); 
BgL_basez00_1532 = BgL_arg3097z00_1528; 
BgL_pathz00_1533 = BgL_pathz00_21; 
{ /* Jvm/jdump.scm 149 */
int BgL_lbasez00_1535;int BgL_lpathz00_1536;
BgL_lbasez00_1535 = 
STRING_LENGTH(BgL_basez00_1532); 
BgL_lpathz00_1536 = 
STRING_LENGTH(BgL_pathz00_1533); 
if(
BGl_2zc3zc3zz__r4_numbers_6_5z00(
BINT(BgL_lpathz00_1536), 
BINT(BgL_lbasez00_1535)))
{ /* Jvm/jdump.scm 151 */
BgL_test3067z00_1515 = ((bool_t)0); }  else 
{ 
long BgL_rpathz00_1538;long BgL_rbasez00_1539;
{ /* Jvm/jdump.scm 153 */
long BgL_auxz00_2846;
BgL_auxz00_2846 = 
(long)(BgL_lpathz00_1536); 
BgL_rpathz00_1538 = 
(BgL_auxz00_2846-((long)1)); } 
{ /* Jvm/jdump.scm 154 */
long BgL_auxz00_2849;
BgL_auxz00_2849 = 
(long)(BgL_lbasez00_1535); 
BgL_rbasez00_1539 = 
(BgL_auxz00_2849-((long)1)); } 
BgL_loopz00_1540:
if(
(BgL_rbasez00_1539==((long)-1)))
{ /* Jvm/jdump.scm 155 */
BgL_test3067z00_1515 = ((bool_t)1); }  else 
{ /* Jvm/jdump.scm 157 */
unsigned char BgL_cbasez00_1544;unsigned char BgL_cpathz00_1545;
{ /* Jvm/jdump.scm 157 */
int BgL_auxz00_2830;
BgL_auxz00_2830 = 
(int)(BgL_rbasez00_1539); 
BgL_cbasez00_1544 = 
STRING_REF(BgL_basez00_1532, BgL_auxz00_2830); } 
{ /* Jvm/jdump.scm 158 */
int BgL_auxz00_2833;
BgL_auxz00_2833 = 
(int)(BgL_rpathz00_1538); 
BgL_cpathz00_1545 = 
STRING_REF(BgL_pathz00_1533, BgL_auxz00_2833); } 
{ /* Jvm/jdump.scm 159 */
bool_t BgL_testz00_2836;
if(
(BgL_cbasez00_1544==BgL_cpathz00_1545))
{ /* Jvm/jdump.scm 159 */
BgL_testz00_2836 = ((bool_t)1)
; }  else 
{ /* Jvm/jdump.scm 159 */
if(
(BgL_cpathz00_1545==((unsigned char)'/')))
{ /* Jvm/jdump.scm 160 */
BgL_testz00_2836 = 
(BgL_cbasez00_1544==((unsigned char)'.'))
; }  else 
{ /* Jvm/jdump.scm 160 */
BgL_testz00_2836 = ((bool_t)0)
; } } 
if(BgL_testz00_2836)
{ 
long BgL_rbasez00_2844;long BgL_rpathz00_2842;
BgL_rpathz00_2842 = 
(BgL_rpathz00_1538-((long)1)); 
BgL_rbasez00_2844 = 
(BgL_rbasez00_1539-((long)1)); 
BgL_rbasez00_1539 = BgL_rbasez00_2844; 
BgL_rpathz00_1538 = BgL_rpathz00_2842; 
goto BgL_loopz00_1540;}  else 
{ /* Jvm/jdump.scm 159 */
BgL_test3067z00_1515 = ((bool_t)0); } } } } } } 
if(BgL_test3067z00_1515)
{ /* Jvm/jdump.scm 173 */
return BFALSE;}  else 
{ /* Jvm/jdump.scm 174 */
obj_t BgL_list3069z00_1516;
{ /* Jvm/jdump.scm 174 */
obj_t BgL_arg3072z00_1518;
{ /* Jvm/jdump.scm 174 */
obj_t BgL_arg3076z00_1520;
{ /* Jvm/jdump.scm 174 */
obj_t BgL_arg3079z00_1521;
{ /* Jvm/jdump.scm 174 */
obj_t BgL_arg3083z00_1523;
{ /* Jvm/jdump.scm 174 */
obj_t BgL_arg3086z00_1524;
{ /* Jvm/jdump.scm 174 */
obj_t BgL_arg3090z00_1526;
{ /* Jvm/jdump.scm 174 */
obj_t BgL_arg3093z00_1527;
BgL_arg3093z00_1527 = 
MAKE_PAIR(BGl_string3770z00zzjvm_jdumpz00, BNIL); 
BgL_arg3090z00_1526 = 
MAKE_PAIR(BgL_pathz00_21, BgL_arg3093z00_1527); } 
BgL_arg3086z00_1524 = 
MAKE_PAIR(BGl_string3771z00zzjvm_jdumpz00, BgL_arg3090z00_1526); } 
BgL_arg3083z00_1523 = 
MAKE_PAIR(BgL_basez00_1514, BgL_arg3086z00_1524); } 
BgL_arg3079z00_1521 = 
MAKE_PAIR(BGl_string3772z00zzjvm_jdumpz00, BgL_arg3083z00_1523); } 
BgL_arg3076z00_1520 = 
MAKE_PAIR(BGl_za2moduleza2z00zzmodule_modulez00, BgL_arg3079z00_1521); } 
BgL_arg3072z00_1518 = 
MAKE_PAIR(BGl_string3773z00zzjvm_jdumpz00, BgL_arg3076z00_1520); } 
BgL_list3069z00_1516 = 
MAKE_PAIR(BGl_string3774z00zzjvm_jdumpz00, BgL_arg3072z00_1518); } 
return 
BGl_warningz00zz__errorz00(BgL_list3069z00_1516);} } } } } } } 
}



/* jvmasdump */
obj_t BGl_jvmasdumpz00zzjvm_jdumpz00(obj_t BgL_classfilez00_22, obj_t BgL_portz00_23)
{ AN_OBJECT;
{ /* Jvm/jdump.scm 180 */
{ /* Jvm/jdump.scm 181 */
obj_t BgL_owz00_1552;obj_t BgL_ocz00_1553;
BgL_owz00_1552 = BGl_za2ppzd2widthza2zd2zz__ppz00; 
BgL_ocz00_1553 = BGl_za2ppzd2caseza2zd2zz__ppz00; 
BGl_za2ppzd2widthza2zd2zz__ppz00 = 
BINT(((long)1024)); 
BGl_za2ppzd2caseza2zd2zz__ppz00 = 
CNST_TABLE_REF(((long)5)); 
{ /* Jvm/jdump.scm 184 */
obj_t BgL_list3133z00_1554;
BgL_list3133z00_1554 = 
MAKE_PAIR(BgL_portz00_23, BNIL); 
BGl_ppz00zz__ppz00(BgL_classfilez00_22, BgL_list3133z00_1554); } 
BGl_za2ppzd2caseza2zd2zz__ppz00 = BgL_ocz00_1553; 
return ( 
BGl_za2ppzd2widthza2zd2zz__ppz00 = BgL_owz00_1552, BUNSPEC) ;} } 
}



/* addsuffix */
obj_t BGl_addsuffixz00zzjvm_jdumpz00(obj_t BgL_namez00_24)
{ AN_OBJECT;
{ /* Jvm/jdump.scm 188 */
{ /* Jvm/jdump.scm 190 */
char * BgL_arg3136z00_1555;
{ /* Jvm/jdump.scm 190 */
obj_t BgL_casezd2valuezd2_1556;
BgL_casezd2valuezd2_1556 = BGl_za2passza2z00zzengine_paramz00; 
{ /* Jvm/jdump.scm 190 */
bool_t BgL_testz00_2866;
{ /* Jvm/jdump.scm 190 */
obj_t BgL_auxz00_2867;
BgL_auxz00_2867 = 
CNST_TABLE_REF(((long)6)); 
BgL_testz00_2866 = 
(BgL_casezd2valuezd2_1556==BgL_auxz00_2867); } 
if(BgL_testz00_2866)
{ /* Jvm/jdump.scm 190 */
BgL_arg3136z00_1555 = ".jast"; }  else 
{ /* Jvm/jdump.scm 190 */
bool_t BgL_testz00_2870;
{ /* Jvm/jdump.scm 190 */
obj_t BgL_auxz00_2871;
BgL_auxz00_2871 = 
CNST_TABLE_REF(((long)4)); 
BgL_testz00_2870 = 
(BgL_casezd2valuezd2_1556==BgL_auxz00_2871); } 
if(BgL_testz00_2870)
{ /* Jvm/jdump.scm 190 */
BgL_arg3136z00_1555 = ".jas"; }  else 
{ /* Jvm/jdump.scm 190 */
BgL_arg3136z00_1555 = ".class"; } } } } 
{ /* Jvm/jdump.scm 189 */
obj_t BgL_auxz00_2874;
BgL_auxz00_2874 = 
string_to_bstring(BgL_arg3136z00_1555); 
return 
string_append(BgL_namez00_24, BgL_auxz00_2874);} } } 
}



/* jasname */
obj_t BGl_jasnamez00zzjvm_jdumpz00(obj_t BgL_cfz00_25)
{ AN_OBJECT;
{ /* Jvm/jdump.scm 198 */
if(
PAIRP(BgL_cfz00_25))
{ /* Jvm/jdump.scm 199 */
obj_t BgL_carzd2105zd2_1563;
BgL_carzd2105zd2_1563 = 
CAR(BgL_cfz00_25); 
if(
PAIRP(BgL_carzd2105zd2_1563))
{ /* Jvm/jdump.scm 199 */
obj_t BgL_cdrzd2109zd2_1565;
BgL_cdrzd2109zd2_1565 = 
CDR(BgL_carzd2105zd2_1563); 
{ /* Jvm/jdump.scm 199 */
bool_t BgL_testz00_2883;
{ /* Jvm/jdump.scm 199 */
obj_t BgL_auxz00_2886;obj_t BgL_auxz00_2884;
BgL_auxz00_2886 = 
CNST_TABLE_REF(((long)7)); 
BgL_auxz00_2884 = 
CAR(BgL_carzd2105zd2_1563); 
BgL_testz00_2883 = 
(BgL_auxz00_2884==BgL_auxz00_2886); } 
if(BgL_testz00_2883)
{ /* Jvm/jdump.scm 199 */
if(
PAIRP(BgL_cdrzd2109zd2_1565))
{ /* Jvm/jdump.scm 199 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2109zd2_1565), BNIL))
{ /* Jvm/jdump.scm 199 */
obj_t BgL_arg3167z00_2084;
{ /* Jvm/jdump.scm 199 */
obj_t BgL_auxz00_2894;
BgL_auxz00_2894 = 
CAR(BgL_cdrzd2109zd2_1565); 
BgL_arg3167z00_2084 = 
SYMBOL_TO_STRING(BgL_auxz00_2894); } 
return 
BGl_addsuffixz00zzjvm_jdumpz00(BgL_arg3167z00_2084);}  else 
{ /* Jvm/jdump.scm 199 */
return BFALSE;} }  else 
{ /* Jvm/jdump.scm 199 */
return BFALSE;} }  else 
{ /* Jvm/jdump.scm 199 */
return BFALSE;} } }  else 
{ /* Jvm/jdump.scm 199 */
return BFALSE;} }  else 
{ /* Jvm/jdump.scm 199 */
return BFALSE;} } 
}



/* jvm-filename */
obj_t BGl_jvmzd2filenamezd2zzjvm_jdumpz00(obj_t BgL_namez00_26)
{ AN_OBJECT;
{ /* Jvm/jdump.scm 206 */
{ /* Jvm/jdump.scm 207 */
bool_t BgL_test3170z00_1575;
{ /* Jvm/jdump.scm 207 */
obj_t BgL_objz00_2088;
BgL_objz00_2088 = BGl_za2jvmzd2directoryza2zd2zzengine_paramz00; 
BgL_test3170z00_1575 = 
STRINGP(BgL_objz00_2088); } 
if(BgL_test3170z00_1575)
{ /* Jvm/jdump.scm 208 */
bool_t BgL_test3171z00_1576;
BgL_test3171z00_1576 = 
bigloo_strcmp(BgL_namez00_26, BGl_string3757z00zzjvm_jdumpz00); 
if(BgL_test3171z00_1576)
{ /* Jvm/jdump.scm 208 */
return BGl_za2jvmzd2directoryza2zd2zzengine_paramz00;}  else 
{ /* Jvm/jdump.scm 208 */
return 
BGl_makezd2filezd2namez00zz__osz00(BGl_za2jvmzd2directoryza2zd2zzengine_paramz00, BgL_namez00_26);} }  else 
{ /* Jvm/jdump.scm 207 */
return BgL_namez00_26;} } } 
}



/* jvm-dirname */
obj_t BGl_jvmzd2dirnamezd2zzjvm_jdumpz00(obj_t BgL_filez00_27)
{ AN_OBJECT;
{ /* Jvm/jdump.scm 216 */
{ /* Jvm/jdump.scm 217 */
obj_t BgL_dfilez00_1577;
BgL_dfilez00_1577 = 
BGl_dirnamez00zz__osz00(BgL_filez00_27); 
{ /* Jvm/jdump.scm 217 */
obj_t BgL_dirz00_1578;
BgL_dirz00_1578 = 
BGl_jvmzd2filenamezd2zzjvm_jdumpz00(BgL_dfilez00_1577); 
{ /* Jvm/jdump.scm 218 */

{ /* Jvm/jdump.scm 219 */
bool_t BgL_test3175z00_1579;
{ /* Jvm/jdump.scm 219 */
bool_t BgL_test3177z00_1580;
BgL_test3177z00_1580 = 
bigloo_strcmp(BgL_dfilez00_1577, BGl_string3769z00zzjvm_jdumpz00); 
if(BgL_test3177z00_1580)
{ /* Jvm/jdump.scm 219 */
BgL_test3175z00_1579 = ((bool_t)0); }  else 
{ /* Jvm/jdump.scm 220 */
bool_t BgL_test3178z00_1581;
{ /* Jvm/jdump.scm 220 */
char * BgL_auxz00_2907;
BgL_auxz00_2907 = 
BSTRING_TO_STRING(BgL_dfilez00_1577); 
BgL_test3178z00_1581 = 
directoryp(BgL_auxz00_2907); } 
if(BgL_test3178z00_1581)
{ /* Jvm/jdump.scm 220 */
BgL_test3175z00_1579 = ((bool_t)0); }  else 
{ /* Jvm/jdump.scm 221 */
bool_t BgL_test3179z00_1582;
{ /* Jvm/jdump.scm 221 */
char * BgL_auxz00_2911;
BgL_auxz00_2911 = 
BSTRING_TO_STRING(BgL_dfilez00_1577); 
BgL_test3179z00_1582 = 
fexists(BgL_auxz00_2911); } 
if(BgL_test3179z00_1582)
{ /* Jvm/jdump.scm 221 */
BgL_test3175z00_1579 = ((bool_t)0); }  else 
{ /* Jvm/jdump.scm 222 */
bool_t BgL__ortest_2882z00_1583;
{ /* Jvm/jdump.scm 222 */
bool_t BgL_test3181z00_1584;
{ /* Jvm/jdump.scm 222 */
obj_t BgL_objz00_2095;
BgL_objz00_2095 = BGl_za2jvmzd2directoryza2zd2zzengine_paramz00; 
BgL_test3181z00_1584 = 
STRINGP(BgL_objz00_2095); } 
if(BgL_test3181z00_1584)
{ /* Jvm/jdump.scm 222 */
BgL__ortest_2882z00_1583 = ((bool_t)0); }  else 
{ /* Jvm/jdump.scm 222 */
BgL__ortest_2882z00_1583 = ((bool_t)1); } } 
if(BgL__ortest_2882z00_1583)
{ /* Jvm/jdump.scm 222 */
BgL_test3175z00_1579 = BgL__ortest_2882z00_1583; }  else 
{ /* Jvm/jdump.scm 223 */
char * BgL_stringz00_2096;
BgL_stringz00_2096 = 
BSTRING_TO_STRING(BGl_za2jvmzd2directoryza2zd2zzengine_paramz00); 
BgL_test3175z00_1579 = 
directoryp(BgL_stringz00_2096); } } } } } 
if(BgL_test3175z00_1579)
{ /* Jvm/jdump.scm 219 */
BGl_makezd2directorieszd2zz__r4_ports_6_10_1z00(BgL_dirz00_1578); }  else 
{ /* Jvm/jdump.scm 219 */((bool_t)0); } } 
return BgL_dirz00_1578;} } } } 
}



/* start-jvm-emission! */
obj_t BGl_startzd2jvmzd2emissionz12z12zzjvm_jdumpz00()
{ AN_OBJECT;
{ /* Jvm/jdump.scm 231 */
{ /* Jvm/jdump.scm 233 */
bool_t BgL_test3188z00_1585;
{ /* Jvm/jdump.scm 233 */
obj_t BgL_objz00_2097;
BgL_objz00_2097 = BGl_za2destza2z00zzengine_paramz00; 
BgL_test3188z00_1585 = 
STRINGP(BgL_objz00_2097); } 
if(BgL_test3188z00_1585)
{ /* Jvm/jdump.scm 233 */
{ /* Jvm/jdump.scm 234 */
obj_t BgL_dnamez00_1586;
BgL_dnamez00_1586 = 
BGl_dirnamez00zz__osz00(BGl_za2destza2z00zzengine_paramz00); 
{ /* Jvm/jdump.scm 235 */
bool_t BgL_test3189z00_1587;
BgL_test3189z00_1587 = 
bigloo_strcmp(BgL_dnamez00_1586, BGl_string3769z00zzjvm_jdumpz00); 
if(BgL_test3189z00_1587)
{ /* Jvm/jdump.scm 235 */BFALSE; }  else 
{ /* Jvm/jdump.scm 235 */
BGl_za2jvmzd2dirzd2nameza2z00zzjvm_jdumpz00 = 
BGl_jvmzd2dirnamezd2zzjvm_jdumpz00(BGl_za2destza2z00zzengine_paramz00); } } } }  else 
{ /* Jvm/jdump.scm 237 */
bool_t BgL_test3193z00_1588;
{ /* Jvm/jdump.scm 237 */
obj_t BgL_auxz00_2928;
BgL_auxz00_2928 = 
CNST_TABLE_REF(((long)3)); 
BgL_test3193z00_1588 = 
(BGl_za2passza2z00zzengine_paramz00==BgL_auxz00_2928); } 
if(BgL_test3193z00_1588)
{ /* Jvm/jdump.scm 237 */
{ /* Jvm/jdump.scm 238 */
bool_t BgL_test3194z00_1589;
{ /* Jvm/jdump.scm 238 */
obj_t BgL_objz00_2100;
BgL_objz00_2100 = BGl_za2srczd2filesza2zd2zzengine_paramz00; 
BgL_test3194z00_1589 = 
PAIRP(BgL_objz00_2100); } 
if(BgL_test3194z00_1589)
{ /* Jvm/jdump.scm 239 */
obj_t BgL_arg3196z00_1590;
{ /* Jvm/jdump.scm 239 */
obj_t BgL_pairz00_2101;
BgL_pairz00_2101 = BGl_za2srczd2filesza2zd2zzengine_paramz00; 
BgL_arg3196z00_1590 = 
CAR(BgL_pairz00_2101); } 
BGl_za2jvmzd2dirzd2nameza2z00zzjvm_jdumpz00 = 
BGl_jvmzd2dirnamezd2zzjvm_jdumpz00(BgL_arg3196z00_1590); }  else 
{ /* Jvm/jdump.scm 238 */BFALSE; } } }  else 
{ /* Jvm/jdump.scm 237 */BFALSE; } } } 
{ /* Jvm/jdump.scm 240 */
bool_t BgL_test3202z00_1591;
{ /* Jvm/jdump.scm 240 */
bool_t BgL_test3204z00_1592;
{ /* Jvm/jdump.scm 240 */
char * BgL_namez00_2102;
BgL_namez00_2102 = 
BSTRING_TO_STRING(BGl_za2jvmzd2dirzd2nameza2z00zzjvm_jdumpz00); 
BgL_test3204z00_1592 = 
fexists(BgL_namez00_2102); } 
if(BgL_test3204z00_1592)
{ /* Jvm/jdump.scm 240 */
char * BgL_stringz00_2103;
BgL_stringz00_2103 = 
BSTRING_TO_STRING(BGl_za2jvmzd2dirzd2nameza2z00zzjvm_jdumpz00); 
BgL_test3202z00_1591 = 
directoryp(BgL_stringz00_2103); }  else 
{ /* Jvm/jdump.scm 240 */
BgL_test3202z00_1591 = ((bool_t)0); } } 
if(BgL_test3202z00_1591)
{ /* Jvm/jdump.scm 240 */
return BTRUE;}  else 
{ /* Jvm/jdump.scm 241 */
obj_t BgL_objectz00_2106;
BgL_objectz00_2106 = BGl_za2jvmzd2dirzd2nameza2z00zzjvm_jdumpz00; 
FAILURE(BGl_string3775z00zzjvm_jdumpz00,BGl_string3776z00zzjvm_jdumpz00,BgL_objectz00_2106);} } } 
}



/* _start-jvm-emission! */
obj_t BGl__startzd2jvmzd2emissionz12z12zzjvm_jdumpz00(obj_t BgL_envz00_2670)
{ AN_OBJECT;
{ /* Jvm/jdump.scm 231 */
return 
BGl_startzd2jvmzd2emissionz12z12zzjvm_jdumpz00();} 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzjvm_jdumpz00()
{ AN_OBJECT;
{ /* Jvm/jdump.scm 71 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzjvm_jdumpz00()
{ AN_OBJECT;
{ /* Jvm/jdump.scm 71 */
BGl_modulezd2initializa7ationz75zztools_speekz00(((long)23545), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zztools_errorz00(((long)17886), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zzengine_passz00(((long)12444), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19010), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)28259), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zzast_nodez00(((long)49436), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zzast_envz00(((long)73271), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zztools_shapez00(((long)30825), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zzobject_classz00(((long)19348), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zzengine_paramz00(((long)189840), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zzcoerce_typeofz00(((long)57980), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zzjvm_compilez00(((long)49882), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zzjas_asz00(((long)62726), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long)12859), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zzread_jvmz00(((long)34896), "jvm_jdump"); 
BGl_modulezd2initializa7ationz75zzcgen_mainz00(((long)1758), "jvm_jdump"); 
return 
BGl_modulezd2initializa7ationz75zzcgen_prototypez00(((long)56964), "jvm_jdump");} 
}

