/*===========================================================================*/
/*   (Jvm/tail.scm)                                                          */
/*   Bigloo (2.5b)                                                           */
/*   Manuel Serrano (c)       Fri Sep 6 09:43:28 CEST 2002                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_nodez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
} *BgL_nodez00_bglt;

typedef struct BgL_nodezf2effectzf2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
} *BgL_nodezf2effectzf2_bglt;

typedef struct BgL_atomz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_atomz00_bglt;

typedef struct BgL_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_varz00_bglt;

typedef struct BgL_closurez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_closurez00_bglt;

typedef struct BgL_kwotez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_kwotez00_bglt;

typedef struct BgL_sequencez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_nodesz00;
} *BgL_sequencez00_bglt;

typedef struct BgL_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
} *BgL_appz00_bglt;

typedef struct BgL_appzd2lyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_appzd2lyzd2_bglt;

typedef struct BgL_funcallz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_strengthz00;
} *BgL_funcallz00_bglt;

typedef struct BgL_externz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_externz00_bglt;

typedef struct BgL_pragmaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_formatz00;
} *BgL_pragmaz00_bglt;

typedef struct BgL_getfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_getfieldz00_bglt;

typedef struct BgL_setfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_setfieldz00_bglt;

typedef struct BgL_newz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_newz00_bglt;

typedef struct BgL_vallocz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2heapzd2formatz00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_vallocz00_bglt;

typedef struct BgL_vrefz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vrefz00_bglt;

typedef struct BgL_vsetz12z12_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vsetz12z12_bglt;

typedef struct BgL_vlengthz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vlengthz00_bglt;

typedef struct BgL_isaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   struct BgL_typez00_bgl * BgL_classz00;
} *BgL_isaz00_bglt;

typedef struct BgL_castz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_castz00_bglt;

typedef struct BgL_setqz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_setqz00_bglt;

typedef struct BgL_conditionalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   struct BgL_nodez00_bgl * BgL_truez00;
   struct BgL_nodez00_bgl * BgL_falsez00;
} *BgL_conditionalz00_bglt;

typedef struct BgL_failz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_procz00;
   struct BgL_nodez00_bgl * BgL_msgz00;
   struct BgL_nodez00_bgl * BgL_objz00;
} *BgL_failz00_bglt;

typedef struct BgL_selectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   obj_t BgL_clausesz00;
   struct BgL_typez00_bgl * BgL_itemzd2typezd2;
} *BgL_selectz00_bglt;

typedef struct BgL_letzd2funzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_localsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_letzd2funzd2_bglt;

typedef struct BgL_letzd2varzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_bindingsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
   bool_t BgL_removablezf3zf3;
} *BgL_letzd2varzd2_bglt;

typedef struct BgL_setzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_setzd2exzd2itz00_bglt;

typedef struct BgL_jumpzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_exitz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_jumpzd2exzd2itz00_bglt;

typedef struct BgL_makezd2boxzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_makezd2boxzd2_bglt;

typedef struct BgL_boxzd2refzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_varz00;
} *BgL_boxzd2refzd2_bglt;

typedef struct BgL_boxzd2setz12zc0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_boxzd2setz12zc0_bglt;

typedef struct BgL_tclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   struct BgL_globalz00_bgl * BgL_holderz00;
   obj_t BgL_wideningz00;
   long BgL_depthz00;
   bool_t BgL_finalzf3zf3;
   obj_t BgL_constructorz00;
   obj_t BgL_virtualzd2slotszd2numberz00;
   bool_t BgL_abstractzf3zf3;
} *BgL_tclassz00_bglt;

typedef struct BgL_jclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   obj_t BgL_packagez00;
} *BgL_jclassz00_bglt;

typedef struct BgL_envz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_declarationsz00;
   obj_t BgL_declaredtypez00;
   obj_t BgL_declaredclassz00;
   obj_t BgL_declaredmodulez00;
   obj_t BgL_currentzd2modulezd2;
   obj_t BgL_declaredfieldsz00;
   obj_t BgL_declaredglobalz00;
   obj_t BgL_libdeclaredz00;
   obj_t BgL_proceduresz00;
   obj_t BgL_clinitzd2codezd2;
   obj_t BgL_currentzd2methodzd2;
   obj_t BgL_vcountz00;
   obj_t BgL_localsz00;
   obj_t BgL_freelocalsz00;
   obj_t BgL_maplocalsz00;
   obj_t BgL_stackz00;
   obj_t BgL_codez00;
} *BgL_envz00_bglt;


static obj_t BGl_compilezd2tailzd2boxzd2setz123026zc0zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_compilerzd2ifzd2zzjvm_compilerz00(BgL_conditionalz00_bglt, BgL_envz00_bglt, obj_t);
extern obj_t BGl_vrefz00zzast_nodez00;
extern obj_t BGl_compilerzd2boxzd2refz00zzjvm_compilerz00(BgL_boxzd2refzd2_bglt, BgL_envz00_bglt);
static obj_t BGl_methodzd2initzd2zzjvm_tailz00();
static obj_t BGl_compilezd2tailzd2new3002z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_compilerzd2boxzd2setz12z12zzjvm_compilerz00(BgL_boxzd2setz12zc0_bglt, BgL_envz00_bglt);
extern obj_t BGl_compilerzd2funcallzd2zzjvm_compilerz00(BgL_funcallz00_bglt, BgL_envz00_bglt);
extern obj_t open_input_string(obj_t);
extern obj_t BGl_letzd2funzd2zzast_nodez00;
static obj_t BGl_compilezd2tailzd2setq2980z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_readz00zz__readerz00(obj_t);
extern obj_t BGl_compilerzd2labelszd2zzjvm_compilerz00(BgL_letzd2funzd2_bglt, BgL_envz00_bglt, obj_t);
extern obj_t BGl_compilerzd2getfieldzd2zzjvm_compilerz00(BgL_getfieldz00_bglt, BgL_envz00_bglt);
extern obj_t BGl_compilezd2tailzd2zzjvm_tailz00(BgL_nodez00_bglt, BgL_envz00_bglt);
extern obj_t BGl_compilerzd2pragmazd2zzjvm_compilerz00(BgL_pragmaz00_bglt, BgL_envz00_bglt);
extern obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
extern obj_t BGl_compilerzd2makezd2boxz00zzjvm_compilerz00(BgL_makezd2boxzd2_bglt, BgL_envz00_bglt);
extern obj_t BGl_letzd2varzd2zzast_nodez00;
extern obj_t BGl_pragmaz00zzast_nodez00;
extern obj_t BGl_compilezd2typezd2zzjvm_envz00(obj_t, BgL_envz00_bglt);
extern obj_t BGl_compilerzd2failzd2zzjvm_compilerz00(BgL_failz00_bglt, BgL_envz00_bglt);
extern obj_t BGl_compilerzd2atomzd2zzjvm_compilerz00(obj_t, BgL_envz00_bglt);
extern obj_t BGl_compilerzd2castzd2zzjvm_compilerz00(BgL_castz00_bglt, BgL_envz00_bglt, obj_t);
static obj_t BGl_compilezd2tailzd2atom2974z00zzjvm_tailz00(obj_t, obj_t, obj_t);
static obj_t BGl__compilezd2tail3766zd2zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_castz00zzast_nodez00;
static obj_t BGl_compilezd2tailzd2var2976z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_boxzd2refzd2zzast_nodez00;
extern obj_t BGl_varz00zzast_nodez00;
static obj_t BGl_cnstzd2initzd2zzjvm_tailz00();
extern obj_t BGl_atomz00zzast_nodez00;
extern obj_t BGl_failz00zzast_nodez00;
extern obj_t BGl_funcallz00zzast_nodez00;
extern obj_t BGl_simplezd2typezd2zzjvm_instrz00(obj_t);
static obj_t BGl_compilezd2tailzd2getfield2998z00zzjvm_tailz00(obj_t, obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zzjvm_tailz00();
extern obj_t BGl_makezd2boxzd2zzast_nodez00;
extern obj_t BGl_getfieldz00zzast_nodez00;
extern obj_t BGl_isaz00zzast_nodez00;
extern obj_t BGl_compilerzd2vsetzd2zzjvm_compilerz00(BgL_vsetz12z12_bglt, BgL_envz00_bglt);
static obj_t BGl_compilezd2tailzd2boxzd2ref3024zd2zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
extern obj_t BGl_compilerzd2selectzd2zzjvm_compilerz00(BgL_selectz00_bglt, BgL_envz00_bglt, obj_t);
static obj_t BGl_compilezd2tailzd2fail3020z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_compilerzd2valloczd2zzjvm_compilerz00(BgL_vallocz00_bglt, BgL_envz00_bglt);
static obj_t BGl_compilezd2tailzd2isa3012z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_selectz00zzast_nodez00;
extern obj_t BGl__storez00zzjvm_instrz00(BgL_envz00_bglt, BgL_localz00_bglt);
extern obj_t BGl_vallocz00zzast_nodez00;
static obj_t BGl_toplevelzd2initzd2zzjvm_tailz00();
extern obj_t BGl_appzd2lyzd2zzast_nodez00;
static obj_t BGl_compilezd2tailzd2valloc3004z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_tailz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_instrz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_exprz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_compilerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_compilerzd2appzd2zzjvm_compilerz00(BgL_appz00_bglt, BgL_envz00_bglt);
extern obj_t BGl_compilerzd2vrefzd2zzjvm_compilerz00(BgL_vrefz00_bglt, BgL_envz00_bglt);
extern obj_t BGl_compilerzd2vlengthzd2zzjvm_compilerz00(BgL_vlengthz00_bglt, BgL_envz00_bglt);
static obj_t BGl_compilezd2tailzd2makezd2box3022zd2zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_compilerzd2setqzd2zzjvm_compilerz00(BgL_setqz00_bglt, BgL_envz00_bglt);
static obj_t BGl_compilezd2tailzd2setzd2exzd2it3016z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_compilerzd2newzd2zzjvm_compilerz00(BgL_newz00_bglt, BgL_envz00_bglt);
extern obj_t bgl_reverse(obj_t);
static obj_t BGl_compilezd2tailzd2appzd2ly2992zd2zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
extern obj_t BGl_compilerzd2applyzd2zzjvm_compilerz00(BgL_appzd2lyzd2_bglt, BgL_envz00_bglt);
static obj_t BGl_compilezd2tailzd2vlength3010z00zzjvm_tailz00(obj_t, obj_t, obj_t);
static obj_t BGl__compilezd2tailzd2default2971z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_compilerzd2jumpzd2exitz00zzjvm_compilerz00(BgL_jumpzd2exzd2itz00_bglt, BgL_envz00_bglt);
extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
static obj_t BGl_compilezd2tailzd2conditional2984z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_compilerzd2setfieldzd2zzjvm_compilerz00(BgL_setfieldz00_bglt, BgL_envz00_bglt);
extern obj_t BGl_newz00zzast_nodez00;
static obj_t BGl_compilezd2tailzd2vsetz123008z12zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_conditionalz00zzast_nodez00;
extern obj_t BGl_sequencez00zzast_nodez00;
extern obj_t BGl__getstaticz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl_compilerzd2letzd2zzjvm_compilerz00(BgL_letzd2varzd2_bglt, BgL_envz00_bglt, obj_t);
static obj_t BGl_compilezd2tailzd2cast3014z00zzjvm_tailz00(obj_t, obj_t, obj_t);
static obj_t BGl_compilezd2tailzd2app2990z00zzjvm_tailz00(obj_t, obj_t, obj_t);
static obj_t BGl_compilezd2tailzd2letzd2var2978zd2zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_appz00zzast_nodez00;
static obj_t BGl_compilezd2tailzd2funcall2994z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_compilerzd2sequencezd2zzjvm_compilerz00(BgL_sequencez00_bglt, BgL_envz00_bglt, obj_t);
extern obj_t BGl_vlengthz00zzast_nodez00;
extern obj_t BGl_setfieldz00zzast_nodez00;
static obj_t BGl_compilezd2tailzd2setfield3000z00zzjvm_tailz00(obj_t, obj_t, obj_t);
static obj_t BGl_compilezd2tailzd2letzd2fun2988zd2zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_compilerzd2isazd2zzjvm_compilerz00(BgL_isaz00_bglt, BgL_envz00_bglt);
extern obj_t BGl_compilerzd2setexitzd2zzjvm_compilerz00(BgL_setzd2exzd2itz00_bglt, BgL_envz00_bglt, obj_t);
static obj_t BGl_compilezd2tailzd2pragma2996z00zzjvm_tailz00(obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zzjvm_tailz00 = BUNSPEC;
extern obj_t BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_bglt, obj_t);
static obj_t BGl_compilezd2tailzd2select2986z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl__gotoz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl_compilezd2exprzd2zzjvm_exprz00(BgL_nodez00_bglt, BgL_envz00_bglt);
static obj_t BGl_libraryzd2moduleszd2initz00zzjvm_tailz00();
extern obj_t BGl_vsetz12z12zzast_nodez00;
static obj_t BGl_compilezd2tailzd2vref3006z00zzjvm_tailz00(obj_t, obj_t, obj_t);
static obj_t BGl_compilezd2tailzd2sequence2982z00zzjvm_tailz00(obj_t, obj_t, obj_t);
static obj_t BGl_compilezd2tailzd2jumpzd2exzd2it3018z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_compilerzd2varzd2zzjvm_compilerz00(BgL_varz00_bglt, BgL_envz00_bglt);
extern obj_t BGl_setqz00zzast_nodez00;
static obj_t BGl_compilezd2tailzd2default2971z00zzjvm_tailz00(BgL_nodez00_bglt, BgL_envz00_bglt);
static obj_t __cnst[ 3 ] ;

DEFINE_STATIC_PROCEDURE( BGl_proc3916z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2setfield3000za700za7za7jvm_tailza7003958z00, BGl_compilezd2tailzd2setfield3000z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3917z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2new3002za700za7za7jvm_tailza7003959z00, BGl_compilezd2tailzd2new3002z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3918z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2valloc3004za700za7za7jvm_tailza7003960z00, BGl_compilezd2tailzd2valloc3004z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3920z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2vsetza7123008za712za7za7jvm_tailza7003961za7, BGl_compilezd2tailzd2vsetz123008z12zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3919z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2vref3006za700za7za7jvm_tailza7003962z00, BGl_compilezd2tailzd2vref3006z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3921z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2vlength3010za700za7za7jvm_tailza7003963z00, BGl_compilezd2tailzd2vlength3010z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3922z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2isa3012za700za7za7jvm_tailza7003964z00, BGl_compilezd2tailzd2isa3012z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3923z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2cast3014za700za7za7jvm_tailza7003965z00, BGl_compilezd2tailzd2cast3014z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3924z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2setza7d2exza7d2it3016za700za7za7jvm_tailza7003966z00, BGl_compilezd2tailzd2setzd2exzd2it3016z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3925z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2jumpza7d2exza7d2it3018za700za7za7jvm_tailza7003967z00, BGl_compilezd2tailzd2jumpzd2exzd2it3018z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3926z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2fail3020za700za7za7jvm_tailza7003968z00, BGl_compilezd2tailzd2fail3020z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3927z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2makeza7d2box3022za7d2za7za7jvm_tailza7003969za7, BGl_compilezd2tailzd2makezd2box3022zd2zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3928z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2boxza7d2ref3024za7d2za7za7jvm_tailza7003970za7, BGl_compilezd2tailzd2boxzd2ref3024zd2zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3929z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2boxza7d2setza7123026za7c0za7za7jvm_tailza7003971z00, BGl_compilezd2tailzd2boxzd2setz123026zc0zzjvm_tailz00, 0L, 2 );
extern obj_t BGl_compilezd2exprzd2envz00zzjvm_exprz00;
DEFINE_EXPORT_GENERIC( BGl_compilezd2tailzd2envz00zzjvm_tailz00, BgL_bgl__compileza7d2tail3766za7d2za7za7jvm_tailza7003972za7, BGl__compilezd2tail3766zd2zzjvm_tailz00, 0L, 2 );
DEFINE_STRING( BGl_string3931z00zzjvm_tailz00, BgL_bgl_string3931za700za7za7jvm_tailza7003973z00, "compile-tail-default2971 begin unspecified ", 43 );
DEFINE_STRING( BGl_string3930z00zzjvm_tailz00, BgL_bgl_string3930za700za7za7jvm_tailza7003974z00, "No method for this object", 25 );
DEFINE_STATIC_PROCEDURE( BGl_compilezd2tailzd2default2971zd2envzd2zzjvm_tailz00, BgL_bgl__compileza7d2tailza7d2default2971za700za7za7jvm_tailza7003975z00, BGl__compilezd2tailzd2default2971z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3903z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2atom2974za700za7za7jvm_tailza7003976z00, BGl_compilezd2tailzd2atom2974z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3904z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2var2976za700za7za7jvm_tailza7003977z00, BGl_compilezd2tailzd2var2976z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3905z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2letza7d2var2978za7d2za7za7jvm_tailza7003978za7, BGl_compilezd2tailzd2letzd2var2978zd2zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3906z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2setq2980za700za7za7jvm_tailza7003979z00, BGl_compilezd2tailzd2setq2980z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3907z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2sequence2982za700za7za7jvm_tailza7003980z00, BGl_compilezd2tailzd2sequence2982z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3908z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2conditional2984za700za7za7jvm_tailza7003981z00, BGl_compilezd2tailzd2conditional2984z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3910z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2letza7d2fun2988za7d2za7za7jvm_tailza7003982za7, BGl_compilezd2tailzd2letzd2fun2988zd2zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3909z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2select2986za700za7za7jvm_tailza7003983z00, BGl_compilezd2tailzd2select2986z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3911z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2app2990za700za7za7jvm_tailza7003984z00, BGl_compilezd2tailzd2app2990z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3912z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2appza7d2ly2992za7d2za7za7jvm_tailza7003985za7, BGl_compilezd2tailzd2appzd2ly2992zd2zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3913z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2funcall2994za700za7za7jvm_tailza7003986z00, BGl_compilezd2tailzd2funcall2994z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3914z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2pragma2996za700za7za7jvm_tailza7003987z00, BGl_compilezd2tailzd2pragma2996z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3915z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2getfield2998za700za7za7jvm_tailza7003988z00, BGl_compilezd2tailzd2getfield2998z00zzjvm_tailz00, 0L, 2 );



/* module-initialization */
obj_t BGl_modulezd2initializa7ationz75zzjvm_tailz00(long BgL_checksumz00_2905, char * BgL_fromz00_2906)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzjvm_tailz00))
{ 
BGl_requirezd2initializa7ationz75zzjvm_tailz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzjvm_tailz00(); 
BGl_cnstzd2initzd2zzjvm_tailz00(); 
BGl_importedzd2moduleszd2initz00zzjvm_tailz00(); 
BGl_methodzd2initzd2zzjvm_tailz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzjvm_tailz00()
{ AN_OBJECT;
{ /* Jvm/tail.scm 2 */
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "jvm_tail"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "jvm_tail"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "jvm_tail"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzjvm_tailz00()
{ AN_OBJECT;
{ /* Jvm/tail.scm 2 */
{ /* Jvm/tail.scm 2 */
obj_t BgL_cportz00_2898;
BgL_cportz00_2898 = 
open_input_string(BGl_string3931z00zzjvm_tailz00); 
{ 
long BgL_iz00_2899;
BgL_iz00_2899 = ((long)2); 
BgL_loopz00_2900:
if(
(BgL_iz00_2899==((long)-1)))
{ /* Jvm/tail.scm 2 */
return BUNSPEC;}  else 
{ /* Jvm/tail.scm 2 */
{ /* Jvm/tail.scm 2 */
obj_t BgL_arg3935z00_2902;
{ /* Jvm/tail.scm 2 */
obj_t BgL_list3938z00_2903;
BgL_list3938z00_2903 = 
MAKE_PAIR(BgL_cportz00_2898, BNIL); 
BgL_arg3935z00_2902 = 
BGl_readz00zz__readerz00(BgL_list3938z00_2903); } 
{ /* Jvm/tail.scm 2 */
int BgL_auxz00_2922;
BgL_auxz00_2922 = 
(int)(BgL_iz00_2899); 
CNST_TABLE_SET(BgL_auxz00_2922, BgL_arg3935z00_2902); } } 
{ 
long BgL_iz00_2925;
{ /* Jvm/tail.scm 2 */
int BgL_auxz00_2926;
{ /* Jvm/tail.scm 2 */
long BgL_auxz00_2927;
BgL_auxz00_2927 = 
(BgL_iz00_2899-((long)1)); 
BgL_auxz00_2926 = 
(int)(BgL_auxz00_2927); } 
BgL_iz00_2925 = 
(long)(BgL_auxz00_2926); } 
BgL_iz00_2899 = BgL_iz00_2925; 
goto BgL_loopz00_2900;} } } } } 
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zzjvm_tailz00()
{ AN_OBJECT;
{ /* Jvm/tail.scm 2 */
return BUNSPEC;} 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzjvm_tailz00()
{ AN_OBJECT;
{ /* Jvm/tail.scm 2 */
BGl_addzd2genericz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_compilezd2tailzd2default2971zd2envzd2zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_atomz00zzast_nodez00, BGl_proc3903z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_varz00zzast_nodez00, BGl_proc3904z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_letzd2varzd2zzast_nodez00, BGl_proc3905z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_setqz00zzast_nodez00, BGl_proc3906z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_sequencez00zzast_nodez00, BGl_proc3907z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_conditionalz00zzast_nodez00, BGl_proc3908z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_selectz00zzast_nodez00, BGl_proc3909z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_letzd2funzd2zzast_nodez00, BGl_proc3910z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_appz00zzast_nodez00, BGl_proc3911z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_appzd2lyzd2zzast_nodez00, BGl_proc3912z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_funcallz00zzast_nodez00, BGl_proc3913z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_pragmaz00zzast_nodez00, BGl_proc3914z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_getfieldz00zzast_nodez00, BGl_proc3915z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_setfieldz00zzast_nodez00, BGl_proc3916z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_newz00zzast_nodez00, BGl_proc3917z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_vallocz00zzast_nodez00, BGl_proc3918z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_vrefz00zzast_nodez00, BGl_proc3919z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_vsetz12z12zzast_nodez00, BGl_proc3920z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_vlengthz00zzast_nodez00, BGl_proc3921z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_isaz00zzast_nodez00, BGl_proc3922z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_castz00zzast_nodez00, BGl_proc3923z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc3924z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc3925z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_failz00zzast_nodez00, BGl_proc3926z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_makezd2boxzd2zzast_nodez00, BGl_proc3927z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_boxzd2refzd2zzast_nodez00, BGl_proc3928z00zzjvm_tailz00); 
return 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc3929z00zzjvm_tailz00);} 
}



/* compile-tail-box-set!3026 */
obj_t BGl_compilezd2tailzd2boxzd2setz123026zc0zzjvm_tailz00(obj_t BgL_envz00_2814, obj_t BgL_ez00_2815, obj_t BgL_envz00_2816)
{ AN_OBJECT;
{ /* Jvm/tail.scm 102 */
{ 
BgL_boxzd2setz12zc0_bglt BgL_ez00_2151;BgL_envz00_bglt BgL_envz00_2152;
BgL_ez00_2151 = 
(BgL_boxzd2setz12zc0_bglt)(BgL_ez00_2815); 
BgL_envz00_2152 = 
(BgL_envz00_bglt)(BgL_envz00_2816); 
BGl_compilerzd2boxzd2setz12z12zzjvm_compilerz00(BgL_ez00_2151, BgL_envz00_2152); 
{ /* Jvm/tail.scm 104 */
obj_t BgL_arg3737z00_2752;
BgL_arg3737z00_2752 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_2152, 
CNST_TABLE_REF(((long)0))); 
return 
BGl__getstaticz00zzjvm_instrz00(BgL_envz00_2152, BgL_arg3737z00_2752);} } } 
}



/* compile-tail-box-ref3024 */
obj_t BGl_compilezd2tailzd2boxzd2ref3024zd2zzjvm_tailz00(obj_t BgL_envz00_2817, obj_t BgL_ez00_2818, obj_t BgL_envz00_2819)
{ AN_OBJECT;
{ /* Jvm/tail.scm 99 */
{ 
BgL_boxzd2refzd2_bglt BgL_ez00_2145;BgL_envz00_bglt BgL_envz00_2146;
BgL_ez00_2145 = 
(BgL_boxzd2refzd2_bglt)(BgL_ez00_2818); 
BgL_envz00_2146 = 
(BgL_envz00_bglt)(BgL_envz00_2819); 
return 
BGl_compilerzd2boxzd2refz00zzjvm_compilerz00(BgL_ez00_2145, BgL_envz00_2146);} } 
}



/* compile-tail-make-box3022 */
obj_t BGl_compilezd2tailzd2makezd2box3022zd2zzjvm_tailz00(obj_t BgL_envz00_2820, obj_t BgL_ez00_2821, obj_t BgL_envz00_2822)
{ AN_OBJECT;
{ /* Jvm/tail.scm 96 */
{ 
BgL_makezd2boxzd2_bglt BgL_ez00_2139;BgL_envz00_bglt BgL_envz00_2140;
BgL_ez00_2139 = 
(BgL_makezd2boxzd2_bglt)(BgL_ez00_2821); 
BgL_envz00_2140 = 
(BgL_envz00_bglt)(BgL_envz00_2822); 
return 
BGl_compilerzd2makezd2boxz00zzjvm_compilerz00(BgL_ez00_2139, BgL_envz00_2140);} } 
}



/* compile-tail-fail3020 */
obj_t BGl_compilezd2tailzd2fail3020z00zzjvm_tailz00(obj_t BgL_envz00_2823, obj_t BgL_ez00_2824, obj_t BgL_envz00_2825)
{ AN_OBJECT;
{ /* Jvm/tail.scm 93 */
{ 
BgL_failz00_bglt BgL_ez00_2133;BgL_envz00_bglt BgL_envz00_2134;
BgL_ez00_2133 = 
(BgL_failz00_bglt)(BgL_ez00_2824); 
BgL_envz00_2134 = 
(BgL_envz00_bglt)(BgL_envz00_2825); 
return 
BGl_compilerzd2failzd2zzjvm_compilerz00(BgL_ez00_2133, BgL_envz00_2134);} } 
}



/* compile-tail-jump-ex-it3018 */
obj_t BGl_compilezd2tailzd2jumpzd2exzd2it3018z00zzjvm_tailz00(obj_t BgL_envz00_2826, obj_t BgL_ez00_2827, obj_t BgL_envz00_2828)
{ AN_OBJECT;
{ /* Jvm/tail.scm 90 */
{ 
BgL_jumpzd2exzd2itz00_bglt BgL_ez00_2127;BgL_envz00_bglt BgL_envz00_2128;
BgL_ez00_2127 = 
(BgL_jumpzd2exzd2itz00_bglt)(BgL_ez00_2827); 
BgL_envz00_2128 = 
(BgL_envz00_bglt)(BgL_envz00_2828); 
return 
BGl_compilerzd2jumpzd2exitz00zzjvm_compilerz00(BgL_ez00_2127, BgL_envz00_2128);} } 
}



/* compile-tail-set-ex-it3016 */
obj_t BGl_compilezd2tailzd2setzd2exzd2it3016z00zzjvm_tailz00(obj_t BgL_envz00_2829, obj_t BgL_ez00_2830, obj_t BgL_envz00_2831)
{ AN_OBJECT;
{ /* Jvm/tail.scm 87 */
{ 
BgL_setzd2exzd2itz00_bglt BgL_ez00_2121;BgL_envz00_bglt BgL_envz00_2122;
BgL_ez00_2121 = 
(BgL_setzd2exzd2itz00_bglt)(BgL_ez00_2830); 
BgL_envz00_2122 = 
(BgL_envz00_bglt)(BgL_envz00_2831); 
return 
BGl_compilerzd2setexitzd2zzjvm_compilerz00(BgL_ez00_2121, BgL_envz00_2122, BGl_compilezd2exprzd2envz00zzjvm_exprz00);} } 
}



/* compile-tail-cast3014 */
obj_t BGl_compilezd2tailzd2cast3014z00zzjvm_tailz00(obj_t BgL_envz00_2832, obj_t BgL_ez00_2833, obj_t BgL_envz00_2834)
{ AN_OBJECT;
{ /* Jvm/tail.scm 84 */
{ 
BgL_castz00_bglt BgL_ez00_2115;BgL_envz00_bglt BgL_envz00_2116;
BgL_ez00_2115 = 
(BgL_castz00_bglt)(BgL_ez00_2833); 
BgL_envz00_2116 = 
(BgL_envz00_bglt)(BgL_envz00_2834); 
return 
BGl_compilerzd2castzd2zzjvm_compilerz00(BgL_ez00_2115, BgL_envz00_2116, BGl_compilezd2tailzd2envz00zzjvm_tailz00);} } 
}



/* compile-tail-isa3012 */
obj_t BGl_compilezd2tailzd2isa3012z00zzjvm_tailz00(obj_t BgL_envz00_2835, obj_t BgL_ez00_2836, obj_t BgL_envz00_2837)
{ AN_OBJECT;
{ /* Jvm/tail.scm 81 */
{ 
BgL_isaz00_bglt BgL_ez00_2109;BgL_envz00_bglt BgL_envz00_2110;
BgL_ez00_2109 = 
(BgL_isaz00_bglt)(BgL_ez00_2836); 
BgL_envz00_2110 = 
(BgL_envz00_bglt)(BgL_envz00_2837); 
return 
BGl_compilerzd2isazd2zzjvm_compilerz00(BgL_ez00_2109, BgL_envz00_2110);} } 
}



/* compile-tail-vlength3010 */
obj_t BGl_compilezd2tailzd2vlength3010z00zzjvm_tailz00(obj_t BgL_envz00_2838, obj_t BgL_ez00_2839, obj_t BgL_envz00_2840)
{ AN_OBJECT;
{ /* Jvm/tail.scm 78 */
{ 
BgL_vlengthz00_bglt BgL_ez00_2103;BgL_envz00_bglt BgL_envz00_2104;
BgL_ez00_2103 = 
(BgL_vlengthz00_bglt)(BgL_ez00_2839); 
BgL_envz00_2104 = 
(BgL_envz00_bglt)(BgL_envz00_2840); 
return 
BGl_compilerzd2vlengthzd2zzjvm_compilerz00(BgL_ez00_2103, BgL_envz00_2104);} } 
}



/* compile-tail-vset!3008 */
obj_t BGl_compilezd2tailzd2vsetz123008z12zzjvm_tailz00(obj_t BgL_envz00_2841, obj_t BgL_ez00_2842, obj_t BgL_envz00_2843)
{ AN_OBJECT;
{ /* Jvm/tail.scm 74 */
{ 
BgL_vsetz12z12_bglt BgL_ez00_2096;BgL_envz00_bglt BgL_envz00_2097;
BgL_ez00_2096 = 
(BgL_vsetz12z12_bglt)(BgL_ez00_2842); 
BgL_envz00_2097 = 
(BgL_envz00_bglt)(BgL_envz00_2843); 
BGl_compilerzd2vsetzd2zzjvm_compilerz00(BgL_ez00_2096, BgL_envz00_2097); 
{ /* Jvm/tail.scm 76 */
obj_t BgL_arg3670z00_2751;
BgL_arg3670z00_2751 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_2097, 
CNST_TABLE_REF(((long)0))); 
return 
BGl__getstaticz00zzjvm_instrz00(BgL_envz00_2097, BgL_arg3670z00_2751);} } } 
}



/* compile-tail-vref3006 */
obj_t BGl_compilezd2tailzd2vref3006z00zzjvm_tailz00(obj_t BgL_envz00_2844, obj_t BgL_ez00_2845, obj_t BgL_envz00_2846)
{ AN_OBJECT;
{ /* Jvm/tail.scm 71 */
{ 
BgL_vrefz00_bglt BgL_ez00_2090;BgL_envz00_bglt BgL_envz00_2091;
BgL_ez00_2090 = 
(BgL_vrefz00_bglt)(BgL_ez00_2845); 
BgL_envz00_2091 = 
(BgL_envz00_bglt)(BgL_envz00_2846); 
return 
BGl_compilerzd2vrefzd2zzjvm_compilerz00(BgL_ez00_2090, BgL_envz00_2091);} } 
}



/* compile-tail-valloc3004 */
obj_t BGl_compilezd2tailzd2valloc3004z00zzjvm_tailz00(obj_t BgL_envz00_2847, obj_t BgL_ez00_2848, obj_t BgL_envz00_2849)
{ AN_OBJECT;
{ /* Jvm/tail.scm 68 */
{ 
BgL_vallocz00_bglt BgL_ez00_2084;BgL_envz00_bglt BgL_envz00_2085;
BgL_ez00_2084 = 
(BgL_vallocz00_bglt)(BgL_ez00_2848); 
BgL_envz00_2085 = 
(BgL_envz00_bglt)(BgL_envz00_2849); 
return 
BGl_compilerzd2valloczd2zzjvm_compilerz00(BgL_ez00_2084, BgL_envz00_2085);} } 
}



/* compile-tail-new3002 */
obj_t BGl_compilezd2tailzd2new3002z00zzjvm_tailz00(obj_t BgL_envz00_2850, obj_t BgL_ez00_2851, obj_t BgL_envz00_2852)
{ AN_OBJECT;
{ /* Jvm/tail.scm 65 */
{ 
BgL_newz00_bglt BgL_ez00_2078;BgL_envz00_bglt BgL_envz00_2079;
BgL_ez00_2078 = 
(BgL_newz00_bglt)(BgL_ez00_2851); 
BgL_envz00_2079 = 
(BgL_envz00_bglt)(BgL_envz00_2852); 
return 
BGl_compilerzd2newzd2zzjvm_compilerz00(BgL_ez00_2078, BgL_envz00_2079);} } 
}



/* compile-tail-setfield3000 */
obj_t BGl_compilezd2tailzd2setfield3000z00zzjvm_tailz00(obj_t BgL_envz00_2853, obj_t BgL_ez00_2854, obj_t BgL_envz00_2855)
{ AN_OBJECT;
{ /* Jvm/tail.scm 61 */
{ 
BgL_setfieldz00_bglt BgL_ez00_2071;BgL_envz00_bglt BgL_envz00_2072;
BgL_ez00_2071 = 
(BgL_setfieldz00_bglt)(BgL_ez00_2854); 
BgL_envz00_2072 = 
(BgL_envz00_bglt)(BgL_envz00_2855); 
BGl_compilerzd2setfieldzd2zzjvm_compilerz00(BgL_ez00_2071, BgL_envz00_2072); 
{ /* Jvm/tail.scm 63 */
obj_t BgL_arg3638z00_2750;
BgL_arg3638z00_2750 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_2072, 
CNST_TABLE_REF(((long)0))); 
return 
BGl__getstaticz00zzjvm_instrz00(BgL_envz00_2072, BgL_arg3638z00_2750);} } } 
}



/* compile-tail-getfield2998 */
obj_t BGl_compilezd2tailzd2getfield2998z00zzjvm_tailz00(obj_t BgL_envz00_2856, obj_t BgL_ez00_2857, obj_t BgL_envz00_2858)
{ AN_OBJECT;
{ /* Jvm/tail.scm 58 */
{ 
BgL_getfieldz00_bglt BgL_ez00_2065;BgL_envz00_bglt BgL_envz00_2066;
BgL_ez00_2065 = 
(BgL_getfieldz00_bglt)(BgL_ez00_2857); 
BgL_envz00_2066 = 
(BgL_envz00_bglt)(BgL_envz00_2858); 
return 
BGl_compilerzd2getfieldzd2zzjvm_compilerz00(BgL_ez00_2065, BgL_envz00_2066);} } 
}



/* compile-tail-pragma2996 */
obj_t BGl_compilezd2tailzd2pragma2996z00zzjvm_tailz00(obj_t BgL_envz00_2859, obj_t BgL_ez00_2860, obj_t BgL_envz00_2861)
{ AN_OBJECT;
{ /* Jvm/tail.scm 55 */
{ 
BgL_pragmaz00_bglt BgL_ez00_2059;BgL_envz00_bglt BgL_envz00_2060;
BgL_ez00_2059 = 
(BgL_pragmaz00_bglt)(BgL_ez00_2860); 
BgL_envz00_2060 = 
(BgL_envz00_bglt)(BgL_envz00_2861); 
return 
BGl_compilerzd2pragmazd2zzjvm_compilerz00(BgL_ez00_2059, BgL_envz00_2060);} } 
}



/* compile-tail-funcall2994 */
obj_t BGl_compilezd2tailzd2funcall2994z00zzjvm_tailz00(obj_t BgL_envz00_2862, obj_t BgL_ez00_2863, obj_t BgL_envz00_2864)
{ AN_OBJECT;
{ /* Jvm/tail.scm 52 */
{ 
BgL_funcallz00_bglt BgL_ez00_2053;BgL_envz00_bglt BgL_envz00_2054;
BgL_ez00_2053 = 
(BgL_funcallz00_bglt)(BgL_ez00_2863); 
BgL_envz00_2054 = 
(BgL_envz00_bglt)(BgL_envz00_2864); 
return 
BGl_compilerzd2funcallzd2zzjvm_compilerz00(BgL_ez00_2053, BgL_envz00_2054);} } 
}



/* compile-tail-app-ly2992 */
obj_t BGl_compilezd2tailzd2appzd2ly2992zd2zzjvm_tailz00(obj_t BgL_envz00_2865, obj_t BgL_ez00_2866, obj_t BgL_envz00_2867)
{ AN_OBJECT;
{ /* Jvm/tail.scm 49 */
{ 
BgL_appzd2lyzd2_bglt BgL_ez00_2047;BgL_envz00_bglt BgL_envz00_2048;
BgL_ez00_2047 = 
(BgL_appzd2lyzd2_bglt)(BgL_ez00_2866); 
BgL_envz00_2048 = 
(BgL_envz00_bglt)(BgL_envz00_2867); 
return 
BGl_compilerzd2applyzd2zzjvm_compilerz00(BgL_ez00_2047, BgL_envz00_2048);} } 
}



/* compile-tail-app2990 */
obj_t BGl_compilezd2tailzd2app2990z00zzjvm_tailz00(obj_t BgL_envz00_2868, obj_t BgL_ez00_2869, obj_t BgL_envz00_2870)
{ AN_OBJECT;
{ /* Jvm/tail.scm 35 */
{ 
BgL_appz00_bglt BgL_ez00_2017;BgL_envz00_bglt BgL_envz00_2018;
BgL_ez00_2017 = 
(BgL_appz00_bglt)(BgL_ez00_2869); 
BgL_envz00_2018 = 
(BgL_envz00_bglt)(BgL_envz00_2870); 
{ /* Jvm/tail.scm 37 */
BgL_variablez00_bglt BgL_vz00_2022;
{ /* Jvm/tail.scm 37 */
BgL_varz00_bglt BgL_arg3599z00_2044;
BgL_arg3599z00_2044 = 
(((BgL_appz00_bglt)CREF(BgL_ez00_2017))->BgL_funz00); 
BgL_vz00_2022 = 
(((BgL_varz00_bglt)CREF(BgL_arg3599z00_2044))->BgL_variablez00); } 
{ /* Jvm/tail.scm 38 */
bool_t BgL_testz00_3024;
{ /* Jvm/tail.scm 38 */
obj_t BgL_auxz00_3027;obj_t BgL_auxz00_3025;
BgL_auxz00_3027 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_2018))->BgL_currentzd2methodzd2); 
BgL_auxz00_3025 = 
(obj_t)(BgL_vz00_2022); 
BgL_testz00_3024 = 
(BgL_auxz00_3025==BgL_auxz00_3027); } 
if(BgL_testz00_3024)
{ /* Jvm/tail.scm 39 */
obj_t BgL_paramsz00_2024;
{ /* Jvm/tail.scm 39 */
BgL_sfunz00_bglt BgL_obj1370z00_2738;
{ /* Jvm/tail.scm 39 */
BgL_valuez00_bglt BgL_auxz00_3030;
{ /* Jvm/tail.scm 39 */
BgL_globalz00_bglt BgL_obj1156z00_2737;
BgL_obj1156z00_2737 = 
(BgL_globalz00_bglt)(BgL_vz00_2022); 
BgL_auxz00_3030 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1156z00_2737))->BgL_valuez00); } 
BgL_obj1370z00_2738 = 
(BgL_sfunz00_bglt)(BgL_auxz00_3030); } 
BgL_paramsz00_2024 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1370z00_2738))->BgL_argsz00); } 
{ 
obj_t BgL_l2967z00_2025;
BgL_l2967z00_2025 = 
(((BgL_appz00_bglt)CREF(BgL_ez00_2017))->BgL_argsz00); 
BgL_lname2968z00_2026:
if(
PAIRP(BgL_l2967z00_2025))
{ /* Jvm/tail.scm 40 */
{ /* Jvm/tail.scm 40 */
BgL_nodez00_bglt BgL_auxz00_3037;
{ /* Jvm/tail.scm 40 */
obj_t BgL_auxz00_3038;
BgL_auxz00_3038 = 
CAR(BgL_l2967z00_2025); 
BgL_auxz00_3037 = 
(BgL_nodez00_bglt)(BgL_auxz00_3038); } 
BGl_compilezd2exprzd2zzjvm_exprz00(BgL_auxz00_3037, BgL_envz00_2018); } 
{ 
obj_t BgL_l2967z00_3042;
BgL_l2967z00_3042 = 
CDR(BgL_l2967z00_2025); 
BgL_l2967z00_2025 = BgL_l2967z00_3042; 
goto BgL_lname2968z00_2026;} }  else 
{ /* Jvm/tail.scm 40 */((bool_t)1); } } 
{ 
obj_t BgL_l2969z00_2031;
BgL_l2969z00_2031 = 
bgl_reverse(BgL_paramsz00_2024); 
BgL_lname2970z00_2032:
if(
PAIRP(BgL_l2969z00_2031))
{ /* Jvm/tail.scm 41 */
{ /* Jvm/tail.scm 41 */
BgL_localz00_bglt BgL_auxz00_3047;
{ /* Jvm/tail.scm 41 */
obj_t BgL_auxz00_3048;
BgL_auxz00_3048 = 
CAR(BgL_l2969z00_2031); 
BgL_auxz00_3047 = 
(BgL_localz00_bglt)(BgL_auxz00_3048); } 
BGl__storez00zzjvm_instrz00(BgL_envz00_2018, BgL_auxz00_3047); } 
{ 
obj_t BgL_l2969z00_3052;
BgL_l2969z00_3052 = 
CDR(BgL_l2969z00_2031); 
BgL_l2969z00_2031 = BgL_l2969z00_3052; 
goto BgL_lname2970z00_2032;} }  else 
{ /* Jvm/tail.scm 41 */((bool_t)1); } } 
{ /* Jvm/tail.scm 44 */
obj_t BgL_arg3574z00_2037;
{ /* Jvm/tail.scm 44 */
obj_t BgL_arg3577z00_2038;obj_t BgL_arg3578z00_2039;
{ /* Jvm/tail.scm 44 */
obj_t BgL_arg3581z00_2040;
{ /* Jvm/tail.scm 44 */
obj_t BgL_auxz00_3055;
{ /* Jvm/tail.scm 44 */
BgL_typez00_bglt BgL_auxz00_3056;
{ /* Jvm/tail.scm 44 */
BgL_globalz00_bglt BgL_obj1153z00_2746;
BgL_obj1153z00_2746 = 
(BgL_globalz00_bglt)(BgL_vz00_2022); 
BgL_auxz00_3056 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1153z00_2746))->BgL_typez00); } 
BgL_auxz00_3055 = 
(obj_t)(BgL_auxz00_3056); } 
BgL_arg3581z00_2040 = 
BGl_compilezd2typezd2zzjvm_envz00(BgL_auxz00_3055, BgL_envz00_2018); } 
BgL_arg3577z00_2038 = 
BGl_simplezd2typezd2zzjvm_instrz00(BgL_arg3581z00_2040); } 
BgL_arg3578z00_2039 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_2018))->BgL_stackz00); 
BgL_arg3574z00_2037 = 
MAKE_PAIR(BgL_arg3577z00_2038, BgL_arg3578z00_2039); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_2018))->BgL_stackz00) = ((obj_t)BgL_arg3574z00_2037), BUNSPEC); } 
return 
BGl__gotoz00zzjvm_instrz00(BgL_envz00_2018, 
CNST_TABLE_REF(((long)1)));}  else 
{ /* Jvm/tail.scm 38 */
return 
BGl_compilerzd2appzd2zzjvm_compilerz00(BgL_ez00_2017, BgL_envz00_2018);} } } } } 
}



/* compile-tail-let-fun2988 */
obj_t BGl_compilezd2tailzd2letzd2fun2988zd2zzjvm_tailz00(obj_t BgL_envz00_2871, obj_t BgL_ez00_2872, obj_t BgL_envz00_2873)
{ AN_OBJECT;
{ /* Jvm/tail.scm 32 */
{ 
BgL_letzd2funzd2_bglt BgL_ez00_2011;BgL_envz00_bglt BgL_envz00_2012;
BgL_ez00_2011 = 
(BgL_letzd2funzd2_bglt)(BgL_ez00_2872); 
BgL_envz00_2012 = 
(BgL_envz00_bglt)(BgL_envz00_2873); 
return 
BGl_compilerzd2labelszd2zzjvm_compilerz00(BgL_ez00_2011, BgL_envz00_2012, BGl_compilezd2tailzd2envz00zzjvm_tailz00);} } 
}



/* compile-tail-select2986 */
obj_t BGl_compilezd2tailzd2select2986z00zzjvm_tailz00(obj_t BgL_envz00_2874, obj_t BgL_ez00_2875, obj_t BgL_envz00_2876)
{ AN_OBJECT;
{ /* Jvm/tail.scm 29 */
{ 
BgL_selectz00_bglt BgL_ez00_2005;BgL_envz00_bglt BgL_envz00_2006;
BgL_ez00_2005 = 
(BgL_selectz00_bglt)(BgL_ez00_2875); 
BgL_envz00_2006 = 
(BgL_envz00_bglt)(BgL_envz00_2876); 
return 
BGl_compilerzd2selectzd2zzjvm_compilerz00(BgL_ez00_2005, BgL_envz00_2006, BGl_compilezd2tailzd2envz00zzjvm_tailz00);} } 
}



/* compile-tail-conditional2984 */
obj_t BGl_compilezd2tailzd2conditional2984z00zzjvm_tailz00(obj_t BgL_envz00_2877, obj_t BgL_ez00_2878, obj_t BgL_envz00_2879)
{ AN_OBJECT;
{ /* Jvm/tail.scm 26 */
{ 
BgL_conditionalz00_bglt BgL_ez00_1999;BgL_envz00_bglt BgL_envz00_2000;
BgL_ez00_1999 = 
(BgL_conditionalz00_bglt)(BgL_ez00_2878); 
BgL_envz00_2000 = 
(BgL_envz00_bglt)(BgL_envz00_2879); 
return 
BGl_compilerzd2ifzd2zzjvm_compilerz00(BgL_ez00_1999, BgL_envz00_2000, BGl_compilezd2tailzd2envz00zzjvm_tailz00);} } 
}



/* compile-tail-sequence2982 */
obj_t BGl_compilezd2tailzd2sequence2982z00zzjvm_tailz00(obj_t BgL_envz00_2880, obj_t BgL_ez00_2881, obj_t BgL_envz00_2882)
{ AN_OBJECT;
{ /* Jvm/tail.scm 23 */
{ 
BgL_sequencez00_bglt BgL_ez00_1993;BgL_envz00_bglt BgL_envz00_1994;
BgL_ez00_1993 = 
(BgL_sequencez00_bglt)(BgL_ez00_2881); 
BgL_envz00_1994 = 
(BgL_envz00_bglt)(BgL_envz00_2882); 
return 
BGl_compilerzd2sequencezd2zzjvm_compilerz00(BgL_ez00_1993, BgL_envz00_1994, BGl_compilezd2tailzd2envz00zzjvm_tailz00);} } 
}



/* compile-tail-setq2980 */
obj_t BGl_compilezd2tailzd2setq2980z00zzjvm_tailz00(obj_t BgL_envz00_2883, obj_t BgL_ez00_2884, obj_t BgL_envz00_2885)
{ AN_OBJECT;
{ /* Jvm/tail.scm 19 */
{ 
BgL_setqz00_bglt BgL_ez00_1986;BgL_envz00_bglt BgL_envz00_1987;
BgL_ez00_1986 = 
(BgL_setqz00_bglt)(BgL_ez00_2884); 
BgL_envz00_1987 = 
(BgL_envz00_bglt)(BgL_envz00_2885); 
BGl_compilerzd2setqzd2zzjvm_compilerz00(BgL_ez00_1986, BgL_envz00_1987); 
{ /* Jvm/tail.scm 21 */
obj_t BgL_arg3511z00_2733;
BgL_arg3511z00_2733 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_1987, 
CNST_TABLE_REF(((long)0))); 
return 
BGl__getstaticz00zzjvm_instrz00(BgL_envz00_1987, BgL_arg3511z00_2733);} } } 
}



/* compile-tail-let-var2978 */
obj_t BGl_compilezd2tailzd2letzd2var2978zd2zzjvm_tailz00(obj_t BgL_envz00_2886, obj_t BgL_ez00_2887, obj_t BgL_envz00_2888)
{ AN_OBJECT;
{ /* Jvm/tail.scm 16 */
{ 
BgL_letzd2varzd2_bglt BgL_ez00_1980;BgL_envz00_bglt BgL_envz00_1981;
BgL_ez00_1980 = 
(BgL_letzd2varzd2_bglt)(BgL_ez00_2887); 
BgL_envz00_1981 = 
(BgL_envz00_bglt)(BgL_envz00_2888); 
return 
BGl_compilerzd2letzd2zzjvm_compilerz00(BgL_ez00_1980, BgL_envz00_1981, BGl_compilezd2tailzd2envz00zzjvm_tailz00);} } 
}



/* compile-tail-var2976 */
obj_t BGl_compilezd2tailzd2var2976z00zzjvm_tailz00(obj_t BgL_envz00_2889, obj_t BgL_ez00_2890, obj_t BgL_envz00_2891)
{ AN_OBJECT;
{ /* Jvm/tail.scm 13 */
{ 
BgL_varz00_bglt BgL_ez00_1974;BgL_envz00_bglt BgL_envz00_1975;
BgL_ez00_1974 = 
(BgL_varz00_bglt)(BgL_ez00_2890); 
BgL_envz00_1975 = 
(BgL_envz00_bglt)(BgL_envz00_2891); 
return 
BGl_compilerzd2varzd2zzjvm_compilerz00(BgL_ez00_1974, BgL_envz00_1975);} } 
}



/* compile-tail-atom2974 */
obj_t BGl_compilezd2tailzd2atom2974z00zzjvm_tailz00(obj_t BgL_envz00_2892, obj_t BgL_ez00_2893, obj_t BgL_envz00_2894)
{ AN_OBJECT;
{ /* Jvm/tail.scm 10 */
{ 
BgL_atomz00_bglt BgL_ez00_1968;BgL_envz00_bglt BgL_envz00_1969;
BgL_ez00_1968 = 
(BgL_atomz00_bglt)(BgL_ez00_2893); 
BgL_envz00_1969 = 
(BgL_envz00_bglt)(BgL_envz00_2894); 
return 
BGl_compilerzd2atomzd2zzjvm_compilerz00(
(obj_t)(BgL_ez00_1968), BgL_envz00_1969);} } 
}



/* compile-tail */
obj_t BGl_compilezd2tailzd2zzjvm_tailz00(BgL_nodez00_bglt BgL_ez00_1, BgL_envz00_bglt BgL_envz00_2)
{ AN_OBJECT;
{ /* Jvm/tail.scm 8 */
{ /* Jvm/tail.scm 8 */
obj_t BgL_method2972z00_2753;
{ /* Jvm/tail.scm 8 */
long BgL_objzd2classzd2numz00_2755;
{ /* Jvm/tail.scm 8 */
BgL_objectz00_bglt BgL_auxz00_3098;
BgL_auxz00_3098 = 
(BgL_objectz00_bglt)(BgL_ez00_1); 
BgL_objzd2classzd2numz00_2755 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_3098); } 
{ /* Jvm/tail.scm 8 */
obj_t BgL_arg1904z00_2756;
{ /* Jvm/tail.scm 8 */
int BgL_auxz00_3101;
BgL_auxz00_3101 = 
(int)(((long)1)); 
BgL_arg1904z00_2756 = 
PROCEDURE_REF(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BgL_auxz00_3101); } 
{ /* Jvm/tail.scm 8 */
long BgL_offsetz00_2760;
{ /* Jvm/tail.scm 8 */
long BgL_auxz00_3104;
{ /* Jvm/tail.scm 8 */
int BgL_auxz00_3105;
BgL_auxz00_3105 = 
(int)(BgL_objzd2classzd2numz00_2755); 
BgL_auxz00_3104 = 
(long)(BgL_auxz00_3105); } 
BgL_offsetz00_2760 = 
(BgL_auxz00_3104-OBJECT_TYPE); } 
{ /* Jvm/tail.scm 8 */
long BgL_modz00_2761;
{ /* Jvm/tail.scm 8 */
long BgL_auxz00_3109;
{ /* Jvm/tail.scm 8 */
int BgL_auxz00_3110;
BgL_auxz00_3110 = 
(int)(((long)8)); 
BgL_auxz00_3109 = 
(long)(BgL_auxz00_3110); } 
BgL_modz00_2761 = 
(BgL_offsetz00_2760/BgL_auxz00_3109); } 
{ /* Jvm/tail.scm 8 */
long BgL_restz00_2763;
{ /* Jvm/tail.scm 8 */
long BgL_auxz00_3114;
{ /* Jvm/tail.scm 8 */
int BgL_auxz00_3115;
BgL_auxz00_3115 = 
(int)(((long)8)); 
BgL_auxz00_3114 = 
(long)(BgL_auxz00_3115); } 
BgL_restz00_2763 = 
(BgL_offsetz00_2760%BgL_auxz00_3114); } 
{ /* Jvm/tail.scm 8 */

{ /* Jvm/tail.scm 8 */
obj_t BgL_bucketz00_2765;
{ /* Jvm/tail.scm 8 */
int BgL_kz00_2775;
BgL_kz00_2775 = 
(int)(BgL_modz00_2761); 
BgL_bucketz00_2765 = 
VECTOR_REF(BgL_arg1904z00_2756,BgL_kz00_2775); } 
{ /* Jvm/tail.scm 8 */
int BgL_kz00_2777;
BgL_kz00_2777 = 
(int)(BgL_restz00_2763); 
BgL_method2972z00_2753 = 
VECTOR_REF(BgL_bucketz00_2765,BgL_kz00_2777); } } } } } } } } 
return 
PROCEDURE_ENTRY(BgL_method2972z00_2753)(BgL_method2972z00_2753, 
(obj_t)(BgL_ez00_1), 
(obj_t)(BgL_envz00_2), BEOA);} } 
}



/* _compile-tail3766 */
obj_t BGl__compilezd2tail3766zd2zzjvm_tailz00(obj_t BgL_envz00_2791, obj_t BgL_ez00_2792, obj_t BgL_envz00_2793)
{ AN_OBJECT;
{ /* Jvm/tail.scm 8 */
return 
BGl_compilezd2tailzd2zzjvm_tailz00(
(BgL_nodez00_bglt)(BgL_ez00_2792), 
(BgL_envz00_bglt)(BgL_envz00_2793));} 
}



/* compile-tail-default2971 */
obj_t BGl_compilezd2tailzd2default2971z00zzjvm_tailz00(BgL_nodez00_bglt BgL_ez00_3, BgL_envz00_bglt BgL_envz00_4)
{ AN_OBJECT;
{ /* Jvm/tail.scm 2 */
{ 
obj_t BgL_auxz00_3132;obj_t BgL_auxz00_3130;
BgL_auxz00_3132 = 
(obj_t)(BgL_ez00_3); 
BgL_auxz00_3130 = 
CNST_TABLE_REF(((long)2)); 
FAILURE(BgL_auxz00_3130,BGl_string3930z00zzjvm_tailz00,BgL_auxz00_3132);} } 
}



/* _compile-tail-default2971 */
obj_t BGl__compilezd2tailzd2default2971z00zzjvm_tailz00(obj_t BgL_envz00_2895, obj_t BgL_ez00_2896, obj_t BgL_envz00_2897)
{ AN_OBJECT;
{ /* Jvm/tail.scm 2 */
return 
BGl_compilezd2tailzd2default2971z00zzjvm_tailz00(
(BgL_nodez00_bglt)(BgL_ez00_2896), 
(BgL_envz00_bglt)(BgL_envz00_2897));} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzjvm_tailz00()
{ AN_OBJECT;
{ /* Jvm/tail.scm 2 */
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19010), "jvm_tail"); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)28259), "jvm_tail"); 
BGl_modulezd2initializa7ationz75zzast_nodez00(((long)49436), "jvm_tail"); 
BGl_modulezd2initializa7ationz75zzobject_classz00(((long)19348), "jvm_tail"); 
BGl_modulezd2initializa7ationz75zzjvm_envz00(((long)47084), "jvm_tail"); 
BGl_modulezd2initializa7ationz75zzjvm_instrz00(((long)9877), "jvm_tail"); 
BGl_modulezd2initializa7ationz75zzjvm_exprz00(((long)25448), "jvm_tail"); 
return 
BGl_modulezd2initializa7ationz75zzjvm_compilerz00(((long)63858), "jvm_tail");} 
}

