/*===========================================================================*/
/*   (Module/class.scm)                                                      */
/*   Bigloo (2.5b)                                                           */
/*   Manuel Serrano (c)       Fri Sep 6 09:43:28 CEST 2002                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_ccompz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_producerz00;
   obj_t BgL_consumerz00;
   obj_t BgL_finaliza7erza7;
} *BgL_ccompz00_bglt;

typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_tclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   struct BgL_globalz00_bgl * BgL_holderz00;
   obj_t BgL_wideningz00;
   long BgL_depthz00;
   bool_t BgL_finalzf3zf3;
   obj_t BgL_constructorz00;
   obj_t BgL_virtualzd2slotszd2numberz00;
   bool_t BgL_abstractzf3zf3;
} *BgL_tclassz00_bglt;

typedef struct BgL_jclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   obj_t BgL_packagez00;
} *BgL_jclassz00_bglt;


extern obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
extern obj_t BGl_idzd2ofzd2idz00zzast_identz00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zzmodule_classz00();
extern long get_hash_power_number(char *, long);
static obj_t BGl_za2objectzd2unitza2zd2zzmodule_classz00 = BUNSPEC;
static obj_t BGl_za2methodzd2unitza2zd2zzmodule_classz00 = BUNSPEC;
extern obj_t open_input_string(obj_t);
extern obj_t BGl_producezd2modulezd2clausez12z12zzmodule_modulez00(obj_t);
static obj_t BGl_zc3anonymousza31859ze3z83zzmodule_classz00(obj_t);
extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
extern obj_t BGl_readz00zz__readerz00(obj_t);
extern bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
extern obj_t BGl_tclassz00zzobject_classz00;
extern bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
extern obj_t BGl_za2moduleza2z00zzmodule_modulez00;
extern obj_t BGl_fastzd2idzd2ofzd2idzd2zzast_identz00(obj_t, obj_t);
extern obj_t BGl_findzd2locationzd2zztools_locationz00(obj_t);
extern obj_t BGl_typez00zztype_typez00;
static obj_t BGl__classzd2finaliza7erz75zzmodule_classz00(obj_t);
static BgL_typez00_bglt BGl_declarezd2exportzd2classz12z12zzmodule_classz00(obj_t, obj_t, obj_t, obj_t, bool_t, obj_t, obj_t, obj_t);
extern obj_t BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(obj_t);
extern obj_t BGl_importzd2parserzd2zzmodule_impusez00(obj_t, obj_t, obj_t);
extern obj_t BGl_globalzd2setzd2readzd2onlyz12zc0zzast_varz00(BgL_globalz00_bglt);
static obj_t BGl_cnstzd2initzd2zzmodule_classz00();
static obj_t BGl_zc3anonymousza31891ze3z83zzmodule_classz00(obj_t);
extern obj_t BGl_getzd2classzd2hashz00zzmodule_classz00(obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zzmodule_classz00();
static obj_t BGl_makezd2slotzd2fieldz00zzmodule_classz00(obj_t, obj_t, obj_t);
extern obj_t BGl_findzd2locationzf2locz20zztools_locationz00(obj_t, obj_t);
static obj_t BGl__delayzd2classzd2accessorsz12z12zzmodule_classz00(obj_t, obj_t, obj_t);
static obj_t BGl_za2classzd2accessesza2zd2zzmodule_classz00 = BUNSPEC;
static obj_t BGl__getzd2classzd2hashz00zzmodule_classz00(obj_t, obj_t, obj_t);
static obj_t BGl_za2declaredzd2classesza2zd2zzmodule_classz00 = BUNSPEC;
static obj_t BGl_toplevelzd2initzd2zzmodule_classz00();
extern obj_t string_append_3(obj_t, obj_t, obj_t);
extern obj_t BGl_jclassz00zzobject_classz00;
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_classz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_impusez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_includez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_plainzd2accesszd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_widezd2accesszd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
static obj_t BGl_findzd2infozd2attributez00zzmodule_classz00(obj_t);
static obj_t BGl_forcezd2classzd2accessesz00zzmodule_classz00();
extern BgL_typez00_bglt BGl_delayzd2classzd2accessorsz12z12zzmodule_classz00(BgL_typez00_bglt, obj_t);
static obj_t BGl_makezd2addzd2classz12z12zzmodule_classz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_declarezd2classz12zc0zzmodule_classz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t);
static obj_t BGl__declarezd2classz12zc0zzmodule_classz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t string_append(obj_t, obj_t);
static obj_t BGl_makezd2classzd2fieldsz00zzmodule_classz00(obj_t, obj_t, obj_t);
static bool_t BGl_readzd2onlyzf3z21zzmodule_classz00(obj_t);
static BgL_typez00_bglt BGl_declarezd2importzd2classz12z12zzmodule_classz00(obj_t, obj_t, obj_t, obj_t, bool_t, obj_t, obj_t);
extern obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl__declarezd2widezd2classz12z12zzmodule_classz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_declarezd2widezd2classz12z12zzmodule_classz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
extern obj_t create_struct(obj_t, int);
extern obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
static obj_t BGl__getzd2methodzd2unitz00zzmodule_classz00(obj_t);
extern obj_t bgl_append2(obj_t, obj_t);
extern BgL_typez00_bglt BGl_declarezd2classzd2typez12z12zzobject_classz00(obj_t, BgL_globalz00_bglt, obj_t, bool_t, bool_t, obj_t);
extern obj_t BGl_makezd2promisezd2zz__r4_control_features_6_9z00(obj_t);
static obj_t BGl_requirezd2initializa7ationz75zzmodule_classz00 = BUNSPEC;
extern obj_t BGl_classzd2finaliza7erz75zzmodule_classz00();
extern obj_t BGl_getzd2objectzd2unitz00zzmodule_classz00();
static obj_t BGl__getzd2objectzd2unitz00zzmodule_classz00(obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zzmodule_classz00();
extern obj_t BGl_za2debugzd2moduleza2zd2zzengine_paramz00;
extern obj_t BGl_getzd2methodzd2unitz00zzmodule_classz00();
static obj_t __cnst[ 34 ] ;

DEFINE_EXPORT_PROCEDURE( BGl_getzd2classzd2hashzd2envzd2zzmodule_classz00, BgL_bgl__getza7d2classza7d2hashza700za7za7module_classza7003355z00, BGl__getzd2classzd2hashz00zzmodule_classz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_delayzd2classzd2accessorsz12zd2envzc0zzmodule_classz00, BgL_bgl__delayza7d2classza7d2accessorsza712za712za7za7module_classza7003356za7, BGl__delayzd2classzd2accessorsz12z12zzmodule_classz00, 0L, 2 );
extern obj_t BGl_importzd2plainzd2classzd2accessorsz12zd2envz12zzobject_plainzd2accesszd2;
DEFINE_EXPORT_PROCEDURE( BGl_getzd2objectzd2unitzd2envzd2zzmodule_classz00, BgL_bgl__getza7d2objectza7d2unitza700za7za7module_classza7003357z00, BGl__getzd2objectzd2unitz00zzmodule_classz00, 0L, 0 );
DEFINE_STRING( BGl_string3325z00zzmodule_classz00, BgL_bgl_string3325za700za7za7module_classza7003358z00, "method unit (#unspecified) object pragma::int begin void -len -ref -set! - make-class-field get info read-only list * cons vector __object register-class! define @ quote error x lambda allocate- make- widening wide plain final (export static) ", 243 );
DEFINE_STRING( BGl_string3324z00zzmodule_classz00, BgL_bgl_string3324za700za7za7module_classza7003359z00, "\")", 2 );
DEFINE_STRING( BGl_string3323z00zzmodule_classz00, BgL_bgl_string3323za700za7za7module_classza7003360z00, "puts(\"    Module init (object): ", 32 );
DEFINE_STRING( BGl_string3322z00zzmodule_classz00, BgL_bgl_string3322za700za7za7module_classza7003361z00, "Illegal slot definition", 23 );
DEFINE_STRING( BGl_string3321z00zzmodule_classz00, BgL_bgl_string3321za700za7za7module_classza7003362z00, "make-class-fields", 17 );
DEFINE_STRING( BGl_string3320z00zzmodule_classz00, BgL_bgl_string3320za700za7za7module_classza7003363z00, "* ", 2 );
DEFINE_STRING( BGl_string3319z00zzmodule_classz00, BgL_bgl_string3319za700za7za7module_classza7003364z00, "Can't allocate instance of abstract classes", 43 );
DEFINE_STRING( BGl_string3318z00zzmodule_classz00, BgL_bgl_string3318za700za7za7module_classza7003365z00, "Can't make instance of abstract classes", 39 );
DEFINE_EXPORT_PROCEDURE( BGl_declarezd2classz12zd2envz12zzmodule_classz00, BgL_bgl__declareza7d2classza712za7c0za7za7module_classza7003366z00, BGl__declarezd2classz12zc0zzmodule_classz00, 0L, 7 );
extern obj_t BGl_genzd2widezd2classzd2accessorsz12zd2envz12zzobject_widezd2accesszd2;
extern obj_t BGl_genzd2plainzd2classzd2accessorsz12zd2envz12zzobject_plainzd2accesszd2;
DEFINE_EXPORT_PROCEDURE( BGl_classzd2finaliza7erzd2envza7zzmodule_classz00, BgL_bgl__classza7d2finaliza7a7erza775za7za7module_classza7003367z00, BGl__classzd2finaliza7erz75zzmodule_classz00, 0L, 0 );
DEFINE_EXPORT_PROCEDURE( BGl_declarezd2widezd2classz12zd2envzc0zzmodule_classz00, BgL_bgl__declareza7d2wideza7d2classza712za712za7za7module_classza7003368za7, BGl__declarezd2widezd2classz12z12zzmodule_classz00, 0L, 5 );
DEFINE_EXPORT_PROCEDURE( BGl_getzd2methodzd2unitzd2envzd2zzmodule_classz00, BgL_bgl__getza7d2methodza7d2unitza700za7za7module_classza7003369z00, BGl__getzd2methodzd2unitz00zzmodule_classz00, 0L, 0 );
extern obj_t BGl_importzd2widezd2classzd2accessorsz12zd2envz12zzobject_widezd2accesszd2;



/* module-initialization */
obj_t BGl_modulezd2initializa7ationz75zzmodule_classz00(long BgL_checksumz00_2004, char * BgL_fromz00_2005)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzmodule_classz00))
{ 
BGl_requirezd2initializa7ationz75zzmodule_classz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzmodule_classz00(); 
BGl_cnstzd2initzd2zzmodule_classz00(); 
BGl_importedzd2moduleszd2initz00zzmodule_classz00(); 
BGl_toplevelzd2initzd2zzmodule_classz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzmodule_classz00()
{ AN_OBJECT;
{ /* Module/class.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "module_class"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "module_class"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "module_class"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "module_class"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "module_class"); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)0), "module_class"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzmodule_classz00()
{ AN_OBJECT;
{ /* Module/class.scm 15 */
{ /* Module/class.scm 15 */
obj_t BgL_cportz00_1997;
BgL_cportz00_1997 = 
open_input_string(BGl_string3325z00zzmodule_classz00); 
{ 
long BgL_iz00_1998;
BgL_iz00_1998 = ((long)33); 
BgL_loopz00_1999:
if(
(BgL_iz00_1998==((long)-1)))
{ /* Module/class.scm 15 */
return BUNSPEC;}  else 
{ /* Module/class.scm 15 */
{ /* Module/class.scm 15 */
obj_t BgL_arg3329z00_2001;
{ /* Module/class.scm 15 */
obj_t BgL_list3332z00_2002;
BgL_list3332z00_2002 = 
MAKE_PAIR(BgL_cportz00_1997, BNIL); 
BgL_arg3329z00_2001 = 
BGl_readz00zz__readerz00(BgL_list3332z00_2002); } 
{ /* Module/class.scm 15 */
int BgL_auxz00_2024;
BgL_auxz00_2024 = 
(int)(BgL_iz00_1998); 
CNST_TABLE_SET(BgL_auxz00_2024, BgL_arg3329z00_2001); } } 
{ 
long BgL_iz00_2027;
{ /* Module/class.scm 15 */
int BgL_auxz00_2028;
{ /* Module/class.scm 15 */
long BgL_auxz00_2029;
BgL_auxz00_2029 = 
(BgL_iz00_1998-((long)1)); 
BgL_auxz00_2028 = 
(int)(BgL_auxz00_2029); } 
BgL_iz00_2027 = 
(long)(BgL_auxz00_2028); } 
BgL_iz00_1998 = BgL_iz00_2027; 
goto BgL_loopz00_1999;} } } } } 
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zzmodule_classz00()
{ AN_OBJECT;
{ /* Module/class.scm 15 */
BGl_za2objectzd2unitza2zd2zzmodule_classz00 = BUNSPEC; 
BGl_za2methodzd2unitza2zd2zzmodule_classz00 = BUNSPEC; 
BGl_za2classzd2accessesza2zd2zzmodule_classz00 = BNIL; 
return ( 
BGl_za2declaredzd2classesza2zd2zzmodule_classz00 = BNIL, BUNSPEC) ;} 
}



/* get-object-unit */
obj_t BGl_getzd2objectzd2unitz00zzmodule_classz00()
{ AN_OBJECT;
{ /* Module/class.scm 50 */
return BGl_za2objectzd2unitza2zd2zzmodule_classz00;} 
}



/* _get-object-unit */
obj_t BGl__getzd2objectzd2unitz00zzmodule_classz00(obj_t BgL_envz00_1936)
{ AN_OBJECT;
{ /* Module/class.scm 50 */
return 
BGl_getzd2objectzd2unitz00zzmodule_classz00();} 
}



/* get-method-unit */
obj_t BGl_getzd2methodzd2unitz00zzmodule_classz00()
{ AN_OBJECT;
{ /* Module/class.scm 56 */
return BGl_za2methodzd2unitza2zd2zzmodule_classz00;} 
}



/* _get-method-unit */
obj_t BGl__getzd2methodzd2unitz00zzmodule_classz00(obj_t BgL_envz00_1937)
{ AN_OBJECT;
{ /* Module/class.scm 56 */
return 
BGl_getzd2methodzd2unitz00zzmodule_classz00();} 
}



/* declare-class! */
obj_t BGl_declarezd2classz12zc0zzmodule_classz00(obj_t BgL_classzd2defzd2_19, obj_t BgL_modulez00_20, obj_t BgL_importz00_21, bool_t BgL_finalzf3zf3_22, bool_t BgL_abstractzf3zf3_23, obj_t BgL_defzd2srczd2_24, obj_t BgL_declzd2srczd2_25)
{ AN_OBJECT;
{ /* Module/class.scm 62 */
{ /* Module/class.scm 64 */
bool_t BgL_testz00_2035;
{ /* Module/class.scm 64 */
obj_t BgL_auxz00_2036;
BgL_auxz00_2036 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_importz00_21, 
CNST_TABLE_REF(((long)0))); 
BgL_testz00_2035 = 
CBOOL(BgL_auxz00_2036); } 
if(BgL_testz00_2035)
{ /* Module/class.scm 64 */
{ /* Module/class.scm 64 */
BgL_typez00_bglt BgL_auxz00_2040;
{ /* Module/class.scm 64 */
obj_t BgL_auxz00_2041;
if(BgL_finalzf3zf3_22)
{ /* Module/class.scm 64 */
BgL_auxz00_2041 = 
CNST_TABLE_REF(((long)1))
; }  else 
{ /* Module/class.scm 64 */
BgL_auxz00_2041 = 
CNST_TABLE_REF(((long)2))
; } 
BgL_auxz00_2040 = 
BGl_declarezd2exportzd2classz12z12zzmodule_classz00(BGl_genzd2plainzd2classzd2accessorsz12zd2envz12zzobject_plainzd2accesszd2, BgL_classzd2defzd2_19, BgL_modulez00_20, BgL_auxz00_2041, BgL_abstractzf3zf3_23, BgL_defzd2srczd2_24, BgL_declzd2srczd2_25, BgL_importz00_21); } 
return 
(obj_t)(BgL_auxz00_2040);} }  else 
{ /* Module/class.scm 64 */
{ /* Module/class.scm 64 */
BgL_typez00_bglt BgL_auxz00_2047;
{ /* Module/class.scm 64 */
obj_t BgL_auxz00_2048;
if(BgL_finalzf3zf3_22)
{ /* Module/class.scm 64 */
BgL_auxz00_2048 = 
CNST_TABLE_REF(((long)1))
; }  else 
{ /* Module/class.scm 64 */
BgL_auxz00_2048 = 
CNST_TABLE_REF(((long)2))
; } 
BgL_auxz00_2047 = 
BGl_declarezd2importzd2classz12z12zzmodule_classz00(BGl_importzd2plainzd2classzd2accessorsz12zd2envz12zzobject_plainzd2accesszd2, BgL_classzd2defzd2_19, BgL_modulez00_20, BgL_auxz00_2048, BgL_abstractzf3zf3_23, BgL_defzd2srczd2_24, BgL_declzd2srczd2_25); } 
return 
(obj_t)(BgL_auxz00_2047);} } } } 
}



/* _declare-class! */
obj_t BGl__declarezd2classz12zc0zzmodule_classz00(obj_t BgL_envz00_1938, obj_t BgL_classzd2defzd2_1939, obj_t BgL_modulez00_1940, obj_t BgL_importz00_1941, obj_t BgL_finalzf3zf3_1942, obj_t BgL_abstractzf3zf3_1943, obj_t BgL_defzd2srczd2_1944, obj_t BgL_declzd2srczd2_1945)
{ AN_OBJECT;
{ /* Module/class.scm 62 */
return 
BGl_declarezd2classz12zc0zzmodule_classz00(BgL_classzd2defzd2_1939, BgL_modulez00_1940, BgL_importz00_1941, 
CBOOL(BgL_finalzf3zf3_1942), 
CBOOL(BgL_abstractzf3zf3_1943), BgL_defzd2srczd2_1944, BgL_declzd2srczd2_1945);} 
}



/* declare-wide-class! */
obj_t BGl_declarezd2widezd2classz12z12zzmodule_classz00(obj_t BgL_classzd2defzd2_26, obj_t BgL_modulez00_27, obj_t BgL_importz00_28, obj_t BgL_defzd2srczd2_29, obj_t BgL_declzd2srczd2_30)
{ AN_OBJECT;
{ /* Module/class.scm 80 */
{ /* Module/class.scm 82 */
bool_t BgL_testz00_2057;
{ /* Module/class.scm 82 */
obj_t BgL_auxz00_2058;
BgL_auxz00_2058 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_importz00_28, 
CNST_TABLE_REF(((long)0))); 
BgL_testz00_2057 = 
CBOOL(BgL_auxz00_2058); } 
if(BgL_testz00_2057)
{ /* Module/class.scm 82 */
{ /* Module/class.scm 82 */
BgL_typez00_bglt BgL_auxz00_2062;
BgL_auxz00_2062 = 
BGl_declarezd2exportzd2classz12z12zzmodule_classz00(BGl_genzd2widezd2classzd2accessorsz12zd2envz12zzobject_widezd2accesszd2, BgL_classzd2defzd2_26, BgL_modulez00_27, 
CNST_TABLE_REF(((long)3)), ((bool_t)0), BgL_defzd2srczd2_29, BgL_declzd2srczd2_30, BgL_importz00_28); 
return 
(obj_t)(BgL_auxz00_2062);} }  else 
{ /* Module/class.scm 82 */
{ /* Module/class.scm 82 */
BgL_typez00_bglt BgL_auxz00_2066;
BgL_auxz00_2066 = 
BGl_declarezd2importzd2classz12z12zzmodule_classz00(BGl_importzd2widezd2classzd2accessorsz12zd2envz12zzobject_widezd2accesszd2, BgL_classzd2defzd2_26, BgL_modulez00_27, 
CNST_TABLE_REF(((long)3)), ((bool_t)0), BgL_defzd2srczd2_29, BgL_declzd2srczd2_30); 
return 
(obj_t)(BgL_auxz00_2066);} } } } 
}



/* _declare-wide-class! */
obj_t BGl__declarezd2widezd2classz12z12zzmodule_classz00(obj_t BgL_envz00_1956, obj_t BgL_classzd2defzd2_1957, obj_t BgL_modulez00_1958, obj_t BgL_importz00_1959, obj_t BgL_defzd2srczd2_1960, obj_t BgL_declzd2srczd2_1961)
{ AN_OBJECT;
{ /* Module/class.scm 80 */
return 
BGl_declarezd2widezd2classz12z12zzmodule_classz00(BgL_classzd2defzd2_1957, BgL_modulez00_1958, BgL_importz00_1959, BgL_defzd2srczd2_1960, BgL_declzd2srczd2_1961);} 
}



/* declare-export-class! */
BgL_typez00_bglt BGl_declarezd2exportzd2classz12z12zzmodule_classz00(obj_t BgL_genz00_31, obj_t BgL_cdefz00_32, obj_t BgL_modulez00_33, obj_t BgL_kindz00_34, bool_t BgL_abstractzf3zf3_35, obj_t BgL_srczd2defzd2_36, obj_t BgL_srczd2declzd2_37, obj_t BgL_importz00_38)
{ AN_OBJECT;
{ /* Module/class.scm 94 */
{ /* Module/class.scm 98 */
obj_t BgL_locz00_672;
BgL_locz00_672 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_srczd2defzd2_36); 
{ /* Module/class.scm 99 */
obj_t BgL_classzd2idzd2_674;
BgL_classzd2idzd2_674 = 
BGl_idzd2ofzd2idz00zzast_identz00(
CAR(BgL_cdefz00_32), BgL_locz00_672); 
{ /* Module/class.scm 100 */
obj_t BgL_holderz00_675;
{ /* Module/class.scm 102 */
obj_t BgL_arg1869z00_687;
{ /* Module/class.scm 102 */
obj_t BgL_arg1873z00_688;
BgL_arg1873z00_688 = 
MAKE_PAIR(BgL_classzd2idzd2_674, BNIL); 
BgL_arg1869z00_687 = 
MAKE_PAIR(BgL_importz00_38, BgL_arg1873z00_688); } 
BGl_producezd2modulezd2clausez12z12zzmodule_modulez00(BgL_arg1869z00_687); } 
BgL_holderz00_675 = 
BGl_findzd2globalzf2modulez20zzast_envz00(BgL_classzd2idzd2_674, BgL_modulez00_33); 
{ /* Module/class.scm 105 */
BgL_typez00_bglt BgL_tclassz00_678;
{ /* Module/class.scm 106 */
bool_t BgL_auxz00_2085;obj_t BgL_auxz00_2078;
{ /* Module/class.scm 104 */
obj_t BgL_auxz00_2086;
BgL_auxz00_2086 = 
CNST_TABLE_REF(((long)1)); 
BgL_auxz00_2085 = 
(BgL_kindz00_34==BgL_auxz00_2086); } 
{ /* Module/class.scm 105 */
bool_t BgL_testz00_2080;
{ /* Module/class.scm 105 */
obj_t BgL_auxz00_2081;
BgL_auxz00_2081 = 
CNST_TABLE_REF(((long)3)); 
BgL_testz00_2080 = 
(BgL_kindz00_34==BgL_auxz00_2081); } 
if(BgL_testz00_2080)
{ /* Module/class.scm 105 */
BgL_auxz00_2078 = 
CNST_TABLE_REF(((long)4))
; }  else 
{ /* Module/class.scm 105 */
BgL_auxz00_2078 = BFALSE
; } } 
BgL_tclassz00_678 = 
BGl_declarezd2classzd2typez12z12zzobject_classz00(BgL_cdefz00_32, 
(BgL_globalz00_bglt)(BgL_holderz00_675), BgL_auxz00_2078, BgL_auxz00_2085, BgL_abstractzf3zf3_35, BgL_srczd2defzd2_36); } 
{ /* Module/class.scm 106 */

BGl_globalzd2setzd2readzd2onlyz12zc0zzast_varz00(
(BgL_globalz00_bglt)(BgL_holderz00_675)); 
{ /* Module/class.scm 115 */
obj_t BgL_arg1850z00_679;
BgL_arg1850z00_679 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_srczd2declzd2_37, BgL_locz00_672); 
((((BgL_typez00_bglt)CREF(BgL_tclassz00_678))->BgL_importzd2locationzd2) = ((obj_t)BgL_arg1850z00_679), BUNSPEC); } 
{ /* Module/class.scm 120 */
obj_t BgL_arg1854z00_680;
{ /* Module/class.scm 120 */
obj_t BgL_zc3anonymousza31859ze3z83_1972;
{ 
int BgL_auxz00_2096;int BgL_auxz00_2094;
BgL_auxz00_2096 = 
(int)(((long)6)); 
BgL_auxz00_2094 = 
(int)(((long)0)); 
BgL_zc3anonymousza31859ze3z83_1972 = 
make_fx_procedure(BGl_zc3anonymousza31859ze3z83zzmodule_classz00, BgL_auxz00_2094, BgL_auxz00_2096); } 
{ /* Module/class.scm 120 */
int BgL_auxz00_2099;
BgL_auxz00_2099 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31859ze3z83_1972, BgL_auxz00_2099, BgL_genz00_31); } 
{ /* Module/class.scm 120 */
int BgL_auxz00_2102;
BgL_auxz00_2102 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_zc3anonymousza31859ze3z83_1972, BgL_auxz00_2102, BgL_cdefz00_32); } 
{ /* Module/class.scm 120 */
obj_t BgL_auxz00_2107;int BgL_auxz00_2105;
BgL_auxz00_2107 = 
(obj_t)(BgL_tclassz00_678); 
BgL_auxz00_2105 = 
(int)(((long)2)); 
PROCEDURE_SET(BgL_zc3anonymousza31859ze3z83_1972, BgL_auxz00_2105, BgL_auxz00_2107); } 
{ /* Module/class.scm 120 */
int BgL_auxz00_2110;
BgL_auxz00_2110 = 
(int)(((long)3)); 
PROCEDURE_SET(BgL_zc3anonymousza31859ze3z83_1972, BgL_auxz00_2110, BgL_srczd2defzd2_36); } 
{ /* Module/class.scm 120 */
int BgL_auxz00_2113;
BgL_auxz00_2113 = 
(int)(((long)4)); 
PROCEDURE_SET(BgL_zc3anonymousza31859ze3z83_1972, BgL_auxz00_2113, BgL_importz00_38); } 
{ /* Module/class.scm 120 */
int BgL_auxz00_2116;
BgL_auxz00_2116 = 
(int)(((long)5)); 
PROCEDURE_SET(BgL_zc3anonymousza31859ze3z83_1972, BgL_auxz00_2116, BgL_holderz00_675); } 
BgL_arg1854z00_680 = 
BGl_makezd2promisezd2zz__r4_control_features_6_9z00(BgL_zc3anonymousza31859ze3z83_1972); } 
{ /* Module/class.scm 117 */
BgL_typez00_bglt BgL_res3158z00_1423;
{ /* Module/class.scm 117 */
obj_t BgL_arg1906z00_1422;
{ /* Module/class.scm 117 */
obj_t BgL_auxz00_2120;
BgL_auxz00_2120 = 
(obj_t)(BgL_tclassz00_678); 
BgL_arg1906z00_1422 = 
MAKE_PAIR(BgL_auxz00_2120, BgL_arg1854z00_680); } 
BGl_za2classzd2accessesza2zd2zzmodule_classz00 = 
MAKE_PAIR(BgL_arg1906z00_1422, BGl_za2classzd2accessesza2zd2zzmodule_classz00); } 
BgL_res3158z00_1423 = BgL_tclassz00_678; 
return BgL_res3158z00_1423;} } } } } } } } 
}



/* <anonymous:1859> */
obj_t BGl_zc3anonymousza31859ze3z83zzmodule_classz00(obj_t BgL_envz00_1973)
{ AN_OBJECT;
{ /* Module/class.scm 119 */
{ /* Module/class.scm 120 */
obj_t BgL_genz00_1974;obj_t BgL_cdefz00_1975;obj_t BgL_tclassz00_1976;obj_t BgL_srczd2defzd2_1977;obj_t BgL_importz00_1978;obj_t BgL_holderz00_1979;
{ /* Module/class.scm 120 */
int BgL_auxz00_2124;
BgL_auxz00_2124 = 
(int)(((long)0)); 
BgL_genz00_1974 = 
PROCEDURE_REF(BgL_envz00_1973, BgL_auxz00_2124); } 
{ /* Module/class.scm 120 */
int BgL_auxz00_2127;
BgL_auxz00_2127 = 
(int)(((long)1)); 
BgL_cdefz00_1975 = 
PROCEDURE_REF(BgL_envz00_1973, BgL_auxz00_2127); } 
{ /* Module/class.scm 120 */
int BgL_auxz00_2130;
BgL_auxz00_2130 = 
(int)(((long)2)); 
BgL_tclassz00_1976 = 
PROCEDURE_REF(BgL_envz00_1973, BgL_auxz00_2130); } 
{ /* Module/class.scm 120 */
int BgL_auxz00_2133;
BgL_auxz00_2133 = 
(int)(((long)3)); 
BgL_srczd2defzd2_1977 = 
PROCEDURE_REF(BgL_envz00_1973, BgL_auxz00_2133); } 
{ /* Module/class.scm 120 */
int BgL_auxz00_2136;
BgL_auxz00_2136 = 
(int)(((long)4)); 
BgL_importz00_1978 = 
PROCEDURE_REF(BgL_envz00_1973, BgL_auxz00_2136); } 
{ /* Module/class.scm 120 */
int BgL_auxz00_2139;
BgL_auxz00_2139 = 
(int)(((long)5)); 
BgL_holderz00_1979 = 
PROCEDURE_REF(BgL_envz00_1973, BgL_auxz00_2139); } 
{ 

{ /* Module/class.scm 120 */
obj_t BgL_concretesz00_683;
BgL_concretesz00_683 = 
PROCEDURE_ENTRY(BgL_genz00_1974)(BgL_genz00_1974, BgL_cdefz00_1975, BgL_tclassz00_1976, BgL_srczd2defzd2_1977, BgL_importz00_1978, BEOA); 
{ /* Module/class.scm 125 */
obj_t BgL_virtualsz00_684;
{ /* Module/class.scm 125 */
int BgL_auxz00_2144;
BgL_auxz00_2144 = 
(int)(((long)1)); 
BgL_virtualsz00_684 = 
BGL_GET_MVALUES_VAL(BgL_auxz00_2144); } 
BGl_makezd2addzd2classz12z12zzmodule_classz00(BgL_holderz00_1979, BgL_tclassz00_1976, BgL_srczd2defzd2_1977, BgL_virtualsz00_684); 
return BgL_concretesz00_683;} } } } } 
}



/* declare-import-class! */
BgL_typez00_bglt BGl_declarezd2importzd2classz12z12zzmodule_classz00(obj_t BgL_genz00_39, obj_t BgL_cdefz00_40, obj_t BgL_modulez00_41, obj_t BgL_kindz00_42, bool_t BgL_abstractzf3zf3_43, obj_t BgL_srczd2defzd2_44, obj_t BgL_srczd2declzd2_45)
{ AN_OBJECT;
{ /* Module/class.scm 135 */
{ /* Module/class.scm 139 */
obj_t BgL_locz00_689;
BgL_locz00_689 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_srczd2defzd2_44); 
{ /* Module/class.scm 140 */
obj_t BgL_classzd2idzd2_691;
BgL_classzd2idzd2_691 = 
BGl_idzd2ofzd2idz00zzast_identz00(
CAR(BgL_cdefz00_40), BgL_locz00_689); 
{ /* Module/class.scm 141 */
obj_t BgL_holderz00_692;
BgL_holderz00_692 = 
BGl_importzd2parserzd2zzmodule_impusez00(BgL_modulez00_41, BgL_classzd2idzd2_691, BNIL); 
{ /* Module/class.scm 144 */
BgL_typez00_bglt BgL_tclassz00_695;
{ /* Module/class.scm 145 */
bool_t BgL_auxz00_2159;obj_t BgL_auxz00_2152;
{ /* Module/class.scm 143 */
obj_t BgL_auxz00_2160;
BgL_auxz00_2160 = 
CNST_TABLE_REF(((long)1)); 
BgL_auxz00_2159 = 
(BgL_kindz00_42==BgL_auxz00_2160); } 
{ /* Module/class.scm 144 */
bool_t BgL_testz00_2154;
{ /* Module/class.scm 144 */
obj_t BgL_auxz00_2155;
BgL_auxz00_2155 = 
CNST_TABLE_REF(((long)3)); 
BgL_testz00_2154 = 
(BgL_kindz00_42==BgL_auxz00_2155); } 
if(BgL_testz00_2154)
{ /* Module/class.scm 144 */
BgL_auxz00_2152 = 
CNST_TABLE_REF(((long)4))
; }  else 
{ /* Module/class.scm 144 */
BgL_auxz00_2152 = BFALSE
; } } 
BgL_tclassz00_695 = 
BGl_declarezd2classzd2typez12z12zzobject_classz00(BgL_cdefz00_40, 
(BgL_globalz00_bglt)(BgL_holderz00_692), BgL_auxz00_2152, BgL_auxz00_2159, BgL_abstractzf3zf3_43, BgL_srczd2defzd2_44); } 
{ /* Module/class.scm 145 */

{ /* Module/class.scm 152 */
obj_t BgL_arg1881z00_696;
BgL_arg1881z00_696 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_srczd2declzd2_45, BgL_locz00_689); 
((((BgL_typez00_bglt)CREF(BgL_tclassz00_695))->BgL_importzd2locationzd2) = ((obj_t)BgL_arg1881z00_696), BUNSPEC); } 
{ /* Module/class.scm 157 */
obj_t BgL_arg1886z00_697;
{ /* Module/class.scm 157 */
obj_t BgL_zc3anonymousza31891ze3z83_1980;
{ 
int BgL_auxz00_2168;int BgL_auxz00_2166;
BgL_auxz00_2168 = 
(int)(((long)5)); 
BgL_auxz00_2166 = 
(int)(((long)0)); 
BgL_zc3anonymousza31891ze3z83_1980 = 
make_fx_procedure(BGl_zc3anonymousza31891ze3z83zzmodule_classz00, BgL_auxz00_2166, BgL_auxz00_2168); } 
{ /* Module/class.scm 157 */
int BgL_auxz00_2171;
BgL_auxz00_2171 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31891ze3z83_1980, BgL_auxz00_2171, BgL_genz00_39); } 
{ /* Module/class.scm 157 */
int BgL_auxz00_2174;
BgL_auxz00_2174 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_zc3anonymousza31891ze3z83_1980, BgL_auxz00_2174, BgL_cdefz00_40); } 
{ /* Module/class.scm 157 */
obj_t BgL_auxz00_2179;int BgL_auxz00_2177;
BgL_auxz00_2179 = 
(obj_t)(BgL_tclassz00_695); 
BgL_auxz00_2177 = 
(int)(((long)2)); 
PROCEDURE_SET(BgL_zc3anonymousza31891ze3z83_1980, BgL_auxz00_2177, BgL_auxz00_2179); } 
{ /* Module/class.scm 157 */
int BgL_auxz00_2182;
BgL_auxz00_2182 = 
(int)(((long)3)); 
PROCEDURE_SET(BgL_zc3anonymousza31891ze3z83_1980, BgL_auxz00_2182, BgL_srczd2defzd2_44); } 
{ /* Module/class.scm 157 */
int BgL_auxz00_2185;
BgL_auxz00_2185 = 
(int)(((long)4)); 
PROCEDURE_SET(BgL_zc3anonymousza31891ze3z83_1980, BgL_auxz00_2185, BgL_modulez00_41); } 
BgL_arg1886z00_697 = 
BGl_makezd2promisezd2zz__r4_control_features_6_9z00(BgL_zc3anonymousza31891ze3z83_1980); } 
{ /* Module/class.scm 154 */
BgL_typez00_bglt BgL_res3159z00_1431;
{ /* Module/class.scm 154 */
obj_t BgL_arg1906z00_1430;
{ /* Module/class.scm 154 */
obj_t BgL_auxz00_2189;
BgL_auxz00_2189 = 
(obj_t)(BgL_tclassz00_695); 
BgL_arg1906z00_1430 = 
MAKE_PAIR(BgL_auxz00_2189, BgL_arg1886z00_697); } 
BGl_za2classzd2accessesza2zd2zzmodule_classz00 = 
MAKE_PAIR(BgL_arg1906z00_1430, BGl_za2classzd2accessesza2zd2zzmodule_classz00); } 
BgL_res3159z00_1431 = BgL_tclassz00_695; 
return BgL_res3159z00_1431;} } } } } } } } 
}



/* <anonymous:1891> */
obj_t BGl_zc3anonymousza31891ze3z83zzmodule_classz00(obj_t BgL_envz00_1981)
{ AN_OBJECT;
{ /* Module/class.scm 156 */
{ /* Module/class.scm 157 */
obj_t BgL_genz00_1982;obj_t BgL_cdefz00_1983;obj_t BgL_tclassz00_1984;obj_t BgL_srczd2defzd2_1985;obj_t BgL_modulez00_1986;
{ /* Module/class.scm 157 */
int BgL_auxz00_2193;
BgL_auxz00_2193 = 
(int)(((long)0)); 
BgL_genz00_1982 = 
PROCEDURE_REF(BgL_envz00_1981, BgL_auxz00_2193); } 
{ /* Module/class.scm 157 */
int BgL_auxz00_2196;
BgL_auxz00_2196 = 
(int)(((long)1)); 
BgL_cdefz00_1983 = 
PROCEDURE_REF(BgL_envz00_1981, BgL_auxz00_2196); } 
{ /* Module/class.scm 157 */
int BgL_auxz00_2199;
BgL_auxz00_2199 = 
(int)(((long)2)); 
BgL_tclassz00_1984 = 
PROCEDURE_REF(BgL_envz00_1981, BgL_auxz00_2199); } 
{ /* Module/class.scm 157 */
int BgL_auxz00_2202;
BgL_auxz00_2202 = 
(int)(((long)3)); 
BgL_srczd2defzd2_1985 = 
PROCEDURE_REF(BgL_envz00_1981, BgL_auxz00_2202); } 
{ /* Module/class.scm 157 */
int BgL_auxz00_2205;
BgL_auxz00_2205 = 
(int)(((long)4)); 
BgL_modulez00_1986 = 
PROCEDURE_REF(BgL_envz00_1981, BgL_auxz00_2205); } 
{ 

{ /* Module/class.scm 157 */
obj_t BgL_concretesz00_700;
BgL_concretesz00_700 = 
PROCEDURE_ENTRY(BgL_genz00_1982)(BgL_genz00_1982, BgL_cdefz00_1983, BgL_tclassz00_1984, BgL_srczd2defzd2_1985, BgL_modulez00_1986, BEOA); 
{ /* Module/class.scm 157 */
obj_t BgL_virtualsz00_701;
{ /* Module/class.scm 157 */
int BgL_auxz00_2210;
BgL_auxz00_2210 = 
(int)(((long)1)); 
BgL_virtualsz00_701 = 
BGL_GET_MVALUES_VAL(BgL_auxz00_2210); } 
return BgL_concretesz00_700;} } } } } 
}



/* delay-class-accessors! */
BgL_typez00_bglt BGl_delayzd2classzd2accessorsz12z12zzmodule_classz00(BgL_typez00_bglt BgL_typez00_46, obj_t BgL_delayedz00_47)
{ AN_OBJECT;
{ /* Module/class.scm 164 */
{ /* Module/class.scm 165 */
obj_t BgL_arg1906z00_1432;
{ /* Module/class.scm 165 */
obj_t BgL_auxz00_2213;
BgL_auxz00_2213 = 
(obj_t)(BgL_typez00_46); 
BgL_arg1906z00_1432 = 
MAKE_PAIR(BgL_auxz00_2213, BgL_delayedz00_47); } 
BGl_za2classzd2accessesza2zd2zzmodule_classz00 = 
MAKE_PAIR(BgL_arg1906z00_1432, BGl_za2classzd2accessesza2zd2zzmodule_classz00); } 
return BgL_typez00_46;} 
}



/* _delay-class-accessors! */
obj_t BGl__delayzd2classzd2accessorsz12z12zzmodule_classz00(obj_t BgL_envz00_1987, obj_t BgL_typez00_1988, obj_t BgL_delayedz00_1989)
{ AN_OBJECT;
{ /* Module/class.scm 164 */
{ /* Module/class.scm 165 */
BgL_typez00_bglt BgL_auxz00_2217;
BgL_auxz00_2217 = 
BGl_delayzd2classzd2accessorsz12z12zzmodule_classz00(
(BgL_typez00_bglt)(BgL_typez00_1988), BgL_delayedz00_1989); 
return 
(obj_t)(BgL_auxz00_2217);} } 
}



/* make-add-class! */
obj_t BGl_makezd2addzd2classz12z12zzmodule_classz00(obj_t BgL_holderz00_48, obj_t BgL_classz00_49, obj_t BgL_srczd2defzd2_50, obj_t BgL_virtualsz00_51)
{ AN_OBJECT;
{ /* Module/class.scm 181 */
{ /* Module/class.scm 182 */
obj_t BgL_superz00_706;
{ /* Module/class.scm 182 */
BgL_tclassz00_bglt BgL_obj1634z00_1433;
BgL_obj1634z00_1433 = 
(BgL_tclassz00_bglt)(BgL_classz00_49); 
{ 
obj_t BgL_auxz00_2222;
{ /* Module/class.scm 182 */
BgL_objectz00_bglt BgL_auxz00_2223;
BgL_auxz00_2223 = 
(BgL_objectz00_bglt)(BgL_obj1634z00_1433); 
BgL_auxz00_2222 = 
BGL_OBJECT_WIDENING(BgL_auxz00_2223); } 
BgL_superz00_706 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_2222))->BgL_itszd2superzd2); } } 
{ /* Module/class.scm 182 */
obj_t BgL_holderzd2idzd2_707;
{ /* Module/class.scm 183 */
BgL_globalz00_bglt BgL_obj1172z00_1434;
BgL_obj1172z00_1434 = 
(BgL_globalz00_bglt)(BgL_holderz00_48); 
BgL_holderzd2idzd2_707 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1172z00_1434))->BgL_idz00); } 
{ /* Module/class.scm 183 */
obj_t BgL_classzd2idzd2_708;
{ /* Module/class.scm 184 */
BgL_typez00_bglt BgL_obj1025z00_1435;
BgL_obj1025z00_1435 = 
(BgL_typez00_bglt)(BgL_classz00_49); 
BgL_classzd2idzd2_708 = 
(((BgL_typez00_bglt)CREF(BgL_obj1025z00_1435))->BgL_idz00); } 
{ /* Module/class.scm 184 */
obj_t BgL_classzd2modulezd2_709;
{ /* Module/class.scm 185 */
BgL_globalz00_bglt BgL_obj1194z00_1436;
BgL_obj1194z00_1436 = 
(BgL_globalz00_bglt)(BgL_holderz00_48); 
BgL_classzd2modulezd2_709 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1194z00_1436))->BgL_modulez00); } 
{ /* Module/class.scm 185 */
obj_t BgL_classzd2makezd2idz00_710;
{ /* Module/class.scm 186 */
obj_t BgL_list2272z00_883;
{ /* Module/class.scm 186 */
obj_t BgL_arg2274z00_884;obj_t BgL_arg2275z00_885;
BgL_arg2274z00_884 = 
CNST_TABLE_REF(((long)5)); 
BgL_arg2275z00_885 = 
MAKE_PAIR(BgL_classzd2idzd2_708, BNIL); 
BgL_list2272z00_883 = 
MAKE_PAIR(BgL_arg2274z00_884, BgL_arg2275z00_885); } 
BgL_classzd2makezd2idz00_710 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2272z00_883); } 
{ /* Module/class.scm 186 */
obj_t BgL_classzd2alloczd2idz00_711;
{ /* Module/class.scm 187 */
obj_t BgL_list2265z00_880;
{ /* Module/class.scm 187 */
obj_t BgL_arg2267z00_881;obj_t BgL_arg2268z00_882;
BgL_arg2267z00_881 = 
CNST_TABLE_REF(((long)6)); 
BgL_arg2268z00_882 = 
MAKE_PAIR(BgL_classzd2idzd2_708, BNIL); 
BgL_list2265z00_880 = 
MAKE_PAIR(BgL_arg2267z00_881, BgL_arg2268z00_882); } 
BgL_classzd2alloczd2idz00_711 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2265z00_880); } 
{ /* Module/class.scm 187 */
obj_t BgL_classzd2makezd2_712;
{ /* Module/class.scm 188 */
bool_t BgL_testz00_2241;
{ /* Module/class.scm 188 */
BgL_tclassz00_bglt BgL_obj1650z00_1437;
BgL_obj1650z00_1437 = 
(BgL_tclassz00_bglt)(BgL_classz00_49); 
{ 
obj_t BgL_auxz00_2243;
{ /* Module/class.scm 188 */
BgL_objectz00_bglt BgL_auxz00_2244;
BgL_auxz00_2244 = 
(BgL_objectz00_bglt)(BgL_obj1650z00_1437); 
BgL_auxz00_2243 = 
BGL_OBJECT_WIDENING(BgL_auxz00_2244); } 
BgL_testz00_2241 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_2243))->BgL_abstractzf3zf3); } } 
if(BgL_testz00_2241)
{ /* Module/class.scm 193 */
obj_t BgL_arg2217z00_859;obj_t BgL_arg2218z00_860;
BgL_arg2217z00_859 = 
CNST_TABLE_REF(((long)7)); 
{ /* Module/class.scm 189 */
obj_t BgL_arg2221z00_861;obj_t BgL_arg2222z00_862;
{ /* Module/class.scm 189 */
obj_t BgL_auxz00_2249;
BgL_auxz00_2249 = 
CNST_TABLE_REF(((long)8)); 
BgL_arg2221z00_861 = 
MAKE_PAIR(BgL_auxz00_2249, BNIL); } 
{ /* Module/class.scm 190 */
obj_t BgL_arg2226z00_863;
{ /* Module/class.scm 190 */
obj_t BgL_arg2230z00_865;obj_t BgL_arg2231z00_866;
BgL_arg2230z00_865 = 
CNST_TABLE_REF(((long)9)); 
{ /* Module/class.scm 191 */
obj_t BgL_arg2234z00_867;obj_t BgL_arg2235z00_868;
{ /* Module/class.scm 191 */
obj_t BgL_arg2238z00_869;obj_t BgL_arg2239z00_870;
BgL_arg2238z00_869 = 
CNST_TABLE_REF(((long)10)); 
BgL_arg2239z00_870 = 
MAKE_PAIR(BgL_classzd2makezd2idz00_710, BNIL); 
BgL_arg2234z00_867 = 
MAKE_PAIR(BgL_arg2238z00_869, BgL_arg2239z00_870); } 
{ /* Module/class.scm 190 */
obj_t BgL_arg2244z00_872;
{ /* Module/class.scm 193 */
obj_t BgL_arg2247z00_873;
{ /* Module/class.scm 193 */
obj_t BgL_arg2251z00_875;obj_t BgL_arg2252z00_876;
BgL_arg2251z00_875 = 
CNST_TABLE_REF(((long)10)); 
BgL_arg2252z00_876 = 
MAKE_PAIR(BgL_classzd2idzd2_708, BNIL); 
BgL_arg2247z00_873 = 
MAKE_PAIR(BgL_arg2251z00_875, BgL_arg2252z00_876); } 
BgL_arg2244z00_872 = 
MAKE_PAIR(BgL_arg2247z00_873, BNIL); } 
BgL_arg2235z00_868 = 
MAKE_PAIR(BGl_string3318z00zzmodule_classz00, BgL_arg2244z00_872); } 
BgL_arg2231z00_866 = 
MAKE_PAIR(BgL_arg2234z00_867, BgL_arg2235z00_868); } 
BgL_arg2226z00_863 = 
MAKE_PAIR(BgL_arg2230z00_865, BgL_arg2231z00_866); } 
BgL_arg2222z00_862 = 
MAKE_PAIR(BgL_arg2226z00_863, BNIL); } 
BgL_arg2218z00_860 = 
MAKE_PAIR(BgL_arg2221z00_861, BgL_arg2222z00_862); } 
BgL_classzd2makezd2_712 = 
MAKE_PAIR(BgL_arg2217z00_859, BgL_arg2218z00_860); }  else 
{ /* Module/class.scm 194 */
obj_t BgL_arg2256z00_877;obj_t BgL_arg2257z00_878;
BgL_arg2256z00_877 = 
CNST_TABLE_REF(((long)11)); 
{ /* Module/class.scm 194 */
obj_t BgL_arg2260z00_879;
BgL_arg2260z00_879 = 
MAKE_PAIR(BgL_classzd2modulezd2_709, BNIL); 
BgL_arg2257z00_878 = 
MAKE_PAIR(BgL_classzd2makezd2idz00_710, BgL_arg2260z00_879); } 
BgL_classzd2makezd2_712 = 
MAKE_PAIR(BgL_arg2256z00_877, BgL_arg2257z00_878); } } 
{ /* Module/class.scm 188 */
obj_t BgL_classzd2alloczd2_713;
{ /* Module/class.scm 195 */
bool_t BgL_testz00_2270;
{ /* Module/class.scm 195 */
BgL_tclassz00_bglt BgL_obj1650z00_1438;
BgL_obj1650z00_1438 = 
(BgL_tclassz00_bglt)(BgL_classz00_49); 
{ 
obj_t BgL_auxz00_2272;
{ /* Module/class.scm 195 */
BgL_objectz00_bglt BgL_auxz00_2273;
BgL_auxz00_2273 = 
(BgL_objectz00_bglt)(BgL_obj1650z00_1438); 
BgL_auxz00_2272 = 
BGL_OBJECT_WIDENING(BgL_auxz00_2273); } 
BgL_testz00_2270 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_2272))->BgL_abstractzf3zf3); } } 
if(BgL_testz00_2270)
{ /* Module/class.scm 200 */
obj_t BgL_arg2168z00_837;obj_t BgL_arg2169z00_838;
BgL_arg2168z00_837 = 
CNST_TABLE_REF(((long)7)); 
{ /* Module/class.scm 196 */
obj_t BgL_arg2172z00_839;obj_t BgL_arg2173z00_840;
{ /* Module/class.scm 196 */
obj_t BgL_auxz00_2278;
BgL_auxz00_2278 = 
CNST_TABLE_REF(((long)8)); 
BgL_arg2172z00_839 = 
MAKE_PAIR(BgL_auxz00_2278, BNIL); } 
{ /* Module/class.scm 197 */
obj_t BgL_arg2177z00_841;
{ /* Module/class.scm 197 */
obj_t BgL_arg2181z00_843;obj_t BgL_arg2182z00_844;
BgL_arg2181z00_843 = 
CNST_TABLE_REF(((long)9)); 
{ /* Module/class.scm 198 */
obj_t BgL_arg2185z00_845;obj_t BgL_arg2186z00_846;
{ /* Module/class.scm 198 */
obj_t BgL_arg2189z00_847;obj_t BgL_arg2190z00_848;
BgL_arg2189z00_847 = 
CNST_TABLE_REF(((long)10)); 
BgL_arg2190z00_848 = 
MAKE_PAIR(BgL_classzd2alloczd2idz00_711, BNIL); 
BgL_arg2185z00_845 = 
MAKE_PAIR(BgL_arg2189z00_847, BgL_arg2190z00_848); } 
{ /* Module/class.scm 197 */
obj_t BgL_arg2195z00_850;
{ /* Module/class.scm 200 */
obj_t BgL_arg2198z00_851;
{ /* Module/class.scm 200 */
obj_t BgL_arg2202z00_853;obj_t BgL_arg2203z00_854;
BgL_arg2202z00_853 = 
CNST_TABLE_REF(((long)10)); 
BgL_arg2203z00_854 = 
MAKE_PAIR(BgL_classzd2idzd2_708, BNIL); 
BgL_arg2198z00_851 = 
MAKE_PAIR(BgL_arg2202z00_853, BgL_arg2203z00_854); } 
BgL_arg2195z00_850 = 
MAKE_PAIR(BgL_arg2198z00_851, BNIL); } 
BgL_arg2186z00_846 = 
MAKE_PAIR(BGl_string3319z00zzmodule_classz00, BgL_arg2195z00_850); } 
BgL_arg2182z00_844 = 
MAKE_PAIR(BgL_arg2185z00_845, BgL_arg2186z00_846); } 
BgL_arg2177z00_841 = 
MAKE_PAIR(BgL_arg2181z00_843, BgL_arg2182z00_844); } 
BgL_arg2173z00_840 = 
MAKE_PAIR(BgL_arg2177z00_841, BNIL); } 
BgL_arg2169z00_838 = 
MAKE_PAIR(BgL_arg2172z00_839, BgL_arg2173z00_840); } 
BgL_classzd2alloczd2_713 = 
MAKE_PAIR(BgL_arg2168z00_837, BgL_arg2169z00_838); }  else 
{ /* Module/class.scm 201 */
obj_t BgL_arg2207z00_855;obj_t BgL_arg2208z00_856;
BgL_arg2207z00_855 = 
CNST_TABLE_REF(((long)11)); 
{ /* Module/class.scm 201 */
obj_t BgL_arg2211z00_857;
BgL_arg2211z00_857 = 
MAKE_PAIR(BgL_classzd2modulezd2_709, BNIL); 
BgL_arg2208z00_856 = 
MAKE_PAIR(BgL_classzd2alloczd2idz00_711, BgL_arg2211z00_857); } 
BgL_classzd2alloczd2_713 = 
MAKE_PAIR(BgL_arg2207z00_855, BgL_arg2208z00_856); } } 
{ /* Module/class.scm 195 */
obj_t BgL_hashz00_714;
{ /* Module/class.scm 202 */
obj_t BgL_auxz00_2299;
{ /* Module/class.scm 202 */
obj_t BgL_auxz00_2300;
BgL_auxz00_2300 = 
CDR(BgL_srczd2defzd2_50); 
BgL_auxz00_2299 = 
CDR(BgL_auxz00_2300); } 
BgL_hashz00_714 = 
BGl_getzd2classzd2hashz00zzmodule_classz00(BgL_classzd2idzd2_708, BgL_auxz00_2299); } 
{ /* Module/class.scm 202 */
obj_t BgL_constrz00_715;
{ /* Module/class.scm 203 */
BgL_tclassz00_bglt BgL_obj1646z00_1443;
BgL_obj1646z00_1443 = 
(BgL_tclassz00_bglt)(BgL_classz00_49); 
{ 
obj_t BgL_auxz00_2305;
{ /* Module/class.scm 203 */
BgL_objectz00_bglt BgL_auxz00_2306;
BgL_auxz00_2306 = 
(BgL_objectz00_bglt)(BgL_obj1646z00_1443); 
BgL_auxz00_2305 = 
BGL_OBJECT_WIDENING(BgL_auxz00_2306); } 
BgL_constrz00_715 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_2305))->BgL_constructorz00); } } 
{ /* Module/class.scm 203 */
obj_t BgL_locz00_716;
BgL_locz00_716 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_srczd2defzd2_50); 
{ /* Module/class.scm 204 */
obj_t BgL_fieldsz00_717;
{ /* Module/class.scm 205 */
obj_t BgL_auxz00_2311;
{ /* Module/class.scm 205 */
obj_t BgL_auxz00_2312;
BgL_auxz00_2312 = 
CDR(BgL_srczd2defzd2_50); 
BgL_auxz00_2311 = 
CDR(BgL_auxz00_2312); } 
BgL_fieldsz00_717 = 
BGl_makezd2classzd2fieldsz00zzmodule_classz00(BgL_classzd2idzd2_708, BgL_auxz00_2311, BgL_locz00_716); } 
{ /* Module/class.scm 205 */

{ /* Module/class.scm 207 */
obj_t BgL_declz00_718;
{ /* Module/class.scm 207 */
bool_t BgL_test1920z00_724;
BgL_test1920z00_724 = 
BGl_iszd2azf3z21zz__objectz00(BgL_superz00_706, BGl_tclassz00zzobject_classz00); 
if(BgL_test1920z00_724)
{ /* Module/class.scm 218 */
BgL_globalz00_bglt BgL_sholderz00_725;
{ /* Module/class.scm 218 */
BgL_tclassz00_bglt BgL_obj1640z00_1449;
BgL_obj1640z00_1449 = 
(BgL_tclassz00_bglt)(BgL_superz00_706); 
{ 
obj_t BgL_auxz00_2319;
{ /* Module/class.scm 218 */
BgL_objectz00_bglt BgL_auxz00_2320;
BgL_auxz00_2320 = 
(BgL_objectz00_bglt)(BgL_obj1640z00_1449); 
BgL_auxz00_2319 = 
BGL_OBJECT_WIDENING(BgL_auxz00_2320); } 
BgL_sholderz00_725 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_2319))->BgL_holderz00); } } 
{ /* Module/class.scm 218 */
obj_t BgL_sholderzd2idzd2_726;
BgL_sholderzd2idzd2_726 = 
(((BgL_globalz00_bglt)CREF(BgL_sholderz00_725))->BgL_idz00); 
{ /* Module/class.scm 220 */

{ /* Module/class.scm 221 */
obj_t BgL_arg1923z00_728;obj_t BgL_arg1924z00_729;
BgL_arg1923z00_728 = 
CNST_TABLE_REF(((long)12)); 
{ /* Module/class.scm 222 */
obj_t BgL_arg1929z00_730;
{ /* Module/class.scm 222 */
obj_t BgL_arg1932z00_731;
{ /* Module/class.scm 222 */
obj_t BgL_arg1936z00_733;obj_t BgL_arg1937z00_734;
{ /* Module/class.scm 222 */
obj_t BgL_arg1940z00_735;obj_t BgL_arg1941z00_736;
BgL_arg1940z00_735 = 
CNST_TABLE_REF(((long)11)); 
{ /* Module/class.scm 222 */
obj_t BgL_arg1944z00_737;obj_t BgL_arg1945z00_738;
BgL_arg1944z00_737 = 
CNST_TABLE_REF(((long)13)); 
{ /* Module/class.scm 222 */
obj_t BgL_auxz00_2328;
BgL_auxz00_2328 = 
CNST_TABLE_REF(((long)14)); 
BgL_arg1945z00_738 = 
MAKE_PAIR(BgL_auxz00_2328, BNIL); } 
BgL_arg1941z00_736 = 
MAKE_PAIR(BgL_arg1944z00_737, BgL_arg1945z00_738); } 
BgL_arg1936z00_733 = 
MAKE_PAIR(BgL_arg1940z00_735, BgL_arg1941z00_736); } 
{ /* Module/class.scm 223 */
obj_t BgL_arg1949z00_739;obj_t BgL_arg1950z00_740;
{ /* Module/class.scm 223 */
obj_t BgL_arg1953z00_741;obj_t BgL_arg1954z00_742;
BgL_arg1953z00_741 = 
CNST_TABLE_REF(((long)10)); 
BgL_arg1954z00_742 = 
MAKE_PAIR(BgL_classzd2idzd2_708, BNIL); 
BgL_arg1949z00_739 = 
MAKE_PAIR(BgL_arg1953z00_741, BgL_arg1954z00_742); } 
{ /* Module/class.scm 223 */
obj_t BgL_arg1958z00_743;obj_t BgL_arg1959z00_744;
{ /* Module/class.scm 223 */
obj_t BgL_arg1962z00_745;obj_t BgL_arg1963z00_746;
BgL_arg1962z00_745 = 
CNST_TABLE_REF(((long)11)); 
{ /* Module/class.scm 223 */
obj_t BgL_arg1967z00_747;
{ /* Module/class.scm 223 */
obj_t BgL_auxz00_2337;
BgL_auxz00_2337 = 
(((BgL_globalz00_bglt)CREF(BgL_sholderz00_725))->BgL_modulez00); 
BgL_arg1967z00_747 = 
MAKE_PAIR(BgL_auxz00_2337, BNIL); } 
BgL_arg1963z00_746 = 
MAKE_PAIR(BgL_sholderzd2idzd2_726, BgL_arg1967z00_747); } 
BgL_arg1958z00_743 = 
MAKE_PAIR(BgL_arg1962z00_745, BgL_arg1963z00_746); } 
{ /* Module/class.scm 226 */
obj_t BgL_arg1971z00_748;
{ /* Module/class.scm 226 */
obj_t BgL_arg1974z00_749;
{ /* Module/class.scm 226 */
obj_t BgL_arg1977z00_750;
{ /* Module/class.scm 226 */
obj_t BgL_arg1980z00_751;
{ /* Module/class.scm 226 */
obj_t BgL_arg1983z00_752;
{ /* Module/class.scm 226 */
obj_t BgL_arg1986z00_753;
{ /* Module/class.scm 226 */
obj_t BgL_arg1990z00_755;obj_t BgL_arg1991z00_756;
BgL_arg1990z00_755 = 
CNST_TABLE_REF(((long)15)); 
{ /* Module/class.scm 226 */
obj_t BgL_arg1994z00_757;
if(
NULLP(BgL_virtualsz00_51))
{ /* Module/class.scm 226 */
BgL_arg1994z00_757 = BNIL; }  else 
{ /* Module/class.scm 226 */
obj_t BgL_head1781z00_761;
BgL_head1781z00_761 = 
MAKE_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1779z00_762;obj_t BgL_tail1782z00_763;
BgL_l1779z00_762 = BgL_virtualsz00_51; 
BgL_tail1782z00_763 = BgL_head1781z00_761; 
BgL_lname1780z00_764:
if(
NULLP(BgL_l1779z00_762))
{ /* Module/class.scm 226 */
BgL_arg1994z00_757 = 
CDR(BgL_head1781z00_761); }  else 
{ /* Module/class.scm 227 */
obj_t BgL_newtail1783z00_766;
{ /* Module/class.scm 227 */
obj_t BgL_arg2007z00_768;
{ /* Module/class.scm 227 */
obj_t BgL_vz00_770;
BgL_vz00_770 = 
CAR(BgL_l1779z00_762); 
{ /* Module/class.scm 227 */
obj_t BgL_arg2011z00_771;obj_t BgL_arg2012z00_772;
BgL_arg2011z00_771 = 
CNST_TABLE_REF(((long)16)); 
{ /* Module/class.scm 227 */
obj_t BgL_arg2015z00_773;obj_t BgL_arg2017z00_774;
BgL_arg2015z00_773 = 
CAR(BgL_vz00_770); 
{ /* Module/class.scm 228 */
obj_t BgL_arg2021z00_775;
{ /* Module/class.scm 228 */
obj_t BgL_arg2025z00_777;obj_t BgL_arg2026z00_778;
BgL_arg2025z00_777 = 
CNST_TABLE_REF(((long)16)); 
{ /* Module/class.scm 228 */
obj_t BgL_arg2029z00_779;obj_t BgL_arg2030z00_780;
{ /* Module/class.scm 228 */
obj_t BgL_auxz00_2353;
BgL_auxz00_2353 = 
CDR(BgL_vz00_770); 
BgL_arg2029z00_779 = 
CAR(BgL_auxz00_2353); } 
{ /* Module/class.scm 228 */
obj_t BgL_auxz00_2356;
{ /* Module/class.scm 229 */
obj_t BgL_auxz00_2357;
{ /* Module/class.scm 229 */
obj_t BgL_auxz00_2358;
BgL_auxz00_2358 = 
CDR(BgL_vz00_770); 
BgL_auxz00_2357 = 
CDR(BgL_auxz00_2358); } 
BgL_auxz00_2356 = 
CAR(BgL_auxz00_2357); } 
BgL_arg2030z00_780 = 
MAKE_PAIR(BgL_auxz00_2356, BNIL); } 
BgL_arg2026z00_778 = 
MAKE_PAIR(BgL_arg2029z00_779, BgL_arg2030z00_780); } 
BgL_arg2021z00_775 = 
MAKE_PAIR(BgL_arg2025z00_777, BgL_arg2026z00_778); } 
BgL_arg2017z00_774 = 
MAKE_PAIR(BgL_arg2021z00_775, BNIL); } 
BgL_arg2012z00_772 = 
MAKE_PAIR(BgL_arg2015z00_773, BgL_arg2017z00_774); } 
BgL_arg2007z00_768 = 
MAKE_PAIR(BgL_arg2011z00_771, BgL_arg2012z00_772); } } 
BgL_newtail1783z00_766 = 
MAKE_PAIR(BgL_arg2007z00_768, BNIL); } 
SET_CDR(BgL_tail1782z00_763, BgL_newtail1783z00_766); 
{ 
obj_t BgL_tail1782z00_2372;obj_t BgL_l1779z00_2370;
BgL_l1779z00_2370 = 
CDR(BgL_l1779z00_762); 
BgL_tail1782z00_2372 = BgL_newtail1783z00_766; 
BgL_tail1782z00_763 = BgL_tail1782z00_2372; 
BgL_l1779z00_762 = BgL_l1779z00_2370; 
goto BgL_lname1780z00_764;} } } } 
BgL_arg1991z00_756 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg1994z00_757, BNIL); } 
BgL_arg1986z00_753 = 
MAKE_PAIR(BgL_arg1990z00_755, BgL_arg1991z00_756); } 
BgL_arg1983z00_752 = 
MAKE_PAIR(BgL_arg1986z00_753, BNIL); } 
BgL_arg1980z00_751 = 
MAKE_PAIR(BgL_constrz00_715, BgL_arg1983z00_752); } 
BgL_arg1977z00_750 = 
MAKE_PAIR(BgL_fieldsz00_717, BgL_arg1980z00_751); } 
BgL_arg1974z00_749 = 
MAKE_PAIR(BgL_hashz00_714, BgL_arg1977z00_750); } 
BgL_arg1971z00_748 = 
MAKE_PAIR(BgL_classzd2alloczd2_713, BgL_arg1974z00_749); } 
BgL_arg1959z00_744 = 
MAKE_PAIR(BgL_classzd2makezd2_712, BgL_arg1971z00_748); } 
BgL_arg1950z00_740 = 
MAKE_PAIR(BgL_arg1958z00_743, BgL_arg1959z00_744); } 
BgL_arg1937z00_734 = 
MAKE_PAIR(BgL_arg1949z00_739, BgL_arg1950z00_740); } 
BgL_arg1932z00_731 = 
MAKE_PAIR(BgL_arg1936z00_733, BgL_arg1937z00_734); } 
BgL_arg1929z00_730 = 
MAKE_PAIR(BgL_arg1932z00_731, BNIL); } 
BgL_arg1924z00_729 = 
MAKE_PAIR(BgL_holderzd2idzd2_707, BgL_arg1929z00_730); } 
BgL_declz00_718 = 
MAKE_PAIR(BgL_arg1923z00_728, BgL_arg1924z00_729); } } } }  else 
{ /* Module/class.scm 217 */
obj_t BgL_arg2046z00_783;obj_t BgL_arg2047z00_784;
BgL_arg2046z00_783 = 
CNST_TABLE_REF(((long)12)); 
{ /* Module/class.scm 209 */
obj_t BgL_arg2051z00_785;
{ /* Module/class.scm 209 */
obj_t BgL_arg2054z00_786;
{ /* Module/class.scm 209 */
obj_t BgL_arg2058z00_788;obj_t BgL_arg2059z00_789;
{ /* Module/class.scm 209 */
obj_t BgL_arg2063z00_790;obj_t BgL_arg2064z00_791;
BgL_arg2063z00_790 = 
CNST_TABLE_REF(((long)11)); 
{ /* Module/class.scm 209 */
obj_t BgL_arg2067z00_792;obj_t BgL_arg2068z00_793;
BgL_arg2067z00_792 = 
CNST_TABLE_REF(((long)13)); 
{ /* Module/class.scm 209 */
obj_t BgL_auxz00_2390;
BgL_auxz00_2390 = 
CNST_TABLE_REF(((long)14)); 
BgL_arg2068z00_793 = 
MAKE_PAIR(BgL_auxz00_2390, BNIL); } 
BgL_arg2064z00_791 = 
MAKE_PAIR(BgL_arg2067z00_792, BgL_arg2068z00_793); } 
BgL_arg2058z00_788 = 
MAKE_PAIR(BgL_arg2063z00_790, BgL_arg2064z00_791); } 
{ /* Module/class.scm 210 */
obj_t BgL_arg2072z00_794;obj_t BgL_arg2073z00_795;
{ /* Module/class.scm 210 */
obj_t BgL_arg2076z00_796;obj_t BgL_arg2078z00_797;
BgL_arg2076z00_796 = 
CNST_TABLE_REF(((long)10)); 
BgL_arg2078z00_797 = 
MAKE_PAIR(BgL_classzd2idzd2_708, BNIL); 
BgL_arg2072z00_794 = 
MAKE_PAIR(BgL_arg2076z00_796, BgL_arg2078z00_797); } 
{ /* Module/class.scm 213 */
obj_t BgL_arg2082z00_798;
{ /* Module/class.scm 213 */
obj_t BgL_arg2085z00_799;
{ /* Module/class.scm 213 */
obj_t BgL_arg2088z00_800;
{ /* Module/class.scm 213 */
obj_t BgL_arg2091z00_801;
{ /* Module/class.scm 213 */
obj_t BgL_arg2094z00_802;
{ /* Module/class.scm 213 */
obj_t BgL_arg2097z00_803;
{ /* Module/class.scm 213 */
obj_t BgL_arg2100z00_804;
{ /* Module/class.scm 213 */
obj_t BgL_arg2104z00_806;obj_t BgL_arg2105z00_807;
BgL_arg2104z00_806 = 
CNST_TABLE_REF(((long)15)); 
{ /* Module/class.scm 213 */
obj_t BgL_arg2108z00_808;
if(
NULLP(BgL_virtualsz00_51))
{ /* Module/class.scm 213 */
BgL_arg2108z00_808 = BNIL; }  else 
{ /* Module/class.scm 213 */
obj_t BgL_head1776z00_812;
BgL_head1776z00_812 = 
MAKE_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1774z00_813;obj_t BgL_tail1777z00_814;
BgL_l1774z00_813 = BgL_virtualsz00_51; 
BgL_tail1777z00_814 = BgL_head1776z00_812; 
BgL_lname1775z00_815:
if(
NULLP(BgL_l1774z00_813))
{ /* Module/class.scm 213 */
BgL_arg2108z00_808 = 
CDR(BgL_head1776z00_812); }  else 
{ /* Module/class.scm 214 */
obj_t BgL_newtail1778z00_817;
{ /* Module/class.scm 214 */
obj_t BgL_arg2121z00_819;
{ /* Module/class.scm 214 */
obj_t BgL_vz00_821;
BgL_vz00_821 = 
CAR(BgL_l1774z00_813); 
{ /* Module/class.scm 214 */
obj_t BgL_arg2125z00_822;obj_t BgL_arg2126z00_823;
BgL_arg2125z00_822 = 
CNST_TABLE_REF(((long)16)); 
{ /* Module/class.scm 214 */
obj_t BgL_arg2129z00_824;obj_t BgL_arg2130z00_825;
BgL_arg2129z00_824 = 
CAR(BgL_vz00_821); 
{ /* Module/class.scm 215 */
obj_t BgL_arg2134z00_826;
{ /* Module/class.scm 215 */
obj_t BgL_arg2138z00_828;obj_t BgL_arg2139z00_829;
BgL_arg2138z00_828 = 
CNST_TABLE_REF(((long)16)); 
{ /* Module/class.scm 215 */
obj_t BgL_arg2142z00_830;obj_t BgL_arg2143z00_831;
{ /* Module/class.scm 215 */
obj_t BgL_auxz00_2409;
BgL_auxz00_2409 = 
CDR(BgL_vz00_821); 
BgL_arg2142z00_830 = 
CAR(BgL_auxz00_2409); } 
{ /* Module/class.scm 215 */
obj_t BgL_auxz00_2412;
{ /* Module/class.scm 216 */
obj_t BgL_auxz00_2413;
{ /* Module/class.scm 216 */
obj_t BgL_auxz00_2414;
BgL_auxz00_2414 = 
CDR(BgL_vz00_821); 
BgL_auxz00_2413 = 
CDR(BgL_auxz00_2414); } 
BgL_auxz00_2412 = 
CAR(BgL_auxz00_2413); } 
BgL_arg2143z00_831 = 
MAKE_PAIR(BgL_auxz00_2412, BNIL); } 
BgL_arg2139z00_829 = 
MAKE_PAIR(BgL_arg2142z00_830, BgL_arg2143z00_831); } 
BgL_arg2134z00_826 = 
MAKE_PAIR(BgL_arg2138z00_828, BgL_arg2139z00_829); } 
BgL_arg2130z00_825 = 
MAKE_PAIR(BgL_arg2134z00_826, BNIL); } 
BgL_arg2126z00_823 = 
MAKE_PAIR(BgL_arg2129z00_824, BgL_arg2130z00_825); } 
BgL_arg2121z00_819 = 
MAKE_PAIR(BgL_arg2125z00_822, BgL_arg2126z00_823); } } 
BgL_newtail1778z00_817 = 
MAKE_PAIR(BgL_arg2121z00_819, BNIL); } 
SET_CDR(BgL_tail1777z00_814, BgL_newtail1778z00_817); 
{ 
obj_t BgL_tail1777z00_2428;obj_t BgL_l1774z00_2426;
BgL_l1774z00_2426 = 
CDR(BgL_l1774z00_813); 
BgL_tail1777z00_2428 = BgL_newtail1778z00_817; 
BgL_tail1777z00_814 = BgL_tail1777z00_2428; 
BgL_l1774z00_813 = BgL_l1774z00_2426; 
goto BgL_lname1775z00_815;} } } } 
BgL_arg2105z00_807 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2108z00_808, BNIL); } 
BgL_arg2100z00_804 = 
MAKE_PAIR(BgL_arg2104z00_806, BgL_arg2105z00_807); } 
BgL_arg2097z00_803 = 
MAKE_PAIR(BgL_arg2100z00_804, BNIL); } 
BgL_arg2094z00_802 = 
MAKE_PAIR(BgL_constrz00_715, BgL_arg2097z00_803); } 
BgL_arg2091z00_801 = 
MAKE_PAIR(BgL_fieldsz00_717, BgL_arg2094z00_802); } 
BgL_arg2088z00_800 = 
MAKE_PAIR(BgL_hashz00_714, BgL_arg2091z00_801); } 
BgL_arg2085z00_799 = 
MAKE_PAIR(BgL_classzd2alloczd2_713, BgL_arg2088z00_800); } 
BgL_arg2082z00_798 = 
MAKE_PAIR(BgL_classzd2makezd2_712, BgL_arg2085z00_799); } 
BgL_arg2073z00_795 = 
MAKE_PAIR(BFALSE, BgL_arg2082z00_798); } 
BgL_arg2059z00_789 = 
MAKE_PAIR(BgL_arg2072z00_794, BgL_arg2073z00_795); } 
BgL_arg2054z00_786 = 
MAKE_PAIR(BgL_arg2058z00_788, BgL_arg2059z00_789); } 
BgL_arg2051z00_785 = 
MAKE_PAIR(BgL_arg2054z00_786, BNIL); } 
BgL_arg2047z00_784 = 
MAKE_PAIR(BgL_holderzd2idzd2_707, BgL_arg2051z00_785); } 
BgL_declz00_718 = 
MAKE_PAIR(BgL_arg2046z00_783, BgL_arg2047z00_784); } } 
{ /* Module/class.scm 232 */
obj_t BgL_loczd2declzd2_719;
{ /* Module/class.scm 232 */
bool_t BgL_test1910z00_720;
BgL_test1910z00_720 = 
EXTENDED_PAIRP(BgL_srczd2defzd2_50); 
if(BgL_test1910z00_720)
{ /* Module/class.scm 233 */
obj_t BgL_res3160z00_1503;
{ /* Module/class.scm 233 */
obj_t BgL_auxz00_2449;obj_t BgL_auxz00_2447;obj_t BgL_auxz00_2445;
BgL_auxz00_2449 = 
CER(BgL_srczd2defzd2_50); 
BgL_auxz00_2447 = 
CDR(BgL_declz00_718); 
BgL_auxz00_2445 = 
CAR(BgL_declz00_718); 
BgL_res3160z00_1503 = 
MAKE_EXTENDED_PAIR(BgL_auxz00_2445, BgL_auxz00_2447, BgL_auxz00_2449); } 
BgL_loczd2declzd2_719 = BgL_res3160z00_1503; }  else 
{ /* Module/class.scm 232 */
BgL_loczd2declzd2_719 = BgL_declz00_718; } } 
return ( 
BGl_za2declaredzd2classesza2zd2zzmodule_classz00 = 
MAKE_PAIR(BgL_loczd2declzd2_719, BGl_za2declaredzd2classesza2zd2zzmodule_classz00), BUNSPEC) ;} } } } } } } } } } } } } } } } 
}



/* get-class-hash */
obj_t BGl_getzd2classzd2hashz00zzmodule_classz00(obj_t BgL_classzd2idzd2_52, obj_t BgL_fieldsz00_53)
{ AN_OBJECT;
{ /* Module/class.scm 240 */
{ 
obj_t BgL_fieldsz00_886;long BgL_hashz00_887;
{ /* Module/class.scm 242 */
long BgL_arg2283z00_889;
{ /* Module/class.scm 242 */
obj_t BgL_arg2286z00_890;
BgL_arg2286z00_890 = 
SYMBOL_TO_STRING(BgL_classzd2idzd2_52); 
{ /* Module/class.scm 242 */
char * BgL_auxz00_2454;
BgL_auxz00_2454 = 
BSTRING_TO_STRING(BgL_arg2286z00_890); 
BgL_arg2283z00_889 = 
get_hash_power_number(BgL_auxz00_2454, ((long)16)); } } 
BgL_fieldsz00_886 = BgL_fieldsz00_53; 
BgL_hashz00_887 = BgL_arg2283z00_889; 
BgL_loopz00_888:
if(
NULLP(BgL_fieldsz00_886))
{ /* Module/class.scm 243 */
return 
BINT(BgL_hashz00_887);}  else 
{ /* Module/class.scm 245 */
obj_t BgL_fieldz00_893;
BgL_fieldz00_893 = 
CAR(BgL_fieldsz00_886); 
{ 
obj_t BgL_idz00_899;obj_t BgL_attz00_900;obj_t BgL_idz00_896;obj_t BgL_attz00_897;
if(
PAIRP(BgL_fieldz00_893))
{ /* Module/class.scm 246 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_fieldz00_893), BNIL))
{ /* Module/class.scm 246 */
{ 
long BgL_hashz00_2468;obj_t BgL_fieldsz00_2466;
BgL_fieldsz00_2466 = 
CDR(BgL_fieldsz00_886); 
BgL_hashz00_2468 = 
(BgL_hashz00_887 ^ ((long)2344)); 
BgL_hashz00_887 = BgL_hashz00_2468; 
BgL_fieldsz00_886 = BgL_fieldsz00_2466; 
goto BgL_loopz00_888;} }  else 
{ /* Module/class.scm 246 */
if(
SYMBOLP(BgL_fieldz00_893))
{ /* Module/class.scm 246 */
BgL_tagzd2121zd2_895:
{ /* Module/class.scm 251 */
obj_t BgL_arg2350z00_928;long BgL_arg2351z00_929;
BgL_arg2350z00_928 = 
CDR(BgL_fieldsz00_886); 
{ /* Module/class.scm 254 */
long BgL_arg2355z00_930;
{ /* Module/class.scm 254 */
obj_t BgL_arg2358z00_931;
BgL_arg2358z00_931 = 
SYMBOL_TO_STRING(BgL_fieldz00_893); 
{ /* Module/class.scm 253 */
char * BgL_auxz00_2474;
BgL_auxz00_2474 = 
BSTRING_TO_STRING(BgL_arg2358z00_931); 
BgL_arg2355z00_930 = 
get_hash_power_number(BgL_auxz00_2474, ((long)16)); } } 
BgL_arg2351z00_929 = 
(BgL_hashz00_887 ^ BgL_arg2355z00_930); } 
{ 
long BgL_hashz00_2479;obj_t BgL_fieldsz00_2478;
BgL_fieldsz00_2478 = BgL_arg2350z00_928; 
BgL_hashz00_2479 = BgL_arg2351z00_929; 
BgL_hashz00_887 = BgL_hashz00_2479; 
BgL_fieldsz00_886 = BgL_fieldsz00_2478; 
goto BgL_loopz00_888;} } }  else 
{ /* Module/class.scm 246 */
obj_t BgL_cdrzd2136zd2_906;
BgL_cdrzd2136zd2_906 = 
CDR(BgL_fieldz00_893); 
{ /* Module/class.scm 246 */
bool_t BgL_testz00_2481;
{ /* Module/class.scm 246 */
obj_t BgL_auxz00_2484;obj_t BgL_auxz00_2482;
BgL_auxz00_2484 = 
CNST_TABLE_REF(((long)17)); 
BgL_auxz00_2482 = 
CAR(BgL_fieldz00_893); 
BgL_testz00_2481 = 
(BgL_auxz00_2482==BgL_auxz00_2484); } 
if(BgL_testz00_2481)
{ /* Module/class.scm 246 */
if(
PAIRP(BgL_cdrzd2136zd2_906))
{ /* Module/class.scm 246 */
obj_t BgL_carzd2139zd2_909;
BgL_carzd2139zd2_909 = 
CAR(BgL_cdrzd2136zd2_906); 
if(
SYMBOLP(BgL_carzd2139zd2_909))
{ /* Module/class.scm 246 */
BgL_idz00_896 = BgL_carzd2139zd2_909; 
BgL_attz00_897 = 
CDR(BgL_cdrzd2136zd2_906); 
{ /* Module/class.scm 257 */
obj_t BgL_arg2363z00_933;long BgL_arg2364z00_934;
BgL_arg2363z00_933 = 
CDR(BgL_fieldsz00_886); 
{ /* Module/class.scm 260 */
long BgL_arg2368z00_935;
{ /* Module/class.scm 260 */
obj_t BgL_arg2371z00_936;
{ /* Module/class.scm 260 */
obj_t BgL_arg2376z00_939;
BgL_arg2376z00_939 = 
SYMBOL_TO_STRING(BgL_idz00_896); 
BgL_arg2371z00_936 = 
string_append(BGl_string3320z00zzmodule_classz00, BgL_arg2376z00_939); } 
{ /* Module/class.scm 259 */
char * BgL_auxz00_2495;
BgL_auxz00_2495 = 
BSTRING_TO_STRING(BgL_arg2371z00_936); 
BgL_arg2368z00_935 = 
get_hash_power_number(BgL_auxz00_2495, ((long)16)); } } 
BgL_arg2364z00_934 = 
(BgL_hashz00_887 ^ BgL_arg2368z00_935); } 
{ 
long BgL_hashz00_2500;obj_t BgL_fieldsz00_2499;
BgL_fieldsz00_2499 = BgL_arg2363z00_933; 
BgL_hashz00_2500 = BgL_arg2364z00_934; 
BgL_hashz00_887 = BgL_hashz00_2500; 
BgL_fieldsz00_886 = BgL_fieldsz00_2499; 
goto BgL_loopz00_888;} } }  else 
{ /* Module/class.scm 246 */
obj_t BgL_carzd2148zd2_912;
BgL_carzd2148zd2_912 = 
CAR(BgL_fieldz00_893); 
if(
SYMBOLP(BgL_carzd2148zd2_912))
{ /* Module/class.scm 246 */
BgL_idz00_899 = BgL_carzd2148zd2_912; 
BgL_attz00_900 = BgL_cdrzd2136zd2_906; 
BgL_tagzd2123zd2_901:
{ /* Module/class.scm 265 */
obj_t BgL_arg2380z00_940;long BgL_arg2381z00_941;
BgL_arg2380z00_940 = 
CDR(BgL_fieldsz00_886); 
{ /* Module/class.scm 268 */
long BgL_arg2385z00_942;
{ /* Module/class.scm 268 */
obj_t BgL_arg2388z00_943;
BgL_arg2388z00_943 = 
SYMBOL_TO_STRING(BgL_idz00_899); 
{ /* Module/class.scm 267 */
char * BgL_auxz00_2507;
BgL_auxz00_2507 = 
BSTRING_TO_STRING(BgL_arg2388z00_943); 
BgL_arg2385z00_942 = 
get_hash_power_number(BgL_auxz00_2507, ((long)16)); } } 
BgL_arg2381z00_941 = 
(BgL_hashz00_887 ^ BgL_arg2385z00_942); } 
{ 
long BgL_hashz00_2512;obj_t BgL_fieldsz00_2511;
BgL_fieldsz00_2511 = BgL_arg2380z00_940; 
BgL_hashz00_2512 = BgL_arg2381z00_941; 
BgL_hashz00_887 = BgL_hashz00_2512; 
BgL_fieldsz00_886 = BgL_fieldsz00_2511; 
goto BgL_loopz00_888;} } }  else 
{ /* Module/class.scm 246 */
return BFALSE;} } }  else 
{ /* Module/class.scm 246 */
obj_t BgL_carzd2157zd2_915;
BgL_carzd2157zd2_915 = 
CAR(BgL_fieldz00_893); 
if(
SYMBOLP(BgL_carzd2157zd2_915))
{ 
obj_t BgL_attz00_2517;obj_t BgL_idz00_2516;
BgL_idz00_2516 = BgL_carzd2157zd2_915; 
BgL_attz00_2517 = BgL_cdrzd2136zd2_906; 
BgL_attz00_900 = BgL_attz00_2517; 
BgL_idz00_899 = BgL_idz00_2516; 
goto BgL_tagzd2123zd2_901;}  else 
{ /* Module/class.scm 246 */
return BFALSE;} } }  else 
{ /* Module/class.scm 246 */
obj_t BgL_carzd2166zd2_918;
BgL_carzd2166zd2_918 = 
CAR(BgL_fieldz00_893); 
if(
SYMBOLP(BgL_carzd2166zd2_918))
{ 
obj_t BgL_attz00_2522;obj_t BgL_idz00_2521;
BgL_idz00_2521 = BgL_carzd2166zd2_918; 
BgL_attz00_2522 = BgL_cdrzd2136zd2_906; 
BgL_attz00_900 = BgL_attz00_2522; 
BgL_idz00_899 = BgL_idz00_2521; 
goto BgL_tagzd2123zd2_901;}  else 
{ /* Module/class.scm 246 */
return BFALSE;} } } } } }  else 
{ /* Module/class.scm 246 */
if(
SYMBOLP(BgL_fieldz00_893))
{ /* Module/class.scm 246 */
goto BgL_tagzd2121zd2_895;}  else 
{ /* Module/class.scm 246 */
return BFALSE;} } } } } } } 
}



/* _get-class-hash */
obj_t BGl__getzd2classzd2hashz00zzmodule_classz00(obj_t BgL_envz00_1990, obj_t BgL_classzd2idzd2_1991, obj_t BgL_fieldsz00_1992)
{ AN_OBJECT;
{ /* Module/class.scm 240 */
return 
BGl_getzd2classzd2hashz00zzmodule_classz00(BgL_classzd2idzd2_1991, BgL_fieldsz00_1992);} 
}



/* make-class-fields */
obj_t BGl_makezd2classzd2fieldsz00zzmodule_classz00(obj_t BgL_classzd2idzd2_54, obj_t BgL_slotzd2defszd2_55, obj_t BgL_locz00_56)
{ AN_OBJECT;
{ /* Module/class.scm 278 */
{ /* Module/class.scm 345 */
obj_t BgL_slotzd2defszd2_949;
if(
PAIRP(BgL_slotzd2defszd2_55))
{ /* Module/class.scm 345 */
obj_t BgL_carzd2248zd2_975;
BgL_carzd2248zd2_975 = 
CAR(BgL_slotzd2defszd2_55); 
if(
PAIRP(BgL_carzd2248zd2_975))
{ /* Module/class.scm 345 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_carzd2248zd2_975), BNIL))
{ /* Module/class.scm 345 */
BgL_slotzd2defszd2_949 = 
CDR(BgL_slotzd2defszd2_55); }  else 
{ /* Module/class.scm 345 */
BgL_slotzd2defszd2_949 = BgL_slotzd2defszd2_55; } }  else 
{ /* Module/class.scm 345 */
BgL_slotzd2defszd2_949 = BgL_slotzd2defszd2_55; } }  else 
{ /* Module/class.scm 345 */
BgL_slotzd2defszd2_949 = BgL_slotzd2defszd2_55; } 
{ /* Module/class.scm 350 */
obj_t BgL_arg2396z00_950;obj_t BgL_arg2397z00_951;
BgL_arg2396z00_950 = 
CNST_TABLE_REF(((long)18)); 
{ /* Module/class.scm 350 */
obj_t BgL_arg2400z00_952;
if(
NULLP(BgL_slotzd2defszd2_949))
{ /* Module/class.scm 350 */
BgL_arg2400z00_952 = BNIL; }  else 
{ /* Module/class.scm 350 */
obj_t BgL_head1786z00_956;
{ /* Module/class.scm 350 */
obj_t BgL_arg2424z00_967;
BgL_arg2424z00_967 = 
BGl_makezd2slotzd2fieldz00zzmodule_classz00(BgL_classzd2idzd2_54, BgL_locz00_56, 
CAR(BgL_slotzd2defszd2_949)); 
BgL_head1786z00_956 = 
MAKE_PAIR(BgL_arg2424z00_967, BNIL); } 
{ 
obj_t BgL_l1784z00_957;obj_t BgL_tail1787z00_958;
BgL_l1784z00_957 = 
CDR(BgL_slotzd2defszd2_949); 
BgL_tail1787z00_958 = BgL_head1786z00_956; 
BgL_lname1785z00_959:
if(
NULLP(BgL_l1784z00_957))
{ /* Module/class.scm 350 */
BgL_arg2400z00_952 = BgL_head1786z00_956; }  else 
{ /* Module/class.scm 350 */
obj_t BgL_newtail1788z00_962;
{ /* Module/class.scm 350 */
obj_t BgL_arg2415z00_964;
BgL_arg2415z00_964 = 
BGl_makezd2slotzd2fieldz00zzmodule_classz00(BgL_classzd2idzd2_54, BgL_locz00_56, 
CAR(BgL_l1784z00_957)); 
BgL_newtail1788z00_962 = 
MAKE_PAIR(BgL_arg2415z00_964, BNIL); } 
SET_CDR(BgL_tail1787z00_958, BgL_newtail1788z00_962); 
{ 
obj_t BgL_tail1787z00_2549;obj_t BgL_l1784z00_2547;
BgL_l1784z00_2547 = 
CDR(BgL_l1784z00_957); 
BgL_tail1787z00_2549 = BgL_newtail1788z00_962; 
BgL_tail1787z00_958 = BgL_tail1787z00_2549; 
BgL_l1784z00_957 = BgL_l1784z00_2547; 
goto BgL_lname1785z00_959;} } } } 
BgL_arg2397z00_951 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2400z00_952, BNIL); } 
return 
MAKE_PAIR(BgL_arg2396z00_950, BgL_arg2397z00_951);} } } 
}



/* read-only? */
bool_t BGl_readzd2onlyzf3z21zzmodule_classz00(obj_t BgL_attrz00_1132)
{ AN_OBJECT;
{ /* Module/class.scm 287 */
{ 
obj_t BgL_attrz00_1134;
BgL_attrz00_1134 = BgL_attrz00_1132; 
BgL_loopz00_1135:
if(
NULLP(BgL_attrz00_1134))
{ /* Module/class.scm 282 */
return ((bool_t)0);}  else 
{ /* Module/class.scm 284 */
bool_t BgL_testz00_2555;
{ /* Module/class.scm 284 */
obj_t BgL_auxz00_2558;obj_t BgL_auxz00_2556;
BgL_auxz00_2558 = 
CNST_TABLE_REF(((long)19)); 
BgL_auxz00_2556 = 
CAR(BgL_attrz00_1134); 
BgL_testz00_2555 = 
(BgL_auxz00_2556==BgL_auxz00_2558); } 
if(BgL_testz00_2555)
{ /* Module/class.scm 284 */
return ((bool_t)1);}  else 
{ /* Module/class.scm 284 */
{ 
obj_t BgL_attrz00_2561;
BgL_attrz00_2561 = 
CDR(BgL_attrz00_1134); 
BgL_attrz00_1134 = BgL_attrz00_2561; 
goto BgL_loopz00_1135;} } } } } 
}



/* find-info-attribute */
obj_t BGl_findzd2infozd2attributez00zzmodule_classz00(obj_t BgL_attrz00_1103)
{ AN_OBJECT;
{ /* Module/class.scm 304 */
BGl_findzd2infozd2attributez00zzmodule_classz00:
if(
PAIRP(BgL_attrz00_1103))
{ 

{ /* Module/class.scm 300 */
obj_t BgL_ezd2183zd2_1109;
BgL_ezd2183zd2_1109 = 
CAR(BgL_attrz00_1103); 
if(
PAIRP(BgL_ezd2183zd2_1109))
{ /* Module/class.scm 300 */
obj_t BgL_cdrzd2187zd2_1111;
BgL_cdrzd2187zd2_1111 = 
CDR(BgL_ezd2183zd2_1109); 
{ /* Module/class.scm 300 */
bool_t BgL_testz00_2569;
{ /* Module/class.scm 300 */
obj_t BgL_auxz00_2572;obj_t BgL_auxz00_2570;
BgL_auxz00_2572 = 
CNST_TABLE_REF(((long)20)); 
BgL_auxz00_2570 = 
CAR(BgL_ezd2183zd2_1109); 
BgL_testz00_2569 = 
(BgL_auxz00_2570==BgL_auxz00_2572); } 
if(BgL_testz00_2569)
{ /* Module/class.scm 300 */
if(
PAIRP(BgL_cdrzd2187zd2_1111))
{ /* Module/class.scm 300 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2187zd2_1111), BNIL))
{ /* Module/class.scm 300 */
return 
CAR(BgL_cdrzd2187zd2_1111);}  else 
{ /* Module/class.scm 300 */
BgL_tagzd2182zd2_1108:
{ 
obj_t BgL_attrz00_2581;
BgL_attrz00_2581 = 
CDR(BgL_attrz00_1103); 
BgL_attrz00_1103 = BgL_attrz00_2581; 
goto BGl_findzd2infozd2attributez00zzmodule_classz00;} } }  else 
{ /* Module/class.scm 300 */
goto BgL_tagzd2182zd2_1108;} }  else 
{ /* Module/class.scm 300 */
goto BgL_tagzd2182zd2_1108;} } }  else 
{ /* Module/class.scm 300 */
goto BgL_tagzd2182zd2_1108;} } }  else 
{ /* Module/class.scm 298 */
return BFALSE;} } 
}



/* make-slot-field */
obj_t BGl_makezd2slotzd2fieldz00zzmodule_classz00(obj_t BgL_classzd2idzd2_1995, obj_t BgL_locz00_1994, obj_t BgL_slotz00_981)
{ AN_OBJECT;
{ /* Module/class.scm 344 */
{ 
obj_t BgL_attrz00_1121;
{ 
obj_t BgL_idz00_984;obj_t BgL_attz00_985;obj_t BgL_idz00_987;obj_t BgL_attz00_988;
if(
SYMBOLP(BgL_slotz00_981))
{ /* Module/class.scm 344 */
{ /* Module/class.scm 309 */
obj_t BgL_idz00_1011;
BgL_idz00_1011 = 
BGl_fastzd2idzd2ofzd2idzd2zzast_identz00(BgL_slotz00_981, BgL_locz00_1994); 
{ /* Module/class.scm 310 */
obj_t BgL_arg2498z00_1012;obj_t BgL_arg2499z00_1013;
{ /* Module/class.scm 310 */
obj_t BgL_arg2502z00_1014;obj_t BgL_arg2503z00_1015;
BgL_arg2502z00_1014 = 
CNST_TABLE_REF(((long)11)); 
{ /* Module/class.scm 310 */
obj_t BgL_arg2506z00_1016;obj_t BgL_arg2507z00_1017;
BgL_arg2506z00_1016 = 
CNST_TABLE_REF(((long)22)); 
{ /* Module/class.scm 310 */
obj_t BgL_auxz00_2588;
BgL_auxz00_2588 = 
CNST_TABLE_REF(((long)14)); 
BgL_arg2507z00_1017 = 
MAKE_PAIR(BgL_auxz00_2588, BNIL); } 
BgL_arg2503z00_1015 = 
MAKE_PAIR(BgL_arg2506z00_1016, BgL_arg2507z00_1017); } 
BgL_arg2498z00_1012 = 
MAKE_PAIR(BgL_arg2502z00_1014, BgL_arg2503z00_1015); } 
{ /* Module/class.scm 311 */
obj_t BgL_arg2511z00_1018;obj_t BgL_arg2512z00_1019;
{ /* Module/class.scm 311 */
obj_t BgL_arg2515z00_1020;obj_t BgL_arg2516z00_1021;
BgL_arg2515z00_1020 = 
CNST_TABLE_REF(((long)10)); 
BgL_arg2516z00_1021 = 
MAKE_PAIR(BgL_idz00_1011, BNIL); 
BgL_arg2511z00_1018 = 
MAKE_PAIR(BgL_arg2515z00_1020, BgL_arg2516z00_1021); } 
{ /* Module/class.scm 312 */
obj_t BgL_arg2520z00_1022;obj_t BgL_arg2521z00_1023;
{ /* Module/class.scm 312 */
obj_t BgL_list2524z00_1024;
{ /* Module/class.scm 312 */
obj_t BgL_arg2526z00_1025;
{ /* Module/class.scm 312 */
obj_t BgL_arg2529z00_1026;obj_t BgL_arg2530z00_1027;
BgL_arg2529z00_1026 = 
CNST_TABLE_REF(((long)23)); 
BgL_arg2530z00_1027 = 
MAKE_PAIR(BgL_idz00_1011, BNIL); 
BgL_arg2526z00_1025 = 
MAKE_PAIR(BgL_arg2529z00_1026, BgL_arg2530z00_1027); } 
BgL_list2524z00_1024 = 
MAKE_PAIR(BgL_classzd2idzd2_1995, BgL_arg2526z00_1025); } 
BgL_arg2520z00_1022 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2524z00_1024); } 
{ /* Module/class.scm 313 */
obj_t BgL_arg2534z00_1028;obj_t BgL_arg2535z00_1029;
{ /* Module/class.scm 313 */
obj_t BgL_list2538z00_1030;
{ /* Module/class.scm 313 */
obj_t BgL_arg2540z00_1031;
{ /* Module/class.scm 313 */
obj_t BgL_arg2543z00_1032;obj_t BgL_arg2546z00_1033;
BgL_arg2543z00_1032 = 
CNST_TABLE_REF(((long)23)); 
{ /* Module/class.scm 313 */
obj_t BgL_arg2549z00_1034;
{ /* Module/class.scm 313 */
obj_t BgL_auxz00_2602;
BgL_auxz00_2602 = 
CNST_TABLE_REF(((long)24)); 
BgL_arg2549z00_1034 = 
MAKE_PAIR(BgL_auxz00_2602, BNIL); } 
BgL_arg2546z00_1033 = 
MAKE_PAIR(BgL_idz00_1011, BgL_arg2549z00_1034); } 
BgL_arg2540z00_1031 = 
MAKE_PAIR(BgL_arg2543z00_1032, BgL_arg2546z00_1033); } 
BgL_list2538z00_1030 = 
MAKE_PAIR(BgL_classzd2idzd2_1995, BgL_arg2540z00_1031); } 
BgL_arg2534z00_1028 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2538z00_1030); } 
{ /* Module/class.scm 310 */
obj_t BgL_arg2553z00_1035;
{ /* Module/class.scm 310 */
obj_t BgL_arg2556z00_1036;
BgL_arg2556z00_1036 = 
MAKE_PAIR(BFALSE, BNIL); 
BgL_arg2553z00_1035 = 
MAKE_PAIR(BFALSE, BgL_arg2556z00_1036); } 
BgL_arg2535z00_1029 = 
MAKE_PAIR(BUNSPEC, BgL_arg2553z00_1035); } 
BgL_arg2521z00_1023 = 
MAKE_PAIR(BgL_arg2534z00_1028, BgL_arg2535z00_1029); } 
BgL_arg2512z00_1019 = 
MAKE_PAIR(BgL_arg2520z00_1022, BgL_arg2521z00_1023); } 
BgL_arg2499z00_1013 = 
MAKE_PAIR(BgL_arg2511z00_1018, BgL_arg2512z00_1019); } 
return 
MAKE_PAIR(BgL_arg2498z00_1012, BgL_arg2499z00_1013);} } }  else 
{ /* Module/class.scm 344 */
if(
PAIRP(BgL_slotz00_981))
{ /* Module/class.scm 344 */
obj_t BgL_cdrzd2204zd2_994;
BgL_cdrzd2204zd2_994 = 
CDR(BgL_slotz00_981); 
{ /* Module/class.scm 344 */
bool_t BgL_testz00_2619;
{ /* Module/class.scm 344 */
obj_t BgL_auxz00_2622;obj_t BgL_auxz00_2620;
BgL_auxz00_2622 = 
CNST_TABLE_REF(((long)17)); 
BgL_auxz00_2620 = 
CAR(BgL_slotz00_981); 
BgL_testz00_2619 = 
(BgL_auxz00_2620==BgL_auxz00_2622); } 
if(BgL_testz00_2619)
{ /* Module/class.scm 344 */
if(
PAIRP(BgL_cdrzd2204zd2_994))
{ /* Module/class.scm 344 */
obj_t BgL_carzd2207zd2_997;
BgL_carzd2207zd2_997 = 
CAR(BgL_cdrzd2204zd2_994); 
if(
SYMBOLP(BgL_carzd2207zd2_997))
{ /* Module/class.scm 344 */
BgL_idz00_984 = BgL_carzd2207zd2_997; 
BgL_attz00_985 = 
CDR(BgL_cdrzd2204zd2_994); 
{ /* Module/class.scm 319 */
obj_t BgL_idz00_1037;
BgL_idz00_1037 = 
BGl_fastzd2idzd2ofzd2idzd2zzast_identz00(BgL_idz00_984, BgL_locz00_1994); 
{ /* Module/class.scm 320 */
obj_t BgL_arg2561z00_1038;obj_t BgL_arg2562z00_1039;
{ /* Module/class.scm 320 */
obj_t BgL_arg2565z00_1040;obj_t BgL_arg2566z00_1041;
BgL_arg2565z00_1040 = 
CNST_TABLE_REF(((long)11)); 
{ /* Module/class.scm 320 */
obj_t BgL_arg2569z00_1042;obj_t BgL_arg2570z00_1043;
BgL_arg2569z00_1042 = 
CNST_TABLE_REF(((long)22)); 
{ /* Module/class.scm 320 */
obj_t BgL_auxz00_2633;
BgL_auxz00_2633 = 
CNST_TABLE_REF(((long)14)); 
BgL_arg2570z00_1043 = 
MAKE_PAIR(BgL_auxz00_2633, BNIL); } 
BgL_arg2566z00_1041 = 
MAKE_PAIR(BgL_arg2569z00_1042, BgL_arg2570z00_1043); } 
BgL_arg2561z00_1038 = 
MAKE_PAIR(BgL_arg2565z00_1040, BgL_arg2566z00_1041); } 
{ /* Module/class.scm 321 */
obj_t BgL_arg2574z00_1044;obj_t BgL_arg2575z00_1045;
{ /* Module/class.scm 321 */
obj_t BgL_arg2578z00_1046;obj_t BgL_arg2579z00_1047;
BgL_arg2578z00_1046 = 
CNST_TABLE_REF(((long)10)); 
BgL_arg2579z00_1047 = 
MAKE_PAIR(BgL_idz00_1037, BNIL); 
BgL_arg2574z00_1044 = 
MAKE_PAIR(BgL_arg2578z00_1046, BgL_arg2579z00_1047); } 
{ /* Module/class.scm 322 */
obj_t BgL_arg2583z00_1048;obj_t BgL_arg2584z00_1049;
{ /* Module/class.scm 322 */
obj_t BgL_list2587z00_1050;
{ /* Module/class.scm 322 */
obj_t BgL_arg2589z00_1051;
{ /* Module/class.scm 322 */
obj_t BgL_arg2592z00_1052;obj_t BgL_arg2593z00_1053;
BgL_arg2592z00_1052 = 
CNST_TABLE_REF(((long)23)); 
{ /* Module/class.scm 322 */
obj_t BgL_arg2596z00_1054;
{ /* Module/class.scm 322 */
obj_t BgL_auxz00_2642;
BgL_auxz00_2642 = 
CNST_TABLE_REF(((long)25)); 
BgL_arg2596z00_1054 = 
MAKE_PAIR(BgL_auxz00_2642, BNIL); } 
BgL_arg2593z00_1053 = 
MAKE_PAIR(BgL_idz00_1037, BgL_arg2596z00_1054); } 
BgL_arg2589z00_1051 = 
MAKE_PAIR(BgL_arg2592z00_1052, BgL_arg2593z00_1053); } 
BgL_list2587z00_1050 = 
MAKE_PAIR(BgL_classzd2idzd2_1995, BgL_arg2589z00_1051); } 
BgL_arg2583z00_1048 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2587z00_1050); } 
{ /* Module/class.scm 323 */
obj_t BgL_arg2600z00_1055;obj_t BgL_arg2601z00_1056;
if(
BGl_readzd2onlyzf3z21zzmodule_classz00(BgL_attz00_985))
{ /* Module/class.scm 323 */
BgL_arg2600z00_1055 = BUNSPEC; }  else 
{ /* Module/class.scm 324 */
obj_t BgL_list2605z00_1058;
{ /* Module/class.scm 324 */
obj_t BgL_arg2608z00_1059;
{ /* Module/class.scm 324 */
obj_t BgL_arg2611z00_1060;obj_t BgL_arg2612z00_1061;
BgL_arg2611z00_1060 = 
CNST_TABLE_REF(((long)23)); 
{ /* Module/class.scm 324 */
obj_t BgL_arg2615z00_1062;
{ /* Module/class.scm 324 */
obj_t BgL_auxz00_2652;
BgL_auxz00_2652 = 
CNST_TABLE_REF(((long)24)); 
BgL_arg2615z00_1062 = 
MAKE_PAIR(BgL_auxz00_2652, BNIL); } 
BgL_arg2612z00_1061 = 
MAKE_PAIR(BgL_idz00_1037, BgL_arg2615z00_1062); } 
BgL_arg2608z00_1059 = 
MAKE_PAIR(BgL_arg2611z00_1060, BgL_arg2612z00_1061); } 
BgL_list2605z00_1058 = 
MAKE_PAIR(BgL_classzd2idzd2_1995, BgL_arg2608z00_1059); } 
BgL_arg2600z00_1055 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2605z00_1058); } 
{ /* Module/class.scm 326 */
obj_t BgL_arg2620z00_1063;obj_t BgL_arg2621z00_1064;
{ /* Module/class.scm 326 */
obj_t BgL_list2624z00_1065;
{ /* Module/class.scm 326 */
obj_t BgL_arg2626z00_1066;
{ /* Module/class.scm 326 */
obj_t BgL_arg2629z00_1067;obj_t BgL_arg2630z00_1068;
BgL_arg2629z00_1067 = 
CNST_TABLE_REF(((long)23)); 
{ /* Module/class.scm 326 */
obj_t BgL_arg2633z00_1069;
{ /* Module/class.scm 326 */
obj_t BgL_auxz00_2660;
BgL_auxz00_2660 = 
CNST_TABLE_REF(((long)26)); 
BgL_arg2633z00_1069 = 
MAKE_PAIR(BgL_auxz00_2660, BNIL); } 
BgL_arg2630z00_1068 = 
MAKE_PAIR(BgL_idz00_1037, BgL_arg2633z00_1069); } 
BgL_arg2626z00_1066 = 
MAKE_PAIR(BgL_arg2629z00_1067, BgL_arg2630z00_1068); } 
BgL_list2624z00_1065 = 
MAKE_PAIR(BgL_classzd2idzd2_1995, BgL_arg2626z00_1066); } 
BgL_arg2620z00_1063 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2624z00_1065); } 
{ /* Module/class.scm 328 */
obj_t BgL_arg2637z00_1070;
{ /* Module/class.scm 320 */
obj_t BgL_auxz00_2667;
BgL_auxz00_2667 = 
BGl_findzd2infozd2attributez00zzmodule_classz00(BgL_slotz00_981); 
BgL_arg2637z00_1070 = 
MAKE_PAIR(BgL_auxz00_2667, BNIL); } 
BgL_arg2621z00_1064 = 
MAKE_PAIR(BFALSE, BgL_arg2637z00_1070); } 
BgL_arg2601z00_1056 = 
MAKE_PAIR(BgL_arg2620z00_1063, BgL_arg2621z00_1064); } 
BgL_arg2584z00_1049 = 
MAKE_PAIR(BgL_arg2600z00_1055, BgL_arg2601z00_1056); } 
BgL_arg2575z00_1045 = 
MAKE_PAIR(BgL_arg2583z00_1048, BgL_arg2584z00_1049); } 
BgL_arg2562z00_1039 = 
MAKE_PAIR(BgL_arg2574z00_1044, BgL_arg2575z00_1045); } 
return 
MAKE_PAIR(BgL_arg2561z00_1038, BgL_arg2562z00_1039);} } }  else 
{ /* Module/class.scm 344 */
obj_t BgL_carzd2216zd2_1000;
BgL_carzd2216zd2_1000 = 
CAR(BgL_slotz00_981); 
if(
SYMBOLP(BgL_carzd2216zd2_1000))
{ /* Module/class.scm 344 */
BgL_idz00_987 = BgL_carzd2216zd2_1000; 
BgL_attz00_988 = BgL_cdrzd2204zd2_994; 
BgL_tagzd2194zd2_989:
{ /* Module/class.scm 331 */
obj_t BgL_idz00_1073;
BgL_idz00_1073 = 
BGl_fastzd2idzd2ofzd2idzd2zzast_identz00(BgL_idz00_987, BgL_locz00_1994); 
{ /* Module/class.scm 332 */
obj_t BgL_arg2646z00_1074;obj_t BgL_arg2647z00_1075;
{ /* Module/class.scm 332 */
obj_t BgL_arg2650z00_1076;obj_t BgL_arg2651z00_1077;
BgL_arg2650z00_1076 = 
CNST_TABLE_REF(((long)11)); 
{ /* Module/class.scm 332 */
obj_t BgL_arg2654z00_1078;obj_t BgL_arg2655z00_1079;
BgL_arg2654z00_1078 = 
CNST_TABLE_REF(((long)22)); 
{ /* Module/class.scm 332 */
obj_t BgL_auxz00_2683;
BgL_auxz00_2683 = 
CNST_TABLE_REF(((long)14)); 
BgL_arg2655z00_1079 = 
MAKE_PAIR(BgL_auxz00_2683, BNIL); } 
BgL_arg2651z00_1077 = 
MAKE_PAIR(BgL_arg2654z00_1078, BgL_arg2655z00_1079); } 
BgL_arg2646z00_1074 = 
MAKE_PAIR(BgL_arg2650z00_1076, BgL_arg2651z00_1077); } 
{ /* Module/class.scm 333 */
obj_t BgL_arg2659z00_1080;obj_t BgL_arg2660z00_1081;
{ /* Module/class.scm 333 */
obj_t BgL_arg2663z00_1082;obj_t BgL_arg2664z00_1083;
BgL_arg2663z00_1082 = 
CNST_TABLE_REF(((long)10)); 
BgL_arg2664z00_1083 = 
MAKE_PAIR(BgL_idz00_1073, BNIL); 
BgL_arg2659z00_1080 = 
MAKE_PAIR(BgL_arg2663z00_1082, BgL_arg2664z00_1083); } 
{ /* Module/class.scm 334 */
obj_t BgL_arg2668z00_1084;obj_t BgL_arg2669z00_1085;
{ /* Module/class.scm 334 */
obj_t BgL_list2672z00_1086;
{ /* Module/class.scm 334 */
obj_t BgL_arg2674z00_1087;
{ /* Module/class.scm 334 */
obj_t BgL_arg2677z00_1088;obj_t BgL_arg2678z00_1089;
BgL_arg2677z00_1088 = 
CNST_TABLE_REF(((long)23)); 
BgL_arg2678z00_1089 = 
MAKE_PAIR(BgL_idz00_1073, BNIL); 
BgL_arg2674z00_1087 = 
MAKE_PAIR(BgL_arg2677z00_1088, BgL_arg2678z00_1089); } 
BgL_list2672z00_1086 = 
MAKE_PAIR(BgL_classzd2idzd2_1995, BgL_arg2674z00_1087); } 
BgL_arg2668z00_1084 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2672z00_1086); } 
{ /* Module/class.scm 335 */
obj_t BgL_arg2682z00_1090;obj_t BgL_arg2683z00_1091;
if(
BGl_readzd2onlyzf3z21zzmodule_classz00(BgL_attz00_988))
{ /* Module/class.scm 335 */
BgL_arg2682z00_1090 = BUNSPEC; }  else 
{ /* Module/class.scm 336 */
obj_t BgL_list2687z00_1093;
{ /* Module/class.scm 336 */
obj_t BgL_arg2689z00_1094;
{ /* Module/class.scm 336 */
obj_t BgL_arg2692z00_1095;obj_t BgL_arg2693z00_1096;
BgL_arg2692z00_1095 = 
CNST_TABLE_REF(((long)23)); 
{ /* Module/class.scm 336 */
obj_t BgL_arg2696z00_1097;
{ /* Module/class.scm 336 */
obj_t BgL_auxz00_2699;
BgL_auxz00_2699 = 
CNST_TABLE_REF(((long)24)); 
BgL_arg2696z00_1097 = 
MAKE_PAIR(BgL_auxz00_2699, BNIL); } 
BgL_arg2693z00_1096 = 
MAKE_PAIR(BgL_idz00_1073, BgL_arg2696z00_1097); } 
BgL_arg2689z00_1094 = 
MAKE_PAIR(BgL_arg2692z00_1095, BgL_arg2693z00_1096); } 
BgL_list2687z00_1093 = 
MAKE_PAIR(BgL_classzd2idzd2_1995, BgL_arg2689z00_1094); } 
BgL_arg2682z00_1090 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2687z00_1093); } 
{ /* Module/class.scm 339 */
obj_t BgL_arg2701z00_1098;
{ /* Module/class.scm 339 */
bool_t BgL_arg2704z00_1099;obj_t BgL_arg2705z00_1100;
BgL_attrz00_1121 = BgL_attz00_988; 
{ 
obj_t BgL_attrz00_1123;
BgL_attrz00_1123 = BgL_attrz00_1121; 
BgL_loopz00_1124:
if(
NULLP(BgL_attrz00_1123))
{ /* Module/class.scm 291 */
BgL_arg2704z00_1099 = ((bool_t)0); }  else 
{ /* Module/class.scm 293 */
bool_t BgL_testz00_2708;
{ /* Module/class.scm 293 */
bool_t BgL_testz00_2709;
{ /* Module/class.scm 293 */
obj_t BgL_auxz00_2710;
BgL_auxz00_2710 = 
CAR(BgL_attrz00_1123); 
BgL_testz00_2709 = 
PAIRP(BgL_auxz00_2710); } 
if(BgL_testz00_2709)
{ /* Module/class.scm 293 */
obj_t BgL_auxz00_2717;obj_t BgL_auxz00_2713;
BgL_auxz00_2717 = 
CNST_TABLE_REF(((long)21)); 
{ /* Module/class.scm 293 */
obj_t BgL_auxz00_2714;
BgL_auxz00_2714 = 
CAR(BgL_attrz00_1123); 
BgL_auxz00_2713 = 
CAR(BgL_auxz00_2714); } 
BgL_testz00_2708 = 
(BgL_auxz00_2713==BgL_auxz00_2717); }  else 
{ /* Module/class.scm 293 */
BgL_testz00_2708 = ((bool_t)0)
; } } 
if(BgL_testz00_2708)
{ /* Module/class.scm 293 */
BgL_arg2704z00_1099 = ((bool_t)1); }  else 
{ /* Module/class.scm 293 */
{ 
obj_t BgL_attrz00_2720;
BgL_attrz00_2720 = 
CDR(BgL_attrz00_1123); 
BgL_attrz00_1123 = BgL_attrz00_2720; 
goto BgL_loopz00_1124;} } } } 
{ /* Module/class.scm 332 */
obj_t BgL_auxz00_2722;
BgL_auxz00_2722 = 
BGl_findzd2infozd2attributez00zzmodule_classz00(BgL_slotz00_981); 
BgL_arg2705z00_1100 = 
MAKE_PAIR(BgL_auxz00_2722, BNIL); } 
{ /* Module/class.scm 332 */
obj_t BgL_auxz00_2725;
BgL_auxz00_2725 = 
BBOOL(BgL_arg2704z00_1099); 
BgL_arg2701z00_1098 = 
MAKE_PAIR(BgL_auxz00_2725, BgL_arg2705z00_1100); } } 
BgL_arg2683z00_1091 = 
MAKE_PAIR(BUNSPEC, BgL_arg2701z00_1098); } 
BgL_arg2669z00_1085 = 
MAKE_PAIR(BgL_arg2682z00_1090, BgL_arg2683z00_1091); } 
BgL_arg2660z00_1081 = 
MAKE_PAIR(BgL_arg2668z00_1084, BgL_arg2669z00_1085); } 
BgL_arg2647z00_1075 = 
MAKE_PAIR(BgL_arg2659z00_1080, BgL_arg2660z00_1081); } 
return 
MAKE_PAIR(BgL_arg2646z00_1074, BgL_arg2647z00_1075);} } }  else 
{ /* Module/class.scm 344 */
BgL_tagzd2195zd2_990:
return 
BGl_internalzd2errorzd2zztools_errorz00(BGl_string3321z00zzmodule_classz00, BGl_string3322z00zzmodule_classz00, BgL_slotz00_981);} } }  else 
{ /* Module/class.scm 344 */
obj_t BgL_carzd2225zd2_1003;
BgL_carzd2225zd2_1003 = 
CAR(BgL_slotz00_981); 
if(
SYMBOLP(BgL_carzd2225zd2_1003))
{ 
obj_t BgL_attz00_2738;obj_t BgL_idz00_2737;
BgL_idz00_2737 = BgL_carzd2225zd2_1003; 
BgL_attz00_2738 = BgL_cdrzd2204zd2_994; 
BgL_attz00_988 = BgL_attz00_2738; 
BgL_idz00_987 = BgL_idz00_2737; 
goto BgL_tagzd2194zd2_989;}  else 
{ /* Module/class.scm 344 */
goto BgL_tagzd2195zd2_990;} } }  else 
{ /* Module/class.scm 344 */
obj_t BgL_carzd2234zd2_1006;
BgL_carzd2234zd2_1006 = 
CAR(BgL_slotz00_981); 
if(
SYMBOLP(BgL_carzd2234zd2_1006))
{ 
obj_t BgL_attz00_2743;obj_t BgL_idz00_2742;
BgL_idz00_2742 = BgL_carzd2234zd2_1006; 
BgL_attz00_2743 = BgL_cdrzd2204zd2_994; 
BgL_attz00_988 = BgL_attz00_2743; 
BgL_idz00_987 = BgL_idz00_2742; 
goto BgL_tagzd2194zd2_989;}  else 
{ /* Module/class.scm 344 */
goto BgL_tagzd2195zd2_990;} } } }  else 
{ /* Module/class.scm 344 */
goto BgL_tagzd2195zd2_990;} } } } } 
}



/* class-finalizer */
obj_t BGl_classzd2finaliza7erz75zzmodule_classz00()
{ AN_OBJECT;
{ /* Module/class.scm 357 */
{ /* Module/class.scm 359 */
bool_t BgL_test2781z00_1145;
{ /* Module/class.scm 359 */
obj_t BgL_objz00_1605;
BgL_objz00_1605 = BGl_za2classzd2accessesza2zd2zzmodule_classz00; 
BgL_test2781z00_1145 = 
NULLP(BgL_objz00_1605); } 
if(BgL_test2781z00_1145)
{ /* Module/class.scm 359 */
return 
CNST_TABLE_REF(((long)27));}  else 
{ /* Module/class.scm 359 */
{ /* Module/class.scm 374 */
obj_t BgL_bodyz00_1146;
BgL_bodyz00_1146 = 
BGl_forcezd2classzd2accessesz00zzmodule_classz00(); 
{ /* Module/class.scm 374 */
obj_t BgL_bodyz00_1147;
{ /* Module/class.scm 375 */
obj_t BgL_arg2826z00_1169;
BgL_arg2826z00_1169 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BGl_za2declaredzd2classesza2zd2zzmodule_classz00); 
BgL_bodyz00_1147 = 
bgl_append2(BgL_arg2826z00_1169, BgL_bodyz00_1146); } 
{ /* Module/class.scm 375 */
obj_t BgL_bodyz00_1148;
{ /* Module/class.scm 376 */
bool_t BgL_test2796z00_1155;
{ /* Module/class.scm 376 */
long BgL_n1z00_1606;
BgL_n1z00_1606 = 
(long)CINT(BGl_za2debugzd2moduleza2zd2zzengine_paramz00); 
BgL_test2796z00_1155 = 
(BgL_n1z00_1606>((long)0)); } 
if(BgL_test2796z00_1155)
{ /* Module/class.scm 377 */
obj_t BgL_arg2798z00_1156;
{ /* Module/class.scm 377 */
obj_t BgL_arg2802z00_1158;obj_t BgL_arg2803z00_1159;
BgL_arg2802z00_1158 = 
CNST_TABLE_REF(((long)28)); 
{ /* Module/class.scm 378 */
obj_t BgL_arg2806z00_1160;obj_t BgL_arg2807z00_1161;
{ /* Module/class.scm 378 */
obj_t BgL_arg2810z00_1162;obj_t BgL_arg2811z00_1163;
BgL_arg2810z00_1162 = 
CNST_TABLE_REF(((long)29)); 
{ /* Module/class.scm 379 */
obj_t BgL_arg2814z00_1164;
{ /* Module/class.scm 379 */
obj_t BgL_arg2819z00_1167;
{ /* Module/class.scm 380 */
obj_t BgL_symbolz00_1608;
BgL_symbolz00_1608 = BGl_za2moduleza2z00zzmodule_modulez00; 
BgL_arg2819z00_1167 = 
SYMBOL_TO_STRING(BgL_symbolz00_1608); } 
BgL_arg2814z00_1164 = 
string_append_3(BGl_string3323z00zzmodule_classz00, BgL_arg2819z00_1167, BGl_string3324z00zzmodule_classz00); } 
BgL_arg2811z00_1163 = 
MAKE_PAIR(BgL_arg2814z00_1164, BNIL); } 
BgL_arg2806z00_1160 = 
MAKE_PAIR(BgL_arg2810z00_1162, BgL_arg2811z00_1163); } 
BgL_arg2807z00_1161 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_bodyz00_1147, BNIL); 
BgL_arg2803z00_1159 = 
MAKE_PAIR(BgL_arg2806z00_1160, BgL_arg2807z00_1161); } 
BgL_arg2798z00_1156 = 
MAKE_PAIR(BgL_arg2802z00_1158, BgL_arg2803z00_1159); } 
BgL_bodyz00_1148 = 
MAKE_PAIR(BgL_arg2798z00_1156, BNIL); }  else 
{ /* Module/class.scm 376 */
BgL_bodyz00_1148 = BgL_bodyz00_1147; } } 
{ /* Module/class.scm 376 */

{ /* Module/class.scm 384 */
obj_t BgL_arg2783z00_1149;obj_t BgL_arg2785z00_1151;
BgL_arg2783z00_1149 = 
CNST_TABLE_REF(((long)30)); 
if(
PAIRP(BgL_bodyz00_1148))
{ /* Module/class.scm 386 */
BgL_arg2785z00_1151 = BgL_bodyz00_1148; }  else 
{ /* Module/class.scm 386 */
BgL_arg2785z00_1151 = 
CNST_TABLE_REF(((long)31)); } 
{ /* Module/class.scm 384 */
obj_t BgL_newz00_1614;
{ /* Module/class.scm 384 */
int BgL_auxz00_2769;obj_t BgL_auxz00_2767;
BgL_auxz00_2769 = 
(int)(((long)4)); 
BgL_auxz00_2767 = 
CNST_TABLE_REF(((long)32)); 
BgL_newz00_1614 = 
create_struct(BgL_auxz00_2767, BgL_auxz00_2769); } 
{ /* Module/class.scm 384 */
int BgL_auxz00_2772;
BgL_auxz00_2772 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_1614, BgL_auxz00_2772, BTRUE); } 
{ /* Module/class.scm 384 */
int BgL_auxz00_2775;
BgL_auxz00_2775 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_1614, BgL_auxz00_2775, BgL_arg2785z00_1151); } 
{ /* Module/class.scm 384 */
obj_t BgL_auxz00_2780;int BgL_auxz00_2778;
BgL_auxz00_2780 = 
BINT(((long)19)); 
BgL_auxz00_2778 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_1614, BgL_auxz00_2778, BgL_auxz00_2780); } 
{ /* Module/class.scm 384 */
int BgL_auxz00_2783;
BgL_auxz00_2783 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_1614, BgL_auxz00_2783, BgL_arg2783z00_1149); } 
BGl_za2objectzd2unitza2zd2zzmodule_classz00 = BgL_newz00_1614; } } 
{ /* Module/class.scm 394 */
obj_t BgL_idz00_1635;obj_t BgL_sexpza2za2_1637;
BgL_idz00_1635 = 
CNST_TABLE_REF(((long)33)); 
BgL_sexpza2za2_1637 = 
CNST_TABLE_REF(((long)31)); 
{ /* Module/class.scm 394 */
obj_t BgL_newz00_1639;
{ /* Module/class.scm 394 */
int BgL_auxz00_2790;obj_t BgL_auxz00_2788;
BgL_auxz00_2790 = 
(int)(((long)4)); 
BgL_auxz00_2788 = 
CNST_TABLE_REF(((long)32)); 
BgL_newz00_1639 = 
create_struct(BgL_auxz00_2788, BgL_auxz00_2790); } 
{ /* Module/class.scm 394 */
int BgL_auxz00_2793;
BgL_auxz00_2793 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_1639, BgL_auxz00_2793, BTRUE); } 
{ /* Module/class.scm 394 */
int BgL_auxz00_2796;
BgL_auxz00_2796 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_1639, BgL_auxz00_2796, BgL_sexpza2za2_1637); } 
{ /* Module/class.scm 394 */
obj_t BgL_auxz00_2801;int BgL_auxz00_2799;
BgL_auxz00_2801 = 
BINT(((long)20)); 
BgL_auxz00_2799 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_1639, BgL_auxz00_2799, BgL_auxz00_2801); } 
{ /* Module/class.scm 394 */
int BgL_auxz00_2804;
BgL_auxz00_2804 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_1639, BgL_auxz00_2804, BgL_idz00_1635); } 
BGl_za2methodzd2unitza2zd2zzmodule_classz00 = BgL_newz00_1639; } } 
{ /* Module/class.scm 400 */
obj_t BgL_list2791z00_1153;
{ /* Module/class.scm 400 */
obj_t BgL_arg2793z00_1154;
BgL_arg2793z00_1154 = 
MAKE_PAIR(BGl_za2methodzd2unitza2zd2zzmodule_classz00, BNIL); 
BgL_list2791z00_1153 = 
MAKE_PAIR(BGl_za2objectzd2unitza2zd2zzmodule_classz00, BgL_arg2793z00_1154); } 
return BgL_list2791z00_1153;} } } } } } } } 
}



/* _class-finalizer */
obj_t BGl__classzd2finaliza7erz75zzmodule_classz00(obj_t BgL_envz00_1993)
{ AN_OBJECT;
{ /* Module/class.scm 357 */
return 
BGl_classzd2finaliza7erz75zzmodule_classz00();} 
}



/* force-class-accesses */
obj_t BGl_forcezd2classzd2accessesz00zzmodule_classz00()
{ AN_OBJECT;
{ /* Module/class.scm 409 */
{ 
obj_t BgL_curz00_1170;obj_t BgL_nextz00_1171;obj_t BgL_accessz00_1172;
{ /* Module/class.scm 411 */
obj_t BgL_arg2832z00_1174;
BgL_arg2832z00_1174 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BGl_za2classzd2accessesza2zd2zzmodule_classz00); 
BgL_curz00_1170 = BgL_arg2832z00_1174; 
BgL_nextz00_1171 = BNIL; 
BgL_accessz00_1172 = BNIL; 
BgL_loopz00_1173:
if(
NULLP(BgL_curz00_1170))
{ /* Module/class.scm 414 */
if(
NULLP(BgL_nextz00_1171))
{ /* Module/class.scm 415 */
return BgL_accessz00_1172;}  else 
{ 
obj_t BgL_nextz00_2816;obj_t BgL_curz00_2815;
BgL_curz00_2815 = BgL_nextz00_1171; 
BgL_nextz00_2816 = BNIL; 
BgL_nextz00_1171 = BgL_nextz00_2816; 
BgL_curz00_1170 = BgL_curz00_2815; 
goto BgL_loopz00_1173;} }  else 
{ /* Module/class.scm 418 */
obj_t BgL_classz00_1179;
{ /* Module/class.scm 418 */
obj_t BgL_auxz00_2817;
BgL_auxz00_2817 = 
CAR(BgL_curz00_1170); 
BgL_classz00_1179 = 
CAR(BgL_auxz00_2817); } 
{ /* Module/class.scm 418 */
obj_t BgL_superz00_1180;
{ /* Module/class.scm 419 */
bool_t BgL_test2959z00_1224;
BgL_test2959z00_1224 = 
BGl_iszd2azf3z21zz__objectz00(BgL_classz00_1179, BGl_tclassz00zzobject_classz00); 
if(BgL_test2959z00_1224)
{ /* Module/class.scm 420 */
BgL_tclassz00_bglt BgL_obj1634z00_1667;
BgL_obj1634z00_1667 = 
(BgL_tclassz00_bglt)(BgL_classz00_1179); 
{ 
obj_t BgL_auxz00_2823;
{ /* Module/class.scm 420 */
BgL_objectz00_bglt BgL_auxz00_2824;
BgL_auxz00_2824 = 
(BgL_objectz00_bglt)(BgL_obj1634z00_1667); 
BgL_auxz00_2823 = 
BGL_OBJECT_WIDENING(BgL_auxz00_2824); } 
BgL_superz00_1180 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_2823))->BgL_itszd2superzd2); } }  else 
{ /* Module/class.scm 421 */
BgL_jclassz00_bglt BgL_obj1726z00_1668;
BgL_obj1726z00_1668 = 
(BgL_jclassz00_bglt)(BgL_classz00_1179); 
{ 
obj_t BgL_auxz00_2829;
{ /* Module/class.scm 421 */
BgL_objectz00_bglt BgL_auxz00_2830;
BgL_auxz00_2830 = 
(BgL_objectz00_bglt)(BgL_obj1726z00_1668); 
BgL_auxz00_2829 = 
BGL_OBJECT_WIDENING(BgL_auxz00_2830); } 
BgL_superz00_1180 = 
(((BgL_jclassz00_bglt)CREF(BgL_auxz00_2829))->BgL_itszd2superzd2); } } } 
{ /* Module/class.scm 419 */

if(
(BgL_superz00_1180==BgL_classz00_1179))
{ /* Module/class.scm 423 */
{ /* Module/class.scm 425 */
obj_t BgL_arg2844z00_1183;
{ /* Module/class.scm 427 */
obj_t BgL_arg2848z00_1184;
{ /* Module/class.scm 427 */
obj_t BgL_arg2851z00_1185;
{ /* Module/class.scm 427 */
obj_t BgL_auxz00_2836;
BgL_auxz00_2836 = 
CAR(BgL_curz00_1170); 
BgL_arg2851z00_1185 = 
CDR(BgL_auxz00_2836); } 
BgL_arg2848z00_1184 = 
PROCEDURE_ENTRY(BgL_arg2851z00_1185)(BgL_arg2851z00_1185, BEOA); } 
BgL_arg2844z00_1183 = 
bgl_append2(BgL_arg2848z00_1184, BgL_accessz00_1172); } 
{ 
obj_t BgL_accessz00_2844;obj_t BgL_curz00_2842;
BgL_curz00_2842 = 
CDR(BgL_curz00_1170); 
BgL_accessz00_2844 = BgL_arg2844z00_1183; 
BgL_accessz00_1172 = BgL_accessz00_2844; 
BgL_curz00_1170 = BgL_curz00_2842; 
goto BgL_loopz00_1173;} } }  else 
{ /* Module/class.scm 429 */
bool_t BgL_test2857z00_1187;
{ /* Module/class.scm 429 */
bool_t BgL_test2954z00_1222;
BgL_test2954z00_1222 = 
BGl_iszd2azf3z21zz__objectz00(BgL_classz00_1179, BGl_tclassz00zzobject_classz00); 
if(BgL_test2954z00_1222)
{ /* Module/class.scm 429 */
bool_t BgL_test2955z00_1223;
BgL_test2955z00_1223 = 
BGl_iszd2azf3z21zz__objectz00(BgL_superz00_1180, BGl_tclassz00zzobject_classz00); 
if(BgL_test2955z00_1223)
{ /* Module/class.scm 429 */
BgL_test2857z00_1187 = ((bool_t)0); }  else 
{ /* Module/class.scm 429 */
BgL_test2857z00_1187 = ((bool_t)1); } }  else 
{ /* Module/class.scm 429 */
BgL_test2857z00_1187 = ((bool_t)0); } } 
if(BgL_test2857z00_1187)
{ /* Module/class.scm 429 */
{ /* Module/class.scm 430 */
bool_t BgL_test2858z00_1188;
BgL_test2858z00_1188 = 
BGl_iszd2azf3z21zz__objectz00(BgL_superz00_1180, BGl_typez00zztype_typez00); 
if(BgL_test2858z00_1188)
{ /* Module/class.scm 430 */
{ /* Module/class.scm 434 */
BgL_tclassz00_bglt BgL_obj1639z00_1676;
BgL_obj1639z00_1676 = 
(BgL_tclassz00_bglt)(BgL_classz00_1179); 
{ 
obj_t BgL_auxz00_2853;
{ /* Module/class.scm 434 */
BgL_objectz00_bglt BgL_auxz00_2854;
BgL_auxz00_2854 = 
(BgL_objectz00_bglt)(BgL_obj1639z00_1676); 
BgL_auxz00_2853 = 
BGL_OBJECT_WIDENING(BgL_auxz00_2854); } 
((((BgL_tclassz00_bglt)CREF(BgL_auxz00_2853))->BgL_slotsz00) = ((obj_t)BNIL), BUNSPEC); } } 
{ 
obj_t BgL_curz00_2858;
BgL_curz00_2858 = 
CDR(BgL_curz00_1170); 
BgL_curz00_1170 = BgL_curz00_2858; 
goto BgL_loopz00_1173;} }  else 
{ /* Module/class.scm 438 */
obj_t BgL_arg2866z00_1191;
{ /* Module/class.scm 440 */
obj_t BgL_arg2870z00_1192;
{ /* Module/class.scm 440 */
obj_t BgL_arg2873z00_1193;
{ /* Module/class.scm 440 */
obj_t BgL_auxz00_2860;
BgL_auxz00_2860 = 
CAR(BgL_curz00_1170); 
BgL_arg2873z00_1193 = 
CDR(BgL_auxz00_2860); } 
BgL_arg2870z00_1192 = 
PROCEDURE_ENTRY(BgL_arg2873z00_1193)(BgL_arg2873z00_1193, BEOA); } 
BgL_arg2866z00_1191 = 
bgl_append2(BgL_arg2870z00_1192, BgL_accessz00_1172); } 
{ 
obj_t BgL_accessz00_2868;obj_t BgL_curz00_2866;
BgL_curz00_2866 = 
CDR(BgL_curz00_1170); 
BgL_accessz00_2868 = BgL_arg2866z00_1191; 
BgL_accessz00_1172 = BgL_accessz00_2868; 
BgL_curz00_1170 = BgL_curz00_2866; 
goto BgL_loopz00_1173;} } } }  else 
{ /* Module/class.scm 442 */
bool_t BgL_test2880z00_1195;
{ /* Module/class.scm 442 */
bool_t BgL_test2950z00_1220;
BgL_test2950z00_1220 = 
BGl_iszd2azf3z21zz__objectz00(BgL_classz00_1179, BGl_jclassz00zzobject_classz00); 
if(BgL_test2950z00_1220)
{ /* Module/class.scm 442 */
bool_t BgL_test2951z00_1221;
BgL_test2951z00_1221 = 
BGl_iszd2azf3z21zz__objectz00(BgL_superz00_1180, BGl_jclassz00zzobject_classz00); 
if(BgL_test2951z00_1221)
{ /* Module/class.scm 442 */
BgL_test2880z00_1195 = ((bool_t)0); }  else 
{ /* Module/class.scm 442 */
BgL_test2880z00_1195 = ((bool_t)1); } }  else 
{ /* Module/class.scm 442 */
BgL_test2880z00_1195 = ((bool_t)0); } } 
if(BgL_test2880z00_1195)
{ /* Module/class.scm 442 */
{ /* Module/class.scm 443 */
bool_t BgL_test2881z00_1196;
BgL_test2881z00_1196 = 
BGl_iszd2azf3z21zz__objectz00(BgL_superz00_1180, BGl_typez00zztype_typez00); 
if(BgL_test2881z00_1196)
{ /* Module/class.scm 443 */
{ /* Module/class.scm 447 */
BgL_jclassz00_bglt BgL_obj1731z00_1686;
BgL_obj1731z00_1686 = 
(BgL_jclassz00_bglt)(BgL_classz00_1179); 
{ 
obj_t BgL_auxz00_2877;
{ /* Module/class.scm 447 */
BgL_objectz00_bglt BgL_auxz00_2878;
BgL_auxz00_2878 = 
(BgL_objectz00_bglt)(BgL_obj1731z00_1686); 
BgL_auxz00_2877 = 
BGL_OBJECT_WIDENING(BgL_auxz00_2878); } 
((((BgL_jclassz00_bglt)CREF(BgL_auxz00_2877))->BgL_slotsz00) = ((obj_t)BNIL), BUNSPEC); } } 
{ 
obj_t BgL_curz00_2882;
BgL_curz00_2882 = 
CDR(BgL_curz00_1170); 
BgL_curz00_1170 = BgL_curz00_2882; 
goto BgL_loopz00_1173;} }  else 
{ /* Module/class.scm 451 */
obj_t BgL_arg2889z00_1199;
{ /* Module/class.scm 453 */
obj_t BgL_arg2893z00_1200;
{ /* Module/class.scm 453 */
obj_t BgL_arg2896z00_1201;
{ /* Module/class.scm 453 */
obj_t BgL_auxz00_2884;
BgL_auxz00_2884 = 
CAR(BgL_curz00_1170); 
BgL_arg2896z00_1201 = 
CDR(BgL_auxz00_2884); } 
BgL_arg2893z00_1200 = 
PROCEDURE_ENTRY(BgL_arg2896z00_1201)(BgL_arg2896z00_1201, BEOA); } 
BgL_arg2889z00_1199 = 
bgl_append2(BgL_arg2893z00_1200, BgL_accessz00_1172); } 
{ 
obj_t BgL_accessz00_2892;obj_t BgL_curz00_2890;
BgL_curz00_2890 = 
CDR(BgL_curz00_1170); 
BgL_accessz00_2892 = BgL_arg2889z00_1199; 
BgL_accessz00_1172 = BgL_accessz00_2892; 
BgL_curz00_1170 = BgL_curz00_2890; 
goto BgL_loopz00_1173;} } } }  else 
{ /* Module/class.scm 455 */
bool_t BgL_test2903z00_1203;
{ /* Module/class.scm 455 */
bool_t BgL_test2944z00_1218;
BgL_test2944z00_1218 = 
BGl_iszd2azf3z21zz__objectz00(BgL_classz00_1179, BGl_tclassz00zzobject_classz00); 
if(BgL_test2944z00_1218)
{ /* Module/class.scm 455 */
obj_t BgL_auxz00_2895;
{ /* Module/class.scm 455 */
BgL_tclassz00_bglt BgL_obj1637z00_1694;
BgL_obj1637z00_1694 = 
(BgL_tclassz00_bglt)(BgL_superz00_1180); 
{ 
obj_t BgL_auxz00_2897;
{ /* Module/class.scm 455 */
BgL_objectz00_bglt BgL_auxz00_2898;
BgL_auxz00_2898 = 
(BgL_objectz00_bglt)(BgL_obj1637z00_1694); 
BgL_auxz00_2897 = 
BGL_OBJECT_WIDENING(BgL_auxz00_2898); } 
BgL_auxz00_2895 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_2897))->BgL_slotsz00); } } 
BgL_test2903z00_1203 = 
(BgL_auxz00_2895==BUNSPEC); }  else 
{ /* Module/class.scm 455 */
BgL_test2903z00_1203 = ((bool_t)0); } } 
if(BgL_test2903z00_1203)
{ /* Module/class.scm 455 */
{ /* Module/class.scm 457 */
obj_t BgL_arg2905z00_1204;obj_t BgL_arg2906z00_1205;
BgL_arg2905z00_1204 = 
CDR(BgL_curz00_1170); 
{ /* Module/class.scm 458 */
obj_t BgL_auxz00_2905;
BgL_auxz00_2905 = 
CAR(BgL_curz00_1170); 
BgL_arg2906z00_1205 = 
MAKE_PAIR(BgL_auxz00_2905, BgL_nextz00_1171); } 
{ 
obj_t BgL_nextz00_2909;obj_t BgL_curz00_2908;
BgL_curz00_2908 = BgL_arg2905z00_1204; 
BgL_nextz00_2909 = BgL_arg2906z00_1205; 
BgL_nextz00_1171 = BgL_nextz00_2909; 
BgL_curz00_1170 = BgL_curz00_2908; 
goto BgL_loopz00_1173;} } }  else 
{ /* Module/class.scm 460 */
bool_t BgL_test2913z00_1207;
{ /* Module/class.scm 460 */
bool_t BgL_test2938z00_1216;
BgL_test2938z00_1216 = 
BGl_iszd2azf3z21zz__objectz00(BgL_classz00_1179, BGl_jclassz00zzobject_classz00); 
if(BgL_test2938z00_1216)
{ /* Module/class.scm 460 */
obj_t BgL_auxz00_2912;
{ /* Module/class.scm 460 */
BgL_jclassz00_bglt BgL_obj1729z00_1698;
BgL_obj1729z00_1698 = 
(BgL_jclassz00_bglt)(BgL_superz00_1180); 
{ 
obj_t BgL_auxz00_2914;
{ /* Module/class.scm 460 */
BgL_objectz00_bglt BgL_auxz00_2915;
BgL_auxz00_2915 = 
(BgL_objectz00_bglt)(BgL_obj1729z00_1698); 
BgL_auxz00_2914 = 
BGL_OBJECT_WIDENING(BgL_auxz00_2915); } 
BgL_auxz00_2912 = 
(((BgL_jclassz00_bglt)CREF(BgL_auxz00_2914))->BgL_slotsz00); } } 
BgL_test2913z00_1207 = 
(BgL_auxz00_2912==BUNSPEC); }  else 
{ /* Module/class.scm 460 */
BgL_test2913z00_1207 = ((bool_t)0); } } 
if(BgL_test2913z00_1207)
{ /* Module/class.scm 460 */
{ /* Module/class.scm 462 */
obj_t BgL_arg2915z00_1208;obj_t BgL_arg2916z00_1209;
BgL_arg2915z00_1208 = 
CDR(BgL_curz00_1170); 
{ /* Module/class.scm 463 */
obj_t BgL_auxz00_2922;
BgL_auxz00_2922 = 
CAR(BgL_curz00_1170); 
BgL_arg2916z00_1209 = 
MAKE_PAIR(BgL_auxz00_2922, BgL_nextz00_1171); } 
{ 
obj_t BgL_nextz00_2926;obj_t BgL_curz00_2925;
BgL_curz00_2925 = BgL_arg2915z00_1208; 
BgL_nextz00_2926 = BgL_arg2916z00_1209; 
BgL_nextz00_1171 = BgL_nextz00_2926; 
BgL_curz00_1170 = BgL_curz00_2925; 
goto BgL_loopz00_1173;} } }  else 
{ /* Module/class.scm 460 */
{ /* Module/class.scm 467 */
obj_t BgL_arg2925z00_1212;
{ /* Module/class.scm 469 */
obj_t BgL_arg2929z00_1213;
{ /* Module/class.scm 469 */
obj_t BgL_arg2932z00_1214;
{ /* Module/class.scm 469 */
obj_t BgL_auxz00_2927;
BgL_auxz00_2927 = 
CAR(BgL_curz00_1170); 
BgL_arg2932z00_1214 = 
CDR(BgL_auxz00_2927); } 
BgL_arg2929z00_1213 = 
PROCEDURE_ENTRY(BgL_arg2932z00_1214)(BgL_arg2932z00_1214, BEOA); } 
BgL_arg2925z00_1212 = 
bgl_append2(BgL_arg2929z00_1213, BgL_accessz00_1172); } 
{ 
obj_t BgL_accessz00_2935;obj_t BgL_curz00_2933;
BgL_curz00_2933 = 
CDR(BgL_curz00_1170); 
BgL_accessz00_2935 = BgL_arg2925z00_1212; 
BgL_accessz00_1172 = BgL_accessz00_2935; 
BgL_curz00_1170 = BgL_curz00_2933; 
goto BgL_loopz00_1173;} } } } } } } } } } } } } 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzmodule_classz00()
{ AN_OBJECT;
{ /* Module/class.scm 15 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzmodule_classz00()
{ AN_OBJECT;
{ /* Module/class.scm 15 */
BGl_modulezd2initializa7ationz75zztools_tracez00(((long)64647), "module_class"); 
BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long)12859), "module_class"); 
BGl_modulezd2initializa7ationz75zzmodule_impusez00(((long)21670), "module_class"); 
BGl_modulezd2initializa7ationz75zzmodule_includez00(((long)99), "module_class"); 
BGl_modulezd2initializa7ationz75zzengine_paramz00(((long)189840), "module_class"); 
BGl_modulezd2initializa7ationz75zztools_shapez00(((long)30825), "module_class"); 
BGl_modulezd2initializa7ationz75zztools_errorz00(((long)17886), "module_class"); 
BGl_modulezd2initializa7ationz75zztools_locationz00(((long)30714), "module_class"); 
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19010), "module_class"); 
BGl_modulezd2initializa7ationz75zztype_envz00(((long)25262), "module_class"); 
BGl_modulezd2initializa7ationz75zzast_identz00(((long)52188), "module_class"); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)28259), "module_class"); 
BGl_modulezd2initializa7ationz75zzast_envz00(((long)73271), "module_class"); 
BGl_modulezd2initializa7ationz75zzobject_classz00(((long)19348), "module_class"); 
BGl_modulezd2initializa7ationz75zzobject_plainzd2accesszd2(((long)40143), "module_class"); 
return 
BGl_modulezd2initializa7ationz75zzobject_widezd2accesszd2(((long)47531), "module_class");} 
}

