/*===========================================================================*/
/*   (Module/eval.scm)                                                       */
/*   Bigloo (2.5b)                                                           */
/*   Manuel Serrano (c)       Fri Sep 6 09:43:28 CEST 2002                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_nodez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
} *BgL_nodez00_bglt;

typedef struct BgL_nodezf2effectzf2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
} *BgL_nodezf2effectzf2_bglt;

typedef struct BgL_atomz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_atomz00_bglt;

typedef struct BgL_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_varz00_bglt;

typedef struct BgL_closurez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_closurez00_bglt;

typedef struct BgL_kwotez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_kwotez00_bglt;

typedef struct BgL_sequencez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_nodesz00;
} *BgL_sequencez00_bglt;

typedef struct BgL_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
} *BgL_appz00_bglt;

typedef struct BgL_appzd2lyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_appzd2lyzd2_bglt;

typedef struct BgL_funcallz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_strengthz00;
} *BgL_funcallz00_bglt;

typedef struct BgL_externz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_externz00_bglt;

typedef struct BgL_pragmaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_formatz00;
} *BgL_pragmaz00_bglt;

typedef struct BgL_getfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_getfieldz00_bglt;

typedef struct BgL_setfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_setfieldz00_bglt;

typedef struct BgL_newz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_newz00_bglt;

typedef struct BgL_vallocz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2heapzd2formatz00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_vallocz00_bglt;

typedef struct BgL_vrefz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vrefz00_bglt;

typedef struct BgL_vsetz12z12_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vsetz12z12_bglt;

typedef struct BgL_vlengthz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vlengthz00_bglt;

typedef struct BgL_isaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   struct BgL_typez00_bgl * BgL_classz00;
} *BgL_isaz00_bglt;

typedef struct BgL_castz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_castz00_bglt;

typedef struct BgL_setqz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_setqz00_bglt;

typedef struct BgL_conditionalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   struct BgL_nodez00_bgl * BgL_truez00;
   struct BgL_nodez00_bgl * BgL_falsez00;
} *BgL_conditionalz00_bglt;

typedef struct BgL_failz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_procz00;
   struct BgL_nodez00_bgl * BgL_msgz00;
   struct BgL_nodez00_bgl * BgL_objz00;
} *BgL_failz00_bglt;

typedef struct BgL_selectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   obj_t BgL_clausesz00;
   struct BgL_typez00_bgl * BgL_itemzd2typezd2;
} *BgL_selectz00_bglt;

typedef struct BgL_letzd2funzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_localsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_letzd2funzd2_bglt;

typedef struct BgL_letzd2varzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_bindingsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
   bool_t BgL_removablezf3zf3;
} *BgL_letzd2varzd2_bglt;

typedef struct BgL_setzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_setzd2exzd2itz00_bglt;

typedef struct BgL_jumpzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_exitz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_jumpzd2exzd2itz00_bglt;

typedef struct BgL_makezd2boxzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_makezd2boxzd2_bglt;

typedef struct BgL_boxzd2refzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_varz00;
} *BgL_boxzd2refzd2_bglt;

typedef struct BgL_boxzd2setz12zc0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_boxzd2setz12zc0_bglt;

typedef struct BgL_ccompz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_producerz00;
   obj_t BgL_consumerz00;
   obj_t BgL_finaliza7erza7;
} *BgL_ccompz00_bglt;


extern obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zzmodule_evalz00();
static bool_t BGl_za2onezd2evalzf3za2z21zzmodule_evalz00;
extern obj_t open_input_string(obj_t);
extern long BGl_classzd2numzd2zz__objectz00(obj_t);
extern obj_t BGl_sfunz00zzast_varz00;
extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
extern obj_t BGl_readz00zz__readerz00(obj_t);
extern bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
extern obj_t BGl_scnstz00zzast_varz00;
extern bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
extern obj_t BGl_svarz00zzast_varz00;
extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_za2moduleza2z00zzmodule_modulez00;
extern bool_t BGl_bigloozd2typezf3z21zztype_typez00(BgL_typez00_bglt);
static obj_t BGl_evalzd2finaliza7erz75zzmodule_evalz00();
extern obj_t BGl_za2_za2z00zztype_cachez00;
extern obj_t BGl_globalz00zzast_varz00;
extern obj_t BGl_findzd2locationzd2zztools_locationz00(obj_t);
extern obj_t BGl_za2libzd2modeza2zd2zzengine_paramz00;
extern obj_t BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(obj_t);
static obj_t BGl_za2evalzd2exportedza2zd2zzmodule_evalz00 = BUNSPEC;
extern obj_t BGl_makezd2evalzd2compilerz00zzmodule_evalz00();
static obj_t BGl_cnstzd2initzd2zzmodule_evalz00();
static obj_t BGl_zc3anonymousza32978ze3z83zzmodule_evalz00(obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zzmodule_evalz00();
extern BgL_nodez00_bglt BGl_locationzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt);
extern BgL_globalz00_bglt BGl_declarezd2globalzd2svarz12z12zzast_glozd2declzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zzmodule_evalz00();
static obj_t BGl_zc3anonymousza32723ze3z83zzmodule_evalz00(obj_t, obj_t, obj_t);
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_evalz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_includez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_glozd2declzd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
extern obj_t BGl_userzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_getzd2evaluatedzd2globalsz00zzmodule_evalz00();
extern BgL_nodez00_bglt BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt, BgL_nodez00_bglt);
extern BgL_nodez00_bglt BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(BgL_globalz00_bglt);
extern obj_t BGl_getzd2toplevelzd2unitzd2weightzd2zzmodule_includez00();
extern obj_t BGl_ccompz00zzmodule_modulez00;
extern obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
obj_t BGl_za2allzd2exportzd2mutablezf3za2zf3zzmodule_evalz00 = BUNSPEC;
extern obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t);
obj_t BGl_za2allzd2modulezd2evalzf3za2zf3zzmodule_evalz00 = BUNSPEC;
extern obj_t create_struct(obj_t, int);
static obj_t BGl_setzd2evalzd2typesz12z12zzmodule_evalz00(obj_t);
static obj_t BGl_evalzd2parserzd2zzmodule_evalz00(obj_t, obj_t);
static obj_t BGl_rememberzd2evalzd2exportedz12z12zzmodule_evalz00(obj_t, obj_t, obj_t);
static obj_t BGl_zc3anonymousza32912ze3z83zzmodule_evalz00(obj_t);
static obj_t BGl__makezd2evalzd2compilerz00zzmodule_evalz00(obj_t);
extern obj_t BGl_za2objza2z00zztype_cachez00;
obj_t BGl_za2allzd2exportzd2evalzf3za2zf3zzmodule_evalz00 = BUNSPEC;
extern obj_t BGl_makezd2promisezd2zz__r4_control_features_6_9z00(obj_t);
static obj_t BGl_requirezd2initializa7ationz75zzmodule_evalz00 = BUNSPEC;
static obj_t BGl_evalzd2producerzd2zzmodule_evalz00(obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zzmodule_evalz00();
static obj_t BGl__evalzd2producerzd2zzmodule_evalz00(obj_t, obj_t);
static obj_t BGl__evalzd2finaliza7erz75zzmodule_evalz00(obj_t);
obj_t BGl_za2allzd2evalzf3za2z21zzmodule_evalz00 = BUNSPEC;
static obj_t __cnst[ 15 ] ;

DEFINE_STRING( BGl_string3575z00zzmodule_evalz00, BgL_bgl_string3575za700za7za7module_evalza7003604z00, "(export) (static export) (import static export) (#unspecified) write begin void unit import @ export export-module export-exports export-all eval ", 146 );
DEFINE_STRING( BGl_string3574z00zzmodule_evalz00, BgL_bgl_string3574za700za7za7module_evalza7003605z00, "Unbound eval variable", 21 );
DEFINE_STRING( BGl_string3573z00zzmodule_evalz00, BgL_bgl_string3573za700za7za7module_evalza7003606z00, "This variable cannot be known by eval", 37 );
DEFINE_STRING( BGl_string3572z00zzmodule_evalz00, BgL_bgl_string3572za700za7za7module_evalza7003607z00, "eval-init", 9 );
DEFINE_STRING( BGl_string3571z00zzmodule_evalz00, BgL_bgl_string3571za700za7za7module_evalza7003608z00, "Non bigloo prototyped value can't be evaluated", 46 );
DEFINE_STRING( BGl_string3570z00zzmodule_evalz00, BgL_bgl_string3570za700za7za7module_evalza7003609z00, "eval", 4 );
DEFINE_STRING( BGl_string3568z00zzmodule_evalz00, BgL_bgl_string3568za700za7za7module_evalza7003610z00, "Illegal `eval clause'", 21 );
DEFINE_STRING( BGl_string3567z00zzmodule_evalz00, BgL_bgl_string3567za700za7za7module_evalza7003611z00, "Illegal `eval' clause", 21 );
DEFINE_STRING( BGl_string3566z00zzmodule_evalz00, BgL_bgl_string3566za700za7za7module_evalza7003612z00, "Parse error", 11 );
DEFINE_EXPORT_PROCEDURE( BGl_makezd2evalzd2compilerzd2envzd2zzmodule_evalz00, BgL_bgl__makeza7d2evalza7d2compilerza700za7za7module_evalza7003613z00, BGl__makezd2evalzd2compilerz00zzmodule_evalz00, 0L, 0 );
DEFINE_STATIC_PROCEDURE( BGl_evalzd2producerzd2envz00zzmodule_evalz00, BgL_bgl__evalza7d2producerza7d2za7za7module_evalza7003614za7, BGl__evalzd2producerzd2zzmodule_evalz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_evalzd2finaliza7erzd2envza7zzmodule_evalz00, BgL_bgl__evalza7d2finaliza7a7erza775za7za7module_evalza7003615z00, BGl__evalzd2finaliza7erz75zzmodule_evalz00, 0L, 0 );
DEFINE_STATIC_PROCEDURE( BGl_proc3565z00zzmodule_evalz00, BgL_bgl_za7c3anonymousza7a32723za7e3za783za7za7module_evalza7003616za7, BGl_zc3anonymousza32723ze3z83zzmodule_evalz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3569z00zzmodule_evalz00, BgL_bgl_za7c3anonymousza7a32912za7e3za783za7za7module_evalza7003617za7, BGl_zc3anonymousza32912ze3z83zzmodule_evalz00, 0L, 0 );



/* module-initialization */
obj_t BGl_modulezd2initializa7ationz75zzmodule_evalz00(long BgL_checksumz00_2538, char * BgL_fromz00_2539)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzmodule_evalz00))
{ 
BGl_requirezd2initializa7ationz75zzmodule_evalz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzmodule_evalz00(); 
BGl_cnstzd2initzd2zzmodule_evalz00(); 
BGl_importedzd2moduleszd2initz00zzmodule_evalz00(); 
BGl_toplevelzd2initzd2zzmodule_evalz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzmodule_evalz00()
{ AN_OBJECT;
{ /* Module/eval.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "module_eval"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "module_eval"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "module_eval"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "module_eval"); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)0), "module_eval"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzmodule_evalz00()
{ AN_OBJECT;
{ /* Module/eval.scm 15 */
{ /* Module/eval.scm 15 */
obj_t BgL_cportz00_2531;
BgL_cportz00_2531 = 
open_input_string(BGl_string3575z00zzmodule_evalz00); 
{ 
long BgL_iz00_2532;
BgL_iz00_2532 = ((long)14); 
BgL_loopz00_2533:
if(
(BgL_iz00_2532==((long)-1)))
{ /* Module/eval.scm 15 */
return BUNSPEC;}  else 
{ /* Module/eval.scm 15 */
{ /* Module/eval.scm 15 */
obj_t BgL_arg3579z00_2535;
{ /* Module/eval.scm 15 */
obj_t BgL_list3582z00_2536;
BgL_list3582z00_2536 = 
MAKE_PAIR(BgL_cportz00_2531, BNIL); 
BgL_arg3579z00_2535 = 
BGl_readz00zz__readerz00(BgL_list3582z00_2536); } 
{ /* Module/eval.scm 15 */
int BgL_auxz00_2557;
BgL_auxz00_2557 = 
(int)(BgL_iz00_2532); 
CNST_TABLE_SET(BgL_auxz00_2557, BgL_arg3579z00_2535); } } 
{ 
long BgL_iz00_2560;
{ /* Module/eval.scm 15 */
int BgL_auxz00_2561;
{ /* Module/eval.scm 15 */
long BgL_auxz00_2562;
BgL_auxz00_2562 = 
(BgL_iz00_2532-((long)1)); 
BgL_auxz00_2561 = 
(int)(BgL_auxz00_2562); } 
BgL_iz00_2560 = 
(long)(BgL_auxz00_2561); } 
BgL_iz00_2532 = BgL_iz00_2560; 
goto BgL_loopz00_2533;} } } } } 
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zzmodule_evalz00()
{ AN_OBJECT;
{ /* Module/eval.scm 15 */
BGl_za2evalzd2exportedza2zd2zzmodule_evalz00 = BNIL; 
BGl_za2allzd2evalzf3za2z21zzmodule_evalz00 = BFALSE; 
BGl_za2allzd2exportzd2evalzf3za2zf3zzmodule_evalz00 = BFALSE; 
BGl_za2allzd2modulezd2evalzf3za2zf3zzmodule_evalz00 = BFALSE; 
BGl_za2allzd2exportzd2mutablezf3za2zf3zzmodule_evalz00 = BFALSE; 
return ( 
BGl_za2onezd2evalzf3za2z21zzmodule_evalz00 = ((bool_t)0), BUNSPEC) ;} 
}



/* make-eval-compiler */
obj_t BGl_makezd2evalzd2compilerz00zzmodule_evalz00()
{ AN_OBJECT;
{ /* Module/eval.scm 37 */
{ /* Module/eval.scm 38 */
obj_t BgL_arg2718z00_1269;obj_t BgL_arg2719z00_1270;obj_t BgL_arg2721z00_1272;
BgL_arg2718z00_1269 = 
CNST_TABLE_REF(((long)0)); 
BgL_arg2719z00_1270 = BGl_evalzd2producerzd2envz00zzmodule_evalz00; 
BgL_arg2721z00_1272 = BGl_evalzd2finaliza7erzd2envza7zzmodule_evalz00; 
{ /* Module/eval.scm 38 */
BgL_ccompz00_bglt BgL_res3475z00_1892;
{ /* Module/eval.scm 38 */
BgL_ccompz00_bglt BgL_new2673z00_1876;
{ /* Module/eval.scm 38 */
BgL_ccompz00_bglt BgL_res3473z00_1882;
{ /* Module/eval.scm 38 */
BgL_ccompz00_bglt BgL_new2675z00_1877;
BgL_new2675z00_1877 = 
((BgL_ccompz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_ccompz00_bgl) ))); 
{ /* Module/eval.scm 38 */
long BgL_arg3056z00_1878;
BgL_arg3056z00_1878 = 
BGl_classzd2numzd2zz__objectz00(BGl_ccompz00zzmodule_modulez00); 
{ /* Module/eval.scm 38 */
BgL_objectz00_bglt BgL_auxz00_2569;
BgL_auxz00_2569 = 
(BgL_objectz00_bglt)(BgL_new2675z00_1877); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_2569, BgL_arg3056z00_1878); } } 
{ /* Module/eval.scm 38 */
BgL_objectz00_bglt BgL_auxz00_2572;
BgL_auxz00_2572 = 
(BgL_objectz00_bglt)(BgL_new2675z00_1877); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_2572, BFALSE); } 
{ /* Module/eval.scm 38 */
obj_t BgL_auxz00_2575;
BgL_auxz00_2575 = 
(obj_t)(BgL_new2675z00_1877); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_2575); } BUNSPEC; 
BgL_res3473z00_1882 = BgL_new2675z00_1877; } 
BgL_new2673z00_1876 = BgL_res3473z00_1882; } 
{ /* Module/eval.scm 38 */
BgL_ccompz00_bglt BgL_res3474z00_1891;
((((BgL_ccompz00_bglt)CREF(BgL_new2673z00_1876))->BgL_idz00) = ((obj_t)BgL_arg2718z00_1269), BUNSPEC); 
((((BgL_ccompz00_bglt)CREF(BgL_new2673z00_1876))->BgL_producerz00) = ((obj_t)BgL_arg2719z00_1270), BUNSPEC); 
((((BgL_ccompz00_bglt)CREF(BgL_new2673z00_1876))->BgL_consumerz00) = ((obj_t)BGl_proc3565z00zzmodule_evalz00), BUNSPEC); 
((((BgL_ccompz00_bglt)CREF(BgL_new2673z00_1876))->BgL_finaliza7erza7) = ((obj_t)BgL_arg2721z00_1272), BUNSPEC); 
BgL_res3474z00_1891 = BgL_new2673z00_1876; BgL_res3474z00_1891; } 
BgL_res3475z00_1892 = BgL_new2673z00_1876; } 
return 
(obj_t)(BgL_res3475z00_1892);} } } 
}



/* _make-eval-compiler */
obj_t BGl__makezd2evalzd2compilerz00zzmodule_evalz00(obj_t BgL_envz00_2515)
{ AN_OBJECT;
{ /* Module/eval.scm 37 */
return 
BGl_makezd2evalzd2compilerz00zzmodule_evalz00();} 
}



/* <anonymous:2723> */
obj_t BGl_zc3anonymousza32723ze3z83zzmodule_evalz00(obj_t BgL_envz00_2516, obj_t BgL_mz00_2517, obj_t BgL_cz00_2518)
{ AN_OBJECT;
{ /* ./Module/module.scm 48 */
{ 
obj_t BgL_mz00_1273;obj_t BgL_cz00_1274;
BgL_mz00_1273 = BgL_mz00_2517; 
BgL_cz00_1274 = BgL_cz00_2518; 
return BNIL;} } 
}



/* eval-producer */
obj_t BGl_evalzd2producerzd2zzmodule_evalz00(obj_t BgL_clausez00_19)
{ AN_OBJECT;
{ /* Module/eval.scm 45 */
{ 
obj_t BgL_protosz00_1277;
if(
PAIRP(BgL_clausez00_19))
{ /* Module/eval.scm 46 */
BgL_protosz00_1277 = 
CDR(BgL_clausez00_19); 
{ 
obj_t BgL_l2678z00_1283;
BgL_l2678z00_1283 = BgL_protosz00_1277; 
BgL_lname2679z00_1284:
if(
PAIRP(BgL_l2678z00_1283))
{ /* Module/eval.scm 48 */
BGl_evalzd2parserzd2zzmodule_evalz00(
CAR(BgL_l2678z00_1283), BgL_clausez00_19); 
{ 
obj_t BgL_l2678z00_2590;
BgL_l2678z00_2590 = 
CDR(BgL_l2678z00_1283); 
BgL_l2678z00_1283 = BgL_l2678z00_2590; 
goto BgL_lname2679z00_1284;} }  else 
{ /* Module/eval.scm 48 */((bool_t)1); } } 
return BNIL;}  else 
{ /* Module/eval.scm 46 */
{ /* Module/eval.scm 51 */
obj_t BgL_list2741z00_1288;
BgL_list2741z00_1288 = 
MAKE_PAIR(BNIL, BNIL); 
return 
BGl_userzd2errorzd2zztools_errorz00(BGl_string3566z00zzmodule_evalz00, BGl_string3567z00zzmodule_evalz00, BgL_clausez00_19, BgL_list2741z00_1288);} } } } 
}



/* _eval-producer */
obj_t BGl__evalzd2producerzd2zzmodule_evalz00(obj_t BgL_envz00_2519, obj_t BgL_clausez00_2520)
{ AN_OBJECT;
{ /* Module/eval.scm 45 */
return 
BGl_evalzd2producerzd2zzmodule_evalz00(BgL_clausez00_2520);} 
}



/* eval-parser */
obj_t BGl_evalzd2parserzd2zzmodule_evalz00(obj_t BgL_protoz00_20, obj_t BgL_clausez00_21)
{ AN_OBJECT;
{ /* Module/eval.scm 59 */
{ 

if(
PAIRP(BgL_protoz00_20))
{ /* Module/eval.scm 60 */
bool_t BgL_testz00_2598;
{ /* Module/eval.scm 60 */
obj_t BgL_auxz00_2601;obj_t BgL_auxz00_2599;
BgL_auxz00_2601 = 
CNST_TABLE_REF(((long)1)); 
BgL_auxz00_2599 = 
CAR(BgL_protoz00_20); 
BgL_testz00_2598 = 
(BgL_auxz00_2599==BgL_auxz00_2601); } 
if(BgL_testz00_2598)
{ /* Module/eval.scm 60 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_protoz00_20), BNIL))
{ /* Module/eval.scm 60 */
return ( 
BGl_za2allzd2evalzf3za2z21zzmodule_evalz00 = BTRUE, BUNSPEC) ;}  else 
{ /* Module/eval.scm 60 */
BgL_tagzd2115zd2_1299:
{ /* Module/eval.scm 76 */
obj_t BgL_list2879z00_1360;
BgL_list2879z00_1360 = 
MAKE_PAIR(BNIL, BNIL); 
return 
BGl_userzd2errorzd2zztools_errorz00(BGl_string3566z00zzmodule_evalz00, BGl_string3568z00zzmodule_evalz00, BgL_clausez00_21, BgL_list2879z00_1360);} } }  else 
{ /* Module/eval.scm 60 */
bool_t BgL_testz00_2609;
{ /* Module/eval.scm 60 */
obj_t BgL_auxz00_2612;obj_t BgL_auxz00_2610;
BgL_auxz00_2612 = 
CNST_TABLE_REF(((long)2)); 
BgL_auxz00_2610 = 
CAR(BgL_protoz00_20); 
BgL_testz00_2609 = 
(BgL_auxz00_2610==BgL_auxz00_2612); } 
if(BgL_testz00_2609)
{ /* Module/eval.scm 60 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_protoz00_20), BNIL))
{ /* Module/eval.scm 60 */
return ( 
BGl_za2allzd2exportzd2evalzf3za2zf3zzmodule_evalz00 = BTRUE, BUNSPEC) ;}  else 
{ /* Module/eval.scm 60 */
goto BgL_tagzd2115zd2_1299;} }  else 
{ /* Module/eval.scm 60 */
bool_t BgL_testz00_2618;
{ /* Module/eval.scm 60 */
obj_t BgL_auxz00_2621;obj_t BgL_auxz00_2619;
BgL_auxz00_2621 = 
CNST_TABLE_REF(((long)3)); 
BgL_auxz00_2619 = 
CAR(BgL_protoz00_20); 
BgL_testz00_2618 = 
(BgL_auxz00_2619==BgL_auxz00_2621); } 
if(BgL_testz00_2618)
{ /* Module/eval.scm 60 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_protoz00_20), BNIL))
{ /* Module/eval.scm 60 */
return ( 
BGl_za2allzd2modulezd2evalzf3za2zf3zzmodule_evalz00 = BTRUE, BUNSPEC) ;}  else 
{ /* Module/eval.scm 60 */
goto BgL_tagzd2115zd2_1299;} }  else 
{ /* Module/eval.scm 60 */
obj_t BgL_cdrzd2166zd2_1314;
BgL_cdrzd2166zd2_1314 = 
CDR(BgL_protoz00_20); 
{ /* Module/eval.scm 60 */
bool_t BgL_testz00_2628;
{ /* Module/eval.scm 60 */
obj_t BgL_auxz00_2631;obj_t BgL_auxz00_2629;
BgL_auxz00_2631 = 
CNST_TABLE_REF(((long)4)); 
BgL_auxz00_2629 = 
CAR(BgL_protoz00_20); 
BgL_testz00_2628 = 
(BgL_auxz00_2629==BgL_auxz00_2631); } 
if(BgL_testz00_2628)
{ /* Module/eval.scm 60 */
if(
PAIRP(BgL_cdrzd2166zd2_1314))
{ /* Module/eval.scm 60 */
obj_t BgL_carzd2168zd2_1317;
BgL_carzd2168zd2_1317 = 
CAR(BgL_cdrzd2166zd2_1314); 
if(
SYMBOLP(BgL_carzd2168zd2_1317))
{ /* Module/eval.scm 60 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2166zd2_1314), BNIL))
{ /* Module/eval.scm 60 */
BGl_za2onezd2evalzf3za2z21zzmodule_evalz00 = ((bool_t)1); 
return 
BGl_rememberzd2evalzd2exportedz12z12zzmodule_evalz00(BgL_carzd2168zd2_1317, BGl_za2moduleza2z00zzmodule_modulez00, BgL_protoz00_20);}  else 
{ /* Module/eval.scm 60 */
goto BgL_tagzd2115zd2_1299;} }  else 
{ /* Module/eval.scm 60 */
obj_t BgL_carzd2187zd2_1323;
BgL_carzd2187zd2_1323 = 
CAR(BgL_cdrzd2166zd2_1314); 
if(
PAIRP(BgL_carzd2187zd2_1323))
{ /* Module/eval.scm 60 */
obj_t BgL_cdrzd2192zd2_1325;
BgL_cdrzd2192zd2_1325 = 
CDR(BgL_carzd2187zd2_1323); 
{ /* Module/eval.scm 60 */
bool_t BgL_testz00_2647;
{ /* Module/eval.scm 60 */
obj_t BgL_auxz00_2650;obj_t BgL_auxz00_2648;
BgL_auxz00_2650 = 
CNST_TABLE_REF(((long)5)); 
BgL_auxz00_2648 = 
CAR(BgL_carzd2187zd2_1323); 
BgL_testz00_2647 = 
(BgL_auxz00_2648==BgL_auxz00_2650); } 
if(BgL_testz00_2647)
{ /* Module/eval.scm 60 */
if(
PAIRP(BgL_cdrzd2192zd2_1325))
{ /* Module/eval.scm 60 */
obj_t BgL_carzd2195zd2_1328;obj_t BgL_cdrzd2196zd2_1329;
BgL_carzd2195zd2_1328 = 
CAR(BgL_cdrzd2192zd2_1325); 
BgL_cdrzd2196zd2_1329 = 
CDR(BgL_cdrzd2192zd2_1325); 
if(
SYMBOLP(BgL_carzd2195zd2_1328))
{ /* Module/eval.scm 60 */
if(
PAIRP(BgL_cdrzd2196zd2_1329))
{ /* Module/eval.scm 60 */
obj_t BgL_carzd2201zd2_1332;
BgL_carzd2201zd2_1332 = 
CAR(BgL_cdrzd2196zd2_1329); 
if(
SYMBOLP(BgL_carzd2201zd2_1332))
{ /* Module/eval.scm 60 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2196zd2_1329), BNIL))
{ /* Module/eval.scm 60 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2166zd2_1314), BNIL))
{ /* Module/eval.scm 60 */
BGl_za2onezd2evalzf3za2z21zzmodule_evalz00 = ((bool_t)1); 
return 
BGl_rememberzd2evalzd2exportedz12z12zzmodule_evalz00(BgL_carzd2195zd2_1328, BgL_carzd2201zd2_1332, BgL_protoz00_20);}  else 
{ /* Module/eval.scm 60 */
goto BgL_tagzd2115zd2_1299;} }  else 
{ /* Module/eval.scm 60 */
goto BgL_tagzd2115zd2_1299;} }  else 
{ /* Module/eval.scm 60 */
goto BgL_tagzd2115zd2_1299;} }  else 
{ /* Module/eval.scm 60 */
goto BgL_tagzd2115zd2_1299;} }  else 
{ /* Module/eval.scm 60 */
goto BgL_tagzd2115zd2_1299;} }  else 
{ /* Module/eval.scm 60 */
goto BgL_tagzd2115zd2_1299;} }  else 
{ /* Module/eval.scm 60 */
goto BgL_tagzd2115zd2_1299;} } }  else 
{ /* Module/eval.scm 60 */
goto BgL_tagzd2115zd2_1299;} } }  else 
{ /* Module/eval.scm 60 */
goto BgL_tagzd2115zd2_1299;} }  else 
{ /* Module/eval.scm 60 */
bool_t BgL_testz00_2671;
{ /* Module/eval.scm 60 */
obj_t BgL_auxz00_2674;obj_t BgL_auxz00_2672;
BgL_auxz00_2674 = 
CNST_TABLE_REF(((long)6)); 
BgL_auxz00_2672 = 
CAR(BgL_protoz00_20); 
BgL_testz00_2671 = 
(BgL_auxz00_2672==BgL_auxz00_2674); } 
if(BgL_testz00_2671)
{ /* Module/eval.scm 60 */
if(
PAIRP(BgL_cdrzd2166zd2_1314))
{ /* Module/eval.scm 60 */
obj_t BgL_carzd2237zd2_1345;
BgL_carzd2237zd2_1345 = 
CAR(BgL_cdrzd2166zd2_1314); 
if(
SYMBOLP(BgL_carzd2237zd2_1345))
{ /* Module/eval.scm 60 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2166zd2_1314), BNIL))
{ /* Module/eval.scm 60 */
BgL_globalz00_bglt BgL_auxz00_2685;
BgL_auxz00_2685 = 
BGl_declarezd2globalzd2svarz12z12zzast_glozd2declzd2(BgL_carzd2237zd2_1345, 
CNST_TABLE_REF(((long)0)), 
CNST_TABLE_REF(((long)0)), BgL_clausez00_21, BFALSE); 
return 
(obj_t)(BgL_auxz00_2685);}  else 
{ /* Module/eval.scm 60 */
goto BgL_tagzd2115zd2_1299;} }  else 
{ /* Module/eval.scm 60 */
goto BgL_tagzd2115zd2_1299;} }  else 
{ /* Module/eval.scm 60 */
goto BgL_tagzd2115zd2_1299;} }  else 
{ /* Module/eval.scm 60 */
goto BgL_tagzd2115zd2_1299;} } } } } } }  else 
{ /* Module/eval.scm 60 */
goto BgL_tagzd2115zd2_1299;} } } 
}



/* remember-eval-exported! */
obj_t BGl_rememberzd2evalzd2exportedz12z12zzmodule_evalz00(obj_t BgL_varz00_22, obj_t BgL_modulez00_23, obj_t BgL_locz00_24)
{ AN_OBJECT;
{ /* Module/eval.scm 86 */
{ /* Module/eval.scm 87 */
obj_t BgL_arg2882z00_1361;
{ /* Module/eval.scm 87 */
obj_t BgL_list2885z00_1362;
{ /* Module/eval.scm 87 */
obj_t BgL_arg2887z00_1363;
{ /* Module/eval.scm 87 */
obj_t BgL_arg2890z00_1364;
BgL_arg2890z00_1364 = 
MAKE_PAIR(BgL_locz00_24, BNIL); 
BgL_arg2887z00_1363 = 
MAKE_PAIR(BgL_modulez00_23, BgL_arg2890z00_1364); } 
BgL_list2885z00_1362 = 
MAKE_PAIR(BgL_varz00_22, BgL_arg2887z00_1363); } 
BgL_arg2882z00_1361 = BgL_list2885z00_1362; } 
return ( 
BGl_za2evalzd2exportedza2zd2zzmodule_evalz00 = 
MAKE_PAIR(BgL_arg2882z00_1361, BGl_za2evalzd2exportedza2zd2zzmodule_evalz00), BUNSPEC) ;} } 
}



/* eval-finalizer */
obj_t BGl_evalzd2finaliza7erz75zzmodule_evalz00()
{ AN_OBJECT;
{ /* Module/eval.scm 105 */
{ /* Module/eval.scm 106 */
bool_t BgL_test2893z00_1365;
if(BGl_za2onezd2evalzf3za2z21zzmodule_evalz00)
{ /* Module/eval.scm 106 */
BgL_test2893z00_1365 = ((bool_t)1); }  else 
{ /* Module/eval.scm 106 */
if(
CBOOL(BGl_za2allzd2evalzf3za2z21zzmodule_evalz00))
{ /* Module/eval.scm 106 */
BgL_test2893z00_1365 = ((bool_t)1); }  else 
{ /* Module/eval.scm 106 */
if(
CBOOL(BGl_za2allzd2exportzd2evalzf3za2zf3zzmodule_evalz00))
{ /* Module/eval.scm 106 */
BgL_test2893z00_1365 = ((bool_t)1); }  else 
{ /* Module/eval.scm 106 */
BgL_test2893z00_1365 = 
CBOOL(BGl_za2allzd2modulezd2evalzf3za2zf3zzmodule_evalz00); } } } 
if(BgL_test2893z00_1365)
{ /* Module/eval.scm 109 */
obj_t BgL_arg2895z00_1366;
{ /* Module/eval.scm 109 */
obj_t BgL_arg2900z00_1368;long BgL_arg2901z00_1369;obj_t BgL_arg2902z00_1370;
BgL_arg2900z00_1368 = 
CNST_TABLE_REF(((long)0)); 
{ /* Module/eval.scm 110 */
obj_t BgL_arg2905z00_1371;
BgL_arg2905z00_1371 = 
BGl_getzd2toplevelzd2unitzd2weightzd2zzmodule_includez00(); 
{ /* Module/eval.scm 110 */
long BgL_auxz00_2703;
BgL_auxz00_2703 = 
(long)CINT(BgL_arg2905z00_1371); 
BgL_arg2901z00_1369 = 
(BgL_auxz00_2703-((long)2)); } } 
BgL_arg2902z00_1370 = 
BGl_makezd2promisezd2zz__r4_control_features_6_9z00(BGl_proc3569z00zzmodule_evalz00); 
{ /* Module/eval.scm 108 */
obj_t BgL_newz00_1952;
{ /* Module/eval.scm 108 */
int BgL_auxz00_2709;obj_t BgL_auxz00_2707;
BgL_auxz00_2709 = 
(int)(((long)4)); 
BgL_auxz00_2707 = 
CNST_TABLE_REF(((long)7)); 
BgL_newz00_1952 = 
create_struct(BgL_auxz00_2707, BgL_auxz00_2709); } 
{ /* Module/eval.scm 108 */
int BgL_auxz00_2712;
BgL_auxz00_2712 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_1952, BgL_auxz00_2712, BFALSE); } 
{ /* Module/eval.scm 108 */
int BgL_auxz00_2715;
BgL_auxz00_2715 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_1952, BgL_auxz00_2715, BgL_arg2902z00_1370); } 
{ /* Module/eval.scm 108 */
obj_t BgL_auxz00_2720;int BgL_auxz00_2718;
BgL_auxz00_2720 = 
BINT(BgL_arg2901z00_1369); 
BgL_auxz00_2718 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_1952, BgL_auxz00_2718, BgL_auxz00_2720); } 
{ /* Module/eval.scm 108 */
int BgL_auxz00_2723;
BgL_auxz00_2723 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_1952, BgL_auxz00_2723, BgL_arg2900z00_1368); } 
BgL_arg2895z00_1366 = BgL_newz00_1952; } } 
{ /* Module/eval.scm 107 */
obj_t BgL_list2897z00_1367;
BgL_list2897z00_1367 = 
MAKE_PAIR(BgL_arg2895z00_1366, BNIL); 
return BgL_list2897z00_1367;} }  else 
{ /* Module/eval.scm 106 */
return 
CNST_TABLE_REF(((long)8));} } } 
}



/* _eval-finalizer */
obj_t BGl__evalzd2finaliza7erz75zzmodule_evalz00(obj_t BgL_envz00_2521)
{ AN_OBJECT;
{ /* Module/eval.scm 105 */
return 
BGl_evalzd2finaliza7erz75zzmodule_evalz00();} 
}



/* <anonymous:2912> */
obj_t BGl_zc3anonymousza32912ze3z83zzmodule_evalz00(obj_t BgL_envz00_2523)
{ AN_OBJECT;
{ /* Module/eval.scm 111 */
{ 

{ 
obj_t BgL_globalsz00_1375;obj_t BgL_initza2za2_1376;
{ /* Module/eval.scm 112 */
obj_t BgL_arg2914z00_1378;obj_t BgL_arg2915z00_1379;
BgL_arg2914z00_1378 = 
BGl_getzd2evaluatedzd2globalsz00zzmodule_evalz00(); 
BgL_arg2915z00_1379 = 
CNST_TABLE_REF(((long)11)); 
BgL_globalsz00_1375 = BgL_arg2914z00_1378; 
BgL_initza2za2_1376 = BgL_arg2915z00_1379; 
BgL_loopz00_1377:
if(
NULLP(BgL_globalsz00_1375))
{ /* Module/eval.scm 115 */
obj_t BgL_arg2920z00_1381;obj_t BgL_arg2921z00_1382;
BgL_arg2920z00_1381 = 
CNST_TABLE_REF(((long)9)); 
{ /* Module/eval.scm 115 */
obj_t BgL_arg2924z00_1383;
BgL_arg2924z00_1383 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_initza2za2_1376); 
BgL_arg2921z00_1382 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2924z00_1383, BNIL); } 
return 
MAKE_PAIR(BgL_arg2920z00_1381, BgL_arg2921z00_1382);}  else 
{ /* Module/eval.scm 116 */
obj_t BgL_gz00_1385;
BgL_gz00_1385 = 
CAR(BgL_globalsz00_1375); 
BGl_setzd2evalzd2typesz12z12zzmodule_evalz00(BgL_gz00_1385); 
{ /* Module/eval.scm 118 */
obj_t BgL_arg2930z00_1386;obj_t BgL_arg2931z00_1387;
BgL_arg2930z00_1386 = 
CDR(BgL_globalsz00_1375); 
{ /* Module/eval.scm 120 */
BgL_nodez00_bglt BgL_arg2935z00_1388;
{ /* Module/eval.scm 120 */
bool_t BgL_test2937z00_1389;
{ /* Module/eval.scm 120 */
obj_t BgL_auxz00_2740;
{ /* Module/eval.scm 120 */
BgL_valuez00_bglt BgL_auxz00_2741;
{ /* Module/eval.scm 120 */
BgL_globalz00_bglt BgL_obj1156z00_1942;
BgL_obj1156z00_1942 = 
(BgL_globalz00_bglt)(BgL_gz00_1385); 
BgL_auxz00_2741 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1156z00_1942))->BgL_valuez00); } 
BgL_auxz00_2740 = 
(obj_t)(BgL_auxz00_2741); } 
BgL_test2937z00_1389 = 
BGl_iszd2azf3z21zz__objectz00(BgL_auxz00_2740, BGl_svarz00zzast_varz00); } 
if(BgL_test2937z00_1389)
{ /* Module/eval.scm 120 */
{ /* Module/eval.scm 121 */
BgL_variablez00_bglt BgL_obj1109z00_1944;obj_t BgL_val1108z00_1945;
BgL_obj1109z00_1944 = 
(BgL_variablez00_bglt)(BgL_gz00_1385); 
BgL_val1108z00_1945 = 
CNST_TABLE_REF(((long)10)); 
((((BgL_variablez00_bglt)CREF(BgL_obj1109z00_1944))->BgL_accessz00) = ((obj_t)BgL_val1108z00_1945), BUNSPEC); } 
{ /* Module/eval.scm 123 */
BgL_nodez00_bglt BgL_arg2940z00_1390;
BgL_arg2940z00_1390 = 
BGl_locationzd2ze3nodez31zzast_sexpz00(
(BgL_globalz00_bglt)(BgL_gz00_1385)); 
BgL_arg2935z00_1388 = 
BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(
(BgL_globalz00_bglt)(BgL_gz00_1385), BgL_arg2940z00_1390); } }  else 
{ /* Module/eval.scm 124 */
bool_t BgL_test2943z00_1391;
{ /* Module/eval.scm 124 */
obj_t BgL_auxz00_2754;
{ /* Module/eval.scm 124 */
BgL_valuez00_bglt BgL_auxz00_2755;
{ /* Module/eval.scm 124 */
BgL_globalz00_bglt BgL_obj1156z00_1946;
BgL_obj1156z00_1946 = 
(BgL_globalz00_bglt)(BgL_gz00_1385); 
BgL_auxz00_2755 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1156z00_1946))->BgL_valuez00); } 
BgL_auxz00_2754 = 
(obj_t)(BgL_auxz00_2755); } 
BgL_test2943z00_1391 = 
BGl_iszd2azf3z21zz__objectz00(BgL_auxz00_2754, BGl_scnstz00zzast_varz00); } 
if(BgL_test2943z00_1391)
{ /* Module/eval.scm 124 */
{ /* Module/eval.scm 126 */
BgL_nodez00_bglt BgL_arg2945z00_1392;
BgL_arg2945z00_1392 = 
BGl_locationzd2ze3nodez31zzast_sexpz00(
(BgL_globalz00_bglt)(BgL_gz00_1385)); 
BgL_arg2935z00_1388 = 
BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(
(BgL_globalz00_bglt)(BgL_gz00_1385), BgL_arg2945z00_1392); } }  else 
{ /* Module/eval.scm 124 */
BgL_arg2935z00_1388 = 
BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(
(BgL_globalz00_bglt)(BgL_gz00_1385)); } } } 
{ /* Module/eval.scm 119 */
obj_t BgL_auxz00_2767;
BgL_auxz00_2767 = 
(obj_t)(BgL_arg2935z00_1388); 
BgL_arg2931z00_1387 = 
MAKE_PAIR(BgL_auxz00_2767, BgL_initza2za2_1376); } } 
{ 
obj_t BgL_initza2za2_2771;obj_t BgL_globalsz00_2770;
BgL_globalsz00_2770 = BgL_arg2930z00_1386; 
BgL_initza2za2_2771 = BgL_arg2931z00_1387; 
BgL_initza2za2_1376 = BgL_initza2za2_2771; 
BgL_globalsz00_1375 = BgL_globalsz00_2770; 
goto BgL_loopz00_1377;} } } } } } } 
}



/* set-eval-types! */
obj_t BGl_setzd2evalzd2typesz12z12zzmodule_evalz00(obj_t BgL_globalz00_25)
{ AN_OBJECT;
{ /* Module/eval.scm 139 */
{ /* Module/eval.scm 141 */
bool_t BgL_test2959z00_1397;
{ /* Module/eval.scm 141 */
obj_t BgL_auxz00_2772;
{ /* Module/eval.scm 141 */
BgL_valuez00_bglt BgL_auxz00_2773;
{ /* Module/eval.scm 140 */
BgL_globalz00_bglt BgL_obj1156z00_1975;
BgL_obj1156z00_1975 = 
(BgL_globalz00_bglt)(BgL_globalz00_25); 
BgL_auxz00_2773 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1156z00_1975))->BgL_valuez00); } 
BgL_auxz00_2772 = 
(obj_t)(BgL_auxz00_2773); } 
BgL_test2959z00_1397 = 
BGl_iszd2azf3z21zz__objectz00(BgL_auxz00_2772, BGl_sfunz00zzast_varz00); } 
if(BgL_test2959z00_1397)
{ /* Module/eval.scm 141 */
return BFALSE;}  else 
{ /* Module/eval.scm 142 */
BgL_typez00_bglt BgL_typez00_1398;
{ /* Module/eval.scm 142 */
BgL_globalz00_bglt BgL_obj1153z00_1977;
BgL_obj1153z00_1977 = 
(BgL_globalz00_bglt)(BgL_globalz00_25); 
BgL_typez00_1398 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1153z00_1977))->BgL_typez00); } 
{ /* Module/eval.scm 144 */
bool_t BgL_test2960z00_1399;
{ /* Module/eval.scm 144 */
obj_t BgL_auxz00_2781;
BgL_auxz00_2781 = 
(obj_t)(BgL_typez00_1398); 
BgL_test2960z00_1399 = 
(BgL_auxz00_2781==BGl_za2_za2z00zztype_cachez00); } 
if(BgL_test2960z00_1399)
{ /* Module/eval.scm 144 */
{ /* Module/eval.scm 145 */
BgL_globalz00_bglt BgL_obj1155z00_1978;BgL_typez00_bglt BgL_val1154z00_1979;
BgL_obj1155z00_1978 = 
(BgL_globalz00_bglt)(BgL_globalz00_25); 
BgL_val1154z00_1979 = 
(BgL_typez00_bglt)(BGl_za2objza2z00zztype_cachez00); 
return 
((((BgL_globalz00_bglt)CREF(BgL_obj1155z00_1978))->BgL_typez00) = ((BgL_typez00_bglt)BgL_val1154z00_1979), BUNSPEC);} }  else 
{ /* Module/eval.scm 146 */
bool_t BgL_test2962z00_1400;
BgL_test2962z00_1400 = 
BGl_bigloozd2typezf3z21zztype_typez00(BgL_typez00_1398); 
if(BgL_test2962z00_1400)
{ /* Module/eval.scm 146 */
return BFALSE;}  else 
{ /* Module/eval.scm 146 */
{ 
obj_t BgL_auxz00_2790;
{ /* Module/eval.scm 149 */
BgL_globalz00_bglt BgL_obj1149z00_1980;
BgL_obj1149z00_1980 = 
(BgL_globalz00_bglt)(BgL_globalz00_25); 
BgL_auxz00_2790 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1149z00_1980))->BgL_idz00); } 
FAILURE(BGl_string3570z00zzmodule_evalz00,BGl_string3571z00zzmodule_evalz00,BgL_auxz00_2790);} } } } } } } 
}



/* get-evaluated-globals */
obj_t BGl_getzd2evaluatedzd2globalsz00zzmodule_evalz00()
{ AN_OBJECT;
{ /* Module/eval.scm 154 */
{ /* Module/eval.scm 155 */
bool_t BgL_test2974z00_1404;
if(
CBOOL(BGl_za2allzd2evalzf3za2z21zzmodule_evalz00))
{ /* Module/eval.scm 155 */
BgL_test2974z00_1404 = ((bool_t)1); }  else 
{ /* Module/eval.scm 155 */
if(
CBOOL(BGl_za2allzd2exportzd2evalzf3za2zf3zzmodule_evalz00))
{ /* Module/eval.scm 155 */
BgL_test2974z00_1404 = ((bool_t)1); }  else 
{ /* Module/eval.scm 155 */
BgL_test2974z00_1404 = 
CBOOL(BGl_za2allzd2modulezd2evalzf3za2zf3zzmodule_evalz00); } } 
if(BgL_test2974z00_1404)
{ /* Module/eval.scm 156 */
obj_t BgL_globalsz00_1405;obj_t BgL_scopezd2lstzd2_1406;
BgL_globalsz00_1405 = 
MAKE_CELL(BNIL); 
if(
CBOOL(BGl_za2allzd2evalzf3za2z21zzmodule_evalz00))
{ /* Module/eval.scm 158 */
BgL_scopezd2lstzd2_1406 = 
CNST_TABLE_REF(((long)12)); }  else 
{ /* Module/eval.scm 158 */
if(
CBOOL(BGl_za2allzd2modulezd2evalzf3za2zf3zzmodule_evalz00))
{ /* Module/eval.scm 159 */
BgL_scopezd2lstzd2_1406 = 
CNST_TABLE_REF(((long)13)); }  else 
{ /* Module/eval.scm 159 */
BgL_scopezd2lstzd2_1406 = 
CNST_TABLE_REF(((long)14)); } } 
{ /* Module/eval.scm 163 */
obj_t BgL_zc3anonymousza32978ze3z83_2524;
{ 
int BgL_auxz00_2809;int BgL_auxz00_2807;
BgL_auxz00_2809 = 
(int)(((long)2)); 
BgL_auxz00_2807 = 
(int)(((long)1)); 
BgL_zc3anonymousza32978ze3z83_2524 = 
make_fx_procedure(BGl_zc3anonymousza32978ze3z83zzmodule_evalz00, BgL_auxz00_2807, BgL_auxz00_2809); } 
{ /* Module/eval.scm 163 */
int BgL_auxz00_2812;
BgL_auxz00_2812 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32978ze3z83_2524, BgL_auxz00_2812, BgL_scopezd2lstzd2_1406); } 
{ /* Module/eval.scm 163 */
int BgL_auxz00_2815;
BgL_auxz00_2815 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_zc3anonymousza32978ze3z83_2524, BgL_auxz00_2815, BgL_globalsz00_1405); } 
BGl_forzd2eachzd2globalz12z12zzast_envz00(BgL_zc3anonymousza32978ze3z83_2524); } 
return 
CELL_REF(BgL_globalsz00_1405);}  else 
{ 
obj_t BgL_evalzd2exportedzd2_1417;obj_t BgL_resz00_1418;
BgL_evalzd2exportedzd2_1417 = BGl_za2evalzd2exportedza2zd2zzmodule_evalz00; 
BgL_resz00_1418 = BNIL; 
BgL_loopz00_1419:
if(
NULLP(BgL_evalzd2exportedzd2_1417))
{ /* Module/eval.scm 170 */
return BgL_resz00_1418;}  else 
{ /* Module/eval.scm 172 */
obj_t BgL_varze2moduleze2posz00_1421;
BgL_varze2moduleze2posz00_1421 = 
CAR(BgL_evalzd2exportedzd2_1417); 
{ /* Module/eval.scm 173 */
obj_t BgL_gz00_1422;
{ /* Module/eval.scm 173 */
obj_t BgL_auxz00_2822;
{ /* Module/eval.scm 174 */
obj_t BgL_auxz00_2824;
BgL_auxz00_2824 = 
CDR(BgL_varze2moduleze2posz00_1421); 
BgL_auxz00_2822 = 
CAR(BgL_auxz00_2824); } 
BgL_gz00_1422 = 
BGl_findzd2globalzf2modulez20zzast_envz00(
CAR(BgL_varze2moduleze2posz00_1421), BgL_auxz00_2822); } 
{ /* Module/eval.scm 176 */
bool_t BgL_test2992z00_1423;
BgL_test2992z00_1423 = 
BGl_iszd2azf3z21zz__objectz00(BgL_gz00_1422, BGl_globalz00zzast_varz00); 
if(BgL_test2992z00_1423)
{ /* Module/eval.scm 184 */
bool_t BgL_test2993z00_1424;
if(
CBOOL(BGl_za2libzd2modeza2zd2zzengine_paramz00))
{ /* Module/eval.scm 184 */
BgL_test2993z00_1424 = ((bool_t)0); }  else 
{ /* Module/eval.scm 184 */
BgL_globalz00_bglt BgL_obj1180z00_1995;
BgL_obj1180z00_1995 = 
(BgL_globalz00_bglt)(BgL_gz00_1422); 
BgL_test2993z00_1424 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1180z00_1995))->BgL_libraryzf3zf3); } 
if(BgL_test2993z00_1424)
{ /* Module/eval.scm 184 */
{ 
obj_t BgL_evalzd2exportedzd2_2835;
BgL_evalzd2exportedzd2_2835 = 
CDR(BgL_evalzd2exportedzd2_1417); 
BgL_evalzd2exportedzd2_1417 = BgL_evalzd2exportedzd2_2835; 
goto BgL_loopz00_1419;} }  else 
{ /* Module/eval.scm 186 */
bool_t BgL_testz00_2837;
{ /* Module/eval.scm 186 */
BgL_globalz00_bglt BgL_obj1177z00_1997;
BgL_obj1177z00_1997 = 
(BgL_globalz00_bglt)(BgL_gz00_1422); 
BgL_testz00_2837 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1177z00_1997))->BgL_evaluablezf3zf3); } 
if(BgL_testz00_2837)
{ /* Module/eval.scm 186 */
{ /* Module/eval.scm 195 */
obj_t BgL_arg3000z00_1427;obj_t BgL_arg3001z00_1428;
BgL_arg3000z00_1427 = 
CDR(BgL_evalzd2exportedzd2_1417); 
BgL_arg3001z00_1428 = 
MAKE_PAIR(BgL_gz00_1422, BgL_resz00_1418); 
{ 
obj_t BgL_resz00_2843;obj_t BgL_evalzd2exportedzd2_2842;
BgL_evalzd2exportedzd2_2842 = BgL_arg3000z00_1427; 
BgL_resz00_2843 = BgL_arg3001z00_1428; 
BgL_resz00_1418 = BgL_resz00_2843; 
BgL_evalzd2exportedzd2_1417 = BgL_evalzd2exportedzd2_2842; 
goto BgL_loopz00_1419;} } }  else 
{ /* Module/eval.scm 186 */
{ /* Module/eval.scm 188 */
obj_t BgL_arg3006z00_1429;obj_t BgL_arg3009z00_1432;
{ /* Module/eval.scm 187 */
obj_t BgL_auxz00_2844;
{ /* Module/eval.scm 188 */
obj_t BgL_auxz00_2845;
{ /* Module/eval.scm 188 */
obj_t BgL_auxz00_2846;
BgL_auxz00_2846 = 
CDR(BgL_varze2moduleze2posz00_1421); 
BgL_auxz00_2845 = 
CDR(BgL_auxz00_2846); } 
BgL_auxz00_2844 = 
CAR(BgL_auxz00_2845); } 
BgL_arg3006z00_1429 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_auxz00_2844); } 
BgL_arg3009z00_1432 = 
CAR(BgL_varze2moduleze2posz00_1421); 
{ /* Module/eval.scm 187 */
obj_t BgL_list3012z00_1434;
BgL_list3012z00_1434 = 
MAKE_PAIR(BNIL, BNIL); 
BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_arg3006z00_1429, BGl_string3572z00zzmodule_evalz00, BGl_string3573z00zzmodule_evalz00, BgL_arg3009z00_1432, BgL_list3012z00_1434); } } 
{ 
obj_t BgL_evalzd2exportedzd2_2854;
BgL_evalzd2exportedzd2_2854 = 
CDR(BgL_evalzd2exportedzd2_1417); 
BgL_evalzd2exportedzd2_1417 = BgL_evalzd2exportedzd2_2854; 
goto BgL_loopz00_1419;} } } }  else 
{ /* Module/eval.scm 176 */
{ /* Module/eval.scm 178 */
obj_t BgL_arg3026z00_1437;obj_t BgL_arg3029z00_1440;
{ /* Module/eval.scm 177 */
obj_t BgL_auxz00_2856;
{ /* Module/eval.scm 178 */
obj_t BgL_auxz00_2857;
{ /* Module/eval.scm 178 */
obj_t BgL_auxz00_2858;
BgL_auxz00_2858 = 
CDR(BgL_varze2moduleze2posz00_1421); 
BgL_auxz00_2857 = 
CDR(BgL_auxz00_2858); } 
BgL_auxz00_2856 = 
CAR(BgL_auxz00_2857); } 
BgL_arg3026z00_1437 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_auxz00_2856); } 
BgL_arg3029z00_1440 = 
CAR(BgL_varze2moduleze2posz00_1421); 
{ /* Module/eval.scm 177 */
obj_t BgL_list3032z00_1442;
BgL_list3032z00_1442 = 
MAKE_PAIR(BNIL, BNIL); 
BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_arg3026z00_1437, BGl_string3572z00zzmodule_evalz00, BGl_string3574z00zzmodule_evalz00, BgL_arg3029z00_1440, BgL_list3032z00_1442); } } 
{ 
obj_t BgL_evalzd2exportedzd2_2866;
BgL_evalzd2exportedzd2_2866 = 
CDR(BgL_evalzd2exportedzd2_1417); 
BgL_evalzd2exportedzd2_1417 = BgL_evalzd2exportedzd2_2866; 
goto BgL_loopz00_1419;} } } } } } } } 
}



/* <anonymous:2978> */
obj_t BGl_zc3anonymousza32978ze3z83zzmodule_evalz00(obj_t BgL_envz00_2525, obj_t BgL_gz00_2528)
{ AN_OBJECT;
{ /* Module/eval.scm 162 */
{ /* Module/eval.scm 163 */
obj_t BgL_scopezd2lstzd2_2526;obj_t BgL_globalsz00_2527;
{ /* Module/eval.scm 163 */
int BgL_auxz00_2868;
BgL_auxz00_2868 = 
(int)(((long)0)); 
BgL_scopezd2lstzd2_2526 = 
PROCEDURE_REF(BgL_envz00_2525, BgL_auxz00_2868); } 
{ /* Module/eval.scm 163 */
int BgL_auxz00_2871;
BgL_auxz00_2871 = 
(int)(((long)1)); 
BgL_globalsz00_2527 = 
PROCEDURE_REF(BgL_envz00_2525, BgL_auxz00_2871); } 
{ 
obj_t BgL_gz00_1408;
BgL_gz00_1408 = BgL_gz00_2528; 
{ /* Module/eval.scm 163 */
bool_t BgL_test2979z00_1410;
{ /* Module/eval.scm 163 */
bool_t BgL_testz00_2874;
{ /* Module/eval.scm 163 */
obj_t BgL_auxz00_2875;
{ /* Module/eval.scm 163 */
obj_t BgL_auxz00_2876;
{ /* Module/eval.scm 163 */
BgL_globalz00_bglt BgL_obj1174z00_1984;
BgL_obj1174z00_1984 = 
(BgL_globalz00_bglt)(BgL_gz00_1408); 
BgL_auxz00_2876 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1174z00_1984))->BgL_importz00); } 
BgL_auxz00_2875 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_auxz00_2876, BgL_scopezd2lstzd2_2526); } 
BgL_testz00_2874 = 
CBOOL(BgL_auxz00_2875); } 
if(BgL_testz00_2874)
{ /* Module/eval.scm 164 */
bool_t BgL_testz00_2881;
{ /* Module/eval.scm 164 */
BgL_globalz00_bglt BgL_obj1177z00_1985;
BgL_obj1177z00_1985 = 
(BgL_globalz00_bglt)(BgL_gz00_1408); 
BgL_testz00_2881 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1177z00_1985))->BgL_evaluablezf3zf3); } 
if(BgL_testz00_2881)
{ /* Module/eval.scm 165 */
obj_t BgL__ortest_2680z00_1413;
BgL__ortest_2680z00_1413 = BGl_za2libzd2modeza2zd2zzengine_paramz00; 
if(
CBOOL(BgL__ortest_2680z00_1413))
{ /* Module/eval.scm 165 */
BgL_test2979z00_1410 = 
CBOOL(BgL__ortest_2680z00_1413); }  else 
{ /* Module/eval.scm 165 */
bool_t BgL_testz00_2887;
{ /* Module/eval.scm 165 */
BgL_globalz00_bglt BgL_obj1180z00_1986;
BgL_obj1180z00_1986 = 
(BgL_globalz00_bglt)(BgL_gz00_1408); 
BgL_testz00_2887 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1180z00_1986))->BgL_libraryzf3zf3); } 
if(BgL_testz00_2887)
{ /* Module/eval.scm 165 */
BgL_test2979z00_1410 = ((bool_t)0); }  else 
{ /* Module/eval.scm 165 */
BgL_test2979z00_1410 = ((bool_t)1); } } }  else 
{ /* Module/eval.scm 164 */
BgL_test2979z00_1410 = ((bool_t)0); } }  else 
{ /* Module/eval.scm 163 */
BgL_test2979z00_1410 = ((bool_t)0); } } 
if(BgL_test2979z00_1410)
{ /* Module/eval.scm 166 */
obj_t BgL_auxz00_2529;
{ /* Module/eval.scm 166 */
obj_t BgL_auxz00_2891;
BgL_auxz00_2891 = 
CELL_REF(BgL_globalsz00_2527); 
BgL_auxz00_2529 = 
MAKE_PAIR(BgL_gz00_1408, BgL_auxz00_2891); } 
return 
CELL_SET(BgL_globalsz00_2527, BgL_auxz00_2529);}  else 
{ /* Module/eval.scm 163 */
return BFALSE;} } } } } 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzmodule_evalz00()
{ AN_OBJECT;
{ /* Module/eval.scm 15 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzmodule_evalz00()
{ AN_OBJECT;
{ /* Module/eval.scm 15 */
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19010), "module_eval"); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)28259), "module_eval"); 
BGl_modulezd2initializa7ationz75zzast_nodez00(((long)49436), "module_eval"); 
BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long)12859), "module_eval"); 
BGl_modulezd2initializa7ationz75zzmodule_includez00(((long)99), "module_eval"); 
BGl_modulezd2initializa7ationz75zzengine_paramz00(((long)189840), "module_eval"); 
BGl_modulezd2initializa7ationz75zztools_shapez00(((long)30825), "module_eval"); 
BGl_modulezd2initializa7ationz75zztools_errorz00(((long)17886), "module_eval"); 
BGl_modulezd2initializa7ationz75zztools_locationz00(((long)30714), "module_eval"); 
BGl_modulezd2initializa7ationz75zztype_cachez00(((long)57983), "module_eval"); 
BGl_modulezd2initializa7ationz75zzast_envz00(((long)73271), "module_eval"); 
BGl_modulezd2initializa7ationz75zzast_glozd2declzd2(((long)22459), "module_eval"); 
return 
BGl_modulezd2initializa7ationz75zzast_sexpz00(((long)26966), "module_eval");} 
}

