/*===========================================================================*/
/*   (Object/struct.scm)                                                     */
/*   Bigloo (2.5b)                                                           */
/*   Manuel Serrano (c)       Fri Sep 6 09:43:28 CEST 2002                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_tclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   struct BgL_globalz00_bgl * BgL_holderz00;
   obj_t BgL_wideningz00;
   long BgL_depthz00;
   bool_t BgL_finalzf3zf3;
   obj_t BgL_constructorz00;
   obj_t BgL_virtualzd2slotszd2numberz00;
   bool_t BgL_abstractzf3zf3;
} *BgL_tclassz00_bglt;

typedef struct BgL_jclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   obj_t BgL_packagez00;
} *BgL_jclassz00_bglt;

typedef struct BgL_slotz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_srcz00;
   obj_t BgL_classzd2ownerzd2;
   obj_t BgL_typez00;
   bool_t BgL_readzd2onlyzf3z21;
   obj_t BgL_defaultzd2valuezd2;
   obj_t BgL_virtualzd2numzd2;
   obj_t BgL_getterz00;
   obj_t BgL_setterz00;
   obj_t BgL_indexedz00;
   obj_t BgL_userzd2infozd2;
} *BgL_slotz00_bglt;


extern obj_t BGl_genzd2plainzd2classzc3zd2ze3structzf2zzobject_structz00(BgL_typez00_bglt, obj_t);
extern obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zzobject_structz00();
static obj_t BGl_savezd2slotzd2zzobject_structz00(obj_t, obj_t, obj_t, long, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t BGl_makezd2pragmazd2directzd2setz12zc0zzobject_toolsz00(BgL_typez00_bglt, BgL_slotz00_bglt, obj_t, obj_t);
extern obj_t BGl_readz00zz__readerz00(obj_t);
extern obj_t BGl_makezd2pragmazd2indexedzd2setz12zc0zzobject_toolsz00(BgL_typez00_bglt, BgL_slotz00_bglt, obj_t, obj_t, obj_t);
static obj_t BGl_genzd2structzd2ze3widezd2classz31zzobject_structz00(obj_t, BgL_typez00_bglt, obj_t, obj_t);
static obj_t BGl_restorezd2slotzd2zzobject_structz00(obj_t, obj_t, obj_t, BgL_typez00_bglt, long, obj_t);
extern obj_t BGl_za2targetzd2languageza2zd2zzengine_paramz00;
extern obj_t BGl_gensymz00zz__r4_symbols_6_4z00;
extern obj_t BGl_makezd2pragmazd2indexedzd2initzd2setz12z12zzobject_toolsz00(BgL_typez00_bglt, BgL_slotz00_bglt, obj_t, obj_t);
extern obj_t BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(obj_t);
static obj_t BGl_cnstzd2initzd2zzobject_structz00();
static obj_t BGl_genzd2widezd2classzd2ze3structz31zzobject_structz00(obj_t, BgL_typez00_bglt, obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zzobject_structz00();
extern obj_t BGl_genzd2widezd2classzc3zd2ze3structzf2zzobject_structz00(BgL_typez00_bglt, obj_t);
static obj_t BGl_genzd2structzd2ze3plainzd2classz31zzobject_structz00(obj_t, BgL_typez00_bglt, obj_t, obj_t);
extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
extern obj_t string_append_3(obj_t, obj_t, obj_t);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_structz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_toolsz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_toolsz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_slotsz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_privatez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
static obj_t BGl__genzd2plainzd2classzc3zd2ze3struct3244zf2zzobject_structz00(obj_t, obj_t, obj_t);
extern bool_t BGl_slotzd2virtualzf3z21zzobject_slotsz00(BgL_slotz00_bglt);
extern obj_t BGl_za2heapzd2debugza2zd2zzengine_paramz00;
static obj_t BGl_genzd2plainzd2classzd2ze3structz31zzobject_structz00(obj_t, BgL_typez00_bglt, obj_t, obj_t);
extern obj_t BGl_epairifyz00zztools_miscz00(obj_t, obj_t);
extern obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
static long BGl_slotszd2lengthzd2zzobject_structz00(obj_t);
extern obj_t BGl_makezd2privatezd2sexpz00zzast_privatez00(obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zzobject_structz00 = BUNSPEC;
static obj_t BGl_libraryzd2moduleszd2initz00zzobject_structz00();
static obj_t BGl__genzd2widezd2classzc3zd2ze3struct3246zf2zzobject_structz00(obj_t, obj_t, obj_t);
static obj_t __cnst[ 49 ] ;

DEFINE_EXPORT_PROCEDURE( BGl_genzd2plainzd2classzc3zd2ze3structzd2envz20zzobject_structz00, BgL_bgl__genza7d2plainza7d2classza7c3za7d2za7e3struct3244za7f2za7za7object_structza7003337za7, BGl__genzd2plainzd2classzc3zd2ze3struct3244zf2zzobject_structz00, 0L, 2 );
DEFINE_STRING( BGl_string3311z00zzobject_structz00, BgL_bgl_string3311za700za7za7object_structza7003338z00, "object-mark-producer! @ class-num object-class-num-set! pragma cast jvm new old object-widening-set! s::struct struct+object->object::object vector-ref-ur done o vector-length s struct-ref f ::long v i struct-key struct-key-set! call-next-method aux ::struct quote make-struct object->struct::struct define-method res obj +fx -ref vector-set-ur! begin struct-set! =fx if labels make-vector -len - let len loop j vec ", 416 );
DEFINE_STRING( BGl_string3310z00zzobject_structz00, BgL_bgl_string3310za700za7za7object_structza7003339z00, ")($1))", 6 );
DEFINE_STRING( BGl_string3309z00zzobject_structz00, BgL_bgl_string3309za700za7za7object_structza7003340z00, "((", 2 );
DEFINE_STRING( BGl_string3308z00zzobject_structz00, BgL_bgl_string3308za700za7za7object_structza7003341z00, "dynamically indexed slots are not supported yet in -gbdb2 mode", 62 );
DEFINE_STRING( BGl_string3307z00zzobject_structz00, BgL_bgl_string3307za700za7za7object_structza7003342z00, "restore-slot", 12 );
DEFINE_EXPORT_PROCEDURE( BGl_genzd2widezd2classzc3zd2ze3structzd2envz20zzobject_structz00, BgL_bgl__genza7d2wideza7d2classza7c3za7d2za7e3struct3246za7f2za7za7object_structza7003343za7, BGl__genzd2widezd2classzc3zd2ze3struct3246zf2zzobject_structz00, 0L, 2 );



/* module-initialization */
obj_t BGl_modulezd2initializa7ationz75zzobject_structz00(long BgL_checksumz00_1725, char * BgL_fromz00_1726)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzobject_structz00))
{ 
BGl_requirezd2initializa7ationz75zzobject_structz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzobject_structz00(); 
BGl_cnstzd2initzd2zzobject_structz00(); 
BGl_importedzd2moduleszd2initz00zzobject_structz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzobject_structz00()
{ AN_OBJECT;
{ /* Object/struct.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "object_struct"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "object_struct"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "object_struct"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzobject_structz00()
{ AN_OBJECT;
{ /* Object/struct.scm 15 */
{ /* Object/struct.scm 15 */
obj_t BgL_cportz00_1718;
BgL_cportz00_1718 = 
open_input_string(BGl_string3311z00zzobject_structz00); 
{ 
long BgL_iz00_1719;
BgL_iz00_1719 = ((long)48); 
BgL_loopz00_1720:
if(
(BgL_iz00_1719==((long)-1)))
{ /* Object/struct.scm 15 */
return BUNSPEC;}  else 
{ /* Object/struct.scm 15 */
{ /* Object/struct.scm 15 */
obj_t BgL_arg3315z00_1722;
{ /* Object/struct.scm 15 */
obj_t BgL_list3318z00_1723;
BgL_list3318z00_1723 = 
MAKE_PAIR(BgL_cportz00_1718, BNIL); 
BgL_arg3315z00_1722 = 
BGl_readz00zz__readerz00(BgL_list3318z00_1723); } 
{ /* Object/struct.scm 15 */
int BgL_auxz00_1741;
BgL_auxz00_1741 = 
(int)(BgL_iz00_1719); 
CNST_TABLE_SET(BgL_auxz00_1741, BgL_arg3315z00_1722); } } 
{ 
long BgL_iz00_1744;
{ /* Object/struct.scm 15 */
int BgL_auxz00_1745;
{ /* Object/struct.scm 15 */
long BgL_auxz00_1746;
BgL_auxz00_1746 = 
(BgL_iz00_1719-((long)1)); 
BgL_auxz00_1745 = 
(int)(BgL_auxz00_1746); } 
BgL_iz00_1744 = 
(long)(BgL_auxz00_1745); } 
BgL_iz00_1719 = BgL_iz00_1744; 
goto BgL_loopz00_1720;} } } } } 
}



/* gen-plain-class<->struct */
obj_t BGl_genzd2plainzd2classzc3zd2ze3structzf2zzobject_structz00(BgL_typez00_bglt BgL_classz00_1, obj_t BgL_srczd2defzd2_2)
{ AN_OBJECT;
{ /* Object/struct.scm 37 */
{ /* Object/struct.scm 39 */
bool_t BgL_testz00_1750;
{ /* Object/struct.scm 39 */
BgL_tclassz00_bglt BgL_obj1625z00_1391;
BgL_obj1625z00_1391 = 
(BgL_tclassz00_bglt)(BgL_classz00_1); 
{ 
obj_t BgL_auxz00_1752;
{ /* Object/struct.scm 39 */
BgL_objectz00_bglt BgL_auxz00_1753;
BgL_auxz00_1753 = 
(BgL_objectz00_bglt)(BgL_obj1625z00_1391); 
BgL_auxz00_1752 = 
BGL_OBJECT_WIDENING(BgL_auxz00_1753); } 
BgL_testz00_1750 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_1752))->BgL_abstractzf3zf3); } } 
if(BgL_testz00_1750)
{ /* Object/struct.scm 39 */
return BNIL;}  else 
{ /* Object/struct.scm 41 */
obj_t BgL_arg1814z00_666;obj_t BgL_arg1815z00_667;
{ /* Object/struct.scm 41 */
obj_t BgL_auxz00_1757;
{ /* Object/struct.scm 41 */
BgL_tclassz00_bglt BgL_obj1611z00_1393;
BgL_obj1611z00_1393 = 
(BgL_tclassz00_bglt)(BgL_classz00_1); 
{ 
obj_t BgL_auxz00_1760;
{ /* Object/struct.scm 41 */
BgL_objectz00_bglt BgL_auxz00_1761;
BgL_auxz00_1761 = 
(BgL_objectz00_bglt)(BgL_obj1611z00_1393); 
BgL_auxz00_1760 = 
BGL_OBJECT_WIDENING(BgL_auxz00_1761); } 
BgL_auxz00_1757 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_1760))->BgL_slotsz00); } } 
BgL_arg1814z00_666 = 
BGl_genzd2plainzd2classzd2ze3structz31zzobject_structz00(
(((BgL_typez00_bglt)CREF(BgL_classz00_1))->BgL_idz00), BgL_classz00_1, BgL_auxz00_1757, BgL_srczd2defzd2_2); } 
{ /* Object/struct.scm 42 */
obj_t BgL_auxz00_1766;
{ /* Object/struct.scm 42 */
BgL_tclassz00_bglt BgL_obj1611z00_1395;
BgL_obj1611z00_1395 = 
(BgL_tclassz00_bglt)(BgL_classz00_1); 
{ 
obj_t BgL_auxz00_1769;
{ /* Object/struct.scm 42 */
BgL_objectz00_bglt BgL_auxz00_1770;
BgL_auxz00_1770 = 
(BgL_objectz00_bglt)(BgL_obj1611z00_1395); 
BgL_auxz00_1769 = 
BGL_OBJECT_WIDENING(BgL_auxz00_1770); } 
BgL_auxz00_1766 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_1769))->BgL_slotsz00); } } 
BgL_arg1815z00_667 = 
BGl_genzd2structzd2ze3plainzd2classz31zzobject_structz00(
(((BgL_typez00_bglt)CREF(BgL_classz00_1))->BgL_idz00), BgL_classz00_1, BgL_auxz00_1766, BgL_srczd2defzd2_2); } 
{ /* Object/struct.scm 41 */
obj_t BgL_list1817z00_668;
{ /* Object/struct.scm 41 */
obj_t BgL_arg1819z00_669;
BgL_arg1819z00_669 = 
MAKE_PAIR(BgL_arg1815z00_667, BNIL); 
BgL_list1817z00_668 = 
MAKE_PAIR(BgL_arg1814z00_666, BgL_arg1819z00_669); } 
return BgL_list1817z00_668;} } } } 
}



/* _gen-plain-class<->struct3244 */
obj_t BGl__genzd2plainzd2classzc3zd2ze3struct3244zf2zzobject_structz00(obj_t BgL_envz00_1712, obj_t BgL_classz00_1713, obj_t BgL_srczd2defzd2_1714)
{ AN_OBJECT;
{ /* Object/struct.scm 37 */
return 
BGl_genzd2plainzd2classzc3zd2ze3structzf2zzobject_structz00(
(BgL_typez00_bglt)(BgL_classz00_1713), BgL_srczd2defzd2_1714);} 
}



/* gen-wide-class<->struct */
obj_t BGl_genzd2widezd2classzc3zd2ze3structzf2zzobject_structz00(BgL_typez00_bglt BgL_classz00_3, obj_t BgL_srczd2defzd2_4)
{ AN_OBJECT;
{ /* Object/struct.scm 47 */
{ /* Object/struct.scm 49 */
obj_t BgL_arg1838z00_675;obj_t BgL_arg1839z00_676;
{ /* Object/struct.scm 49 */
obj_t BgL_auxz00_1779;
{ /* Object/struct.scm 49 */
BgL_tclassz00_bglt BgL_obj1611z00_1399;
BgL_obj1611z00_1399 = 
(BgL_tclassz00_bglt)(BgL_classz00_3); 
{ 
obj_t BgL_auxz00_1782;
{ /* Object/struct.scm 49 */
BgL_objectz00_bglt BgL_auxz00_1783;
BgL_auxz00_1783 = 
(BgL_objectz00_bglt)(BgL_obj1611z00_1399); 
BgL_auxz00_1782 = 
BGL_OBJECT_WIDENING(BgL_auxz00_1783); } 
BgL_auxz00_1779 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_1782))->BgL_slotsz00); } } 
BgL_arg1838z00_675 = 
BGl_genzd2widezd2classzd2ze3structz31zzobject_structz00(
(((BgL_typez00_bglt)CREF(BgL_classz00_3))->BgL_idz00), BgL_classz00_3, BgL_auxz00_1779, BgL_srczd2defzd2_4); } 
{ /* Object/struct.scm 50 */
obj_t BgL_auxz00_1788;
{ /* Object/struct.scm 50 */
BgL_tclassz00_bglt BgL_obj1611z00_1401;
BgL_obj1611z00_1401 = 
(BgL_tclassz00_bglt)(BgL_classz00_3); 
{ 
obj_t BgL_auxz00_1791;
{ /* Object/struct.scm 50 */
BgL_objectz00_bglt BgL_auxz00_1792;
BgL_auxz00_1792 = 
(BgL_objectz00_bglt)(BgL_obj1611z00_1401); 
BgL_auxz00_1791 = 
BGL_OBJECT_WIDENING(BgL_auxz00_1792); } 
BgL_auxz00_1788 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_1791))->BgL_slotsz00); } } 
BgL_arg1839z00_676 = 
BGl_genzd2structzd2ze3widezd2classz31zzobject_structz00(
(((BgL_typez00_bglt)CREF(BgL_classz00_3))->BgL_idz00), BgL_classz00_3, BgL_auxz00_1788, BgL_srczd2defzd2_4); } 
{ /* Object/struct.scm 49 */
obj_t BgL_list1841z00_677;
{ /* Object/struct.scm 49 */
obj_t BgL_arg1844z00_678;
BgL_arg1844z00_678 = 
MAKE_PAIR(BgL_arg1839z00_676, BNIL); 
BgL_list1841z00_677 = 
MAKE_PAIR(BgL_arg1838z00_675, BgL_arg1844z00_678); } 
return BgL_list1841z00_677;} } } 
}



/* _gen-wide-class<->struct3246 */
obj_t BGl__genzd2widezd2classzc3zd2ze3struct3246zf2zzobject_structz00(obj_t BgL_envz00_1715, obj_t BgL_classz00_1716, obj_t BgL_srczd2defzd2_1717)
{ AN_OBJECT;
{ /* Object/struct.scm 47 */
return 
BGl_genzd2widezd2classzc3zd2ze3structzf2zzobject_structz00(
(BgL_typez00_bglt)(BgL_classz00_1716), BgL_srczd2defzd2_1717);} 
}



/* save-slot */
obj_t BGl_savezd2slotzd2zzobject_structz00(obj_t BgL_onamez00_5, obj_t BgL_snamez00_6, obj_t BgL_cnamez00_7, long BgL_iz00_8, obj_t BgL_slotz00_9)
{ AN_OBJECT;
{ /* Object/struct.scm 55 */
{ 

{ /* Object/struct.scm 83 */
bool_t BgL_test1859z00_685;
BgL_test1859z00_685 = 
BGl_slotzd2virtualzf3z21zzobject_slotsz00(
(BgL_slotz00_bglt)(BgL_slotz00_9)); 
if(BgL_test1859z00_685)
{ /* Object/struct.scm 83 */
return BUNSPEC;}  else 
{ /* Object/struct.scm 85 */
bool_t BgL_testz00_1804;
{ /* Object/struct.scm 85 */
BgL_slotz00_bglt BgL_obj1764z00_1404;
BgL_obj1764z00_1404 = 
(BgL_slotz00_bglt)(BgL_slotz00_9); 
{ /* Object/struct.scm 85 */
obj_t BgL_auxz00_1806;
BgL_auxz00_1806 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1764z00_1404))->BgL_indexedz00); 
BgL_testz00_1804 = 
CBOOL(BgL_auxz00_1806); } } 
if(BgL_testz00_1804)
{ /* Object/struct.scm 85 */
{ /* Object/struct.scm 62 */
obj_t BgL_vecz00_688;obj_t BgL_jz00_689;obj_t BgL_loopz00_690;obj_t BgL_lenz00_691;
BgL_vecz00_688 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)0)), BEOA); 
BgL_jz00_689 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)1)), BEOA); 
BgL_loopz00_690 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)2)), BEOA); 
BgL_lenz00_691 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)3)), BEOA); 
{ /* Object/struct.scm 66 */
obj_t BgL_arg1867z00_692;obj_t BgL_arg1869z00_693;
BgL_arg1867z00_692 = 
CNST_TABLE_REF(((long)4)); 
{ /* Object/struct.scm 66 */
obj_t BgL_arg1873z00_694;obj_t BgL_arg1874z00_695;
{ /* Object/struct.scm 66 */
obj_t BgL_arg1878z00_696;
{ /* Object/struct.scm 66 */
obj_t BgL_arg1886z00_698;
{ /* Object/struct.scm 66 */
obj_t BgL_arg1889z00_699;
{ /* Object/struct.scm 66 */
obj_t BgL_arg1896z00_701;obj_t BgL_arg1897z00_702;
{ /* Object/struct.scm 66 */
obj_t BgL_arg1900z00_703;obj_t BgL_arg1901z00_704;
BgL_arg1900z00_703 = 
CNST_TABLE_REF(((long)5)); 
{ /* Object/struct.scm 66 */
BgL_slotz00_bglt BgL_obj1747z00_1405;
BgL_obj1747z00_1405 = 
(BgL_slotz00_bglt)(BgL_slotz00_9); 
BgL_arg1901z00_704 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1747z00_1405))->BgL_idz00); } 
{ /* Object/struct.scm 66 */
obj_t BgL_list1904z00_706;
{ /* Object/struct.scm 66 */
obj_t BgL_arg1906z00_707;
{ /* Object/struct.scm 66 */
obj_t BgL_arg1909z00_708;
{ /* Object/struct.scm 66 */
obj_t BgL_arg1912z00_709;
{ /* Object/struct.scm 66 */
obj_t BgL_auxz00_1825;
BgL_auxz00_1825 = 
CNST_TABLE_REF(((long)6)); 
BgL_arg1912z00_709 = 
MAKE_PAIR(BgL_auxz00_1825, BNIL); } 
BgL_arg1909z00_708 = 
MAKE_PAIR(BgL_arg1901z00_704, BgL_arg1912z00_709); } 
BgL_arg1906z00_707 = 
MAKE_PAIR(BgL_arg1900z00_703, BgL_arg1909z00_708); } 
BgL_list1904z00_706 = 
MAKE_PAIR(BgL_cnamez00_7, BgL_arg1906z00_707); } 
BgL_arg1896z00_701 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list1904z00_706); } } 
BgL_arg1897z00_702 = 
MAKE_PAIR(BgL_onamez00_5, BNIL); 
BgL_arg1889z00_699 = 
MAKE_PAIR(BgL_arg1896z00_701, BgL_arg1897z00_702); } 
BgL_arg1886z00_698 = 
MAKE_PAIR(BgL_arg1889z00_699, BNIL); } 
BgL_arg1878z00_696 = 
MAKE_PAIR(BgL_lenz00_691, BgL_arg1886z00_698); } 
BgL_arg1873z00_694 = 
MAKE_PAIR(BgL_arg1878z00_696, BNIL); } 
{ /* Object/struct.scm 67 */
obj_t BgL_arg1918z00_710;
{ /* Object/struct.scm 67 */
obj_t BgL_arg1923z00_712;obj_t BgL_arg1924z00_713;
BgL_arg1923z00_712 = 
CNST_TABLE_REF(((long)4)); 
{ /* Object/struct.scm 67 */
obj_t BgL_arg1929z00_714;obj_t BgL_arg1930z00_715;
{ /* Object/struct.scm 67 */
obj_t BgL_arg1933z00_716;
{ /* Object/struct.scm 67 */
obj_t BgL_arg1939z00_718;
{ /* Object/struct.scm 67 */
obj_t BgL_arg1943z00_719;
{ /* Object/struct.scm 67 */
obj_t BgL_arg1947z00_721;obj_t BgL_arg1948z00_722;
BgL_arg1947z00_721 = 
CNST_TABLE_REF(((long)7)); 
BgL_arg1948z00_722 = 
MAKE_PAIR(BgL_lenz00_691, BNIL); 
BgL_arg1943z00_719 = 
MAKE_PAIR(BgL_arg1947z00_721, BgL_arg1948z00_722); } 
BgL_arg1939z00_718 = 
MAKE_PAIR(BgL_arg1943z00_719, BNIL); } 
BgL_arg1933z00_716 = 
MAKE_PAIR(BgL_vecz00_688, BgL_arg1939z00_718); } 
BgL_arg1929z00_714 = 
MAKE_PAIR(BgL_arg1933z00_716, BNIL); } 
{ /* Object/struct.scm 68 */
obj_t BgL_arg1952z00_723;
{ /* Object/struct.scm 68 */
obj_t BgL_arg1956z00_725;obj_t BgL_arg1957z00_726;
BgL_arg1956z00_725 = 
CNST_TABLE_REF(((long)8)); 
{ /* Object/struct.scm 68 */
obj_t BgL_arg1960z00_727;obj_t BgL_arg1961z00_728;
{ /* Object/struct.scm 68 */
obj_t BgL_arg1964z00_729;
{ /* Object/struct.scm 68 */
obj_t BgL_arg1968z00_731;
{ /* Object/struct.scm 68 */
obj_t BgL_arg1971z00_732;obj_t BgL_arg1972z00_733;
BgL_arg1971z00_732 = 
MAKE_PAIR(BgL_jz00_689, BNIL); 
{ /* Object/struct.scm 68 */
obj_t BgL_arg1976z00_734;
{ /* Object/struct.scm 68 */
obj_t BgL_arg1980z00_736;obj_t BgL_arg1981z00_737;
BgL_arg1980z00_736 = 
CNST_TABLE_REF(((long)9)); 
{ /* Object/struct.scm 68 */
obj_t BgL_arg1984z00_738;obj_t BgL_arg1985z00_739;
{ /* Object/struct.scm 68 */
obj_t BgL_arg1988z00_740;obj_t BgL_arg1989z00_741;
BgL_arg1988z00_740 = 
CNST_TABLE_REF(((long)10)); 
{ /* Object/struct.scm 68 */
obj_t BgL_arg1992z00_742;
BgL_arg1992z00_742 = 
MAKE_PAIR(BgL_lenz00_691, BNIL); 
BgL_arg1989z00_741 = 
MAKE_PAIR(BgL_jz00_689, BgL_arg1992z00_742); } 
BgL_arg1984z00_738 = 
MAKE_PAIR(BgL_arg1988z00_740, BgL_arg1989z00_741); } 
{ /* Object/struct.scm 69 */
obj_t BgL_arg1996z00_743;obj_t BgL_arg1997z00_744;
{ /* Object/struct.scm 69 */
obj_t BgL_arg2000z00_745;obj_t BgL_arg2001z00_746;
BgL_arg2000z00_745 = 
CNST_TABLE_REF(((long)11)); 
{ /* Object/struct.scm 69 */
obj_t BgL_arg2004z00_747;
{ /* Object/struct.scm 69 */
obj_t BgL_arg2007z00_748;
BgL_arg2007z00_748 = 
MAKE_PAIR(BgL_vecz00_688, BNIL); 
{ /* Object/struct.scm 69 */
obj_t BgL_auxz00_1853;
BgL_auxz00_1853 = 
BINT(BgL_iz00_8); 
BgL_arg2004z00_747 = 
MAKE_PAIR(BgL_auxz00_1853, BgL_arg2007z00_748); } } 
BgL_arg2001z00_746 = 
MAKE_PAIR(BgL_snamez00_6, BgL_arg2004z00_747); } 
BgL_arg1996z00_743 = 
MAKE_PAIR(BgL_arg2000z00_745, BgL_arg2001z00_746); } 
{ /* Object/struct.scm 70 */
obj_t BgL_arg2011z00_749;
{ /* Object/struct.scm 70 */
obj_t BgL_arg2015z00_751;obj_t BgL_arg2017z00_752;
BgL_arg2015z00_751 = 
CNST_TABLE_REF(((long)12)); 
{ /* Object/struct.scm 71 */
obj_t BgL_arg2020z00_753;obj_t BgL_arg2021z00_754;
{ /* Object/struct.scm 71 */
obj_t BgL_arg2024z00_755;obj_t BgL_arg2025z00_756;
BgL_arg2024z00_755 = 
CNST_TABLE_REF(((long)13)); 
{ /* Object/struct.scm 75 */
obj_t BgL_arg2028z00_757;
{ /* Object/struct.scm 75 */
obj_t BgL_arg2031z00_758;
{ /* Object/struct.scm 75 */
obj_t BgL_arg2034z00_759;
{ /* Object/struct.scm 75 */
obj_t BgL_arg2038z00_761;obj_t BgL_arg2039z00_762;
{ /* Object/struct.scm 75 */
obj_t BgL_arg2042z00_763;obj_t BgL_arg2043z00_764;
BgL_arg2042z00_763 = 
CNST_TABLE_REF(((long)5)); 
{ /* Object/struct.scm 76 */
BgL_slotz00_bglt BgL_obj1747z00_1406;
BgL_obj1747z00_1406 = 
(BgL_slotz00_bglt)(BgL_slotz00_9); 
BgL_arg2043z00_764 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1747z00_1406))->BgL_idz00); } 
{ /* Object/struct.scm 74 */
obj_t BgL_list2046z00_766;
{ /* Object/struct.scm 74 */
obj_t BgL_arg2048z00_767;
{ /* Object/struct.scm 74 */
obj_t BgL_arg2051z00_768;
{ /* Object/struct.scm 74 */
obj_t BgL_arg2054z00_769;
{ /* Object/struct.scm 74 */
obj_t BgL_auxz00_1863;
BgL_auxz00_1863 = 
CNST_TABLE_REF(((long)14)); 
BgL_arg2054z00_769 = 
MAKE_PAIR(BgL_auxz00_1863, BNIL); } 
BgL_arg2051z00_768 = 
MAKE_PAIR(BgL_arg2043z00_764, BgL_arg2054z00_769); } 
BgL_arg2048z00_767 = 
MAKE_PAIR(BgL_arg2042z00_763, BgL_arg2051z00_768); } 
BgL_list2046z00_766 = 
MAKE_PAIR(BgL_cnamez00_7, BgL_arg2048z00_767); } 
BgL_arg2038z00_761 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2046z00_766); } } 
{ /* Object/struct.scm 74 */
obj_t BgL_arg2059z00_770;
BgL_arg2059z00_770 = 
MAKE_PAIR(BgL_jz00_689, BNIL); 
BgL_arg2039z00_762 = 
MAKE_PAIR(BgL_onamez00_5, BgL_arg2059z00_770); } 
BgL_arg2034z00_759 = 
MAKE_PAIR(BgL_arg2038z00_761, BgL_arg2039z00_762); } 
BgL_arg2031z00_758 = 
MAKE_PAIR(BgL_arg2034z00_759, BNIL); } 
BgL_arg2028z00_757 = 
MAKE_PAIR(BgL_jz00_689, BgL_arg2031z00_758); } 
BgL_arg2025z00_756 = 
MAKE_PAIR(BgL_vecz00_688, BgL_arg2028z00_757); } 
BgL_arg2020z00_753 = 
MAKE_PAIR(BgL_arg2024z00_755, BgL_arg2025z00_756); } 
{ /* Object/struct.scm 80 */
obj_t BgL_arg2063z00_771;
{ /* Object/struct.scm 80 */
obj_t BgL_arg2067z00_773;
{ /* Object/struct.scm 80 */
obj_t BgL_arg2070z00_774;
{ /* Object/struct.scm 80 */
obj_t BgL_arg2074z00_776;obj_t BgL_arg2075z00_777;
BgL_arg2074z00_776 = 
CNST_TABLE_REF(((long)15)); 
{ /* Object/struct.scm 80 */
obj_t BgL_arg2078z00_778;
{ /* Object/struct.scm 80 */
obj_t BgL_auxz00_1878;
BgL_auxz00_1878 = 
BINT(((long)1)); 
BgL_arg2078z00_778 = 
MAKE_PAIR(BgL_auxz00_1878, BNIL); } 
BgL_arg2075z00_777 = 
MAKE_PAIR(BgL_jz00_689, BgL_arg2078z00_778); } 
BgL_arg2070z00_774 = 
MAKE_PAIR(BgL_arg2074z00_776, BgL_arg2075z00_777); } 
BgL_arg2067z00_773 = 
MAKE_PAIR(BgL_arg2070z00_774, BNIL); } 
BgL_arg2063z00_771 = 
MAKE_PAIR(BgL_loopz00_690, BgL_arg2067z00_773); } 
BgL_arg2021z00_754 = 
MAKE_PAIR(BgL_arg2063z00_771, BNIL); } 
BgL_arg2017z00_752 = 
MAKE_PAIR(BgL_arg2020z00_753, BgL_arg2021z00_754); } 
BgL_arg2011z00_749 = 
MAKE_PAIR(BgL_arg2015z00_751, BgL_arg2017z00_752); } 
BgL_arg1997z00_744 = 
MAKE_PAIR(BgL_arg2011z00_749, BNIL); } 
BgL_arg1985z00_739 = 
MAKE_PAIR(BgL_arg1996z00_743, BgL_arg1997z00_744); } 
BgL_arg1981z00_737 = 
MAKE_PAIR(BgL_arg1984z00_738, BgL_arg1985z00_739); } 
BgL_arg1976z00_734 = 
MAKE_PAIR(BgL_arg1980z00_736, BgL_arg1981z00_737); } 
BgL_arg1972z00_733 = 
MAKE_PAIR(BgL_arg1976z00_734, BNIL); } 
BgL_arg1968z00_731 = 
MAKE_PAIR(BgL_arg1971z00_732, BgL_arg1972z00_733); } 
BgL_arg1964z00_729 = 
MAKE_PAIR(BgL_loopz00_690, BgL_arg1968z00_731); } 
BgL_arg1960z00_727 = 
MAKE_PAIR(BgL_arg1964z00_729, BNIL); } 
{ /* Object/struct.scm 81 */
obj_t BgL_arg2082z00_779;
{ /* Object/struct.scm 81 */
obj_t BgL_arg2086z00_781;
{ /* Object/struct.scm 81 */
obj_t BgL_auxz00_1896;
BgL_auxz00_1896 = 
BINT(((long)0)); 
BgL_arg2086z00_781 = 
MAKE_PAIR(BgL_auxz00_1896, BNIL); } 
BgL_arg2082z00_779 = 
MAKE_PAIR(BgL_loopz00_690, BgL_arg2086z00_781); } 
BgL_arg1961z00_728 = 
MAKE_PAIR(BgL_arg2082z00_779, BNIL); } 
BgL_arg1957z00_726 = 
MAKE_PAIR(BgL_arg1960z00_727, BgL_arg1961z00_728); } 
BgL_arg1952z00_723 = 
MAKE_PAIR(BgL_arg1956z00_725, BgL_arg1957z00_726); } 
BgL_arg1930z00_715 = 
MAKE_PAIR(BgL_arg1952z00_723, BNIL); } 
BgL_arg1924z00_713 = 
MAKE_PAIR(BgL_arg1929z00_714, BgL_arg1930z00_715); } 
BgL_arg1918z00_710 = 
MAKE_PAIR(BgL_arg1923z00_712, BgL_arg1924z00_713); } 
BgL_arg1874z00_695 = 
MAKE_PAIR(BgL_arg1918z00_710, BNIL); } 
BgL_arg1869z00_693 = 
MAKE_PAIR(BgL_arg1873z00_694, BgL_arg1874z00_695); } 
return 
MAKE_PAIR(BgL_arg1867z00_692, BgL_arg1869z00_693);} } }  else 
{ /* Object/struct.scm 85 */
{ /* Object/struct.scm 57 */
obj_t BgL_arg2095z00_783;obj_t BgL_arg2096z00_784;
BgL_arg2095z00_783 = 
CNST_TABLE_REF(((long)11)); 
{ /* Object/struct.scm 59 */
obj_t BgL_arg2099z00_785;
{ /* Object/struct.scm 59 */
obj_t BgL_arg2102z00_786;
{ /* Object/struct.scm 59 */
obj_t BgL_arg2105z00_787;
{ /* Object/struct.scm 59 */
obj_t BgL_arg2109z00_789;obj_t BgL_arg2110z00_790;
{ /* Object/struct.scm 59 */
obj_t BgL_arg2113z00_791;
BgL_arg2113z00_791 = 
CNST_TABLE_REF(((long)5)); 
{ /* Object/struct.scm 59 */
obj_t BgL_list2116z00_793;
{ /* Object/struct.scm 59 */
obj_t BgL_arg2118z00_794;
{ /* Object/struct.scm 59 */
obj_t BgL_arg2121z00_795;
{ /* Object/struct.scm 59 */
obj_t BgL_auxz00_1911;
{ /* Object/struct.scm 59 */
BgL_slotz00_bglt BgL_obj1747z00_1407;
BgL_obj1747z00_1407 = 
(BgL_slotz00_bglt)(BgL_slotz00_9); 
BgL_auxz00_1911 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1747z00_1407))->BgL_idz00); } 
BgL_arg2121z00_795 = 
MAKE_PAIR(BgL_auxz00_1911, BNIL); } 
BgL_arg2118z00_794 = 
MAKE_PAIR(BgL_arg2113z00_791, BgL_arg2121z00_795); } 
BgL_list2116z00_793 = 
MAKE_PAIR(BgL_cnamez00_7, BgL_arg2118z00_794); } 
BgL_arg2109z00_789 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2116z00_793); } } 
BgL_arg2110z00_790 = 
MAKE_PAIR(BgL_onamez00_5, BNIL); 
BgL_arg2105z00_787 = 
MAKE_PAIR(BgL_arg2109z00_789, BgL_arg2110z00_790); } 
BgL_arg2102z00_786 = 
MAKE_PAIR(BgL_arg2105z00_787, BNIL); } 
{ /* Object/struct.scm 57 */
obj_t BgL_auxz00_1921;
BgL_auxz00_1921 = 
BINT(BgL_iz00_8); 
BgL_arg2099z00_785 = 
MAKE_PAIR(BgL_auxz00_1921, BgL_arg2102z00_786); } } 
BgL_arg2096z00_784 = 
MAKE_PAIR(BgL_snamez00_6, BgL_arg2099z00_785); } 
return 
MAKE_PAIR(BgL_arg2095z00_783, BgL_arg2096z00_784);} } } } } } 
}



/* slots-length */
long BGl_slotszd2lengthzd2zzobject_structz00(obj_t BgL_slotsz00_10)
{ AN_OBJECT;
{ /* Object/struct.scm 93 */
{ 
obj_t BgL_slotsz00_798;long BgL_lenz00_799;
BgL_slotsz00_798 = BgL_slotsz00_10; 
BgL_lenz00_799 = ((long)0); 
BgL_loopz00_800:
if(
NULLP(BgL_slotsz00_798))
{ /* Object/struct.scm 97 */
return BgL_lenz00_799;}  else 
{ /* Object/struct.scm 99 */
bool_t BgL_test2128z00_802;
{ /* Object/struct.scm 99 */
BgL_slotz00_bglt BgL_auxz00_1928;
{ /* Object/struct.scm 99 */
obj_t BgL_auxz00_1929;
BgL_auxz00_1929 = 
CAR(BgL_slotsz00_798); 
BgL_auxz00_1928 = 
(BgL_slotz00_bglt)(BgL_auxz00_1929); } 
BgL_test2128z00_802 = 
BGl_slotzd2virtualzf3z21zzobject_slotsz00(BgL_auxz00_1928); } 
if(BgL_test2128z00_802)
{ /* Object/struct.scm 99 */
{ 
obj_t BgL_slotsz00_1934;
BgL_slotsz00_1934 = 
CDR(BgL_slotsz00_798); 
BgL_slotsz00_798 = BgL_slotsz00_1934; 
goto BgL_loopz00_800;} }  else 
{ /* Object/struct.scm 99 */
{ 
long BgL_lenz00_1938;obj_t BgL_slotsz00_1936;
BgL_slotsz00_1936 = 
CDR(BgL_slotsz00_798); 
BgL_lenz00_1938 = 
(((long)1)+BgL_lenz00_799); 
BgL_lenz00_799 = BgL_lenz00_1938; 
BgL_slotsz00_798 = BgL_slotsz00_1936; 
goto BgL_loopz00_800;} } } } } 
}



/* gen-plain-class->struct */
obj_t BGl_genzd2plainzd2classzd2ze3structz31zzobject_structz00(obj_t BgL_cnamez00_11, BgL_typez00_bglt BgL_typez00_12, obj_t BgL_slotsz00_13, obj_t BgL_srczd2defzd2_14)
{ AN_OBJECT;
{ /* Object/struct.scm 107 */
{ /* Object/struct.scm 108 */
long BgL_lenz00_807;obj_t BgL_onamez00_808;obj_t BgL_snamez00_809;
{ /* Object/struct.scm 108 */
long BgL_arg2265z00_865;
BgL_arg2265z00_865 = 
BGl_slotszd2lengthzd2zzobject_structz00(BgL_slotsz00_13); 
BgL_lenz00_807 = 
(((long)1)+BgL_arg2265z00_865); } 
BgL_onamez00_808 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)16)), BEOA); 
BgL_snamez00_809 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)17)), BEOA); 
{ /* Object/struct.scm 112 */
obj_t BgL_arg2145z00_810;
{ /* Object/struct.scm 112 */
obj_t BgL_arg2148z00_811;obj_t BgL_arg2149z00_812;
BgL_arg2148z00_811 = 
CNST_TABLE_REF(((long)18)); 
{ /* Object/struct.scm 112 */
obj_t BgL_arg2152z00_813;obj_t BgL_arg2153z00_814;
{ /* Object/struct.scm 112 */
obj_t BgL_arg2156z00_815;obj_t BgL_arg2157z00_816;
BgL_arg2156z00_815 = 
CNST_TABLE_REF(((long)19)); 
{ /* Object/struct.scm 112 */
obj_t BgL_arg2160z00_817;
BgL_arg2160z00_817 = 
BGl_makezd2typedzd2identz00zzast_identz00(BgL_onamez00_808, BgL_cnamez00_11); 
BgL_arg2157z00_816 = 
MAKE_PAIR(BgL_arg2160z00_817, BNIL); } 
BgL_arg2152z00_813 = 
MAKE_PAIR(BgL_arg2156z00_815, BgL_arg2157z00_816); } 
{ /* Object/struct.scm 113 */
obj_t BgL_arg2165z00_819;
{ /* Object/struct.scm 113 */
obj_t BgL_arg2169z00_821;obj_t BgL_arg2170z00_822;
BgL_arg2169z00_821 = 
CNST_TABLE_REF(((long)4)); 
{ /* Object/struct.scm 113 */
obj_t BgL_arg2173z00_823;obj_t BgL_arg2174z00_824;
{ /* Object/struct.scm 113 */
obj_t BgL_arg2177z00_825;
{ /* Object/struct.scm 113 */
obj_t BgL_arg2181z00_827;
{ /* Object/struct.scm 113 */
obj_t BgL_arg2184z00_828;
{ /* Object/struct.scm 113 */
obj_t BgL_arg2188z00_830;obj_t BgL_arg2189z00_831;
BgL_arg2188z00_830 = 
CNST_TABLE_REF(((long)20)); 
{ /* Object/struct.scm 113 */
obj_t BgL_arg2192z00_832;obj_t BgL_arg2193z00_833;
{ /* Object/struct.scm 113 */
obj_t BgL_arg2196z00_834;obj_t BgL_arg2197z00_835;
BgL_arg2196z00_834 = 
CNST_TABLE_REF(((long)21)); 
BgL_arg2197z00_835 = 
MAKE_PAIR(BgL_cnamez00_11, BNIL); 
BgL_arg2192z00_832 = 
MAKE_PAIR(BgL_arg2196z00_834, BgL_arg2197z00_835); } 
{ /* Object/struct.scm 113 */
obj_t BgL_arg2201z00_836;
BgL_arg2201z00_836 = 
MAKE_PAIR(BUNSPEC, BNIL); 
{ /* Object/struct.scm 113 */
obj_t BgL_auxz00_1959;
BgL_auxz00_1959 = 
BINT(BgL_lenz00_807); 
BgL_arg2193z00_833 = 
MAKE_PAIR(BgL_auxz00_1959, BgL_arg2201z00_836); } } 
BgL_arg2189z00_831 = 
MAKE_PAIR(BgL_arg2192z00_832, BgL_arg2193z00_833); } 
BgL_arg2184z00_828 = 
MAKE_PAIR(BgL_arg2188z00_830, BgL_arg2189z00_831); } 
BgL_arg2181z00_827 = 
MAKE_PAIR(BgL_arg2184z00_828, BNIL); } 
BgL_arg2177z00_825 = 
MAKE_PAIR(BgL_snamez00_809, BgL_arg2181z00_827); } 
BgL_arg2173z00_823 = 
MAKE_PAIR(BgL_arg2177z00_825, BNIL); } 
{ /* Object/struct.scm 114 */
obj_t BgL_arg2205z00_837;
{ /* Object/struct.scm 114 */
obj_t BgL_arg2209z00_839;obj_t BgL_arg2210z00_840;
BgL_arg2209z00_839 = 
CNST_TABLE_REF(((long)12)); 
{ /* Object/struct.scm 115 */
obj_t BgL_arg2213z00_841;obj_t BgL_arg2215z00_842;
{ /* Object/struct.scm 115 */
obj_t BgL_arg2218z00_843;obj_t BgL_arg2219z00_844;
BgL_arg2218z00_843 = 
CNST_TABLE_REF(((long)11)); 
{ /* Object/struct.scm 115 */
obj_t BgL_arg2222z00_845;
{ /* Object/struct.scm 115 */
obj_t BgL_arg2226z00_847;
BgL_arg2226z00_847 = 
MAKE_PAIR(BFALSE, BNIL); 
{ /* Object/struct.scm 115 */
obj_t BgL_auxz00_1970;
BgL_auxz00_1970 = 
BINT(((long)0)); 
BgL_arg2222z00_845 = 
MAKE_PAIR(BgL_auxz00_1970, BgL_arg2226z00_847); } } 
BgL_arg2219z00_844 = 
MAKE_PAIR(BgL_snamez00_809, BgL_arg2222z00_845); } 
BgL_arg2213z00_841 = 
MAKE_PAIR(BgL_arg2218z00_843, BgL_arg2219z00_844); } 
{ /* Object/struct.scm 116 */
obj_t BgL_arg2230z00_848;obj_t BgL_arg2231z00_849;
{ 
long BgL_iz00_850;obj_t BgL_slotsz00_851;obj_t BgL_resz00_852;
BgL_iz00_850 = ((long)1); 
BgL_slotsz00_851 = BgL_slotsz00_13; 
BgL_resz00_852 = BNIL; 
BgL_loopz00_853:
if(
(BgL_iz00_850==BgL_lenz00_807))
{ /* Object/struct.scm 120 */
BgL_arg2230z00_848 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_resz00_852); }  else 
{ /* Object/struct.scm 122 */
bool_t BgL_test2236z00_855;
{ /* Object/struct.scm 122 */
BgL_slotz00_bglt BgL_auxz00_1978;
{ /* Object/struct.scm 122 */
obj_t BgL_auxz00_1979;
BgL_auxz00_1979 = 
CAR(BgL_slotsz00_851); 
BgL_auxz00_1978 = 
(BgL_slotz00_bglt)(BgL_auxz00_1979); } 
BgL_test2236z00_855 = 
BGl_slotzd2virtualzf3z21zzobject_slotsz00(BgL_auxz00_1978); } 
if(BgL_test2236z00_855)
{ /* Object/struct.scm 122 */
{ 
obj_t BgL_slotsz00_1986;long BgL_iz00_1984;
BgL_iz00_1984 = 
(BgL_iz00_850+((long)1)); 
BgL_slotsz00_1986 = 
CDR(BgL_slotsz00_851); 
BgL_slotsz00_851 = BgL_slotsz00_1986; 
BgL_iz00_850 = BgL_iz00_1984; 
goto BgL_loopz00_853;} }  else 
{ /* Object/struct.scm 122 */
{ /* Object/struct.scm 127 */
long BgL_arg2244z00_858;obj_t BgL_arg2245z00_859;obj_t BgL_arg2246z00_860;
BgL_arg2244z00_858 = 
(BgL_iz00_850+((long)1)); 
BgL_arg2245z00_859 = 
CDR(BgL_slotsz00_851); 
{ /* Object/struct.scm 133 */
obj_t BgL_arg2251z00_861;
BgL_arg2251z00_861 = 
BGl_savezd2slotzd2zzobject_structz00(BgL_onamez00_808, BgL_snamez00_809, BgL_cnamez00_11, BgL_iz00_850, 
CAR(BgL_slotsz00_851)); 
BgL_arg2246z00_860 = 
MAKE_PAIR(BgL_arg2251z00_861, BgL_resz00_852); } 
{ 
obj_t BgL_resz00_1995;obj_t BgL_slotsz00_1994;long BgL_iz00_1993;
BgL_iz00_1993 = BgL_arg2244z00_858; 
BgL_slotsz00_1994 = BgL_arg2245z00_859; 
BgL_resz00_1995 = BgL_arg2246z00_860; 
BgL_resz00_852 = BgL_resz00_1995; 
BgL_slotsz00_851 = BgL_slotsz00_1994; 
BgL_iz00_850 = BgL_iz00_1993; 
goto BgL_loopz00_853;} } } } } 
BgL_arg2231z00_849 = 
MAKE_PAIR(BgL_snamez00_809, BNIL); 
BgL_arg2215z00_842 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2230z00_848, BgL_arg2231z00_849); } 
BgL_arg2210z00_840 = 
MAKE_PAIR(BgL_arg2213z00_841, BgL_arg2215z00_842); } 
BgL_arg2205z00_837 = 
MAKE_PAIR(BgL_arg2209z00_839, BgL_arg2210z00_840); } 
BgL_arg2174z00_824 = 
MAKE_PAIR(BgL_arg2205z00_837, BNIL); } 
BgL_arg2170z00_822 = 
MAKE_PAIR(BgL_arg2173z00_823, BgL_arg2174z00_824); } 
BgL_arg2165z00_819 = 
MAKE_PAIR(BgL_arg2169z00_821, BgL_arg2170z00_822); } 
BgL_arg2153z00_814 = 
MAKE_PAIR(BgL_arg2165z00_819, BNIL); } 
BgL_arg2149z00_812 = 
MAKE_PAIR(BgL_arg2152z00_813, BgL_arg2153z00_814); } 
BgL_arg2145z00_810 = 
MAKE_PAIR(BgL_arg2148z00_811, BgL_arg2149z00_812); } 
return 
BGl_epairifyz00zztools_miscz00(BgL_arg2145z00_810, BgL_srczd2defzd2_14);} } } 
}



/* gen-wide-class->struct */
obj_t BGl_genzd2widezd2classzd2ze3structz31zzobject_structz00(obj_t BgL_cnamez00_15, BgL_typez00_bglt BgL_typez00_16, obj_t BgL_slotsz00_17, obj_t BgL_srczd2defzd2_18)
{ AN_OBJECT;
{ /* Object/struct.scm 141 */
{ /* Object/struct.scm 142 */
long BgL_lenz00_866;
BgL_lenz00_866 = 
BGl_slotszd2lengthzd2zzobject_structz00(BgL_slotsz00_17); 
{ /* Object/struct.scm 142 */
obj_t BgL_onamez00_867;
BgL_onamez00_867 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)16)), BEOA); 
{ /* Object/struct.scm 143 */
obj_t BgL_resz00_868;
BgL_resz00_868 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)17)), BEOA); 
{ /* Object/struct.scm 144 */
obj_t BgL_tresz00_869;
{ /* Object/struct.scm 145 */
obj_t BgL_list2449z00_950;
{ /* Object/struct.scm 145 */
obj_t BgL_arg2451z00_951;
{ /* Object/struct.scm 145 */
obj_t BgL_auxz00_2014;
BgL_auxz00_2014 = 
CNST_TABLE_REF(((long)22)); 
BgL_arg2451z00_951 = 
MAKE_PAIR(BgL_auxz00_2014, BNIL); } 
BgL_list2449z00_950 = 
MAKE_PAIR(BgL_resz00_868, BgL_arg2451z00_951); } 
BgL_tresz00_869 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2449z00_950); } 
{ /* Object/struct.scm 145 */
obj_t BgL_auxz00_870;
BgL_auxz00_870 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)23)), BEOA); 
{ /* Object/struct.scm 146 */

{ /* Object/struct.scm 148 */
obj_t BgL_arg2271z00_871;
{ /* Object/struct.scm 148 */
obj_t BgL_arg2274z00_872;obj_t BgL_arg2275z00_873;
BgL_arg2274z00_872 = 
CNST_TABLE_REF(((long)18)); 
{ /* Object/struct.scm 148 */
obj_t BgL_arg2278z00_874;obj_t BgL_arg2279z00_875;
{ /* Object/struct.scm 148 */
obj_t BgL_arg2282z00_876;obj_t BgL_arg2283z00_877;
BgL_arg2282z00_876 = 
CNST_TABLE_REF(((long)19)); 
{ /* Object/struct.scm 148 */
obj_t BgL_arg2286z00_878;
BgL_arg2286z00_878 = 
BGl_makezd2typedzd2identz00zzast_identz00(BgL_onamez00_867, BgL_cnamez00_15); 
BgL_arg2283z00_877 = 
MAKE_PAIR(BgL_arg2286z00_878, BNIL); } 
BgL_arg2278z00_874 = 
MAKE_PAIR(BgL_arg2282z00_876, BgL_arg2283z00_877); } 
{ /* Object/struct.scm 149 */
obj_t BgL_arg2291z00_880;
{ /* Object/struct.scm 149 */
obj_t BgL_arg2295z00_882;obj_t BgL_arg2296z00_883;
BgL_arg2295z00_882 = 
CNST_TABLE_REF(((long)4)); 
{ /* Object/struct.scm 149 */
obj_t BgL_arg2299z00_884;obj_t BgL_arg2300z00_885;
{ /* Object/struct.scm 149 */
obj_t BgL_arg2303z00_886;
{ /* Object/struct.scm 149 */
obj_t BgL_arg2307z00_888;
{ /* Object/struct.scm 149 */
obj_t BgL_arg2310z00_889;
{ /* Object/struct.scm 149 */
obj_t BgL_auxz00_2028;
BgL_auxz00_2028 = 
CNST_TABLE_REF(((long)24)); 
BgL_arg2310z00_889 = 
MAKE_PAIR(BgL_auxz00_2028, BNIL); } 
BgL_arg2307z00_888 = 
MAKE_PAIR(BgL_arg2310z00_889, BNIL); } 
BgL_arg2303z00_886 = 
MAKE_PAIR(BgL_tresz00_869, BgL_arg2307z00_888); } 
BgL_arg2299z00_884 = 
MAKE_PAIR(BgL_arg2303z00_886, BNIL); } 
{ /* Object/struct.scm 150 */
obj_t BgL_arg2315z00_891;
{ /* Object/struct.scm 150 */
obj_t BgL_arg2319z00_893;obj_t BgL_arg2321z00_894;
BgL_arg2319z00_893 = 
CNST_TABLE_REF(((long)4)); 
{ /* Object/struct.scm 150 */
obj_t BgL_arg2324z00_895;obj_t BgL_arg2325z00_896;
{ /* Object/struct.scm 150 */
obj_t BgL_arg2328z00_897;
{ /* Object/struct.scm 150 */
obj_t BgL_arg2332z00_899;
{ /* Object/struct.scm 150 */
obj_t BgL_arg2335z00_900;
{ /* Object/struct.scm 150 */
obj_t BgL_arg2339z00_902;obj_t BgL_arg2340z00_903;
BgL_arg2339z00_902 = 
CNST_TABLE_REF(((long)20)); 
{ /* Object/struct.scm 150 */
obj_t BgL_arg2344z00_904;obj_t BgL_arg2345z00_905;
{ /* Object/struct.scm 150 */
obj_t BgL_arg2348z00_906;obj_t BgL_arg2350z00_907;
BgL_arg2348z00_906 = 
CNST_TABLE_REF(((long)21)); 
BgL_arg2350z00_907 = 
MAKE_PAIR(BgL_cnamez00_15, BNIL); 
BgL_arg2344z00_904 = 
MAKE_PAIR(BgL_arg2348z00_906, BgL_arg2350z00_907); } 
{ /* Object/struct.scm 150 */
obj_t BgL_arg2354z00_908;
BgL_arg2354z00_908 = 
MAKE_PAIR(BUNSPEC, BNIL); 
{ /* Object/struct.scm 150 */
obj_t BgL_auxz00_2040;
BgL_auxz00_2040 = 
BINT(BgL_lenz00_866); 
BgL_arg2345z00_905 = 
MAKE_PAIR(BgL_auxz00_2040, BgL_arg2354z00_908); } } 
BgL_arg2340z00_903 = 
MAKE_PAIR(BgL_arg2344z00_904, BgL_arg2345z00_905); } 
BgL_arg2335z00_900 = 
MAKE_PAIR(BgL_arg2339z00_902, BgL_arg2340z00_903); } 
BgL_arg2332z00_899 = 
MAKE_PAIR(BgL_arg2335z00_900, BNIL); } 
BgL_arg2328z00_897 = 
MAKE_PAIR(BgL_auxz00_870, BgL_arg2332z00_899); } 
BgL_arg2324z00_895 = 
MAKE_PAIR(BgL_arg2328z00_897, BNIL); } 
{ /* Object/struct.scm 151 */
obj_t BgL_arg2358z00_909;obj_t BgL_arg2359z00_910;
{ 
long BgL_iz00_911;obj_t BgL_slotsz00_912;obj_t BgL_resz00_913;
BgL_iz00_911 = ((long)0); 
BgL_slotsz00_912 = BgL_slotsz00_17; 
BgL_resz00_913 = BNIL; 
BgL_loopz00_914:
if(
(BgL_iz00_911==BgL_lenz00_866))
{ /* Object/struct.scm 155 */
BgL_arg2358z00_909 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_resz00_913); }  else 
{ /* Object/struct.scm 157 */
bool_t BgL_test2364z00_916;
{ /* Object/struct.scm 157 */
BgL_slotz00_bglt BgL_auxz00_2051;
{ /* Object/struct.scm 157 */
obj_t BgL_auxz00_2052;
BgL_auxz00_2052 = 
CAR(BgL_slotsz00_912); 
BgL_auxz00_2051 = 
(BgL_slotz00_bglt)(BgL_auxz00_2052); } 
BgL_test2364z00_916 = 
BGl_slotzd2virtualzf3z21zzobject_slotsz00(BgL_auxz00_2051); } 
if(BgL_test2364z00_916)
{ /* Object/struct.scm 157 */
{ 
obj_t BgL_slotsz00_2059;long BgL_iz00_2057;
BgL_iz00_2057 = 
(BgL_iz00_911+((long)1)); 
BgL_slotsz00_2059 = 
CDR(BgL_slotsz00_912); 
BgL_slotsz00_912 = BgL_slotsz00_2059; 
BgL_iz00_911 = BgL_iz00_2057; 
goto BgL_loopz00_914;} }  else 
{ /* Object/struct.scm 157 */
{ /* Object/struct.scm 162 */
long BgL_arg2372z00_919;obj_t BgL_arg2373z00_920;obj_t BgL_arg2374z00_921;
BgL_arg2372z00_919 = 
(BgL_iz00_911+((long)1)); 
BgL_arg2373z00_920 = 
CDR(BgL_slotsz00_912); 
{ /* Object/struct.scm 164 */
obj_t BgL_arg2379z00_922;
BgL_arg2379z00_922 = 
BGl_savezd2slotzd2zzobject_structz00(BgL_onamez00_867, BgL_auxz00_870, BgL_cnamez00_15, BgL_iz00_911, 
CAR(BgL_slotsz00_912)); 
BgL_arg2374z00_921 = 
MAKE_PAIR(BgL_arg2379z00_922, BgL_resz00_913); } 
{ 
obj_t BgL_resz00_2068;obj_t BgL_slotsz00_2067;long BgL_iz00_2066;
BgL_iz00_2066 = BgL_arg2372z00_919; 
BgL_slotsz00_2067 = BgL_arg2373z00_920; 
BgL_resz00_2068 = BgL_arg2374z00_921; 
BgL_resz00_913 = BgL_resz00_2068; 
BgL_slotsz00_912 = BgL_slotsz00_2067; 
BgL_iz00_911 = BgL_iz00_2066; 
goto BgL_loopz00_914;} } } } } 
{ /* Object/struct.scm 166 */
obj_t BgL_arg2391z00_925;obj_t BgL_arg2392z00_926;
{ /* Object/struct.scm 166 */
obj_t BgL_arg2395z00_927;obj_t BgL_arg2396z00_928;
BgL_arg2395z00_927 = 
CNST_TABLE_REF(((long)11)); 
{ /* Object/struct.scm 166 */
obj_t BgL_arg2399z00_929;
{ /* Object/struct.scm 166 */
obj_t BgL_arg2403z00_931;
BgL_arg2403z00_931 = 
MAKE_PAIR(BgL_auxz00_870, BNIL); 
{ /* Object/struct.scm 166 */
obj_t BgL_auxz00_2071;
BgL_auxz00_2071 = 
BINT(((long)0)); 
BgL_arg2399z00_929 = 
MAKE_PAIR(BgL_auxz00_2071, BgL_arg2403z00_931); } } 
BgL_arg2396z00_928 = 
MAKE_PAIR(BgL_resz00_868, BgL_arg2399z00_929); } 
BgL_arg2391z00_925 = 
MAKE_PAIR(BgL_arg2395z00_927, BgL_arg2396z00_928); } 
{ /* Object/struct.scm 168 */
obj_t BgL_arg2407z00_932;obj_t BgL_arg2408z00_933;
{ /* Object/struct.scm 168 */
obj_t BgL_arg2411z00_934;obj_t BgL_arg2412z00_935;
BgL_arg2411z00_934 = 
CNST_TABLE_REF(((long)25)); 
{ /* Object/struct.scm 168 */
obj_t BgL_arg2415z00_936;
{ /* Object/struct.scm 168 */
obj_t BgL_arg2418z00_937;
{ /* Object/struct.scm 168 */
obj_t BgL_arg2422z00_939;obj_t BgL_arg2423z00_940;
BgL_arg2422z00_939 = 
CNST_TABLE_REF(((long)26)); 
BgL_arg2423z00_940 = 
MAKE_PAIR(BgL_resz00_868, BNIL); 
BgL_arg2418z00_937 = 
MAKE_PAIR(BgL_arg2422z00_939, BgL_arg2423z00_940); } 
BgL_arg2415z00_936 = 
MAKE_PAIR(BgL_arg2418z00_937, BNIL); } 
BgL_arg2412z00_935 = 
MAKE_PAIR(BgL_auxz00_870, BgL_arg2415z00_936); } 
BgL_arg2407z00_932 = 
MAKE_PAIR(BgL_arg2411z00_934, BgL_arg2412z00_935); } 
{ /* Object/struct.scm 169 */
obj_t BgL_arg2427z00_941;obj_t BgL_arg2428z00_942;
{ /* Object/struct.scm 169 */
obj_t BgL_arg2431z00_943;obj_t BgL_arg2432z00_944;
BgL_arg2431z00_943 = 
CNST_TABLE_REF(((long)25)); 
{ /* Object/struct.scm 169 */
obj_t BgL_arg2435z00_945;
{ /* Object/struct.scm 169 */
obj_t BgL_arg2438z00_946;
{ /* Object/struct.scm 169 */
obj_t BgL_arg2442z00_948;obj_t BgL_arg2443z00_949;
BgL_arg2442z00_948 = 
CNST_TABLE_REF(((long)21)); 
BgL_arg2443z00_949 = 
MAKE_PAIR(BgL_cnamez00_15, BNIL); 
BgL_arg2438z00_946 = 
MAKE_PAIR(BgL_arg2442z00_948, BgL_arg2443z00_949); } 
BgL_arg2435z00_945 = 
MAKE_PAIR(BgL_arg2438z00_946, BNIL); } 
BgL_arg2432z00_944 = 
MAKE_PAIR(BgL_resz00_868, BgL_arg2435z00_945); } 
BgL_arg2427z00_941 = 
MAKE_PAIR(BgL_arg2431z00_943, BgL_arg2432z00_944); } 
BgL_arg2428z00_942 = 
MAKE_PAIR(BgL_resz00_868, BNIL); 
BgL_arg2408z00_933 = 
MAKE_PAIR(BgL_arg2427z00_941, BgL_arg2428z00_942); } 
BgL_arg2392z00_926 = 
MAKE_PAIR(BgL_arg2407z00_932, BgL_arg2408z00_933); } 
BgL_arg2359z00_910 = 
MAKE_PAIR(BgL_arg2391z00_925, BgL_arg2392z00_926); } 
BgL_arg2325z00_896 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2358z00_909, BgL_arg2359z00_910); } 
BgL_arg2321z00_894 = 
MAKE_PAIR(BgL_arg2324z00_895, BgL_arg2325z00_896); } 
BgL_arg2315z00_891 = 
MAKE_PAIR(BgL_arg2319z00_893, BgL_arg2321z00_894); } 
BgL_arg2300z00_885 = 
MAKE_PAIR(BgL_arg2315z00_891, BNIL); } 
BgL_arg2296z00_883 = 
MAKE_PAIR(BgL_arg2299z00_884, BgL_arg2300z00_885); } 
BgL_arg2291z00_880 = 
MAKE_PAIR(BgL_arg2295z00_882, BgL_arg2296z00_883); } 
BgL_arg2279z00_875 = 
MAKE_PAIR(BgL_arg2291z00_880, BNIL); } 
BgL_arg2275z00_873 = 
MAKE_PAIR(BgL_arg2278z00_874, BgL_arg2279z00_875); } 
BgL_arg2271z00_871 = 
MAKE_PAIR(BgL_arg2274z00_872, BgL_arg2275z00_873); } 
return 
BGl_epairifyz00zztools_miscz00(BgL_arg2271z00_871, BgL_srczd2defzd2_18);} } } } } } } } 
}



/* restore-slot */
obj_t BGl_restorezd2slotzd2zzobject_structz00(obj_t BgL_onamez00_19, obj_t BgL_snamez00_20, obj_t BgL_cnamez00_21, BgL_typez00_bglt BgL_typez00_22, long BgL_iz00_23, obj_t BgL_slotz00_24)
{ AN_OBJECT;
{ /* Object/struct.scm 177 */
{ /* Object/struct.scm 178 */
obj_t BgL_loopz00_952;
BgL_loopz00_952 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)2)), BEOA); 
{ /* Object/struct.scm 178 */
obj_t BgL_runnerz00_953;
BgL_runnerz00_953 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)27)), BEOA); 
{ /* Object/struct.scm 179 */
obj_t BgL_vz00_954;
BgL_vz00_954 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)28)), BEOA); 
{ /* Object/struct.scm 180 */
obj_t BgL_lenz00_955;
BgL_lenz00_955 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)3)), BEOA); 
{ /* Object/struct.scm 181 */
obj_t BgL_runnerzd2typedzd2_956;
{ /* Object/struct.scm 182 */
obj_t BgL_list2702z00_1065;
{ /* Object/struct.scm 182 */
obj_t BgL_arg2704z00_1066;
{ /* Object/struct.scm 182 */
obj_t BgL_auxz00_2116;
BgL_auxz00_2116 = 
CNST_TABLE_REF(((long)29)); 
BgL_arg2704z00_1066 = 
MAKE_PAIR(BgL_auxz00_2116, BNIL); } 
BgL_list2702z00_1065 = 
MAKE_PAIR(BgL_runnerz00_953, BgL_arg2704z00_1066); } 
BgL_runnerzd2typedzd2_956 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2702z00_1065); } 
{ /* Object/struct.scm 182 */

{ /* Object/struct.scm 184 */
bool_t BgL_test2457z00_957;
BgL_test2457z00_957 = 
BGl_slotzd2virtualzf3z21zzobject_slotsz00(
(BgL_slotz00_bglt)(BgL_slotz00_24)); 
if(BgL_test2457z00_957)
{ /* Object/struct.scm 184 */
return BUNSPEC;}  else 
{ /* Object/struct.scm 186 */
bool_t BgL_testz00_2124;
{ /* Object/struct.scm 186 */
BgL_slotz00_bglt BgL_obj1764z00_1436;
BgL_obj1764z00_1436 = 
(BgL_slotz00_bglt)(BgL_slotz00_24); 
{ /* Object/struct.scm 186 */
obj_t BgL_auxz00_2126;
BgL_auxz00_2126 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1764z00_1436))->BgL_indexedz00); 
BgL_testz00_2124 = 
CBOOL(BgL_auxz00_2126); } } 
if(BgL_testz00_2124)
{ /* Object/struct.scm 186 */
{ /* Object/struct.scm 195 */
bool_t BgL_test2459z00_959;
{ /* Object/struct.scm 195 */
bool_t BgL_test2461z00_960;
{ /* Object/struct.scm 195 */
obj_t BgL_objz00_1437;
BgL_objz00_1437 = BGl_za2heapzd2debugza2zd2zzengine_paramz00; 
BgL_test2461z00_960 = 
INTEGERP(BgL_objz00_1437); } 
if(BgL_test2461z00_960)
{ /* Object/struct.scm 196 */
long BgL_n1z00_1438;
BgL_n1z00_1438 = 
(long)CINT(BGl_za2heapzd2debugza2zd2zzengine_paramz00); 
BgL_test2459z00_959 = 
(BgL_n1z00_1438>=((long)1)); }  else 
{ /* Object/struct.scm 195 */
BgL_test2459z00_959 = ((bool_t)0); } } 
if(BgL_test2459z00_959)
{ /* Object/struct.scm 195 */
FAILURE(BGl_string3307z00zzobject_structz00,BGl_string3308z00zzobject_structz00,BgL_slotz00_24);}  else 
{ /* Object/struct.scm 195 */BFALSE; } } 
{ /* Object/struct.scm 202 */
obj_t BgL_fz00_961;
BgL_fz00_961 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)30)), BEOA); 
{ /* Object/struct.scm 202 */
obj_t BgL_tfz00_962;
{ /* Object/struct.scm 203 */
obj_t BgL_auxz00_2138;
{ /* Object/struct.scm 203 */
BgL_typez00_bglt BgL_obj1003z00_1444;
{ /* Object/struct.scm 203 */
obj_t BgL_auxz00_2139;
{ /* Object/struct.scm 203 */
BgL_slotz00_bglt BgL_obj1751z00_1443;
BgL_obj1751z00_1443 = 
(BgL_slotz00_bglt)(BgL_slotz00_24); 
BgL_auxz00_2139 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1751z00_1443))->BgL_typez00); } 
BgL_obj1003z00_1444 = 
(BgL_typez00_bglt)(BgL_auxz00_2139); } 
BgL_auxz00_2138 = 
(((BgL_typez00_bglt)CREF(BgL_obj1003z00_1444))->BgL_idz00); } 
BgL_tfz00_962 = 
BGl_makezd2typedzd2identz00zzast_identz00(BgL_fz00_961, BgL_auxz00_2138); } 
{ /* Object/struct.scm 203 */

{ /* Object/struct.scm 204 */
obj_t BgL_arg2465z00_963;obj_t BgL_arg2466z00_964;
BgL_arg2465z00_963 = 
CNST_TABLE_REF(((long)4)); 
{ /* Object/struct.scm 204 */
obj_t BgL_arg2469z00_965;obj_t BgL_arg2470z00_966;
{ /* Object/struct.scm 204 */
obj_t BgL_arg2473z00_967;
{ /* Object/struct.scm 204 */
obj_t BgL_arg2477z00_969;
{ /* Object/struct.scm 204 */
obj_t BgL_arg2480z00_970;
{ /* Object/struct.scm 204 */
obj_t BgL_arg2484z00_972;obj_t BgL_arg2485z00_973;
BgL_arg2484z00_972 = 
CNST_TABLE_REF(((long)31)); 
{ /* Object/struct.scm 204 */
obj_t BgL_arg2488z00_974;obj_t BgL_arg2489z00_975;
BgL_arg2488z00_974 = 
CNST_TABLE_REF(((long)32)); 
{ /* Object/struct.scm 204 */
obj_t BgL_auxz00_2148;
BgL_auxz00_2148 = 
BINT(BgL_iz00_23); 
BgL_arg2489z00_975 = 
MAKE_PAIR(BgL_auxz00_2148, BNIL); } 
BgL_arg2485z00_973 = 
MAKE_PAIR(BgL_arg2488z00_974, BgL_arg2489z00_975); } 
BgL_arg2480z00_970 = 
MAKE_PAIR(BgL_arg2484z00_972, BgL_arg2485z00_973); } 
BgL_arg2477z00_969 = 
MAKE_PAIR(BgL_arg2480z00_970, BNIL); } 
BgL_arg2473z00_967 = 
MAKE_PAIR(BgL_vz00_954, BgL_arg2477z00_969); } 
BgL_arg2469z00_965 = 
MAKE_PAIR(BgL_arg2473z00_967, BNIL); } 
{ /* Object/struct.scm 205 */
obj_t BgL_arg2493z00_976;
{ /* Object/struct.scm 205 */
obj_t BgL_arg2497z00_978;obj_t BgL_arg2498z00_979;
BgL_arg2497z00_978 = 
CNST_TABLE_REF(((long)4)); 
{ /* Object/struct.scm 205 */
obj_t BgL_arg2501z00_980;obj_t BgL_arg2502z00_981;
{ /* Object/struct.scm 205 */
obj_t BgL_arg2505z00_982;
{ /* Object/struct.scm 205 */
obj_t BgL_arg2509z00_984;obj_t BgL_arg2510z00_985;
{ /* Object/struct.scm 205 */
obj_t BgL_list2513z00_986;
{ /* Object/struct.scm 205 */
obj_t BgL_arg2515z00_987;
{ /* Object/struct.scm 205 */
obj_t BgL_auxz00_2157;
BgL_auxz00_2157 = 
CNST_TABLE_REF(((long)29)); 
BgL_arg2515z00_987 = 
MAKE_PAIR(BgL_auxz00_2157, BNIL); } 
BgL_list2513z00_986 = 
MAKE_PAIR(BgL_lenz00_955, BgL_arg2515z00_987); } 
BgL_arg2509z00_984 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2513z00_986); } 
{ /* Object/struct.scm 205 */
obj_t BgL_arg2519z00_988;
{ /* Object/struct.scm 205 */
obj_t BgL_arg2523z00_990;obj_t BgL_arg2524z00_991;
BgL_arg2523z00_990 = 
CNST_TABLE_REF(((long)33)); 
BgL_arg2524z00_991 = 
MAKE_PAIR(BgL_vz00_954, BNIL); 
BgL_arg2519z00_988 = 
MAKE_PAIR(BgL_arg2523z00_990, BgL_arg2524z00_991); } 
BgL_arg2510z00_985 = 
MAKE_PAIR(BgL_arg2519z00_988, BNIL); } 
BgL_arg2505z00_982 = 
MAKE_PAIR(BgL_arg2509z00_984, BgL_arg2510z00_985); } 
BgL_arg2501z00_980 = 
MAKE_PAIR(BgL_arg2505z00_982, BNIL); } 
{ /* Object/struct.scm 206 */
obj_t BgL_arg2528z00_992;obj_t BgL_arg2529z00_993;
BgL_arg2528z00_992 = 
BGl_makezd2pragmazd2indexedzd2initzd2setz12z12zzobject_toolsz00(BgL_typez00_22, 
(BgL_slotz00_bglt)(BgL_slotz00_24), 
CNST_TABLE_REF(((long)34)), BgL_lenz00_955); 
{ /* Object/struct.scm 208 */
obj_t BgL_arg2533z00_994;
{ /* Object/struct.scm 208 */
obj_t BgL_arg2537z00_996;obj_t BgL_arg2538z00_997;
BgL_arg2537z00_996 = 
CNST_TABLE_REF(((long)8)); 
{ /* Object/struct.scm 208 */
obj_t BgL_arg2541z00_998;obj_t BgL_arg2542z00_999;
{ /* Object/struct.scm 208 */
obj_t BgL_arg2546z00_1000;
{ /* Object/struct.scm 208 */
obj_t BgL_arg2550z00_1002;
{ /* Object/struct.scm 208 */
obj_t BgL_arg2553z00_1003;obj_t BgL_arg2554z00_1004;
BgL_arg2553z00_1003 = 
MAKE_PAIR(BgL_runnerzd2typedzd2_956, BNIL); 
{ /* Object/struct.scm 209 */
obj_t BgL_arg2558z00_1005;
{ /* Object/struct.scm 209 */
obj_t BgL_arg2562z00_1007;obj_t BgL_arg2563z00_1008;
BgL_arg2562z00_1007 = 
CNST_TABLE_REF(((long)9)); 
{ /* Object/struct.scm 209 */
obj_t BgL_arg2566z00_1009;obj_t BgL_arg2567z00_1010;
{ /* Object/struct.scm 209 */
obj_t BgL_arg2570z00_1011;obj_t BgL_arg2571z00_1012;
BgL_arg2570z00_1011 = 
CNST_TABLE_REF(((long)10)); 
{ /* Object/struct.scm 209 */
obj_t BgL_arg2574z00_1013;
BgL_arg2574z00_1013 = 
MAKE_PAIR(BgL_lenz00_955, BNIL); 
BgL_arg2571z00_1012 = 
MAKE_PAIR(BgL_runnerz00_953, BgL_arg2574z00_1013); } 
BgL_arg2566z00_1009 = 
MAKE_PAIR(BgL_arg2570z00_1011, BgL_arg2571z00_1012); } 
{ /* Object/struct.scm 210 */
obj_t BgL_arg2578z00_1014;obj_t BgL_arg2579z00_1015;
{ /* Object/struct.scm 210 */
obj_t BgL_arg2582z00_1016;obj_t BgL_arg2583z00_1017;
BgL_arg2582z00_1016 = 
CNST_TABLE_REF(((long)21)); 
{ /* Object/struct.scm 210 */
obj_t BgL_auxz00_2179;
BgL_auxz00_2179 = 
CNST_TABLE_REF(((long)35)); 
BgL_arg2583z00_1017 = 
MAKE_PAIR(BgL_auxz00_2179, BNIL); } 
BgL_arg2578z00_1014 = 
MAKE_PAIR(BgL_arg2582z00_1016, BgL_arg2583z00_1017); } 
{ /* Object/struct.scm 211 */
obj_t BgL_arg2587z00_1018;
{ /* Object/struct.scm 211 */
obj_t BgL_arg2591z00_1020;obj_t BgL_arg2592z00_1021;
BgL_arg2591z00_1020 = 
CNST_TABLE_REF(((long)4)); 
{ /* Object/struct.scm 211 */
obj_t BgL_arg2595z00_1022;obj_t BgL_arg2596z00_1023;
{ /* Object/struct.scm 211 */
obj_t BgL_arg2599z00_1024;
{ /* Object/struct.scm 211 */
obj_t BgL_arg2603z00_1026;
{ /* Object/struct.scm 211 */
obj_t BgL_arg2606z00_1027;
{ /* Object/struct.scm 211 */
obj_t BgL_arg2611z00_1029;obj_t BgL_arg2612z00_1030;
BgL_arg2611z00_1029 = 
CNST_TABLE_REF(((long)36)); 
{ /* Object/struct.scm 211 */
obj_t BgL_arg2615z00_1031;
BgL_arg2615z00_1031 = 
MAKE_PAIR(BgL_runnerz00_953, BNIL); 
BgL_arg2612z00_1030 = 
MAKE_PAIR(BgL_vz00_954, BgL_arg2615z00_1031); } 
BgL_arg2606z00_1027 = 
MAKE_PAIR(BgL_arg2611z00_1029, BgL_arg2612z00_1030); } 
BgL_arg2603z00_1026 = 
MAKE_PAIR(BgL_arg2606z00_1027, BNIL); } 
BgL_arg2599z00_1024 = 
MAKE_PAIR(BgL_tfz00_962, BgL_arg2603z00_1026); } 
BgL_arg2595z00_1022 = 
MAKE_PAIR(BgL_arg2599z00_1024, BNIL); } 
{ /* Object/struct.scm 212 */
obj_t BgL_arg2619z00_1032;obj_t BgL_arg2620z00_1033;
BgL_arg2619z00_1032 = 
BGl_makezd2pragmazd2indexedzd2setz12zc0zzobject_toolsz00(BgL_typez00_22, 
(BgL_slotz00_bglt)(BgL_slotz00_24), 
CNST_TABLE_REF(((long)34)), BgL_fz00_961, BgL_runnerz00_953); 
{ /* Object/struct.scm 218 */
obj_t BgL_arg2624z00_1034;
{ /* Object/struct.scm 218 */
obj_t BgL_arg2628z00_1036;
{ /* Object/struct.scm 218 */
obj_t BgL_arg2631z00_1037;
{ /* Object/struct.scm 218 */
obj_t BgL_arg2635z00_1039;obj_t BgL_arg2636z00_1040;
BgL_arg2635z00_1039 = 
CNST_TABLE_REF(((long)15)); 
{ /* Object/struct.scm 218 */
obj_t BgL_arg2639z00_1041;
{ /* Object/struct.scm 218 */
obj_t BgL_auxz00_2195;
BgL_auxz00_2195 = 
BINT(((long)1)); 
BgL_arg2639z00_1041 = 
MAKE_PAIR(BgL_auxz00_2195, BNIL); } 
BgL_arg2636z00_1040 = 
MAKE_PAIR(BgL_runnerz00_953, BgL_arg2639z00_1041); } 
BgL_arg2631z00_1037 = 
MAKE_PAIR(BgL_arg2635z00_1039, BgL_arg2636z00_1040); } 
BgL_arg2628z00_1036 = 
MAKE_PAIR(BgL_arg2631z00_1037, BNIL); } 
BgL_arg2624z00_1034 = 
MAKE_PAIR(BgL_loopz00_952, BgL_arg2628z00_1036); } 
BgL_arg2620z00_1033 = 
MAKE_PAIR(BgL_arg2624z00_1034, BNIL); } 
BgL_arg2596z00_1023 = 
MAKE_PAIR(BgL_arg2619z00_1032, BgL_arg2620z00_1033); } 
BgL_arg2592z00_1021 = 
MAKE_PAIR(BgL_arg2595z00_1022, BgL_arg2596z00_1023); } 
BgL_arg2587z00_1018 = 
MAKE_PAIR(BgL_arg2591z00_1020, BgL_arg2592z00_1021); } 
BgL_arg2579z00_1015 = 
MAKE_PAIR(BgL_arg2587z00_1018, BNIL); } 
BgL_arg2567z00_1010 = 
MAKE_PAIR(BgL_arg2578z00_1014, BgL_arg2579z00_1015); } 
BgL_arg2563z00_1008 = 
MAKE_PAIR(BgL_arg2566z00_1009, BgL_arg2567z00_1010); } 
BgL_arg2558z00_1005 = 
MAKE_PAIR(BgL_arg2562z00_1007, BgL_arg2563z00_1008); } 
BgL_arg2554z00_1004 = 
MAKE_PAIR(BgL_arg2558z00_1005, BNIL); } 
BgL_arg2550z00_1002 = 
MAKE_PAIR(BgL_arg2553z00_1003, BgL_arg2554z00_1004); } 
BgL_arg2546z00_1000 = 
MAKE_PAIR(BgL_loopz00_952, BgL_arg2550z00_1002); } 
BgL_arg2541z00_998 = 
MAKE_PAIR(BgL_arg2546z00_1000, BNIL); } 
{ /* Object/struct.scm 219 */
obj_t BgL_arg2643z00_1042;
{ /* Object/struct.scm 219 */
obj_t BgL_arg2647z00_1044;
{ /* Object/struct.scm 219 */
obj_t BgL_auxz00_2214;
BgL_auxz00_2214 = 
BINT(((long)0)); 
BgL_arg2647z00_1044 = 
MAKE_PAIR(BgL_auxz00_2214, BNIL); } 
BgL_arg2643z00_1042 = 
MAKE_PAIR(BgL_loopz00_952, BgL_arg2647z00_1044); } 
BgL_arg2542z00_999 = 
MAKE_PAIR(BgL_arg2643z00_1042, BNIL); } 
BgL_arg2538z00_997 = 
MAKE_PAIR(BgL_arg2541z00_998, BgL_arg2542z00_999); } 
BgL_arg2533z00_994 = 
MAKE_PAIR(BgL_arg2537z00_996, BgL_arg2538z00_997); } 
BgL_arg2529z00_993 = 
MAKE_PAIR(BgL_arg2533z00_994, BNIL); } 
BgL_arg2502z00_981 = 
MAKE_PAIR(BgL_arg2528z00_992, BgL_arg2529z00_993); } 
BgL_arg2498z00_979 = 
MAKE_PAIR(BgL_arg2501z00_980, BgL_arg2502z00_981); } 
BgL_arg2493z00_976 = 
MAKE_PAIR(BgL_arg2497z00_978, BgL_arg2498z00_979); } 
BgL_arg2470z00_966 = 
MAKE_PAIR(BgL_arg2493z00_976, BNIL); } 
BgL_arg2466z00_964 = 
MAKE_PAIR(BgL_arg2469z00_965, BgL_arg2470z00_966); } 
return 
MAKE_PAIR(BgL_arg2465z00_963, BgL_arg2466z00_964);} } } } }  else 
{ /* Object/struct.scm 186 */
{ /* Object/struct.scm 221 */
obj_t BgL_arg2659z00_1047;obj_t BgL_arg2660z00_1048;
BgL_arg2659z00_1047 = 
CNST_TABLE_REF(((long)4)); 
{ /* Object/struct.scm 221 */
obj_t BgL_arg2663z00_1049;obj_t BgL_arg2664z00_1050;
{ /* Object/struct.scm 221 */
obj_t BgL_arg2667z00_1051;
{ /* Object/struct.scm 221 */
obj_t BgL_arg2671z00_1053;obj_t BgL_arg2672z00_1054;
{ /* Object/struct.scm 221 */
obj_t BgL_auxz00_2229;
{ /* Object/struct.scm 221 */
BgL_typez00_bglt BgL_obj1003z00_1446;
{ /* Object/struct.scm 221 */
obj_t BgL_auxz00_2230;
{ /* Object/struct.scm 221 */
BgL_slotz00_bglt BgL_obj1751z00_1445;
BgL_obj1751z00_1445 = 
(BgL_slotz00_bglt)(BgL_slotz00_24); 
BgL_auxz00_2230 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1751z00_1445))->BgL_typez00); } 
BgL_obj1003z00_1446 = 
(BgL_typez00_bglt)(BgL_auxz00_2230); } 
BgL_auxz00_2229 = 
(((BgL_typez00_bglt)CREF(BgL_obj1003z00_1446))->BgL_idz00); } 
BgL_arg2671z00_1053 = 
BGl_makezd2typedzd2identz00zzast_identz00(BgL_vz00_954, BgL_auxz00_2229); } 
{ /* Object/struct.scm 222 */
obj_t BgL_arg2682z00_1057;
{ /* Object/struct.scm 222 */
obj_t BgL_arg2686z00_1059;obj_t BgL_arg2687z00_1060;
BgL_arg2686z00_1059 = 
CNST_TABLE_REF(((long)31)); 
{ /* Object/struct.scm 222 */
obj_t BgL_arg2690z00_1061;obj_t BgL_arg2691z00_1062;
BgL_arg2690z00_1061 = 
CNST_TABLE_REF(((long)32)); 
{ /* Object/struct.scm 222 */
obj_t BgL_auxz00_2238;
BgL_auxz00_2238 = 
BINT(BgL_iz00_23); 
BgL_arg2691z00_1062 = 
MAKE_PAIR(BgL_auxz00_2238, BNIL); } 
BgL_arg2687z00_1060 = 
MAKE_PAIR(BgL_arg2690z00_1061, BgL_arg2691z00_1062); } 
BgL_arg2682z00_1057 = 
MAKE_PAIR(BgL_arg2686z00_1059, BgL_arg2687z00_1060); } 
BgL_arg2672z00_1054 = 
MAKE_PAIR(BgL_arg2682z00_1057, BNIL); } 
BgL_arg2667z00_1051 = 
MAKE_PAIR(BgL_arg2671z00_1053, BgL_arg2672z00_1054); } 
BgL_arg2663z00_1049 = 
MAKE_PAIR(BgL_arg2667z00_1051, BNIL); } 
{ /* Object/struct.scm 223 */
obj_t BgL_arg2695z00_1063;
BgL_arg2695z00_1063 = 
BGl_makezd2pragmazd2directzd2setz12zc0zzobject_toolsz00(BgL_typez00_22, 
(BgL_slotz00_bglt)(BgL_slotz00_24), 
CNST_TABLE_REF(((long)34)), BgL_vz00_954); 
BgL_arg2664z00_1050 = 
MAKE_PAIR(BgL_arg2695z00_1063, BNIL); } 
BgL_arg2660z00_1048 = 
MAKE_PAIR(BgL_arg2663z00_1049, BgL_arg2664z00_1050); } 
return 
MAKE_PAIR(BgL_arg2659z00_1047, BgL_arg2660z00_1048);} } } } } } } } } } } 
}



/* gen-struct->plain-class */
obj_t BGl_genzd2structzd2ze3plainzd2classz31zzobject_structz00(obj_t BgL_cnamez00_25, BgL_typez00_bglt BgL_typez00_26, obj_t BgL_slotsz00_27, obj_t BgL_srczd2defzd2_28)
{ AN_OBJECT;
{ /* Object/struct.scm 234 */
{ /* Object/struct.scm 236 */
obj_t BgL_arg2712z00_1067;
{ /* Object/struct.scm 236 */
obj_t BgL_arg2715z00_1068;obj_t BgL_arg2716z00_1069;
BgL_arg2715z00_1068 = 
CNST_TABLE_REF(((long)18)); 
{ /* Object/struct.scm 236 */
obj_t BgL_arg2719z00_1070;obj_t BgL_arg2720z00_1071;
{ /* Object/struct.scm 236 */
obj_t BgL_arg2723z00_1072;obj_t BgL_arg2724z00_1073;
BgL_arg2723z00_1072 = 
CNST_TABLE_REF(((long)37)); 
{ /* Object/struct.scm 236 */
obj_t BgL_arg2727z00_1074;obj_t BgL_arg2728z00_1075;
BgL_arg2727z00_1074 = 
BGl_makezd2typedzd2identz00zzast_identz00(
CNST_TABLE_REF(((long)34)), BgL_cnamez00_25); 
{ /* Object/struct.scm 236 */
obj_t BgL_auxz00_2256;
BgL_auxz00_2256 = 
CNST_TABLE_REF(((long)38)); 
BgL_arg2728z00_1075 = 
MAKE_PAIR(BgL_auxz00_2256, BNIL); } 
BgL_arg2724z00_1073 = 
MAKE_PAIR(BgL_arg2727z00_1074, BgL_arg2728z00_1075); } 
BgL_arg2719z00_1070 = 
MAKE_PAIR(BgL_arg2723z00_1072, BgL_arg2724z00_1073); } 
{ /* Object/struct.scm 238 */
obj_t BgL_arg2733z00_1076;
{ /* Object/struct.scm 238 */
obj_t BgL_arg2737z00_1078;obj_t BgL_arg2738z00_1079;
BgL_arg2737z00_1078 = 
CNST_TABLE_REF(((long)12)); 
{ /* Object/struct.scm 239 */
obj_t BgL_arg2741z00_1080;obj_t BgL_arg2742z00_1081;
{ /* Object/struct.scm 239 */
obj_t BgL_arg2745z00_1082;obj_t BgL_arg2746z00_1083;
BgL_arg2745z00_1082 = 
CNST_TABLE_REF(((long)39)); 
{ /* Object/struct.scm 239 */
obj_t BgL_arg2749z00_1084;obj_t BgL_arg2750z00_1085;
BgL_arg2749z00_1084 = 
CNST_TABLE_REF(((long)34)); 
{ /* Object/struct.scm 239 */
obj_t BgL_arg2753z00_1086;
{ /* Object/struct.scm 239 */
obj_t BgL_arg2757z00_1088;obj_t BgL_arg2758z00_1089;
BgL_arg2757z00_1088 = 
CNST_TABLE_REF(((long)31)); 
{ /* Object/struct.scm 239 */
obj_t BgL_arg2761z00_1090;obj_t BgL_arg2762z00_1091;
BgL_arg2761z00_1090 = 
CNST_TABLE_REF(((long)32)); 
{ /* Object/struct.scm 239 */
obj_t BgL_auxz00_2266;
BgL_auxz00_2266 = 
BINT(((long)0)); 
BgL_arg2762z00_1091 = 
MAKE_PAIR(BgL_auxz00_2266, BNIL); } 
BgL_arg2758z00_1089 = 
MAKE_PAIR(BgL_arg2761z00_1090, BgL_arg2762z00_1091); } 
BgL_arg2753z00_1086 = 
MAKE_PAIR(BgL_arg2757z00_1088, BgL_arg2758z00_1089); } 
BgL_arg2750z00_1085 = 
MAKE_PAIR(BgL_arg2753z00_1086, BNIL); } 
BgL_arg2746z00_1083 = 
MAKE_PAIR(BgL_arg2749z00_1084, BgL_arg2750z00_1085); } 
BgL_arg2741z00_1080 = 
MAKE_PAIR(BgL_arg2745z00_1082, BgL_arg2746z00_1083); } 
{ /* Object/struct.scm 240 */
obj_t BgL_arg2766z00_1092;obj_t BgL_arg2767z00_1093;
{ 
long BgL_iz00_1094;obj_t BgL_slotsz00_1095;obj_t BgL_resz00_1096;
BgL_iz00_1094 = ((long)1); 
BgL_slotsz00_1095 = BgL_slotsz00_27; 
BgL_resz00_1096 = BNIL; 
BgL_loopz00_1097:
if(
NULLP(BgL_slotsz00_1095))
{ /* Object/struct.scm 244 */
BgL_arg2766z00_1092 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_resz00_1096); }  else 
{ /* Object/struct.scm 246 */
bool_t BgL_test2772z00_1099;
{ /* Object/struct.scm 246 */
BgL_slotz00_bglt BgL_auxz00_2277;
{ /* Object/struct.scm 246 */
obj_t BgL_auxz00_2278;
BgL_auxz00_2278 = 
CAR(BgL_slotsz00_1095); 
BgL_auxz00_2277 = 
(BgL_slotz00_bglt)(BgL_auxz00_2278); } 
BgL_test2772z00_1099 = 
BGl_slotzd2virtualzf3z21zzobject_slotsz00(BgL_auxz00_2277); } 
if(BgL_test2772z00_1099)
{ /* Object/struct.scm 246 */
{ 
obj_t BgL_slotsz00_2285;long BgL_iz00_2283;
BgL_iz00_2283 = 
(BgL_iz00_1094+((long)1)); 
BgL_slotsz00_2285 = 
CDR(BgL_slotsz00_1095); 
BgL_slotsz00_1095 = BgL_slotsz00_2285; 
BgL_iz00_1094 = BgL_iz00_2283; 
goto BgL_loopz00_1097;} }  else 
{ /* Object/struct.scm 246 */
{ /* Object/struct.scm 251 */
obj_t BgL_newz00_1102;
BgL_newz00_1102 = 
BGl_restorezd2slotzd2zzobject_structz00(
CNST_TABLE_REF(((long)34)), 
CNST_TABLE_REF(((long)32)), BgL_cnamez00_25, BgL_typez00_26, BgL_iz00_1094, 
CAR(BgL_slotsz00_1095)); 
{ /* Object/struct.scm 252 */
long BgL_arg2780z00_1103;obj_t BgL_arg2781z00_1104;obj_t BgL_arg2782z00_1105;
BgL_arg2780z00_1103 = 
(BgL_iz00_1094+((long)1)); 
BgL_arg2781z00_1104 = 
CDR(BgL_slotsz00_1095); 
BgL_arg2782z00_1105 = 
MAKE_PAIR(BgL_newz00_1102, BgL_resz00_1096); 
{ 
obj_t BgL_resz00_2296;obj_t BgL_slotsz00_2295;long BgL_iz00_2294;
BgL_iz00_2294 = BgL_arg2780z00_1103; 
BgL_slotsz00_2295 = BgL_arg2781z00_1104; 
BgL_resz00_2296 = BgL_arg2782z00_1105; 
BgL_resz00_1096 = BgL_resz00_2296; 
BgL_slotsz00_1095 = BgL_slotsz00_2295; 
BgL_iz00_1094 = BgL_iz00_2294; 
goto BgL_loopz00_1097;} } } } } } 
{ /* Object/struct.scm 238 */
obj_t BgL_auxz00_2297;
BgL_auxz00_2297 = 
CNST_TABLE_REF(((long)34)); 
BgL_arg2767z00_1093 = 
MAKE_PAIR(BgL_auxz00_2297, BNIL); } 
BgL_arg2742z00_1081 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2766z00_1092, BgL_arg2767z00_1093); } 
BgL_arg2738z00_1079 = 
MAKE_PAIR(BgL_arg2741z00_1080, BgL_arg2742z00_1081); } 
BgL_arg2733z00_1076 = 
MAKE_PAIR(BgL_arg2737z00_1078, BgL_arg2738z00_1079); } 
BgL_arg2720z00_1071 = 
MAKE_PAIR(BgL_arg2733z00_1076, BNIL); } 
BgL_arg2716z00_1069 = 
MAKE_PAIR(BgL_arg2719z00_1070, BgL_arg2720z00_1071); } 
BgL_arg2712z00_1067 = 
MAKE_PAIR(BgL_arg2715z00_1068, BgL_arg2716z00_1069); } 
return 
BGl_epairifyz00zztools_miscz00(BgL_arg2712z00_1067, BgL_srczd2defzd2_28);} } 
}



/* gen-struct->wide-class */
obj_t BGl_genzd2structzd2ze3widezd2classz31zzobject_structz00(obj_t BgL_cnamez00_29, BgL_typez00_bglt BgL_typez00_30, obj_t BgL_slotsz00_31, obj_t BgL_srczd2defzd2_32)
{ AN_OBJECT;
{ /* Object/struct.scm 261 */
{ /* Object/struct.scm 262 */
obj_t BgL_oldz00_1110;
BgL_oldz00_1110 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)40)), BEOA); 
{ /* Object/struct.scm 262 */
long BgL_lenz00_1111;
BgL_lenz00_1111 = 
BGl_slotszd2lengthzd2zzobject_structz00(BgL_slotsz00_31); 
{ /* Object/struct.scm 263 */
obj_t BgL_auxz00_1112;
BgL_auxz00_1112 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)23)), BEOA); 
{ /* Object/struct.scm 264 */
obj_t BgL_tauxz00_1113;
{ /* Object/struct.scm 265 */
obj_t BgL_list3045z00_1229;
{ /* Object/struct.scm 265 */
obj_t BgL_arg3047z00_1230;
{ /* Object/struct.scm 265 */
obj_t BgL_auxz00_2314;
BgL_auxz00_2314 = 
CNST_TABLE_REF(((long)22)); 
BgL_arg3047z00_1230 = 
MAKE_PAIR(BgL_auxz00_2314, BNIL); } 
BgL_list3045z00_1229 = 
MAKE_PAIR(BgL_auxz00_1112, BgL_arg3047z00_1230); } 
BgL_tauxz00_1113 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list3045z00_1229); } 
{ /* Object/struct.scm 265 */
obj_t BgL_newz00_1114;
BgL_newz00_1114 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)41)), BEOA); 
{ /* Object/struct.scm 266 */
obj_t BgL_tidz00_1115;
BgL_tidz00_1115 = 
(((BgL_typez00_bglt)CREF(BgL_typez00_30))->BgL_idz00); 
{ /* Object/struct.scm 267 */
BgL_globalz00_bglt BgL_holderz00_1116;
{ /* Object/struct.scm 268 */
BgL_tclassz00_bglt BgL_obj1614z00_1457;
BgL_obj1614z00_1457 = 
(BgL_tclassz00_bglt)(BgL_typez00_30); 
{ 
obj_t BgL_auxz00_2324;
{ /* Object/struct.scm 268 */
BgL_objectz00_bglt BgL_auxz00_2325;
BgL_auxz00_2325 = 
(BgL_objectz00_bglt)(BgL_obj1614z00_1457); 
BgL_auxz00_2324 = 
BGL_OBJECT_WIDENING(BgL_auxz00_2325); } 
BgL_holderz00_1116 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_2324))->BgL_holderz00); } } 
{ /* Object/struct.scm 268 */
obj_t BgL_wideningz00_1117;
{ /* Object/struct.scm 269 */
obj_t BgL_arg3029z00_1224;obj_t BgL_arg3030z00_1225;
{ /* Object/struct.scm 269 */
BgL_tclassz00_bglt BgL_obj1615z00_1458;
BgL_obj1615z00_1458 = 
(BgL_tclassz00_bglt)(BgL_typez00_30); 
{ 
obj_t BgL_auxz00_2330;
{ /* Object/struct.scm 269 */
BgL_objectz00_bglt BgL_auxz00_2331;
BgL_auxz00_2331 = 
(BgL_objectz00_bglt)(BgL_obj1615z00_1458); 
BgL_auxz00_2330 = 
BGL_OBJECT_WIDENING(BgL_auxz00_2331); } 
BgL_arg3029z00_1224 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_2330))->BgL_wideningz00); } } 
BgL_arg3030z00_1225 = 
CNST_TABLE_REF(((long)5)); 
{ /* Object/struct.scm 269 */
obj_t BgL_list3032z00_1226;
{ /* Object/struct.scm 269 */
obj_t BgL_arg3034z00_1227;
{ /* Object/struct.scm 269 */
obj_t BgL_arg3037z00_1228;
BgL_arg3037z00_1228 = 
MAKE_PAIR(BgL_tidz00_1115, BNIL); 
BgL_arg3034z00_1227 = 
MAKE_PAIR(BgL_arg3030z00_1225, BgL_arg3037z00_1228); } 
BgL_list3032z00_1226 = 
MAKE_PAIR(BgL_arg3029z00_1224, BgL_arg3034z00_1227); } 
BgL_wideningz00_1117 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list3032z00_1226); } } 
{ /* Object/struct.scm 269 */

{ 
BgL_typez00_bglt BgL_typez00_1207;obj_t BgL_exprz00_1208;
{ /* Object/struct.scm 277 */
obj_t BgL_arg2800z00_1119;
{ /* Object/struct.scm 277 */
obj_t BgL_arg2803z00_1120;obj_t BgL_arg2804z00_1121;
BgL_arg2803z00_1120 = 
CNST_TABLE_REF(((long)18)); 
{ /* Object/struct.scm 277 */
obj_t BgL_arg2807z00_1122;obj_t BgL_arg2808z00_1123;
{ /* Object/struct.scm 277 */
obj_t BgL_arg2811z00_1124;obj_t BgL_arg2812z00_1125;
BgL_arg2811z00_1124 = 
CNST_TABLE_REF(((long)37)); 
{ /* Object/struct.scm 278 */
obj_t BgL_arg2815z00_1126;obj_t BgL_arg2816z00_1127;
BgL_arg2815z00_1126 = 
BGl_makezd2typedzd2identz00zzast_identz00(
CNST_TABLE_REF(((long)34)), BgL_cnamez00_29); 
{ /* Object/struct.scm 277 */
obj_t BgL_auxz00_2344;
BgL_auxz00_2344 = 
CNST_TABLE_REF(((long)38)); 
BgL_arg2816z00_1127 = 
MAKE_PAIR(BgL_auxz00_2344, BNIL); } 
BgL_arg2812z00_1125 = 
MAKE_PAIR(BgL_arg2815z00_1126, BgL_arg2816z00_1127); } 
BgL_arg2807z00_1122 = 
MAKE_PAIR(BgL_arg2811z00_1124, BgL_arg2812z00_1125); } 
{ /* Object/struct.scm 280 */
obj_t BgL_arg2821z00_1128;
{ /* Object/struct.scm 280 */
obj_t BgL_arg2825z00_1130;obj_t BgL_arg2826z00_1131;
BgL_arg2825z00_1130 = 
CNST_TABLE_REF(((long)4)); 
{ /* Object/struct.scm 280 */
obj_t BgL_arg2829z00_1132;obj_t BgL_arg2830z00_1133;
{ /* Object/struct.scm 280 */
obj_t BgL_arg2833z00_1134;obj_t BgL_arg2834z00_1135;
{ /* Object/struct.scm 280 */
obj_t BgL_arg2837z00_1136;
{ /* Object/struct.scm 280 */
obj_t BgL_arg2841z00_1137;
{ /* Object/struct.scm 280 */
obj_t BgL_auxz00_2350;
BgL_auxz00_2350 = 
CNST_TABLE_REF(((long)24)); 
BgL_arg2841z00_1137 = 
MAKE_PAIR(BgL_auxz00_2350, BNIL); } 
BgL_arg2837z00_1136 = 
MAKE_PAIR(BgL_arg2841z00_1137, BNIL); } 
BgL_arg2833z00_1134 = 
MAKE_PAIR(BgL_oldz00_1110, BgL_arg2837z00_1136); } 
{ /* Object/struct.scm 281 */
obj_t BgL_arg2846z00_1139;
{ /* Object/struct.scm 281 */
obj_t BgL_arg2851z00_1141;
{ /* Object/struct.scm 281 */
obj_t BgL_arg2854z00_1142;
{ /* Object/struct.scm 281 */
obj_t BgL_arg2858z00_1144;obj_t BgL_arg2859z00_1145;
BgL_arg2858z00_1144 = 
CNST_TABLE_REF(((long)31)); 
{ /* Object/struct.scm 281 */
obj_t BgL_arg2862z00_1146;obj_t BgL_arg2863z00_1147;
BgL_arg2862z00_1146 = 
CNST_TABLE_REF(((long)32)); 
{ /* Object/struct.scm 281 */
obj_t BgL_auxz00_2357;
BgL_auxz00_2357 = 
BINT(((long)0)); 
BgL_arg2863z00_1147 = 
MAKE_PAIR(BgL_auxz00_2357, BNIL); } 
BgL_arg2859z00_1145 = 
MAKE_PAIR(BgL_arg2862z00_1146, BgL_arg2863z00_1147); } 
BgL_arg2854z00_1142 = 
MAKE_PAIR(BgL_arg2858z00_1144, BgL_arg2859z00_1145); } 
BgL_arg2851z00_1141 = 
MAKE_PAIR(BgL_arg2854z00_1142, BNIL); } 
BgL_arg2846z00_1139 = 
MAKE_PAIR(BgL_tauxz00_1113, BgL_arg2851z00_1141); } 
BgL_arg2834z00_1135 = 
MAKE_PAIR(BgL_arg2846z00_1139, BNIL); } 
BgL_arg2829z00_1132 = 
MAKE_PAIR(BgL_arg2833z00_1134, BgL_arg2834z00_1135); } 
{ /* Object/struct.scm 282 */
obj_t BgL_arg2867z00_1148;
{ /* Object/struct.scm 282 */
obj_t BgL_arg2871z00_1150;obj_t BgL_arg2872z00_1151;
BgL_arg2871z00_1150 = 
CNST_TABLE_REF(((long)4)); 
{ /* Object/struct.scm 282 */
obj_t BgL_arg2875z00_1152;obj_t BgL_arg2876z00_1153;
{ /* Object/struct.scm 282 */
obj_t BgL_arg2879z00_1154;
{ /* Object/struct.scm 282 */
obj_t BgL_arg2883z00_1156;obj_t BgL_arg2884z00_1157;
BgL_arg2883z00_1156 = 
BGl_makezd2typedzd2identz00zzast_identz00(BgL_newz00_1114, BgL_tidz00_1115); 
{ /* Object/struct.scm 283 */
obj_t BgL_arg2888z00_1158;
BgL_typez00_1207 = BgL_typez00_30; 
BgL_exprz00_1208 = BgL_oldz00_1110; 
{ /* Object/struct.scm 271 */
bool_t BgL_test2998z00_1210;
{ /* Object/struct.scm 271 */
obj_t BgL_auxz00_2368;
BgL_auxz00_2368 = 
CNST_TABLE_REF(((long)42)); 
BgL_test2998z00_1210 = 
(BGl_za2targetzd2languageza2zd2zzengine_paramz00==BgL_auxz00_2368); } 
if(BgL_test2998z00_1210)
{ /* Object/struct.scm 272 */
obj_t BgL_arg3000z00_1211;obj_t BgL_arg3001z00_1212;
BgL_arg3000z00_1211 = 
CNST_TABLE_REF(((long)43)); 
BgL_arg3001z00_1212 = 
(((BgL_typez00_bglt)CREF(BgL_typez00_1207))->BgL_idz00); 
{ /* Object/struct.scm 272 */
obj_t BgL_list3003z00_1213;
BgL_list3003z00_1213 = 
MAKE_PAIR(BgL_exprz00_1208, BNIL); 
BgL_arg2888z00_1158 = 
BGl_makezd2privatezd2sexpz00zzast_privatez00(BgL_arg3000z00_1211, BgL_arg3001z00_1212, BgL_list3003z00_1213); } }  else 
{ /* Object/struct.scm 273 */
obj_t BgL_arg3007z00_1214;obj_t BgL_arg3008z00_1215;
BgL_arg3007z00_1214 = 
BGl_makezd2typedzd2identz00zzast_identz00(
CNST_TABLE_REF(((long)44)), 
(((BgL_typez00_bglt)CREF(BgL_typez00_1207))->BgL_idz00)); 
{ /* Object/struct.scm 274 */
obj_t BgL_arg3016z00_1218;obj_t BgL_arg3017z00_1219;
{ /* Object/struct.scm 274 */
obj_t BgL_auxz00_2379;
BgL_auxz00_2379 = 
(((BgL_typez00_bglt)CREF(BgL_typez00_1207))->BgL_namez00); 
BgL_arg3016z00_1218 = 
string_append_3(BGl_string3309z00zzobject_structz00, BgL_auxz00_2379, BGl_string3310z00zzobject_structz00); } 
BgL_arg3017z00_1219 = 
MAKE_PAIR(BgL_exprz00_1208, BNIL); 
BgL_arg3008z00_1215 = 
MAKE_PAIR(BgL_arg3016z00_1218, BgL_arg3017z00_1219); } 
BgL_arg2888z00_1158 = 
MAKE_PAIR(BgL_arg3007z00_1214, BgL_arg3008z00_1215); } } 
BgL_arg2884z00_1157 = 
MAKE_PAIR(BgL_arg2888z00_1158, BNIL); } 
BgL_arg2879z00_1154 = 
MAKE_PAIR(BgL_arg2883z00_1156, BgL_arg2884z00_1157); } 
BgL_arg2875z00_1152 = 
MAKE_PAIR(BgL_arg2879z00_1154, BNIL); } 
{ /* Object/struct.scm 284 */
obj_t BgL_arg2893z00_1160;obj_t BgL_arg2894z00_1161;
{ /* Object/struct.scm 284 */
obj_t BgL_arg2897z00_1162;obj_t BgL_arg2898z00_1163;
BgL_arg2897z00_1162 = 
CNST_TABLE_REF(((long)45)); 
{ /* Object/struct.scm 285 */
obj_t BgL_arg2901z00_1164;
{ /* Object/struct.scm 285 */
obj_t BgL_arg2904z00_1165;
{ /* Object/struct.scm 285 */
obj_t BgL_arg2908z00_1167;obj_t BgL_arg2909z00_1168;
BgL_arg2908z00_1167 = 
CNST_TABLE_REF(((long)46)); 
{ /* Object/struct.scm 286 */
obj_t BgL_arg2912z00_1169;
{ /* Object/struct.scm 286 */
obj_t BgL_arg2916z00_1171;obj_t BgL_arg2917z00_1172;
BgL_arg2916z00_1171 = 
CNST_TABLE_REF(((long)47)); 
{ /* Object/struct.scm 286 */
obj_t BgL_arg2920z00_1173;obj_t BgL_arg2921z00_1174;
BgL_arg2920z00_1173 = 
(((BgL_globalz00_bglt)CREF(BgL_holderz00_1116))->BgL_idz00); 
{ /* Object/struct.scm 286 */
obj_t BgL_auxz00_2392;
BgL_auxz00_2392 = 
(((BgL_globalz00_bglt)CREF(BgL_holderz00_1116))->BgL_modulez00); 
BgL_arg2921z00_1174 = 
MAKE_PAIR(BgL_auxz00_2392, BNIL); } 
BgL_arg2917z00_1172 = 
MAKE_PAIR(BgL_arg2920z00_1173, BgL_arg2921z00_1174); } 
BgL_arg2912z00_1169 = 
MAKE_PAIR(BgL_arg2916z00_1171, BgL_arg2917z00_1172); } 
BgL_arg2909z00_1168 = 
MAKE_PAIR(BgL_arg2912z00_1169, BNIL); } 
BgL_arg2904z00_1165 = 
MAKE_PAIR(BgL_arg2908z00_1167, BgL_arg2909z00_1168); } 
BgL_arg2901z00_1164 = 
MAKE_PAIR(BgL_arg2904z00_1165, BNIL); } 
BgL_arg2898z00_1163 = 
MAKE_PAIR(BgL_newz00_1114, BgL_arg2901z00_1164); } 
BgL_arg2893z00_1160 = 
MAKE_PAIR(BgL_arg2897z00_1162, BgL_arg2898z00_1163); } 
{ /* Object/struct.scm 288 */
obj_t BgL_arg2930z00_1177;obj_t BgL_arg2931z00_1178;
{ /* Object/struct.scm 288 */
obj_t BgL_arg2934z00_1179;obj_t BgL_arg2935z00_1180;
BgL_arg2934z00_1179 = 
CNST_TABLE_REF(((long)39)); 
{ /* Object/struct.scm 290 */
obj_t BgL_arg2938z00_1181;
{ /* Object/struct.scm 290 */
obj_t BgL_arg2941z00_1182;
{ /* Object/struct.scm 290 */
obj_t BgL_arg2945z00_1184;
{ /* Object/struct.scm 290 */
obj_t BgL_arg2948z00_1185;
{ 
long BgL_iz00_1187;obj_t BgL_slotsz00_1188;obj_t BgL_refza2za2_1189;
BgL_iz00_1187 = ((long)0); 
BgL_slotsz00_1188 = BgL_slotsz00_31; 
BgL_refza2za2_1189 = BNIL; 
BgL_loopz00_1190:
if(
(BgL_iz00_1187==BgL_lenz00_1111))
{ /* Object/struct.scm 294 */
BgL_arg2948z00_1185 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_refza2za2_1189); }  else 
{ /* Object/struct.scm 296 */
bool_t BgL_test2954z00_1192;
{ /* Object/struct.scm 296 */
BgL_slotz00_bglt BgL_auxz00_2406;
{ /* Object/struct.scm 296 */
obj_t BgL_auxz00_2407;
BgL_auxz00_2407 = 
CAR(BgL_slotsz00_1188); 
BgL_auxz00_2406 = 
(BgL_slotz00_bglt)(BgL_auxz00_2407); } 
BgL_test2954z00_1192 = 
BGl_slotzd2virtualzf3z21zzobject_slotsz00(BgL_auxz00_2406); } 
if(BgL_test2954z00_1192)
{ /* Object/struct.scm 296 */
{ 
obj_t BgL_slotsz00_2414;long BgL_iz00_2412;
BgL_iz00_2412 = 
(BgL_iz00_1187+((long)1)); 
BgL_slotsz00_2414 = 
CDR(BgL_slotsz00_1188); 
BgL_slotsz00_1188 = BgL_slotsz00_2414; 
BgL_iz00_1187 = BgL_iz00_2412; 
goto BgL_loopz00_1190;} }  else 
{ /* Object/struct.scm 296 */
{ /* Object/struct.scm 301 */
long BgL_arg2963z00_1195;obj_t BgL_arg2964z00_1196;obj_t BgL_arg2965z00_1197;
BgL_arg2963z00_1195 = 
(BgL_iz00_1187+((long)1)); 
BgL_arg2964z00_1196 = 
CDR(BgL_slotsz00_1188); 
{ /* Object/struct.scm 303 */
obj_t BgL_arg2970z00_1198;
{ /* Object/struct.scm 303 */
obj_t BgL_arg2973z00_1199;obj_t BgL_arg2974z00_1200;
BgL_arg2973z00_1199 = 
CNST_TABLE_REF(((long)31)); 
{ /* Object/struct.scm 303 */
obj_t BgL_arg2977z00_1201;
{ /* Object/struct.scm 303 */
obj_t BgL_auxz00_2419;
BgL_auxz00_2419 = 
BINT(BgL_iz00_1187); 
BgL_arg2977z00_1201 = 
MAKE_PAIR(BgL_auxz00_2419, BNIL); } 
BgL_arg2974z00_1200 = 
MAKE_PAIR(BgL_auxz00_1112, BgL_arg2977z00_1201); } 
BgL_arg2970z00_1198 = 
MAKE_PAIR(BgL_arg2973z00_1199, BgL_arg2974z00_1200); } 
BgL_arg2965z00_1197 = 
MAKE_PAIR(BgL_arg2970z00_1198, BgL_refza2za2_1189); } 
{ 
obj_t BgL_refza2za2_2427;obj_t BgL_slotsz00_2426;long BgL_iz00_2425;
BgL_iz00_2425 = BgL_arg2963z00_1195; 
BgL_slotsz00_2426 = BgL_arg2964z00_1196; 
BgL_refza2za2_2427 = BgL_arg2965z00_1197; 
BgL_refza2za2_1189 = BgL_refza2za2_2427; 
BgL_slotsz00_1188 = BgL_slotsz00_2426; 
BgL_iz00_1187 = BgL_iz00_2425; 
goto BgL_loopz00_1190;} } } } } 
BgL_arg2945z00_1184 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2948z00_1185, BNIL); } 
BgL_arg2941z00_1182 = 
MAKE_PAIR(BgL_wideningz00_1117, BgL_arg2945z00_1184); } 
BgL_arg2938z00_1181 = 
MAKE_PAIR(BgL_arg2941z00_1182, BNIL); } 
BgL_arg2935z00_1180 = 
MAKE_PAIR(BgL_newz00_1114, BgL_arg2938z00_1181); } 
BgL_arg2930z00_1177 = 
MAKE_PAIR(BgL_arg2934z00_1179, BgL_arg2935z00_1180); } 
{ /* Object/struct.scm 305 */
obj_t BgL_arg2988z00_1203;obj_t BgL_arg2989z00_1204;
{ /* Object/struct.scm 305 */
obj_t BgL_arg2992z00_1205;obj_t BgL_arg2993z00_1206;
BgL_arg2992z00_1205 = 
CNST_TABLE_REF(((long)48)); 
BgL_arg2993z00_1206 = 
MAKE_PAIR(BgL_newz00_1114, BNIL); 
BgL_arg2988z00_1203 = 
MAKE_PAIR(BgL_arg2992z00_1205, BgL_arg2993z00_1206); } 
BgL_arg2989z00_1204 = 
MAKE_PAIR(BgL_newz00_1114, BNIL); 
BgL_arg2931z00_1178 = 
MAKE_PAIR(BgL_arg2988z00_1203, BgL_arg2989z00_1204); } 
BgL_arg2894z00_1161 = 
MAKE_PAIR(BgL_arg2930z00_1177, BgL_arg2931z00_1178); } 
BgL_arg2876z00_1153 = 
MAKE_PAIR(BgL_arg2893z00_1160, BgL_arg2894z00_1161); } 
BgL_arg2872z00_1151 = 
MAKE_PAIR(BgL_arg2875z00_1152, BgL_arg2876z00_1153); } 
BgL_arg2867z00_1148 = 
MAKE_PAIR(BgL_arg2871z00_1150, BgL_arg2872z00_1151); } 
BgL_arg2830z00_1133 = 
MAKE_PAIR(BgL_arg2867z00_1148, BNIL); } 
BgL_arg2826z00_1131 = 
MAKE_PAIR(BgL_arg2829z00_1132, BgL_arg2830z00_1133); } 
BgL_arg2821z00_1128 = 
MAKE_PAIR(BgL_arg2825z00_1130, BgL_arg2826z00_1131); } 
BgL_arg2808z00_1123 = 
MAKE_PAIR(BgL_arg2821z00_1128, BNIL); } 
BgL_arg2804z00_1121 = 
MAKE_PAIR(BgL_arg2807z00_1122, BgL_arg2808z00_1123); } 
BgL_arg2800z00_1119 = 
MAKE_PAIR(BgL_arg2803z00_1120, BgL_arg2804z00_1121); } 
return 
BGl_epairifyz00zztools_miscz00(BgL_arg2800z00_1119, BgL_srczd2defzd2_32);} } } } } } } } } } } } 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzobject_structz00()
{ AN_OBJECT;
{ /* Object/struct.scm 15 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzobject_structz00()
{ AN_OBJECT;
{ /* Object/struct.scm 15 */
BGl_modulezd2initializa7ationz75zztools_errorz00(((long)17886), "object_struct"); 
BGl_modulezd2initializa7ationz75zztools_miscz00(((long)63966), "object_struct"); 
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19010), "object_struct"); 
BGl_modulezd2initializa7ationz75zztype_envz00(((long)25262), "object_struct"); 
BGl_modulezd2initializa7ationz75zztype_cachez00(((long)57983), "object_struct"); 
BGl_modulezd2initializa7ationz75zztype_toolsz00(((long)14899), "object_struct"); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)28259), "object_struct"); 
BGl_modulezd2initializa7ationz75zzast_envz00(((long)73271), "object_struct"); 
BGl_modulezd2initializa7ationz75zzast_identz00(((long)52188), "object_struct"); 
BGl_modulezd2initializa7ationz75zzengine_paramz00(((long)189840), "object_struct"); 
BGl_modulezd2initializa7ationz75zzobject_classz00(((long)19348), "object_struct"); 
BGl_modulezd2initializa7ationz75zzobject_toolsz00(((long)59737), "object_struct"); 
BGl_modulezd2initializa7ationz75zzobject_slotsz00(((long)83931), "object_struct"); 
return 
BGl_modulezd2initializa7ationz75zzast_privatez00(((long)10040), "object_struct");} 
}

