/*===========================================================================*/
/*   (Object/wide-access.scm)                                                */
/*   Bigloo (2.5b)                                                           */
/*   Manuel Serrano (c)       Fri Sep 6 09:43:28 CEST 2002                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_tclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   struct BgL_globalz00_bgl * BgL_holderz00;
   obj_t BgL_wideningz00;
   long BgL_depthz00;
   bool_t BgL_finalzf3zf3;
   obj_t BgL_constructorz00;
   obj_t BgL_virtualzd2slotszd2numberz00;
   bool_t BgL_abstractzf3zf3;
} *BgL_tclassz00_bglt;

typedef struct BgL_jclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   obj_t BgL_packagez00;
} *BgL_jclassz00_bglt;

typedef struct BgL_slotz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_srcz00;
   obj_t BgL_classzd2ownerzd2;
   obj_t BgL_typez00;
   bool_t BgL_readzd2onlyzf3z21;
   obj_t BgL_defaultzd2valuezd2;
   obj_t BgL_virtualzd2numzd2;
   obj_t BgL_getterz00;
   obj_t BgL_setterz00;
   obj_t BgL_indexedz00;
   obj_t BgL_userzd2infozd2;
} *BgL_slotz00_bglt;

typedef struct BgL_ccompz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_producerz00;
   obj_t BgL_consumerz00;
   obj_t BgL_finaliza7erza7;
} *BgL_ccompz00_bglt;


extern obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zzobject_widezd2accesszd2();
extern obj_t open_input_string(obj_t);
static obj_t BGl__heapzd2widezd2classzd2accessorsz122228zc0zzobject_widezd2accesszd2(obj_t, obj_t);
extern obj_t BGl_readz00zz__readerz00(obj_t);
extern bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
extern obj_t BGl_tclassz00zzobject_classz00;
extern obj_t BGl_genzd2classzd2predz12z12zzobject_predicatez00(BgL_tclassz00_bglt, obj_t, obj_t);
static obj_t BGl__importzd2widezd2classzd2accessorsz122226zc0zzobject_widezd2accesszd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_correctzd2widezd2classzf3zf3zzobject_widezd2accesszd2(BgL_tclassz00_bglt, obj_t);
extern obj_t BGl_importzd2classzd2predz12z12zzobject_predicatez00(BgL_tclassz00_bglt, obj_t, obj_t);
extern obj_t BGl_typez00zztype_typez00;
extern bool_t BGl_widezd2classzf3z21zzobject_classz00(obj_t);
static obj_t BGl__genzd2widezd2classzd2accessorsz122224zc0zzobject_widezd2accesszd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zzobject_widezd2accesszd2();
extern obj_t BGl_genzd2widezd2classzd2creatorszd2zzobject_creatorz00(BgL_tclassz00_bglt, obj_t, obj_t);
extern obj_t BGl_displayzd22zd2zz__r4_output_6_10_3z00(obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zzobject_widezd2accesszd2();
extern obj_t BGl_genzd2widezd2classzc3zd2ze3structzf2zzobject_structz00(BgL_typez00_bglt, obj_t);
extern obj_t BGl_importzd2widezd2classzd2creatorszd2zzobject_creatorz00(BgL_tclassz00_bglt, obj_t, obj_t);
extern obj_t BGl_makezd2classzd2slotsz00zzobject_slotsz00(BgL_tclassz00_bglt, obj_t, obj_t, int, obj_t);
extern obj_t string_append_3(obj_t, obj_t, obj_t);
extern bool_t BGl_finalzd2classzf3z21zzobject_classz00(obj_t);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_widezd2accesszd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_toolsz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_privatez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_structz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_slotsz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_toolsz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_getterz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_creatorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_predicatez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_coercionz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_impusez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
extern obj_t BGl_userzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_genzd2widezd2classzd2accessorsz12zc0zzobject_widezd2accesszd2(obj_t, BgL_tclassz00_bglt, obj_t, obj_t);
extern obj_t BGl_heapzd2widezd2classzd2accessorsz12zc0zzobject_widezd2accesszd2(BgL_tclassz00_bglt);
extern obj_t BGl_getzd2localzd2virtualzd2slotszd2numberz00zzobject_slotsz00(BgL_tclassz00_bglt, obj_t);
extern obj_t BGl_importzd2widezd2classzd2accessorsz12zc0zzobject_widezd2accesszd2(obj_t, BgL_tclassz00_bglt, obj_t, obj_t);
extern obj_t BGl_genzd2classzd2coercionsz12z12zzobject_coercionz00(obj_t);
extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
extern obj_t BGl_genzd2classzd2slotszd2accessz12zc0zzobject_getterz00(BgL_tclassz00_bglt, obj_t, obj_t, obj_t);
extern obj_t bgl_append2(obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zzobject_widezd2accesszd2 = BUNSPEC;
static obj_t BGl_setzd2widezd2classzd2slotsz12zc0zzobject_widezd2accesszd2(obj_t, obj_t, BgL_tclassz00_bglt);
static obj_t BGl_libraryzd2moduleszd2initz00zzobject_widezd2accesszd2();
static obj_t __cnst[ 1 ] ;

DEFINE_EXPORT_PROCEDURE( BGl_heapzd2widezd2classzd2accessorsz12zd2envz12zzobject_widezd2accesszd2, BgL_bgl__heapza7d2wideza7d2classza7d2accessorsza7122228za7c0za7za7object_wideza7d2accessza7d22332za7, BGl__heapzd2widezd2classzd2accessorsz122228zc0zzobject_widezd2accesszd2, 0L, 1 );
DEFINE_STRING( BGl_string2299z00zzobject_widezd2accesszd2, BgL_bgl_string2299za700za7za7object_wideza7d2accessza7d22333za7, "' is a wide class", 17 );
DEFINE_STRING( BGl_string2298z00zzobject_widezd2accesszd2, BgL_bgl_string2298za700za7za7object_wideza7d2accessza7d22334za7, "' is not a class", 16 );
DEFINE_STRING( BGl_string2297z00zzobject_widezd2accesszd2, BgL_bgl_string2297za700za7za7object_wideza7d2accessza7d22335za7, "super of `", 10 );
DEFINE_STRING( BGl_string2296z00zzobject_widezd2accesszd2, BgL_bgl_string2296za700za7za7object_wideza7d2accessza7d22336za7, "heap super-fields: ", 19 );
DEFINE_STRING( BGl_string2305z00zzobject_widezd2accesszd2, BgL_bgl_string2305za700za7za7object_wideza7d2accessza7d22337za7, "(no def found) ", 15 );
DEFINE_STRING( BGl_string2295z00zzobject_widezd2accesszd2, BgL_bgl_string2295za700za7za7object_wideza7d2accessza7d22338za7, "heap fields: ", 13 );
DEFINE_STRING( BGl_string2304z00zzobject_widezd2accesszd2, BgL_bgl_string2304za700za7za7object_wideza7d2accessza7d22339za7, "Should not be able to see a plain class here", 44 );
DEFINE_STRING( BGl_string2303z00zzobject_widezd2accesszd2, BgL_bgl_string2303za700za7za7object_wideza7d2accessza7d22340za7, "correct-wide-class?", 19 );
DEFINE_STRING( BGl_string2302z00zzobject_widezd2accesszd2, BgL_bgl_string2302za700za7za7object_wideza7d2accessza7d22341za7, "' is not a final class", 22 );
DEFINE_STRING( BGl_string2301z00zzobject_widezd2accesszd2, BgL_bgl_string2301za700za7za7object_wideza7d2accessza7d22342za7, "super of wide class `", 21 );
DEFINE_STRING( BGl_string2300z00zzobject_widezd2accesszd2, BgL_bgl_string2300za700za7za7object_wideza7d2accessza7d22343za7, "A class can't be `wide' and `final'", 35 );
DEFINE_EXPORT_PROCEDURE( BGl_genzd2widezd2classzd2accessorsz12zd2envz12zzobject_widezd2accesszd2, BgL_bgl__genza7d2wideza7d2classza7d2accessorsza7122224za7c0za7za7object_wideza7d2accessza7d22344za7, BGl__genzd2widezd2classzd2accessorsz122224zc0zzobject_widezd2accesszd2, 0L, 4 );
DEFINE_EXPORT_PROCEDURE( BGl_importzd2widezd2classzd2accessorsz12zd2envz12zzobject_widezd2accesszd2, BgL_bgl__importza7d2wideza7d2classza7d2accessorsza7122226za7c0za7za7object_wideza7d2accessza7d22345za7, BGl__importzd2widezd2classzd2accessorsz122226zc0zzobject_widezd2accesszd2, 0L, 4 );



/* module-initialization */
obj_t BGl_modulezd2initializa7ationz75zzobject_widezd2accesszd2(long BgL_checksumz00_1228, char * BgL_fromz00_1229)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzobject_widezd2accesszd2))
{ 
BGl_requirezd2initializa7ationz75zzobject_widezd2accesszd2 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzobject_widezd2accesszd2(); 
BGl_cnstzd2initzd2zzobject_widezd2accesszd2(); 
BGl_importedzd2moduleszd2initz00zzobject_widezd2accesszd2(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzobject_widezd2accesszd2()
{ AN_OBJECT;
{ /* Object/wide-access.scm 21 */
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "object_wide-access"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "object_wide-access"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "object_wide-access"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "object_wide-access"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzobject_widezd2accesszd2()
{ AN_OBJECT;
{ /* Object/wide-access.scm 21 */
{ /* Object/wide-access.scm 21 */
obj_t BgL_cportz00_1221;
BgL_cportz00_1221 = 
open_input_string(BGl_string2305z00zzobject_widezd2accesszd2); 
{ 
long BgL_iz00_1222;
BgL_iz00_1222 = ((long)0); 
BgL_loopz00_1223:
if(
(BgL_iz00_1222==((long)-1)))
{ /* Object/wide-access.scm 21 */
return BUNSPEC;}  else 
{ /* Object/wide-access.scm 21 */
{ /* Object/wide-access.scm 21 */
obj_t BgL_arg2309z00_1225;
{ /* Object/wide-access.scm 21 */
obj_t BgL_list2312z00_1226;
BgL_list2312z00_1226 = 
MAKE_PAIR(BgL_cportz00_1221, BNIL); 
BgL_arg2309z00_1225 = 
BGl_readz00zz__readerz00(BgL_list2312z00_1226); } 
{ /* Object/wide-access.scm 21 */
int BgL_auxz00_1245;
BgL_auxz00_1245 = 
(int)(BgL_iz00_1222); 
CNST_TABLE_SET(BgL_auxz00_1245, BgL_arg2309z00_1225); } } 
{ 
long BgL_iz00_1248;
{ /* Object/wide-access.scm 21 */
int BgL_auxz00_1249;
{ /* Object/wide-access.scm 21 */
long BgL_auxz00_1250;
BgL_auxz00_1250 = 
(BgL_iz00_1222-((long)1)); 
BgL_auxz00_1249 = 
(int)(BgL_auxz00_1250); } 
BgL_iz00_1248 = 
(long)(BgL_auxz00_1249); } 
BgL_iz00_1222 = BgL_iz00_1248; 
goto BgL_loopz00_1223;} } } } } 
}



/* gen-wide-class-accessors! */
obj_t BGl_genzd2widezd2classzd2accessorsz12zc0zzobject_widezd2accesszd2(obj_t BgL_classzd2defzd2_1, BgL_tclassz00_bglt BgL_classz00_2, obj_t BgL_srczd2defzd2_3, obj_t BgL_importz00_4)
{ AN_OBJECT;
{ /* Object/wide-access.scm 50 */
{ /* Object/wide-access.scm 52 */
bool_t BgL_test1846z00_660;
{ /* Object/wide-access.scm 52 */
obj_t BgL_auxz00_1254;
BgL_auxz00_1254 = 
BGl_correctzd2widezd2classzf3zf3zzobject_widezd2accesszd2(BgL_classz00_2, BgL_srczd2defzd2_3); 
BgL_test1846z00_660 = 
CBOOL(BgL_auxz00_1254); } 
if(BgL_test1846z00_660)
{ /* Object/wide-access.scm 52 */
BGl_setzd2widezd2classzd2slotsz12zc0zzobject_widezd2accesszd2(BgL_classzd2defzd2_1, BgL_srczd2defzd2_3, BgL_classz00_2); 
BGl_genzd2classzd2coercionsz12z12zzobject_coercionz00(
(obj_t)(BgL_classz00_2)); 
{ /* Object/wide-access.scm 61 */
obj_t BgL_creatsz00_662;obj_t BgL_structsz00_663;obj_t BgL_predicatez00_664;
BgL_creatsz00_662 = 
BGl_genzd2widezd2classzd2creatorszd2zzobject_creatorz00(BgL_classz00_2, BgL_srczd2defzd2_3, BgL_importz00_4); 
BgL_structsz00_663 = 
BGl_genzd2widezd2classzc3zd2ze3structzf2zzobject_structz00(
(BgL_typez00_bglt)(BgL_classz00_2), BgL_srczd2defzd2_3); 
BgL_predicatez00_664 = 
BGl_genzd2classzd2predz12z12zzobject_predicatez00(BgL_classz00_2, BgL_srczd2defzd2_3, BgL_importz00_4); 
{ /* Object/wide-access.scm 64 */
obj_t BgL_fieldsz00_665;
BgL_fieldsz00_665 = 
BGl_genzd2classzd2slotszd2accessz12zc0zzobject_getterz00(BgL_classz00_2, 
(obj_t)(BgL_classz00_2), 
(obj_t)(BgL_classz00_2), BgL_srczd2defzd2_3); 
{ /* Object/wide-access.scm 66 */
obj_t BgL_virtualsz00_666;
{ /* Object/wide-access.scm 66 */
int BgL_auxz00_1268;
BgL_auxz00_1268 = 
(int)(((long)1)); 
BgL_virtualsz00_666 = 
BGL_GET_MVALUES_VAL(BgL_auxz00_1268); } 
{ /* Object/wide-access.scm 66 */
obj_t BgL_superzd2fieldszd2_667;
{ /* Object/wide-access.scm 67 */
obj_t BgL_auxz00_1271;
{ 
obj_t BgL_auxz00_1272;
{ /* Object/wide-access.scm 67 */
BgL_objectz00_bglt BgL_auxz00_1273;
BgL_auxz00_1273 = 
(BgL_objectz00_bglt)(BgL_classz00_2); 
BgL_auxz00_1272 = 
BGL_OBJECT_WIDENING(BgL_auxz00_1273); } 
BgL_auxz00_1271 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_1272))->BgL_itszd2superzd2); } 
BgL_superzd2fieldszd2_667 = 
BGl_genzd2classzd2slotszd2accessz12zc0zzobject_getterz00(BgL_classz00_2, BgL_auxz00_1271, BFALSE, BgL_srczd2defzd2_3); } 
{ /* Object/wide-access.scm 68 */
obj_t BgL_superzd2virtualszd2_668;
{ /* Object/wide-access.scm 68 */
int BgL_auxz00_1278;
BgL_auxz00_1278 = 
(int)(((long)1)); 
BgL_superzd2virtualszd2_668 = 
BGL_GET_MVALUES_VAL(BgL_auxz00_1278); } 
{ /* Object/wide-access.scm 68 */
obj_t BgL_val0_1832z00_669;obj_t BgL_val1_1833z00_670;
BgL_val0_1832z00_669 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_predicatez00_664, 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_structsz00_663, 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_creatsz00_662, 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_superzd2fieldszd2_667, 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_fieldsz00_665, BNIL))))); 
BgL_val1_1833z00_670 = 
bgl_append2(BgL_superzd2virtualszd2_668, BgL_virtualsz00_666); 
{ /* Object/wide-access.scm 68 */
int BgL_auxz00_1287;
BgL_auxz00_1287 = 
(int)(((long)2)); 
BGL_SET_MVALUES_NUMBER(BgL_auxz00_1287); } 
{ /* Object/wide-access.scm 68 */
int BgL_auxz00_1290;
BgL_auxz00_1290 = 
(int)(((long)1)); 
BGL_SET_MVALUES_VAL(BgL_auxz00_1290, BgL_val1_1833z00_670); } 
return BgL_val0_1832z00_669;} } } } } } }  else 
{ /* Object/wide-access.scm 52 */
{ /* Object/wide-access.scm 71 */
int BgL_auxz00_1293;
BgL_auxz00_1293 = 
(int)(((long)2)); 
BGL_SET_MVALUES_NUMBER(BgL_auxz00_1293); } 
{ /* Object/wide-access.scm 71 */
int BgL_auxz00_1296;
BgL_auxz00_1296 = 
(int)(((long)1)); 
BGL_SET_MVALUES_VAL(BgL_auxz00_1296, BNIL); } 
return BNIL;} } } 
}



/* _gen-wide-class-accessors!2224 */
obj_t BGl__genzd2widezd2classzd2accessorsz122224zc0zzobject_widezd2accesszd2(obj_t BgL_envz00_1209, obj_t BgL_classzd2defzd2_1210, obj_t BgL_classz00_1211, obj_t BgL_srczd2defzd2_1212, obj_t BgL_importz00_1213)
{ AN_OBJECT;
{ /* Object/wide-access.scm 50 */
return 
BGl_genzd2widezd2classzd2accessorsz12zc0zzobject_widezd2accesszd2(BgL_classzd2defzd2_1210, 
(BgL_tclassz00_bglt)(BgL_classz00_1211), BgL_srczd2defzd2_1212, BgL_importz00_1213);} 
}



/* import-wide-class-accessors! */
obj_t BGl_importzd2widezd2classzd2accessorsz12zc0zzobject_widezd2accesszd2(obj_t BgL_classzd2defzd2_5, BgL_tclassz00_bglt BgL_classz00_6, obj_t BgL_srczd2defzd2_7, obj_t BgL_modulez00_8)
{ AN_OBJECT;
{ /* Object/wide-access.scm 76 */
{ /* Object/wide-access.scm 78 */
bool_t BgL_test1880z00_678;
{ /* Object/wide-access.scm 78 */
obj_t BgL_auxz00_1301;
BgL_auxz00_1301 = 
BGl_correctzd2widezd2classzf3zf3zzobject_widezd2accesszd2(BgL_classz00_6, BgL_srczd2defzd2_7); 
BgL_test1880z00_678 = 
CBOOL(BgL_auxz00_1301); } 
if(BgL_test1880z00_678)
{ /* Object/wide-access.scm 78 */
BGl_setzd2widezd2classzd2slotsz12zc0zzobject_widezd2accesszd2(BgL_classzd2defzd2_5, BgL_srczd2defzd2_7, BgL_classz00_6); 
BGl_genzd2classzd2coercionsz12z12zzobject_coercionz00(
(obj_t)(BgL_classz00_6)); 
{ /* Object/wide-access.scm 87 */
obj_t BgL_creatsz00_680;obj_t BgL_predicatez00_681;
BgL_creatsz00_680 = 
BGl_importzd2widezd2classzd2creatorszd2zzobject_creatorz00(BgL_classz00_6, BgL_srczd2defzd2_7, BgL_modulez00_8); 
BgL_predicatez00_681 = 
BGl_importzd2classzd2predz12z12zzobject_predicatez00(BgL_classz00_6, BgL_srczd2defzd2_7, BgL_modulez00_8); 
{ /* Object/wide-access.scm 89 */
obj_t BgL_fieldsz00_682;
BgL_fieldsz00_682 = 
BGl_genzd2classzd2slotszd2accessz12zc0zzobject_getterz00(BgL_classz00_6, 
(obj_t)(BgL_classz00_6), 
(obj_t)(BgL_classz00_6), BgL_srczd2defzd2_7); 
{ /* Object/wide-access.scm 91 */
obj_t BgL_virtualsz00_683;
{ /* Object/wide-access.scm 91 */
int BgL_auxz00_1313;
BgL_auxz00_1313 = 
(int)(((long)1)); 
BgL_virtualsz00_683 = 
BGL_GET_MVALUES_VAL(BgL_auxz00_1313); } 
{ /* Object/wide-access.scm 91 */
obj_t BgL_superzd2fieldszd2_684;
{ /* Object/wide-access.scm 92 */
obj_t BgL_auxz00_1316;
{ 
obj_t BgL_auxz00_1317;
{ /* Object/wide-access.scm 92 */
BgL_objectz00_bglt BgL_auxz00_1318;
BgL_auxz00_1318 = 
(BgL_objectz00_bglt)(BgL_classz00_6); 
BgL_auxz00_1317 = 
BGL_OBJECT_WIDENING(BgL_auxz00_1318); } 
BgL_auxz00_1316 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_1317))->BgL_itszd2superzd2); } 
BgL_superzd2fieldszd2_684 = 
BGl_genzd2classzd2slotszd2accessz12zc0zzobject_getterz00(BgL_classz00_6, BgL_auxz00_1316, BFALSE, BgL_srczd2defzd2_7); } 
{ /* Object/wide-access.scm 93 */
obj_t BgL_superzd2virtualszd2_685;
{ /* Object/wide-access.scm 93 */
int BgL_auxz00_1323;
BgL_auxz00_1323 = 
(int)(((long)1)); 
BgL_superzd2virtualszd2_685 = 
BGL_GET_MVALUES_VAL(BgL_auxz00_1323); } 
{ /* Object/wide-access.scm 93 */
obj_t BgL_val0_1838z00_686;obj_t BgL_val1_1839z00_687;
BgL_val0_1838z00_686 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_predicatez00_681, 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_creatsz00_680, 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_superzd2fieldszd2_684, 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_fieldsz00_682, BNIL)))); 
BgL_val1_1839z00_687 = 
bgl_append2(BgL_superzd2virtualszd2_685, BgL_virtualsz00_683); 
{ /* Object/wide-access.scm 93 */
int BgL_auxz00_1331;
BgL_auxz00_1331 = 
(int)(((long)2)); 
BGL_SET_MVALUES_NUMBER(BgL_auxz00_1331); } 
{ /* Object/wide-access.scm 93 */
int BgL_auxz00_1334;
BgL_auxz00_1334 = 
(int)(((long)1)); 
BGL_SET_MVALUES_VAL(BgL_auxz00_1334, BgL_val1_1839z00_687); } 
return BgL_val0_1838z00_686;} } } } } } }  else 
{ /* Object/wide-access.scm 78 */
{ /* Object/wide-access.scm 95 */
int BgL_auxz00_1337;
BgL_auxz00_1337 = 
(int)(((long)2)); 
BGL_SET_MVALUES_NUMBER(BgL_auxz00_1337); } 
{ /* Object/wide-access.scm 95 */
int BgL_auxz00_1340;
BgL_auxz00_1340 = 
(int)(((long)1)); 
BGL_SET_MVALUES_VAL(BgL_auxz00_1340, BNIL); } 
return BNIL;} } } 
}



/* _import-wide-class-accessors!2226 */
obj_t BGl__importzd2widezd2classzd2accessorsz122226zc0zzobject_widezd2accesszd2(obj_t BgL_envz00_1214, obj_t BgL_classzd2defzd2_1215, obj_t BgL_classz00_1216, obj_t BgL_srczd2defzd2_1217, obj_t BgL_modulez00_1218)
{ AN_OBJECT;
{ /* Object/wide-access.scm 76 */
return 
BGl_importzd2widezd2classzd2accessorsz12zc0zzobject_widezd2accesszd2(BgL_classzd2defzd2_1215, 
(BgL_tclassz00_bglt)(BgL_classz00_1216), BgL_srczd2defzd2_1217, BgL_modulez00_1218);} 
}



/* heap-wide-class-accessors! */
obj_t BGl_heapzd2widezd2classzd2accessorsz12zc0zzobject_widezd2accesszd2(BgL_tclassz00_bglt BgL_classz00_9)
{ AN_OBJECT;
{ /* Object/wide-access.scm 100 */
{ /* Object/wide-access.scm 101 */
obj_t BgL_srczd2defzd2_694;
BgL_srczd2defzd2_694 = 
CNST_TABLE_REF(((long)0)); 
{ /* Object/wide-access.scm 108 */
obj_t BgL_fieldsz00_696;
BgL_fieldsz00_696 = 
BGl_genzd2classzd2slotszd2accessz12zc0zzobject_getterz00(BgL_classz00_9, 
(obj_t)(BgL_classz00_9), BFALSE, BgL_srczd2defzd2_694); 
{ /* Object/wide-access.scm 110 */
obj_t BgL_virtualsz00_697;
{ /* Object/wide-access.scm 110 */
int BgL_auxz00_1348;
BgL_auxz00_1348 = 
(int)(((long)1)); 
BgL_virtualsz00_697 = 
BGL_GET_MVALUES_VAL(BgL_auxz00_1348); } 
{ /* Object/wide-access.scm 110 */
obj_t BgL_arg1910z00_699;
BgL_arg1910z00_699 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string2295z00zzobject_widezd2accesszd2, BgL_arg1910z00_699); } 
{ /* Object/wide-access.scm 110 */
obj_t BgL_arg1914z00_700;
BgL_arg1914z00_700 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_fieldsz00_696, BgL_arg1914z00_700); } 
{ /* Object/wide-access.scm 110 */
obj_t BgL_arg1918z00_701;
BgL_arg1918z00_701 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg1918z00_701); } 
{ /* Object/wide-access.scm 111 */
obj_t BgL_superzd2fieldszd2_702;
{ /* Object/wide-access.scm 112 */
obj_t BgL_auxz00_1357;
{ 
obj_t BgL_auxz00_1358;
{ /* Object/wide-access.scm 112 */
BgL_objectz00_bglt BgL_auxz00_1359;
BgL_auxz00_1359 = 
(BgL_objectz00_bglt)(BgL_classz00_9); 
BgL_auxz00_1358 = 
BGL_OBJECT_WIDENING(BgL_auxz00_1359); } 
BgL_auxz00_1357 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_1358))->BgL_itszd2superzd2); } 
BgL_superzd2fieldszd2_702 = 
BGl_genzd2classzd2slotszd2accessz12zc0zzobject_getterz00(BgL_classz00_9, BgL_auxz00_1357, BFALSE, BgL_srczd2defzd2_694); } 
{ /* Object/wide-access.scm 113 */
obj_t BgL_superzd2virtualszd2_703;
{ /* Object/wide-access.scm 113 */
int BgL_auxz00_1364;
BgL_auxz00_1364 = 
(int)(((long)1)); 
BgL_superzd2virtualszd2_703 = 
BGL_GET_MVALUES_VAL(BgL_auxz00_1364); } 
{ /* Object/wide-access.scm 113 */
obj_t BgL_arg1924z00_705;
BgL_arg1924z00_705 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string2296z00zzobject_widezd2accesszd2, BgL_arg1924z00_705); } 
{ /* Object/wide-access.scm 113 */
obj_t BgL_arg1929z00_706;
BgL_arg1929z00_706 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_superzd2fieldszd2_702, BgL_arg1929z00_706); } 
{ /* Object/wide-access.scm 113 */
obj_t BgL_arg1933z00_707;
BgL_arg1933z00_707 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg1933z00_707); } 
{ /* Object/wide-access.scm 114 */
obj_t BgL_val0_1844z00_708;obj_t BgL_val1_1845z00_709;
BgL_val0_1844z00_708 = 
bgl_append2(BgL_superzd2fieldszd2_702, BgL_fieldsz00_696); 
BgL_val1_1845z00_709 = 
bgl_append2(BgL_superzd2virtualszd2_703, BgL_virtualsz00_697); 
{ /* Object/wide-access.scm 114 */
int BgL_auxz00_1375;
BgL_auxz00_1375 = 
(int)(((long)2)); 
BGL_SET_MVALUES_NUMBER(BgL_auxz00_1375); } 
{ /* Object/wide-access.scm 114 */
int BgL_auxz00_1378;
BgL_auxz00_1378 = 
(int)(((long)1)); 
BGL_SET_MVALUES_VAL(BgL_auxz00_1378, BgL_val1_1845z00_709); } 
return BgL_val0_1844z00_708;} } } } } } } 
}



/* _heap-wide-class-accessors!2228 */
obj_t BGl__heapzd2widezd2classzd2accessorsz122228zc0zzobject_widezd2accesszd2(obj_t BgL_envz00_1219, obj_t BgL_classz00_1220)
{ AN_OBJECT;
{ /* Object/wide-access.scm 100 */
return 
BGl_heapzd2widezd2classzd2accessorsz12zc0zzobject_widezd2accesszd2(
(BgL_tclassz00_bglt)(BgL_classz00_1220));} 
}



/* set-wide-class-slots! */
obj_t BGl_setzd2widezd2classzd2slotsz12zc0zzobject_widezd2accesszd2(obj_t BgL_classzd2defzd2_10, obj_t BgL_srczd2defzd2_11, BgL_tclassz00_bglt BgL_classz00_12)
{ AN_OBJECT;
{ /* Object/wide-access.scm 123 */
{ /* Object/wide-access.scm 124 */
obj_t BgL_superz00_711;
{ /* Object/wide-access.scm 124 */
obj_t BgL_superz00_717;
{ 
obj_t BgL_auxz00_1383;
{ /* Object/wide-access.scm 124 */
BgL_objectz00_bglt BgL_auxz00_1384;
BgL_auxz00_1384 = 
(BgL_objectz00_bglt)(BgL_classz00_12); 
BgL_auxz00_1383 = 
BGL_OBJECT_WIDENING(BgL_auxz00_1384); } 
BgL_superz00_717 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_1383))->BgL_itszd2superzd2); } 
{ /* Object/wide-access.scm 125 */
bool_t BgL_testz00_1388;
{ /* Object/wide-access.scm 125 */
obj_t BgL_auxz00_1389;
BgL_auxz00_1389 = 
(obj_t)(BgL_classz00_12); 
BgL_testz00_1388 = 
(BgL_superz00_717==BgL_auxz00_1389); } 
if(BgL_testz00_1388)
{ /* Object/wide-access.scm 125 */
BgL_superz00_711 = BFALSE; }  else 
{ /* Object/wide-access.scm 125 */
BgL_superz00_711 = BgL_superz00_717; } } } 
{ /* Object/wide-access.scm 124 */
obj_t BgL_superzd2vnumzd2_712;
{ /* Object/wide-access.scm 128 */
bool_t BgL_test1953z00_716;
BgL_test1953z00_716 = 
BGl_iszd2azf3z21zz__objectz00(BgL_superz00_711, BGl_tclassz00zzobject_classz00); 
if(BgL_test1953z00_716)
{ /* Object/wide-access.scm 129 */
BgL_tclassz00_bglt BgL_obj1621z00_942;
BgL_obj1621z00_942 = 
(BgL_tclassz00_bglt)(BgL_superz00_711); 
{ 
obj_t BgL_auxz00_1395;
{ /* Object/wide-access.scm 129 */
BgL_objectz00_bglt BgL_auxz00_1396;
BgL_auxz00_1396 = 
(BgL_objectz00_bglt)(BgL_obj1621z00_942); 
BgL_auxz00_1395 = 
BGL_OBJECT_WIDENING(BgL_auxz00_1396); } 
BgL_superzd2vnumzd2_712 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_1395))->BgL_virtualzd2slotszd2numberz00); } }  else 
{ /* Object/wide-access.scm 128 */
BgL_superzd2vnumzd2_712 = 
BINT(((long)0)); } } 
{ /* Object/wide-access.scm 131 */

{ /* Object/wide-access.scm 135 */
obj_t BgL_cslotsz00_714;
{ /* Object/wide-access.scm 135 */
obj_t BgL_auxz00_1401;
{ /* Object/wide-access.scm 131 */
obj_t BgL_auxz00_1402;
BgL_auxz00_1402 = 
CDR(BgL_classzd2defzd2_10); 
BgL_auxz00_1401 = 
CDR(BgL_auxz00_1402); } 
BgL_cslotsz00_714 = 
BGl_makezd2classzd2slotsz00zzobject_slotsz00(BgL_classz00_12, BgL_auxz00_1401, BFALSE, 
CINT(BgL_superzd2vnumzd2_712), BgL_srczd2defzd2_11); } 
{ /* Object/wide-access.scm 135 */
obj_t BgL_localzd2vnumzd2_715;
BgL_localzd2vnumzd2_715 = 
BGl_getzd2localzd2virtualzd2slotszd2numberz00zzobject_slotsz00(BgL_classz00_12, BgL_cslotsz00_714); 
{ /* Object/wide-access.scm 136 */

{ 
obj_t BgL_auxz00_1408;
{ /* Object/wide-access.scm 138 */
BgL_objectz00_bglt BgL_auxz00_1409;
BgL_auxz00_1409 = 
(BgL_objectz00_bglt)(BgL_classz00_12); 
BgL_auxz00_1408 = 
BGL_OBJECT_WIDENING(BgL_auxz00_1409); } 
((((BgL_tclassz00_bglt)CREF(BgL_auxz00_1408))->BgL_virtualzd2slotszd2numberz00) = ((obj_t)BgL_localzd2vnumzd2_715), BUNSPEC); } 
{ 
obj_t BgL_auxz00_1413;
{ /* Object/wide-access.scm 140 */
BgL_objectz00_bglt BgL_auxz00_1414;
BgL_auxz00_1414 = 
(BgL_objectz00_bglt)(BgL_classz00_12); 
BgL_auxz00_1413 = 
BGL_OBJECT_WIDENING(BgL_auxz00_1414); } 
return 
((((BgL_tclassz00_bglt)CREF(BgL_auxz00_1413))->BgL_slotsz00) = ((obj_t)BgL_cslotsz00_714), BUNSPEC);} } } } } } } } 
}



/* correct-wide-class? */
obj_t BGl_correctzd2widezd2classzf3zf3zzobject_widezd2accesszd2(BgL_tclassz00_bglt BgL_classz00_13, obj_t BgL_srczd2defzd2_14)
{ AN_OBJECT;
{ /* Object/wide-access.scm 149 */
{ /* Object/wide-access.scm 150 */
obj_t BgL_superz00_719;
{ 
obj_t BgL_auxz00_1418;
{ /* Object/wide-access.scm 150 */
BgL_objectz00_bglt BgL_auxz00_1419;
BgL_auxz00_1419 = 
(BgL_objectz00_bglt)(BgL_classz00_13); 
BgL_auxz00_1418 = 
BGL_OBJECT_WIDENING(BgL_auxz00_1419); } 
BgL_superz00_719 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_1418))->BgL_itszd2superzd2); } 
{ /* Object/wide-access.scm 150 */
obj_t BgL_classzd2idzd2_720;
{ /* Object/wide-access.scm 151 */
BgL_typez00_bglt BgL_obj1626z00_952;
BgL_obj1626z00_952 = 
(BgL_typez00_bglt)(BgL_classz00_13); 
BgL_classzd2idzd2_720 = 
(((BgL_typez00_bglt)CREF(BgL_obj1626z00_952))->BgL_idz00); } 
{ /* Object/wide-access.scm 151 */

{ /* Object/wide-access.scm 155 */
bool_t BgL_test1959z00_721;
{ /* Object/wide-access.scm 155 */
bool_t BgL_test2012z00_745;
BgL_test2012z00_745 = 
BGl_iszd2azf3z21zz__objectz00(BgL_superz00_719, BGl_typez00zztype_typez00); 
if(BgL_test2012z00_745)
{ /* Object/wide-access.scm 155 */
bool_t BgL_test2013z00_746;
BgL_test2013z00_746 = 
BGl_iszd2azf3z21zz__objectz00(BgL_superz00_719, BGl_tclassz00zzobject_classz00); 
if(BgL_test2013z00_746)
{ /* Object/wide-access.scm 155 */
BgL_test1959z00_721 = ((bool_t)0); }  else 
{ /* Object/wide-access.scm 155 */
BgL_test1959z00_721 = ((bool_t)1); } }  else 
{ /* Object/wide-access.scm 155 */
BgL_test1959z00_721 = ((bool_t)0); } } 
if(BgL_test1959z00_721)
{ /* Object/wide-access.scm 155 */
{ /* Object/wide-access.scm 156 */
obj_t BgL_arg1961z00_722;obj_t BgL_arg1962z00_723;
{ /* Object/wide-access.scm 156 */
BgL_typez00_bglt BgL_obj1003z00_955;
BgL_obj1003z00_955 = 
(BgL_typez00_bglt)(BgL_superz00_719); 
BgL_arg1961z00_722 = 
(((BgL_typez00_bglt)CREF(BgL_obj1003z00_955))->BgL_idz00); } 
{ /* Object/wide-access.scm 157 */
obj_t BgL_arg1969z00_726;
BgL_arg1969z00_726 = 
SYMBOL_TO_STRING(BgL_classzd2idzd2_720); 
BgL_arg1962z00_723 = 
string_append_3(BGl_string2297z00zzobject_widezd2accesszd2, BgL_arg1969z00_726, BGl_string2298z00zzobject_widezd2accesszd2); } 
{ /* Object/wide-access.scm 156 */
obj_t BgL_list1964z00_724;
BgL_list1964z00_724 = 
MAKE_PAIR(BGl_typez00zztype_typez00, BNIL); 
return 
BGl_userzd2errorzd2zztools_errorz00(BgL_arg1961z00_722, BgL_arg1962z00_723, BgL_srczd2defzd2_14, BgL_list1964z00_724);} } }  else 
{ /* Object/wide-access.scm 162 */
bool_t BgL_test1973z00_728;
BgL_test1973z00_728 = 
BGl_widezd2classzf3z21zzobject_classz00(
(obj_t)(BgL_classz00_13)); 
if(BgL_test1973z00_728)
{ /* Object/wide-access.scm 168 */
bool_t BgL_test1975z00_729;
BgL_test1975z00_729 = 
BGl_widezd2classzf3z21zzobject_classz00(BgL_superz00_719); 
if(BgL_test1975z00_729)
{ /* Object/wide-access.scm 168 */
{ /* Object/wide-access.scm 170 */
obj_t BgL_arg1977z00_730;obj_t BgL_arg1978z00_731;
{ /* Object/wide-access.scm 170 */
BgL_typez00_bglt BgL_obj1003z00_957;
BgL_obj1003z00_957 = 
(BgL_typez00_bglt)(BgL_superz00_719); 
BgL_arg1977z00_730 = 
(((BgL_typez00_bglt)CREF(BgL_obj1003z00_957))->BgL_idz00); } 
{ /* Object/wide-access.scm 171 */
obj_t BgL_arg1985z00_734;
BgL_arg1985z00_734 = 
SYMBOL_TO_STRING(BgL_classzd2idzd2_720); 
BgL_arg1978z00_731 = 
string_append_3(BGl_string2297z00zzobject_widezd2accesszd2, BgL_arg1985z00_734, BGl_string2299z00zzobject_widezd2accesszd2); } 
{ /* Object/wide-access.scm 170 */
obj_t BgL_list1980z00_732;
BgL_list1980z00_732 = 
MAKE_PAIR(BGl_typez00zztype_typez00, BNIL); 
return 
BGl_userzd2errorzd2zztools_errorz00(BgL_arg1977z00_730, BgL_arg1978z00_731, BgL_srczd2defzd2_14, BgL_list1980z00_732);} } }  else 
{ /* Object/wide-access.scm 176 */
bool_t BgL_test1989z00_736;
BgL_test1989z00_736 = 
BGl_finalzd2classzf3z21zzobject_classz00(BgL_superz00_719); 
if(BgL_test1989z00_736)
{ /* Object/wide-access.scm 184 */
bool_t BgL_test1990z00_737;
BgL_test1990z00_737 = 
BGl_finalzd2classzf3z21zzobject_classz00(
(obj_t)(BgL_classz00_13)); 
if(BgL_test1990z00_737)
{ /* Object/wide-access.scm 184 */
{ /* Object/wide-access.scm 186 */
obj_t BgL_list1992z00_738;
BgL_list1992z00_738 = 
MAKE_PAIR(BGl_typez00zztype_typez00, BNIL); 
return 
BGl_userzd2errorzd2zztools_errorz00(BgL_classzd2idzd2_720, BGl_string2300z00zzobject_widezd2accesszd2, BgL_srczd2defzd2_14, BgL_list1992z00_738);} }  else 
{ /* Object/wide-access.scm 184 */
return BTRUE;} }  else 
{ /* Object/wide-access.scm 176 */
{ /* Object/wide-access.scm 178 */
obj_t BgL_arg1996z00_739;obj_t BgL_arg1997z00_740;
{ /* Object/wide-access.scm 178 */
BgL_typez00_bglt BgL_obj1003z00_959;
BgL_obj1003z00_959 = 
(BgL_typez00_bglt)(BgL_superz00_719); 
BgL_arg1996z00_739 = 
(((BgL_typez00_bglt)CREF(BgL_obj1003z00_959))->BgL_idz00); } 
{ /* Object/wide-access.scm 179 */
obj_t BgL_arg2004z00_743;
BgL_arg2004z00_743 = 
SYMBOL_TO_STRING(BgL_classzd2idzd2_720); 
BgL_arg1997z00_740 = 
string_append_3(BGl_string2301z00zzobject_widezd2accesszd2, BgL_arg2004z00_743, BGl_string2302z00zzobject_widezd2accesszd2); } 
{ /* Object/wide-access.scm 178 */
obj_t BgL_list1999z00_741;
BgL_list1999z00_741 = 
MAKE_PAIR(BGl_typez00zztype_typez00, BNIL); 
return 
BGl_userzd2errorzd2zztools_errorz00(BgL_arg1996z00_739, BgL_arg1997z00_740, BgL_srczd2defzd2_14, BgL_list1999z00_741);} } } } }  else 
{ /* Object/wide-access.scm 162 */
return 
BGl_internalzd2errorzd2zztools_errorz00(BGl_string2303z00zzobject_widezd2accesszd2, BGl_string2304z00zzobject_widezd2accesszd2, BgL_srczd2defzd2_14);} } } } } } } 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzobject_widezd2accesszd2()
{ AN_OBJECT;
{ /* Object/wide-access.scm 21 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzobject_widezd2accesszd2()
{ AN_OBJECT;
{ /* Object/wide-access.scm 21 */
BGl_modulezd2initializa7ationz75zztools_tracez00(((long)64647), "object_wide-access"); 
BGl_modulezd2initializa7ationz75zztools_errorz00(((long)17886), "object_wide-access"); 
BGl_modulezd2initializa7ationz75zztools_miscz00(((long)63966), "object_wide-access"); 
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19010), "object_wide-access"); 
BGl_modulezd2initializa7ationz75zztype_envz00(((long)25262), "object_wide-access"); 
BGl_modulezd2initializa7ationz75zztype_toolsz00(((long)14899), "object_wide-access"); 
BGl_modulezd2initializa7ationz75zztype_cachez00(((long)57983), "object_wide-access"); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)28259), "object_wide-access"); 
BGl_modulezd2initializa7ationz75zzast_identz00(((long)52188), "object_wide-access"); 
BGl_modulezd2initializa7ationz75zzast_privatez00(((long)10040), "object_wide-access"); 
BGl_modulezd2initializa7ationz75zzobject_classz00(((long)19348), "object_wide-access"); 
BGl_modulezd2initializa7ationz75zzobject_structz00(((long)41722), "object_wide-access"); 
BGl_modulezd2initializa7ationz75zzobject_slotsz00(((long)83931), "object_wide-access"); 
BGl_modulezd2initializa7ationz75zzobject_toolsz00(((long)59737), "object_wide-access"); 
BGl_modulezd2initializa7ationz75zzobject_getterz00(((long)25716), "object_wide-access"); 
BGl_modulezd2initializa7ationz75zzobject_creatorz00(((long)595), "object_wide-access"); 
BGl_modulezd2initializa7ationz75zzobject_predicatez00(((long)48825), "object_wide-access"); 
BGl_modulezd2initializa7ationz75zzobject_coercionz00(((long)60556), "object_wide-access"); 
BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long)12859), "object_wide-access"); 
BGl_modulezd2initializa7ationz75zzmodule_impusez00(((long)21670), "object_wide-access"); 
return 
BGl_modulezd2initializa7ationz75zzengine_paramz00(((long)189840), "object_wide-access");} 
}

