/*===========================================================================*/
/*   (Type/tenv.scm)                                                         */
/*   Bigloo (2.5b)                                                           */
/*   Manuel Serrano (c)       Fri Sep 6 09:43:28 CEST 2002                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_ccompz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_producerz00;
   obj_t BgL_consumerz00;
   obj_t BgL_finaliza7erza7;
} *BgL_ccompz00_bglt;

typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_caliasz00_bgl {
   bool_t BgL_arrayzf3zf3;
} *BgL_caliasz00_bglt;

typedef struct BgL_cenumz00_bgl {
   struct BgL_typez00_bgl * BgL_btypez00;
   obj_t BgL_literalsz00;
} *BgL_cenumz00_bglt;

typedef struct BgL_copaquez00_bgl {
   struct BgL_typez00_bgl * BgL_btypez00;
} *BgL_copaquez00_bglt;

typedef struct BgL_cfunctionz00_bgl {
   struct BgL_typez00_bgl * BgL_btypez00;
   long BgL_arityz00;
   struct BgL_typez00_bgl * BgL_typezd2reszd2;
   obj_t BgL_typezd2argszd2;
} *BgL_cfunctionz00_bglt;

typedef struct BgL_cptrz00_bgl {
   struct BgL_typez00_bgl * BgL_btypez00;
   struct BgL_typez00_bgl * BgL_pointzd2tozd2;
   bool_t BgL_arrayzf3zf3;
} *BgL_cptrz00_bglt;

typedef struct BgL_cstructz00_bgl {
   bool_t BgL_structzf3zf3;
   obj_t BgL_fieldsz00;
   obj_t BgL_cstructza2za2;
} *BgL_cstructz00_bglt;

typedef struct BgL_cstructza2za2_bgl {
   struct BgL_typez00_bgl * BgL_btypez00;
   struct BgL_cstructz00_bgl * BgL_cstructz00;
} *BgL_cstructza2za2_bglt;

typedef struct BgL_tclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   struct BgL_globalz00_bgl * BgL_holderz00;
   obj_t BgL_wideningz00;
   long BgL_depthz00;
   bool_t BgL_finalzf3zf3;
   obj_t BgL_constructorz00;
   obj_t BgL_virtualzd2slotszd2numberz00;
   bool_t BgL_abstractzf3zf3;
} *BgL_tclassz00_bglt;

typedef struct BgL_jclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   obj_t BgL_packagez00;
} *BgL_jclassz00_bglt;


static obj_t BGl_zc3anonymousza32790ze3z83zztype_envz00(obj_t);
static obj_t BGl_methodzd2initzd2zztype_envz00();
static BgL_typez00_bglt BGl_bindzd2typez12zc0zztype_envz00(obj_t, bool_t, obj_t);
static obj_t BGl_zc3anonymousza32802ze3z83zztype_envz00(obj_t);
static obj_t BGl_zc3anonymousza32792ze3z83zztype_envz00(obj_t);
extern bool_t BGl_ctypezf3zf3zzforeign_ctypez00(obj_t);
static obj_t BGl__declarezd2subtypez123200zc0zztype_envz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern long BGl_classzd2numzd2zz__objectz00(obj_t);
extern obj_t BGl_getzd2tenvzd2zztype_envz00();
static obj_t BGl__findzd2type3186zd2zztype_envz00(obj_t, obj_t);
extern obj_t BGl_dynamiczd2windzd2zz__r4_control_features_6_9z00(obj_t, obj_t, obj_t);
static bool_t BGl_za2typeszd2alreadyzd2checkedzf3za2zf3zztype_envz00;
static obj_t BGl_zc3anonymousza32799ze3z83zztype_envz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_foreignzd2accesseszd2addz12z12zzmodule_foreignz00(obj_t);
extern obj_t BGl_readz00zz__readerz00(obj_t);
extern obj_t BGl_addzd2tenvz12zc0zztype_envz00(obj_t);
static obj_t BGl__setzd2tenvz12zc0zztype_envz00(obj_t, obj_t);
extern bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
static obj_t BGl_zc3anonymousza32385ze3z83zztype_envz00(obj_t, obj_t, obj_t);
extern obj_t BGl_forzd2eachzd2typez12z12zztype_envz00(obj_t);
extern obj_t BGl_tclassz00zzobject_classz00;
extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_za2moduleza2z00zzmodule_modulez00;
static obj_t BGl__subzd2typezf33227z21zztype_envz00(obj_t, obj_t, obj_t);
static obj_t BGl__typezd2existszf33188z21zztype_envz00(obj_t, obj_t);
static obj_t BGl_escapez00zztype_envz00(obj_t, obj_t);
extern obj_t BGl_typez00zztype_typez00;
extern obj_t BGl_za2libzd2modeza2zd2zzengine_paramz00;
static obj_t BGl__initializa7ezd2Tenvz12z67zztype_envz00(obj_t);
extern obj_t BGl_hashtablezd2putz12zc0zz__hashz00(obj_t, obj_t, obj_t);
static obj_t BGl_handling_function2782z00zztype_envz00(obj_t, obj_t, obj_t);
static obj_t BGl_zc3anonymousza32688ze3z83zztype_envz00(obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zztype_envz00();
static obj_t BGl_handling_function2724z00zztype_envz00(obj_t, obj_t, obj_t);
static obj_t BGl__declarezd2typez123198zc0zztype_envz00(obj_t, obj_t, obj_t, obj_t);
extern BgL_typez00_bglt BGl_usezd2foreignzd2typezf2importzd2locz12z32zztype_envz00(obj_t, obj_t, obj_t);
static obj_t BGl__getzd2tenvzd2zztype_envz00(obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zztype_envz00();
extern obj_t BGl_makezd2hashtablezd2zz__hashz00(obj_t);
extern obj_t BGl_setzd2tenvz12zc0zztype_envz00(obj_t);
extern BgL_typez00_bglt BGl_usezd2typezf2importzd2locz12ze0zztype_envz00(obj_t, obj_t, obj_t);
static obj_t BGl__addzd2tenvz12zc0zztype_envz00(obj_t, obj_t);
static obj_t BGl_zc3anonymousza32428ze3z83zztype_envz00(obj_t);
extern obj_t BGl_heapzd2addzd2jclassz12z12zzmodule_javaz00(obj_t);
extern obj_t BGl_exitz00zz__errorz00(obj_t);
extern obj_t BGl_notifyzd2errorzd2zz__errorz00(obj_t, obj_t, obj_t);
extern obj_t BGl_displayz00zz__r4_output_6_10_3z00(obj_t, obj_t);
extern obj_t BGl_hashtablezd2forzd2eachz00zz__hashz00(obj_t, obj_t);
extern obj_t BGl_addzd2errorzd2handlerz12z12zz__errorz00(obj_t, obj_t);
static obj_t BGl__usezd2foreignzd2typez123194z12zztype_envz00(obj_t, obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zztype_envz00();
extern BgL_typez00_bglt BGl_declarezd2aliastypez12zc0zztype_envz00(obj_t, obj_t, obj_t, BgL_typez00_bglt);
extern obj_t BGl_jclassz00zzobject_classz00;
static obj_t BGl_zc3anonymousza32443ze3z83zztype_envz00(obj_t, obj_t, obj_t);
extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_classz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_toolsz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzforeign_ctypez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_widezd2accesszd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_plainzd2accesszd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzforeign_accessz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_foreignz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_javaz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__hashz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
extern obj_t BGl_userzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t, obj_t);
extern long bgl_list_length(obj_t);
static obj_t BGl_zc3anonymousza32732ze3z83zztype_envz00(obj_t);
extern obj_t BGl_hashtablezd2getzd2zz__hashz00(obj_t, obj_t);
extern BgL_typez00_bglt BGl_delayzd2classzd2accessorsz12z12zzmodule_classz00(BgL_typez00_bglt, obj_t);
extern obj_t BGl_heapzd2addzd2classz12z12zzobject_classz00(BgL_tclassz00_bglt);
static obj_t BGl_zc3anonymousza32734ze3z83zztype_envz00(obj_t);
static obj_t BGl__usezd2typezf2importzd2locz123192ze0zztype_envz00(obj_t, obj_t, obj_t, obj_t);
extern BgL_typez00_bglt BGl_findzd2typezd2zztype_envz00(obj_t);
extern obj_t BGl_checkzd2typeszd2zztype_envz00();
extern obj_t BGl_heapzd2widezd2classzd2accessorsz12zc0zzobject_widezd2accesszd2(BgL_tclassz00_bglt);
static obj_t BGl_zc3anonymousza32741ze3z83zztype_envz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern BgL_typez00_bglt BGl_usezd2typez12zc0zztype_envz00(obj_t, obj_t);
extern obj_t BGl_shapez00zztools_shapez00(obj_t);
extern obj_t BGl_heapzd2plainzd2classzd2accessorsz12zc0zzobject_plainzd2accesszd2(BgL_tclassz00_bglt);
static obj_t BGl__usezd2foreignzd2typezf2importzd2locz123196z32zztype_envz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_zc3anonymousza32744ze3z83zztype_envz00(obj_t);
extern BgL_typez00_bglt BGl_getzd2defaultzd2typez00zztype_cachez00();
extern obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
extern obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
extern BgL_typez00_bglt BGl_declarezd2subtypez12zc0zztype_envz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl__declarezd2aliastypez123202zc0zztype_envz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl__checkzd2typeszd2zztype_envz00(obj_t);
extern obj_t BGl_makezd2ctypezd2accessesz12z12zzforeign_accessz00(BgL_typez00_bglt, BgL_typez00_bglt, obj_t);
static obj_t BGl_escape_3224z00zztype_envz00(obj_t, obj_t);
static obj_t BGl_zc3anonymousza32688ze3_3207z83zztype_envz00(obj_t, obj_t, obj_t);
static obj_t BGl__forzd2eachzd2typez123204z12zztype_envz00(obj_t, obj_t);
extern obj_t BGl_initializa7ezd2Tenvz12z67zztype_envz00();
extern obj_t BGl_removezd2errorzd2handlerz12z12zz__errorz00();
extern bool_t BGl_subzd2typezf3z21zztype_envz00(BgL_typez00_bglt, BgL_typez00_bglt);
static obj_t BGl_za2Tenvza2z00zztype_envz00 = BUNSPEC;
extern obj_t BGl_makezd2promisezd2zz__r4_control_features_6_9z00(obj_t);
extern bool_t BGl_typezd2existszf3z21zztype_envz00(obj_t);
extern BgL_typez00_bglt BGl_usezd2foreignzd2typez12z12zztype_envz00(obj_t, obj_t);
extern BgL_typez00_bglt BGl_declarezd2typez12zc0zztype_envz00(obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zztype_envz00 = BUNSPEC;
extern obj_t BGl_z42zd2inzd2namezf3zb1zztype_toolsz00(obj_t);
static obj_t BGl_zc3anonymousza32362ze3z83zztype_envz00(obj_t, obj_t, obj_t);
extern obj_t BGl_parsezd2idzd2zzast_identz00(obj_t, obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zztype_envz00();
static obj_t BGl_uninitializa7edzd2typesz75zztype_envz00();
static obj_t BGl__usezd2typez123190zc0zztype_envz00(obj_t, obj_t, obj_t);
static obj_t __cnst[ 3 ] ;

DEFINE_EXPORT_PROCEDURE( BGl_getzd2tenvzd2envz00zztype_envz00, BgL_bgl__getza7d2tenvza7d2za7za7type_envza7003499za7, BGl__getzd2tenvzd2zztype_envz00, 0L, 0 );
DEFINE_EXPORT_PROCEDURE( BGl_addzd2tenvz12zd2envz12zztype_envz00, BgL_bgl__addza7d2tenvza712za7c0za7za7type_envza7003500z00, BGl__addzd2tenvz12zc0zztype_envz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl_usezd2foreignzd2typezf2importzd2locz12zd2envze0zztype_envz00, BgL_bgl__useza7d2foreignza7d2typeza7f2importza7d2locza7123196za732za7za7type_envza7003501za7, BGl__usezd2foreignzd2typezf2importzd2locz123196z32zztype_envz00, 0L, 3 );
DEFINE_STRING( BGl_string3467z00zztype_envz00, BgL_bgl_string3467za700za7za7type_envza7003502z00, "(bigloo C _ java) bigloo the-global-environment ", 48 );
DEFINE_STRING( BGl_string3466z00zztype_envz00, BgL_bgl_string3466za700za7za7type_envza7003503z00, "Undefined type", 14 );
DEFINE_STRING( BGl_string3465z00zztype_envz00, BgL_bgl_string3465za700za7za7type_envza7003504z00, "Undefined used type", 19 );
DEFINE_STRING( BGl_string3464z00zztype_envz00, BgL_bgl_string3464za700za7za7type_envza7003505z00, "Undefined type used in export clause", 36 );
DEFINE_STRING( BGl_string3463z00zztype_envz00, BgL_bgl_string3463za700za7za7type_envza7003506z00, "Stopping compilation...", 23 );
DEFINE_STRING( BGl_string3462z00zztype_envz00, BgL_bgl_string3462za700za7za7type_envza7003507z00, " type(s) used but not defined.", 30 );
DEFINE_STRING( BGl_string3461z00zztype_envz00, BgL_bgl_string3461za700za7za7type_envza7003508z00, "Illegal type class", 18 );
DEFINE_STRING( BGl_string3460z00zztype_envz00, BgL_bgl_string3460za700za7za7type_envza7003509z00, "declare-type!", 13 );
DEFINE_STRING( BGl_string3459z00zztype_envz00, BgL_bgl_string3459za700za7za7type_envza7003510z00, "use-type!", 9 );
DEFINE_STRING( BGl_string3458z00zztype_envz00, BgL_bgl_string3458za700za7za7type_envza7003511z00, "Type redefinition", 17 );
DEFINE_STRING( BGl_string3457z00zztype_envz00, BgL_bgl_string3457za700za7za7type_envza7003512z00, "bind-type!", 10 );
DEFINE_STRING( BGl_string3456z00zztype_envz00, BgL_bgl_string3456za700za7za7type_envza7003513z00, "Can't find type", 15 );
DEFINE_STRING( BGl_string3455z00zztype_envz00, BgL_bgl_string3455za700za7za7type_envza7003514z00, "find-type", 9 );
DEFINE_STRING( BGl_string3454z00zztype_envz00, BgL_bgl_string3454za700za7za7type_envza7003515z00, "Illegal type heap redefinition", 30 );
DEFINE_STRING( BGl_string3453z00zztype_envz00, BgL_bgl_string3453za700za7za7type_envza7003516z00, "add-Tenv!", 9 );
DEFINE_STRING( BGl_string3451z00zztype_envz00, BgL_bgl_string3451za700za7za7type_envza7003517z00, "Can't find super class of", 25 );
DEFINE_STRING( BGl_string3450z00zztype_envz00, BgL_bgl_string3450za700za7za7type_envza7003518z00, "add-Tenv", 8 );
DEFINE_EXPORT_PROCEDURE( BGl_forzd2eachzd2typez12zd2envzc0zztype_envz00, BgL_bgl__forza7d2eachza7d2typeza7123204za712za7za7type_envza7003519za7, BGl__forzd2eachzd2typez123204z12zztype_envz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl_usezd2typezf2importzd2locz12zd2envz32zztype_envz00, BgL_bgl__useza7d2typeza7f2importza7d2locza7123192za7e0za7za7type_envza7003520z00, BGl__usezd2typezf2importzd2locz123192ze0zztype_envz00, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( BGl_declarezd2aliastypez12zd2envz12zztype_envz00, BgL_bgl__declareza7d2aliastypeza7123202za7c0za7za7type_envza7003521z00, BGl__declarezd2aliastypez123202zc0zztype_envz00, 0L, 4 );
DEFINE_EXPORT_PROCEDURE( BGl_subzd2typezf3zd2envzf3zztype_envz00, BgL_bgl__subza7d2typeza7f33227za721za7za7type_envza7003522z00, BGl__subzd2typezf33227z21zztype_envz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_findzd2typezd2envz00zztype_envz00, BgL_bgl__findza7d2type3186za7d2za7za7type_envza7003523za7, BGl__findzd2type3186zd2zztype_envz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl_declarezd2typez12zd2envz12zztype_envz00, BgL_bgl__declareza7d2typeza7123198za7c0za7za7type_envza7003524z00, BGl__declarezd2typez123198zc0zztype_envz00, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( BGl_usezd2typez12zd2envz12zztype_envz00, BgL_bgl__useza7d2typeza7123190za7c0za7za7type_envza7003525z00, BGl__usezd2typez123190zc0zztype_envz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3449z00zztype_envz00, BgL_bgl_za7c3anonymousza7a32385za7e3za783za7za7type_envza7003526za7, BGl_zc3anonymousza32385ze3z83zztype_envz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3452z00zztype_envz00, BgL_bgl_za7c3anonymousza7a32443za7e3za783za7za7type_envza7003527za7, BGl_zc3anonymousza32443ze3z83zztype_envz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_declarezd2subtypez12zd2envz12zztype_envz00, BgL_bgl__declareza7d2subtypeza7123200za7c0za7za7type_envza7003528z00, BGl__declarezd2subtypez123200zc0zztype_envz00, 0L, 4 );
DEFINE_EXPORT_PROCEDURE( BGl_usezd2foreignzd2typez12zd2envzc0zztype_envz00, BgL_bgl__useza7d2foreignza7d2typeza7123194za712za7za7type_envza7003529za7, BGl__usezd2foreignzd2typez123194z12zztype_envz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_typezd2existszf3zd2envzf3zztype_envz00, BgL_bgl__typeza7d2existsza7f33188za721za7za7type_envza7003530z00, BGl__typezd2existszf33188z21zztype_envz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl_initializa7ezd2Tenvz12zd2envzb5zztype_envz00, BgL_bgl__initializa7a7eza7d2tenvza712za767za7za7type_envza7003531za7, BGl__initializa7ezd2Tenvz12z67zztype_envz00, 0L, 0 );
DEFINE_EXPORT_PROCEDURE( BGl_setzd2tenvz12zd2envz12zztype_envz00, BgL_bgl__setza7d2tenvza712za7c0za7za7type_envza7003532z00, BGl__setzd2tenvz12zc0zztype_envz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl_checkzd2typeszd2envz00zztype_envz00, BgL_bgl__checkza7d2typesza7d2za7za7type_envza7003533za7, BGl__checkzd2typeszd2zztype_envz00, 0L, 0 );



/* module-initialization */
obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long BgL_checksumz00_2314, char * BgL_fromz00_2315)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zztype_envz00))
{ 
BGl_requirezd2initializa7ationz75zztype_envz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zztype_envz00(); 
BGl_cnstzd2initzd2zztype_envz00(); 
BGl_importedzd2moduleszd2initz00zztype_envz00(); 
BGl_toplevelzd2initzd2zztype_envz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zztype_envz00()
{ AN_OBJECT;
{ /* Type/tenv.scm 15 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "type_env"); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)0), "type_env"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "type_env"); 
BGl_modulezd2initializa7ationz75zz__hashz00(((long)0), "type_env"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "type_env"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "type_env"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "type_env"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "type_env"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zztype_envz00()
{ AN_OBJECT;
{ /* Type/tenv.scm 15 */
{ /* Type/tenv.scm 15 */
obj_t BgL_cportz00_2307;
BgL_cportz00_2307 = 
open_input_string(BGl_string3467z00zztype_envz00); 
{ 
long BgL_iz00_2308;
BgL_iz00_2308 = ((long)2); 
BgL_loopz00_2309:
if(
(BgL_iz00_2308==((long)-1)))
{ /* Type/tenv.scm 15 */
return BUNSPEC;}  else 
{ /* Type/tenv.scm 15 */
{ /* Type/tenv.scm 15 */
obj_t BgL_arg3471z00_2311;
{ /* Type/tenv.scm 15 */
obj_t BgL_list3474z00_2312;
BgL_list3474z00_2312 = 
MAKE_PAIR(BgL_cportz00_2307, BNIL); 
BgL_arg3471z00_2311 = 
BGl_readz00zz__readerz00(BgL_list3474z00_2312); } 
{ /* Type/tenv.scm 15 */
int BgL_auxz00_2336;
BgL_auxz00_2336 = 
(int)(BgL_iz00_2308); 
CNST_TABLE_SET(BgL_auxz00_2336, BgL_arg3471z00_2311); } } 
{ 
long BgL_iz00_2339;
{ /* Type/tenv.scm 15 */
int BgL_auxz00_2340;
{ /* Type/tenv.scm 15 */
long BgL_auxz00_2341;
BgL_auxz00_2341 = 
(BgL_iz00_2308-((long)1)); 
BgL_auxz00_2340 = 
(int)(BgL_auxz00_2341); } 
BgL_iz00_2339 = 
(long)(BgL_auxz00_2340); } 
BgL_iz00_2308 = BgL_iz00_2339; 
goto BgL_loopz00_2309;} } } } } 
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zztype_envz00()
{ AN_OBJECT;
{ /* Type/tenv.scm 15 */
BGl_za2Tenvza2z00zztype_envz00 = 
CNST_TABLE_REF(((long)0)); 
return ( 
BGl_za2typeszd2alreadyzd2checkedzf3za2zf3zztype_envz00 = ((bool_t)0), BUNSPEC) ;} 
}



/* set-tenv! */
obj_t BGl_setzd2tenvz12zc0zztype_envz00(obj_t BgL_tenvz00_19)
{ AN_OBJECT;
{ /* Type/tenv.scm 69 */
return ( 
BGl_za2Tenvza2z00zztype_envz00 = BgL_tenvz00_19, BUNSPEC) ;} 
}



/* _set-tenv! */
obj_t BGl__setzd2tenvz12zc0zztype_envz00(obj_t BgL_envz00_2176, obj_t BgL_tenvz00_2177)
{ AN_OBJECT;
{ /* Type/tenv.scm 69 */
return 
BGl_setzd2tenvz12zc0zztype_envz00(BgL_tenvz00_2177);} 
}



/* add-tenv! */
obj_t BGl_addzd2tenvz12zc0zztype_envz00(obj_t BgL_tenvz00_20)
{ AN_OBJECT;
{ /* Type/tenv.scm 75 */
{ /* Type/tenv.scm 115 */
obj_t BgL_rememberzd2listzd2_1124;
BgL_rememberzd2listzd2_1124 = 
MAKE_CELL(BNIL); 
{ /* Type/tenv.scm 126 */
obj_t BgL_zc3anonymousza32362ze3z83_2181;
{ 
int BgL_auxz00_2349;int BgL_auxz00_2347;
BgL_auxz00_2349 = 
(int)(((long)1)); 
BgL_auxz00_2347 = 
(int)(((long)2)); 
BgL_zc3anonymousza32362ze3z83_2181 = 
make_fx_procedure(BGl_zc3anonymousza32362ze3z83zztype_envz00, BgL_auxz00_2347, BgL_auxz00_2349); } 
{ /* Type/tenv.scm 126 */
int BgL_auxz00_2352;
BgL_auxz00_2352 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32362ze3z83_2181, BgL_auxz00_2352, BgL_rememberzd2listzd2_1124); } 
BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_tenvz00_20, BgL_zc3anonymousza32362ze3z83_2181); } 
BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_tenvz00_20, BGl_proc3449z00zztype_envz00); 
{ 
obj_t BgL_l2295z00_1147;
BgL_l2295z00_1147 = 
CELL_REF(BgL_rememberzd2listzd2_1124); 
BgL_lname2296z00_1148:
if(
PAIRP(BgL_l2295z00_1147))
{ /* Type/tenv.scm 157 */
{ /* Type/tenv.scm 158 */
obj_t BgL_newz00_1150;
BgL_newz00_1150 = 
CAR(BgL_l2295z00_1147); 
{ /* Type/tenv.scm 158 */
bool_t BgL_test2397z00_1151;
BgL_test2397z00_1151 = 
BGl_iszd2azf3z21zz__objectz00(BgL_newz00_1150, BGl_tclassz00zzobject_classz00); 
if(BgL_test2397z00_1151)
{ /* Type/tenv.scm 159 */
obj_t BgL_superz00_1152;
{ /* Type/tenv.scm 159 */
BgL_tclassz00_bglt BgL_obj2148z00_1657;
BgL_obj2148z00_1657 = 
(BgL_tclassz00_bglt)(BgL_newz00_1150); 
{ 
obj_t BgL_auxz00_2363;
{ /* Type/tenv.scm 159 */
BgL_objectz00_bglt BgL_auxz00_2364;
BgL_auxz00_2364 = 
(BgL_objectz00_bglt)(BgL_obj2148z00_1657); 
BgL_auxz00_2363 = 
BGL_OBJECT_WIDENING(BgL_auxz00_2364); } 
BgL_superz00_1152 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_2363))->BgL_itszd2superzd2); } } 
{ /* Type/tenv.scm 160 */
bool_t BgL_test2398z00_1153;
BgL_test2398z00_1153 = 
BGl_iszd2azf3z21zz__objectz00(BgL_superz00_1152, BGl_tclassz00zzobject_classz00); 
if(BgL_test2398z00_1153)
{ /* Type/tenv.scm 161 */
BgL_typez00_bglt BgL_oldzd2szd2_1155;
{ /* Type/tenv.scm 162 */
obj_t BgL_auxz00_2370;
{ /* Type/tenv.scm 161 */
BgL_typez00_bglt BgL_obj2165z00_1659;
BgL_obj2165z00_1659 = 
(BgL_typez00_bglt)(BgL_superz00_1152); 
BgL_auxz00_2370 = 
(((BgL_typez00_bglt)CREF(BgL_obj2165z00_1659))->BgL_idz00); } 
BgL_oldzd2szd2_1155 = 
BGl_findzd2typezd2zztype_envz00(BgL_auxz00_2370); } 
{ /* Type/tenv.scm 162 */

{ /* Type/tenv.scm 163 */
bool_t BgL_test2399z00_1156;
BgL_test2399z00_1156 = 
BGl_iszd2azf3z21zz__objectz00(
(obj_t)(BgL_oldzd2szd2_1155), BGl_tclassz00zzobject_classz00); 
if(BgL_test2399z00_1156)
{ /* Type/tenv.scm 167 */
BgL_tclassz00_bglt BgL_obj2150z00_1661;obj_t BgL_val2149z00_1662;
BgL_obj2150z00_1661 = 
(BgL_tclassz00_bglt)(BgL_newz00_1150); 
BgL_val2149z00_1662 = 
(obj_t)(BgL_oldzd2szd2_1155); 
{ 
obj_t BgL_auxz00_2379;
{ /* Type/tenv.scm 167 */
BgL_objectz00_bglt BgL_auxz00_2380;
BgL_auxz00_2380 = 
(BgL_objectz00_bglt)(BgL_obj2150z00_1661); 
BgL_auxz00_2379 = 
BGL_OBJECT_WIDENING(BgL_auxz00_2380); } 
((((BgL_tclassz00_bglt)CREF(BgL_auxz00_2379))->BgL_itszd2superzd2) = ((obj_t)BgL_val2149z00_1662), BUNSPEC); } }  else 
{ 
obj_t BgL_auxz00_2384;
{ /* Type/tenv.scm 166 */
BgL_typez00_bglt BgL_obj2166z00_1663;
BgL_obj2166z00_1663 = 
(BgL_typez00_bglt)(BgL_newz00_1150); 
BgL_auxz00_2384 = 
(((BgL_typez00_bglt)CREF(BgL_obj2166z00_1663))->BgL_namez00); } 
FAILURE(BGl_string3450z00zztype_envz00,BGl_string3451z00zztype_envz00,BgL_auxz00_2384);} } } }  else 
{ /* Type/tenv.scm 160 */BFALSE; } } }  else 
{ /* Type/tenv.scm 158 */BFALSE; } } } 
{ 
obj_t BgL_l2295z00_2388;
BgL_l2295z00_2388 = 
CDR(BgL_l2295z00_1147); 
BgL_l2295z00_1147 = BgL_l2295z00_2388; 
goto BgL_lname2296z00_1148;} }  else 
{ /* Type/tenv.scm 157 */((bool_t)1); } } 
{ 
obj_t BgL_l2297z00_1161;
BgL_l2297z00_1161 = 
CELL_REF(BgL_rememberzd2listzd2_1124); 
BgL_lname2298z00_1162:
if(
PAIRP(BgL_l2297z00_1161))
{ /* Type/tenv.scm 174 */
{ /* Type/tenv.scm 175 */
obj_t BgL_newz00_1164;
BgL_newz00_1164 = 
CAR(BgL_l2297z00_1161); 
{ /* Type/tenv.scm 175 */
bool_t BgL_test2421z00_1165;
BgL_test2421z00_1165 = 
BGl_iszd2azf3z21zz__objectz00(BgL_newz00_1164, BGl_tclassz00zzobject_classz00); 
if(BgL_test2421z00_1165)
{ /* Type/tenv.scm 179 */
obj_t BgL_arg2423z00_1166;
{ /* Type/tenv.scm 179 */
obj_t BgL_zc3anonymousza32428ze3z83_2179;
{ 
int BgL_auxz00_2397;int BgL_auxz00_2395;
BgL_auxz00_2397 = 
(int)(((long)1)); 
BgL_auxz00_2395 = 
(int)(((long)0)); 
BgL_zc3anonymousza32428ze3z83_2179 = 
make_fx_procedure(BGl_zc3anonymousza32428ze3z83zztype_envz00, BgL_auxz00_2395, BgL_auxz00_2397); } 
{ /* Type/tenv.scm 179 */
int BgL_auxz00_2400;
BgL_auxz00_2400 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32428ze3z83_2179, BgL_auxz00_2400, BgL_newz00_1164); } 
BgL_arg2423z00_1166 = 
BGl_makezd2promisezd2zz__r4_control_features_6_9z00(BgL_zc3anonymousza32428ze3z83_2179); } 
{ /* Type/tenv.scm 176 */
BgL_typez00_bglt BgL_auxz00_2404;
BgL_auxz00_2404 = 
BGl_delayzd2classzd2accessorsz12z12zzmodule_classz00(
(BgL_typez00_bglt)(BgL_newz00_1164), BgL_arg2423z00_1166); 
(obj_t)(BgL_auxz00_2404); } }  else 
{ /* Type/tenv.scm 175 */BFALSE; } } } 
{ 
obj_t BgL_l2297z00_2408;
BgL_l2297z00_2408 = 
CDR(BgL_l2297z00_1161); 
BgL_l2297z00_1161 = BgL_l2297z00_2408; 
goto BgL_lname2298z00_1162;} }  else 
{ /* Type/tenv.scm 174 */((bool_t)1); } } } 
return 
BGl_hashtablezd2forzd2eachz00zz__hashz00(BGl_za2Tenvza2z00zztype_envz00, BGl_proc3452z00zztype_envz00);} 
}



/* _add-tenv! */
obj_t BGl__addzd2tenvz12zc0zztype_envz00(obj_t BgL_envz00_2182, obj_t BgL_tenvz00_2183)
{ AN_OBJECT;
{ /* Type/tenv.scm 75 */
return 
BGl_addzd2tenvz12zc0zztype_envz00(BgL_tenvz00_2183);} 
}



/* <anonymous:2443> */
obj_t BGl_zc3anonymousza32443ze3z83zztype_envz00(obj_t BgL_envz00_2184, obj_t BgL_kz00_2185, obj_t BgL_newz00_2186)
{ AN_OBJECT;
{ /* Type/tenv.scm 190 */
{ 
obj_t BgL_kz00_1173;obj_t BgL_newz00_1174;
{ /* Type/tenv.scm 191 */
bool_t BgL_auxz00_2412;
BgL_kz00_1173 = BgL_kz00_2185; 
BgL_newz00_1174 = BgL_newz00_2186; 
{ 
obj_t BgL_typez00_1206;
BgL_typez00_1206 = BgL_newz00_1174; 
{ /* Type/tenv.scm 78 */
bool_t BgL_test2495z00_1208;
{ /* Type/tenv.scm 78 */
obj_t BgL_auxz00_2413;
{ /* Type/tenv.scm 78 */
BgL_typez00_bglt BgL_obj1509z00_1695;
BgL_obj1509z00_1695 = 
(BgL_typez00_bglt)(BgL_typez00_1206); 
BgL_auxz00_2413 = 
(((BgL_typez00_bglt)CREF(BgL_obj1509z00_1695))->BgL_aliasz00); } 
BgL_test2495z00_1208 = 
BGl_iszd2azf3z21zz__objectz00(BgL_auxz00_2413, BGl_typez00zztype_typez00); } 
if(BgL_test2495z00_1208)
{ /* Type/tenv.scm 79 */
BgL_typez00_bglt BgL_arg2497z00_1209;
{ /* Type/tenv.scm 79 */
obj_t BgL_auxz00_2418;
{ /* Type/tenv.scm 79 */
BgL_typez00_bglt BgL_obj1484z00_1698;
{ /* Type/tenv.scm 79 */
obj_t BgL_auxz00_2419;
{ /* Type/tenv.scm 79 */
BgL_typez00_bglt BgL_obj1509z00_1697;
BgL_obj1509z00_1697 = 
(BgL_typez00_bglt)(BgL_typez00_1206); 
BgL_auxz00_2419 = 
(((BgL_typez00_bglt)CREF(BgL_obj1509z00_1697))->BgL_aliasz00); } 
BgL_obj1484z00_1698 = 
(BgL_typez00_bglt)(BgL_auxz00_2419); } 
BgL_auxz00_2418 = 
(((BgL_typez00_bglt)CREF(BgL_obj1484z00_1698))->BgL_idz00); } 
BgL_arg2497z00_1209 = 
BGl_findzd2typezd2zztype_envz00(BgL_auxz00_2418); } 
{ /* Type/tenv.scm 79 */
BgL_typez00_bglt BgL_obj1511z00_1699;obj_t BgL_val1510z00_1700;
BgL_obj1511z00_1699 = 
(BgL_typez00_bglt)(BgL_typez00_1206); 
BgL_val1510z00_1700 = 
(obj_t)(BgL_arg2497z00_1209); 
((((BgL_typez00_bglt)CREF(BgL_obj1511z00_1699))->BgL_aliasz00) = ((obj_t)BgL_val1510z00_1700), BUNSPEC); } }  else 
{ /* Type/tenv.scm 78 */BFALSE; } } 
{ /* Type/tenv.scm 82 */
obj_t BgL_arg2511z00_1213;
{ /* Type/tenv.scm 82 */
obj_t BgL_l2286z00_1214;
{ /* Type/tenv.scm 84 */
BgL_typez00_bglt BgL_obj1497z00_1701;
BgL_obj1497z00_1701 = 
(BgL_typez00_bglt)(BgL_typez00_1206); 
BgL_l2286z00_1214 = 
(((BgL_typez00_bglt)CREF(BgL_obj1497z00_1701))->BgL_parentsz00); } 
if(
NULLP(BgL_l2286z00_1214))
{ /* Type/tenv.scm 82 */
BgL_arg2511z00_1213 = BNIL; }  else 
{ /* Type/tenv.scm 82 */
obj_t BgL_head2288z00_1216;
BgL_head2288z00_1216 = 
MAKE_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l2286z00_1217;obj_t BgL_tail2289z00_1218;
BgL_l2286z00_1217 = BgL_l2286z00_1214; 
BgL_tail2289z00_1218 = BgL_head2288z00_1216; 
BgL_lname2287z00_1219:
if(
NULLP(BgL_l2286z00_1217))
{ /* Type/tenv.scm 82 */
BgL_arg2511z00_1213 = 
CDR(BgL_head2288z00_1216); }  else 
{ /* Type/tenv.scm 83 */
obj_t BgL_newtail2290z00_1221;
{ /* Type/tenv.scm 83 */
BgL_typez00_bglt BgL_arg2523z00_1223;
{ /* Type/tenv.scm 83 */
obj_t BgL_auxz00_2436;
{ /* Type/tenv.scm 83 */
BgL_typez00_bglt BgL_obj1484z00_1708;
{ /* Type/tenv.scm 83 */
obj_t BgL_auxz00_2437;
BgL_auxz00_2437 = 
CAR(BgL_l2286z00_1217); 
BgL_obj1484z00_1708 = 
(BgL_typez00_bglt)(BgL_auxz00_2437); } 
BgL_auxz00_2436 = 
(((BgL_typez00_bglt)CREF(BgL_obj1484z00_1708))->BgL_idz00); } 
BgL_arg2523z00_1223 = 
BGl_findzd2typezd2zztype_envz00(BgL_auxz00_2436); } 
{ /* Type/tenv.scm 82 */
obj_t BgL_auxz00_2442;
BgL_auxz00_2442 = 
(obj_t)(BgL_arg2523z00_1223); 
BgL_newtail2290z00_1221 = 
MAKE_PAIR(BgL_auxz00_2442, BNIL); } } 
SET_CDR(BgL_tail2289z00_1218, BgL_newtail2290z00_1221); 
{ 
obj_t BgL_tail2289z00_2448;obj_t BgL_l2286z00_2446;
BgL_l2286z00_2446 = 
CDR(BgL_l2286z00_1217); 
BgL_tail2289z00_2448 = BgL_newtail2290z00_1221; 
BgL_tail2289z00_1218 = BgL_tail2289z00_2448; 
BgL_l2286z00_1217 = BgL_l2286z00_2446; 
goto BgL_lname2287z00_1219;} } } } } 
{ /* Type/tenv.scm 81 */
BgL_typez00_bglt BgL_obj1499z00_1714;
BgL_obj1499z00_1714 = 
(BgL_typez00_bglt)(BgL_typez00_1206); 
((((BgL_typez00_bglt)CREF(BgL_obj1499z00_1714))->BgL_parentsz00) = ((obj_t)BgL_arg2511z00_1213), BUNSPEC); } } 
{ 
obj_t BgL_l2291z00_1227;
{ /* Type/tenv.scm 91 */
BgL_typez00_bglt BgL_obj1494z00_1716;
BgL_obj1494z00_1716 = 
(BgL_typez00_bglt)(BgL_typez00_1206); 
BgL_l2291z00_1227 = 
(((BgL_typez00_bglt)CREF(BgL_obj1494z00_1716))->BgL_coercezd2tozd2); } 
BgL_lname2292z00_1228:
if(
PAIRP(BgL_l2291z00_1227))
{ /* Type/tenv.scm 86 */
{ /* Type/tenv.scm 87 */
obj_t BgL_coercerz00_1231;
BgL_coercerz00_1231 = 
CAR(BgL_l2291z00_1227); 
{ /* Type/tenv.scm 87 */
obj_t BgL_toz00_1233;
{ /* Type/tenv.scm 88 */
int BgL_auxz00_2454;
BgL_auxz00_2454 = 
(int)(((long)1)); 
BgL_toz00_1233 = 
STRUCT_REF(BgL_coercerz00_1231, BgL_auxz00_2454); } 
{ /* Type/tenv.scm 89 */
BgL_typez00_bglt BgL_arg2541z00_1234;
{ /* Type/tenv.scm 89 */
obj_t BgL_auxz00_2457;
{ /* Type/tenv.scm 89 */
BgL_typez00_bglt BgL_obj1484z00_1725;
{ /* Type/tenv.scm 89 */
obj_t BgL_auxz00_2458;
{ /* Type/tenv.scm 87 */
int BgL_auxz00_2459;
BgL_auxz00_2459 = 
(int)(((long)0)); 
BgL_auxz00_2458 = 
STRUCT_REF(BgL_coercerz00_1231, BgL_auxz00_2459); } 
BgL_obj1484z00_1725 = 
(BgL_typez00_bglt)(BgL_auxz00_2458); } 
BgL_auxz00_2457 = 
(((BgL_typez00_bglt)CREF(BgL_obj1484z00_1725))->BgL_idz00); } 
BgL_arg2541z00_1234 = 
BGl_findzd2typezd2zztype_envz00(BgL_auxz00_2457); } 
{ /* Type/tenv.scm 89 */
obj_t BgL_auxz00_2467;int BgL_auxz00_2465;
BgL_auxz00_2467 = 
(obj_t)(BgL_arg2541z00_1234); 
BgL_auxz00_2465 = 
(int)(((long)0)); 
STRUCT_SET(BgL_coercerz00_1231, BgL_auxz00_2465, BgL_auxz00_2467); } } 
{ /* Type/tenv.scm 90 */
BgL_typez00_bglt BgL_arg2550z00_1236;
{ /* Type/tenv.scm 90 */
obj_t BgL_auxz00_2470;
{ /* Type/tenv.scm 90 */
BgL_typez00_bglt BgL_obj1484z00_1731;
BgL_obj1484z00_1731 = 
(BgL_typez00_bglt)(BgL_toz00_1233); 
BgL_auxz00_2470 = 
(((BgL_typez00_bglt)CREF(BgL_obj1484z00_1731))->BgL_idz00); } 
BgL_arg2550z00_1236 = 
BGl_findzd2typezd2zztype_envz00(BgL_auxz00_2470); } 
{ /* Type/tenv.scm 90 */
obj_t BgL_auxz00_2476;int BgL_auxz00_2474;
BgL_auxz00_2476 = 
(obj_t)(BgL_arg2550z00_1236); 
BgL_auxz00_2474 = 
(int)(((long)1)); 
STRUCT_SET(BgL_coercerz00_1231, BgL_auxz00_2474, BgL_auxz00_2476); } } } } 
{ 
obj_t BgL_l2291z00_2479;
BgL_l2291z00_2479 = 
CDR(BgL_l2291z00_1227); 
BgL_l2291z00_1227 = BgL_l2291z00_2479; 
goto BgL_lname2292z00_1228;} }  else 
{ /* Type/tenv.scm 86 */
BgL_auxz00_2412 = ((bool_t)1); } } } 
return 
BBOOL(BgL_auxz00_2412);} } } 
}



/* <anonymous:2428> */
obj_t BGl_zc3anonymousza32428ze3z83zztype_envz00(obj_t BgL_envz00_2187)
{ AN_OBJECT;
{ /* Type/tenv.scm 178 */
{ /* Type/tenv.scm 179 */
obj_t BgL_newz00_2188;
{ /* Type/tenv.scm 179 */
int BgL_auxz00_2484;
BgL_auxz00_2484 = 
(int)(((long)0)); 
BgL_newz00_2188 = 
PROCEDURE_REF(BgL_envz00_2187, BgL_auxz00_2484); } 
{ 

{ /* Type/tenv.scm 179 */
bool_t BgL_testz00_2487;
{ /* Type/tenv.scm 179 */
BgL_tclassz00_bglt BgL_obj2155z00_1671;
BgL_obj2155z00_1671 = 
(BgL_tclassz00_bglt)(BgL_newz00_2188); 
{ /* Type/tenv.scm 179 */
obj_t BgL_auxz00_2489;
{ 
obj_t BgL_auxz00_2490;
{ /* Type/tenv.scm 179 */
BgL_objectz00_bglt BgL_auxz00_2491;
BgL_auxz00_2491 = 
(BgL_objectz00_bglt)(BgL_obj2155z00_1671); 
BgL_auxz00_2490 = 
BGL_OBJECT_WIDENING(BgL_auxz00_2491); } 
BgL_auxz00_2489 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_2490))->BgL_wideningz00); } 
BgL_testz00_2487 = 
CBOOL(BgL_auxz00_2489); } } 
if(BgL_testz00_2487)
{ /* Type/tenv.scm 179 */
return 
BGl_heapzd2widezd2classzd2accessorsz12zc0zzobject_widezd2accesszd2(
(BgL_tclassz00_bglt)(BgL_newz00_2188));}  else 
{ /* Type/tenv.scm 179 */
return 
BGl_heapzd2plainzd2classzd2accessorsz12zc0zzobject_plainzd2accesszd2(
(BgL_tclassz00_bglt)(BgL_newz00_2188));} } } } } 
}



/* <anonymous:2385> */
obj_t BGl_zc3anonymousza32385ze3z83zztype_envz00(obj_t BgL_envz00_2189, obj_t BgL_kz00_2190, obj_t BgL_newz00_2191)
{ AN_OBJECT;
{ /* Type/tenv.scm 148 */
{ 
obj_t BgL_kz00_1138;obj_t BgL_newz00_1139;
BgL_kz00_1138 = BgL_kz00_2190; 
BgL_newz00_1139 = BgL_newz00_2191; 
{ /* Type/tenv.scm 149 */
obj_t BgL_oldz00_1142;
{ /* Type/tenv.scm 150 */
obj_t BgL_auxz00_2500;
{ /* Type/tenv.scm 149 */
BgL_typez00_bglt BgL_obj1484z00_1652;
BgL_obj1484z00_1652 = 
(BgL_typez00_bglt)(BgL_newz00_1139); 
BgL_auxz00_2500 = 
(((BgL_typez00_bglt)CREF(BgL_obj1484z00_1652))->BgL_idz00); } 
BgL_oldz00_1142 = 
BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Tenvza2z00zztype_envz00, BgL_auxz00_2500); } 
{ /* Type/tenv.scm 150 */

{ /* Type/tenv.scm 151 */
bool_t BgL_test2386z00_1143;
BgL_test2386z00_1143 = 
BGl_ctypezf3zf3zzforeign_ctypez00(BgL_oldz00_1142); 
if(BgL_test2386z00_1143)
{ /* Type/tenv.scm 154 */
obj_t BgL_arg2388z00_1145;
{ /* Type/tenv.scm 154 */
obj_t BgL_auxz00_2506;
{ /* Type/tenv.scm 152 */
BgL_typez00_bglt BgL_obj1518z00_1653;
BgL_obj1518z00_1653 = 
(BgL_typez00_bglt)(BgL_oldz00_1142); 
BgL_auxz00_2506 = 
(((BgL_typez00_bglt)CREF(BgL_obj1518z00_1653))->BgL_locationz00); } 
BgL_arg2388z00_1145 = 
BGl_makezd2ctypezd2accessesz12z12zzforeign_accessz00(
(BgL_typez00_bglt)(BgL_oldz00_1142), 
(BgL_typez00_bglt)(BgL_oldz00_1142), BgL_auxz00_2506); } 
return 
BGl_foreignzd2accesseszd2addz12z12zzmodule_foreignz00(BgL_arg2388z00_1145);}  else 
{ /* Type/tenv.scm 151 */
return BFALSE;} } } } } } 
}



/* <anonymous:2362> */
obj_t BGl_zc3anonymousza32362ze3z83zztype_envz00(obj_t BgL_envz00_2192, obj_t BgL_kz00_2194, obj_t BgL_newz00_2195)
{ AN_OBJECT;
{ /* Type/tenv.scm 125 */
{ /* Type/tenv.scm 126 */
obj_t BgL_rememberzd2listzd2_2193;
{ /* Type/tenv.scm 126 */
int BgL_auxz00_2513;
BgL_auxz00_2513 = 
(int)(((long)0)); 
BgL_rememberzd2listzd2_2193 = 
PROCEDURE_REF(BgL_envz00_2192, BgL_auxz00_2513); } 
{ 
obj_t BgL_kz00_1126;obj_t BgL_newz00_1127;
BgL_kz00_1126 = BgL_kz00_2194; 
BgL_newz00_1127 = BgL_newz00_2195; 
{ 
obj_t BgL_oldz00_1177;obj_t BgL_newz00_1178;obj_t BgL_fromz00_1195;BgL_typez00_bglt BgL_toz00_1196;
{ /* Type/tenv.scm 126 */
obj_t BgL_idz00_1129;
{ /* Type/tenv.scm 126 */
BgL_typez00_bglt BgL_obj1484z00_1644;
BgL_obj1484z00_1644 = 
(BgL_typez00_bglt)(BgL_newz00_1127); 
BgL_idz00_1129 = 
(((BgL_typez00_bglt)CREF(BgL_obj1484z00_1644))->BgL_idz00); } 
{ /* Type/tenv.scm 126 */
obj_t BgL_oldz00_1130;
BgL_oldz00_1130 = 
BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Tenvza2z00zztype_envz00, BgL_idz00_1129); 
{ /* Type/tenv.scm 127 */

{ /* Type/tenv.scm 129 */
bool_t BgL_test2363z00_1131;
BgL_test2363z00_1131 = 
BGl_iszd2azf3z21zz__objectz00(BgL_oldz00_1130, BGl_typez00zztype_typez00); 
if(BgL_test2363z00_1131)
{ /* Type/tenv.scm 138 */
bool_t BgL_testz00_2521;
{ /* Type/tenv.scm 138 */
BgL_typez00_bglt BgL_obj1500z00_1646;
BgL_obj1500z00_1646 = 
(BgL_typez00_bglt)(BgL_oldz00_1130); 
BgL_testz00_2521 = 
(((BgL_typez00_bglt)CREF(BgL_obj1500z00_1646))->BgL_initzf3zf3); } 
if(BgL_testz00_2521)
{ /* Type/tenv.scm 138 */
{ /* Type/tenv.scm 146 */
bool_t BgL_auxz00_2524;
BgL_oldz00_1177 = BgL_oldz00_1130; 
BgL_newz00_1178 = BgL_newz00_1127; 
{ 
obj_t BgL_l2293z00_1180;
{ /* Type/tenv.scm 112 */
BgL_typez00_bglt BgL_obj1494z00_1673;
BgL_obj1494z00_1673 = 
(BgL_typez00_bglt)(BgL_newz00_1178); 
BgL_l2293z00_1180 = 
(((BgL_typez00_bglt)CREF(BgL_obj1494z00_1673))->BgL_coercezd2tozd2); } 
BgL_lname2294z00_1181:
if(
PAIRP(BgL_l2293z00_1180))
{ /* Type/tenv.scm 102 */
{ /* Type/tenv.scm 103 */
obj_t BgL_coercerz00_1184;
BgL_coercerz00_1184 = 
CAR(BgL_l2293z00_1180); 
{ /* Type/tenv.scm 104 */
obj_t BgL_tidz00_1187;
{ /* Type/tenv.scm 105 */
BgL_typez00_bglt BgL_obj1484z00_1682;
{ /* Type/tenv.scm 105 */
obj_t BgL_auxz00_2528;
{ /* Type/tenv.scm 104 */
int BgL_auxz00_2529;
BgL_auxz00_2529 = 
(int)(((long)1)); 
BgL_auxz00_2528 = 
STRUCT_REF(BgL_coercerz00_1184, BgL_auxz00_2529); } 
BgL_obj1484z00_1682 = 
(BgL_typez00_bglt)(BgL_auxz00_2528); } 
BgL_tidz00_1187 = 
(((BgL_typez00_bglt)CREF(BgL_obj1484z00_1682))->BgL_idz00); } 
{ /* Type/tenv.scm 106 */

{ /* Type/tenv.scm 107 */
bool_t BgL_test2451z00_1189;
if(
BGl_typezd2existszf3z21zztype_envz00(BgL_tidz00_1187))
{ /* Type/tenv.scm 108 */
bool_t BgL_test2459z00_1192;
{ /* Type/tenv.scm 108 */
BgL_typez00_bglt BgL_arg2461z00_1193;
BgL_arg2461z00_1193 = 
BGl_findzd2typezd2zztype_envz00(BgL_tidz00_1187); 
{ /* Type/tenv.scm 108 */
obj_t BgL_auxz00_2537;
BgL_fromz00_1195 = BgL_oldz00_1177; 
BgL_toz00_1196 = BgL_arg2461z00_1193; 
{ 
obj_t BgL_coercerz00_1198;
{ /* Type/tenv.scm 93 */
BgL_typez00_bglt BgL_obj1494z00_1687;
BgL_obj1494z00_1687 = 
(BgL_typez00_bglt)(BgL_fromz00_1195); 
BgL_coercerz00_1198 = 
(((BgL_typez00_bglt)CREF(BgL_obj1494z00_1687))->BgL_coercezd2tozd2); } 
BgL_loopz00_1199:
if(
NULLP(BgL_coercerz00_1198))
{ /* Type/tenv.scm 95 */
BgL_auxz00_2537 = BFALSE; }  else 
{ /* Type/tenv.scm 97 */
bool_t BgL_testz00_2540;
{ /* Type/tenv.scm 97 */
obj_t BgL_auxz00_2547;obj_t BgL_auxz00_2541;
BgL_auxz00_2547 = 
(obj_t)(BgL_toz00_1196); 
{ /* Type/tenv.scm 97 */
int BgL_auxz00_2544;obj_t BgL_auxz00_2542;
BgL_auxz00_2544 = 
(int)(((long)1)); 
BgL_auxz00_2542 = 
CAR(BgL_coercerz00_1198); 
BgL_auxz00_2541 = 
STRUCT_REF(BgL_auxz00_2542, BgL_auxz00_2544); } 
BgL_testz00_2540 = 
(BgL_auxz00_2541==BgL_auxz00_2547); } 
if(BgL_testz00_2540)
{ /* Type/tenv.scm 97 */
BgL_auxz00_2537 = 
CAR(BgL_coercerz00_1198); }  else 
{ /* Type/tenv.scm 97 */
{ 
obj_t BgL_coercerz00_2551;
BgL_coercerz00_2551 = 
CDR(BgL_coercerz00_1198); 
BgL_coercerz00_1198 = BgL_coercerz00_2551; 
goto BgL_loopz00_1199;} } } } 
BgL_test2459z00_1192 = 
CBOOL(BgL_auxz00_2537); } } 
if(BgL_test2459z00_1192)
{ /* Type/tenv.scm 108 */
BgL_test2451z00_1189 = ((bool_t)0); }  else 
{ /* Type/tenv.scm 108 */
BgL_test2451z00_1189 = ((bool_t)1); } }  else 
{ /* Type/tenv.scm 107 */
BgL_test2451z00_1189 = ((bool_t)1); } 
if(BgL_test2451z00_1189)
{ /* Type/tenv.scm 111 */
obj_t BgL_arg2453z00_1190;
{ /* Type/tenv.scm 110 */
obj_t BgL_auxz00_2558;
{ /* Type/tenv.scm 111 */
BgL_typez00_bglt BgL_obj1494z00_1683;
BgL_obj1494z00_1683 = 
(BgL_typez00_bglt)(BgL_oldz00_1177); 
BgL_auxz00_2558 = 
(((BgL_typez00_bglt)CREF(BgL_obj1494z00_1683))->BgL_coercezd2tozd2); } 
BgL_arg2453z00_1190 = 
MAKE_PAIR(BgL_coercerz00_1184, BgL_auxz00_2558); } 
{ /* Type/tenv.scm 109 */
BgL_typez00_bglt BgL_obj1496z00_1684;
BgL_obj1496z00_1684 = 
(BgL_typez00_bglt)(BgL_oldz00_1177); 
((((BgL_typez00_bglt)CREF(BgL_obj1496z00_1684))->BgL_coercezd2tozd2) = ((obj_t)BgL_arg2453z00_1190), BUNSPEC); } }  else 
{ /* Type/tenv.scm 107 */BFALSE; } } } } } 
{ 
obj_t BgL_l2293z00_2564;
BgL_l2293z00_2564 = 
CDR(BgL_l2293z00_1180); 
BgL_l2293z00_1180 = BgL_l2293z00_2564; 
goto BgL_lname2294z00_1181;} }  else 
{ /* Type/tenv.scm 102 */
BgL_auxz00_2524 = ((bool_t)1); } } 
return 
BBOOL(BgL_auxz00_2524);} }  else 
{ /* Type/tenv.scm 138 */
FAILURE(BGl_string3453z00zztype_envz00,BGl_string3454z00zztype_envz00,BgL_idz00_1129);} }  else 
{ /* Type/tenv.scm 129 */
BGl_hashtablezd2putz12zc0zz__hashz00(BGl_za2Tenvza2z00zztype_envz00, BgL_idz00_1129, BgL_newz00_1127); 
{ /* Type/tenv.scm 131 */
bool_t BgL_test2372z00_1134;
BgL_test2372z00_1134 = 
BGl_iszd2azf3z21zz__objectz00(BgL_newz00_1127, BGl_tclassz00zzobject_classz00); 
if(BgL_test2372z00_1134)
{ /* Type/tenv.scm 131 */
BGl_heapzd2addzd2classz12z12zzobject_classz00(
(BgL_tclassz00_bglt)(BgL_newz00_1127)); 
{ /* Type/tenv.scm 134 */
obj_t BgL_auxz00_2196;
{ /* Type/tenv.scm 135 */
obj_t BgL_auxz00_2579;
BgL_auxz00_2579 = 
CELL_REF(BgL_rememberzd2listzd2_2193); 
BgL_auxz00_2196 = 
MAKE_PAIR(BgL_newz00_1127, BgL_auxz00_2579); } 
CELL_SET(BgL_rememberzd2listzd2_2193, BgL_auxz00_2196); } }  else 
{ /* Type/tenv.scm 131 */BFALSE; } } 
{ /* Type/tenv.scm 136 */
bool_t BgL_test2376z00_1135;
BgL_test2376z00_1135 = 
BGl_iszd2azf3z21zz__objectz00(BgL_newz00_1127, BGl_jclassz00zzobject_classz00); 
if(BgL_test2376z00_1135)
{ /* Type/tenv.scm 136 */
return 
BGl_heapzd2addzd2jclassz12z12zzmodule_javaz00(BgL_newz00_1127);}  else 
{ /* Type/tenv.scm 136 */
return BFALSE;} } } } } } } } } } } 
}



/* get-tenv */
obj_t BGl_getzd2tenvzd2zztype_envz00()
{ AN_OBJECT;
{ /* Type/tenv.scm 196 */
return BGl_za2Tenvza2z00zztype_envz00;} 
}



/* _get-tenv */
obj_t BGl__getzd2tenvzd2zztype_envz00(obj_t BgL_envz00_2197)
{ AN_OBJECT;
{ /* Type/tenv.scm 196 */
return 
BGl_getzd2tenvzd2zztype_envz00();} 
}



/* initialize-Tenv! */
obj_t BGl_initializa7ezd2Tenvz12z67zztype_envz00()
{ AN_OBJECT;
{ /* Type/tenv.scm 202 */
return ( 
BGl_za2Tenvza2z00zztype_envz00 = 
BGl_makezd2hashtablezd2zz__hashz00(BNIL), BUNSPEC) ;} 
}



/* _initialize-Tenv! */
obj_t BGl__initializa7ezd2Tenvz12z67zztype_envz00(obj_t BgL_envz00_2198)
{ AN_OBJECT;
{ /* Type/tenv.scm 202 */
return 
BGl_initializa7ezd2Tenvz12z67zztype_envz00();} 
}



/* find-type */
BgL_typez00_bglt BGl_findzd2typezd2zztype_envz00(obj_t BgL_idz00_21)
{ AN_OBJECT;
{ /* Type/tenv.scm 209 */
{ /* Type/tenv.scm 210 */
obj_t BgL_typez00_1243;
BgL_typez00_1243 = 
BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Tenvza2z00zztype_envz00, BgL_idz00_21); 
{ /* Type/tenv.scm 211 */
bool_t BgL_test2566z00_1244;
BgL_test2566z00_1244 = 
BGl_iszd2azf3z21zz__objectz00(BgL_typez00_1243, BGl_typez00zztype_typez00); 
if(BgL_test2566z00_1244)
{ /* Type/tenv.scm 211 */
return 
(BgL_typez00_bglt)(BgL_typez00_1243);}  else 
{ /* Type/tenv.scm 211 */
FAILURE(BGl_string3455z00zztype_envz00,BGl_string3456z00zztype_envz00,BgL_idz00_21);} } } } 
}



/* _find-type3186 */
obj_t BGl__findzd2type3186zd2zztype_envz00(obj_t BgL_envz00_2199, obj_t BgL_idz00_2200)
{ AN_OBJECT;
{ /* Type/tenv.scm 209 */
{ /* Type/tenv.scm 210 */
BgL_typez00_bglt BgL_auxz00_2592;
BgL_auxz00_2592 = 
BGl_findzd2typezd2zztype_envz00(BgL_idz00_2200); 
return 
(obj_t)(BgL_auxz00_2592);} } 
}



/* type-exists? */
bool_t BGl_typezd2existszf3z21zztype_envz00(obj_t BgL_idz00_22)
{ AN_OBJECT;
{ /* Type/tenv.scm 220 */
{ /* Type/tenv.scm 221 */
obj_t BgL_typez00_1245;
BgL_typez00_1245 = 
BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Tenvza2z00zztype_envz00, BgL_idz00_22); 
{ /* Type/tenv.scm 222 */
bool_t BgL_test2570z00_1246;
BgL_test2570z00_1246 = 
BGl_iszd2azf3z21zz__objectz00(BgL_typez00_1245, BGl_typez00zztype_typez00); 
if(BgL_test2570z00_1246)
{ /* Type/tenv.scm 224 */
BgL_typez00_bglt BgL_obj1500z00_1743;
BgL_obj1500z00_1743 = 
(BgL_typez00_bglt)(BgL_typez00_1245); 
return 
(((BgL_typez00_bglt)CREF(BgL_obj1500z00_1743))->BgL_initzf3zf3);}  else 
{ /* Type/tenv.scm 222 */
return ((bool_t)0);} } } } 
}



/* _type-exists?3188 */
obj_t BGl__typezd2existszf33188z21zztype_envz00(obj_t BgL_envz00_2201, obj_t BgL_idz00_2202)
{ AN_OBJECT;
{ /* Type/tenv.scm 220 */
{ /* Type/tenv.scm 221 */
bool_t BgL_auxz00_2600;
BgL_auxz00_2600 = 
BGl_typezd2existszf3z21zztype_envz00(BgL_idz00_2202); 
return 
BBOOL(BgL_auxz00_2600);} } 
}



/* bind-type! */
BgL_typez00_bglt BGl_bindzd2typez12zc0zztype_envz00(obj_t BgL_idz00_23, bool_t BgL_initzf3zf3_24, obj_t BgL_locz00_25)
{ AN_OBJECT;
{ /* Type/tenv.scm 229 */
{ /* Type/tenv.scm 230 */
obj_t BgL_typez00_1247;
BgL_typez00_1247 = 
BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Tenvza2z00zztype_envz00, BgL_idz00_23); 
{ /* Type/tenv.scm 231 */
bool_t BgL_test2574z00_1248;
BgL_test2574z00_1248 = 
BGl_iszd2azf3z21zz__objectz00(BgL_typez00_1247, BGl_typez00zztype_typez00); 
if(BgL_test2574z00_1248)
{ /* Type/tenv.scm 232 */
bool_t BgL_test2575z00_1249;
if(
CBOOL(BGl_za2libzd2modeza2zd2zzengine_paramz00))
{ /* Type/tenv.scm 232 */
BgL_test2575z00_1249 = ((bool_t)0); }  else 
{ /* Type/tenv.scm 232 */
BgL_typez00_bglt BgL_obj1500z00_1745;
BgL_obj1500z00_1745 = 
(BgL_typez00_bglt)(BgL_typez00_1247); 
BgL_test2575z00_1249 = 
(((BgL_typez00_bglt)CREF(BgL_obj1500z00_1745))->BgL_initzf3zf3); } 
if(BgL_test2575z00_1249)
{ /* Type/tenv.scm 233 */
obj_t BgL_arg2579z00_1252;
BgL_arg2579z00_1252 = 
BGl_shapez00zztools_shapez00(BgL_typez00_1247); 
{ /* Type/tenv.scm 233 */
obj_t BgL_auxz00_2612;
BgL_auxz00_2612 = 
BGl_userzd2errorzd2zztools_errorz00(BGl_string3457z00zztype_envz00, BGl_string3458z00zztype_envz00, BgL_arg2579z00_1252, BNIL); 
return 
(BgL_typez00_bglt)(BgL_auxz00_2612);} }  else 
{ /* Type/tenv.scm 232 */
if(BgL_initzf3zf3_24)
{ /* Type/tenv.scm 237 */
BgL_typez00_bglt BgL_obj1502z00_1746;
BgL_obj1502z00_1746 = 
(BgL_typez00_bglt)(BgL_typez00_1247); 
((((BgL_typez00_bglt)CREF(BgL_obj1502z00_1746))->BgL_initzf3zf3) = ((bool_t)((bool_t)1)), BUNSPEC); }  else 
{ /* Type/tenv.scm 237 */BFALSE; } 
return 
(BgL_typez00_bglt)(BgL_typez00_1247);} }  else 
{ /* Type/tenv.scm 240 */
BgL_typez00_bglt BgL_newz00_1254;
{ /* Type/tenv.scm 240 */
obj_t BgL_arg2587z00_1255;obj_t BgL_arg2588z00_1256;bool_t BgL_arg2591z00_1259;obj_t BgL_arg2592z00_1260;
BgL_arg2587z00_1255 = BgL_idz00_23; 
BgL_arg2588z00_1256 = 
CNST_TABLE_REF(((long)1)); 
BgL_arg2591z00_1259 = BgL_initzf3zf3_24; 
BgL_arg2592z00_1260 = BgL_locz00_25; 
{ /* Type/tenv.scm 240 */
BgL_typez00_bglt BgL_res3168z00_1799;
{ /* Type/tenv.scm 240 */
BgL_typez00_bglt BgL_new1568z00_1762;
{ /* Type/tenv.scm 240 */
BgL_typez00_bglt BgL_res3166z00_1768;
{ /* Type/tenv.scm 240 */
BgL_typez00_bglt BgL_new1570z00_1763;
BgL_new1570z00_1763 = 
((BgL_typez00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_typez00_bgl) ))); 
{ /* Type/tenv.scm 240 */
long BgL_arg3033z00_1764;
BgL_arg3033z00_1764 = 
BGl_classzd2numzd2zz__objectz00(BGl_typez00zztype_typez00); 
{ /* Type/tenv.scm 240 */
BgL_objectz00_bglt BgL_auxz00_2622;
BgL_auxz00_2622 = 
(BgL_objectz00_bglt)(BgL_new1570z00_1763); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_2622, BgL_arg3033z00_1764); } } 
{ /* Type/tenv.scm 240 */
BgL_objectz00_bglt BgL_auxz00_2625;
BgL_auxz00_2625 = 
(BgL_objectz00_bglt)(BgL_new1570z00_1763); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_2625, BFALSE); } 
{ /* Type/tenv.scm 240 */
obj_t BgL_auxz00_2628;
BgL_auxz00_2628 = 
(obj_t)(BgL_new1570z00_1763); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_2628); } BUNSPEC; 
BgL_res3166z00_1768 = BgL_new1570z00_1763; } 
BgL_new1568z00_1762 = BgL_res3166z00_1768; } 
{ /* Type/tenv.scm 240 */
BgL_typez00_bglt BgL_res3167z00_1798;
((((BgL_typez00_bglt)CREF(BgL_new1568z00_1762))->BgL_idz00) = ((obj_t)BgL_arg2587z00_1255), BUNSPEC); 
((((BgL_typez00_bglt)CREF(BgL_new1568z00_1762))->BgL_namez00) = ((obj_t)BUNSPEC), BUNSPEC); 
((((BgL_typez00_bglt)CREF(BgL_new1568z00_1762))->BgL_siza7eza7) = ((obj_t)BUNSPEC), BUNSPEC); 
((((BgL_typez00_bglt)CREF(BgL_new1568z00_1762))->BgL_classz00) = ((obj_t)BgL_arg2588z00_1256), BUNSPEC); 
((((BgL_typez00_bglt)CREF(BgL_new1568z00_1762))->BgL_coercezd2tozd2) = ((obj_t)BNIL), BUNSPEC); 
((((BgL_typez00_bglt)CREF(BgL_new1568z00_1762))->BgL_parentsz00) = ((obj_t)BNIL), BUNSPEC); 
((((BgL_typez00_bglt)CREF(BgL_new1568z00_1762))->BgL_initzf3zf3) = ((bool_t)BgL_arg2591z00_1259), BUNSPEC); 
((((BgL_typez00_bglt)CREF(BgL_new1568z00_1762))->BgL_magiczf3zf3) = ((bool_t)((bool_t)0)), BUNSPEC); 
((((BgL_typez00_bglt)CREF(BgL_new1568z00_1762))->BgL_z42z42) = ((obj_t)BTRUE), BUNSPEC); 
((((BgL_typez00_bglt)CREF(BgL_new1568z00_1762))->BgL_aliasz00) = ((obj_t)BFALSE), BUNSPEC); 
((((BgL_typez00_bglt)CREF(BgL_new1568z00_1762))->BgL_pointedzd2tozd2byz00) = ((obj_t)BFALSE), BUNSPEC); 
((((BgL_typez00_bglt)CREF(BgL_new1568z00_1762))->BgL_tvectorz00) = ((obj_t)BUNSPEC), BUNSPEC); 
((((BgL_typez00_bglt)CREF(BgL_new1568z00_1762))->BgL_locationz00) = ((obj_t)BgL_arg2592z00_1260), BUNSPEC); 
((((BgL_typez00_bglt)CREF(BgL_new1568z00_1762))->BgL_importzd2locationzd2) = ((obj_t)BFALSE), BUNSPEC); 
BgL_res3167z00_1798 = BgL_new1568z00_1762; BgL_res3167z00_1798; } 
BgL_res3168z00_1799 = BgL_new1568z00_1762; } 
BgL_newz00_1254 = BgL_res3168z00_1799; } } 
BGl_hashtablezd2putz12zc0zz__hashz00(BGl_za2Tenvza2z00zztype_envz00, BgL_idz00_23, 
(obj_t)(BgL_newz00_1254)); 
return BgL_newz00_1254;} } } } 
}



/* use-type! */
BgL_typez00_bglt BGl_usezd2typez12zc0zztype_envz00(obj_t BgL_idz00_26, obj_t BgL_locz00_27)
{ AN_OBJECT;
{ /* Type/tenv.scm 247 */
{ /* Type/tenv.scm 249 */
obj_t BgL_typez00_1261;
BgL_typez00_1261 = 
BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Tenvza2z00zztype_envz00, BgL_idz00_26); 
{ /* Type/tenv.scm 251 */
bool_t BgL_test2596z00_1262;
BgL_test2596z00_1262 = 
BGl_iszd2azf3z21zz__objectz00(BgL_typez00_1261, BGl_typez00zztype_typez00); 
if(BgL_test2596z00_1262)
{ /* Type/tenv.scm 251 */
return 
(BgL_typez00_bglt)(BgL_typez00_1261);}  else 
{ /* Type/tenv.scm 251 */
if(BGl_za2typeszd2alreadyzd2checkedzf3za2zf3zztype_envz00)
{ /* Type/tenv.scm 253 */
{ /* Type/tenv.scm 254 */
obj_t BgL_auxz00_2652;
BgL_auxz00_2652 = 
BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_27, BGl_string3459z00zztype_envz00, BGl_string3456z00zztype_envz00, BgL_idz00_26, BNIL); 
return 
(BgL_typez00_bglt)(BgL_auxz00_2652);} }  else 
{ /* Type/tenv.scm 253 */
return 
BGl_bindzd2typez12zc0zztype_envz00(BgL_idz00_26, ((bool_t)0), BgL_locz00_27);} } } } } 
}



/* _use-type!3190 */
obj_t BGl__usezd2typez123190zc0zztype_envz00(obj_t BgL_envz00_2203, obj_t BgL_idz00_2204, obj_t BgL_locz00_2205)
{ AN_OBJECT;
{ /* Type/tenv.scm 247 */
{ /* Type/tenv.scm 248 */
BgL_typez00_bglt BgL_auxz00_2656;
BgL_auxz00_2656 = 
BGl_usezd2typez12zc0zztype_envz00(BgL_idz00_2204, BgL_locz00_2205); 
return 
(obj_t)(BgL_auxz00_2656);} } 
}



/* use-type/import-loc! */
BgL_typez00_bglt BGl_usezd2typezf2importzd2locz12ze0zztype_envz00(obj_t BgL_idz00_28, obj_t BgL_locz00_29, obj_t BgL_lociz00_30)
{ AN_OBJECT;
{ /* Type/tenv.scm 262 */
{ /* Type/tenv.scm 264 */
obj_t BgL_typez00_1264;
BgL_typez00_1264 = 
BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Tenvza2z00zztype_envz00, BgL_idz00_28); 
{ /* Type/tenv.scm 266 */
bool_t BgL_test2602z00_1265;
BgL_test2602z00_1265 = 
BGl_iszd2azf3z21zz__objectz00(BgL_typez00_1264, BGl_typez00zztype_typez00); 
if(BgL_test2602z00_1265)
{ /* Type/tenv.scm 266 */
return 
(BgL_typez00_bglt)(BgL_typez00_1264);}  else 
{ /* Type/tenv.scm 266 */
if(BGl_za2typeszd2alreadyzd2checkedzf3za2zf3zztype_envz00)
{ /* Type/tenv.scm 268 */
{ /* Type/tenv.scm 269 */
obj_t BgL_auxz00_2664;
BgL_auxz00_2664 = 
BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_29, BGl_string3459z00zztype_envz00, BGl_string3456z00zztype_envz00, BgL_idz00_28, BNIL); 
return 
(BgL_typez00_bglt)(BgL_auxz00_2664);} }  else 
{ /* Type/tenv.scm 268 */
{ /* Type/tenv.scm 272 */
BgL_typez00_bglt BgL_typez00_1267;
BgL_typez00_1267 = 
BGl_bindzd2typez12zc0zztype_envz00(BgL_idz00_28, ((bool_t)0), BgL_locz00_29); 
((((BgL_typez00_bglt)CREF(BgL_typez00_1267))->BgL_importzd2locationzd2) = ((obj_t)BgL_lociz00_30), BUNSPEC); 
return BgL_typez00_1267;} } } } } } 
}



/* _use-type/import-loc!3192 */
obj_t BGl__usezd2typezf2importzd2locz123192ze0zztype_envz00(obj_t BgL_envz00_2206, obj_t BgL_idz00_2207, obj_t BgL_locz00_2208, obj_t BgL_lociz00_2209)
{ AN_OBJECT;
{ /* Type/tenv.scm 262 */
{ /* Type/tenv.scm 263 */
BgL_typez00_bglt BgL_auxz00_2669;
BgL_auxz00_2669 = 
BGl_usezd2typezf2importzd2locz12ze0zztype_envz00(BgL_idz00_2207, BgL_locz00_2208, BgL_lociz00_2209); 
return 
(obj_t)(BgL_auxz00_2669);} } 
}



/* use-foreign-type! */
BgL_typez00_bglt BGl_usezd2foreignzd2typez12z12zztype_envz00(obj_t BgL_idz00_31, obj_t BgL_locz00_32)
{ AN_OBJECT;
{ /* Type/tenv.scm 285 */
{ /* Type/tenv.scm 287 */
obj_t BgL_tidz00_1268;
BgL_tidz00_1268 = 
BGl_parsezd2idzd2zzast_identz00(BgL_idz00_31, BgL_locz00_32); 
{ /* Type/tenv.scm 292 */
bool_t BgL_test2609z00_1269;
{ /* Type/tenv.scm 292 */
obj_t BgL_arg2616z00_1271;BgL_typez00_bglt BgL_arg2617z00_1272;
BgL_arg2616z00_1271 = 
CDR(BgL_tidz00_1268); 
BgL_arg2617z00_1272 = 
BGl_getzd2defaultzd2typez00zztype_cachez00(); 
{ /* Type/tenv.scm 292 */
obj_t BgL_auxz00_2675;
BgL_auxz00_2675 = 
(obj_t)(BgL_arg2617z00_1272); 
BgL_test2609z00_1269 = 
(BgL_arg2616z00_1271==BgL_auxz00_2675); } } 
if(BgL_test2609z00_1269)
{ /* Type/tenv.scm 292 */
return 
BGl_usezd2typez12zc0zztype_envz00(
CAR(BgL_tidz00_1268), BgL_locz00_32);}  else 
{ /* Type/tenv.scm 296 */
obj_t BgL_auxz00_2681;
BgL_auxz00_2681 = 
CDR(BgL_tidz00_1268); 
return 
(BgL_typez00_bglt)(BgL_auxz00_2681);} } } } 
}



/* _use-foreign-type!3194 */
obj_t BGl__usezd2foreignzd2typez123194z12zztype_envz00(obj_t BgL_envz00_2210, obj_t BgL_idz00_2211, obj_t BgL_locz00_2212)
{ AN_OBJECT;
{ /* Type/tenv.scm 285 */
{ /* Type/tenv.scm 286 */
BgL_typez00_bglt BgL_auxz00_2684;
BgL_auxz00_2684 = 
BGl_usezd2foreignzd2typez12z12zztype_envz00(BgL_idz00_2211, BgL_locz00_2212); 
return 
(obj_t)(BgL_auxz00_2684);} } 
}



/* use-foreign-type/import-loc! */
BgL_typez00_bglt BGl_usezd2foreignzd2typezf2importzd2locz12z32zztype_envz00(obj_t BgL_idz00_33, obj_t BgL_locz00_34, obj_t BgL_lociz00_35)
{ AN_OBJECT;
{ /* Type/tenv.scm 307 */
{ /* Type/tenv.scm 309 */
obj_t BgL_tidz00_1273;
BgL_tidz00_1273 = 
BGl_parsezd2idzd2zzast_identz00(BgL_idz00_33, BgL_locz00_34); 
{ /* Type/tenv.scm 314 */
bool_t BgL_test2622z00_1274;
{ /* Type/tenv.scm 314 */
obj_t BgL_arg2629z00_1276;BgL_typez00_bglt BgL_arg2630z00_1277;
BgL_arg2629z00_1276 = 
CDR(BgL_tidz00_1273); 
BgL_arg2630z00_1277 = 
BGl_getzd2defaultzd2typez00zztype_cachez00(); 
{ /* Type/tenv.scm 314 */
obj_t BgL_auxz00_2690;
BgL_auxz00_2690 = 
(obj_t)(BgL_arg2630z00_1277); 
BgL_test2622z00_1274 = 
(BgL_arg2629z00_1276==BgL_auxz00_2690); } } 
if(BgL_test2622z00_1274)
{ /* Type/tenv.scm 314 */
return 
BGl_usezd2typezf2importzd2locz12ze0zztype_envz00(
CAR(BgL_tidz00_1273), BgL_locz00_34, BgL_lociz00_35);}  else 
{ /* Type/tenv.scm 318 */
obj_t BgL_auxz00_2696;
BgL_auxz00_2696 = 
CDR(BgL_tidz00_1273); 
return 
(BgL_typez00_bglt)(BgL_auxz00_2696);} } } } 
}



/* _use-foreign-type/import-loc!3196 */
obj_t BGl__usezd2foreignzd2typezf2importzd2locz123196z32zztype_envz00(obj_t BgL_envz00_2213, obj_t BgL_idz00_2214, obj_t BgL_locz00_2215, obj_t BgL_lociz00_2216)
{ AN_OBJECT;
{ /* Type/tenv.scm 307 */
{ /* Type/tenv.scm 308 */
BgL_typez00_bglt BgL_auxz00_2699;
BgL_auxz00_2699 = 
BGl_usezd2foreignzd2typezf2importzd2locz12z32zztype_envz00(BgL_idz00_2214, BgL_locz00_2215, BgL_lociz00_2216); 
return 
(obj_t)(BgL_auxz00_2699);} } 
}



/* declare-type! */
BgL_typez00_bglt BGl_declarezd2typez12zc0zztype_envz00(obj_t BgL_idz00_36, obj_t BgL_namez00_37, obj_t BgL_classz00_38)
{ AN_OBJECT;
{ /* Type/tenv.scm 323 */
{ /* Type/tenv.scm 325 */
bool_t BgL_testz00_2702;
{ /* Type/tenv.scm 325 */
obj_t BgL_auxz00_2703;
BgL_auxz00_2703 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_classz00_38, 
CNST_TABLE_REF(((long)2))); 
BgL_testz00_2702 = 
CBOOL(BgL_auxz00_2703); } 
if(BgL_testz00_2702)
{ /* Type/tenv.scm 329 */
BgL_typez00_bglt BgL_typez00_1279;
BgL_typez00_1279 = 
BGl_bindzd2typez12zc0zztype_envz00(BgL_idz00_36, ((bool_t)1), BUNSPEC); 
((((BgL_typez00_bglt)CREF(BgL_typez00_1279))->BgL_namez00) = ((obj_t)BgL_namez00_37), BUNSPEC); 
{ /* Type/tenv.scm 331 */
obj_t BgL_arg2638z00_1280;
BgL_arg2638z00_1280 = 
BGl_z42zd2inzd2namezf3zb1zztype_toolsz00(BgL_namez00_37); 
((((BgL_typez00_bglt)CREF(BgL_typez00_1279))->BgL_z42z42) = ((obj_t)BgL_arg2638z00_1280), BUNSPEC); } 
((((BgL_typez00_bglt)CREF(BgL_typez00_1279))->BgL_classz00) = ((obj_t)BgL_classz00_38), BUNSPEC); 
return BgL_typez00_1279;}  else 
{ /* Type/tenv.scm 326 */
obj_t BgL_auxz00_2712;
BgL_auxz00_2712 = 
BGl_userzd2errorzd2zztools_errorz00(BGl_string3460z00zztype_envz00, BGl_string3461z00zztype_envz00, BgL_classz00_38, BNIL); 
return 
(BgL_typez00_bglt)(BgL_auxz00_2712);} } } 
}



/* _declare-type!3198 */
obj_t BGl__declarezd2typez123198zc0zztype_envz00(obj_t BgL_envz00_2217, obj_t BgL_idz00_2218, obj_t BgL_namez00_2219, obj_t BgL_classz00_2220)
{ AN_OBJECT;
{ /* Type/tenv.scm 323 */
{ /* Type/tenv.scm 324 */
BgL_typez00_bglt BgL_auxz00_2715;
BgL_auxz00_2715 = 
BGl_declarezd2typez12zc0zztype_envz00(BgL_idz00_2218, BgL_namez00_2219, BgL_classz00_2220); 
return 
(obj_t)(BgL_auxz00_2715);} } 
}



/* declare-subtype! */
BgL_typez00_bglt BGl_declarezd2subtypez12zc0zztype_envz00(obj_t BgL_idz00_39, obj_t BgL_namez00_40, obj_t BgL_parentsz00_41, obj_t BgL_classz00_42)
{ AN_OBJECT;
{ /* Type/tenv.scm 340 */
{ /* Type/tenv.scm 343 */
BgL_typez00_bglt BgL_typez00_1282;obj_t BgL_parentsz00_1283;
BgL_typez00_1282 = 
BGl_bindzd2typez12zc0zztype_envz00(BgL_idz00_39, ((bool_t)1), BUNSPEC); 
if(
NULLP(BgL_parentsz00_41))
{ /* Type/tenv.scm 344 */
BgL_parentsz00_1283 = BNIL; }  else 
{ /* Type/tenv.scm 344 */
obj_t BgL_head2302z00_1287;
{ /* Type/tenv.scm 344 */
BgL_typez00_bglt BgL_arg2675z00_1298;
BgL_arg2675z00_1298 = 
BGl_findzd2typezd2zztype_envz00(
CAR(BgL_parentsz00_41)); 
{ /* Type/tenv.scm 344 */
obj_t BgL_auxz00_2723;
BgL_auxz00_2723 = 
(obj_t)(BgL_arg2675z00_1298); 
BgL_head2302z00_1287 = 
MAKE_PAIR(BgL_auxz00_2723, BNIL); } } 
{ 
obj_t BgL_l2300z00_1288;obj_t BgL_tail2303z00_1289;
BgL_l2300z00_1288 = 
CDR(BgL_parentsz00_41); 
BgL_tail2303z00_1289 = BgL_head2302z00_1287; 
BgL_lname2301z00_1290:
if(
NULLP(BgL_l2300z00_1288))
{ /* Type/tenv.scm 344 */
BgL_parentsz00_1283 = BgL_head2302z00_1287; }  else 
{ /* Type/tenv.scm 344 */
obj_t BgL_newtail2304z00_1293;
{ /* Type/tenv.scm 344 */
BgL_typez00_bglt BgL_arg2666z00_1295;
BgL_arg2666z00_1295 = 
BGl_findzd2typezd2zztype_envz00(
CAR(BgL_l2300z00_1288)); 
{ /* Type/tenv.scm 344 */
obj_t BgL_auxz00_2730;
BgL_auxz00_2730 = 
(obj_t)(BgL_arg2666z00_1295); 
BgL_newtail2304z00_1293 = 
MAKE_PAIR(BgL_auxz00_2730, BNIL); } } 
SET_CDR(BgL_tail2303z00_1289, BgL_newtail2304z00_1293); 
{ 
obj_t BgL_tail2303z00_2736;obj_t BgL_l2300z00_2734;
BgL_l2300z00_2734 = 
CDR(BgL_l2300z00_1288); 
BgL_tail2303z00_2736 = BgL_newtail2304z00_1293; 
BgL_tail2303z00_1289 = BgL_tail2303z00_2736; 
BgL_l2300z00_1288 = BgL_l2300z00_2734; 
goto BgL_lname2301z00_1290;} } } } 
((((BgL_typez00_bglt)CREF(BgL_typez00_1282))->BgL_namez00) = ((obj_t)BgL_namez00_40), BUNSPEC); 
{ /* Type/tenv.scm 346 */
obj_t BgL_arg2648z00_1284;
BgL_arg2648z00_1284 = 
BGl_z42zd2inzd2namezf3zb1zztype_toolsz00(BgL_namez00_40); 
((((BgL_typez00_bglt)CREF(BgL_typez00_1282))->BgL_z42z42) = ((obj_t)BgL_arg2648z00_1284), BUNSPEC); } 
((((BgL_typez00_bglt)CREF(BgL_typez00_1282))->BgL_classz00) = ((obj_t)BgL_classz00_42), BUNSPEC); 
((((BgL_typez00_bglt)CREF(BgL_typez00_1282))->BgL_parentsz00) = ((obj_t)BgL_parentsz00_1283), BUNSPEC); 
return BgL_typez00_1282;} } 
}



/* _declare-subtype!3200 */
obj_t BGl__declarezd2subtypez123200zc0zztype_envz00(obj_t BgL_envz00_2221, obj_t BgL_idz00_2222, obj_t BgL_namez00_2223, obj_t BgL_parentsz00_2224, obj_t BgL_classz00_2225)
{ AN_OBJECT;
{ /* Type/tenv.scm 340 */
{ /* Type/tenv.scm 341 */
BgL_typez00_bglt BgL_auxz00_2743;
BgL_auxz00_2743 = 
BGl_declarezd2subtypez12zc0zztype_envz00(BgL_idz00_2222, BgL_namez00_2223, BgL_parentsz00_2224, BgL_classz00_2225); 
return 
(obj_t)(BgL_auxz00_2743);} } 
}



/* declare-aliastype! */
BgL_typez00_bglt BGl_declarezd2aliastypez12zc0zztype_envz00(obj_t BgL_idz00_43, obj_t BgL_namez00_44, obj_t BgL_classz00_45, BgL_typez00_bglt BgL_aliasz00_46)
{ AN_OBJECT;
{ /* Type/tenv.scm 354 */
{ /* Type/tenv.scm 356 */
BgL_typez00_bglt BgL_typez00_1836;
BgL_typez00_1836 = 
BGl_declarezd2typez12zc0zztype_envz00(BgL_idz00_43, BgL_namez00_44, BgL_classz00_45); 
{ /* Type/tenv.scm 356 */
obj_t BgL_val1510z00_1838;
BgL_val1510z00_1838 = 
(obj_t)(BgL_aliasz00_46); 
((((BgL_typez00_bglt)CREF(BgL_typez00_1836))->BgL_aliasz00) = ((obj_t)BgL_val1510z00_1838), BUNSPEC); } 
return BgL_typez00_1836;} } 
}



/* _declare-aliastype!3202 */
obj_t BGl__declarezd2aliastypez123202zc0zztype_envz00(obj_t BgL_envz00_2226, obj_t BgL_idz00_2227, obj_t BgL_namez00_2228, obj_t BgL_classz00_2229, obj_t BgL_aliasz00_2230)
{ AN_OBJECT;
{ /* Type/tenv.scm 354 */
{ /* Type/tenv.scm 355 */
BgL_typez00_bglt BgL_auxz00_2749;
BgL_auxz00_2749 = 
BGl_declarezd2aliastypez12zc0zztype_envz00(BgL_idz00_2227, BgL_namez00_2228, BgL_classz00_2229, 
(BgL_typez00_bglt)(BgL_aliasz00_2230)); 
return 
(obj_t)(BgL_auxz00_2749);} } 
}



/* for-each-type! */
obj_t BGl_forzd2eachzd2typez12z12zztype_envz00(obj_t BgL_procz00_47)
{ AN_OBJECT;
{ /* Type/tenv.scm 363 */
{ /* Type/tenv.scm 364 */
obj_t BgL_zc3anonymousza32688ze3z83_2231;
{ 
int BgL_auxz00_2755;int BgL_auxz00_2753;
BgL_auxz00_2755 = 
(int)(((long)1)); 
BgL_auxz00_2753 = 
(int)(((long)2)); 
BgL_zc3anonymousza32688ze3z83_2231 = 
make_fx_procedure(BGl_zc3anonymousza32688ze3z83zztype_envz00, BgL_auxz00_2753, BgL_auxz00_2755); } 
{ /* Type/tenv.scm 364 */
int BgL_auxz00_2758;
BgL_auxz00_2758 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32688ze3z83_2231, BgL_auxz00_2758, BgL_procz00_47); } 
return 
BGl_hashtablezd2forzd2eachz00zz__hashz00(BGl_za2Tenvza2z00zztype_envz00, BgL_zc3anonymousza32688ze3z83_2231);} } 
}



/* _for-each-type!3204 */
obj_t BGl__forzd2eachzd2typez123204z12zztype_envz00(obj_t BgL_envz00_2232, obj_t BgL_procz00_2233)
{ AN_OBJECT;
{ /* Type/tenv.scm 363 */
return 
BGl_forzd2eachzd2typez12z12zztype_envz00(BgL_procz00_2233);} 
}



/* <anonymous:2688> */
obj_t BGl_zc3anonymousza32688ze3z83zztype_envz00(obj_t BgL_envz00_2234, obj_t BgL_kz00_2236, obj_t BgL_xz00_2237)
{ AN_OBJECT;
{ /* Type/tenv.scm 364 */
{ /* Type/tenv.scm 364 */
obj_t BgL_procz00_2235;
{ /* Type/tenv.scm 364 */
int BgL_auxz00_2763;
BgL_auxz00_2763 = 
(int)(((long)0)); 
BgL_procz00_2235 = 
PROCEDURE_REF(BgL_envz00_2234, BgL_auxz00_2763); } 
{ 
obj_t BgL_kz00_1840;obj_t BgL_xz00_1841;
BgL_kz00_1840 = BgL_kz00_2236; 
BgL_xz00_1841 = BgL_xz00_2237; 
return 
PROCEDURE_ENTRY(BgL_procz00_2235)(BgL_procz00_2235, BgL_xz00_1841, BEOA);} } } 
}



/* uninitialized-types */
obj_t BGl_uninitializa7edzd2typesz75zztype_envz00()
{ AN_OBJECT;
{ /* Type/tenv.scm 371 */
{ /* Type/tenv.scm 372 */
obj_t BgL_uninitz00_1307;
BgL_uninitz00_1307 = 
MAKE_CELL(BNIL); 
{ /* Type/tenv.scm 373 */
obj_t BgL_zc3anonymousza32688ze3z83_2238;
{ 
int BgL_auxz00_2770;int BgL_auxz00_2768;
BgL_auxz00_2770 = 
(int)(((long)1)); 
BgL_auxz00_2768 = 
(int)(((long)2)); 
BgL_zc3anonymousza32688ze3z83_2238 = 
make_fx_procedure(BGl_zc3anonymousza32688ze3_3207z83zztype_envz00, BgL_auxz00_2768, BgL_auxz00_2770); } 
{ /* Type/tenv.scm 373 */
int BgL_auxz00_2773;
BgL_auxz00_2773 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32688ze3z83_2238, BgL_auxz00_2773, BgL_uninitz00_1307); } 
BGl_hashtablezd2forzd2eachz00zz__hashz00(BGl_za2Tenvza2z00zztype_envz00, BgL_zc3anonymousza32688ze3z83_2238); } 
return 
CELL_REF(BgL_uninitz00_1307);} } 
}



/* <anonymous:2688>_3207 */
obj_t BGl_zc3anonymousza32688ze3_3207z83zztype_envz00(obj_t BgL_envz00_2239, obj_t BgL_kz00_2241, obj_t BgL_xz00_2242)
{ AN_OBJECT;
{ /* Type/tenv.scm 364 */
{ /* Type/tenv.scm 373 */
obj_t BgL_uninitz00_2240;
{ /* Type/tenv.scm 373 */
int BgL_auxz00_2777;
BgL_auxz00_2777 = 
(int)(((long)0)); 
BgL_uninitz00_2240 = 
PROCEDURE_REF(BgL_envz00_2239, BgL_auxz00_2777); } 
{ 
obj_t BgL_kz00_1843;obj_t BgL_xz00_1844;
BgL_kz00_1843 = BgL_kz00_2241; 
BgL_xz00_1844 = BgL_xz00_2242; 
{ 
obj_t BgL_tz00_1309;
BgL_tz00_1309 = BgL_xz00_1844; 
{ /* Type/tenv.scm 374 */
bool_t BgL_testz00_2780;
{ /* Type/tenv.scm 374 */
BgL_typez00_bglt BgL_obj1500z00_1845;
BgL_obj1500z00_1845 = 
(BgL_typez00_bglt)(BgL_tz00_1309); 
BgL_testz00_2780 = 
(((BgL_typez00_bglt)CREF(BgL_obj1500z00_1845))->BgL_initzf3zf3); } 
if(BgL_testz00_2780)
{ /* Type/tenv.scm 374 */
return BFALSE;}  else 
{ /* Type/tenv.scm 375 */
obj_t BgL_auxz00_2243;
{ /* Type/tenv.scm 375 */
obj_t BgL_auxz00_2783;
BgL_auxz00_2783 = 
CELL_REF(BgL_uninitz00_2240); 
BgL_auxz00_2243 = 
MAKE_PAIR(BgL_tz00_1309, BgL_auxz00_2783); } 
return 
CELL_SET(BgL_uninitz00_2240, BgL_auxz00_2243);} } } } } } 
}



/* check-types */
obj_t BGl_checkzd2typeszd2zztype_envz00()
{ AN_OBJECT;
{ /* Type/tenv.scm 392 */
{ /* Type/tenv.scm 393 */
obj_t BgL_utz00_1313;
BgL_utz00_1313 = 
BGl_uninitializa7edzd2typesz75zztype_envz00(); 
if(
PAIRP(BgL_utz00_1313))
{ /* Type/tenv.scm 394 */
{ /* Type/tenv.scm 396 */
obj_t BgL_arg2699z00_1315;
BgL_arg2699z00_1315 = 
GET_CURRENT_ERROR_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2699z00_1315); } 
{ /* Type/tenv.scm 397 */
obj_t BgL_port2305z00_1316;
BgL_port2305z00_1316 = 
GET_CURRENT_ERROR_PORT(); 
{ /* Type/tenv.scm 398 */
long BgL_arg2703z00_1317;
BgL_arg2703z00_1317 = 
bgl_list_length(BgL_utz00_1313); 
{ /* Type/tenv.scm 397 */
obj_t BgL_list2705z00_1318;
BgL_list2705z00_1318 = 
MAKE_PAIR(BgL_port2305z00_1316, BNIL); 
BGl_displayz00zz__r4_output_6_10_3z00(
BINT(BgL_arg2703z00_1317), BgL_list2705z00_1318); } } 
{ /* Type/tenv.scm 397 */
obj_t BgL_list2709z00_1319;
BgL_list2709z00_1319 = 
MAKE_PAIR(BgL_port2305z00_1316, BNIL); 
BGl_displayz00zz__r4_output_6_10_3z00(BGl_string3462z00zztype_envz00, BgL_list2709z00_1319); } 
WRITE_CHAR(((unsigned char)'\n'), BgL_port2305z00_1316); } 
{ 
obj_t BgL_utz00_1320;
BgL_utz00_1320 = BgL_utz00_1313; 
BgL_loopz00_1321:
if(
NULLP(BgL_utz00_1320))
{ /* Type/tenv.scm 402 */
{ /* Type/tenv.scm 403 */
obj_t BgL_port2306z00_1323;
BgL_port2306z00_1323 = 
GET_CURRENT_ERROR_PORT(); 
{ /* Type/tenv.scm 403 */
obj_t BgL_list2716z00_1324;
BgL_list2716z00_1324 = 
MAKE_PAIR(BgL_port2306z00_1323, BNIL); 
BGl_displayz00zz__r4_output_6_10_3z00(BGl_string3463z00zztype_envz00, BgL_list2716z00_1324); } 
WRITE_CHAR(((unsigned char)'\n'), BgL_port2306z00_1323); } 
{ /* Type/tenv.scm 404 */
obj_t BgL_list2721z00_1325;
{ /* Type/tenv.scm 404 */
obj_t BgL_auxz00_2804;
BgL_auxz00_2804 = 
BINT(((long)-1)); 
BgL_list2721z00_1325 = 
MAKE_PAIR(BgL_auxz00_2804, BNIL); } 
BGl_exitz00zz__errorz00(BgL_list2721z00_1325); } }  else 
{ /* Type/tenv.scm 405 */
bool_t BgL_test2723z00_1326;
BgL_test2723z00_1326 = 
BGl_iszd2azf3z21zz__objectz00(
CAR(BgL_utz00_1320), BGl_typez00zztype_typez00); 
if(BgL_test2723z00_1326)
{ /* Type/tenv.scm 405 */
{ /* Type/tenv.scm 406 */
obj_t BgL_armed2310z00_1327;
BgL_armed2310z00_1327 = 
MAKE_CELL(BUNSPEC); 
{ /* Type/tenv.scm 416 */
obj_t BgL_zc3anonymousza32744ze3z83_2245;obj_t BgL_zc3anonymousza32741ze3z83_2247;
{ 
int BgL_auxz00_2813;int BgL_auxz00_2811;
BgL_auxz00_2813 = 
(int)(((long)1)); 
BgL_auxz00_2811 = 
(int)(((long)0)); 
BgL_zc3anonymousza32744ze3z83_2245 = 
make_fx_procedure(BGl_zc3anonymousza32744ze3z83zztype_envz00, BgL_auxz00_2811, BgL_auxz00_2813); } 
{ 
int BgL_auxz00_2818;int BgL_auxz00_2816;
BgL_auxz00_2818 = 
(int)(((long)1)); 
BgL_auxz00_2816 = 
(int)(((long)4)); 
BgL_zc3anonymousza32741ze3z83_2247 = 
make_fx_procedure(BGl_zc3anonymousza32741ze3z83zztype_envz00, BgL_auxz00_2816, BgL_auxz00_2818); } 
{ /* Type/tenv.scm 416 */
int BgL_auxz00_2821;
BgL_auxz00_2821 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32744ze3z83_2245, BgL_auxz00_2821, BgL_utz00_1320); } 
{ /* Type/tenv.scm 416 */
int BgL_auxz00_2824;
BgL_auxz00_2824 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32741ze3z83_2247, BgL_auxz00_2824, BgL_armed2310z00_1327); } 
CELL_SET(BgL_armed2310z00_1327, BTRUE); 
BGl_handling_function2724z00zztype_envz00(BgL_zc3anonymousza32744ze3z83_2245, BgL_zc3anonymousza32741ze3z83_2247, BgL_armed2310z00_1327); } } 
{ 
obj_t BgL_utz00_2828;
BgL_utz00_2828 = 
CDR(BgL_utz00_1320); 
BgL_utz00_1320 = BgL_utz00_2828; 
goto BgL_loopz00_1321;} }  else 
{ /* Type/tenv.scm 405 */
{ /* Type/tenv.scm 420 */
obj_t BgL_armed2318z00_1372;
BgL_armed2318z00_1372 = 
MAKE_CELL(BUNSPEC); 
{ /* Type/tenv.scm 424 */
obj_t BgL_zc3anonymousza32802ze3z83_2250;obj_t BgL_zc3anonymousza32799ze3z83_2252;
{ 
int BgL_auxz00_2832;int BgL_auxz00_2830;
BgL_auxz00_2832 = 
(int)(((long)1)); 
BgL_auxz00_2830 = 
(int)(((long)0)); 
BgL_zc3anonymousza32802ze3z83_2250 = 
make_fx_procedure(BGl_zc3anonymousza32802ze3z83zztype_envz00, BgL_auxz00_2830, BgL_auxz00_2832); } 
{ 
int BgL_auxz00_2837;int BgL_auxz00_2835;
BgL_auxz00_2837 = 
(int)(((long)1)); 
BgL_auxz00_2835 = 
(int)(((long)4)); 
BgL_zc3anonymousza32799ze3z83_2252 = 
make_fx_procedure(BGl_zc3anonymousza32799ze3z83zztype_envz00, BgL_auxz00_2835, BgL_auxz00_2837); } 
{ /* Type/tenv.scm 424 */
int BgL_auxz00_2840;
BgL_auxz00_2840 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32802ze3z83_2250, BgL_auxz00_2840, BgL_utz00_1320); } 
{ /* Type/tenv.scm 424 */
int BgL_auxz00_2843;
BgL_auxz00_2843 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32799ze3z83_2252, BgL_auxz00_2843, BgL_armed2318z00_1372); } 
CELL_SET(BgL_armed2318z00_1372, BTRUE); 
BGl_handling_function2782z00zztype_envz00(BgL_zc3anonymousza32802ze3z83_2250, BgL_zc3anonymousza32799ze3z83_2252, BgL_armed2318z00_1372); } } 
{ 
obj_t BgL_utz00_2847;
BgL_utz00_2847 = 
CDR(BgL_utz00_1320); 
BgL_utz00_1320 = BgL_utz00_2847; 
goto BgL_loopz00_1321;} } } } }  else 
{ /* Type/tenv.scm 394 */BFALSE; } 
return ( 
BGl_za2typeszd2alreadyzd2checkedzf3za2zf3zztype_envz00 = ((bool_t)1), BUNSPEC) ;} } 
}



/* handling_function2782 */
obj_t BGl_handling_function2782z00zztype_envz00(obj_t BgL_zc3anonymousza32802ze3z83_2302, obj_t BgL_zc3anonymousza32799ze3z83_2301, obj_t BgL_armed2318z00_2300)
{ AN_OBJECT;
{ /* Type/tenv.scm 420 */
jmp_buf jmpbuf; 
obj_t BgL_an_exit2319z00_1377;
if( SET_EXIT(BgL_an_exit2319z00_1377) ) { RESTORE_TRACE(); 
return 
_exit_value_;
} else {
BgL_an_exit2319z00_1377 = 
(obj_t)jmpbuf; 
{ /* Type/tenv.scm 420 */

PUSH_EXIT(BgL_an_exit2319z00_1377, ((bool_t)1)); 
{ /* Type/tenv.scm 420 */
obj_t BgL_an_exitd2320z00_1378;
BgL_an_exitd2320z00_1378 = 
BGL_GET_EXITD_TOP(); 
{ /* Type/tenv.scm 420 */
obj_t BgL_escapez00_2251;
{ 
int BgL_auxz00_2855;int BgL_auxz00_2853;
BgL_auxz00_2855 = 
(int)(((long)1)); 
BgL_auxz00_2853 = 
(int)(((long)1)); 
BgL_escapez00_2251 = 
make_fx_procedure(BGl_escape_3224z00zztype_envz00, BgL_auxz00_2853, BgL_auxz00_2855); } 
{ /* Type/tenv.scm 420 */
int BgL_auxz00_2858;
BgL_auxz00_2858 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_escapez00_2251, BgL_auxz00_2858, BgL_an_exitd2320z00_1378); } 
{ /* Type/tenv.scm 420 */
obj_t BgL_res2322z00_1381;
{ /* Type/tenv.scm 420 */
obj_t BgL_zc3anonymousza32792ze3z83_2249;obj_t BgL_zc3anonymousza32790ze3z83_2253;
{ 
int BgL_auxz00_2863;int BgL_auxz00_2861;
BgL_auxz00_2863 = 
(int)(((long)1)); 
BgL_auxz00_2861 = 
(int)(((long)0)); 
BgL_zc3anonymousza32792ze3z83_2249 = 
make_fx_procedure(BGl_zc3anonymousza32792ze3z83zztype_envz00, BgL_auxz00_2861, BgL_auxz00_2863); } 
{ 
int BgL_auxz00_2868;int BgL_auxz00_2866;
BgL_auxz00_2868 = 
(int)(((long)4)); 
BgL_auxz00_2866 = 
(int)(((long)0)); 
BgL_zc3anonymousza32790ze3z83_2253 = 
make_fx_procedure(BGl_zc3anonymousza32790ze3z83zztype_envz00, BgL_auxz00_2866, BgL_auxz00_2868); } 
{ /* Type/tenv.scm 420 */
int BgL_auxz00_2871;
BgL_auxz00_2871 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32792ze3z83_2249, BgL_auxz00_2871, BgL_armed2318z00_2300); } 
{ /* Type/tenv.scm 420 */
int BgL_auxz00_2874;
BgL_auxz00_2874 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32790ze3z83_2253, BgL_auxz00_2874, BgL_an_exitd2320z00_1378); } 
{ /* Type/tenv.scm 420 */
int BgL_auxz00_2877;
BgL_auxz00_2877 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_zc3anonymousza32790ze3z83_2253, BgL_auxz00_2877, BgL_armed2318z00_2300); } 
{ /* Type/tenv.scm 420 */
int BgL_auxz00_2880;
BgL_auxz00_2880 = 
(int)(((long)2)); 
PROCEDURE_SET(BgL_zc3anonymousza32790ze3z83_2253, BgL_auxz00_2880, BgL_zc3anonymousza32799ze3z83_2301); } 
{ /* Type/tenv.scm 420 */
int BgL_auxz00_2883;
BgL_auxz00_2883 = 
(int)(((long)3)); 
PROCEDURE_SET(BgL_zc3anonymousza32790ze3z83_2253, BgL_auxz00_2883, BgL_escapez00_2251); } 
BgL_res2322z00_1381 = 
BGl_dynamiczd2windzd2zz__r4_control_features_6_9z00(BgL_zc3anonymousza32790ze3z83_2253, BgL_zc3anonymousza32802ze3z83_2302, BgL_zc3anonymousza32792ze3z83_2249); } 
POP_EXIT(); 
return BgL_res2322z00_1381;} } } } 
} } 
}



/* handling_function2724 */
obj_t BGl_handling_function2724z00zztype_envz00(obj_t BgL_zc3anonymousza32744ze3z83_2305, obj_t BgL_zc3anonymousza32741ze3z83_2304, obj_t BgL_armed2310z00_2303)
{ AN_OBJECT;
{ /* Type/tenv.scm 406 */
jmp_buf jmpbuf; 
obj_t BgL_an_exit2311z00_1332;
if( SET_EXIT(BgL_an_exit2311z00_1332) ) { RESTORE_TRACE(); 
return 
_exit_value_;
} else {
BgL_an_exit2311z00_1332 = 
(obj_t)jmpbuf; 
{ /* Type/tenv.scm 406 */

PUSH_EXIT(BgL_an_exit2311z00_1332, ((bool_t)1)); 
{ /* Type/tenv.scm 406 */
obj_t BgL_an_exitd2312z00_1333;
BgL_an_exitd2312z00_1333 = 
BGL_GET_EXITD_TOP(); 
{ /* Type/tenv.scm 406 */
obj_t BgL_escapez00_2246;
{ 
int BgL_auxz00_2894;int BgL_auxz00_2892;
BgL_auxz00_2894 = 
(int)(((long)1)); 
BgL_auxz00_2892 = 
(int)(((long)1)); 
BgL_escapez00_2246 = 
make_fx_procedure(BGl_escapez00zztype_envz00, BgL_auxz00_2892, BgL_auxz00_2894); } 
{ /* Type/tenv.scm 406 */
int BgL_auxz00_2897;
BgL_auxz00_2897 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_escapez00_2246, BgL_auxz00_2897, BgL_an_exitd2312z00_1333); } 
{ /* Type/tenv.scm 406 */
obj_t BgL_res2314z00_1336;
{ /* Type/tenv.scm 406 */
obj_t BgL_zc3anonymousza32734ze3z83_2244;obj_t BgL_zc3anonymousza32732ze3z83_2248;
{ 
int BgL_auxz00_2902;int BgL_auxz00_2900;
BgL_auxz00_2902 = 
(int)(((long)1)); 
BgL_auxz00_2900 = 
(int)(((long)0)); 
BgL_zc3anonymousza32734ze3z83_2244 = 
make_fx_procedure(BGl_zc3anonymousza32734ze3z83zztype_envz00, BgL_auxz00_2900, BgL_auxz00_2902); } 
{ 
int BgL_auxz00_2907;int BgL_auxz00_2905;
BgL_auxz00_2907 = 
(int)(((long)4)); 
BgL_auxz00_2905 = 
(int)(((long)0)); 
BgL_zc3anonymousza32732ze3z83_2248 = 
make_fx_procedure(BGl_zc3anonymousza32732ze3z83zztype_envz00, BgL_auxz00_2905, BgL_auxz00_2907); } 
{ /* Type/tenv.scm 406 */
int BgL_auxz00_2910;
BgL_auxz00_2910 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32734ze3z83_2244, BgL_auxz00_2910, BgL_armed2310z00_2303); } 
{ /* Type/tenv.scm 406 */
int BgL_auxz00_2913;
BgL_auxz00_2913 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32732ze3z83_2248, BgL_auxz00_2913, BgL_an_exitd2312z00_1333); } 
{ /* Type/tenv.scm 406 */
int BgL_auxz00_2916;
BgL_auxz00_2916 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_zc3anonymousza32732ze3z83_2248, BgL_auxz00_2916, BgL_armed2310z00_2303); } 
{ /* Type/tenv.scm 406 */
int BgL_auxz00_2919;
BgL_auxz00_2919 = 
(int)(((long)2)); 
PROCEDURE_SET(BgL_zc3anonymousza32732ze3z83_2248, BgL_auxz00_2919, BgL_zc3anonymousza32741ze3z83_2304); } 
{ /* Type/tenv.scm 406 */
int BgL_auxz00_2922;
BgL_auxz00_2922 = 
(int)(((long)3)); 
PROCEDURE_SET(BgL_zc3anonymousza32732ze3z83_2248, BgL_auxz00_2922, BgL_escapez00_2246); } 
BgL_res2314z00_1336 = 
BGl_dynamiczd2windzd2zz__r4_control_features_6_9z00(BgL_zc3anonymousza32732ze3z83_2248, BgL_zc3anonymousza32744ze3z83_2305, BgL_zc3anonymousza32734ze3z83_2244); } 
POP_EXIT(); 
return BgL_res2314z00_1336;} } } } 
} } 
}



/* _check-types */
obj_t BGl__checkzd2typeszd2zztype_envz00(obj_t BgL_envz00_2254)
{ AN_OBJECT;
{ /* Type/tenv.scm 392 */
return 
BGl_checkzd2typeszd2zztype_envz00();} 
}



/* <anonymous:2734> */
obj_t BGl_zc3anonymousza32734ze3z83zztype_envz00(obj_t BgL_envz00_2255)
{ AN_OBJECT;
{ /* Type/tenv.scm 406 */
{ /* Type/tenv.scm 406 */
obj_t BgL_armed2310z00_2256;
{ /* Type/tenv.scm 406 */
int BgL_auxz00_2928;
BgL_auxz00_2928 = 
(int)(((long)0)); 
BgL_armed2310z00_2256 = 
PROCEDURE_REF(BgL_envz00_2255, BgL_auxz00_2928); } 
{ 

{ /* Type/tenv.scm 406 */
bool_t BgL_testz00_2931;
{ /* Type/tenv.scm 406 */
obj_t BgL_auxz00_2932;
BgL_auxz00_2932 = 
CELL_REF(BgL_armed2310z00_2256); 
BgL_testz00_2931 = 
CBOOL(BgL_auxz00_2932); } 
if(BgL_testz00_2931)
{ /* Type/tenv.scm 406 */
CELL_SET(BgL_armed2310z00_2256, BFALSE); 
return 
BGl_removezd2errorzd2handlerz12z12zz__errorz00();}  else 
{ /* Type/tenv.scm 406 */
return BFALSE;} } } } } 
}



/* <anonymous:2744> */
obj_t BGl_zc3anonymousza32744ze3z83zztype_envz00(obj_t BgL_envz00_2258)
{ AN_OBJECT;
{ /* Type/tenv.scm 406 */
{ /* Type/tenv.scm 406 */
obj_t BgL_utz00_2259;
{ /* Type/tenv.scm 406 */
int BgL_auxz00_2935;
BgL_auxz00_2935 = 
(int)(((long)0)); 
BgL_utz00_2259 = 
PROCEDURE_REF(BgL_envz00_2258, BgL_auxz00_2935); } 
{ 

{ /* Type/tenv.scm 406 */
bool_t BgL_testz00_2938;
{ /* Type/tenv.scm 406 */
BgL_typez00_bglt BgL_obj1521z00_1858;
{ /* Type/tenv.scm 406 */
obj_t BgL_auxz00_2939;
BgL_auxz00_2939 = 
CAR(BgL_utz00_2259); 
BgL_obj1521z00_1858 = 
(BgL_typez00_bglt)(BgL_auxz00_2939); } 
{ /* Type/tenv.scm 406 */
obj_t BgL_auxz00_2942;
BgL_auxz00_2942 = 
(((BgL_typez00_bglt)CREF(BgL_obj1521z00_1858))->BgL_importzd2locationzd2); 
BgL_testz00_2938 = 
CBOOL(BgL_auxz00_2942); } } 
if(BgL_testz00_2938)
{ /* Type/tenv.scm 407 */
obj_t BgL_arg2747z00_1355;obj_t BgL_arg2749z00_1357;
{ /* Type/tenv.scm 407 */
BgL_typez00_bglt BgL_obj1521z00_1860;
{ /* Type/tenv.scm 407 */
obj_t BgL_auxz00_2945;
BgL_auxz00_2945 = 
CAR(BgL_utz00_2259); 
BgL_obj1521z00_1860 = 
(BgL_typez00_bglt)(BgL_auxz00_2945); } 
BgL_arg2747z00_1355 = 
(((BgL_typez00_bglt)CREF(BgL_obj1521z00_1860))->BgL_importzd2locationzd2); } 
BgL_arg2749z00_1357 = 
BGl_shapez00zztools_shapez00(
CAR(BgL_utz00_2259)); 
return 
BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_arg2747z00_1355, BGl_za2moduleza2z00zzmodule_modulez00, BGl_string3464z00zztype_envz00, BgL_arg2749z00_1357, BNIL);}  else 
{ /* Type/tenv.scm 411 */
obj_t BgL_arg2761z00_1361;obj_t BgL_arg2763z00_1363;
{ /* Type/tenv.scm 411 */
BgL_typez00_bglt BgL_obj1518z00_1863;
{ /* Type/tenv.scm 411 */
obj_t BgL_auxz00_2952;
BgL_auxz00_2952 = 
CAR(BgL_utz00_2259); 
BgL_obj1518z00_1863 = 
(BgL_typez00_bglt)(BgL_auxz00_2952); } 
BgL_arg2761z00_1361 = 
(((BgL_typez00_bglt)CREF(BgL_obj1518z00_1863))->BgL_locationz00); } 
BgL_arg2763z00_1363 = 
BGl_shapez00zztools_shapez00(
CAR(BgL_utz00_2259)); 
return 
BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_arg2761z00_1361, BGl_za2moduleza2z00zzmodule_modulez00, BGl_string3465z00zztype_envz00, BgL_arg2763z00_1363, BNIL);} } } } } 
}



/* <anonymous:2732> */
obj_t BGl_zc3anonymousza32732ze3z83zztype_envz00(obj_t BgL_envz00_2260)
{ AN_OBJECT;
{ /* Type/tenv.scm 406 */
{ /* Type/tenv.scm 406 */
obj_t BgL_zc3anonymousza32741ze3z83_2263;obj_t BgL_escapez00_2264;
{ /* Type/tenv.scm 406 */
int BgL_auxz00_2959;
BgL_auxz00_2959 = 
(int)(((long)2)); 
BgL_zc3anonymousza32741ze3z83_2263 = 
PROCEDURE_REF(BgL_envz00_2260, BgL_auxz00_2959); } 
{ /* Type/tenv.scm 406 */
int BgL_auxz00_2962;
BgL_auxz00_2962 = 
(int)(((long)3)); 
BgL_escapez00_2264 = 
PROCEDURE_REF(BgL_envz00_2260, BgL_auxz00_2962); } 
{ 

return 
BGl_addzd2errorzd2handlerz12z12zz__errorz00(BgL_zc3anonymousza32741ze3z83_2263, BgL_escapez00_2264);} } } 
}



/* escape */
obj_t BGl_escapez00zztype_envz00(obj_t BgL_envz00_2265, obj_t BgL_val2313z00_2267)
{ AN_OBJECT;
{ /* Type/tenv.scm 406 */
{ /* Type/tenv.scm 406 */
obj_t BgL_an_exitd2312z00_2266;
{ /* Type/tenv.scm 406 */
int BgL_auxz00_2966;
BgL_auxz00_2966 = 
(int)(((long)0)); 
BgL_an_exitd2312z00_2266 = 
PROCEDURE_REF(BgL_envz00_2265, BgL_auxz00_2966); } 
{ 
obj_t BgL_val2313z00_1334;
BgL_val2313z00_1334 = BgL_val2313z00_2267; 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd2312z00_2266, BgL_val2313z00_1334);} } } 
}



/* <anonymous:2741> */
obj_t BGl_zc3anonymousza32741ze3z83zztype_envz00(obj_t BgL_envz00_2268, obj_t BgL_escz00_2270, obj_t BgL_objz00_2271, obj_t BgL_procz00_2272, obj_t BgL_msgz00_2273)
{ AN_OBJECT;
{ /* Type/tenv.scm 406 */
{ /* Type/tenv.scm 406 */
obj_t BgL_armed2310z00_2269;
{ /* Type/tenv.scm 406 */
int BgL_auxz00_2970;
BgL_auxz00_2970 = 
(int)(((long)0)); 
BgL_armed2310z00_2269 = 
PROCEDURE_REF(BgL_envz00_2268, BgL_auxz00_2970); } 
{ 
obj_t BgL_escz00_1348;obj_t BgL_objz00_1349;obj_t BgL_procz00_1350;obj_t BgL_msgz00_1351;
BgL_escz00_1348 = BgL_escz00_2270; 
BgL_objz00_1349 = BgL_objz00_2271; 
BgL_procz00_1350 = BgL_procz00_2272; 
BgL_msgz00_1351 = BgL_msgz00_2273; 
CELL_SET(BgL_armed2310z00_2269, BFALSE); 
BGl_removezd2errorzd2handlerz12z12zz__errorz00(); 
BGl_notifyzd2errorzd2zz__errorz00(BgL_objz00_1349, BgL_procz00_1350, BgL_msgz00_1351); 
return 
PROCEDURE_ENTRY(BgL_escz00_1348)(BgL_escz00_1348, BFALSE, BEOA);} } } 
}



/* <anonymous:2792> */
obj_t BGl_zc3anonymousza32792ze3z83zztype_envz00(obj_t BgL_envz00_2275)
{ AN_OBJECT;
{ /* Type/tenv.scm 420 */
{ /* Type/tenv.scm 420 */
obj_t BgL_armed2318z00_2276;
{ /* Type/tenv.scm 420 */
int BgL_auxz00_2977;
BgL_auxz00_2977 = 
(int)(((long)0)); 
BgL_armed2318z00_2276 = 
PROCEDURE_REF(BgL_envz00_2275, BgL_auxz00_2977); } 
{ 

{ /* Type/tenv.scm 420 */
bool_t BgL_testz00_2980;
{ /* Type/tenv.scm 420 */
obj_t BgL_auxz00_2981;
BgL_auxz00_2981 = 
CELL_REF(BgL_armed2318z00_2276); 
BgL_testz00_2980 = 
CBOOL(BgL_auxz00_2981); } 
if(BgL_testz00_2980)
{ /* Type/tenv.scm 420 */
CELL_SET(BgL_armed2318z00_2276, BFALSE); 
return 
BGl_removezd2errorzd2handlerz12z12zz__errorz00();}  else 
{ /* Type/tenv.scm 420 */
return BFALSE;} } } } } 
}



/* <anonymous:2802> */
obj_t BGl_zc3anonymousza32802ze3z83zztype_envz00(obj_t BgL_envz00_2278)
{ AN_OBJECT;
{ /* Type/tenv.scm 420 */
{ /* Type/tenv.scm 420 */
obj_t BgL_utz00_2279;
{ /* Type/tenv.scm 420 */
int BgL_auxz00_2984;
BgL_auxz00_2984 = 
(int)(((long)0)); 
BgL_utz00_2279 = 
PROCEDURE_REF(BgL_envz00_2278, BgL_auxz00_2984); } 
{ 

{ /* Type/tenv.scm 420 */
obj_t BgL_arg2805z00_1400;
BgL_arg2805z00_1400 = 
BGl_shapez00zztools_shapez00(
CAR(BgL_utz00_2279)); 
{ /* Type/tenv.scm 420 */
obj_t BgL_procz00_1871;
BgL_procz00_1871 = BGl_za2moduleza2z00zzmodule_modulez00; 
FAILURE(BgL_procz00_1871,BGl_string3466z00zztype_envz00,BgL_arg2805z00_1400);} } } } } 
}



/* <anonymous:2790> */
obj_t BGl_zc3anonymousza32790ze3z83zztype_envz00(obj_t BgL_envz00_2280)
{ AN_OBJECT;
{ /* Type/tenv.scm 420 */
{ /* Type/tenv.scm 420 */
obj_t BgL_zc3anonymousza32799ze3z83_2283;obj_t BgL_escapez00_2284;
{ /* Type/tenv.scm 420 */
int BgL_auxz00_2990;
BgL_auxz00_2990 = 
(int)(((long)2)); 
BgL_zc3anonymousza32799ze3z83_2283 = 
PROCEDURE_REF(BgL_envz00_2280, BgL_auxz00_2990); } 
{ /* Type/tenv.scm 420 */
int BgL_auxz00_2993;
BgL_auxz00_2993 = 
(int)(((long)3)); 
BgL_escapez00_2284 = 
PROCEDURE_REF(BgL_envz00_2280, BgL_auxz00_2993); } 
{ 

return 
BGl_addzd2errorzd2handlerz12z12zz__errorz00(BgL_zc3anonymousza32799ze3z83_2283, BgL_escapez00_2284);} } } 
}



/* escape_3224 */
obj_t BGl_escape_3224z00zztype_envz00(obj_t BgL_envz00_2285, obj_t BgL_val2321z00_2287)
{ AN_OBJECT;
{ /* Type/tenv.scm 420 */
{ /* Type/tenv.scm 420 */
obj_t BgL_an_exitd2320z00_2286;
{ /* Type/tenv.scm 420 */
int BgL_auxz00_2997;
BgL_auxz00_2997 = 
(int)(((long)0)); 
BgL_an_exitd2320z00_2286 = 
PROCEDURE_REF(BgL_envz00_2285, BgL_auxz00_2997); } 
{ 
obj_t BgL_val2321z00_1379;
BgL_val2321z00_1379 = BgL_val2321z00_2287; 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd2320z00_2286, BgL_val2321z00_1379);} } } 
}



/* <anonymous:2799> */
obj_t BGl_zc3anonymousza32799ze3z83zztype_envz00(obj_t BgL_envz00_2288, obj_t BgL_escz00_2290, obj_t BgL_objz00_2291, obj_t BgL_procz00_2292, obj_t BgL_msgz00_2293)
{ AN_OBJECT;
{ /* Type/tenv.scm 420 */
{ /* Type/tenv.scm 420 */
obj_t BgL_armed2318z00_2289;
{ /* Type/tenv.scm 420 */
int BgL_auxz00_3001;
BgL_auxz00_3001 = 
(int)(((long)0)); 
BgL_armed2318z00_2289 = 
PROCEDURE_REF(BgL_envz00_2288, BgL_auxz00_3001); } 
{ 
obj_t BgL_escz00_1393;obj_t BgL_objz00_1394;obj_t BgL_procz00_1395;obj_t BgL_msgz00_1396;
BgL_escz00_1393 = BgL_escz00_2290; 
BgL_objz00_1394 = BgL_objz00_2291; 
BgL_procz00_1395 = BgL_procz00_2292; 
BgL_msgz00_1396 = BgL_msgz00_2293; 
CELL_SET(BgL_armed2318z00_2289, BFALSE); 
BGl_removezd2errorzd2handlerz12z12zz__errorz00(); 
BGl_notifyzd2errorzd2zz__errorz00(BgL_objz00_1394, BgL_procz00_1395, BgL_msgz00_1396); 
return 
PROCEDURE_ENTRY(BgL_escz00_1393)(BgL_escz00_1393, BFALSE, BEOA);} } } 
}



/* sub-type? */
bool_t BGl_subzd2typezf3z21zztype_envz00(BgL_typez00_bglt BgL_minorz00_48, BgL_typez00_bglt BgL_majorz00_49)
{ AN_OBJECT;
{ /* Type/tenv.scm 434 */
{ /* Type/tenv.scm 436 */
bool_t BgL_testz00_3008;
{ /* Type/tenv.scm 436 */
obj_t BgL_auxz00_3011;obj_t BgL_auxz00_3009;
BgL_auxz00_3011 = 
(obj_t)(BgL_majorz00_49); 
BgL_auxz00_3009 = 
(obj_t)(BgL_minorz00_48); 
BgL_testz00_3008 = 
(BgL_auxz00_3009==BgL_auxz00_3011); } 
if(BgL_testz00_3008)
{ /* Type/tenv.scm 436 */
return ((bool_t)1);}  else 
{ /* Type/tenv.scm 438 */
bool_t BgL_testz00_3014;
{ /* Type/tenv.scm 438 */
obj_t BgL_auxz00_3015;
BgL_auxz00_3015 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(
(obj_t)(BgL_majorz00_49), 
(((BgL_typez00_bglt)CREF(BgL_minorz00_48))->BgL_parentsz00)); 
BgL_testz00_3014 = 
CBOOL(BgL_auxz00_3015); } 
if(BgL_testz00_3014)
{ /* Type/tenv.scm 438 */
return ((bool_t)1);}  else 
{ /* Type/tenv.scm 438 */
return ((bool_t)0);} } } } 
}



/* _sub-type?3227 */
obj_t BGl__subzd2typezf33227z21zztype_envz00(obj_t BgL_envz00_2297, obj_t BgL_minorz00_2298, obj_t BgL_majorz00_2299)
{ AN_OBJECT;
{ /* Type/tenv.scm 434 */
{ /* Type/tenv.scm 436 */
bool_t BgL_auxz00_3020;
BgL_auxz00_3020 = 
BGl_subzd2typezf3z21zztype_envz00(
(BgL_typez00_bglt)(BgL_minorz00_2298), 
(BgL_typez00_bglt)(BgL_majorz00_2299)); 
return 
BBOOL(BgL_auxz00_3020);} } 
}



/* method-init */
obj_t BGl_methodzd2initzd2zztype_envz00()
{ AN_OBJECT;
{ /* Type/tenv.scm 15 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zztype_envz00()
{ AN_OBJECT;
{ /* Type/tenv.scm 15 */
BGl_modulezd2initializa7ationz75zztools_tracez00(((long)64647), "type_env"); 
BGl_modulezd2initializa7ationz75zztools_shapez00(((long)30825), "type_env"); 
BGl_modulezd2initializa7ationz75zztools_errorz00(((long)17886), "type_env"); 
BGl_modulezd2initializa7ationz75zztools_locationz00(((long)30714), "type_env"); 
BGl_modulezd2initializa7ationz75zzast_identz00(((long)52188), "type_env"); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)28259), "type_env"); 
BGl_modulezd2initializa7ationz75zzengine_paramz00(((long)189840), "type_env"); 
BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long)12859), "type_env"); 
BGl_modulezd2initializa7ationz75zzmodule_classz00(((long)33471), "type_env"); 
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19010), "type_env"); 
BGl_modulezd2initializa7ationz75zztype_toolsz00(((long)14899), "type_env"); 
BGl_modulezd2initializa7ationz75zztype_cachez00(((long)57983), "type_env"); 
BGl_modulezd2initializa7ationz75zzforeign_ctypez00(((long)63074), "type_env"); 
BGl_modulezd2initializa7ationz75zzobject_classz00(((long)19348), "type_env"); 
BGl_modulezd2initializa7ationz75zzobject_widezd2accesszd2(((long)47531), "type_env"); 
BGl_modulezd2initializa7ationz75zzobject_plainzd2accesszd2(((long)40143), "type_env"); 
BGl_modulezd2initializa7ationz75zzforeign_accessz00(((long)1934), "type_env"); 
BGl_modulezd2initializa7ationz75zzmodule_foreignz00(((long)23320), "type_env"); 
return 
BGl_modulezd2initializa7ationz75zzmodule_javaz00(((long)4332), "type_env");} 
}

