;*=====================================================================*/
;*    serrano/prgm/project/bigloo/fthread/src/fair-writer.scm          */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Thu Jul 11 10:22:38 2002                          */
;*    Last change :  Thu Jul 11 11:41:42 2002 (serrano)                */
;*    Copyright   :  2002 Manuel Serrano                               */
;*    -------------------------------------------------------------    */
;*    Fair writers, i.e., cooperative writers.                         */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module __ft_writer
   
   (import __ft_types
	   __ft_scheduler
	   __ft_%thread)

   (export (make-fair-writer ::output-port ::bstring ::obj)))

;*---------------------------------------------------------------------*/
;*    make-fair-writer ...                                             */
;*    -------------------------------------------------------------    */
;*    A fair thread asks WRITER-AWAIT to be notified when N chars      */
;*    written on PORT. When this condition is meet, the event EVENT    */
;*    is signaled.                                                     */
;*---------------------------------------------------------------------*/
(define (make-fair-writer port str event)
   (lambda (scdl)
      (lambda ()
	 (display-string str port)
	 (flush-output-port port)
	 (scheduler-broadcast scdl event str))))


