/*=====================================================================*/
/*    serrano/prgm/project/bigloo/runtime/Clib/cinit-obj.c             */
/*    -------------------------------------------------------------    */
/*    Author      :  Manuel Serrano                                    */
/*    Creation    :  Tue Jan 29 09:19:48 2002                          */
/*    Last change :  Tue Jan 29 09:19:52 2002 (serrano)                */
/*    Copyright   :  2002 Manuel Serrano                               */
/*    -------------------------------------------------------------    */
/*    Bootstrap of pre-allocated objects.                              */
/*=====================================================================*/
#include <stdio.h>
#include <bigloo.h>

/*---------------------------------------------------------------------*/
/*    Les objects vitaux ...                                           */
/*---------------------------------------------------------------------*/
obj_t an_object;

obj_t quote;
obj_t *c_allocated_char;
obj_t _exit_value_;

obj_t bprof_port = BUNSPEC;

/*---------------------------------------------------------------------*/
/*    Importations                                                     */
/*---------------------------------------------------------------------*/
extern obj_t string_to_obj();

extern void init_symbol_table();
extern void init_keyword_table();
extern void init_io();
extern void init_trace();

/*---------------------------------------------------------------------*/
/*    init_objects ...                                                 */
/*---------------------------------------------------------------------*/
void init_objects()
{
   /* l'initialisation des traces */
   init_trace();
   
   /* l'initialisation des symbols */
   init_symbol_table();

   /* l'initialisation des ports d'entree/sortie */
   init_io();

   /* the dsssl keywords initialization */
   init_keyword_table();

   /* l'initialisation du symbol QUOTE (voir apply.c) */
   quote = string_to_symbol( "QUOTE" );
   
}
