/*=====================================================================*/
/*    serrano/prgm/project/bigloo/runtime/Jlib/bglthread.java          */
/*    -------------------------------------------------------------    */
/*    Author      :  Manuel Serrano                                    */
/*    Creation    :  Fri Feb  8 15:04:47 2002                          */
/*    Last change :  Wed Aug  7 11:33:40 2002 (serrano)                */
/*    Copyright   :  2002 Manuel Serrano                               */
/*    -------------------------------------------------------------    */
/*    Bigloo thread. When a client has to create its own threads, it   */
/*    must inherit from that particular class and not from             */
/*    java.lang.Thread.                                                */
/*=====================================================================*/

/*---------------------------------------------------------------------*/
/*    The package                                                      */
/*---------------------------------------------------------------------*/
package bigloo;
import java.lang.*;
import bigloo.foreign;

/*---------------------------------------------------------------------*/
/*    bglthread                                                        */
/*---------------------------------------------------------------------*/
public class bglthread extends Thread {
   // global state
   private static Object G_EXIT_TOP;
   public static Object G_ERROR_HANDLER;
   public static input_port g_current_input_port;
   public static output_port g_current_output_port;
   public static output_port g_current_error_port;
   public static int g_mvalues_number;
   public static Object[] g_mvalues_values;

   // per thread state
   private Object EXIT_TOP;
   public Object ERROR_HANDLER;
   public input_port current_input_port;
   public output_port current_output_port;
   public output_port current_error_port;
   private int mvalues_number;
   private Object[] mvalues_values;

   // static initialization
   static {
      G_EXIT_TOP = new exit();
      G_ERROR_HANDLER = bigloo.nil.nil;
      g_current_input_port = new input_console_port( (int) foreign.default_io_bufsiz );
      g_current_output_port = new output_port( System.out );
      g_current_error_port = new output_port( System.err );
      g_mvalues_number = 1;
      g_mvalues_values = new Object[ 4 ];
      g_mvalues_values[ 0 ] = unspecified.unspecified;
      g_mvalues_values[ 1 ] = unspecified.unspecified;
      g_mvalues_values[ 2 ] = unspecified.unspecified;
      g_mvalues_values[ 3 ] = unspecified.unspecified;
   }

   // per thread initialization
   public bglthread() {
      EXIT_TOP = new exit();
      ERROR_HANDLER = bigloo.nil.nil;
      current_input_port = g_current_input_port;
      current_output_port = g_current_output_port;
      current_error_port = g_current_error_port;
      mvalues_number = 1;
      mvalues_values = new Object[ 4 ];
      mvalues_values[ 0 ] = unspecified.unspecified;
      mvalues_values[ 1 ] = unspecified.unspecified;
      mvalues_values[ 2 ] = unspecified.unspecified;
      mvalues_values[ 3 ] = unspecified.unspecified;
   }

   // Exit top
   public static Object getExitTop() {
      Thread t = currentThread();

      if( t instanceof bglthread )
	 return ((bglthread)t).EXIT_TOP;
      else
	 return G_EXIT_TOP;
   }

   public static void setExitTop( Object o ) {
      Thread t = currentThread();

      if( t instanceof bglthread )
	 ((bglthread)t).EXIT_TOP = o;
      else
	 G_EXIT_TOP = o;
      
      return;
   }

   // Multiple values
   public static int getMvaluesNumber() {
      Thread t = currentThread();

      if( t instanceof bglthread )
	 return ((bglthread)t).mvalues_number;
      else
	 return g_mvalues_number;
   }

   public static int setMvaluesNumber( int n ) {
      Thread t = currentThread();

      if( t instanceof bglthread )
	 ((bglthread)t).mvalues_number = n;
      else
	 g_mvalues_number = n;

      return n;
   }

   public static Object getMvaluesVal( int n ) {
      Thread t = currentThread();

      if( t instanceof bglthread )
	 return ((bglthread)t).mvalues_values[ n ];
      else
	 return g_mvalues_values[ n ];
   }

   public static void setMvaluesVal( int n, Object o ) {
      Thread t = currentThread();

      if( t instanceof bglthread )
	 ((bglthread)t).mvalues_values[ n ] = o;
      else
	 g_mvalues_values[ n ] = o;
   }
}
