/*=====================================================================*/
/*    serrano/prgm/project/bigloo/runtime/Jlib/client_socket.java      */
/*    -------------------------------------------------------------    */
/*    Author      :  Manuel Serrano                                    */
/*    Creation    :  Tue Dec  5 10:53:03 2000                          */
/*    Last change :  Mon Apr 29 10:49:54 2002 (serrano)                */
/*    Copyright   :  2000-02 Manuel Serrano                            */
/*    -------------------------------------------------------------    */
/*    The Client Socket implementation for the JVM back-end.           */
/*=====================================================================*/
package bigloo;
import bigloo.*;
import java.io.*;
import java.net.*;

/*---------------------------------------------------------------------*/
/*    SOCKET ...                                                       */
/*---------------------------------------------------------------------*/
public class client_socket extends socket {
/*--- public fields ---------------------------------------------------*/
   Socket socket;
   byte[] hostname;
   boolean blocking;
   int port;

/*--- constructors ----------------------------------------------------*/
    public client_socket( client_socket s ) {
    }

    // This is a client socket creation
    public client_socket( byte[] _hostname, int _port, boolean b ) {
	super();

	hostname = _hostname;
	blocking = b;
	port = _port;
	
	try {
	    socket = new Socket( new String(_hostname), _port );
	    set_socket_io_ports( (Socket)socket, b );
	} 
	catch ( UnknownHostException e ) {
	    socket_error( "make-client-socket",
			  "unknown or misspelled host name",
			  _hostname );
	}
	catch( IOException e ) {
	    socket_error( "make-client-socket",
			  "cannot create socket",
			  _hostname );
	}
    }

    // This is a client socket creation
    private client_socket( Socket _s, byte[] _host, int _port, boolean b ) {
	super();

	hostname = _host;
	blocking = b;
	port = _port;
	
	try {
	   socket = _s;
	   set_socket_io_ports( (Socket)socket, b );
	} 
	catch( IOException e ) {
	    socket_error( "make-client-socket",
			  "cannot create socket",
			  _host );
	}
    }

/*--- public methods --------------------------------------------------*/
    public Object HOSTNAME() {
	return socket.getInetAddress().getHostName().getBytes();
    }

    public Object HOSTIP() {
	return socket.getInetAddress().getHostAddress().getBytes();
    }
   
    public byte[] local_addr() {
	return socket.getLocalAddress().getHostName().getBytes();
    }

    public socket socket_dup() {
       return new client_socket( socket, hostname, port, blocking );
    }
   
    public Object shutdown(boolean close_socket) throws IOException {
	socket.close();
	down = true;
	return bigloo.foreign.BUNSPEC;
    }

    public int PORT() {
	return socket.getPort();
    }
    public void write(output_port p) {
       p.write("#<socket:" + new String(hostname) + "." + port + ">");
    }
}
