/*=====================================================================*/
/*    serrano/prgm/project/bigloo/runtime/Jlib/server_socket.java      */
/*    -------------------------------------------------------------    */
/*    Author      :  Manuel Serrano                                    */
/*    Creation    :  Tue Dec  5 10:53:03 2000                          */
/*    Last change :  Thu Jun 20 02:56:03 2002 (serrano)                */
/*    Copyright   :  2000-02 Manuel Serrano                            */
/*    -------------------------------------------------------------    */
/*    The Server Socket implementation for the JVM back-end.           */
/*=====================================================================*/
package bigloo;

import java.io.*;
import java.net.*;

/*---------------------------------------------------------------------*/
/*    SOCKET ...                                                       */
/*---------------------------------------------------------------------*/
public class server_socket extends socket {
/*--- public fields ---------------------------------------------------*/
   ServerSocket socket;
   private Socket client;
   private boolean blocking;
   private int port;
   
/*--- constructors ----------------------------------------------------*/
   public server_socket( int _port ) {
      super();

      port = _port;
      
      try {
	 socket = new ServerSocket( _port );
      } 
      catch( IOException e ) {
	 socket_error( "make-server-socket", 
		       "cannot create socket", 
		       new bint( _port ) );
      }
   }

   private server_socket( ServerSocket _socket, int _port ) {
      super();

      port = _port;
      socket = _socket;
   }

/*--- public methods --------------------------------------------------*/
   public Object HOSTNAME() {
      if( client != null )
	 return client.getInetAddress().getHostName().getBytes();
      else
	 return bigloo.foreign.BFALSE;
   }

   public Object HOSTIP() {
      if( client != null )
	 return client.getInetAddress().getHostAddress().getBytes();
      else
	 return bigloo.foreign.BFALSE;
   }
   
    public byte[] local_addr() {
       return "0.0.0.0".getBytes();
    }

   public Object accept_connection( boolean b ) 
      throws IOException, SecurityException {
      client = socket.accept();
      blocking = b;
      set_socket_io_ports( client, b );
	    
      return bigloo.foreign.BUNSPEC;
   }

   public socket socket_dup() {
      server_socket srv = new server_socket( socket, port );
      srv.blocking = blocking;
      srv.client = client;

      return srv;
   }
   
   public Object shutdown(boolean close_socket) throws IOException {
      if( client != null ) {
	 client.shutdownOutput();
	 client.shutdownInput();
      }
      if( close_socket ) {
	 if( client != null ) client.close();
	 socket.close();
	 down = true;
      }
      return bigloo.foreign.BUNSPEC;
   }

   public int PORT() {
      return socket.getLocalPort();
   }

    public void write(output_port p) {
       p.write("#<socket:localhost" + "." + port + ">");
    }
}
