/*===========================================================================*/
/*   (Ast/sexp.scm)                                                          */
/*   Bigloo (2.5b)                                                           */
/*   Manuel Serrano (c)       Fri Sep 6 09:43:28 CEST 2002                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_nodez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
} *BgL_nodez00_bglt;

typedef struct BgL_nodezf2effectzf2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
} *BgL_nodezf2effectzf2_bglt;

typedef struct BgL_atomz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_atomz00_bglt;

typedef struct BgL_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_varz00_bglt;

typedef struct BgL_closurez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_closurez00_bglt;

typedef struct BgL_kwotez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_kwotez00_bglt;

typedef struct BgL_sequencez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_nodesz00;
} *BgL_sequencez00_bglt;

typedef struct BgL_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
} *BgL_appz00_bglt;

typedef struct BgL_appzd2lyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_appzd2lyzd2_bglt;

typedef struct BgL_funcallz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_strengthz00;
} *BgL_funcallz00_bglt;

typedef struct BgL_externz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_externz00_bglt;

typedef struct BgL_pragmaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_formatz00;
} *BgL_pragmaz00_bglt;

typedef struct BgL_getfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_getfieldz00_bglt;

typedef struct BgL_setfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_setfieldz00_bglt;

typedef struct BgL_newz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_newz00_bglt;

typedef struct BgL_vallocz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2heapzd2formatz00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_vallocz00_bglt;

typedef struct BgL_vrefz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vrefz00_bglt;

typedef struct BgL_vsetz12z12_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vsetz12z12_bglt;

typedef struct BgL_vlengthz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vlengthz00_bglt;

typedef struct BgL_isaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   struct BgL_typez00_bgl * BgL_classz00;
} *BgL_isaz00_bglt;

typedef struct BgL_castz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_castz00_bglt;

typedef struct BgL_setqz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_setqz00_bglt;

typedef struct BgL_conditionalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   struct BgL_nodez00_bgl * BgL_truez00;
   struct BgL_nodez00_bgl * BgL_falsez00;
} *BgL_conditionalz00_bglt;

typedef struct BgL_failz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_procz00;
   struct BgL_nodez00_bgl * BgL_msgz00;
   struct BgL_nodez00_bgl * BgL_objz00;
} *BgL_failz00_bglt;

typedef struct BgL_selectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   obj_t BgL_clausesz00;
   struct BgL_typez00_bgl * BgL_itemzd2typezd2;
} *BgL_selectz00_bglt;

typedef struct BgL_letzd2funzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_localsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_letzd2funzd2_bglt;

typedef struct BgL_letzd2varzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_bindingsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
   bool_t BgL_removablezf3zf3;
} *BgL_letzd2varzd2_bglt;

typedef struct BgL_setzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_setzd2exzd2itz00_bglt;

typedef struct BgL_jumpzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_exitz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_jumpzd2exzd2itz00_bglt;

typedef struct BgL_makezd2boxzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_makezd2boxzd2_bglt;

typedef struct BgL_boxzd2refzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_varz00;
} *BgL_boxzd2refzd2_bglt;

typedef struct BgL_boxzd2setz12zc0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_boxzd2setz12zc0_bglt;


extern obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zzast_sexpz00();
extern obj_t open_input_string(obj_t);
extern long BGl_classzd2numzd2zz__objectz00(obj_t);
extern bool_t BGl_globalzd2readzd2onlyzf3zf3zzast_varz00(BgL_globalz00_bglt);
extern obj_t BGl_nodez00zzast_nodez00;
extern BgL_nodez00_bglt BGl_letzd2ze3nodez31zzast_letz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
extern obj_t BGl_readz00zz__readerz00(obj_t);
extern bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
extern BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_usezd2variablez12zc0zzast_sexpz00(BgL_variablez00_bglt, obj_t, obj_t);
static obj_t BGl__definezd2primopzd2ze3node4762ze3zzast_sexpz00(obj_t, obj_t);
extern char * BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00(obj_t, obj_t);
static obj_t BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BUNSPEC;
static obj_t BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BUNSPEC;
extern bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t BGl_kwotez00zzast_nodez00;
extern obj_t BGl_za2_za2z00zztype_cachez00;
extern obj_t BGl_funz00zzast_varz00;
extern obj_t BGl_za2targetzd2languageza2zd2zzengine_paramz00;
extern obj_t BGl_gensymz00zz__r4_symbols_6_4z00;
extern obj_t BGl_globalz00zzast_varz00;
static obj_t BGl_liipz00zzast_sexpz00(obj_t);
static obj_t BGl_za2sitesza2z00zzast_sexpz00 = BUNSPEC;
static obj_t BGl__topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t, obj_t);
extern obj_t BGl_dssslzd2findzd2firstzd2formalzd2zztools_dssslz00(obj_t);
extern obj_t BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(obj_t);
static obj_t BGl__errorzd2sexpzd2ze3node4758ze3zzast_sexpz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_za2cachezd2resza2zd2zzast_sexpz00 = BUNSPEC;
extern BgL_nodez00_bglt BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(bool_t, BgL_typez00_bglt, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_varz00zzast_nodez00;
extern obj_t BGl_za2bdbzd2debugza2zd2zzengine_paramz00;
static obj_t BGl_cnstzd2initzd2zzast_sexpz00();
extern obj_t BGl_atomz00zzast_nodez00;
extern obj_t BGl_failz00zzast_nodez00;
extern BgL_nodez00_bglt BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t);
extern obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
extern obj_t BGl_za2unspecza2z00zztype_cachez00;
static obj_t BGl_importedzd2moduleszd2initz00zzast_sexpz00();
static obj_t BGl__usezd2variablez124756zc0zzast_sexpz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_findzd2locationzf2locz20zztools_locationz00(obj_t, obj_t);
extern obj_t BGl_currentzd2functionzd2zztools_errorz00();
extern obj_t BGl_za2bnilza2z00zztype_cachez00;
extern BgL_nodez00_bglt BGl_locationzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt);
extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
extern BgL_nodez00_bglt BGl_applicationzd2ze3nodez31zzast_appz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_selectz00zzast_nodez00;
static obj_t BGl_toplevelzd2initzd2zzast_sexpz00();
extern BgL_jumpzd2exzd2itz00_bglt BGl_jumpzd2exitzd2ze3nodeze3zzast_exitz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl__sexpza2zd2ze3node4754z93zzast_sexpz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_prognz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_dssslz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_buildz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_pragmaz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_labelsz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_letz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_exitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_appz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_applyz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_privatez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
extern obj_t BGl_normaliza7ezd2prognz75zztools_prognz00(obj_t);
extern obj_t BGl_epairifyzd2reczd2zztools_miscz00(obj_t, obj_t);
extern obj_t BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl__sexpzd2ze3node4751z31zzast_sexpz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
extern obj_t BGl_sexpza2zd2ze3nodez93zzast_sexpz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t string_to_symbol(char *);
extern BgL_nodez00_bglt BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt, BgL_nodez00_bglt);
extern obj_t string_append(obj_t, obj_t);
extern BgL_nodez00_bglt BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(BgL_globalz00_bglt);
extern obj_t BGl_shapez00zztools_shapez00(obj_t);
static obj_t BGl__locationzd2ze3node4764z31zzast_sexpz00(obj_t, obj_t);
static obj_t BGl_lookupz00zzast_sexpz00(obj_t, obj_t);
extern BgL_letzd2funzd2_bglt BGl_setzd2exitzd2ze3nodeze3zzast_exitz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_cfunz00zzast_varz00;
extern obj_t BGl_privatezd2ze3nodez31zzast_privatez00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_conditionalz00zzast_nodez00;
extern obj_t BGl_sequencez00zzast_nodez00;
extern bool_t BGl_privatezd2sexpzf3z21zzast_privatez00(obj_t);
static obj_t BGl__definezd2primopzd2refzd2ze3node4760z31zzast_sexpz00(obj_t, obj_t, obj_t);
static obj_t BGl_loopz00zzast_sexpz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_replacez12z12zztools_miscz00(obj_t, obj_t);
extern obj_t BGl_appz00zzast_nodez00;
extern obj_t BGl_epairifyz00zztools_miscz00(obj_t, obj_t);
extern obj_t BGl_localz00zzast_varz00;
extern obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
extern obj_t BGl_closurez00zzast_nodez00;
static obj_t BGl_makezd2anonymouszd2namez00zzast_sexpz00(obj_t);
extern BgL_nodez00_bglt BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zzast_sexpz00 = BUNSPEC;
extern BgL_letzd2funzd2_bglt BGl_labelszd2ze3nodez31zzast_labelsz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_za2magicza2z00zztype_cachez00;
static obj_t BGl_zc3anonymousza33728ze3z83zzast_sexpz00(obj_t, obj_t, obj_t, obj_t);
extern BgL_nodez00_bglt BGl_applycationzd2ze3nodez31zzast_applyz00(obj_t, obj_t, obj_t, obj_t);
extern BgL_typez00_bglt BGl_typeofzd2atomzd2zztype_typeofz00(obj_t);
extern obj_t BGl_parsezd2idzd2zzast_identz00(obj_t, obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zzast_sexpz00();
extern obj_t BGl_dssslzd2namedzd2constantzf3zf3zztools_dssslz00(obj_t);
extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
extern obj_t BGl_setqz00zzast_nodez00;
static obj_t __cnst[ 35 ] ;

DEFINE_STRING( BGl_string5127z00zzast_sexpz00, BgL_bgl_string5127za700za7za7ast_sexpza7005159z00, "> <anonymous- (@ __evmeaning_address foreign) define-primop! define-primop-ref! write cons (quote ()) jump-exit set-exit case failure letrec define begin apply jvm quote @ app eval not if ::bool test location set! let else labels lambda free-pragma pragma value (value apply app set!) ", 285 );
DEFINE_STRING( BGl_string5126z00zzast_sexpz00, BgL_bgl_string5126za700za7za7ast_sexpza7005160z00, ":", 1 );
DEFINE_STRING( BGl_string5125z00zzast_sexpz00, BgL_bgl_string5125za700za7za7ast_sexpza7005161z00, ">", 1 );
DEFINE_STRING( BGl_string5124z00zzast_sexpz00, BgL_bgl_string5124za700za7za7ast_sexpza7005162z00, "<anonymous:", 11 );
DEFINE_STRING( BGl_string5123z00zzast_sexpz00, BgL_bgl_string5123za700za7za7ast_sexpza7005163z00, "Illegal mutation", 16 );
DEFINE_STRING( BGl_string5122z00zzast_sexpz00, BgL_bgl_string5122za700za7za7ast_sexpza7005164z00, "Illegal empty sequence", 22 );
DEFINE_STRING( BGl_string5121z00zzast_sexpz00, BgL_bgl_string5121za700za7za7ast_sexpza7005165z00, "Illegal formal argument", 23 );
DEFINE_STRING( BGl_string5120z00zzast_sexpz00, BgL_bgl_string5120za700za7za7ast_sexpza7005166z00, "wrong number of argument", 24 );
DEFINE_STRING( BGl_string5119z00zzast_sexpz00, BgL_bgl_string5119za700za7za7ast_sexpza7005167z00, "Illegal `()' expression", 23 );
DEFINE_STRING( BGl_string5118z00zzast_sexpz00, BgL_bgl_string5118za700za7za7ast_sexpza7005168z00, "Illegal atom", 12 );
DEFINE_STRING( BGl_string5117z00zzast_sexpz00, BgL_bgl_string5117za700za7za7ast_sexpza7005169z00, "Java method cannot be used as value", 35 );
DEFINE_STRING( BGl_string5116z00zzast_sexpz00, BgL_bgl_string5116za700za7za7ast_sexpza7005170z00, "Unbound variable", 16 );
DEFINE_STRING( BGl_string5115z00zzast_sexpz00, BgL_bgl_string5115za700za7za7ast_sexpza7005171z00, "Illegal `@' expression", 22 );
DEFINE_STRING( BGl_string5114z00zzast_sexpz00, BgL_bgl_string5114za700za7za7ast_sexpza7005172z00, "Illegal `quote' expression", 26 );
DEFINE_STRING( BGl_string5113z00zzast_sexpz00, BgL_bgl_string5113za700za7za7ast_sexpza7005173z00, "Illegal `if' form", 17 );
DEFINE_STRING( BGl_string5112z00zzast_sexpz00, BgL_bgl_string5112za700za7za7ast_sexpza7005174z00, "illegal `set!' expression", 25 );
DEFINE_STRING( BGl_string5111z00zzast_sexpz00, BgL_bgl_string5111za700za7za7ast_sexpza7005175z00, "Read-only variable", 18 );
DEFINE_STRING( BGl_string5110z00zzast_sexpz00, BgL_bgl_string5110za700za7za7ast_sexpza7005176z00, "Illegal `set!' form", 19 );
DEFINE_STRING( BGl_string5109z00zzast_sexpz00, BgL_bgl_string5109za700za7za7ast_sexpza7005177z00, "illegal `define' expression", 27 );
DEFINE_STRING( BGl_string5108z00zzast_sexpz00, BgL_bgl_string5108za700za7za7ast_sexpza7005178z00, "Illegal `define' form", 21 );
DEFINE_STRING( BGl_string5107z00zzast_sexpz00, BgL_bgl_string5107za700za7za7ast_sexpza7005179z00, "Illegal `failure' form", 22 );
DEFINE_STRING( BGl_string5106z00zzast_sexpz00, BgL_bgl_string5106za700za7za7ast_sexpza7005180z00, "Illegal `case' form", 19 );
DEFINE_STRING( BGl_string5105z00zzast_sexpz00, BgL_bgl_string5105za700za7za7ast_sexpza7005181z00, "Illegal `lambda' form", 21 );
DEFINE_EXPORT_PROCEDURE( BGl_sexpzd2ze3nodezd2envze3zzast_sexpz00, BgL_bgl__sexpza7d2za7e3node4751za731za7za7ast_sexpza7005182z00, BGl__sexpzd2ze3node4751z31zzast_sexpz00, 0L, 4 );
DEFINE_EXPORT_PROCEDURE( BGl_topzd2levelzd2sexpzd2ze3nodezd2envze3zzast_sexpz00, BgL_bgl__topza7d2levelza7d2sexpza7d2za7e3nodeza731za7za7ast_sexpza7005183z00, BGl__topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_sexpza2zd2ze3nodezd2envz41zzast_sexpz00, BgL_bgl__sexpza7a2za7d2za7e3node4754za793za7za7ast_sexpza7005184za7, BGl__sexpza2zd2ze3node4754z93zzast_sexpz00, 0L, 4 );
DEFINE_EXPORT_PROCEDURE( BGl_definezd2primopzd2ze3nodezd2envz31zzast_sexpz00, BgL_bgl__defineza7d2primopza7d2za7e3node4762za7e3za7za7ast_sexpza7005185za7, BGl__definezd2primopzd2ze3node4762ze3zzast_sexpz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl_errorzd2sexpzd2ze3nodezd2envz31zzast_sexpz00, BgL_bgl__errorza7d2sexpza7d2za7e3node4758za7e3za7za7ast_sexpza7005186za7, BGl__errorzd2sexpzd2ze3node4758ze3zzast_sexpz00, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( BGl_usezd2variablez12zd2envz12zzast_sexpz00, BgL_bgl__useza7d2variableza7124756za7c0za7za7ast_sexpza7005187z00, BGl__usezd2variablez124756zc0zzast_sexpz00, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( BGl_definezd2primopzd2refzd2ze3nodezd2envze3zzast_sexpz00, BgL_bgl__defineza7d2primopza7d2refza7d2za7e3node4760za731za7za7ast_sexpza7005188z00, BGl__definezd2primopzd2refzd2ze3node4760z31zzast_sexpz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_locationzd2ze3nodezd2envze3zzast_sexpz00, BgL_bgl__locationza7d2za7e3node4764za731za7za7ast_sexpza7005189z00, BGl__locationzd2ze3node4764z31zzast_sexpz00, 0L, 1 );



/* module-initialization */
obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long BgL_checksumz00_3967, char * BgL_fromz00_3968)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzast_sexpz00))
{ 
BGl_requirezd2initializa7ationz75zzast_sexpz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzast_sexpz00(); 
BGl_cnstzd2initzd2zzast_sexpz00(); 
BGl_importedzd2moduleszd2initz00zzast_sexpz00(); 
BGl_toplevelzd2initzd2zzast_sexpz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzast_sexpz00()
{ AN_OBJECT;
{ /* Ast/sexp.scm 14 */
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zz__dssslz00(((long)0), "ast_sexp"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzast_sexpz00()
{ AN_OBJECT;
{ /* Ast/sexp.scm 14 */
{ /* Ast/sexp.scm 14 */
obj_t BgL_cportz00_3960;
BgL_cportz00_3960 = 
open_input_string(BGl_string5127z00zzast_sexpz00); 
{ 
long BgL_iz00_3961;
BgL_iz00_3961 = ((long)34); 
BgL_loopz00_3962:
if(
(BgL_iz00_3961==((long)-1)))
{ /* Ast/sexp.scm 14 */
return BUNSPEC;}  else 
{ /* Ast/sexp.scm 14 */
{ /* Ast/sexp.scm 14 */
obj_t BgL_arg5131z00_3964;
{ /* Ast/sexp.scm 14 */
obj_t BgL_list5134z00_3965;
BgL_list5134z00_3965 = 
MAKE_PAIR(BgL_cportz00_3960, BNIL); 
BgL_arg5131z00_3964 = 
BGl_readz00zz__readerz00(BgL_list5134z00_3965); } 
{ /* Ast/sexp.scm 14 */
int BgL_auxz00_3989;
BgL_auxz00_3989 = 
(int)(BgL_iz00_3961); 
CNST_TABLE_SET(BgL_auxz00_3989, BgL_arg5131z00_3964); } } 
{ 
long BgL_iz00_3992;
{ /* Ast/sexp.scm 14 */
int BgL_auxz00_3993;
{ /* Ast/sexp.scm 14 */
long BgL_auxz00_3994;
BgL_auxz00_3994 = 
(BgL_iz00_3961-((long)1)); 
BgL_auxz00_3993 = 
(int)(BgL_auxz00_3994); } 
BgL_iz00_3992 = 
(long)(BgL_auxz00_3993); } 
BgL_iz00_3961 = BgL_iz00_3992; 
goto BgL_loopz00_3962;} } } } } 
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zzast_sexpz00()
{ AN_OBJECT;
{ /* Ast/sexp.scm 14 */
BGl_za2sitesza2z00zzast_sexpz00 = 
CNST_TABLE_REF(((long)0)); 
BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BFALSE; 
BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BFALSE; 
return ( 
BGl_za2cachezd2resza2zd2zzast_sexpz00 = BFALSE, BUNSPEC) ;} 
}



/* top-level-sexp->node */
BgL_nodez00_bglt BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t BgL_expz00_15, obj_t BgL_locz00_16)
{ AN_OBJECT;
{ /* Ast/sexp.scm 55 */
return 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_15, BNIL, BgL_locz00_16, 
CNST_TABLE_REF(((long)1)));} 
}



/* _top-level-sexp->node */
obj_t BGl__topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t BgL_envz00_3923, obj_t BgL_expz00_3924, obj_t BgL_locz00_3925)
{ AN_OBJECT;
{ /* Ast/sexp.scm 55 */
{ /* Ast/sexp.scm 56 */
BgL_nodez00_bglt BgL_auxz00_4001;
BgL_auxz00_4001 = 
BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_3924, BgL_locz00_3925); 
return 
(obj_t)(BgL_auxz00_4001);} } 
}



/* sexp->node */
BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t BgL_expz00_17, obj_t BgL_stackz00_18, obj_t BgL_locz00_19, obj_t BgL_sitez00_20)
{ AN_OBJECT;
{ /* Ast/sexp.scm 71 */
BGl_sexpzd2ze3nodez31zzast_sexpz00:
{ 
obj_t BgL_atomz00_1269;obj_t BgL_bodyz00_1273;obj_t BgL_bodyz00_1278;obj_t BgL_argsz00_1279;obj_t BgL_varsz00_1283;obj_t BgL_bodyz00_1284;obj_t BgL_argsz00_1285;
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(BgL_expz00_17, BNIL))
{ /* Ast/sexp.scm 74 */
return 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string5119z00zzast_sexpz00, BgL_expz00_17, BgL_locz00_19);}  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_test2713z00_1299;
BgL_test2713z00_1299 = 
BGl_iszd2azf3z21zz__objectz00(BgL_expz00_17, BGl_nodez00zzast_nodez00); 
if(BgL_test2713z00_1299)
{ /* Ast/sexp.scm 74 */
return 
(BgL_nodez00_bglt)(BgL_expz00_17);}  else 
{ /* Ast/sexp.scm 74 */
if(
PAIRP(BgL_expz00_17))
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4012;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4015;obj_t BgL_auxz00_4013;
BgL_auxz00_4015 = 
CNST_TABLE_REF(((long)16)); 
BgL_auxz00_4013 = 
CAR(BgL_expz00_17); 
BgL_testz00_4012 = 
(BgL_auxz00_4013==BgL_auxz00_4015); } 
if(BgL_testz00_4012)
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4018;
{ /* Ast/sexp.scm 145 */
obj_t BgL_locz00_1464;
BgL_locz00_1464 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, BgL_locz00_19); 
{ 
obj_t BgL_namez00_1465;obj_t BgL_modulez00_1466;
if(
PAIRP(BgL_expz00_17))
{ /* Ast/sexp.scm 146 */
obj_t BgL_cdrzd2357zd2_1471;
BgL_cdrzd2357zd2_1471 = 
CDR(BgL_expz00_17); 
{ /* Ast/sexp.scm 146 */
bool_t BgL_testz00_4023;
{ /* Ast/sexp.scm 146 */
obj_t BgL_auxz00_4026;obj_t BgL_auxz00_4024;
BgL_auxz00_4026 = 
CNST_TABLE_REF(((long)16)); 
BgL_auxz00_4024 = 
CAR(BgL_expz00_17); 
BgL_testz00_4023 = 
(BgL_auxz00_4024==BgL_auxz00_4026); } 
if(BgL_testz00_4023)
{ /* Ast/sexp.scm 146 */
if(
PAIRP(BgL_cdrzd2357zd2_1471))
{ /* Ast/sexp.scm 146 */
obj_t BgL_carzd2360zd2_1474;obj_t BgL_cdrzd2361zd2_1475;
BgL_carzd2360zd2_1474 = 
CAR(BgL_cdrzd2357zd2_1471); 
BgL_cdrzd2361zd2_1475 = 
CDR(BgL_cdrzd2357zd2_1471); 
if(
SYMBOLP(BgL_carzd2360zd2_1474))
{ /* Ast/sexp.scm 146 */
if(
PAIRP(BgL_cdrzd2361zd2_1475))
{ /* Ast/sexp.scm 146 */
obj_t BgL_carzd2366zd2_1478;
BgL_carzd2366zd2_1478 = 
CAR(BgL_cdrzd2361zd2_1475); 
if(
SYMBOLP(BgL_carzd2366zd2_1478))
{ /* Ast/sexp.scm 146 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2361zd2_1475), BNIL))
{ /* Ast/sexp.scm 146 */
BgL_namez00_1465 = BgL_carzd2360zd2_1474; 
BgL_modulez00_1466 = BgL_carzd2366zd2_1478; 
{ /* Ast/sexp.scm 148 */
obj_t BgL_globalz00_1485;
BgL_globalz00_1485 = 
BGl_findzd2globalzf2modulez20zzast_envz00(BgL_namez00_1465, BgL_modulez00_1466); 
{ /* Ast/sexp.scm 150 */
bool_t BgL_test3122z00_1486;
BgL_test3122z00_1486 = 
BGl_iszd2azf3z21zz__objectz00(BgL_globalz00_1485, BGl_globalz00zzast_varz00); 
if(BgL_test3122z00_1486)
{ /* Ast/sexp.scm 152 */
bool_t BgL_testz00_4046;
{ /* Ast/sexp.scm 152 */
obj_t BgL_auxz00_4050;obj_t BgL_auxz00_4047;
BgL_auxz00_4050 = 
CNST_TABLE_REF(((long)14)); 
{ /* Ast/sexp.scm 152 */
BgL_globalz00_bglt BgL_obj1174z00_2680;
BgL_obj1174z00_2680 = 
(BgL_globalz00_bglt)(BgL_globalz00_1485); 
BgL_auxz00_4047 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1174z00_2680))->BgL_importz00); } 
BgL_testz00_4046 = 
(BgL_auxz00_4047==BgL_auxz00_4050); } 
if(BgL_testz00_4046)
{ /* Ast/sexp.scm 152 */
{ /* Ast/sexp.scm 153 */
obj_t BgL_arg3125z00_1488;
{ /* Ast/sexp.scm 153 */
obj_t BgL_arg3128z00_1489;obj_t BgL_arg3129z00_1490;
BgL_arg3128z00_1489 = 
CNST_TABLE_REF(((long)14)); 
BgL_arg3129z00_1490 = 
MAKE_PAIR(BGl_atomz00zzast_nodez00, BNIL); 
BgL_arg3125z00_1488 = 
MAKE_PAIR(BgL_arg3128z00_1489, BgL_arg3129z00_1490); } 
{ /* Ast/sexp.scm 153 */
BgL_nodez00_bglt BgL_auxz00_4056;
BgL_auxz00_4056 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg3125z00_1488, BgL_stackz00_18, BgL_locz00_1464, BgL_sitez00_20); 
BgL_auxz00_4018 = 
(obj_t)(BgL_auxz00_4056); } } }  else 
{ /* Ast/sexp.scm 152 */
BGl_usezd2variablez12zc0zzast_sexpz00(
(BgL_variablez00_bglt)(BgL_globalz00_1485), BgL_locz00_1464, BgL_sitez00_20); 
{ /* Ast/sexp.scm 156 */
bool_t BgL_test3133z00_1491;
{ /* Ast/sexp.scm 156 */
bool_t BgL_testz00_4061;
{ /* Ast/sexp.scm 156 */
obj_t BgL_auxz00_4062;
BgL_auxz00_4062 = 
CNST_TABLE_REF(((long)15)); 
BgL_testz00_4061 = 
(BgL_sitez00_20==BgL_auxz00_4062); } 
if(BgL_testz00_4061)
{ /* Ast/sexp.scm 156 */
BgL_test3133z00_1491 = ((bool_t)0); }  else 
{ /* Ast/sexp.scm 157 */
obj_t BgL_auxz00_4065;
{ /* Ast/sexp.scm 157 */
BgL_valuez00_bglt BgL_auxz00_4066;
{ /* Ast/sexp.scm 157 */
BgL_globalz00_bglt BgL_obj1156z00_2681;
BgL_obj1156z00_2681 = 
(BgL_globalz00_bglt)(BgL_globalz00_1485); 
BgL_auxz00_4066 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1156z00_2681))->BgL_valuez00); } 
BgL_auxz00_4065 = 
(obj_t)(BgL_auxz00_4066); } 
BgL_test3133z00_1491 = 
BGl_iszd2azf3z21zz__objectz00(BgL_auxz00_4065, BGl_funz00zzast_varz00); } } 
if(BgL_test3133z00_1491)
{ /* Ast/sexp.scm 158 */
obj_t BgL_arg3135z00_1492;BgL_typez00_bglt BgL_arg3136z00_1493;
BgL_arg3135z00_1492 = BgL_locz00_1464; 
{ /* Ast/sexp.scm 159 */
BgL_globalz00_bglt BgL_obj1153z00_2683;
BgL_obj1153z00_2683 = 
(BgL_globalz00_bglt)(BgL_globalz00_1485); 
BgL_arg3136z00_1493 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1153z00_2683))->BgL_typez00); } 
{ /* Ast/sexp.scm 158 */
BgL_closurez00_bglt BgL_res4682z00_2702;
{ /* Ast/sexp.scm 158 */
BgL_variablez00_bglt BgL_variable1655z00_2686;
{ /* Ast/sexp.scm 160 */
obj_t BgL_auxz00_4074;
BgL_auxz00_4074 = BgL_globalz00_1485; 
BgL_variable1655z00_2686 = 
(BgL_variablez00_bglt)(BgL_auxz00_4074); } 
{ /* Ast/sexp.scm 158 */
BgL_closurez00_bglt BgL_new1656z00_2687;
{ /* Ast/sexp.scm 158 */
BgL_closurez00_bglt BgL_res4680z00_2693;
{ /* Ast/sexp.scm 158 */
BgL_closurez00_bglt BgL_new1658z00_2688;
BgL_new1658z00_2688 = 
((BgL_closurez00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_closurez00_bgl) ))); 
{ /* Ast/sexp.scm 158 */
long BgL_arg4482z00_2689;
BgL_arg4482z00_2689 = 
BGl_classzd2numzd2zz__objectz00(BGl_closurez00zzast_nodez00); 
{ /* Ast/sexp.scm 158 */
BgL_objectz00_bglt BgL_auxz00_4078;
BgL_auxz00_4078 = 
(BgL_objectz00_bglt)(BgL_new1658z00_2688); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4078, BgL_arg4482z00_2689); } } 
{ /* Ast/sexp.scm 158 */
BgL_objectz00_bglt BgL_auxz00_4081;
BgL_auxz00_4081 = 
(BgL_objectz00_bglt)(BgL_new1658z00_2688); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4081, BFALSE); } 
{ /* Ast/sexp.scm 158 */
obj_t BgL_auxz00_4084;
BgL_auxz00_4084 = 
(obj_t)(BgL_new1658z00_2688); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4084); } BUNSPEC; 
BgL_res4680z00_2693 = BgL_new1658z00_2688; } 
BgL_new1656z00_2687 = BgL_res4680z00_2693; } 
{ /* Ast/sexp.scm 158 */
BgL_closurez00_bglt BgL_res4681z00_2701;
((((BgL_closurez00_bglt)CREF(BgL_new1656z00_2687))->BgL_locz00) = ((obj_t)BgL_arg3135z00_1492), BUNSPEC); 
((((BgL_closurez00_bglt)CREF(BgL_new1656z00_2687))->BgL_typez00) = ((BgL_typez00_bglt)BgL_arg3136z00_1493), BUNSPEC); 
((((BgL_closurez00_bglt)CREF(BgL_new1656z00_2687))->BgL_variablez00) = ((BgL_variablez00_bglt)BgL_variable1655z00_2686), BUNSPEC); 
BgL_res4681z00_2701 = BgL_new1656z00_2687; BgL_res4681z00_2701; } 
BgL_res4682z00_2702 = BgL_new1656z00_2687; } } 
BgL_auxz00_4018 = 
(obj_t)(BgL_res4682z00_2702); } }  else 
{ /* Ast/sexp.scm 161 */
obj_t BgL_arg3141z00_1495;BgL_typez00_bglt BgL_arg3142z00_1496;
BgL_arg3141z00_1495 = BgL_locz00_1464; 
{ /* Ast/sexp.scm 162 */
BgL_globalz00_bglt BgL_obj1153z00_2703;
BgL_obj1153z00_2703 = 
(BgL_globalz00_bglt)(BgL_globalz00_1485); 
BgL_arg3142z00_1496 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1153z00_2703))->BgL_typez00); } 
{ /* Ast/sexp.scm 161 */
BgL_varz00_bglt BgL_res4685z00_2722;
{ /* Ast/sexp.scm 161 */
BgL_variablez00_bglt BgL_variable1633z00_2706;
{ /* Ast/sexp.scm 163 */
obj_t BgL_auxz00_4093;
BgL_auxz00_4093 = BgL_globalz00_1485; 
BgL_variable1633z00_2706 = 
(BgL_variablez00_bglt)(BgL_auxz00_4093); } 
{ /* Ast/sexp.scm 161 */
BgL_varz00_bglt BgL_new1634z00_2707;
{ /* Ast/sexp.scm 161 */
BgL_varz00_bglt BgL_res4683z00_2713;
{ /* Ast/sexp.scm 161 */
BgL_varz00_bglt BgL_new1636z00_2708;
BgL_new1636z00_2708 = 
((BgL_varz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_varz00_bgl) ))); 
{ /* Ast/sexp.scm 161 */
long BgL_arg4491z00_2709;
BgL_arg4491z00_2709 = 
BGl_classzd2numzd2zz__objectz00(BGl_varz00zzast_nodez00); 
{ /* Ast/sexp.scm 161 */
BgL_objectz00_bglt BgL_auxz00_4097;
BgL_auxz00_4097 = 
(BgL_objectz00_bglt)(BgL_new1636z00_2708); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4097, BgL_arg4491z00_2709); } } 
{ /* Ast/sexp.scm 161 */
BgL_objectz00_bglt BgL_auxz00_4100;
BgL_auxz00_4100 = 
(BgL_objectz00_bglt)(BgL_new1636z00_2708); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4100, BFALSE); } 
{ /* Ast/sexp.scm 161 */
obj_t BgL_auxz00_4103;
BgL_auxz00_4103 = 
(obj_t)(BgL_new1636z00_2708); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4103); } BUNSPEC; 
BgL_res4683z00_2713 = BgL_new1636z00_2708; } 
BgL_new1634z00_2707 = BgL_res4683z00_2713; } 
{ /* Ast/sexp.scm 161 */
BgL_varz00_bglt BgL_res4684z00_2721;
((((BgL_varz00_bglt)CREF(BgL_new1634z00_2707))->BgL_locz00) = ((obj_t)BgL_arg3141z00_1495), BUNSPEC); 
((((BgL_varz00_bglt)CREF(BgL_new1634z00_2707))->BgL_typez00) = ((BgL_typez00_bglt)BgL_arg3142z00_1496), BUNSPEC); 
((((BgL_varz00_bglt)CREF(BgL_new1634z00_2707))->BgL_variablez00) = ((BgL_variablez00_bglt)BgL_variable1633z00_2706), BUNSPEC); 
BgL_res4684z00_2721 = BgL_new1634z00_2707; BgL_res4684z00_2721; } 
BgL_res4685z00_2722 = BgL_new1634z00_2707; } } 
BgL_auxz00_4018 = 
(obj_t)(BgL_res4685z00_2722); } } } } }  else 
{ /* Ast/sexp.scm 150 */
{ /* Ast/sexp.scm 151 */
BgL_nodez00_bglt BgL_auxz00_4110;
BgL_auxz00_4110 = 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string5116z00zzast_sexpz00, BgL_expz00_17, BgL_locz00_1464); 
BgL_auxz00_4018 = 
(obj_t)(BgL_auxz00_4110); } } } } }  else 
{ /* Ast/sexp.scm 146 */
BgL_nodez00_bglt BgL_auxz00_4113;
BgL_tagzd2350zd2_1468:
BgL_auxz00_4113 = 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string5115z00zzast_sexpz00, BgL_expz00_17, BgL_locz00_1464); 
BgL_auxz00_4018 = 
(obj_t)(BgL_auxz00_4113); } }  else 
{ /* Ast/sexp.scm 146 */
BgL_nodez00_bglt BgL_auxz00_4116;
goto BgL_tagzd2350zd2_1468;
BgL_auxz00_4018 = 
(obj_t)(BgL_auxz00_4116); } }  else 
{ /* Ast/sexp.scm 146 */
BgL_nodez00_bglt BgL_auxz00_4118;
goto BgL_tagzd2350zd2_1468;
BgL_auxz00_4018 = 
(obj_t)(BgL_auxz00_4118); } }  else 
{ /* Ast/sexp.scm 146 */
BgL_nodez00_bglt BgL_auxz00_4120;
goto BgL_tagzd2350zd2_1468;
BgL_auxz00_4018 = 
(obj_t)(BgL_auxz00_4120); } }  else 
{ /* Ast/sexp.scm 146 */
BgL_nodez00_bglt BgL_auxz00_4122;
goto BgL_tagzd2350zd2_1468;
BgL_auxz00_4018 = 
(obj_t)(BgL_auxz00_4122); } }  else 
{ /* Ast/sexp.scm 146 */
BgL_nodez00_bglt BgL_auxz00_4124;
goto BgL_tagzd2350zd2_1468;
BgL_auxz00_4018 = 
(obj_t)(BgL_auxz00_4124); } } }  else 
{ /* Ast/sexp.scm 146 */
BgL_nodez00_bglt BgL_auxz00_4126;
goto BgL_tagzd2350zd2_1468;
BgL_auxz00_4018 = 
(obj_t)(BgL_auxz00_4126); } } } 
return 
(BgL_nodez00_bglt)(BgL_auxz00_4018);}  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4129;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4132;obj_t BgL_auxz00_4130;
BgL_auxz00_4132 = 
CNST_TABLE_REF(((long)17)); 
BgL_auxz00_4130 = 
CAR(BgL_expz00_17); 
BgL_testz00_4129 = 
(BgL_auxz00_4130==BgL_auxz00_4132); } 
if(BgL_testz00_4129)
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4135;
{ 
obj_t BgL_valuez00_1502;
if(
PAIRP(BgL_expz00_17))
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2377zd2_1507;
BgL_cdrzd2377zd2_1507 = 
CDR(BgL_expz00_17); 
if(
PAIRP(BgL_cdrzd2377zd2_1507))
{ /* Ast/sexp.scm 74 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2377zd2_1507), BNIL))
{ /* Ast/sexp.scm 74 */
BgL_valuez00_1502 = 
CAR(BgL_cdrzd2377zd2_1507); 
{ /* Ast/sexp.scm 170 */
obj_t BgL_locz00_1513;
BgL_locz00_1513 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, BgL_locz00_19); 
if(
NULLP(BgL_valuez00_1502))
{ /* Ast/sexp.scm 172 */
{ /* Ast/sexp.scm 173 */
obj_t BgL_arg3182z00_1515;obj_t BgL_arg3183z00_1516;
BgL_arg3182z00_1515 = BgL_locz00_1513; 
BgL_arg3183z00_1516 = BGl_za2bnilza2z00zztype_cachez00; 
{ /* Ast/sexp.scm 173 */
BgL_atomz00_bglt BgL_res4688z00_2747;
{ /* Ast/sexp.scm 173 */
BgL_typez00_bglt BgL_type1610z00_2730;
BgL_type1610z00_2730 = 
(BgL_typez00_bglt)(BgL_arg3183z00_1516); 
{ /* Ast/sexp.scm 173 */
BgL_atomz00_bglt BgL_new1612z00_2732;
{ /* Ast/sexp.scm 173 */
BgL_atomz00_bglt BgL_res4686z00_2738;
{ /* Ast/sexp.scm 173 */
BgL_atomz00_bglt BgL_new1614z00_2733;
BgL_new1614z00_2733 = 
((BgL_atomz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_atomz00_bgl) ))); 
{ /* Ast/sexp.scm 173 */
long BgL_arg4500z00_2734;
BgL_arg4500z00_2734 = 
BGl_classzd2numzd2zz__objectz00(BGl_atomz00zzast_nodez00); 
{ /* Ast/sexp.scm 173 */
BgL_objectz00_bglt BgL_auxz00_4150;
BgL_auxz00_4150 = 
(BgL_objectz00_bglt)(BgL_new1614z00_2733); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4150, BgL_arg4500z00_2734); } } 
{ /* Ast/sexp.scm 173 */
BgL_objectz00_bglt BgL_auxz00_4153;
BgL_auxz00_4153 = 
(BgL_objectz00_bglt)(BgL_new1614z00_2733); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4153, BFALSE); } 
{ /* Ast/sexp.scm 173 */
obj_t BgL_auxz00_4156;
BgL_auxz00_4156 = 
(obj_t)(BgL_new1614z00_2733); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4156); } BUNSPEC; 
BgL_res4686z00_2738 = BgL_new1614z00_2733; } 
BgL_new1612z00_2732 = BgL_res4686z00_2738; } 
{ /* Ast/sexp.scm 173 */
BgL_atomz00_bglt BgL_res4687z00_2746;
((((BgL_atomz00_bglt)CREF(BgL_new1612z00_2732))->BgL_locz00) = ((obj_t)BgL_arg3182z00_1515), BUNSPEC); 
((((BgL_atomz00_bglt)CREF(BgL_new1612z00_2732))->BgL_typez00) = ((BgL_typez00_bglt)BgL_type1610z00_2730), BUNSPEC); 
((((BgL_atomz00_bglt)CREF(BgL_new1612z00_2732))->BgL_valuez00) = ((obj_t)BNIL), BUNSPEC); 
BgL_res4687z00_2746 = BgL_new1612z00_2732; BgL_res4687z00_2746; } 
BgL_res4688z00_2747 = BgL_new1612z00_2732; } } 
BgL_auxz00_4135 = 
(obj_t)(BgL_res4688z00_2747); } } }  else 
{ /* Ast/sexp.scm 176 */
bool_t BgL_testz00_4163;
if(
PAIRP(BgL_valuez00_1502))
{ /* Ast/sexp.scm 176 */
BgL_testz00_4163 = ((bool_t)1)
; }  else 
{ /* Ast/sexp.scm 176 */
if(
VECTORP(BgL_valuez00_1502))
{ /* Ast/sexp.scm 177 */
BgL_testz00_4163 = ((bool_t)1)
; }  else 
{ /* Ast/sexp.scm 177 */
if(
STRUCTP(BgL_valuez00_1502))
{ /* Ast/sexp.scm 178 */
BgL_testz00_4163 = ((bool_t)1)
; }  else 
{ /* Ast/sexp.scm 178 */
if(
SYMBOLP(BgL_valuez00_1502))
{ /* Ast/sexp.scm 179 */
BgL_testz00_4163 = ((bool_t)1)
; }  else 
{ /* Ast/sexp.scm 179 */
BgL_testz00_4163 = 
KEYWORDP(BgL_valuez00_1502)
; } } } } 
if(BgL_testz00_4163)
{ /* Ast/sexp.scm 176 */
{ /* Ast/sexp.scm 181 */
obj_t BgL_arg3188z00_1519;obj_t BgL_arg3189z00_1520;obj_t BgL_arg3190z00_1521;
BgL_arg3188z00_1519 = BgL_locz00_1513; 
BgL_arg3189z00_1520 = BGl_za2_za2z00zztype_cachez00; 
BgL_arg3190z00_1521 = BgL_valuez00_1502; 
{ /* Ast/sexp.scm 181 */
BgL_kwotez00_bglt BgL_res4691z00_2771;
{ /* Ast/sexp.scm 181 */
BgL_typez00_bglt BgL_type1675z00_2754;
BgL_type1675z00_2754 = 
(BgL_typez00_bglt)(BgL_arg3189z00_1520); 
{ /* Ast/sexp.scm 181 */
BgL_kwotez00_bglt BgL_new1677z00_2756;
{ /* Ast/sexp.scm 181 */
BgL_kwotez00_bglt BgL_res4689z00_2762;
{ /* Ast/sexp.scm 181 */
BgL_kwotez00_bglt BgL_new1679z00_2757;
BgL_new1679z00_2757 = 
((BgL_kwotez00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_kwotez00_bgl) ))); 
{ /* Ast/sexp.scm 181 */
long BgL_arg4473z00_2758;
BgL_arg4473z00_2758 = 
BGl_classzd2numzd2zz__objectz00(BGl_kwotez00zzast_nodez00); 
{ /* Ast/sexp.scm 181 */
BgL_objectz00_bglt BgL_auxz00_4176;
BgL_auxz00_4176 = 
(BgL_objectz00_bglt)(BgL_new1679z00_2757); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4176, BgL_arg4473z00_2758); } } 
{ /* Ast/sexp.scm 181 */
BgL_objectz00_bglt BgL_auxz00_4179;
BgL_auxz00_4179 = 
(BgL_objectz00_bglt)(BgL_new1679z00_2757); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4179, BFALSE); } 
{ /* Ast/sexp.scm 181 */
obj_t BgL_auxz00_4182;
BgL_auxz00_4182 = 
(obj_t)(BgL_new1679z00_2757); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4182); } BUNSPEC; 
BgL_res4689z00_2762 = BgL_new1679z00_2757; } 
BgL_new1677z00_2756 = BgL_res4689z00_2762; } 
{ /* Ast/sexp.scm 181 */
BgL_kwotez00_bglt BgL_res4690z00_2770;
((((BgL_kwotez00_bglt)CREF(BgL_new1677z00_2756))->BgL_locz00) = ((obj_t)BgL_arg3188z00_1519), BUNSPEC); 
((((BgL_kwotez00_bglt)CREF(BgL_new1677z00_2756))->BgL_typez00) = ((BgL_typez00_bglt)BgL_type1675z00_2754), BUNSPEC); 
((((BgL_kwotez00_bglt)CREF(BgL_new1677z00_2756))->BgL_valuez00) = ((obj_t)BgL_arg3190z00_1521), BUNSPEC); 
BgL_res4690z00_2770 = BgL_new1677z00_2756; BgL_res4690z00_2770; } 
BgL_res4691z00_2771 = BgL_new1677z00_2756; } } 
BgL_auxz00_4135 = 
(obj_t)(BgL_res4691z00_2771); } } }  else 
{ /* Ast/sexp.scm 184 */
bool_t BgL_testz00_4189;
{ /* Ast/sexp.scm 184 */
bool_t BgL_test3195z00_1523;
BgL_test3195z00_1523 = 
INTEGERP(BgL_valuez00_1502); 
if(BgL_test3195z00_1523)
{ /* Ast/sexp.scm 184 */
BgL_testz00_4189 = ((bool_t)1)
; }  else 
{ /* Ast/sexp.scm 185 */
bool_t BgL_testz00_4192;
if(BgL_test3195z00_1523)
{ /* Ast/sexp.scm 185 */
BgL_testz00_4192 = ((bool_t)1)
; }  else 
{ /* Ast/sexp.scm 185 */
BgL_testz00_4192 = 
REALP(BgL_valuez00_1502)
; } 
if(BgL_testz00_4192)
{ /* Ast/sexp.scm 185 */
BgL_testz00_4189 = ((bool_t)1)
; }  else 
{ /* Ast/sexp.scm 185 */
if(
STRINGP(BgL_valuez00_1502))
{ /* Ast/sexp.scm 186 */
BgL_testz00_4189 = ((bool_t)1)
; }  else 
{ /* Ast/sexp.scm 186 */
if(
CNSTP(BgL_valuez00_1502))
{ /* Ast/sexp.scm 187 */
BgL_testz00_4189 = ((bool_t)1)
; }  else 
{ /* Ast/sexp.scm 187 */
if(
CHARP(BgL_valuez00_1502))
{ /* Ast/sexp.scm 191 */
BgL_testz00_4189 = ((bool_t)1)
; }  else 
{ /* Ast/sexp.scm 191 */
BgL_testz00_4189 = 
BOOLEANP(BgL_valuez00_1502)
; } } } } } } 
if(BgL_testz00_4189)
{ /* Ast/sexp.scm 184 */
{ /* Ast/sexp.scm 193 */
BgL_nodez00_bglt BgL_auxz00_4202;
BgL_auxz00_4202 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_valuez00_1502, BgL_stackz00_18, BgL_locz00_1513, BgL_sitez00_20); 
BgL_auxz00_4135 = 
(obj_t)(BgL_auxz00_4202); } }  else 
{ /* Ast/sexp.scm 184 */
{ /* Ast/sexp.scm 195 */
BgL_nodez00_bglt BgL_auxz00_4205;
BgL_auxz00_4205 = 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string5114z00zzast_sexpz00, BgL_expz00_17, BgL_locz00_1513); 
BgL_auxz00_4135 = 
(obj_t)(BgL_auxz00_4205); } } } } } }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4209;
BgL_tagzd2372zd2_1504:
BgL_auxz00_4209 = 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string5114z00zzast_sexpz00, BgL_expz00_17, BgL_locz00_19); 
BgL_auxz00_4135 = 
(obj_t)(BgL_auxz00_4209); } }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4212;
goto BgL_tagzd2372zd2_1504;
BgL_auxz00_4135 = 
(obj_t)(BgL_auxz00_4212); } }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4214;
goto BgL_tagzd2372zd2_1504;
BgL_auxz00_4135 = 
(obj_t)(BgL_auxz00_4214); } } 
return 
(BgL_nodez00_bglt)(BgL_auxz00_4135);}  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4217;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4220;obj_t BgL_auxz00_4218;
BgL_auxz00_4220 = 
CNST_TABLE_REF(((long)20)); 
BgL_auxz00_4218 = 
CAR(BgL_expz00_17); 
BgL_testz00_4217 = 
(BgL_auxz00_4218==BgL_auxz00_4220); } 
if(BgL_testz00_4217)
{ /* Ast/sexp.scm 74 */
BgL_sequencez00_bglt BgL_auxz00_4223;
BgL_bodyz00_1273 = 
CDR(BgL_expz00_17); 
{ /* Ast/sexp.scm 200 */
obj_t BgL_bodyz00_1532;
if(
NULLP(BgL_bodyz00_1273))
{ /* Ast/sexp.scm 201 */
obj_t BgL_list3228z00_1540;
BgL_list3228z00_1540 = 
MAKE_PAIR(BUNSPEC, BNIL); 
BgL_bodyz00_1532 = BgL_list3228z00_1540; }  else 
{ /* Ast/sexp.scm 200 */
BgL_bodyz00_1532 = BgL_bodyz00_1273; } 
{ /* Ast/sexp.scm 203 */
obj_t BgL_locz00_1533;
BgL_locz00_1533 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, BgL_locz00_19); 
{ /* Ast/sexp.scm 203 */
obj_t BgL_nodesz00_1534;
BgL_nodesz00_1534 = 
BGl_sexpza2zd2ze3nodez93zzast_sexpz00(BgL_bodyz00_1532, BgL_stackz00_18, BgL_locz00_1533, BgL_sitez00_20); 
{ /* Ast/sexp.scm 204 */

{ /* Ast/sexp.scm 205 */
obj_t BgL_arg3219z00_1535;obj_t BgL_arg3220z00_1536;obj_t BgL_arg3222z00_1538;
BgL_arg3219z00_1535 = BgL_locz00_1533; 
BgL_arg3220z00_1536 = BGl_za2_za2z00zztype_cachez00; 
BgL_arg3222z00_1538 = BgL_nodesz00_1534; 
{ /* Ast/sexp.scm 205 */
BgL_sequencez00_bglt BgL_res4696z00_2807;
{ /* Ast/sexp.scm 205 */
BgL_typez00_bglt BgL_type1705z00_2784;obj_t BgL_key1707z00_2786;
BgL_type1705z00_2784 = 
(BgL_typez00_bglt)(BgL_arg3220z00_1536); 
BgL_key1707z00_2786 = 
BINT(((long)-1)); 
{ /* Ast/sexp.scm 205 */
BgL_sequencez00_bglt BgL_new1709z00_2788;
{ /* Ast/sexp.scm 205 */
BgL_sequencez00_bglt BgL_res4694z00_2794;
{ /* Ast/sexp.scm 205 */
BgL_sequencez00_bglt BgL_new1711z00_2789;
BgL_new1711z00_2789 = 
((BgL_sequencez00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_sequencez00_bgl) ))); 
{ /* Ast/sexp.scm 205 */
long BgL_arg4464z00_2790;
BgL_arg4464z00_2790 = 
BGl_classzd2numzd2zz__objectz00(BGl_sequencez00zzast_nodez00); 
{ /* Ast/sexp.scm 205 */
BgL_objectz00_bglt BgL_auxz00_4233;
BgL_auxz00_4233 = 
(BgL_objectz00_bglt)(BgL_new1711z00_2789); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4233, BgL_arg4464z00_2790); } } 
{ /* Ast/sexp.scm 205 */
BgL_objectz00_bglt BgL_auxz00_4236;
BgL_auxz00_4236 = 
(BgL_objectz00_bglt)(BgL_new1711z00_2789); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4236, BFALSE); } 
{ /* Ast/sexp.scm 205 */
obj_t BgL_auxz00_4239;
BgL_auxz00_4239 = 
(obj_t)(BgL_new1711z00_2789); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4239); } BUNSPEC; 
BgL_res4694z00_2794 = BgL_new1711z00_2789; } 
BgL_new1709z00_2788 = BgL_res4694z00_2794; } 
{ /* Ast/sexp.scm 205 */
BgL_sequencez00_bglt BgL_res4695z00_2806;
((((BgL_sequencez00_bglt)CREF(BgL_new1709z00_2788))->BgL_locz00) = ((obj_t)BgL_arg3219z00_1535), BUNSPEC); 
((((BgL_sequencez00_bglt)CREF(BgL_new1709z00_2788))->BgL_typez00) = ((BgL_typez00_bglt)BgL_type1705z00_2784), BUNSPEC); 
((((BgL_sequencez00_bglt)CREF(BgL_new1709z00_2788))->BgL_sidezd2effectzf3z21) = ((obj_t)BUNSPEC), BUNSPEC); 
((((BgL_sequencez00_bglt)CREF(BgL_new1709z00_2788))->BgL_keyz00) = ((obj_t)BgL_key1707z00_2786), BUNSPEC); 
((((BgL_sequencez00_bglt)CREF(BgL_new1709z00_2788))->BgL_nodesz00) = ((obj_t)BgL_arg3222z00_1538), BUNSPEC); 
BgL_res4695z00_2806 = BgL_new1709z00_2788; BgL_res4695z00_2806; } 
BgL_res4696z00_2807 = BgL_new1709z00_2788; } } 
BgL_auxz00_4223 = BgL_res4696z00_2807; } } } } } } 
return 
(BgL_nodez00_bglt)(BgL_auxz00_4223);}  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4249;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4252;obj_t BgL_auxz00_4250;
BgL_auxz00_4252 = 
CNST_TABLE_REF(((long)12)); 
BgL_auxz00_4250 = 
CAR(BgL_expz00_17); 
BgL_testz00_4249 = 
(BgL_auxz00_4250==BgL_auxz00_4252); } 
if(BgL_testz00_4249)
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4255;
{ 
obj_t BgL_siz00_1541;obj_t BgL_alorsz00_1542;obj_t BgL_sinonz00_1543;obj_t BgL_siz00_1545;obj_t BgL_alorsz00_1546;
if(
PAIRP(BgL_expz00_17))
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2393zd2_1551;
BgL_cdrzd2393zd2_1551 = 
CDR(BgL_expz00_17); 
if(
PAIRP(BgL_cdrzd2393zd2_1551))
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2398zd2_1553;
BgL_cdrzd2398zd2_1553 = 
CDR(BgL_cdrzd2393zd2_1551); 
if(
PAIRP(BgL_cdrzd2398zd2_1553))
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2403zd2_1555;
BgL_cdrzd2403zd2_1555 = 
CDR(BgL_cdrzd2398zd2_1553); 
if(
PAIRP(BgL_cdrzd2403zd2_1555))
{ /* Ast/sexp.scm 74 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2403zd2_1555), BNIL))
{ /* Ast/sexp.scm 74 */
BgL_siz00_1541 = 
CAR(BgL_cdrzd2393zd2_1551); 
BgL_alorsz00_1542 = 
CAR(BgL_cdrzd2398zd2_1553); 
BgL_sinonz00_1543 = 
CAR(BgL_cdrzd2403zd2_1555); 
{ 
obj_t BgL_siz00_1570;
if(
PAIRP(BgL_siz00_1541))
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2458zd2_1575;
BgL_cdrzd2458zd2_1575 = 
CDR(BgL_siz00_1541); 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4273;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4276;obj_t BgL_auxz00_4274;
BgL_auxz00_4276 = 
CNST_TABLE_REF(((long)12)); 
BgL_auxz00_4274 = 
CAR(BgL_siz00_1541); 
BgL_testz00_4273 = 
(BgL_auxz00_4274==BgL_auxz00_4276); } 
if(BgL_testz00_4273)
{ /* Ast/sexp.scm 74 */
if(
PAIRP(BgL_cdrzd2458zd2_1575))
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2461zd2_1578;
BgL_cdrzd2461zd2_1578 = 
CDR(BgL_cdrzd2458zd2_1575); 
if(
PAIRP(BgL_cdrzd2461zd2_1578))
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2464zd2_1580;
BgL_cdrzd2464zd2_1580 = 
CDR(BgL_cdrzd2461zd2_1578); 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4285;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4286;
BgL_auxz00_4286 = 
CAR(BgL_cdrzd2461zd2_1578); 
BgL_testz00_4285 = 
(BgL_auxz00_4286==BFALSE); } 
if(BgL_testz00_4285)
{ /* Ast/sexp.scm 74 */
if(
PAIRP(BgL_cdrzd2464zd2_1580))
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4291;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4292;
BgL_auxz00_4292 = 
CAR(BgL_cdrzd2464zd2_1580); 
BgL_testz00_4291 = 
(BgL_auxz00_4292==BTRUE); } 
if(BgL_testz00_4291)
{ /* Ast/sexp.scm 74 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2464zd2_1580), BNIL))
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4298;
BgL_siz00_1570 = 
CAR(BgL_cdrzd2458zd2_1575); 
BgL_tagzd2450zd2_1571:
{ /* Ast/sexp.scm 214 */
obj_t BgL_auxz00_4299;
BgL_auxz00_4299 = 
CDR(BgL_expz00_17); 
SET_CAR(BgL_auxz00_4299, BgL_siz00_1570); } 
{ /* Ast/sexp.scm 215 */
obj_t BgL_auxz00_4302;
{ /* Ast/sexp.scm 215 */
obj_t BgL_auxz00_4303;
BgL_auxz00_4303 = 
CDR(BgL_expz00_17); 
BgL_auxz00_4302 = 
CDR(BgL_auxz00_4303); } 
SET_CAR(BgL_auxz00_4302, BgL_sinonz00_1543); } 
{ /* Ast/sexp.scm 216 */
obj_t BgL_auxz00_4307;
{ /* Ast/sexp.scm 216 */
obj_t BgL_auxz00_4308;
{ /* Ast/sexp.scm 216 */
obj_t BgL_auxz00_4309;
BgL_auxz00_4309 = 
CDR(BgL_expz00_17); 
BgL_auxz00_4308 = 
CDR(BgL_auxz00_4309); } 
BgL_auxz00_4307 = 
CDR(BgL_auxz00_4308); } 
SET_CAR(BgL_auxz00_4307, BgL_alorsz00_1542); } 
BgL_auxz00_4298 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_17, BgL_stackz00_18, BgL_locz00_19, BgL_sitez00_20); 
BgL_auxz00_4255 = 
(obj_t)(BgL_auxz00_4298); }  else 
{ /* Ast/sexp.scm 74 */
BgL_tagzd2451zd2_1572:
{ /* Ast/sexp.scm 219 */
bool_t BgL_test3356z00_1606;
if(
SYMBOLP(BgL_siz00_1541))
{ /* Ast/sexp.scm 219 */
BgL_test3356z00_1606 = ((bool_t)1); }  else 
{ /* Ast/sexp.scm 219 */
BgL_test3356z00_1606 = 
BGl_iszd2azf3z21zz__objectz00(BgL_siz00_1541, BGl_atomz00zzast_nodez00); } 
if(BgL_test3356z00_1606)
{ /* Ast/sexp.scm 220 */
obj_t BgL_olocz00_1607;
BgL_olocz00_1607 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, BgL_locz00_19); 
{ /* Ast/sexp.scm 220 */
obj_t BgL_cdlocz00_1608;
BgL_cdlocz00_1608 = 
BGl_findzd2locationzf2locz20zztools_locationz00(
CDR(BgL_expz00_17), BgL_locz00_19); 
{ /* Ast/sexp.scm 221 */
obj_t BgL_cddlocz00_1609;
{ /* Ast/sexp.scm 222 */
obj_t BgL_auxz00_4324;
{ /* Ast/sexp.scm 222 */
obj_t BgL_auxz00_4325;
BgL_auxz00_4325 = 
CDR(BgL_expz00_17); 
BgL_auxz00_4324 = 
CDR(BgL_auxz00_4325); } 
BgL_cddlocz00_1609 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_auxz00_4324, BgL_locz00_19); } 
{ /* Ast/sexp.scm 222 */
obj_t BgL_cdddlocz00_1610;
{ /* Ast/sexp.scm 223 */
obj_t BgL_auxz00_4329;
{ /* Ast/sexp.scm 223 */
obj_t BgL_auxz00_4330;
{ /* Ast/sexp.scm 223 */
obj_t BgL_auxz00_4331;
BgL_auxz00_4331 = 
CDR(BgL_expz00_17); 
BgL_auxz00_4330 = 
CDR(BgL_auxz00_4331); } 
BgL_auxz00_4329 = 
CDR(BgL_auxz00_4330); } 
BgL_cdddlocz00_1610 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_auxz00_4329, BgL_locz00_19); } 
{ /* Ast/sexp.scm 223 */
obj_t BgL_lzd2sizd2_1611;
BgL_lzd2sizd2_1611 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_siz00_1541, BgL_cdlocz00_1608); 
{ /* Ast/sexp.scm 224 */
obj_t BgL_lzd2alorszd2_1612;
BgL_lzd2alorszd2_1612 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_alorsz00_1542, BgL_cddlocz00_1609); 
{ /* Ast/sexp.scm 225 */
obj_t BgL_lzd2sinonzd2_1613;
BgL_lzd2sinonzd2_1613 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_sinonz00_1543, BgL_cdddlocz00_1610); 
{ /* Ast/sexp.scm 226 */
BgL_nodez00_bglt BgL_siz00_1614;
BgL_siz00_1614 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_siz00_1541, BgL_stackz00_18, BgL_lzd2sizd2_1611, 
CNST_TABLE_REF(((long)1))); 
{ /* Ast/sexp.scm 227 */
BgL_nodez00_bglt BgL_alorsz00_1615;
BgL_alorsz00_1615 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_alorsz00_1542, BgL_stackz00_18, BgL_lzd2alorszd2_1612, 
CNST_TABLE_REF(((long)1))); 
{ /* Ast/sexp.scm 228 */
BgL_nodez00_bglt BgL_sinonz00_1616;
BgL_sinonz00_1616 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_sinonz00_1543, BgL_stackz00_18, BgL_lzd2sinonzd2_1613, 
CNST_TABLE_REF(((long)1))); 
{ /* Ast/sexp.scm 229 */
obj_t BgL_locz00_1617;
{ /* Ast/sexp.scm 230 */
obj_t BgL_locz00_1624;
BgL_locz00_1624 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, 
(((BgL_nodez00_bglt)CREF(BgL_siz00_1614))->BgL_locz00)); 
{ /* Ast/sexp.scm 233 */
bool_t BgL_testz00_4347;
if(
STRUCTP(BgL_locz00_1624))
{ /* Ast/sexp.scm 233 */
obj_t BgL_auxz00_4352;obj_t BgL_auxz00_4350;
BgL_auxz00_4352 = 
CNST_TABLE_REF(((long)9)); 
BgL_auxz00_4350 = 
STRUCT_KEY(BgL_locz00_1624); 
BgL_testz00_4347 = 
(BgL_auxz00_4350==BgL_auxz00_4352); }  else 
{ /* Ast/sexp.scm 233 */
BgL_testz00_4347 = ((bool_t)0)
; } 
if(BgL_testz00_4347)
{ /* Ast/sexp.scm 233 */
BgL_locz00_1617 = BgL_locz00_1624; }  else 
{ /* Ast/sexp.scm 233 */
BgL_locz00_1617 = BgL_olocz00_1607; } } } 
{ /* Ast/sexp.scm 230 */

{ /* Ast/sexp.scm 236 */
obj_t BgL_arg3358z00_1618;obj_t BgL_arg3359z00_1619;BgL_nodez00_bglt BgL_arg3361z00_1621;BgL_nodez00_bglt BgL_arg3362z00_1622;BgL_nodez00_bglt BgL_arg3363z00_1623;
BgL_arg3358z00_1618 = BgL_locz00_1617; 
BgL_arg3359z00_1619 = BGl_za2_za2z00zztype_cachez00; 
BgL_arg3361z00_1621 = BgL_siz00_1614; 
BgL_arg3362z00_1622 = BgL_alorsz00_1615; 
BgL_arg3363z00_1623 = BgL_sinonz00_1616; 
{ /* Ast/sexp.scm 236 */
BgL_conditionalz00_bglt BgL_res4700z00_2909;
{ /* Ast/sexp.scm 236 */
BgL_typez00_bglt BgL_type2331z00_2880;obj_t BgL_key2333z00_2882;
BgL_type2331z00_2880 = 
(BgL_typez00_bglt)(BgL_arg3359z00_1619); 
BgL_key2333z00_2882 = 
BINT(((long)-1)); 
{ /* Ast/sexp.scm 236 */
BgL_conditionalz00_bglt BgL_new2337z00_2886;
{ /* Ast/sexp.scm 236 */
BgL_conditionalz00_bglt BgL_res4698z00_2892;
{ /* Ast/sexp.scm 236 */
BgL_conditionalz00_bglt BgL_new2339z00_2887;
BgL_new2339z00_2887 = 
((BgL_conditionalz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_conditionalz00_bgl) ))); 
{ /* Ast/sexp.scm 236 */
long BgL_arg4320z00_2888;
BgL_arg4320z00_2888 = 
BGl_classzd2numzd2zz__objectz00(BGl_conditionalz00zzast_nodez00); 
{ /* Ast/sexp.scm 236 */
BgL_objectz00_bglt BgL_auxz00_4359;
BgL_auxz00_4359 = 
(BgL_objectz00_bglt)(BgL_new2339z00_2887); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4359, BgL_arg4320z00_2888); } } 
{ /* Ast/sexp.scm 236 */
BgL_objectz00_bglt BgL_auxz00_4362;
BgL_auxz00_4362 = 
(BgL_objectz00_bglt)(BgL_new2339z00_2887); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4362, BFALSE); } 
{ /* Ast/sexp.scm 236 */
obj_t BgL_auxz00_4365;
BgL_auxz00_4365 = 
(obj_t)(BgL_new2339z00_2887); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4365); } BUNSPEC; 
BgL_res4698z00_2892 = BgL_new2339z00_2887; } 
BgL_new2337z00_2886 = BgL_res4698z00_2892; } 
{ /* Ast/sexp.scm 236 */
BgL_conditionalz00_bglt BgL_res4699z00_2908;
((((BgL_conditionalz00_bglt)CREF(BgL_new2337z00_2886))->BgL_locz00) = ((obj_t)BgL_arg3358z00_1618), BUNSPEC); 
((((BgL_conditionalz00_bglt)CREF(BgL_new2337z00_2886))->BgL_typez00) = ((BgL_typez00_bglt)BgL_type2331z00_2880), BUNSPEC); 
((((BgL_conditionalz00_bglt)CREF(BgL_new2337z00_2886))->BgL_sidezd2effectzf3z21) = ((obj_t)BUNSPEC), BUNSPEC); 
((((BgL_conditionalz00_bglt)CREF(BgL_new2337z00_2886))->BgL_keyz00) = ((obj_t)BgL_key2333z00_2882), BUNSPEC); 
((((BgL_conditionalz00_bglt)CREF(BgL_new2337z00_2886))->BgL_testz00) = ((BgL_nodez00_bglt)BgL_arg3361z00_1621), BUNSPEC); 
((((BgL_conditionalz00_bglt)CREF(BgL_new2337z00_2886))->BgL_truez00) = ((BgL_nodez00_bglt)BgL_arg3362z00_1622), BUNSPEC); 
((((BgL_conditionalz00_bglt)CREF(BgL_new2337z00_2886))->BgL_falsez00) = ((BgL_nodez00_bglt)BgL_arg3363z00_1623), BUNSPEC); 
BgL_res4699z00_2908 = BgL_new2337z00_2886; BgL_res4699z00_2908; } 
BgL_res4700z00_2909 = BgL_new2337z00_2886; } } 
BgL_auxz00_4255 = 
(obj_t)(BgL_res4700z00_2909); } } } } } } } } } } } } } }  else 
{ /* Ast/sexp.scm 241 */
obj_t BgL_testz00_1630;
{ /* Ast/sexp.scm 241 */
obj_t BgL_arg3437z00_1649;
BgL_arg3437z00_1649 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)10)), BEOA); 
BgL_testz00_1630 = 
BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(BgL_arg3437z00_1649); } 
{ /* Ast/sexp.scm 243 */
obj_t BgL_arg3392z00_1631;
{ /* Ast/sexp.scm 243 */
obj_t BgL_arg3395z00_1632;obj_t BgL_arg3396z00_1633;
BgL_arg3395z00_1632 = 
CNST_TABLE_REF(((long)7)); 
{ /* Ast/sexp.scm 243 */
obj_t BgL_arg3399z00_1634;obj_t BgL_arg3400z00_1635;
{ /* Ast/sexp.scm 243 */
obj_t BgL_arg3403z00_1636;
{ /* Ast/sexp.scm 243 */
obj_t BgL_arg3407z00_1638;obj_t BgL_arg3408z00_1639;
{ /* Ast/sexp.scm 243 */
obj_t BgL_list3411z00_1640;
{ /* Ast/sexp.scm 243 */
obj_t BgL_arg3413z00_1641;
{ /* Ast/sexp.scm 243 */
obj_t BgL_auxz00_4381;
BgL_auxz00_4381 = 
CNST_TABLE_REF(((long)11)); 
BgL_arg3413z00_1641 = 
MAKE_PAIR(BgL_auxz00_4381, BNIL); } 
BgL_list3411z00_1640 = 
MAKE_PAIR(BgL_testz00_1630, BgL_arg3413z00_1641); } 
BgL_arg3407z00_1638 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list3411z00_1640); } 
BgL_arg3408z00_1639 = 
MAKE_PAIR(BgL_siz00_1541, BNIL); 
BgL_arg3403z00_1636 = 
MAKE_PAIR(BgL_arg3407z00_1638, BgL_arg3408z00_1639); } 
BgL_arg3399z00_1634 = 
MAKE_PAIR(BgL_arg3403z00_1636, BNIL); } 
{ /* Ast/sexp.scm 244 */
obj_t BgL_arg3418z00_1642;
{ /* Ast/sexp.scm 244 */
obj_t BgL_arg3422z00_1644;
{ /* Ast/sexp.scm 244 */
obj_t BgL_arg3425z00_1645;obj_t BgL_arg3426z00_1646;
BgL_arg3425z00_1645 = 
CNST_TABLE_REF(((long)12)); 
{ /* Ast/sexp.scm 244 */
obj_t BgL_arg3429z00_1647;
{ /* Ast/sexp.scm 244 */
obj_t BgL_arg3432z00_1648;
BgL_arg3432z00_1648 = 
MAKE_PAIR(BgL_sinonz00_1543, BNIL); 
BgL_arg3429z00_1647 = 
MAKE_PAIR(BgL_alorsz00_1542, BgL_arg3432z00_1648); } 
BgL_arg3426z00_1646 = 
MAKE_PAIR(BgL_testz00_1630, BgL_arg3429z00_1647); } 
BgL_arg3422z00_1644 = 
MAKE_PAIR(BgL_arg3425z00_1645, BgL_arg3426z00_1646); } 
BgL_arg3418z00_1642 = 
BGl_epairifyzd2reczd2zztools_miscz00(BgL_arg3422z00_1644, BgL_expz00_17); } 
BgL_arg3400z00_1635 = 
MAKE_PAIR(BgL_arg3418z00_1642, BNIL); } 
BgL_arg3396z00_1633 = 
MAKE_PAIR(BgL_arg3399z00_1634, BgL_arg3400z00_1635); } 
BgL_arg3392z00_1631 = 
MAKE_PAIR(BgL_arg3395z00_1632, BgL_arg3396z00_1633); } 
BGl_replacez12z12zztools_miscz00(BgL_expz00_17, BgL_arg3392z00_1631); } 
{ /* Ast/sexp.scm 246 */
BgL_nodez00_bglt BgL_auxz00_4399;
BgL_auxz00_4399 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_17, BgL_stackz00_18, BgL_locz00_19, BgL_sitez00_20); 
BgL_auxz00_4255 = 
(obj_t)(BgL_auxz00_4399); } } } } }  else 
{ /* Ast/sexp.scm 74 */
goto BgL_tagzd2451zd2_1572;} }  else 
{ /* Ast/sexp.scm 74 */
goto BgL_tagzd2451zd2_1572;} }  else 
{ /* Ast/sexp.scm 74 */
goto BgL_tagzd2451zd2_1572;} } }  else 
{ /* Ast/sexp.scm 74 */
goto BgL_tagzd2451zd2_1572;} }  else 
{ /* Ast/sexp.scm 74 */
goto BgL_tagzd2451zd2_1572;} }  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4402;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4405;obj_t BgL_auxz00_4403;
BgL_auxz00_4405 = 
CNST_TABLE_REF(((long)13)); 
BgL_auxz00_4403 = 
CAR(BgL_siz00_1541); 
BgL_testz00_4402 = 
(BgL_auxz00_4403==BgL_auxz00_4405); } 
if(BgL_testz00_4402)
{ /* Ast/sexp.scm 74 */
if(
PAIRP(BgL_cdrzd2458zd2_1575))
{ /* Ast/sexp.scm 74 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2458zd2_1575), BNIL))
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4413;
{ 
obj_t BgL_siz00_4414;
BgL_siz00_4414 = 
CAR(BgL_cdrzd2458zd2_1575); 
BgL_siz00_1570 = BgL_siz00_4414; 
goto BgL_tagzd2450zd2_1571;} 
BgL_auxz00_4255 = 
(obj_t)(BgL_auxz00_4413); }  else 
{ /* Ast/sexp.scm 74 */
goto BgL_tagzd2451zd2_1572;} }  else 
{ /* Ast/sexp.scm 74 */
goto BgL_tagzd2451zd2_1572;} }  else 
{ /* Ast/sexp.scm 74 */
goto BgL_tagzd2451zd2_1572;} } } }  else 
{ /* Ast/sexp.scm 74 */
goto BgL_tagzd2451zd2_1572;} } }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4420;
BgL_tagzd2384zd2_1548:
BgL_auxz00_4420 = 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string5113z00zzast_sexpz00, BgL_expz00_17, BgL_locz00_19); 
BgL_auxz00_4255 = 
(obj_t)(BgL_auxz00_4420); } }  else 
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2428zd2_1564;
BgL_cdrzd2428zd2_1564 = 
CDR(BgL_cdrzd2393zd2_1551); 
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2428zd2_1564), BNIL))
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4427;
BgL_siz00_1545 = 
CAR(BgL_cdrzd2393zd2_1551); 
BgL_alorsz00_1546 = 
CAR(BgL_cdrzd2428zd2_1564); 
{ /* Ast/sexp.scm 248 */
obj_t BgL_arg3444z00_1651;obj_t BgL_arg3445z00_1652;
{ /* Ast/sexp.scm 248 */
obj_t BgL_auxz00_4428;
BgL_auxz00_4428 = 
CDR(BgL_expz00_17); 
BgL_arg3444z00_1651 = 
CDR(BgL_auxz00_4428); } 
{ /* Ast/sexp.scm 248 */
obj_t BgL_list3449z00_1653;
BgL_list3449z00_1653 = 
MAKE_PAIR(BUNSPEC, BNIL); 
BgL_arg3445z00_1652 = BgL_list3449z00_1653; } 
SET_CDR(BgL_arg3444z00_1651, BgL_arg3445z00_1652); } 
BgL_auxz00_4427 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_17, BgL_stackz00_18, BgL_locz00_19, BgL_sitez00_20); 
BgL_auxz00_4255 = 
(obj_t)(BgL_auxz00_4427); }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4437;
goto BgL_tagzd2384zd2_1548;
BgL_auxz00_4255 = 
(obj_t)(BgL_auxz00_4437); } } }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4439;
goto BgL_tagzd2384zd2_1548;
BgL_auxz00_4255 = 
(obj_t)(BgL_auxz00_4439); } }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4441;
goto BgL_tagzd2384zd2_1548;
BgL_auxz00_4255 = 
(obj_t)(BgL_auxz00_4441); } }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4443;
goto BgL_tagzd2384zd2_1548;
BgL_auxz00_4255 = 
(obj_t)(BgL_auxz00_4443); } } 
return 
(BgL_nodez00_bglt)(BgL_auxz00_4255);}  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4446;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4449;obj_t BgL_auxz00_4447;
BgL_auxz00_4449 = 
CNST_TABLE_REF(((long)8)); 
BgL_auxz00_4447 = 
CAR(BgL_expz00_17); 
BgL_testz00_4446 = 
(BgL_auxz00_4447==BgL_auxz00_4449); } 
if(BgL_testz00_4446)
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4452;
{ 
obj_t BgL_varz00_1654;obj_t BgL_valz00_1655;
if(
PAIRP(BgL_expz00_17))
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2489zd2_1660;
BgL_cdrzd2489zd2_1660 = 
CDR(BgL_expz00_17); 
if(
PAIRP(BgL_cdrzd2489zd2_1660))
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2493zd2_1662;
BgL_cdrzd2493zd2_1662 = 
CDR(BgL_cdrzd2489zd2_1660); 
if(
PAIRP(BgL_cdrzd2493zd2_1662))
{ /* Ast/sexp.scm 74 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2493zd2_1662), BNIL))
{ /* Ast/sexp.scm 74 */
BgL_varz00_1654 = 
CAR(BgL_cdrzd2489zd2_1660); 
BgL_valz00_1655 = 
CAR(BgL_cdrzd2493zd2_1662); 
{ /* Ast/sexp.scm 256 */
obj_t BgL_locz00_1669;
BgL_locz00_1669 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, BgL_locz00_19); 
{ /* Ast/sexp.scm 256 */
obj_t BgL_cdlocz00_1670;
BgL_cdlocz00_1670 = 
BGl_findzd2locationzf2locz20zztools_locationz00(
CDR(BgL_expz00_17), BgL_locz00_1669); 
{ /* Ast/sexp.scm 257 */
obj_t BgL_cddlocz00_1671;
{ /* Ast/sexp.scm 258 */
obj_t BgL_auxz00_4467;
{ /* Ast/sexp.scm 258 */
obj_t BgL_auxz00_4468;
BgL_auxz00_4468 = 
CDR(BgL_expz00_17); 
BgL_auxz00_4467 = 
CDR(BgL_auxz00_4468); } 
BgL_cddlocz00_1671 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_auxz00_4467, BgL_locz00_1669); } 
{ /* Ast/sexp.scm 258 */
obj_t BgL_valzd2loczd2_1672;
BgL_valzd2loczd2_1672 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_valz00_1655, BgL_cddlocz00_1671); 
{ /* Ast/sexp.scm 259 */
BgL_nodez00_bglt BgL_valz00_1673;
BgL_valz00_1673 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_valz00_1655, BgL_stackz00_18, BgL_valzd2loczd2_1672, 
CNST_TABLE_REF(((long)1))); 
{ /* Ast/sexp.scm 260 */

{ /* Ast/sexp.scm 261 */
BgL_nodez00_bglt BgL_astz00_1674;
BgL_astz00_1674 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_varz00_1654, BgL_stackz00_18, BgL_cdlocz00_1670, 
CNST_TABLE_REF(((long)8))); 
{ /* Ast/sexp.scm 262 */
bool_t BgL_test3477z00_1675;
BgL_test3477z00_1675 = 
BGl_iszd2azf3z21zz__objectz00(
(obj_t)(BgL_astz00_1674), BGl_varz00zzast_nodez00); 
if(BgL_test3477z00_1675)
{ /* Ast/sexp.scm 264 */
bool_t BgL_test3478z00_1677;
{ /* Ast/sexp.scm 264 */
bool_t BgL_test3486z00_1682;
{ /* Ast/sexp.scm 264 */
obj_t BgL_auxz00_4480;
{ /* Ast/sexp.scm 264 */
BgL_variablez00_bglt BgL_auxz00_4481;
{ /* Ast/sexp.scm 264 */
BgL_varz00_bglt BgL_obj1620z00_2932;
BgL_obj1620z00_2932 = 
(BgL_varz00_bglt)(BgL_astz00_1674); 
BgL_auxz00_4481 = 
(((BgL_varz00_bglt)CREF(BgL_obj1620z00_2932))->BgL_variablez00); } 
BgL_auxz00_4480 = 
(obj_t)(BgL_auxz00_4481); } 
BgL_test3486z00_1682 = 
BGl_iszd2azf3z21zz__objectz00(BgL_auxz00_4480, BGl_globalz00zzast_varz00); } 
if(BgL_test3486z00_1682)
{ /* Ast/sexp.scm 265 */
BgL_globalz00_bglt BgL_auxz00_4487;
{ /* Ast/sexp.scm 265 */
BgL_variablez00_bglt BgL_auxz00_4488;
{ /* Ast/sexp.scm 265 */
BgL_varz00_bglt BgL_obj1620z00_2934;
BgL_obj1620z00_2934 = 
(BgL_varz00_bglt)(BgL_astz00_1674); 
BgL_auxz00_4488 = 
(((BgL_varz00_bglt)CREF(BgL_obj1620z00_2934))->BgL_variablez00); } 
BgL_auxz00_4487 = 
(BgL_globalz00_bglt)(BgL_auxz00_4488); } 
BgL_test3478z00_1677 = 
BGl_globalzd2readzd2onlyzf3zf3zzast_varz00(BgL_auxz00_4487); }  else 
{ /* Ast/sexp.scm 264 */
BgL_test3478z00_1677 = ((bool_t)0); } } 
if(BgL_test3478z00_1677)
{ /* Ast/sexp.scm 266 */
BgL_nodez00_bglt BgL_auxz00_4494;
BgL_auxz00_4494 = 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string5111z00zzast_sexpz00, BgL_expz00_17, BgL_cdlocz00_1670); 
BgL_auxz00_4452 = 
(obj_t)(BgL_auxz00_4494); }  else 
{ /* Ast/sexp.scm 270 */
obj_t BgL_arg3481z00_1678;obj_t BgL_arg3482z00_1679;BgL_nodez00_bglt BgL_arg3484z00_1681;
BgL_arg3481z00_1678 = BgL_locz00_1669; 
BgL_arg3482z00_1679 = BGl_za2unspecza2z00zztype_cachez00; 
BgL_arg3484z00_1681 = BgL_valz00_1673; 
{ /* Ast/sexp.scm 269 */
BgL_setqz00_bglt BgL_res4704z00_2956;
{ /* Ast/sexp.scm 269 */
BgL_typez00_bglt BgL_type2288z00_2936;BgL_varz00_bglt BgL_var2289z00_2937;
BgL_type2288z00_2936 = 
(BgL_typez00_bglt)(BgL_arg3482z00_1679); 
{ /* Ast/sexp.scm 272 */
BgL_nodez00_bglt BgL_auxz00_4498;
BgL_auxz00_4498 = BgL_astz00_1674; 
BgL_var2289z00_2937 = 
(BgL_varz00_bglt)(BgL_auxz00_4498); } 
{ /* Ast/sexp.scm 269 */
BgL_setqz00_bglt BgL_new2291z00_2939;
{ /* Ast/sexp.scm 269 */
BgL_setqz00_bglt BgL_res4702z00_2945;
{ /* Ast/sexp.scm 269 */
BgL_setqz00_bglt BgL_new2293z00_2940;
BgL_new2293z00_2940 = 
((BgL_setqz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_setqz00_bgl) ))); 
{ /* Ast/sexp.scm 269 */
long BgL_arg4329z00_2941;
BgL_arg4329z00_2941 = 
BGl_classzd2numzd2zz__objectz00(BGl_setqz00zzast_nodez00); 
{ /* Ast/sexp.scm 269 */
BgL_objectz00_bglt BgL_auxz00_4502;
BgL_auxz00_4502 = 
(BgL_objectz00_bglt)(BgL_new2293z00_2940); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4502, BgL_arg4329z00_2941); } } 
{ /* Ast/sexp.scm 269 */
BgL_objectz00_bglt BgL_auxz00_4505;
BgL_auxz00_4505 = 
(BgL_objectz00_bglt)(BgL_new2293z00_2940); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4505, BFALSE); } 
{ /* Ast/sexp.scm 269 */
obj_t BgL_auxz00_4508;
BgL_auxz00_4508 = 
(obj_t)(BgL_new2293z00_2940); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4508); } BUNSPEC; 
BgL_res4702z00_2945 = BgL_new2293z00_2940; } 
BgL_new2291z00_2939 = BgL_res4702z00_2945; } 
{ /* Ast/sexp.scm 269 */
BgL_setqz00_bglt BgL_res4703z00_2955;
((((BgL_setqz00_bglt)CREF(BgL_new2291z00_2939))->BgL_locz00) = ((obj_t)BgL_arg3481z00_1678), BUNSPEC); 
((((BgL_setqz00_bglt)CREF(BgL_new2291z00_2939))->BgL_typez00) = ((BgL_typez00_bglt)BgL_type2288z00_2936), BUNSPEC); 
((((BgL_setqz00_bglt)CREF(BgL_new2291z00_2939))->BgL_varz00) = ((BgL_varz00_bglt)BgL_var2289z00_2937), BUNSPEC); 
((((BgL_setqz00_bglt)CREF(BgL_new2291z00_2939))->BgL_valuez00) = ((BgL_nodez00_bglt)BgL_arg3484z00_1681), BUNSPEC); 
BgL_res4703z00_2955 = BgL_new2291z00_2939; BgL_res4703z00_2955; } 
BgL_res4704z00_2956 = BgL_new2291z00_2939; } } 
BgL_auxz00_4452 = 
(obj_t)(BgL_res4704z00_2956); } } }  else 
{ /* Ast/sexp.scm 274 */
BgL_nodez00_bglt BgL_auxz00_4516;
BgL_auxz00_4516 = 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string5112z00zzast_sexpz00, BgL_expz00_17, BgL_locz00_1669); 
BgL_auxz00_4452 = 
(obj_t)(BgL_auxz00_4516); } } } } } } } } } }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4521;
BgL_tagzd2482zd2_1657:
{ /* Ast/sexp.scm 278 */
obj_t BgL_arg3511z00_1688;
BgL_arg3511z00_1688 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, BgL_locz00_19); 
BgL_auxz00_4521 = 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string5110z00zzast_sexpz00, BgL_expz00_17, BgL_arg3511z00_1688); } 
BgL_auxz00_4452 = 
(obj_t)(BgL_auxz00_4521); } }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4525;
goto BgL_tagzd2482zd2_1657;
BgL_auxz00_4452 = 
(obj_t)(BgL_auxz00_4525); } }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4527;
goto BgL_tagzd2482zd2_1657;
BgL_auxz00_4452 = 
(obj_t)(BgL_auxz00_4527); } }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4529;
goto BgL_tagzd2482zd2_1657;
BgL_auxz00_4452 = 
(obj_t)(BgL_auxz00_4529); } } 
return 
(BgL_nodez00_bglt)(BgL_auxz00_4452);}  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4532;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4535;obj_t BgL_auxz00_4533;
BgL_auxz00_4535 = 
CNST_TABLE_REF(((long)21)); 
BgL_auxz00_4533 = 
CAR(BgL_expz00_17); 
BgL_testz00_4532 = 
(BgL_auxz00_4533==BgL_auxz00_4535); } 
if(BgL_testz00_4532)
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4538;
{ 
obj_t BgL_varz00_1689;obj_t BgL_valz00_1690;
if(
PAIRP(BgL_expz00_17))
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2507zd2_1695;
BgL_cdrzd2507zd2_1695 = 
CDR(BgL_expz00_17); 
if(
PAIRP(BgL_cdrzd2507zd2_1695))
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2511zd2_1697;
BgL_cdrzd2511zd2_1697 = 
CDR(BgL_cdrzd2507zd2_1695); 
if(
PAIRP(BgL_cdrzd2511zd2_1697))
{ /* Ast/sexp.scm 74 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2511zd2_1697), BNIL))
{ /* Ast/sexp.scm 74 */
BgL_varz00_1689 = 
CAR(BgL_cdrzd2507zd2_1695); 
BgL_valz00_1690 = 
CAR(BgL_cdrzd2511zd2_1697); 
{ /* Ast/sexp.scm 287 */
obj_t BgL_locz00_1704;
BgL_locz00_1704 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, BgL_locz00_19); 
{ /* Ast/sexp.scm 287 */
obj_t BgL_cdlocz00_1705;
BgL_cdlocz00_1705 = 
BGl_findzd2locationzf2locz20zztools_locationz00(
CDR(BgL_expz00_17), BgL_locz00_1704); 
{ /* Ast/sexp.scm 288 */
obj_t BgL_cddlocz00_1706;
{ /* Ast/sexp.scm 289 */
obj_t BgL_auxz00_4553;
{ /* Ast/sexp.scm 289 */
obj_t BgL_auxz00_4554;
BgL_auxz00_4554 = 
CDR(BgL_expz00_17); 
BgL_auxz00_4553 = 
CDR(BgL_auxz00_4554); } 
BgL_cddlocz00_1706 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_auxz00_4553, BgL_locz00_1704); } 
{ /* Ast/sexp.scm 289 */
obj_t BgL_valzd2loczd2_1707;
BgL_valzd2loczd2_1707 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_valz00_1690, BgL_cddlocz00_1706); 
{ /* Ast/sexp.scm 290 */
BgL_nodez00_bglt BgL_valz00_1708;
BgL_valz00_1708 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_valz00_1690, BgL_stackz00_18, BgL_valzd2loczd2_1707, 
CNST_TABLE_REF(((long)1))); 
{ /* Ast/sexp.scm 291 */

{ /* Ast/sexp.scm 292 */
BgL_nodez00_bglt BgL_astz00_1709;
BgL_astz00_1709 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_varz00_1689, BgL_stackz00_18, BgL_cdlocz00_1705, 
CNST_TABLE_REF(((long)1))); 
{ /* Ast/sexp.scm 293 */
bool_t BgL_test3538z00_1710;
{ /* Ast/sexp.scm 293 */
bool_t BgL_test3550z00_1716;
BgL_test3550z00_1716 = 
BGl_iszd2azf3z21zz__objectz00(
(obj_t)(BgL_astz00_1709), BGl_varz00zzast_nodez00); 
if(BgL_test3550z00_1716)
{ /* Ast/sexp.scm 293 */
obj_t BgL_auxz00_4566;
{ /* Ast/sexp.scm 293 */
BgL_variablez00_bglt BgL_auxz00_4567;
{ /* Ast/sexp.scm 293 */
BgL_varz00_bglt BgL_obj1620z00_2971;
BgL_obj1620z00_2971 = 
(BgL_varz00_bglt)(BgL_astz00_1709); 
BgL_auxz00_4567 = 
(((BgL_varz00_bglt)CREF(BgL_obj1620z00_2971))->BgL_variablez00); } 
BgL_auxz00_4566 = 
(obj_t)(BgL_auxz00_4567); } 
BgL_test3538z00_1710 = 
BGl_iszd2azf3z21zz__objectz00(BgL_auxz00_4566, BGl_globalz00zzast_varz00); }  else 
{ /* Ast/sexp.scm 293 */
BgL_test3538z00_1710 = ((bool_t)0); } } 
if(BgL_test3538z00_1710)
{ /* Ast/sexp.scm 293 */
{ /* Ast/sexp.scm 295 */
BgL_globalz00_bglt BgL_obj1191z00_2974;obj_t BgL_val1190z00_2975;
{ /* Ast/sexp.scm 295 */
BgL_variablez00_bglt BgL_auxz00_4573;
{ /* Ast/sexp.scm 295 */
BgL_varz00_bglt BgL_obj1620z00_2973;
BgL_obj1620z00_2973 = 
(BgL_varz00_bglt)(BgL_astz00_1709); 
BgL_auxz00_4573 = 
(((BgL_varz00_bglt)CREF(BgL_obj1620z00_2973))->BgL_variablez00); } 
BgL_obj1191z00_2974 = 
(BgL_globalz00_bglt)(BgL_auxz00_4573); } 
BgL_val1190z00_2975 = 
(obj_t)(BgL_valz00_1708); 
((((BgL_globalz00_bglt)CREF(BgL_obj1191z00_2974))->BgL_srcz00) = ((obj_t)BgL_val1190z00_2975), BUNSPEC); } 
{ /* Ast/sexp.scm 297 */
obj_t BgL_arg3544z00_1712;obj_t BgL_arg3545z00_1713;BgL_nodez00_bglt BgL_arg3547z00_1715;
BgL_arg3544z00_1712 = BgL_locz00_1704; 
BgL_arg3545z00_1713 = BGl_za2unspecza2z00zztype_cachez00; 
BgL_arg3547z00_1715 = BgL_valz00_1708; 
{ /* Ast/sexp.scm 296 */
BgL_setqz00_bglt BgL_res4707z00_2997;
{ /* Ast/sexp.scm 296 */
BgL_typez00_bglt BgL_type2288z00_2977;BgL_varz00_bglt BgL_var2289z00_2978;
BgL_type2288z00_2977 = 
(BgL_typez00_bglt)(BgL_arg3545z00_1713); 
{ /* Ast/sexp.scm 299 */
BgL_nodez00_bglt BgL_auxz00_4580;
BgL_auxz00_4580 = BgL_astz00_1709; 
BgL_var2289z00_2978 = 
(BgL_varz00_bglt)(BgL_auxz00_4580); } 
{ /* Ast/sexp.scm 296 */
BgL_setqz00_bglt BgL_new2291z00_2980;
{ /* Ast/sexp.scm 296 */
BgL_setqz00_bglt BgL_res4705z00_2986;
{ /* Ast/sexp.scm 296 */
BgL_setqz00_bglt BgL_new2293z00_2981;
BgL_new2293z00_2981 = 
((BgL_setqz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_setqz00_bgl) ))); 
{ /* Ast/sexp.scm 296 */
long BgL_arg4329z00_2982;
BgL_arg4329z00_2982 = 
BGl_classzd2numzd2zz__objectz00(BGl_setqz00zzast_nodez00); 
{ /* Ast/sexp.scm 296 */
BgL_objectz00_bglt BgL_auxz00_4584;
BgL_auxz00_4584 = 
(BgL_objectz00_bglt)(BgL_new2293z00_2981); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4584, BgL_arg4329z00_2982); } } 
{ /* Ast/sexp.scm 296 */
BgL_objectz00_bglt BgL_auxz00_4587;
BgL_auxz00_4587 = 
(BgL_objectz00_bglt)(BgL_new2293z00_2981); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4587, BFALSE); } 
{ /* Ast/sexp.scm 296 */
obj_t BgL_auxz00_4590;
BgL_auxz00_4590 = 
(obj_t)(BgL_new2293z00_2981); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4590); } BUNSPEC; 
BgL_res4705z00_2986 = BgL_new2293z00_2981; } 
BgL_new2291z00_2980 = BgL_res4705z00_2986; } 
{ /* Ast/sexp.scm 296 */
BgL_setqz00_bglt BgL_res4706z00_2996;
((((BgL_setqz00_bglt)CREF(BgL_new2291z00_2980))->BgL_locz00) = ((obj_t)BgL_arg3544z00_1712), BUNSPEC); 
((((BgL_setqz00_bglt)CREF(BgL_new2291z00_2980))->BgL_typez00) = ((BgL_typez00_bglt)BgL_type2288z00_2977), BUNSPEC); 
((((BgL_setqz00_bglt)CREF(BgL_new2291z00_2980))->BgL_varz00) = ((BgL_varz00_bglt)BgL_var2289z00_2978), BUNSPEC); 
((((BgL_setqz00_bglt)CREF(BgL_new2291z00_2980))->BgL_valuez00) = ((BgL_nodez00_bglt)BgL_arg3547z00_1715), BUNSPEC); 
BgL_res4706z00_2996 = BgL_new2291z00_2980; BgL_res4706z00_2996; } 
BgL_res4707z00_2997 = BgL_new2291z00_2980; } } 
BgL_auxz00_4538 = 
(obj_t)(BgL_res4707z00_2997); } } }  else 
{ /* Ast/sexp.scm 301 */
BgL_nodez00_bglt BgL_auxz00_4598;
BgL_auxz00_4598 = 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string5109z00zzast_sexpz00, BgL_expz00_17, BgL_locz00_1704); 
BgL_auxz00_4538 = 
(obj_t)(BgL_auxz00_4598); } } } } } } } } } }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4603;
BgL_tagzd2500zd2_1692:
{ /* Ast/sexp.scm 305 */
obj_t BgL_arg3570z00_1721;
BgL_arg3570z00_1721 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, BgL_locz00_19); 
BgL_auxz00_4603 = 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string5108z00zzast_sexpz00, BgL_expz00_17, BgL_arg3570z00_1721); } 
BgL_auxz00_4538 = 
(obj_t)(BgL_auxz00_4603); } }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4607;
goto BgL_tagzd2500zd2_1692;
BgL_auxz00_4538 = 
(obj_t)(BgL_auxz00_4607); } }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4609;
goto BgL_tagzd2500zd2_1692;
BgL_auxz00_4538 = 
(obj_t)(BgL_auxz00_4609); } }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4611;
goto BgL_tagzd2500zd2_1692;
BgL_auxz00_4538 = 
(obj_t)(BgL_auxz00_4611); } } 
return 
(BgL_nodez00_bglt)(BgL_auxz00_4538);}  else 
{ /* Ast/sexp.scm 74 */
obj_t BgL_carzd2197zd2_1308;
BgL_carzd2197zd2_1308 = 
CAR(BgL_expz00_17); 
if(
PAIRP(BgL_carzd2197zd2_1308))
{ /* Ast/sexp.scm 74 */
obj_t BgL_carzd2200zd2_1310;obj_t BgL_cdrzd2201zd2_1311;
BgL_carzd2200zd2_1310 = 
CAR(BgL_carzd2197zd2_1308); 
BgL_cdrzd2201zd2_1311 = 
CDR(BgL_carzd2197zd2_1308); 
{ 

{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4619;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4620;
BgL_auxz00_4620 = 
CNST_TABLE_REF(((long)7)); 
BgL_testz00_4619 = 
(BgL_carzd2200zd2_1310==BgL_auxz00_4620); } 
if(BgL_testz00_4619)
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4623;
BgL_kapzd2202zd2_1312:
if(
PAIRP(BgL_cdrzd2201zd2_1311))
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2205zd2_1328;
BgL_cdrzd2205zd2_1328 = 
CDR(BgL_cdrzd2201zd2_1311); 
if(
PAIRP(BgL_cdrzd2205zd2_1328))
{ /* Ast/sexp.scm 74 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2205zd2_1328), BNIL))
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4632;
BgL_bodyz00_1278 = 
CAR(BgL_cdrzd2205zd2_1328); 
BgL_argsz00_1279 = 
CDR(BgL_expz00_17); 
{ /* Ast/sexp.scm 310 */
obj_t BgL_letzd2partzd2_1722;
BgL_letzd2partzd2_1722 = 
CAR(BgL_expz00_17); 
{ /* Ast/sexp.scm 310 */
obj_t BgL_nexpz00_1723;
{ /* Ast/sexp.scm 311 */
obj_t BgL_arg3575z00_1724;obj_t BgL_arg3576z00_1725;
BgL_arg3575z00_1724 = 
CAR(BgL_letzd2partzd2_1722); 
{ /* Ast/sexp.scm 311 */
obj_t BgL_arg3580z00_1726;obj_t BgL_arg3581z00_1727;
{ /* Ast/sexp.scm 311 */
obj_t BgL_auxz00_4635;
BgL_auxz00_4635 = 
CDR(BgL_letzd2partzd2_1722); 
BgL_arg3580z00_1726 = 
CAR(BgL_auxz00_4635); } 
{ /* Ast/sexp.scm 311 */
obj_t BgL_arg3586z00_1728;
{ /* Ast/sexp.scm 311 */
obj_t BgL_auxz00_4638;
BgL_auxz00_4638 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_argsz00_1279, BNIL); 
BgL_arg3586z00_1728 = 
MAKE_PAIR(BgL_bodyz00_1278, BgL_auxz00_4638); } 
BgL_arg3581z00_1727 = 
MAKE_PAIR(BgL_arg3586z00_1728, BNIL); } 
BgL_arg3576z00_1725 = 
MAKE_PAIR(BgL_arg3580z00_1726, BgL_arg3581z00_1727); } 
BgL_nexpz00_1723 = 
MAKE_PAIR(BgL_arg3575z00_1724, BgL_arg3576z00_1725); } 
{ /* Ast/sexp.scm 311 */

BgL_auxz00_4632 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_nexpz00_1723, BgL_stackz00_18, BgL_locz00_19, BgL_sitez00_20); } } } 
BgL_auxz00_4623 = 
(obj_t)(BgL_auxz00_4632); }  else 
{ /* Ast/sexp.scm 74 */
obj_t BgL_carzd2226zd2_1333;
BgL_carzd2226zd2_1333 = 
CAR(BgL_expz00_17); 
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2231zd2_1334;
BgL_cdrzd2231zd2_1334 = 
CDR(BgL_carzd2226zd2_1333); 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4650;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4653;obj_t BgL_auxz00_4651;
BgL_auxz00_4653 = 
CNST_TABLE_REF(((long)4)); 
BgL_auxz00_4651 = 
CAR(BgL_carzd2226zd2_1333); 
BgL_testz00_4650 = 
(BgL_auxz00_4651==BgL_auxz00_4653); } 
if(BgL_testz00_4650)
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4656;
BgL_varsz00_1283 = 
CAR(BgL_cdrzd2231zd2_1334); 
BgL_bodyz00_1284 = 
CDR(BgL_cdrzd2231zd2_1334); 
BgL_argsz00_1285 = 
CDR(BgL_expz00_17); 
BgL_tagzd2132zd2_1286:
{ /* Ast/sexp.scm 321 */
obj_t BgL_locz00_1731;
BgL_locz00_1731 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, BgL_locz00_19); 
{ /* Ast/sexp.scm 322 */
obj_t BgL_arg3598z00_1732;
{ /* Ast/sexp.scm 322 */
obj_t BgL_arg3601z00_1733;obj_t BgL_arg3602z00_1734;
BgL_arg3601z00_1733 = 
CNST_TABLE_REF(((long)7)); 
{ /* Ast/sexp.scm 322 */
obj_t BgL_arg3605z00_1735;obj_t BgL_arg3606z00_1736;
BgL_arg3605z00_1735 = 
BGl_loopz00zzast_sexpz00(BgL_expz00_17, BgL_locz00_1731, BgL_varsz00_1283, BgL_argsz00_1285); 
{ /* Ast/sexp.scm 364 */
obj_t BgL_arg3715z00_1785;
{ /* Ast/sexp.scm 364 */
obj_t BgL_arg3719z00_1787;obj_t BgL_arg3720z00_1788;
{ /* Ast/sexp.scm 364 */
obj_t BgL_arg3724z00_1790;
BgL_arg3724z00_1790 = 
BGl_currentzd2functionzd2zztools_errorz00(); 
BgL_arg3719z00_1787 = 
BGl_shapez00zztools_shapez00(BgL_arg3724z00_1790); } 
BgL_arg3720z00_1788 = 
BGl_normaliza7ezd2prognz75zztools_prognz00(BgL_bodyz00_1284); 
{ /* Ast/sexp.scm 368 */
obj_t BgL_zc3anonymousza33728ze3z83_3926;
{ 
int BgL_auxz00_4665;int BgL_auxz00_4663;
BgL_auxz00_4665 = 
(int)(((long)1)); 
BgL_auxz00_4663 = 
(int)(((long)3)); 
BgL_zc3anonymousza33728ze3z83_3926 = 
make_fx_procedure(BGl_zc3anonymousza33728ze3z83zzast_sexpz00, BgL_auxz00_4663, BgL_auxz00_4665); } 
{ /* Ast/sexp.scm 368 */
int BgL_auxz00_4668;
BgL_auxz00_4668 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza33728ze3z83_3926, BgL_auxz00_4668, BgL_locz00_1731); } 
BgL_arg3715z00_1785 = 
BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00(BgL_arg3719z00_1787, BgL_varsz00_1283, BgL_arg3720z00_1788, BgL_zc3anonymousza33728ze3z83_3926); } } 
BgL_arg3606z00_1736 = 
MAKE_PAIR(BgL_arg3715z00_1785, BNIL); } 
BgL_arg3602z00_1734 = 
MAKE_PAIR(BgL_arg3605z00_1735, BgL_arg3606z00_1736); } 
BgL_arg3598z00_1732 = 
MAKE_PAIR(BgL_arg3601z00_1733, BgL_arg3602z00_1734); } 
BgL_auxz00_4656 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg3598z00_1732, BgL_stackz00_18, BgL_locz00_1731, BgL_sitez00_20); } } 
BgL_auxz00_4623 = 
(obj_t)(BgL_auxz00_4656); }  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_test2785z00_1339;
BgL_test2785z00_1339 = 
BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17); 
if(BgL_test2785z00_1339)
{ /* Ast/sexp.scm 74 */
BgL_tagzd2141zd2_1295:
BgL_auxz00_4623 = 
BGl_privatezd2ze3nodez31zzast_privatez00(BgL_expz00_17, BgL_stackz00_18, BgL_locz00_19, BgL_sitez00_20)
; }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4683;
BgL_tagzd2142zd2_1296:
{ /* Ast/sexp.scm 479 */
obj_t BgL_callerz00_1913;obj_t BgL_locz00_1914;
BgL_callerz00_1913 = 
CAR(BgL_expz00_17); 
BgL_locz00_1914 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, BgL_locz00_19); 
if(
SYMBOLP(BgL_callerz00_1913))
{ /* Ast/sexp.scm 483 */
obj_t BgL_pidz00_1916;
BgL_pidz00_1916 = 
BGl_parsezd2idzd2zzast_identz00(BgL_callerz00_1913, BgL_locz00_1914); 
{ /* Ast/sexp.scm 483 */
obj_t BgL_idz00_1917;
BgL_idz00_1917 = 
CAR(BgL_pidz00_1916); 
{ /* Ast/sexp.scm 484 */
obj_t BgL_typez00_1918;
BgL_typez00_1918 = 
CDR(BgL_pidz00_1916); 
{ /* Ast/sexp.scm 485 */

{ /* Ast/sexp.scm 486 */
bool_t BgL_testz00_4691;
{ /* Ast/sexp.scm 486 */
obj_t BgL_auxz00_4692;
BgL_auxz00_4692 = 
CNST_TABLE_REF(((long)2)); 
BgL_testz00_4691 = 
(BgL_idz00_1917==BgL_auxz00_4692); } 
if(BgL_testz00_4691)
{ /* Ast/sexp.scm 486 */
BgL_auxz00_4683 = 
BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t)0), 
(BgL_typez00_bglt)(BgL_typez00_1918), BgL_expz00_17, BgL_stackz00_18, BgL_locz00_1914, BgL_sitez00_20)
; }  else 
{ /* Ast/sexp.scm 486 */
bool_t BgL_testz00_4697;
{ /* Ast/sexp.scm 486 */
obj_t BgL_auxz00_4698;
BgL_auxz00_4698 = 
CNST_TABLE_REF(((long)3)); 
BgL_testz00_4697 = 
(BgL_idz00_1917==BgL_auxz00_4698); } 
if(BgL_testz00_4697)
{ /* Ast/sexp.scm 486 */
BgL_auxz00_4683 = 
BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t)1), 
(BgL_typez00_bglt)(BgL_typez00_1918), BgL_expz00_17, BgL_stackz00_18, BgL_locz00_1914, BgL_sitez00_20)
; }  else 
{ /* Ast/sexp.scm 486 */
bool_t BgL_testz00_4703;
{ /* Ast/sexp.scm 486 */
obj_t BgL_auxz00_4704;
BgL_auxz00_4704 = 
CNST_TABLE_REF(((long)4)); 
BgL_testz00_4703 = 
(BgL_idz00_1917==BgL_auxz00_4704); } 
if(BgL_testz00_4703)
{ 
obj_t BgL_argsz00_1923;obj_t BgL_bodyz00_1924;
if(
PAIRP(BgL_expz00_17))
{ /* Ast/sexp.scm 492 */
obj_t BgL_cdrzd2581zd2_1929;
BgL_cdrzd2581zd2_1929 = 
CDR(BgL_expz00_17); 
if(
PAIRP(BgL_cdrzd2581zd2_1929))
{ /* Ast/sexp.scm 492 */
BgL_argsz00_1923 = 
CAR(BgL_cdrzd2581zd2_1929); 
BgL_bodyz00_1924 = 
CDR(BgL_cdrzd2581zd2_1929); 
{ /* Ast/sexp.scm 494 */
obj_t BgL_locz00_1933;
BgL_locz00_1933 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, BgL_locz00_1914); 
{ /* Ast/sexp.scm 494 */
obj_t BgL_funz00_1934;
{ /* Ast/sexp.scm 495 */
obj_t BgL_arg3994z00_1948;
BgL_arg3994z00_1948 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)4)), BEOA); 
BgL_funz00_1934 = 
BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(BgL_arg3994z00_1948); } 
{ /* Ast/sexp.scm 495 */
obj_t BgL_tfunz00_1935;
{ /* Ast/sexp.scm 496 */
obj_t BgL_auxz00_4717;
{ /* Ast/sexp.scm 496 */
BgL_typez00_bglt BgL_obj1003z00_3136;
BgL_obj1003z00_3136 = 
(BgL_typez00_bglt)(BgL_typez00_1918); 
BgL_auxz00_4717 = 
(((BgL_typez00_bglt)CREF(BgL_obj1003z00_3136))->BgL_idz00); } 
BgL_tfunz00_1935 = 
BGl_makezd2typedzd2identz00zzast_identz00(BgL_funz00_1934, BgL_auxz00_4717); } 
{ /* Ast/sexp.scm 496 */

{ /* Ast/sexp.scm 498 */
obj_t BgL_arg3963z00_1936;
{ /* Ast/sexp.scm 498 */
obj_t BgL_arg3966z00_1937;obj_t BgL_arg3967z00_1938;
BgL_arg3966z00_1937 = 
CNST_TABLE_REF(((long)5)); 
{ /* Ast/sexp.scm 498 */
obj_t BgL_arg3970z00_1939;obj_t BgL_arg3971z00_1940;
{ /* Ast/sexp.scm 498 */
obj_t BgL_arg3974z00_1941;
{ /* Ast/sexp.scm 498 */
obj_t BgL_arg3978z00_1943;
{ /* Ast/sexp.scm 498 */
obj_t BgL_arg3981z00_1944;
{ /* Ast/sexp.scm 498 */
obj_t BgL_arg3984z00_1945;
BgL_arg3984z00_1945 = 
BGl_normaliza7ezd2prognz75zztools_prognz00(BgL_bodyz00_1924); 
BgL_arg3981z00_1944 = 
MAKE_PAIR(BgL_arg3984z00_1945, BNIL); } 
BgL_arg3978z00_1943 = 
MAKE_PAIR(BgL_argsz00_1923, BgL_arg3981z00_1944); } 
BgL_arg3974z00_1941 = 
MAKE_PAIR(BgL_tfunz00_1935, BgL_arg3978z00_1943); } 
BgL_arg3970z00_1939 = 
MAKE_PAIR(BgL_arg3974z00_1941, BNIL); } 
BgL_arg3971z00_1940 = 
MAKE_PAIR(BgL_funz00_1934, BNIL); 
BgL_arg3967z00_1938 = 
MAKE_PAIR(BgL_arg3970z00_1939, BgL_arg3971z00_1940); } 
BgL_arg3963z00_1936 = 
MAKE_PAIR(BgL_arg3966z00_1937, BgL_arg3967z00_1938); } 
BgL_auxz00_4683 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg3963z00_1936, BgL_stackz00_18, BgL_locz00_1933, BgL_sitez00_20); } } } } } }  else 
{ /* Ast/sexp.scm 492 */
BgL_tagzd2574zd2_1926:
BgL_auxz00_4683 = 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string5105z00zzast_sexpz00, BgL_expz00_17, BgL_locz00_1914)
; } }  else 
{ /* Ast/sexp.scm 492 */
goto BgL_tagzd2574zd2_1926;} }  else 
{ /* Ast/sexp.scm 486 */
BgL_auxz00_4683 = 
BGl_applicationzd2ze3nodez31zzast_appz00(BgL_expz00_17, BgL_stackz00_18, BgL_locz00_1914, BgL_sitez00_20)
; } } } } } } } }  else 
{ /* Ast/sexp.scm 481 */
BgL_auxz00_4683 = 
BGl_applicationzd2ze3nodez31zzast_appz00(BgL_expz00_17, BgL_stackz00_18, BgL_locz00_1914, BgL_sitez00_20)
; } } 
BgL_auxz00_4623 = 
(obj_t)(BgL_auxz00_4683); } } } } } }  else 
{ /* Ast/sexp.scm 74 */
obj_t BgL_carzd2254zd2_1344;
BgL_carzd2254zd2_1344 = 
CAR(BgL_expz00_17); 
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2259zd2_1345;
BgL_cdrzd2259zd2_1345 = 
CDR(BgL_carzd2254zd2_1344); 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4739;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4742;obj_t BgL_auxz00_4740;
BgL_auxz00_4742 = 
CNST_TABLE_REF(((long)4)); 
BgL_auxz00_4740 = 
CAR(BgL_carzd2254zd2_1344); 
BgL_testz00_4739 = 
(BgL_auxz00_4740==BgL_auxz00_4742); } 
if(BgL_testz00_4739)
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4745;
{ 
obj_t BgL_argsz00_4750;obj_t BgL_bodyz00_4748;obj_t BgL_varsz00_4746;
BgL_varsz00_4746 = 
CAR(BgL_cdrzd2259zd2_1345); 
BgL_bodyz00_4748 = 
CDR(BgL_cdrzd2259zd2_1345); 
BgL_argsz00_4750 = 
CDR(BgL_expz00_17); 
BgL_argsz00_1285 = BgL_argsz00_4750; 
BgL_bodyz00_1284 = BgL_bodyz00_4748; 
BgL_varsz00_1283 = BgL_varsz00_4746; 
goto BgL_tagzd2132zd2_1286;} 
BgL_auxz00_4623 = 
(obj_t)(BgL_auxz00_4745); }  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_test2810z00_1350;
BgL_test2810z00_1350 = 
BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17); 
if(BgL_test2810z00_1350)
{ /* Ast/sexp.scm 74 */
goto BgL_tagzd2141zd2_1295;}  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4755;
goto BgL_tagzd2142zd2_1296;
BgL_auxz00_4623 = 
(obj_t)(BgL_auxz00_4755); } } } } } }  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_test2823z00_1353;
BgL_test2823z00_1353 = 
BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17); 
if(BgL_test2823z00_1353)
{ /* Ast/sexp.scm 74 */
goto BgL_tagzd2141zd2_1295;}  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4759;
goto BgL_tagzd2142zd2_1296;
BgL_auxz00_4623 = 
(obj_t)(BgL_auxz00_4759); } } 
return 
(BgL_nodez00_bglt)(BgL_auxz00_4623);}  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4762;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4763;
BgL_auxz00_4763 = 
CNST_TABLE_REF(((long)22)); 
BgL_testz00_4762 = 
(BgL_carzd2200zd2_1310==BgL_auxz00_4763); } 
if(BgL_testz00_4762)
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4766;
goto BgL_kapzd2202zd2_1312;
return 
(BgL_nodez00_bglt)(BgL_auxz00_4766);}  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4768;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4769;
BgL_auxz00_4769 = 
CNST_TABLE_REF(((long)5)); 
BgL_testz00_4768 = 
(BgL_carzd2200zd2_1310==BgL_auxz00_4769); } 
if(BgL_testz00_4768)
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4772;
goto BgL_kapzd2202zd2_1312;
return 
(BgL_nodez00_bglt)(BgL_auxz00_4772);}  else 
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2303zd2_1317;
BgL_cdrzd2303zd2_1317 = 
CDR(BgL_carzd2197zd2_1308); 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4775;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4778;obj_t BgL_auxz00_4776;
BgL_auxz00_4778 = 
CNST_TABLE_REF(((long)4)); 
BgL_auxz00_4776 = 
CAR(BgL_carzd2197zd2_1308); 
BgL_testz00_4775 = 
(BgL_auxz00_4776==BgL_auxz00_4778); } 
if(BgL_testz00_4775)
{ /* Ast/sexp.scm 74 */
if(
PAIRP(BgL_cdrzd2303zd2_1317))
{ 
obj_t BgL_argsz00_4787;obj_t BgL_bodyz00_4785;obj_t BgL_varsz00_4783;
BgL_varsz00_4783 = 
CAR(BgL_cdrzd2303zd2_1317); 
BgL_bodyz00_4785 = 
CDR(BgL_cdrzd2303zd2_1317); 
BgL_argsz00_4787 = 
CDR(BgL_expz00_17); 
BgL_argsz00_1285 = BgL_argsz00_4787; 
BgL_bodyz00_1284 = BgL_bodyz00_4785; 
BgL_varsz00_1283 = BgL_varsz00_4783; 
goto BgL_tagzd2132zd2_1286;}  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_test2748z00_1323;
BgL_test2748z00_1323 = 
BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17); 
if(BgL_test2748z00_1323)
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4791;
goto BgL_tagzd2141zd2_1295;
return 
(BgL_nodez00_bglt)(BgL_auxz00_4791);}  else 
{ /* Ast/sexp.scm 74 */
goto BgL_tagzd2142zd2_1296;} } }  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_test2753z00_1324;
BgL_test2753z00_1324 = 
BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17); 
if(BgL_test2753z00_1324)
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4795;
goto BgL_tagzd2141zd2_1295;
return 
(BgL_nodez00_bglt)(BgL_auxz00_4795);}  else 
{ /* Ast/sexp.scm 74 */
goto BgL_tagzd2142zd2_1296;} } } } } } } } }  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4797;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4798;
BgL_auxz00_4798 = 
CNST_TABLE_REF(((long)7)); 
BgL_testz00_4797 = 
(BgL_carzd2197zd2_1308==BgL_auxz00_4798); } 
if(BgL_testz00_4797)
{ /* Ast/sexp.scm 74 */
BgL_tagzd2130zd2_1281:
return 
BGl_letzd2ze3nodez31zzast_letz00(BgL_expz00_17, BgL_stackz00_18, BgL_locz00_19, 
CNST_TABLE_REF(((long)1)));}  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4803;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4804;
BgL_auxz00_4804 = 
CNST_TABLE_REF(((long)22)); 
BgL_testz00_4803 = 
(BgL_carzd2197zd2_1308==BgL_auxz00_4804); } 
if(BgL_testz00_4803)
{ /* Ast/sexp.scm 74 */
goto BgL_tagzd2130zd2_1281;}  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4807;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4810;obj_t BgL_auxz00_4808;
BgL_auxz00_4810 = 
CNST_TABLE_REF(((long)5)); 
BgL_auxz00_4808 = 
CAR(BgL_expz00_17); 
BgL_testz00_4807 = 
(BgL_auxz00_4808==BgL_auxz00_4810); } 
if(BgL_testz00_4807)
{ /* Ast/sexp.scm 74 */
BgL_letzd2funzd2_bglt BgL_auxz00_4813;
BgL_auxz00_4813 = 
BGl_labelszd2ze3nodez31zzast_labelsz00(BgL_expz00_17, BgL_stackz00_18, BgL_locz00_19, 
CNST_TABLE_REF(((long)1))); 
return 
(BgL_nodez00_bglt)(BgL_auxz00_4813);}  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4817;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4820;obj_t BgL_auxz00_4818;
BgL_auxz00_4820 = 
CNST_TABLE_REF(((long)4)); 
BgL_auxz00_4818 = 
CAR(BgL_expz00_17); 
BgL_testz00_4817 = 
(BgL_auxz00_4818==BgL_auxz00_4820); } 
if(BgL_testz00_4817)
{ /* Ast/sexp.scm 74 */
{ 
obj_t BgL_argsz00_1797;obj_t BgL_bodyz00_1798;
if(
PAIRP(BgL_expz00_17))
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2525zd2_1803;
BgL_cdrzd2525zd2_1803 = 
CDR(BgL_expz00_17); 
if(
PAIRP(BgL_cdrzd2525zd2_1803))
{ /* Ast/sexp.scm 74 */
BgL_argsz00_1797 = 
CAR(BgL_cdrzd2525zd2_1803); 
BgL_bodyz00_1798 = 
CDR(BgL_cdrzd2525zd2_1803); 
{ /* Ast/sexp.scm 376 */
obj_t BgL_locz00_1807;obj_t BgL_funz00_1808;
BgL_locz00_1807 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, BgL_locz00_19); 
BgL_funz00_1808 = 
BGl_makezd2anonymouszd2namez00zzast_sexpz00(BgL_locz00_19); 
{ /* Ast/sexp.scm 378 */
obj_t BgL_arg3746z00_1809;
{ /* Ast/sexp.scm 378 */
obj_t BgL_arg3749z00_1810;obj_t BgL_arg3750z00_1811;
BgL_arg3749z00_1810 = 
CNST_TABLE_REF(((long)5)); 
{ /* Ast/sexp.scm 378 */
obj_t BgL_arg3753z00_1812;obj_t BgL_arg3754z00_1813;
{ /* Ast/sexp.scm 378 */
obj_t BgL_arg3757z00_1814;
{ /* Ast/sexp.scm 378 */
obj_t BgL_arg3761z00_1816;
{ /* Ast/sexp.scm 378 */
obj_t BgL_arg3764z00_1817;
{ /* Ast/sexp.scm 378 */
obj_t BgL_arg3767z00_1818;
BgL_arg3767z00_1818 = 
BGl_normaliza7ezd2prognz75zztools_prognz00(BgL_bodyz00_1798); 
BgL_arg3764z00_1817 = 
MAKE_PAIR(BgL_arg3767z00_1818, BNIL); } 
BgL_arg3761z00_1816 = 
MAKE_PAIR(BgL_argsz00_1797, BgL_arg3764z00_1817); } 
BgL_arg3757z00_1814 = 
MAKE_PAIR(BgL_funz00_1808, BgL_arg3761z00_1816); } 
BgL_arg3753z00_1812 = 
MAKE_PAIR(BgL_arg3757z00_1814, BNIL); } 
BgL_arg3754z00_1813 = 
MAKE_PAIR(BgL_funz00_1808, BNIL); 
BgL_arg3750z00_1811 = 
MAKE_PAIR(BgL_arg3753z00_1812, BgL_arg3754z00_1813); } 
BgL_arg3746z00_1809 = 
MAKE_PAIR(BgL_arg3749z00_1810, BgL_arg3750z00_1811); } 
{ 
obj_t BgL_locz00_4840;obj_t BgL_expz00_4839;
BgL_expz00_4839 = BgL_arg3746z00_1809; 
BgL_locz00_4840 = BgL_locz00_1807; 
BgL_locz00_19 = BgL_locz00_4840; 
BgL_expz00_17 = BgL_expz00_4839; 
goto BGl_sexpzd2ze3nodez31zzast_sexpz00;} } } }  else 
{ /* Ast/sexp.scm 74 */
BgL_tagzd2518zd2_1800:
{ /* Ast/sexp.scm 383 */
obj_t BgL_arg3776z00_1821;
BgL_arg3776z00_1821 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, BgL_locz00_19); 
return 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string5105z00zzast_sexpz00, BgL_expz00_17, BgL_arg3776z00_1821);} } }  else 
{ /* Ast/sexp.scm 74 */
goto BgL_tagzd2518zd2_1800;} } }  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4845;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4848;obj_t BgL_auxz00_4846;
BgL_auxz00_4848 = 
CNST_TABLE_REF(((long)2)); 
BgL_auxz00_4846 = 
CAR(BgL_expz00_17); 
BgL_testz00_4845 = 
(BgL_auxz00_4846==BgL_auxz00_4848); } 
if(BgL_testz00_4845)
{ /* Ast/sexp.scm 74 */
return 
BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t)0), 
(BgL_typez00_bglt)(BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_17, BgL_stackz00_18, BgL_locz00_19, BgL_sitez00_20);}  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4853;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4856;obj_t BgL_auxz00_4854;
BgL_auxz00_4856 = 
CNST_TABLE_REF(((long)3)); 
BgL_auxz00_4854 = 
CAR(BgL_expz00_17); 
BgL_testz00_4853 = 
(BgL_auxz00_4854==BgL_auxz00_4856); } 
if(BgL_testz00_4853)
{ /* Ast/sexp.scm 74 */
return 
BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t)1), 
(BgL_typez00_bglt)(BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_17, BgL_stackz00_18, BgL_locz00_19, BgL_sitez00_20);}  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4861;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4864;obj_t BgL_auxz00_4862;
BgL_auxz00_4864 = 
CNST_TABLE_REF(((long)23)); 
BgL_auxz00_4862 = 
CAR(BgL_expz00_17); 
BgL_testz00_4861 = 
(BgL_auxz00_4862==BgL_auxz00_4864); } 
if(BgL_testz00_4861)
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4867;
{ 
obj_t BgL_procz00_1822;obj_t BgL_msgz00_1823;obj_t BgL_objz00_1824;
if(
PAIRP(BgL_expz00_17))
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2542zd2_1829;
BgL_cdrzd2542zd2_1829 = 
CDR(BgL_expz00_17); 
if(
PAIRP(BgL_cdrzd2542zd2_1829))
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2547zd2_1831;
BgL_cdrzd2547zd2_1831 = 
CDR(BgL_cdrzd2542zd2_1829); 
if(
PAIRP(BgL_cdrzd2547zd2_1831))
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2552zd2_1833;
BgL_cdrzd2552zd2_1833 = 
CDR(BgL_cdrzd2547zd2_1831); 
if(
PAIRP(BgL_cdrzd2552zd2_1833))
{ /* Ast/sexp.scm 74 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2552zd2_1833), BNIL))
{ /* Ast/sexp.scm 74 */
BgL_failz00_bglt BgL_auxz00_4882;
BgL_procz00_1822 = 
CAR(BgL_cdrzd2542zd2_1829); 
BgL_msgz00_1823 = 
CAR(BgL_cdrzd2547zd2_1831); 
BgL_objz00_1824 = 
CAR(BgL_cdrzd2552zd2_1833); 
{ /* Ast/sexp.scm 396 */
obj_t BgL_locz00_1841;
BgL_locz00_1841 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, BgL_locz00_19); 
{ /* Ast/sexp.scm 396 */
obj_t BgL_cdlocz00_1842;
BgL_cdlocz00_1842 = 
BGl_findzd2locationzf2locz20zztools_locationz00(
CDR(BgL_expz00_17), BgL_locz00_1841); 
{ /* Ast/sexp.scm 397 */
obj_t BgL_cddlocz00_1843;
{ /* Ast/sexp.scm 398 */
obj_t BgL_auxz00_4886;
{ /* Ast/sexp.scm 398 */
obj_t BgL_auxz00_4887;
BgL_auxz00_4887 = 
CDR(BgL_expz00_17); 
BgL_auxz00_4886 = 
CDR(BgL_auxz00_4887); } 
BgL_cddlocz00_1843 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_auxz00_4886, BgL_locz00_1841); } 
{ /* Ast/sexp.scm 398 */
obj_t BgL_cdddlocz00_1844;
{ /* Ast/sexp.scm 399 */
obj_t BgL_auxz00_4891;
{ /* Ast/sexp.scm 399 */
obj_t BgL_auxz00_4892;
{ /* Ast/sexp.scm 399 */
obj_t BgL_auxz00_4893;
BgL_auxz00_4893 = 
CDR(BgL_expz00_17); 
BgL_auxz00_4892 = 
CDR(BgL_auxz00_4893); } 
BgL_auxz00_4891 = 
CDR(BgL_auxz00_4892); } 
BgL_cdddlocz00_1844 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_auxz00_4891, BgL_locz00_1841); } 
{ /* Ast/sexp.scm 399 */
obj_t BgL_loczd2proczd2_1845;
BgL_loczd2proczd2_1845 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_procz00_1822, BgL_cdlocz00_1842); 
{ /* Ast/sexp.scm 400 */
obj_t BgL_loczd2msgzd2_1846;
BgL_loczd2msgzd2_1846 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_msgz00_1823, BgL_cddlocz00_1843); 
{ /* Ast/sexp.scm 401 */
obj_t BgL_loczd2objzd2_1847;
BgL_loczd2objzd2_1847 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_objz00_1824, BgL_cdddlocz00_1844); 
{ /* Ast/sexp.scm 402 */
BgL_nodez00_bglt BgL_procz00_1848;
BgL_procz00_1848 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_procz00_1822, BgL_stackz00_18, BgL_loczd2proczd2_1845, 
CNST_TABLE_REF(((long)1))); 
{ /* Ast/sexp.scm 403 */
BgL_nodez00_bglt BgL_msgz00_1849;
BgL_msgz00_1849 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_msgz00_1823, BgL_stackz00_18, BgL_loczd2msgzd2_1846, 
CNST_TABLE_REF(((long)1))); 
{ /* Ast/sexp.scm 404 */
BgL_nodez00_bglt BgL_objz00_1850;
BgL_objz00_1850 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_objz00_1824, BgL_stackz00_18, BgL_loczd2objzd2_1847, 
CNST_TABLE_REF(((long)1))); 
{ /* Ast/sexp.scm 405 */

{ /* Ast/sexp.scm 406 */
obj_t BgL_arg3812z00_1851;obj_t BgL_arg3813z00_1852;BgL_nodez00_bglt BgL_arg3814z00_1853;BgL_nodez00_bglt BgL_arg3815z00_1854;BgL_nodez00_bglt BgL_arg3817z00_1855;
BgL_arg3812z00_1851 = BgL_locz00_1841; 
BgL_arg3813z00_1852 = BGl_za2magicza2z00zztype_cachez00; 
BgL_arg3814z00_1853 = BgL_procz00_1848; 
BgL_arg3815z00_1854 = BgL_msgz00_1849; 
BgL_arg3817z00_1855 = BgL_objz00_1850; 
{ /* Ast/sexp.scm 406 */
BgL_failz00_bglt BgL_res4713z00_3077;
{ /* Ast/sexp.scm 406 */
BgL_typez00_bglt BgL_type2367z00_3054;
BgL_type2367z00_3054 = 
(BgL_typez00_bglt)(BgL_arg3813z00_1852); 
{ /* Ast/sexp.scm 406 */
BgL_failz00_bglt BgL_new2371z00_3058;
{ /* Ast/sexp.scm 406 */
BgL_failz00_bglt BgL_res4711z00_3064;
{ /* Ast/sexp.scm 406 */
BgL_failz00_bglt BgL_new2373z00_3059;
BgL_new2373z00_3059 = 
((BgL_failz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_failz00_bgl) ))); 
{ /* Ast/sexp.scm 406 */
long BgL_arg4311z00_3060;
BgL_arg4311z00_3060 = 
BGl_classzd2numzd2zz__objectz00(BGl_failz00zzast_nodez00); 
{ /* Ast/sexp.scm 406 */
BgL_objectz00_bglt BgL_auxz00_4910;
BgL_auxz00_4910 = 
(BgL_objectz00_bglt)(BgL_new2373z00_3059); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4910, BgL_arg4311z00_3060); } } 
{ /* Ast/sexp.scm 406 */
BgL_objectz00_bglt BgL_auxz00_4913;
BgL_auxz00_4913 = 
(BgL_objectz00_bglt)(BgL_new2373z00_3059); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4913, BFALSE); } 
{ /* Ast/sexp.scm 406 */
obj_t BgL_auxz00_4916;
BgL_auxz00_4916 = 
(obj_t)(BgL_new2373z00_3059); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4916); } BUNSPEC; 
BgL_res4711z00_3064 = BgL_new2373z00_3059; } 
BgL_new2371z00_3058 = BgL_res4711z00_3064; } 
{ /* Ast/sexp.scm 406 */
BgL_failz00_bglt BgL_res4712z00_3076;
((((BgL_failz00_bglt)CREF(BgL_new2371z00_3058))->BgL_locz00) = ((obj_t)BgL_arg3812z00_1851), BUNSPEC); 
((((BgL_failz00_bglt)CREF(BgL_new2371z00_3058))->BgL_typez00) = ((BgL_typez00_bglt)BgL_type2367z00_3054), BUNSPEC); 
((((BgL_failz00_bglt)CREF(BgL_new2371z00_3058))->BgL_procz00) = ((BgL_nodez00_bglt)BgL_arg3814z00_1853), BUNSPEC); 
((((BgL_failz00_bglt)CREF(BgL_new2371z00_3058))->BgL_msgz00) = ((BgL_nodez00_bglt)BgL_arg3815z00_1854), BUNSPEC); 
((((BgL_failz00_bglt)CREF(BgL_new2371z00_3058))->BgL_objz00) = ((BgL_nodez00_bglt)BgL_arg3817z00_1855), BUNSPEC); 
BgL_res4712z00_3076 = BgL_new2371z00_3058; BgL_res4712z00_3076; } 
BgL_res4713z00_3077 = BgL_new2371z00_3058; } } 
BgL_auxz00_4882 = BgL_res4713z00_3077; } } } } } } } } } } } } } 
BgL_auxz00_4867 = 
(obj_t)(BgL_auxz00_4882); }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4928;
BgL_tagzd2533zd2_1826:
{ /* Ast/sexp.scm 412 */
obj_t BgL_arg3841z00_1860;
BgL_arg3841z00_1860 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, BgL_locz00_19); 
BgL_auxz00_4928 = 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string5107z00zzast_sexpz00, BgL_expz00_17, BgL_arg3841z00_1860); } 
BgL_auxz00_4867 = 
(obj_t)(BgL_auxz00_4928); } }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4932;
goto BgL_tagzd2533zd2_1826;
BgL_auxz00_4867 = 
(obj_t)(BgL_auxz00_4932); } }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4934;
goto BgL_tagzd2533zd2_1826;
BgL_auxz00_4867 = 
(obj_t)(BgL_auxz00_4934); } }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4936;
goto BgL_tagzd2533zd2_1826;
BgL_auxz00_4867 = 
(obj_t)(BgL_auxz00_4936); } }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_4938;
goto BgL_tagzd2533zd2_1826;
BgL_auxz00_4867 = 
(obj_t)(BgL_auxz00_4938); } } 
return 
(BgL_nodez00_bglt)(BgL_auxz00_4867);}  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_4941;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4944;obj_t BgL_auxz00_4942;
BgL_auxz00_4944 = 
CNST_TABLE_REF(((long)24)); 
BgL_auxz00_4942 = 
CAR(BgL_expz00_17); 
BgL_testz00_4941 = 
(BgL_auxz00_4942==BgL_auxz00_4944); } 
if(BgL_testz00_4941)
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_4947;
{ 
obj_t BgL_testz00_1861;obj_t BgL_clausesz00_1862;
if(
PAIRP(BgL_expz00_17))
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2566zd2_1867;
BgL_cdrzd2566zd2_1867 = 
CDR(BgL_expz00_17); 
if(
PAIRP(BgL_cdrzd2566zd2_1867))
{ /* Ast/sexp.scm 74 */
BgL_testz00_1861 = 
CAR(BgL_cdrzd2566zd2_1867); 
BgL_clausesz00_1862 = 
CDR(BgL_cdrzd2566zd2_1867); 
{ /* Ast/sexp.scm 425 */
obj_t BgL_locz00_1871;
BgL_locz00_1871 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, BgL_locz00_19); 
{ /* Ast/sexp.scm 425 */
obj_t BgL_cdlocz00_1872;
BgL_cdlocz00_1872 = 
BGl_findzd2locationzf2locz20zztools_locationz00(
CDR(BgL_expz00_17), BgL_locz00_1871); 
{ /* Ast/sexp.scm 426 */
obj_t BgL_cddlocz00_1873;
BgL_cddlocz00_1873 = 
BGl_findzd2locationzf2locz20zztools_locationz00(
CDR(BgL_expz00_17), BgL_locz00_1871); 
{ /* Ast/sexp.scm 427 */
BgL_nodez00_bglt BgL_testz00_1874;
{ /* Ast/sexp.scm 430 */
obj_t BgL_arg3921z00_1907;obj_t BgL_arg3922z00_1908;
BgL_arg3921z00_1907 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_testz00_1861, BgL_cdlocz00_1872); 
BgL_arg3922z00_1908 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_1874 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_testz00_1861, BgL_stackz00_18, BgL_arg3921z00_1907, BgL_arg3922z00_1908); } 
{ /* Ast/sexp.scm 428 */

{ 
obj_t BgL_clsz00_1875;obj_t BgL_nclausesz00_1876;
BgL_clsz00_1875 = BgL_clausesz00_1862; 
BgL_nclausesz00_1876 = BNIL; 
BgL_loopz00_1877:
if(
NULLP(BgL_clsz00_1875))
{ /* Ast/sexp.scm 436 */
obj_t BgL_arg3860z00_1879;obj_t BgL_arg3861z00_1880;BgL_nodez00_bglt BgL_arg3863z00_1882;obj_t BgL_arg3864z00_1883;BgL_typez00_bglt BgL_arg3865z00_1884;
BgL_arg3860z00_1879 = BgL_locz00_1871; 
BgL_arg3861z00_1880 = BGl_za2_za2z00zztype_cachez00; 
BgL_arg3863z00_1882 = BgL_testz00_1874; 
BgL_arg3864z00_1883 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_nclausesz00_1876); 
{ /* Ast/sexp.scm 439 */
obj_t BgL_auxz00_4964;
{ /* Ast/sexp.scm 439 */
obj_t BgL_auxz00_4965;
{ /* Ast/sexp.scm 439 */
obj_t BgL_auxz00_4966;
BgL_auxz00_4966 = 
CAR(BgL_clausesz00_1862); 
BgL_auxz00_4965 = 
CAR(BgL_auxz00_4966); } 
BgL_auxz00_4964 = 
CAR(BgL_auxz00_4965); } 
BgL_arg3865z00_1884 = 
BGl_typeofzd2atomzd2zztype_typeofz00(BgL_auxz00_4964); } 
{ /* Ast/sexp.scm 435 */
BgL_selectz00_bglt BgL_res4716z00_3119;
{ /* Ast/sexp.scm 435 */
BgL_typez00_bglt BgL_type2407z00_3090;obj_t BgL_key2409z00_3092;
BgL_type2407z00_3090 = 
(BgL_typez00_bglt)(BgL_arg3861z00_1880); 
BgL_key2409z00_3092 = 
BINT(((long)-1)); 
{ /* Ast/sexp.scm 435 */
BgL_selectz00_bglt BgL_new2413z00_3096;
{ /* Ast/sexp.scm 435 */
BgL_selectz00_bglt BgL_res4714z00_3102;
{ /* Ast/sexp.scm 435 */
BgL_selectz00_bglt BgL_new2415z00_3097;
BgL_new2415z00_3097 = 
((BgL_selectz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_selectz00_bgl) ))); 
{ /* Ast/sexp.scm 435 */
long BgL_arg4302z00_3098;
BgL_arg4302z00_3098 = 
BGl_classzd2numzd2zz__objectz00(BGl_selectz00zzast_nodez00); 
{ /* Ast/sexp.scm 435 */
BgL_objectz00_bglt BgL_auxz00_4975;
BgL_auxz00_4975 = 
(BgL_objectz00_bglt)(BgL_new2415z00_3097); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4975, BgL_arg4302z00_3098); } } 
{ /* Ast/sexp.scm 435 */
BgL_objectz00_bglt BgL_auxz00_4978;
BgL_auxz00_4978 = 
(BgL_objectz00_bglt)(BgL_new2415z00_3097); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4978, BFALSE); } 
{ /* Ast/sexp.scm 435 */
obj_t BgL_auxz00_4981;
BgL_auxz00_4981 = 
(obj_t)(BgL_new2415z00_3097); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4981); } BUNSPEC; 
BgL_res4714z00_3102 = BgL_new2415z00_3097; } 
BgL_new2413z00_3096 = BgL_res4714z00_3102; } 
{ /* Ast/sexp.scm 435 */
BgL_selectz00_bglt BgL_res4715z00_3118;
((((BgL_selectz00_bglt)CREF(BgL_new2413z00_3096))->BgL_locz00) = ((obj_t)BgL_arg3860z00_1879), BUNSPEC); 
((((BgL_selectz00_bglt)CREF(BgL_new2413z00_3096))->BgL_typez00) = ((BgL_typez00_bglt)BgL_type2407z00_3090), BUNSPEC); 
((((BgL_selectz00_bglt)CREF(BgL_new2413z00_3096))->BgL_sidezd2effectzf3z21) = ((obj_t)BUNSPEC), BUNSPEC); 
((((BgL_selectz00_bglt)CREF(BgL_new2413z00_3096))->BgL_keyz00) = ((obj_t)BgL_key2409z00_3092), BUNSPEC); 
((((BgL_selectz00_bglt)CREF(BgL_new2413z00_3096))->BgL_testz00) = ((BgL_nodez00_bglt)BgL_arg3863z00_1882), BUNSPEC); 
((((BgL_selectz00_bglt)CREF(BgL_new2413z00_3096))->BgL_clausesz00) = ((obj_t)BgL_arg3864z00_1883), BUNSPEC); 
((((BgL_selectz00_bglt)CREF(BgL_new2413z00_3096))->BgL_itemzd2typezd2) = ((BgL_typez00_bglt)BgL_arg3865z00_1884), BUNSPEC); 
BgL_res4715z00_3118 = BgL_new2413z00_3096; BgL_res4715z00_3118; } 
BgL_res4716z00_3119 = BgL_new2413z00_3096; } } 
BgL_auxz00_4947 = 
(obj_t)(BgL_res4716z00_3119); } }  else 
{ /* Ast/sexp.scm 441 */
obj_t BgL_clausez00_1888;
BgL_clausez00_1888 = 
CAR(BgL_clsz00_1875); 
{ /* Ast/sexp.scm 441 */
BgL_nodez00_bglt BgL_bodyz00_1889;
{ /* Ast/sexp.scm 442 */
obj_t BgL_arg3909z00_1903;obj_t BgL_arg3910z00_1904;obj_t BgL_arg3911z00_1905;
BgL_arg3909z00_1903 = 
BGl_normaliza7ezd2prognz75zztools_prognz00(
CDR(BgL_clausez00_1888)); 
BgL_arg3910z00_1904 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_clausez00_1888, BgL_cddlocz00_1873); 
BgL_arg3911z00_1905 = 
CNST_TABLE_REF(((long)1)); 
BgL_bodyz00_1889 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg3909z00_1903, BgL_stackz00_18, BgL_arg3910z00_1904, BgL_arg3911z00_1905); } 
{ /* Ast/sexp.scm 442 */
obj_t BgL_nclausez00_1890;
{ /* Ast/sexp.scm 446 */
obj_t BgL_auxz00_5000;obj_t BgL_auxz00_4998;
BgL_auxz00_5000 = 
(obj_t)(BgL_bodyz00_1889); 
BgL_auxz00_4998 = 
CAR(BgL_clausez00_1888); 
BgL_nclausez00_1890 = 
MAKE_PAIR(BgL_auxz00_4998, BgL_auxz00_5000); } 
{ /* Ast/sexp.scm 446 */

{ /* Ast/sexp.scm 448 */
bool_t BgL_testz00_5003;
{ /* Ast/sexp.scm 448 */
bool_t BgL_testz00_5004;
{ /* Ast/sexp.scm 448 */
obj_t BgL_auxz00_5007;obj_t BgL_auxz00_5005;
BgL_auxz00_5007 = 
CNST_TABLE_REF(((long)6)); 
BgL_auxz00_5005 = 
CAR(BgL_clausez00_1888); 
BgL_testz00_5004 = 
(BgL_auxz00_5005==BgL_auxz00_5007); } 
if(BgL_testz00_5004)
{ /* Ast/sexp.scm 449 */
bool_t BgL_testz00_5010;
{ /* Ast/sexp.scm 449 */
obj_t BgL_auxz00_5011;
BgL_auxz00_5011 = 
CDR(BgL_clsz00_1875); 
BgL_testz00_5010 = 
NULLP(BgL_auxz00_5011); } 
if(BgL_testz00_5010)
{ /* Ast/sexp.scm 449 */
BgL_testz00_5003 = ((bool_t)0)
; }  else 
{ /* Ast/sexp.scm 449 */
BgL_testz00_5003 = ((bool_t)1)
; } }  else 
{ /* Ast/sexp.scm 448 */
BgL_testz00_5003 = ((bool_t)0)
; } } 
if(BgL_testz00_5003)
{ /* Ast/sexp.scm 450 */
obj_t BgL_arg3881z00_1893;
BgL_arg3881z00_1893 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, BgL_locz00_1871); 
{ /* Ast/sexp.scm 450 */
BgL_nodez00_bglt BgL_auxz00_5015;
BgL_auxz00_5015 = 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string5106z00zzast_sexpz00, BgL_arg3881z00_1893, BgL_expz00_17); 
BgL_auxz00_4947 = 
(obj_t)(BgL_auxz00_5015); } }  else 
{ /* Ast/sexp.scm 453 */
obj_t BgL_arg3885z00_1894;obj_t BgL_arg3886z00_1895;
BgL_arg3885z00_1894 = 
CDR(BgL_clsz00_1875); 
{ /* Ast/sexp.scm 454 */
obj_t BgL_arg3890z00_1896;
BgL_arg3890z00_1896 = 
BGl_epairifyz00zztools_miscz00(BgL_nclausez00_1890, BgL_clausez00_1888); 
BgL_arg3886z00_1895 = 
MAKE_PAIR(BgL_arg3890z00_1896, BgL_nclausesz00_1876); } 
{ 
obj_t BgL_nclausesz00_5022;obj_t BgL_clsz00_5021;
BgL_clsz00_5021 = BgL_arg3885z00_1894; 
BgL_nclausesz00_5022 = BgL_arg3886z00_1895; 
BgL_nclausesz00_1876 = BgL_nclausesz00_5022; 
BgL_clsz00_1875 = BgL_clsz00_5021; 
goto BgL_loopz00_1877;} } } } } } } } } } } } } }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_5025;
BgL_tagzd2559zd2_1864:
{ /* Ast/sexp.scm 457 */
obj_t BgL_arg3936z00_1912;
BgL_arg3936z00_1912 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, BgL_locz00_19); 
BgL_auxz00_5025 = 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string5106z00zzast_sexpz00, BgL_arg3936z00_1912, BgL_expz00_17); } 
BgL_auxz00_4947 = 
(obj_t)(BgL_auxz00_5025); } }  else 
{ /* Ast/sexp.scm 74 */
BgL_nodez00_bglt BgL_auxz00_5029;
goto BgL_tagzd2559zd2_1864;
BgL_auxz00_4947 = 
(obj_t)(BgL_auxz00_5029); } } 
return 
(BgL_nodez00_bglt)(BgL_auxz00_4947);}  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_5032;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_5035;obj_t BgL_auxz00_5033;
BgL_auxz00_5035 = 
CNST_TABLE_REF(((long)25)); 
BgL_auxz00_5033 = 
CAR(BgL_expz00_17); 
BgL_testz00_5032 = 
(BgL_auxz00_5033==BgL_auxz00_5035); } 
if(BgL_testz00_5032)
{ /* Ast/sexp.scm 74 */
BgL_letzd2funzd2_bglt BgL_auxz00_5038;
BgL_auxz00_5038 = 
BGl_setzd2exitzd2ze3nodeze3zzast_exitz00(BgL_expz00_17, BgL_stackz00_18, BgL_locz00_19, BgL_sitez00_20); 
return 
(BgL_nodez00_bglt)(BgL_auxz00_5038);}  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_5041;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_5044;obj_t BgL_auxz00_5042;
BgL_auxz00_5044 = 
CNST_TABLE_REF(((long)26)); 
BgL_auxz00_5042 = 
CAR(BgL_expz00_17); 
BgL_testz00_5041 = 
(BgL_auxz00_5042==BgL_auxz00_5044); } 
if(BgL_testz00_5041)
{ /* Ast/sexp.scm 74 */
BgL_jumpzd2exzd2itz00_bglt BgL_auxz00_5047;
BgL_auxz00_5047 = 
BGl_jumpzd2exitzd2ze3nodeze3zzast_exitz00(BgL_expz00_17, BgL_stackz00_18, BgL_locz00_19, BgL_sitez00_20); 
return 
(BgL_nodez00_bglt)(BgL_auxz00_5047);}  else 
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2343zd2_1365;
BgL_cdrzd2343zd2_1365 = 
CDR(BgL_expz00_17); 
{ /* Ast/sexp.scm 74 */
bool_t BgL_testz00_5051;
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_5054;obj_t BgL_auxz00_5052;
BgL_auxz00_5054 = 
CNST_TABLE_REF(((long)19)); 
BgL_auxz00_5052 = 
CAR(BgL_expz00_17); 
BgL_testz00_5051 = 
(BgL_auxz00_5052==BgL_auxz00_5054); } 
if(BgL_testz00_5051)
{ /* Ast/sexp.scm 74 */
if(
PAIRP(BgL_cdrzd2343zd2_1365))
{ /* Ast/sexp.scm 74 */
obj_t BgL_cdrzd2345zd2_1368;
BgL_cdrzd2345zd2_1368 = 
CDR(BgL_cdrzd2343zd2_1365); 
if(
PAIRP(BgL_cdrzd2345zd2_1368))
{ /* Ast/sexp.scm 74 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2345zd2_1368), BNIL))
{ /* Ast/sexp.scm 74 */
return 
BGl_applycationzd2ze3nodez31zzast_applyz00(BgL_expz00_17, BgL_stackz00_18, BgL_locz00_19, BgL_sitez00_20);}  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_test2855z00_1371;
BgL_test2855z00_1371 = 
BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17); 
if(BgL_test2855z00_1371)
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_5068;
goto BgL_tagzd2141zd2_1295;
return 
(BgL_nodez00_bglt)(BgL_auxz00_5068);}  else 
{ /* Ast/sexp.scm 74 */
goto BgL_tagzd2142zd2_1296;} } }  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_test2864z00_1374;
BgL_test2864z00_1374 = 
BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17); 
if(BgL_test2864z00_1374)
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_5072;
goto BgL_tagzd2141zd2_1295;
return 
(BgL_nodez00_bglt)(BgL_auxz00_5072);}  else 
{ /* Ast/sexp.scm 74 */
goto BgL_tagzd2142zd2_1296;} } }  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_test2870z00_1375;
BgL_test2870z00_1375 = 
BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17); 
if(BgL_test2870z00_1375)
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_5076;
goto BgL_tagzd2141zd2_1295;
return 
(BgL_nodez00_bglt)(BgL_auxz00_5076);}  else 
{ /* Ast/sexp.scm 74 */
goto BgL_tagzd2142zd2_1296;} } }  else 
{ /* Ast/sexp.scm 74 */
bool_t BgL_test2875z00_1376;
BgL_test2875z00_1376 = 
BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17); 
if(BgL_test2875z00_1376)
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_5080;
goto BgL_tagzd2141zd2_1295;
return 
(BgL_nodez00_bglt)(BgL_auxz00_5080);}  else 
{ /* Ast/sexp.scm 74 */
goto BgL_tagzd2142zd2_1296;} } } } } } } } } } } } } } } } } } } } }  else 
{ /* Ast/sexp.scm 74 */
obj_t BgL_auxz00_5082;
BgL_atomz00_1269 = BgL_expz00_17; 
if(
SYMBOLP(BgL_atomz00_1269))
{ /* Ast/sexp.scm 106 */
bool_t BgL_test2967z00_1408;
{ /* Ast/sexp.scm 106 */
obj_t BgL_auxz00_5085;
BgL_auxz00_5085 = 
BGl_lookupz00zzast_sexpz00(BgL_atomz00_1269, BgL_stackz00_18); 
BgL_test2967z00_1408 = 
CBOOL(BgL_auxz00_5085); } 
if(BgL_test2967z00_1408)
{ /* Ast/sexp.scm 106 */
{ /* Ast/sexp.scm 107 */
obj_t BgL_localz00_1409;
BgL_localz00_1409 = 
BGl_lookupz00zzast_sexpz00(BgL_atomz00_1269, BgL_stackz00_18); 
{ /* Ast/sexp.scm 107 */
obj_t BgL_varz00_1410;
{ /* Ast/sexp.scm 108 */
bool_t BgL_test2969z00_1411;
{ /* Ast/sexp.scm 108 */
bool_t BgL_testz00_5090;
{ /* Ast/sexp.scm 108 */
obj_t BgL_auxz00_5091;
BgL_auxz00_5091 = 
CNST_TABLE_REF(((long)15)); 
BgL_testz00_5090 = 
(BgL_sitez00_20==BgL_auxz00_5091); } 
if(BgL_testz00_5090)
{ /* Ast/sexp.scm 108 */
BgL_test2969z00_1411 = ((bool_t)0); }  else 
{ /* Ast/sexp.scm 109 */
obj_t BgL_auxz00_5094;
{ /* Ast/sexp.scm 109 */
BgL_valuez00_bglt BgL_auxz00_5095;
{ /* Ast/sexp.scm 109 */
BgL_localz00_bglt BgL_obj1256z00_2514;
BgL_obj1256z00_2514 = 
(BgL_localz00_bglt)(BgL_localz00_1409); 
BgL_auxz00_5095 = 
(((BgL_localz00_bglt)CREF(BgL_obj1256z00_2514))->BgL_valuez00); } 
BgL_auxz00_5094 = 
(obj_t)(BgL_auxz00_5095); } 
BgL_test2969z00_1411 = 
BGl_iszd2azf3z21zz__objectz00(BgL_auxz00_5094, BGl_funz00zzast_varz00); } } 
if(BgL_test2969z00_1411)
{ /* Ast/sexp.scm 111 */
obj_t BgL_arg2971z00_1412;BgL_typez00_bglt BgL_arg2972z00_1413;
BgL_arg2971z00_1412 = BgL_locz00_19; 
{ /* Ast/sexp.scm 112 */
BgL_localz00_bglt BgL_obj1253z00_2516;
BgL_obj1253z00_2516 = 
(BgL_localz00_bglt)(BgL_localz00_1409); 
BgL_arg2972z00_1413 = 
(((BgL_localz00_bglt)CREF(BgL_obj1253z00_2516))->BgL_typez00); } 
{ /* Ast/sexp.scm 110 */
BgL_closurez00_bglt BgL_res4661z00_2535;
{ /* Ast/sexp.scm 110 */
BgL_variablez00_bglt BgL_variable1655z00_2519;
{ /* Ast/sexp.scm 113 */
obj_t BgL_auxz00_5103;
BgL_auxz00_5103 = BgL_localz00_1409; 
BgL_variable1655z00_2519 = 
(BgL_variablez00_bglt)(BgL_auxz00_5103); } 
{ /* Ast/sexp.scm 110 */
BgL_closurez00_bglt BgL_new1656z00_2520;
{ /* Ast/sexp.scm 110 */
BgL_closurez00_bglt BgL_res4659z00_2526;
{ /* Ast/sexp.scm 110 */
BgL_closurez00_bglt BgL_new1658z00_2521;
BgL_new1658z00_2521 = 
((BgL_closurez00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_closurez00_bgl) ))); 
{ /* Ast/sexp.scm 110 */
long BgL_arg4482z00_2522;
BgL_arg4482z00_2522 = 
BGl_classzd2numzd2zz__objectz00(BGl_closurez00zzast_nodez00); 
{ /* Ast/sexp.scm 110 */
BgL_objectz00_bglt BgL_auxz00_5107;
BgL_auxz00_5107 = 
(BgL_objectz00_bglt)(BgL_new1658z00_2521); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_5107, BgL_arg4482z00_2522); } } 
{ /* Ast/sexp.scm 110 */
BgL_objectz00_bglt BgL_auxz00_5110;
BgL_auxz00_5110 = 
(BgL_objectz00_bglt)(BgL_new1658z00_2521); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_5110, BFALSE); } 
{ /* Ast/sexp.scm 110 */
obj_t BgL_auxz00_5113;
BgL_auxz00_5113 = 
(obj_t)(BgL_new1658z00_2521); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_5113); } BUNSPEC; 
BgL_res4659z00_2526 = BgL_new1658z00_2521; } 
BgL_new1656z00_2520 = BgL_res4659z00_2526; } 
{ /* Ast/sexp.scm 110 */
BgL_closurez00_bglt BgL_res4660z00_2534;
((((BgL_closurez00_bglt)CREF(BgL_new1656z00_2520))->BgL_locz00) = ((obj_t)BgL_arg2971z00_1412), BUNSPEC); 
((((BgL_closurez00_bglt)CREF(BgL_new1656z00_2520))->BgL_typez00) = ((BgL_typez00_bglt)BgL_arg2972z00_1413), BUNSPEC); 
((((BgL_closurez00_bglt)CREF(BgL_new1656z00_2520))->BgL_variablez00) = ((BgL_variablez00_bglt)BgL_variable1655z00_2519), BUNSPEC); 
BgL_res4660z00_2534 = BgL_new1656z00_2520; BgL_res4660z00_2534; } 
BgL_res4661z00_2535 = BgL_new1656z00_2520; } } 
BgL_varz00_1410 = 
(obj_t)(BgL_res4661z00_2535); } }  else 
{ /* Ast/sexp.scm 115 */
obj_t BgL_arg2977z00_1415;BgL_typez00_bglt BgL_arg2978z00_1416;
BgL_arg2977z00_1415 = BgL_locz00_19; 
{ /* Ast/sexp.scm 116 */
BgL_localz00_bglt BgL_obj1253z00_2536;
BgL_obj1253z00_2536 = 
(BgL_localz00_bglt)(BgL_localz00_1409); 
BgL_arg2978z00_1416 = 
(((BgL_localz00_bglt)CREF(BgL_obj1253z00_2536))->BgL_typez00); } 
{ /* Ast/sexp.scm 114 */
BgL_varz00_bglt BgL_res4664z00_2555;
{ /* Ast/sexp.scm 114 */
BgL_variablez00_bglt BgL_variable1633z00_2539;
{ /* Ast/sexp.scm 117 */
obj_t BgL_auxz00_5122;
BgL_auxz00_5122 = BgL_localz00_1409; 
BgL_variable1633z00_2539 = 
(BgL_variablez00_bglt)(BgL_auxz00_5122); } 
{ /* Ast/sexp.scm 114 */
BgL_varz00_bglt BgL_new1634z00_2540;
{ /* Ast/sexp.scm 114 */
BgL_varz00_bglt BgL_res4662z00_2546;
{ /* Ast/sexp.scm 114 */
BgL_varz00_bglt BgL_new1636z00_2541;
BgL_new1636z00_2541 = 
((BgL_varz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_varz00_bgl) ))); 
{ /* Ast/sexp.scm 114 */
long BgL_arg4491z00_2542;
BgL_arg4491z00_2542 = 
BGl_classzd2numzd2zz__objectz00(BGl_varz00zzast_nodez00); 
{ /* Ast/sexp.scm 114 */
BgL_objectz00_bglt BgL_auxz00_5126;
BgL_auxz00_5126 = 
(BgL_objectz00_bglt)(BgL_new1636z00_2541); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_5126, BgL_arg4491z00_2542); } } 
{ /* Ast/sexp.scm 114 */
BgL_objectz00_bglt BgL_auxz00_5129;
BgL_auxz00_5129 = 
(BgL_objectz00_bglt)(BgL_new1636z00_2541); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_5129, BFALSE); } 
{ /* Ast/sexp.scm 114 */
obj_t BgL_auxz00_5132;
BgL_auxz00_5132 = 
(obj_t)(BgL_new1636z00_2541); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_5132); } BUNSPEC; 
BgL_res4662z00_2546 = BgL_new1636z00_2541; } 
BgL_new1634z00_2540 = BgL_res4662z00_2546; } 
{ /* Ast/sexp.scm 114 */
BgL_varz00_bglt BgL_res4663z00_2554;
((((BgL_varz00_bglt)CREF(BgL_new1634z00_2540))->BgL_locz00) = ((obj_t)BgL_arg2977z00_1415), BUNSPEC); 
((((BgL_varz00_bglt)CREF(BgL_new1634z00_2540))->BgL_typez00) = ((BgL_typez00_bglt)BgL_arg2978z00_1416), BUNSPEC); 
((((BgL_varz00_bglt)CREF(BgL_new1634z00_2540))->BgL_variablez00) = ((BgL_variablez00_bglt)BgL_variable1633z00_2539), BUNSPEC); 
BgL_res4663z00_2554 = BgL_new1634z00_2540; BgL_res4663z00_2554; } 
BgL_res4664z00_2555 = BgL_new1634z00_2540; } } 
BgL_varz00_1410 = 
(obj_t)(BgL_res4664z00_2555); } } } 
{ /* Ast/sexp.scm 108 */

BGl_usezd2variablez12zc0zzast_sexpz00(
(BgL_variablez00_bglt)(BgL_localz00_1409), BgL_locz00_19, BgL_sitez00_20); 
BgL_auxz00_5082 = BgL_varz00_1410; } } } }  else 
{ /* Ast/sexp.scm 106 */
{ /* Ast/sexp.scm 121 */
obj_t BgL_globalz00_1420;
BgL_globalz00_1420 = 
BGl_findzd2globalzd2zzast_envz00(BgL_atomz00_1269, BNIL); 
{ /* Ast/sexp.scm 123 */
bool_t BgL_test2989z00_1421;
BgL_test2989z00_1421 = 
BGl_iszd2azf3z21zz__objectz00(BgL_globalz00_1420, BGl_globalz00zzast_varz00); 
if(BgL_test2989z00_1421)
{ /* Ast/sexp.scm 125 */
bool_t BgL_testz00_5144;
{ /* Ast/sexp.scm 125 */
obj_t BgL_auxz00_5148;obj_t BgL_auxz00_5145;
BgL_auxz00_5148 = 
CNST_TABLE_REF(((long)14)); 
{ /* Ast/sexp.scm 125 */
BgL_globalz00_bglt BgL_obj1174z00_2557;
BgL_obj1174z00_2557 = 
(BgL_globalz00_bglt)(BgL_globalz00_1420); 
BgL_auxz00_5145 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1174z00_2557))->BgL_importz00); } 
BgL_testz00_5144 = 
(BgL_auxz00_5145==BgL_auxz00_5148); } 
if(BgL_testz00_5144)
{ /* Ast/sexp.scm 125 */
{ /* Ast/sexp.scm 126 */
obj_t BgL_arg2992z00_1423;
{ /* Ast/sexp.scm 126 */
obj_t BgL_arg2995z00_1424;obj_t BgL_arg2996z00_1425;
BgL_arg2995z00_1424 = 
CNST_TABLE_REF(((long)14)); 
{ /* Ast/sexp.scm 126 */
obj_t BgL_arg2999z00_1426;
{ /* Ast/sexp.scm 126 */
obj_t BgL_arg3005z00_1428;obj_t BgL_arg3006z00_1429;
BgL_arg3005z00_1428 = 
CNST_TABLE_REF(((long)17)); 
BgL_arg3006z00_1429 = 
MAKE_PAIR(BgL_atomz00_1269, BNIL); 
BgL_arg2999z00_1426 = 
MAKE_PAIR(BgL_arg3005z00_1428, BgL_arg3006z00_1429); } 
BgL_arg2996z00_1425 = 
MAKE_PAIR(BgL_arg2999z00_1426, BNIL); } 
BgL_arg2992z00_1423 = 
MAKE_PAIR(BgL_arg2995z00_1424, BgL_arg2996z00_1425); } 
{ /* Ast/sexp.scm 126 */
BgL_nodez00_bglt BgL_auxz00_5157;
BgL_auxz00_5157 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg2992z00_1423, BgL_stackz00_18, BgL_locz00_19, BgL_sitez00_20); 
BgL_auxz00_5082 = 
(obj_t)(BgL_auxz00_5157); } } }  else 
{ /* Ast/sexp.scm 125 */
BGl_usezd2variablez12zc0zzast_sexpz00(
(BgL_variablez00_bglt)(BgL_globalz00_1420), BgL_locz00_19, BgL_sitez00_20); 
{ /* Ast/sexp.scm 129 */
bool_t BgL_test3010z00_1430;
{ /* Ast/sexp.scm 129 */
bool_t BgL_testz00_5162;
{ /* Ast/sexp.scm 129 */
obj_t BgL_auxz00_5163;
BgL_auxz00_5163 = 
CNST_TABLE_REF(((long)15)); 
BgL_testz00_5162 = 
(BgL_sitez00_20==BgL_auxz00_5163); } 
if(BgL_testz00_5162)
{ /* Ast/sexp.scm 129 */
BgL_test3010z00_1430 = ((bool_t)0); }  else 
{ /* Ast/sexp.scm 129 */
obj_t BgL_auxz00_5166;
{ /* Ast/sexp.scm 129 */
BgL_valuez00_bglt BgL_auxz00_5167;
{ /* Ast/sexp.scm 129 */
BgL_globalz00_bglt BgL_obj1156z00_2558;
BgL_obj1156z00_2558 = 
(BgL_globalz00_bglt)(BgL_globalz00_1420); 
BgL_auxz00_5167 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1156z00_2558))->BgL_valuez00); } 
BgL_auxz00_5166 = 
(obj_t)(BgL_auxz00_5167); } 
BgL_test3010z00_1430 = 
BGl_iszd2azf3z21zz__objectz00(BgL_auxz00_5166, BGl_funz00zzast_varz00); } } 
if(BgL_test3010z00_1430)
{ /* Ast/sexp.scm 130 */
bool_t BgL_test3011z00_1431;
{ /* Ast/sexp.scm 130 */
bool_t BgL_test3019z00_1435;
{ /* Ast/sexp.scm 130 */
obj_t BgL_auxz00_5173;
{ /* Ast/sexp.scm 130 */
BgL_valuez00_bglt BgL_auxz00_5174;
{ /* Ast/sexp.scm 130 */
BgL_globalz00_bglt BgL_obj1156z00_2560;
BgL_obj1156z00_2560 = 
(BgL_globalz00_bglt)(BgL_globalz00_1420); 
BgL_auxz00_5174 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1156z00_2560))->BgL_valuez00); } 
BgL_auxz00_5173 = 
(obj_t)(BgL_auxz00_5174); } 
BgL_test3019z00_1435 = 
BGl_iszd2azf3z21zz__objectz00(BgL_auxz00_5173, BGl_cfunz00zzast_varz00); } 
if(BgL_test3019z00_1435)
{ /* Ast/sexp.scm 131 */
bool_t BgL_test3020z00_1436;
{ /* Ast/sexp.scm 131 */
obj_t BgL_auxz00_5180;
BgL_auxz00_5180 = 
CNST_TABLE_REF(((long)18)); 
BgL_test3020z00_1436 = 
(BGl_za2targetzd2languageza2zd2zzengine_paramz00==BgL_auxz00_5180); } 
if(BgL_test3020z00_1436)
{ /* Ast/sexp.scm 131 */
bool_t BgL_testz00_5184;
{ /* Ast/sexp.scm 132 */
obj_t BgL_auxz00_5185;
BgL_auxz00_5185 = 
CNST_TABLE_REF(((long)19)); 
BgL_testz00_5184 = 
(BgL_sitez00_20==BgL_auxz00_5185); } 
if(BgL_testz00_5184)
{ /* Ast/sexp.scm 131 */
BgL_test3011z00_1431 = ((bool_t)0); }  else 
{ /* Ast/sexp.scm 131 */
BgL_test3011z00_1431 = ((bool_t)1); } }  else 
{ /* Ast/sexp.scm 131 */
BgL_test3011z00_1431 = ((bool_t)0); } }  else 
{ /* Ast/sexp.scm 130 */
BgL_test3011z00_1431 = ((bool_t)0); } } 
if(BgL_test3011z00_1431)
{ /* Ast/sexp.scm 133 */
BgL_nodez00_bglt BgL_auxz00_5189;
BgL_auxz00_5189 = 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string5117z00zzast_sexpz00, BgL_expz00_17, BgL_locz00_19); 
BgL_auxz00_5082 = 
(obj_t)(BgL_auxz00_5189); }  else 
{ /* Ast/sexp.scm 136 */
obj_t BgL_arg3014z00_1432;BgL_typez00_bglt BgL_arg3015z00_1433;
BgL_arg3014z00_1432 = BgL_locz00_19; 
{ /* Ast/sexp.scm 137 */
BgL_globalz00_bglt BgL_obj1153z00_2562;
BgL_obj1153z00_2562 = 
(BgL_globalz00_bglt)(BgL_globalz00_1420); 
BgL_arg3015z00_1433 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1153z00_2562))->BgL_typez00); } 
{ /* Ast/sexp.scm 135 */
BgL_closurez00_bglt BgL_res4667z00_2581;
{ /* Ast/sexp.scm 135 */
BgL_variablez00_bglt BgL_variable1655z00_2565;
{ /* Ast/sexp.scm 138 */
obj_t BgL_auxz00_5194;
BgL_auxz00_5194 = BgL_globalz00_1420; 
BgL_variable1655z00_2565 = 
(BgL_variablez00_bglt)(BgL_auxz00_5194); } 
{ /* Ast/sexp.scm 135 */
BgL_closurez00_bglt BgL_new1656z00_2566;
{ /* Ast/sexp.scm 135 */
BgL_closurez00_bglt BgL_res4665z00_2572;
{ /* Ast/sexp.scm 135 */
BgL_closurez00_bglt BgL_new1658z00_2567;
BgL_new1658z00_2567 = 
((BgL_closurez00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_closurez00_bgl) ))); 
{ /* Ast/sexp.scm 135 */
long BgL_arg4482z00_2568;
BgL_arg4482z00_2568 = 
BGl_classzd2numzd2zz__objectz00(BGl_closurez00zzast_nodez00); 
{ /* Ast/sexp.scm 135 */
BgL_objectz00_bglt BgL_auxz00_5198;
BgL_auxz00_5198 = 
(BgL_objectz00_bglt)(BgL_new1658z00_2567); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_5198, BgL_arg4482z00_2568); } } 
{ /* Ast/sexp.scm 135 */
BgL_objectz00_bglt BgL_auxz00_5201;
BgL_auxz00_5201 = 
(BgL_objectz00_bglt)(BgL_new1658z00_2567); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_5201, BFALSE); } 
{ /* Ast/sexp.scm 135 */
obj_t BgL_auxz00_5204;
BgL_auxz00_5204 = 
(obj_t)(BgL_new1658z00_2567); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_5204); } BUNSPEC; 
BgL_res4665z00_2572 = BgL_new1658z00_2567; } 
BgL_new1656z00_2566 = BgL_res4665z00_2572; } 
{ /* Ast/sexp.scm 135 */
BgL_closurez00_bglt BgL_res4666z00_2580;
((((BgL_closurez00_bglt)CREF(BgL_new1656z00_2566))->BgL_locz00) = ((obj_t)BgL_arg3014z00_1432), BUNSPEC); 
((((BgL_closurez00_bglt)CREF(BgL_new1656z00_2566))->BgL_typez00) = ((BgL_typez00_bglt)BgL_arg3015z00_1433), BUNSPEC); 
((((BgL_closurez00_bglt)CREF(BgL_new1656z00_2566))->BgL_variablez00) = ((BgL_variablez00_bglt)BgL_variable1655z00_2565), BUNSPEC); 
BgL_res4666z00_2580 = BgL_new1656z00_2566; BgL_res4666z00_2580; } 
BgL_res4667z00_2581 = BgL_new1656z00_2566; } } 
BgL_auxz00_5082 = 
(obj_t)(BgL_res4667z00_2581); } } }  else 
{ /* Ast/sexp.scm 140 */
obj_t BgL_arg3029z00_1439;BgL_typez00_bglt BgL_arg3030z00_1440;
BgL_arg3029z00_1439 = BgL_locz00_19; 
{ /* Ast/sexp.scm 141 */
BgL_globalz00_bglt BgL_obj1153z00_2582;
BgL_obj1153z00_2582 = 
(BgL_globalz00_bglt)(BgL_globalz00_1420); 
BgL_arg3030z00_1440 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1153z00_2582))->BgL_typez00); } 
{ /* Ast/sexp.scm 139 */
BgL_varz00_bglt BgL_res4670z00_2601;
{ /* Ast/sexp.scm 139 */
BgL_variablez00_bglt BgL_variable1633z00_2585;
{ /* Ast/sexp.scm 142 */
obj_t BgL_auxz00_5213;
BgL_auxz00_5213 = BgL_globalz00_1420; 
BgL_variable1633z00_2585 = 
(BgL_variablez00_bglt)(BgL_auxz00_5213); } 
{ /* Ast/sexp.scm 139 */
BgL_varz00_bglt BgL_new1634z00_2586;
{ /* Ast/sexp.scm 139 */
BgL_varz00_bglt BgL_res4668z00_2592;
{ /* Ast/sexp.scm 139 */
BgL_varz00_bglt BgL_new1636z00_2587;
BgL_new1636z00_2587 = 
((BgL_varz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_varz00_bgl) ))); 
{ /* Ast/sexp.scm 139 */
long BgL_arg4491z00_2588;
BgL_arg4491z00_2588 = 
BGl_classzd2numzd2zz__objectz00(BGl_varz00zzast_nodez00); 
{ /* Ast/sexp.scm 139 */
BgL_objectz00_bglt BgL_auxz00_5217;
BgL_auxz00_5217 = 
(BgL_objectz00_bglt)(BgL_new1636z00_2587); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_5217, BgL_arg4491z00_2588); } } 
{ /* Ast/sexp.scm 139 */
BgL_objectz00_bglt BgL_auxz00_5220;
BgL_auxz00_5220 = 
(BgL_objectz00_bglt)(BgL_new1636z00_2587); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_5220, BFALSE); } 
{ /* Ast/sexp.scm 139 */
obj_t BgL_auxz00_5223;
BgL_auxz00_5223 = 
(obj_t)(BgL_new1636z00_2587); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_5223); } BUNSPEC; 
BgL_res4668z00_2592 = BgL_new1636z00_2587; } 
BgL_new1634z00_2586 = BgL_res4668z00_2592; } 
{ /* Ast/sexp.scm 139 */
BgL_varz00_bglt BgL_res4669z00_2600;
((((BgL_varz00_bglt)CREF(BgL_new1634z00_2586))->BgL_locz00) = ((obj_t)BgL_arg3029z00_1439), BUNSPEC); 
((((BgL_varz00_bglt)CREF(BgL_new1634z00_2586))->BgL_typez00) = ((BgL_typez00_bglt)BgL_arg3030z00_1440), BUNSPEC); 
((((BgL_varz00_bglt)CREF(BgL_new1634z00_2586))->BgL_variablez00) = ((BgL_variablez00_bglt)BgL_variable1633z00_2585), BUNSPEC); 
BgL_res4669z00_2600 = BgL_new1634z00_2586; BgL_res4669z00_2600; } 
BgL_res4670z00_2601 = BgL_new1634z00_2586; } } 
BgL_auxz00_5082 = 
(obj_t)(BgL_res4670z00_2601); } } } } }  else 
{ /* Ast/sexp.scm 123 */
{ /* Ast/sexp.scm 124 */
BgL_nodez00_bglt BgL_auxz00_5230;
BgL_auxz00_5230 = 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string5116z00zzast_sexpz00, BgL_expz00_17, BgL_locz00_19); 
BgL_auxz00_5082 = 
(obj_t)(BgL_auxz00_5230); } } } } } }  else 
{ /* Ast/sexp.scm 84 */
{ /* Ast/sexp.scm 86 */
bool_t BgL_test3050z00_1447;
{ /* Ast/sexp.scm 86 */
bool_t BgL_test3084z00_1463;
BgL_test3084z00_1463 = 
BGl_iszd2azf3z21zz__objectz00(BgL_atomz00_1269, BGl_localz00zzast_varz00); 
if(BgL_test3084z00_1463)
{ /* Ast/sexp.scm 86 */
BgL_test3050z00_1447 = ((bool_t)1); }  else 
{ /* Ast/sexp.scm 86 */
BgL_test3050z00_1447 = 
BGl_iszd2azf3z21zz__objectz00(BgL_atomz00_1269, BGl_globalz00zzast_varz00); } } 
if(BgL_test3050z00_1447)
{ /* Ast/sexp.scm 86 */
BGl_usezd2variablez12zc0zzast_sexpz00(
(BgL_variablez00_bglt)(BgL_atomz00_1269), BgL_locz00_19, BgL_sitez00_20); 
{ /* Ast/sexp.scm 88 */
bool_t BgL_test3052z00_1448;
{ /* Ast/sexp.scm 88 */
bool_t BgL_testz00_5239;
{ /* Ast/sexp.scm 88 */
obj_t BgL_auxz00_5240;
BgL_auxz00_5240 = 
CNST_TABLE_REF(((long)15)); 
BgL_testz00_5239 = 
(BgL_sitez00_20==BgL_auxz00_5240); } 
if(BgL_testz00_5239)
{ /* Ast/sexp.scm 88 */
BgL_test3052z00_1448 = ((bool_t)0); }  else 
{ /* Ast/sexp.scm 88 */
obj_t BgL_auxz00_5243;
{ /* Ast/sexp.scm 88 */
BgL_valuez00_bglt BgL_auxz00_5244;
{ /* Ast/sexp.scm 88 */
BgL_variablez00_bglt BgL_obj1104z00_2604;
BgL_obj1104z00_2604 = 
(BgL_variablez00_bglt)(BgL_atomz00_1269); 
BgL_auxz00_5244 = 
(((BgL_variablez00_bglt)CREF(BgL_obj1104z00_2604))->BgL_valuez00); } 
BgL_auxz00_5243 = 
(obj_t)(BgL_auxz00_5244); } 
BgL_test3052z00_1448 = 
BGl_iszd2azf3z21zz__objectz00(BgL_auxz00_5243, BGl_funz00zzast_varz00); } } 
if(BgL_test3052z00_1448)
{ /* Ast/sexp.scm 90 */
obj_t BgL_arg3054z00_1449;BgL_typez00_bglt BgL_arg3055z00_1450;
BgL_arg3054z00_1449 = BgL_locz00_19; 
{ /* Ast/sexp.scm 91 */
BgL_variablez00_bglt BgL_obj1101z00_2606;
BgL_obj1101z00_2606 = 
(BgL_variablez00_bglt)(BgL_atomz00_1269); 
BgL_arg3055z00_1450 = 
(((BgL_variablez00_bglt)CREF(BgL_obj1101z00_2606))->BgL_typez00); } 
{ /* Ast/sexp.scm 89 */
BgL_closurez00_bglt BgL_res4673z00_2625;
{ /* Ast/sexp.scm 89 */
BgL_variablez00_bglt BgL_variable1655z00_2609;
{ /* Ast/sexp.scm 92 */
obj_t BgL_auxz00_5252;
BgL_auxz00_5252 = BgL_atomz00_1269; 
BgL_variable1655z00_2609 = 
(BgL_variablez00_bglt)(BgL_auxz00_5252); } 
{ /* Ast/sexp.scm 89 */
BgL_closurez00_bglt BgL_new1656z00_2610;
{ /* Ast/sexp.scm 89 */
BgL_closurez00_bglt BgL_res4671z00_2616;
{ /* Ast/sexp.scm 89 */
BgL_closurez00_bglt BgL_new1658z00_2611;
BgL_new1658z00_2611 = 
((BgL_closurez00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_closurez00_bgl) ))); 
{ /* Ast/sexp.scm 89 */
long BgL_arg4482z00_2612;
BgL_arg4482z00_2612 = 
BGl_classzd2numzd2zz__objectz00(BGl_closurez00zzast_nodez00); 
{ /* Ast/sexp.scm 89 */
BgL_objectz00_bglt BgL_auxz00_5256;
BgL_auxz00_5256 = 
(BgL_objectz00_bglt)(BgL_new1658z00_2611); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_5256, BgL_arg4482z00_2612); } } 
{ /* Ast/sexp.scm 89 */
BgL_objectz00_bglt BgL_auxz00_5259;
BgL_auxz00_5259 = 
(BgL_objectz00_bglt)(BgL_new1658z00_2611); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_5259, BFALSE); } 
{ /* Ast/sexp.scm 89 */
obj_t BgL_auxz00_5262;
BgL_auxz00_5262 = 
(obj_t)(BgL_new1658z00_2611); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_5262); } BUNSPEC; 
BgL_res4671z00_2616 = BgL_new1658z00_2611; } 
BgL_new1656z00_2610 = BgL_res4671z00_2616; } 
{ /* Ast/sexp.scm 89 */
BgL_closurez00_bglt BgL_res4672z00_2624;
((((BgL_closurez00_bglt)CREF(BgL_new1656z00_2610))->BgL_locz00) = ((obj_t)BgL_arg3054z00_1449), BUNSPEC); 
((((BgL_closurez00_bglt)CREF(BgL_new1656z00_2610))->BgL_typez00) = ((BgL_typez00_bglt)BgL_arg3055z00_1450), BUNSPEC); 
((((BgL_closurez00_bglt)CREF(BgL_new1656z00_2610))->BgL_variablez00) = ((BgL_variablez00_bglt)BgL_variable1655z00_2609), BUNSPEC); 
BgL_res4672z00_2624 = BgL_new1656z00_2610; BgL_res4672z00_2624; } 
BgL_res4673z00_2625 = BgL_new1656z00_2610; } } 
BgL_auxz00_5082 = 
(obj_t)(BgL_res4673z00_2625); } }  else 
{ /* Ast/sexp.scm 94 */
obj_t BgL_arg3060z00_1452;BgL_typez00_bglt BgL_arg3061z00_1453;
BgL_arg3060z00_1452 = BgL_locz00_19; 
{ /* Ast/sexp.scm 95 */
BgL_variablez00_bglt BgL_obj1101z00_2626;
BgL_obj1101z00_2626 = 
(BgL_variablez00_bglt)(BgL_atomz00_1269); 
BgL_arg3061z00_1453 = 
(((BgL_variablez00_bglt)CREF(BgL_obj1101z00_2626))->BgL_typez00); } 
{ /* Ast/sexp.scm 93 */
BgL_varz00_bglt BgL_res4676z00_2645;
{ /* Ast/sexp.scm 93 */
BgL_variablez00_bglt BgL_variable1633z00_2629;
{ /* Ast/sexp.scm 96 */
obj_t BgL_auxz00_5271;
BgL_auxz00_5271 = BgL_atomz00_1269; 
BgL_variable1633z00_2629 = 
(BgL_variablez00_bglt)(BgL_auxz00_5271); } 
{ /* Ast/sexp.scm 93 */
BgL_varz00_bglt BgL_new1634z00_2630;
{ /* Ast/sexp.scm 93 */
BgL_varz00_bglt BgL_res4674z00_2636;
{ /* Ast/sexp.scm 93 */
BgL_varz00_bglt BgL_new1636z00_2631;
BgL_new1636z00_2631 = 
((BgL_varz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_varz00_bgl) ))); 
{ /* Ast/sexp.scm 93 */
long BgL_arg4491z00_2632;
BgL_arg4491z00_2632 = 
BGl_classzd2numzd2zz__objectz00(BGl_varz00zzast_nodez00); 
{ /* Ast/sexp.scm 93 */
BgL_objectz00_bglt BgL_auxz00_5275;
BgL_auxz00_5275 = 
(BgL_objectz00_bglt)(BgL_new1636z00_2631); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_5275, BgL_arg4491z00_2632); } } 
{ /* Ast/sexp.scm 93 */
BgL_objectz00_bglt BgL_auxz00_5278;
BgL_auxz00_5278 = 
(BgL_objectz00_bglt)(BgL_new1636z00_2631); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_5278, BFALSE); } 
{ /* Ast/sexp.scm 93 */
obj_t BgL_auxz00_5281;
BgL_auxz00_5281 = 
(obj_t)(BgL_new1636z00_2631); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_5281); } BUNSPEC; 
BgL_res4674z00_2636 = BgL_new1636z00_2631; } 
BgL_new1634z00_2630 = BgL_res4674z00_2636; } 
{ /* Ast/sexp.scm 93 */
BgL_varz00_bglt BgL_res4675z00_2644;
((((BgL_varz00_bglt)CREF(BgL_new1634z00_2630))->BgL_locz00) = ((obj_t)BgL_arg3060z00_1452), BUNSPEC); 
((((BgL_varz00_bglt)CREF(BgL_new1634z00_2630))->BgL_typez00) = ((BgL_typez00_bglt)BgL_arg3061z00_1453), BUNSPEC); 
((((BgL_varz00_bglt)CREF(BgL_new1634z00_2630))->BgL_variablez00) = ((BgL_variablez00_bglt)BgL_variable1633z00_2629), BUNSPEC); 
BgL_res4675z00_2644 = BgL_new1634z00_2630; BgL_res4675z00_2644; } 
BgL_res4676z00_2645 = BgL_new1634z00_2630; } } 
BgL_auxz00_5082 = 
(obj_t)(BgL_res4676z00_2645); } } } }  else 
{ /* Ast/sexp.scm 97 */
bool_t BgL_test3071z00_1457;
if(
STRUCTP(BgL_atomz00_1269))
{ /* Ast/sexp.scm 97 */
BgL_test3071z00_1457 = ((bool_t)1); }  else 
{ /* Ast/sexp.scm 97 */
if(
VECTORP(BgL_atomz00_1269))
{ /* Ast/sexp.scm 98 */
BgL_test3071z00_1457 = ((bool_t)1); }  else 
{ /* Ast/sexp.scm 98 */
BgL_test3071z00_1457 = 
BGL_OBJECTP(BgL_atomz00_1269); } } 
if(BgL_test3071z00_1457)
{ /* Ast/sexp.scm 97 */
{ /* Ast/sexp.scm 100 */
BgL_nodez00_bglt BgL_auxz00_5294;
BgL_auxz00_5294 = 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string5118z00zzast_sexpz00, BgL_expz00_17, BgL_locz00_19); 
BgL_auxz00_5082 = 
(obj_t)(BgL_auxz00_5294); } }  else 
{ /* Ast/sexp.scm 97 */
{ /* Ast/sexp.scm 103 */
obj_t BgL_arg3074z00_1458;BgL_typez00_bglt BgL_arg3075z00_1459;obj_t BgL_arg3076z00_1460;
BgL_arg3074z00_1458 = BgL_locz00_19; 
BgL_arg3075z00_1459 = 
BGl_typeofzd2atomzd2zztype_typeofz00(BgL_atomz00_1269); 
BgL_arg3076z00_1460 = BgL_atomz00_1269; 
{ /* Ast/sexp.scm 102 */
BgL_atomz00_bglt BgL_res4679z00_2667;
{ /* Ast/sexp.scm 102 */
BgL_atomz00_bglt BgL_new1612z00_2652;
{ /* Ast/sexp.scm 102 */
BgL_atomz00_bglt BgL_res4677z00_2658;
{ /* Ast/sexp.scm 102 */
BgL_atomz00_bglt BgL_new1614z00_2653;
BgL_new1614z00_2653 = 
((BgL_atomz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_atomz00_bgl) ))); 
{ /* Ast/sexp.scm 102 */
long BgL_arg4500z00_2654;
BgL_arg4500z00_2654 = 
BGl_classzd2numzd2zz__objectz00(BGl_atomz00zzast_nodez00); 
{ /* Ast/sexp.scm 102 */
BgL_objectz00_bglt BgL_auxz00_5300;
BgL_auxz00_5300 = 
(BgL_objectz00_bglt)(BgL_new1614z00_2653); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_5300, BgL_arg4500z00_2654); } } 
{ /* Ast/sexp.scm 102 */
BgL_objectz00_bglt BgL_auxz00_5303;
BgL_auxz00_5303 = 
(BgL_objectz00_bglt)(BgL_new1614z00_2653); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_5303, BFALSE); } 
{ /* Ast/sexp.scm 102 */
obj_t BgL_auxz00_5306;
BgL_auxz00_5306 = 
(obj_t)(BgL_new1614z00_2653); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_5306); } BUNSPEC; 
BgL_res4677z00_2658 = BgL_new1614z00_2653; } 
BgL_new1612z00_2652 = BgL_res4677z00_2658; } 
{ /* Ast/sexp.scm 102 */
BgL_atomz00_bglt BgL_res4678z00_2666;
((((BgL_atomz00_bglt)CREF(BgL_new1612z00_2652))->BgL_locz00) = ((obj_t)BgL_arg3074z00_1458), BUNSPEC); 
((((BgL_atomz00_bglt)CREF(BgL_new1612z00_2652))->BgL_typez00) = ((BgL_typez00_bglt)BgL_arg3075z00_1459), BUNSPEC); 
((((BgL_atomz00_bglt)CREF(BgL_new1612z00_2652))->BgL_valuez00) = ((obj_t)BgL_arg3076z00_1460), BUNSPEC); 
BgL_res4678z00_2666 = BgL_new1612z00_2652; BgL_res4678z00_2666; } 
BgL_res4679z00_2667 = BgL_new1612z00_2652; } 
BgL_auxz00_5082 = 
(obj_t)(BgL_res4679z00_2667); } } } } } } 
return 
(BgL_nodez00_bglt)(BgL_auxz00_5082);} } } } } 
}



/* liip */
obj_t BGl_liipz00zzast_sexpz00(obj_t BgL_argsz00_1775)
{ AN_OBJECT;
{ /* Ast/sexp.scm 337 */
if(
NULLP(BgL_argsz00_1775))
{ /* Ast/sexp.scm 338 */
return 
CNST_TABLE_REF(((long)27));}  else 
{ /* Ast/sexp.scm 341 */
obj_t BgL_arg3695z00_1778;obj_t BgL_arg3696z00_1779;
BgL_arg3695z00_1778 = 
CNST_TABLE_REF(((long)28)); 
{ /* Ast/sexp.scm 340 */
obj_t BgL_arg3699z00_1780;obj_t BgL_arg3700z00_1781;
BgL_arg3699z00_1780 = 
CAR(BgL_argsz00_1775); 
{ /* Ast/sexp.scm 341 */
obj_t BgL_arg3704z00_1782;
BgL_arg3704z00_1782 = 
BGl_liipz00zzast_sexpz00(
CDR(BgL_argsz00_1775)); 
BgL_arg3700z00_1781 = 
MAKE_PAIR(BgL_arg3704z00_1782, BNIL); } 
BgL_arg3696z00_1779 = 
MAKE_PAIR(BgL_arg3699z00_1780, BgL_arg3700z00_1781); } 
return 
MAKE_PAIR(BgL_arg3695z00_1778, BgL_arg3696z00_1779);} } 
}



/* loop */
obj_t BGl_loopz00zzast_sexpz00(obj_t BgL_expz00_3958, obj_t BgL_locz00_3957, obj_t BgL_varsz00_1737, obj_t BgL_argsz00_1738)
{ AN_OBJECT;
{ /* Ast/sexp.scm 322 */
BGl_loopz00zzast_sexpz00:
if(
NULLP(BgL_varsz00_1737))
{ /* Ast/sexp.scm 325 */
if(
NULLP(BgL_argsz00_1738))
{ /* Ast/sexp.scm 326 */
return BNIL;}  else 
{ /* Ast/sexp.scm 330 */
obj_t BgL_arg3612z00_1742;
{ /* Ast/sexp.scm 330 */
obj_t BgL_arg3617z00_1745;
BgL_arg3617z00_1745 = 
BGl_currentzd2functionzd2zztools_errorz00(); 
BgL_arg3612z00_1742 = 
BGl_shapez00zztools_shapez00(BgL_arg3617z00_1745); } 
return 
BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_3957, BgL_arg3612z00_1742, BGl_string5120z00zzast_sexpz00, BgL_expz00_3958, BNIL);} }  else 
{ /* Ast/sexp.scm 325 */
if(
PAIRP(BgL_varsz00_1737))
{ /* Ast/sexp.scm 342 */
bool_t BgL_test3622z00_1747;
{ /* Ast/sexp.scm 342 */
obj_t BgL_auxz00_5333;
BgL_auxz00_5333 = 
BGl_dssslzd2namedzd2constantzf3zf3zztools_dssslz00(
CAR(BgL_varsz00_1737)); 
BgL_test3622z00_1747 = 
CBOOL(BgL_auxz00_5333); } 
if(BgL_test3622z00_1747)
{ /* Ast/sexp.scm 342 */
{ /* Ast/sexp.scm 343 */
obj_t BgL_argz00_1748;
BgL_argz00_1748 = 
BGl_dssslzd2findzd2firstzd2formalzd2zztools_dssslz00(
CDR(BgL_varsz00_1737)); 
if(
CBOOL(BgL_argz00_1748))
{ 
obj_t BgL_varsz00_5342;
BgL_varsz00_5342 = BgL_argz00_1748; 
BgL_varsz00_1737 = BgL_varsz00_5342; 
goto BGl_loopz00zzast_sexpz00;}  else 
{ 
obj_t BgL_varsz00_5343;
BgL_varsz00_5343 = BNIL; 
BgL_varsz00_1737 = BgL_varsz00_5343; 
goto BGl_loopz00zzast_sexpz00;} } }  else 
{ /* Ast/sexp.scm 348 */
bool_t BgL_testz00_5344;
{ /* Ast/sexp.scm 348 */
obj_t BgL_auxz00_5345;
BgL_auxz00_5345 = 
CAR(BgL_varsz00_1737); 
BgL_testz00_5344 = 
SYMBOLP(BgL_auxz00_5345); } 
if(BgL_testz00_5344)
{ /* Ast/sexp.scm 348 */
if(
NULLP(BgL_argsz00_1738))
{ /* Ast/sexp.scm 354 */
{ /* Ast/sexp.scm 357 */
obj_t BgL_arg3632z00_1752;
{ /* Ast/sexp.scm 357 */
obj_t BgL_arg3637z00_1755;
BgL_arg3637z00_1755 = 
BGl_currentzd2functionzd2zztools_errorz00(); 
BgL_arg3632z00_1752 = 
BGl_shapez00zztools_shapez00(BgL_arg3637z00_1755); } 
return 
BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_3957, BgL_arg3632z00_1752, BGl_string5120z00zzast_sexpz00, BgL_expz00_3958, BNIL);} }  else 
{ /* Ast/sexp.scm 354 */
{ /* Ast/sexp.scm 361 */
obj_t BgL_arg3641z00_1756;obj_t BgL_arg3642z00_1757;
{ /* Ast/sexp.scm 361 */
obj_t BgL_arg3645z00_1758;
BgL_arg3645z00_1758 = 
CAR(BgL_varsz00_1737); 
{ /* Ast/sexp.scm 361 */
obj_t BgL_list3648z00_1760;
{ /* Ast/sexp.scm 361 */
obj_t BgL_arg3650z00_1761;
{ /* Ast/sexp.scm 361 */
obj_t BgL_auxz00_5354;
BgL_auxz00_5354 = 
CAR(BgL_argsz00_1738); 
BgL_arg3650z00_1761 = 
MAKE_PAIR(BgL_auxz00_5354, BNIL); } 
BgL_list3648z00_1760 = 
MAKE_PAIR(BgL_arg3645z00_1758, BgL_arg3650z00_1761); } 
BgL_arg3641z00_1756 = BgL_list3648z00_1760; } } 
BgL_arg3642z00_1757 = 
BGl_loopz00zzast_sexpz00(BgL_expz00_3958, BgL_locz00_3957, 
CDR(BgL_varsz00_1737), 
CDR(BgL_argsz00_1738)); 
return 
MAKE_PAIR(BgL_arg3641z00_1756, BgL_arg3642z00_1757);} } }  else 
{ /* Ast/sexp.scm 348 */
{ /* Ast/sexp.scm 351 */
obj_t BgL_arg3663z00_1764;
{ /* Ast/sexp.scm 351 */
obj_t BgL_arg3668z00_1767;
BgL_arg3668z00_1767 = 
BGl_currentzd2functionzd2zztools_errorz00(); 
BgL_arg3663z00_1764 = 
BGl_shapez00zztools_shapez00(BgL_arg3668z00_1767); } 
return 
BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_3957, BgL_arg3663z00_1764, BGl_string5121z00zzast_sexpz00, BgL_expz00_3958, BNIL);} } } }  else 
{ /* Ast/sexp.scm 333 */
{ /* Ast/sexp.scm 337 */
obj_t BgL_arg3680z00_1770;
{ /* Ast/sexp.scm 337 */
obj_t BgL_arg3685z00_1772;
BgL_arg3685z00_1772 = 
BGl_liipz00zzast_sexpz00(BgL_argsz00_1738); 
{ /* Ast/sexp.scm 335 */
obj_t BgL_list3687z00_1773;
{ /* Ast/sexp.scm 335 */
obj_t BgL_arg3689z00_1774;
BgL_arg3689z00_1774 = 
MAKE_PAIR(BgL_arg3685z00_1772, BNIL); 
BgL_list3687z00_1773 = 
MAKE_PAIR(BgL_varsz00_1737, BgL_arg3689z00_1774); } 
BgL_arg3680z00_1770 = BgL_list3687z00_1773; } } 
{ /* Ast/sexp.scm 334 */
obj_t BgL_list3682z00_1771;
BgL_list3682z00_1771 = 
MAKE_PAIR(BgL_arg3680z00_1770, BNIL); 
return BgL_list3682z00_1771;} } } } } 
}



/* _sexp->node4751 */
obj_t BGl__sexpzd2ze3node4751z31zzast_sexpz00(obj_t BgL_envz00_3927, obj_t BgL_expz00_3928, obj_t BgL_stackz00_3929, obj_t BgL_locz00_3930, obj_t BgL_sitez00_3931)
{ AN_OBJECT;
{ /* Ast/sexp.scm 71 */
{ /* Ast/sexp.scm 72 */
BgL_nodez00_bglt BgL_auxz00_5369;
BgL_auxz00_5369 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_3928, BgL_stackz00_3929, BgL_locz00_3930, BgL_sitez00_3931); 
return 
(obj_t)(BgL_auxz00_5369);} } 
}



/* <anonymous:3728> */
obj_t BGl_zc3anonymousza33728ze3z83zzast_sexpz00(obj_t BgL_envz00_3932, obj_t BgL_objz00_3934, obj_t BgL_procz00_3935, obj_t BgL_msgz00_3936)
{ AN_OBJECT;
{ /* Ast/sexp.scm 367 */
{ /* Ast/sexp.scm 368 */
obj_t BgL_locz00_3933;
{ /* Ast/sexp.scm 368 */
int BgL_auxz00_5372;
BgL_auxz00_5372 = 
(int)(((long)0)); 
BgL_locz00_3933 = 
PROCEDURE_REF(BgL_envz00_3932, BgL_auxz00_5372); } 
{ 
obj_t BgL_objz00_1791;obj_t BgL_procz00_1792;obj_t BgL_msgz00_1793;
BgL_objz00_1791 = BgL_objz00_3934; 
BgL_procz00_1792 = BgL_procz00_3935; 
BgL_msgz00_1793 = BgL_msgz00_3936; 
return 
BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_3933, BgL_objz00_1791, BgL_procz00_1792, BgL_msgz00_1793, BNIL);} } } 
}



/* sexp*->node */
obj_t BGl_sexpza2zd2ze3nodez93zzast_sexpz00(obj_t BgL_expza2za2_21, obj_t BgL_stackz00_22, obj_t BgL_locz00_23, obj_t BgL_sitez00_24)
{ AN_OBJECT;
{ /* Ast/sexp.scm 514 */
{ 
obj_t BgL_expsz00_1949;obj_t BgL_resz00_1950;obj_t BgL_locz00_1951;
BgL_expsz00_1949 = BgL_expza2za2_21; 
BgL_resz00_1950 = BNIL; 
BgL_locz00_1951 = BgL_locz00_23; 
BgL_loopz00_1952:
if(
NULLP(BgL_expsz00_1949))
{ /* Ast/sexp.scm 519 */
{ /* Ast/sexp.scm 520 */
BgL_nodez00_bglt BgL_auxz00_5378;
BgL_auxz00_5378 = 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string5122z00zzast_sexpz00, BgL_expsz00_1949, BgL_locz00_1951); 
return 
(obj_t)(BgL_auxz00_5378);} }  else 
{ /* Ast/sexp.scm 521 */
bool_t BgL_testz00_5381;
{ /* Ast/sexp.scm 521 */
obj_t BgL_auxz00_5382;
BgL_auxz00_5382 = 
CDR(BgL_expsz00_1949); 
BgL_testz00_5381 = 
NULLP(BgL_auxz00_5382); } 
if(BgL_testz00_5381)
{ /* Ast/sexp.scm 521 */
{ /* Ast/sexp.scm 522 */
obj_t BgL_locz00_1955;obj_t BgL_nsitez00_1956;
{ /* Ast/sexp.scm 522 */
obj_t BgL_arg4025z00_1960;obj_t BgL_arg4026z00_1961;
BgL_arg4025z00_1960 = 
CAR(BgL_expsz00_1949); 
BgL_arg4026z00_1961 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expsz00_1949, BgL_locz00_1951); 
BgL_locz00_1955 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_arg4025z00_1960, BgL_arg4026z00_1961); } 
{ /* Ast/sexp.scm 524 */
bool_t BgL_testz00_5388;
{ /* Ast/sexp.scm 524 */
obj_t BgL_auxz00_5389;
BgL_auxz00_5389 = 
CNST_TABLE_REF(((long)15)); 
BgL_testz00_5388 = 
(BgL_sitez00_24==BgL_auxz00_5389); } 
if(BgL_testz00_5388)
{ /* Ast/sexp.scm 524 */
BgL_nsitez00_1956 = 
CNST_TABLE_REF(((long)1)); }  else 
{ /* Ast/sexp.scm 524 */
BgL_nsitez00_1956 = BgL_sitez00_24; } } 
{ /* Ast/sexp.scm 525 */
obj_t BgL_arg4015z00_1957;
{ /* Ast/sexp.scm 525 */
BgL_nodez00_bglt BgL_arg4018z00_1958;
BgL_arg4018z00_1958 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(
CAR(BgL_expsz00_1949), BgL_stackz00_22, BgL_locz00_1955, BgL_nsitez00_1956); 
{ /* Ast/sexp.scm 525 */
obj_t BgL_auxz00_5395;
BgL_auxz00_5395 = 
(obj_t)(BgL_arg4018z00_1958); 
BgL_arg4015z00_1957 = 
MAKE_PAIR(BgL_auxz00_5395, BgL_resz00_1950); } } 
return 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_arg4015z00_1957);} } }  else 
{ /* Ast/sexp.scm 521 */
{ /* Ast/sexp.scm 527 */
obj_t BgL_locz00_1963;
{ /* Ast/sexp.scm 527 */
obj_t BgL_arg4046z00_1969;obj_t BgL_arg4047z00_1970;
BgL_arg4046z00_1969 = 
CAR(BgL_expsz00_1949); 
BgL_arg4047z00_1970 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expsz00_1949, BgL_locz00_1951); 
BgL_locz00_1963 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_arg4046z00_1969, BgL_arg4047z00_1970); } 
{ /* Ast/sexp.scm 529 */
obj_t BgL_arg4033z00_1964;obj_t BgL_arg4034z00_1965;
BgL_arg4033z00_1964 = 
CDR(BgL_expsz00_1949); 
{ /* Ast/sexp.scm 530 */
BgL_nodez00_bglt BgL_arg4038z00_1966;
BgL_arg4038z00_1966 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(
CAR(BgL_expsz00_1949), BgL_stackz00_22, BgL_locz00_1963, 
CNST_TABLE_REF(((long)1))); 
{ /* Ast/sexp.scm 530 */
obj_t BgL_auxz00_5406;
BgL_auxz00_5406 = 
(obj_t)(BgL_arg4038z00_1966); 
BgL_arg4034z00_1965 = 
MAKE_PAIR(BgL_auxz00_5406, BgL_resz00_1950); } } 
{ 
obj_t BgL_locz00_5411;obj_t BgL_resz00_5410;obj_t BgL_expsz00_5409;
BgL_expsz00_5409 = BgL_arg4033z00_1964; 
BgL_resz00_5410 = BgL_arg4034z00_1965; 
BgL_locz00_5411 = BgL_locz00_1963; 
BgL_locz00_1951 = BgL_locz00_5411; 
BgL_resz00_1950 = BgL_resz00_5410; 
BgL_expsz00_1949 = BgL_expsz00_5409; 
goto BgL_loopz00_1952;} } } } } } } 
}



/* _sexp*->node4754 */
obj_t BGl__sexpza2zd2ze3node4754z93zzast_sexpz00(obj_t BgL_envz00_3937, obj_t BgL_expza2za2_3938, obj_t BgL_stackz00_3939, obj_t BgL_locz00_3940, obj_t BgL_sitez00_3941)
{ AN_OBJECT;
{ /* Ast/sexp.scm 514 */
return 
BGl_sexpza2zd2ze3nodez93zzast_sexpz00(BgL_expza2za2_3938, BgL_stackz00_3939, BgL_locz00_3940, BgL_sitez00_3941);} 
}



/* lookup */
obj_t BGl_lookupz00zzast_sexpz00(obj_t BgL_namez00_25, obj_t BgL_stackz00_26)
{ AN_OBJECT;
{ /* Ast/sexp.scm 543 */
{ /* Ast/sexp.scm 544 */
bool_t BgL_test4056z00_1972;
{ /* Ast/sexp.scm 544 */
bool_t BgL_test4074z00_1980;
BgL_test4074z00_1980 = 
(BgL_namez00_25==BGl_za2cachezd2nameza2zd2zzast_sexpz00); 
if(BgL_test4074z00_1980)
{ /* Ast/sexp.scm 544 */
BgL_test4056z00_1972 = 
(BgL_stackz00_26==BGl_za2cachezd2stackza2zd2zzast_sexpz00); }  else 
{ /* Ast/sexp.scm 544 */
BgL_test4056z00_1972 = ((bool_t)0); } } 
if(BgL_test4056z00_1972)
{ /* Ast/sexp.scm 544 */
return BGl_za2cachezd2resza2zd2zzast_sexpz00;}  else 
{ /* Ast/sexp.scm 544 */
BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BgL_namez00_25; 
BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BgL_stackz00_26; 
{ 
obj_t BgL_stackz00_1973;
BgL_stackz00_1973 = BgL_stackz00_26; 
BgL_loopz00_1974:
if(
NULLP(BgL_stackz00_1973))
{ /* Ast/sexp.scm 552 */
BGl_za2cachezd2resza2zd2zzast_sexpz00 = BFALSE; 
return BFALSE;}  else 
{ /* Ast/sexp.scm 555 */
bool_t BgL_testz00_5419;
{ /* Ast/sexp.scm 555 */
obj_t BgL_auxz00_5420;
{ /* Ast/sexp.scm 555 */
BgL_localz00_bglt BgL_obj1249z00_3147;
{ /* Ast/sexp.scm 555 */
obj_t BgL_auxz00_5421;
BgL_auxz00_5421 = 
CAR(BgL_stackz00_1973); 
BgL_obj1249z00_3147 = 
(BgL_localz00_bglt)(BgL_auxz00_5421); } 
BgL_auxz00_5420 = 
(((BgL_localz00_bglt)CREF(BgL_obj1249z00_3147))->BgL_idz00); } 
BgL_testz00_5419 = 
(BgL_auxz00_5420==BgL_namez00_25); } 
if(BgL_testz00_5419)
{ /* Ast/sexp.scm 555 */
BGl_za2cachezd2resza2zd2zzast_sexpz00 = 
CAR(BgL_stackz00_1973); 
return 
CAR(BgL_stackz00_1973);}  else 
{ /* Ast/sexp.scm 555 */
{ 
obj_t BgL_stackz00_5428;
BgL_stackz00_5428 = 
CDR(BgL_stackz00_1973); 
BgL_stackz00_1973 = BgL_stackz00_5428; 
goto BgL_loopz00_1974;} } } } } } } 
}



/* use-variable! */
obj_t BGl_usezd2variablez12zc0zzast_sexpz00(BgL_variablez00_bglt BgL_varz00_27, obj_t BgL_locz00_28, obj_t BgL_sitez00_29)
{ AN_OBJECT;
{ /* Ast/sexp.scm 564 */
{ /* Ast/sexp.scm 566 */
bool_t BgL_testz00_5430;
{ /* Ast/sexp.scm 566 */
obj_t BgL_auxz00_5431;
BgL_auxz00_5431 = 
CNST_TABLE_REF(((long)8)); 
BgL_testz00_5430 = 
(BgL_sitez00_29==BgL_auxz00_5431); } 
if(BgL_testz00_5430)
{ /* Ast/sexp.scm 567 */
obj_t BgL_val1108z00_3152;
BgL_val1108z00_3152 = 
CNST_TABLE_REF(((long)29)); 
((((BgL_variablez00_bglt)CREF(BgL_varz00_27))->BgL_accessz00) = ((obj_t)BgL_val1108z00_3152), BUNSPEC); }  else 
{ /* Ast/sexp.scm 566 */BFALSE; } } 
{ /* Ast/sexp.scm 569 */
bool_t BgL_test4080z00_1983;
{ /* Ast/sexp.scm 569 */
bool_t BgL_testz00_5436;
{ /* Ast/sexp.scm 569 */
obj_t BgL_auxz00_5437;
BgL_auxz00_5437 = 
CNST_TABLE_REF(((long)8)); 
BgL_testz00_5436 = 
(BgL_sitez00_29==BgL_auxz00_5437); } 
if(BgL_testz00_5436)
{ /* Ast/sexp.scm 569 */
obj_t BgL_auxz00_5440;
{ /* Ast/sexp.scm 569 */
BgL_valuez00_bglt BgL_auxz00_5441;
BgL_auxz00_5441 = 
(((BgL_variablez00_bglt)CREF(BgL_varz00_27))->BgL_valuez00); 
BgL_auxz00_5440 = 
(obj_t)(BgL_auxz00_5441); } 
BgL_test4080z00_1983 = 
BGl_iszd2azf3z21zz__objectz00(BgL_auxz00_5440, BGl_funz00zzast_varz00); }  else 
{ /* Ast/sexp.scm 569 */
BgL_test4080z00_1983 = ((bool_t)0); } } 
if(BgL_test4080z00_1983)
{ /* Ast/sexp.scm 570 */
obj_t BgL_arg4083z00_1985;
BgL_arg4083z00_1985 = 
BGl_shapez00zztools_shapez00(
(obj_t)(BgL_varz00_27)); 
{ /* Ast/sexp.scm 570 */
BgL_nodez00_bglt BgL_auxz00_5448;
BgL_auxz00_5448 = 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string5123z00zzast_sexpz00, BgL_arg4083z00_1985, BgL_locz00_28); 
return 
(obj_t)(BgL_auxz00_5448);} }  else 
{ /* Ast/sexp.scm 569 */
return BFALSE;} } } 
}



/* _use-variable!4756 */
obj_t BGl__usezd2variablez124756zc0zzast_sexpz00(obj_t BgL_envz00_3942, obj_t BgL_varz00_3943, obj_t BgL_locz00_3944, obj_t BgL_sitez00_3945)
{ AN_OBJECT;
{ /* Ast/sexp.scm 564 */
return 
BGl_usezd2variablez12zc0zzast_sexpz00(
(BgL_variablez00_bglt)(BgL_varz00_3943), BgL_locz00_3944, BgL_sitez00_3945);} 
}



/* error-sexp->node */
BgL_nodez00_bglt BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t BgL_msgz00_30, obj_t BgL_expz00_31, obj_t BgL_locz00_32)
{ AN_OBJECT;
{ /* Ast/sexp.scm 575 */
{ /* Ast/sexp.scm 577 */
obj_t BgL_arg4091z00_1987;BgL_nodez00_bglt BgL_arg4092z00_1988;
{ /* Ast/sexp.scm 577 */
obj_t BgL_arg4097z00_1990;
BgL_arg4097z00_1990 = 
BGl_currentzd2functionzd2zztools_errorz00(); 
BgL_arg4091z00_1987 = 
BGl_shapez00zztools_shapez00(BgL_arg4097z00_1990); } 
BgL_arg4092z00_1988 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(
CNST_TABLE_REF(((long)27)), BNIL, BgL_locz00_32, 
CNST_TABLE_REF(((long)1))); 
{ /* Ast/sexp.scm 576 */
obj_t BgL_list4094z00_1989;
{ /* Ast/sexp.scm 576 */
obj_t BgL_auxz00_5458;
BgL_auxz00_5458 = 
(obj_t)(BgL_arg4092z00_1988); 
BgL_list4094z00_1989 = 
MAKE_PAIR(BgL_auxz00_5458, BNIL); } 
{ /* Ast/sexp.scm 576 */
obj_t BgL_auxz00_5461;
BgL_auxz00_5461 = 
BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_32, BgL_arg4091z00_1987, BgL_msgz00_30, BgL_expz00_31, BgL_list4094z00_1989); 
return 
(BgL_nodez00_bglt)(BgL_auxz00_5461);} } } } 
}



/* _error-sexp->node4758 */
obj_t BGl__errorzd2sexpzd2ze3node4758ze3zzast_sexpz00(obj_t BgL_envz00_3946, obj_t BgL_msgz00_3947, obj_t BgL_expz00_3948, obj_t BgL_locz00_3949)
{ AN_OBJECT;
{ /* Ast/sexp.scm 575 */
{ /* Ast/sexp.scm 577 */
BgL_nodez00_bglt BgL_auxz00_5464;
BgL_auxz00_5464 = 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BgL_msgz00_3947, BgL_expz00_3948, BgL_locz00_3949); 
return 
(obj_t)(BgL_auxz00_5464);} } 
}



/* define-primop-ref->node */
BgL_nodez00_bglt BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt BgL_globalz00_33, BgL_nodez00_bglt BgL_refz00_34)
{ AN_OBJECT;
{ /* Ast/sexp.scm 585 */
{ /* Ast/sexp.scm 586 */
BgL_nodez00_bglt BgL_funz00_1991;
BgL_funz00_1991 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(
CNST_TABLE_REF(((long)30)), BNIL, BFALSE, 
CNST_TABLE_REF(((long)15))); 
{ /* Ast/sexp.scm 587 */
bool_t BgL_test4101z00_1992;
BgL_test4101z00_1992 = 
BGl_iszd2azf3z21zz__objectz00(
(obj_t)(BgL_funz00_1991), BGl_varz00zzast_nodez00); 
if(BgL_test4101z00_1992)
{ /* Ast/sexp.scm 589 */
obj_t BgL_arg4103z00_1993;BgL_nodez00_bglt BgL_arg4105z00_1995;obj_t BgL_arg4106z00_1996;
BgL_arg4103z00_1993 = BGl_za2_za2z00zztype_cachez00; 
BgL_arg4105z00_1995 = BgL_funz00_1991; 
{ /* Ast/sexp.scm 590 */
BgL_nodez00_bglt BgL_arg4109z00_1997;
{ /* Ast/sexp.scm 590 */
obj_t BgL_arg4117z00_2000;obj_t BgL_arg4119z00_2002;
{ /* Ast/sexp.scm 590 */
obj_t BgL_arg4122z00_2003;obj_t BgL_arg4123z00_2004;
BgL_arg4122z00_2003 = 
CNST_TABLE_REF(((long)17)); 
{ /* Ast/sexp.scm 590 */
obj_t BgL_auxz00_5474;
BgL_auxz00_5474 = 
(((BgL_globalz00_bglt)CREF(BgL_globalz00_33))->BgL_idz00); 
BgL_arg4123z00_2004 = 
MAKE_PAIR(BgL_auxz00_5474, BNIL); } 
BgL_arg4117z00_2000 = 
MAKE_PAIR(BgL_arg4122z00_2003, BgL_arg4123z00_2004); } 
BgL_arg4119z00_2002 = 
CNST_TABLE_REF(((long)1)); 
BgL_arg4109z00_1997 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg4117z00_2000, BNIL, BFALSE, BgL_arg4119z00_2002); } 
{ /* Ast/sexp.scm 590 */
obj_t BgL_list4111z00_1998;
{ /* Ast/sexp.scm 590 */
obj_t BgL_arg4113z00_1999;
{ /* Ast/sexp.scm 590 */
obj_t BgL_auxz00_5480;
BgL_auxz00_5480 = 
(obj_t)(BgL_refz00_34); 
BgL_arg4113z00_1999 = 
MAKE_PAIR(BgL_auxz00_5480, BNIL); } 
{ /* Ast/sexp.scm 590 */
obj_t BgL_auxz00_5483;
BgL_auxz00_5483 = 
(obj_t)(BgL_arg4109z00_1997); 
BgL_list4111z00_1998 = 
MAKE_PAIR(BgL_auxz00_5483, BgL_arg4113z00_1999); } } 
BgL_arg4106z00_1996 = BgL_list4111z00_1998; } } 
{ /* Ast/sexp.scm 588 */
BgL_appz00_bglt BgL_res4720z00_3186;
{ /* Ast/sexp.scm 588 */
BgL_typez00_bglt BgL_type1744z00_3160;obj_t BgL_key1746z00_3162;BgL_varz00_bglt BgL_fun1747z00_3163;
BgL_type1744z00_3160 = 
(BgL_typez00_bglt)(BgL_arg4103z00_1993); 
BgL_key1746z00_3162 = 
BINT(((long)-1)); 
BgL_fun1747z00_3163 = 
(BgL_varz00_bglt)(BgL_arg4105z00_1995); 
{ /* Ast/sexp.scm 588 */
BgL_appz00_bglt BgL_new1749z00_3165;
{ /* Ast/sexp.scm 588 */
BgL_appz00_bglt BgL_res4718z00_3171;
{ /* Ast/sexp.scm 588 */
BgL_appz00_bglt BgL_new1751z00_3166;
BgL_new1751z00_3166 = 
((BgL_appz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_appz00_bgl) ))); 
{ /* Ast/sexp.scm 588 */
long BgL_arg4455z00_3167;
BgL_arg4455z00_3167 = 
BGl_classzd2numzd2zz__objectz00(BGl_appz00zzast_nodez00); 
{ /* Ast/sexp.scm 588 */
BgL_objectz00_bglt BgL_auxz00_5491;
BgL_auxz00_5491 = 
(BgL_objectz00_bglt)(BgL_new1751z00_3166); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_5491, BgL_arg4455z00_3167); } } 
{ /* Ast/sexp.scm 588 */
BgL_objectz00_bglt BgL_auxz00_5494;
BgL_auxz00_5494 = 
(BgL_objectz00_bglt)(BgL_new1751z00_3166); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_5494, BFALSE); } 
{ /* Ast/sexp.scm 588 */
obj_t BgL_auxz00_5497;
BgL_auxz00_5497 = 
(obj_t)(BgL_new1751z00_3166); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_5497); } BUNSPEC; 
BgL_res4718z00_3171 = BgL_new1751z00_3166; } 
BgL_new1749z00_3165 = BgL_res4718z00_3171; } 
{ /* Ast/sexp.scm 588 */
BgL_appz00_bglt BgL_res4719z00_3185;
((((BgL_appz00_bglt)CREF(BgL_new1749z00_3165))->BgL_locz00) = ((obj_t)BFALSE), BUNSPEC); 
((((BgL_appz00_bglt)CREF(BgL_new1749z00_3165))->BgL_typez00) = ((BgL_typez00_bglt)BgL_type1744z00_3160), BUNSPEC); 
((((BgL_appz00_bglt)CREF(BgL_new1749z00_3165))->BgL_sidezd2effectzf3z21) = ((obj_t)BUNSPEC), BUNSPEC); 
((((BgL_appz00_bglt)CREF(BgL_new1749z00_3165))->BgL_keyz00) = ((obj_t)BgL_key1746z00_3162), BUNSPEC); 
((((BgL_appz00_bglt)CREF(BgL_new1749z00_3165))->BgL_funz00) = ((BgL_varz00_bglt)BgL_fun1747z00_3163), BUNSPEC); 
((((BgL_appz00_bglt)CREF(BgL_new1749z00_3165))->BgL_argsz00) = ((obj_t)BgL_arg4106z00_1996), BUNSPEC); 
BgL_res4719z00_3185 = BgL_new1749z00_3165; BgL_res4719z00_3185; } 
BgL_res4720z00_3186 = BgL_new1749z00_3165; } } 
return 
(BgL_nodez00_bglt)(BgL_res4720z00_3186);} }  else 
{ /* Ast/sexp.scm 587 */
return BgL_funz00_1991;} } } } 
}



/* _define-primop-ref->node4760 */
obj_t BGl__definezd2primopzd2refzd2ze3node4760z31zzast_sexpz00(obj_t BgL_envz00_3950, obj_t BgL_globalz00_3951, obj_t BgL_refz00_3952)
{ AN_OBJECT;
{ /* Ast/sexp.scm 585 */
{ /* Ast/sexp.scm 586 */
BgL_nodez00_bglt BgL_auxz00_5507;
BgL_auxz00_5507 = 
BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(
(BgL_globalz00_bglt)(BgL_globalz00_3951), 
(BgL_nodez00_bglt)(BgL_refz00_3952)); 
return 
(obj_t)(BgL_auxz00_5507);} } 
}



/* define-primop->node */
BgL_nodez00_bglt BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(BgL_globalz00_bglt BgL_globalz00_35)
{ AN_OBJECT;
{ /* Ast/sexp.scm 600 */
BGl_usezd2variablez12zc0zzast_sexpz00(
(BgL_variablez00_bglt)(BgL_globalz00_35), BFALSE, 
CNST_TABLE_REF(((long)1))); 
{ /* Ast/sexp.scm 602 */
BgL_nodez00_bglt BgL_funz00_2007;
BgL_funz00_2007 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(
CNST_TABLE_REF(((long)31)), BNIL, BFALSE, 
CNST_TABLE_REF(((long)15))); 
{ /* Ast/sexp.scm 603 */
bool_t BgL_test4133z00_2008;
BgL_test4133z00_2008 = 
BGl_iszd2azf3z21zz__objectz00(
(obj_t)(BgL_funz00_2007), BGl_varz00zzast_nodez00); 
if(BgL_test4133z00_2008)
{ /* Ast/sexp.scm 605 */
obj_t BgL_arg4135z00_2009;BgL_nodez00_bglt BgL_arg4137z00_2011;obj_t BgL_arg4138z00_2012;
BgL_arg4135z00_2009 = BGl_za2_za2z00zztype_cachez00; 
BgL_arg4137z00_2011 = BgL_funz00_2007; 
{ /* Ast/sexp.scm 606 */
BgL_nodez00_bglt BgL_arg4141z00_2013;BgL_nodez00_bglt BgL_arg4142z00_2014;
{ /* Ast/sexp.scm 606 */
obj_t BgL_arg4150z00_2017;obj_t BgL_arg4152z00_2019;
{ /* Ast/sexp.scm 606 */
obj_t BgL_arg4155z00_2020;obj_t BgL_arg4156z00_2021;
BgL_arg4155z00_2020 = 
CNST_TABLE_REF(((long)17)); 
{ /* Ast/sexp.scm 606 */
obj_t BgL_auxz00_5522;
BgL_auxz00_5522 = 
(((BgL_globalz00_bglt)CREF(BgL_globalz00_35))->BgL_idz00); 
BgL_arg4156z00_2021 = 
MAKE_PAIR(BgL_auxz00_5522, BNIL); } 
BgL_arg4150z00_2017 = 
MAKE_PAIR(BgL_arg4155z00_2020, BgL_arg4156z00_2021); } 
BgL_arg4152z00_2019 = 
CNST_TABLE_REF(((long)1)); 
BgL_arg4141z00_2013 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg4150z00_2017, BNIL, BFALSE, BgL_arg4152z00_2019); } 
BgL_arg4142z00_2014 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(
(obj_t)(BgL_globalz00_35), BNIL, BFALSE, 
CNST_TABLE_REF(((long)1))); 
{ /* Ast/sexp.scm 606 */
obj_t BgL_list4144z00_2015;
{ /* Ast/sexp.scm 606 */
obj_t BgL_arg4146z00_2016;
{ /* Ast/sexp.scm 606 */
obj_t BgL_auxz00_5531;
BgL_auxz00_5531 = 
(obj_t)(BgL_arg4142z00_2014); 
BgL_arg4146z00_2016 = 
MAKE_PAIR(BgL_auxz00_5531, BNIL); } 
{ /* Ast/sexp.scm 606 */
obj_t BgL_auxz00_5534;
BgL_auxz00_5534 = 
(obj_t)(BgL_arg4141z00_2013); 
BgL_list4144z00_2015 = 
MAKE_PAIR(BgL_auxz00_5534, BgL_arg4146z00_2016); } } 
BgL_arg4138z00_2012 = BgL_list4144z00_2015; } } 
{ /* Ast/sexp.scm 604 */
BgL_appz00_bglt BgL_res4724z00_3218;
{ /* Ast/sexp.scm 604 */
BgL_typez00_bglt BgL_type1744z00_3192;obj_t BgL_key1746z00_3194;BgL_varz00_bglt BgL_fun1747z00_3195;
BgL_type1744z00_3192 = 
(BgL_typez00_bglt)(BgL_arg4135z00_2009); 
BgL_key1746z00_3194 = 
BINT(((long)-1)); 
BgL_fun1747z00_3195 = 
(BgL_varz00_bglt)(BgL_arg4137z00_2011); 
{ /* Ast/sexp.scm 604 */
BgL_appz00_bglt BgL_new1749z00_3197;
{ /* Ast/sexp.scm 604 */
BgL_appz00_bglt BgL_res4722z00_3203;
{ /* Ast/sexp.scm 604 */
BgL_appz00_bglt BgL_new1751z00_3198;
BgL_new1751z00_3198 = 
((BgL_appz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_appz00_bgl) ))); 
{ /* Ast/sexp.scm 604 */
long BgL_arg4455z00_3199;
BgL_arg4455z00_3199 = 
BGl_classzd2numzd2zz__objectz00(BGl_appz00zzast_nodez00); 
{ /* Ast/sexp.scm 604 */
BgL_objectz00_bglt BgL_auxz00_5542;
BgL_auxz00_5542 = 
(BgL_objectz00_bglt)(BgL_new1751z00_3198); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_5542, BgL_arg4455z00_3199); } } 
{ /* Ast/sexp.scm 604 */
BgL_objectz00_bglt BgL_auxz00_5545;
BgL_auxz00_5545 = 
(BgL_objectz00_bglt)(BgL_new1751z00_3198); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_5545, BFALSE); } 
{ /* Ast/sexp.scm 604 */
obj_t BgL_auxz00_5548;
BgL_auxz00_5548 = 
(obj_t)(BgL_new1751z00_3198); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_5548); } BUNSPEC; 
BgL_res4722z00_3203 = BgL_new1751z00_3198; } 
BgL_new1749z00_3197 = BgL_res4722z00_3203; } 
{ /* Ast/sexp.scm 604 */
BgL_appz00_bglt BgL_res4723z00_3217;
((((BgL_appz00_bglt)CREF(BgL_new1749z00_3197))->BgL_locz00) = ((obj_t)BFALSE), BUNSPEC); 
((((BgL_appz00_bglt)CREF(BgL_new1749z00_3197))->BgL_typez00) = ((BgL_typez00_bglt)BgL_type1744z00_3192), BUNSPEC); 
((((BgL_appz00_bglt)CREF(BgL_new1749z00_3197))->BgL_sidezd2effectzf3z21) = ((obj_t)BUNSPEC), BUNSPEC); 
((((BgL_appz00_bglt)CREF(BgL_new1749z00_3197))->BgL_keyz00) = ((obj_t)BgL_key1746z00_3194), BUNSPEC); 
((((BgL_appz00_bglt)CREF(BgL_new1749z00_3197))->BgL_funz00) = ((BgL_varz00_bglt)BgL_fun1747z00_3195), BUNSPEC); 
((((BgL_appz00_bglt)CREF(BgL_new1749z00_3197))->BgL_argsz00) = ((obj_t)BgL_arg4138z00_2012), BUNSPEC); 
BgL_res4723z00_3217 = BgL_new1749z00_3197; BgL_res4723z00_3217; } 
BgL_res4724z00_3218 = BgL_new1749z00_3197; } } 
return 
(BgL_nodez00_bglt)(BgL_res4724z00_3218);} }  else 
{ /* Ast/sexp.scm 603 */
return BgL_funz00_2007;} } } } 
}



/* _define-primop->node4762 */
obj_t BGl__definezd2primopzd2ze3node4762ze3zzast_sexpz00(obj_t BgL_envz00_3953, obj_t BgL_globalz00_3954)
{ AN_OBJECT;
{ /* Ast/sexp.scm 600 */
{ /* Ast/sexp.scm 601 */
BgL_nodez00_bglt BgL_auxz00_5558;
BgL_auxz00_5558 = 
BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(
(BgL_globalz00_bglt)(BgL_globalz00_3954)); 
return 
(obj_t)(BgL_auxz00_5558);} } 
}



/* location->node */
BgL_nodez00_bglt BGl_locationzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt BgL_globalz00_36)
{ AN_OBJECT;
{ /* Ast/sexp.scm 619 */
BGl_usezd2variablez12zc0zzast_sexpz00(
(BgL_variablez00_bglt)(BgL_globalz00_36), BFALSE, 
CNST_TABLE_REF(((long)1))); 
{ /* Ast/sexp.scm 621 */
BgL_nodez00_bglt BgL_funz00_2024;
BgL_funz00_2024 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(
CNST_TABLE_REF(((long)32)), BNIL, BFALSE, 
CNST_TABLE_REF(((long)15))); 
{ /* Ast/sexp.scm 625 */
bool_t BgL_test4167z00_2025;
BgL_test4167z00_2025 = 
BGl_iszd2azf3z21zz__objectz00(
(obj_t)(BgL_funz00_2024), BGl_varz00zzast_nodez00); 
if(BgL_test4167z00_2025)
{ /* Ast/sexp.scm 627 */
obj_t BgL_arg4170z00_2026;BgL_nodez00_bglt BgL_arg4172z00_2028;obj_t BgL_arg4173z00_2029;
BgL_arg4170z00_2026 = BGl_za2_za2z00zztype_cachez00; 
BgL_arg4172z00_2028 = BgL_funz00_2024; 
{ /* Ast/sexp.scm 628 */
BgL_nodez00_bglt BgL_arg4176z00_2030;
BgL_arg4176z00_2030 = 
BGl_sexpzd2ze3nodez31zzast_sexpz00(
(obj_t)(BgL_globalz00_36), BNIL, BFALSE, 
CNST_TABLE_REF(((long)1))); 
{ /* Ast/sexp.scm 628 */
obj_t BgL_list4178z00_2031;
{ /* Ast/sexp.scm 628 */
obj_t BgL_auxz00_5574;
BgL_auxz00_5574 = 
(obj_t)(BgL_arg4176z00_2030); 
BgL_list4178z00_2031 = 
MAKE_PAIR(BgL_auxz00_5574, BNIL); } 
BgL_arg4173z00_2029 = BgL_list4178z00_2031; } } 
{ /* Ast/sexp.scm 626 */
BgL_appz00_bglt BgL_res4728z00_3249;
{ /* Ast/sexp.scm 626 */
BgL_typez00_bglt BgL_type1744z00_3223;obj_t BgL_key1746z00_3225;BgL_varz00_bglt BgL_fun1747z00_3226;
BgL_type1744z00_3223 = 
(BgL_typez00_bglt)(BgL_arg4170z00_2026); 
BgL_key1746z00_3225 = 
BINT(((long)-1)); 
BgL_fun1747z00_3226 = 
(BgL_varz00_bglt)(BgL_arg4172z00_2028); 
{ /* Ast/sexp.scm 626 */
BgL_appz00_bglt BgL_new1749z00_3228;
{ /* Ast/sexp.scm 626 */
BgL_appz00_bglt BgL_res4726z00_3234;
{ /* Ast/sexp.scm 626 */
BgL_appz00_bglt BgL_new1751z00_3229;
BgL_new1751z00_3229 = 
((BgL_appz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_appz00_bgl) ))); 
{ /* Ast/sexp.scm 626 */
long BgL_arg4455z00_3230;
BgL_arg4455z00_3230 = 
BGl_classzd2numzd2zz__objectz00(BGl_appz00zzast_nodez00); 
{ /* Ast/sexp.scm 626 */
BgL_objectz00_bglt BgL_auxz00_5582;
BgL_auxz00_5582 = 
(BgL_objectz00_bglt)(BgL_new1751z00_3229); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_5582, BgL_arg4455z00_3230); } } 
{ /* Ast/sexp.scm 626 */
BgL_objectz00_bglt BgL_auxz00_5585;
BgL_auxz00_5585 = 
(BgL_objectz00_bglt)(BgL_new1751z00_3229); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_5585, BFALSE); } 
{ /* Ast/sexp.scm 626 */
obj_t BgL_auxz00_5588;
BgL_auxz00_5588 = 
(obj_t)(BgL_new1751z00_3229); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_5588); } BUNSPEC; 
BgL_res4726z00_3234 = BgL_new1751z00_3229; } 
BgL_new1749z00_3228 = BgL_res4726z00_3234; } 
{ /* Ast/sexp.scm 626 */
BgL_appz00_bglt BgL_res4727z00_3248;
((((BgL_appz00_bglt)CREF(BgL_new1749z00_3228))->BgL_locz00) = ((obj_t)BFALSE), BUNSPEC); 
((((BgL_appz00_bglt)CREF(BgL_new1749z00_3228))->BgL_typez00) = ((BgL_typez00_bglt)BgL_type1744z00_3223), BUNSPEC); 
((((BgL_appz00_bglt)CREF(BgL_new1749z00_3228))->BgL_sidezd2effectzf3z21) = ((obj_t)BUNSPEC), BUNSPEC); 
((((BgL_appz00_bglt)CREF(BgL_new1749z00_3228))->BgL_keyz00) = ((obj_t)BgL_key1746z00_3225), BUNSPEC); 
((((BgL_appz00_bglt)CREF(BgL_new1749z00_3228))->BgL_funz00) = ((BgL_varz00_bglt)BgL_fun1747z00_3226), BUNSPEC); 
((((BgL_appz00_bglt)CREF(BgL_new1749z00_3228))->BgL_argsz00) = ((obj_t)BgL_arg4173z00_2029), BUNSPEC); 
BgL_res4727z00_3248 = BgL_new1749z00_3228; BgL_res4727z00_3248; } 
BgL_res4728z00_3249 = BgL_new1749z00_3228; } } 
return 
(BgL_nodez00_bglt)(BgL_res4728z00_3249);} }  else 
{ /* Ast/sexp.scm 625 */
return BgL_funz00_2024;} } } } 
}



/* _location->node4764 */
obj_t BGl__locationzd2ze3node4764z31zzast_sexpz00(obj_t BgL_envz00_3955, obj_t BgL_globalz00_3956)
{ AN_OBJECT;
{ /* Ast/sexp.scm 619 */
{ /* Ast/sexp.scm 620 */
BgL_nodez00_bglt BgL_auxz00_5598;
BgL_auxz00_5598 = 
BGl_locationzd2ze3nodez31zzast_sexpz00(
(BgL_globalz00_bglt)(BgL_globalz00_3956)); 
return 
(obj_t)(BgL_auxz00_5598);} } 
}



/* make-anonymous-name */
obj_t BGl_makezd2anonymouszd2namez00zzast_sexpz00(obj_t BgL_locz00_37)
{ AN_OBJECT;
{ /* Ast/sexp.scm 634 */
{ /* Ast/sexp.scm 635 */
bool_t BgL_testz00_5602;
if(
STRUCTP(BgL_locz00_37))
{ /* Ast/sexp.scm 635 */
obj_t BgL_auxz00_5607;obj_t BgL_auxz00_5605;
BgL_auxz00_5607 = 
CNST_TABLE_REF(((long)9)); 
BgL_auxz00_5605 = 
STRUCT_KEY(BgL_locz00_37); 
BgL_testz00_5602 = 
(BgL_auxz00_5605==BgL_auxz00_5607); }  else 
{ /* Ast/sexp.scm 635 */
BgL_testz00_5602 = ((bool_t)0)
; } 
if(BgL_testz00_5602)
{ /* Ast/sexp.scm 636 */
obj_t BgL_filez00_2033;obj_t BgL_linez00_2034;obj_t BgL_basez00_2035;
{ /* Ast/sexp.scm 636 */
int BgL_auxz00_5610;
BgL_auxz00_5610 = 
(int)(((long)0)); 
BgL_filez00_2033 = 
STRUCT_REF(BgL_locz00_37, BgL_auxz00_5610); } 
{ /* Ast/sexp.scm 637 */
int BgL_auxz00_5613;
BgL_auxz00_5613 = 
(int)(((long)2)); 
BgL_linez00_2034 = 
STRUCT_REF(BgL_locz00_37, BgL_auxz00_5613); } 
{ /* Ast/sexp.scm 638 */
obj_t BgL_arg4221z00_2050;
BgL_arg4221z00_2050 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, BGl_string5124z00zzast_sexpz00, BEOA); 
BgL_basez00_2035 = 
SYMBOL_TO_STRING(BgL_arg4221z00_2050); } 
{ /* Ast/sexp.scm 640 */
bool_t BgL_test4184z00_2036;
{ /* Ast/sexp.scm 640 */
long BgL_n1z00_3264;
BgL_n1z00_3264 = 
(long)CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00); 
BgL_test4184z00_2036 = 
(BgL_n1z00_3264>=((long)1)); } 
if(BgL_test4184z00_2036)
{ /* Ast/sexp.scm 640 */
{ /* Ast/sexp.scm 642 */
obj_t BgL_arg4186z00_2037;
{ /* Ast/sexp.scm 642 */
char * BgL_arg4191z00_2040;
BgL_arg4191z00_2040 = 
BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00(BgL_linez00_2034, BNIL); 
{ /* Ast/sexp.scm 642 */
obj_t BgL_list4194z00_2042;
{ /* Ast/sexp.scm 642 */
obj_t BgL_arg4196z00_2043;
{ /* Ast/sexp.scm 642 */
obj_t BgL_arg4199z00_2044;
{ /* Ast/sexp.scm 642 */
obj_t BgL_arg4202z00_2045;
{ /* Ast/sexp.scm 642 */
obj_t BgL_arg4205z00_2046;
{ /* Ast/sexp.scm 642 */
obj_t BgL_arg4208z00_2047;
BgL_arg4208z00_2047 = 
MAKE_PAIR(BGl_string5125z00zzast_sexpz00, BNIL); 
{ /* Ast/sexp.scm 642 */
obj_t BgL_auxz00_5624;
BgL_auxz00_5624 = 
string_to_bstring(BgL_arg4191z00_2040); 
BgL_arg4205z00_2046 = 
MAKE_PAIR(BgL_auxz00_5624, BgL_arg4208z00_2047); } } 
BgL_arg4202z00_2045 = 
MAKE_PAIR(BGl_string5126z00zzast_sexpz00, BgL_arg4205z00_2046); } 
BgL_arg4199z00_2044 = 
MAKE_PAIR(BgL_filez00_2033, BgL_arg4202z00_2045); } 
BgL_arg4196z00_2043 = 
MAKE_PAIR(BGl_string5126z00zzast_sexpz00, BgL_arg4199z00_2044); } 
BgL_list4194z00_2042 = 
MAKE_PAIR(BgL_basez00_2035, BgL_arg4196z00_2043); } 
BgL_arg4186z00_2037 = 
BGl_stringzd2appendzd2zz__r4_strings_6_7z00(BgL_list4194z00_2042); } } 
{ /* Ast/sexp.scm 641 */
char * BgL_auxz00_5632;
BgL_auxz00_5632 = 
BSTRING_TO_STRING(BgL_arg4186z00_2037); 
return 
string_to_symbol(BgL_auxz00_5632);} } }  else 
{ /* Ast/sexp.scm 640 */
{ /* Ast/sexp.scm 646 */
obj_t BgL_arg4214z00_2049;
BgL_arg4214z00_2049 = 
string_append(BgL_basez00_2035, BGl_string5125z00zzast_sexpz00); 
{ /* Ast/sexp.scm 646 */
char * BgL_auxz00_5636;
BgL_auxz00_5636 = 
BSTRING_TO_STRING(BgL_arg4214z00_2049); 
return 
string_to_symbol(BgL_auxz00_5636);} } } } }  else 
{ /* Ast/sexp.scm 647 */
obj_t BgL_arg4225z00_2051;
BgL_arg4225z00_2051 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)33)), BEOA); 
{ /* Ast/sexp.scm 647 */
obj_t BgL_list4228z00_2053;
{ /* Ast/sexp.scm 647 */
obj_t BgL_arg4230z00_2054;
{ /* Ast/sexp.scm 647 */
obj_t BgL_auxz00_5642;
BgL_auxz00_5642 = 
CNST_TABLE_REF(((long)34)); 
BgL_arg4230z00_2054 = 
MAKE_PAIR(BgL_auxz00_5642, BNIL); } 
BgL_list4228z00_2053 = 
MAKE_PAIR(BgL_arg4225z00_2051, BgL_arg4230z00_2054); } 
return 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list4228z00_2053);} } } } 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzast_sexpz00()
{ AN_OBJECT;
{ /* Ast/sexp.scm 14 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzast_sexpz00()
{ AN_OBJECT;
{ /* Ast/sexp.scm 14 */
BGl_modulezd2initializa7ationz75zztools_tracez00(((long)64647), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zztools_errorz00(((long)17886), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zztools_shapez00(((long)30825), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zztools_prognz00(((long)55621), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zztools_locationz00(((long)30714), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zztools_miscz00(((long)63966), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zztools_dssslz00(((long)53421), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19010), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zztype_envz00(((long)25262), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zztype_cachez00(((long)57983), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zztype_typeofz00(((long)34095), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zzengine_paramz00(((long)189840), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zzast_identz00(((long)52188), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zzast_envz00(((long)73271), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)28259), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zzast_nodez00(((long)49436), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zzast_buildz00(((long)23045), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zzast_pragmaz00(((long)40790), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zzast_labelsz00(((long)44282), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zzast_letz00(((long)39525), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zzast_exitz00(((long)5484), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zzast_appz00(((long)62572), "ast_sexp"); 
BGl_modulezd2initializa7ationz75zzast_applyz00(((long)56957), "ast_sexp"); 
return 
BGl_modulezd2initializa7ationz75zzast_privatez00(((long)10040), "ast_sexp");} 
}

