/*===========================================================================*/
/*   (Ast/unit.scm)                                                          */
/*   Bigloo (2.5b)                                                           */
/*   Manuel Serrano (c)       Fri Sep 6 09:43:28 CEST 2002                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_nodez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
} *BgL_nodez00_bglt;

typedef struct BgL_nodezf2effectzf2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
} *BgL_nodezf2effectzf2_bglt;

typedef struct BgL_atomz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_atomz00_bglt;

typedef struct BgL_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_varz00_bglt;

typedef struct BgL_closurez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_closurez00_bglt;

typedef struct BgL_kwotez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_kwotez00_bglt;

typedef struct BgL_sequencez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_nodesz00;
} *BgL_sequencez00_bglt;

typedef struct BgL_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
} *BgL_appz00_bglt;

typedef struct BgL_appzd2lyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_appzd2lyzd2_bglt;

typedef struct BgL_funcallz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_strengthz00;
} *BgL_funcallz00_bglt;

typedef struct BgL_externz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_externz00_bglt;

typedef struct BgL_pragmaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_formatz00;
} *BgL_pragmaz00_bglt;

typedef struct BgL_getfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_getfieldz00_bglt;

typedef struct BgL_setfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_setfieldz00_bglt;

typedef struct BgL_newz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_newz00_bglt;

typedef struct BgL_vallocz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2heapzd2formatz00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_vallocz00_bglt;

typedef struct BgL_vrefz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vrefz00_bglt;

typedef struct BgL_vsetz12z12_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vsetz12z12_bglt;

typedef struct BgL_vlengthz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vlengthz00_bglt;

typedef struct BgL_isaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   struct BgL_typez00_bgl * BgL_classz00;
} *BgL_isaz00_bglt;

typedef struct BgL_castz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_castz00_bglt;

typedef struct BgL_setqz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_setqz00_bglt;

typedef struct BgL_conditionalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   struct BgL_nodez00_bgl * BgL_truez00;
   struct BgL_nodez00_bgl * BgL_falsez00;
} *BgL_conditionalz00_bglt;

typedef struct BgL_failz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_procz00;
   struct BgL_nodez00_bgl * BgL_msgz00;
   struct BgL_nodez00_bgl * BgL_objz00;
} *BgL_failz00_bglt;

typedef struct BgL_selectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   obj_t BgL_clausesz00;
   struct BgL_typez00_bgl * BgL_itemzd2typezd2;
} *BgL_selectz00_bglt;

typedef struct BgL_letzd2funzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_localsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_letzd2funzd2_bglt;

typedef struct BgL_letzd2varzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_bindingsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
   bool_t BgL_removablezf3zf3;
} *BgL_letzd2varzd2_bglt;

typedef struct BgL_setzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_setzd2exzd2itz00_bglt;

typedef struct BgL_jumpzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_exitz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_jumpzd2exzd2itz00_bglt;

typedef struct BgL_makezd2boxzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_makezd2boxzd2_bglt;

typedef struct BgL_boxzd2refzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_varz00;
} *BgL_boxzd2refzd2_bglt;

typedef struct BgL_boxzd2setz12zc0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_boxzd2setz12zc0_bglt;

typedef struct BgL_tclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   struct BgL_globalz00_bgl * BgL_holderz00;
   obj_t BgL_wideningz00;
   long BgL_depthz00;
   bool_t BgL_finalzf3zf3;
   obj_t BgL_constructorz00;
   obj_t BgL_virtualzd2slotszd2numberz00;
   bool_t BgL_abstractzf3zf3;
} *BgL_tclassz00_bglt;

typedef struct BgL_jclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   obj_t BgL_packagez00;
} *BgL_jclassz00_bglt;

typedef struct BgL_ccompz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_producerz00;
   obj_t BgL_consumerz00;
   obj_t BgL_finaliza7erza7;
} *BgL_ccompz00_bglt;


extern obj_t BGl_makezd2methodzd2bodyz00zzobject_methodz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
extern obj_t BGl_idzd2ofzd2idz00zzast_identz00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zzast_unitz00();
static obj_t BGl_toplevelzd2ze3astz31zzast_unitz00(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
static obj_t BGl_declarezd2unitz12zc0zzast_unitz00(obj_t, long);
extern obj_t BGl_stringzd2downcasezd2zz__r4_strings_6_7z00(obj_t);
extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
static obj_t BGl_etazd2expansezd2zzast_unitz00(obj_t, obj_t);
extern obj_t BGl_readz00zz__readerz00(obj_t);
extern bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
extern obj_t BGl_unitzd2ze3defsz31zzast_unitz00(obj_t);
extern BgL_localz00_bglt BGl_makezd2userzd2localzd2svarzd2zzast_localz00(obj_t, BgL_typez00_bglt);
extern bool_t BGl_checkzd2methodzd2definitionz00zzast_glozd2defzd2(obj_t, obj_t, obj_t, obj_t);
extern BgL_globalz00_bglt BGl_defzd2globalzd2sfunzd2nozd2warningz12z12zzast_glozd2defzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl__unitzd2sexpza2zd2addz12zb0zzast_unitz00(obj_t, obj_t, obj_t);
extern bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
extern obj_t BGl_za2moduleza2z00zzmodule_modulez00;
extern obj_t BGl_unitzd2initializa7ersz75zzast_unitz00();
extern obj_t BGl_za2_za2z00zztype_cachez00;
static obj_t BGl_za2unitzd2listza2zd2zzast_unitz00 = BUNSPEC;
extern obj_t BGl_funz00zzast_varz00;
extern obj_t BGl_gensymz00zz__r4_symbols_6_4z00;
extern obj_t BGl_globalz00zzast_varz00;
extern obj_t BGl_findzd2locationzd2zztools_locationz00(obj_t);
extern obj_t BGl_makezd2nzd2protoz00zztools_argsz00(obj_t);
static obj_t BGl_makezd2methodzd2definitionz00zzast_unitz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_dssslzd2findzd2firstzd2formalzd2zztools_dssslz00(obj_t);
extern obj_t BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(obj_t);
extern obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
extern obj_t BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(obj_t);
static obj_t BGl_cnstzd2initzd2zzast_unitz00();
extern obj_t BGl_unitzd2sexpza2zd2addz12zb0zzast_unitz00(obj_t, obj_t);
static obj_t BGl_getzd2globalzd2arityz00zzast_unitz00(obj_t, obj_t, obj_t);
extern obj_t BGl_za2modulezd2clauseza2zd2zzmodule_modulez00;
static obj_t BGl__unitzd2initzd2callsz00zzast_unitz00(obj_t);
extern obj_t BGl_unitzd2initializa7erzd2idza7zzast_unitz00(obj_t);
static obj_t BGl_makezd2sfunzd2definitionz00zzast_unitz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_findzd2globalzd2defsz00zzast_findzd2gdefszd2(obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zzast_unitz00();
static obj_t BGl__unitzd2ze3defsz31zzast_unitz00(obj_t, obj_t);
extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zzast_unitz00();
extern obj_t BGl_unitzd2initzd2callsz00zzast_unitz00();
extern obj_t BGl_modulezd2initializa7ationz75zzast_unitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_findzd2gdefszd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_glozd2defzd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_localz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_genericz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_methodz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_prognz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_argsz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_dssslz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_classz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_includez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
extern obj_t BGl_normaliza7ezd2prognz75zztools_prognz00(obj_t);
extern obj_t BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
extern obj_t BGl_userzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
extern BgL_globalz00_bglt BGl_defzd2globalzd2svarz12z12zzast_glozd2defzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_toplevelza2zd2ze3astz93zzast_unitz00(obj_t, obj_t);
static obj_t BGl__unitzd2initializa7ersz75zzast_unitz00(obj_t);
extern bool_t BGl_userzd2symbolzf3z21zzast_identz00(obj_t);
static obj_t BGl__unitzd2initializa7erzd2idza7zzast_unitz00(obj_t, obj_t);
extern obj_t BGl_checkzd2idzd2zzast_identz00(obj_t, obj_t);
extern obj_t BGl_getzd2toplevelzd2unitz00zzmodule_includez00();
extern BgL_globalz00_bglt BGl_defzd2globalzd2sfunz12z12zzast_glozd2defzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_makezd2svarzd2definitionz00zzast_unitz00(obj_t, obj_t);
extern BgL_localz00_bglt BGl_makezd2localzd2svarz00zzast_localz00(obj_t, BgL_typez00_bglt);
extern obj_t BGl_replacez12z12zztools_miscz00(obj_t, obj_t);
extern obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
static obj_t BGl_makezd2sgfunzd2defaultz00zzast_unitz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern BgL_nodez00_bglt BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t, obj_t, obj_t);
extern obj_t bgl_append2(obj_t, obj_t);
extern obj_t BGl_za2objza2z00zztype_cachez00;
static obj_t BGl_requirezd2initializa7ationz75zzast_unitz00 = BUNSPEC;
static obj_t BGl_normaliza7ezd2prognzf2errorz87zzast_unitz00(obj_t, obj_t, obj_t);
static obj_t BGl_makezd2sgfunzd2definitionz00zzast_unitz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_parsezd2idzd2zzast_identz00(obj_t, obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zzast_unitz00();
extern obj_t BGl_makezd2genericzd2bodyz00zzobject_genericz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_dssslzd2namedzd2constantzf3zf3zztools_dssslz00(obj_t);
extern obj_t BGl_getzd2methodzd2unitz00zzmodule_classz00();
extern obj_t BGl_argsza2zd2ze3argszd2listz41zztools_argsz00(obj_t);
static obj_t __cnst[ 24 ] ;

DEFINE_EXPORT_PROCEDURE( BGl_unitzd2sexpza2zd2addz12zd2envz62zzast_unitz00, BgL_bgl__unitza7d2sexpza7a2za7d2addza712za7b0za7za7ast_unitza7005125z00, BGl__unitzd2sexpza2zd2addz12zb0zzast_unitz00, 0L, 2 );
extern obj_t BGl_userzd2errorzd2envz00zztools_errorz00;
DEFINE_STRING( BGl_string5094z00zzast_unitz00, BgL_bgl_string5094za700za7za7ast_unitza7005126z00, "unit add-generic! sgfun -default quote error now cons* apply define-method define-generic define-inline define begin sifun lambda set! sfun read @ -init cgen snifun ::obj ", 171 );
DEFINE_STRING( BGl_string5093z00zzast_unitz00, BgL_bgl_string5093za700za7za7ast_unitza7005127z00, "Illegal generic definition (first argument missing)", 51 );
DEFINE_STRING( BGl_string5092z00zzast_unitz00, BgL_bgl_string5092za700za7za7ast_unitza7005128z00, "No method for this object", 25 );
DEFINE_STRING( BGl_string5091z00zzast_unitz00, BgL_bgl_string5091za700za7za7ast_unitza7005129z00, "Illegal '() expression", 22 );
DEFINE_STRING( BGl_string5090z00zzast_unitz00, BgL_bgl_string5090za700za7za7ast_unitza7005130z00, "      [", 7 );
DEFINE_STRING( BGl_string5089z00zzast_unitz00, BgL_bgl_string5089za700za7za7ast_unitza7005131z00, "]", 1 );
DEFINE_EXPORT_PROCEDURE( BGl_unitzd2initzd2callszd2envzd2zzast_unitz00, BgL_bgl__unitza7d2initza7d2callsza700za7za7ast_unitza7005132z00, BGl__unitzd2initzd2callsz00zzast_unitz00, 0L, 0 );
DEFINE_EXPORT_PROCEDURE( BGl_unitzd2ze3defszd2envze3zzast_unitz00, BgL_bgl__unitza7d2za7e3defsza731za7za7ast_unitza7005133z00, BGl__unitzd2ze3defsz31zzast_unitz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl_unitzd2initializa7erszd2envza7zzast_unitz00, BgL_bgl__unitza7d2initializa7a7ersza775za7za7ast_unitza7005134z00, BGl__unitzd2initializa7ersz75zzast_unitz00, 0L, 0 );
DEFINE_EXPORT_PROCEDURE( BGl_unitzd2initializa7erzd2idzd2envz75zzast_unitz00, BgL_bgl__unitza7d2initializa7a7erza7d2idza7a7za7za7ast_unitza7005135za7, BGl__unitzd2initializa7erzd2idza7zzast_unitz00, 0L, 1 );



/* module-initialization */
obj_t BGl_modulezd2initializa7ationz75zzast_unitz00(long BgL_checksumz00_3888, char * BgL_fromz00_3889)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzast_unitz00))
{ 
BGl_requirezd2initializa7ationz75zzast_unitz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzast_unitz00(); 
BGl_cnstzd2initzd2zzast_unitz00(); 
BGl_importedzd2moduleszd2initz00zzast_unitz00(); 
BGl_toplevelzd2initzd2zzast_unitz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzast_unitz00()
{ AN_OBJECT;
{ /* Ast/unit.scm 21 */
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "ast_unit"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "ast_unit"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "ast_unit"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "ast_unit"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "ast_unit"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "ast_unit"); 
BGl_modulezd2initializa7ationz75zz__dssslz00(((long)0), "ast_unit"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzast_unitz00()
{ AN_OBJECT;
{ /* Ast/unit.scm 21 */
{ /* Ast/unit.scm 21 */
obj_t BgL_cportz00_3881;
BgL_cportz00_3881 = 
open_input_string(BGl_string5094z00zzast_unitz00); 
{ 
long BgL_iz00_3882;
BgL_iz00_3882 = ((long)23); 
BgL_loopz00_3883:
if(
(BgL_iz00_3882==((long)-1)))
{ /* Ast/unit.scm 21 */
return BUNSPEC;}  else 
{ /* Ast/unit.scm 21 */
{ /* Ast/unit.scm 21 */
obj_t BgL_arg5098z00_3885;
{ /* Ast/unit.scm 21 */
obj_t BgL_list5101z00_3886;
BgL_list5101z00_3886 = 
MAKE_PAIR(BgL_cportz00_3881, BNIL); 
BgL_arg5098z00_3885 = 
BGl_readz00zz__readerz00(BgL_list5101z00_3886); } 
{ /* Ast/unit.scm 21 */
int BgL_auxz00_3909;
BgL_auxz00_3909 = 
(int)(BgL_iz00_3882); 
CNST_TABLE_SET(BgL_auxz00_3909, BgL_arg5098z00_3885); } } 
{ 
long BgL_iz00_3912;
{ /* Ast/unit.scm 21 */
int BgL_auxz00_3913;
{ /* Ast/unit.scm 21 */
long BgL_auxz00_3914;
BgL_auxz00_3914 = 
(BgL_iz00_3882-((long)1)); 
BgL_auxz00_3913 = 
(int)(BgL_auxz00_3914); } 
BgL_iz00_3912 = 
(long)(BgL_auxz00_3913); } 
BgL_iz00_3882 = BgL_iz00_3912; 
goto BgL_loopz00_3883;} } } } } 
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zzast_unitz00()
{ AN_OBJECT;
{ /* Ast/unit.scm 21 */
return ( 
BGl_za2unitzd2listza2zd2zzast_unitz00 = BNIL, BUNSPEC) ;} 
}



/* unit-sexp*-add! */
obj_t BGl_unitzd2sexpza2zd2addz12zb0zzast_unitz00(obj_t BgL_unitz00_19, obj_t BgL_sexpz00_20)
{ AN_OBJECT;
{ /* Ast/unit.scm 56 */
{ /* Ast/unit.scm 57 */
bool_t BgL_testz00_3918;
{ /* Ast/unit.scm 57 */
obj_t BgL_auxz00_3919;
{ /* Ast/unit.scm 57 */
int BgL_auxz00_3920;
BgL_auxz00_3920 = 
(int)(((long)2)); 
BgL_auxz00_3919 = 
STRUCT_REF(BgL_unitz00_19, BgL_auxz00_3920); } 
BgL_testz00_3918 = 
NULLP(BgL_auxz00_3919); } 
if(BgL_testz00_3918)
{ /* Ast/unit.scm 58 */
int BgL_auxz00_3924;
BgL_auxz00_3924 = 
(int)(((long)2)); 
return 
STRUCT_SET(BgL_unitz00_19, BgL_auxz00_3924, BgL_sexpz00_20);}  else 
{ /* Ast/unit.scm 59 */
obj_t BgL_auxz00_3927;
{ /* Ast/unit.scm 59 */
obj_t BgL_auxz00_3928;
{ /* Ast/unit.scm 59 */
int BgL_auxz00_3929;
BgL_auxz00_3929 = 
(int)(((long)2)); 
BgL_auxz00_3928 = 
STRUCT_REF(BgL_unitz00_19, BgL_auxz00_3929); } 
BgL_auxz00_3927 = 
BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(BgL_auxz00_3928); } 
return 
SET_CDR(BgL_auxz00_3927, BgL_sexpz00_20);} } } 
}



/* _unit-sexp*-add! */
obj_t BGl__unitzd2sexpza2zd2addz12zb0zzast_unitz00(obj_t BgL_envz00_3866, obj_t BgL_unitz00_3867, obj_t BgL_sexpz00_3868)
{ AN_OBJECT;
{ /* Ast/unit.scm 56 */
return 
BGl_unitzd2sexpza2zd2addz12zb0zzast_unitz00(BgL_unitz00_3867, BgL_sexpz00_3868);} 
}



/* unit->defs */
obj_t BGl_unitzd2ze3defsz31zzast_unitz00(obj_t BgL_unitz00_21)
{ AN_OBJECT;
{ /* Ast/unit.scm 64 */
{ /* Ast/unit.scm 65 */
obj_t BgL_arg2944z00_1482;
{ /* Ast/unit.scm 66 */
obj_t BgL_arg2959z00_1488;
{ /* Ast/unit.scm 66 */
obj_t BgL_auxz00_3935;
{ /* Ast/unit.scm 66 */
int BgL_auxz00_3936;
BgL_auxz00_3936 = 
(int)(((long)0)); 
BgL_auxz00_3935 = 
STRUCT_REF(BgL_unitz00_21, BgL_auxz00_3936); } 
BgL_arg2959z00_1488 = 
SYMBOL_TO_STRING(BgL_auxz00_3935); } 
BgL_arg2944z00_1482 = 
BGl_stringzd2downcasezd2zz__r4_strings_6_7z00(BgL_arg2959z00_1488); } 
{ /* Ast/unit.scm 65 */
obj_t BgL_list2947z00_1484;
{ /* Ast/unit.scm 65 */
obj_t BgL_arg2949z00_1485;
{ /* Ast/unit.scm 65 */
obj_t BgL_arg2952z00_1486;
{ /* Ast/unit.scm 65 */
obj_t BgL_arg2955z00_1487;
{ /* Ast/unit.scm 65 */
obj_t BgL_auxz00_3941;
BgL_auxz00_3941 = 
BCHAR(((unsigned char)'\n')); 
BgL_arg2955z00_1487 = 
MAKE_PAIR(BgL_auxz00_3941, BNIL); } 
BgL_arg2952z00_1486 = 
MAKE_PAIR(BGl_string5089z00zzast_unitz00, BgL_arg2955z00_1487); } 
BgL_arg2949z00_1485 = 
MAKE_PAIR(BgL_arg2944z00_1482, BgL_arg2952z00_1486); } 
BgL_list2947z00_1484 = 
MAKE_PAIR(BGl_string5090z00zzast_unitz00, BgL_arg2949z00_1485); } 
BGl_verbosez00zztools_speekz00(
BINT(((long)2)), BgL_list2947z00_1484); } } 
{ /* Ast/unit.scm 70 */
obj_t BgL_idz00_1490;obj_t BgL_weightz00_1491;obj_t BgL_sexpza2za2_1492;
{ /* Ast/unit.scm 70 */
int BgL_auxz00_3949;
BgL_auxz00_3949 = 
(int)(((long)0)); 
BgL_idz00_1490 = 
STRUCT_REF(BgL_unitz00_21, BgL_auxz00_3949); } 
{ /* Ast/unit.scm 71 */
int BgL_auxz00_3952;
BgL_auxz00_3952 = 
(int)(((long)1)); 
BgL_weightz00_1491 = 
STRUCT_REF(BgL_unitz00_21, BgL_auxz00_3952); } 
{ /* Ast/unit.scm 72 */
int BgL_auxz00_3955;
BgL_auxz00_3955 = 
(int)(((long)2)); 
BgL_sexpza2za2_1492 = 
STRUCT_REF(BgL_unitz00_21, BgL_auxz00_3955); } 
{ 
obj_t BgL_aexpza2za2_1493;obj_t BgL_initza2za2_1494;obj_t BgL_defza2za2_1495;
{ /* Ast/unit.scm 74 */
obj_t BgL_arg2966z00_1497;
if(
PROCEDUREP(BgL_sexpza2za2_1492))
{ /* Ast/unit.scm 74 */
BgL_arg2966z00_1497 = 
PROCEDURE_ENTRY(BgL_sexpza2za2_1492)(BgL_sexpza2za2_1492, BEOA); }  else 
{ /* Ast/unit.scm 76 */
obj_t BgL_arg2973z00_1501;
BgL_arg2973z00_1501 = 
BGl_findzd2globalzd2defsz00zzast_findzd2gdefszd2(BgL_sexpza2za2_1492); 
BgL_arg2966z00_1497 = 
BGl_toplevelza2zd2ze3astz93zzast_unitz00(BgL_sexpza2za2_1492, BgL_arg2973z00_1501); } 
BgL_aexpza2za2_1493 = BgL_arg2966z00_1497; 
BgL_initza2za2_1494 = BNIL; 
BgL_defza2za2_1495 = BNIL; 
BgL_loopz00_1496:
if(
NULLP(BgL_aexpza2za2_1493))
{ /* Ast/unit.scm 79 */
if(
PAIRP(BgL_initza2za2_1494))
{ /* Ast/unit.scm 81 */
BgL_globalz00_bglt BgL_initz00_1504;
{ /* Ast/unit.scm 82 */
obj_t BgL_arg2993z00_1508;obj_t BgL_arg2996z00_1511;obj_t BgL_arg2997z00_1512;obj_t BgL_arg2998z00_1513;
{ /* Ast/unit.scm 82 */
obj_t BgL_arg3001z00_1514;obj_t BgL_arg3002z00_1515;
BgL_arg3001z00_1514 = 
BGl_unitzd2initializa7erzd2idza7zzast_unitz00(BgL_idz00_1490); 
BgL_arg3002z00_1515 = 
CNST_TABLE_REF(((long)0)); 
{ /* Ast/unit.scm 82 */
obj_t BgL_list3004z00_1516;
{ /* Ast/unit.scm 82 */
obj_t BgL_arg3006z00_1517;
BgL_arg3006z00_1517 = 
MAKE_PAIR(BgL_arg3002z00_1515, BNIL); 
BgL_list3004z00_1516 = 
MAKE_PAIR(BgL_arg3001z00_1514, BgL_arg3006z00_1517); } 
BgL_arg2993z00_1508 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list3004z00_1516); } } 
BgL_arg2996z00_1511 = 
CNST_TABLE_REF(((long)1)); 
BgL_arg2997z00_1512 = 
CNST_TABLE_REF(((long)2)); 
{ /* Ast/unit.scm 89 */
obj_t BgL_arg3011z00_1518;
BgL_arg3011z00_1518 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_initza2za2_1494); 
BgL_arg2998z00_1513 = 
BGl_normaliza7ezd2prognz75zztools_prognz00(BgL_arg3011z00_1518); } 
BgL_initz00_1504 = 
BGl_defzd2globalzd2sfunzd2nozd2warningz12z12zzast_glozd2defzd2(BgL_arg2993z00_1508, BNIL, BNIL, BGl_za2moduleza2z00zzmodule_modulez00, BgL_arg2996z00_1511, BGl_za2modulezd2clauseza2zd2zzmodule_modulez00, BgL_arg2997z00_1512, BgL_arg2998z00_1513); } 
{ /* Ast/unit.scm 92 */
bool_t BgL_test2979z00_1505;
{ /* Ast/unit.scm 92 */
obj_t BgL_arg2983z00_1506;
BgL_arg2983z00_1506 = 
BGl_getzd2toplevelzd2unitz00zzmodule_includez00(); 
BgL_test2979z00_1505 = 
(BgL_unitz00_21==BgL_arg2983z00_1506); } 
if(BgL_test2979z00_1505)
{ /* Ast/unit.scm 92 */BFALSE; }  else 
{ /* Ast/unit.scm 92 */
((((BgL_globalz00_bglt)CREF(BgL_initz00_1504))->BgL_userzf3zf3) = ((bool_t)((bool_t)0)), BUNSPEC); } } 
BGl_declarezd2unitz12zc0zzast_unitz00(BgL_idz00_1490, 
(long)CINT(BgL_weightz00_1491)); 
((((BgL_globalz00_bglt)CREF(BgL_initz00_1504))->BgL_evaluablezf3zf3) = ((bool_t)((bool_t)0)), BUNSPEC); 
{ /* Ast/unit.scm 102 */
obj_t BgL_arg2989z00_1507;
BgL_arg2989z00_1507 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_defza2za2_1495); 
{ /* Ast/unit.scm 102 */
obj_t BgL_auxz00_3986;
BgL_auxz00_3986 = 
(obj_t)(BgL_initz00_1504); 
return 
MAKE_PAIR(BgL_auxz00_3986, BgL_arg2989z00_1507);} } }  else 
{ /* Ast/unit.scm 80 */
return 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_defza2za2_1495);} }  else 
{ /* Ast/unit.scm 104 */
bool_t BgL_test3016z00_1519;
BgL_test3016z00_1519 = 
BGl_iszd2azf3z21zz__objectz00(
CAR(BgL_aexpza2za2_1493), BGl_globalz00zzast_varz00); 
if(BgL_test3016z00_1519)
{ /* Ast/unit.scm 105 */
obj_t BgL_arg3018z00_1520;obj_t BgL_arg3019z00_1521;
BgL_arg3018z00_1520 = 
CDR(BgL_aexpza2za2_1493); 
{ /* Ast/unit.scm 107 */
obj_t BgL_auxz00_3994;
BgL_auxz00_3994 = 
CAR(BgL_aexpza2za2_1493); 
BgL_arg3019z00_1521 = 
MAKE_PAIR(BgL_auxz00_3994, BgL_defza2za2_1495); } 
{ 
obj_t BgL_defza2za2_3998;obj_t BgL_aexpza2za2_3997;
BgL_aexpza2za2_3997 = BgL_arg3018z00_1520; 
BgL_defza2za2_3998 = BgL_arg3019z00_1521; 
BgL_defza2za2_1495 = BgL_defza2za2_3998; 
BgL_aexpza2za2_1493 = BgL_aexpza2za2_3997; 
goto BgL_loopz00_1496;} }  else 
{ /* Ast/unit.scm 108 */
obj_t BgL_arg3027z00_1523;obj_t BgL_arg3028z00_1524;
BgL_arg3027z00_1523 = 
CDR(BgL_aexpza2za2_1493); 
{ /* Ast/unit.scm 109 */
obj_t BgL_auxz00_4000;
BgL_auxz00_4000 = 
CAR(BgL_aexpza2za2_1493); 
BgL_arg3028z00_1524 = 
MAKE_PAIR(BgL_auxz00_4000, BgL_initza2za2_1494); } 
{ 
obj_t BgL_initza2za2_4004;obj_t BgL_aexpza2za2_4003;
BgL_aexpza2za2_4003 = BgL_arg3027z00_1523; 
BgL_initza2za2_4004 = BgL_arg3028z00_1524; 
BgL_initza2za2_1494 = BgL_initza2za2_4004; 
BgL_aexpza2za2_1493 = BgL_aexpza2za2_4003; 
goto BgL_loopz00_1496;} } } } } } } 
}



/* _unit->defs */
obj_t BGl__unitzd2ze3defsz31zzast_unitz00(obj_t BgL_envz00_3869, obj_t BgL_unitz00_3870)
{ AN_OBJECT;
{ /* Ast/unit.scm 64 */
return 
BGl_unitzd2ze3defsz31zzast_unitz00(BgL_unitz00_3870);} 
}



/* declare-unit! */
obj_t BGl_declarezd2unitz12zc0zzast_unitz00(obj_t BgL_idz00_22, long BgL_weightz00_23)
{ AN_OBJECT;
{ /* Ast/unit.scm 120 */
{ /* Ast/unit.scm 121 */
bool_t BgL_test3043z00_1527;
{ /* Ast/unit.scm 121 */
bool_t BgL_test3088z00_1544;
{ /* Ast/unit.scm 121 */
obj_t BgL_objz00_2762;
BgL_objz00_2762 = BGl_za2unitzd2listza2zd2zzast_unitz00; 
BgL_test3088z00_1544 = 
NULLP(BgL_objz00_2762); } 
if(BgL_test3088z00_1544)
{ /* Ast/unit.scm 121 */
BgL_test3043z00_1527 = ((bool_t)1); }  else 
{ /* Ast/unit.scm 121 */
obj_t BgL_arg3090z00_1545;
{ /* Ast/unit.scm 121 */
obj_t BgL_arg3093z00_1546;
{ /* Ast/unit.scm 121 */
obj_t BgL_pairz00_2763;
BgL_pairz00_2763 = BGl_za2unitzd2listza2zd2zzast_unitz00; 
BgL_arg3093z00_1546 = 
CAR(BgL_pairz00_2763); } 
BgL_arg3090z00_1545 = 
CDR(BgL_arg3093z00_1546); } 
{ /* Ast/unit.scm 121 */
long BgL_auxz00_4010;
BgL_auxz00_4010 = 
(long)CINT(BgL_arg3090z00_1545); 
BgL_test3043z00_1527 = 
(BgL_weightz00_23<BgL_auxz00_4010); } } } 
if(BgL_test3043z00_1527)
{ /* Ast/unit.scm 122 */
obj_t BgL_arg3045z00_1528;
{ /* Ast/unit.scm 122 */
obj_t BgL_auxz00_4014;
BgL_auxz00_4014 = 
BINT(BgL_weightz00_23); 
BgL_arg3045z00_1528 = 
MAKE_PAIR(BgL_idz00_22, BgL_auxz00_4014); } 
return ( 
BGl_za2unitzd2listza2zd2zzast_unitz00 = 
MAKE_PAIR(BgL_arg3045z00_1528, BGl_za2unitzd2listza2zd2zzast_unitz00), BUNSPEC) ;}  else 
{ 
obj_t BgL_ulistz00_1529;
BgL_ulistz00_1529 = BGl_za2unitzd2listza2zd2zzast_unitz00; 
BgL_loopz00_1530:
{ /* Ast/unit.scm 125 */
bool_t BgL_testz00_4018;
{ /* Ast/unit.scm 125 */
long BgL_auxz00_4019;
{ /* Ast/unit.scm 125 */
obj_t BgL_auxz00_4020;
{ /* Ast/unit.scm 125 */
obj_t BgL_auxz00_4021;
BgL_auxz00_4021 = 
CAR(BgL_ulistz00_1529); 
BgL_auxz00_4020 = 
CDR(BgL_auxz00_4021); } 
BgL_auxz00_4019 = 
(long)CINT(BgL_auxz00_4020); } 
BgL_testz00_4018 = 
(BgL_weightz00_23<BgL_auxz00_4019); } 
if(BgL_testz00_4018)
{ /* Ast/unit.scm 125 */
{ /* Ast/unit.scm 126 */
obj_t BgL_arg3051z00_1532;
{ /* Ast/unit.scm 126 */
obj_t BgL_auxz00_4028;obj_t BgL_auxz00_4026;
BgL_auxz00_4028 = 
CDR(BgL_ulistz00_1529); 
BgL_auxz00_4026 = 
CAR(BgL_ulistz00_1529); 
BgL_arg3051z00_1532 = 
MAKE_PAIR(BgL_auxz00_4026, BgL_auxz00_4028); } 
SET_CDR(BgL_ulistz00_1529, BgL_arg3051z00_1532); } 
{ /* Ast/unit.scm 127 */
obj_t BgL_arg3060z00_1535;
{ /* Ast/unit.scm 127 */
obj_t BgL_auxz00_4032;
BgL_auxz00_4032 = 
BINT(BgL_weightz00_23); 
BgL_arg3060z00_1535 = 
MAKE_PAIR(BgL_idz00_22, BgL_auxz00_4032); } 
return 
SET_CAR(BgL_ulistz00_1529, BgL_arg3060z00_1535);} }  else 
{ /* Ast/unit.scm 128 */
bool_t BgL_testz00_4036;
{ /* Ast/unit.scm 128 */
obj_t BgL_auxz00_4037;
BgL_auxz00_4037 = 
CDR(BgL_ulistz00_1529); 
BgL_testz00_4036 = 
NULLP(BgL_auxz00_4037); } 
if(BgL_testz00_4036)
{ /* Ast/unit.scm 128 */
{ /* Ast/unit.scm 129 */
obj_t BgL_arg3065z00_1537;
{ /* Ast/unit.scm 129 */
obj_t BgL_arg3068z00_1538;
{ /* Ast/unit.scm 129 */
obj_t BgL_auxz00_4040;
BgL_auxz00_4040 = 
BINT(BgL_weightz00_23); 
BgL_arg3068z00_1538 = 
MAKE_PAIR(BgL_idz00_22, BgL_auxz00_4040); } 
{ /* Ast/unit.scm 129 */
obj_t BgL_list3070z00_1539;
BgL_list3070z00_1539 = 
MAKE_PAIR(BgL_arg3068z00_1538, BNIL); 
BgL_arg3065z00_1537 = BgL_list3070z00_1539; } } 
return 
SET_CDR(BgL_ulistz00_1529, BgL_arg3065z00_1537);} }  else 
{ /* Ast/unit.scm 128 */
{ 
obj_t BgL_ulistz00_4045;
BgL_ulistz00_4045 = 
CDR(BgL_ulistz00_1529); 
BgL_ulistz00_1529 = BgL_ulistz00_4045; 
goto BgL_loopz00_1530;} } } } } } } 
}



/* unit-initializer-id */
obj_t BGl_unitzd2initializa7erzd2idza7zzast_unitz00(obj_t BgL_idz00_24)
{ AN_OBJECT;
{ /* Ast/unit.scm 136 */
{ /* Ast/unit.scm 137 */
obj_t BgL_list3098z00_1547;
{ /* Ast/unit.scm 137 */
obj_t BgL_arg3100z00_1548;
{ /* Ast/unit.scm 137 */
obj_t BgL_auxz00_4047;
BgL_auxz00_4047 = 
CNST_TABLE_REF(((long)3)); 
BgL_arg3100z00_1548 = 
MAKE_PAIR(BgL_auxz00_4047, BNIL); } 
BgL_list3098z00_1547 = 
MAKE_PAIR(BgL_idz00_24, BgL_arg3100z00_1548); } 
return 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list3098z00_1547);} } 
}



/* _unit-initializer-id */
obj_t BGl__unitzd2initializa7erzd2idza7zzast_unitz00(obj_t BgL_envz00_3871, obj_t BgL_idz00_3872)
{ AN_OBJECT;
{ /* Ast/unit.scm 136 */
return 
BGl_unitzd2initializa7erzd2idza7zzast_unitz00(BgL_idz00_3872);} 
}



/* unit-initializers */
obj_t BGl_unitzd2initializa7ersz75zzast_unitz00()
{ AN_OBJECT;
{ /* Ast/unit.scm 142 */
{ /* Ast/unit.scm 143 */
obj_t BgL_l2879z00_1549;
BgL_l2879z00_1549 = BGl_za2unitzd2listza2zd2zzast_unitz00; 
if(
NULLP(BgL_l2879z00_1549))
{ /* Ast/unit.scm 143 */
return BNIL;}  else 
{ /* Ast/unit.scm 143 */
obj_t BgL_head2881z00_1551;
BgL_head2881z00_1551 = 
MAKE_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l2879z00_1552;obj_t BgL_tail2882z00_1553;
BgL_l2879z00_1552 = BgL_l2879z00_1549; 
BgL_tail2882z00_1553 = BgL_head2881z00_1551; 
BgL_lname2880z00_1554:
if(
NULLP(BgL_l2879z00_1552))
{ /* Ast/unit.scm 143 */
return 
CDR(BgL_head2881z00_1551);}  else 
{ /* Ast/unit.scm 144 */
obj_t BgL_newtail2883z00_1556;
{ /* Ast/unit.scm 144 */
obj_t BgL_arg3113z00_1558;
{ /* Ast/unit.scm 144 */
obj_t BgL_arg3117z00_1561;
{ /* Ast/unit.scm 144 */
obj_t BgL_auxz00_4059;
{ /* Ast/unit.scm 144 */
obj_t BgL_auxz00_4060;
BgL_auxz00_4060 = 
CAR(BgL_l2879z00_1552); 
BgL_auxz00_4059 = 
CAR(BgL_auxz00_4060); } 
BgL_arg3117z00_1561 = 
BGl_unitzd2initializa7erzd2idza7zzast_unitz00(BgL_auxz00_4059); } 
BgL_arg3113z00_1558 = 
BGl_findzd2globalzf2modulez20zzast_envz00(BgL_arg3117z00_1561, BGl_za2moduleza2z00zzmodule_modulez00); } 
BgL_newtail2883z00_1556 = 
MAKE_PAIR(BgL_arg3113z00_1558, BNIL); } 
SET_CDR(BgL_tail2882z00_1553, BgL_newtail2883z00_1556); 
{ 
obj_t BgL_tail2882z00_4069;obj_t BgL_l2879z00_4067;
BgL_l2879z00_4067 = 
CDR(BgL_l2879z00_1552); 
BgL_tail2882z00_4069 = BgL_newtail2883z00_1556; 
BgL_tail2882z00_1553 = BgL_tail2882z00_4069; 
BgL_l2879z00_1552 = BgL_l2879z00_4067; 
goto BgL_lname2880z00_1554;} } } } } } 
}



/* _unit-initializers */
obj_t BGl__unitzd2initializa7ersz75zzast_unitz00(obj_t BgL_envz00_3873)
{ AN_OBJECT;
{ /* Ast/unit.scm 142 */
return 
BGl_unitzd2initializa7ersz75zzast_unitz00();} 
}



/* unit-init-calls */
obj_t BGl_unitzd2initzd2callsz00zzast_unitz00()
{ AN_OBJECT;
{ /* Ast/unit.scm 150 */
{ /* Ast/unit.scm 151 */
obj_t BgL_l2884z00_1563;
BgL_l2884z00_1563 = BGl_za2unitzd2listza2zd2zzast_unitz00; 
if(
NULLP(BgL_l2884z00_1563))
{ /* Ast/unit.scm 151 */
return BNIL;}  else 
{ /* Ast/unit.scm 151 */
obj_t BgL_head2886z00_1565;
BgL_head2886z00_1565 = 
MAKE_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l2884z00_1566;obj_t BgL_tail2887z00_1567;
BgL_l2884z00_1566 = BgL_l2884z00_1563; 
BgL_tail2887z00_1567 = BgL_head2886z00_1565; 
BgL_lname2885z00_1568:
if(
NULLP(BgL_l2884z00_1566))
{ /* Ast/unit.scm 151 */
return 
CDR(BgL_head2886z00_1565);}  else 
{ /* Ast/unit.scm 151 */
obj_t BgL_newtail2888z00_1570;
{ /* Ast/unit.scm 151 */
obj_t BgL_arg3137z00_1572;
{ /* Ast/unit.scm 151 */
obj_t BgL_arg3141z00_1575;
{ /* Ast/unit.scm 151 */
obj_t BgL_arg3145z00_1577;obj_t BgL_arg3146z00_1578;
BgL_arg3145z00_1577 = 
CNST_TABLE_REF(((long)4)); 
{ /* Ast/unit.scm 151 */
obj_t BgL_arg3149z00_1579;obj_t BgL_arg3150z00_1580;
{ /* Ast/unit.scm 151 */
obj_t BgL_auxz00_4078;
{ /* Ast/unit.scm 151 */
obj_t BgL_auxz00_4079;
BgL_auxz00_4079 = 
CAR(BgL_l2884z00_1566); 
BgL_auxz00_4078 = 
CAR(BgL_auxz00_4079); } 
BgL_arg3149z00_1579 = 
BGl_unitzd2initializa7erzd2idza7zzast_unitz00(BgL_auxz00_4078); } 
BgL_arg3150z00_1580 = 
MAKE_PAIR(BGl_za2moduleza2z00zzmodule_modulez00, BNIL); 
BgL_arg3146z00_1578 = 
MAKE_PAIR(BgL_arg3149z00_1579, BgL_arg3150z00_1580); } 
BgL_arg3141z00_1575 = 
MAKE_PAIR(BgL_arg3145z00_1577, BgL_arg3146z00_1578); } 
BgL_arg3137z00_1572 = 
MAKE_PAIR(BgL_arg3141z00_1575, BNIL); } 
BgL_newtail2888z00_1570 = 
MAKE_PAIR(BgL_arg3137z00_1572, BNIL); } 
SET_CDR(BgL_tail2887z00_1567, BgL_newtail2888z00_1570); 
{ 
obj_t BgL_tail2887z00_4091;obj_t BgL_l2884z00_4089;
BgL_l2884z00_4089 = 
CDR(BgL_l2884z00_1566); 
BgL_tail2887z00_4091 = BgL_newtail2888z00_1570; 
BgL_tail2887z00_1567 = BgL_tail2887z00_4091; 
BgL_l2884z00_1566 = BgL_l2884z00_4089; 
goto BgL_lname2885z00_1568;} } } } } } 
}



/* _unit-init-calls */
obj_t BGl__unitzd2initzd2callsz00zzast_unitz00(obj_t BgL_envz00_3874)
{ AN_OBJECT;
{ /* Ast/unit.scm 150 */
return 
BGl_unitzd2initzd2callsz00zzast_unitz00();} 
}



/* toplevel*->ast */
obj_t BGl_toplevelza2zd2ze3astz93zzast_unitz00(obj_t BgL_sexpza2za2_25, obj_t BgL_gdefsz00_26)
{ AN_OBJECT;
{ /* Ast/unit.scm 157 */
{ 
obj_t BgL_sexpza2za2_1582;obj_t BgL_aexpza2za2_1583;
BgL_sexpza2za2_1582 = BgL_sexpza2za2_25; 
BgL_aexpza2za2_1583 = BNIL; 
BgL_loopz00_1584:
if(
NULLP(BgL_sexpza2za2_1582))
{ /* Ast/unit.scm 160 */
return 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_aexpza2za2_1583);}  else 
{ /* Ast/unit.scm 162 */
obj_t BgL_arg3165z00_1586;obj_t BgL_arg3166z00_1587;
BgL_arg3165z00_1586 = 
CDR(BgL_sexpza2za2_1582); 
{ /* Ast/unit.scm 163 */
obj_t BgL_arg3171z00_1588;
BgL_arg3171z00_1588 = 
BGl_toplevelzd2ze3astz31zzast_unitz00(
CAR(BgL_sexpza2za2_1582), BgL_gdefsz00_26); 
BgL_arg3166z00_1587 = 
bgl_append2(BgL_arg3171z00_1588, BgL_aexpza2za2_1583); } 
{ 
obj_t BgL_aexpza2za2_4101;obj_t BgL_sexpza2za2_4100;
BgL_sexpza2za2_4100 = BgL_arg3165z00_1586; 
BgL_aexpza2za2_4101 = BgL_arg3166z00_1587; 
BgL_aexpza2za2_1583 = BgL_aexpza2za2_4101; 
BgL_sexpza2za2_1582 = BgL_sexpza2za2_4100; 
goto BgL_loopz00_1584;} } } } 
}



/* toplevel->ast */
obj_t BGl_toplevelzd2ze3astz31zzast_unitz00(obj_t BgL_sexpz00_27, obj_t BgL_gdefsz00_28)
{ AN_OBJECT;
{ /* Ast/unit.scm 170 */
BGl_toplevelzd2ze3astz31zzast_unitz00:
{ 
obj_t BgL_varz00_1619;obj_t BgL_argsz00_1620;obj_t BgL_expz00_1621;obj_t BgL_varz00_1607;obj_t BgL_var2z00_1608;obj_t BgL_modulez00_1609;obj_t BgL_varz00_1604;obj_t BgL_var2z00_1605;obj_t BgL_varz00_1597;obj_t BgL_argsz00_1598;obj_t BgL_expz00_1599;obj_t BgL_varz00_1593;obj_t BgL_argsz00_1594;obj_t BgL_expz00_1595;
if(
PAIRP(BgL_sexpz00_27))
{ /* Ast/unit.scm 171 */
bool_t BgL_testz00_4104;
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4107;obj_t BgL_auxz00_4105;
BgL_auxz00_4107 = 
CNST_TABLE_REF(((long)10)); 
BgL_auxz00_4105 = 
CAR(BgL_sexpz00_27); 
BgL_testz00_4104 = 
(BgL_auxz00_4105==BgL_auxz00_4107); } 
if(BgL_testz00_4104)
{ /* Ast/unit.scm 171 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_sexpz00_27), BNIL))
{ /* Ast/unit.scm 171 */
{ /* Ast/unit.scm 173 */
obj_t BgL_list3742z00_1912;
BgL_list3742z00_1912 = 
MAKE_PAIR(BgL_sexpz00_27, BNIL); 
return BgL_list3742z00_1912;} }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_arg3745z00_2816;
BgL_arg3745z00_2816 = 
BGl_toplevelza2zd2ze3astz93zzast_unitz00(
CDR(BgL_sexpz00_27), BgL_gdefsz00_28); 
return 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_arg3745z00_2816);} }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd2173zd2_1644;
BgL_cdrzd2173zd2_1644 = 
CDR(BgL_sexpz00_27); 
{ /* Ast/unit.scm 171 */
bool_t BgL_testz00_4118;
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4121;obj_t BgL_auxz00_4119;
BgL_auxz00_4121 = 
CNST_TABLE_REF(((long)11)); 
BgL_auxz00_4119 = 
CAR(BgL_sexpz00_27); 
BgL_testz00_4118 = 
(BgL_auxz00_4119==BgL_auxz00_4121); } 
if(BgL_testz00_4118)
{ /* Ast/unit.scm 171 */
if(
PAIRP(BgL_cdrzd2173zd2_1644))
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd2177zd2_1647;
BgL_carzd2177zd2_1647 = 
CAR(BgL_cdrzd2173zd2_1644); 
if(
PAIRP(BgL_carzd2177zd2_1647))
{ /* Ast/unit.scm 171 */
BgL_varz00_1593 = 
CAR(BgL_carzd2177zd2_1647); 
BgL_argsz00_1594 = 
CDR(BgL_carzd2177zd2_1647); 
BgL_expz00_1595 = 
CDR(BgL_cdrzd2173zd2_1644); 
{ /* Ast/unit.scm 177 */
obj_t BgL_idz00_1914;
{ /* Ast/unit.scm 177 */
obj_t BgL_arg3803z00_1940;
BgL_arg3803z00_1940 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_sexpz00_27); 
BgL_idz00_1914 = 
BGl_idzd2ofzd2idz00zzast_identz00(BgL_varz00_1593, BgL_arg3803z00_1940); } 
{ /* Ast/unit.scm 177 */
obj_t BgL_defz00_1915;
BgL_defz00_1915 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_idz00_1914, BgL_gdefsz00_28); 
{ /* Ast/unit.scm 178 */
obj_t BgL_globalz00_1916;
BgL_globalz00_1916 = 
BGl_findzd2globalzf2modulez20zzast_envz00(BgL_idz00_1914, BGl_za2moduleza2z00zzmodule_modulez00); 
{ /* Ast/unit.scm 179 */

{ /* Ast/unit.scm 187 */
bool_t BgL_test3748z00_1917;
if(
PAIRP(BgL_defz00_1915))
{ /* Ast/unit.scm 188 */
bool_t BgL_testz00_4135;
{ /* Ast/unit.scm 188 */
obj_t BgL_auxz00_4140;obj_t BgL_auxz00_4136;
BgL_auxz00_4140 = 
CNST_TABLE_REF(((long)5)); 
{ /* Ast/unit.scm 188 */
obj_t BgL_auxz00_4137;
BgL_auxz00_4137 = 
CDR(BgL_defz00_1915); 
BgL_auxz00_4136 = 
CAR(BgL_auxz00_4137); } 
BgL_testz00_4135 = 
(BgL_auxz00_4136==BgL_auxz00_4140); } 
if(BgL_testz00_4135)
{ /* Ast/unit.scm 189 */
bool_t BgL__ortest_2890z00_1933;
{ /* Ast/unit.scm 189 */
bool_t BgL_test3789z00_1936;
BgL_test3789z00_1936 = 
BGl_iszd2azf3z21zz__objectz00(BgL_globalz00_1916, BGl_globalz00zzast_varz00); 
if(BgL_test3789z00_1936)
{ /* Ast/unit.scm 189 */
BgL__ortest_2890z00_1933 = ((bool_t)0); }  else 
{ /* Ast/unit.scm 189 */
BgL__ortest_2890z00_1933 = ((bool_t)1); } } 
if(BgL__ortest_2890z00_1933)
{ /* Ast/unit.scm 189 */
BgL_test3748z00_1917 = BgL__ortest_2890z00_1933; }  else 
{ /* Ast/unit.scm 190 */
obj_t BgL_auxz00_4149;obj_t BgL_auxz00_4146;
BgL_auxz00_4149 = 
CNST_TABLE_REF(((long)5)); 
{ /* Ast/unit.scm 190 */
BgL_globalz00_bglt BgL_obj1159z00_3136;
BgL_obj1159z00_3136 = 
(BgL_globalz00_bglt)(BgL_globalz00_1916); 
BgL_auxz00_4146 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1159z00_3136))->BgL_accessz00); } 
BgL_test3748z00_1917 = 
(BgL_auxz00_4146==BgL_auxz00_4149); } }  else 
{ /* Ast/unit.scm 188 */
BgL_test3748z00_1917 = ((bool_t)0); } }  else 
{ /* Ast/unit.scm 187 */
BgL_test3748z00_1917 = ((bool_t)1); } 
if(BgL_test3748z00_1917)
{ /* Ast/unit.scm 197 */
obj_t BgL_arg3750z00_1918;obj_t BgL_arg3751z00_1919;
{ /* Ast/unit.scm 197 */
obj_t BgL_arg3754z00_1920;
{ /* Ast/unit.scm 196 */
obj_t BgL_auxz00_4153;
{ /* Ast/unit.scm 197 */
obj_t BgL_auxz00_4154;
BgL_auxz00_4154 = 
CDR(BgL_sexpz00_27); 
BgL_auxz00_4153 = 
CDR(BgL_auxz00_4154); } 
BgL_arg3754z00_1920 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_auxz00_4153); } 
BgL_arg3750z00_1918 = 
BGl_normaliza7ezd2prognzf2errorz87zzast_unitz00(BgL_expz00_1595, BgL_sexpz00_27, BgL_arg3754z00_1920); } 
BgL_arg3751z00_1919 = 
CNST_TABLE_REF(((long)6)); 
return 
BGl_makezd2sfunzd2definitionz00zzast_unitz00(BgL_varz00_1593, BGl_za2moduleza2z00zzmodule_modulez00, BgL_argsz00_1594, BgL_arg3750z00_1918, BgL_sexpz00_27, BgL_arg3751z00_1919);}  else 
{ /* Ast/unit.scm 200 */
obj_t BgL_newzd2sexpzd2_1922;
{ /* Ast/unit.scm 200 */
obj_t BgL_arg3764z00_1923;obj_t BgL_arg3765z00_1924;
BgL_arg3764z00_1923 = 
CNST_TABLE_REF(((long)7)); 
{ /* Ast/unit.scm 200 */
obj_t BgL_arg3768z00_1925;
{ /* Ast/unit.scm 200 */
obj_t BgL_arg3772z00_1926;
{ /* Ast/unit.scm 200 */
obj_t BgL_arg3776z00_1928;obj_t BgL_arg3777z00_1929;
BgL_arg3776z00_1928 = 
CNST_TABLE_REF(((long)8)); 
{ /* Ast/unit.scm 200 */
obj_t BgL_auxz00_4163;
BgL_auxz00_4163 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_expz00_1595, BNIL); 
BgL_arg3777z00_1929 = 
MAKE_PAIR(BgL_argsz00_1594, BgL_auxz00_4163); } 
BgL_arg3772z00_1926 = 
MAKE_PAIR(BgL_arg3776z00_1928, BgL_arg3777z00_1929); } 
BgL_arg3768z00_1925 = 
MAKE_PAIR(BgL_arg3772z00_1926, BNIL); } 
BgL_arg3765z00_1924 = 
MAKE_PAIR(BgL_varz00_1593, BgL_arg3768z00_1925); } 
BgL_newzd2sexpzd2_1922 = 
MAKE_PAIR(BgL_arg3764z00_1923, BgL_arg3765z00_1924); } 
BGl_replacez12z12zztools_miscz00(BgL_sexpz00_27, BgL_newzd2sexpzd2_1922); 
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(BgL_varz00_1593, BgL_sexpz00_27);} } } } } } }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd2201zd2_1653;
BgL_cdrzd2201zd2_1653 = 
CDR(BgL_cdrzd2173zd2_1644); 
if(
PAIRP(BgL_cdrzd2201zd2_1653))
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd2205zd2_1655;
BgL_carzd2205zd2_1655 = 
CAR(BgL_cdrzd2201zd2_1653); 
if(
PAIRP(BgL_carzd2205zd2_1655))
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd2210zd2_1657;
BgL_cdrzd2210zd2_1657 = 
CDR(BgL_carzd2205zd2_1655); 
{ /* Ast/unit.scm 171 */
bool_t BgL_testz00_4182;
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4185;obj_t BgL_auxz00_4183;
BgL_auxz00_4185 = 
CNST_TABLE_REF(((long)8)); 
BgL_auxz00_4183 = 
CAR(BgL_carzd2205zd2_1655); 
BgL_testz00_4182 = 
(BgL_auxz00_4183==BgL_auxz00_4185); } 
if(BgL_testz00_4182)
{ /* Ast/unit.scm 171 */
if(
PAIRP(BgL_cdrzd2210zd2_1657))
{ /* Ast/unit.scm 171 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2201zd2_1653), BNIL))
{ /* Ast/unit.scm 171 */
BgL_varz00_1597 = 
CAR(BgL_cdrzd2173zd2_1644); 
BgL_argsz00_1598 = 
CAR(BgL_cdrzd2210zd2_1657); 
BgL_expz00_1599 = 
CDR(BgL_cdrzd2210zd2_1657); 
{ /* Ast/unit.scm 204 */
obj_t BgL_idz00_1941;
{ /* Ast/unit.scm 204 */
obj_t BgL_arg3839z00_1957;
BgL_arg3839z00_1957 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_sexpz00_27); 
BgL_idz00_1941 = 
BGl_idzd2ofzd2idz00zzast_identz00(BgL_varz00_1597, BgL_arg3839z00_1957); } 
{ /* Ast/unit.scm 204 */
obj_t BgL_defz00_1942;
BgL_defz00_1942 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_idz00_1941, BgL_gdefsz00_28); 
{ /* Ast/unit.scm 205 */
obj_t BgL_globalz00_1943;
BgL_globalz00_1943 = 
BGl_findzd2globalzf2modulez20zzast_envz00(BgL_idz00_1941, BGl_za2moduleza2z00zzmodule_modulez00); 
{ /* Ast/unit.scm 206 */

{ /* Ast/unit.scm 208 */
bool_t BgL_test3806z00_1944;
{ /* Ast/unit.scm 208 */
bool_t BgL_testz00_4197;
{ /* Ast/unit.scm 208 */
obj_t BgL_auxz00_4202;obj_t BgL_auxz00_4198;
BgL_auxz00_4202 = 
CNST_TABLE_REF(((long)5)); 
{ /* Ast/unit.scm 208 */
obj_t BgL_auxz00_4199;
BgL_auxz00_4199 = 
CDR(BgL_defz00_1942); 
BgL_auxz00_4198 = 
CAR(BgL_auxz00_4199); } 
BgL_testz00_4197 = 
(BgL_auxz00_4198==BgL_auxz00_4202); } 
if(BgL_testz00_4197)
{ /* Ast/unit.scm 209 */
bool_t BgL__ortest_2891z00_1950;
{ /* Ast/unit.scm 209 */
bool_t BgL_test3825z00_1953;
BgL_test3825z00_1953 = 
BGl_iszd2azf3z21zz__objectz00(BgL_globalz00_1943, BGl_globalz00zzast_varz00); 
if(BgL_test3825z00_1953)
{ /* Ast/unit.scm 209 */
BgL__ortest_2891z00_1950 = ((bool_t)0); }  else 
{ /* Ast/unit.scm 209 */
BgL__ortest_2891z00_1950 = ((bool_t)1); } } 
if(BgL__ortest_2891z00_1950)
{ /* Ast/unit.scm 210 */
BgL_test3806z00_1944 = BgL__ortest_2891z00_1950; }  else 
{ /* Ast/unit.scm 210 */
obj_t BgL_auxz00_4211;obj_t BgL_auxz00_4208;
BgL_auxz00_4211 = 
CNST_TABLE_REF(((long)5)); 
{ /* Ast/unit.scm 210 */
BgL_globalz00_bglt BgL_obj1159z00_3144;
BgL_obj1159z00_3144 = 
(BgL_globalz00_bglt)(BgL_globalz00_1943); 
BgL_auxz00_4208 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1159z00_3144))->BgL_accessz00); } 
BgL_test3806z00_1944 = 
(BgL_auxz00_4208==BgL_auxz00_4211); } }  else 
{ /* Ast/unit.scm 208 */
BgL_test3806z00_1944 = ((bool_t)0); } } 
if(BgL_test3806z00_1944)
{ /* Ast/unit.scm 217 */
obj_t BgL_arg3808z00_1945;obj_t BgL_arg3809z00_1946;
{ /* Ast/unit.scm 217 */
obj_t BgL_arg3812z00_1947;
{ /* Ast/unit.scm 216 */
obj_t BgL_auxz00_4215;
{ /* Ast/unit.scm 217 */
obj_t BgL_auxz00_4216;
BgL_auxz00_4216 = 
CDR(BgL_sexpz00_27); 
BgL_auxz00_4215 = 
CDR(BgL_auxz00_4216); } 
BgL_arg3812z00_1947 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_auxz00_4215); } 
BgL_arg3808z00_1945 = 
BGl_normaliza7ezd2prognzf2errorz87zzast_unitz00(BgL_expz00_1599, BgL_sexpz00_27, BgL_arg3812z00_1947); } 
BgL_arg3809z00_1946 = 
CNST_TABLE_REF(((long)6)); 
return 
BGl_makezd2sfunzd2definitionz00zzast_unitz00(BgL_varz00_1597, BGl_za2moduleza2z00zzmodule_modulez00, BgL_argsz00_1598, BgL_arg3808z00_1945, BgL_sexpz00_27, BgL_arg3809z00_1946);}  else 
{ /* Ast/unit.scm 208 */
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(BgL_varz00_1597, BgL_sexpz00_27);} } } } } } }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4227;
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4228;
BgL_auxz00_4228 = 
CDR(BgL_sexpz00_27); 
BgL_auxz00_4227 = 
CAR(BgL_auxz00_4228); } 
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(BgL_auxz00_4227, BgL_sexpz00_27);} }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd2278zd2_1669;
BgL_cdrzd2278zd2_1669 = 
CDR(BgL_sexpz00_27); 
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd2283zd2_1670;
BgL_cdrzd2283zd2_1670 = 
CDR(BgL_cdrzd2278zd2_1669); 
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd2287zd2_1671;
BgL_carzd2287zd2_1671 = 
CAR(BgL_cdrzd2283zd2_1670); 
if(
SYMBOLP(BgL_carzd2287zd2_1671))
{ /* Ast/unit.scm 171 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2283zd2_1670), BNIL))
{ /* Ast/unit.scm 171 */
BgL_varz00_1604 = 
CAR(BgL_cdrzd2278zd2_1669); 
BgL_var2z00_1605 = BgL_carzd2287zd2_1671; 
BgL_tagzd2125zd2_1606:
{ /* Ast/unit.scm 225 */
obj_t BgL_defz00_1959;
{ /* Ast/unit.scm 225 */
obj_t BgL_arg3864z00_1967;
{ /* Ast/unit.scm 225 */
obj_t BgL_arg3867z00_1968;
BgL_arg3867z00_1968 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_sexpz00_27); 
BgL_arg3864z00_1967 = 
BGl_idzd2ofzd2idz00zzast_identz00(BgL_varz00_1604, BgL_arg3867z00_1968); } 
BgL_defz00_1959 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg3864z00_1967, BgL_gdefsz00_28); } 
{ /* Ast/unit.scm 226 */
bool_t BgL_testz00_4243;
{ /* Ast/unit.scm 226 */
obj_t BgL_auxz00_4248;obj_t BgL_auxz00_4244;
BgL_auxz00_4248 = 
CNST_TABLE_REF(((long)5)); 
{ /* Ast/unit.scm 226 */
obj_t BgL_auxz00_4245;
BgL_auxz00_4245 = 
CDR(BgL_defz00_1959); 
BgL_auxz00_4244 = 
CAR(BgL_auxz00_4245); } 
BgL_testz00_4243 = 
(BgL_auxz00_4244==BgL_auxz00_4248); } 
if(BgL_testz00_4243)
{ /* Ast/unit.scm 227 */
obj_t BgL_arityz00_1961;
BgL_arityz00_1961 = 
BGl_getzd2globalzd2arityz00zzast_unitz00(BgL_var2z00_1605, BFALSE, BgL_gdefsz00_28); 
if(
INTEGERP(BgL_arityz00_1961))
{ /* Ast/unit.scm 229 */
obj_t BgL_defz00_1963;
BgL_defz00_1963 = 
BGl_etazd2expansezd2zzast_unitz00(BgL_sexpz00_27, BgL_arityz00_1961); 
{ 
obj_t BgL_sexpz00_4255;
BgL_sexpz00_4255 = BgL_defz00_1963; 
BgL_sexpz00_27 = BgL_sexpz00_4255; 
goto BGl_toplevelzd2ze3astz31zzast_unitz00;} }  else 
{ /* Ast/unit.scm 228 */
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(BgL_varz00_1604, BgL_sexpz00_27);} }  else 
{ /* Ast/unit.scm 226 */
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(BgL_varz00_1604, BgL_sexpz00_27);} } } }  else 
{ /* Ast/unit.scm 171 */
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(
CAR(BgL_cdrzd2278zd2_1669), BgL_sexpz00_27);} }  else 
{ /* Ast/unit.scm 171 */
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(
CAR(BgL_cdrzd2278zd2_1669), BgL_sexpz00_27);} } } } }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd2354zd2_1683;
BgL_cdrzd2354zd2_1683 = 
CDR(BgL_sexpz00_27); 
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd2359zd2_1684;
BgL_cdrzd2359zd2_1684 = 
CDR(BgL_cdrzd2354zd2_1683); 
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd2363zd2_1685;
BgL_carzd2363zd2_1685 = 
CAR(BgL_cdrzd2359zd2_1684); 
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd2367zd2_1686;
BgL_cdrzd2367zd2_1686 = 
CDR(BgL_carzd2363zd2_1685); 
{ /* Ast/unit.scm 171 */
bool_t BgL_testz00_4267;
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4270;obj_t BgL_auxz00_4268;
BgL_auxz00_4270 = 
CNST_TABLE_REF(((long)10)); 
BgL_auxz00_4268 = 
CAR(BgL_carzd2363zd2_1685); 
BgL_testz00_4267 = 
(BgL_auxz00_4268==BgL_auxz00_4270); } 
if(BgL_testz00_4267)
{ /* Ast/unit.scm 171 */
if(
PAIRP(BgL_cdrzd2367zd2_1686))
{ /* Ast/unit.scm 171 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2367zd2_1686), BNIL))
{ /* Ast/unit.scm 171 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2359zd2_1684), BNIL))
{ /* Ast/unit.scm 171 */
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4283;obj_t BgL_auxz00_4281;
BgL_auxz00_4283 = 
CAR(BgL_cdrzd2367zd2_1686); 
BgL_auxz00_4281 = 
CDR(BgL_cdrzd2354zd2_1683); 
SET_CAR(BgL_auxz00_4281, BgL_auxz00_4283); } 
{ 

goto BGl_toplevelzd2ze3astz31zzast_unitz00;} }  else 
{ /* Ast/unit.scm 171 */
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(
CAR(BgL_cdrzd2354zd2_1683), BgL_sexpz00_27);} }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd2420zd2_1699;
BgL_cdrzd2420zd2_1699 = 
CDR(BgL_cdrzd2354zd2_1683); 
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd2424zd2_1700;
BgL_carzd2424zd2_1700 = 
CAR(BgL_cdrzd2420zd2_1699); 
if(
SYMBOLP(BgL_carzd2424zd2_1700))
{ /* Ast/unit.scm 171 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2420zd2_1699), BNIL))
{ 
obj_t BgL_var2z00_4297;obj_t BgL_varz00_4295;
BgL_varz00_4295 = 
CAR(BgL_cdrzd2354zd2_1683); 
BgL_var2z00_4297 = BgL_carzd2424zd2_1700; 
BgL_var2z00_1605 = BgL_var2z00_4297; 
BgL_varz00_1604 = BgL_varz00_4295; 
goto BgL_tagzd2125zd2_1606;}  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4298;
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4299;
BgL_auxz00_4299 = 
CDR(BgL_sexpz00_27); 
BgL_auxz00_4298 = 
CAR(BgL_auxz00_4299); } 
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(BgL_auxz00_4298, BgL_sexpz00_27);} }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4303;
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4304;
BgL_auxz00_4304 = 
CDR(BgL_sexpz00_27); 
BgL_auxz00_4303 = 
CAR(BgL_auxz00_4304); } 
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(BgL_auxz00_4303, BgL_sexpz00_27);} } } }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd2495zd2_1715;
BgL_cdrzd2495zd2_1715 = 
CDR(BgL_cdrzd2354zd2_1683); 
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd2499zd2_1716;
BgL_carzd2499zd2_1716 = 
CAR(BgL_cdrzd2495zd2_1715); 
if(
SYMBOLP(BgL_carzd2499zd2_1716))
{ /* Ast/unit.scm 171 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2495zd2_1715), BNIL))
{ 
obj_t BgL_var2z00_4317;obj_t BgL_varz00_4315;
BgL_varz00_4315 = 
CAR(BgL_cdrzd2354zd2_1683); 
BgL_var2z00_4317 = BgL_carzd2499zd2_1716; 
BgL_var2z00_1605 = BgL_var2z00_4317; 
BgL_varz00_1604 = BgL_varz00_4315; 
goto BgL_tagzd2125zd2_1606;}  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4318;
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4319;
BgL_auxz00_4319 = 
CDR(BgL_sexpz00_27); 
BgL_auxz00_4318 = 
CAR(BgL_auxz00_4319); } 
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(BgL_auxz00_4318, BgL_sexpz00_27);} }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4323;
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4324;
BgL_auxz00_4324 = 
CDR(BgL_sexpz00_27); 
BgL_auxz00_4323 = 
CAR(BgL_auxz00_4324); } 
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(BgL_auxz00_4323, BgL_sexpz00_27);} } } }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd2570zd2_1729;
BgL_cdrzd2570zd2_1729 = 
CDR(BgL_cdrzd2354zd2_1683); 
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd2574zd2_1730;
BgL_carzd2574zd2_1730 = 
CAR(BgL_cdrzd2570zd2_1729); 
if(
SYMBOLP(BgL_carzd2574zd2_1730))
{ /* Ast/unit.scm 171 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2570zd2_1729), BNIL))
{ 
obj_t BgL_var2z00_4337;obj_t BgL_varz00_4335;
BgL_varz00_4335 = 
CAR(BgL_cdrzd2354zd2_1683); 
BgL_var2z00_4337 = BgL_carzd2574zd2_1730; 
BgL_var2z00_1605 = BgL_var2z00_4337; 
BgL_varz00_1604 = BgL_varz00_4335; 
goto BgL_tagzd2125zd2_1606;}  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4338;
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4339;
BgL_auxz00_4339 = 
CDR(BgL_sexpz00_27); 
BgL_auxz00_4338 = 
CAR(BgL_auxz00_4339); } 
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(BgL_auxz00_4338, BgL_sexpz00_27);} }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd2615zd2_1739;
BgL_cdrzd2615zd2_1739 = 
CDR(BgL_sexpz00_27); 
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd2621zd2_1740;
BgL_cdrzd2621zd2_1740 = 
CDR(BgL_cdrzd2615zd2_1739); 
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd2626zd2_1741;
BgL_carzd2626zd2_1741 = 
CAR(BgL_cdrzd2621zd2_1740); 
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd2631zd2_1742;
BgL_cdrzd2631zd2_1742 = 
CDR(BgL_carzd2626zd2_1741); 
{ /* Ast/unit.scm 171 */
bool_t BgL_testz00_4347;
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4350;obj_t BgL_auxz00_4348;
BgL_auxz00_4350 = 
CNST_TABLE_REF(((long)4)); 
BgL_auxz00_4348 = 
CAR(BgL_carzd2626zd2_1741); 
BgL_testz00_4347 = 
(BgL_auxz00_4348==BgL_auxz00_4350); } 
if(BgL_testz00_4347)
{ /* Ast/unit.scm 171 */
if(
PAIRP(BgL_cdrzd2631zd2_1742))
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd2634zd2_1745;obj_t BgL_cdrzd2635zd2_1746;
BgL_carzd2634zd2_1745 = 
CAR(BgL_cdrzd2631zd2_1742); 
BgL_cdrzd2635zd2_1746 = 
CDR(BgL_cdrzd2631zd2_1742); 
if(
SYMBOLP(BgL_carzd2634zd2_1745))
{ /* Ast/unit.scm 171 */
if(
PAIRP(BgL_cdrzd2635zd2_1746))
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd2640zd2_1749;
BgL_carzd2640zd2_1749 = 
CAR(BgL_cdrzd2635zd2_1746); 
if(
SYMBOLP(BgL_carzd2640zd2_1749))
{ /* Ast/unit.scm 171 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2635zd2_1746), BNIL))
{ /* Ast/unit.scm 171 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2621zd2_1740), BNIL))
{ /* Ast/unit.scm 171 */
BgL_varz00_1607 = 
CAR(BgL_cdrzd2615zd2_1739); 
BgL_var2z00_1608 = BgL_carzd2634zd2_1745; 
BgL_modulez00_1609 = BgL_carzd2640zd2_1749; 
{ /* Ast/unit.scm 234 */
obj_t BgL_defz00_1969;
{ /* Ast/unit.scm 234 */
obj_t BgL_arg3887z00_1977;
{ /* Ast/unit.scm 234 */
obj_t BgL_arg3890z00_1978;
BgL_arg3890z00_1978 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_sexpz00_27); 
BgL_arg3887z00_1977 = 
BGl_idzd2ofzd2idz00zzast_identz00(BgL_varz00_1607, BgL_arg3890z00_1978); } 
BgL_defz00_1969 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg3887z00_1977, BgL_gdefsz00_28); } 
{ /* Ast/unit.scm 235 */
bool_t BgL_testz00_4373;
{ /* Ast/unit.scm 235 */
obj_t BgL_auxz00_4378;obj_t BgL_auxz00_4374;
BgL_auxz00_4378 = 
CNST_TABLE_REF(((long)5)); 
{ /* Ast/unit.scm 235 */
obj_t BgL_auxz00_4375;
BgL_auxz00_4375 = 
CDR(BgL_defz00_1969); 
BgL_auxz00_4374 = 
CAR(BgL_auxz00_4375); } 
BgL_testz00_4373 = 
(BgL_auxz00_4374==BgL_auxz00_4378); } 
if(BgL_testz00_4373)
{ /* Ast/unit.scm 236 */
obj_t BgL_arityz00_1971;
BgL_arityz00_1971 = 
BGl_getzd2globalzd2arityz00zzast_unitz00(BgL_var2z00_1608, BgL_modulez00_1609, BgL_gdefsz00_28); 
if(
INTEGERP(BgL_arityz00_1971))
{ /* Ast/unit.scm 238 */
obj_t BgL_defz00_1973;
BgL_defz00_1973 = 
BGl_etazd2expansezd2zzast_unitz00(BgL_sexpz00_27, BgL_arityz00_1971); 
{ 
obj_t BgL_sexpz00_4385;
BgL_sexpz00_4385 = BgL_defz00_1973; 
BgL_sexpz00_27 = BgL_sexpz00_4385; 
goto BGl_toplevelzd2ze3astz31zzast_unitz00;} }  else 
{ /* Ast/unit.scm 237 */
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(BgL_varz00_1607, BgL_sexpz00_27);} }  else 
{ /* Ast/unit.scm 235 */
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(BgL_varz00_1607, BgL_sexpz00_27);} } } }  else 
{ /* Ast/unit.scm 171 */
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(
CAR(BgL_cdrzd2615zd2_1739), BgL_sexpz00_27);} }  else 
{ /* Ast/unit.scm 171 */
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(
CAR(BgL_cdrzd2615zd2_1739), BgL_sexpz00_27);} }  else 
{ /* Ast/unit.scm 171 */
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(
CAR(BgL_cdrzd2615zd2_1739), BgL_sexpz00_27);} }  else 
{ /* Ast/unit.scm 171 */
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(
CAR(BgL_cdrzd2615zd2_1739), BgL_sexpz00_27);} }  else 
{ /* Ast/unit.scm 171 */
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(
CAR(BgL_cdrzd2615zd2_1739), BgL_sexpz00_27);} }  else 
{ /* Ast/unit.scm 171 */
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(
CAR(BgL_cdrzd2615zd2_1739), BgL_sexpz00_27);} }  else 
{ /* Ast/unit.scm 171 */
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(
CAR(BgL_cdrzd2615zd2_1739), BgL_sexpz00_27);} } } } } } } } } } } } } } }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd2782zd2_1785;
BgL_cdrzd2782zd2_1785 = 
CDR(BgL_sexpz00_27); 
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd2787zd2_1786;
BgL_cdrzd2787zd2_1786 = 
CDR(BgL_cdrzd2782zd2_1785); 
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd2791zd2_1787;
BgL_carzd2791zd2_1787 = 
CAR(BgL_cdrzd2787zd2_1786); 
if(
SYMBOLP(BgL_carzd2791zd2_1787))
{ /* Ast/unit.scm 171 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2787zd2_1786), BNIL))
{ 
obj_t BgL_var2z00_4413;obj_t BgL_varz00_4411;
BgL_varz00_4411 = 
CAR(BgL_cdrzd2782zd2_1785); 
BgL_var2z00_4413 = BgL_carzd2791zd2_1787; 
BgL_var2z00_1605 = BgL_var2z00_4413; 
BgL_varz00_1604 = BgL_varz00_4411; 
goto BgL_tagzd2125zd2_1606;}  else 
{ /* Ast/unit.scm 171 */
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(
CAR(BgL_cdrzd2782zd2_1785), BgL_sexpz00_27);} }  else 
{ /* Ast/unit.scm 171 */
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(
CAR(BgL_cdrzd2782zd2_1785), BgL_sexpz00_27);} } } } }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4418;
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4419;
BgL_auxz00_4419 = 
CDR(BgL_sexpz00_27); 
BgL_auxz00_4418 = 
CAR(BgL_auxz00_4419); } 
return 
BGl_makezd2svarzd2definitionz00zzast_unitz00(BgL_auxz00_4418, BgL_sexpz00_27);} } }  else 
{ /* Ast/unit.scm 171 */
BgL_tagzd2133zd2_1636:
{ /* Ast/unit.scm 285 */
obj_t BgL_list3930z00_1990;
BgL_list3930z00_1990 = 
MAKE_PAIR(BgL_sexpz00_27, BNIL); 
return BgL_list3930z00_1990;} } }  else 
{ /* Ast/unit.scm 171 */
bool_t BgL_testz00_4424;
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4427;obj_t BgL_auxz00_4425;
BgL_auxz00_4427 = 
CNST_TABLE_REF(((long)12)); 
BgL_auxz00_4425 = 
CAR(BgL_sexpz00_27); 
BgL_testz00_4424 = 
(BgL_auxz00_4425==BgL_auxz00_4427); } 
if(BgL_testz00_4424)
{ /* Ast/unit.scm 171 */
if(
PAIRP(BgL_cdrzd2173zd2_1644))
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd21016zd2_1805;
BgL_carzd21016zd2_1805 = 
CAR(BgL_cdrzd2173zd2_1644); 
if(
PAIRP(BgL_carzd21016zd2_1805))
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd21021zd2_1807;
BgL_carzd21021zd2_1807 = 
CAR(BgL_carzd21016zd2_1805); 
if(
PAIRP(BgL_carzd21021zd2_1807))
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd21026zd2_1809;
BgL_cdrzd21026zd2_1809 = 
CDR(BgL_carzd21021zd2_1807); 
{ /* Ast/unit.scm 171 */
bool_t BgL_testz00_4439;
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4442;obj_t BgL_auxz00_4440;
BgL_auxz00_4442 = 
CNST_TABLE_REF(((long)4)); 
BgL_auxz00_4440 = 
CAR(BgL_carzd21021zd2_1807); 
BgL_testz00_4439 = 
(BgL_auxz00_4440==BgL_auxz00_4442); } 
if(BgL_testz00_4439)
{ /* Ast/unit.scm 171 */
if(
PAIRP(BgL_cdrzd21026zd2_1809))
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd21030zd2_1812;
BgL_cdrzd21030zd2_1812 = 
CDR(BgL_cdrzd21026zd2_1809); 
if(
PAIRP(BgL_cdrzd21030zd2_1812))
{ /* Ast/unit.scm 171 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd21030zd2_1812), BNIL))
{ /* Ast/unit.scm 171 */
obj_t BgL_arg3520z00_1815;obj_t BgL_arg3521z00_1816;obj_t BgL_arg3522z00_1817;obj_t BgL_arg3523z00_1818;
BgL_arg3520z00_1815 = 
CAR(BgL_cdrzd21026zd2_1809); 
BgL_arg3521z00_1816 = 
CAR(BgL_cdrzd21030zd2_1812); 
BgL_arg3522z00_1817 = 
CDR(BgL_carzd21016zd2_1805); 
BgL_arg3523z00_1818 = 
CDR(BgL_cdrzd2173zd2_1644); 
{ /* Ast/unit.scm 171 */
obj_t BgL_arg3896z00_3017;obj_t BgL_arg3897z00_3018;
{ /* Ast/unit.scm 171 */
obj_t BgL_arg3900z00_3019;
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4457;
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4458;
BgL_auxz00_4458 = 
CDR(BgL_sexpz00_27); 
BgL_auxz00_4457 = 
CDR(BgL_auxz00_4458); } 
BgL_arg3900z00_3019 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_auxz00_4457); } 
BgL_arg3896z00_3017 = 
BGl_normaliza7ezd2prognzf2errorz87zzast_unitz00(BgL_arg3523z00_1818, BgL_sexpz00_27, BgL_arg3900z00_3019); } 
BgL_arg3897z00_3018 = 
CNST_TABLE_REF(((long)9)); 
return 
BGl_makezd2sfunzd2definitionz00zzast_unitz00(BgL_arg3520z00_1815, BgL_arg3521z00_1816, BgL_arg3522z00_1817, BgL_arg3896z00_3017, BgL_sexpz00_27, BgL_arg3897z00_3018);} }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd21046zd2_1819;
BgL_cdrzd21046zd2_1819 = 
CDR(BgL_sexpz00_27); 
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd21050zd2_1820;
BgL_carzd21050zd2_1820 = 
CAR(BgL_cdrzd21046zd2_1819); 
BgL_varz00_1619 = 
CAR(BgL_carzd21050zd2_1820); 
BgL_argsz00_1620 = 
CDR(BgL_carzd21050zd2_1820); 
BgL_expz00_1621 = 
CDR(BgL_cdrzd21046zd2_1819); 
BgL_tagzd2129zd2_1622:
{ /* Ast/unit.scm 260 */
obj_t BgL_arg3907z00_1983;obj_t BgL_arg3908z00_1984;
{ /* Ast/unit.scm 260 */
obj_t BgL_arg3911z00_1985;
{ /* Ast/unit.scm 260 */
obj_t BgL_auxz00_4467;
{ /* Ast/unit.scm 260 */
obj_t BgL_auxz00_4468;
BgL_auxz00_4468 = 
CDR(BgL_sexpz00_27); 
BgL_auxz00_4467 = 
CDR(BgL_auxz00_4468); } 
BgL_arg3911z00_1985 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_auxz00_4467); } 
BgL_arg3907z00_1983 = 
BGl_normaliza7ezd2prognzf2errorz87zzast_unitz00(BgL_expz00_1621, BgL_sexpz00_27, BgL_arg3911z00_1985); } 
BgL_arg3908z00_1984 = 
CNST_TABLE_REF(((long)9)); 
return 
BGl_makezd2sfunzd2definitionz00zzast_unitz00(BgL_varz00_1619, BGl_za2moduleza2z00zzmodule_modulez00, BgL_argsz00_1620, BgL_arg3907z00_1983, BgL_sexpz00_27, BgL_arg3908z00_1984);} } } }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd21067zd2_1826;
BgL_cdrzd21067zd2_1826 = 
CDR(BgL_sexpz00_27); 
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd21071zd2_1827;
BgL_carzd21071zd2_1827 = 
CAR(BgL_cdrzd21067zd2_1826); 
{ 
obj_t BgL_expz00_4484;obj_t BgL_argsz00_4482;obj_t BgL_varz00_4480;
BgL_varz00_4480 = 
CAR(BgL_carzd21071zd2_1827); 
BgL_argsz00_4482 = 
CDR(BgL_carzd21071zd2_1827); 
BgL_expz00_4484 = 
CDR(BgL_cdrzd21067zd2_1826); 
BgL_expz00_1621 = BgL_expz00_4484; 
BgL_argsz00_1620 = BgL_argsz00_4482; 
BgL_varz00_1619 = BgL_varz00_4480; 
goto BgL_tagzd2129zd2_1622;} } } }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd21088zd2_1831;
BgL_cdrzd21088zd2_1831 = 
CDR(BgL_sexpz00_27); 
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd21092zd2_1832;
BgL_carzd21092zd2_1832 = 
CAR(BgL_cdrzd21088zd2_1831); 
{ 
obj_t BgL_expz00_4492;obj_t BgL_argsz00_4490;obj_t BgL_varz00_4488;
BgL_varz00_4488 = 
CAR(BgL_carzd21092zd2_1832); 
BgL_argsz00_4490 = 
CDR(BgL_carzd21092zd2_1832); 
BgL_expz00_4492 = 
CDR(BgL_cdrzd21088zd2_1831); 
BgL_expz00_1621 = BgL_expz00_4492; 
BgL_argsz00_1620 = BgL_argsz00_4490; 
BgL_varz00_1619 = BgL_varz00_4488; 
goto BgL_tagzd2129zd2_1622;} } } }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd21109zd2_1836;
BgL_cdrzd21109zd2_1836 = 
CDR(BgL_sexpz00_27); 
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd21113zd2_1837;
BgL_carzd21113zd2_1837 = 
CAR(BgL_cdrzd21109zd2_1836); 
{ 
obj_t BgL_expz00_4500;obj_t BgL_argsz00_4498;obj_t BgL_varz00_4496;
BgL_varz00_4496 = 
CAR(BgL_carzd21113zd2_1837); 
BgL_argsz00_4498 = 
CDR(BgL_carzd21113zd2_1837); 
BgL_expz00_4500 = 
CDR(BgL_cdrzd21109zd2_1836); 
BgL_expz00_1621 = BgL_expz00_4500; 
BgL_argsz00_1620 = BgL_argsz00_4498; 
BgL_varz00_1619 = BgL_varz00_4496; 
goto BgL_tagzd2129zd2_1622;} } } } }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd21130zd2_1843;
BgL_cdrzd21130zd2_1843 = 
CDR(BgL_sexpz00_27); 
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd21134zd2_1844;
BgL_carzd21134zd2_1844 = 
CAR(BgL_cdrzd21130zd2_1843); 
{ 
obj_t BgL_expz00_4508;obj_t BgL_argsz00_4506;obj_t BgL_varz00_4504;
BgL_varz00_4504 = 
CAR(BgL_carzd21134zd2_1844); 
BgL_argsz00_4506 = 
CDR(BgL_carzd21134zd2_1844); 
BgL_expz00_4508 = 
CDR(BgL_cdrzd21130zd2_1843); 
BgL_expz00_1621 = BgL_expz00_4508; 
BgL_argsz00_1620 = BgL_argsz00_4506; 
BgL_varz00_1619 = BgL_varz00_4504; 
goto BgL_tagzd2129zd2_1622;} } } }  else 
{ /* Ast/unit.scm 171 */
goto BgL_tagzd2133zd2_1636;} }  else 
{ /* Ast/unit.scm 171 */
goto BgL_tagzd2133zd2_1636;} }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd21213zd2_1848;
BgL_cdrzd21213zd2_1848 = 
CDR(BgL_sexpz00_27); 
{ /* Ast/unit.scm 171 */
bool_t BgL_testz00_4511;
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4514;obj_t BgL_auxz00_4512;
BgL_auxz00_4514 = 
CNST_TABLE_REF(((long)13)); 
BgL_auxz00_4512 = 
CAR(BgL_sexpz00_27); 
BgL_testz00_4511 = 
(BgL_auxz00_4512==BgL_auxz00_4514); } 
if(BgL_testz00_4511)
{ /* Ast/unit.scm 171 */
if(
PAIRP(BgL_cdrzd21213zd2_1848))
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd21218zd2_1851;
BgL_carzd21218zd2_1851 = 
CAR(BgL_cdrzd21213zd2_1848); 
if(
PAIRP(BgL_carzd21218zd2_1851))
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd21223zd2_1853;
BgL_carzd21223zd2_1853 = 
CAR(BgL_carzd21218zd2_1851); 
if(
PAIRP(BgL_carzd21223zd2_1853))
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd21228zd2_1855;
BgL_cdrzd21228zd2_1855 = 
CDR(BgL_carzd21223zd2_1853); 
{ /* Ast/unit.scm 171 */
bool_t BgL_testz00_4526;
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4529;obj_t BgL_auxz00_4527;
BgL_auxz00_4529 = 
CNST_TABLE_REF(((long)4)); 
BgL_auxz00_4527 = 
CAR(BgL_carzd21223zd2_1853); 
BgL_testz00_4526 = 
(BgL_auxz00_4527==BgL_auxz00_4529); } 
if(BgL_testz00_4526)
{ /* Ast/unit.scm 171 */
if(
PAIRP(BgL_cdrzd21228zd2_1855))
{ /* Ast/unit.scm 171 */
obj_t BgL_cdrzd21232zd2_1858;
BgL_cdrzd21232zd2_1858 = 
CDR(BgL_cdrzd21228zd2_1855); 
if(
PAIRP(BgL_cdrzd21232zd2_1858))
{ /* Ast/unit.scm 171 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd21232zd2_1858), BNIL))
{ /* Ast/unit.scm 171 */
return 
BGl_makezd2sgfunzd2definitionz00zzast_unitz00(
CAR(BgL_cdrzd21228zd2_1855), 
CAR(BgL_cdrzd21232zd2_1858), 
CDR(BgL_carzd21218zd2_1851), 
CDR(BgL_cdrzd21213zd2_1848), BgL_sexpz00_27, BgL_gdefsz00_28);}  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd21251zd2_1866;
BgL_carzd21251zd2_1866 = 
CAR(BgL_cdrzd21213zd2_1848); 
return 
BGl_makezd2sgfunzd2definitionz00zzast_unitz00(
CAR(BgL_carzd21251zd2_1866), BGl_za2moduleza2z00zzmodule_modulez00, 
CDR(BgL_carzd21251zd2_1866), 
CDR(BgL_cdrzd21213zd2_1848), BgL_sexpz00_27, BgL_gdefsz00_28);} }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd21271zd2_1873;
BgL_carzd21271zd2_1873 = 
CAR(BgL_cdrzd21213zd2_1848); 
return 
BGl_makezd2sgfunzd2definitionz00zzast_unitz00(
CAR(BgL_carzd21271zd2_1873), BGl_za2moduleza2z00zzmodule_modulez00, 
CDR(BgL_carzd21271zd2_1873), 
CDR(BgL_cdrzd21213zd2_1848), BgL_sexpz00_27, BgL_gdefsz00_28);} }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd21291zd2_1878;
BgL_carzd21291zd2_1878 = 
CAR(BgL_cdrzd21213zd2_1848); 
return 
BGl_makezd2sgfunzd2definitionz00zzast_unitz00(
CAR(BgL_carzd21291zd2_1878), BGl_za2moduleza2z00zzmodule_modulez00, 
CDR(BgL_carzd21291zd2_1878), 
CDR(BgL_cdrzd21213zd2_1848), BgL_sexpz00_27, BgL_gdefsz00_28);} }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd21311zd2_1883;
BgL_carzd21311zd2_1883 = 
CAR(BgL_cdrzd21213zd2_1848); 
return 
BGl_makezd2sgfunzd2definitionz00zzast_unitz00(
CAR(BgL_carzd21311zd2_1883), BGl_za2moduleza2z00zzmodule_modulez00, 
CDR(BgL_carzd21311zd2_1883), 
CDR(BgL_cdrzd21213zd2_1848), BgL_sexpz00_27, BgL_gdefsz00_28);} } }  else 
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd21331zd2_1890;
BgL_carzd21331zd2_1890 = 
CAR(BgL_cdrzd21213zd2_1848); 
return 
BGl_makezd2sgfunzd2definitionz00zzast_unitz00(
CAR(BgL_carzd21331zd2_1890), BGl_za2moduleza2z00zzmodule_modulez00, 
CDR(BgL_carzd21331zd2_1890), 
CDR(BgL_cdrzd21213zd2_1848), BgL_sexpz00_27, BgL_gdefsz00_28);} }  else 
{ /* Ast/unit.scm 171 */
goto BgL_tagzd2133zd2_1636;} }  else 
{ /* Ast/unit.scm 171 */
goto BgL_tagzd2133zd2_1636;} }  else 
{ /* Ast/unit.scm 171 */
bool_t BgL_testz00_4570;
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4573;obj_t BgL_auxz00_4571;
BgL_auxz00_4573 = 
CNST_TABLE_REF(((long)14)); 
BgL_auxz00_4571 = 
CAR(BgL_sexpz00_27); 
BgL_testz00_4570 = 
(BgL_auxz00_4571==BgL_auxz00_4573); } 
if(BgL_testz00_4570)
{ /* Ast/unit.scm 171 */
if(
PAIRP(BgL_cdrzd21213zd2_1848))
{ /* Ast/unit.scm 171 */
obj_t BgL_carzd21381zd2_1897;
BgL_carzd21381zd2_1897 = 
CAR(BgL_cdrzd21213zd2_1848); 
if(
PAIRP(BgL_carzd21381zd2_1897))
{ /* Ast/unit.scm 171 */
obj_t BgL_arg3696z00_1899;obj_t BgL_arg3697z00_1900;obj_t BgL_arg3698z00_1901;
BgL_arg3696z00_1899 = 
CAR(BgL_carzd21381zd2_1897); 
BgL_arg3697z00_1900 = 
CDR(BgL_carzd21381zd2_1897); 
BgL_arg3698z00_1901 = 
CDR(BgL_cdrzd21213zd2_1848); 
{ /* Ast/unit.scm 171 */
obj_t BgL_arg3920z00_3122;
{ /* Ast/unit.scm 171 */
obj_t BgL_arg3923z00_3123;
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4584;
{ /* Ast/unit.scm 171 */
obj_t BgL_auxz00_4585;
BgL_auxz00_4585 = 
CDR(BgL_sexpz00_27); 
BgL_auxz00_4584 = 
CDR(BgL_auxz00_4585); } 
BgL_arg3923z00_3123 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_auxz00_4584); } 
BgL_arg3920z00_3122 = 
BGl_normaliza7ezd2prognzf2errorz87zzast_unitz00(BgL_arg3698z00_1901, BgL_sexpz00_27, BgL_arg3923z00_3123); } 
return 
BGl_makezd2methodzd2definitionz00zzast_unitz00(BgL_arg3696z00_1899, BgL_arg3697z00_1900, BgL_arg3920z00_3122, BgL_sexpz00_27);} }  else 
{ /* Ast/unit.scm 171 */
goto BgL_tagzd2133zd2_1636;} }  else 
{ /* Ast/unit.scm 171 */
goto BgL_tagzd2133zd2_1636;} }  else 
{ /* Ast/unit.scm 171 */
goto BgL_tagzd2133zd2_1636;} } } } } } } }  else 
{ /* Ast/unit.scm 171 */
goto BgL_tagzd2133zd2_1636;} } } 
}



/* normalize-progn/error */
obj_t BGl_normaliza7ezd2prognzf2errorz87zzast_unitz00(obj_t BgL_expz00_29, obj_t BgL_srcz00_30, obj_t BgL_locz00_31)
{ AN_OBJECT;
{ /* Ast/unit.scm 290 */
if(
NULLP(BgL_expz00_29))
{ /* Ast/unit.scm 292 */
obj_t BgL_arg3935z00_1993;
BgL_arg3935z00_1993 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_srcz00_30); 
{ /* Ast/unit.scm 292 */
BgL_nodez00_bglt BgL_auxz00_4594;
BgL_auxz00_4594 = 
BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string5091z00zzast_unitz00, BgL_srcz00_30, BgL_arg3935z00_1993); 
return 
(obj_t)(BgL_auxz00_4594);} }  else 
{ /* Ast/unit.scm 293 */
obj_t BgL_expz00_1994;
BgL_expz00_1994 = 
BGl_normaliza7ezd2prognz75zztools_prognz00(BgL_expz00_29); 
if(
CBOOL(BgL_locz00_31))
{ /* Ast/unit.scm 297 */
bool_t BgL_test3938z00_1995;
BgL_test3938z00_1995 = 
EXTENDED_PAIRP(BgL_expz00_1994); 
if(BgL_test3938z00_1995)
{ /* Ast/unit.scm 297 */
return BgL_expz00_1994;}  else 
{ /* Ast/unit.scm 297 */
if(
PAIRP(BgL_expz00_1994))
{ /* Ast/unit.scm 299 */
{ /* Ast/unit.scm 300 */
obj_t BgL_res4999z00_3191;
{ /* Ast/unit.scm 300 */
obj_t BgL_auxz00_4606;obj_t BgL_auxz00_4604;
BgL_auxz00_4606 = 
CDR(BgL_expz00_1994); 
BgL_auxz00_4604 = 
CAR(BgL_expz00_1994); 
BgL_res4999z00_3191 = 
MAKE_EXTENDED_PAIR(BgL_auxz00_4604, BgL_auxz00_4606, BgL_locz00_31); } 
return BgL_res4999z00_3191;} }  else 
{ /* Ast/unit.scm 299 */
{ /* Ast/unit.scm 302 */
obj_t BgL_arg3947z00_1999;obj_t BgL_arg3948z00_2000;
BgL_arg3947z00_1999 = 
CNST_TABLE_REF(((long)10)); 
{ /* Ast/unit.scm 302 */
obj_t BgL_list3951z00_2001;
BgL_list3951z00_2001 = 
MAKE_PAIR(BgL_expz00_1994, BNIL); 
BgL_arg3948z00_2000 = BgL_list3951z00_2001; } 
{ /* Ast/unit.scm 302 */
obj_t BgL_res5001z00_3197;
BgL_res5001z00_3197 = 
MAKE_EXTENDED_PAIR(BgL_arg3947z00_1999, BgL_arg3948z00_2000, BgL_locz00_31); 
return BgL_res5001z00_3197;} } } } }  else 
{ /* Ast/unit.scm 295 */
return BgL_expz00_1994;} } } 
}



/* get-global-arity */
obj_t BGl_getzd2globalzd2arityz00zzast_unitz00(obj_t BgL_idz00_32, obj_t BgL_modulez00_33, obj_t BgL_gdefsz00_34)
{ AN_OBJECT;
{ /* Ast/unit.scm 307 */
{ /* Ast/unit.scm 308 */
obj_t BgL_globalz00_2002;
if(
SYMBOLP(BgL_modulez00_33))
{ /* Ast/unit.scm 308 */
BgL_globalz00_2002 = 
BGl_findzd2globalzf2modulez20zzast_envz00(BgL_idz00_32, BgL_modulez00_33); }  else 
{ /* Ast/unit.scm 308 */
BgL_globalz00_2002 = 
BGl_findzd2globalzd2zzast_envz00(BgL_idz00_32, BNIL); } 
{ /* Ast/unit.scm 311 */
bool_t BgL_test3957z00_2003;
BgL_test3957z00_2003 = 
BGl_iszd2azf3z21zz__objectz00(BgL_globalz00_2002, BGl_globalz00zzast_varz00); 
if(BgL_test3957z00_2003)
{ /* Ast/unit.scm 313 */
bool_t BgL_test3958z00_2004;
{ /* Ast/unit.scm 313 */
obj_t BgL_auxz00_4618;
{ /* Ast/unit.scm 313 */
BgL_valuez00_bglt BgL_auxz00_4619;
{ /* Ast/unit.scm 313 */
BgL_globalz00_bglt BgL_obj1156z00_3200;
BgL_obj1156z00_3200 = 
(BgL_globalz00_bglt)(BgL_globalz00_2002); 
BgL_auxz00_4619 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1156z00_3200))->BgL_valuez00); } 
BgL_auxz00_4618 = 
(obj_t)(BgL_auxz00_4619); } 
BgL_test3958z00_2004 = 
BGl_iszd2azf3z21zz__objectz00(BgL_auxz00_4618, BGl_funz00zzast_varz00); } 
if(BgL_test3958z00_2004)
{ /* Ast/unit.scm 314 */
BgL_funz00_bglt BgL_obj1311z00_3203;
{ /* Ast/unit.scm 314 */
BgL_valuez00_bglt BgL_auxz00_4625;
{ /* Ast/unit.scm 314 */
BgL_globalz00_bglt BgL_obj1156z00_3202;
BgL_obj1156z00_3202 = 
(BgL_globalz00_bglt)(BgL_globalz00_2002); 
BgL_auxz00_4625 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1156z00_3202))->BgL_valuez00); } 
BgL_obj1311z00_3203 = 
(BgL_funz00_bglt)(BgL_auxz00_4625); } 
{ /* Ast/unit.scm 314 */
long BgL_auxz00_4629;
BgL_auxz00_4629 = 
(((BgL_funz00_bglt)CREF(BgL_obj1311z00_3203))->BgL_arityz00); 
return 
BINT(BgL_auxz00_4629);} }  else 
{ /* Ast/unit.scm 313 */
return BFALSE;} }  else 
{ /* Ast/unit.scm 311 */
return BFALSE;} } } } 
}



/* eta-expanse */
obj_t BGl_etazd2expansezd2zzast_unitz00(obj_t BgL_sexpz00_35, obj_t BgL_arityz00_36)
{ AN_OBJECT;
{ /* Ast/unit.scm 320 */
{ /* Ast/unit.scm 321 */
obj_t BgL_argsz00_2009;
BgL_argsz00_2009 = 
BGl_makezd2nzd2protoz00zztools_argsz00(BgL_arityz00_36); 
{ 
obj_t BgL_varz00_2039;obj_t BgL_id2z00_2040;
if(
PAIRP(BgL_sexpz00_35))
{ /* Ast/unit.scm 345 */
obj_t BgL_cdrzd21489zd2_2021;
BgL_cdrzd21489zd2_2021 = 
CDR(BgL_sexpz00_35); 
{ /* Ast/unit.scm 345 */
bool_t BgL_testz00_4636;
{ /* Ast/unit.scm 345 */
obj_t BgL_auxz00_4639;obj_t BgL_auxz00_4637;
BgL_auxz00_4639 = 
CNST_TABLE_REF(((long)11)); 
BgL_auxz00_4637 = 
CAR(BgL_sexpz00_35); 
BgL_testz00_4636 = 
(BgL_auxz00_4637==BgL_auxz00_4639); } 
if(BgL_testz00_4636)
{ /* Ast/unit.scm 345 */
if(
PAIRP(BgL_cdrzd21489zd2_2021))
{ /* Ast/unit.scm 345 */
obj_t BgL_cdrzd21493zd2_2024;
BgL_cdrzd21493zd2_2024 = 
CDR(BgL_cdrzd21489zd2_2021); 
if(
PAIRP(BgL_cdrzd21493zd2_2024))
{ /* Ast/unit.scm 345 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd21493zd2_2024), BNIL))
{ /* Ast/unit.scm 345 */
obj_t BgL_arg3979z00_2027;obj_t BgL_arg3980z00_2028;
BgL_arg3979z00_2027 = 
CAR(BgL_cdrzd21489zd2_2021); 
BgL_arg3980z00_2028 = 
CAR(BgL_cdrzd21493zd2_2024); 
{ /* Ast/unit.scm 345 */
obj_t BgL_id2z00_3215;
{ /* Ast/unit.scm 345 */
obj_t BgL_arg4004z00_3216;
BgL_arg4004z00_3216 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_sexpz00_35); 
BgL_id2z00_3215 = 
BGl_idzd2ofzd2idz00zzast_identz00(BgL_arg3980z00_2028, BgL_arg4004z00_3216); } 
{ /* Ast/unit.scm 345 */
obj_t BgL_arg4000z00_3217;
BgL_varz00_2039 = BgL_arg3979z00_2027; 
BgL_id2z00_2040 = BgL_id2z00_3215; 
{ /* Ast/unit.scm 336 */
bool_t BgL_testz00_4654;
{ /* Ast/unit.scm 336 */
long BgL_auxz00_4655;
BgL_auxz00_4655 = 
(long)CINT(BgL_arityz00_36); 
BgL_testz00_4654 = 
(BgL_auxz00_4655>=((long)0)); } 
if(BgL_testz00_4654)
{ /* Ast/unit.scm 336 */
{ /* Ast/unit.scm 337 */
obj_t BgL_arg4018z00_2043;obj_t BgL_arg4019z00_2044;
BgL_arg4018z00_2043 = 
CNST_TABLE_REF(((long)11)); 
{ /* Ast/unit.scm 337 */
obj_t BgL_arg4022z00_2045;obj_t BgL_arg4023z00_2046;
BgL_arg4022z00_2045 = 
MAKE_PAIR(BgL_varz00_2039, BgL_argsz00_2009); 
{ /* Ast/unit.scm 338 */
obj_t BgL_arg4027z00_2047;
{ /* Ast/unit.scm 338 */
obj_t BgL_auxz00_4660;
BgL_auxz00_4660 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_argsz00_2009, BNIL); 
BgL_arg4027z00_2047 = 
MAKE_PAIR(BgL_id2z00_2040, BgL_auxz00_4660); } 
BgL_arg4023z00_2046 = 
MAKE_PAIR(BgL_arg4027z00_2047, BNIL); } 
BgL_arg4019z00_2044 = 
MAKE_PAIR(BgL_arg4022z00_2045, BgL_arg4023z00_2046); } 
BgL_arg4000z00_3217 = 
MAKE_PAIR(BgL_arg4018z00_2043, BgL_arg4019z00_2044); } }  else 
{ /* Ast/unit.scm 339 */
bool_t BgL_testz00_4666;
{ /* Ast/unit.scm 339 */
long BgL_auxz00_4667;
BgL_auxz00_4667 = 
(long)CINT(BgL_arityz00_36); 
BgL_testz00_4666 = 
(BgL_auxz00_4667==((long)-1)); } 
if(BgL_testz00_4666)
{ /* Ast/unit.scm 339 */
{ /* Ast/unit.scm 340 */
obj_t BgL_arg4036z00_2051;obj_t BgL_arg4037z00_2052;
BgL_arg4036z00_2051 = 
CNST_TABLE_REF(((long)11)); 
{ /* Ast/unit.scm 340 */
obj_t BgL_arg4040z00_2053;obj_t BgL_arg4041z00_2054;
BgL_arg4040z00_2053 = 
MAKE_PAIR(BgL_varz00_2039, BgL_argsz00_2009); 
{ /* Ast/unit.scm 341 */
obj_t BgL_arg4045z00_2055;
{ /* Ast/unit.scm 341 */
obj_t BgL_arg4049z00_2057;obj_t BgL_arg4050z00_2058;
BgL_arg4049z00_2057 = 
CNST_TABLE_REF(((long)15)); 
{ /* Ast/unit.scm 341 */
obj_t BgL_arg4053z00_2059;
BgL_arg4053z00_2059 = 
MAKE_PAIR(BgL_argsz00_2009, BNIL); 
BgL_arg4050z00_2058 = 
MAKE_PAIR(BgL_id2z00_2040, BgL_arg4053z00_2059); } 
BgL_arg4045z00_2055 = 
MAKE_PAIR(BgL_arg4049z00_2057, BgL_arg4050z00_2058); } 
BgL_arg4041z00_2054 = 
MAKE_PAIR(BgL_arg4045z00_2055, BNIL); } 
BgL_arg4037z00_2052 = 
MAKE_PAIR(BgL_arg4040z00_2053, BgL_arg4041z00_2054); } 
BgL_arg4000z00_3217 = 
MAKE_PAIR(BgL_arg4036z00_2051, BgL_arg4037z00_2052); } }  else 
{ /* Ast/unit.scm 339 */
{ /* Ast/unit.scm 343 */
obj_t BgL_arg4057z00_2060;obj_t BgL_arg4058z00_2061;
BgL_arg4057z00_2060 = 
CNST_TABLE_REF(((long)11)); 
{ /* Ast/unit.scm 343 */
obj_t BgL_arg4061z00_2062;obj_t BgL_arg4062z00_2063;
BgL_arg4061z00_2062 = 
MAKE_PAIR(BgL_varz00_2039, BgL_argsz00_2009); 
{ /* Ast/unit.scm 344 */
obj_t BgL_arg4066z00_2064;
{ /* Ast/unit.scm 344 */
obj_t BgL_arg4070z00_2066;obj_t BgL_arg4071z00_2067;
BgL_arg4070z00_2066 = 
CNST_TABLE_REF(((long)15)); 
{ /* Ast/unit.scm 344 */
obj_t BgL_arg4074z00_2068;
{ /* Ast/unit.scm 344 */
obj_t BgL_arg4077z00_2069;
{ /* Ast/unit.scm 344 */
obj_t BgL_arg4081z00_2071;obj_t BgL_arg4082z00_2072;
BgL_arg4081z00_2071 = 
CNST_TABLE_REF(((long)16)); 
{ /* Ast/unit.scm 344 */
obj_t BgL_arg4085z00_2073;
BgL_arg4085z00_2073 = 
BGl_argsza2zd2ze3argszd2listz41zztools_argsz00(BgL_argsz00_2009); 
BgL_arg4082z00_2072 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg4085z00_2073, BNIL); } 
BgL_arg4077z00_2069 = 
MAKE_PAIR(BgL_arg4081z00_2071, BgL_arg4082z00_2072); } 
BgL_arg4074z00_2068 = 
MAKE_PAIR(BgL_arg4077z00_2069, BNIL); } 
BgL_arg4071z00_2067 = 
MAKE_PAIR(BgL_id2z00_2040, BgL_arg4074z00_2068); } 
BgL_arg4066z00_2064 = 
MAKE_PAIR(BgL_arg4070z00_2066, BgL_arg4071z00_2067); } 
BgL_arg4062z00_2063 = 
MAKE_PAIR(BgL_arg4066z00_2064, BNIL); } 
BgL_arg4058z00_2061 = 
MAKE_PAIR(BgL_arg4061z00_2062, BgL_arg4062z00_2063); } 
BgL_arg4000z00_3217 = 
MAKE_PAIR(BgL_arg4057z00_2060, BgL_arg4058z00_2061); } } } } 
return 
BGl_replacez12z12zztools_miscz00(BgL_sexpz00_35, BgL_arg4000z00_3217);} } }  else 
{ /* Ast/unit.scm 345 */
return BFALSE;} }  else 
{ /* Ast/unit.scm 345 */
return BFALSE;} }  else 
{ /* Ast/unit.scm 345 */
return BFALSE;} }  else 
{ /* Ast/unit.scm 345 */
return BFALSE;} } }  else 
{ /* Ast/unit.scm 345 */
return BFALSE;} } } } 
}



/* make-sfun-definition */
obj_t BGl_makezd2sfunzd2definitionz00zzast_unitz00(obj_t BgL_idz00_37, obj_t BgL_modulez00_38, obj_t BgL_argsz00_39, obj_t BgL_bodyz00_40, obj_t BgL_srcz00_41, obj_t BgL_classz00_42)
{ AN_OBJECT;
{ /* Ast/unit.scm 356 */
{ /* Ast/unit.scm 357 */
obj_t BgL_locz00_2126;
BgL_locz00_2126 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_srcz00_41); 
{ /* Ast/unit.scm 357 */
obj_t BgL_localsz00_2127;
{ 
obj_t BgL_argsz00_2131;obj_t BgL_resz00_2132;
BgL_argsz00_2131 = BgL_argsz00_39; 
BgL_resz00_2132 = BNIL; 
BgL_loopz00_2133:
if(
NULLP(BgL_argsz00_2131))
{ /* Ast/unit.scm 361 */
BgL_localsz00_2127 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_resz00_2132); }  else 
{ /* Ast/unit.scm 361 */
if(
PAIRP(BgL_argsz00_2131))
{ /* Ast/unit.scm 372 */
bool_t BgL_test4207z00_2136;
{ /* Ast/unit.scm 372 */
obj_t BgL_auxz00_4699;
BgL_auxz00_4699 = 
BGl_dssslzd2namedzd2constantzf3zf3zztools_dssslz00(
CAR(BgL_argsz00_2131)); 
BgL_test4207z00_2136 = 
CBOOL(BgL_auxz00_4699); } 
if(BgL_test4207z00_2136)
{ /* Ast/unit.scm 372 */
{ /* Ast/unit.scm 373 */
obj_t BgL_argz00_2137;
BgL_argz00_2137 = 
BGl_dssslzd2findzd2firstzd2formalzd2zztools_dssslz00(BgL_argsz00_2131); 
if(
CBOOL(BgL_argz00_2137))
{ /* Ast/unit.scm 376 */
obj_t BgL_arg4209z00_2138;
{ /* Ast/unit.scm 376 */
BgL_localz00_bglt BgL_arg4212z00_2139;
BgL_arg4212z00_2139 = 
BGl_makezd2userzd2localzd2svarzd2zzast_localz00(BgL_argz00_2137, 
(BgL_typez00_bglt)(BGl_za2objza2z00zztype_cachez00)); 
{ /* Ast/unit.scm 376 */
obj_t BgL_auxz00_4709;
BgL_auxz00_4709 = 
(obj_t)(BgL_arg4212z00_2139); 
BgL_arg4209z00_2138 = 
MAKE_PAIR(BgL_auxz00_4709, BgL_resz00_2132); } } 
BgL_localsz00_2127 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_arg4209z00_2138); }  else 
{ /* Ast/unit.scm 374 */
BgL_localsz00_2127 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_resz00_2132); } } }  else 
{ /* Ast/unit.scm 372 */
{ /* Ast/unit.scm 379 */
obj_t BgL_pidz00_2140;
{ /* Ast/unit.scm 379 */
obj_t BgL_arg4232z00_2147;
BgL_arg4232z00_2147 = 
BGl_parsezd2idzd2zzast_identz00(
CAR(BgL_argsz00_2131), BgL_locz00_2126); 
BgL_pidz00_2140 = 
BGl_checkzd2idzd2zzast_identz00(BgL_arg4232z00_2147, BgL_srcz00_41); } 
{ /* Ast/unit.scm 379 */
obj_t BgL_idz00_2141;
BgL_idz00_2141 = 
CAR(BgL_pidz00_2140); 
{ /* Ast/unit.scm 381 */
obj_t BgL_typez00_2142;
BgL_typez00_2142 = 
CDR(BgL_pidz00_2140); 
{ /* Ast/unit.scm 382 */

{ /* Ast/unit.scm 383 */
obj_t BgL_arg4218z00_2143;obj_t BgL_arg4219z00_2144;
BgL_arg4218z00_2143 = 
CDR(BgL_argsz00_2131); 
{ /* Ast/unit.scm 384 */
BgL_localz00_bglt BgL_arg4223z00_2145;
{ /* Ast/unit.scm 384 */
bool_t BgL_test4225z00_2146;
BgL_test4225z00_2146 = 
BGl_userzd2symbolzf3z21zzast_identz00(BgL_idz00_2141); 
if(BgL_test4225z00_2146)
{ /* Ast/unit.scm 384 */
BgL_arg4223z00_2145 = 
BGl_makezd2userzd2localzd2svarzd2zzast_localz00(BgL_idz00_2141, 
(BgL_typez00_bglt)(BgL_typez00_2142)); }  else 
{ /* Ast/unit.scm 384 */
BgL_arg4223z00_2145 = 
BGl_makezd2localzd2svarz00zzast_localz00(BgL_idz00_2141, 
(BgL_typez00_bglt)(BgL_typez00_2142)); } } 
{ /* Ast/unit.scm 384 */
obj_t BgL_auxz00_4726;
BgL_auxz00_4726 = 
(obj_t)(BgL_arg4223z00_2145); 
BgL_arg4219z00_2144 = 
MAKE_PAIR(BgL_auxz00_4726, BgL_resz00_2132); } } 
{ 
obj_t BgL_resz00_4730;obj_t BgL_argsz00_4729;
BgL_argsz00_4729 = BgL_arg4218z00_2143; 
BgL_resz00_4730 = BgL_arg4219z00_2144; 
BgL_resz00_2132 = BgL_resz00_4730; 
BgL_argsz00_2131 = BgL_argsz00_4729; 
goto BgL_loopz00_2133;} } } } } } } }  else 
{ /* Ast/unit.scm 363 */
{ /* Ast/unit.scm 364 */
obj_t BgL_pidz00_2150;
{ /* Ast/unit.scm 364 */
obj_t BgL_arg4252z00_2155;
BgL_arg4252z00_2155 = 
BGl_parsezd2idzd2zzast_identz00(BgL_argsz00_2131, BgL_locz00_2126); 
BgL_pidz00_2150 = 
BGl_checkzd2idzd2zzast_identz00(BgL_arg4252z00_2155, BgL_srcz00_41); } 
{ /* Ast/unit.scm 366 */

{ /* Ast/unit.scm 370 */
obj_t BgL_arg4243z00_2153;
{ /* Ast/unit.scm 370 */
BgL_localz00_bglt BgL_arg4246z00_2154;
{ /* Ast/unit.scm 370 */
BgL_typez00_bglt BgL_auxz00_4733;
{ /* Ast/unit.scm 370 */
obj_t BgL_auxz00_4735;
BgL_auxz00_4735 = 
CDR(BgL_pidz00_2150); 
BgL_auxz00_4733 = 
(BgL_typez00_bglt)(BgL_auxz00_4735); } 
BgL_arg4246z00_2154 = 
BGl_makezd2userzd2localzd2svarzd2zzast_localz00(
CAR(BgL_pidz00_2150), BgL_auxz00_4733); } 
{ /* Ast/unit.scm 370 */
obj_t BgL_auxz00_4739;
BgL_auxz00_4739 = 
(obj_t)(BgL_arg4246z00_2154); 
BgL_arg4243z00_2153 = 
MAKE_PAIR(BgL_auxz00_4739, BgL_resz00_2132); } } 
BgL_localsz00_2127 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_arg4243z00_2153); } } } } } } 
{ /* Ast/unit.scm 358 */
obj_t BgL_bodyz00_2128;
BgL_bodyz00_2128 = 
BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00(BgL_idz00_37, BgL_argsz00_39, BgL_bodyz00_40, BGl_userzd2errorzd2envz00zztools_errorz00); 
{ /* Ast/unit.scm 388 */

{ /* Ast/unit.scm 389 */
BgL_globalz00_bglt BgL_arg4197z00_2129;
BgL_arg4197z00_2129 = 
BGl_defzd2globalzd2sfunz12z12zzast_glozd2defzd2(BgL_idz00_37, BgL_argsz00_39, BgL_localsz00_2127, BgL_modulez00_38, BgL_classz00_42, BgL_srcz00_41, 
CNST_TABLE_REF(((long)17)), BgL_bodyz00_2128); 
{ /* Ast/unit.scm 389 */
obj_t BgL_list4199z00_2130;
{ /* Ast/unit.scm 389 */
obj_t BgL_auxz00_4746;
BgL_auxz00_4746 = 
(obj_t)(BgL_arg4197z00_2129); 
BgL_list4199z00_2130 = 
MAKE_PAIR(BgL_auxz00_4746, BNIL); } 
return BgL_list4199z00_2130;} } } } } } } 
}



/* make-svar-definition */
obj_t BGl_makezd2svarzd2definitionz00zzast_unitz00(obj_t BgL_idz00_43, obj_t BgL_srcz00_44)
{ AN_OBJECT;
{ /* Ast/unit.scm 394 */
BGl_defzd2globalzd2svarz12z12zzast_glozd2defzd2(BgL_idz00_43, BGl_za2moduleza2z00zzmodule_modulez00, BgL_srcz00_44, 
CNST_TABLE_REF(((long)17))); 
{ /* Ast/unit.scm 398 */
obj_t BgL_arg4260z00_2156;obj_t BgL_arg4261z00_2157;
BgL_arg4260z00_2156 = 
CDR(BgL_srcz00_44); 
{ /* Ast/unit.scm 398 */
obj_t BgL_arg4265z00_2158;
{ /* Ast/unit.scm 398 */
obj_t BgL_arg4268z00_2159;
{ /* Ast/unit.scm 398 */
obj_t BgL_arg4271z00_2160;
BgL_arg4271z00_2160 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_srcz00_44); 
BgL_arg4268z00_2159 = 
BGl_parsezd2idzd2zzast_identz00(BgL_idz00_43, BgL_arg4271z00_2160); } 
BgL_arg4265z00_2158 = 
BGl_checkzd2idzd2zzast_identz00(BgL_arg4268z00_2159, BgL_srcz00_44); } 
BgL_arg4261z00_2157 = 
CAR(BgL_arg4265z00_2158); } 
SET_CAR(BgL_arg4260z00_2156, BgL_arg4261z00_2157); } 
{ /* Ast/unit.scm 399 */
obj_t BgL_list4275z00_2161;
BgL_list4275z00_2161 = 
MAKE_PAIR(BgL_srcz00_44, BNIL); 
return BgL_list4275z00_2161;} } 
}



/* make-sgfun-default */
obj_t BGl_makezd2sgfunzd2defaultz00zzast_unitz00(obj_t BgL_namez00_45, obj_t BgL_typez00_46, obj_t BgL_argsz00_47, obj_t BgL_bodyz00_48, obj_t BgL_srcz00_49, obj_t BgL_gdefsz00_50)
{ AN_OBJECT;
{ /* Ast/unit.scm 404 */
{ /* Ast/unit.scm 406 */
obj_t BgL_defaultzd2tidzd2_2163;
{ /* Ast/unit.scm 407 */
bool_t BgL_test4339z00_2193;
BgL_test4339z00_2193 = 
(BgL_typez00_46==BGl_za2_za2z00zztype_cachez00); 
if(BgL_test4339z00_2193)
{ /* Ast/unit.scm 407 */
BgL_defaultzd2tidzd2_2163 = BgL_namez00_45; }  else 
{ /* Ast/unit.scm 409 */
obj_t BgL_auxz00_4760;
{ /* Ast/unit.scm 409 */
BgL_typez00_bglt BgL_obj1003z00_3246;
BgL_obj1003z00_3246 = 
(BgL_typez00_bglt)(BgL_typez00_46); 
BgL_auxz00_4760 = 
(((BgL_typez00_bglt)CREF(BgL_obj1003z00_3246))->BgL_idz00); } 
BgL_defaultzd2tidzd2_2163 = 
BGl_makezd2typedzd2identz00zzast_identz00(BgL_namez00_45, BgL_auxz00_4760); } } 
{ /* Ast/unit.scm 407 */
obj_t BgL_defaultzd2bodyzd2_2164;
if(
PAIRP(BgL_bodyz00_48))
{ /* Ast/unit.scm 410 */
BgL_defaultzd2bodyzd2_2164 = 
BGl_normaliza7ezd2prognz75zztools_prognz00(BgL_bodyz00_48); }  else 
{ /* Ast/unit.scm 415 */
obj_t BgL_arg4312z00_2181;obj_t BgL_arg4313z00_2182;
BgL_arg4312z00_2181 = 
CNST_TABLE_REF(((long)18)); 
{ /* Ast/unit.scm 412 */
obj_t BgL_arg4316z00_2183;obj_t BgL_arg4317z00_2184;
{ /* Ast/unit.scm 412 */
obj_t BgL_arg4320z00_2185;obj_t BgL_arg4321z00_2186;
BgL_arg4320z00_2185 = 
CNST_TABLE_REF(((long)19)); 
BgL_arg4321z00_2186 = 
MAKE_PAIR(BgL_namez00_45, BNIL); 
BgL_arg4316z00_2183 = 
MAKE_PAIR(BgL_arg4320z00_2185, BgL_arg4321z00_2186); } 
{ /* Ast/unit.scm 412 */
obj_t BgL_arg4326z00_2188;
{ /* Ast/unit.scm 414 */
obj_t BgL_arg4329z00_2189;
{ /* Ast/unit.scm 414 */
obj_t BgL_arg4333z00_2191;obj_t BgL_arg4334z00_2192;
BgL_arg4333z00_2191 = 
CAR(BgL_argsz00_47); 
BgL_arg4334z00_2192 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_srcz00_49); 
BgL_arg4329z00_2189 = 
BGl_idzd2ofzd2idz00zzast_identz00(BgL_arg4333z00_2191, BgL_arg4334z00_2192); } 
BgL_arg4326z00_2188 = 
MAKE_PAIR(BgL_arg4329z00_2189, BNIL); } 
BgL_arg4317z00_2184 = 
MAKE_PAIR(BGl_string5092z00zzast_unitz00, BgL_arg4326z00_2188); } 
BgL_arg4313z00_2182 = 
MAKE_PAIR(BgL_arg4316z00_2183, BgL_arg4317z00_2184); } 
BgL_defaultzd2bodyzd2_2164 = 
MAKE_PAIR(BgL_arg4312z00_2181, BgL_arg4313z00_2182); } 
{ /* Ast/unit.scm 410 */
obj_t BgL_formz00_2165;
{ /* Ast/unit.scm 416 */
obj_t BgL_tmpz00_2171;
{ /* Ast/unit.scm 416 */
obj_t BgL_arg4300z00_2176;obj_t BgL_arg4301z00_2177;
BgL_arg4300z00_2176 = 
CNST_TABLE_REF(((long)11)); 
{ /* Ast/unit.scm 416 */
obj_t BgL_arg4304z00_2178;obj_t BgL_arg4305z00_2179;
BgL_arg4304z00_2178 = 
MAKE_PAIR(BgL_defaultzd2tidzd2_2163, BgL_argsz00_47); 
BgL_arg4305z00_2179 = 
MAKE_PAIR(BgL_defaultzd2bodyzd2_2164, BNIL); 
BgL_arg4301z00_2177 = 
MAKE_PAIR(BgL_arg4304z00_2178, BgL_arg4305z00_2179); } 
BgL_tmpz00_2171 = 
MAKE_PAIR(BgL_arg4300z00_2176, BgL_arg4301z00_2177); } 
{ /* Ast/unit.scm 417 */
bool_t BgL_test4289z00_2172;
{ /* Ast/unit.scm 417 */
obj_t BgL_objz00_3249;
BgL_objz00_3249 = BGl_za2modulezd2clauseza2zd2zzmodule_modulez00; 
BgL_test4289z00_2172 = 
EXTENDED_PAIRP(BgL_objz00_3249); } 
if(BgL_test4289z00_2172)
{ /* Ast/unit.scm 418 */
obj_t BgL_arg4293z00_2175;
{ /* Ast/unit.scm 418 */
obj_t BgL_objz00_3252;
BgL_objz00_3252 = BGl_za2modulezd2clauseza2zd2zzmodule_modulez00; 
BgL_arg4293z00_2175 = 
CER(BgL_objz00_3252); } 
{ /* Ast/unit.scm 418 */
obj_t BgL_res5004z00_3256;
{ /* Ast/unit.scm 418 */
obj_t BgL_auxz00_4788;obj_t BgL_auxz00_4786;
BgL_auxz00_4788 = 
CDR(BgL_tmpz00_2171); 
BgL_auxz00_4786 = 
CAR(BgL_tmpz00_2171); 
BgL_res5004z00_3256 = 
MAKE_EXTENDED_PAIR(BgL_auxz00_4786, BgL_auxz00_4788, BgL_arg4293z00_2175); } 
BgL_formz00_2165 = BgL_res5004z00_3256; } }  else 
{ /* Ast/unit.scm 417 */
BgL_formz00_2165 = BgL_tmpz00_2171; } } } 
{ /* Ast/unit.scm 416 */

{ /* Ast/unit.scm 421 */
obj_t BgL_astz00_2166;
BgL_astz00_2166 = 
BGl_toplevelzd2ze3astz31zzast_unitz00(BgL_formz00_2165, BgL_gdefsz00_50); 
if(
PAIRP(BgL_astz00_2166))
{ /* Ast/unit.scm 424 */
bool_t BgL_test4278z00_2168;
BgL_test4278z00_2168 = 
BGl_iszd2azf3z21zz__objectz00(
CAR(BgL_astz00_2166), BGl_globalz00zzast_varz00); 
if(BgL_test4278z00_2168)
{ /* Ast/unit.scm 428 */
BgL_globalz00_bglt BgL_obj1185z00_3261;
{ /* Ast/unit.scm 428 */
obj_t BgL_auxz00_4797;
BgL_auxz00_4797 = 
CAR(BgL_astz00_2166); 
BgL_obj1185z00_3261 = 
(BgL_globalz00_bglt)(BgL_auxz00_4797); } 
((((BgL_globalz00_bglt)CREF(BgL_obj1185z00_3261))->BgL_userzf3zf3) = ((bool_t)((bool_t)1)), BUNSPEC); }  else 
{ /* Ast/unit.scm 424 */BFALSE; } }  else 
{ /* Ast/unit.scm 423 */BFALSE; } 
return BgL_astz00_2166;} } } } } } 
}



/* make-sgfun-definition */
obj_t BGl_makezd2sgfunzd2definitionz00zzast_unitz00(obj_t BgL_idz00_51, obj_t BgL_modulez00_52, obj_t BgL_argsz00_53, obj_t BgL_bodyz00_54, obj_t BgL_srcz00_55, obj_t BgL_gdefsz00_56)
{ AN_OBJECT;
{ /* Ast/unit.scm 434 */
{ /* Ast/unit.scm 437 */
obj_t BgL_locz00_2195;
BgL_locz00_2195 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_srcz00_55); 
{ /* Ast/unit.scm 437 */
obj_t BgL_localsz00_2196;
if(
NULLP(BgL_argsz00_53))
{ /* Ast/unit.scm 438 */
BgL_localsz00_2196 = 
BGl_userzd2errorzd2zztools_errorz00(BgL_idz00_51, BGl_string5093z00zzast_unitz00, BgL_srcz00_55, BNIL); }  else 
{ 
obj_t BgL_argsz00_2232;obj_t BgL_resz00_2233;
BgL_argsz00_2232 = BgL_argsz00_53; 
BgL_resz00_2233 = BNIL; 
BgL_loopz00_2234:
if(
NULLP(BgL_argsz00_2232))
{ /* Ast/unit.scm 445 */
BgL_localsz00_2196 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_resz00_2233); }  else 
{ /* Ast/unit.scm 445 */
if(
PAIRP(BgL_argsz00_2232))
{ /* Ast/unit.scm 447 */
{ /* Ast/unit.scm 457 */
obj_t BgL_pidz00_2237;
{ /* Ast/unit.scm 457 */
obj_t BgL_arg4432z00_2243;
BgL_arg4432z00_2243 = 
BGl_parsezd2idzd2zzast_identz00(
CAR(BgL_argsz00_2232), BgL_locz00_2195); 
BgL_pidz00_2237 = 
BGl_checkzd2idzd2zzast_identz00(BgL_arg4432z00_2243, BgL_srcz00_55); } 
{ /* Ast/unit.scm 460 */

{ /* Ast/unit.scm 461 */
obj_t BgL_arg4421z00_2240;obj_t BgL_arg4422z00_2241;
BgL_arg4421z00_2240 = 
CDR(BgL_argsz00_2232); 
{ /* Ast/unit.scm 462 */
BgL_localz00_bglt BgL_arg4426z00_2242;
{ /* Ast/unit.scm 462 */
BgL_typez00_bglt BgL_auxz00_4814;
{ /* Ast/unit.scm 462 */
obj_t BgL_auxz00_4816;
BgL_auxz00_4816 = 
CDR(BgL_pidz00_2237); 
BgL_auxz00_4814 = 
(BgL_typez00_bglt)(BgL_auxz00_4816); } 
BgL_arg4426z00_2242 = 
BGl_makezd2userzd2localzd2svarzd2zzast_localz00(
CAR(BgL_pidz00_2237), BgL_auxz00_4814); } 
{ /* Ast/unit.scm 462 */
obj_t BgL_auxz00_4820;
BgL_auxz00_4820 = 
(obj_t)(BgL_arg4426z00_2242); 
BgL_arg4422z00_2241 = 
MAKE_PAIR(BgL_auxz00_4820, BgL_resz00_2233); } } 
{ 
obj_t BgL_resz00_4824;obj_t BgL_argsz00_4823;
BgL_argsz00_4823 = BgL_arg4421z00_2240; 
BgL_resz00_4824 = BgL_arg4422z00_2241; 
BgL_resz00_2233 = BgL_resz00_4824; 
BgL_argsz00_2232 = BgL_argsz00_4823; 
goto BgL_loopz00_2234;} } } } }  else 
{ /* Ast/unit.scm 447 */
{ /* Ast/unit.scm 448 */
obj_t BgL_pidz00_2245;
{ /* Ast/unit.scm 448 */
obj_t BgL_arg4448z00_2250;
BgL_arg4448z00_2250 = 
BGl_parsezd2idzd2zzast_identz00(BgL_argsz00_2232, BgL_locz00_2195); 
BgL_pidz00_2245 = 
BGl_checkzd2idzd2zzast_identz00(BgL_arg4448z00_2250, BgL_srcz00_55); } 
{ /* Ast/unit.scm 450 */

{ /* Ast/unit.scm 454 */
obj_t BgL_arg4439z00_2248;
{ /* Ast/unit.scm 454 */
BgL_localz00_bglt BgL_arg4442z00_2249;
{ /* Ast/unit.scm 454 */
BgL_typez00_bglt BgL_auxz00_4827;
{ /* Ast/unit.scm 454 */
obj_t BgL_auxz00_4829;
BgL_auxz00_4829 = 
CDR(BgL_pidz00_2245); 
BgL_auxz00_4827 = 
(BgL_typez00_bglt)(BgL_auxz00_4829); } 
BgL_arg4442z00_2249 = 
BGl_makezd2userzd2localzd2svarzd2zzast_localz00(
CAR(BgL_pidz00_2245), BgL_auxz00_4827); } 
{ /* Ast/unit.scm 454 */
obj_t BgL_auxz00_4833;
BgL_auxz00_4833 = 
(obj_t)(BgL_arg4442z00_2249); 
BgL_arg4439z00_2248 = 
MAKE_PAIR(BgL_auxz00_4833, BgL_resz00_2233); } } 
BgL_localsz00_2196 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_arg4439z00_2248); } } } } } } 
{ /* Ast/unit.scm 438 */
obj_t BgL_pidz00_2197;
{ /* Ast/unit.scm 464 */
obj_t BgL_arg4410z00_2229;
BgL_arg4410z00_2229 = 
BGl_parsezd2idzd2zzast_identz00(BgL_idz00_51, BgL_locz00_2195); 
BgL_pidz00_2197 = 
BGl_checkzd2idzd2zzast_identz00(BgL_arg4410z00_2229, BgL_srcz00_55); } 
{ /* Ast/unit.scm 464 */
obj_t BgL_namez00_2198;
BgL_namez00_2198 = 
CAR(BgL_pidz00_2197); 
{ /* Ast/unit.scm 465 */
obj_t BgL_typez00_2199;
BgL_typez00_2199 = 
CDR(BgL_pidz00_2197); 
{ /* Ast/unit.scm 466 */
obj_t BgL_dnamez00_2200;
{ /* Ast/unit.scm 467 */
obj_t BgL_arg4399z00_2226;
{ /* Ast/unit.scm 467 */
obj_t BgL_list4402z00_2227;
{ /* Ast/unit.scm 467 */
obj_t BgL_arg4404z00_2228;
{ /* Ast/unit.scm 467 */
obj_t BgL_auxz00_4841;
BgL_auxz00_4841 = 
CNST_TABLE_REF(((long)20)); 
BgL_arg4404z00_2228 = 
MAKE_PAIR(BgL_auxz00_4841, BNIL); } 
BgL_list4402z00_2227 = 
MAKE_PAIR(BgL_namez00_2198, BgL_arg4404z00_2228); } 
BgL_arg4399z00_2226 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list4402z00_2227); } 
BgL_dnamez00_2200 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, BgL_arg4399z00_2226, BEOA); } 
{ /* Ast/unit.scm 467 */
obj_t BgL_defaultz00_2201;
{ /* Ast/unit.scm 468 */
bool_t BgL_test4395z00_2225;
BgL_test4395z00_2225 = 
(BgL_modulez00_52==BGl_za2moduleza2z00zzmodule_modulez00); 
if(BgL_test4395z00_2225)
{ /* Ast/unit.scm 468 */
BgL_defaultz00_2201 = 
BGl_makezd2sgfunzd2defaultz00zzast_unitz00(BgL_dnamez00_2200, BgL_typez00_2199, BgL_argsz00_53, BgL_bodyz00_54, BgL_srcz00_55, BgL_gdefsz00_56); }  else 
{ /* Ast/unit.scm 468 */
BgL_defaultz00_2201 = BNIL; } } 
{ /* Ast/unit.scm 468 */
obj_t BgL_bodyz00_2202;
BgL_bodyz00_2202 = 
BGl_makezd2genericzd2bodyz00zzobject_genericz00(BgL_idz00_51, BgL_localsz00_2196, BgL_argsz00_53, BgL_srcz00_55); 
{ /* Ast/unit.scm 471 */
BgL_globalz00_bglt BgL_genericz00_2203;
BgL_genericz00_2203 = 
BGl_defzd2globalzd2sfunz12z12zzast_glozd2defzd2(BgL_idz00_51, BgL_argsz00_53, BgL_localsz00_2196, BgL_modulez00_52, 
CNST_TABLE_REF(((long)21)), BgL_srcz00_55, 
CNST_TABLE_REF(((long)17)), BgL_bodyz00_2202); 
{ /* Ast/unit.scm 472 */

{ /* Ast/unit.scm 481 */
obj_t BgL_ozd2unitzd2_2204;obj_t BgL_sexpza2za2_2205;
BgL_ozd2unitzd2_2204 = 
BGl_getzd2methodzd2unitz00zzmodule_classz00(); 
{ /* Ast/unit.scm 483 */
obj_t BgL_arg4353z00_2208;
{ /* Ast/unit.scm 483 */
obj_t BgL_arg4356z00_2209;
{ /* Ast/unit.scm 483 */
obj_t BgL_arg4359z00_2210;
{ /* Ast/unit.scm 483 */
obj_t BgL_arg4364z00_2212;obj_t BgL_arg4365z00_2213;
BgL_arg4364z00_2212 = 
CNST_TABLE_REF(((long)22)); 
{ /* Ast/unit.scm 483 */
obj_t BgL_arg4368z00_2214;obj_t BgL_arg4369z00_2215;
{ /* Ast/unit.scm 483 */
obj_t BgL_arg4372z00_2216;obj_t BgL_arg4373z00_2217;
BgL_arg4372z00_2216 = 
CNST_TABLE_REF(((long)4)); 
{ /* Ast/unit.scm 483 */
obj_t BgL_arg4376z00_2218;obj_t BgL_arg4377z00_2219;
BgL_arg4376z00_2218 = 
(((BgL_globalz00_bglt)CREF(BgL_genericz00_2203))->BgL_idz00); 
BgL_arg4377z00_2219 = 
MAKE_PAIR(BgL_modulez00_52, BNIL); 
BgL_arg4373z00_2217 = 
MAKE_PAIR(BgL_arg4376z00_2218, BgL_arg4377z00_2219); } 
BgL_arg4368z00_2214 = 
MAKE_PAIR(BgL_arg4372z00_2216, BgL_arg4373z00_2217); } 
{ /* Ast/unit.scm 485 */
obj_t BgL_arg4382z00_2220;
{ /* Ast/unit.scm 485 */
obj_t BgL_arg4386z00_2222;obj_t BgL_arg4387z00_2223;
BgL_arg4386z00_2222 = 
CNST_TABLE_REF(((long)4)); 
{ /* Ast/unit.scm 485 */
obj_t BgL_arg4390z00_2224;
BgL_arg4390z00_2224 = 
MAKE_PAIR(BGl_za2moduleza2z00zzmodule_modulez00, BNIL); 
BgL_arg4387z00_2223 = 
MAKE_PAIR(BgL_dnamez00_2200, BgL_arg4390z00_2224); } 
BgL_arg4382z00_2220 = 
MAKE_PAIR(BgL_arg4386z00_2222, BgL_arg4387z00_2223); } 
BgL_arg4369z00_2215 = 
MAKE_PAIR(BgL_arg4382z00_2220, BNIL); } 
BgL_arg4365z00_2213 = 
MAKE_PAIR(BgL_arg4368z00_2214, BgL_arg4369z00_2215); } 
BgL_arg4359z00_2210 = 
MAKE_PAIR(BgL_arg4364z00_2212, BgL_arg4365z00_2213); } 
{ /* Ast/unit.scm 483 */
obj_t BgL_list4361z00_2211;
BgL_list4361z00_2211 = 
MAKE_PAIR(BgL_arg4359z00_2210, BNIL); 
BgL_arg4356z00_2209 = BgL_list4361z00_2211; } } 
BgL_arg4353z00_2208 = 
bgl_append2(BgL_arg4356z00_2209, BgL_defaultz00_2201); } 
{ /* Ast/unit.scm 482 */
obj_t BgL_auxz00_4871;
BgL_auxz00_4871 = 
(obj_t)(BgL_genericz00_2203); 
BgL_sexpza2za2_2205 = 
MAKE_PAIR(BgL_auxz00_4871, BgL_arg4353z00_2208); } } 
{ /* Ast/unit.scm 487 */
bool_t BgL_testz00_4874;
if(
STRUCTP(BgL_ozd2unitzd2_2204))
{ /* Ast/unit.scm 487 */
obj_t BgL_auxz00_4879;obj_t BgL_auxz00_4877;
BgL_auxz00_4879 = 
CNST_TABLE_REF(((long)23)); 
BgL_auxz00_4877 = 
STRUCT_KEY(BgL_ozd2unitzd2_2204); 
BgL_testz00_4874 = 
(BgL_auxz00_4877==BgL_auxz00_4879); }  else 
{ /* Ast/unit.scm 487 */
BgL_testz00_4874 = ((bool_t)0)
; } 
if(BgL_testz00_4874)
{ /* Ast/unit.scm 487 */
BGl_unitzd2sexpza2zd2addz12zb0zzast_unitz00(BgL_ozd2unitzd2_2204, BgL_sexpza2za2_2205); 
{ /* Ast/unit.scm 491 */
obj_t BgL_list4348z00_2207;
BgL_list4348z00_2207 = 
MAKE_PAIR(BUNSPEC, BNIL); 
return BgL_list4348z00_2207;} }  else 
{ /* Ast/unit.scm 487 */
return BgL_sexpza2za2_2205;} } } } } } } } } } } } } } 
}



/* make-method-definition */
obj_t BGl_makezd2methodzd2definitionz00zzast_unitz00(obj_t BgL_idz00_57, obj_t BgL_argsz00_58, obj_t BgL_bodyz00_59, obj_t BgL_srcz00_60)
{ AN_OBJECT;
{ /* Ast/unit.scm 496 */
{ /* Ast/unit.scm 497 */
obj_t BgL_locz00_2251;
BgL_locz00_2251 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_srcz00_60); 
{ /* Ast/unit.scm 497 */
obj_t BgL_localsz00_2252;
{ 
obj_t BgL_argsz00_2259;obj_t BgL_resz00_2260;
BgL_argsz00_2259 = BgL_argsz00_58; 
BgL_resz00_2260 = BNIL; 
BgL_loopz00_2261:
if(
NULLP(BgL_argsz00_2259))
{ /* Ast/unit.scm 501 */
BgL_localsz00_2252 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_resz00_2260); }  else 
{ /* Ast/unit.scm 501 */
if(
PAIRP(BgL_argsz00_2259))
{ /* Ast/unit.scm 503 */
{ /* Ast/unit.scm 512 */
obj_t BgL_pidz00_2264;
{ /* Ast/unit.scm 512 */
obj_t BgL_arg4484z00_2270;
BgL_arg4484z00_2270 = 
BGl_parsezd2idzd2zzast_identz00(
CAR(BgL_argsz00_2259), BgL_locz00_2251); 
BgL_pidz00_2264 = 
BGl_checkzd2idzd2zzast_identz00(BgL_arg4484z00_2270, BgL_srcz00_60); } 
{ /* Ast/unit.scm 514 */

{ /* Ast/unit.scm 515 */
obj_t BgL_arg4473z00_2267;obj_t BgL_arg4474z00_2268;
BgL_arg4473z00_2267 = 
CDR(BgL_argsz00_2259); 
{ /* Ast/unit.scm 516 */
BgL_localz00_bglt BgL_arg4478z00_2269;
{ /* Ast/unit.scm 516 */
BgL_typez00_bglt BgL_auxz00_4894;
{ /* Ast/unit.scm 516 */
obj_t BgL_auxz00_4896;
BgL_auxz00_4896 = 
CDR(BgL_pidz00_2264); 
BgL_auxz00_4894 = 
(BgL_typez00_bglt)(BgL_auxz00_4896); } 
BgL_arg4478z00_2269 = 
BGl_makezd2localzd2svarz00zzast_localz00(
CAR(BgL_pidz00_2264), BgL_auxz00_4894); } 
{ /* Ast/unit.scm 516 */
obj_t BgL_auxz00_4900;
BgL_auxz00_4900 = 
(obj_t)(BgL_arg4478z00_2269); 
BgL_arg4474z00_2268 = 
MAKE_PAIR(BgL_auxz00_4900, BgL_resz00_2260); } } 
{ 
obj_t BgL_resz00_4904;obj_t BgL_argsz00_4903;
BgL_argsz00_4903 = BgL_arg4473z00_2267; 
BgL_resz00_4904 = BgL_arg4474z00_2268; 
BgL_resz00_2260 = BgL_resz00_4904; 
BgL_argsz00_2259 = BgL_argsz00_4903; 
goto BgL_loopz00_2261;} } } } }  else 
{ /* Ast/unit.scm 503 */
{ /* Ast/unit.scm 504 */
obj_t BgL_pidz00_2272;
{ /* Ast/unit.scm 504 */
obj_t BgL_arg4500z00_2277;
BgL_arg4500z00_2277 = 
BGl_parsezd2idzd2zzast_identz00(BgL_argsz00_2259, BgL_locz00_2251); 
BgL_pidz00_2272 = 
BGl_checkzd2idzd2zzast_identz00(BgL_arg4500z00_2277, BgL_srcz00_60); } 
{ /* Ast/unit.scm 506 */

{ /* Ast/unit.scm 510 */
obj_t BgL_arg4491z00_2275;
{ /* Ast/unit.scm 510 */
BgL_localz00_bglt BgL_arg4494z00_2276;
{ /* Ast/unit.scm 510 */
BgL_typez00_bglt BgL_auxz00_4907;
{ /* Ast/unit.scm 510 */
obj_t BgL_auxz00_4909;
BgL_auxz00_4909 = 
CDR(BgL_pidz00_2272); 
BgL_auxz00_4907 = 
(BgL_typez00_bglt)(BgL_auxz00_4909); } 
BgL_arg4494z00_2276 = 
BGl_makezd2localzd2svarz00zzast_localz00(
CAR(BgL_pidz00_2272), BgL_auxz00_4907); } 
{ /* Ast/unit.scm 510 */
obj_t BgL_auxz00_4913;
BgL_auxz00_4913 = 
(obj_t)(BgL_arg4494z00_2276); 
BgL_arg4491z00_2275 = 
MAKE_PAIR(BgL_auxz00_4913, BgL_resz00_2260); } } 
BgL_localsz00_2252 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_arg4491z00_2275); } } } } } } 
{ /* Ast/unit.scm 498 */

{ /* Ast/unit.scm 517 */
bool_t BgL_test4455z00_2253;
BgL_test4455z00_2253 = 
BGl_checkzd2methodzd2definitionz00zzast_glozd2defzd2(BgL_idz00_57, BgL_argsz00_58, BgL_localsz00_2252, BgL_srcz00_60); 
if(BgL_test4455z00_2253)
{ /* Ast/unit.scm 519 */
obj_t BgL_ozd2unitzd2_2254;obj_t BgL_sexpza2za2_2255;
BgL_ozd2unitzd2_2254 = 
BGl_getzd2methodzd2unitz00zzmodule_classz00(); 
BgL_sexpza2za2_2255 = 
BGl_makezd2methodzd2bodyz00zzobject_methodz00(BgL_idz00_57, BgL_argsz00_58, BgL_localsz00_2252, BgL_bodyz00_59, BgL_srcz00_60); 
{ /* Ast/unit.scm 521 */
bool_t BgL_testz00_4921;
if(
STRUCTP(BgL_ozd2unitzd2_2254))
{ /* Ast/unit.scm 521 */
obj_t BgL_auxz00_4926;obj_t BgL_auxz00_4924;
BgL_auxz00_4926 = 
CNST_TABLE_REF(((long)23)); 
BgL_auxz00_4924 = 
STRUCT_KEY(BgL_ozd2unitzd2_2254); 
BgL_testz00_4921 = 
(BgL_auxz00_4924==BgL_auxz00_4926); }  else 
{ /* Ast/unit.scm 521 */
BgL_testz00_4921 = ((bool_t)0)
; } 
if(BgL_testz00_4921)
{ /* Ast/unit.scm 521 */
BGl_unitzd2sexpza2zd2addz12zb0zzast_unitz00(BgL_ozd2unitzd2_2254, BgL_sexpza2za2_2255); 
{ /* Ast/unit.scm 525 */
obj_t BgL_list4459z00_2257;
BgL_list4459z00_2257 = 
MAKE_PAIR(BUNSPEC, BNIL); 
return BgL_list4459z00_2257;} }  else 
{ /* Ast/unit.scm 521 */
return BgL_sexpza2za2_2255;} } }  else 
{ /* Ast/unit.scm 518 */
obj_t BgL_list4465z00_2258;
BgL_list4465z00_2258 = 
MAKE_PAIR(BUNSPEC, BNIL); 
return BgL_list4465z00_2258;} } } } } } 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzast_unitz00()
{ AN_OBJECT;
{ /* Ast/unit.scm 21 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzast_unitz00()
{ AN_OBJECT;
{ /* Ast/unit.scm 21 */
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19010), "ast_unit"); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)28259), "ast_unit"); 
BGl_modulezd2initializa7ationz75zzast_nodez00(((long)49436), "ast_unit"); 
BGl_modulezd2initializa7ationz75zztools_tracez00(((long)64647), "ast_unit"); 
BGl_modulezd2initializa7ationz75zzast_findzd2gdefszd2(((long)63226), "ast_unit"); 
BGl_modulezd2initializa7ationz75zzast_glozd2defzd2(((long)8183), "ast_unit"); 
BGl_modulezd2initializa7ationz75zzast_identz00(((long)52188), "ast_unit"); 
BGl_modulezd2initializa7ationz75zzast_envz00(((long)73271), "ast_unit"); 
BGl_modulezd2initializa7ationz75zzast_localz00(((long)106367), "ast_unit"); 
BGl_modulezd2initializa7ationz75zzast_sexpz00(((long)26966), "ast_unit"); 
BGl_modulezd2initializa7ationz75zzobject_classz00(((long)19348), "ast_unit"); 
BGl_modulezd2initializa7ationz75zzobject_genericz00(((long)48751), "ast_unit"); 
BGl_modulezd2initializa7ationz75zzobject_methodz00(((long)28982), "ast_unit"); 
BGl_modulezd2initializa7ationz75zztools_prognz00(((long)55621), "ast_unit"); 
BGl_modulezd2initializa7ationz75zztools_argsz00(((long)54833), "ast_unit"); 
BGl_modulezd2initializa7ationz75zztools_miscz00(((long)63966), "ast_unit"); 
BGl_modulezd2initializa7ationz75zztools_speekz00(((long)23545), "ast_unit"); 
BGl_modulezd2initializa7ationz75zztools_shapez00(((long)30825), "ast_unit"); 
BGl_modulezd2initializa7ationz75zztools_locationz00(((long)30714), "ast_unit"); 
BGl_modulezd2initializa7ationz75zztools_errorz00(((long)17886), "ast_unit"); 
BGl_modulezd2initializa7ationz75zztools_dssslz00(((long)53421), "ast_unit"); 
BGl_modulezd2initializa7ationz75zzengine_paramz00(((long)189840), "ast_unit"); 
BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long)12859), "ast_unit"); 
BGl_modulezd2initializa7ationz75zzmodule_classz00(((long)33471), "ast_unit"); 
BGl_modulezd2initializa7ationz75zzmodule_includez00(((long)99), "ast_unit"); 
return 
BGl_modulezd2initializa7ationz75zztype_cachez00(((long)57983), "ast_unit");} 
}

