/*===========================================================================*/
/*   (Callcc/walk.scm)                                                       */
/*   Bigloo (2.5b)                                                           */
/*   Manuel Serrano (c)       Fri Sep 6 09:43:28 CEST 2002                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_nodez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
} *BgL_nodez00_bglt;

typedef struct BgL_nodezf2effectzf2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
} *BgL_nodezf2effectzf2_bglt;

typedef struct BgL_atomz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_atomz00_bglt;

typedef struct BgL_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_varz00_bglt;

typedef struct BgL_closurez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_closurez00_bglt;

typedef struct BgL_kwotez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_kwotez00_bglt;

typedef struct BgL_sequencez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_nodesz00;
} *BgL_sequencez00_bglt;

typedef struct BgL_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
} *BgL_appz00_bglt;

typedef struct BgL_appzd2lyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_appzd2lyzd2_bglt;

typedef struct BgL_funcallz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_strengthz00;
} *BgL_funcallz00_bglt;

typedef struct BgL_externz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_externz00_bglt;

typedef struct BgL_pragmaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_formatz00;
} *BgL_pragmaz00_bglt;

typedef struct BgL_getfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_getfieldz00_bglt;

typedef struct BgL_setfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_setfieldz00_bglt;

typedef struct BgL_newz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_newz00_bglt;

typedef struct BgL_vallocz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2heapzd2formatz00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_vallocz00_bglt;

typedef struct BgL_vrefz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vrefz00_bglt;

typedef struct BgL_vsetz12z12_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vsetz12z12_bglt;

typedef struct BgL_vlengthz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vlengthz00_bglt;

typedef struct BgL_isaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   struct BgL_typez00_bgl * BgL_classz00;
} *BgL_isaz00_bglt;

typedef struct BgL_castz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_castz00_bglt;

typedef struct BgL_setqz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_setqz00_bglt;

typedef struct BgL_conditionalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   struct BgL_nodez00_bgl * BgL_truez00;
   struct BgL_nodez00_bgl * BgL_falsez00;
} *BgL_conditionalz00_bglt;

typedef struct BgL_failz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_procz00;
   struct BgL_nodez00_bgl * BgL_msgz00;
   struct BgL_nodez00_bgl * BgL_objz00;
} *BgL_failz00_bglt;

typedef struct BgL_selectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   obj_t BgL_clausesz00;
   struct BgL_typez00_bgl * BgL_itemzd2typezd2;
} *BgL_selectz00_bglt;

typedef struct BgL_letzd2funzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_localsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_letzd2funzd2_bglt;

typedef struct BgL_letzd2varzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_bindingsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
   bool_t BgL_removablezf3zf3;
} *BgL_letzd2varzd2_bglt;

typedef struct BgL_setzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_setzd2exzd2itz00_bglt;

typedef struct BgL_jumpzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_exitz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_jumpzd2exzd2itz00_bglt;

typedef struct BgL_makezd2boxzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_makezd2boxzd2_bglt;

typedef struct BgL_boxzd2refzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_varz00;
} *BgL_boxzd2refzd2_bglt;

typedef struct BgL_boxzd2setz12zc0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_boxzd2setz12zc0_bglt;

typedef struct BgL_localzf2cellzf2_bgl {
   char dummy;
} *BgL_localzf2cellzf2_bglt;


static obj_t BGl_methodzd2initzd2zzcallcc_walkz00();
static BgL_nodez00_bglt BGl_callccz12zd2default2758zc0zzcallcc_walkz00(BgL_nodez00_bglt);
static obj_t BGl__callccz12zd2default2758zc0zzcallcc_walkz00(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
static obj_t BGl_callccza2z12zb0zzcallcc_walkz00(obj_t);
extern long BGl_classzd2numzd2zz__objectz00(obj_t);
extern obj_t BGl_letzd2funzd2zzast_nodez00;
extern obj_t BGl_readz00zz__readerz00(obj_t);
extern bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
extern obj_t BGl_objectzd2ze3structz31zz__objectz00(BgL_objectz00_bglt);
extern obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
extern obj_t BGl_letzd2varzd2zzast_nodez00;
extern obj_t BGl_za2compilerzd2debugza2zd2zzengine_paramz00;
static BgL_nodez00_bglt BGl_cellzd2formalszd2zzcallcc_walkz00(obj_t, BgL_nodez00_bglt);
extern obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t BGl_kwotez00zzast_nodez00;
extern obj_t BGl_za2_za2z00zztype_cachez00;
static obj_t BGl_callccz12zd2cast2777zc0zzcallcc_walkz00(obj_t, obj_t);
extern obj_t BGl_globalz00zzast_varz00;
static obj_t BGl__makezd2localzf2cell4061z20zzcallcc_walkz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_callccz12zd2funcall2773zc0zzcallcc_walkz00(obj_t, obj_t);
static BgL_makezd2boxzd2_bglt BGl_azd2makezd2cellz00zzcallcc_walkz00(BgL_nodez00_bglt, BgL_variablez00_bglt);
extern obj_t BGl_castz00zzast_nodez00;
extern obj_t BGl_boxzd2refzd2zzast_nodez00;
extern obj_t BGl_varz00zzast_nodez00;
static obj_t BGl_callccz12zd2boxzd2setz122799z00zzcallcc_walkz00(obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zzcallcc_walkz00();
static obj_t BGl_callccz12zd2app2769zc0zzcallcc_walkz00(obj_t, obj_t);
extern obj_t BGl_atomz00zzast_nodez00;
extern obj_t BGl_failz00zzast_nodez00;
extern obj_t BGl_funcallz00zzast_nodez00;
static obj_t BGl_callccz12zd2boxzd2ref2797z12zzcallcc_walkz00(obj_t, obj_t);
extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
static obj_t BGl_importedzd2moduleszd2initz00zzcallcc_walkz00();
extern obj_t BGl_makezd2boxzd2zzast_nodez00;
extern obj_t make_struct(obj_t, int, obj_t);
static obj_t BGl_callccz12zd2sequence2767zc0zzcallcc_walkz00(obj_t, obj_t);
static obj_t BGl_objectzd2ze3structzd2localzf2cell2801z11zzcallcc_walkz00(obj_t, obj_t);
extern obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
extern obj_t BGl_exitz00zz__errorz00(obj_t);
extern obj_t BGl_displayz00zz__r4_output_6_10_3z00(obj_t, obj_t);
extern obj_t BGl_selectz00zzast_nodez00;
static obj_t BGl_toplevelzd2initzd2zzcallcc_walkz00();
extern obj_t BGl_appzd2lyzd2zzast_nodez00;
static obj_t BGl_callccz12zd2setq2779zc0zzcallcc_walkz00(obj_t, obj_t);
extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
extern bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_modulezd2initializa7ationz75zzcallcc_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_localz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
static bool_t BGl_celledzf3zf3zzcallcc_walkz00(BgL_variablez00_bglt);
extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
static obj_t BGl__callccz124059z12zzcallcc_walkz00(obj_t, obj_t);
static obj_t BGl_callccz12zd2select2785zc0zzcallcc_walkz00(obj_t, obj_t);
static obj_t BGl_callccz12zd2jumpzd2exzd2it2793zc0zzcallcc_walkz00(obj_t, obj_t);
static obj_t BGl_callccz12zd2setzd2exzd2it2791zc0zzcallcc_walkz00(obj_t, obj_t);
extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
extern BgL_objectz00_bglt BGl_structzb2objectzd2ze3objectz83zz__objectz00(BgL_objectz00_bglt, obj_t);
static bool_t BGl_callcczd2funz12zc0zzcallcc_walkz00(obj_t);
static BgL_nodez00_bglt BGl_callccz12z12zzcallcc_walkz00(BgL_nodez00_bglt);
static obj_t BGl_callccz12zd2atom2761zc0zzcallcc_walkz00(obj_t, obj_t);
static obj_t BGl__allocatezd2localzf2cellz20zzcallcc_walkz00(obj_t);
extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
static BgL_localz00_bglt BGl_allocatezd2localzf2cellz20zzcallcc_walkz00();
static obj_t BGl_callccz12zd2letzd2var2789z12zzcallcc_walkz00(obj_t, obj_t);
extern obj_t BGl_externz00zzast_nodez00;
extern obj_t BGl_conditionalz00zzast_nodez00;
extern BgL_localz00_bglt BGl_makezd2localzd2svarz00zzast_localz00(obj_t, BgL_typez00_bglt);
extern obj_t BGl_sequencez00zzast_nodez00;
extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_callccz12zd2kwote2763zc0zzcallcc_walkz00(obj_t, obj_t);
static obj_t BGl_celledzd2bindingszd2zzcallcc_walkz00(obj_t);
extern obj_t BGl_appz00zzast_nodez00;
static obj_t BGl_callccz12zd2makezd2box2795z12zzcallcc_walkz00(obj_t, obj_t);
static obj_t BGl__callcczd2walkz12zc0zzcallcc_walkz00(obj_t, obj_t);
extern obj_t BGl_localz00zzast_varz00;
static obj_t BGl_callccz12zd2conditional2781zc0zzcallcc_walkz00(obj_t, obj_t);
static obj_t BGl_callccz12zd2letzd2fun2787z12zzcallcc_walkz00(obj_t, obj_t);
static obj_t BGl_structzb2objectzd2ze3objectzd2localzf2cell2803za3zzcallcc_walkz00(obj_t, obj_t, obj_t);
static obj_t BGl_callccz12zd2var2765zc0zzcallcc_walkz00(obj_t, obj_t);
extern obj_t BGl_za2objza2z00zztype_cachez00;
static obj_t BGl_objectzd2initzd2zzcallcc_walkz00();
static obj_t BGl_requirezd2initializa7ationz75zzcallcc_walkz00 = BUNSPEC;
static BgL_localzf2cellzf2_bglt BGl_makezd2localzf2cellz20zzcallcc_walkz00(obj_t, obj_t, BgL_typez00_bglt, BgL_valuez00_bglt, obj_t, obj_t, obj_t, long, bool_t, long);
static obj_t BGl_callccz12zd2fail2783zc0zzcallcc_walkz00(obj_t, obj_t);
extern obj_t BGl_callcczd2walkz12zc0zzcallcc_walkz00(obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zzcallcc_walkz00();
static obj_t BGl_callccz12zd2appzd2ly2771z12zzcallcc_walkz00(obj_t, obj_t);
static obj_t BGl_callccz12zd2extern2775zc0zzcallcc_walkz00(obj_t, obj_t);
static obj_t BGl_localzf2cellzf2zzcallcc_walkz00 = BUNSPEC;
extern obj_t BGl_setqz00zzast_nodez00;
extern obj_t BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t, obj_t);
static obj_t __cnst[ 7 ] ;

DEFINE_STATIC_PROCEDURE( BGl_callccz12zd2default2758zd2envz12zzcallcc_walkz00, BgL_bgl__callccza712za7d2default2758za7c0za7za7callcc_walkza7004681z00, BGl__callccz12zd2default2758zc0zzcallcc_walkz00, 0L, 1 );
extern obj_t BGl_objectzd2ze3structzd2envze3zz__objectz00;
DEFINE_STRING( BGl_string4651z00zzcallcc_walkz00, BgL_bgl_string4651za700za7za7callcc_walkza7004682z00, "callcc!-default2758 aux local/cell done write cell-callcc pass-started ", 71 );
DEFINE_STRING( BGl_string4650z00zzcallcc_walkz00, BgL_bgl_string4650za700za7za7callcc_walkza7004683z00, "No method for this object", 25 );
DEFINE_STRING( BGl_string4627z00zzcallcc_walkz00, BgL_bgl_string4627za700za7za7callcc_walkza7004684z00, "failure during postlude hook", 28 );
DEFINE_STRING( BGl_string4626z00zzcallcc_walkz00, BgL_bgl_string4626za700za7za7callcc_walkza7004685z00, " occured, ending ...", 20 );
DEFINE_STRING( BGl_string4625z00zzcallcc_walkz00, BgL_bgl_string4625za700za7za7callcc_walkza7004686z00, " error", 6 );
DEFINE_STRING( BGl_string4624z00zzcallcc_walkz00, BgL_bgl_string4624za700za7za7callcc_walkza7004687z00, "failure during prelude hook", 27 );
DEFINE_STRING( BGl_string4623z00zzcallcc_walkz00, BgL_bgl_string4623za700za7za7callcc_walkza7004688z00, "   . ", 5 );
DEFINE_STRING( BGl_string4622z00zzcallcc_walkz00, BgL_bgl_string4622za700za7za7callcc_walkza7004689z00, "Callcc", 6 );
DEFINE_STATIC_PROCEDURE( BGl_makezd2localzf2cellzd2envzf2zzcallcc_walkz00, BgL_bgl__makeza7d2localza7f2cell4061za720za7za7callcc_walkza7004690z00, BGl__makezd2localzf2cell4061z20zzcallcc_walkz00, 0L, 10 );
DEFINE_STATIC_PROCEDURE( BGl_allocatezd2localzf2cellzd2envzf2zzcallcc_walkz00, BgL_bgl__allocateza7d2localza7f2cellza720za7za7callcc_walkza7004691z00, BGl__allocatezd2localzf2cellz20zzcallcc_walkz00, 0L, 0 );
DEFINE_STATIC_PROCEDURE( BGl_proc4628z00zzcallcc_walkz00, BgL_bgl_callccza712za7d2atom2761za7c0za7za7callcc_walkza7004692z00, BGl_callccz12zd2atom2761zc0zzcallcc_walkz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4630z00zzcallcc_walkz00, BgL_bgl_callccza712za7d2var2765za7c0za7za7callcc_walkza7004693z00, BGl_callccz12zd2var2765zc0zzcallcc_walkz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4629z00zzcallcc_walkz00, BgL_bgl_callccza712za7d2kwote2763za7c0za7za7callcc_walkza7004694z00, BGl_callccz12zd2kwote2763zc0zzcallcc_walkz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4631z00zzcallcc_walkz00, BgL_bgl_callccza712za7d2sequence2767za7c0za7za7callcc_walkza7004695z00, BGl_callccz12zd2sequence2767zc0zzcallcc_walkz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4632z00zzcallcc_walkz00, BgL_bgl_callccza712za7d2app2769za7c0za7za7callcc_walkza7004696z00, BGl_callccz12zd2app2769zc0zzcallcc_walkz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4633z00zzcallcc_walkz00, BgL_bgl_callccza712za7d2appza7d2ly2771za712za7za7callcc_walkza7004697za7, BGl_callccz12zd2appzd2ly2771z12zzcallcc_walkz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4634z00zzcallcc_walkz00, BgL_bgl_callccza712za7d2funcall2773za7c0za7za7callcc_walkza7004698z00, BGl_callccz12zd2funcall2773zc0zzcallcc_walkz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4635z00zzcallcc_walkz00, BgL_bgl_callccza712za7d2extern2775za7c0za7za7callcc_walkza7004699z00, BGl_callccz12zd2extern2775zc0zzcallcc_walkz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4636z00zzcallcc_walkz00, BgL_bgl_callccza712za7d2cast2777za7c0za7za7callcc_walkza7004700z00, BGl_callccz12zd2cast2777zc0zzcallcc_walkz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4637z00zzcallcc_walkz00, BgL_bgl_callccza712za7d2setq2779za7c0za7za7callcc_walkza7004701z00, BGl_callccz12zd2setq2779zc0zzcallcc_walkz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4638z00zzcallcc_walkz00, BgL_bgl_callccza712za7d2conditional2781za7c0za7za7callcc_walkza7004702z00, BGl_callccz12zd2conditional2781zc0zzcallcc_walkz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4640z00zzcallcc_walkz00, BgL_bgl_callccza712za7d2select2785za7c0za7za7callcc_walkza7004703z00, BGl_callccz12zd2select2785zc0zzcallcc_walkz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4639z00zzcallcc_walkz00, BgL_bgl_callccza712za7d2fail2783za7c0za7za7callcc_walkza7004704z00, BGl_callccz12zd2fail2783zc0zzcallcc_walkz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4641z00zzcallcc_walkz00, BgL_bgl_callccza712za7d2letza7d2fun2787za712za7za7callcc_walkza7004705za7, BGl_callccz12zd2letzd2fun2787z12zzcallcc_walkz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4642z00zzcallcc_walkz00, BgL_bgl_callccza712za7d2letza7d2var2789za712za7za7callcc_walkza7004706za7, BGl_callccz12zd2letzd2var2789z12zzcallcc_walkz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4643z00zzcallcc_walkz00, BgL_bgl_callccza712za7d2setza7d2exza7d2it2791za7c0za7za7callcc_walkza7004707z00, BGl_callccz12zd2setzd2exzd2it2791zc0zzcallcc_walkz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4644z00zzcallcc_walkz00, BgL_bgl_callccza712za7d2jumpza7d2exza7d2it2793za7c0za7za7callcc_walkza7004708z00, BGl_callccz12zd2jumpzd2exzd2it2793zc0zzcallcc_walkz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4645z00zzcallcc_walkz00, BgL_bgl_callccza712za7d2makeza7d2box2795za712za7za7callcc_walkza7004709za7, BGl_callccz12zd2makezd2box2795z12zzcallcc_walkz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4646z00zzcallcc_walkz00, BgL_bgl_callccza712za7d2boxza7d2ref2797za712za7za7callcc_walkza7004710za7, BGl_callccz12zd2boxzd2ref2797z12zzcallcc_walkz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4647z00zzcallcc_walkz00, BgL_bgl_callccza712za7d2boxza7d2setza7122799za700za7za7callcc_walkza7004711z00, BGl_callccz12zd2boxzd2setz122799z00zzcallcc_walkz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4648z00zzcallcc_walkz00, BgL_bgl_objectza7d2za7e3structza7d2localza7f2cell2801za711za7za7callcc_walkza7004712z00, BGl_objectzd2ze3structzd2localzf2cell2801z11zzcallcc_walkz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4649z00zzcallcc_walkz00, BgL_bgl_structza7b2objectza7d2za7e3objectza7d2localza7f2cell2803za7a3za7za7callcc_walkza7004713za7, BGl_structzb2objectzd2ze3objectzd2localzf2cell2803za3zzcallcc_walkz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_callcczd2walkz12zd2envz12zzcallcc_walkz00, BgL_bgl__callccza7d2walkza712za7c0za7za7callcc_walkza7004714z00, BGl__callcczd2walkz12zc0zzcallcc_walkz00, 0L, 1 );
extern obj_t BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00;
DEFINE_STATIC_GENERIC( BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_bgl__callccza7124059za712za7za7callcc_walkza7004715za7, BGl__callccz124059z12zzcallcc_walkz00, 0L, 1 );



/* module-initialization */
obj_t BGl_modulezd2initializa7ationz75zzcallcc_walkz00(long BgL_checksumz00_3878, char * BgL_fromz00_3879)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzcallcc_walkz00))
{ 
BGl_requirezd2initializa7ationz75zzcallcc_walkz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzcallcc_walkz00(); 
BGl_cnstzd2initzd2zzcallcc_walkz00(); 
BGl_importedzd2moduleszd2initz00zzcallcc_walkz00(); 
BGl_objectzd2initzd2zzcallcc_walkz00(); 
BGl_methodzd2initzd2zzcallcc_walkz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzcallcc_walkz00()
{ AN_OBJECT;
{ /* Callcc/walk.scm 16 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "callcc_walk"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "callcc_walk"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "callcc_walk"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "callcc_walk"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "callcc_walk"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzcallcc_walkz00()
{ AN_OBJECT;
{ /* Callcc/walk.scm 16 */
{ /* Callcc/walk.scm 16 */
obj_t BgL_cportz00_3871;
BgL_cportz00_3871 = 
open_input_string(BGl_string4651z00zzcallcc_walkz00); 
{ 
long BgL_iz00_3872;
BgL_iz00_3872 = ((long)6); 
BgL_loopz00_3873:
if(
(BgL_iz00_3872==((long)-1)))
{ /* Callcc/walk.scm 16 */
return BUNSPEC;}  else 
{ /* Callcc/walk.scm 16 */
{ /* Callcc/walk.scm 16 */
obj_t BgL_arg4655z00_3875;
{ /* Callcc/walk.scm 16 */
obj_t BgL_list4658z00_3876;
BgL_list4658z00_3876 = 
MAKE_PAIR(BgL_cportz00_3871, BNIL); 
BgL_arg4655z00_3875 = 
BGl_readz00zz__readerz00(BgL_list4658z00_3876); } 
{ /* Callcc/walk.scm 16 */
int BgL_auxz00_3898;
BgL_auxz00_3898 = 
(int)(BgL_iz00_3872); 
CNST_TABLE_SET(BgL_auxz00_3898, BgL_arg4655z00_3875); } } 
{ 
long BgL_iz00_3901;
{ /* Callcc/walk.scm 16 */
int BgL_auxz00_3902;
{ /* Callcc/walk.scm 16 */
long BgL_auxz00_3903;
BgL_auxz00_3903 = 
(BgL_iz00_3872-((long)1)); 
BgL_auxz00_3902 = 
(int)(BgL_auxz00_3903); } 
BgL_iz00_3901 = 
(long)(BgL_auxz00_3902); } 
BgL_iz00_3872 = BgL_iz00_3901; 
goto BgL_loopz00_3873;} } } } } 
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zzcallcc_walkz00()
{ AN_OBJECT;
{ /* Callcc/walk.scm 16 */
return BUNSPEC;} 
}



/* callcc-walk! */
obj_t BGl_callcczd2walkz12zc0zzcallcc_walkz00(obj_t BgL_globalsz00_1)
{ AN_OBJECT;
{ /* Callcc/walk.scm 30 */
{ /* Callcc/walk.scm 31 */
obj_t BgL_list2805z00_1292;
{ /* Callcc/walk.scm 31 */
obj_t BgL_arg2808z00_1294;
{ /* Callcc/walk.scm 31 */
obj_t BgL_arg2812z00_1296;
{ /* Callcc/walk.scm 31 */
obj_t BgL_auxz00_3907;
BgL_auxz00_3907 = 
BCHAR(((unsigned char)'\n')); 
BgL_arg2812z00_1296 = 
MAKE_PAIR(BgL_auxz00_3907, BNIL); } 
BgL_arg2808z00_1294 = 
MAKE_PAIR(BGl_string4622z00zzcallcc_walkz00, BgL_arg2812z00_1296); } 
BgL_list2805z00_1292 = 
MAKE_PAIR(BGl_string4623z00zzcallcc_walkz00, BgL_arg2808z00_1294); } 
BGl_verbosez00zztools_speekz00(
BINT(((long)1)), BgL_list2805z00_1292); } 
BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 = 
BINT(((long)0)); 
BGl_za2currentzd2passza2zd2zzengine_passz00 = BGl_string4622z00zzcallcc_walkz00; 
{ 
obj_t BgL_hooksz00_1297;obj_t BgL_hnamesz00_1298;
BgL_hooksz00_1297 = BNIL; 
BgL_hnamesz00_1298 = BNIL; 
BgL_loopz00_1299:
if(
NULLP(BgL_hooksz00_1297))
{ /* Callcc/walk.scm 31 */
CNST_TABLE_REF(((long)0)); }  else 
{ /* Callcc/walk.scm 31 */
bool_t BgL_test2822z00_1304;
{ /* Callcc/walk.scm 31 */
obj_t BgL_fun2838z00_1310;
BgL_fun2838z00_1310 = 
CAR(BgL_hooksz00_1297); 
{ /* Callcc/walk.scm 31 */
obj_t BgL_auxz00_3919;
BgL_auxz00_3919 = 
PROCEDURE_ENTRY(BgL_fun2838z00_1310)(BgL_fun2838z00_1310, BEOA); 
BgL_test2822z00_1304 = 
CBOOL(BgL_auxz00_3919); } } 
if(BgL_test2822z00_1304)
{ /* Callcc/walk.scm 31 */
{ 
obj_t BgL_hnamesz00_3926;obj_t BgL_hooksz00_3924;
BgL_hooksz00_3924 = 
CDR(BgL_hooksz00_1297); 
BgL_hnamesz00_3926 = 
CDR(BgL_hnamesz00_1298); 
BgL_hnamesz00_1298 = BgL_hnamesz00_3926; 
BgL_hooksz00_1297 = BgL_hooksz00_3924; 
goto BgL_loopz00_1299;} }  else 
{ /* Callcc/walk.scm 31 */
BGl_internalzd2errorzd2zztools_errorz00(BGl_string4622z00zzcallcc_walkz00, BGl_string4624z00zzcallcc_walkz00, 
CAR(BgL_hnamesz00_1298)); } } } 
{ /* Callcc/walk.scm 33 */
bool_t BgL_test2841z00_1311;
{ /* Callcc/walk.scm 33 */
long BgL_n1z00_2065;
BgL_n1z00_2065 = 
(long)CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00); 
BgL_test2841z00_1311 = 
(BgL_n1z00_2065>((long)2)); } 
if(BgL_test2841z00_1311)
{ /* Callcc/walk.scm 33 */
BGl_za2compilerzd2debugza2zd2zzengine_paramz00 = 
BINT(((long)2)); }  else 
{ /* Callcc/walk.scm 33 */BFALSE; } } 
{ 
obj_t BgL_l2707z00_1312;
BgL_l2707z00_1312 = BgL_globalsz00_1; 
BgL_lname2708z00_1313:
if(
PAIRP(BgL_l2707z00_1312))
{ /* Callcc/walk.scm 35 */
BGl_callcczd2funz12zc0zzcallcc_walkz00(
CAR(BgL_l2707z00_1312)); 
{ 
obj_t BgL_l2707z00_3938;
BgL_l2707z00_3938 = 
CDR(BgL_l2707z00_1312); 
BgL_l2707z00_1312 = BgL_l2707z00_3938; 
goto BgL_lname2708z00_1313;} }  else 
{ /* Callcc/walk.scm 35 */((bool_t)1); } } 
{ /* Callcc/walk.scm 36 */
bool_t BgL_test2855z00_1318;
{ /* Callcc/walk.scm 36 */
long BgL_n1z00_2070;
BgL_n1z00_2070 = 
(long)CINT(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00); 
BgL_test2855z00_1318 = 
(BgL_n1z00_2070>((long)0)); } 
if(BgL_test2855z00_1318)
{ /* Callcc/walk.scm 36 */
{ /* Callcc/walk.scm 36 */
obj_t BgL_port2709z00_1319;
BgL_port2709z00_1319 = 
GET_CURRENT_ERROR_PORT(); 
{ /* Callcc/walk.scm 36 */
obj_t BgL_list2857z00_1320;
BgL_list2857z00_1320 = 
MAKE_PAIR(BgL_port2709z00_1319, BNIL); 
BGl_displayz00zz__r4_output_6_10_3z00(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00, BgL_list2857z00_1320); } 
{ /* Callcc/walk.scm 36 */
obj_t BgL_list2860z00_1321;
BgL_list2860z00_1321 = 
MAKE_PAIR(BgL_port2709z00_1319, BNIL); 
BGl_displayz00zz__r4_output_6_10_3z00(BGl_string4625z00zzcallcc_walkz00, BgL_list2860z00_1321); } 
{ /* Callcc/walk.scm 36 */
char * BgL_arg2863z00_1322;
{ /* Callcc/walk.scm 36 */
bool_t BgL_test2867z00_1324;
{ /* Callcc/walk.scm 36 */
bool_t BgL_test2868z00_1325;
{ /* Callcc/walk.scm 36 */
obj_t BgL_objz00_2072;
BgL_objz00_2072 = BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00; 
BgL_test2868z00_1325 = 
INTEGERP(BgL_objz00_2072); } 
if(BgL_test2868z00_1325)
{ /* Callcc/walk.scm 36 */
BgL_test2867z00_1324 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00, 
BINT(((long)1))); }  else 
{ /* Callcc/walk.scm 36 */
BgL_test2867z00_1324 = ((bool_t)0); } } 
if(BgL_test2867z00_1324)
{ /* Callcc/walk.scm 36 */
BgL_arg2863z00_1322 = "s"; }  else 
{ /* Callcc/walk.scm 36 */
BgL_arg2863z00_1322 = ""; } } 
{ /* Callcc/walk.scm 36 */
obj_t BgL_list2865z00_1323;
BgL_list2865z00_1323 = 
MAKE_PAIR(BgL_port2709z00_1319, BNIL); 
BGl_displayz00zz__r4_output_6_10_3z00(
string_to_bstring(BgL_arg2863z00_1322), BgL_list2865z00_1323); } } 
{ /* Callcc/walk.scm 36 */
obj_t BgL_list2872z00_1326;
BgL_list2872z00_1326 = 
MAKE_PAIR(BgL_port2709z00_1319, BNIL); 
BGl_displayz00zz__r4_output_6_10_3z00(BGl_string4626z00zzcallcc_walkz00, BgL_list2872z00_1326); } 
WRITE_CHAR(((unsigned char)'\n'), BgL_port2709z00_1319); } 
{ /* Callcc/walk.scm 36 */
obj_t BgL_list2877z00_1327;
{ /* Callcc/walk.scm 36 */
obj_t BgL_auxz00_3959;
BgL_auxz00_3959 = 
BINT(((long)-1)); 
BgL_list2877z00_1327 = 
MAKE_PAIR(BgL_auxz00_3959, BNIL); } 
return 
BGl_exitz00zz__errorz00(BgL_list2877z00_1327);} }  else 
{ 
obj_t BgL_hooksz00_1328;obj_t BgL_hnamesz00_1329;
BgL_hooksz00_1328 = BNIL; 
BgL_hnamesz00_1329 = BNIL; 
BgL_loopz00_1330:
if(
NULLP(BgL_hooksz00_1328))
{ /* Callcc/walk.scm 36 */
return BgL_globalsz00_1;}  else 
{ /* Callcc/walk.scm 36 */
bool_t BgL_test2886z00_1335;
{ /* Callcc/walk.scm 36 */
obj_t BgL_fun2900z00_1340;
BgL_fun2900z00_1340 = 
CAR(BgL_hooksz00_1328); 
{ /* Callcc/walk.scm 36 */
obj_t BgL_auxz00_3966;
BgL_auxz00_3966 = 
PROCEDURE_ENTRY(BgL_fun2900z00_1340)(BgL_fun2900z00_1340, BEOA); 
BgL_test2886z00_1335 = 
CBOOL(BgL_auxz00_3966); } } 
if(BgL_test2886z00_1335)
{ /* Callcc/walk.scm 36 */
{ 
obj_t BgL_hnamesz00_3973;obj_t BgL_hooksz00_3971;
BgL_hooksz00_3971 = 
CDR(BgL_hooksz00_1328); 
BgL_hnamesz00_3973 = 
CDR(BgL_hnamesz00_1329); 
BgL_hnamesz00_1329 = BgL_hnamesz00_3973; 
BgL_hooksz00_1328 = BgL_hooksz00_3971; 
goto BgL_loopz00_1330;} }  else 
{ /* Callcc/walk.scm 36 */
return 
BGl_internalzd2errorzd2zztools_errorz00(BGl_za2currentzd2passza2zd2zzengine_passz00, BGl_string4627z00zzcallcc_walkz00, 
CAR(BgL_hnamesz00_1329));} } } } } 
}



/* _callcc-walk! */
obj_t BGl__callcczd2walkz12zc0zzcallcc_walkz00(obj_t BgL_envz00_3781, obj_t BgL_globalsz00_3782)
{ AN_OBJECT;
{ /* Callcc/walk.scm 30 */
return 
BGl_callcczd2walkz12zc0zzcallcc_walkz00(BgL_globalsz00_3782);} 
}



/* callcc-fun! */
bool_t BGl_callcczd2funz12zc0zzcallcc_walkz00(obj_t BgL_varz00_2)
{ AN_OBJECT;
{ /* Callcc/walk.scm 41 */
{ /* Callcc/walk.scm 42 */
BgL_valuez00_bglt BgL_funz00_1341;
{ /* Callcc/walk.scm 42 */
BgL_variablez00_bglt BgL_obj1104z00_2081;
BgL_obj1104z00_2081 = 
(BgL_variablez00_bglt)(BgL_varz00_2); 
BgL_funz00_1341 = 
(((BgL_variablez00_bglt)CREF(BgL_obj1104z00_2081))->BgL_valuez00); } 
{ /* Callcc/walk.scm 42 */
obj_t BgL_bodyz00_1342;
{ /* Callcc/walk.scm 43 */
BgL_sfunz00_bglt BgL_obj1373z00_2082;
BgL_obj1373z00_2082 = 
(BgL_sfunz00_bglt)(BgL_funz00_1341); 
BgL_bodyz00_1342 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1373z00_2082))->BgL_bodyz00); } 
{ /* Callcc/walk.scm 43 */
obj_t BgL_celledz00_1343;
{ /* Callcc/walk.scm 44 */
obj_t BgL_auxz00_3982;
{ /* Callcc/walk.scm 44 */
BgL_sfunz00_bglt BgL_obj1370z00_2083;
BgL_obj1370z00_2083 = 
(BgL_sfunz00_bglt)(BgL_funz00_1341); 
BgL_auxz00_3982 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1370z00_2083))->BgL_argsz00); } 
BgL_celledz00_1343 = 
BGl_celledzd2bindingszd2zzcallcc_walkz00(BgL_auxz00_3982); } 
{ /* Callcc/walk.scm 44 */

{ 
obj_t BgL_l2710z00_1344;
BgL_l2710z00_1344 = BgL_celledz00_1343; 
BgL_lname2711z00_1345:
if(
PAIRP(BgL_l2710z00_1344))
{ /* Callcc/walk.scm 46 */
{ /* Callcc/walk.scm 47 */
obj_t BgL_wze2bze2_1347;
BgL_wze2bze2_1347 = 
CAR(BgL_l2710z00_1344); 
{ /* Callcc/walk.scm 47 */
obj_t BgL_arg2908z00_1349;
BgL_arg2908z00_1349 = 
CDR(BgL_wze2bze2_1347); 
{ /* Callcc/walk.scm 47 */
BgL_localz00_bglt BgL_obj1264z00_2088;
{ /* Callcc/walk.scm 47 */
obj_t BgL_auxz00_3990;
BgL_auxz00_3990 = 
CAR(BgL_wze2bze2_1347); 
BgL_obj1264z00_2088 = 
(BgL_localz00_bglt)(BgL_auxz00_3990); } 
((((BgL_localz00_bglt)CREF(BgL_obj1264z00_2088))->BgL_fastzd2alphazd2) = ((obj_t)BgL_arg2908z00_1349), BUNSPEC); } } } 
{ 
obj_t BgL_l2710z00_3994;
BgL_l2710z00_3994 = 
CDR(BgL_l2710z00_1344); 
BgL_l2710z00_1344 = BgL_l2710z00_3994; 
goto BgL_lname2711z00_1345;} }  else 
{ /* Callcc/walk.scm 46 */((bool_t)1); } } 
{ /* Callcc/walk.scm 49 */
BgL_nodez00_bglt BgL_arg2919z00_1351;
{ /* Callcc/walk.scm 49 */
BgL_nodez00_bglt BgL_arg2922z00_1352;
{ /* Callcc/walk.scm 49 */
BgL_nodez00_bglt BgL_res3943z00_2117;
{ /* Callcc/walk.scm 49 */
BgL_nodez00_bglt BgL_nodez00_2091;
BgL_nodez00_2091 = 
(BgL_nodez00_bglt)(BgL_bodyz00_1342); 
{ /* Callcc/walk.scm 49 */
obj_t BgL_method2759z00_2092;
{ /* Callcc/walk.scm 49 */
long BgL_objzd2classzd2numz00_2094;
{ /* Callcc/walk.scm 49 */
BgL_objectz00_bglt BgL_auxz00_3997;
BgL_auxz00_3997 = 
(BgL_objectz00_bglt)(BgL_nodez00_2091); 
BgL_objzd2classzd2numz00_2094 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_3997); } 
{ /* Callcc/walk.scm 49 */
obj_t BgL_arg1904z00_2095;
{ /* Callcc/walk.scm 49 */
int BgL_auxz00_4000;
BgL_auxz00_4000 = 
(int)(((long)1)); 
BgL_arg1904z00_2095 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_4000); } 
{ /* Callcc/walk.scm 49 */
long BgL_offsetz00_2099;
{ /* Callcc/walk.scm 49 */
long BgL_auxz00_4003;
{ /* Callcc/walk.scm 49 */
int BgL_auxz00_4004;
BgL_auxz00_4004 = 
(int)(BgL_objzd2classzd2numz00_2094); 
BgL_auxz00_4003 = 
(long)(BgL_auxz00_4004); } 
BgL_offsetz00_2099 = 
(BgL_auxz00_4003-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 49 */
long BgL_modz00_2100;
{ /* Callcc/walk.scm 49 */
long BgL_auxz00_4008;
{ /* Callcc/walk.scm 49 */
int BgL_auxz00_4009;
BgL_auxz00_4009 = 
(int)(((long)8)); 
BgL_auxz00_4008 = 
(long)(BgL_auxz00_4009); } 
BgL_modz00_2100 = 
(BgL_offsetz00_2099/BgL_auxz00_4008); } 
{ /* Callcc/walk.scm 49 */
long BgL_restz00_2102;
{ /* Callcc/walk.scm 49 */
long BgL_auxz00_4013;
{ /* Callcc/walk.scm 49 */
int BgL_auxz00_4014;
BgL_auxz00_4014 = 
(int)(((long)8)); 
BgL_auxz00_4013 = 
(long)(BgL_auxz00_4014); } 
BgL_restz00_2102 = 
(BgL_offsetz00_2099%BgL_auxz00_4013); } 
{ /* Callcc/walk.scm 49 */

{ /* Callcc/walk.scm 49 */
obj_t BgL_bucketz00_2104;
{ /* Callcc/walk.scm 49 */
int BgL_kz00_2114;
BgL_kz00_2114 = 
(int)(BgL_modz00_2100); 
BgL_bucketz00_2104 = 
VECTOR_REF(BgL_arg1904z00_2095,BgL_kz00_2114); } 
{ /* Callcc/walk.scm 49 */
int BgL_kz00_2116;
BgL_kz00_2116 = 
(int)(BgL_restz00_2102); 
BgL_method2759z00_2092 = 
VECTOR_REF(BgL_bucketz00_2104,BgL_kz00_2116); } } } } } } } } 
{ /* Callcc/walk.scm 49 */
obj_t BgL_auxz00_4022;
BgL_auxz00_4022 = 
PROCEDURE_ENTRY(BgL_method2759z00_2092)(BgL_method2759z00_2092, 
(obj_t)(BgL_nodez00_2091), BEOA); 
BgL_res3943z00_2117 = 
(BgL_nodez00_bglt)(BgL_auxz00_4022); } } } 
BgL_arg2922z00_1352 = BgL_res3943z00_2117; } 
BgL_arg2919z00_1351 = 
BGl_cellzd2formalszd2zzcallcc_walkz00(BgL_celledz00_1343, BgL_arg2922z00_1352); } 
{ /* Callcc/walk.scm 49 */
BgL_sfunz00_bglt BgL_obj1375z00_2118;obj_t BgL_val1374z00_2119;
BgL_obj1375z00_2118 = 
(BgL_sfunz00_bglt)(BgL_funz00_1341); 
BgL_val1374z00_2119 = 
(obj_t)(BgL_arg2919z00_1351); 
((((BgL_sfunz00_bglt)CREF(BgL_obj1375z00_2118))->BgL_bodyz00) = ((obj_t)BgL_val1374z00_2119), BUNSPEC); } } 
{ 
obj_t BgL_l2712z00_1353;
BgL_l2712z00_1353 = BgL_celledz00_1343; 
BgL_lname2713z00_1354:
if(
PAIRP(BgL_l2712z00_1353))
{ /* Callcc/walk.scm 51 */
{ /* Callcc/walk.scm 52 */
BgL_localz00_bglt BgL_obj1264z00_2123;
{ /* Callcc/walk.scm 52 */
obj_t BgL_auxz00_4033;
{ /* Callcc/walk.scm 52 */
obj_t BgL_auxz00_4034;
BgL_auxz00_4034 = 
CAR(BgL_l2712z00_1353); 
BgL_auxz00_4033 = 
CAR(BgL_auxz00_4034); } 
BgL_obj1264z00_2123 = 
(BgL_localz00_bglt)(BgL_auxz00_4033); } 
((((BgL_localz00_bglt)CREF(BgL_obj1264z00_2123))->BgL_fastzd2alphazd2) = ((obj_t)BUNSPEC), BUNSPEC); } 
{ 
obj_t BgL_l2712z00_4039;
BgL_l2712z00_4039 = 
CDR(BgL_l2712z00_1353); 
BgL_l2712z00_1353 = BgL_l2712z00_4039; 
goto BgL_lname2713z00_1354;} }  else 
{ /* Callcc/walk.scm 51 */
return ((bool_t)1);} } } } } } } 
}



/* celled-bindings */
obj_t BGl_celledzd2bindingszd2zzcallcc_walkz00(obj_t BgL_formalsz00_3)
{ AN_OBJECT;
{ /* Callcc/walk.scm 58 */
{ 
obj_t BgL_celledz00_1360;obj_t BgL_formalsz00_1361;
BgL_celledz00_1360 = BNIL; 
BgL_formalsz00_1361 = BgL_formalsz00_3; 
BgL_loopz00_1362:
if(
NULLP(BgL_formalsz00_1361))
{ /* Callcc/walk.scm 62 */
return BgL_celledz00_1360;}  else 
{ /* Callcc/walk.scm 64 */
bool_t BgL_testz00_4043;
{ /* Callcc/walk.scm 64 */
BgL_variablez00_bglt BgL_auxz00_4044;
{ /* Callcc/walk.scm 64 */
obj_t BgL_auxz00_4045;
BgL_auxz00_4045 = 
CAR(BgL_formalsz00_1361); 
BgL_auxz00_4044 = 
(BgL_variablez00_bglt)(BgL_auxz00_4045); } 
BgL_testz00_4043 = 
BGl_celledzf3zf3zzcallcc_walkz00(BgL_auxz00_4044); } 
if(BgL_testz00_4043)
{ /* Callcc/walk.scm 64 */
{ /* Callcc/walk.scm 67 */
BgL_localz00_bglt BgL_varz00_1365;
{ /* Callcc/walk.scm 67 */
obj_t BgL_auxz00_4049;
{ /* Callcc/walk.scm 67 */
BgL_localz00_bglt BgL_obj1249z00_2129;
{ /* Callcc/walk.scm 67 */
obj_t BgL_auxz00_4050;
BgL_auxz00_4050 = 
CAR(BgL_formalsz00_1361); 
BgL_obj1249z00_2129 = 
(BgL_localz00_bglt)(BgL_auxz00_4050); } 
BgL_auxz00_4049 = 
(((BgL_localz00_bglt)CREF(BgL_obj1249z00_2129))->BgL_idz00); } 
BgL_varz00_1365 = 
BGl_makezd2localzd2svarz00zzast_localz00(BgL_auxz00_4049, 
(BgL_typez00_bglt)(BGl_za2objza2z00zztype_cachez00)); } 
{ /* Callcc/walk.scm 67 */
obj_t BgL_oze2nze2_1366;
{ /* Callcc/walk.scm 68 */
obj_t BgL_auxz00_4058;obj_t BgL_auxz00_4056;
BgL_auxz00_4058 = 
(obj_t)(BgL_varz00_1365); 
BgL_auxz00_4056 = 
CAR(BgL_formalsz00_1361); 
BgL_oze2nze2_1366 = 
MAKE_PAIR(BgL_auxz00_4056, BgL_auxz00_4058); } 
{ /* Callcc/walk.scm 68 */

{ /* Callcc/walk.scm 69 */
BgL_localzf2cellzf2_bglt BgL_obj2714z00_1367;
BgL_obj2714z00_1367 = 
((BgL_localzf2cellzf2_bglt)BgL_varz00_1365); 
{ /* Callcc/walk.scm 69 */
obj_t BgL_auxz00_4064;BgL_objectz00_bglt BgL_auxz00_4062;
{ /* Callcc/walk.scm 69 */
BgL_localzf2cellzf2_bglt BgL_auxz00_4065;
{ /* Callcc/walk.scm 69 */
BgL_localzf2cellzf2_bglt BgL_new2655z00_2131;
BgL_new2655z00_2131 = 
((BgL_localzf2cellzf2_bglt)BREF( GC_MALLOC (sizeof(struct BgL_localzf2cellzf2_bgl)))); 
BgL_auxz00_4065 = BgL_new2655z00_2131; } 
BgL_auxz00_4064 = 
(obj_t)(BgL_auxz00_4065); } 
BgL_auxz00_4062 = 
(BgL_objectz00_bglt)(BgL_obj2714z00_1367); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4062, BgL_auxz00_4064); } 
{ /* Callcc/walk.scm 69 */
long BgL_auxz00_4071;BgL_objectz00_bglt BgL_auxz00_4069;
BgL_auxz00_4071 = 
BGl_classzd2numzd2zz__objectz00(BGl_localzf2cellzf2zzcallcc_walkz00); 
BgL_auxz00_4069 = 
(BgL_objectz00_bglt)(BgL_obj2714z00_1367); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4069, BgL_auxz00_4071); } 
{ /* Callcc/walk.scm 69 */
obj_t BgL_auxz00_4074;
BgL_auxz00_4074 = 
(obj_t)(BgL_obj2714z00_1367); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4074); } BUNSPEC; BgL_obj2714z00_1367; } 
{ /* Callcc/walk.scm 70 */
obj_t BgL_arg2957z00_1370;obj_t BgL_arg2958z00_1371;
BgL_arg2957z00_1370 = 
MAKE_PAIR(BgL_oze2nze2_1366, BgL_celledz00_1360); 
BgL_arg2958z00_1371 = 
CDR(BgL_formalsz00_1361); 
{ 
obj_t BgL_formalsz00_4080;obj_t BgL_celledz00_4079;
BgL_celledz00_4079 = BgL_arg2957z00_1370; 
BgL_formalsz00_4080 = BgL_arg2958z00_1371; 
BgL_formalsz00_1361 = BgL_formalsz00_4080; 
BgL_celledz00_1360 = BgL_celledz00_4079; 
goto BgL_loopz00_1362;} } } } } }  else 
{ /* Callcc/walk.scm 64 */
{ 
obj_t BgL_formalsz00_4081;
BgL_formalsz00_4081 = 
CDR(BgL_formalsz00_1361); 
BgL_formalsz00_1361 = BgL_formalsz00_4081; 
goto BgL_loopz00_1362;} } } } } 
}



/* cell-formals */
BgL_nodez00_bglt BGl_cellzd2formalszd2zzcallcc_walkz00(obj_t BgL_celledz00_4, BgL_nodez00_bglt BgL_bodyz00_5)
{ AN_OBJECT;
{ /* Callcc/walk.scm 75 */
{ /* Callcc/walk.scm 76 */
bool_t BgL_test2982z00_1377;
BgL_test2982z00_1377 = 
NULLP(BgL_celledz00_4); 
if(BgL_test2982z00_1377)
{ /* Callcc/walk.scm 76 */
return BgL_bodyz00_5;}  else 
{ /* Callcc/walk.scm 78 */
obj_t BgL_locz00_1378;
BgL_locz00_1378 = 
(((BgL_nodez00_bglt)CREF(BgL_bodyz00_5))->BgL_locz00); 
{ /* Callcc/walk.scm 80 */
obj_t BgL_arg2984z00_1379;obj_t BgL_arg2985z00_1380;obj_t BgL_arg2987z00_1382;BgL_nodez00_bglt BgL_arg2988z00_1383;
BgL_arg2984z00_1379 = BgL_locz00_1378; 
BgL_arg2985z00_1380 = BGl_za2_za2z00zztype_cachez00; 
if(BgL_test2982z00_1377)
{ /* Callcc/walk.scm 83 */
BgL_arg2987z00_1382 = BNIL; }  else 
{ /* Callcc/walk.scm 83 */
obj_t BgL_head2718z00_1386;
BgL_head2718z00_1386 = 
MAKE_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l2716z00_1387;obj_t BgL_tail2719z00_1388;
BgL_l2716z00_1387 = BgL_celledz00_4; 
BgL_tail2719z00_1388 = BgL_head2718z00_1386; 
BgL_lname2717z00_1389:
if(
NULLP(BgL_l2716z00_1387))
{ /* Callcc/walk.scm 83 */
BgL_arg2987z00_1382 = 
CDR(BgL_head2718z00_1386); }  else 
{ /* Callcc/walk.scm 84 */
obj_t BgL_newtail2720z00_1391;
{ /* Callcc/walk.scm 84 */
obj_t BgL_arg3000z00_1393;
{ /* Callcc/walk.scm 84 */
obj_t BgL_oze2nze2_1395;
BgL_oze2nze2_1395 = 
CAR(BgL_l2716z00_1387); 
{ /* Callcc/walk.scm 84 */
obj_t BgL_arg3005z00_1396;BgL_makezd2boxzd2_bglt BgL_arg3006z00_1397;
BgL_arg3005z00_1396 = 
CDR(BgL_oze2nze2_1395); 
{ /* Callcc/walk.scm 87 */
BgL_varz00_bglt BgL_arg3010z00_1398;obj_t BgL_arg3011z00_1399;
{ /* Callcc/walk.scm 87 */
obj_t BgL_arg3014z00_1400;obj_t BgL_arg3015z00_1401;
BgL_arg3014z00_1400 = BgL_locz00_1378; 
BgL_arg3015z00_1401 = BGl_za2_za2z00zztype_cachez00; 
{ /* Callcc/walk.scm 85 */
BgL_varz00_bglt BgL_res3947z00_2167;
{ /* Callcc/walk.scm 85 */
BgL_typez00_bglt BgL_type1632z00_2150;BgL_variablez00_bglt BgL_variable1633z00_2151;
BgL_type1632z00_2150 = 
(BgL_typez00_bglt)(BgL_arg3015z00_1401); 
{ /* Callcc/walk.scm 88 */
obj_t BgL_auxz00_4094;
BgL_auxz00_4094 = 
CAR(BgL_oze2nze2_1395); 
BgL_variable1633z00_2151 = 
(BgL_variablez00_bglt)(BgL_auxz00_4094); } 
{ /* Callcc/walk.scm 85 */
BgL_varz00_bglt BgL_new1634z00_2152;
{ /* Callcc/walk.scm 85 */
BgL_varz00_bglt BgL_res3945z00_2158;
{ /* Callcc/walk.scm 85 */
BgL_varz00_bglt BgL_new1636z00_2153;
BgL_new1636z00_2153 = 
((BgL_varz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_varz00_bgl) ))); 
{ /* Callcc/walk.scm 85 */
long BgL_arg3348z00_2154;
BgL_arg3348z00_2154 = 
BGl_classzd2numzd2zz__objectz00(BGl_varz00zzast_nodez00); 
{ /* Callcc/walk.scm 85 */
BgL_objectz00_bglt BgL_auxz00_4099;
BgL_auxz00_4099 = 
(BgL_objectz00_bglt)(BgL_new1636z00_2153); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4099, BgL_arg3348z00_2154); } } 
{ /* Callcc/walk.scm 85 */
BgL_objectz00_bglt BgL_auxz00_4102;
BgL_auxz00_4102 = 
(BgL_objectz00_bglt)(BgL_new1636z00_2153); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4102, BFALSE); } 
{ /* Callcc/walk.scm 85 */
obj_t BgL_auxz00_4105;
BgL_auxz00_4105 = 
(obj_t)(BgL_new1636z00_2153); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4105); } BUNSPEC; 
BgL_res3945z00_2158 = BgL_new1636z00_2153; } 
BgL_new1634z00_2152 = BgL_res3945z00_2158; } 
{ /* Callcc/walk.scm 85 */
BgL_varz00_bglt BgL_res3946z00_2166;
((((BgL_varz00_bglt)CREF(BgL_new1634z00_2152))->BgL_locz00) = ((obj_t)BgL_arg3014z00_1400), BUNSPEC); 
((((BgL_varz00_bglt)CREF(BgL_new1634z00_2152))->BgL_typez00) = ((BgL_typez00_bglt)BgL_type1632z00_2150), BUNSPEC); 
((((BgL_varz00_bglt)CREF(BgL_new1634z00_2152))->BgL_variablez00) = ((BgL_variablez00_bglt)BgL_variable1633z00_2151), BUNSPEC); 
BgL_res3946z00_2166 = BgL_new1634z00_2152; BgL_res3946z00_2166; } 
BgL_res3947z00_2167 = BgL_new1634z00_2152; } } 
BgL_arg3010z00_1398 = BgL_res3947z00_2167; } } 
BgL_arg3011z00_1399 = 
CAR(BgL_oze2nze2_1395); 
BgL_arg3006z00_1397 = 
BGl_azd2makezd2cellz00zzcallcc_walkz00(
(BgL_nodez00_bglt)(BgL_arg3010z00_1398), 
(BgL_variablez00_bglt)(BgL_arg3011z00_1399)); } 
{ /* Callcc/walk.scm 84 */
obj_t BgL_auxz00_4115;
BgL_auxz00_4115 = 
(obj_t)(BgL_arg3006z00_1397); 
BgL_arg3000z00_1393 = 
MAKE_PAIR(BgL_arg3005z00_1396, BgL_auxz00_4115); } } } 
BgL_newtail2720z00_1391 = 
MAKE_PAIR(BgL_arg3000z00_1393, BNIL); } 
SET_CDR(BgL_tail2719z00_1388, BgL_newtail2720z00_1391); 
{ 
obj_t BgL_tail2719z00_4122;obj_t BgL_l2716z00_4120;
BgL_l2716z00_4120 = 
CDR(BgL_l2716z00_1387); 
BgL_tail2719z00_4122 = BgL_newtail2720z00_1391; 
BgL_tail2719z00_1388 = BgL_tail2719z00_4122; 
BgL_l2716z00_1387 = BgL_l2716z00_4120; 
goto BgL_lname2717z00_1389;} } } } 
BgL_arg2988z00_1383 = BgL_bodyz00_5; 
{ /* Callcc/walk.scm 79 */
BgL_letzd2varzd2_bglt BgL_res3950z00_2204;
{ /* Callcc/walk.scm 79 */
BgL_typez00_bglt BgL_type2493z00_2175;obj_t BgL_key2495z00_2177;
BgL_type2493z00_2175 = 
(BgL_typez00_bglt)(BgL_arg2985z00_1380); 
BgL_key2495z00_2177 = 
BINT(((long)-1)); 
{ /* Callcc/walk.scm 79 */
BgL_letzd2varzd2_bglt BgL_new2499z00_2181;
{ /* Callcc/walk.scm 79 */
BgL_letzd2varzd2_bglt BgL_res3948z00_2187;
{ /* Callcc/walk.scm 79 */
BgL_letzd2varzd2_bglt BgL_new2501z00_2182;
BgL_new2501z00_2182 = 
((BgL_letzd2varzd2_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_letzd2varzd2_bgl) ))); 
{ /* Callcc/walk.scm 79 */
long BgL_arg3141z00_2183;
BgL_arg3141z00_2183 = 
BGl_classzd2numzd2zz__objectz00(BGl_letzd2varzd2zzast_nodez00); 
{ /* Callcc/walk.scm 79 */
BgL_objectz00_bglt BgL_auxz00_4127;
BgL_auxz00_4127 = 
(BgL_objectz00_bglt)(BgL_new2501z00_2182); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4127, BgL_arg3141z00_2183); } } 
{ /* Callcc/walk.scm 79 */
BgL_objectz00_bglt BgL_auxz00_4130;
BgL_auxz00_4130 = 
(BgL_objectz00_bglt)(BgL_new2501z00_2182); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4130, BFALSE); } 
{ /* Callcc/walk.scm 79 */
obj_t BgL_auxz00_4133;
BgL_auxz00_4133 = 
(obj_t)(BgL_new2501z00_2182); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4133); } BUNSPEC; 
BgL_res3948z00_2187 = BgL_new2501z00_2182; } 
BgL_new2499z00_2181 = BgL_res3948z00_2187; } 
{ /* Callcc/walk.scm 79 */
BgL_letzd2varzd2_bglt BgL_res3949z00_2203;
((((BgL_letzd2varzd2_bglt)CREF(BgL_new2499z00_2181))->BgL_locz00) = ((obj_t)BgL_arg2984z00_1379), BUNSPEC); 
((((BgL_letzd2varzd2_bglt)CREF(BgL_new2499z00_2181))->BgL_typez00) = ((BgL_typez00_bglt)BgL_type2493z00_2175), BUNSPEC); 
((((BgL_letzd2varzd2_bglt)CREF(BgL_new2499z00_2181))->BgL_sidezd2effectzf3z21) = ((obj_t)BUNSPEC), BUNSPEC); 
((((BgL_letzd2varzd2_bglt)CREF(BgL_new2499z00_2181))->BgL_keyz00) = ((obj_t)BgL_key2495z00_2177), BUNSPEC); 
((((BgL_letzd2varzd2_bglt)CREF(BgL_new2499z00_2181))->BgL_bindingsz00) = ((obj_t)BgL_arg2987z00_1382), BUNSPEC); 
((((BgL_letzd2varzd2_bglt)CREF(BgL_new2499z00_2181))->BgL_bodyz00) = ((BgL_nodez00_bglt)BgL_arg2988z00_1383), BUNSPEC); 
((((BgL_letzd2varzd2_bglt)CREF(BgL_new2499z00_2181))->BgL_removablezf3zf3) = ((bool_t)((bool_t)1)), BUNSPEC); 
BgL_res3949z00_2203 = BgL_new2499z00_2181; BgL_res3949z00_2203; } 
BgL_res3950z00_2204 = BgL_new2499z00_2181; } } 
return 
(BgL_nodez00_bglt)(BgL_res3950z00_2204);} } } } } 
}



/* a-make-cell */
BgL_makezd2boxzd2_bglt BGl_azd2makezd2cellz00zzcallcc_walkz00(BgL_nodez00_bglt BgL_nodez00_6, BgL_variablez00_bglt BgL_variablez00_7)
{ AN_OBJECT;
{ /* Callcc/walk.scm 95 */
{ /* Callcc/walk.scm 97 */
BgL_localz00_bglt BgL_obj1261z00_2205;obj_t BgL_val1260z00_2206;
BgL_obj1261z00_2205 = 
(BgL_localz00_bglt)(BgL_variablez00_7); 
BgL_val1260z00_2206 = 
CNST_TABLE_REF(((long)1)); 
((((BgL_localz00_bglt)CREF(BgL_obj1261z00_2205))->BgL_accessz00) = ((obj_t)BgL_val1260z00_2206), BUNSPEC); } 
{ /* Callcc/walk.scm 98 */
BgL_localzf2cellzf2_bglt BgL_obj2724z00_1404;
BgL_obj2724z00_1404 = 
((BgL_localzf2cellzf2_bglt)BgL_variablez00_7); 
{ /* Callcc/walk.scm 98 */
obj_t BgL_auxz00_4150;BgL_objectz00_bglt BgL_auxz00_4148;
{ /* Callcc/walk.scm 98 */
BgL_localzf2cellzf2_bglt BgL_auxz00_4151;
{ /* Callcc/walk.scm 98 */
BgL_localzf2cellzf2_bglt BgL_new2655z00_2207;
BgL_new2655z00_2207 = 
((BgL_localzf2cellzf2_bglt)BREF( GC_MALLOC (sizeof(struct BgL_localzf2cellzf2_bgl)))); 
BgL_auxz00_4151 = BgL_new2655z00_2207; } 
BgL_auxz00_4150 = 
(obj_t)(BgL_auxz00_4151); } 
BgL_auxz00_4148 = 
(BgL_objectz00_bglt)(BgL_obj2724z00_1404); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4148, BgL_auxz00_4150); } 
{ /* Callcc/walk.scm 98 */
long BgL_auxz00_4157;BgL_objectz00_bglt BgL_auxz00_4155;
BgL_auxz00_4157 = 
BGl_classzd2numzd2zz__objectz00(BGl_localzf2cellzf2zzcallcc_walkz00); 
BgL_auxz00_4155 = 
(BgL_objectz00_bglt)(BgL_obj2724z00_1404); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4155, BgL_auxz00_4157); } 
{ /* Callcc/walk.scm 98 */
obj_t BgL_auxz00_4160;
BgL_auxz00_4160 = 
(obj_t)(BgL_obj2724z00_1404); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4160); } BUNSPEC; BgL_obj2724z00_1404; } 
{ /* Callcc/walk.scm 99 */
obj_t BgL_arg3037z00_1407;obj_t BgL_arg3038z00_1408;BgL_nodez00_bglt BgL_arg3040z00_1410;
BgL_arg3037z00_1407 = 
(((BgL_nodez00_bglt)CREF(BgL_nodez00_6))->BgL_locz00); 
BgL_arg3038z00_1408 = BGl_za2_za2z00zztype_cachez00; 
BgL_arg3040z00_1410 = BgL_nodez00_6; 
{ /* Callcc/walk.scm 99 */
BgL_makezd2boxzd2_bglt BgL_res3954z00_2238;
{ /* Callcc/walk.scm 99 */
BgL_typez00_bglt BgL_type2585z00_2215;obj_t BgL_key2587z00_2217;
BgL_type2585z00_2215 = 
(BgL_typez00_bglt)(BgL_arg3038z00_1408); 
BgL_key2587z00_2217 = 
BINT(((long)-1)); 
{ /* Callcc/walk.scm 99 */
BgL_makezd2boxzd2_bglt BgL_new2589z00_2219;
{ /* Callcc/walk.scm 99 */
BgL_makezd2boxzd2_bglt BgL_res3952z00_2225;
{ /* Callcc/walk.scm 99 */
BgL_makezd2boxzd2_bglt BgL_new2591z00_2220;
BgL_new2591z00_2220 = 
((BgL_makezd2boxzd2_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_makezd2boxzd2_bgl) ))); 
{ /* Callcc/walk.scm 99 */
long BgL_arg3114z00_2221;
BgL_arg3114z00_2221 = 
BGl_classzd2numzd2zz__objectz00(BGl_makezd2boxzd2zzast_nodez00); 
{ /* Callcc/walk.scm 99 */
BgL_objectz00_bglt BgL_auxz00_4168;
BgL_auxz00_4168 = 
(BgL_objectz00_bglt)(BgL_new2591z00_2220); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4168, BgL_arg3114z00_2221); } } 
{ /* Callcc/walk.scm 99 */
BgL_objectz00_bglt BgL_auxz00_4171;
BgL_auxz00_4171 = 
(BgL_objectz00_bglt)(BgL_new2591z00_2220); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4171, BFALSE); } 
{ /* Callcc/walk.scm 99 */
obj_t BgL_auxz00_4174;
BgL_auxz00_4174 = 
(obj_t)(BgL_new2591z00_2220); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4174); } BUNSPEC; 
BgL_res3952z00_2225 = BgL_new2591z00_2220; } 
BgL_new2589z00_2219 = BgL_res3952z00_2225; } 
{ /* Callcc/walk.scm 99 */
BgL_makezd2boxzd2_bglt BgL_res3953z00_2237;
((((BgL_makezd2boxzd2_bglt)CREF(BgL_new2589z00_2219))->BgL_locz00) = ((obj_t)BgL_arg3037z00_1407), BUNSPEC); 
((((BgL_makezd2boxzd2_bglt)CREF(BgL_new2589z00_2219))->BgL_typez00) = ((BgL_typez00_bglt)BgL_type2585z00_2215), BUNSPEC); 
((((BgL_makezd2boxzd2_bglt)CREF(BgL_new2589z00_2219))->BgL_sidezd2effectzf3z21) = ((obj_t)BUNSPEC), BUNSPEC); 
((((BgL_makezd2boxzd2_bglt)CREF(BgL_new2589z00_2219))->BgL_keyz00) = ((obj_t)BgL_key2587z00_2217), BUNSPEC); 
((((BgL_makezd2boxzd2_bglt)CREF(BgL_new2589z00_2219))->BgL_valuez00) = ((BgL_nodez00_bglt)BgL_arg3040z00_1410), BUNSPEC); 
BgL_res3953z00_2237 = BgL_new2589z00_2219; BgL_res3953z00_2237; } 
BgL_res3954z00_2238 = BgL_new2589z00_2219; } } 
return BgL_res3954z00_2238;} } } 
}



/* celled? */
bool_t BGl_celledzf3zf3zzcallcc_walkz00(BgL_variablez00_bglt BgL_varz00_8)
{ AN_OBJECT;
{ /* Callcc/walk.scm 104 */
{ /* Callcc/walk.scm 105 */
bool_t BgL__ortest_2726z00_1411;
BgL__ortest_2726z00_1411 = 
BGl_iszd2azf3z21zz__objectz00(
(obj_t)(BgL_varz00_8), BGl_localzf2cellzf2zzcallcc_walkz00); 
if(BgL__ortest_2726z00_1411)
{ /* Callcc/walk.scm 105 */
return BgL__ortest_2726z00_1411;}  else 
{ /* Callcc/walk.scm 105 */
obj_t BgL_auxz00_4188;obj_t BgL_auxz00_4185;
BgL_auxz00_4188 = 
CNST_TABLE_REF(((long)2)); 
{ /* Callcc/walk.scm 105 */
BgL_localz00_bglt BgL_obj1259z00_2240;
BgL_obj1259z00_2240 = 
(BgL_localz00_bglt)(BgL_varz00_8); 
BgL_auxz00_4185 = 
(((BgL_localz00_bglt)CREF(BgL_obj1259z00_2240))->BgL_accessz00); } 
return 
(BgL_auxz00_4185==BgL_auxz00_4188);} } } 
}



/* callcc*! */
obj_t BGl_callccza2z12zb0zzcallcc_walkz00(obj_t BgL_nodeza2za2_31)
{ AN_OBJECT;
{ /* Callcc/walk.scm 327 */
BGl_callccza2z12zb0zzcallcc_walkz00:
if(
NULLP(BgL_nodeza2za2_31))
{ /* Callcc/walk.scm 328 */
return 
CNST_TABLE_REF(((long)3));}  else 
{ /* Callcc/walk.scm 328 */
{ /* Callcc/walk.scm 331 */
BgL_nodez00_bglt BgL_arg3051z00_1415;
{ /* Callcc/walk.scm 331 */
BgL_nodez00_bglt BgL_res3957z00_2269;
{ /* Callcc/walk.scm 331 */
BgL_nodez00_bglt BgL_nodez00_2243;
{ /* Callcc/walk.scm 331 */
obj_t BgL_auxz00_4194;
BgL_auxz00_4194 = 
CAR(BgL_nodeza2za2_31); 
BgL_nodez00_2243 = 
(BgL_nodez00_bglt)(BgL_auxz00_4194); } 
{ /* Callcc/walk.scm 331 */
obj_t BgL_method2759z00_2244;
{ /* Callcc/walk.scm 331 */
long BgL_objzd2classzd2numz00_2246;
{ /* Callcc/walk.scm 331 */
BgL_objectz00_bglt BgL_auxz00_4197;
BgL_auxz00_4197 = 
(BgL_objectz00_bglt)(BgL_nodez00_2243); 
BgL_objzd2classzd2numz00_2246 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4197); } 
{ /* Callcc/walk.scm 331 */
obj_t BgL_arg1904z00_2247;
{ /* Callcc/walk.scm 331 */
int BgL_auxz00_4200;
BgL_auxz00_4200 = 
(int)(((long)1)); 
BgL_arg1904z00_2247 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_4200); } 
{ /* Callcc/walk.scm 331 */
long BgL_offsetz00_2251;
{ /* Callcc/walk.scm 331 */
long BgL_auxz00_4203;
{ /* Callcc/walk.scm 331 */
int BgL_auxz00_4204;
BgL_auxz00_4204 = 
(int)(BgL_objzd2classzd2numz00_2246); 
BgL_auxz00_4203 = 
(long)(BgL_auxz00_4204); } 
BgL_offsetz00_2251 = 
(BgL_auxz00_4203-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 331 */
long BgL_modz00_2252;
{ /* Callcc/walk.scm 331 */
long BgL_auxz00_4208;
{ /* Callcc/walk.scm 331 */
int BgL_auxz00_4209;
BgL_auxz00_4209 = 
(int)(((long)8)); 
BgL_auxz00_4208 = 
(long)(BgL_auxz00_4209); } 
BgL_modz00_2252 = 
(BgL_offsetz00_2251/BgL_auxz00_4208); } 
{ /* Callcc/walk.scm 331 */
long BgL_restz00_2254;
{ /* Callcc/walk.scm 331 */
long BgL_auxz00_4213;
{ /* Callcc/walk.scm 331 */
int BgL_auxz00_4214;
BgL_auxz00_4214 = 
(int)(((long)8)); 
BgL_auxz00_4213 = 
(long)(BgL_auxz00_4214); } 
BgL_restz00_2254 = 
(BgL_offsetz00_2251%BgL_auxz00_4213); } 
{ /* Callcc/walk.scm 331 */

{ /* Callcc/walk.scm 331 */
obj_t BgL_bucketz00_2256;
{ /* Callcc/walk.scm 331 */
int BgL_kz00_2266;
BgL_kz00_2266 = 
(int)(BgL_modz00_2252); 
BgL_bucketz00_2256 = 
VECTOR_REF(BgL_arg1904z00_2247,BgL_kz00_2266); } 
{ /* Callcc/walk.scm 331 */
int BgL_kz00_2268;
BgL_kz00_2268 = 
(int)(BgL_restz00_2254); 
BgL_method2759z00_2244 = 
VECTOR_REF(BgL_bucketz00_2256,BgL_kz00_2268); } } } } } } } } 
{ /* Callcc/walk.scm 331 */
obj_t BgL_auxz00_4222;
BgL_auxz00_4222 = 
PROCEDURE_ENTRY(BgL_method2759z00_2244)(BgL_method2759z00_2244, 
(obj_t)(BgL_nodez00_2243), BEOA); 
BgL_res3957z00_2269 = 
(BgL_nodez00_bglt)(BgL_auxz00_4222); } } } 
BgL_arg3051z00_1415 = BgL_res3957z00_2269; } 
{ /* Callcc/walk.scm 331 */
obj_t BgL_auxz00_4227;
BgL_auxz00_4227 = 
(obj_t)(BgL_arg3051z00_1415); 
SET_CAR(BgL_nodeza2za2_31, BgL_auxz00_4227); } } 
{ 
obj_t BgL_nodeza2za2_4230;
BgL_nodeza2za2_4230 = 
CDR(BgL_nodeza2za2_31); 
BgL_nodeza2za2_31 = BgL_nodeza2za2_4230; 
goto BGl_callccza2z12zb0zzcallcc_walkz00;} } } 
}



/* object-init */
obj_t BGl_objectzd2initzd2zzcallcc_walkz00()
{ AN_OBJECT;
{ /* Callcc/walk.scm 16 */
{ /* Callcc/walk.scm 24 */
obj_t BgL_arg3063z00_1418;obj_t BgL_arg3064z00_1419;obj_t BgL_arg3068z00_1423;obj_t BgL_arg3069z00_1424;
BgL_arg3063z00_1418 = 
CNST_TABLE_REF(((long)4)); 
BgL_arg3064z00_1419 = BGl_localz00zzast_varz00; 
BgL_arg3068z00_1423 = BNIL; 
{ /* Callcc/walk.scm 24 */
obj_t BgL_v2757z00_1426;
{ 
int BgL_auxz00_4233;
BgL_auxz00_4233 = 
(int)(((long)0)); 
BgL_v2757z00_1426 = 
create_vector(BgL_auxz00_4233); } 
BgL_arg3069z00_1424 = BgL_v2757z00_1426; } 
BGl_localzf2cellzf2zzcallcc_walkz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BgL_arg3063z00_1418, BgL_arg3064z00_1419, BGl_makezd2localzf2cellzd2envzf2zzcallcc_walkz00, BGl_allocatezd2localzf2cellzd2envzf2zzcallcc_walkz00, ((long)47114), BgL_arg3068z00_1423, BFALSE, BgL_arg3069z00_1424); } 
return BUNSPEC;} 
}



/* make-local/cell */
BgL_localzf2cellzf2_bglt BGl_makezd2localzf2cellz20zzcallcc_walkz00(obj_t BgL_id2659z00_37, obj_t BgL_name2660z00_38, BgL_typez00_bglt BgL_type2661z00_39, BgL_valuez00_bglt BgL_value2662z00_40, obj_t BgL_access2663z00_41, obj_t BgL_fastzd2alpha2664zd2_42, obj_t BgL_removable2665z00_43, long BgL_occurrence2666z00_44, bool_t BgL_userzf32667zf3_45, long BgL_key2668z00_46)
{ AN_OBJECT;
{ /* Callcc/walk.scm 24 */
{ /* Callcc/walk.scm 24 */
BgL_localz00_bglt BgL_aux2669z00_2277;
{ /* Callcc/walk.scm 24 */
BgL_localz00_bglt BgL_res3961z00_2320;
{ /* Callcc/walk.scm 24 */
BgL_localz00_bglt BgL_new1307z00_2291;
{ /* Callcc/walk.scm 24 */
BgL_localz00_bglt BgL_res3959z00_2297;
{ /* Callcc/walk.scm 24 */
BgL_localz00_bglt BgL_new1309z00_2292;
BgL_new1309z00_2292 = 
((BgL_localz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_localz00_bgl) ))); 
{ /* Callcc/walk.scm 24 */
long BgL_arg3448z00_2293;
BgL_arg3448z00_2293 = 
BGl_classzd2numzd2zz__objectz00(BGl_localz00zzast_varz00); 
{ /* Callcc/walk.scm 24 */
BgL_objectz00_bglt BgL_auxz00_4239;
BgL_auxz00_4239 = 
(BgL_objectz00_bglt)(BgL_new1309z00_2292); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4239, BgL_arg3448z00_2293); } } 
{ /* Callcc/walk.scm 24 */
BgL_objectz00_bglt BgL_auxz00_4242;
BgL_auxz00_4242 = 
(BgL_objectz00_bglt)(BgL_new1309z00_2292); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4242, BFALSE); } 
{ /* Callcc/walk.scm 24 */
obj_t BgL_auxz00_4245;
BgL_auxz00_4245 = 
(obj_t)(BgL_new1309z00_2292); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4245); } BUNSPEC; 
BgL_res3959z00_2297 = BgL_new1309z00_2292; } 
BgL_new1307z00_2291 = BgL_res3959z00_2297; } 
{ /* Callcc/walk.scm 24 */
BgL_localz00_bglt BgL_res3960z00_2319;
((((BgL_localz00_bglt)CREF(BgL_new1307z00_2291))->BgL_idz00) = ((obj_t)BgL_id2659z00_37), BUNSPEC); 
((((BgL_localz00_bglt)CREF(BgL_new1307z00_2291))->BgL_namez00) = ((obj_t)BgL_name2660z00_38), BUNSPEC); 
((((BgL_localz00_bglt)CREF(BgL_new1307z00_2291))->BgL_typez00) = ((BgL_typez00_bglt)BgL_type2661z00_39), BUNSPEC); 
((((BgL_localz00_bglt)CREF(BgL_new1307z00_2291))->BgL_valuez00) = ((BgL_valuez00_bglt)BgL_value2662z00_40), BUNSPEC); 
((((BgL_localz00_bglt)CREF(BgL_new1307z00_2291))->BgL_accessz00) = ((obj_t)BgL_access2663z00_41), BUNSPEC); 
((((BgL_localz00_bglt)CREF(BgL_new1307z00_2291))->BgL_fastzd2alphazd2) = ((obj_t)BgL_fastzd2alpha2664zd2_42), BUNSPEC); 
((((BgL_localz00_bglt)CREF(BgL_new1307z00_2291))->BgL_removablez00) = ((obj_t)BgL_removable2665z00_43), BUNSPEC); 
((((BgL_localz00_bglt)CREF(BgL_new1307z00_2291))->BgL_occurrencez00) = ((long)BgL_occurrence2666z00_44), BUNSPEC); 
((((BgL_localz00_bglt)CREF(BgL_new1307z00_2291))->BgL_userzf3zf3) = ((bool_t)BgL_userzf32667zf3_45), BUNSPEC); 
((((BgL_localz00_bglt)CREF(BgL_new1307z00_2291))->BgL_keyz00) = ((long)BgL_key2668z00_46), BUNSPEC); 
BgL_res3960z00_2319 = BgL_new1307z00_2291; BgL_res3960z00_2319; } 
BgL_res3961z00_2320 = BgL_new1307z00_2291; } 
BgL_aux2669z00_2277 = BgL_res3961z00_2320; } 
{ /* Callcc/walk.scm 24 */
BgL_localzf2cellzf2_bglt BgL_new2670z00_2278;
BgL_new2670z00_2278 = 
((BgL_localzf2cellzf2_bglt)BgL_aux2669z00_2277); 
{ /* Callcc/walk.scm 24 */
long BgL_auxz00_4261;BgL_objectz00_bglt BgL_auxz00_4259;
BgL_auxz00_4261 = 
BGl_classzd2numzd2zz__objectz00(BGl_localzf2cellzf2zzcallcc_walkz00); 
BgL_auxz00_4259 = 
(BgL_objectz00_bglt)(BgL_new2670z00_2278); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4259, BgL_auxz00_4261); } 
{ /* Callcc/walk.scm 24 */
obj_t BgL_auxz00_4266;BgL_objectz00_bglt BgL_auxz00_4264;
{ /* Callcc/walk.scm 24 */
BgL_localzf2cellzf2_bglt BgL_auxz00_4267;
{ /* Callcc/walk.scm 24 */
BgL_localzf2cellzf2_bglt BgL_new2655z00_2323;
BgL_new2655z00_2323 = 
((BgL_localzf2cellzf2_bglt)BREF( GC_MALLOC (sizeof(struct BgL_localzf2cellzf2_bgl)))); 
BgL_auxz00_4267 = BgL_new2655z00_2323; } 
BgL_auxz00_4266 = 
(obj_t)(BgL_auxz00_4267); } 
BgL_auxz00_4264 = 
(BgL_objectz00_bglt)(BgL_new2670z00_2278); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4264, BgL_auxz00_4266); } 
{ /* Callcc/walk.scm 24 */
obj_t BgL_auxz00_4271;
BgL_auxz00_4271 = 
(obj_t)(BgL_new2670z00_2278); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4271); } BUNSPEC; 
return BgL_new2670z00_2278;} } } 
}



/* _make-local/cell4061 */
obj_t BGl__makezd2localzf2cell4061z20zzcallcc_walkz00(obj_t BgL_envz00_3785, obj_t BgL_id2659z00_3786, obj_t BgL_name2660z00_3787, obj_t BgL_type2661z00_3788, obj_t BgL_value2662z00_3789, obj_t BgL_access2663z00_3790, obj_t BgL_fastzd2alpha2664zd2_3791, obj_t BgL_removable2665z00_3792, obj_t BgL_occurrence2666z00_3793, obj_t BgL_userzf32667zf3_3794, obj_t BgL_key2668z00_3795)
{ AN_OBJECT;
{ /* Callcc/walk.scm 24 */
{ /* Callcc/walk.scm 24 */
BgL_localzf2cellzf2_bglt BgL_auxz00_4274;
BgL_auxz00_4274 = 
BGl_makezd2localzf2cellz20zzcallcc_walkz00(BgL_id2659z00_3786, BgL_name2660z00_3787, 
(BgL_typez00_bglt)(BgL_type2661z00_3788), 
(BgL_valuez00_bglt)(BgL_value2662z00_3789), BgL_access2663z00_3790, BgL_fastzd2alpha2664zd2_3791, BgL_removable2665z00_3792, 
(long)CINT(BgL_occurrence2666z00_3793), 
CBOOL(BgL_userzf32667zf3_3794), 
(long)CINT(BgL_key2668z00_3795)); 
return 
(obj_t)(BgL_auxz00_4274);} } 
}



/* allocate-local/cell */
BgL_localz00_bglt BGl_allocatezd2localzf2cellz20zzcallcc_walkz00()
{ AN_OBJECT;
{ /* Callcc/walk.scm 24 */
{ /* Callcc/walk.scm 24 */
BgL_localz00_bglt BgL_new2671z00_2327;
BgL_new2671z00_2327 = 
((BgL_localz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_localz00_bgl) ))); 
{ /* Callcc/walk.scm 24 */
long BgL_auxz00_4285;BgL_objectz00_bglt BgL_auxz00_4283;
BgL_auxz00_4285 = 
BGl_classzd2numzd2zz__objectz00(BGl_localzf2cellzf2zzcallcc_walkz00); 
BgL_auxz00_4283 = 
(BgL_objectz00_bglt)(BgL_new2671z00_2327); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4283, BgL_auxz00_4285); } 
{ /* Callcc/walk.scm 24 */
BgL_objectz00_bglt BgL_auxz00_4288;
BgL_auxz00_4288 = 
(BgL_objectz00_bglt)(BgL_new2671z00_2327); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4288, BFALSE); } 
{ /* Callcc/walk.scm 24 */
obj_t BgL_auxz00_4291;
BgL_auxz00_4291 = 
(obj_t)(BgL_new2671z00_2327); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4291); } BUNSPEC; 
return BgL_new2671z00_2327;} } 
}



/* _allocate-local/cell */
obj_t BGl__allocatezd2localzf2cellz20zzcallcc_walkz00(obj_t BgL_envz00_3796)
{ AN_OBJECT;
{ /* Callcc/walk.scm 24 */
{ /* Callcc/walk.scm 24 */
BgL_localz00_bglt BgL_auxz00_4294;
BgL_auxz00_4294 = 
BGl_allocatezd2localzf2cellz20zzcallcc_walkz00(); 
return 
(obj_t)(BgL_auxz00_4294);} } 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzcallcc_walkz00()
{ AN_OBJECT;
{ /* Callcc/walk.scm 16 */
BGl_addzd2genericz12zc0zz__objectz00(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_callccz12zd2default2758zd2envz12zzcallcc_walkz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_atomz00zzast_nodez00, BGl_proc4628z00zzcallcc_walkz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_kwotez00zzast_nodez00, BGl_proc4629z00zzcallcc_walkz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_varz00zzast_nodez00, BGl_proc4630z00zzcallcc_walkz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_sequencez00zzast_nodez00, BGl_proc4631z00zzcallcc_walkz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_appz00zzast_nodez00, BGl_proc4632z00zzcallcc_walkz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_appzd2lyzd2zzast_nodez00, BGl_proc4633z00zzcallcc_walkz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_funcallz00zzast_nodez00, BGl_proc4634z00zzcallcc_walkz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_externz00zzast_nodez00, BGl_proc4635z00zzcallcc_walkz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_castz00zzast_nodez00, BGl_proc4636z00zzcallcc_walkz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_setqz00zzast_nodez00, BGl_proc4637z00zzcallcc_walkz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_conditionalz00zzast_nodez00, BGl_proc4638z00zzcallcc_walkz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_failz00zzast_nodez00, BGl_proc4639z00zzcallcc_walkz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_selectz00zzast_nodez00, BGl_proc4640z00zzcallcc_walkz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_letzd2funzd2zzast_nodez00, BGl_proc4641z00zzcallcc_walkz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_letzd2varzd2zzast_nodez00, BGl_proc4642z00zzcallcc_walkz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc4643z00zzcallcc_walkz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc4644z00zzcallcc_walkz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_makezd2boxzd2zzast_nodez00, BGl_proc4645z00zzcallcc_walkz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_boxzd2refzd2zzast_nodez00, BGl_proc4646z00zzcallcc_walkz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc4647z00zzcallcc_walkz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_objectzd2ze3structzd2envze3zz__objectz00, BGl_localzf2cellzf2zzcallcc_walkz00, BGl_proc4648z00zzcallcc_walkz00); 
return 
BGl_addzd2methodz12zc0zz__objectz00(BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00, BGl_localzf2cellzf2zzcallcc_walkz00, BGl_proc4649z00zzcallcc_walkz00);} 
}



/* struct+object->object-local/cell2803 */
obj_t BGl_structzb2objectzd2ze3objectzd2localzf2cell2803za3zzcallcc_walkz00(obj_t BgL_envz00_3824, obj_t BgL_oz00_3825, obj_t BgL_sz00_3826)
{ AN_OBJECT;
{ /* Callcc/walk.scm 24 */
{ 
BgL_localzf2cellzf2_bglt BgL_oz00_2046;obj_t BgL_sz00_2047;
{ /* Callcc/walk.scm 24 */
BgL_localzf2cellzf2_bglt BgL_auxz00_4320;
BgL_oz00_2046 = 
(BgL_localzf2cellzf2_bglt)(BgL_oz00_3825); 
BgL_sz00_2047 = BgL_sz00_3826; 
{ 

{ /* Callcc/walk.scm 24 */
obj_t BgL_old2675z00_2050;
{ /* Callcc/walk.scm 24 */
obj_t BgL_nextzd2method2802zd2_2055;
BgL_nextzd2method2802zd2_2055 = 
BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
(BgL_objectz00_bglt)(BgL_oz00_2046), BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00, BGl_localzf2cellzf2zzcallcc_walkz00); 
if(
PROCEDUREP(BgL_nextzd2method2802zd2_2055))
{ /* Callcc/walk.scm 24 */
BgL_old2675z00_2050 = 
PROCEDURE_ENTRY(BgL_nextzd2method2802zd2_2055)(BgL_nextzd2method2802zd2_2055, 
(obj_t)(BgL_oz00_2046), BgL_sz00_2047, BEOA); }  else 
{ /* Callcc/walk.scm 24 */
{ /* Callcc/walk.scm 24 */
BgL_objectz00_bglt BgL_auxz00_4328;
BgL_auxz00_4328 = 
BGl_structzb2objectzd2ze3objectz83zz__objectz00(
(BgL_objectz00_bglt)(BgL_oz00_2046), BgL_sz00_2047); 
BgL_old2675z00_2050 = 
(obj_t)(BgL_auxz00_4328); } } } 
{ /* Callcc/walk.scm 24 */
BgL_localzf2cellzf2_bglt BgL_new2677z00_2052;
BgL_new2677z00_2052 = 
((BgL_localzf2cellzf2_bglt)(BgL_old2675z00_2050)); 
{ /* Callcc/walk.scm 24 */
long BgL_auxz00_4335;BgL_objectz00_bglt BgL_auxz00_4333;
BgL_auxz00_4335 = 
BGl_classzd2numzd2zz__objectz00(BGl_localzf2cellzf2zzcallcc_walkz00); 
BgL_auxz00_4333 = 
(BgL_objectz00_bglt)(BgL_new2677z00_2052); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4333, BgL_auxz00_4335); } 
{ /* Callcc/walk.scm 24 */
obj_t BgL_auxz00_4340;BgL_objectz00_bglt BgL_auxz00_4338;
{ /* Callcc/walk.scm 24 */
BgL_localzf2cellzf2_bglt BgL_auxz00_4341;
{ /* Callcc/walk.scm 24 */
BgL_localzf2cellzf2_bglt BgL_new2655z00_3748;
BgL_new2655z00_3748 = 
((BgL_localzf2cellzf2_bglt)BREF( GC_MALLOC (sizeof(struct BgL_localzf2cellzf2_bgl)))); 
BgL_auxz00_4341 = BgL_new2655z00_3748; } 
BgL_auxz00_4340 = 
(obj_t)(BgL_auxz00_4341); } 
BgL_auxz00_4338 = 
(BgL_objectz00_bglt)(BgL_new2677z00_2052); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4338, BgL_auxz00_4340); } 
{ /* Callcc/walk.scm 24 */
obj_t BgL_auxz00_4345;
BgL_auxz00_4345 = 
(obj_t)(BgL_new2677z00_2052); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4345); } BUNSPEC; 
BgL_auxz00_4320 = BgL_new2677z00_2052; } } } 
return 
(obj_t)(BgL_auxz00_4320);} } } 
}



/* object->struct-local/cell2801 */
obj_t BGl_objectzd2ze3structzd2localzf2cell2801z11zzcallcc_walkz00(obj_t BgL_envz00_3827, obj_t BgL_obj2672z00_3828)
{ AN_OBJECT;
{ /* Callcc/walk.scm 24 */
{ 
BgL_localzf2cellzf2_bglt BgL_obj2672z00_2038;
BgL_obj2672z00_2038 = 
(BgL_localzf2cellzf2_bglt)(BgL_obj2672z00_3828); 
{ 

{ /* Callcc/walk.scm 24 */
obj_t BgL_res2673z00_2041;
{ /* Callcc/walk.scm 24 */
obj_t BgL_nextzd2method2800zd2_2044;
BgL_nextzd2method2800zd2_2044 = 
BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
(BgL_objectz00_bglt)(BgL_obj2672z00_2038), BGl_objectzd2ze3structzd2envze3zz__objectz00, BGl_localzf2cellzf2zzcallcc_walkz00); 
if(
PROCEDUREP(BgL_nextzd2method2800zd2_2044))
{ /* Callcc/walk.scm 24 */
BgL_res2673z00_2041 = 
PROCEDURE_ENTRY(BgL_nextzd2method2800zd2_2044)(BgL_nextzd2method2800zd2_2044, 
(obj_t)(BgL_obj2672z00_2038), BEOA); }  else 
{ /* Callcc/walk.scm 24 */
BgL_res2673z00_2041 = 
BGl_objectzd2ze3structz31zz__objectz00(
(BgL_objectz00_bglt)(BgL_obj2672z00_2038)); } } 
{ /* Callcc/walk.scm 24 */
obj_t BgL_aux2674z00_2042;
{ /* Callcc/walk.scm 24 */
int BgL_auxz00_4361;obj_t BgL_auxz00_4359;
BgL_auxz00_4361 = 
(int)(((long)0)); 
BgL_auxz00_4359 = 
CNST_TABLE_REF(((long)4)); 
BgL_aux2674z00_2042 = 
make_struct(BgL_auxz00_4359, BgL_auxz00_4361, BUNSPEC); } 
{ /* Callcc/walk.scm 24 */
int BgL_auxz00_4364;
BgL_auxz00_4364 = 
(int)(((long)0)); 
STRUCT_SET(BgL_res2673z00_2041, BgL_auxz00_4364, BgL_aux2674z00_2042); } 
{ /* Callcc/walk.scm 24 */
obj_t BgL_auxz00_4367;
BgL_auxz00_4367 = 
STRUCT_KEY(BgL_res2673z00_2041); 
STRUCT_KEY_SET(BgL_aux2674z00_2042, BgL_auxz00_4367); } 
{ /* Callcc/walk.scm 24 */
obj_t BgL_auxz00_4370;
BgL_auxz00_4370 = 
CNST_TABLE_REF(((long)4)); 
STRUCT_KEY_SET(BgL_res2673z00_2041, BgL_auxz00_4370); } 
return BgL_res2673z00_2041;} } } } } 
}



/* callcc!-box-set!2799 */
obj_t BGl_callccz12zd2boxzd2setz122799z00zzcallcc_walkz00(obj_t BgL_envz00_3829, obj_t BgL_nodez00_3830)
{ AN_OBJECT;
{ /* Callcc/walk.scm 319 */
{ 
BgL_boxzd2setz12zc0_bglt BgL_nodez00_2030;
{ /* Callcc/walk.scm 320 */
BgL_boxzd2setz12zc0_bglt BgL_auxz00_4374;
BgL_nodez00_2030 = 
(BgL_boxzd2setz12zc0_bglt)(BgL_nodez00_3830); 
{ /* Callcc/walk.scm 321 */
BgL_nodez00_bglt BgL_arg3884z00_2034;
{ /* Callcc/walk.scm 321 */
BgL_nodez00_bglt BgL_arg3887z00_2035;
BgL_arg3887z00_2035 = 
(((BgL_boxzd2setz12zc0_bglt)CREF(BgL_nodez00_2030))->BgL_valuez00); 
{ /* Callcc/walk.scm 321 */
BgL_nodez00_bglt BgL_res4053z00_3728;
{ /* Callcc/walk.scm 321 */
obj_t BgL_method2759z00_3703;
{ /* Callcc/walk.scm 321 */
long BgL_objzd2classzd2numz00_3705;
{ /* Callcc/walk.scm 321 */
BgL_objectz00_bglt BgL_auxz00_4376;
BgL_auxz00_4376 = 
(BgL_objectz00_bglt)(BgL_arg3887z00_2035); 
BgL_objzd2classzd2numz00_3705 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4376); } 
{ /* Callcc/walk.scm 321 */
obj_t BgL_arg1904z00_3706;
{ /* Callcc/walk.scm 321 */
int BgL_auxz00_4379;
BgL_auxz00_4379 = 
(int)(((long)1)); 
BgL_arg1904z00_3706 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_4379); } 
{ /* Callcc/walk.scm 321 */
long BgL_offsetz00_3710;
{ /* Callcc/walk.scm 321 */
long BgL_auxz00_4382;
{ /* Callcc/walk.scm 321 */
int BgL_auxz00_4383;
BgL_auxz00_4383 = 
(int)(BgL_objzd2classzd2numz00_3705); 
BgL_auxz00_4382 = 
(long)(BgL_auxz00_4383); } 
BgL_offsetz00_3710 = 
(BgL_auxz00_4382-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 321 */
long BgL_modz00_3711;
{ /* Callcc/walk.scm 321 */
long BgL_auxz00_4387;
{ /* Callcc/walk.scm 321 */
int BgL_auxz00_4388;
BgL_auxz00_4388 = 
(int)(((long)8)); 
BgL_auxz00_4387 = 
(long)(BgL_auxz00_4388); } 
BgL_modz00_3711 = 
(BgL_offsetz00_3710/BgL_auxz00_4387); } 
{ /* Callcc/walk.scm 321 */
long BgL_restz00_3713;
{ /* Callcc/walk.scm 321 */
long BgL_auxz00_4392;
{ /* Callcc/walk.scm 321 */
int BgL_auxz00_4393;
BgL_auxz00_4393 = 
(int)(((long)8)); 
BgL_auxz00_4392 = 
(long)(BgL_auxz00_4393); } 
BgL_restz00_3713 = 
(BgL_offsetz00_3710%BgL_auxz00_4392); } 
{ /* Callcc/walk.scm 321 */

{ /* Callcc/walk.scm 321 */
obj_t BgL_bucketz00_3715;
{ /* Callcc/walk.scm 321 */
int BgL_kz00_3725;
BgL_kz00_3725 = 
(int)(BgL_modz00_3711); 
BgL_bucketz00_3715 = 
VECTOR_REF(BgL_arg1904z00_3706,BgL_kz00_3725); } 
{ /* Callcc/walk.scm 321 */
int BgL_kz00_3727;
BgL_kz00_3727 = 
(int)(BgL_restz00_3713); 
BgL_method2759z00_3703 = 
VECTOR_REF(BgL_bucketz00_3715,BgL_kz00_3727); } } } } } } } } 
{ /* Callcc/walk.scm 321 */
obj_t BgL_auxz00_4401;
BgL_auxz00_4401 = 
PROCEDURE_ENTRY(BgL_method2759z00_3703)(BgL_method2759z00_3703, 
(obj_t)(BgL_arg3887z00_2035), BEOA); 
BgL_res4053z00_3728 = 
(BgL_nodez00_bglt)(BgL_auxz00_4401); } } 
BgL_arg3884z00_2034 = BgL_res4053z00_3728; } } 
((((BgL_boxzd2setz12zc0_bglt)CREF(BgL_nodez00_2030))->BgL_valuez00) = ((BgL_nodez00_bglt)BgL_arg3884z00_2034), BUNSPEC); } 
BgL_auxz00_4374 = BgL_nodez00_2030; 
return 
(obj_t)(BgL_auxz00_4374);} } } 
}



/* callcc!-box-ref2797 */
obj_t BGl_callccz12zd2boxzd2ref2797z12zzcallcc_walkz00(obj_t BgL_envz00_3831, obj_t BgL_nodez00_3832)
{ AN_OBJECT;
{ /* Callcc/walk.scm 313 */
{ 
BgL_boxzd2refzd2_bglt BgL_nodez00_2025;
{ /* Callcc/walk.scm 314 */
BgL_boxzd2refzd2_bglt BgL_auxz00_4409;
BgL_nodez00_2025 = 
(BgL_boxzd2refzd2_bglt)(BgL_nodez00_3832); 
BgL_auxz00_4409 = BgL_nodez00_2025; 
return 
(obj_t)(BgL_auxz00_4409);} } } 
}



/* callcc!-make-box2795 */
obj_t BGl_callccz12zd2makezd2box2795z12zzcallcc_walkz00(obj_t BgL_envz00_3833, obj_t BgL_nodez00_3834)
{ AN_OBJECT;
{ /* Callcc/walk.scm 306 */
{ 
BgL_makezd2boxzd2_bglt BgL_nodez00_2018;
{ /* Callcc/walk.scm 307 */
BgL_makezd2boxzd2_bglt BgL_auxz00_4412;
BgL_nodez00_2018 = 
(BgL_makezd2boxzd2_bglt)(BgL_nodez00_3834); 
{ /* Callcc/walk.scm 307 */
BgL_nodez00_bglt BgL_arg3865z00_2021;
{ /* Callcc/walk.scm 307 */
BgL_nodez00_bglt BgL_arg3868z00_2022;
BgL_arg3868z00_2022 = 
(((BgL_makezd2boxzd2_bglt)CREF(BgL_nodez00_2018))->BgL_valuez00); 
{ /* Callcc/walk.scm 307 */
BgL_nodez00_bglt BgL_res4050z00_3698;
{ /* Callcc/walk.scm 307 */
obj_t BgL_method2759z00_3673;
{ /* Callcc/walk.scm 307 */
long BgL_objzd2classzd2numz00_3675;
{ /* Callcc/walk.scm 307 */
BgL_objectz00_bglt BgL_auxz00_4414;
BgL_auxz00_4414 = 
(BgL_objectz00_bglt)(BgL_arg3868z00_2022); 
BgL_objzd2classzd2numz00_3675 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4414); } 
{ /* Callcc/walk.scm 307 */
obj_t BgL_arg1904z00_3676;
{ /* Callcc/walk.scm 307 */
int BgL_auxz00_4417;
BgL_auxz00_4417 = 
(int)(((long)1)); 
BgL_arg1904z00_3676 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_4417); } 
{ /* Callcc/walk.scm 307 */
long BgL_offsetz00_3680;
{ /* Callcc/walk.scm 307 */
long BgL_auxz00_4420;
{ /* Callcc/walk.scm 307 */
int BgL_auxz00_4421;
BgL_auxz00_4421 = 
(int)(BgL_objzd2classzd2numz00_3675); 
BgL_auxz00_4420 = 
(long)(BgL_auxz00_4421); } 
BgL_offsetz00_3680 = 
(BgL_auxz00_4420-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 307 */
long BgL_modz00_3681;
{ /* Callcc/walk.scm 307 */
long BgL_auxz00_4425;
{ /* Callcc/walk.scm 307 */
int BgL_auxz00_4426;
BgL_auxz00_4426 = 
(int)(((long)8)); 
BgL_auxz00_4425 = 
(long)(BgL_auxz00_4426); } 
BgL_modz00_3681 = 
(BgL_offsetz00_3680/BgL_auxz00_4425); } 
{ /* Callcc/walk.scm 307 */
long BgL_restz00_3683;
{ /* Callcc/walk.scm 307 */
long BgL_auxz00_4430;
{ /* Callcc/walk.scm 307 */
int BgL_auxz00_4431;
BgL_auxz00_4431 = 
(int)(((long)8)); 
BgL_auxz00_4430 = 
(long)(BgL_auxz00_4431); } 
BgL_restz00_3683 = 
(BgL_offsetz00_3680%BgL_auxz00_4430); } 
{ /* Callcc/walk.scm 307 */

{ /* Callcc/walk.scm 307 */
obj_t BgL_bucketz00_3685;
{ /* Callcc/walk.scm 307 */
int BgL_kz00_3695;
BgL_kz00_3695 = 
(int)(BgL_modz00_3681); 
BgL_bucketz00_3685 = 
VECTOR_REF(BgL_arg1904z00_3676,BgL_kz00_3695); } 
{ /* Callcc/walk.scm 307 */
int BgL_kz00_3697;
BgL_kz00_3697 = 
(int)(BgL_restz00_3683); 
BgL_method2759z00_3673 = 
VECTOR_REF(BgL_bucketz00_3685,BgL_kz00_3697); } } } } } } } } 
{ /* Callcc/walk.scm 307 */
obj_t BgL_auxz00_4439;
BgL_auxz00_4439 = 
PROCEDURE_ENTRY(BgL_method2759z00_3673)(BgL_method2759z00_3673, 
(obj_t)(BgL_arg3868z00_2022), BEOA); 
BgL_res4050z00_3698 = 
(BgL_nodez00_bglt)(BgL_auxz00_4439); } } 
BgL_arg3865z00_2021 = BgL_res4050z00_3698; } } 
((((BgL_makezd2boxzd2_bglt)CREF(BgL_nodez00_2018))->BgL_valuez00) = ((BgL_nodez00_bglt)BgL_arg3865z00_2021), BUNSPEC); } 
BgL_auxz00_4412 = BgL_nodez00_2018; 
return 
(obj_t)(BgL_auxz00_4412);} } } 
}



/* callcc!-jump-ex-it2793 */
obj_t BGl_callccz12zd2jumpzd2exzd2it2793zc0zzcallcc_walkz00(obj_t BgL_envz00_3835, obj_t BgL_nodez00_3836)
{ AN_OBJECT;
{ /* Callcc/walk.scm 297 */
{ 
BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_2008;
{ /* Callcc/walk.scm 298 */
BgL_jumpzd2exzd2itz00_bglt BgL_auxz00_4447;
BgL_nodez00_2008 = 
(BgL_jumpzd2exzd2itz00_bglt)(BgL_nodez00_3836); 
{ /* Callcc/walk.scm 299 */
BgL_nodez00_bglt BgL_arg3845z00_2012;
{ /* Callcc/walk.scm 299 */
BgL_nodez00_bglt BgL_arg3848z00_2013;
BgL_arg3848z00_2013 = 
(((BgL_jumpzd2exzd2itz00_bglt)CREF(BgL_nodez00_2008))->BgL_exitz00); 
{ /* Callcc/walk.scm 299 */
BgL_nodez00_bglt BgL_res4044z00_3638;
{ /* Callcc/walk.scm 299 */
obj_t BgL_method2759z00_3613;
{ /* Callcc/walk.scm 299 */
long BgL_objzd2classzd2numz00_3615;
{ /* Callcc/walk.scm 299 */
BgL_objectz00_bglt BgL_auxz00_4449;
BgL_auxz00_4449 = 
(BgL_objectz00_bglt)(BgL_arg3848z00_2013); 
BgL_objzd2classzd2numz00_3615 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4449); } 
{ /* Callcc/walk.scm 299 */
obj_t BgL_arg1904z00_3616;
{ /* Callcc/walk.scm 299 */
int BgL_auxz00_4452;
BgL_auxz00_4452 = 
(int)(((long)1)); 
BgL_arg1904z00_3616 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_4452); } 
{ /* Callcc/walk.scm 299 */
long BgL_offsetz00_3620;
{ /* Callcc/walk.scm 299 */
long BgL_auxz00_4455;
{ /* Callcc/walk.scm 299 */
int BgL_auxz00_4456;
BgL_auxz00_4456 = 
(int)(BgL_objzd2classzd2numz00_3615); 
BgL_auxz00_4455 = 
(long)(BgL_auxz00_4456); } 
BgL_offsetz00_3620 = 
(BgL_auxz00_4455-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 299 */
long BgL_modz00_3621;
{ /* Callcc/walk.scm 299 */
long BgL_auxz00_4460;
{ /* Callcc/walk.scm 299 */
int BgL_auxz00_4461;
BgL_auxz00_4461 = 
(int)(((long)8)); 
BgL_auxz00_4460 = 
(long)(BgL_auxz00_4461); } 
BgL_modz00_3621 = 
(BgL_offsetz00_3620/BgL_auxz00_4460); } 
{ /* Callcc/walk.scm 299 */
long BgL_restz00_3623;
{ /* Callcc/walk.scm 299 */
long BgL_auxz00_4465;
{ /* Callcc/walk.scm 299 */
int BgL_auxz00_4466;
BgL_auxz00_4466 = 
(int)(((long)8)); 
BgL_auxz00_4465 = 
(long)(BgL_auxz00_4466); } 
BgL_restz00_3623 = 
(BgL_offsetz00_3620%BgL_auxz00_4465); } 
{ /* Callcc/walk.scm 299 */

{ /* Callcc/walk.scm 299 */
obj_t BgL_bucketz00_3625;
{ /* Callcc/walk.scm 299 */
int BgL_kz00_3635;
BgL_kz00_3635 = 
(int)(BgL_modz00_3621); 
BgL_bucketz00_3625 = 
VECTOR_REF(BgL_arg1904z00_3616,BgL_kz00_3635); } 
{ /* Callcc/walk.scm 299 */
int BgL_kz00_3637;
BgL_kz00_3637 = 
(int)(BgL_restz00_3623); 
BgL_method2759z00_3613 = 
VECTOR_REF(BgL_bucketz00_3625,BgL_kz00_3637); } } } } } } } } 
{ /* Callcc/walk.scm 299 */
obj_t BgL_auxz00_4474;
BgL_auxz00_4474 = 
PROCEDURE_ENTRY(BgL_method2759z00_3613)(BgL_method2759z00_3613, 
(obj_t)(BgL_arg3848z00_2013), BEOA); 
BgL_res4044z00_3638 = 
(BgL_nodez00_bglt)(BgL_auxz00_4474); } } 
BgL_arg3845z00_2012 = BgL_res4044z00_3638; } } 
((((BgL_jumpzd2exzd2itz00_bglt)CREF(BgL_nodez00_2008))->BgL_exitz00) = ((BgL_nodez00_bglt)BgL_arg3845z00_2012), BUNSPEC); } 
{ /* Callcc/walk.scm 300 */
BgL_nodez00_bglt BgL_arg3852z00_2014;
{ /* Callcc/walk.scm 300 */
BgL_nodez00_bglt BgL_arg3855z00_2015;
BgL_arg3855z00_2015 = 
(((BgL_jumpzd2exzd2itz00_bglt)CREF(BgL_nodez00_2008))->BgL_valuez00); 
{ /* Callcc/walk.scm 300 */
BgL_nodez00_bglt BgL_res4047z00_3668;
{ /* Callcc/walk.scm 300 */
obj_t BgL_method2759z00_3643;
{ /* Callcc/walk.scm 300 */
long BgL_objzd2classzd2numz00_3645;
{ /* Callcc/walk.scm 300 */
BgL_objectz00_bglt BgL_auxz00_4481;
BgL_auxz00_4481 = 
(BgL_objectz00_bglt)(BgL_arg3855z00_2015); 
BgL_objzd2classzd2numz00_3645 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4481); } 
{ /* Callcc/walk.scm 300 */
obj_t BgL_arg1904z00_3646;
{ /* Callcc/walk.scm 300 */
int BgL_auxz00_4484;
BgL_auxz00_4484 = 
(int)(((long)1)); 
BgL_arg1904z00_3646 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_4484); } 
{ /* Callcc/walk.scm 300 */
long BgL_offsetz00_3650;
{ /* Callcc/walk.scm 300 */
long BgL_auxz00_4487;
{ /* Callcc/walk.scm 300 */
int BgL_auxz00_4488;
BgL_auxz00_4488 = 
(int)(BgL_objzd2classzd2numz00_3645); 
BgL_auxz00_4487 = 
(long)(BgL_auxz00_4488); } 
BgL_offsetz00_3650 = 
(BgL_auxz00_4487-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 300 */
long BgL_modz00_3651;
{ /* Callcc/walk.scm 300 */
long BgL_auxz00_4492;
{ /* Callcc/walk.scm 300 */
int BgL_auxz00_4493;
BgL_auxz00_4493 = 
(int)(((long)8)); 
BgL_auxz00_4492 = 
(long)(BgL_auxz00_4493); } 
BgL_modz00_3651 = 
(BgL_offsetz00_3650/BgL_auxz00_4492); } 
{ /* Callcc/walk.scm 300 */
long BgL_restz00_3653;
{ /* Callcc/walk.scm 300 */
long BgL_auxz00_4497;
{ /* Callcc/walk.scm 300 */
int BgL_auxz00_4498;
BgL_auxz00_4498 = 
(int)(((long)8)); 
BgL_auxz00_4497 = 
(long)(BgL_auxz00_4498); } 
BgL_restz00_3653 = 
(BgL_offsetz00_3650%BgL_auxz00_4497); } 
{ /* Callcc/walk.scm 300 */

{ /* Callcc/walk.scm 300 */
obj_t BgL_bucketz00_3655;
{ /* Callcc/walk.scm 300 */
int BgL_kz00_3665;
BgL_kz00_3665 = 
(int)(BgL_modz00_3651); 
BgL_bucketz00_3655 = 
VECTOR_REF(BgL_arg1904z00_3646,BgL_kz00_3665); } 
{ /* Callcc/walk.scm 300 */
int BgL_kz00_3667;
BgL_kz00_3667 = 
(int)(BgL_restz00_3653); 
BgL_method2759z00_3643 = 
VECTOR_REF(BgL_bucketz00_3655,BgL_kz00_3667); } } } } } } } } 
{ /* Callcc/walk.scm 300 */
obj_t BgL_auxz00_4506;
BgL_auxz00_4506 = 
PROCEDURE_ENTRY(BgL_method2759z00_3643)(BgL_method2759z00_3643, 
(obj_t)(BgL_arg3855z00_2015), BEOA); 
BgL_res4047z00_3668 = 
(BgL_nodez00_bglt)(BgL_auxz00_4506); } } 
BgL_arg3852z00_2014 = BgL_res4047z00_3668; } } 
((((BgL_jumpzd2exzd2itz00_bglt)CREF(BgL_nodez00_2008))->BgL_valuez00) = ((BgL_nodez00_bglt)BgL_arg3852z00_2014), BUNSPEC); } 
BgL_auxz00_4447 = BgL_nodez00_2008; 
return 
(obj_t)(BgL_auxz00_4447);} } } 
}



/* callcc!-set-ex-it2791 */
obj_t BGl_callccz12zd2setzd2exzd2it2791zc0zzcallcc_walkz00(obj_t BgL_envz00_3837, obj_t BgL_nodez00_3838)
{ AN_OBJECT;
{ /* Callcc/walk.scm 290 */
{ 
BgL_setzd2exzd2itz00_bglt BgL_nodez00_2001;
{ /* Callcc/walk.scm 291 */
BgL_setzd2exzd2itz00_bglt BgL_auxz00_4514;
BgL_nodez00_2001 = 
(BgL_setzd2exzd2itz00_bglt)(BgL_nodez00_3838); 
{ /* Callcc/walk.scm 291 */
BgL_nodez00_bglt BgL_arg3832z00_2004;
{ /* Callcc/walk.scm 291 */
BgL_nodez00_bglt BgL_arg3835z00_2005;
BgL_arg3835z00_2005 = 
(((BgL_setzd2exzd2itz00_bglt)CREF(BgL_nodez00_2001))->BgL_bodyz00); 
{ /* Callcc/walk.scm 291 */
BgL_nodez00_bglt BgL_res4041z00_3608;
{ /* Callcc/walk.scm 291 */
obj_t BgL_method2759z00_3583;
{ /* Callcc/walk.scm 291 */
long BgL_objzd2classzd2numz00_3585;
{ /* Callcc/walk.scm 291 */
BgL_objectz00_bglt BgL_auxz00_4516;
BgL_auxz00_4516 = 
(BgL_objectz00_bglt)(BgL_arg3835z00_2005); 
BgL_objzd2classzd2numz00_3585 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4516); } 
{ /* Callcc/walk.scm 291 */
obj_t BgL_arg1904z00_3586;
{ /* Callcc/walk.scm 291 */
int BgL_auxz00_4519;
BgL_auxz00_4519 = 
(int)(((long)1)); 
BgL_arg1904z00_3586 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_4519); } 
{ /* Callcc/walk.scm 291 */
long BgL_offsetz00_3590;
{ /* Callcc/walk.scm 291 */
long BgL_auxz00_4522;
{ /* Callcc/walk.scm 291 */
int BgL_auxz00_4523;
BgL_auxz00_4523 = 
(int)(BgL_objzd2classzd2numz00_3585); 
BgL_auxz00_4522 = 
(long)(BgL_auxz00_4523); } 
BgL_offsetz00_3590 = 
(BgL_auxz00_4522-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 291 */
long BgL_modz00_3591;
{ /* Callcc/walk.scm 291 */
long BgL_auxz00_4527;
{ /* Callcc/walk.scm 291 */
int BgL_auxz00_4528;
BgL_auxz00_4528 = 
(int)(((long)8)); 
BgL_auxz00_4527 = 
(long)(BgL_auxz00_4528); } 
BgL_modz00_3591 = 
(BgL_offsetz00_3590/BgL_auxz00_4527); } 
{ /* Callcc/walk.scm 291 */
long BgL_restz00_3593;
{ /* Callcc/walk.scm 291 */
long BgL_auxz00_4532;
{ /* Callcc/walk.scm 291 */
int BgL_auxz00_4533;
BgL_auxz00_4533 = 
(int)(((long)8)); 
BgL_auxz00_4532 = 
(long)(BgL_auxz00_4533); } 
BgL_restz00_3593 = 
(BgL_offsetz00_3590%BgL_auxz00_4532); } 
{ /* Callcc/walk.scm 291 */

{ /* Callcc/walk.scm 291 */
obj_t BgL_bucketz00_3595;
{ /* Callcc/walk.scm 291 */
int BgL_kz00_3605;
BgL_kz00_3605 = 
(int)(BgL_modz00_3591); 
BgL_bucketz00_3595 = 
VECTOR_REF(BgL_arg1904z00_3586,BgL_kz00_3605); } 
{ /* Callcc/walk.scm 291 */
int BgL_kz00_3607;
BgL_kz00_3607 = 
(int)(BgL_restz00_3593); 
BgL_method2759z00_3583 = 
VECTOR_REF(BgL_bucketz00_3595,BgL_kz00_3607); } } } } } } } } 
{ /* Callcc/walk.scm 291 */
obj_t BgL_auxz00_4541;
BgL_auxz00_4541 = 
PROCEDURE_ENTRY(BgL_method2759z00_3583)(BgL_method2759z00_3583, 
(obj_t)(BgL_arg3835z00_2005), BEOA); 
BgL_res4041z00_3608 = 
(BgL_nodez00_bglt)(BgL_auxz00_4541); } } 
BgL_arg3832z00_2004 = BgL_res4041z00_3608; } } 
((((BgL_setzd2exzd2itz00_bglt)CREF(BgL_nodez00_2001))->BgL_bodyz00) = ((BgL_nodez00_bglt)BgL_arg3832z00_2004), BUNSPEC); } 
BgL_auxz00_4514 = BgL_nodez00_2001; 
return 
(obj_t)(BgL_auxz00_4514);} } } 
}



/* callcc!-let-var2789 */
obj_t BGl_callccz12zd2letzd2var2789z12zzcallcc_walkz00(obj_t BgL_envz00_3839, obj_t BgL_nodez00_3840)
{ AN_OBJECT;
{ /* Callcc/walk.scm 272 */
{ 
BgL_letzd2varzd2_bglt BgL_nodez00_1981;
{ /* Callcc/walk.scm 273 */
BgL_letzd2varzd2_bglt BgL_auxz00_4549;
BgL_nodez00_1981 = 
(BgL_letzd2varzd2_bglt)(BgL_nodez00_3840); 
{ /* Callcc/walk.scm 274 */
BgL_nodez00_bglt BgL_arg3792z00_1985;
{ /* Callcc/walk.scm 274 */
BgL_nodez00_bglt BgL_arg3795z00_1986;
BgL_arg3795z00_1986 = 
(((BgL_letzd2varzd2_bglt)CREF(BgL_nodez00_1981))->BgL_bodyz00); 
{ /* Callcc/walk.scm 274 */
BgL_nodez00_bglt BgL_res4035z00_3538;
{ /* Callcc/walk.scm 274 */
obj_t BgL_method2759z00_3513;
{ /* Callcc/walk.scm 274 */
long BgL_objzd2classzd2numz00_3515;
{ /* Callcc/walk.scm 274 */
BgL_objectz00_bglt BgL_auxz00_4551;
BgL_auxz00_4551 = 
(BgL_objectz00_bglt)(BgL_arg3795z00_1986); 
BgL_objzd2classzd2numz00_3515 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4551); } 
{ /* Callcc/walk.scm 274 */
obj_t BgL_arg1904z00_3516;
{ /* Callcc/walk.scm 274 */
int BgL_auxz00_4554;
BgL_auxz00_4554 = 
(int)(((long)1)); 
BgL_arg1904z00_3516 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_4554); } 
{ /* Callcc/walk.scm 274 */
long BgL_offsetz00_3520;
{ /* Callcc/walk.scm 274 */
long BgL_auxz00_4557;
{ /* Callcc/walk.scm 274 */
int BgL_auxz00_4558;
BgL_auxz00_4558 = 
(int)(BgL_objzd2classzd2numz00_3515); 
BgL_auxz00_4557 = 
(long)(BgL_auxz00_4558); } 
BgL_offsetz00_3520 = 
(BgL_auxz00_4557-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 274 */
long BgL_modz00_3521;
{ /* Callcc/walk.scm 274 */
long BgL_auxz00_4562;
{ /* Callcc/walk.scm 274 */
int BgL_auxz00_4563;
BgL_auxz00_4563 = 
(int)(((long)8)); 
BgL_auxz00_4562 = 
(long)(BgL_auxz00_4563); } 
BgL_modz00_3521 = 
(BgL_offsetz00_3520/BgL_auxz00_4562); } 
{ /* Callcc/walk.scm 274 */
long BgL_restz00_3523;
{ /* Callcc/walk.scm 274 */
long BgL_auxz00_4567;
{ /* Callcc/walk.scm 274 */
int BgL_auxz00_4568;
BgL_auxz00_4568 = 
(int)(((long)8)); 
BgL_auxz00_4567 = 
(long)(BgL_auxz00_4568); } 
BgL_restz00_3523 = 
(BgL_offsetz00_3520%BgL_auxz00_4567); } 
{ /* Callcc/walk.scm 274 */

{ /* Callcc/walk.scm 274 */
obj_t BgL_bucketz00_3525;
{ /* Callcc/walk.scm 274 */
int BgL_kz00_3535;
BgL_kz00_3535 = 
(int)(BgL_modz00_3521); 
BgL_bucketz00_3525 = 
VECTOR_REF(BgL_arg1904z00_3516,BgL_kz00_3535); } 
{ /* Callcc/walk.scm 274 */
int BgL_kz00_3537;
BgL_kz00_3537 = 
(int)(BgL_restz00_3523); 
BgL_method2759z00_3513 = 
VECTOR_REF(BgL_bucketz00_3525,BgL_kz00_3537); } } } } } } } } 
{ /* Callcc/walk.scm 274 */
obj_t BgL_auxz00_4576;
BgL_auxz00_4576 = 
PROCEDURE_ENTRY(BgL_method2759z00_3513)(BgL_method2759z00_3513, 
(obj_t)(BgL_arg3795z00_1986), BEOA); 
BgL_res4035z00_3538 = 
(BgL_nodez00_bglt)(BgL_auxz00_4576); } } 
BgL_arg3792z00_1985 = BgL_res4035z00_3538; } } 
((((BgL_letzd2varzd2_bglt)CREF(BgL_nodez00_1981))->BgL_bodyz00) = ((BgL_nodez00_bglt)BgL_arg3792z00_1985), BUNSPEC); } 
{ 
obj_t BgL_l2751z00_1987;
BgL_l2751z00_1987 = 
(((BgL_letzd2varzd2_bglt)CREF(BgL_nodez00_1981))->BgL_bindingsz00); 
BgL_lname2752z00_1988:
if(
PAIRP(BgL_l2751z00_1987))
{ /* Callcc/walk.scm 275 */
{ /* Callcc/walk.scm 276 */
obj_t BgL_bindingz00_1991;
BgL_bindingz00_1991 = 
CAR(BgL_l2751z00_1987); 
{ /* Callcc/walk.scm 276 */
obj_t BgL_varz00_1992;
BgL_varz00_1992 = 
CAR(BgL_bindingz00_1991); 
{ /* Callcc/walk.scm 278 */
BgL_nodez00_bglt BgL_arg3804z00_1994;
{ /* Callcc/walk.scm 278 */
BgL_nodez00_bglt BgL_res4038z00_3572;
{ /* Callcc/walk.scm 278 */
BgL_nodez00_bglt BgL_nodez00_3546;
{ /* Callcc/walk.scm 278 */
obj_t BgL_auxz00_4586;
BgL_auxz00_4586 = 
CDR(BgL_bindingz00_1991); 
BgL_nodez00_3546 = 
(BgL_nodez00_bglt)(BgL_auxz00_4586); } 
{ /* Callcc/walk.scm 278 */
obj_t BgL_method2759z00_3547;
{ /* Callcc/walk.scm 278 */
long BgL_objzd2classzd2numz00_3549;
{ /* Callcc/walk.scm 278 */
BgL_objectz00_bglt BgL_auxz00_4589;
BgL_auxz00_4589 = 
(BgL_objectz00_bglt)(BgL_nodez00_3546); 
BgL_objzd2classzd2numz00_3549 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4589); } 
{ /* Callcc/walk.scm 278 */
obj_t BgL_arg1904z00_3550;
{ /* Callcc/walk.scm 278 */
int BgL_auxz00_4592;
BgL_auxz00_4592 = 
(int)(((long)1)); 
BgL_arg1904z00_3550 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_4592); } 
{ /* Callcc/walk.scm 278 */
long BgL_offsetz00_3554;
{ /* Callcc/walk.scm 278 */
long BgL_auxz00_4595;
{ /* Callcc/walk.scm 278 */
int BgL_auxz00_4596;
BgL_auxz00_4596 = 
(int)(BgL_objzd2classzd2numz00_3549); 
BgL_auxz00_4595 = 
(long)(BgL_auxz00_4596); } 
BgL_offsetz00_3554 = 
(BgL_auxz00_4595-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 278 */
long BgL_modz00_3555;
{ /* Callcc/walk.scm 278 */
long BgL_auxz00_4600;
{ /* Callcc/walk.scm 278 */
int BgL_auxz00_4601;
BgL_auxz00_4601 = 
(int)(((long)8)); 
BgL_auxz00_4600 = 
(long)(BgL_auxz00_4601); } 
BgL_modz00_3555 = 
(BgL_offsetz00_3554/BgL_auxz00_4600); } 
{ /* Callcc/walk.scm 278 */
long BgL_restz00_3557;
{ /* Callcc/walk.scm 278 */
long BgL_auxz00_4605;
{ /* Callcc/walk.scm 278 */
int BgL_auxz00_4606;
BgL_auxz00_4606 = 
(int)(((long)8)); 
BgL_auxz00_4605 = 
(long)(BgL_auxz00_4606); } 
BgL_restz00_3557 = 
(BgL_offsetz00_3554%BgL_auxz00_4605); } 
{ /* Callcc/walk.scm 278 */

{ /* Callcc/walk.scm 278 */
obj_t BgL_bucketz00_3559;
{ /* Callcc/walk.scm 278 */
int BgL_kz00_3569;
BgL_kz00_3569 = 
(int)(BgL_modz00_3555); 
BgL_bucketz00_3559 = 
VECTOR_REF(BgL_arg1904z00_3550,BgL_kz00_3569); } 
{ /* Callcc/walk.scm 278 */
int BgL_kz00_3571;
BgL_kz00_3571 = 
(int)(BgL_restz00_3557); 
BgL_method2759z00_3547 = 
VECTOR_REF(BgL_bucketz00_3559,BgL_kz00_3571); } } } } } } } } 
{ /* Callcc/walk.scm 278 */
obj_t BgL_auxz00_4614;
BgL_auxz00_4614 = 
PROCEDURE_ENTRY(BgL_method2759z00_3547)(BgL_method2759z00_3547, 
(obj_t)(BgL_nodez00_3546), BEOA); 
BgL_res4038z00_3572 = 
(BgL_nodez00_bglt)(BgL_auxz00_4614); } } } 
BgL_arg3804z00_1994 = BgL_res4038z00_3572; } 
{ /* Callcc/walk.scm 278 */
obj_t BgL_auxz00_4619;
BgL_auxz00_4619 = 
(obj_t)(BgL_arg3804z00_1994); 
SET_CDR(BgL_bindingz00_1991, BgL_auxz00_4619); } } 
if(
BGl_celledzf3zf3zzcallcc_walkz00(
(BgL_variablez00_bglt)(BgL_varz00_1992)))
{ /* Callcc/walk.scm 279 */
{ /* Callcc/walk.scm 281 */
BgL_localz00_bglt BgL_obj1255z00_3575;BgL_typez00_bglt BgL_val1254z00_3576;
BgL_obj1255z00_3575 = 
(BgL_localz00_bglt)(BgL_varz00_1992); 
BgL_val1254z00_3576 = 
(BgL_typez00_bglt)(BGl_za2objza2z00zztype_cachez00); 
((((BgL_localz00_bglt)CREF(BgL_obj1255z00_3575))->BgL_typez00) = ((BgL_typez00_bglt)BgL_val1254z00_3576), BUNSPEC); } 
{ /* Callcc/walk.scm 283 */
BgL_makezd2boxzd2_bglt BgL_arg3810z00_1996;
{ /* Callcc/walk.scm 283 */
BgL_nodez00_bglt BgL_auxz00_4628;
{ /* Callcc/walk.scm 283 */
obj_t BgL_auxz00_4629;
BgL_auxz00_4629 = 
CDR(BgL_bindingz00_1991); 
BgL_auxz00_4628 = 
(BgL_nodez00_bglt)(BgL_auxz00_4629); } 
BgL_arg3810z00_1996 = 
BGl_azd2makezd2cellz00zzcallcc_walkz00(BgL_auxz00_4628, 
(BgL_variablez00_bglt)(BgL_varz00_1992)); } 
{ /* Callcc/walk.scm 282 */
obj_t BgL_auxz00_4634;
BgL_auxz00_4634 = 
(obj_t)(BgL_arg3810z00_1996); 
SET_CDR(BgL_bindingz00_1991, BgL_auxz00_4634); } } }  else 
{ /* Callcc/walk.scm 279 */BFALSE; } } } 
{ 
obj_t BgL_l2751z00_4637;
BgL_l2751z00_4637 = 
CDR(BgL_l2751z00_1987); 
BgL_l2751z00_1987 = BgL_l2751z00_4637; 
goto BgL_lname2752z00_1988;} }  else 
{ /* Callcc/walk.scm 275 */((bool_t)1); } } 
BgL_auxz00_4549 = BgL_nodez00_1981; 
return 
(obj_t)(BgL_auxz00_4549);} } } 
}



/* callcc!-let-fun2787 */
obj_t BGl_callccz12zd2letzd2fun2787z12zzcallcc_walkz00(obj_t BgL_envz00_3841, obj_t BgL_nodez00_3842)
{ AN_OBJECT;
{ /* Callcc/walk.scm 263 */
{ 
BgL_letzd2funzd2_bglt BgL_nodez00_1967;
{ /* Callcc/walk.scm 264 */
BgL_letzd2funzd2_bglt BgL_auxz00_4642;
BgL_nodez00_1967 = 
(BgL_letzd2funzd2_bglt)(BgL_nodez00_3842); 
{ 
obj_t BgL_l2747z00_1971;
BgL_l2747z00_1971 = 
(((BgL_letzd2funzd2_bglt)CREF(BgL_nodez00_1967))->BgL_localsz00); 
BgL_lname2748z00_1972:
if(
PAIRP(BgL_l2747z00_1971))
{ /* Callcc/walk.scm 265 */
BGl_callcczd2funz12zc0zzcallcc_walkz00(
CAR(BgL_l2747z00_1971)); 
{ 
obj_t BgL_l2747z00_4647;
BgL_l2747z00_4647 = 
CDR(BgL_l2747z00_1971); 
BgL_l2747z00_1971 = BgL_l2747z00_4647; 
goto BgL_lname2748z00_1972;} }  else 
{ /* Callcc/walk.scm 265 */((bool_t)1); } } 
{ /* Callcc/walk.scm 266 */
BgL_nodez00_bglt BgL_arg3779z00_1977;
{ /* Callcc/walk.scm 266 */
BgL_nodez00_bglt BgL_arg3782z00_1978;
BgL_arg3782z00_1978 = 
(((BgL_letzd2funzd2_bglt)CREF(BgL_nodez00_1967))->BgL_bodyz00); 
{ /* Callcc/walk.scm 266 */
BgL_nodez00_bglt BgL_res4032z00_3508;
{ /* Callcc/walk.scm 266 */
obj_t BgL_method2759z00_3483;
{ /* Callcc/walk.scm 266 */
long BgL_objzd2classzd2numz00_3485;
{ /* Callcc/walk.scm 266 */
BgL_objectz00_bglt BgL_auxz00_4651;
BgL_auxz00_4651 = 
(BgL_objectz00_bglt)(BgL_arg3782z00_1978); 
BgL_objzd2classzd2numz00_3485 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4651); } 
{ /* Callcc/walk.scm 266 */
obj_t BgL_arg1904z00_3486;
{ /* Callcc/walk.scm 266 */
int BgL_auxz00_4654;
BgL_auxz00_4654 = 
(int)(((long)1)); 
BgL_arg1904z00_3486 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_4654); } 
{ /* Callcc/walk.scm 266 */
long BgL_offsetz00_3490;
{ /* Callcc/walk.scm 266 */
long BgL_auxz00_4657;
{ /* Callcc/walk.scm 266 */
int BgL_auxz00_4658;
BgL_auxz00_4658 = 
(int)(BgL_objzd2classzd2numz00_3485); 
BgL_auxz00_4657 = 
(long)(BgL_auxz00_4658); } 
BgL_offsetz00_3490 = 
(BgL_auxz00_4657-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 266 */
long BgL_modz00_3491;
{ /* Callcc/walk.scm 266 */
long BgL_auxz00_4662;
{ /* Callcc/walk.scm 266 */
int BgL_auxz00_4663;
BgL_auxz00_4663 = 
(int)(((long)8)); 
BgL_auxz00_4662 = 
(long)(BgL_auxz00_4663); } 
BgL_modz00_3491 = 
(BgL_offsetz00_3490/BgL_auxz00_4662); } 
{ /* Callcc/walk.scm 266 */
long BgL_restz00_3493;
{ /* Callcc/walk.scm 266 */
long BgL_auxz00_4667;
{ /* Callcc/walk.scm 266 */
int BgL_auxz00_4668;
BgL_auxz00_4668 = 
(int)(((long)8)); 
BgL_auxz00_4667 = 
(long)(BgL_auxz00_4668); } 
BgL_restz00_3493 = 
(BgL_offsetz00_3490%BgL_auxz00_4667); } 
{ /* Callcc/walk.scm 266 */

{ /* Callcc/walk.scm 266 */
obj_t BgL_bucketz00_3495;
{ /* Callcc/walk.scm 266 */
int BgL_kz00_3505;
BgL_kz00_3505 = 
(int)(BgL_modz00_3491); 
BgL_bucketz00_3495 = 
VECTOR_REF(BgL_arg1904z00_3486,BgL_kz00_3505); } 
{ /* Callcc/walk.scm 266 */
int BgL_kz00_3507;
BgL_kz00_3507 = 
(int)(BgL_restz00_3493); 
BgL_method2759z00_3483 = 
VECTOR_REF(BgL_bucketz00_3495,BgL_kz00_3507); } } } } } } } } 
{ /* Callcc/walk.scm 266 */
obj_t BgL_auxz00_4676;
BgL_auxz00_4676 = 
PROCEDURE_ENTRY(BgL_method2759z00_3483)(BgL_method2759z00_3483, 
(obj_t)(BgL_arg3782z00_1978), BEOA); 
BgL_res4032z00_3508 = 
(BgL_nodez00_bglt)(BgL_auxz00_4676); } } 
BgL_arg3779z00_1977 = BgL_res4032z00_3508; } } 
((((BgL_letzd2funzd2_bglt)CREF(BgL_nodez00_1967))->BgL_bodyz00) = ((BgL_nodez00_bglt)BgL_arg3779z00_1977), BUNSPEC); } 
BgL_auxz00_4642 = BgL_nodez00_1967; 
return 
(obj_t)(BgL_auxz00_4642);} } } 
}



/* callcc!-select2785 */
obj_t BGl_callccz12zd2select2785zc0zzcallcc_walkz00(obj_t BgL_envz00_3843, obj_t BgL_nodez00_3844)
{ AN_OBJECT;
{ /* Callcc/walk.scm 252 */
{ 
BgL_selectz00_bglt BgL_nodez00_1951;
{ /* Callcc/walk.scm 253 */
BgL_selectz00_bglt BgL_auxz00_4684;
BgL_nodez00_1951 = 
(BgL_selectz00_bglt)(BgL_nodez00_3844); 
{ /* Callcc/walk.scm 254 */
BgL_nodez00_bglt BgL_arg3734z00_1955;
{ /* Callcc/walk.scm 254 */
BgL_nodez00_bglt BgL_arg3737z00_1956;
BgL_arg3737z00_1956 = 
(((BgL_selectz00_bglt)CREF(BgL_nodez00_1951))->BgL_testz00); 
{ /* Callcc/walk.scm 254 */
BgL_nodez00_bglt BgL_res4026z00_3440;
{ /* Callcc/walk.scm 254 */
obj_t BgL_method2759z00_3415;
{ /* Callcc/walk.scm 254 */
long BgL_objzd2classzd2numz00_3417;
{ /* Callcc/walk.scm 254 */
BgL_objectz00_bglt BgL_auxz00_4686;
BgL_auxz00_4686 = 
(BgL_objectz00_bglt)(BgL_arg3737z00_1956); 
BgL_objzd2classzd2numz00_3417 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4686); } 
{ /* Callcc/walk.scm 254 */
obj_t BgL_arg1904z00_3418;
{ /* Callcc/walk.scm 254 */
int BgL_auxz00_4689;
BgL_auxz00_4689 = 
(int)(((long)1)); 
BgL_arg1904z00_3418 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_4689); } 
{ /* Callcc/walk.scm 254 */
long BgL_offsetz00_3422;
{ /* Callcc/walk.scm 254 */
long BgL_auxz00_4692;
{ /* Callcc/walk.scm 254 */
int BgL_auxz00_4693;
BgL_auxz00_4693 = 
(int)(BgL_objzd2classzd2numz00_3417); 
BgL_auxz00_4692 = 
(long)(BgL_auxz00_4693); } 
BgL_offsetz00_3422 = 
(BgL_auxz00_4692-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 254 */
long BgL_modz00_3423;
{ /* Callcc/walk.scm 254 */
long BgL_auxz00_4697;
{ /* Callcc/walk.scm 254 */
int BgL_auxz00_4698;
BgL_auxz00_4698 = 
(int)(((long)8)); 
BgL_auxz00_4697 = 
(long)(BgL_auxz00_4698); } 
BgL_modz00_3423 = 
(BgL_offsetz00_3422/BgL_auxz00_4697); } 
{ /* Callcc/walk.scm 254 */
long BgL_restz00_3425;
{ /* Callcc/walk.scm 254 */
long BgL_auxz00_4702;
{ /* Callcc/walk.scm 254 */
int BgL_auxz00_4703;
BgL_auxz00_4703 = 
(int)(((long)8)); 
BgL_auxz00_4702 = 
(long)(BgL_auxz00_4703); } 
BgL_restz00_3425 = 
(BgL_offsetz00_3422%BgL_auxz00_4702); } 
{ /* Callcc/walk.scm 254 */

{ /* Callcc/walk.scm 254 */
obj_t BgL_bucketz00_3427;
{ /* Callcc/walk.scm 254 */
int BgL_kz00_3437;
BgL_kz00_3437 = 
(int)(BgL_modz00_3423); 
BgL_bucketz00_3427 = 
VECTOR_REF(BgL_arg1904z00_3418,BgL_kz00_3437); } 
{ /* Callcc/walk.scm 254 */
int BgL_kz00_3439;
BgL_kz00_3439 = 
(int)(BgL_restz00_3425); 
BgL_method2759z00_3415 = 
VECTOR_REF(BgL_bucketz00_3427,BgL_kz00_3439); } } } } } } } } 
{ /* Callcc/walk.scm 254 */
obj_t BgL_auxz00_4711;
BgL_auxz00_4711 = 
PROCEDURE_ENTRY(BgL_method2759z00_3415)(BgL_method2759z00_3415, 
(obj_t)(BgL_arg3737z00_1956), BEOA); 
BgL_res4026z00_3440 = 
(BgL_nodez00_bglt)(BgL_auxz00_4711); } } 
BgL_arg3734z00_1955 = BgL_res4026z00_3440; } } 
((((BgL_selectz00_bglt)CREF(BgL_nodez00_1951))->BgL_testz00) = ((BgL_nodez00_bglt)BgL_arg3734z00_1955), BUNSPEC); } 
{ 
obj_t BgL_l2743z00_1957;
BgL_l2743z00_1957 = 
(((BgL_selectz00_bglt)CREF(BgL_nodez00_1951))->BgL_clausesz00); 
BgL_lname2744z00_1958:
if(
PAIRP(BgL_l2743z00_1957))
{ /* Callcc/walk.scm 255 */
{ /* Callcc/walk.scm 256 */
obj_t BgL_clausez00_1961;
BgL_clausez00_1961 = 
CAR(BgL_l2743z00_1957); 
{ /* Callcc/walk.scm 256 */
BgL_nodez00_bglt BgL_arg3746z00_1962;
{ /* Callcc/walk.scm 256 */
BgL_nodez00_bglt BgL_res4029z00_3473;
{ /* Callcc/walk.scm 256 */
BgL_nodez00_bglt BgL_nodez00_3447;
{ /* Callcc/walk.scm 256 */
obj_t BgL_auxz00_4720;
BgL_auxz00_4720 = 
CDR(BgL_clausez00_1961); 
BgL_nodez00_3447 = 
(BgL_nodez00_bglt)(BgL_auxz00_4720); } 
{ /* Callcc/walk.scm 256 */
obj_t BgL_method2759z00_3448;
{ /* Callcc/walk.scm 256 */
long BgL_objzd2classzd2numz00_3450;
{ /* Callcc/walk.scm 256 */
BgL_objectz00_bglt BgL_auxz00_4723;
BgL_auxz00_4723 = 
(BgL_objectz00_bglt)(BgL_nodez00_3447); 
BgL_objzd2classzd2numz00_3450 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4723); } 
{ /* Callcc/walk.scm 256 */
obj_t BgL_arg1904z00_3451;
{ /* Callcc/walk.scm 256 */
int BgL_auxz00_4726;
BgL_auxz00_4726 = 
(int)(((long)1)); 
BgL_arg1904z00_3451 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_4726); } 
{ /* Callcc/walk.scm 256 */
long BgL_offsetz00_3455;
{ /* Callcc/walk.scm 256 */
long BgL_auxz00_4729;
{ /* Callcc/walk.scm 256 */
int BgL_auxz00_4730;
BgL_auxz00_4730 = 
(int)(BgL_objzd2classzd2numz00_3450); 
BgL_auxz00_4729 = 
(long)(BgL_auxz00_4730); } 
BgL_offsetz00_3455 = 
(BgL_auxz00_4729-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 256 */
long BgL_modz00_3456;
{ /* Callcc/walk.scm 256 */
long BgL_auxz00_4734;
{ /* Callcc/walk.scm 256 */
int BgL_auxz00_4735;
BgL_auxz00_4735 = 
(int)(((long)8)); 
BgL_auxz00_4734 = 
(long)(BgL_auxz00_4735); } 
BgL_modz00_3456 = 
(BgL_offsetz00_3455/BgL_auxz00_4734); } 
{ /* Callcc/walk.scm 256 */
long BgL_restz00_3458;
{ /* Callcc/walk.scm 256 */
long BgL_auxz00_4739;
{ /* Callcc/walk.scm 256 */
int BgL_auxz00_4740;
BgL_auxz00_4740 = 
(int)(((long)8)); 
BgL_auxz00_4739 = 
(long)(BgL_auxz00_4740); } 
BgL_restz00_3458 = 
(BgL_offsetz00_3455%BgL_auxz00_4739); } 
{ /* Callcc/walk.scm 256 */

{ /* Callcc/walk.scm 256 */
obj_t BgL_bucketz00_3460;
{ /* Callcc/walk.scm 256 */
int BgL_kz00_3470;
BgL_kz00_3470 = 
(int)(BgL_modz00_3456); 
BgL_bucketz00_3460 = 
VECTOR_REF(BgL_arg1904z00_3451,BgL_kz00_3470); } 
{ /* Callcc/walk.scm 256 */
int BgL_kz00_3472;
BgL_kz00_3472 = 
(int)(BgL_restz00_3458); 
BgL_method2759z00_3448 = 
VECTOR_REF(BgL_bucketz00_3460,BgL_kz00_3472); } } } } } } } } 
{ /* Callcc/walk.scm 256 */
obj_t BgL_auxz00_4748;
BgL_auxz00_4748 = 
PROCEDURE_ENTRY(BgL_method2759z00_3448)(BgL_method2759z00_3448, 
(obj_t)(BgL_nodez00_3447), BEOA); 
BgL_res4029z00_3473 = 
(BgL_nodez00_bglt)(BgL_auxz00_4748); } } } 
BgL_arg3746z00_1962 = BgL_res4029z00_3473; } 
{ /* Callcc/walk.scm 256 */
obj_t BgL_auxz00_4753;
BgL_auxz00_4753 = 
(obj_t)(BgL_arg3746z00_1962); 
SET_CDR(BgL_clausez00_1961, BgL_auxz00_4753); } } } 
{ 
obj_t BgL_l2743z00_4756;
BgL_l2743z00_4756 = 
CDR(BgL_l2743z00_1957); 
BgL_l2743z00_1957 = BgL_l2743z00_4756; 
goto BgL_lname2744z00_1958;} }  else 
{ /* Callcc/walk.scm 255 */((bool_t)1); } } 
BgL_auxz00_4684 = BgL_nodez00_1951; 
return 
(obj_t)(BgL_auxz00_4684);} } } 
}



/* callcc!-fail2783 */
obj_t BGl_callccz12zd2fail2783zc0zzcallcc_walkz00(obj_t BgL_envz00_3845, obj_t BgL_nodez00_3846)
{ AN_OBJECT;
{ /* Callcc/walk.scm 242 */
{ 
BgL_failz00_bglt BgL_nodez00_1939;
{ /* Callcc/walk.scm 243 */
BgL_failz00_bglt BgL_auxz00_4761;
BgL_nodez00_1939 = 
(BgL_failz00_bglt)(BgL_nodez00_3846); 
{ /* Callcc/walk.scm 244 */
BgL_nodez00_bglt BgL_arg3707z00_1943;
{ /* Callcc/walk.scm 244 */
BgL_nodez00_bglt BgL_arg3710z00_1944;
BgL_arg3710z00_1944 = 
(((BgL_failz00_bglt)CREF(BgL_nodez00_1939))->BgL_procz00); 
{ /* Callcc/walk.scm 244 */
BgL_nodez00_bglt BgL_res4017z00_3350;
{ /* Callcc/walk.scm 244 */
obj_t BgL_method2759z00_3325;
{ /* Callcc/walk.scm 244 */
long BgL_objzd2classzd2numz00_3327;
{ /* Callcc/walk.scm 244 */
BgL_objectz00_bglt BgL_auxz00_4763;
BgL_auxz00_4763 = 
(BgL_objectz00_bglt)(BgL_arg3710z00_1944); 
BgL_objzd2classzd2numz00_3327 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4763); } 
{ /* Callcc/walk.scm 244 */
obj_t BgL_arg1904z00_3328;
{ /* Callcc/walk.scm 244 */
int BgL_auxz00_4766;
BgL_auxz00_4766 = 
(int)(((long)1)); 
BgL_arg1904z00_3328 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_4766); } 
{ /* Callcc/walk.scm 244 */
long BgL_offsetz00_3332;
{ /* Callcc/walk.scm 244 */
long BgL_auxz00_4769;
{ /* Callcc/walk.scm 244 */
int BgL_auxz00_4770;
BgL_auxz00_4770 = 
(int)(BgL_objzd2classzd2numz00_3327); 
BgL_auxz00_4769 = 
(long)(BgL_auxz00_4770); } 
BgL_offsetz00_3332 = 
(BgL_auxz00_4769-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 244 */
long BgL_modz00_3333;
{ /* Callcc/walk.scm 244 */
long BgL_auxz00_4774;
{ /* Callcc/walk.scm 244 */
int BgL_auxz00_4775;
BgL_auxz00_4775 = 
(int)(((long)8)); 
BgL_auxz00_4774 = 
(long)(BgL_auxz00_4775); } 
BgL_modz00_3333 = 
(BgL_offsetz00_3332/BgL_auxz00_4774); } 
{ /* Callcc/walk.scm 244 */
long BgL_restz00_3335;
{ /* Callcc/walk.scm 244 */
long BgL_auxz00_4779;
{ /* Callcc/walk.scm 244 */
int BgL_auxz00_4780;
BgL_auxz00_4780 = 
(int)(((long)8)); 
BgL_auxz00_4779 = 
(long)(BgL_auxz00_4780); } 
BgL_restz00_3335 = 
(BgL_offsetz00_3332%BgL_auxz00_4779); } 
{ /* Callcc/walk.scm 244 */

{ /* Callcc/walk.scm 244 */
obj_t BgL_bucketz00_3337;
{ /* Callcc/walk.scm 244 */
int BgL_kz00_3347;
BgL_kz00_3347 = 
(int)(BgL_modz00_3333); 
BgL_bucketz00_3337 = 
VECTOR_REF(BgL_arg1904z00_3328,BgL_kz00_3347); } 
{ /* Callcc/walk.scm 244 */
int BgL_kz00_3349;
BgL_kz00_3349 = 
(int)(BgL_restz00_3335); 
BgL_method2759z00_3325 = 
VECTOR_REF(BgL_bucketz00_3337,BgL_kz00_3349); } } } } } } } } 
{ /* Callcc/walk.scm 244 */
obj_t BgL_auxz00_4788;
BgL_auxz00_4788 = 
PROCEDURE_ENTRY(BgL_method2759z00_3325)(BgL_method2759z00_3325, 
(obj_t)(BgL_arg3710z00_1944), BEOA); 
BgL_res4017z00_3350 = 
(BgL_nodez00_bglt)(BgL_auxz00_4788); } } 
BgL_arg3707z00_1943 = BgL_res4017z00_3350; } } 
((((BgL_failz00_bglt)CREF(BgL_nodez00_1939))->BgL_procz00) = ((BgL_nodez00_bglt)BgL_arg3707z00_1943), BUNSPEC); } 
{ /* Callcc/walk.scm 245 */
BgL_nodez00_bglt BgL_arg3714z00_1945;
{ /* Callcc/walk.scm 245 */
BgL_nodez00_bglt BgL_arg3717z00_1946;
BgL_arg3717z00_1946 = 
(((BgL_failz00_bglt)CREF(BgL_nodez00_1939))->BgL_msgz00); 
{ /* Callcc/walk.scm 245 */
BgL_nodez00_bglt BgL_res4020z00_3380;
{ /* Callcc/walk.scm 245 */
obj_t BgL_method2759z00_3355;
{ /* Callcc/walk.scm 245 */
long BgL_objzd2classzd2numz00_3357;
{ /* Callcc/walk.scm 245 */
BgL_objectz00_bglt BgL_auxz00_4795;
BgL_auxz00_4795 = 
(BgL_objectz00_bglt)(BgL_arg3717z00_1946); 
BgL_objzd2classzd2numz00_3357 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4795); } 
{ /* Callcc/walk.scm 245 */
obj_t BgL_arg1904z00_3358;
{ /* Callcc/walk.scm 245 */
int BgL_auxz00_4798;
BgL_auxz00_4798 = 
(int)(((long)1)); 
BgL_arg1904z00_3358 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_4798); } 
{ /* Callcc/walk.scm 245 */
long BgL_offsetz00_3362;
{ /* Callcc/walk.scm 245 */
long BgL_auxz00_4801;
{ /* Callcc/walk.scm 245 */
int BgL_auxz00_4802;
BgL_auxz00_4802 = 
(int)(BgL_objzd2classzd2numz00_3357); 
BgL_auxz00_4801 = 
(long)(BgL_auxz00_4802); } 
BgL_offsetz00_3362 = 
(BgL_auxz00_4801-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 245 */
long BgL_modz00_3363;
{ /* Callcc/walk.scm 245 */
long BgL_auxz00_4806;
{ /* Callcc/walk.scm 245 */
int BgL_auxz00_4807;
BgL_auxz00_4807 = 
(int)(((long)8)); 
BgL_auxz00_4806 = 
(long)(BgL_auxz00_4807); } 
BgL_modz00_3363 = 
(BgL_offsetz00_3362/BgL_auxz00_4806); } 
{ /* Callcc/walk.scm 245 */
long BgL_restz00_3365;
{ /* Callcc/walk.scm 245 */
long BgL_auxz00_4811;
{ /* Callcc/walk.scm 245 */
int BgL_auxz00_4812;
BgL_auxz00_4812 = 
(int)(((long)8)); 
BgL_auxz00_4811 = 
(long)(BgL_auxz00_4812); } 
BgL_restz00_3365 = 
(BgL_offsetz00_3362%BgL_auxz00_4811); } 
{ /* Callcc/walk.scm 245 */

{ /* Callcc/walk.scm 245 */
obj_t BgL_bucketz00_3367;
{ /* Callcc/walk.scm 245 */
int BgL_kz00_3377;
BgL_kz00_3377 = 
(int)(BgL_modz00_3363); 
BgL_bucketz00_3367 = 
VECTOR_REF(BgL_arg1904z00_3358,BgL_kz00_3377); } 
{ /* Callcc/walk.scm 245 */
int BgL_kz00_3379;
BgL_kz00_3379 = 
(int)(BgL_restz00_3365); 
BgL_method2759z00_3355 = 
VECTOR_REF(BgL_bucketz00_3367,BgL_kz00_3379); } } } } } } } } 
{ /* Callcc/walk.scm 245 */
obj_t BgL_auxz00_4820;
BgL_auxz00_4820 = 
PROCEDURE_ENTRY(BgL_method2759z00_3355)(BgL_method2759z00_3355, 
(obj_t)(BgL_arg3717z00_1946), BEOA); 
BgL_res4020z00_3380 = 
(BgL_nodez00_bglt)(BgL_auxz00_4820); } } 
BgL_arg3714z00_1945 = BgL_res4020z00_3380; } } 
((((BgL_failz00_bglt)CREF(BgL_nodez00_1939))->BgL_msgz00) = ((BgL_nodez00_bglt)BgL_arg3714z00_1945), BUNSPEC); } 
{ /* Callcc/walk.scm 246 */
BgL_nodez00_bglt BgL_arg3721z00_1947;
{ /* Callcc/walk.scm 246 */
BgL_nodez00_bglt BgL_arg3724z00_1948;
BgL_arg3724z00_1948 = 
(((BgL_failz00_bglt)CREF(BgL_nodez00_1939))->BgL_objz00); 
{ /* Callcc/walk.scm 246 */
BgL_nodez00_bglt BgL_res4023z00_3410;
{ /* Callcc/walk.scm 246 */
obj_t BgL_method2759z00_3385;
{ /* Callcc/walk.scm 246 */
long BgL_objzd2classzd2numz00_3387;
{ /* Callcc/walk.scm 246 */
BgL_objectz00_bglt BgL_auxz00_4827;
BgL_auxz00_4827 = 
(BgL_objectz00_bglt)(BgL_arg3724z00_1948); 
BgL_objzd2classzd2numz00_3387 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4827); } 
{ /* Callcc/walk.scm 246 */
obj_t BgL_arg1904z00_3388;
{ /* Callcc/walk.scm 246 */
int BgL_auxz00_4830;
BgL_auxz00_4830 = 
(int)(((long)1)); 
BgL_arg1904z00_3388 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_4830); } 
{ /* Callcc/walk.scm 246 */
long BgL_offsetz00_3392;
{ /* Callcc/walk.scm 246 */
long BgL_auxz00_4833;
{ /* Callcc/walk.scm 246 */
int BgL_auxz00_4834;
BgL_auxz00_4834 = 
(int)(BgL_objzd2classzd2numz00_3387); 
BgL_auxz00_4833 = 
(long)(BgL_auxz00_4834); } 
BgL_offsetz00_3392 = 
(BgL_auxz00_4833-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 246 */
long BgL_modz00_3393;
{ /* Callcc/walk.scm 246 */
long BgL_auxz00_4838;
{ /* Callcc/walk.scm 246 */
int BgL_auxz00_4839;
BgL_auxz00_4839 = 
(int)(((long)8)); 
BgL_auxz00_4838 = 
(long)(BgL_auxz00_4839); } 
BgL_modz00_3393 = 
(BgL_offsetz00_3392/BgL_auxz00_4838); } 
{ /* Callcc/walk.scm 246 */
long BgL_restz00_3395;
{ /* Callcc/walk.scm 246 */
long BgL_auxz00_4843;
{ /* Callcc/walk.scm 246 */
int BgL_auxz00_4844;
BgL_auxz00_4844 = 
(int)(((long)8)); 
BgL_auxz00_4843 = 
(long)(BgL_auxz00_4844); } 
BgL_restz00_3395 = 
(BgL_offsetz00_3392%BgL_auxz00_4843); } 
{ /* Callcc/walk.scm 246 */

{ /* Callcc/walk.scm 246 */
obj_t BgL_bucketz00_3397;
{ /* Callcc/walk.scm 246 */
int BgL_kz00_3407;
BgL_kz00_3407 = 
(int)(BgL_modz00_3393); 
BgL_bucketz00_3397 = 
VECTOR_REF(BgL_arg1904z00_3388,BgL_kz00_3407); } 
{ /* Callcc/walk.scm 246 */
int BgL_kz00_3409;
BgL_kz00_3409 = 
(int)(BgL_restz00_3395); 
BgL_method2759z00_3385 = 
VECTOR_REF(BgL_bucketz00_3397,BgL_kz00_3409); } } } } } } } } 
{ /* Callcc/walk.scm 246 */
obj_t BgL_auxz00_4852;
BgL_auxz00_4852 = 
PROCEDURE_ENTRY(BgL_method2759z00_3385)(BgL_method2759z00_3385, 
(obj_t)(BgL_arg3724z00_1948), BEOA); 
BgL_res4023z00_3410 = 
(BgL_nodez00_bglt)(BgL_auxz00_4852); } } 
BgL_arg3721z00_1947 = BgL_res4023z00_3410; } } 
((((BgL_failz00_bglt)CREF(BgL_nodez00_1939))->BgL_objz00) = ((BgL_nodez00_bglt)BgL_arg3721z00_1947), BUNSPEC); } 
BgL_auxz00_4761 = BgL_nodez00_1939; 
return 
(obj_t)(BgL_auxz00_4761);} } } 
}



/* callcc!-conditional2781 */
obj_t BGl_callccz12zd2conditional2781zc0zzcallcc_walkz00(obj_t BgL_envz00_3847, obj_t BgL_nodez00_3848)
{ AN_OBJECT;
{ /* Callcc/walk.scm 232 */
{ 
BgL_conditionalz00_bglt BgL_nodez00_1927;
{ /* Callcc/walk.scm 233 */
BgL_conditionalz00_bglt BgL_auxz00_4860;
BgL_nodez00_1927 = 
(BgL_conditionalz00_bglt)(BgL_nodez00_3848); 
{ /* Callcc/walk.scm 234 */
BgL_nodez00_bglt BgL_arg3680z00_1931;
{ /* Callcc/walk.scm 234 */
BgL_nodez00_bglt BgL_arg3683z00_1932;
BgL_arg3683z00_1932 = 
(((BgL_conditionalz00_bglt)CREF(BgL_nodez00_1927))->BgL_testz00); 
{ /* Callcc/walk.scm 234 */
BgL_nodez00_bglt BgL_res4008z00_3260;
{ /* Callcc/walk.scm 234 */
obj_t BgL_method2759z00_3235;
{ /* Callcc/walk.scm 234 */
long BgL_objzd2classzd2numz00_3237;
{ /* Callcc/walk.scm 234 */
BgL_objectz00_bglt BgL_auxz00_4862;
BgL_auxz00_4862 = 
(BgL_objectz00_bglt)(BgL_arg3683z00_1932); 
BgL_objzd2classzd2numz00_3237 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4862); } 
{ /* Callcc/walk.scm 234 */
obj_t BgL_arg1904z00_3238;
{ /* Callcc/walk.scm 234 */
int BgL_auxz00_4865;
BgL_auxz00_4865 = 
(int)(((long)1)); 
BgL_arg1904z00_3238 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_4865); } 
{ /* Callcc/walk.scm 234 */
long BgL_offsetz00_3242;
{ /* Callcc/walk.scm 234 */
long BgL_auxz00_4868;
{ /* Callcc/walk.scm 234 */
int BgL_auxz00_4869;
BgL_auxz00_4869 = 
(int)(BgL_objzd2classzd2numz00_3237); 
BgL_auxz00_4868 = 
(long)(BgL_auxz00_4869); } 
BgL_offsetz00_3242 = 
(BgL_auxz00_4868-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 234 */
long BgL_modz00_3243;
{ /* Callcc/walk.scm 234 */
long BgL_auxz00_4873;
{ /* Callcc/walk.scm 234 */
int BgL_auxz00_4874;
BgL_auxz00_4874 = 
(int)(((long)8)); 
BgL_auxz00_4873 = 
(long)(BgL_auxz00_4874); } 
BgL_modz00_3243 = 
(BgL_offsetz00_3242/BgL_auxz00_4873); } 
{ /* Callcc/walk.scm 234 */
long BgL_restz00_3245;
{ /* Callcc/walk.scm 234 */
long BgL_auxz00_4878;
{ /* Callcc/walk.scm 234 */
int BgL_auxz00_4879;
BgL_auxz00_4879 = 
(int)(((long)8)); 
BgL_auxz00_4878 = 
(long)(BgL_auxz00_4879); } 
BgL_restz00_3245 = 
(BgL_offsetz00_3242%BgL_auxz00_4878); } 
{ /* Callcc/walk.scm 234 */

{ /* Callcc/walk.scm 234 */
obj_t BgL_bucketz00_3247;
{ /* Callcc/walk.scm 234 */
int BgL_kz00_3257;
BgL_kz00_3257 = 
(int)(BgL_modz00_3243); 
BgL_bucketz00_3247 = 
VECTOR_REF(BgL_arg1904z00_3238,BgL_kz00_3257); } 
{ /* Callcc/walk.scm 234 */
int BgL_kz00_3259;
BgL_kz00_3259 = 
(int)(BgL_restz00_3245); 
BgL_method2759z00_3235 = 
VECTOR_REF(BgL_bucketz00_3247,BgL_kz00_3259); } } } } } } } } 
{ /* Callcc/walk.scm 234 */
obj_t BgL_auxz00_4887;
BgL_auxz00_4887 = 
PROCEDURE_ENTRY(BgL_method2759z00_3235)(BgL_method2759z00_3235, 
(obj_t)(BgL_arg3683z00_1932), BEOA); 
BgL_res4008z00_3260 = 
(BgL_nodez00_bglt)(BgL_auxz00_4887); } } 
BgL_arg3680z00_1931 = BgL_res4008z00_3260; } } 
((((BgL_conditionalz00_bglt)CREF(BgL_nodez00_1927))->BgL_testz00) = ((BgL_nodez00_bglt)BgL_arg3680z00_1931), BUNSPEC); } 
{ /* Callcc/walk.scm 235 */
BgL_nodez00_bglt BgL_arg3687z00_1933;
{ /* Callcc/walk.scm 235 */
BgL_nodez00_bglt BgL_arg3690z00_1934;
BgL_arg3690z00_1934 = 
(((BgL_conditionalz00_bglt)CREF(BgL_nodez00_1927))->BgL_truez00); 
{ /* Callcc/walk.scm 235 */
BgL_nodez00_bglt BgL_res4011z00_3290;
{ /* Callcc/walk.scm 235 */
obj_t BgL_method2759z00_3265;
{ /* Callcc/walk.scm 235 */
long BgL_objzd2classzd2numz00_3267;
{ /* Callcc/walk.scm 235 */
BgL_objectz00_bglt BgL_auxz00_4894;
BgL_auxz00_4894 = 
(BgL_objectz00_bglt)(BgL_arg3690z00_1934); 
BgL_objzd2classzd2numz00_3267 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4894); } 
{ /* Callcc/walk.scm 235 */
obj_t BgL_arg1904z00_3268;
{ /* Callcc/walk.scm 235 */
int BgL_auxz00_4897;
BgL_auxz00_4897 = 
(int)(((long)1)); 
BgL_arg1904z00_3268 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_4897); } 
{ /* Callcc/walk.scm 235 */
long BgL_offsetz00_3272;
{ /* Callcc/walk.scm 235 */
long BgL_auxz00_4900;
{ /* Callcc/walk.scm 235 */
int BgL_auxz00_4901;
BgL_auxz00_4901 = 
(int)(BgL_objzd2classzd2numz00_3267); 
BgL_auxz00_4900 = 
(long)(BgL_auxz00_4901); } 
BgL_offsetz00_3272 = 
(BgL_auxz00_4900-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 235 */
long BgL_modz00_3273;
{ /* Callcc/walk.scm 235 */
long BgL_auxz00_4905;
{ /* Callcc/walk.scm 235 */
int BgL_auxz00_4906;
BgL_auxz00_4906 = 
(int)(((long)8)); 
BgL_auxz00_4905 = 
(long)(BgL_auxz00_4906); } 
BgL_modz00_3273 = 
(BgL_offsetz00_3272/BgL_auxz00_4905); } 
{ /* Callcc/walk.scm 235 */
long BgL_restz00_3275;
{ /* Callcc/walk.scm 235 */
long BgL_auxz00_4910;
{ /* Callcc/walk.scm 235 */
int BgL_auxz00_4911;
BgL_auxz00_4911 = 
(int)(((long)8)); 
BgL_auxz00_4910 = 
(long)(BgL_auxz00_4911); } 
BgL_restz00_3275 = 
(BgL_offsetz00_3272%BgL_auxz00_4910); } 
{ /* Callcc/walk.scm 235 */

{ /* Callcc/walk.scm 235 */
obj_t BgL_bucketz00_3277;
{ /* Callcc/walk.scm 235 */
int BgL_kz00_3287;
BgL_kz00_3287 = 
(int)(BgL_modz00_3273); 
BgL_bucketz00_3277 = 
VECTOR_REF(BgL_arg1904z00_3268,BgL_kz00_3287); } 
{ /* Callcc/walk.scm 235 */
int BgL_kz00_3289;
BgL_kz00_3289 = 
(int)(BgL_restz00_3275); 
BgL_method2759z00_3265 = 
VECTOR_REF(BgL_bucketz00_3277,BgL_kz00_3289); } } } } } } } } 
{ /* Callcc/walk.scm 235 */
obj_t BgL_auxz00_4919;
BgL_auxz00_4919 = 
PROCEDURE_ENTRY(BgL_method2759z00_3265)(BgL_method2759z00_3265, 
(obj_t)(BgL_arg3690z00_1934), BEOA); 
BgL_res4011z00_3290 = 
(BgL_nodez00_bglt)(BgL_auxz00_4919); } } 
BgL_arg3687z00_1933 = BgL_res4011z00_3290; } } 
((((BgL_conditionalz00_bglt)CREF(BgL_nodez00_1927))->BgL_truez00) = ((BgL_nodez00_bglt)BgL_arg3687z00_1933), BUNSPEC); } 
{ /* Callcc/walk.scm 236 */
BgL_nodez00_bglt BgL_arg3694z00_1935;
{ /* Callcc/walk.scm 236 */
BgL_nodez00_bglt BgL_arg3697z00_1936;
BgL_arg3697z00_1936 = 
(((BgL_conditionalz00_bglt)CREF(BgL_nodez00_1927))->BgL_falsez00); 
{ /* Callcc/walk.scm 236 */
BgL_nodez00_bglt BgL_res4014z00_3320;
{ /* Callcc/walk.scm 236 */
obj_t BgL_method2759z00_3295;
{ /* Callcc/walk.scm 236 */
long BgL_objzd2classzd2numz00_3297;
{ /* Callcc/walk.scm 236 */
BgL_objectz00_bglt BgL_auxz00_4926;
BgL_auxz00_4926 = 
(BgL_objectz00_bglt)(BgL_arg3697z00_1936); 
BgL_objzd2classzd2numz00_3297 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4926); } 
{ /* Callcc/walk.scm 236 */
obj_t BgL_arg1904z00_3298;
{ /* Callcc/walk.scm 236 */
int BgL_auxz00_4929;
BgL_auxz00_4929 = 
(int)(((long)1)); 
BgL_arg1904z00_3298 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_4929); } 
{ /* Callcc/walk.scm 236 */
long BgL_offsetz00_3302;
{ /* Callcc/walk.scm 236 */
long BgL_auxz00_4932;
{ /* Callcc/walk.scm 236 */
int BgL_auxz00_4933;
BgL_auxz00_4933 = 
(int)(BgL_objzd2classzd2numz00_3297); 
BgL_auxz00_4932 = 
(long)(BgL_auxz00_4933); } 
BgL_offsetz00_3302 = 
(BgL_auxz00_4932-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 236 */
long BgL_modz00_3303;
{ /* Callcc/walk.scm 236 */
long BgL_auxz00_4937;
{ /* Callcc/walk.scm 236 */
int BgL_auxz00_4938;
BgL_auxz00_4938 = 
(int)(((long)8)); 
BgL_auxz00_4937 = 
(long)(BgL_auxz00_4938); } 
BgL_modz00_3303 = 
(BgL_offsetz00_3302/BgL_auxz00_4937); } 
{ /* Callcc/walk.scm 236 */
long BgL_restz00_3305;
{ /* Callcc/walk.scm 236 */
long BgL_auxz00_4942;
{ /* Callcc/walk.scm 236 */
int BgL_auxz00_4943;
BgL_auxz00_4943 = 
(int)(((long)8)); 
BgL_auxz00_4942 = 
(long)(BgL_auxz00_4943); } 
BgL_restz00_3305 = 
(BgL_offsetz00_3302%BgL_auxz00_4942); } 
{ /* Callcc/walk.scm 236 */

{ /* Callcc/walk.scm 236 */
obj_t BgL_bucketz00_3307;
{ /* Callcc/walk.scm 236 */
int BgL_kz00_3317;
BgL_kz00_3317 = 
(int)(BgL_modz00_3303); 
BgL_bucketz00_3307 = 
VECTOR_REF(BgL_arg1904z00_3298,BgL_kz00_3317); } 
{ /* Callcc/walk.scm 236 */
int BgL_kz00_3319;
BgL_kz00_3319 = 
(int)(BgL_restz00_3305); 
BgL_method2759z00_3295 = 
VECTOR_REF(BgL_bucketz00_3307,BgL_kz00_3319); } } } } } } } } 
{ /* Callcc/walk.scm 236 */
obj_t BgL_auxz00_4951;
BgL_auxz00_4951 = 
PROCEDURE_ENTRY(BgL_method2759z00_3295)(BgL_method2759z00_3295, 
(obj_t)(BgL_arg3697z00_1936), BEOA); 
BgL_res4014z00_3320 = 
(BgL_nodez00_bglt)(BgL_auxz00_4951); } } 
BgL_arg3694z00_1935 = BgL_res4014z00_3320; } } 
((((BgL_conditionalz00_bglt)CREF(BgL_nodez00_1927))->BgL_falsez00) = ((BgL_nodez00_bglt)BgL_arg3694z00_1935), BUNSPEC); } 
BgL_auxz00_4860 = BgL_nodez00_1927; 
return 
(obj_t)(BgL_auxz00_4860);} } } 
}



/* callcc!-setq2779 */
obj_t BGl_callccz12zd2setq2779zc0zzcallcc_walkz00(obj_t BgL_envz00_3849, obj_t BgL_nodez00_3850)
{ AN_OBJECT;
{ /* Callcc/walk.scm 199 */
{ 
BgL_setqz00_bglt BgL_nodez00_1892;
BgL_nodez00_1892 = 
(BgL_setqz00_bglt)(BgL_nodez00_3850); 
{ /* Callcc/walk.scm 200 */
BgL_nodez00_bglt BgL_arg3614z00_1895;
{ /* Callcc/walk.scm 200 */
BgL_nodez00_bglt BgL_arg3617z00_1896;
BgL_arg3617z00_1896 = 
(((BgL_setqz00_bglt)CREF(BgL_nodez00_1892))->BgL_valuez00); 
{ /* Callcc/walk.scm 200 */
BgL_nodez00_bglt BgL_res3995z00_3144;
{ /* Callcc/walk.scm 200 */
obj_t BgL_method2759z00_3119;
{ /* Callcc/walk.scm 200 */
long BgL_objzd2classzd2numz00_3121;
{ /* Callcc/walk.scm 200 */
BgL_objectz00_bglt BgL_auxz00_4960;
BgL_auxz00_4960 = 
(BgL_objectz00_bglt)(BgL_arg3617z00_1896); 
BgL_objzd2classzd2numz00_3121 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4960); } 
{ /* Callcc/walk.scm 200 */
obj_t BgL_arg1904z00_3122;
{ /* Callcc/walk.scm 200 */
int BgL_auxz00_4963;
BgL_auxz00_4963 = 
(int)(((long)1)); 
BgL_arg1904z00_3122 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_4963); } 
{ /* Callcc/walk.scm 200 */
long BgL_offsetz00_3126;
{ /* Callcc/walk.scm 200 */
long BgL_auxz00_4966;
{ /* Callcc/walk.scm 200 */
int BgL_auxz00_4967;
BgL_auxz00_4967 = 
(int)(BgL_objzd2classzd2numz00_3121); 
BgL_auxz00_4966 = 
(long)(BgL_auxz00_4967); } 
BgL_offsetz00_3126 = 
(BgL_auxz00_4966-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 200 */
long BgL_modz00_3127;
{ /* Callcc/walk.scm 200 */
long BgL_auxz00_4971;
{ /* Callcc/walk.scm 200 */
int BgL_auxz00_4972;
BgL_auxz00_4972 = 
(int)(((long)8)); 
BgL_auxz00_4971 = 
(long)(BgL_auxz00_4972); } 
BgL_modz00_3127 = 
(BgL_offsetz00_3126/BgL_auxz00_4971); } 
{ /* Callcc/walk.scm 200 */
long BgL_restz00_3129;
{ /* Callcc/walk.scm 200 */
long BgL_auxz00_4976;
{ /* Callcc/walk.scm 200 */
int BgL_auxz00_4977;
BgL_auxz00_4977 = 
(int)(((long)8)); 
BgL_auxz00_4976 = 
(long)(BgL_auxz00_4977); } 
BgL_restz00_3129 = 
(BgL_offsetz00_3126%BgL_auxz00_4976); } 
{ /* Callcc/walk.scm 200 */

{ /* Callcc/walk.scm 200 */
obj_t BgL_bucketz00_3131;
{ /* Callcc/walk.scm 200 */
int BgL_kz00_3141;
BgL_kz00_3141 = 
(int)(BgL_modz00_3127); 
BgL_bucketz00_3131 = 
VECTOR_REF(BgL_arg1904z00_3122,BgL_kz00_3141); } 
{ /* Callcc/walk.scm 200 */
int BgL_kz00_3143;
BgL_kz00_3143 = 
(int)(BgL_restz00_3129); 
BgL_method2759z00_3119 = 
VECTOR_REF(BgL_bucketz00_3131,BgL_kz00_3143); } } } } } } } } 
{ /* Callcc/walk.scm 200 */
obj_t BgL_auxz00_4985;
BgL_auxz00_4985 = 
PROCEDURE_ENTRY(BgL_method2759z00_3119)(BgL_method2759z00_3119, 
(obj_t)(BgL_arg3617z00_1896), BEOA); 
BgL_res3995z00_3144 = 
(BgL_nodez00_bglt)(BgL_auxz00_4985); } } 
BgL_arg3614z00_1895 = BgL_res3995z00_3144; } } 
((((BgL_setqz00_bglt)CREF(BgL_nodez00_1892))->BgL_valuez00) = ((BgL_nodez00_bglt)BgL_arg3614z00_1895), BUNSPEC); } 
{ /* Callcc/walk.scm 201 */
BgL_variablez00_bglt BgL_varz00_1897;
{ /* Callcc/walk.scm 201 */
BgL_varz00_bglt BgL_arg3670z00_1924;
BgL_arg3670z00_1924 = 
(((BgL_setqz00_bglt)CREF(BgL_nodez00_1892))->BgL_varz00); 
BgL_varz00_1897 = 
(((BgL_varz00_bglt)CREF(BgL_arg3670z00_1924))->BgL_variablez00); } 
{ 
obj_t BgL_varz00_1898;obj_t BgL_alphaz00_1899;
BgL_varz00_1898 = 
(obj_t)(BgL_varz00_1897); 
BgL_alphaz00_1899 = 
(((BgL_variablez00_bglt)CREF(BgL_varz00_1897))->BgL_fastzd2alphazd2); 
BgL_loopz00_1900:
{ /* Callcc/walk.scm 204 */
bool_t BgL_test3624z00_1902;
BgL_test3624z00_1902 = 
BGl_iszd2azf3z21zz__objectz00(BgL_alphaz00_1899, BGl_localz00zzast_varz00); 
if(BgL_test3624z00_1902)
{ /* Callcc/walk.scm 204 */
{ /* Callcc/walk.scm 206 */
BgL_varz00_bglt BgL_arg3626z00_1903;
BgL_arg3626z00_1903 = 
(((BgL_setqz00_bglt)CREF(BgL_nodez00_1892))->BgL_varz00); 
{ /* Callcc/walk.scm 206 */
BgL_variablez00_bglt BgL_val1621z00_3153;
BgL_val1621z00_3153 = 
(BgL_variablez00_bglt)(BgL_alphaz00_1899); 
((((BgL_varz00_bglt)CREF(BgL_arg3626z00_1903))->BgL_variablez00) = ((BgL_variablez00_bglt)BgL_val1621z00_3153), BUNSPEC); } } 
{ 
obj_t BgL_alphaz00_4999;obj_t BgL_varz00_4998;
BgL_varz00_4998 = BgL_alphaz00_1899; 
{ /* Callcc/walk.scm 207 */
BgL_variablez00_bglt BgL_obj1110z00_3154;
BgL_obj1110z00_3154 = 
(BgL_variablez00_bglt)(BgL_alphaz00_1899); 
BgL_alphaz00_4999 = 
(((BgL_variablez00_bglt)CREF(BgL_obj1110z00_3154))->BgL_fastzd2alphazd2); } 
BgL_alphaz00_1899 = BgL_alphaz00_4999; 
BgL_varz00_1898 = BgL_varz00_4998; 
goto BgL_loopz00_1900;} }  else 
{ /* Callcc/walk.scm 208 */
bool_t BgL_test3633z00_1905;
BgL_test3633z00_1905 = 
BGl_iszd2azf3z21zz__objectz00(BgL_varz00_1898, BGl_globalz00zzast_varz00); 
if(BgL_test3633z00_1905)
{ /* Callcc/walk.scm 208 */
return 
(obj_t)(BgL_nodez00_1892);}  else 
{ /* Callcc/walk.scm 208 */
if(
BGl_celledzf3zf3zzcallcc_walkz00(
(BgL_variablez00_bglt)(BgL_varz00_1898)))
{ /* Callcc/walk.scm 213 */
{ /* Callcc/walk.scm 214 */
BgL_localz00_bglt BgL_azd2varzd2_1907;obj_t BgL_locz00_1908;
BgL_azd2varzd2_1907 = 
BGl_makezd2localzd2svarz00zzast_localz00(
CNST_TABLE_REF(((long)5)), 
(BgL_typez00_bglt)(BGl_za2objza2z00zztype_cachez00)); 
{ /* Callcc/walk.scm 215 */
BgL_nodez00_bglt BgL_obj1550z00_3156;
BgL_obj1550z00_3156 = 
(BgL_nodez00_bglt)(BgL_nodez00_1892); 
BgL_locz00_1908 = 
(((BgL_nodez00_bglt)CREF(BgL_obj1550z00_3156))->BgL_locz00); } 
{ /* Callcc/walk.scm 218 */
obj_t BgL_arg3636z00_1909;obj_t BgL_arg3637z00_1910;obj_t BgL_arg3639z00_1912;BgL_boxzd2setz12zc0_bglt BgL_arg3640z00_1913;
BgL_arg3636z00_1909 = BgL_locz00_1908; 
BgL_arg3637z00_1910 = BGl_za2_za2z00zztype_cachez00; 
{ /* Callcc/walk.scm 219 */
obj_t BgL_arg3643z00_1914;
{ /* Callcc/walk.scm 219 */
obj_t BgL_auxz00_5015;obj_t BgL_auxz00_5013;
{ /* Callcc/walk.scm 219 */
BgL_nodez00_bglt BgL_auxz00_5016;
BgL_auxz00_5016 = 
(((BgL_setqz00_bglt)CREF(BgL_nodez00_1892))->BgL_valuez00); 
BgL_auxz00_5015 = 
(obj_t)(BgL_auxz00_5016); } 
BgL_auxz00_5013 = 
(obj_t)(BgL_azd2varzd2_1907); 
BgL_arg3643z00_1914 = 
MAKE_PAIR(BgL_auxz00_5013, BgL_auxz00_5015); } 
{ /* Callcc/walk.scm 219 */
obj_t BgL_list3645z00_1915;
BgL_list3645z00_1915 = 
MAKE_PAIR(BgL_arg3643z00_1914, BNIL); 
BgL_arg3639z00_1912 = BgL_list3645z00_1915; } } 
{ /* Callcc/walk.scm 222 */
obj_t BgL_arg3652z00_1917;obj_t BgL_arg3653z00_1918;BgL_varz00_bglt BgL_arg3654z00_1919;BgL_varz00_bglt BgL_arg3655z00_1920;
BgL_arg3652z00_1917 = BgL_locz00_1908; 
BgL_arg3653z00_1918 = BGl_za2_za2z00zztype_cachez00; 
BgL_arg3654z00_1919 = 
(((BgL_setqz00_bglt)CREF(BgL_nodez00_1892))->BgL_varz00); 
{ /* Callcc/walk.scm 226 */
obj_t BgL_arg3660z00_1921;obj_t BgL_arg3661z00_1922;
BgL_arg3660z00_1921 = BgL_locz00_1908; 
BgL_arg3661z00_1922 = BGl_za2_za2z00zztype_cachez00; 
{ /* Callcc/walk.scm 224 */
BgL_varz00_bglt BgL_res3999z00_3179;
{ /* Callcc/walk.scm 224 */
BgL_typez00_bglt BgL_type1632z00_3162;BgL_variablez00_bglt BgL_variable1633z00_3163;
BgL_type1632z00_3162 = 
(BgL_typez00_bglt)(BgL_arg3661z00_1922); 
{ /* Callcc/walk.scm 227 */
BgL_localz00_bglt BgL_auxz00_5023;
BgL_auxz00_5023 = BgL_azd2varzd2_1907; 
BgL_variable1633z00_3163 = 
(BgL_variablez00_bglt)(BgL_auxz00_5023); } 
{ /* Callcc/walk.scm 224 */
BgL_varz00_bglt BgL_new1634z00_3164;
{ /* Callcc/walk.scm 224 */
BgL_varz00_bglt BgL_res3997z00_3170;
{ /* Callcc/walk.scm 224 */
BgL_varz00_bglt BgL_new1636z00_3165;
BgL_new1636z00_3165 = 
((BgL_varz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_varz00_bgl) ))); 
{ /* Callcc/walk.scm 224 */
long BgL_arg3348z00_3166;
BgL_arg3348z00_3166 = 
BGl_classzd2numzd2zz__objectz00(BGl_varz00zzast_nodez00); 
{ /* Callcc/walk.scm 224 */
BgL_objectz00_bglt BgL_auxz00_5027;
BgL_auxz00_5027 = 
(BgL_objectz00_bglt)(BgL_new1636z00_3165); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_5027, BgL_arg3348z00_3166); } } 
{ /* Callcc/walk.scm 224 */
BgL_objectz00_bglt BgL_auxz00_5030;
BgL_auxz00_5030 = 
(BgL_objectz00_bglt)(BgL_new1636z00_3165); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_5030, BFALSE); } 
{ /* Callcc/walk.scm 224 */
obj_t BgL_auxz00_5033;
BgL_auxz00_5033 = 
(obj_t)(BgL_new1636z00_3165); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_5033); } BUNSPEC; 
BgL_res3997z00_3170 = BgL_new1636z00_3165; } 
BgL_new1634z00_3164 = BgL_res3997z00_3170; } 
{ /* Callcc/walk.scm 224 */
BgL_varz00_bglt BgL_res3998z00_3178;
((((BgL_varz00_bglt)CREF(BgL_new1634z00_3164))->BgL_locz00) = ((obj_t)BgL_arg3660z00_1921), BUNSPEC); 
((((BgL_varz00_bglt)CREF(BgL_new1634z00_3164))->BgL_typez00) = ((BgL_typez00_bglt)BgL_type1632z00_3162), BUNSPEC); 
((((BgL_varz00_bglt)CREF(BgL_new1634z00_3164))->BgL_variablez00) = ((BgL_variablez00_bglt)BgL_variable1633z00_3163), BUNSPEC); 
BgL_res3998z00_3178 = BgL_new1634z00_3164; BgL_res3998z00_3178; } 
BgL_res3999z00_3179 = BgL_new1634z00_3164; } } 
BgL_arg3655z00_1920 = BgL_res3999z00_3179; } } 
{ /* Callcc/walk.scm 220 */
BgL_boxzd2setz12zc0_bglt BgL_res4002z00_3201;
{ /* Callcc/walk.scm 220 */
BgL_typez00_bglt BgL_type2648z00_3181;BgL_nodez00_bglt BgL_value2650z00_3183;
BgL_type2648z00_3181 = 
(BgL_typez00_bglt)(BgL_arg3653z00_1918); 
BgL_value2650z00_3183 = 
(BgL_nodez00_bglt)(BgL_arg3655z00_1920); 
{ /* Callcc/walk.scm 220 */
BgL_boxzd2setz12zc0_bglt BgL_new2651z00_3184;
{ /* Callcc/walk.scm 220 */
BgL_boxzd2setz12zc0_bglt BgL_res4000z00_3190;
{ /* Callcc/walk.scm 220 */
BgL_boxzd2setz12zc0_bglt BgL_new2653z00_3185;
BgL_new2653z00_3185 = 
((BgL_boxzd2setz12zc0_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_boxzd2setz12zc0_bgl) ))); 
{ /* Callcc/walk.scm 220 */
long BgL_arg3096z00_3186;
BgL_arg3096z00_3186 = 
BGl_classzd2numzd2zz__objectz00(BGl_boxzd2setz12zc0zzast_nodez00); 
{ /* Callcc/walk.scm 220 */
BgL_objectz00_bglt BgL_auxz00_5043;
BgL_auxz00_5043 = 
(BgL_objectz00_bglt)(BgL_new2653z00_3185); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_5043, BgL_arg3096z00_3186); } } 
{ /* Callcc/walk.scm 220 */
BgL_objectz00_bglt BgL_auxz00_5046;
BgL_auxz00_5046 = 
(BgL_objectz00_bglt)(BgL_new2653z00_3185); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_5046, BFALSE); } 
{ /* Callcc/walk.scm 220 */
obj_t BgL_auxz00_5049;
BgL_auxz00_5049 = 
(obj_t)(BgL_new2653z00_3185); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_5049); } BUNSPEC; 
BgL_res4000z00_3190 = BgL_new2653z00_3185; } 
BgL_new2651z00_3184 = BgL_res4000z00_3190; } 
{ /* Callcc/walk.scm 220 */
BgL_boxzd2setz12zc0_bglt BgL_res4001z00_3200;
((((BgL_boxzd2setz12zc0_bglt)CREF(BgL_new2651z00_3184))->BgL_locz00) = ((obj_t)BgL_arg3652z00_1917), BUNSPEC); 
((((BgL_boxzd2setz12zc0_bglt)CREF(BgL_new2651z00_3184))->BgL_typez00) = ((BgL_typez00_bglt)BgL_type2648z00_3181), BUNSPEC); 
((((BgL_boxzd2setz12zc0_bglt)CREF(BgL_new2651z00_3184))->BgL_varz00) = ((BgL_varz00_bglt)BgL_arg3654z00_1919), BUNSPEC); 
((((BgL_boxzd2setz12zc0_bglt)CREF(BgL_new2651z00_3184))->BgL_valuez00) = ((BgL_nodez00_bglt)BgL_value2650z00_3183), BUNSPEC); 
BgL_res4001z00_3200 = BgL_new2651z00_3184; BgL_res4001z00_3200; } 
BgL_res4002z00_3201 = BgL_new2651z00_3184; } } 
BgL_arg3640z00_1913 = BgL_res4002z00_3201; } } 
{ /* Callcc/walk.scm 216 */
BgL_letzd2varzd2_bglt BgL_res4005z00_3232;
{ /* Callcc/walk.scm 216 */
BgL_typez00_bglt BgL_type2493z00_3203;obj_t BgL_key2495z00_3205;BgL_nodez00_bglt BgL_body2497z00_3207;
BgL_type2493z00_3203 = 
(BgL_typez00_bglt)(BgL_arg3637z00_1910); 
BgL_key2495z00_3205 = 
BINT(((long)-1)); 
BgL_body2497z00_3207 = 
(BgL_nodez00_bglt)(BgL_arg3640z00_1913); 
{ /* Callcc/walk.scm 216 */
BgL_letzd2varzd2_bglt BgL_new2499z00_3209;
{ /* Callcc/walk.scm 216 */
BgL_letzd2varzd2_bglt BgL_res4003z00_3215;
{ /* Callcc/walk.scm 216 */
BgL_letzd2varzd2_bglt BgL_new2501z00_3210;
BgL_new2501z00_3210 = 
((BgL_letzd2varzd2_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_letzd2varzd2_bgl) ))); 
{ /* Callcc/walk.scm 216 */
long BgL_arg3141z00_3211;
BgL_arg3141z00_3211 = 
BGl_classzd2numzd2zz__objectz00(BGl_letzd2varzd2zzast_nodez00); 
{ /* Callcc/walk.scm 216 */
BgL_objectz00_bglt BgL_auxz00_5061;
BgL_auxz00_5061 = 
(BgL_objectz00_bglt)(BgL_new2501z00_3210); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_5061, BgL_arg3141z00_3211); } } 
{ /* Callcc/walk.scm 216 */
BgL_objectz00_bglt BgL_auxz00_5064;
BgL_auxz00_5064 = 
(BgL_objectz00_bglt)(BgL_new2501z00_3210); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_5064, BFALSE); } 
{ /* Callcc/walk.scm 216 */
obj_t BgL_auxz00_5067;
BgL_auxz00_5067 = 
(obj_t)(BgL_new2501z00_3210); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_5067); } BUNSPEC; 
BgL_res4003z00_3215 = BgL_new2501z00_3210; } 
BgL_new2499z00_3209 = BgL_res4003z00_3215; } 
{ /* Callcc/walk.scm 216 */
BgL_letzd2varzd2_bglt BgL_res4004z00_3231;
((((BgL_letzd2varzd2_bglt)CREF(BgL_new2499z00_3209))->BgL_locz00) = ((obj_t)BgL_arg3636z00_1909), BUNSPEC); 
((((BgL_letzd2varzd2_bglt)CREF(BgL_new2499z00_3209))->BgL_typez00) = ((BgL_typez00_bglt)BgL_type2493z00_3203), BUNSPEC); 
((((BgL_letzd2varzd2_bglt)CREF(BgL_new2499z00_3209))->BgL_sidezd2effectzf3z21) = ((obj_t)BUNSPEC), BUNSPEC); 
((((BgL_letzd2varzd2_bglt)CREF(BgL_new2499z00_3209))->BgL_keyz00) = ((obj_t)BgL_key2495z00_3205), BUNSPEC); 
((((BgL_letzd2varzd2_bglt)CREF(BgL_new2499z00_3209))->BgL_bindingsz00) = ((obj_t)BgL_arg3639z00_1912), BUNSPEC); 
((((BgL_letzd2varzd2_bglt)CREF(BgL_new2499z00_3209))->BgL_bodyz00) = ((BgL_nodez00_bglt)BgL_body2497z00_3207), BUNSPEC); 
((((BgL_letzd2varzd2_bglt)CREF(BgL_new2499z00_3209))->BgL_removablezf3zf3) = ((bool_t)((bool_t)1)), BUNSPEC); 
BgL_res4004z00_3231 = BgL_new2499z00_3209; BgL_res4004z00_3231; } 
BgL_res4005z00_3232 = BgL_new2499z00_3209; } } 
return 
(obj_t)(BgL_res4005z00_3232);} } } }  else 
{ /* Callcc/walk.scm 213 */
return 
(obj_t)(BgL_nodez00_1892);} } } } } } } } 
}



/* callcc!-cast2777 */
obj_t BGl_callccz12zd2cast2777zc0zzcallcc_walkz00(obj_t BgL_envz00_3851, obj_t BgL_nodez00_3852)
{ AN_OBJECT;
{ /* Callcc/walk.scm 192 */
{ 
BgL_castz00_bglt BgL_nodez00_1886;
{ /* Callcc/walk.scm 193 */
BgL_castz00_bglt BgL_auxz00_5082;
BgL_nodez00_1886 = 
(BgL_castz00_bglt)(BgL_nodez00_3852); 
{ /* Callcc/walk.scm 193 */
BgL_nodez00_bglt BgL_arg3604z00_3088;
BgL_arg3604z00_3088 = 
(((BgL_castz00_bglt)CREF(BgL_nodez00_1886))->BgL_argz00); 
{ /* Callcc/walk.scm 193 */
BgL_nodez00_bglt BgL_res3992z00_3116;
{ /* Callcc/walk.scm 193 */
obj_t BgL_method2759z00_3091;
{ /* Callcc/walk.scm 193 */
long BgL_objzd2classzd2numz00_3093;
{ /* Callcc/walk.scm 193 */
BgL_objectz00_bglt BgL_auxz00_5084;
BgL_auxz00_5084 = 
(BgL_objectz00_bglt)(BgL_arg3604z00_3088); 
BgL_objzd2classzd2numz00_3093 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_5084); } 
{ /* Callcc/walk.scm 193 */
obj_t BgL_arg1904z00_3094;
{ /* Callcc/walk.scm 193 */
int BgL_auxz00_5087;
BgL_auxz00_5087 = 
(int)(((long)1)); 
BgL_arg1904z00_3094 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_5087); } 
{ /* Callcc/walk.scm 193 */
long BgL_offsetz00_3098;
{ /* Callcc/walk.scm 193 */
long BgL_auxz00_5090;
{ /* Callcc/walk.scm 193 */
int BgL_auxz00_5091;
BgL_auxz00_5091 = 
(int)(BgL_objzd2classzd2numz00_3093); 
BgL_auxz00_5090 = 
(long)(BgL_auxz00_5091); } 
BgL_offsetz00_3098 = 
(BgL_auxz00_5090-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 193 */
long BgL_modz00_3099;
{ /* Callcc/walk.scm 193 */
long BgL_auxz00_5095;
{ /* Callcc/walk.scm 193 */
int BgL_auxz00_5096;
BgL_auxz00_5096 = 
(int)(((long)8)); 
BgL_auxz00_5095 = 
(long)(BgL_auxz00_5096); } 
BgL_modz00_3099 = 
(BgL_offsetz00_3098/BgL_auxz00_5095); } 
{ /* Callcc/walk.scm 193 */
long BgL_restz00_3101;
{ /* Callcc/walk.scm 193 */
long BgL_auxz00_5100;
{ /* Callcc/walk.scm 193 */
int BgL_auxz00_5101;
BgL_auxz00_5101 = 
(int)(((long)8)); 
BgL_auxz00_5100 = 
(long)(BgL_auxz00_5101); } 
BgL_restz00_3101 = 
(BgL_offsetz00_3098%BgL_auxz00_5100); } 
{ /* Callcc/walk.scm 193 */

{ /* Callcc/walk.scm 193 */
obj_t BgL_bucketz00_3103;
{ /* Callcc/walk.scm 193 */
int BgL_kz00_3113;
BgL_kz00_3113 = 
(int)(BgL_modz00_3099); 
BgL_bucketz00_3103 = 
VECTOR_REF(BgL_arg1904z00_3094,BgL_kz00_3113); } 
{ /* Callcc/walk.scm 193 */
int BgL_kz00_3115;
BgL_kz00_3115 = 
(int)(BgL_restz00_3101); 
BgL_method2759z00_3091 = 
VECTOR_REF(BgL_bucketz00_3103,BgL_kz00_3115); } } } } } } } } 
{ /* Callcc/walk.scm 193 */
obj_t BgL_auxz00_5109;
BgL_auxz00_5109 = 
PROCEDURE_ENTRY(BgL_method2759z00_3091)(BgL_method2759z00_3091, 
(obj_t)(BgL_arg3604z00_3088), BEOA); 
BgL_res3992z00_3116 = 
(BgL_nodez00_bglt)(BgL_auxz00_5109); } } BgL_res3992z00_3116; } } 
BgL_auxz00_5082 = BgL_nodez00_1886; 
return 
(obj_t)(BgL_auxz00_5082);} } } 
}



/* callcc!-extern2775 */
obj_t BGl_callccz12zd2extern2775zc0zzcallcc_walkz00(obj_t BgL_envz00_3853, obj_t BgL_nodez00_3854)
{ AN_OBJECT;
{ /* Callcc/walk.scm 185 */
{ 
BgL_externz00_bglt BgL_nodez00_1880;
{ /* Callcc/walk.scm 186 */
BgL_externz00_bglt BgL_auxz00_5116;
BgL_nodez00_1880 = 
(BgL_externz00_bglt)(BgL_nodez00_3854); 
BGl_callccza2z12zb0zzcallcc_walkz00(
(((BgL_externz00_bglt)CREF(BgL_nodez00_1880))->BgL_exprza2za2)); 
BgL_auxz00_5116 = BgL_nodez00_1880; 
return 
(obj_t)(BgL_auxz00_5116);} } } 
}



/* callcc!-funcall2773 */
obj_t BGl_callccz12zd2funcall2773zc0zzcallcc_walkz00(obj_t BgL_envz00_3855, obj_t BgL_nodez00_3856)
{ AN_OBJECT;
{ /* Callcc/walk.scm 176 */
{ 
BgL_funcallz00_bglt BgL_nodez00_1871;
{ /* Callcc/walk.scm 177 */
BgL_funcallz00_bglt BgL_auxz00_5121;
BgL_nodez00_1871 = 
(BgL_funcallz00_bglt)(BgL_nodez00_3856); 
{ /* Callcc/walk.scm 178 */
BgL_nodez00_bglt BgL_arg3577z00_1875;
{ /* Callcc/walk.scm 178 */
BgL_nodez00_bglt BgL_arg3580z00_1876;
BgL_arg3580z00_1876 = 
(((BgL_funcallz00_bglt)CREF(BgL_nodez00_1871))->BgL_funz00); 
{ /* Callcc/walk.scm 178 */
BgL_nodez00_bglt BgL_res3989z00_3082;
{ /* Callcc/walk.scm 178 */
obj_t BgL_method2759z00_3057;
{ /* Callcc/walk.scm 178 */
long BgL_objzd2classzd2numz00_3059;
{ /* Callcc/walk.scm 178 */
BgL_objectz00_bglt BgL_auxz00_5123;
BgL_auxz00_5123 = 
(BgL_objectz00_bglt)(BgL_arg3580z00_1876); 
BgL_objzd2classzd2numz00_3059 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_5123); } 
{ /* Callcc/walk.scm 178 */
obj_t BgL_arg1904z00_3060;
{ /* Callcc/walk.scm 178 */
int BgL_auxz00_5126;
BgL_auxz00_5126 = 
(int)(((long)1)); 
BgL_arg1904z00_3060 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_5126); } 
{ /* Callcc/walk.scm 178 */
long BgL_offsetz00_3064;
{ /* Callcc/walk.scm 178 */
long BgL_auxz00_5129;
{ /* Callcc/walk.scm 178 */
int BgL_auxz00_5130;
BgL_auxz00_5130 = 
(int)(BgL_objzd2classzd2numz00_3059); 
BgL_auxz00_5129 = 
(long)(BgL_auxz00_5130); } 
BgL_offsetz00_3064 = 
(BgL_auxz00_5129-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 178 */
long BgL_modz00_3065;
{ /* Callcc/walk.scm 178 */
long BgL_auxz00_5134;
{ /* Callcc/walk.scm 178 */
int BgL_auxz00_5135;
BgL_auxz00_5135 = 
(int)(((long)8)); 
BgL_auxz00_5134 = 
(long)(BgL_auxz00_5135); } 
BgL_modz00_3065 = 
(BgL_offsetz00_3064/BgL_auxz00_5134); } 
{ /* Callcc/walk.scm 178 */
long BgL_restz00_3067;
{ /* Callcc/walk.scm 178 */
long BgL_auxz00_5139;
{ /* Callcc/walk.scm 178 */
int BgL_auxz00_5140;
BgL_auxz00_5140 = 
(int)(((long)8)); 
BgL_auxz00_5139 = 
(long)(BgL_auxz00_5140); } 
BgL_restz00_3067 = 
(BgL_offsetz00_3064%BgL_auxz00_5139); } 
{ /* Callcc/walk.scm 178 */

{ /* Callcc/walk.scm 178 */
obj_t BgL_bucketz00_3069;
{ /* Callcc/walk.scm 178 */
int BgL_kz00_3079;
BgL_kz00_3079 = 
(int)(BgL_modz00_3065); 
BgL_bucketz00_3069 = 
VECTOR_REF(BgL_arg1904z00_3060,BgL_kz00_3079); } 
{ /* Callcc/walk.scm 178 */
int BgL_kz00_3081;
BgL_kz00_3081 = 
(int)(BgL_restz00_3067); 
BgL_method2759z00_3057 = 
VECTOR_REF(BgL_bucketz00_3069,BgL_kz00_3081); } } } } } } } } 
{ /* Callcc/walk.scm 178 */
obj_t BgL_auxz00_5148;
BgL_auxz00_5148 = 
PROCEDURE_ENTRY(BgL_method2759z00_3057)(BgL_method2759z00_3057, 
(obj_t)(BgL_arg3580z00_1876), BEOA); 
BgL_res3989z00_3082 = 
(BgL_nodez00_bglt)(BgL_auxz00_5148); } } 
BgL_arg3577z00_1875 = BgL_res3989z00_3082; } } 
((((BgL_funcallz00_bglt)CREF(BgL_nodez00_1871))->BgL_funz00) = ((BgL_nodez00_bglt)BgL_arg3577z00_1875), BUNSPEC); } 
BGl_callccza2z12zb0zzcallcc_walkz00(
(((BgL_funcallz00_bglt)CREF(BgL_nodez00_1871))->BgL_argsz00)); 
BgL_auxz00_5121 = BgL_nodez00_1871; 
return 
(obj_t)(BgL_auxz00_5121);} } } 
}



/* callcc!-app-ly2771 */
obj_t BGl_callccz12zd2appzd2ly2771z12zzcallcc_walkz00(obj_t BgL_envz00_3857, obj_t BgL_nodez00_3858)
{ AN_OBJECT;
{ /* Callcc/walk.scm 167 */
{ 
BgL_appzd2lyzd2_bglt BgL_nodez00_1861;
{ /* Callcc/walk.scm 168 */
BgL_appzd2lyzd2_bglt BgL_auxz00_5158;
BgL_nodez00_1861 = 
(BgL_appzd2lyzd2_bglt)(BgL_nodez00_3858); 
{ /* Callcc/walk.scm 169 */
BgL_nodez00_bglt BgL_arg3557z00_1865;
{ /* Callcc/walk.scm 169 */
BgL_nodez00_bglt BgL_arg3560z00_1866;
BgL_arg3560z00_1866 = 
(((BgL_appzd2lyzd2_bglt)CREF(BgL_nodez00_1861))->BgL_funz00); 
{ /* Callcc/walk.scm 169 */
BgL_nodez00_bglt BgL_res3983z00_3022;
{ /* Callcc/walk.scm 169 */
obj_t BgL_method2759z00_2997;
{ /* Callcc/walk.scm 169 */
long BgL_objzd2classzd2numz00_2999;
{ /* Callcc/walk.scm 169 */
BgL_objectz00_bglt BgL_auxz00_5160;
BgL_auxz00_5160 = 
(BgL_objectz00_bglt)(BgL_arg3560z00_1866); 
BgL_objzd2classzd2numz00_2999 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_5160); } 
{ /* Callcc/walk.scm 169 */
obj_t BgL_arg1904z00_3000;
{ /* Callcc/walk.scm 169 */
int BgL_auxz00_5163;
BgL_auxz00_5163 = 
(int)(((long)1)); 
BgL_arg1904z00_3000 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_5163); } 
{ /* Callcc/walk.scm 169 */
long BgL_offsetz00_3004;
{ /* Callcc/walk.scm 169 */
long BgL_auxz00_5166;
{ /* Callcc/walk.scm 169 */
int BgL_auxz00_5167;
BgL_auxz00_5167 = 
(int)(BgL_objzd2classzd2numz00_2999); 
BgL_auxz00_5166 = 
(long)(BgL_auxz00_5167); } 
BgL_offsetz00_3004 = 
(BgL_auxz00_5166-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 169 */
long BgL_modz00_3005;
{ /* Callcc/walk.scm 169 */
long BgL_auxz00_5171;
{ /* Callcc/walk.scm 169 */
int BgL_auxz00_5172;
BgL_auxz00_5172 = 
(int)(((long)8)); 
BgL_auxz00_5171 = 
(long)(BgL_auxz00_5172); } 
BgL_modz00_3005 = 
(BgL_offsetz00_3004/BgL_auxz00_5171); } 
{ /* Callcc/walk.scm 169 */
long BgL_restz00_3007;
{ /* Callcc/walk.scm 169 */
long BgL_auxz00_5176;
{ /* Callcc/walk.scm 169 */
int BgL_auxz00_5177;
BgL_auxz00_5177 = 
(int)(((long)8)); 
BgL_auxz00_5176 = 
(long)(BgL_auxz00_5177); } 
BgL_restz00_3007 = 
(BgL_offsetz00_3004%BgL_auxz00_5176); } 
{ /* Callcc/walk.scm 169 */

{ /* Callcc/walk.scm 169 */
obj_t BgL_bucketz00_3009;
{ /* Callcc/walk.scm 169 */
int BgL_kz00_3019;
BgL_kz00_3019 = 
(int)(BgL_modz00_3005); 
BgL_bucketz00_3009 = 
VECTOR_REF(BgL_arg1904z00_3000,BgL_kz00_3019); } 
{ /* Callcc/walk.scm 169 */
int BgL_kz00_3021;
BgL_kz00_3021 = 
(int)(BgL_restz00_3007); 
BgL_method2759z00_2997 = 
VECTOR_REF(BgL_bucketz00_3009,BgL_kz00_3021); } } } } } } } } 
{ /* Callcc/walk.scm 169 */
obj_t BgL_auxz00_5185;
BgL_auxz00_5185 = 
PROCEDURE_ENTRY(BgL_method2759z00_2997)(BgL_method2759z00_2997, 
(obj_t)(BgL_arg3560z00_1866), BEOA); 
BgL_res3983z00_3022 = 
(BgL_nodez00_bglt)(BgL_auxz00_5185); } } 
BgL_arg3557z00_1865 = BgL_res3983z00_3022; } } 
((((BgL_appzd2lyzd2_bglt)CREF(BgL_nodez00_1861))->BgL_funz00) = ((BgL_nodez00_bglt)BgL_arg3557z00_1865), BUNSPEC); } 
{ /* Callcc/walk.scm 170 */
BgL_nodez00_bglt BgL_arg3564z00_1867;
{ /* Callcc/walk.scm 170 */
BgL_nodez00_bglt BgL_arg3567z00_1868;
BgL_arg3567z00_1868 = 
(((BgL_appzd2lyzd2_bglt)CREF(BgL_nodez00_1861))->BgL_argz00); 
{ /* Callcc/walk.scm 170 */
BgL_nodez00_bglt BgL_res3986z00_3052;
{ /* Callcc/walk.scm 170 */
obj_t BgL_method2759z00_3027;
{ /* Callcc/walk.scm 170 */
long BgL_objzd2classzd2numz00_3029;
{ /* Callcc/walk.scm 170 */
BgL_objectz00_bglt BgL_auxz00_5192;
BgL_auxz00_5192 = 
(BgL_objectz00_bglt)(BgL_arg3567z00_1868); 
BgL_objzd2classzd2numz00_3029 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_5192); } 
{ /* Callcc/walk.scm 170 */
obj_t BgL_arg1904z00_3030;
{ /* Callcc/walk.scm 170 */
int BgL_auxz00_5195;
BgL_auxz00_5195 = 
(int)(((long)1)); 
BgL_arg1904z00_3030 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_5195); } 
{ /* Callcc/walk.scm 170 */
long BgL_offsetz00_3034;
{ /* Callcc/walk.scm 170 */
long BgL_auxz00_5198;
{ /* Callcc/walk.scm 170 */
int BgL_auxz00_5199;
BgL_auxz00_5199 = 
(int)(BgL_objzd2classzd2numz00_3029); 
BgL_auxz00_5198 = 
(long)(BgL_auxz00_5199); } 
BgL_offsetz00_3034 = 
(BgL_auxz00_5198-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 170 */
long BgL_modz00_3035;
{ /* Callcc/walk.scm 170 */
long BgL_auxz00_5203;
{ /* Callcc/walk.scm 170 */
int BgL_auxz00_5204;
BgL_auxz00_5204 = 
(int)(((long)8)); 
BgL_auxz00_5203 = 
(long)(BgL_auxz00_5204); } 
BgL_modz00_3035 = 
(BgL_offsetz00_3034/BgL_auxz00_5203); } 
{ /* Callcc/walk.scm 170 */
long BgL_restz00_3037;
{ /* Callcc/walk.scm 170 */
long BgL_auxz00_5208;
{ /* Callcc/walk.scm 170 */
int BgL_auxz00_5209;
BgL_auxz00_5209 = 
(int)(((long)8)); 
BgL_auxz00_5208 = 
(long)(BgL_auxz00_5209); } 
BgL_restz00_3037 = 
(BgL_offsetz00_3034%BgL_auxz00_5208); } 
{ /* Callcc/walk.scm 170 */

{ /* Callcc/walk.scm 170 */
obj_t BgL_bucketz00_3039;
{ /* Callcc/walk.scm 170 */
int BgL_kz00_3049;
BgL_kz00_3049 = 
(int)(BgL_modz00_3035); 
BgL_bucketz00_3039 = 
VECTOR_REF(BgL_arg1904z00_3030,BgL_kz00_3049); } 
{ /* Callcc/walk.scm 170 */
int BgL_kz00_3051;
BgL_kz00_3051 = 
(int)(BgL_restz00_3037); 
BgL_method2759z00_3027 = 
VECTOR_REF(BgL_bucketz00_3039,BgL_kz00_3051); } } } } } } } } 
{ /* Callcc/walk.scm 170 */
obj_t BgL_auxz00_5217;
BgL_auxz00_5217 = 
PROCEDURE_ENTRY(BgL_method2759z00_3027)(BgL_method2759z00_3027, 
(obj_t)(BgL_arg3567z00_1868), BEOA); 
BgL_res3986z00_3052 = 
(BgL_nodez00_bglt)(BgL_auxz00_5217); } } 
BgL_arg3564z00_1867 = BgL_res3986z00_3052; } } 
((((BgL_appzd2lyzd2_bglt)CREF(BgL_nodez00_1861))->BgL_argz00) = ((BgL_nodez00_bglt)BgL_arg3564z00_1867), BUNSPEC); } 
BgL_auxz00_5158 = BgL_nodez00_1861; 
return 
(obj_t)(BgL_auxz00_5158);} } } 
}



/* callcc!-app2769 */
obj_t BGl_callccz12zd2app2769zc0zzcallcc_walkz00(obj_t BgL_envz00_3859, obj_t BgL_nodez00_3860)
{ AN_OBJECT;
{ /* Callcc/walk.scm 159 */
{ 
BgL_appz00_bglt BgL_nodez00_1854;
{ /* Callcc/walk.scm 160 */
BgL_appz00_bglt BgL_auxz00_5225;
BgL_nodez00_1854 = 
(BgL_appz00_bglt)(BgL_nodez00_3860); 
BGl_callccza2z12zb0zzcallcc_walkz00(
(((BgL_appz00_bglt)CREF(BgL_nodez00_1854))->BgL_argsz00)); 
BgL_auxz00_5225 = BgL_nodez00_1854; 
return 
(obj_t)(BgL_auxz00_5225);} } } 
}



/* callcc!-sequence2767 */
obj_t BGl_callccz12zd2sequence2767zc0zzcallcc_walkz00(obj_t BgL_envz00_3861, obj_t BgL_nodez00_3862)
{ AN_OBJECT;
{ /* Callcc/walk.scm 152 */
{ 
BgL_sequencez00_bglt BgL_nodez00_1848;
{ /* Callcc/walk.scm 153 */
BgL_sequencez00_bglt BgL_auxz00_5230;
BgL_nodez00_1848 = 
(BgL_sequencez00_bglt)(BgL_nodez00_3862); 
BGl_callccza2z12zb0zzcallcc_walkz00(
(((BgL_sequencez00_bglt)CREF(BgL_nodez00_1848))->BgL_nodesz00)); 
BgL_auxz00_5230 = BgL_nodez00_1848; 
return 
(obj_t)(BgL_auxz00_5230);} } } 
}



/* callcc!-var2765 */
obj_t BGl_callccz12zd2var2765zc0zzcallcc_walkz00(obj_t BgL_envz00_3863, obj_t BgL_nodez00_3864)
{ AN_OBJECT;
{ /* Callcc/walk.scm 127 */
{ 
BgL_varz00_bglt BgL_nodez00_1829;
BgL_nodez00_1829 = 
(BgL_varz00_bglt)(BgL_nodez00_3864); 
{ /* Callcc/walk.scm 128 */
BgL_variablez00_bglt BgL_varz00_1832;
BgL_varz00_1832 = 
(((BgL_varz00_bglt)CREF(BgL_nodez00_1829))->BgL_variablez00); 
{ 
obj_t BgL_varz00_1833;obj_t BgL_alphaz00_1834;
BgL_varz00_1833 = 
(obj_t)(BgL_varz00_1832); 
BgL_alphaz00_1834 = 
(((BgL_variablez00_bglt)CREF(BgL_varz00_1832))->BgL_fastzd2alphazd2); 
BgL_loopz00_1835:
{ /* Callcc/walk.scm 131 */
bool_t BgL_test3507z00_1837;
BgL_test3507z00_1837 = 
BGl_iszd2azf3z21zz__objectz00(BgL_alphaz00_1834, BGl_localz00zzast_varz00); 
if(BgL_test3507z00_1837)
{ /* Callcc/walk.scm 131 */
{ /* Callcc/walk.scm 133 */
BgL_variablez00_bglt BgL_val1621z00_2931;
BgL_val1621z00_2931 = 
(BgL_variablez00_bglt)(BgL_alphaz00_1834); 
((((BgL_varz00_bglt)CREF(BgL_nodez00_1829))->BgL_variablez00) = ((BgL_variablez00_bglt)BgL_val1621z00_2931), BUNSPEC); } 
{ 
obj_t BgL_alphaz00_5241;obj_t BgL_varz00_5240;
BgL_varz00_5240 = BgL_alphaz00_1834; 
{ /* Callcc/walk.scm 134 */
BgL_variablez00_bglt BgL_obj1110z00_2932;
BgL_obj1110z00_2932 = 
(BgL_variablez00_bglt)(BgL_alphaz00_1834); 
BgL_alphaz00_5241 = 
(((BgL_variablez00_bglt)CREF(BgL_obj1110z00_2932))->BgL_fastzd2alphazd2); } 
BgL_alphaz00_1834 = BgL_alphaz00_5241; 
BgL_varz00_1833 = BgL_varz00_5240; 
goto BgL_loopz00_1835;} }  else 
{ /* Callcc/walk.scm 135 */
bool_t BgL_test3513z00_1839;
BgL_test3513z00_1839 = 
BGl_iszd2azf3z21zz__objectz00(BgL_alphaz00_1834, BGl_localz00zzast_varz00); 
if(BgL_test3513z00_1839)
{ /* Callcc/walk.scm 135 */
{ /* Callcc/walk.scm 137 */
BgL_variablez00_bglt BgL_val1621z00_2935;
BgL_val1621z00_2935 = 
(BgL_variablez00_bglt)(BgL_alphaz00_1834); 
((((BgL_varz00_bglt)CREF(BgL_nodez00_1829))->BgL_variablez00) = ((BgL_variablez00_bglt)BgL_val1621z00_2935), BUNSPEC); } 
{ /* Callcc/walk.scm 138 */
BgL_nodez00_bglt BgL_res3977z00_2962;
{ /* Callcc/walk.scm 138 */
BgL_nodez00_bglt BgL_nodez00_2936;
BgL_nodez00_2936 = 
(BgL_nodez00_bglt)(BgL_nodez00_1829); 
{ /* Callcc/walk.scm 138 */
obj_t BgL_method2759z00_2937;
{ /* Callcc/walk.scm 138 */
long BgL_objzd2classzd2numz00_2939;
{ /* Callcc/walk.scm 138 */
BgL_objectz00_bglt BgL_auxz00_5249;
BgL_auxz00_5249 = 
(BgL_objectz00_bglt)(BgL_nodez00_2936); 
BgL_objzd2classzd2numz00_2939 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_5249); } 
{ /* Callcc/walk.scm 138 */
obj_t BgL_arg1904z00_2940;
{ /* Callcc/walk.scm 138 */
int BgL_auxz00_5252;
BgL_auxz00_5252 = 
(int)(((long)1)); 
BgL_arg1904z00_2940 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_5252); } 
{ /* Callcc/walk.scm 138 */
long BgL_offsetz00_2944;
{ /* Callcc/walk.scm 138 */
long BgL_auxz00_5255;
{ /* Callcc/walk.scm 138 */
int BgL_auxz00_5256;
BgL_auxz00_5256 = 
(int)(BgL_objzd2classzd2numz00_2939); 
BgL_auxz00_5255 = 
(long)(BgL_auxz00_5256); } 
BgL_offsetz00_2944 = 
(BgL_auxz00_5255-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 138 */
long BgL_modz00_2945;
{ /* Callcc/walk.scm 138 */
long BgL_auxz00_5260;
{ /* Callcc/walk.scm 138 */
int BgL_auxz00_5261;
BgL_auxz00_5261 = 
(int)(((long)8)); 
BgL_auxz00_5260 = 
(long)(BgL_auxz00_5261); } 
BgL_modz00_2945 = 
(BgL_offsetz00_2944/BgL_auxz00_5260); } 
{ /* Callcc/walk.scm 138 */
long BgL_restz00_2947;
{ /* Callcc/walk.scm 138 */
long BgL_auxz00_5265;
{ /* Callcc/walk.scm 138 */
int BgL_auxz00_5266;
BgL_auxz00_5266 = 
(int)(((long)8)); 
BgL_auxz00_5265 = 
(long)(BgL_auxz00_5266); } 
BgL_restz00_2947 = 
(BgL_offsetz00_2944%BgL_auxz00_5265); } 
{ /* Callcc/walk.scm 138 */

{ /* Callcc/walk.scm 138 */
obj_t BgL_bucketz00_2949;
{ /* Callcc/walk.scm 138 */
int BgL_kz00_2959;
BgL_kz00_2959 = 
(int)(BgL_modz00_2945); 
BgL_bucketz00_2949 = 
VECTOR_REF(BgL_arg1904z00_2940,BgL_kz00_2959); } 
{ /* Callcc/walk.scm 138 */
int BgL_kz00_2961;
BgL_kz00_2961 = 
(int)(BgL_restz00_2947); 
BgL_method2759z00_2937 = 
VECTOR_REF(BgL_bucketz00_2949,BgL_kz00_2961); } } } } } } } } 
{ /* Callcc/walk.scm 138 */
obj_t BgL_auxz00_5274;
BgL_auxz00_5274 = 
PROCEDURE_ENTRY(BgL_method2759z00_2937)(BgL_method2759z00_2937, 
(obj_t)(BgL_nodez00_2936), BEOA); 
BgL_res3977z00_2962 = 
(BgL_nodez00_bglt)(BgL_auxz00_5274); } } } 
return 
(obj_t)(BgL_res3977z00_2962);} }  else 
{ /* Callcc/walk.scm 141 */
bool_t BgL_test3516z00_1840;
BgL_test3516z00_1840 = 
BGl_iszd2azf3z21zz__objectz00(BgL_varz00_1833, BGl_globalz00zzast_varz00); 
if(BgL_test3516z00_1840)
{ /* Callcc/walk.scm 141 */
return 
(obj_t)(BgL_nodez00_1829);}  else 
{ /* Callcc/walk.scm 141 */
if(
BGl_celledzf3zf3zzcallcc_walkz00(
(BgL_variablez00_bglt)(BgL_varz00_1833)))
{ /* Callcc/walk.scm 141 */
{ /* Callcc/walk.scm 146 */
obj_t BgL_arg3519z00_1842;obj_t BgL_arg3520z00_1843;BgL_varz00_bglt BgL_arg3522z00_1845;
{ /* Callcc/walk.scm 146 */
BgL_nodez00_bglt BgL_obj1550z00_2964;
BgL_obj1550z00_2964 = 
(BgL_nodez00_bglt)(BgL_nodez00_1829); 
BgL_arg3519z00_1842 = 
(((BgL_nodez00_bglt)CREF(BgL_obj1550z00_2964))->BgL_locz00); } 
BgL_arg3520z00_1843 = BGl_za2_za2z00zztype_cachez00; 
BgL_arg3522z00_1845 = BgL_nodez00_1829; 
{ /* Callcc/walk.scm 144 */
BgL_boxzd2refzd2_bglt BgL_res3980z00_2989;
{ /* Callcc/walk.scm 144 */
BgL_typez00_bglt BgL_type2619z00_2966;obj_t BgL_key2621z00_2968;
BgL_type2619z00_2966 = 
(BgL_typez00_bglt)(BgL_arg3520z00_1843); 
BgL_key2621z00_2968 = 
BINT(((long)-1)); 
{ /* Callcc/walk.scm 144 */
BgL_boxzd2refzd2_bglt BgL_new2623z00_2970;
{ /* Callcc/walk.scm 144 */
BgL_boxzd2refzd2_bglt BgL_res3978z00_2976;
{ /* Callcc/walk.scm 144 */
BgL_boxzd2refzd2_bglt BgL_new2625z00_2971;
BgL_new2625z00_2971 = 
((BgL_boxzd2refzd2_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_boxzd2refzd2_bgl) ))); 
{ /* Callcc/walk.scm 144 */
long BgL_arg3105z00_2972;
BgL_arg3105z00_2972 = 
BGl_classzd2numzd2zz__objectz00(BGl_boxzd2refzd2zzast_nodez00); 
{ /* Callcc/walk.scm 144 */
BgL_objectz00_bglt BgL_auxz00_5292;
BgL_auxz00_5292 = 
(BgL_objectz00_bglt)(BgL_new2625z00_2971); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_5292, BgL_arg3105z00_2972); } } 
{ /* Callcc/walk.scm 144 */
BgL_objectz00_bglt BgL_auxz00_5295;
BgL_auxz00_5295 = 
(BgL_objectz00_bglt)(BgL_new2625z00_2971); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_5295, BFALSE); } 
{ /* Callcc/walk.scm 144 */
obj_t BgL_auxz00_5298;
BgL_auxz00_5298 = 
(obj_t)(BgL_new2625z00_2971); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_5298); } BUNSPEC; 
BgL_res3978z00_2976 = BgL_new2625z00_2971; } 
BgL_new2623z00_2970 = BgL_res3978z00_2976; } 
{ /* Callcc/walk.scm 144 */
BgL_boxzd2refzd2_bglt BgL_res3979z00_2988;
((((BgL_boxzd2refzd2_bglt)CREF(BgL_new2623z00_2970))->BgL_locz00) = ((obj_t)BgL_arg3519z00_1842), BUNSPEC); 
((((BgL_boxzd2refzd2_bglt)CREF(BgL_new2623z00_2970))->BgL_typez00) = ((BgL_typez00_bglt)BgL_type2619z00_2966), BUNSPEC); 
((((BgL_boxzd2refzd2_bglt)CREF(BgL_new2623z00_2970))->BgL_sidezd2effectzf3z21) = ((obj_t)BUNSPEC), BUNSPEC); 
((((BgL_boxzd2refzd2_bglt)CREF(BgL_new2623z00_2970))->BgL_keyz00) = ((obj_t)BgL_key2621z00_2968), BUNSPEC); 
((((BgL_boxzd2refzd2_bglt)CREF(BgL_new2623z00_2970))->BgL_varz00) = ((BgL_varz00_bglt)BgL_arg3522z00_1845), BUNSPEC); 
BgL_res3979z00_2988 = BgL_new2623z00_2970; BgL_res3979z00_2988; } 
BgL_res3980z00_2989 = BgL_new2623z00_2970; } } 
return 
(obj_t)(BgL_res3980z00_2989);} } }  else 
{ /* Callcc/walk.scm 141 */
return 
(obj_t)(BgL_nodez00_1829);} } } } } } } } } 
}



/* callcc!-kwote2763 */
obj_t BGl_callccz12zd2kwote2763zc0zzcallcc_walkz00(obj_t BgL_envz00_3865, obj_t BgL_nodez00_3866)
{ AN_OBJECT;
{ /* Callcc/walk.scm 121 */
{ 
BgL_kwotez00_bglt BgL_nodez00_1824;
{ /* Callcc/walk.scm 122 */
BgL_kwotez00_bglt BgL_auxz00_5311;
BgL_nodez00_1824 = 
(BgL_kwotez00_bglt)(BgL_nodez00_3866); 
BgL_auxz00_5311 = BgL_nodez00_1824; 
return 
(obj_t)(BgL_auxz00_5311);} } } 
}



/* callcc!-atom2761 */
obj_t BGl_callccz12zd2atom2761zc0zzcallcc_walkz00(obj_t BgL_envz00_3867, obj_t BgL_nodez00_3868)
{ AN_OBJECT;
{ /* Callcc/walk.scm 115 */
{ 
BgL_atomz00_bglt BgL_nodez00_1819;
{ /* Callcc/walk.scm 116 */
BgL_atomz00_bglt BgL_auxz00_5314;
BgL_nodez00_1819 = 
(BgL_atomz00_bglt)(BgL_nodez00_3868); 
BgL_auxz00_5314 = BgL_nodez00_1819; 
return 
(obj_t)(BgL_auxz00_5314);} } } 
}



/* callcc! */
BgL_nodez00_bglt BGl_callccz12z12zzcallcc_walkz00(BgL_nodez00_bglt BgL_nodez00_9)
{ AN_OBJECT;
{ /* Callcc/walk.scm 110 */
{ /* Callcc/walk.scm 110 */
obj_t BgL_method2759z00_3753;
{ /* Callcc/walk.scm 110 */
long BgL_objzd2classzd2numz00_3755;
{ /* Callcc/walk.scm 110 */
BgL_objectz00_bglt BgL_auxz00_5317;
BgL_auxz00_5317 = 
(BgL_objectz00_bglt)(BgL_nodez00_9); 
BgL_objzd2classzd2numz00_3755 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_5317); } 
{ /* Callcc/walk.scm 110 */
obj_t BgL_arg1904z00_3756;
{ /* Callcc/walk.scm 110 */
int BgL_auxz00_5320;
BgL_auxz00_5320 = 
(int)(((long)1)); 
BgL_arg1904z00_3756 = 
PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00, BgL_auxz00_5320); } 
{ /* Callcc/walk.scm 110 */
long BgL_offsetz00_3760;
{ /* Callcc/walk.scm 110 */
long BgL_auxz00_5323;
{ /* Callcc/walk.scm 110 */
int BgL_auxz00_5324;
BgL_auxz00_5324 = 
(int)(BgL_objzd2classzd2numz00_3755); 
BgL_auxz00_5323 = 
(long)(BgL_auxz00_5324); } 
BgL_offsetz00_3760 = 
(BgL_auxz00_5323-OBJECT_TYPE); } 
{ /* Callcc/walk.scm 110 */
long BgL_modz00_3761;
{ /* Callcc/walk.scm 110 */
long BgL_auxz00_5328;
{ /* Callcc/walk.scm 110 */
int BgL_auxz00_5329;
BgL_auxz00_5329 = 
(int)(((long)8)); 
BgL_auxz00_5328 = 
(long)(BgL_auxz00_5329); } 
BgL_modz00_3761 = 
(BgL_offsetz00_3760/BgL_auxz00_5328); } 
{ /* Callcc/walk.scm 110 */
long BgL_restz00_3763;
{ /* Callcc/walk.scm 110 */
long BgL_auxz00_5333;
{ /* Callcc/walk.scm 110 */
int BgL_auxz00_5334;
BgL_auxz00_5334 = 
(int)(((long)8)); 
BgL_auxz00_5333 = 
(long)(BgL_auxz00_5334); } 
BgL_restz00_3763 = 
(BgL_offsetz00_3760%BgL_auxz00_5333); } 
{ /* Callcc/walk.scm 110 */

{ /* Callcc/walk.scm 110 */
obj_t BgL_bucketz00_3765;
{ /* Callcc/walk.scm 110 */
int BgL_kz00_3775;
BgL_kz00_3775 = 
(int)(BgL_modz00_3761); 
BgL_bucketz00_3765 = 
VECTOR_REF(BgL_arg1904z00_3756,BgL_kz00_3775); } 
{ /* Callcc/walk.scm 110 */
int BgL_kz00_3777;
BgL_kz00_3777 = 
(int)(BgL_restz00_3763); 
BgL_method2759z00_3753 = 
VECTOR_REF(BgL_bucketz00_3765,BgL_kz00_3777); } } } } } } } } 
{ /* Callcc/walk.scm 110 */
obj_t BgL_auxz00_5342;
BgL_auxz00_5342 = 
PROCEDURE_ENTRY(BgL_method2759z00_3753)(BgL_method2759z00_3753, 
(obj_t)(BgL_nodez00_9), BEOA); 
return 
(BgL_nodez00_bglt)(BgL_auxz00_5342);} } } 
}



/* _callcc!4059 */
obj_t BGl__callccz124059z12zzcallcc_walkz00(obj_t BgL_envz00_3783, obj_t BgL_nodez00_3784)
{ AN_OBJECT;
{ /* Callcc/walk.scm 110 */
{ /* Callcc/walk.scm 110 */
BgL_nodez00_bglt BgL_auxz00_5347;
BgL_auxz00_5347 = 
BGl_callccz12z12zzcallcc_walkz00(
(BgL_nodez00_bglt)(BgL_nodez00_3784)); 
return 
(obj_t)(BgL_auxz00_5347);} } 
}



/* callcc!-default2758 */
BgL_nodez00_bglt BGl_callccz12zd2default2758zc0zzcallcc_walkz00(BgL_nodez00_bglt BgL_nodez00_10)
{ AN_OBJECT;
{ /* Callcc/walk.scm 16 */
{ 
obj_t BgL_auxz00_5353;obj_t BgL_auxz00_5351;
BgL_auxz00_5353 = 
(obj_t)(BgL_nodez00_10); 
BgL_auxz00_5351 = 
CNST_TABLE_REF(((long)6)); 
FAILURE(BgL_auxz00_5351,BGl_string4650z00zzcallcc_walkz00,BgL_auxz00_5353);} } 
}



/* _callcc!-default2758 */
obj_t BGl__callccz12zd2default2758zc0zzcallcc_walkz00(obj_t BgL_envz00_3869, obj_t BgL_nodez00_3870)
{ AN_OBJECT;
{ /* Callcc/walk.scm 16 */
{ /* Callcc/walk.scm 16 */
BgL_nodez00_bglt BgL_auxz00_5356;
BgL_auxz00_5356 = 
BGl_callccz12zd2default2758zc0zzcallcc_walkz00(
(BgL_nodez00_bglt)(BgL_nodez00_3870)); 
return 
(obj_t)(BgL_auxz00_5356);} } 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzcallcc_walkz00()
{ AN_OBJECT;
{ /* Callcc/walk.scm 16 */
BGl_modulezd2initializa7ationz75zztools_speekz00(((long)23545), "callcc_walk"); 
BGl_modulezd2initializa7ationz75zztools_errorz00(((long)17886), "callcc_walk"); 
BGl_modulezd2initializa7ationz75zzengine_passz00(((long)12444), "callcc_walk"); 
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19010), "callcc_walk"); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)28259), "callcc_walk"); 
BGl_modulezd2initializa7ationz75zzast_nodez00(((long)49436), "callcc_walk"); 
BGl_modulezd2initializa7ationz75zztools_shapez00(((long)30825), "callcc_walk"); 
BGl_modulezd2initializa7ationz75zztype_cachez00(((long)57983), "callcc_walk"); 
BGl_modulezd2initializa7ationz75zzast_localz00(((long)106367), "callcc_walk"); 
return 
BGl_modulezd2initializa7ationz75zzengine_paramz00(((long)189840), "callcc_walk");} 
}

