/*===========================================================================*/
/*   (Expand/object.scm)                                                     */
/*   Bigloo (2.5b)                                                           */
/*   Manuel Serrano (c)       Fri Sep 6 09:43:28 CEST 2002                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_tclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   struct BgL_globalz00_bgl * BgL_holderz00;
   obj_t BgL_wideningz00;
   long BgL_depthz00;
   bool_t BgL_finalzf3zf3;
   obj_t BgL_constructorz00;
   obj_t BgL_virtualzd2slotszd2numberz00;
   bool_t BgL_abstractzf3zf3;
} *BgL_tclassz00_bglt;

typedef struct BgL_jclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   obj_t BgL_packagez00;
} *BgL_jclassz00_bglt;

typedef struct BgL_slotz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_srcz00;
   obj_t BgL_classzd2ownerzd2;
   obj_t BgL_typez00;
   bool_t BgL_readzd2onlyzf3z21;
   obj_t BgL_defaultzd2valuezd2;
   obj_t BgL_virtualzd2numzd2;
   obj_t BgL_getterz00;
   obj_t BgL_setterz00;
   obj_t BgL_indexedz00;
   obj_t BgL_userzd2infozd2;
} *BgL_slotz00_bglt;


extern obj_t BGl_slotz00zzobject_slotsz00;
static obj_t BGl_allocz00zzexpand_objectz00(obj_t, obj_t);
extern obj_t BGl_modulezd2initializa7ationz75zzexpand_objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_argsz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_prognz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzexpand_epsz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_privatez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_slotsz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
extern obj_t BGl_normaliza7ezd2prognz75zztools_prognz00(obj_t);
static obj_t BGl__expandzd2withzd2accessz00zzexpand_objectz00(obj_t, obj_t, obj_t);
static obj_t BGl_makezd2withzd2accesszd2bodyzd2zzexpand_objectz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zzexpand_objectz00();
static obj_t BGl__expandzd2instantiatezd2zzexpand_objectz00(obj_t, obj_t, obj_t);
static obj_t BGl_zc3anonymousza32803ze3z83zzexpand_objectz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern long bgl_list_length(obj_t);
extern obj_t open_input_string(obj_t);
static obj_t BGl_classzd2splitzd2slotsz00zzexpand_objectz00(obj_t, BgL_typez00_bglt, obj_t);
static obj_t BGl_findzd2slotzd2offsetz00zzexpand_objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_duplicatezd2ze3makez31zzexpand_objectz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00(obj_t);
extern obj_t BGl_mapz00zz__r4_control_features_6_9z00(obj_t, obj_t);
static obj_t BGl_zc3anonymousza31862ze3z83zzexpand_objectz00(obj_t);
extern obj_t BGl_readz00zz__readerz00(obj_t);
extern bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
extern obj_t string_append(obj_t, obj_t);
extern obj_t make_vector(int, obj_t);
static obj_t BGl_makezd2wideningzd2zzexpand_objectz00(obj_t, BgL_typez00_bglt, obj_t, obj_t);
extern obj_t BGl_tclassz00zzobject_classz00;
extern obj_t BGl_expandzd2cozd2instantiatez00zzexpand_objectz00(obj_t, obj_t);
extern obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
extern bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
extern obj_t string_to_bstring(char *);
extern bool_t BGl_slotzd2virtualzf3z21zzobject_slotsz00(BgL_slotz00_bglt);
extern obj_t BGl_za2unsafezd2typeza2zd2zzengine_paramz00;
static obj_t BGl__expandzd2duplicatezd2zzexpand_objectz00(obj_t, obj_t, obj_t);
static obj_t BGl__expandzd2shrinkz12zc0zzexpand_objectz00(obj_t, obj_t, obj_t);
extern obj_t BGl_gensymz00zz__r4_symbols_6_4z00;
extern BgL_typez00_bglt BGl_typezd2ofzd2idz00zzast_identz00(obj_t, obj_t);
extern obj_t BGl_expandzd2duplicatezd2zzexpand_objectz00(obj_t, obj_t);
extern obj_t BGl_putpropz12z12zz__r4_symbols_6_4z00(obj_t, obj_t, obj_t);
extern obj_t BGl_findzd2locationzd2zztools_locationz00(obj_t);
extern obj_t BGl_getpropz00zz__r4_symbols_6_4z00(obj_t, obj_t);
static obj_t BGl_makezd2indexedzd2bodyz00zzexpand_objectz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_loopz00zzexpand_objectz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_replacez12z12zztools_miscz00(obj_t, obj_t);
static obj_t BGl__expandzd2widenz12zc0zzexpand_objectz00(obj_t, obj_t, obj_t);
static obj_t BGl_makezd2virtualzd2setz00zzexpand_objectz00(obj_t, obj_t, obj_t, obj_t, obj_t, char *);
extern obj_t BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(obj_t);
extern obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
extern obj_t BGl_tclasszd2allzd2slotsz00zzobject_classz00(BgL_tclassz00_bglt);
static obj_t BGl_makezd2azd2shrinkz12z12zzexpand_objectz00(obj_t, obj_t);
extern obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
static obj_t BGl_instantiatezd2ze3fillz31zzexpand_objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zzexpand_objectz00();
static obj_t BGl_zc3anonymousza32418ze3z83zzexpand_objectz00(obj_t, obj_t);
static obj_t BGl_cozd2instantiatezd2ze3letze3zzexpand_objectz00(obj_t, obj_t, obj_t, obj_t);
extern bool_t BGl_slotzd2defaultzf3z21zzobject_slotsz00(BgL_slotz00_bglt);
static obj_t BGl_zc3anonymousza31894ze3z83zzexpand_objectz00(obj_t);
extern obj_t BGl_displayzd22zd2zz__r4_output_6_10_3z00(obj_t, obj_t);
extern obj_t BGl_expandzd2widenz12zc0zzexpand_objectz00(obj_t, obj_t);
extern obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zzexpand_objectz00();
extern obj_t BGl_makezd2privatezd2sexpz00zzast_privatez00(obj_t, obj_t, obj_t);
static obj_t BGl_withzd2accesszd2expanderz00zzexpand_objectz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zzexpand_objectz00 = BUNSPEC;
extern obj_t BGl_expandzd2withzd2accessz00zzexpand_objectz00(obj_t, obj_t);
static obj_t BGl__expandzd2cozd2instantiatez00zzexpand_objectz00(obj_t, obj_t, obj_t);
extern obj_t BGl_findzd2locationzf2locz20zztools_locationz00(obj_t, obj_t);
static obj_t BGl_zc3anonymousza32284ze3z83zzexpand_objectz00(obj_t, obj_t, obj_t);
extern obj_t BGl_expandzd2shrinkz12zc0zzexpand_objectz00(obj_t, obj_t);
extern obj_t BGl_expandzd2instantiatezd2zzexpand_objectz00(obj_t, obj_t);
extern obj_t BGl_lexicalzd2stackzd2zzexpand_epsz00();
static obj_t BGl_e1z00zzexpand_objectz00(obj_t, obj_t, obj_t);
extern obj_t BGl_parsezd2idzd2zzast_identz00(obj_t, obj_t);
static obj_t BGl_objectzd2epairifyzd2zzexpand_objectz00(obj_t, obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zzexpand_objectz00();
extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
extern obj_t BGl_withzd2lexicalzd2zzexpand_epsz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_instantiatezd2ze3makez31zzexpand_objectz00(obj_t, BgL_typez00_bglt, obj_t);
extern obj_t bgl_list_ref(obj_t, long);
extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
extern obj_t string_append_3(obj_t, obj_t, obj_t);
static obj_t __cnst[ 41 ] ;

DEFINE_EXPORT_PROCEDURE( BGl_expandzd2widenz12zd2envz12zzexpand_objectz00, BgL_bgl__expandza7d2widenza712za7c0za7za7expand_objectza7004903z00, BGl__expandzd2widenz12zc0zzexpand_objectz00, 0L, 2 );
DEFINE_STRING( BGl_string4871z00zzexpand_objectz00, BgL_bgl_string4871za700za7za7expand_objectza7004904z00, "object? o error object-class class-super eq? shrink! object-widening if object-mark-producer! class-num __object object-class-num-set! @ object-widening-set! cast obj let* nothing duplicated ! fill- begin allocate- instantiate co-instantiate ok done new make- set! value -set! labels index -len - -ref let with-access instance ", 327 );
DEFINE_STRING( BGl_string4870z00zzexpand_objectz00, BgL_bgl_string4870za700za7za7expand_objectza7004905z00, "' form (unknown slot ", 21 );
DEFINE_STRING( BGl_string4869z00zzexpand_objectz00, BgL_bgl_string4869za700za7za7expand_objectza7004906z00, "Illegal `", 9 );
DEFINE_STRING( BGl_string4868z00zzexpand_objectz00, BgL_bgl_string4868za700za7za7expand_objectza7004907z00, "' form (read-only slot ", 23 );
DEFINE_STRING( BGl_string4867z00zzexpand_objectz00, BgL_bgl_string4867za700za7za7expand_objectza7004908z00, "shrink!", 7 );
DEFINE_STRING( BGl_string4866z00zzexpand_objectz00, BgL_bgl_string4866za700za7za7expand_objectza7004909z00, "Not a wide object", 17 );
DEFINE_STRING( BGl_string4865z00zzexpand_objectz00, BgL_bgl_string4865za700za7za7expand_objectza7004910z00, "Illegal `shrink!' form", 22 );
DEFINE_STRING( BGl_string4864z00zzexpand_objectz00, BgL_bgl_string4864za700za7za7expand_objectza7004911z00, "This object can't be widened to the wanted class", 48 );
DEFINE_STRING( BGl_string4863z00zzexpand_objectz00, BgL_bgl_string4863za700za7za7expand_objectza7004912z00, "Illegal `widening!' form (missing arguments for slot ", 53 );
DEFINE_STRING( BGl_string4862z00zzexpand_objectz00, BgL_bgl_string4862za700za7za7expand_objectza7004913z00, "widen!", 6 );
DEFINE_STRING( BGl_string4861z00zzexpand_objectz00, BgL_bgl_string4861za700za7za7expand_objectza7004914z00, "Illegal `widen!' form", 21 );
DEFINE_STRING( BGl_string4860z00zzexpand_objectz00, BgL_bgl_string4860za700za7za7expand_objectza7004915z00, "widen!:Illegal class type:", 26 );
DEFINE_STRING( BGl_string4859z00zzexpand_objectz00, BgL_bgl_string4859za700za7za7expand_objectza7004916z00, "duplicate", 9 );
DEFINE_STRING( BGl_string4858z00zzexpand_objectz00, BgL_bgl_string4858za700za7za7expand_objectza7004917z00, "Illegal `duplicate' form", 24 );
DEFINE_STRING( BGl_string4857z00zzexpand_objectz00, BgL_bgl_string4857za700za7za7expand_objectza7004918z00, "duplicate:Illegal class type:", 29 );
DEFINE_STRING( BGl_string4856z00zzexpand_objectz00, BgL_bgl_string4856za700za7za7expand_objectza7004919z00, "Abstract classes can't be duplicated", 36 );
DEFINE_STRING( BGl_string4855z00zzexpand_objectz00, BgL_bgl_string4855za700za7za7expand_objectza7004920z00, "co-instantiate:Illegal binding", 30 );
DEFINE_STRING( BGl_string4854z00zzexpand_objectz00, BgL_bgl_string4854za700za7za7expand_objectza7004921z00, "co-instantiate:Illegal class", 28 );
DEFINE_STRING( BGl_string4853z00zzexpand_objectz00, BgL_bgl_string4853za700za7za7expand_objectza7004922z00, "co-instantiate:Abstract classes can't be instantiated", 53 );
DEFINE_STRING( BGl_string4852z00zzexpand_objectz00, BgL_bgl_string4852za700za7za7expand_objectza7004923z00, "Illegal `co-instantiate' form", 29 );
DEFINE_STRING( BGl_string4851z00zzexpand_objectz00, BgL_bgl_string4851za700za7za7expand_objectza7004924z00, ")", 1 );
DEFINE_STRING( BGl_string4850z00zzexpand_objectz00, BgL_bgl_string4850za700za7za7expand_objectza7004925z00, "Illegal `instantiate' form (missing arguments for slot ", 55 );
DEFINE_STRING( BGl_string4849z00zzexpand_objectz00, BgL_bgl_string4849za700za7za7expand_objectza7004926z00, "instantiate", 11 );
DEFINE_STRING( BGl_string4848z00zzexpand_objectz00, BgL_bgl_string4848za700za7za7expand_objectza7004927z00, "Illegal `instantiate' form", 26 );
DEFINE_STRING( BGl_string4847z00zzexpand_objectz00, BgL_bgl_string4847za700za7za7expand_objectza7004928z00, "Abstract classes can't be instantiated", 38 );
DEFINE_STRING( BGl_string4846z00zzexpand_objectz00, BgL_bgl_string4846za700za7za7expand_objectza7004929z00, "Illegal `with-access' form. Unknown slot `", 42 );
DEFINE_STRING( BGl_string4845z00zzexpand_objectz00, BgL_bgl_string4845za700za7za7expand_objectza7004930z00, "Illegal `with-access' form", 26 );
DEFINE_STRING( BGl_string4844z00zzexpand_objectz00, BgL_bgl_string4844za700za7za7expand_objectza7004931z00, "'", 1 );
DEFINE_STRING( BGl_string4843z00zzexpand_objectz00, BgL_bgl_string4843za700za7za7expand_objectza7004932z00, "Illegal `with-access' form. Illegal slot identifier `", 53 );
DEFINE_EXPORT_PROCEDURE( BGl_expandzd2shrinkz12zd2envz12zzexpand_objectz00, BgL_bgl__expandza7d2shrinkza712za7c0za7za7expand_objectza7004933z00, BGl__expandzd2shrinkz12zc0zzexpand_objectz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_expandzd2instantiatezd2envz00zzexpand_objectz00, BgL_bgl__expandza7d2instantiateza7d2za7za7expand_objectza7004934za7, BGl__expandzd2instantiatezd2zzexpand_objectz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_expandzd2duplicatezd2envz00zzexpand_objectz00, BgL_bgl__expandza7d2duplicateza7d2za7za7expand_objectza7004935za7, BGl__expandzd2duplicatezd2zzexpand_objectz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_expandzd2cozd2instantiatezd2envzd2zzexpand_objectz00, BgL_bgl__expandza7d2coza7d2instantiateza700za7za7expand_objectza7004936z00, BGl__expandzd2cozd2instantiatez00zzexpand_objectz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_expandzd2withzd2accesszd2envzd2zzexpand_objectz00, BgL_bgl__expandza7d2withza7d2accessza700za7za7expand_objectza7004937z00, BGl__expandzd2withzd2accessz00zzexpand_objectz00, 0L, 2 );



/* module-initialization */
obj_t BGl_modulezd2initializa7ationz75zzexpand_objectz00(long BgL_checksumz00_2972, char * BgL_fromz00_2973)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzexpand_objectz00))
{ 
BGl_requirezd2initializa7ationz75zzexpand_objectz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzexpand_objectz00(); 
BGl_cnstzd2initzd2zzexpand_objectz00(); 
BGl_importedzd2moduleszd2initz00zzexpand_objectz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzexpand_objectz00()
{ AN_OBJECT;
{ /* Expand/object.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "expand_object"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "expand_object"); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)0), "expand_object"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "expand_object"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "expand_object"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "expand_object"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "expand_object"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "expand_object"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "expand_object"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzexpand_objectz00()
{ AN_OBJECT;
{ /* Expand/object.scm 15 */
{ /* Expand/object.scm 15 */
obj_t BgL_cportz00_2965;
BgL_cportz00_2965 = 
open_input_string(BGl_string4871z00zzexpand_objectz00); 
{ 
long BgL_iz00_2966;
BgL_iz00_2966 = ((long)40); 
BgL_loopz00_2967:
if(
(BgL_iz00_2966==((long)-1)))
{ /* Expand/object.scm 15 */
return BUNSPEC;}  else 
{ /* Expand/object.scm 15 */
{ /* Expand/object.scm 15 */
obj_t BgL_arg4875z00_2969;
{ /* Expand/object.scm 15 */
obj_t BgL_list4878z00_2970;
BgL_list4878z00_2970 = 
MAKE_PAIR(BgL_cportz00_2965, BNIL); 
BgL_arg4875z00_2969 = 
BGl_readz00zz__readerz00(BgL_list4878z00_2970); } 
{ /* Expand/object.scm 15 */
int BgL_auxz00_2994;
BgL_auxz00_2994 = 
(int)(BgL_iz00_2966); 
CNST_TABLE_SET(BgL_auxz00_2994, BgL_arg4875z00_2969); } } 
{ 
long BgL_iz00_2997;
{ /* Expand/object.scm 15 */
int BgL_auxz00_2998;
{ /* Expand/object.scm 15 */
long BgL_auxz00_2999;
BgL_auxz00_2999 = 
(BgL_iz00_2966-((long)1)); 
BgL_auxz00_2998 = 
(int)(BgL_auxz00_2999); } 
BgL_iz00_2997 = 
(long)(BgL_auxz00_2998); } 
BgL_iz00_2966 = BgL_iz00_2997; 
goto BgL_loopz00_2967;} } } } } 
}



/* expand-with-access */
obj_t BGl_expandzd2withzd2accessz00zzexpand_objectz00(obj_t BgL_xz00_1, obj_t BgL_ez00_2)
{ AN_OBJECT;
{ /* Expand/object.scm 39 */
{ 
obj_t BgL_withzd2accesszd2_691;obj_t BgL_instancez00_692;obj_t BgL_slotsz00_693;obj_t BgL_bodyz00_694;
if(
PAIRP(BgL_xz00_1))
{ /* Expand/object.scm 40 */
obj_t BgL_cdrzd2113zd2_699;
BgL_cdrzd2113zd2_699 = 
CDR(BgL_xz00_1); 
if(
PAIRP(BgL_cdrzd2113zd2_699))
{ /* Expand/object.scm 40 */
obj_t BgL_cdrzd2119zd2_701;
BgL_cdrzd2119zd2_701 = 
CDR(BgL_cdrzd2113zd2_699); 
if(
PAIRP(BgL_cdrzd2119zd2_701))
{ /* Expand/object.scm 40 */
obj_t BgL_carzd2123zd2_703;obj_t BgL_cdrzd2124zd2_704;
BgL_carzd2123zd2_703 = 
CAR(BgL_cdrzd2119zd2_701); 
BgL_cdrzd2124zd2_704 = 
CDR(BgL_cdrzd2119zd2_701); 
if(
PAIRP(BgL_carzd2123zd2_703))
{ /* Expand/object.scm 40 */
if(
PAIRP(BgL_cdrzd2124zd2_704))
{ /* Expand/object.scm 40 */
BgL_withzd2accesszd2_691 = 
CAR(BgL_xz00_1); 
BgL_instancez00_692 = 
CAR(BgL_cdrzd2113zd2_699); 
BgL_slotsz00_693 = BgL_carzd2123zd2_703; 
BgL_bodyz00_694 = BgL_cdrzd2124zd2_704; 
{ /* Expand/object.scm 42 */
obj_t BgL_locz00_709;
BgL_locz00_709 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_xz00_1); 
{ /* Expand/object.scm 42 */
BgL_typez00_bglt BgL_classz00_710;
BgL_classz00_710 = 
BGl_typezd2ofzd2idz00zzast_identz00(BgL_withzd2accesszd2_691, BgL_locz00_709); 
{ /* Expand/object.scm 43 */

{ /* Expand/object.scm 45 */
bool_t BgL_test1849z00_711;
BgL_test1849z00_711 = 
BGl_iszd2azf3z21zz__objectz00(
(obj_t)(BgL_classz00_710), BGl_tclassz00zzobject_classz00); 
if(BgL_test1849z00_711)
{ /* Expand/object.scm 45 */
{ 
obj_t BgL_sz00_712;
BgL_sz00_712 = BgL_slotsz00_693; 
BgL_loopz00_713:
if(
NULLP(BgL_sz00_712))
{ /* Expand/object.scm 50 */
{ /* Expand/object.scm 51 */
obj_t BgL_auxz00_715;
{ /* Expand/object.scm 51 */
obj_t BgL_arg1870z00_727;
BgL_arg1870z00_727 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)0)), BEOA); 
BgL_auxz00_715 = 
BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(BgL_arg1870z00_727); } 
{ /* Expand/object.scm 52 */
obj_t BgL_instancez00_717;
BgL_instancez00_717 = 
PROCEDURE_ENTRY(BgL_ez00_2)(BgL_ez00_2, BgL_instancez00_692, BgL_ez00_2, BEOA); 
{ /* Expand/object.scm 53 */
obj_t BgL_classzd2idzd2_718;
BgL_classzd2idzd2_718 = 
(((BgL_typez00_bglt)CREF(BgL_classz00_710))->BgL_idz00); 
{ /* Expand/object.scm 54 */

{ /* Expand/object.scm 55 */
obj_t BgL_directz00_719;
BgL_directz00_719 = 
BGl_classzd2splitzd2slotsz00zzexpand_objectz00(BgL_xz00_1, BgL_classz00_710, BgL_slotsz00_693); 
{ /* Expand/object.scm 57 */
obj_t BgL_indexedz00_720;
{ /* Expand/object.scm 57 */
int BgL_auxz00_3032;
BgL_auxz00_3032 = 
(int)(((long)1)); 
BgL_indexedz00_720 = 
BGL_GET_MVALUES_VAL(BgL_auxz00_3032); } 
{ /* Expand/object.scm 61 */
obj_t BgL_arg1854z00_721;
{ /* Expand/object.scm 61 */
obj_t BgL_arg1857z00_722;
BgL_arg1857z00_722 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_xz00_1); 
{ /* Expand/object.scm 63 */
obj_t BgL_zc3anonymousza31862ze3z83_2886;
{ 
int BgL_auxz00_3038;int BgL_auxz00_3036;
BgL_auxz00_3038 = 
(int)(((long)8)); 
BgL_auxz00_3036 = 
(int)(((long)0)); 
BgL_zc3anonymousza31862ze3z83_2886 = 
make_fx_procedure(BGl_zc3anonymousza31862ze3z83zzexpand_objectz00, BgL_auxz00_3036, BgL_auxz00_3038); } 
{ /* Expand/object.scm 63 */
int BgL_auxz00_3041;
BgL_auxz00_3041 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31862ze3z83_2886, BgL_auxz00_3041, BgL_ez00_2); } 
{ /* Expand/object.scm 63 */
int BgL_auxz00_3044;
BgL_auxz00_3044 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_zc3anonymousza31862ze3z83_2886, BgL_auxz00_3044, BgL_auxz00_715); } 
{ /* Expand/object.scm 63 */
int BgL_auxz00_3047;
BgL_auxz00_3047 = 
(int)(((long)2)); 
PROCEDURE_SET(BgL_zc3anonymousza31862ze3z83_2886, BgL_auxz00_3047, BgL_auxz00_715); } 
{ /* Expand/object.scm 63 */
int BgL_auxz00_3050;
BgL_auxz00_3050 = 
(int)(((long)3)); 
PROCEDURE_SET(BgL_zc3anonymousza31862ze3z83_2886, BgL_auxz00_3050, BgL_classzd2idzd2_718); } 
{ /* Expand/object.scm 63 */
int BgL_auxz00_3053;
BgL_auxz00_3053 = 
(int)(((long)4)); 
PROCEDURE_SET(BgL_zc3anonymousza31862ze3z83_2886, BgL_auxz00_3053, BgL_directz00_719); } 
{ /* Expand/object.scm 63 */
int BgL_auxz00_3056;
BgL_auxz00_3056 = 
(int)(((long)5)); 
PROCEDURE_SET(BgL_zc3anonymousza31862ze3z83_2886, BgL_auxz00_3056, BgL_instancez00_717); } 
{ /* Expand/object.scm 63 */
int BgL_auxz00_3059;
BgL_auxz00_3059 = 
(int)(((long)6)); 
PROCEDURE_SET(BgL_zc3anonymousza31862ze3z83_2886, BgL_auxz00_3059, BgL_indexedz00_720); } 
{ /* Expand/object.scm 63 */
int BgL_auxz00_3062;
BgL_auxz00_3062 = 
(int)(((long)7)); 
PROCEDURE_SET(BgL_zc3anonymousza31862ze3z83_2886, BgL_auxz00_3062, BgL_bodyz00_694); } 
BgL_arg1854z00_721 = 
BGl_withzd2lexicalzd2zzexpand_epsz00(BgL_slotsz00_693, BgL_auxz00_715, BgL_arg1857z00_722, BgL_zc3anonymousza31862ze3z83_2886); } } 
return 
BGl_replacez12z12zztools_miscz00(BgL_xz00_1, BgL_arg1854z00_721);} } } } } } } }  else 
{ /* Expand/object.scm 50 */
if(
PAIRP(BgL_sz00_712))
{ /* Expand/object.scm 77 */
bool_t BgL_testz00_3069;
{ /* Expand/object.scm 77 */
obj_t BgL_auxz00_3070;
BgL_auxz00_3070 = 
CAR(BgL_sz00_712); 
BgL_testz00_3069 = 
SYMBOLP(BgL_auxz00_3070); } 
if(BgL_testz00_3069)
{ /* Expand/object.scm 77 */
{ 
obj_t BgL_sz00_3073;
BgL_sz00_3073 = 
CDR(BgL_sz00_712); 
BgL_sz00_712 = BgL_sz00_3073; 
goto BgL_loopz00_713;} }  else 
{ /* Expand/object.scm 77 */
{ /* Expand/object.scm 81 */
obj_t BgL_arg1880z00_731;
{ /* Expand/object.scm 81 */
obj_t BgL_arg1888z00_733;
{ /* Expand/object.scm 84 */
obj_t BgL_zc3anonymousza31894ze3z83_2887;
{ 
int BgL_auxz00_3077;int BgL_auxz00_3075;
BgL_auxz00_3077 = 
(int)(((long)1)); 
BgL_auxz00_3075 = 
(int)(((long)0)); 
BgL_zc3anonymousza31894ze3z83_2887 = 
make_fx_procedure(BGl_zc3anonymousza31894ze3z83zzexpand_objectz00, BgL_auxz00_3075, BgL_auxz00_3077); } 
{ /* Expand/object.scm 84 */
int BgL_auxz00_3080;
BgL_auxz00_3080 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31894ze3z83_2887, BgL_auxz00_3080, BgL_sz00_712); } 
BgL_arg1888z00_733 = 
BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00(BgL_zc3anonymousza31894ze3z83_2887); } 
BgL_arg1880z00_731 = 
string_append_3(BGl_string4843z00zzexpand_objectz00, BgL_arg1888z00_733, BGl_string4844z00zzexpand_objectz00); } 
FAILURE(BFALSE,BgL_arg1880z00_731,BgL_xz00_1);} } }  else 
{ /* Expand/object.scm 75 */
FAILURE(BFALSE,BGl_string4845z00zzexpand_objectz00,BgL_xz00_1);} } } }  else 
{ /* Expand/object.scm 45 */
FAILURE(BFALSE,BGl_string4845z00zzexpand_objectz00,BgL_xz00_1);} } } } } }  else 
{ /* Expand/object.scm 40 */
BgL_tagzd2102zd2_696:
FAILURE(BFALSE,BGl_string4845z00zzexpand_objectz00,BgL_xz00_1);} }  else 
{ /* Expand/object.scm 40 */
goto BgL_tagzd2102zd2_696;} }  else 
{ /* Expand/object.scm 40 */
goto BgL_tagzd2102zd2_696;} }  else 
{ /* Expand/object.scm 40 */
goto BgL_tagzd2102zd2_696;} }  else 
{ /* Expand/object.scm 40 */
goto BgL_tagzd2102zd2_696;} } } 
}



/* _expand-with-access */
obj_t BGl__expandzd2withzd2accessz00zzexpand_objectz00(obj_t BgL_envz00_2888, obj_t BgL_xz00_2889, obj_t BgL_ez00_2890)
{ AN_OBJECT;
{ /* Expand/object.scm 39 */
return 
BGl_expandzd2withzd2accessz00zzexpand_objectz00(BgL_xz00_2889, BgL_ez00_2890);} 
}



/* <anonymous:1862> */
obj_t BGl_zc3anonymousza31862ze3z83zzexpand_objectz00(obj_t BgL_envz00_2891)
{ AN_OBJECT;
{ /* Expand/object.scm 62 */
{ /* Expand/object.scm 63 */
obj_t BgL_ez00_2892;obj_t BgL_markz00_2893;obj_t BgL_auxz00_2894;obj_t BgL_classzd2idzd2_2895;obj_t BgL_directz00_2896;obj_t BgL_instancez00_2897;obj_t BgL_indexedz00_2898;obj_t BgL_bodyz00_2899;
{ /* Expand/object.scm 63 */
int BgL_auxz00_3092;
BgL_auxz00_3092 = 
(int)(((long)0)); 
BgL_ez00_2892 = 
PROCEDURE_REF(BgL_envz00_2891, BgL_auxz00_3092); } 
{ /* Expand/object.scm 63 */
int BgL_auxz00_3095;
BgL_auxz00_3095 = 
(int)(((long)1)); 
BgL_markz00_2893 = 
PROCEDURE_REF(BgL_envz00_2891, BgL_auxz00_3095); } 
{ /* Expand/object.scm 63 */
int BgL_auxz00_3098;
BgL_auxz00_3098 = 
(int)(((long)2)); 
BgL_auxz00_2894 = 
PROCEDURE_REF(BgL_envz00_2891, BgL_auxz00_3098); } 
{ /* Expand/object.scm 63 */
int BgL_auxz00_3101;
BgL_auxz00_3101 = 
(int)(((long)3)); 
BgL_classzd2idzd2_2895 = 
PROCEDURE_REF(BgL_envz00_2891, BgL_auxz00_3101); } 
{ /* Expand/object.scm 63 */
int BgL_auxz00_3104;
BgL_auxz00_3104 = 
(int)(((long)4)); 
BgL_directz00_2896 = 
PROCEDURE_REF(BgL_envz00_2891, BgL_auxz00_3104); } 
{ /* Expand/object.scm 63 */
int BgL_auxz00_3107;
BgL_auxz00_3107 = 
(int)(((long)5)); 
BgL_instancez00_2897 = 
PROCEDURE_REF(BgL_envz00_2891, BgL_auxz00_3107); } 
{ /* Expand/object.scm 63 */
int BgL_auxz00_3110;
BgL_auxz00_3110 = 
(int)(((long)6)); 
BgL_indexedz00_2898 = 
PROCEDURE_REF(BgL_envz00_2891, BgL_auxz00_3110); } 
{ /* Expand/object.scm 63 */
int BgL_auxz00_3113;
BgL_auxz00_3113 = 
(int)(((long)7)); 
BgL_bodyz00_2899 = 
PROCEDURE_REF(BgL_envz00_2891, BgL_auxz00_3113); } 
{ 

{ /* Expand/object.scm 63 */
obj_t BgL_ez00_725;
BgL_ez00_725 = 
BGl_withzd2accesszd2expanderz00zzexpand_objectz00(BgL_ez00_2892, BgL_markz00_2893, BgL_auxz00_2894, BgL_classzd2idzd2_2895, BgL_directz00_2896); 
return 
BGl_makezd2withzd2accesszd2bodyzd2zzexpand_objectz00(BgL_auxz00_2894, BgL_instancez00_2897, BgL_classzd2idzd2_2895, BgL_indexedz00_2898, BgL_bodyz00_2899, BgL_ez00_725);} } } } 
}



/* <anonymous:1894> */
obj_t BGl_zc3anonymousza31894ze3z83zzexpand_objectz00(obj_t BgL_envz00_2900)
{ AN_OBJECT;
{ /* Expand/object.scm 84 */
{ /* Expand/object.scm 84 */
obj_t BgL_sz00_2901;
{ /* Expand/object.scm 84 */
int BgL_auxz00_3118;
BgL_auxz00_3118 = 
(int)(((long)0)); 
BgL_sz00_2901 = 
PROCEDURE_REF(BgL_envz00_2900, BgL_auxz00_3118); } 
{ 

{ /* Expand/object.scm 84 */
obj_t BgL_arg1896z00_737;obj_t BgL_arg1897z00_738;
BgL_arg1896z00_737 = 
CAR(BgL_sz00_2901); 
BgL_arg1897z00_738 = 
GET_CURRENT_OUTPUT_PORT(); 
return 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg1896z00_737, BgL_arg1897z00_738);} } } } 
}



/* class-split-slots */
obj_t BGl_classzd2splitzd2slotsz00zzexpand_objectz00(obj_t BgL_xz00_3, BgL_typez00_bglt BgL_classz00_4, obj_t BgL_slotsz00_5)
{ AN_OBJECT;
{ /* Expand/object.scm 96 */
{ /* Expand/object.scm 97 */
obj_t BgL_markz00_741;
BgL_markz00_741 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)1)), BEOA); 
{ 
obj_t BgL_l1808z00_742;
{ /* Expand/object.scm 101 */
obj_t BgL_arg1914z00_744;
BgL_arg1914z00_744 = 
BGl_tclasszd2allzd2slotsz00zzobject_classz00(
(BgL_tclassz00_bglt)(BgL_classz00_4)); 
BgL_l1808z00_742 = BgL_arg1914z00_744; 
BgL_lname1809z00_743:
if(
PAIRP(BgL_l1808z00_742))
{ /* Expand/object.scm 98 */
{ /* Expand/object.scm 99 */
obj_t BgL_slotz00_746;
BgL_slotz00_746 = 
CAR(BgL_l1808z00_742); 
{ /* Expand/object.scm 100 */
obj_t BgL_auxz00_3132;
{ /* Expand/object.scm 100 */
BgL_slotz00_bglt BgL_obj1747z00_2141;
BgL_obj1747z00_2141 = 
(BgL_slotz00_bglt)(BgL_slotz00_746); 
BgL_auxz00_3132 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1747z00_2141))->BgL_idz00); } 
BGl_putpropz12z12zz__r4_symbols_6_4z00(BgL_auxz00_3132, BgL_markz00_741, BgL_slotz00_746); } } 
{ 
obj_t BgL_l1808z00_3136;
BgL_l1808z00_3136 = 
CDR(BgL_l1808z00_742); 
BgL_l1808z00_742 = BgL_l1808z00_3136; 
goto BgL_lname1809z00_743;} }  else 
{ /* Expand/object.scm 98 */((bool_t)1); } } } 
{ 
obj_t BgL_slotsz00_750;obj_t BgL_directz00_751;obj_t BgL_indexedz00_752;
BgL_slotsz00_750 = BgL_slotsz00_5; 
BgL_directz00_751 = BNIL; 
BgL_indexedz00_752 = BNIL; 
BgL_loopz00_753:
if(
NULLP(BgL_slotsz00_750))
{ /* Expand/object.scm 105 */
{ /* Expand/object.scm 106 */
int BgL_auxz00_3140;
BgL_auxz00_3140 = 
(int)(((long)2)); 
BGL_SET_MVALUES_NUMBER(BgL_auxz00_3140); } 
{ /* Expand/object.scm 106 */
int BgL_auxz00_3143;
BgL_auxz00_3143 = 
(int)(((long)1)); 
BGL_SET_MVALUES_VAL(BgL_auxz00_3143, BgL_indexedz00_752); } 
return BgL_directz00_751;}  else 
{ /* Expand/object.scm 107 */
obj_t BgL_slotz00_757;
BgL_slotz00_757 = 
BGl_getpropz00zz__r4_symbols_6_4z00(
CAR(BgL_slotsz00_750), BgL_markz00_741); 
{ /* Expand/object.scm 108 */
bool_t BgL_test1934z00_758;
BgL_test1934z00_758 = 
BGl_iszd2azf3z21zz__objectz00(BgL_slotz00_757, BGl_slotz00zzobject_slotsz00); 
if(BgL_test1934z00_758)
{ /* Expand/object.scm 115 */
bool_t BgL_testz00_3150;
{ /* Expand/object.scm 115 */
BgL_slotz00_bglt BgL_obj1764z00_2149;
BgL_obj1764z00_2149 = 
(BgL_slotz00_bglt)(BgL_slotz00_757); 
{ /* Expand/object.scm 115 */
obj_t BgL_auxz00_3152;
BgL_auxz00_3152 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1764z00_2149))->BgL_indexedz00); 
BgL_testz00_3150 = 
CBOOL(BgL_auxz00_3152); } } 
if(BgL_testz00_3150)
{ /* Expand/object.scm 116 */
obj_t BgL_arg1937z00_760;obj_t BgL_arg1939z00_761;
BgL_arg1937z00_760 = 
CDR(BgL_slotsz00_750); 
BgL_arg1939z00_761 = 
MAKE_PAIR(BgL_slotz00_757, BgL_indexedz00_752); 
{ 
obj_t BgL_indexedz00_3158;obj_t BgL_slotsz00_3157;
BgL_slotsz00_3157 = BgL_arg1937z00_760; 
BgL_indexedz00_3158 = BgL_arg1939z00_761; 
BgL_indexedz00_752 = BgL_indexedz00_3158; 
BgL_slotsz00_750 = BgL_slotsz00_3157; 
goto BgL_loopz00_753;} }  else 
{ /* Expand/object.scm 119 */
obj_t BgL_arg1944z00_762;obj_t BgL_arg1945z00_763;
BgL_arg1944z00_762 = 
CDR(BgL_slotsz00_750); 
{ /* Expand/object.scm 120 */
obj_t BgL_auxz00_3160;
BgL_auxz00_3160 = 
CAR(BgL_slotsz00_750); 
BgL_arg1945z00_763 = 
MAKE_PAIR(BgL_auxz00_3160, BgL_directz00_751); } 
{ 
obj_t BgL_directz00_3164;obj_t BgL_slotsz00_3163;
BgL_slotsz00_3163 = BgL_arg1944z00_762; 
BgL_directz00_3164 = BgL_arg1945z00_763; 
BgL_directz00_751 = BgL_directz00_3164; 
BgL_slotsz00_750 = BgL_slotsz00_3163; 
goto BgL_loopz00_753;} } }  else 
{ /* Expand/object.scm 110 */
obj_t BgL_arg1954z00_765;
{ /* Expand/object.scm 110 */
obj_t BgL_arg1958z00_767;
{ /* Expand/object.scm 112 */
obj_t BgL_auxz00_3165;
BgL_auxz00_3165 = 
CAR(BgL_slotsz00_750); 
BgL_arg1958z00_767 = 
SYMBOL_TO_STRING(BgL_auxz00_3165); } 
BgL_arg1954z00_765 = 
string_append_3(BGl_string4846z00zzexpand_objectz00, BgL_arg1958z00_767, BGl_string4844z00zzexpand_objectz00); } 
FAILURE(BFALSE,BgL_arg1954z00_765,BgL_xz00_3);} } } } } } 
}



/* make-with-access-body */
obj_t BGl_makezd2withzd2accesszd2bodyzd2zzexpand_objectz00(obj_t BgL_auxz00_6, obj_t BgL_instancez00_7, obj_t BgL_classzd2idzd2_8, obj_t BgL_indexedz00_9, obj_t BgL_bodyz00_10, obj_t BgL_ez00_11)
{ AN_OBJECT;
{ /* Expand/object.scm 126 */
{ /* Expand/object.scm 156 */
obj_t BgL_arg1973z00_772;obj_t BgL_arg1974z00_773;
BgL_arg1973z00_772 = 
CNST_TABLE_REF(((long)2)); 
{ /* Expand/object.scm 156 */
obj_t BgL_arg1977z00_774;obj_t BgL_arg1978z00_775;
{ /* Expand/object.scm 156 */
obj_t BgL_arg1981z00_776;
{ /* Expand/object.scm 156 */
obj_t BgL_arg1985z00_778;
BgL_arg1985z00_778 = 
MAKE_PAIR(BgL_instancez00_7, BNIL); 
BgL_arg1981z00_776 = 
MAKE_PAIR(BgL_auxz00_6, BgL_arg1985z00_778); } 
BgL_arg1977z00_774 = 
MAKE_PAIR(BgL_arg1981z00_776, BNIL); } 
{ /* Expand/object.scm 157 */
obj_t BgL_arg1989z00_779;
BgL_arg1989z00_779 = 
BGl_makezd2indexedzd2bodyz00zzexpand_objectz00(BgL_indexedz00_9, BgL_ez00_11, BgL_bodyz00_10, BgL_auxz00_6, BgL_classzd2idzd2_8); 
BgL_arg1978z00_775 = 
MAKE_PAIR(BgL_arg1989z00_779, BNIL); } 
BgL_arg1974z00_773 = 
MAKE_PAIR(BgL_arg1977z00_774, BgL_arg1978z00_775); } 
return 
MAKE_PAIR(BgL_arg1973z00_772, BgL_arg1974z00_773);} } 
}



/* loop */
obj_t BGl_loopz00zzexpand_objectz00(obj_t BgL_ez00_2954, obj_t BgL_bodyz00_2953, obj_t BgL_auxz00_2952, obj_t BgL_classzd2idzd2_2951, obj_t BgL_indexedz00_782)
{ AN_OBJECT;
{ /* Expand/object.scm 128 */
if(
NULLP(BgL_indexedz00_782))
{ /* Expand/object.scm 130 */
{ /* Expand/object.scm 131 */
obj_t BgL_arg1997z00_785;
BgL_arg1997z00_785 = 
BGl_normaliza7ezd2prognz75zztools_prognz00(BgL_bodyz00_2953); 
return 
PROCEDURE_ENTRY(BgL_ez00_2954)(BgL_ez00_2954, BgL_arg1997z00_785, BgL_ez00_2954, BEOA);} }  else 
{ /* Expand/object.scm 132 */
bool_t BgL_testz00_3183;
{ /* Expand/object.scm 132 */
BgL_slotz00_bglt BgL_obj1752z00_2160;
{ /* Expand/object.scm 132 */
obj_t BgL_auxz00_3184;
BgL_auxz00_3184 = 
CAR(BgL_indexedz00_782); 
BgL_obj1752z00_2160 = 
(BgL_slotz00_bglt)(BgL_auxz00_3184); } 
BgL_testz00_3183 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1752z00_2160))->BgL_readzd2onlyzf3z21); } 
if(BgL_testz00_3183)
{ /* Expand/object.scm 132 */
{ /* Expand/object.scm 133 */
obj_t BgL_slotz00_787;
BgL_slotz00_787 = 
CAR(BgL_indexedz00_782); 
{ /* Expand/object.scm 133 */
obj_t BgL_srefz00_788;
{ /* Expand/object.scm 134 */
obj_t BgL_arg2104z00_834;
{ /* Expand/object.scm 134 */
BgL_slotz00_bglt BgL_obj1747z00_2162;
BgL_obj1747z00_2162 = 
(BgL_slotz00_bglt)(BgL_slotz00_787); 
BgL_arg2104z00_834 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1747z00_2162))->BgL_idz00); } 
{ /* Expand/object.scm 134 */
obj_t BgL_list2107z00_836;
{ /* Expand/object.scm 134 */
obj_t BgL_arg2109z00_837;
{ /* Expand/object.scm 134 */
obj_t BgL_auxz00_3191;
BgL_auxz00_3191 = 
CNST_TABLE_REF(((long)3)); 
BgL_arg2109z00_837 = 
MAKE_PAIR(BgL_auxz00_3191, BNIL); } 
BgL_list2107z00_836 = 
MAKE_PAIR(BgL_arg2104z00_834, BgL_arg2109z00_837); } 
BgL_srefz00_788 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2107z00_836); } } 
{ /* Expand/object.scm 134 */
obj_t BgL_fullzd2srefzd2_789;
{ /* Expand/object.scm 135 */
obj_t BgL_list2094z00_830;
{ /* Expand/object.scm 135 */
obj_t BgL_arg2096z00_831;
{ /* Expand/object.scm 135 */
obj_t BgL_arg2099z00_832;obj_t BgL_arg2100z00_833;
BgL_arg2099z00_832 = 
CNST_TABLE_REF(((long)4)); 
BgL_arg2100z00_833 = 
MAKE_PAIR(BgL_srefz00_788, BNIL); 
BgL_arg2096z00_831 = 
MAKE_PAIR(BgL_arg2099z00_832, BgL_arg2100z00_833); } 
BgL_list2094z00_830 = 
MAKE_PAIR(BgL_classzd2idzd2_2951, BgL_arg2096z00_831); } 
BgL_fullzd2srefzd2_789 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2094z00_830); } 
{ /* Expand/object.scm 135 */
obj_t BgL_slenz00_790;
{ /* Expand/object.scm 136 */
obj_t BgL_arg2084z00_826;
{ /* Expand/object.scm 136 */
BgL_slotz00_bglt BgL_obj1747z00_2163;
BgL_obj1747z00_2163 = 
(BgL_slotz00_bglt)(BgL_slotz00_787); 
BgL_arg2084z00_826 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1747z00_2163))->BgL_idz00); } 
{ /* Expand/object.scm 136 */
obj_t BgL_list2087z00_828;
{ /* Expand/object.scm 136 */
obj_t BgL_arg2089z00_829;
{ /* Expand/object.scm 136 */
obj_t BgL_auxz00_3203;
BgL_auxz00_3203 = 
CNST_TABLE_REF(((long)5)); 
BgL_arg2089z00_829 = 
MAKE_PAIR(BgL_auxz00_3203, BNIL); } 
BgL_list2087z00_828 = 
MAKE_PAIR(BgL_arg2084z00_826, BgL_arg2089z00_829); } 
BgL_slenz00_790 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2087z00_828); } } 
{ /* Expand/object.scm 136 */
obj_t BgL_fullzd2slenzd2_791;
{ /* Expand/object.scm 137 */
obj_t BgL_list2074z00_822;
{ /* Expand/object.scm 137 */
obj_t BgL_arg2076z00_823;
{ /* Expand/object.scm 137 */
obj_t BgL_arg2079z00_824;obj_t BgL_arg2080z00_825;
BgL_arg2079z00_824 = 
CNST_TABLE_REF(((long)4)); 
BgL_arg2080z00_825 = 
MAKE_PAIR(BgL_slenz00_790, BNIL); 
BgL_arg2076z00_823 = 
MAKE_PAIR(BgL_arg2079z00_824, BgL_arg2080z00_825); } 
BgL_list2074z00_822 = 
MAKE_PAIR(BgL_classzd2idzd2_2951, BgL_arg2076z00_823); } 
BgL_fullzd2slenzd2_791 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2074z00_822); } 
{ /* Expand/object.scm 137 */
obj_t BgL_iz00_792;
{ /* Expand/object.scm 138 */
obj_t BgL_arg2070z00_821;
BgL_arg2070z00_821 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)6)), BEOA); 
BgL_iz00_792 = 
BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(BgL_arg2070z00_821); } 
{ /* Expand/object.scm 138 */

{ /* Expand/object.scm 139 */
obj_t BgL_arg2002z00_793;obj_t BgL_arg2003z00_794;
BgL_arg2002z00_793 = 
CNST_TABLE_REF(((long)2)); 
{ /* Expand/object.scm 139 */
obj_t BgL_arg2006z00_795;obj_t BgL_arg2007z00_796;
{ /* Expand/object.scm 139 */
obj_t BgL_arg2010z00_797;
{ /* Expand/object.scm 139 */
obj_t BgL_arg2014z00_799;
{ /* Expand/object.scm 139 */
obj_t BgL_arg2017z00_800;
{ /* Expand/object.scm 139 */
obj_t BgL_arg2021z00_802;
BgL_arg2021z00_802 = 
MAKE_PAIR(BgL_auxz00_2952, BNIL); 
BgL_arg2017z00_800 = 
MAKE_PAIR(BgL_fullzd2slenzd2_791, BgL_arg2021z00_802); } 
BgL_arg2014z00_799 = 
MAKE_PAIR(BgL_arg2017z00_800, BNIL); } 
BgL_arg2010z00_797 = 
MAKE_PAIR(BgL_slenz00_790, BgL_arg2014z00_799); } 
BgL_arg2006z00_795 = 
MAKE_PAIR(BgL_arg2010z00_797, BNIL); } 
{ /* Expand/object.scm 140 */
obj_t BgL_arg2025z00_803;
{ /* Expand/object.scm 140 */
obj_t BgL_arg2029z00_805;obj_t BgL_arg2030z00_806;
BgL_arg2029z00_805 = 
CNST_TABLE_REF(((long)7)); 
{ /* Expand/object.scm 140 */
obj_t BgL_arg2033z00_807;obj_t BgL_arg2034z00_808;
{ /* Expand/object.scm 140 */
obj_t BgL_arg2037z00_809;
{ /* Expand/object.scm 140 */
obj_t BgL_arg2041z00_811;
{ /* Expand/object.scm 140 */
obj_t BgL_arg2044z00_812;obj_t BgL_arg2045z00_813;
BgL_arg2044z00_812 = 
MAKE_PAIR(BgL_iz00_792, BNIL); 
{ /* Expand/object.scm 140 */
obj_t BgL_arg2049z00_814;
{ /* Expand/object.scm 140 */
obj_t BgL_arg2054z00_816;
{ /* Expand/object.scm 140 */
obj_t BgL_arg2057z00_817;
BgL_arg2057z00_817 = 
MAKE_PAIR(BgL_iz00_792, BNIL); 
BgL_arg2054z00_816 = 
MAKE_PAIR(BgL_auxz00_2952, BgL_arg2057z00_817); } 
BgL_arg2049z00_814 = 
MAKE_PAIR(BgL_fullzd2srefzd2_789, BgL_arg2054z00_816); } 
BgL_arg2045z00_813 = 
MAKE_PAIR(BgL_arg2049z00_814, BNIL); } 
BgL_arg2041z00_811 = 
MAKE_PAIR(BgL_arg2044z00_812, BgL_arg2045z00_813); } 
BgL_arg2037z00_809 = 
MAKE_PAIR(BgL_srefz00_788, BgL_arg2041z00_811); } 
BgL_arg2033z00_807 = 
MAKE_PAIR(BgL_arg2037z00_809, BNIL); } 
{ /* Expand/object.scm 141 */
obj_t BgL_arg2061z00_818;
BgL_arg2061z00_818 = 
BGl_loopz00zzexpand_objectz00(BgL_ez00_2954, BgL_bodyz00_2953, BgL_auxz00_2952, BgL_classzd2idzd2_2951, 
CDR(BgL_indexedz00_782)); 
BgL_arg2034z00_808 = 
MAKE_PAIR(BgL_arg2061z00_818, BNIL); } 
BgL_arg2030z00_806 = 
MAKE_PAIR(BgL_arg2033z00_807, BgL_arg2034z00_808); } 
BgL_arg2025z00_803 = 
MAKE_PAIR(BgL_arg2029z00_805, BgL_arg2030z00_806); } 
BgL_arg2007z00_796 = 
MAKE_PAIR(BgL_arg2025z00_803, BNIL); } 
BgL_arg2003z00_794 = 
MAKE_PAIR(BgL_arg2006z00_795, BgL_arg2007z00_796); } 
return 
MAKE_PAIR(BgL_arg2002z00_793, BgL_arg2003z00_794);} } } } } } } } }  else 
{ /* Expand/object.scm 132 */
{ /* Expand/object.scm 143 */
obj_t BgL_slotz00_838;
BgL_slotz00_838 = 
CAR(BgL_indexedz00_782); 
{ /* Expand/object.scm 143 */
obj_t BgL_srefz00_839;
{ /* Expand/object.scm 144 */
obj_t BgL_arg2269z00_908;
{ /* Expand/object.scm 144 */
BgL_slotz00_bglt BgL_obj1747z00_2166;
BgL_obj1747z00_2166 = 
(BgL_slotz00_bglt)(BgL_slotz00_838); 
BgL_arg2269z00_908 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1747z00_2166))->BgL_idz00); } 
{ /* Expand/object.scm 144 */
obj_t BgL_list2272z00_910;
{ /* Expand/object.scm 144 */
obj_t BgL_arg2274z00_911;
{ /* Expand/object.scm 144 */
obj_t BgL_auxz00_3243;
BgL_auxz00_3243 = 
CNST_TABLE_REF(((long)3)); 
BgL_arg2274z00_911 = 
MAKE_PAIR(BgL_auxz00_3243, BNIL); } 
BgL_list2272z00_910 = 
MAKE_PAIR(BgL_arg2269z00_908, BgL_arg2274z00_911); } 
BgL_srefz00_839 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2272z00_910); } } 
{ /* Expand/object.scm 144 */
obj_t BgL_fullzd2srefzd2_840;
{ /* Expand/object.scm 145 */
obj_t BgL_list2259z00_904;
{ /* Expand/object.scm 145 */
obj_t BgL_arg2261z00_905;
{ /* Expand/object.scm 145 */
obj_t BgL_arg2264z00_906;obj_t BgL_arg2265z00_907;
BgL_arg2264z00_906 = 
CNST_TABLE_REF(((long)4)); 
BgL_arg2265z00_907 = 
MAKE_PAIR(BgL_srefz00_839, BNIL); 
BgL_arg2261z00_905 = 
MAKE_PAIR(BgL_arg2264z00_906, BgL_arg2265z00_907); } 
BgL_list2259z00_904 = 
MAKE_PAIR(BgL_classzd2idzd2_2951, BgL_arg2261z00_905); } 
BgL_fullzd2srefzd2_840 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2259z00_904); } 
{ /* Expand/object.scm 145 */
obj_t BgL_ssetz00_841;
{ /* Expand/object.scm 146 */
obj_t BgL_arg2249z00_900;
{ /* Expand/object.scm 146 */
BgL_slotz00_bglt BgL_obj1747z00_2167;
BgL_obj1747z00_2167 = 
(BgL_slotz00_bglt)(BgL_slotz00_838); 
BgL_arg2249z00_900 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1747z00_2167))->BgL_idz00); } 
{ /* Expand/object.scm 146 */
obj_t BgL_list2252z00_902;
{ /* Expand/object.scm 146 */
obj_t BgL_arg2254z00_903;
{ /* Expand/object.scm 146 */
obj_t BgL_auxz00_3255;
BgL_auxz00_3255 = 
CNST_TABLE_REF(((long)8)); 
BgL_arg2254z00_903 = 
MAKE_PAIR(BgL_auxz00_3255, BNIL); } 
BgL_list2252z00_902 = 
MAKE_PAIR(BgL_arg2249z00_900, BgL_arg2254z00_903); } 
BgL_ssetz00_841 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2252z00_902); } } 
{ /* Expand/object.scm 146 */
obj_t BgL_fullzd2ssetzd2_842;
{ /* Expand/object.scm 147 */
obj_t BgL_list2239z00_896;
{ /* Expand/object.scm 147 */
obj_t BgL_arg2241z00_897;
{ /* Expand/object.scm 147 */
obj_t BgL_arg2244z00_898;obj_t BgL_arg2245z00_899;
BgL_arg2244z00_898 = 
CNST_TABLE_REF(((long)4)); 
BgL_arg2245z00_899 = 
MAKE_PAIR(BgL_ssetz00_841, BNIL); 
BgL_arg2241z00_897 = 
MAKE_PAIR(BgL_arg2244z00_898, BgL_arg2245z00_899); } 
BgL_list2239z00_896 = 
MAKE_PAIR(BgL_classzd2idzd2_2951, BgL_arg2241z00_897); } 
BgL_fullzd2ssetzd2_842 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2239z00_896); } 
{ /* Expand/object.scm 147 */
obj_t BgL_slenz00_843;
{ /* Expand/object.scm 148 */
obj_t BgL_arg2229z00_892;
{ /* Expand/object.scm 148 */
BgL_slotz00_bglt BgL_obj1747z00_2168;
BgL_obj1747z00_2168 = 
(BgL_slotz00_bglt)(BgL_slotz00_838); 
BgL_arg2229z00_892 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1747z00_2168))->BgL_idz00); } 
{ /* Expand/object.scm 148 */
obj_t BgL_list2232z00_894;
{ /* Expand/object.scm 148 */
obj_t BgL_arg2234z00_895;
{ /* Expand/object.scm 148 */
obj_t BgL_auxz00_3267;
BgL_auxz00_3267 = 
CNST_TABLE_REF(((long)5)); 
BgL_arg2234z00_895 = 
MAKE_PAIR(BgL_auxz00_3267, BNIL); } 
BgL_list2232z00_894 = 
MAKE_PAIR(BgL_arg2229z00_892, BgL_arg2234z00_895); } 
BgL_slenz00_843 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2232z00_894); } } 
{ /* Expand/object.scm 148 */
obj_t BgL_fullzd2slenzd2_844;
{ /* Expand/object.scm 149 */
obj_t BgL_list2219z00_888;
{ /* Expand/object.scm 149 */
obj_t BgL_arg2221z00_889;
{ /* Expand/object.scm 149 */
obj_t BgL_arg2224z00_890;obj_t BgL_arg2225z00_891;
BgL_arg2224z00_890 = 
CNST_TABLE_REF(((long)4)); 
BgL_arg2225z00_891 = 
MAKE_PAIR(BgL_slenz00_843, BNIL); 
BgL_arg2221z00_889 = 
MAKE_PAIR(BgL_arg2224z00_890, BgL_arg2225z00_891); } 
BgL_list2219z00_888 = 
MAKE_PAIR(BgL_classzd2idzd2_2951, BgL_arg2221z00_889); } 
BgL_fullzd2slenzd2_844 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2219z00_888); } 
{ /* Expand/object.scm 149 */
obj_t BgL_iz00_845;
{ /* Expand/object.scm 150 */
obj_t BgL_arg2215z00_887;
BgL_arg2215z00_887 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)6)), BEOA); 
BgL_iz00_845 = 
BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(BgL_arg2215z00_887); } 
{ /* Expand/object.scm 150 */
obj_t BgL_vz00_846;
{ /* Expand/object.scm 151 */
obj_t BgL_arg2210z00_886;
BgL_arg2210z00_886 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)9)), BEOA); 
BgL_vz00_846 = 
BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(BgL_arg2210z00_886); } 
{ /* Expand/object.scm 151 */

{ /* Expand/object.scm 152 */
obj_t BgL_arg2115z00_847;obj_t BgL_arg2116z00_848;
BgL_arg2115z00_847 = 
CNST_TABLE_REF(((long)2)); 
{ /* Expand/object.scm 152 */
obj_t BgL_arg2119z00_849;obj_t BgL_arg2120z00_850;
{ /* Expand/object.scm 152 */
obj_t BgL_arg2123z00_851;
{ /* Expand/object.scm 152 */
obj_t BgL_arg2127z00_853;
{ /* Expand/object.scm 152 */
obj_t BgL_arg2130z00_854;
{ /* Expand/object.scm 152 */
obj_t BgL_arg2134z00_856;
BgL_arg2134z00_856 = 
MAKE_PAIR(BgL_auxz00_2952, BNIL); 
BgL_arg2130z00_854 = 
MAKE_PAIR(BgL_fullzd2slenzd2_844, BgL_arg2134z00_856); } 
BgL_arg2127z00_853 = 
MAKE_PAIR(BgL_arg2130z00_854, BNIL); } 
BgL_arg2123z00_851 = 
MAKE_PAIR(BgL_slenz00_843, BgL_arg2127z00_853); } 
BgL_arg2119z00_849 = 
MAKE_PAIR(BgL_arg2123z00_851, BNIL); } 
{ /* Expand/object.scm 153 */
obj_t BgL_arg2138z00_857;
{ /* Expand/object.scm 153 */
obj_t BgL_arg2142z00_859;obj_t BgL_arg2143z00_860;
BgL_arg2142z00_859 = 
CNST_TABLE_REF(((long)7)); 
{ /* Expand/object.scm 153 */
obj_t BgL_arg2146z00_861;obj_t BgL_arg2147z00_862;
{ /* Expand/object.scm 153 */
obj_t BgL_arg2150z00_863;obj_t BgL_arg2151z00_864;
{ /* Expand/object.scm 153 */
obj_t BgL_arg2154z00_865;
{ /* Expand/object.scm 153 */
obj_t BgL_arg2157z00_866;obj_t BgL_arg2158z00_867;
BgL_arg2157z00_866 = 
MAKE_PAIR(BgL_iz00_845, BNIL); 
{ /* Expand/object.scm 153 */
obj_t BgL_arg2162z00_868;
{ /* Expand/object.scm 153 */
obj_t BgL_arg2166z00_870;
{ /* Expand/object.scm 153 */
obj_t BgL_arg2169z00_871;
BgL_arg2169z00_871 = 
MAKE_PAIR(BgL_iz00_845, BNIL); 
BgL_arg2166z00_870 = 
MAKE_PAIR(BgL_auxz00_2952, BgL_arg2169z00_871); } 
BgL_arg2162z00_868 = 
MAKE_PAIR(BgL_fullzd2srefzd2_840, BgL_arg2166z00_870); } 
BgL_arg2158z00_867 = 
MAKE_PAIR(BgL_arg2162z00_868, BNIL); } 
BgL_arg2154z00_865 = 
MAKE_PAIR(BgL_arg2157z00_866, BgL_arg2158z00_867); } 
BgL_arg2150z00_863 = 
MAKE_PAIR(BgL_srefz00_839, BgL_arg2154z00_865); } 
{ /* Expand/object.scm 154 */
obj_t BgL_arg2173z00_872;
{ /* Expand/object.scm 154 */
obj_t BgL_arg2177z00_874;
{ /* Expand/object.scm 154 */
obj_t BgL_arg2180z00_875;obj_t BgL_arg2181z00_876;
{ /* Expand/object.scm 154 */
obj_t BgL_arg2184z00_877;
BgL_arg2184z00_877 = 
MAKE_PAIR(BgL_vz00_846, BNIL); 
BgL_arg2180z00_875 = 
MAKE_PAIR(BgL_iz00_845, BgL_arg2184z00_877); } 
{ /* Expand/object.scm 154 */
obj_t BgL_arg2188z00_878;
{ /* Expand/object.scm 154 */
obj_t BgL_arg2192z00_880;
{ /* Expand/object.scm 154 */
obj_t BgL_arg2195z00_881;
{ /* Expand/object.scm 154 */
obj_t BgL_arg2198z00_882;
BgL_arg2198z00_882 = 
MAKE_PAIR(BgL_vz00_846, BNIL); 
BgL_arg2195z00_881 = 
MAKE_PAIR(BgL_iz00_845, BgL_arg2198z00_882); } 
BgL_arg2192z00_880 = 
MAKE_PAIR(BgL_auxz00_2952, BgL_arg2195z00_881); } 
BgL_arg2188z00_878 = 
MAKE_PAIR(BgL_fullzd2ssetzd2_842, BgL_arg2192z00_880); } 
BgL_arg2181z00_876 = 
MAKE_PAIR(BgL_arg2188z00_878, BNIL); } 
BgL_arg2177z00_874 = 
MAKE_PAIR(BgL_arg2180z00_875, BgL_arg2181z00_876); } 
BgL_arg2173z00_872 = 
MAKE_PAIR(BgL_ssetz00_841, BgL_arg2177z00_874); } 
BgL_arg2151z00_864 = 
MAKE_PAIR(BgL_arg2173z00_872, BNIL); } 
BgL_arg2146z00_861 = 
MAKE_PAIR(BgL_arg2150z00_863, BgL_arg2151z00_864); } 
{ /* Expand/object.scm 155 */
obj_t BgL_arg2202z00_883;
BgL_arg2202z00_883 = 
BGl_loopz00zzexpand_objectz00(BgL_ez00_2954, BgL_bodyz00_2953, BgL_auxz00_2952, BgL_classzd2idzd2_2951, 
CDR(BgL_indexedz00_782)); 
BgL_arg2147z00_862 = 
MAKE_PAIR(BgL_arg2202z00_883, BNIL); } 
BgL_arg2143z00_860 = 
MAKE_PAIR(BgL_arg2146z00_861, BgL_arg2147z00_862); } 
BgL_arg2138z00_857 = 
MAKE_PAIR(BgL_arg2142z00_859, BgL_arg2143z00_860); } 
BgL_arg2120z00_850 = 
MAKE_PAIR(BgL_arg2138z00_857, BNIL); } 
BgL_arg2116z00_848 = 
MAKE_PAIR(BgL_arg2119z00_849, BgL_arg2120z00_850); } 
return 
MAKE_PAIR(BgL_arg2115z00_847, BgL_arg2116z00_848);} } } } } } } } } } } } } } 
}



/* make-indexed-body */
obj_t BGl_makezd2indexedzd2bodyz00zzexpand_objectz00(obj_t BgL_indexedz00_2959, obj_t BgL_ez00_2958, obj_t BgL_bodyz00_2957, obj_t BgL_auxz00_2956, obj_t BgL_classzd2idzd2_2955)
{ AN_OBJECT;
{ /* Expand/object.scm 155 */
return 
BGl_loopz00zzexpand_objectz00(BgL_ez00_2958, BgL_bodyz00_2957, BgL_auxz00_2956, BgL_classzd2idzd2_2955, BgL_indexedz00_2959);} 
}



/* with-access-expander */
obj_t BGl_withzd2accesszd2expanderz00zzexpand_objectz00(obj_t BgL_oldzd2expanderzd2_12, obj_t BgL_markz00_13, obj_t BgL_instancez00_14, obj_t BgL_classz00_15, obj_t BgL_slotsz00_16)
{ AN_OBJECT;
{ /* Expand/object.scm 162 */
{ /* Expand/object.scm 163 */
obj_t BgL_zc3anonymousza32284ze3z83_2902;
{ 
int BgL_auxz00_3321;int BgL_auxz00_3319;
BgL_auxz00_3321 = 
(int)(((long)5)); 
BgL_auxz00_3319 = 
(int)(((long)2)); 
BgL_zc3anonymousza32284ze3z83_2902 = 
make_fx_procedure(BGl_zc3anonymousza32284ze3z83zzexpand_objectz00, BgL_auxz00_3319, BgL_auxz00_3321); } 
{ /* Expand/object.scm 163 */
int BgL_auxz00_3324;
BgL_auxz00_3324 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32284ze3z83_2902, BgL_auxz00_3324, BgL_oldzd2expanderzd2_12); } 
{ /* Expand/object.scm 163 */
int BgL_auxz00_3327;
BgL_auxz00_3327 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_zc3anonymousza32284ze3z83_2902, BgL_auxz00_3327, BgL_slotsz00_16); } 
{ /* Expand/object.scm 163 */
int BgL_auxz00_3330;
BgL_auxz00_3330 = 
(int)(((long)2)); 
PROCEDURE_SET(BgL_zc3anonymousza32284ze3z83_2902, BgL_auxz00_3330, BgL_markz00_13); } 
{ /* Expand/object.scm 163 */
int BgL_auxz00_3333;
BgL_auxz00_3333 = 
(int)(((long)3)); 
PROCEDURE_SET(BgL_zc3anonymousza32284ze3z83_2902, BgL_auxz00_3333, BgL_classz00_15); } 
{ /* Expand/object.scm 163 */
int BgL_auxz00_3336;
BgL_auxz00_3336 = 
(int)(((long)4)); 
PROCEDURE_SET(BgL_zc3anonymousza32284ze3z83_2902, BgL_auxz00_3336, BgL_instancez00_14); } 
return BgL_zc3anonymousza32284ze3z83_2902;} } 
}



/* <anonymous:2284> */
obj_t BGl_zc3anonymousza32284ze3z83zzexpand_objectz00(obj_t BgL_envz00_2903, obj_t BgL_xz00_2909, obj_t BgL_ez00_2910)
{ AN_OBJECT;
{ /* Expand/object.scm 163 */
{ /* Expand/object.scm 163 */
obj_t BgL_oldzd2expanderzd2_2904;obj_t BgL_slotsz00_2905;obj_t BgL_markz00_2906;obj_t BgL_classz00_2907;obj_t BgL_instancez00_2908;
{ /* Expand/object.scm 163 */
int BgL_auxz00_3339;
BgL_auxz00_3339 = 
(int)(((long)0)); 
BgL_oldzd2expanderzd2_2904 = 
PROCEDURE_REF(BgL_envz00_2903, BgL_auxz00_3339); } 
{ /* Expand/object.scm 163 */
int BgL_auxz00_3342;
BgL_auxz00_3342 = 
(int)(((long)1)); 
BgL_slotsz00_2905 = 
PROCEDURE_REF(BgL_envz00_2903, BgL_auxz00_3342); } 
{ /* Expand/object.scm 163 */
int BgL_auxz00_3345;
BgL_auxz00_3345 = 
(int)(((long)2)); 
BgL_markz00_2906 = 
PROCEDURE_REF(BgL_envz00_2903, BgL_auxz00_3345); } 
{ /* Expand/object.scm 163 */
int BgL_auxz00_3348;
BgL_auxz00_3348 = 
(int)(((long)3)); 
BgL_classz00_2907 = 
PROCEDURE_REF(BgL_envz00_2903, BgL_auxz00_3348); } 
{ /* Expand/object.scm 163 */
int BgL_auxz00_3351;
BgL_auxz00_3351 = 
(int)(((long)4)); 
BgL_instancez00_2908 = 
PROCEDURE_REF(BgL_envz00_2903, BgL_auxz00_3351); } 
{ 
obj_t BgL_xz00_914;obj_t BgL_ez00_915;
BgL_xz00_914 = BgL_xz00_2909; 
BgL_ez00_915 = BgL_ez00_2910; 
{ 
obj_t BgL_varz00_919;obj_t BgL_valz00_920;obj_t BgL_varz00_917;
if(
SYMBOLP(BgL_xz00_914))
{ /* Expand/object.scm 163 */
BgL_varz00_917 = BgL_xz00_914; 
{ /* Expand/object.scm 166 */
bool_t BgL_test2322z00_939;
{ /* Expand/object.scm 166 */
bool_t BgL_testz00_3356;
{ /* Expand/object.scm 166 */
obj_t BgL_auxz00_3357;
BgL_auxz00_3357 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_varz00_917, BgL_slotsz00_2905); 
BgL_testz00_3356 = 
CBOOL(BgL_auxz00_3357); } 
if(BgL_testz00_3356)
{ /* Expand/object.scm 167 */
obj_t BgL_cellz00_947;
{ /* Expand/object.scm 167 */
obj_t BgL_arg2346z00_950;
BgL_arg2346z00_950 = 
BGl_lexicalzd2stackzd2zzexpand_epsz00(); 
BgL_cellz00_947 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_varz00_917, BgL_arg2346z00_950); } 
if(
PAIRP(BgL_cellz00_947))
{ /* Expand/object.scm 168 */
obj_t BgL_auxz00_3364;
BgL_auxz00_3364 = 
CDR(BgL_cellz00_947); 
BgL_test2322z00_939 = 
(BgL_auxz00_3364==BgL_markz00_2906); }  else 
{ /* Expand/object.scm 168 */
BgL_test2322z00_939 = ((bool_t)0); } }  else 
{ /* Expand/object.scm 166 */
BgL_test2322z00_939 = ((bool_t)0); } } 
if(BgL_test2322z00_939)
{ /* Expand/object.scm 169 */
obj_t BgL_arg2324z00_940;obj_t BgL_arg2325z00_941;
{ /* Expand/object.scm 169 */
obj_t BgL_list2328z00_942;
{ /* Expand/object.scm 169 */
obj_t BgL_arg2330z00_943;
{ /* Expand/object.scm 169 */
obj_t BgL_arg2333z00_944;obj_t BgL_arg2334z00_945;
BgL_arg2333z00_944 = 
CNST_TABLE_REF(((long)4)); 
BgL_arg2334z00_945 = 
MAKE_PAIR(BgL_varz00_917, BNIL); 
BgL_arg2330z00_943 = 
MAKE_PAIR(BgL_arg2333z00_944, BgL_arg2334z00_945); } 
BgL_list2328z00_942 = 
MAKE_PAIR(BgL_classz00_2907, BgL_arg2330z00_943); } 
BgL_arg2324z00_940 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2328z00_942); } 
BgL_arg2325z00_941 = 
MAKE_PAIR(BgL_instancez00_2908, BNIL); 
return 
MAKE_PAIR(BgL_arg2324z00_940, BgL_arg2325z00_941);}  else 
{ /* Expand/object.scm 166 */
return 
PROCEDURE_ENTRY(BgL_oldzd2expanderzd2_2904)(BgL_oldzd2expanderzd2_2904, BgL_varz00_917, BgL_oldzd2expanderzd2_2904, BEOA);} } }  else 
{ /* Expand/object.scm 163 */
if(
PAIRP(BgL_xz00_914))
{ /* Expand/object.scm 163 */
obj_t BgL_cdrzd2144zd2_926;
BgL_cdrzd2144zd2_926 = 
CDR(BgL_xz00_914); 
{ /* Expand/object.scm 163 */
bool_t BgL_testz00_3380;
{ /* Expand/object.scm 163 */
obj_t BgL_auxz00_3383;obj_t BgL_auxz00_3381;
BgL_auxz00_3383 = 
CNST_TABLE_REF(((long)10)); 
BgL_auxz00_3381 = 
CAR(BgL_xz00_914); 
BgL_testz00_3380 = 
(BgL_auxz00_3381==BgL_auxz00_3383); } 
if(BgL_testz00_3380)
{ /* Expand/object.scm 163 */
if(
PAIRP(BgL_cdrzd2144zd2_926))
{ /* Expand/object.scm 163 */
obj_t BgL_carzd2147zd2_929;obj_t BgL_cdrzd2148zd2_930;
BgL_carzd2147zd2_929 = 
CAR(BgL_cdrzd2144zd2_926); 
BgL_cdrzd2148zd2_930 = 
CDR(BgL_cdrzd2144zd2_926); 
if(
SYMBOLP(BgL_carzd2147zd2_929))
{ /* Expand/object.scm 163 */
if(
PAIRP(BgL_cdrzd2148zd2_930))
{ /* Expand/object.scm 163 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2148zd2_930), BNIL))
{ /* Expand/object.scm 163 */
BgL_varz00_919 = BgL_carzd2147zd2_929; 
BgL_valz00_920 = 
CAR(BgL_cdrzd2148zd2_930); 
{ /* Expand/object.scm 172 */
obj_t BgL_valz00_951;
BgL_valz00_951 = 
PROCEDURE_ENTRY(BgL_ez00_915)(BgL_ez00_915, BgL_valz00_920, BgL_ez00_915, BEOA); 
{ /* Expand/object.scm 173 */
bool_t BgL_test2350z00_952;
{ /* Expand/object.scm 173 */
bool_t BgL_testz00_3399;
{ /* Expand/object.scm 173 */
obj_t BgL_auxz00_3400;
BgL_auxz00_3400 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_varz00_919, BgL_slotsz00_2905); 
BgL_testz00_3399 = 
CBOOL(BgL_auxz00_3400); } 
if(BgL_testz00_3399)
{ /* Expand/object.scm 174 */
obj_t BgL_cellz00_964;
{ /* Expand/object.scm 174 */
obj_t BgL_arg2387z00_967;
BgL_arg2387z00_967 = 
BGl_lexicalzd2stackzd2zzexpand_epsz00(); 
BgL_cellz00_964 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_varz00_919, BgL_arg2387z00_967); } 
if(
PAIRP(BgL_cellz00_964))
{ /* Expand/object.scm 175 */
obj_t BgL_auxz00_3407;
BgL_auxz00_3407 = 
CDR(BgL_cellz00_964); 
BgL_test2350z00_952 = 
(BgL_auxz00_3407==BgL_markz00_2906); }  else 
{ /* Expand/object.scm 175 */
BgL_test2350z00_952 = ((bool_t)0); } }  else 
{ /* Expand/object.scm 173 */
BgL_test2350z00_952 = ((bool_t)0); } } 
if(BgL_test2350z00_952)
{ /* Expand/object.scm 177 */
obj_t BgL_arg2352z00_953;
{ /* Expand/object.scm 177 */
obj_t BgL_arg2355z00_954;obj_t BgL_arg2356z00_955;
{ /* Expand/object.scm 177 */
obj_t BgL_list2359z00_956;
{ /* Expand/object.scm 177 */
obj_t BgL_arg2361z00_957;
{ /* Expand/object.scm 177 */
obj_t BgL_arg2364z00_958;obj_t BgL_arg2365z00_959;
BgL_arg2364z00_958 = 
CNST_TABLE_REF(((long)4)); 
{ /* Expand/object.scm 177 */
obj_t BgL_arg2368z00_960;
{ /* Expand/object.scm 177 */
obj_t BgL_auxz00_3412;
BgL_auxz00_3412 = 
CNST_TABLE_REF(((long)8)); 
BgL_arg2368z00_960 = 
MAKE_PAIR(BgL_auxz00_3412, BNIL); } 
BgL_arg2365z00_959 = 
MAKE_PAIR(BgL_varz00_919, BgL_arg2368z00_960); } 
BgL_arg2361z00_957 = 
MAKE_PAIR(BgL_arg2364z00_958, BgL_arg2365z00_959); } 
BgL_list2359z00_956 = 
MAKE_PAIR(BgL_classz00_2907, BgL_arg2361z00_957); } 
BgL_arg2355z00_954 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2359z00_956); } 
{ /* Expand/object.scm 177 */
obj_t BgL_arg2372z00_961;
BgL_arg2372z00_961 = 
MAKE_PAIR(BgL_valz00_951, BNIL); 
BgL_arg2356z00_955 = 
MAKE_PAIR(BgL_instancez00_2908, BgL_arg2372z00_961); } 
BgL_arg2352z00_953 = 
MAKE_PAIR(BgL_arg2355z00_954, BgL_arg2356z00_955); } 
return 
BGl_objectzd2epairifyzd2zzexpand_objectz00(BgL_arg2352z00_953, BgL_xz00_914);}  else 
{ /* Expand/object.scm 173 */
{ /* Expand/object.scm 180 */
obj_t BgL_auxz00_3423;
{ /* Expand/object.scm 180 */
obj_t BgL_auxz00_3424;
BgL_auxz00_3424 = 
CDR(BgL_xz00_914); 
BgL_auxz00_3423 = 
CDR(BgL_auxz00_3424); } 
SET_CAR(BgL_auxz00_3423, BgL_valz00_951); } 
return 
PROCEDURE_ENTRY(BgL_oldzd2expanderzd2_2904)(BgL_oldzd2expanderzd2_2904, BgL_xz00_914, BgL_oldzd2expanderzd2_2904, BEOA);} } } }  else 
{ /* Expand/object.scm 163 */
BgL_tagzd2133zd2_922:
return 
PROCEDURE_ENTRY(BgL_oldzd2expanderzd2_2904)(BgL_oldzd2expanderzd2_2904, BgL_xz00_914, BgL_ez00_915, BEOA);} }  else 
{ /* Expand/object.scm 163 */
goto BgL_tagzd2133zd2_922;} }  else 
{ /* Expand/object.scm 163 */
goto BgL_tagzd2133zd2_922;} }  else 
{ /* Expand/object.scm 163 */
goto BgL_tagzd2133zd2_922;} }  else 
{ /* Expand/object.scm 163 */
goto BgL_tagzd2133zd2_922;} } }  else 
{ /* Expand/object.scm 163 */
goto BgL_tagzd2133zd2_922;} } } } } } 
}



/* expand-instantiate */
obj_t BGl_expandzd2instantiatezd2zzexpand_objectz00(obj_t BgL_xz00_17, obj_t BgL_ez00_18)
{ AN_OBJECT;
{ /* Expand/object.scm 188 */
{ 
obj_t BgL_instantiatez00_968;
if(
PAIRP(BgL_xz00_17))
{ /* Expand/object.scm 189 */
BgL_instantiatez00_968 = 
CAR(BgL_xz00_17); 
{ /* Expand/object.scm 191 */
BgL_typez00_bglt BgL_classz00_974;
{ /* Expand/object.scm 191 */
obj_t BgL_arg2411z00_978;
BgL_arg2411z00_978 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_xz00_17); 
BgL_classz00_974 = 
BGl_typezd2ofzd2idz00zzast_identz00(BgL_instantiatez00_968, BgL_arg2411z00_978); } 
{ /* Expand/object.scm 193 */
bool_t BgL_test2400z00_975;
BgL_test2400z00_975 = 
BGl_iszd2azf3z21zz__objectz00(
(obj_t)(BgL_classz00_974), BGl_tclassz00zzobject_classz00); 
if(BgL_test2400z00_975)
{ /* Expand/object.scm 195 */
bool_t BgL_testz00_3440;
{ /* Expand/object.scm 195 */
BgL_tclassz00_bglt BgL_obj1625z00_2194;
BgL_obj1625z00_2194 = 
(BgL_tclassz00_bglt)(BgL_classz00_974); 
{ 
obj_t BgL_auxz00_3442;
{ /* Expand/object.scm 195 */
BgL_objectz00_bglt BgL_auxz00_3443;
BgL_auxz00_3443 = 
(BgL_objectz00_bglt)(BgL_obj1625z00_2194); 
BgL_auxz00_3442 = 
BGL_OBJECT_WIDENING(BgL_auxz00_3443); } 
BgL_testz00_3440 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_3442))->BgL_abstractzf3zf3); } } 
if(BgL_testz00_3440)
{ /* Expand/object.scm 195 */
FAILURE(BFALSE,BGl_string4847z00zzexpand_objectz00,BgL_xz00_17);}  else 
{ /* Expand/object.scm 195 */
{ /* Expand/object.scm 198 */
obj_t BgL_arg2404z00_977;
BgL_arg2404z00_977 = 
BGl_instantiatezd2ze3makez31zzexpand_objectz00(BgL_xz00_17, BgL_classz00_974, BgL_ez00_18); 
return 
BGl_replacez12z12zztools_miscz00(BgL_xz00_17, BgL_arg2404z00_977);} } }  else 
{ /* Expand/object.scm 193 */
FAILURE(BFALSE,BGl_string4848z00zzexpand_objectz00,BgL_xz00_17);} } } }  else 
{ /* Expand/object.scm 189 */
FAILURE(BFALSE,BGl_string4848z00zzexpand_objectz00,BgL_xz00_17);} } } 
}



/* _expand-instantiate */
obj_t BGl__expandzd2instantiatezd2zzexpand_objectz00(obj_t BgL_envz00_2911, obj_t BgL_xz00_2912, obj_t BgL_ez00_2913)
{ AN_OBJECT;
{ /* Expand/object.scm 188 */
return 
BGl_expandzd2instantiatezd2zzexpand_objectz00(BgL_xz00_2912, BgL_ez00_2913);} 
}



/* instantiate->make */
obj_t BGl_instantiatezd2ze3makez31zzexpand_objectz00(obj_t BgL_formz00_19, BgL_typez00_bglt BgL_classz00_20, obj_t BgL_ez00_21)
{ AN_OBJECT;
{ /* Expand/object.scm 205 */
{ /* Expand/object.scm 206 */
obj_t BgL_makezd2namezd2_979;
{ /* Expand/object.scm 206 */
obj_t BgL_arg2427z00_986;
BgL_arg2427z00_986 = 
CNST_TABLE_REF(((long)11)); 
{ /* Expand/object.scm 206 */
obj_t BgL_list2430z00_988;
{ /* Expand/object.scm 206 */
obj_t BgL_arg2432z00_989;
{ /* Expand/object.scm 206 */
obj_t BgL_auxz00_3455;
BgL_auxz00_3455 = 
(((BgL_typez00_bglt)CREF(BgL_classz00_20))->BgL_idz00); 
BgL_arg2432z00_989 = 
MAKE_PAIR(BgL_auxz00_3455, BNIL); } 
BgL_list2430z00_988 = 
MAKE_PAIR(BgL_arg2427z00_986, BgL_arg2432z00_989); } 
BgL_makezd2namezd2_979 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2430z00_988); } } 
{ /* Expand/object.scm 210 */
obj_t BgL_zc3anonymousza32418ze3z83_2914;
{ 
int BgL_auxz00_3460;
BgL_auxz00_3460 = 
(int)(((long)2)); 
BgL_zc3anonymousza32418ze3z83_2914 = 
MAKE_L_PROCEDURE(BGl_zc3anonymousza32418ze3z83zzexpand_objectz00, BgL_auxz00_3460); } 
{ /* Expand/object.scm 210 */
int BgL_auxz00_3463;
BgL_auxz00_3463 = 
(int)(((long)0)); 
PROCEDURE_L_SET(BgL_zc3anonymousza32418ze3z83_2914, BgL_auxz00_3463, BgL_formz00_19); } 
{ /* Expand/object.scm 210 */
int BgL_auxz00_3466;
BgL_auxz00_3466 = 
(int)(((long)1)); 
PROCEDURE_L_SET(BgL_zc3anonymousza32418ze3z83_2914, BgL_auxz00_3466, BgL_makezd2namezd2_979); } 
return 
BGl_instantiatezd2ze3fillz31zzexpand_objectz00(BgL_formz00_19, 
(obj_t)(BgL_classz00_20), BgL_zc3anonymousza32418ze3z83_2914, BgL_ez00_21);} } } 
}



/* <anonymous:2418> */
obj_t BGl_zc3anonymousza32418ze3z83zzexpand_objectz00(obj_t BgL_envz00_2915, obj_t BgL_largsz00_2918)
{ AN_OBJECT;
{ /* Expand/object.scm 209 */
{ /* Expand/object.scm 210 */
obj_t BgL_formz00_2916;obj_t BgL_makezd2namezd2_2917;
{ /* Expand/object.scm 210 */
int BgL_auxz00_3471;
BgL_auxz00_3471 = 
(int)(((long)0)); 
BgL_formz00_2916 = 
PROCEDURE_L_REF(BgL_envz00_2915, BgL_auxz00_3471); } 
{ /* Expand/object.scm 210 */
int BgL_auxz00_3474;
BgL_auxz00_3474 = 
(int)(((long)1)); 
BgL_makezd2namezd2_2917 = 
PROCEDURE_L_REF(BgL_envz00_2915, BgL_auxz00_3474); } 
{ 
obj_t BgL_largsz00_981;
BgL_largsz00_981 = BgL_largsz00_2918; 
{ /* Expand/object.scm 210 */
bool_t BgL_test2419z00_983;
BgL_test2419z00_983 = 
EXTENDED_PAIRP(BgL_formz00_2916); 
if(BgL_test2419z00_983)
{ /* Expand/object.scm 211 */
obj_t BgL_res4542z00_2210;
{ /* Expand/object.scm 211 */
obj_t BgL_auxz00_3479;
BgL_auxz00_3479 = 
CER(BgL_formz00_2916); 
BgL_res4542z00_2210 = 
MAKE_EXTENDED_PAIR(BgL_makezd2namezd2_2917, BgL_largsz00_981, BgL_auxz00_3479); } 
return BgL_res4542z00_2210;}  else 
{ /* Expand/object.scm 210 */
return 
MAKE_PAIR(BgL_makezd2namezd2_2917, BgL_largsz00_981);} } } } } 
}



/* instantiate->fill */
obj_t BGl_instantiatezd2ze3fillz31zzexpand_objectz00(obj_t BgL_formz00_22, obj_t BgL_classz00_23, obj_t BgL_allocz00_24, obj_t BgL_ez00_25)
{ AN_OBJECT;
{ /* Expand/object.scm 218 */
{ /* Expand/object.scm 219 */
obj_t BgL_slotsz00_990;
BgL_slotsz00_990 = 
BGl_tclasszd2allzd2slotsz00zzobject_classz00(
(BgL_tclassz00_bglt)(BgL_classz00_23)); 
{ /* Expand/object.scm 219 */
long BgL_lenz00_991;
BgL_lenz00_991 = 
bgl_list_length(BgL_slotsz00_990); 
{ /* Expand/object.scm 220 */
obj_t BgL_vargsz00_992;
{ /* Expand/object.scm 221 */
obj_t BgL_auxz00_3488;int BgL_auxz00_3486;
BgL_auxz00_3488 = BUNSPEC; 
BgL_auxz00_3486 = 
(int)(BgL_lenz00_991); 
BgL_vargsz00_992 = 
make_vector(BgL_auxz00_3486, BgL_auxz00_3488); } 
{ /* Expand/object.scm 221 */
obj_t BgL_newz00_993;
BgL_newz00_993 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)12)), BEOA); 
{ /* Expand/object.scm 222 */
obj_t BgL_providedz00_994;
BgL_providedz00_994 = 
CDR(BgL_formz00_22); 
{ /* Expand/object.scm 223 */

{ 
long BgL_iz00_995;obj_t BgL_slotsz00_996;
BgL_iz00_995 = ((long)0); 
BgL_slotsz00_996 = BgL_slotsz00_990; 
BgL_loopz00_997:
if(
NULLP(BgL_slotsz00_996))
{ /* Expand/object.scm 227 */
CNST_TABLE_REF(((long)13)); }  else 
{ /* Expand/object.scm 229 */
obj_t BgL_sz00_999;
BgL_sz00_999 = 
CAR(BgL_slotsz00_996); 
{ /* Expand/object.scm 231 */
bool_t BgL_test2438z00_1000;
BgL_test2438z00_1000 = 
BGl_slotzd2defaultzf3z21zzobject_slotsz00(
(BgL_slotz00_bglt)(BgL_sz00_999)); 
if(BgL_test2438z00_1000)
{ /* Expand/object.scm 231 */
{ /* Expand/object.scm 232 */
obj_t BgL_arg2440z00_1001;
{ /* Expand/object.scm 232 */
obj_t BgL_auxz00_3501;
{ /* Expand/object.scm 232 */
BgL_slotz00_bglt BgL_obj1753z00_2215;
BgL_obj1753z00_2215 = 
(BgL_slotz00_bglt)(BgL_sz00_999); 
BgL_auxz00_3501 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1753z00_2215))->BgL_defaultzd2valuezd2); } 
BgL_arg2440z00_1001 = 
MAKE_PAIR(BTRUE, BgL_auxz00_3501); } 
{ /* Expand/object.scm 232 */
int BgL_kz00_2217;
BgL_kz00_2217 = 
(int)(BgL_iz00_995); 
VECTOR_SET(BgL_vargsz00_992,BgL_kz00_2217,BgL_arg2440z00_1001); } } }  else 
{ /* Expand/object.scm 231 */
{ /* Expand/object.scm 234 */
obj_t BgL_arg2447z00_1003;
BgL_arg2447z00_1003 = 
MAKE_PAIR(BFALSE, BUNSPEC); 
{ /* Expand/object.scm 234 */
int BgL_kz00_2220;
BgL_kz00_2220 = 
(int)(BgL_iz00_995); 
VECTOR_SET(BgL_vargsz00_992,BgL_kz00_2220,BgL_arg2447z00_1003); } } } } 
{ 
obj_t BgL_slotsz00_3512;long BgL_iz00_3510;
BgL_iz00_3510 = 
(BgL_iz00_995+((long)1)); 
BgL_slotsz00_3512 = 
CDR(BgL_slotsz00_996); 
BgL_slotsz00_996 = BgL_slotsz00_3512; 
BgL_iz00_995 = BgL_iz00_3510; 
goto BgL_loopz00_997;} } } 
{ 
obj_t BgL_providedz00_1006;
BgL_providedz00_1006 = BgL_providedz00_994; 
BgL_loopz00_1007:
if(
NULLP(BgL_providedz00_1006))
{ /* Expand/object.scm 239 */
CNST_TABLE_REF(((long)13)); }  else 
{ /* Expand/object.scm 241 */
obj_t BgL_pz00_1009;
BgL_pz00_1009 = 
CAR(BgL_providedz00_1006); 
{ 
obj_t BgL_szd2namezd2_1013;obj_t BgL_lenz00_1014;obj_t BgL_valuez00_1015;obj_t BgL_szd2namezd2_1010;obj_t BgL_valuez00_1011;
if(
PAIRP(BgL_pz00_1009))
{ /* Expand/object.scm 242 */
obj_t BgL_carzd2173zd2_1020;obj_t BgL_cdrzd2174zd2_1021;
BgL_carzd2173zd2_1020 = 
CAR(BgL_pz00_1009); 
BgL_cdrzd2174zd2_1021 = 
CDR(BgL_pz00_1009); 
if(
SYMBOLP(BgL_carzd2173zd2_1020))
{ /* Expand/object.scm 242 */
if(
PAIRP(BgL_cdrzd2174zd2_1021))
{ /* Expand/object.scm 242 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2174zd2_1021), BNIL))
{ /* Expand/object.scm 242 */
BgL_szd2namezd2_1010 = BgL_carzd2173zd2_1020; 
BgL_valuez00_1011 = 
CAR(BgL_cdrzd2174zd2_1021); 
{ /* Expand/object.scm 245 */
obj_t BgL_pvalz00_1049;
{ /* Expand/object.scm 246 */
obj_t BgL_arg2534z00_1051;
BgL_arg2534z00_1051 = 
BGl_findzd2slotzd2offsetz00zzexpand_objectz00(BgL_slotsz00_990, BgL_szd2namezd2_1010, BGl_string4849z00zzexpand_objectz00, BgL_pz00_1009); 
{ /* Expand/object.scm 245 */
int BgL_kz00_2252;
BgL_kz00_2252 = 
CINT(BgL_arg2534z00_1051); 
BgL_pvalz00_1049 = 
VECTOR_REF(BgL_vargsz00_992,BgL_kz00_2252); } } 
SET_CAR(BgL_pvalz00_1049, BTRUE); 
{ /* Expand/object.scm 251 */
obj_t BgL_arg2530z00_1050;
BgL_arg2530z00_1050 = 
BGl_objectzd2epairifyzd2zzexpand_objectz00(BgL_valuez00_1011, BgL_pz00_1009); 
SET_CDR(BgL_pvalz00_1049, BgL_arg2530z00_1050); } } }  else 
{ /* Expand/object.scm 242 */
if(
SYMBOLP(BgL_carzd2173zd2_1020))
{ /* Expand/object.scm 242 */
obj_t BgL_cdrzd2201zd2_1029;
BgL_cdrzd2201zd2_1029 = 
CDR(BgL_cdrzd2174zd2_1021); 
if(
PAIRP(BgL_cdrzd2201zd2_1029))
{ /* Expand/object.scm 242 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2201zd2_1029), BNIL))
{ /* Expand/object.scm 242 */
BgL_szd2namezd2_1013 = BgL_carzd2173zd2_1020; 
BgL_lenz00_1014 = 
CAR(BgL_cdrzd2174zd2_1021); 
BgL_valuez00_1015 = 
CAR(BgL_cdrzd2201zd2_1029); 
BgL_tagzd2165zd2_1016:
{ /* Expand/object.scm 254 */
obj_t BgL_snumz00_1052;
BgL_snumz00_1052 = 
BGl_findzd2slotzd2offsetz00zzexpand_objectz00(BgL_slotsz00_990, BgL_szd2namezd2_1013, BGl_string4849z00zzexpand_objectz00, BgL_pz00_1009); 
{ /* Expand/object.scm 258 */

{ /* Expand/object.scm 259 */
bool_t BgL_testz00_3545;
{ /* Expand/object.scm 259 */
BgL_slotz00_bglt BgL_obj1764z00_2257;
{ /* Expand/object.scm 259 */
obj_t BgL_auxz00_3546;
BgL_auxz00_3546 = 
bgl_list_ref(BgL_slotsz00_990, 
(long)CINT(BgL_snumz00_1052)); 
BgL_obj1764z00_2257 = 
(BgL_slotz00_bglt)(BgL_auxz00_3546); } 
{ /* Expand/object.scm 259 */
obj_t BgL_auxz00_3550;
BgL_auxz00_3550 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1764z00_2257))->BgL_indexedz00); 
BgL_testz00_3545 = 
CBOOL(BgL_auxz00_3550); } } 
if(BgL_testz00_3545)
{ /* Expand/object.scm 261 */
obj_t BgL_pvalz00_1055;
{ /* Expand/object.scm 261 */
int BgL_kz00_2259;
BgL_kz00_2259 = 
CINT(BgL_snumz00_1052); 
BgL_pvalz00_1055 = 
VECTOR_REF(BgL_vargsz00_992,BgL_kz00_2259); } 
{ /* Expand/object.scm 261 */
obj_t BgL_plenz00_1056;
{ /* Expand/object.scm 262 */
int BgL_kz00_2263;
{ /* Expand/object.scm 262 */
long BgL_auxz00_3555;
{ /* Expand/object.scm 262 */
long BgL_auxz00_3556;
BgL_auxz00_3556 = 
(long)CINT(BgL_snumz00_1052); 
BgL_auxz00_3555 = 
(BgL_auxz00_3556-((long)1)); } 
BgL_kz00_2263 = 
(int)(BgL_auxz00_3555); } 
BgL_plenz00_1056 = 
VECTOR_REF(BgL_vargsz00_992,BgL_kz00_2263); } 
{ /* Expand/object.scm 262 */

SET_CAR(BgL_pvalz00_1055, BTRUE); 
{ /* Expand/object.scm 264 */
obj_t BgL_arg2540z00_1057;
BgL_arg2540z00_1057 = 
BGl_objectzd2epairifyzd2zzexpand_objectz00(BgL_valuez00_1015, BgL_pz00_1009); 
SET_CDR(BgL_pvalz00_1055, BgL_arg2540z00_1057); } 
SET_CAR(BgL_plenz00_1056, BTRUE); 
SET_CDR(BgL_plenz00_1056, BgL_lenz00_1014); } } }  else 
{ /* Expand/object.scm 259 */
FAILURE(BFALSE,BGl_string4848z00zzexpand_objectz00,BgL_formz00_22);} } } } }  else 
{ /* Expand/object.scm 242 */
BgL_tagzd2166zd2_1017:
FAILURE(BFALSE,BGl_string4848z00zzexpand_objectz00,BgL_formz00_22);} }  else 
{ /* Expand/object.scm 242 */
goto BgL_tagzd2166zd2_1017;} }  else 
{ /* Expand/object.scm 242 */
goto BgL_tagzd2166zd2_1017;} } }  else 
{ /* Expand/object.scm 242 */
goto BgL_tagzd2166zd2_1017;} }  else 
{ /* Expand/object.scm 242 */
if(
SYMBOLP(BgL_carzd2173zd2_1020))
{ /* Expand/object.scm 242 */
if(
PAIRP(BgL_cdrzd2174zd2_1021))
{ /* Expand/object.scm 242 */
obj_t BgL_cdrzd2229zd2_1042;
BgL_cdrzd2229zd2_1042 = 
CDR(BgL_cdrzd2174zd2_1021); 
if(
PAIRP(BgL_cdrzd2229zd2_1042))
{ /* Expand/object.scm 242 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2229zd2_1042), BNIL))
{ 
obj_t BgL_valuez00_3583;obj_t BgL_lenz00_3581;obj_t BgL_szd2namezd2_3580;
BgL_szd2namezd2_3580 = BgL_carzd2173zd2_1020; 
BgL_lenz00_3581 = 
CAR(BgL_cdrzd2174zd2_1021); 
BgL_valuez00_3583 = 
CAR(BgL_cdrzd2229zd2_1042); 
BgL_valuez00_1015 = BgL_valuez00_3583; 
BgL_lenz00_1014 = BgL_lenz00_3581; 
BgL_szd2namezd2_1013 = BgL_szd2namezd2_3580; 
goto BgL_tagzd2165zd2_1016;}  else 
{ /* Expand/object.scm 242 */
goto BgL_tagzd2166zd2_1017;} }  else 
{ /* Expand/object.scm 242 */
goto BgL_tagzd2166zd2_1017;} }  else 
{ /* Expand/object.scm 242 */
goto BgL_tagzd2166zd2_1017;} }  else 
{ /* Expand/object.scm 242 */
goto BgL_tagzd2166zd2_1017;} } }  else 
{ /* Expand/object.scm 242 */
goto BgL_tagzd2166zd2_1017;} } 
{ 
obj_t BgL_providedz00_3585;
BgL_providedz00_3585 = 
CDR(BgL_providedz00_1006); 
BgL_providedz00_1006 = BgL_providedz00_3585; 
goto BgL_loopz00_1007;} } } 
{ 
long BgL_iz00_1060;obj_t BgL_sz00_1061;
BgL_iz00_1060 = ((long)0); 
BgL_sz00_1061 = BgL_slotsz00_990; 
BgL_loopz00_1062:
if(
(BgL_iz00_1060==BgL_lenz00_991))
{ /* Expand/object.scm 274 */
CNST_TABLE_REF(((long)14)); }  else 
{ /* Expand/object.scm 276 */
bool_t BgL_test2563z00_1064;
{ /* Expand/object.scm 276 */
bool_t BgL_test2585z00_1073;
{ /* Expand/object.scm 276 */
obj_t BgL_arg2592z00_1076;
{ /* Expand/object.scm 276 */
int BgL_kz00_2282;
BgL_kz00_2282 = 
(int)(BgL_iz00_1060); 
BgL_arg2592z00_1076 = 
VECTOR_REF(BgL_vargsz00_992,BgL_kz00_2282); } 
{ /* Expand/object.scm 276 */
obj_t BgL_auxz00_3592;
BgL_auxz00_3592 = 
CAR(BgL_arg2592z00_1076); 
BgL_test2585z00_1073 = 
CBOOL(BgL_auxz00_3592); } } 
if(BgL_test2585z00_1073)
{ /* Expand/object.scm 276 */
BgL_test2563z00_1064 = ((bool_t)0); }  else 
{ /* Expand/object.scm 277 */
bool_t BgL_test2586z00_1074;
{ /* Expand/object.scm 277 */
BgL_slotz00_bglt BgL_auxz00_3596;
{ /* Expand/object.scm 277 */
obj_t BgL_auxz00_3597;
BgL_auxz00_3597 = 
CAR(BgL_sz00_1061); 
BgL_auxz00_3596 = 
(BgL_slotz00_bglt)(BgL_auxz00_3597); } 
BgL_test2586z00_1074 = 
BGl_slotzd2virtualzf3z21zzobject_slotsz00(BgL_auxz00_3596); } 
if(BgL_test2586z00_1074)
{ /* Expand/object.scm 277 */
BgL_test2563z00_1064 = ((bool_t)0); }  else 
{ /* Expand/object.scm 277 */
BgL_test2563z00_1064 = ((bool_t)1); } } } 
if(BgL_test2563z00_1064)
{ /* Expand/object.scm 276 */
{ /* Expand/object.scm 280 */
obj_t BgL_arg2565z00_1065;
{ /* Expand/object.scm 280 */
obj_t BgL_arg2569z00_1067;
{ /* Expand/object.scm 282 */
obj_t BgL_auxz00_3603;
{ /* Expand/object.scm 282 */
BgL_slotz00_bglt BgL_obj1747z00_2286;
{ /* Expand/object.scm 282 */
obj_t BgL_auxz00_3604;
BgL_auxz00_3604 = 
CAR(BgL_sz00_1061); 
BgL_obj1747z00_2286 = 
(BgL_slotz00_bglt)(BgL_auxz00_3604); } 
BgL_auxz00_3603 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1747z00_2286))->BgL_idz00); } 
BgL_arg2569z00_1067 = 
SYMBOL_TO_STRING(BgL_auxz00_3603); } 
BgL_arg2565z00_1065 = 
string_append_3(BGl_string4850z00zzexpand_objectz00, BgL_arg2569z00_1067, BGl_string4851z00zzexpand_objectz00); } 
FAILURE(BFALSE,BgL_arg2565z00_1065,BgL_formz00_22);} }  else 
{ /* Expand/object.scm 276 */
{ 
obj_t BgL_sz00_3613;long BgL_iz00_3611;
BgL_iz00_3611 = 
(BgL_iz00_1060+((long)1)); 
BgL_sz00_3613 = 
CDR(BgL_sz00_1061); 
BgL_sz00_1061 = BgL_sz00_3613; 
BgL_iz00_1060 = BgL_iz00_3611; 
goto BgL_loopz00_1062;} } } } 
{ 
long BgL_iz00_1077;obj_t BgL_slotsz00_1078;obj_t BgL_largsz00_1079;obj_t BgL_virtualsz00_1080;
BgL_iz00_1077 = ((long)0); 
BgL_slotsz00_1078 = BgL_slotsz00_990; 
BgL_largsz00_1079 = BNIL; 
BgL_virtualsz00_1080 = BNIL; 
BgL_loopz00_1081:
if(
(BgL_iz00_1077==BgL_lenz00_991))
{ /* Expand/object.scm 292 */
if(
NULLP(BgL_virtualsz00_1080))
{ /* Expand/object.scm 294 */
obj_t BgL_arg2600z00_1084;
BgL_arg2600z00_1084 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_largsz00_1079); 
return 
PROCEDURE_L_ENTRY(BgL_allocz00_24)(BgL_allocz00_24, BgL_arg2600z00_1084);}  else 
{ /* Expand/object.scm 297 */
obj_t BgL_arg2604z00_1085;obj_t BgL_arg2605z00_1086;
BgL_arg2604z00_1085 = 
CNST_TABLE_REF(((long)2)); 
{ /* Expand/object.scm 295 */
obj_t BgL_arg2608z00_1087;obj_t BgL_arg2609z00_1088;
{ /* Expand/object.scm 295 */
obj_t BgL_arg2612z00_1089;
{ /* Expand/object.scm 295 */
obj_t BgL_arg2616z00_1091;
{ /* Expand/object.scm 295 */
obj_t BgL_arg2619z00_1092;
{ /* Expand/object.scm 295 */
obj_t BgL_arg2623z00_1094;
BgL_arg2623z00_1094 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_largsz00_1079); 
BgL_arg2619z00_1092 = 
PROCEDURE_L_ENTRY(BgL_allocz00_24)(BgL_allocz00_24, BgL_arg2623z00_1094); } 
BgL_arg2616z00_1091 = 
MAKE_PAIR(BgL_arg2619z00_1092, BNIL); } 
BgL_arg2612z00_1089 = 
MAKE_PAIR(BgL_newz00_993, BgL_arg2616z00_1091); } 
BgL_arg2608z00_1087 = 
MAKE_PAIR(BgL_arg2612z00_1089, BNIL); } 
{ /* Expand/object.scm 296 */
obj_t BgL_arg2627z00_1095;obj_t BgL_arg2628z00_1096;
BgL_arg2627z00_1095 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_virtualsz00_1080); 
BgL_arg2628z00_1096 = 
MAKE_PAIR(BgL_newz00_993, BNIL); 
BgL_arg2609z00_1088 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2627z00_1095, BgL_arg2628z00_1096); } 
BgL_arg2605z00_1086 = 
MAKE_PAIR(BgL_arg2608z00_1087, BgL_arg2609z00_1088); } 
return 
MAKE_PAIR(BgL_arg2604z00_1085, BgL_arg2605z00_1086);} }  else 
{ /* Expand/object.scm 298 */
obj_t BgL_valuez00_1097;
{ /* Expand/object.scm 298 */
obj_t BgL_arg2682z00_1117;
{ /* Expand/object.scm 298 */
obj_t BgL_arg2685z00_1118;
{ /* Expand/object.scm 298 */
int BgL_kz00_2298;
BgL_kz00_2298 = 
(int)(BgL_iz00_1077); 
BgL_arg2685z00_1118 = 
VECTOR_REF(BgL_vargsz00_992,BgL_kz00_2298); } 
BgL_arg2682z00_1117 = 
CDR(BgL_arg2685z00_1118); } 
BgL_valuez00_1097 = 
PROCEDURE_ENTRY(BgL_ez00_25)(BgL_ez00_25, BgL_arg2682z00_1117, BgL_ez00_25, BEOA); } 
{ /* Expand/object.scm 300 */
bool_t BgL_test2633z00_1098;
{ /* Expand/object.scm 300 */
BgL_slotz00_bglt BgL_auxz00_3639;
{ /* Expand/object.scm 300 */
obj_t BgL_auxz00_3640;
BgL_auxz00_3640 = 
CAR(BgL_slotsz00_1078); 
BgL_auxz00_3639 = 
(BgL_slotz00_bglt)(BgL_auxz00_3640); } 
BgL_test2633z00_1098 = 
BGl_slotzd2virtualzf3z21zzobject_slotsz00(BgL_auxz00_3639); } 
if(BgL_test2633z00_1098)
{ /* Expand/object.scm 300 */
{ /* Expand/object.scm 301 */
long BgL_arg2635z00_1099;obj_t BgL_arg2636z00_1100;obj_t BgL_arg2637z00_1101;
BgL_arg2635z00_1099 = 
(BgL_iz00_1077+((long)1)); 
BgL_arg2636z00_1100 = 
CDR(BgL_slotsz00_1078); 
if(
(BgL_valuez00_1097==BUNSPEC))
{ /* Expand/object.scm 304 */
BgL_arg2637z00_1101 = BgL_virtualsz00_1080; }  else 
{ /* Expand/object.scm 306 */
bool_t BgL_test2642z00_1103;
BgL_test2642z00_1103 = 
EXTENDED_PAIRP(BgL_valuez00_1097); 
if(BgL_test2642z00_1103)
{ /* Expand/object.scm 307 */
obj_t BgL_arg2644z00_1104;obj_t BgL_arg2645z00_1105;
BgL_arg2644z00_1104 = 
BGl_makezd2virtualzd2setz00zzexpand_objectz00(
CAR(BgL_slotsz00_1078), BgL_valuez00_1097, BgL_newz00_993, BgL_classz00_23, BgL_formz00_22, "instantiate"); 
BgL_arg2645z00_1105 = 
CER(BgL_valuez00_1097); 
{ /* Expand/object.scm 307 */
obj_t BgL_res4544z00_2310;
BgL_res4544z00_2310 = 
MAKE_EXTENDED_PAIR(BgL_arg2644z00_1104, BgL_virtualsz00_1080, BgL_arg2645z00_1105); 
BgL_arg2637z00_1101 = BgL_res4544z00_2310; } }  else 
{ /* Expand/object.scm 315 */
obj_t BgL_arg2654z00_1108;
BgL_arg2654z00_1108 = 
BGl_makezd2virtualzd2setz00zzexpand_objectz00(
CAR(BgL_slotsz00_1078), BgL_valuez00_1097, BgL_newz00_993, BgL_classz00_23, BgL_formz00_22, "instantiate"); 
BgL_arg2637z00_1101 = 
MAKE_PAIR(BgL_arg2654z00_1108, BgL_virtualsz00_1080); } } 
{ 
obj_t BgL_virtualsz00_3660;obj_t BgL_slotsz00_3659;long BgL_iz00_3658;
BgL_iz00_3658 = BgL_arg2635z00_1099; 
BgL_slotsz00_3659 = BgL_arg2636z00_1100; 
BgL_virtualsz00_3660 = BgL_arg2637z00_1101; 
BgL_virtualsz00_1080 = BgL_virtualsz00_3660; 
BgL_slotsz00_1078 = BgL_slotsz00_3659; 
BgL_iz00_1077 = BgL_iz00_3658; 
goto BgL_loopz00_1081;} } }  else 
{ /* Expand/object.scm 300 */
{ /* Expand/object.scm 323 */
long BgL_arg2664z00_1111;obj_t BgL_arg2665z00_1112;obj_t BgL_arg2666z00_1113;
BgL_arg2664z00_1111 = 
(BgL_iz00_1077+((long)1)); 
BgL_arg2665z00_1112 = 
CDR(BgL_slotsz00_1078); 
{ /* Expand/object.scm 325 */
bool_t BgL_test2670z00_1114;
BgL_test2670z00_1114 = 
EXTENDED_PAIRP(BgL_valuez00_1097); 
if(BgL_test2670z00_1114)
{ /* Expand/object.scm 326 */
obj_t BgL_res4545z00_2320;
{ /* Expand/object.scm 326 */
obj_t BgL_auxz00_3665;
BgL_auxz00_3665 = 
CER(BgL_valuez00_1097); 
BgL_res4545z00_2320 = 
MAKE_EXTENDED_PAIR(BgL_valuez00_1097, BgL_largsz00_1079, BgL_auxz00_3665); } 
BgL_arg2666z00_1113 = BgL_res4545z00_2320; }  else 
{ /* Expand/object.scm 325 */
BgL_arg2666z00_1113 = 
MAKE_PAIR(BgL_valuez00_1097, BgL_largsz00_1079); } } 
{ 
obj_t BgL_largsz00_3671;obj_t BgL_slotsz00_3670;long BgL_iz00_3669;
BgL_iz00_3669 = BgL_arg2664z00_1111; 
BgL_slotsz00_3670 = BgL_arg2665z00_1112; 
BgL_largsz00_3671 = BgL_arg2666z00_1113; 
BgL_largsz00_1079 = BgL_largsz00_3671; 
BgL_slotsz00_1078 = BgL_slotsz00_3670; 
BgL_iz00_1077 = BgL_iz00_3669; 
goto BgL_loopz00_1081;} } } } } } } } } } } } } 
}



/* expand-co-instantiate */
obj_t BGl_expandzd2cozd2instantiatez00zzexpand_objectz00(obj_t BgL_xz00_26, obj_t BgL_ez00_27)
{ AN_OBJECT;
{ /* Expand/object.scm 333 */
{ 

if(
PAIRP(BgL_xz00_26))
{ /* Expand/object.scm 334 */
obj_t BgL_cdrzd2249zd2_1127;
BgL_cdrzd2249zd2_1127 = 
CDR(BgL_xz00_26); 
{ /* Expand/object.scm 334 */
bool_t BgL_testz00_3675;
{ /* Expand/object.scm 334 */
obj_t BgL_auxz00_3678;obj_t BgL_auxz00_3676;
BgL_auxz00_3678 = 
CNST_TABLE_REF(((long)15)); 
BgL_auxz00_3676 = 
CAR(BgL_xz00_26); 
BgL_testz00_3675 = 
(BgL_auxz00_3676==BgL_auxz00_3678); } 
if(BgL_testz00_3675)
{ /* Expand/object.scm 334 */
if(
PAIRP(BgL_cdrzd2249zd2_1127))
{ /* Expand/object.scm 334 */
obj_t BgL_arg2720z00_2329;
BgL_arg2720z00_2329 = 
BGl_cozd2instantiatezd2ze3letze3zzexpand_objectz00(
CAR(BgL_cdrzd2249zd2_1127), 
CDR(BgL_cdrzd2249zd2_1127), BgL_xz00_26, BgL_ez00_27); 
return 
BGl_replacez12z12zztools_miscz00(BgL_xz00_26, BgL_arg2720z00_2329);}  else 
{ /* Expand/object.scm 334 */
BgL_tagzd2242zd2_1124:
FAILURE(BFALSE,BGl_string4852z00zzexpand_objectz00,BgL_xz00_26);} }  else 
{ /* Expand/object.scm 334 */
goto BgL_tagzd2242zd2_1124;} } }  else 
{ /* Expand/object.scm 334 */
goto BgL_tagzd2242zd2_1124;} } } 
}



/* _expand-co-instantiate */
obj_t BGl__expandzd2cozd2instantiatez00zzexpand_objectz00(obj_t BgL_envz00_2919, obj_t BgL_xz00_2920, obj_t BgL_ez00_2921)
{ AN_OBJECT;
{ /* Expand/object.scm 333 */
return 
BGl_expandzd2cozd2instantiatez00zzexpand_objectz00(BgL_xz00_2920, BgL_ez00_2921);} 
}



/* co-instantiate->let */
obj_t BGl_cozd2instantiatezd2ze3letze3zzexpand_objectz00(obj_t BgL_bindingsz00_28, obj_t BgL_bodyz00_29, obj_t BgL_xz00_30, obj_t BgL_ez00_31)
{ AN_OBJECT;
{ /* Expand/object.scm 343 */
{ 
obj_t BgL_exprz00_1265;obj_t BgL_bdgz00_1266;obj_t BgL_locz00_1267;
{ /* Expand/object.scm 369 */
obj_t BgL_locz00_1136;
BgL_locz00_1136 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_xz00_30); 
{ 
obj_t BgL_bindingsz00_1137;obj_t BgL_userzd2variableszd2_1138;obj_t BgL_privatezd2variableszd2_1139;obj_t BgL_rewritezd2bindingszd2_1140;obj_t BgL_classesz00_1141;obj_t BgL_instantiatesz00_1142;
BgL_bindingsz00_1137 = BgL_bindingsz00_28; 
BgL_userzd2variableszd2_1138 = BNIL; 
BgL_privatezd2variableszd2_1139 = BNIL; 
BgL_rewritezd2bindingszd2_1140 = BNIL; 
BgL_classesz00_1141 = BNIL; 
BgL_instantiatesz00_1142 = BNIL; 
BgL_loopz00_1143:
if(
NULLP(BgL_bindingsz00_1137))
{ /* Expand/object.scm 378 */
obj_t BgL_e1z00_2922;
{ 
int BgL_auxz00_3694;int BgL_auxz00_3692;
BgL_auxz00_3694 = 
(int)(((long)2)); 
BgL_auxz00_3692 = 
(int)(((long)2)); 
BgL_e1z00_2922 = 
make_fx_procedure(BGl_e1z00zzexpand_objectz00, BgL_auxz00_3692, BgL_auxz00_3694); } 
{ /* Expand/object.scm 378 */
int BgL_auxz00_3697;
BgL_auxz00_3697 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_e1z00_2922, BgL_auxz00_3697, BgL_ez00_31); } 
{ /* Expand/object.scm 378 */
int BgL_auxz00_3700;
BgL_auxz00_3700 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_e1z00_2922, BgL_auxz00_3700, BgL_rewritezd2bindingszd2_1140); } 
{ /* Expand/object.scm 388 */
obj_t BgL_arg2727z00_1146;obj_t BgL_arg2728z00_1147;
BgL_arg2727z00_1146 = 
CNST_TABLE_REF(((long)2)); 
{ /* Expand/object.scm 388 */
obj_t BgL_arg2731z00_1148;obj_t BgL_arg2732z00_1149;
if(
NULLP(BgL_privatezd2variableszd2_1139))
{ /* Expand/object.scm 388 */
BgL_arg2731z00_1148 = BNIL; }  else 
{ /* Expand/object.scm 388 */
obj_t BgL_head1818z00_1153;
BgL_head1818z00_1153 = 
MAKE_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_ll1816z00_1154;obj_t BgL_ll1817z00_1155;obj_t BgL_tail1819z00_1156;
BgL_ll1816z00_1154 = BgL_privatezd2variableszd2_1139; 
BgL_ll1817z00_1155 = BgL_classesz00_1141; 
BgL_tail1819z00_1156 = BgL_head1818z00_1153; 
BgL_lname1821z00_1157:
if(
NULLP(BgL_ll1816z00_1154))
{ /* Expand/object.scm 388 */
BgL_arg2731z00_1148 = 
CDR(BgL_head1818z00_1153); }  else 
{ /* Expand/object.scm 389 */
obj_t BgL_newtail1820z00_1159;
{ /* Expand/object.scm 389 */
obj_t BgL_arg2746z00_1162;
{ /* Expand/object.scm 389 */
obj_t BgL_cidz00_1166;
{ /* Expand/object.scm 389 */
BgL_typez00_bglt BgL_obj1626z00_2342;
{ /* Expand/object.scm 389 */
obj_t BgL_auxz00_3710;
BgL_auxz00_3710 = 
CAR(BgL_ll1817z00_1155); 
BgL_obj1626z00_2342 = 
(BgL_typez00_bglt)(BgL_auxz00_3710); } 
BgL_cidz00_1166 = 
(((BgL_typez00_bglt)CREF(BgL_obj1626z00_2342))->BgL_idz00); } 
{ /* Expand/object.scm 389 */
obj_t BgL_tvz00_1167;
BgL_tvz00_1167 = 
BGl_makezd2typedzd2identz00zzast_identz00(
CAR(BgL_ll1816z00_1154), BgL_cidz00_1166); 
{ /* Expand/object.scm 390 */

{ /* Expand/object.scm 391 */
obj_t BgL_arg2750z00_1168;
{ /* Expand/object.scm 391 */
obj_t BgL_arg2753z00_1169;
{ /* Expand/object.scm 391 */
obj_t BgL_arg2757z00_1171;
{ /* Expand/object.scm 391 */
obj_t BgL_list2761z00_1173;
{ /* Expand/object.scm 391 */
obj_t BgL_arg2763z00_1174;obj_t BgL_arg2764z00_1175;
BgL_arg2763z00_1174 = 
CNST_TABLE_REF(((long)17)); 
BgL_arg2764z00_1175 = 
MAKE_PAIR(BgL_cidz00_1166, BNIL); 
BgL_list2761z00_1173 = 
MAKE_PAIR(BgL_arg2763z00_1174, BgL_arg2764z00_1175); } 
BgL_arg2757z00_1171 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2761z00_1173); } 
BgL_arg2753z00_1169 = 
MAKE_PAIR(BgL_arg2757z00_1171, BNIL); } 
BgL_arg2750z00_1168 = 
MAKE_PAIR(BgL_arg2753z00_1169, BNIL); } 
BgL_arg2746z00_1162 = 
MAKE_PAIR(BgL_tvz00_1167, BgL_arg2750z00_1168); } } } } 
BgL_newtail1820z00_1159 = 
MAKE_PAIR(BgL_arg2746z00_1162, BNIL); } 
SET_CDR(BgL_tail1819z00_1156, BgL_newtail1820z00_1159); 
{ 
obj_t BgL_tail1819z00_3729;obj_t BgL_ll1817z00_3727;obj_t BgL_ll1816z00_3725;
BgL_ll1816z00_3725 = 
CDR(BgL_ll1816z00_1154); 
BgL_ll1817z00_3727 = 
CDR(BgL_ll1817z00_1155); 
BgL_tail1819z00_3729 = BgL_newtail1820z00_1159; 
BgL_tail1819z00_1156 = BgL_tail1819z00_3729; 
BgL_ll1817z00_1155 = BgL_ll1817z00_3727; 
BgL_ll1816z00_1154 = BgL_ll1816z00_3725; 
goto BgL_lname1821z00_1157;} } } } 
{ /* Expand/object.scm 394 */
obj_t BgL_arg2775z00_1176;
{ /* Expand/object.scm 394 */
obj_t BgL_arg2779z00_1178;obj_t BgL_arg2780z00_1179;
BgL_arg2779z00_1178 = 
CNST_TABLE_REF(((long)2)); 
{ /* Expand/object.scm 396 */
obj_t BgL_arg2783z00_1180;obj_t BgL_arg2784z00_1181;
{ /* Expand/object.scm 396 */
obj_t BgL_arg2787z00_1182;
{ /* Expand/object.scm 396 */
obj_t BgL_zc3anonymousza32803ze3z83_2924;
{ 
int BgL_auxz00_3733;int BgL_auxz00_3731;
BgL_auxz00_3733 = 
(int)(((long)3)); 
BgL_auxz00_3731 = 
(int)(((long)4)); 
BgL_zc3anonymousza32803ze3z83_2924 = 
make_fx_procedure(BGl_zc3anonymousza32803ze3z83zzexpand_objectz00, BgL_auxz00_3731, BgL_auxz00_3733); } 
{ /* Expand/object.scm 396 */
int BgL_auxz00_3736;
BgL_auxz00_3736 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32803ze3z83_2924, BgL_auxz00_3736, BgL_ez00_31); } 
{ /* Expand/object.scm 396 */
int BgL_auxz00_3739;
BgL_auxz00_3739 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_zc3anonymousza32803ze3z83_2924, BgL_auxz00_3739, BgL_rewritezd2bindingszd2_1140); } 
{ /* Expand/object.scm 396 */
int BgL_auxz00_3742;
BgL_auxz00_3742 = 
(int)(((long)2)); 
PROCEDURE_SET(BgL_zc3anonymousza32803ze3z83_2924, BgL_auxz00_3742, BgL_e1z00_2922); } 
{ /* Expand/object.scm 395 */
obj_t BgL_list2792z00_1184;
{ /* Expand/object.scm 395 */
obj_t BgL_arg2794z00_1185;
{ /* Expand/object.scm 395 */
obj_t BgL_arg2797z00_1186;
{ /* Expand/object.scm 395 */
obj_t BgL_arg2800z00_1187;
BgL_arg2800z00_1187 = 
MAKE_PAIR(BgL_instantiatesz00_1142, BNIL); 
BgL_arg2797z00_1186 = 
MAKE_PAIR(BgL_classesz00_1141, BgL_arg2800z00_1187); } 
BgL_arg2794z00_1185 = 
MAKE_PAIR(BgL_privatezd2variableszd2_1139, BgL_arg2797z00_1186); } 
BgL_list2792z00_1184 = 
MAKE_PAIR(BgL_userzd2variableszd2_1138, BgL_arg2794z00_1185); } 
BgL_arg2787z00_1182 = 
BGl_mapz00zz__r4_control_features_6_9z00(BgL_zc3anonymousza32803ze3z83_2924, BgL_list2792z00_1184); } } 
BgL_arg2783z00_1180 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_arg2787z00_1182); } 
{ /* Expand/object.scm 408 */
obj_t BgL_arg2833z00_1209;
{ /* Expand/object.scm 408 */
obj_t BgL_arg2837z00_1211;
{ /* Expand/object.scm 408 */
obj_t BgL_auxz00_3753;obj_t BgL_auxz00_3751;
BgL_auxz00_3753 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_bodyz00_29, BNIL); 
BgL_auxz00_3751 = 
CNST_TABLE_REF(((long)18)); 
BgL_arg2837z00_1211 = 
MAKE_PAIR(BgL_auxz00_3751, BgL_auxz00_3753); } 
BgL_arg2833z00_1209 = 
PROCEDURE_ENTRY(BgL_ez00_31)(BgL_ez00_31, BgL_arg2837z00_1211, BgL_ez00_31, BEOA); } 
BgL_arg2784z00_1181 = 
MAKE_PAIR(BgL_arg2833z00_1209, BNIL); } 
BgL_arg2780z00_1179 = 
MAKE_PAIR(BgL_arg2783z00_1180, BgL_arg2784z00_1181); } 
BgL_arg2775z00_1176 = 
MAKE_PAIR(BgL_arg2779z00_1178, BgL_arg2780z00_1179); } 
BgL_arg2732z00_1149 = 
MAKE_PAIR(BgL_arg2775z00_1176, BNIL); } 
BgL_arg2728z00_1147 = 
MAKE_PAIR(BgL_arg2731z00_1148, BgL_arg2732z00_1149); } 
return 
MAKE_PAIR(BgL_arg2727z00_1146, BgL_arg2728z00_1147);} }  else 
{ 
obj_t BgL_varz00_1235;obj_t BgL_exprz00_1236;
{ /* Expand/object.scm 409 */
obj_t BgL_ezd2280zd2_1239;
BgL_ezd2280zd2_1239 = 
CAR(BgL_bindingsz00_1137); 
if(
PAIRP(BgL_ezd2280zd2_1239))
{ /* Expand/object.scm 409 */
obj_t BgL_carzd2285zd2_1241;obj_t BgL_cdrzd2286zd2_1242;
BgL_carzd2285zd2_1241 = 
CAR(BgL_ezd2280zd2_1239); 
BgL_cdrzd2286zd2_1242 = 
CDR(BgL_ezd2280zd2_1239); 
if(
SYMBOLP(BgL_carzd2285zd2_1241))
{ /* Expand/object.scm 409 */
if(
PAIRP(BgL_cdrzd2286zd2_1242))
{ /* Expand/object.scm 409 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2286zd2_1242), BNIL))
{ /* Expand/object.scm 409 */
BgL_varz00_1235 = BgL_carzd2285zd2_1241; 
BgL_exprz00_1236 = 
CAR(BgL_cdrzd2286zd2_1242); 
{ /* Expand/object.scm 411 */
obj_t BgL_bdgz00_1249;
BgL_bdgz00_1249 = 
CAR(BgL_bindingsz00_1137); 
{ /* Expand/object.scm 411 */
obj_t BgL_locz00_1250;
BgL_locz00_1250 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_bdgz00_1249, BgL_xz00_30); 
{ /* Expand/object.scm 412 */
obj_t BgL_idze2typeze2_1251;
BgL_idze2typeze2_1251 = 
BGl_parsezd2idzd2zzast_identz00(BgL_varz00_1235, BgL_locz00_1250); 
{ /* Expand/object.scm 413 */
obj_t BgL_idz00_1252;
BgL_idz00_1252 = 
CAR(BgL_idze2typeze2_1251); 
{ /* Expand/object.scm 415 */
obj_t BgL_privz00_1254;
BgL_privz00_1254 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, BEOA); 
{ /* Expand/object.scm 416 */
obj_t BgL_kclassz00_1255;
BgL_exprz00_1265 = BgL_exprz00_1236; 
BgL_bdgz00_1266 = BgL_bdgz00_1249; 
BgL_locz00_1267 = BgL_locz00_1250; 
{ 
obj_t BgL_instantiatez00_1269;obj_t BgL_bodyz00_1270;
if(
PAIRP(BgL_exprz00_1265))
{ /* Expand/object.scm 368 */
BgL_instantiatez00_1269 = 
CAR(BgL_exprz00_1265); 
BgL_bodyz00_1270 = 
CDR(BgL_exprz00_1265); 
{ /* Expand/object.scm 347 */
obj_t BgL_locz00_1277;
BgL_locz00_1277 = 
BGl_findzd2locationzf2locz20zztools_locationz00(BgL_bodyz00_1270, BgL_locz00_1267); 
{ /* Expand/object.scm 347 */
obj_t BgL_idze2typeze2_1278;
BgL_idze2typeze2_1278 = 
BGl_parsezd2idzd2zzast_identz00(BgL_instantiatez00_1269, BgL_locz00_1277); 
{ /* Expand/object.scm 348 */
obj_t BgL_kclassz00_1279;
BgL_kclassz00_1279 = 
CDR(BgL_idze2typeze2_1278); 
{ /* Expand/object.scm 349 */

{ /* Expand/object.scm 351 */
bool_t BgL_testz00_3787;
{ /* Expand/object.scm 351 */
obj_t BgL_auxz00_3790;obj_t BgL_auxz00_3788;
BgL_auxz00_3790 = 
CNST_TABLE_REF(((long)16)); 
BgL_auxz00_3788 = 
CAR(BgL_idze2typeze2_1278); 
BgL_testz00_3787 = 
(BgL_auxz00_3788==BgL_auxz00_3790); } 
if(BgL_testz00_3787)
{ /* Expand/object.scm 355 */
bool_t BgL_test2944z00_1281;
BgL_test2944z00_1281 = 
BGl_iszd2azf3z21zz__objectz00(BgL_kclassz00_1279, BGl_tclassz00zzobject_classz00); 
if(BgL_test2944z00_1281)
{ /* Expand/object.scm 359 */
bool_t BgL_testz00_3795;
{ /* Expand/object.scm 359 */
BgL_tclassz00_bglt BgL_obj1625z00_2382;
BgL_obj1625z00_2382 = 
(BgL_tclassz00_bglt)(BgL_kclassz00_1279); 
{ 
obj_t BgL_auxz00_3797;
{ /* Expand/object.scm 359 */
BgL_objectz00_bglt BgL_auxz00_3798;
BgL_auxz00_3798 = 
(BgL_objectz00_bglt)(BgL_obj1625z00_2382); 
BgL_auxz00_3797 = 
BGL_OBJECT_WIDENING(BgL_auxz00_3798); } 
BgL_testz00_3795 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_3797))->BgL_abstractzf3zf3); } } 
if(BgL_testz00_3795)
{ /* Expand/object.scm 359 */
FAILURE(BFALSE,BGl_string4853z00zzexpand_objectz00,BgL_bdgz00_1266);}  else 
{ /* Expand/object.scm 359 */
BgL_kclassz00_1255 = BgL_kclassz00_1279; } }  else 
{ /* Expand/object.scm 355 */
FAILURE(BFALSE,BGl_string4854z00zzexpand_objectz00,BgL_bdgz00_1266);} }  else 
{ /* Expand/object.scm 351 */
FAILURE(BFALSE,BGl_string4855z00zzexpand_objectz00,BgL_bdgz00_1266);} } } } } } }  else 
{ /* Expand/object.scm 368 */
FAILURE(BFALSE,BGl_string4855z00zzexpand_objectz00,BgL_bdgz00_1266);} } 
{ /* Expand/object.scm 417 */

{ /* Expand/object.scm 418 */
obj_t BgL_arg2903z00_1256;obj_t BgL_arg2904z00_1257;obj_t BgL_arg2905z00_1258;obj_t BgL_arg2906z00_1259;obj_t BgL_arg2907z00_1260;obj_t BgL_arg2908z00_1261;
BgL_arg2903z00_1256 = 
CDR(BgL_bindingsz00_1137); 
BgL_arg2904z00_1257 = 
MAKE_PAIR(BgL_varz00_1235, BgL_userzd2variableszd2_1138); 
BgL_arg2905z00_1258 = 
MAKE_PAIR(BgL_privz00_1254, BgL_privatezd2variableszd2_1139); 
{ /* Expand/object.scm 421 */
obj_t BgL_arg2914z00_1262;
BgL_arg2914z00_1262 = 
MAKE_PAIR(BgL_idz00_1252, BgL_privz00_1254); 
BgL_arg2906z00_1259 = 
MAKE_PAIR(BgL_arg2914z00_1262, BgL_rewritezd2bindingszd2_1140); } 
BgL_arg2907z00_1260 = 
MAKE_PAIR(BgL_kclassz00_1255, BgL_classesz00_1141); 
BgL_arg2908z00_1261 = 
MAKE_PAIR(BgL_exprz00_1236, BgL_instantiatesz00_1142); 
{ 
obj_t BgL_instantiatesz00_3820;obj_t BgL_classesz00_3819;obj_t BgL_rewritezd2bindingszd2_3818;obj_t BgL_privatezd2variableszd2_3817;obj_t BgL_userzd2variableszd2_3816;obj_t BgL_bindingsz00_3815;
BgL_bindingsz00_3815 = BgL_arg2903z00_1256; 
BgL_userzd2variableszd2_3816 = BgL_arg2904z00_1257; 
BgL_privatezd2variableszd2_3817 = BgL_arg2905z00_1258; 
BgL_rewritezd2bindingszd2_3818 = BgL_arg2906z00_1259; 
BgL_classesz00_3819 = BgL_arg2907z00_1260; 
BgL_instantiatesz00_3820 = BgL_arg2908z00_1261; 
BgL_instantiatesz00_1142 = BgL_instantiatesz00_3820; 
BgL_classesz00_1141 = BgL_classesz00_3819; 
BgL_rewritezd2bindingszd2_1140 = BgL_rewritezd2bindingszd2_3818; 
BgL_privatezd2variableszd2_1139 = BgL_privatezd2variableszd2_3817; 
BgL_userzd2variableszd2_1138 = BgL_userzd2variableszd2_3816; 
BgL_bindingsz00_1137 = BgL_bindingsz00_3815; 
goto BgL_loopz00_1143;} } } } } } } } } }  else 
{ /* Expand/object.scm 409 */
BgL_tagzd2279zd2_1238:
{ 
obj_t BgL_auxz00_3822;
BgL_auxz00_3822 = 
CAR(BgL_bindingsz00_1137); 
FAILURE(BFALSE,BGl_string4855z00zzexpand_objectz00,BgL_auxz00_3822);} } }  else 
{ /* Expand/object.scm 409 */
goto BgL_tagzd2279zd2_1238;} }  else 
{ /* Expand/object.scm 409 */
goto BgL_tagzd2279zd2_1238;} }  else 
{ /* Expand/object.scm 409 */
goto BgL_tagzd2279zd2_1238;} } } } } } } 
}



/* <anonymous:2803> */
obj_t BGl_zc3anonymousza32803ze3z83zzexpand_objectz00(obj_t BgL_envz00_2925, obj_t BgL_userz00_2929, obj_t BgL_privatez00_2930, obj_t BgL_classz00_2931, obj_t BgL_instantiatez00_2932)
{ AN_OBJECT;
{ /* Expand/object.scm 395 */
{ /* Expand/object.scm 396 */
obj_t BgL_e1z00_2928;
{ /* Expand/object.scm 396 */
int BgL_auxz00_3825;
BgL_auxz00_3825 = 
(int)(((long)2)); 
BgL_e1z00_2928 = 
PROCEDURE_REF(BgL_envz00_2925, BgL_auxz00_3825); } 
{ 
obj_t BgL_userz00_1188;obj_t BgL_privatez00_1189;obj_t BgL_classz00_1190;obj_t BgL_instantiatez00_1191;
BgL_userz00_1188 = BgL_userz00_2929; 
BgL_privatez00_1189 = BgL_privatez00_2930; 
BgL_classz00_1190 = BgL_classz00_2931; 
BgL_instantiatez00_1191 = BgL_instantiatez00_2932; 
{ /* Expand/object.scm 396 */
obj_t BgL_cidz00_1193;
{ /* Expand/object.scm 396 */
BgL_typez00_bglt BgL_obj1626z00_2349;
BgL_obj1626z00_2349 = 
(BgL_typez00_bglt)(BgL_classz00_1190); 
BgL_cidz00_1193 = 
(((BgL_typez00_bglt)CREF(BgL_obj1626z00_2349))->BgL_idz00); } 
{ /* Expand/object.scm 396 */
obj_t BgL_fillz00_1194;
{ /* Expand/object.scm 397 */
obj_t BgL_list2821z00_1204;
{ /* Expand/object.scm 397 */
obj_t BgL_arg2823z00_1205;obj_t BgL_arg2825z00_1206;
BgL_arg2823z00_1205 = 
CNST_TABLE_REF(((long)19)); 
{ /* Expand/object.scm 397 */
obj_t BgL_arg2828z00_1207;
{ /* Expand/object.scm 397 */
obj_t BgL_auxz00_3831;
BgL_auxz00_3831 = 
CNST_TABLE_REF(((long)20)); 
BgL_arg2828z00_1207 = 
MAKE_PAIR(BgL_auxz00_3831, BNIL); } 
BgL_arg2825z00_1206 = 
MAKE_PAIR(BgL_cidz00_1193, BgL_arg2828z00_1207); } 
BgL_list2821z00_1204 = 
MAKE_PAIR(BgL_arg2823z00_1205, BgL_arg2825z00_1206); } 
BgL_fillz00_1194 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2821z00_1204); } 
{ /* Expand/object.scm 399 */
obj_t BgL_allocz00_2923;
{ 
int BgL_auxz00_3837;
BgL_auxz00_3837 = 
(int)(((long)2)); 
BgL_allocz00_2923 = 
MAKE_L_PROCEDURE(BGl_allocz00zzexpand_objectz00, BgL_auxz00_3837); } 
{ /* Expand/object.scm 399 */
int BgL_auxz00_3840;
BgL_auxz00_3840 = 
(int)(((long)0)); 
PROCEDURE_L_SET(BgL_allocz00_2923, BgL_auxz00_3840, BgL_privatez00_1189); } 
{ /* Expand/object.scm 399 */
int BgL_auxz00_3843;
BgL_auxz00_3843 = 
(int)(((long)1)); 
PROCEDURE_L_SET(BgL_allocz00_2923, BgL_auxz00_3843, BgL_fillz00_1194); } 
{ /* Expand/object.scm 398 */

{ /* Expand/object.scm 400 */
obj_t BgL_arg2805z00_1196;
{ /* Expand/object.scm 400 */
obj_t BgL_arg2808z00_1197;
BgL_arg2808z00_1197 = 
BGl_instantiatezd2ze3fillz31zzexpand_objectz00(BgL_instantiatez00_1191, BgL_classz00_1190, BgL_allocz00_2923, BgL_e1z00_2928); 
BgL_arg2805z00_1196 = 
MAKE_PAIR(BgL_arg2808z00_1197, BNIL); } 
return 
MAKE_PAIR(BgL_userz00_1188, BgL_arg2805z00_1196);} } } } } } } } 
}



/* e1 */
obj_t BGl_e1z00zzexpand_objectz00(obj_t BgL_envz00_2933, obj_t BgL_xz00_2936, obj_t BgL__z00_2937)
{ AN_OBJECT;
{ /* Expand/object.scm 377 */
{ /* Expand/object.scm 378 */
obj_t BgL_ez00_2934;obj_t BgL_rewritezd2bindingszd2_2935;
{ /* Expand/object.scm 378 */
int BgL_auxz00_3849;
BgL_auxz00_3849 = 
(int)(((long)0)); 
BgL_ez00_2934 = 
PROCEDURE_REF(BgL_envz00_2933, BgL_auxz00_3849); } 
{ /* Expand/object.scm 378 */
int BgL_auxz00_3852;
BgL_auxz00_3852 = 
(int)(((long)1)); 
BgL_rewritezd2bindingszd2_2935 = 
PROCEDURE_REF(BgL_envz00_2933, BgL_auxz00_3852); } 
{ 
obj_t BgL_xz00_1214;obj_t BgL__z00_1215;
BgL_xz00_1214 = BgL_xz00_2936; 
BgL__z00_1215 = BgL__z00_2937; 
BgL_zc3anonymousza32845ze3z83_1216:
if(
SYMBOLP(BgL_xz00_1214))
{ /* Expand/object.scm 379 */
obj_t BgL_cellz00_1218;
BgL_cellz00_1218 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_xz00_1214, BgL_rewritezd2bindingszd2_2935); 
if(
PAIRP(BgL_cellz00_1218))
{ /* Expand/object.scm 380 */
return 
CDR(BgL_cellz00_1218);}  else 
{ /* Expand/object.scm 380 */
return BgL_xz00_1214;} }  else 
{ 

if(
PAIRP(BgL_xz00_1214))
{ /* Expand/object.scm 383 */
obj_t BgL_cdrzd2273zd2_1225;
BgL_cdrzd2273zd2_1225 = 
CDR(BgL_xz00_1214); 
{ /* Expand/object.scm 383 */
bool_t BgL_testz00_3864;
{ /* Expand/object.scm 383 */
obj_t BgL_auxz00_3867;obj_t BgL_auxz00_3865;
BgL_auxz00_3867 = 
CNST_TABLE_REF(((long)18)); 
BgL_auxz00_3865 = 
CAR(BgL_xz00_1214); 
BgL_testz00_3864 = 
(BgL_auxz00_3865==BgL_auxz00_3867); } 
if(BgL_testz00_3864)
{ /* Expand/object.scm 383 */
if(
PAIRP(BgL_cdrzd2273zd2_1225))
{ /* Expand/object.scm 383 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2273zd2_1225), BNIL))
{ 
obj_t BgL__z00_3877;obj_t BgL_xz00_3875;
BgL_xz00_3875 = 
CAR(BgL_cdrzd2273zd2_1225); 
BgL__z00_3877 = BgL_ez00_2934; 
BgL__z00_1215 = BgL__z00_3877; 
BgL_xz00_1214 = BgL_xz00_3875; 
goto BgL_zc3anonymousza32845ze3z83_1216;}  else 
{ /* Expand/object.scm 383 */
BgL_tagzd2268zd2_1222:
return 
PROCEDURE_ENTRY(BgL_ez00_2934)(BgL_ez00_2934, BgL_xz00_1214, BgL_ez00_2934, BEOA);} }  else 
{ /* Expand/object.scm 383 */
goto BgL_tagzd2268zd2_1222;} }  else 
{ /* Expand/object.scm 383 */
goto BgL_tagzd2268zd2_1222;} } }  else 
{ /* Expand/object.scm 383 */
goto BgL_tagzd2268zd2_1222;} } } } } 
}



/* alloc */
obj_t BGl_allocz00zzexpand_objectz00(obj_t BgL_envz00_2938, obj_t BgL_argsz00_2941)
{ AN_OBJECT;
{ /* Expand/object.scm 398 */
{ /* Expand/object.scm 399 */
obj_t BgL_privatez00_2939;obj_t BgL_fillz00_2940;
{ /* Expand/object.scm 399 */
int BgL_auxz00_3880;
BgL_auxz00_3880 = 
(int)(((long)0)); 
BgL_privatez00_2939 = 
PROCEDURE_L_REF(BgL_envz00_2938, BgL_auxz00_3880); } 
{ /* Expand/object.scm 399 */
int BgL_auxz00_3883;
BgL_auxz00_3883 = 
(int)(((long)1)); 
BgL_fillz00_2940 = 
PROCEDURE_L_REF(BgL_envz00_2938, BgL_auxz00_3883); } 
{ 
obj_t BgL_argsz00_1199;
BgL_argsz00_1199 = BgL_argsz00_2941; 
{ /* Expand/object.scm 399 */
obj_t BgL_arg2814z00_1201;
{ /* Expand/object.scm 399 */
obj_t BgL_auxz00_3886;
BgL_auxz00_3886 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_argsz00_1199, BNIL); 
BgL_arg2814z00_1201 = 
MAKE_PAIR(BgL_privatez00_2939, BgL_auxz00_3886); } 
return 
MAKE_PAIR(BgL_fillz00_2940, BgL_arg2814z00_1201);} } } } 
}



/* expand-duplicate */
obj_t BGl_expandzd2duplicatezd2zzexpand_objectz00(obj_t BgL_xz00_32, obj_t BgL_ez00_33)
{ AN_OBJECT;
{ /* Expand/object.scm 432 */
{ 
obj_t BgL_duplicatez00_1286;obj_t BgL_dupz00_1287;obj_t BgL_provz00_1288;
if(
PAIRP(BgL_xz00_32))
{ /* Expand/object.scm 433 */
obj_t BgL_cdrzd2303zd2_1293;
BgL_cdrzd2303zd2_1293 = 
CDR(BgL_xz00_32); 
if(
PAIRP(BgL_cdrzd2303zd2_1293))
{ /* Expand/object.scm 433 */
BgL_duplicatez00_1286 = 
CAR(BgL_xz00_32); 
BgL_dupz00_1287 = 
CAR(BgL_cdrzd2303zd2_1293); 
BgL_provz00_1288 = 
CDR(BgL_cdrzd2303zd2_1293); 
{ /* Expand/object.scm 435 */
obj_t BgL_idze2typeze2_1298;
{ /* Expand/object.scm 435 */
obj_t BgL_arg2999z00_1308;
BgL_arg2999z00_1308 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_xz00_32); 
BgL_idze2typeze2_1298 = 
BGl_parsezd2idzd2zzast_identz00(BgL_duplicatez00_1286, BgL_arg2999z00_1308); } 
{ /* Expand/object.scm 435 */
obj_t BgL_idz00_1299;
BgL_idz00_1299 = 
CAR(BgL_idze2typeze2_1298); 
{ /* Expand/object.scm 436 */
obj_t BgL_classz00_1300;
BgL_classz00_1300 = 
CDR(BgL_idze2typeze2_1298); 
{ /* Expand/object.scm 437 */

{ /* Expand/object.scm 439 */
bool_t BgL_test2975z00_1301;
BgL_test2975z00_1301 = 
BGl_iszd2azf3z21zz__objectz00(BgL_classz00_1300, BGl_tclassz00zzobject_classz00); 
if(BgL_test2975z00_1301)
{ /* Expand/object.scm 444 */
bool_t BgL_testz00_3901;
{ /* Expand/object.scm 444 */
BgL_tclassz00_bglt BgL_obj1625z00_2404;
BgL_obj1625z00_2404 = 
(BgL_tclassz00_bglt)(BgL_classz00_1300); 
{ 
obj_t BgL_auxz00_3903;
{ /* Expand/object.scm 444 */
BgL_objectz00_bglt BgL_auxz00_3904;
BgL_auxz00_3904 = 
(BgL_objectz00_bglt)(BgL_obj1625z00_2404); 
BgL_auxz00_3903 = 
BGL_OBJECT_WIDENING(BgL_auxz00_3904); } 
BgL_testz00_3901 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_3903))->BgL_abstractzf3zf3); } } 
if(BgL_testz00_3901)
{ /* Expand/object.scm 444 */
FAILURE(BFALSE,BGl_string4856z00zzexpand_objectz00,BgL_xz00_32);}  else 
{ /* Expand/object.scm 444 */
{ /* Expand/object.scm 447 */
obj_t BgL_arg2979z00_1303;
{ /* Expand/object.scm 447 */
obj_t BgL_arg2983z00_1304;
BgL_arg2983z00_1304 = 
BGl_duplicatezd2ze3makez31zzexpand_objectz00(BgL_xz00_32, BgL_classz00_1300, BgL_dupz00_1287, BgL_provz00_1288); 
BgL_arg2979z00_1303 = 
PROCEDURE_ENTRY(BgL_ez00_33)(BgL_ez00_33, BgL_arg2983z00_1304, BgL_ez00_33, BEOA); } 
return 
BGl_replacez12z12zztools_miscz00(BgL_xz00_32, BgL_arg2979z00_1303);} } }  else 
{ /* Expand/object.scm 439 */
{ /* Expand/object.scm 441 */
obj_t BgL_arg2988z00_1305;
{ /* Expand/object.scm 441 */
obj_t BgL_arg2992z00_1307;
BgL_arg2992z00_1307 = 
SYMBOL_TO_STRING(BgL_idz00_1299); 
BgL_arg2988z00_1305 = 
string_append(BGl_string4857z00zzexpand_objectz00, BgL_arg2992z00_1307); } 
FAILURE(BFALSE,BgL_arg2988z00_1305,BgL_xz00_32);} } } } } } } }  else 
{ /* Expand/object.scm 433 */
BgL_tagzd2294zd2_1290:
FAILURE(BFALSE,BGl_string4858z00zzexpand_objectz00,BgL_xz00_32);} }  else 
{ /* Expand/object.scm 433 */
goto BgL_tagzd2294zd2_1290;} } } 
}



/* _expand-duplicate */
obj_t BGl__expandzd2duplicatezd2zzexpand_objectz00(obj_t BgL_envz00_2942, obj_t BgL_xz00_2943, obj_t BgL_ez00_2944)
{ AN_OBJECT;
{ /* Expand/object.scm 432 */
return 
BGl_expandzd2duplicatezd2zzexpand_objectz00(BgL_xz00_2943, BgL_ez00_2944);} 
}



/* duplicate->make */
obj_t BGl_duplicatezd2ze3makez31zzexpand_objectz00(obj_t BgL_formz00_34, obj_t BgL_classz00_35, obj_t BgL_duplicatedz00_36, obj_t BgL_providedz00_37)
{ AN_OBJECT;
{ /* Expand/object.scm 460 */
{ /* Expand/object.scm 461 */
obj_t BgL_slotsz00_1309;
BgL_slotsz00_1309 = 
BGl_tclasszd2allzd2slotsz00zzobject_classz00(
(BgL_tclassz00_bglt)(BgL_classz00_35)); 
{ /* Expand/object.scm 461 */
long BgL_lenz00_1310;
BgL_lenz00_1310 = 
bgl_list_length(BgL_slotsz00_1309); 
{ /* Expand/object.scm 462 */
obj_t BgL_dupzd2varzd2_1311;
{ /* Expand/object.scm 463 */
obj_t BgL_arg3274z00_1445;
BgL_arg3274z00_1445 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)21)), BEOA); 
BgL_dupzd2varzd2_1311 = 
BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(BgL_arg3274z00_1445); } 
{ /* Expand/object.scm 463 */
obj_t BgL_dupzd2varzd2typedz00_1312;
{ /* Expand/object.scm 464 */
obj_t BgL_auxz00_3928;
{ /* Expand/object.scm 464 */
BgL_typez00_bglt BgL_obj1003z00_2415;
BgL_obj1003z00_2415 = 
(BgL_typez00_bglt)(BgL_classz00_35); 
BgL_auxz00_3928 = 
(((BgL_typez00_bglt)CREF(BgL_obj1003z00_2415))->BgL_idz00); } 
BgL_dupzd2varzd2typedz00_1312 = 
BGl_makezd2typedzd2identz00zzast_identz00(BgL_dupzd2varzd2_1311, BgL_auxz00_3928); } 
{ /* Expand/object.scm 464 */
obj_t BgL_newz00_1313;
BgL_newz00_1313 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)12)), BEOA); 
{ /* Expand/object.scm 465 */
obj_t BgL_vargsz00_1314;
{ /* Expand/object.scm 466 */
obj_t BgL_auxz00_3939;int BgL_auxz00_3935;
BgL_auxz00_3939 = BUNSPEC; 
{ /* Expand/object.scm 466 */
long BgL_auxz00_3936;
BgL_auxz00_3936 = 
bgl_list_length(BgL_slotsz00_1309); 
BgL_auxz00_3935 = 
(int)(BgL_auxz00_3936); } 
BgL_vargsz00_1314 = 
make_vector(BgL_auxz00_3935, BgL_auxz00_3939); } 
{ /* Expand/object.scm 466 */

{ 
obj_t BgL_providedz00_1315;
BgL_providedz00_1315 = BgL_providedz00_37; 
BgL_loopz00_1316:
if(
NULLP(BgL_providedz00_1315))
{ /* Expand/object.scm 469 */
CNST_TABLE_REF(((long)13)); }  else 
{ /* Expand/object.scm 471 */
obj_t BgL_pz00_1318;
BgL_pz00_1318 = 
CAR(BgL_providedz00_1315); 
{ 
obj_t BgL_szd2namezd2_1322;obj_t BgL_lenz00_1323;obj_t BgL_valuez00_1324;obj_t BgL_szd2namezd2_1319;obj_t BgL_valuez00_1320;
if(
PAIRP(BgL_pz00_1318))
{ /* Expand/object.scm 472 */
obj_t BgL_carzd2320zd2_1329;obj_t BgL_cdrzd2321zd2_1330;
BgL_carzd2320zd2_1329 = 
CAR(BgL_pz00_1318); 
BgL_cdrzd2321zd2_1330 = 
CDR(BgL_pz00_1318); 
if(
SYMBOLP(BgL_carzd2320zd2_1329))
{ /* Expand/object.scm 472 */
if(
PAIRP(BgL_cdrzd2321zd2_1330))
{ /* Expand/object.scm 472 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2321zd2_1330), BNIL))
{ /* Expand/object.scm 472 */
BgL_szd2namezd2_1319 = BgL_carzd2320zd2_1329; 
BgL_valuez00_1320 = 
CAR(BgL_cdrzd2321zd2_1330); 
{ /* Expand/object.scm 476 */
obj_t BgL_arg3073z00_1358;obj_t BgL_arg3074z00_1359;
BgL_arg3073z00_1358 = 
BGl_findzd2slotzd2offsetz00zzexpand_objectz00(BgL_slotsz00_1309, BgL_szd2namezd2_1319, BGl_string4859z00zzexpand_objectz00, BgL_pz00_1318); 
{ /* Expand/object.scm 480 */
obj_t BgL_arg3078z00_1360;
BgL_arg3078z00_1360 = 
BGl_objectzd2epairifyzd2zzexpand_objectz00(BgL_valuez00_1320, BgL_pz00_1318); 
BgL_arg3074z00_1359 = 
MAKE_PAIR(BTRUE, BgL_arg3078z00_1360); } 
{ /* Expand/object.scm 475 */
int BgL_kz00_2444;
BgL_kz00_2444 = 
CINT(BgL_arg3073z00_1358); 
{ /* Expand/object.scm 475 */
obj_t BgL_xz00_2962;
BgL_xz00_2962 = 
VECTOR_SET(BgL_vargsz00_1314,BgL_kz00_2444,BgL_arg3074z00_1359); BUNSPEC; } } } }  else 
{ /* Expand/object.scm 472 */
if(
SYMBOLP(BgL_carzd2320zd2_1329))
{ /* Expand/object.scm 472 */
obj_t BgL_cdrzd2348zd2_1338;
BgL_cdrzd2348zd2_1338 = 
CDR(BgL_cdrzd2321zd2_1330); 
if(
PAIRP(BgL_cdrzd2348zd2_1338))
{ /* Expand/object.scm 472 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2348zd2_1338), BNIL))
{ /* Expand/object.scm 472 */
BgL_szd2namezd2_1322 = BgL_carzd2320zd2_1329; 
BgL_lenz00_1323 = 
CAR(BgL_cdrzd2321zd2_1330); 
BgL_valuez00_1324 = 
CAR(BgL_cdrzd2348zd2_1338); 
BgL_tagzd2312zd2_1325:
{ /* Expand/object.scm 483 */
obj_t BgL_snumz00_1361;
BgL_snumz00_1361 = 
BGl_findzd2slotzd2offsetz00zzexpand_objectz00(BgL_slotsz00_1309, BgL_szd2namezd2_1322, BGl_string4859z00zzexpand_objectz00, BgL_pz00_1318); 
{ /* Expand/object.scm 487 */

{ /* Expand/object.scm 488 */
bool_t BgL_testz00_3971;
{ /* Expand/object.scm 488 */
BgL_slotz00_bglt BgL_obj1764z00_2446;
{ /* Expand/object.scm 488 */
obj_t BgL_auxz00_3972;
BgL_auxz00_3972 = 
bgl_list_ref(BgL_slotsz00_1309, 
(long)CINT(BgL_snumz00_1361)); 
BgL_obj1764z00_2446 = 
(BgL_slotz00_bglt)(BgL_auxz00_3972); } 
{ /* Expand/object.scm 488 */
obj_t BgL_auxz00_3976;
BgL_auxz00_3976 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1764z00_2446))->BgL_indexedz00); 
BgL_testz00_3971 = 
CBOOL(BgL_auxz00_3976); } } 
if(BgL_testz00_3971)
{ /* Expand/object.scm 488 */
{ /* Expand/object.scm 493 */
obj_t BgL_arg3083z00_1364;
{ /* Expand/object.scm 493 */
obj_t BgL_arg3086z00_1365;
BgL_arg3086z00_1365 = 
BGl_objectzd2epairifyzd2zzexpand_objectz00(BgL_valuez00_1324, BgL_pz00_1318); 
BgL_arg3083z00_1364 = 
MAKE_PAIR(BTRUE, BgL_arg3086z00_1365); } 
{ /* Expand/object.scm 491 */
int BgL_kz00_2448;
BgL_kz00_2448 = 
CINT(BgL_snumz00_1361); 
VECTOR_SET(BgL_vargsz00_1314,BgL_kz00_2448,BgL_arg3083z00_1364); } } 
{ /* Expand/object.scm 494 */
long BgL_arg3090z00_1366;obj_t BgL_arg3091z00_1367;
{ /* Expand/object.scm 494 */
long BgL_auxz00_3983;
BgL_auxz00_3983 = 
(long)CINT(BgL_snumz00_1361); 
BgL_arg3090z00_1366 = 
(BgL_auxz00_3983-((long)1)); } 
BgL_arg3091z00_1367 = 
MAKE_PAIR(BFALSE, BgL_lenz00_1323); 
{ /* Expand/object.scm 494 */
int BgL_kz00_2453;
BgL_kz00_2453 = 
(int)(BgL_arg3090z00_1366); 
VECTOR_SET(BgL_vargsz00_1314,BgL_kz00_2453,BgL_arg3091z00_1367); } } }  else 
{ /* Expand/object.scm 488 */
FAILURE(BFALSE,BGl_string4858z00zzexpand_objectz00,BgL_formz00_34);} } } } }  else 
{ /* Expand/object.scm 472 */
BgL_tagzd2313zd2_1326:
FAILURE(BFALSE,BGl_string4858z00zzexpand_objectz00,BgL_formz00_34);} }  else 
{ /* Expand/object.scm 472 */
goto BgL_tagzd2313zd2_1326;} }  else 
{ /* Expand/object.scm 472 */
goto BgL_tagzd2313zd2_1326;} } }  else 
{ /* Expand/object.scm 472 */
goto BgL_tagzd2313zd2_1326;} }  else 
{ /* Expand/object.scm 472 */
if(
SYMBOLP(BgL_carzd2320zd2_1329))
{ /* Expand/object.scm 472 */
if(
PAIRP(BgL_cdrzd2321zd2_1330))
{ /* Expand/object.scm 472 */
obj_t BgL_cdrzd2376zd2_1351;
BgL_cdrzd2376zd2_1351 = 
CDR(BgL_cdrzd2321zd2_1330); 
if(
PAIRP(BgL_cdrzd2376zd2_1351))
{ /* Expand/object.scm 472 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2376zd2_1351), BNIL))
{ 
obj_t BgL_valuez00_4006;obj_t BgL_lenz00_4004;obj_t BgL_szd2namezd2_4003;
BgL_szd2namezd2_4003 = BgL_carzd2320zd2_1329; 
BgL_lenz00_4004 = 
CAR(BgL_cdrzd2321zd2_1330); 
BgL_valuez00_4006 = 
CAR(BgL_cdrzd2376zd2_1351); 
BgL_valuez00_1324 = BgL_valuez00_4006; 
BgL_lenz00_1323 = BgL_lenz00_4004; 
BgL_szd2namezd2_1322 = BgL_szd2namezd2_4003; 
goto BgL_tagzd2312zd2_1325;}  else 
{ /* Expand/object.scm 472 */
goto BgL_tagzd2313zd2_1326;} }  else 
{ /* Expand/object.scm 472 */
goto BgL_tagzd2313zd2_1326;} }  else 
{ /* Expand/object.scm 472 */
goto BgL_tagzd2313zd2_1326;} }  else 
{ /* Expand/object.scm 472 */
goto BgL_tagzd2313zd2_1326;} } }  else 
{ /* Expand/object.scm 472 */
goto BgL_tagzd2313zd2_1326;} } 
{ 
obj_t BgL_providedz00_4008;
BgL_providedz00_4008 = 
CDR(BgL_providedz00_1315); 
BgL_providedz00_1315 = BgL_providedz00_4008; 
goto BgL_loopz00_1316;} } } 
{ 
long BgL_iz00_1369;obj_t BgL_slotsz00_1370;
BgL_iz00_1369 = ((long)0); 
BgL_slotsz00_1370 = BgL_slotsz00_1309; 
BgL_loopz00_1371:
if(
NULLP(BgL_slotsz00_1370))
{ /* Expand/object.scm 502 */
CNST_TABLE_REF(((long)13)); }  else 
{ /* Expand/object.scm 504 */
obj_t BgL_valuez00_1373;
{ /* Expand/object.scm 504 */
int BgL_kz00_2464;
BgL_kz00_2464 = 
(int)(BgL_iz00_1369); 
BgL_valuez00_1373 = 
VECTOR_REF(BgL_vargsz00_1314,BgL_kz00_2464); } 
if(
PAIRP(BgL_valuez00_1373))
{ /* Expand/object.scm 505 */
CNST_TABLE_REF(((long)22)); }  else 
{ /* Expand/object.scm 508 */
obj_t BgL_slotz00_1375;
BgL_slotz00_1375 = 
CAR(BgL_slotsz00_1370); 
{ /* Expand/object.scm 509 */
bool_t BgL_testz00_4019;
{ /* Expand/object.scm 509 */
BgL_slotz00_bglt BgL_obj1764z00_2467;
BgL_obj1764z00_2467 = 
(BgL_slotz00_bglt)(BgL_slotz00_1375); 
{ /* Expand/object.scm 509 */
obj_t BgL_auxz00_4021;
BgL_auxz00_4021 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1764z00_2467))->BgL_indexedz00); 
BgL_testz00_4019 = 
CBOOL(BgL_auxz00_4021); } } 
if(BgL_testz00_4019)
{ /* Expand/object.scm 512 */
obj_t BgL_azd2namezd2_1377;
{ /* Expand/object.scm 512 */
obj_t BgL_arg3124z00_1382;obj_t BgL_arg3125z00_1383;obj_t BgL_arg3126z00_1384;
{ /* Expand/object.scm 512 */
BgL_typez00_bglt BgL_obj1003z00_2468;
BgL_obj1003z00_2468 = 
(BgL_typez00_bglt)(BgL_classz00_35); 
BgL_arg3124z00_1382 = 
(((BgL_typez00_bglt)CREF(BgL_obj1003z00_2468))->BgL_idz00); } 
BgL_arg3125z00_1383 = 
CNST_TABLE_REF(((long)4)); 
{ /* Expand/object.scm 514 */
BgL_slotz00_bglt BgL_obj1747z00_2469;
BgL_obj1747z00_2469 = 
(BgL_slotz00_bglt)(BgL_slotz00_1375); 
BgL_arg3126z00_1384 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1747z00_2469))->BgL_idz00); } 
{ /* Expand/object.scm 512 */
obj_t BgL_list3129z00_1386;
{ /* Expand/object.scm 512 */
obj_t BgL_arg3131z00_1387;
{ /* Expand/object.scm 512 */
obj_t BgL_arg3134z00_1388;
{ /* Expand/object.scm 512 */
obj_t BgL_arg3137z00_1389;
{ /* Expand/object.scm 512 */
obj_t BgL_auxz00_4029;
BgL_auxz00_4029 = 
CNST_TABLE_REF(((long)3)); 
BgL_arg3137z00_1389 = 
MAKE_PAIR(BgL_auxz00_4029, BNIL); } 
BgL_arg3134z00_1388 = 
MAKE_PAIR(BgL_arg3126z00_1384, BgL_arg3137z00_1389); } 
BgL_arg3131z00_1387 = 
MAKE_PAIR(BgL_arg3125z00_1383, BgL_arg3134z00_1388); } 
BgL_list3129z00_1386 = 
MAKE_PAIR(BgL_arg3124z00_1382, BgL_arg3131z00_1387); } 
BgL_azd2namezd2_1377 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list3129z00_1386); } } 
{ /* Expand/object.scm 518 */
obj_t BgL_arg3111z00_1378;
{ /* Expand/object.scm 518 */
obj_t BgL_arg3114z00_1379;
{ /* Expand/object.scm 518 */
obj_t BgL_arg3117z00_1380;
{ /* Expand/object.scm 518 */
obj_t BgL_arg3120z00_1381;
{ /* Expand/object.scm 518 */
obj_t BgL_auxz00_4036;
BgL_auxz00_4036 = 
BINT(((long)0)); 
BgL_arg3120z00_1381 = 
MAKE_PAIR(BgL_auxz00_4036, BNIL); } 
BgL_arg3117z00_1380 = 
MAKE_PAIR(BgL_dupzd2varzd2_1311, BgL_arg3120z00_1381); } 
BgL_arg3114z00_1379 = 
MAKE_PAIR(BgL_azd2namezd2_1377, BgL_arg3117z00_1380); } 
BgL_arg3111z00_1378 = 
MAKE_PAIR(BTRUE, BgL_arg3114z00_1379); } 
{ /* Expand/object.scm 516 */
int BgL_kz00_2471;
BgL_kz00_2471 = 
(int)(BgL_iz00_1369); 
VECTOR_SET(BgL_vargsz00_1314,BgL_kz00_2471,BgL_arg3111z00_1378); } } }  else 
{ /* Expand/object.scm 521 */
obj_t BgL_azd2namezd2_1390;
{ /* Expand/object.scm 521 */
obj_t BgL_arg3153z00_1394;obj_t BgL_arg3154z00_1395;
{ /* Expand/object.scm 521 */
BgL_typez00_bglt BgL_obj1003z00_2473;
BgL_obj1003z00_2473 = 
(BgL_typez00_bglt)(BgL_classz00_35); 
BgL_arg3153z00_1394 = 
(((BgL_typez00_bglt)CREF(BgL_obj1003z00_2473))->BgL_idz00); } 
BgL_arg3154z00_1395 = 
CNST_TABLE_REF(((long)4)); 
{ /* Expand/object.scm 521 */
obj_t BgL_list3157z00_1397;
{ /* Expand/object.scm 521 */
obj_t BgL_arg3159z00_1398;
{ /* Expand/object.scm 521 */
obj_t BgL_arg3162z00_1399;
{ /* Expand/object.scm 521 */
obj_t BgL_auxz00_4047;
{ /* Expand/object.scm 523 */
BgL_slotz00_bglt BgL_obj1747z00_2474;
BgL_obj1747z00_2474 = 
(BgL_slotz00_bglt)(BgL_slotz00_1375); 
BgL_auxz00_4047 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1747z00_2474))->BgL_idz00); } 
BgL_arg3162z00_1399 = 
MAKE_PAIR(BgL_auxz00_4047, BNIL); } 
BgL_arg3159z00_1398 = 
MAKE_PAIR(BgL_arg3154z00_1395, BgL_arg3162z00_1399); } 
BgL_list3157z00_1397 = 
MAKE_PAIR(BgL_arg3153z00_1394, BgL_arg3159z00_1398); } 
BgL_azd2namezd2_1390 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list3157z00_1397); } } 
{ /* Expand/object.scm 526 */
obj_t BgL_arg3143z00_1391;
{ /* Expand/object.scm 526 */
obj_t BgL_arg3146z00_1392;
{ /* Expand/object.scm 526 */
obj_t BgL_arg3149z00_1393;
BgL_arg3149z00_1393 = 
MAKE_PAIR(BgL_dupzd2varzd2_1311, BNIL); 
BgL_arg3146z00_1392 = 
MAKE_PAIR(BgL_azd2namezd2_1390, BgL_arg3149z00_1393); } 
BgL_arg3143z00_1391 = 
MAKE_PAIR(BTRUE, BgL_arg3146z00_1392); } 
{ /* Expand/object.scm 524 */
int BgL_kz00_2476;
BgL_kz00_2476 = 
(int)(BgL_iz00_1369); 
VECTOR_SET(BgL_vargsz00_1314,BgL_kz00_2476,BgL_arg3143z00_1391); } } } } } 
{ 
obj_t BgL_slotsz00_4061;long BgL_iz00_4059;
BgL_iz00_4059 = 
(BgL_iz00_1369+((long)1)); 
BgL_slotsz00_4061 = 
CDR(BgL_slotsz00_1370); 
BgL_slotsz00_1370 = BgL_slotsz00_4061; 
BgL_iz00_1369 = BgL_iz00_4059; 
goto BgL_loopz00_1371;} } } 
{ 
long BgL_iz00_1402;obj_t BgL_slotsz00_1403;obj_t BgL_largsz00_1404;obj_t BgL_virtualsz00_1405;
BgL_iz00_1402 = ((long)0); 
BgL_slotsz00_1403 = BgL_slotsz00_1309; 
BgL_largsz00_1404 = BNIL; 
BgL_virtualsz00_1405 = BNIL; 
BgL_loopz00_1406:
if(
(BgL_iz00_1402==BgL_lenz00_1310))
{ /* Expand/object.scm 535 */
obj_t BgL_makezd2namezd2_1408;
{ /* Expand/object.scm 535 */
obj_t BgL_arg3219z00_1425;
BgL_arg3219z00_1425 = 
CNST_TABLE_REF(((long)11)); 
{ /* Expand/object.scm 535 */
obj_t BgL_list3222z00_1427;
{ /* Expand/object.scm 535 */
obj_t BgL_arg3224z00_1428;
{ /* Expand/object.scm 535 */
obj_t BgL_auxz00_4066;
{ /* Expand/object.scm 535 */
BgL_typez00_bglt BgL_obj1003z00_2483;
BgL_obj1003z00_2483 = 
(BgL_typez00_bglt)(BgL_classz00_35); 
BgL_auxz00_4066 = 
(((BgL_typez00_bglt)CREF(BgL_obj1003z00_2483))->BgL_idz00); } 
BgL_arg3224z00_1428 = 
MAKE_PAIR(BgL_auxz00_4066, BNIL); } 
BgL_list3222z00_1427 = 
MAKE_PAIR(BgL_arg3219z00_1425, BgL_arg3224z00_1428); } 
BgL_makezd2namezd2_1408 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list3222z00_1427); } } 
{ /* Expand/object.scm 535 */
obj_t BgL_allocz00_1409;
{ /* Expand/object.scm 536 */
obj_t BgL_arg3211z00_1422;
{ /* Expand/object.scm 536 */
obj_t BgL_arg3214z00_1423;
BgL_arg3214z00_1423 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_largsz00_1404); 
BgL_arg3211z00_1422 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg3214z00_1423, BNIL); } 
BgL_allocz00_1409 = 
MAKE_PAIR(BgL_makezd2namezd2_1408, BgL_arg3211z00_1422); } 
{ /* Expand/object.scm 536 */

{ /* Expand/object.scm 537 */
obj_t BgL_arg3181z00_1410;obj_t BgL_arg3182z00_1411;
BgL_arg3181z00_1410 = 
CNST_TABLE_REF(((long)23)); 
{ /* Expand/object.scm 537 */
obj_t BgL_arg3185z00_1412;obj_t BgL_arg3186z00_1413;
{ /* Expand/object.scm 537 */
obj_t BgL_arg3189z00_1414;obj_t BgL_arg3190z00_1415;
{ /* Expand/object.scm 537 */
obj_t BgL_arg3193z00_1416;
BgL_arg3193z00_1416 = 
MAKE_PAIR(BgL_duplicatedz00_36, BNIL); 
BgL_arg3189z00_1414 = 
MAKE_PAIR(BgL_dupzd2varzd2typedz00_1312, BgL_arg3193z00_1416); } 
{ /* Expand/object.scm 538 */
obj_t BgL_arg3197z00_1417;
{ /* Expand/object.scm 538 */
obj_t BgL_arg3201z00_1419;
BgL_arg3201z00_1419 = 
MAKE_PAIR(BgL_allocz00_1409, BNIL); 
BgL_arg3197z00_1417 = 
MAKE_PAIR(BgL_newz00_1313, BgL_arg3201z00_1419); } 
BgL_arg3190z00_1415 = 
MAKE_PAIR(BgL_arg3197z00_1417, BNIL); } 
BgL_arg3185z00_1412 = 
MAKE_PAIR(BgL_arg3189z00_1414, BgL_arg3190z00_1415); } 
{ /* Expand/object.scm 539 */
obj_t BgL_arg3205z00_1420;obj_t BgL_arg3206z00_1421;
BgL_arg3205z00_1420 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_virtualsz00_1405); 
BgL_arg3206z00_1421 = 
MAKE_PAIR(BgL_newz00_1313, BNIL); 
BgL_arg3186z00_1413 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg3205z00_1420, BgL_arg3206z00_1421); } 
BgL_arg3182z00_1411 = 
MAKE_PAIR(BgL_arg3185z00_1412, BgL_arg3186z00_1413); } 
return 
MAKE_PAIR(BgL_arg3181z00_1410, BgL_arg3182z00_1411);} } } }  else 
{ /* Expand/object.scm 541 */
obj_t BgL_valuez00_1429;
{ /* Expand/object.scm 541 */
obj_t BgL_arg3257z00_1441;
{ /* Expand/object.scm 541 */
int BgL_kz00_2485;
BgL_kz00_2485 = 
(int)(BgL_iz00_1402); 
BgL_arg3257z00_1441 = 
VECTOR_REF(BgL_vargsz00_1314,BgL_kz00_2485); } 
BgL_valuez00_1429 = 
CDR(BgL_arg3257z00_1441); } 
{ /* Expand/object.scm 543 */
bool_t BgL_test3228z00_1430;
{ /* Expand/object.scm 543 */
BgL_slotz00_bglt BgL_auxz00_4090;
{ /* Expand/object.scm 543 */
obj_t BgL_auxz00_4091;
BgL_auxz00_4091 = 
CAR(BgL_slotsz00_1403); 
BgL_auxz00_4090 = 
(BgL_slotz00_bglt)(BgL_auxz00_4091); } 
BgL_test3228z00_1430 = 
BGl_slotzd2virtualzf3z21zzobject_slotsz00(BgL_auxz00_4090); } 
if(BgL_test3228z00_1430)
{ /* Expand/object.scm 543 */
{ /* Expand/object.scm 544 */
long BgL_arg3230z00_1431;obj_t BgL_arg3231z00_1432;obj_t BgL_arg3232z00_1433;
BgL_arg3230z00_1431 = 
(BgL_iz00_1402+((long)1)); 
BgL_arg3231z00_1432 = 
CDR(BgL_slotsz00_1403); 
{ /* Expand/object.scm 547 */
obj_t BgL_arg3237z00_1434;
BgL_arg3237z00_1434 = 
BGl_makezd2virtualzd2setz00zzexpand_objectz00(
CAR(BgL_slotsz00_1403), BgL_valuez00_1429, BgL_newz00_1313, BgL_classz00_35, BgL_formz00_34, "duplicate"); 
BgL_arg3232z00_1433 = 
MAKE_PAIR(BgL_arg3237z00_1434, BgL_virtualsz00_1405); } 
{ 
obj_t BgL_virtualsz00_4103;obj_t BgL_slotsz00_4102;long BgL_iz00_4101;
BgL_iz00_4101 = BgL_arg3230z00_1431; 
BgL_slotsz00_4102 = BgL_arg3231z00_1432; 
BgL_virtualsz00_4103 = BgL_arg3232z00_1433; 
BgL_virtualsz00_1405 = BgL_virtualsz00_4103; 
BgL_slotsz00_1403 = BgL_slotsz00_4102; 
BgL_iz00_1402 = BgL_iz00_4101; 
goto BgL_loopz00_1406;} } }  else 
{ /* Expand/object.scm 543 */
{ /* Expand/object.scm 555 */
long BgL_arg3245z00_1437;obj_t BgL_arg3246z00_1438;obj_t BgL_arg3247z00_1439;
BgL_arg3245z00_1437 = 
(BgL_iz00_1402+((long)1)); 
BgL_arg3246z00_1438 = 
CDR(BgL_slotsz00_1403); 
BgL_arg3247z00_1439 = 
MAKE_PAIR(BgL_valuez00_1429, BgL_largsz00_1404); 
{ 
obj_t BgL_largsz00_4109;obj_t BgL_slotsz00_4108;long BgL_iz00_4107;
BgL_iz00_4107 = BgL_arg3245z00_1437; 
BgL_slotsz00_4108 = BgL_arg3246z00_1438; 
BgL_largsz00_4109 = BgL_arg3247z00_1439; 
BgL_largsz00_1404 = BgL_largsz00_4109; 
BgL_slotsz00_1403 = BgL_slotsz00_4108; 
BgL_iz00_1402 = BgL_iz00_4107; 
goto BgL_loopz00_1406;} } } } } } } } } } } } } } 
}



/* expand-widen! */
obj_t BGl_expandzd2widenz12zc0zzexpand_objectz00(obj_t BgL_xz00_38, obj_t BgL_ez00_39)
{ AN_OBJECT;
{ /* Expand/object.scm 563 */
{ 
obj_t BgL_widenz12z12_1446;obj_t BgL_objz00_1447;obj_t BgL_providedz00_1448;
if(
PAIRP(BgL_xz00_38))
{ /* Expand/object.scm 564 */
obj_t BgL_cdrzd2398zd2_1453;
BgL_cdrzd2398zd2_1453 = 
CDR(BgL_xz00_38); 
if(
PAIRP(BgL_cdrzd2398zd2_1453))
{ /* Expand/object.scm 564 */
BgL_widenz12z12_1446 = 
CAR(BgL_xz00_38); 
BgL_objz00_1447 = 
CAR(BgL_cdrzd2398zd2_1453); 
BgL_providedz00_1448 = 
CDR(BgL_cdrzd2398zd2_1453); 
{ /* Expand/object.scm 566 */
BgL_typez00_bglt BgL_classz00_1458;
{ /* Expand/object.scm 566 */
obj_t BgL_arg3317z00_1467;
BgL_arg3317z00_1467 = 
BGl_findzd2locationzd2zztools_locationz00(BgL_xz00_38); 
BgL_classz00_1458 = 
BGl_typezd2ofzd2idz00zzast_identz00(BgL_widenz12z12_1446, BgL_arg3317z00_1467); } 
{ /* Expand/object.scm 567 */
bool_t BgL_test3294z00_1459;
{ /* Expand/object.scm 567 */
bool_t BgL_test3313z00_1466;
BgL_test3313z00_1466 = 
BGl_iszd2azf3z21zz__objectz00(
(obj_t)(BgL_classz00_1458), BGl_tclassz00zzobject_classz00); 
if(BgL_test3313z00_1466)
{ /* Expand/object.scm 567 */
BgL_tclassz00_bglt BgL_obj1615z00_2502;
BgL_obj1615z00_2502 = 
(BgL_tclassz00_bglt)(BgL_classz00_1458); 
{ /* Expand/object.scm 567 */
obj_t BgL_auxz00_4121;
{ 
obj_t BgL_auxz00_4122;
{ /* Expand/object.scm 567 */
BgL_objectz00_bglt BgL_auxz00_4123;
BgL_auxz00_4123 = 
(BgL_objectz00_bglt)(BgL_obj1615z00_2502); 
BgL_auxz00_4122 = 
BGL_OBJECT_WIDENING(BgL_auxz00_4123); } 
BgL_auxz00_4121 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_4122))->BgL_wideningz00); } 
BgL_test3294z00_1459 = 
CBOOL(BgL_auxz00_4121); } }  else 
{ /* Expand/object.scm 567 */
BgL_test3294z00_1459 = ((bool_t)0); } } 
if(BgL_test3294z00_1459)
{ /* Expand/object.scm 568 */
obj_t BgL_arg3296z00_1460;
{ /* Expand/object.scm 568 */
obj_t BgL_arg3299z00_1461;
BgL_arg3299z00_1461 = 
BGl_makezd2wideningzd2zzexpand_objectz00(BgL_xz00_38, BgL_classz00_1458, BgL_objz00_1447, BgL_providedz00_1448); 
BgL_arg3296z00_1460 = 
PROCEDURE_ENTRY(BgL_ez00_39)(BgL_ez00_39, BgL_arg3299z00_1461, BgL_ez00_39, BEOA); } 
return 
BGl_replacez12z12zztools_miscz00(BgL_xz00_38, BgL_arg3296z00_1460);}  else 
{ /* Expand/object.scm 570 */
obj_t BgL_arg3303z00_1462;
{ /* Expand/object.scm 570 */
obj_t BgL_arg3307z00_1464;
{ /* Expand/object.scm 571 */
obj_t BgL_auxz00_4133;
BgL_auxz00_4133 = 
(((BgL_typez00_bglt)CREF(BgL_classz00_1458))->BgL_idz00); 
BgL_arg3307z00_1464 = 
SYMBOL_TO_STRING(BgL_auxz00_4133); } 
BgL_arg3303z00_1462 = 
string_append(BGl_string4860z00zzexpand_objectz00, BgL_arg3307z00_1464); } 
FAILURE(BFALSE,BgL_arg3303z00_1462,BgL_xz00_38);} } } }  else 
{ /* Expand/object.scm 564 */
BgL_tagzd2389zd2_1450:
FAILURE(BFALSE,BGl_string4861z00zzexpand_objectz00,BgL_xz00_38);} }  else 
{ /* Expand/object.scm 564 */
goto BgL_tagzd2389zd2_1450;} } } 
}



/* _expand-widen! */
obj_t BGl__expandzd2widenz12zc0zzexpand_objectz00(obj_t BgL_envz00_2945, obj_t BgL_xz00_2946, obj_t BgL_ez00_2947)
{ AN_OBJECT;
{ /* Expand/object.scm 563 */
return 
BGl_expandzd2widenz12zc0zzexpand_objectz00(BgL_xz00_2946, BgL_ez00_2947);} 
}



/* make-widening */
obj_t BGl_makezd2wideningzd2zzexpand_objectz00(obj_t BgL_formz00_40, BgL_typez00_bglt BgL_classz00_41, obj_t BgL_objz00_42, obj_t BgL_providedz00_43)
{ AN_OBJECT;
{ /* Expand/object.scm 579 */
{ /* Expand/object.scm 580 */
obj_t BgL_slotsz00_1468;
{ /* Expand/object.scm 580 */
BgL_tclassz00_bglt BgL_obj1611z00_2511;
BgL_obj1611z00_2511 = 
(BgL_tclassz00_bglt)(BgL_classz00_41); 
{ 
obj_t BgL_auxz00_4144;
{ /* Expand/object.scm 580 */
BgL_objectz00_bglt BgL_auxz00_4145;
BgL_auxz00_4145 = 
(BgL_objectz00_bglt)(BgL_obj1611z00_2511); 
BgL_auxz00_4144 = 
BGL_OBJECT_WIDENING(BgL_auxz00_4145); } 
BgL_slotsz00_1468 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_4144))->BgL_slotsz00); } } 
{ /* Expand/object.scm 580 */
BgL_globalz00_bglt BgL_holderz00_1469;
{ /* Expand/object.scm 581 */
BgL_tclassz00_bglt BgL_obj1614z00_2512;
BgL_obj1614z00_2512 = 
(BgL_tclassz00_bglt)(BgL_classz00_41); 
{ 
obj_t BgL_auxz00_4150;
{ /* Expand/object.scm 581 */
BgL_objectz00_bglt BgL_auxz00_4151;
BgL_auxz00_4151 = 
(BgL_objectz00_bglt)(BgL_obj1614z00_2512); 
BgL_auxz00_4150 = 
BGL_OBJECT_WIDENING(BgL_auxz00_4151); } 
BgL_holderz00_1469 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_4150))->BgL_holderz00); } } 
{ /* Expand/object.scm 581 */
long BgL_lenz00_1470;
BgL_lenz00_1470 = 
bgl_list_length(BgL_slotsz00_1468); 
{ /* Expand/object.scm 582 */
obj_t BgL_vargsz00_1471;
{ /* Expand/object.scm 583 */
obj_t BgL_auxz00_4158;int BgL_auxz00_4156;
BgL_auxz00_4158 = BUNSPEC; 
BgL_auxz00_4156 = 
(int)(BgL_lenz00_1470); 
BgL_vargsz00_1471 = 
make_vector(BgL_auxz00_4156, BgL_auxz00_4158); } 
{ /* Expand/object.scm 583 */
obj_t BgL_dupzd2varzd2_1472;
{ /* Expand/object.scm 584 */
obj_t BgL_arg3904z00_1746;
BgL_arg3904z00_1746 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)24)), BEOA); 
BgL_dupzd2varzd2_1472 = 
BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(BgL_arg3904z00_1746); } 
{ /* Expand/object.scm 584 */
obj_t BgL_tidz00_1473;
BgL_tidz00_1473 = 
(((BgL_typez00_bglt)CREF(BgL_classz00_41))->BgL_idz00); 
{ /* Expand/object.scm 585 */
obj_t BgL_dupzd2varzd2typedz00_1474;
BgL_dupzd2varzd2typedz00_1474 = 
BGl_makezd2typedzd2identz00zzast_identz00(BgL_dupzd2varzd2_1472, BgL_tidz00_1473); 
{ /* Expand/object.scm 586 */
obj_t BgL_castz00_1475;
{ /* Expand/object.scm 587 */
obj_t BgL_list3899z00_1745;
BgL_list3899z00_1745 = 
MAKE_PAIR(BgL_objz00_42, BNIL); 
BgL_castz00_1475 = 
BGl_makezd2privatezd2sexpz00zzast_privatez00(
CNST_TABLE_REF(((long)25)), BgL_tidz00_1473, BgL_list3899z00_1745); } 
{ /* Expand/object.scm 587 */

{ 
long BgL_iz00_1476;obj_t BgL_slotsz00_1477;
BgL_iz00_1476 = ((long)0); 
BgL_slotsz00_1477 = BgL_slotsz00_1468; 
BgL_loopz00_1478:
if(
NULLP(BgL_slotsz00_1477))
{ /* Expand/object.scm 591 */
CNST_TABLE_REF(((long)13)); }  else 
{ /* Expand/object.scm 593 */
obj_t BgL_sz00_1480;
BgL_sz00_1480 = 
CAR(BgL_slotsz00_1477); 
{ /* Expand/object.scm 594 */
bool_t BgL_test3323z00_1481;
BgL_test3323z00_1481 = 
BGl_slotzd2defaultzf3z21zzobject_slotsz00(
(BgL_slotz00_bglt)(BgL_sz00_1480)); 
if(BgL_test3323z00_1481)
{ /* Expand/object.scm 595 */
obj_t BgL_arg3325z00_1482;
{ /* Expand/object.scm 595 */
obj_t BgL_auxz00_4176;
{ /* Expand/object.scm 595 */
BgL_slotz00_bglt BgL_obj1753z00_2517;
BgL_obj1753z00_2517 = 
(BgL_slotz00_bglt)(BgL_sz00_1480); 
BgL_auxz00_4176 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1753z00_2517))->BgL_defaultzd2valuezd2); } 
BgL_arg3325z00_1482 = 
MAKE_PAIR(BTRUE, BgL_auxz00_4176); } 
{ /* Expand/object.scm 595 */
int BgL_kz00_2519;
BgL_kz00_2519 = 
(int)(BgL_iz00_1476); 
VECTOR_SET(BgL_vargsz00_1471,BgL_kz00_2519,BgL_arg3325z00_1482); } }  else 
{ /* Expand/object.scm 596 */
obj_t BgL_arg3332z00_1484;
BgL_arg3332z00_1484 = 
MAKE_PAIR(BFALSE, BUNSPEC); 
{ /* Expand/object.scm 596 */
int BgL_kz00_2522;
BgL_kz00_2522 = 
(int)(BgL_iz00_1476); 
VECTOR_SET(BgL_vargsz00_1471,BgL_kz00_2522,BgL_arg3332z00_1484); } } } 
{ 
obj_t BgL_slotsz00_4187;long BgL_iz00_4185;
BgL_iz00_4185 = 
(BgL_iz00_1476+((long)1)); 
BgL_slotsz00_4187 = 
CDR(BgL_slotsz00_1477); 
BgL_slotsz00_1477 = BgL_slotsz00_4187; 
BgL_iz00_1476 = BgL_iz00_4185; 
goto BgL_loopz00_1478;} } } 
{ 
obj_t BgL_providedz00_1487;
BgL_providedz00_1487 = BgL_providedz00_43; 
BgL_loopz00_1488:
if(
NULLP(BgL_providedz00_1487))
{ /* Expand/object.scm 601 */
CNST_TABLE_REF(((long)13)); }  else 
{ /* Expand/object.scm 603 */
obj_t BgL_pz00_1490;
BgL_pz00_1490 = 
CAR(BgL_providedz00_1487); 
{ 
obj_t BgL_szd2namezd2_1494;obj_t BgL_lenz00_1495;obj_t BgL_valuez00_1496;obj_t BgL_szd2namezd2_1491;obj_t BgL_valuez00_1492;
if(
PAIRP(BgL_pz00_1490))
{ /* Expand/object.scm 604 */
obj_t BgL_carzd2415zd2_1501;obj_t BgL_cdrzd2416zd2_1502;
BgL_carzd2415zd2_1501 = 
CAR(BgL_pz00_1490); 
BgL_cdrzd2416zd2_1502 = 
CDR(BgL_pz00_1490); 
if(
SYMBOLP(BgL_carzd2415zd2_1501))
{ /* Expand/object.scm 604 */
if(
PAIRP(BgL_cdrzd2416zd2_1502))
{ /* Expand/object.scm 604 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2416zd2_1502), BNIL))
{ /* Expand/object.scm 604 */
BgL_szd2namezd2_1491 = BgL_carzd2415zd2_1501; 
BgL_valuez00_1492 = 
CAR(BgL_cdrzd2416zd2_1502); 
{ /* Expand/object.scm 607 */
obj_t BgL_arg3414z00_1530;obj_t BgL_arg3415z00_1531;
BgL_arg3414z00_1530 = 
BGl_findzd2slotzd2offsetz00zzexpand_objectz00(BgL_slotsz00_1468, BgL_szd2namezd2_1491, BGl_string4862z00zzexpand_objectz00, BgL_pz00_1490); 
{ /* Expand/object.scm 611 */
obj_t BgL_arg3419z00_1532;
BgL_arg3419z00_1532 = 
BGl_objectzd2epairifyzd2zzexpand_objectz00(BgL_valuez00_1492, BgL_pz00_1490); 
BgL_arg3415z00_1531 = 
MAKE_PAIR(BTRUE, BgL_arg3419z00_1532); } 
{ /* Expand/object.scm 606 */
int BgL_kz00_2554;
BgL_kz00_2554 = 
CINT(BgL_arg3414z00_1530); 
{ /* Expand/object.scm 606 */
obj_t BgL_xz00_2964;
BgL_xz00_2964 = 
VECTOR_SET(BgL_vargsz00_1471,BgL_kz00_2554,BgL_arg3415z00_1531); BUNSPEC; } } } }  else 
{ /* Expand/object.scm 604 */
if(
SYMBOLP(BgL_carzd2415zd2_1501))
{ /* Expand/object.scm 604 */
obj_t BgL_cdrzd2443zd2_1510;
BgL_cdrzd2443zd2_1510 = 
CDR(BgL_cdrzd2416zd2_1502); 
if(
PAIRP(BgL_cdrzd2443zd2_1510))
{ /* Expand/object.scm 604 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2443zd2_1510), BNIL))
{ /* Expand/object.scm 604 */
BgL_szd2namezd2_1494 = BgL_carzd2415zd2_1501; 
BgL_lenz00_1495 = 
CAR(BgL_cdrzd2416zd2_1502); 
BgL_valuez00_1496 = 
CAR(BgL_cdrzd2443zd2_1510); 
BgL_tagzd2407zd2_1497:
{ /* Expand/object.scm 613 */
obj_t BgL_snumz00_1533;
BgL_snumz00_1533 = 
BGl_findzd2slotzd2offsetz00zzexpand_objectz00(BgL_slotsz00_1468, BgL_szd2namezd2_1494, BGl_string4862z00zzexpand_objectz00, BgL_pz00_1490); 
{ /* Expand/object.scm 617 */

{ /* Expand/object.scm 618 */
bool_t BgL_testz00_4219;
{ /* Expand/object.scm 618 */
BgL_slotz00_bglt BgL_obj1764z00_2556;
{ /* Expand/object.scm 618 */
obj_t BgL_auxz00_4220;
BgL_auxz00_4220 = 
bgl_list_ref(BgL_slotsz00_1468, 
(long)CINT(BgL_snumz00_1533)); 
BgL_obj1764z00_2556 = 
(BgL_slotz00_bglt)(BgL_auxz00_4220); } 
{ /* Expand/object.scm 618 */
obj_t BgL_auxz00_4224;
BgL_auxz00_4224 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1764z00_2556))->BgL_indexedz00); 
BgL_testz00_4219 = 
CBOOL(BgL_auxz00_4224); } } 
if(BgL_testz00_4219)
{ /* Expand/object.scm 618 */
{ /* Expand/object.scm 623 */
obj_t BgL_arg3424z00_1536;
{ /* Expand/object.scm 623 */
obj_t BgL_arg3427z00_1537;
BgL_arg3427z00_1537 = 
BGl_objectzd2epairifyzd2zzexpand_objectz00(BgL_valuez00_1496, BgL_pz00_1490); 
BgL_arg3424z00_1536 = 
MAKE_PAIR(BTRUE, BgL_arg3427z00_1537); } 
{ /* Expand/object.scm 621 */
int BgL_kz00_2558;
BgL_kz00_2558 = 
CINT(BgL_snumz00_1533); 
VECTOR_SET(BgL_vargsz00_1471,BgL_kz00_2558,BgL_arg3424z00_1536); } } 
{ /* Expand/object.scm 624 */
long BgL_arg3431z00_1538;obj_t BgL_arg3432z00_1539;
{ /* Expand/object.scm 624 */
long BgL_auxz00_4231;
BgL_auxz00_4231 = 
(long)CINT(BgL_snumz00_1533); 
BgL_arg3431z00_1538 = 
(BgL_auxz00_4231-((long)1)); } 
BgL_arg3432z00_1539 = 
MAKE_PAIR(BFALSE, BgL_lenz00_1495); 
{ /* Expand/object.scm 624 */
int BgL_kz00_2563;
BgL_kz00_2563 = 
(int)(BgL_arg3431z00_1538); 
VECTOR_SET(BgL_vargsz00_1471,BgL_kz00_2563,BgL_arg3432z00_1539); } } }  else 
{ /* Expand/object.scm 618 */
FAILURE(BFALSE,BGl_string4861z00zzexpand_objectz00,BgL_formz00_40);} } } } }  else 
{ /* Expand/object.scm 604 */
BgL_tagzd2408zd2_1498:
FAILURE(BFALSE,BGl_string4861z00zzexpand_objectz00,BgL_formz00_40);} }  else 
{ /* Expand/object.scm 604 */
goto BgL_tagzd2408zd2_1498;} }  else 
{ /* Expand/object.scm 604 */
goto BgL_tagzd2408zd2_1498;} } }  else 
{ /* Expand/object.scm 604 */
goto BgL_tagzd2408zd2_1498;} }  else 
{ /* Expand/object.scm 604 */
if(
SYMBOLP(BgL_carzd2415zd2_1501))
{ /* Expand/object.scm 604 */
if(
PAIRP(BgL_cdrzd2416zd2_1502))
{ /* Expand/object.scm 604 */
obj_t BgL_cdrzd2471zd2_1523;
BgL_cdrzd2471zd2_1523 = 
CDR(BgL_cdrzd2416zd2_1502); 
if(
PAIRP(BgL_cdrzd2471zd2_1523))
{ /* Expand/object.scm 604 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2471zd2_1523), BNIL))
{ 
obj_t BgL_valuez00_4254;obj_t BgL_lenz00_4252;obj_t BgL_szd2namezd2_4251;
BgL_szd2namezd2_4251 = BgL_carzd2415zd2_1501; 
BgL_lenz00_4252 = 
CAR(BgL_cdrzd2416zd2_1502); 
BgL_valuez00_4254 = 
CAR(BgL_cdrzd2471zd2_1523); 
BgL_valuez00_1496 = BgL_valuez00_4254; 
BgL_lenz00_1495 = BgL_lenz00_4252; 
BgL_szd2namezd2_1494 = BgL_szd2namezd2_4251; 
goto BgL_tagzd2407zd2_1497;}  else 
{ /* Expand/object.scm 604 */
goto BgL_tagzd2408zd2_1498;} }  else 
{ /* Expand/object.scm 604 */
goto BgL_tagzd2408zd2_1498;} }  else 
{ /* Expand/object.scm 604 */
goto BgL_tagzd2408zd2_1498;} }  else 
{ /* Expand/object.scm 604 */
goto BgL_tagzd2408zd2_1498;} } }  else 
{ /* Expand/object.scm 604 */
goto BgL_tagzd2408zd2_1498;} } 
{ 
obj_t BgL_providedz00_4256;
BgL_providedz00_4256 = 
CDR(BgL_providedz00_1487); 
BgL_providedz00_1487 = BgL_providedz00_4256; 
goto BgL_loopz00_1488;} } } 
{ 
long BgL_iz00_1541;obj_t BgL_sz00_1542;
BgL_iz00_1541 = ((long)0); 
BgL_sz00_1542 = BgL_slotsz00_1468; 
BgL_loopz00_1543:
if(
(BgL_iz00_1541==BgL_lenz00_1470))
{ /* Expand/object.scm 633 */
CNST_TABLE_REF(((long)14)); }  else 
{ /* Expand/object.scm 635 */
bool_t BgL_test3449z00_1545;
{ /* Expand/object.scm 635 */
bool_t BgL_test3471z00_1554;
{ /* Expand/object.scm 635 */
obj_t BgL_arg3478z00_1557;
{ /* Expand/object.scm 635 */
int BgL_kz00_2575;
BgL_kz00_2575 = 
(int)(BgL_iz00_1541); 
BgL_arg3478z00_1557 = 
VECTOR_REF(BgL_vargsz00_1471,BgL_kz00_2575); } 
{ /* Expand/object.scm 635 */
obj_t BgL_auxz00_4263;
BgL_auxz00_4263 = 
CAR(BgL_arg3478z00_1557); 
BgL_test3471z00_1554 = 
CBOOL(BgL_auxz00_4263); } } 
if(BgL_test3471z00_1554)
{ /* Expand/object.scm 635 */
BgL_test3449z00_1545 = ((bool_t)0); }  else 
{ /* Expand/object.scm 636 */
bool_t BgL_test3472z00_1555;
{ /* Expand/object.scm 636 */
BgL_slotz00_bglt BgL_auxz00_4267;
{ /* Expand/object.scm 636 */
obj_t BgL_auxz00_4268;
BgL_auxz00_4268 = 
CAR(BgL_sz00_1542); 
BgL_auxz00_4267 = 
(BgL_slotz00_bglt)(BgL_auxz00_4268); } 
BgL_test3472z00_1555 = 
BGl_slotzd2virtualzf3z21zzobject_slotsz00(BgL_auxz00_4267); } 
if(BgL_test3472z00_1555)
{ /* Expand/object.scm 636 */
BgL_test3449z00_1545 = ((bool_t)0); }  else 
{ /* Expand/object.scm 636 */
BgL_test3449z00_1545 = ((bool_t)1); } } } 
if(BgL_test3449z00_1545)
{ /* Expand/object.scm 635 */
{ /* Expand/object.scm 639 */
obj_t BgL_arg3451z00_1546;
{ /* Expand/object.scm 639 */
obj_t BgL_arg3455z00_1548;
{ /* Expand/object.scm 641 */
obj_t BgL_auxz00_4274;
{ /* Expand/object.scm 641 */
BgL_slotz00_bglt BgL_obj1747z00_2579;
{ /* Expand/object.scm 641 */
obj_t BgL_auxz00_4275;
BgL_auxz00_4275 = 
CAR(BgL_sz00_1542); 
BgL_obj1747z00_2579 = 
(BgL_slotz00_bglt)(BgL_auxz00_4275); } 
BgL_auxz00_4274 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1747z00_2579))->BgL_idz00); } 
BgL_arg3455z00_1548 = 
SYMBOL_TO_STRING(BgL_auxz00_4274); } 
BgL_arg3451z00_1546 = 
string_append_3(BGl_string4863z00zzexpand_objectz00, BgL_arg3455z00_1548, BGl_string4851z00zzexpand_objectz00); } 
FAILURE(BFALSE,BgL_arg3451z00_1546,BgL_formz00_40);} }  else 
{ /* Expand/object.scm 635 */
{ 
obj_t BgL_sz00_4284;long BgL_iz00_4282;
BgL_iz00_4282 = 
(BgL_iz00_1541+((long)1)); 
BgL_sz00_4284 = 
CDR(BgL_sz00_1542); 
BgL_sz00_1542 = BgL_sz00_4284; 
BgL_iz00_1541 = BgL_iz00_4282; 
goto BgL_loopz00_1543;} } } } 
{ 
long BgL_iz00_1558;obj_t BgL_slotsz00_1559;obj_t BgL_largsz00_1560;obj_t BgL_virtualsz00_1561;
BgL_iz00_1558 = ((long)0); 
BgL_slotsz00_1559 = BgL_slotsz00_1468; 
BgL_largsz00_1560 = BNIL; 
BgL_virtualsz00_1561 = BNIL; 
BgL_loopz00_1562:
if(
(BgL_iz00_1558==BgL_lenz00_1470))
{ /* Expand/object.scm 652 */
obj_t BgL_wideningz00_1564;
{ /* Expand/object.scm 652 */
obj_t BgL_arg3848z00_1725;obj_t BgL_arg3849z00_1726;
{ /* Expand/object.scm 652 */
BgL_tclassz00_bglt BgL_obj1615z00_2589;
BgL_obj1615z00_2589 = 
(BgL_tclassz00_bglt)(BgL_classz00_41); 
{ 
obj_t BgL_auxz00_4289;
{ /* Expand/object.scm 652 */
BgL_objectz00_bglt BgL_auxz00_4290;
BgL_auxz00_4290 = 
(BgL_objectz00_bglt)(BgL_obj1615z00_2589); 
BgL_auxz00_4289 = 
BGL_OBJECT_WIDENING(BgL_auxz00_4290); } 
BgL_arg3848z00_1725 = 
(((BgL_tclassz00_bglt)CREF(BgL_auxz00_4289))->BgL_wideningz00); } } 
BgL_arg3849z00_1726 = 
CNST_TABLE_REF(((long)4)); 
{ /* Expand/object.scm 652 */
obj_t BgL_list3852z00_1728;
{ /* Expand/object.scm 652 */
obj_t BgL_arg3854z00_1729;
{ /* Expand/object.scm 652 */
obj_t BgL_arg3857z00_1730;
{ /* Expand/object.scm 652 */
obj_t BgL_auxz00_4295;
BgL_auxz00_4295 = 
(((BgL_typez00_bglt)CREF(BgL_classz00_41))->BgL_idz00); 
BgL_arg3857z00_1730 = 
MAKE_PAIR(BgL_auxz00_4295, BNIL); } 
BgL_arg3854z00_1729 = 
MAKE_PAIR(BgL_arg3849z00_1726, BgL_arg3857z00_1730); } 
BgL_list3852z00_1728 = 
MAKE_PAIR(BgL_arg3848z00_1725, BgL_arg3854z00_1729); } 
BgL_wideningz00_1564 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list3852z00_1728); } } 
if(
CBOOL(BGl_za2unsafezd2typeza2zd2zzengine_paramz00))
{ /* Expand/object.scm 669 */
obj_t BgL_arg3485z00_1565;obj_t BgL_arg3486z00_1566;
BgL_arg3485z00_1565 = 
CNST_TABLE_REF(((long)2)); 
{ /* Expand/object.scm 656 */
obj_t BgL_arg3489z00_1567;obj_t BgL_arg3491z00_1568;
{ /* Expand/object.scm 656 */
obj_t BgL_arg3494z00_1569;
{ /* Expand/object.scm 656 */
obj_t BgL_arg3498z00_1571;
BgL_arg3498z00_1571 = 
MAKE_PAIR(BgL_castz00_1475, BNIL); 
BgL_arg3494z00_1569 = 
MAKE_PAIR(BgL_dupzd2varzd2typedz00_1474, BgL_arg3498z00_1571); } 
BgL_arg3489z00_1567 = 
MAKE_PAIR(BgL_arg3494z00_1569, BNIL); } 
{ /* Expand/object.scm 657 */
obj_t BgL_arg3502z00_1572;obj_t BgL_arg3503z00_1573;
{ /* Expand/object.scm 657 */
obj_t BgL_arg3506z00_1574;obj_t BgL_arg3507z00_1575;
BgL_arg3506z00_1574 = 
CNST_TABLE_REF(((long)26)); 
{ /* Expand/object.scm 659 */
obj_t BgL_arg3510z00_1576;
{ /* Expand/object.scm 659 */
obj_t BgL_arg3513z00_1577;
{ /* Expand/object.scm 659 */
obj_t BgL_arg3517z00_1579;
{ /* Expand/object.scm 659 */
obj_t BgL_arg3520z00_1580;
BgL_arg3520z00_1580 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_largsz00_1560); 
BgL_arg3517z00_1579 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg3520z00_1580, BNIL); } 
BgL_arg3513z00_1577 = 
MAKE_PAIR(BgL_wideningz00_1564, BgL_arg3517z00_1579); } 
BgL_arg3510z00_1576 = 
MAKE_PAIR(BgL_arg3513z00_1577, BNIL); } 
BgL_arg3507z00_1575 = 
MAKE_PAIR(BgL_dupzd2varzd2_1472, BgL_arg3510z00_1576); } 
BgL_arg3502z00_1572 = 
MAKE_PAIR(BgL_arg3506z00_1574, BgL_arg3507z00_1575); } 
{ /* Expand/object.scm 662 */
obj_t BgL_arg3525z00_1582;obj_t BgL_arg3526z00_1583;
{ /* Expand/object.scm 662 */
obj_t BgL_arg3529z00_1584;obj_t BgL_arg3530z00_1585;
{ /* Expand/object.scm 662 */
obj_t BgL_arg3533z00_1586;obj_t BgL_arg3534z00_1587;
BgL_arg3533z00_1586 = 
CNST_TABLE_REF(((long)27)); 
{ /* Expand/object.scm 662 */
obj_t BgL_arg3537z00_1588;obj_t BgL_arg3538z00_1589;
BgL_arg3537z00_1588 = 
CNST_TABLE_REF(((long)28)); 
{ /* Expand/object.scm 662 */
obj_t BgL_auxz00_4316;
BgL_auxz00_4316 = 
CNST_TABLE_REF(((long)29)); 
BgL_arg3538z00_1589 = 
MAKE_PAIR(BgL_auxz00_4316, BNIL); } 
BgL_arg3534z00_1587 = 
MAKE_PAIR(BgL_arg3537z00_1588, BgL_arg3538z00_1589); } 
BgL_arg3529z00_1584 = 
MAKE_PAIR(BgL_arg3533z00_1586, BgL_arg3534z00_1587); } 
{ /* Expand/object.scm 664 */
obj_t BgL_arg3542z00_1590;
{ /* Expand/object.scm 664 */
obj_t BgL_arg3545z00_1591;
{ /* Expand/object.scm 664 */
obj_t BgL_arg3549z00_1593;obj_t BgL_arg3550z00_1594;
{ /* Expand/object.scm 664 */
obj_t BgL_arg3553z00_1595;obj_t BgL_arg3554z00_1596;
BgL_arg3553z00_1595 = 
CNST_TABLE_REF(((long)27)); 
{ /* Expand/object.scm 664 */
obj_t BgL_arg3557z00_1597;obj_t BgL_arg3558z00_1598;
BgL_arg3557z00_1597 = 
CNST_TABLE_REF(((long)30)); 
{ /* Expand/object.scm 664 */
obj_t BgL_auxz00_4323;
BgL_auxz00_4323 = 
CNST_TABLE_REF(((long)29)); 
BgL_arg3558z00_1598 = 
MAKE_PAIR(BgL_auxz00_4323, BNIL); } 
BgL_arg3554z00_1596 = 
MAKE_PAIR(BgL_arg3557z00_1597, BgL_arg3558z00_1598); } 
BgL_arg3549z00_1593 = 
MAKE_PAIR(BgL_arg3553z00_1595, BgL_arg3554z00_1596); } 
{ /* Expand/object.scm 665 */
obj_t BgL_arg3562z00_1599;
{ /* Expand/object.scm 665 */
obj_t BgL_arg3566z00_1601;obj_t BgL_arg3567z00_1602;
BgL_arg3566z00_1601 = 
CNST_TABLE_REF(((long)27)); 
{ /* Expand/object.scm 665 */
obj_t BgL_arg3570z00_1603;obj_t BgL_arg3571z00_1604;
BgL_arg3570z00_1603 = 
(((BgL_globalz00_bglt)CREF(BgL_holderz00_1469))->BgL_idz00); 
{ /* Expand/object.scm 665 */
obj_t BgL_auxz00_4330;
BgL_auxz00_4330 = 
(((BgL_globalz00_bglt)CREF(BgL_holderz00_1469))->BgL_modulez00); 
BgL_arg3571z00_1604 = 
MAKE_PAIR(BgL_auxz00_4330, BNIL); } 
BgL_arg3567z00_1602 = 
MAKE_PAIR(BgL_arg3570z00_1603, BgL_arg3571z00_1604); } 
BgL_arg3562z00_1599 = 
MAKE_PAIR(BgL_arg3566z00_1601, BgL_arg3567z00_1602); } 
BgL_arg3550z00_1594 = 
MAKE_PAIR(BgL_arg3562z00_1599, BNIL); } 
BgL_arg3545z00_1591 = 
MAKE_PAIR(BgL_arg3549z00_1593, BgL_arg3550z00_1594); } 
BgL_arg3542z00_1590 = 
MAKE_PAIR(BgL_arg3545z00_1591, BNIL); } 
BgL_arg3530z00_1585 = 
MAKE_PAIR(BgL_dupzd2varzd2_1472, BgL_arg3542z00_1590); } 
BgL_arg3525z00_1582 = 
MAKE_PAIR(BgL_arg3529z00_1584, BgL_arg3530z00_1585); } 
{ /* Expand/object.scm 667 */
obj_t BgL_arg3580z00_1607;obj_t BgL_arg3581z00_1608;
{ /* Expand/object.scm 667 */
obj_t BgL_arg3584z00_1609;obj_t BgL_arg3586z00_1610;
{ /* Expand/object.scm 667 */
obj_t BgL_arg3589z00_1611;obj_t BgL_arg3590z00_1612;
BgL_arg3589z00_1611 = 
CNST_TABLE_REF(((long)27)); 
{ /* Expand/object.scm 667 */
obj_t BgL_arg3593z00_1613;obj_t BgL_arg3594z00_1614;
BgL_arg3593z00_1613 = 
CNST_TABLE_REF(((long)31)); 
{ /* Expand/object.scm 667 */
obj_t BgL_auxz00_4342;
BgL_auxz00_4342 = 
CNST_TABLE_REF(((long)29)); 
BgL_arg3594z00_1614 = 
MAKE_PAIR(BgL_auxz00_4342, BNIL); } 
BgL_arg3590z00_1612 = 
MAKE_PAIR(BgL_arg3593z00_1613, BgL_arg3594z00_1614); } 
BgL_arg3584z00_1609 = 
MAKE_PAIR(BgL_arg3589z00_1611, BgL_arg3590z00_1612); } 
BgL_arg3586z00_1610 = 
MAKE_PAIR(BgL_dupzd2varzd2_1472, BNIL); 
BgL_arg3580z00_1607 = 
MAKE_PAIR(BgL_arg3584z00_1609, BgL_arg3586z00_1610); } 
{ /* Expand/object.scm 668 */
obj_t BgL_arg3599z00_1615;obj_t BgL_arg3600z00_1616;
BgL_arg3599z00_1615 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_virtualsz00_1561); 
BgL_arg3600z00_1616 = 
MAKE_PAIR(BgL_dupzd2varzd2_1472, BNIL); 
BgL_arg3581z00_1608 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg3599z00_1615, BgL_arg3600z00_1616); } 
BgL_arg3526z00_1583 = 
MAKE_PAIR(BgL_arg3580z00_1607, BgL_arg3581z00_1608); } 
BgL_arg3503z00_1573 = 
MAKE_PAIR(BgL_arg3525z00_1582, BgL_arg3526z00_1583); } 
BgL_arg3491z00_1568 = 
MAKE_PAIR(BgL_arg3502z00_1572, BgL_arg3503z00_1573); } 
BgL_arg3486z00_1566 = 
MAKE_PAIR(BgL_arg3489z00_1567, BgL_arg3491z00_1568); } 
return 
MAKE_PAIR(BgL_arg3485z00_1565, BgL_arg3486z00_1566);}  else 
{ /* Expand/object.scm 694 */
obj_t BgL_arg3605z00_1617;obj_t BgL_arg3606z00_1618;
BgL_arg3605z00_1617 = 
CNST_TABLE_REF(((long)2)); 
{ /* Expand/object.scm 670 */
obj_t BgL_arg3609z00_1619;obj_t BgL_arg3610z00_1620;
{ /* Expand/object.scm 670 */
obj_t BgL_arg3613z00_1621;
{ /* Expand/object.scm 670 */
obj_t BgL_arg3617z00_1623;
BgL_arg3617z00_1623 = 
MAKE_PAIR(BgL_castz00_1475, BNIL); 
BgL_arg3613z00_1621 = 
MAKE_PAIR(BgL_dupzd2varzd2typedz00_1474, BgL_arg3617z00_1623); } 
BgL_arg3609z00_1619 = 
MAKE_PAIR(BgL_arg3613z00_1621, BNIL); } 
{ /* Expand/object.scm 671 */
obj_t BgL_arg3621z00_1624;obj_t BgL_arg3622z00_1625;
{ /* Expand/object.scm 671 */
obj_t BgL_arg3625z00_1626;obj_t BgL_arg3626z00_1627;
BgL_arg3625z00_1626 = 
CNST_TABLE_REF(((long)32)); 
{ /* Expand/object.scm 671 */
obj_t BgL_arg3629z00_1628;obj_t BgL_arg3630z00_1629;
{ /* Expand/object.scm 671 */
obj_t BgL_arg3633z00_1630;obj_t BgL_arg3634z00_1631;
BgL_arg3633z00_1630 = 
CNST_TABLE_REF(((long)33)); 
BgL_arg3634z00_1631 = 
MAKE_PAIR(BgL_dupzd2varzd2_1472, BNIL); 
BgL_arg3629z00_1628 = 
MAKE_PAIR(BgL_arg3633z00_1630, BgL_arg3634z00_1631); } 
{ /* Expand/object.scm 672 */
obj_t BgL_arg3638z00_1632;
{ /* Expand/object.scm 672 */
obj_t BgL_arg3642z00_1634;obj_t BgL_arg3643z00_1635;
BgL_arg3642z00_1634 = 
CNST_TABLE_REF(((long)34)); 
BgL_arg3643z00_1635 = 
MAKE_PAIR(BgL_dupzd2varzd2_1472, BNIL); 
BgL_arg3638z00_1632 = 
MAKE_PAIR(BgL_arg3642z00_1634, BgL_arg3643z00_1635); } 
BgL_arg3630z00_1629 = 
MAKE_PAIR(BgL_arg3638z00_1632, BNIL); } 
BgL_arg3626z00_1627 = 
MAKE_PAIR(BgL_arg3629z00_1628, BgL_arg3630z00_1629); } 
BgL_arg3621z00_1624 = 
MAKE_PAIR(BgL_arg3625z00_1626, BgL_arg3626z00_1627); } 
{ /* Expand/object.scm 673 */
obj_t BgL_arg3647z00_1636;
{ /* Expand/object.scm 673 */
obj_t BgL_arg3651z00_1638;obj_t BgL_arg3652z00_1639;
BgL_arg3651z00_1638 = 
CNST_TABLE_REF(((long)32)); 
{ /* Expand/object.scm 673 */
obj_t BgL_arg3655z00_1640;obj_t BgL_arg3656z00_1641;
{ /* Expand/object.scm 673 */
obj_t BgL_arg3660z00_1642;obj_t BgL_arg3661z00_1643;
BgL_arg3660z00_1642 = 
CNST_TABLE_REF(((long)35)); 
{ /* Expand/object.scm 673 */
obj_t BgL_arg3664z00_1644;obj_t BgL_arg3665z00_1645;
{ /* Expand/object.scm 673 */
obj_t BgL_arg3668z00_1646;obj_t BgL_arg3669z00_1647;
{ /* Expand/object.scm 673 */
obj_t BgL_arg3672z00_1648;obj_t BgL_arg3673z00_1649;
BgL_arg3672z00_1648 = 
CNST_TABLE_REF(((long)27)); 
{ /* Expand/object.scm 673 */
obj_t BgL_arg3676z00_1650;obj_t BgL_arg3677z00_1651;
BgL_arg3676z00_1650 = 
CNST_TABLE_REF(((long)36)); 
{ /* Expand/object.scm 673 */
obj_t BgL_auxz00_4375;
BgL_auxz00_4375 = 
CNST_TABLE_REF(((long)29)); 
BgL_arg3677z00_1651 = 
MAKE_PAIR(BgL_auxz00_4375, BNIL); } 
BgL_arg3673z00_1649 = 
MAKE_PAIR(BgL_arg3676z00_1650, BgL_arg3677z00_1651); } 
BgL_arg3668z00_1646 = 
MAKE_PAIR(BgL_arg3672z00_1648, BgL_arg3673z00_1649); } 
{ /* Expand/object.scm 674 */
obj_t BgL_arg3681z00_1652;
{ /* Expand/object.scm 674 */
obj_t BgL_arg3686z00_1654;obj_t BgL_arg3687z00_1655;
BgL_arg3686z00_1654 = 
CNST_TABLE_REF(((long)27)); 
{ /* Expand/object.scm 674 */
obj_t BgL_arg3690z00_1656;obj_t BgL_arg3691z00_1657;
BgL_arg3690z00_1656 = 
(((BgL_globalz00_bglt)CREF(BgL_holderz00_1469))->BgL_idz00); 
{ /* Expand/object.scm 674 */
obj_t BgL_auxz00_4382;
BgL_auxz00_4382 = 
(((BgL_globalz00_bglt)CREF(BgL_holderz00_1469))->BgL_modulez00); 
BgL_arg3691z00_1657 = 
MAKE_PAIR(BgL_auxz00_4382, BNIL); } 
BgL_arg3687z00_1655 = 
MAKE_PAIR(BgL_arg3690z00_1656, BgL_arg3691z00_1657); } 
BgL_arg3681z00_1652 = 
MAKE_PAIR(BgL_arg3686z00_1654, BgL_arg3687z00_1655); } 
BgL_arg3669z00_1647 = 
MAKE_PAIR(BgL_arg3681z00_1652, BNIL); } 
BgL_arg3664z00_1644 = 
MAKE_PAIR(BgL_arg3668z00_1646, BgL_arg3669z00_1647); } 
{ /* Expand/object.scm 676 */
obj_t BgL_arg3700z00_1660;
{ /* Expand/object.scm 676 */
obj_t BgL_arg3704z00_1662;obj_t BgL_arg3705z00_1663;
{ /* Expand/object.scm 676 */
obj_t BgL_arg3708z00_1664;obj_t BgL_arg3709z00_1665;
BgL_arg3708z00_1664 = 
CNST_TABLE_REF(((long)27)); 
{ /* Expand/object.scm 676 */
obj_t BgL_arg3712z00_1666;obj_t BgL_arg3713z00_1667;
BgL_arg3712z00_1666 = 
CNST_TABLE_REF(((long)37)); 
{ /* Expand/object.scm 676 */
obj_t BgL_auxz00_4391;
BgL_auxz00_4391 = 
CNST_TABLE_REF(((long)29)); 
BgL_arg3713z00_1667 = 
MAKE_PAIR(BgL_auxz00_4391, BNIL); } 
BgL_arg3709z00_1665 = 
MAKE_PAIR(BgL_arg3712z00_1666, BgL_arg3713z00_1667); } 
BgL_arg3704z00_1662 = 
MAKE_PAIR(BgL_arg3708z00_1664, BgL_arg3709z00_1665); } 
BgL_arg3705z00_1663 = 
MAKE_PAIR(BgL_dupzd2varzd2_1472, BNIL); 
BgL_arg3700z00_1660 = 
MAKE_PAIR(BgL_arg3704z00_1662, BgL_arg3705z00_1663); } 
BgL_arg3665z00_1645 = 
MAKE_PAIR(BgL_arg3700z00_1660, BNIL); } 
BgL_arg3661z00_1643 = 
MAKE_PAIR(BgL_arg3664z00_1644, BgL_arg3665z00_1645); } 
BgL_arg3655z00_1640 = 
MAKE_PAIR(BgL_arg3660z00_1642, BgL_arg3661z00_1643); } 
{ /* Expand/object.scm 677 */
obj_t BgL_arg3718z00_1668;obj_t BgL_arg3719z00_1669;
{ /* Expand/object.scm 677 */
obj_t BgL_arg3722z00_1670;obj_t BgL_arg3723z00_1671;
BgL_arg3722z00_1670 = 
CNST_TABLE_REF(((long)18)); 
{ /* Expand/object.scm 678 */
obj_t BgL_arg3726z00_1672;obj_t BgL_arg3727z00_1673;
{ /* Expand/object.scm 678 */
obj_t BgL_arg3730z00_1674;obj_t BgL_arg3731z00_1675;
BgL_arg3730z00_1674 = 
CNST_TABLE_REF(((long)26)); 
{ /* Expand/object.scm 680 */
obj_t BgL_arg3734z00_1676;
{ /* Expand/object.scm 680 */
obj_t BgL_arg3737z00_1677;
{ /* Expand/object.scm 680 */
obj_t BgL_arg3741z00_1679;
{ /* Expand/object.scm 680 */
obj_t BgL_arg3744z00_1680;
BgL_arg3744z00_1680 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_largsz00_1560); 
BgL_arg3741z00_1679 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg3744z00_1680, BNIL); } 
BgL_arg3737z00_1677 = 
MAKE_PAIR(BgL_wideningz00_1564, BgL_arg3741z00_1679); } 
BgL_arg3734z00_1676 = 
MAKE_PAIR(BgL_arg3737z00_1677, BNIL); } 
BgL_arg3731z00_1675 = 
MAKE_PAIR(BgL_dupzd2varzd2_1472, BgL_arg3734z00_1676); } 
BgL_arg3726z00_1672 = 
MAKE_PAIR(BgL_arg3730z00_1674, BgL_arg3731z00_1675); } 
{ /* Expand/object.scm 682 */
obj_t BgL_arg3749z00_1682;obj_t BgL_arg3750z00_1683;
{ /* Expand/object.scm 682 */
obj_t BgL_arg3753z00_1684;obj_t BgL_arg3754z00_1685;
{ /* Expand/object.scm 682 */
obj_t BgL_arg3757z00_1686;obj_t BgL_arg3758z00_1687;
BgL_arg3757z00_1686 = 
CNST_TABLE_REF(((long)27)); 
{ /* Expand/object.scm 682 */
obj_t BgL_arg3761z00_1688;obj_t BgL_arg3762z00_1689;
BgL_arg3761z00_1688 = 
CNST_TABLE_REF(((long)28)); 
{ /* Expand/object.scm 682 */
obj_t BgL_auxz00_4411;
BgL_auxz00_4411 = 
CNST_TABLE_REF(((long)29)); 
BgL_arg3762z00_1689 = 
MAKE_PAIR(BgL_auxz00_4411, BNIL); } 
BgL_arg3758z00_1687 = 
MAKE_PAIR(BgL_arg3761z00_1688, BgL_arg3762z00_1689); } 
BgL_arg3753z00_1684 = 
MAKE_PAIR(BgL_arg3757z00_1686, BgL_arg3758z00_1687); } 
{ /* Expand/object.scm 684 */
obj_t BgL_arg3766z00_1690;
{ /* Expand/object.scm 684 */
obj_t BgL_arg3769z00_1691;
{ /* Expand/object.scm 684 */
obj_t BgL_arg3773z00_1693;obj_t BgL_arg3774z00_1694;
{ /* Expand/object.scm 684 */
obj_t BgL_arg3777z00_1695;obj_t BgL_arg3778z00_1696;
BgL_arg3777z00_1695 = 
CNST_TABLE_REF(((long)27)); 
{ /* Expand/object.scm 684 */
obj_t BgL_arg3781z00_1697;obj_t BgL_arg3782z00_1698;
BgL_arg3781z00_1697 = 
CNST_TABLE_REF(((long)30)); 
{ /* Expand/object.scm 684 */
obj_t BgL_auxz00_4418;
BgL_auxz00_4418 = 
CNST_TABLE_REF(((long)29)); 
BgL_arg3782z00_1698 = 
MAKE_PAIR(BgL_auxz00_4418, BNIL); } 
BgL_arg3778z00_1696 = 
MAKE_PAIR(BgL_arg3781z00_1697, BgL_arg3782z00_1698); } 
BgL_arg3773z00_1693 = 
MAKE_PAIR(BgL_arg3777z00_1695, BgL_arg3778z00_1696); } 
{ /* Expand/object.scm 685 */
obj_t BgL_arg3786z00_1699;
{ /* Expand/object.scm 685 */
obj_t BgL_arg3790z00_1701;obj_t BgL_arg3791z00_1702;
BgL_arg3790z00_1701 = 
CNST_TABLE_REF(((long)27)); 
{ /* Expand/object.scm 685 */
obj_t BgL_arg3794z00_1703;obj_t BgL_arg3795z00_1704;
BgL_arg3794z00_1703 = 
(((BgL_globalz00_bglt)CREF(BgL_holderz00_1469))->BgL_idz00); 
{ /* Expand/object.scm 685 */
obj_t BgL_auxz00_4425;
BgL_auxz00_4425 = 
(((BgL_globalz00_bglt)CREF(BgL_holderz00_1469))->BgL_modulez00); 
BgL_arg3795z00_1704 = 
MAKE_PAIR(BgL_auxz00_4425, BNIL); } 
BgL_arg3791z00_1702 = 
MAKE_PAIR(BgL_arg3794z00_1703, BgL_arg3795z00_1704); } 
BgL_arg3786z00_1699 = 
MAKE_PAIR(BgL_arg3790z00_1701, BgL_arg3791z00_1702); } 
BgL_arg3774z00_1694 = 
MAKE_PAIR(BgL_arg3786z00_1699, BNIL); } 
BgL_arg3769z00_1691 = 
MAKE_PAIR(BgL_arg3773z00_1693, BgL_arg3774z00_1694); } 
BgL_arg3766z00_1690 = 
MAKE_PAIR(BgL_arg3769z00_1691, BNIL); } 
BgL_arg3754z00_1685 = 
MAKE_PAIR(BgL_dupzd2varzd2_1472, BgL_arg3766z00_1690); } 
BgL_arg3749z00_1682 = 
MAKE_PAIR(BgL_arg3753z00_1684, BgL_arg3754z00_1685); } 
{ /* Expand/object.scm 688 */
obj_t BgL_arg3804z00_1707;obj_t BgL_arg3805z00_1708;
{ /* Expand/object.scm 688 */
obj_t BgL_arg3808z00_1709;obj_t BgL_arg3809z00_1710;
{ /* Expand/object.scm 688 */
obj_t BgL_arg3812z00_1711;obj_t BgL_arg3813z00_1712;
BgL_arg3812z00_1711 = 
CNST_TABLE_REF(((long)27)); 
{ /* Expand/object.scm 688 */
obj_t BgL_arg3817z00_1713;obj_t BgL_arg3818z00_1714;
BgL_arg3817z00_1713 = 
CNST_TABLE_REF(((long)31)); 
{ /* Expand/object.scm 688 */
obj_t BgL_auxz00_4437;
BgL_auxz00_4437 = 
CNST_TABLE_REF(((long)29)); 
BgL_arg3818z00_1714 = 
MAKE_PAIR(BgL_auxz00_4437, BNIL); } 
BgL_arg3813z00_1712 = 
MAKE_PAIR(BgL_arg3817z00_1713, BgL_arg3818z00_1714); } 
BgL_arg3808z00_1709 = 
MAKE_PAIR(BgL_arg3812z00_1711, BgL_arg3813z00_1712); } 
BgL_arg3809z00_1710 = 
MAKE_PAIR(BgL_dupzd2varzd2_1472, BNIL); 
BgL_arg3804z00_1707 = 
MAKE_PAIR(BgL_arg3808z00_1709, BgL_arg3809z00_1710); } 
{ /* Expand/object.scm 689 */
obj_t BgL_arg3823z00_1715;obj_t BgL_arg3824z00_1716;
BgL_arg3823z00_1715 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_virtualsz00_1561); 
BgL_arg3824z00_1716 = 
MAKE_PAIR(BgL_dupzd2varzd2_1472, BNIL); 
BgL_arg3805z00_1708 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg3823z00_1715, BgL_arg3824z00_1716); } 
BgL_arg3750z00_1683 = 
MAKE_PAIR(BgL_arg3804z00_1707, BgL_arg3805z00_1708); } 
BgL_arg3727z00_1673 = 
MAKE_PAIR(BgL_arg3749z00_1682, BgL_arg3750z00_1683); } 
BgL_arg3723z00_1671 = 
MAKE_PAIR(BgL_arg3726z00_1672, BgL_arg3727z00_1673); } 
BgL_arg3718z00_1668 = 
MAKE_PAIR(BgL_arg3722z00_1670, BgL_arg3723z00_1671); } 
{ /* Expand/object.scm 691 */
obj_t BgL_arg3829z00_1717;
{ /* Expand/object.scm 691 */
obj_t BgL_arg3833z00_1719;obj_t BgL_arg3835z00_1720;
BgL_arg3833z00_1719 = 
CNST_TABLE_REF(((long)38)); 
{ /* Expand/object.scm 691 */
obj_t BgL_arg3840z00_1722;
{ /* Expand/object.scm 691 */
obj_t BgL_arg3844z00_1724;
BgL_arg3844z00_1724 = 
MAKE_PAIR(BgL_dupzd2varzd2_1472, BNIL); 
BgL_arg3840z00_1722 = 
MAKE_PAIR(BGl_string4864z00zzexpand_objectz00, BgL_arg3844z00_1724); } 
BgL_arg3835z00_1720 = 
MAKE_PAIR(BGl_string4862z00zzexpand_objectz00, BgL_arg3840z00_1722); } 
BgL_arg3829z00_1717 = 
MAKE_PAIR(BgL_arg3833z00_1719, BgL_arg3835z00_1720); } 
BgL_arg3719z00_1669 = 
MAKE_PAIR(BgL_arg3829z00_1717, BNIL); } 
BgL_arg3656z00_1641 = 
MAKE_PAIR(BgL_arg3718z00_1668, BgL_arg3719z00_1669); } 
BgL_arg3652z00_1639 = 
MAKE_PAIR(BgL_arg3655z00_1640, BgL_arg3656z00_1641); } 
BgL_arg3647z00_1636 = 
MAKE_PAIR(BgL_arg3651z00_1638, BgL_arg3652z00_1639); } 
BgL_arg3622z00_1625 = 
MAKE_PAIR(BgL_arg3647z00_1636, BNIL); } 
BgL_arg3610z00_1620 = 
MAKE_PAIR(BgL_arg3621z00_1624, BgL_arg3622z00_1625); } 
BgL_arg3606z00_1618 = 
MAKE_PAIR(BgL_arg3609z00_1619, BgL_arg3610z00_1620); } 
return 
MAKE_PAIR(BgL_arg3605z00_1617, BgL_arg3606z00_1618);} }  else 
{ /* Expand/object.scm 695 */
obj_t BgL_valuez00_1731;
{ /* Expand/object.scm 695 */
obj_t BgL_arg3894z00_1744;
{ /* Expand/object.scm 695 */
int BgL_kz00_2598;
BgL_kz00_2598 = 
(int)(BgL_iz00_1558); 
BgL_arg3894z00_1744 = 
VECTOR_REF(BgL_vargsz00_1471,BgL_kz00_2598); } 
BgL_valuez00_1731 = 
CDR(BgL_arg3894z00_1744); } 
{ /* Expand/object.scm 697 */
bool_t BgL_test3862z00_1732;
{ /* Expand/object.scm 697 */
BgL_slotz00_bglt BgL_auxz00_4467;
{ /* Expand/object.scm 697 */
obj_t BgL_auxz00_4468;
BgL_auxz00_4468 = 
CAR(BgL_slotsz00_1559); 
BgL_auxz00_4467 = 
(BgL_slotz00_bglt)(BgL_auxz00_4468); } 
BgL_test3862z00_1732 = 
BGl_slotzd2virtualzf3z21zzobject_slotsz00(BgL_auxz00_4467); } 
if(BgL_test3862z00_1732)
{ /* Expand/object.scm 697 */
{ /* Expand/object.scm 698 */
long BgL_arg3864z00_1733;obj_t BgL_arg3865z00_1734;obj_t BgL_arg3866z00_1735;
BgL_arg3864z00_1733 = 
(BgL_iz00_1558+((long)1)); 
BgL_arg3865z00_1734 = 
CDR(BgL_slotsz00_1559); 
if(
(BgL_valuez00_1731==BUNSPEC))
{ /* Expand/object.scm 701 */
BgL_arg3866z00_1735 = BgL_virtualsz00_1561; }  else 
{ /* Expand/object.scm 703 */
obj_t BgL_arg3872z00_1737;
BgL_arg3872z00_1737 = 
BGl_makezd2virtualzd2setz00zzexpand_objectz00(
CAR(BgL_slotsz00_1559), BgL_valuez00_1731, BgL_dupzd2varzd2_1472, 
(obj_t)(BgL_classz00_41), BgL_formz00_40, "widen!"); 
BgL_arg3866z00_1735 = 
MAKE_PAIR(BgL_arg3872z00_1737, BgL_virtualsz00_1561); } 
{ 
obj_t BgL_virtualsz00_4483;obj_t BgL_slotsz00_4482;long BgL_iz00_4481;
BgL_iz00_4481 = BgL_arg3864z00_1733; 
BgL_slotsz00_4482 = BgL_arg3865z00_1734; 
BgL_virtualsz00_4483 = BgL_arg3866z00_1735; 
BgL_virtualsz00_1561 = BgL_virtualsz00_4483; 
BgL_slotsz00_1559 = BgL_slotsz00_4482; 
BgL_iz00_1558 = BgL_iz00_4481; 
goto BgL_loopz00_1562;} } }  else 
{ /* Expand/object.scm 697 */
{ /* Expand/object.scm 711 */
long BgL_arg3881z00_1740;obj_t BgL_arg3883z00_1741;obj_t BgL_arg3884z00_1742;
BgL_arg3881z00_1740 = 
(BgL_iz00_1558+((long)1)); 
BgL_arg3883z00_1741 = 
CDR(BgL_slotsz00_1559); 
BgL_arg3884z00_1742 = 
MAKE_PAIR(BgL_valuez00_1731, BgL_largsz00_1560); 
{ 
obj_t BgL_largsz00_4489;obj_t BgL_slotsz00_4488;long BgL_iz00_4487;
BgL_iz00_4487 = BgL_arg3881z00_1740; 
BgL_slotsz00_4488 = BgL_arg3883z00_1741; 
BgL_largsz00_4489 = BgL_arg3884z00_1742; 
BgL_largsz00_1560 = BgL_largsz00_4489; 
BgL_slotsz00_1559 = BgL_slotsz00_4488; 
BgL_iz00_1558 = BgL_iz00_4487; 
goto BgL_loopz00_1562;} } } } } } } } } } } } } } } } 
}



/* expand-shrink! */
obj_t BGl_expandzd2shrinkz12zc0zzexpand_objectz00(obj_t BgL_xz00_44, obj_t BgL_ez00_45)
{ AN_OBJECT;
{ /* Expand/object.scm 719 */
{ 

if(
PAIRP(BgL_xz00_44))
{ /* Expand/object.scm 720 */
obj_t BgL_cdrzd2489zd2_1754;
BgL_cdrzd2489zd2_1754 = 
CDR(BgL_xz00_44); 
{ /* Expand/object.scm 720 */
bool_t BgL_testz00_4493;
{ /* Expand/object.scm 720 */
obj_t BgL_auxz00_4496;obj_t BgL_auxz00_4494;
BgL_auxz00_4496 = 
CNST_TABLE_REF(((long)34)); 
BgL_auxz00_4494 = 
CAR(BgL_xz00_44); 
BgL_testz00_4493 = 
(BgL_auxz00_4494==BgL_auxz00_4496); } 
if(BgL_testz00_4493)
{ /* Expand/object.scm 720 */
if(
PAIRP(BgL_cdrzd2489zd2_1754))
{ /* Expand/object.scm 720 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2489zd2_1754), BNIL))
{ /* Expand/object.scm 720 */
obj_t BgL_arg3942z00_2615;
BgL_arg3942z00_2615 = 
BGl_makezd2azd2shrinkz12z12zzexpand_objectz00(BgL_ez00_45, 
CAR(BgL_cdrzd2489zd2_1754)); 
return 
BGl_replacez12z12zztools_miscz00(BgL_xz00_44, BgL_arg3942z00_2615);}  else 
{ /* Expand/object.scm 720 */
BgL_tagzd2484zd2_1751:
FAILURE(BFALSE,BGl_string4865z00zzexpand_objectz00,BgL_xz00_44);} }  else 
{ /* Expand/object.scm 720 */
goto BgL_tagzd2484zd2_1751;} }  else 
{ /* Expand/object.scm 720 */
goto BgL_tagzd2484zd2_1751;} } }  else 
{ /* Expand/object.scm 720 */
goto BgL_tagzd2484zd2_1751;} } } 
}



/* _expand-shrink! */
obj_t BGl__expandzd2shrinkz12zc0zzexpand_objectz00(obj_t BgL_envz00_2948, obj_t BgL_xz00_2949, obj_t BgL_ez00_2950)
{ AN_OBJECT;
{ /* Expand/object.scm 719 */
return 
BGl_expandzd2shrinkz12zc0zzexpand_objectz00(BgL_xz00_2949, BgL_ez00_2950);} 
}



/* make-a-shrink! */
obj_t BGl_makezd2azd2shrinkz12z12zzexpand_objectz00(obj_t BgL_ez00_46, obj_t BgL_oz00_47)
{ AN_OBJECT;
{ /* Expand/object.scm 729 */
{ /* Expand/object.scm 730 */
obj_t BgL_newoz00_1764;
{ /* Expand/object.scm 730 */
obj_t BgL_arg4235z00_1895;
BgL_arg4235z00_1895 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)39)), BEOA); 
BgL_newoz00_1764 = 
BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(BgL_arg4235z00_1895); } 
if(
CBOOL(BGl_za2unsafezd2typeza2zd2zzengine_paramz00))
{ /* Expand/object.scm 739 */
obj_t BgL_arg3947z00_1765;obj_t BgL_arg3948z00_1766;
BgL_arg3947z00_1765 = 
CNST_TABLE_REF(((long)2)); 
{ /* Expand/object.scm 732 */
obj_t BgL_arg3951z00_1767;obj_t BgL_arg3952z00_1768;
{ /* Expand/object.scm 732 */
obj_t BgL_arg3955z00_1769;
{ /* Expand/object.scm 732 */
obj_t BgL_arg3959z00_1771;
{ /* Expand/object.scm 732 */
obj_t BgL_arg3962z00_1772;
BgL_arg3962z00_1772 = 
PROCEDURE_ENTRY(BgL_ez00_46)(BgL_ez00_46, BgL_oz00_47, BgL_ez00_46, BEOA); 
BgL_arg3959z00_1771 = 
MAKE_PAIR(BgL_arg3962z00_1772, BNIL); } 
BgL_arg3955z00_1769 = 
MAKE_PAIR(BgL_newoz00_1764, BgL_arg3959z00_1771); } 
BgL_arg3951z00_1767 = 
MAKE_PAIR(BgL_arg3955z00_1769, BNIL); } 
{ /* Expand/object.scm 733 */
obj_t BgL_arg3967z00_1774;obj_t BgL_arg3968z00_1775;
{ /* Expand/object.scm 733 */
obj_t BgL_arg3971z00_1776;obj_t BgL_arg3972z00_1777;
{ /* Expand/object.scm 733 */
obj_t BgL_arg3975z00_1778;obj_t BgL_arg3976z00_1779;
BgL_arg3975z00_1778 = 
CNST_TABLE_REF(((long)27)); 
{ /* Expand/object.scm 733 */
obj_t BgL_arg3979z00_1780;obj_t BgL_arg3980z00_1781;
BgL_arg3979z00_1780 = 
CNST_TABLE_REF(((long)28)); 
{ /* Expand/object.scm 733 */
obj_t BgL_auxz00_4523;
BgL_auxz00_4523 = 
CNST_TABLE_REF(((long)29)); 
BgL_arg3980z00_1781 = 
MAKE_PAIR(BgL_auxz00_4523, BNIL); } 
BgL_arg3976z00_1779 = 
MAKE_PAIR(BgL_arg3979z00_1780, BgL_arg3980z00_1781); } 
BgL_arg3971z00_1776 = 
MAKE_PAIR(BgL_arg3975z00_1778, BgL_arg3976z00_1779); } 
{ /* Expand/object.scm 735 */
obj_t BgL_arg3984z00_1782;
{ /* Expand/object.scm 735 */
obj_t BgL_arg3987z00_1783;
{ /* Expand/object.scm 735 */
obj_t BgL_arg3991z00_1785;obj_t BgL_arg3992z00_1786;
{ /* Expand/object.scm 735 */
obj_t BgL_arg3995z00_1787;obj_t BgL_arg3996z00_1788;
BgL_arg3995z00_1787 = 
CNST_TABLE_REF(((long)27)); 
{ /* Expand/object.scm 735 */
obj_t BgL_arg3999z00_1789;obj_t BgL_arg4000z00_1790;
BgL_arg3999z00_1789 = 
CNST_TABLE_REF(((long)30)); 
{ /* Expand/object.scm 735 */
obj_t BgL_auxz00_4530;
BgL_auxz00_4530 = 
CNST_TABLE_REF(((long)29)); 
BgL_arg4000z00_1790 = 
MAKE_PAIR(BgL_auxz00_4530, BNIL); } 
BgL_arg3996z00_1788 = 
MAKE_PAIR(BgL_arg3999z00_1789, BgL_arg4000z00_1790); } 
BgL_arg3991z00_1785 = 
MAKE_PAIR(BgL_arg3995z00_1787, BgL_arg3996z00_1788); } 
{ /* Expand/object.scm 736 */
obj_t BgL_arg4004z00_1791;
{ /* Expand/object.scm 736 */
obj_t BgL_arg4008z00_1793;obj_t BgL_arg4009z00_1794;
{ /* Expand/object.scm 736 */
obj_t BgL_arg4012z00_1795;obj_t BgL_arg4013z00_1796;
BgL_arg4012z00_1795 = 
CNST_TABLE_REF(((long)27)); 
{ /* Expand/object.scm 736 */
obj_t BgL_arg4016z00_1797;obj_t BgL_arg4017z00_1798;
BgL_arg4016z00_1797 = 
CNST_TABLE_REF(((long)36)); 
{ /* Expand/object.scm 736 */
obj_t BgL_auxz00_4537;
BgL_auxz00_4537 = 
CNST_TABLE_REF(((long)29)); 
BgL_arg4017z00_1798 = 
MAKE_PAIR(BgL_auxz00_4537, BNIL); } 
BgL_arg4013z00_1796 = 
MAKE_PAIR(BgL_arg4016z00_1797, BgL_arg4017z00_1798); } 
BgL_arg4008z00_1793 = 
MAKE_PAIR(BgL_arg4012z00_1795, BgL_arg4013z00_1796); } 
{ /* Expand/object.scm 737 */
obj_t BgL_arg4021z00_1799;
{ /* Expand/object.scm 737 */
obj_t BgL_arg4025z00_1801;obj_t BgL_arg4026z00_1802;
{ /* Expand/object.scm 737 */
obj_t BgL_arg4029z00_1803;obj_t BgL_arg4030z00_1804;
BgL_arg4029z00_1803 = 
CNST_TABLE_REF(((long)27)); 
{ /* Expand/object.scm 737 */
obj_t BgL_arg4033z00_1805;obj_t BgL_arg4034z00_1806;
BgL_arg4033z00_1805 = 
CNST_TABLE_REF(((long)37)); 
{ /* Expand/object.scm 737 */
obj_t BgL_auxz00_4544;
BgL_auxz00_4544 = 
CNST_TABLE_REF(((long)29)); 
BgL_arg4034z00_1806 = 
MAKE_PAIR(BgL_auxz00_4544, BNIL); } 
BgL_arg4030z00_1804 = 
MAKE_PAIR(BgL_arg4033z00_1805, BgL_arg4034z00_1806); } 
BgL_arg4025z00_1801 = 
MAKE_PAIR(BgL_arg4029z00_1803, BgL_arg4030z00_1804); } 
BgL_arg4026z00_1802 = 
MAKE_PAIR(BgL_newoz00_1764, BNIL); 
BgL_arg4021z00_1799 = 
MAKE_PAIR(BgL_arg4025z00_1801, BgL_arg4026z00_1802); } 
BgL_arg4009z00_1794 = 
MAKE_PAIR(BgL_arg4021z00_1799, BNIL); } 
BgL_arg4004z00_1791 = 
MAKE_PAIR(BgL_arg4008z00_1793, BgL_arg4009z00_1794); } 
BgL_arg3992z00_1786 = 
MAKE_PAIR(BgL_arg4004z00_1791, BNIL); } 
BgL_arg3987z00_1783 = 
MAKE_PAIR(BgL_arg3991z00_1785, BgL_arg3992z00_1786); } 
BgL_arg3984z00_1782 = 
MAKE_PAIR(BgL_arg3987z00_1783, BNIL); } 
BgL_arg3972z00_1777 = 
MAKE_PAIR(BgL_newoz00_1764, BgL_arg3984z00_1782); } 
BgL_arg3967z00_1774 = 
MAKE_PAIR(BgL_arg3971z00_1776, BgL_arg3972z00_1777); } 
{ /* Expand/object.scm 738 */
obj_t BgL_arg4039z00_1807;obj_t BgL_arg4040z00_1808;
{ /* Expand/object.scm 738 */
obj_t BgL_arg4043z00_1809;obj_t BgL_arg4044z00_1810;
BgL_arg4043z00_1809 = 
CNST_TABLE_REF(((long)26)); 
{ /* Expand/object.scm 738 */
obj_t BgL_arg4047z00_1811;
BgL_arg4047z00_1811 = 
MAKE_PAIR(BFALSE, BNIL); 
BgL_arg4044z00_1810 = 
MAKE_PAIR(BgL_newoz00_1764, BgL_arg4047z00_1811); } 
BgL_arg4039z00_1807 = 
MAKE_PAIR(BgL_arg4043z00_1809, BgL_arg4044z00_1810); } 
BgL_arg4040z00_1808 = 
MAKE_PAIR(BgL_newoz00_1764, BNIL); 
BgL_arg3968z00_1775 = 
MAKE_PAIR(BgL_arg4039z00_1807, BgL_arg4040z00_1808); } 
BgL_arg3952z00_1768 = 
MAKE_PAIR(BgL_arg3967z00_1774, BgL_arg3968z00_1775); } 
BgL_arg3948z00_1766 = 
MAKE_PAIR(BgL_arg3951z00_1767, BgL_arg3952z00_1768); } 
return 
MAKE_PAIR(BgL_arg3947z00_1765, BgL_arg3948z00_1766);}  else 
{ /* Expand/object.scm 752 */
obj_t BgL_arg4052z00_1812;obj_t BgL_arg4053z00_1813;
BgL_arg4052z00_1812 = 
CNST_TABLE_REF(((long)2)); 
{ /* Expand/object.scm 740 */
obj_t BgL_arg4056z00_1814;obj_t BgL_arg4057z00_1815;
{ /* Expand/object.scm 740 */
obj_t BgL_arg4060z00_1816;
{ /* Expand/object.scm 740 */
obj_t BgL_arg4064z00_1818;
{ /* Expand/object.scm 740 */
obj_t BgL_arg4067z00_1819;
BgL_arg4067z00_1819 = 
PROCEDURE_ENTRY(BgL_ez00_46)(BgL_ez00_46, BgL_oz00_47, BgL_ez00_46, BEOA); 
BgL_arg4064z00_1818 = 
MAKE_PAIR(BgL_arg4067z00_1819, BNIL); } 
BgL_arg4060z00_1816 = 
MAKE_PAIR(BgL_newoz00_1764, BgL_arg4064z00_1818); } 
BgL_arg4056z00_1814 = 
MAKE_PAIR(BgL_arg4060z00_1816, BNIL); } 
{ /* Expand/object.scm 741 */
obj_t BgL_arg4073z00_1821;
{ /* Expand/object.scm 741 */
obj_t BgL_arg4077z00_1823;obj_t BgL_arg4078z00_1824;
BgL_arg4077z00_1823 = 
CNST_TABLE_REF(((long)32)); 
{ /* Expand/object.scm 741 */
obj_t BgL_arg4081z00_1825;obj_t BgL_arg4082z00_1826;
{ /* Expand/object.scm 741 */
obj_t BgL_arg4085z00_1827;obj_t BgL_arg4086z00_1828;
BgL_arg4085z00_1827 = 
CNST_TABLE_REF(((long)40)); 
BgL_arg4086z00_1828 = 
MAKE_PAIR(BgL_newoz00_1764, BNIL); 
BgL_arg4081z00_1825 = 
MAKE_PAIR(BgL_arg4085z00_1827, BgL_arg4086z00_1828); } 
{ /* Expand/object.scm 742 */
obj_t BgL_arg4090z00_1829;obj_t BgL_arg4091z00_1830;
{ /* Expand/object.scm 742 */
obj_t BgL_arg4094z00_1831;obj_t BgL_arg4095z00_1832;
BgL_arg4094z00_1831 = 
CNST_TABLE_REF(((long)32)); 
{ /* Expand/object.scm 742 */
obj_t BgL_arg4098z00_1833;obj_t BgL_arg4099z00_1834;
{ /* Expand/object.scm 742 */
obj_t BgL_arg4102z00_1835;obj_t BgL_arg4103z00_1836;
BgL_arg4102z00_1835 = 
CNST_TABLE_REF(((long)33)); 
BgL_arg4103z00_1836 = 
MAKE_PAIR(BgL_newoz00_1764, BNIL); 
BgL_arg4098z00_1833 = 
MAKE_PAIR(BgL_arg4102z00_1835, BgL_arg4103z00_1836); } 
{ /* Expand/object.scm 743 */
obj_t BgL_arg4107z00_1837;obj_t BgL_arg4108z00_1838;
{ /* Expand/object.scm 743 */
obj_t BgL_arg4111z00_1839;obj_t BgL_arg4112z00_1840;
BgL_arg4111z00_1839 = 
CNST_TABLE_REF(((long)18)); 
{ /* Expand/object.scm 744 */
obj_t BgL_arg4115z00_1841;obj_t BgL_arg4116z00_1842;
{ /* Expand/object.scm 744 */
obj_t BgL_arg4119z00_1843;obj_t BgL_arg4120z00_1844;
{ /* Expand/object.scm 744 */
obj_t BgL_arg4123z00_1845;obj_t BgL_arg4124z00_1846;
BgL_arg4123z00_1845 = 
CNST_TABLE_REF(((long)27)); 
{ /* Expand/object.scm 744 */
obj_t BgL_arg4127z00_1847;obj_t BgL_arg4128z00_1848;
BgL_arg4127z00_1847 = 
CNST_TABLE_REF(((long)28)); 
{ /* Expand/object.scm 744 */
obj_t BgL_auxz00_4584;
BgL_auxz00_4584 = 
CNST_TABLE_REF(((long)29)); 
BgL_arg4128z00_1848 = 
MAKE_PAIR(BgL_auxz00_4584, BNIL); } 
BgL_arg4124z00_1846 = 
MAKE_PAIR(BgL_arg4127z00_1847, BgL_arg4128z00_1848); } 
BgL_arg4119z00_1843 = 
MAKE_PAIR(BgL_arg4123z00_1845, BgL_arg4124z00_1846); } 
{ /* Expand/object.scm 746 */
obj_t BgL_arg4132z00_1849;
{ /* Expand/object.scm 746 */
obj_t BgL_arg4135z00_1850;
{ /* Expand/object.scm 746 */
obj_t BgL_arg4139z00_1852;obj_t BgL_arg4140z00_1853;
{ /* Expand/object.scm 746 */
obj_t BgL_arg4143z00_1854;obj_t BgL_arg4144z00_1855;
BgL_arg4143z00_1854 = 
CNST_TABLE_REF(((long)27)); 
{ /* Expand/object.scm 746 */
obj_t BgL_arg4147z00_1856;obj_t BgL_arg4148z00_1857;
BgL_arg4147z00_1856 = 
CNST_TABLE_REF(((long)30)); 
{ /* Expand/object.scm 746 */
obj_t BgL_auxz00_4591;
BgL_auxz00_4591 = 
CNST_TABLE_REF(((long)29)); 
BgL_arg4148z00_1857 = 
MAKE_PAIR(BgL_auxz00_4591, BNIL); } 
BgL_arg4144z00_1855 = 
MAKE_PAIR(BgL_arg4147z00_1856, BgL_arg4148z00_1857); } 
BgL_arg4139z00_1852 = 
MAKE_PAIR(BgL_arg4143z00_1854, BgL_arg4144z00_1855); } 
{ /* Expand/object.scm 747 */
obj_t BgL_arg4152z00_1858;
{ /* Expand/object.scm 747 */
obj_t BgL_arg4156z00_1860;obj_t BgL_arg4157z00_1861;
{ /* Expand/object.scm 747 */
obj_t BgL_arg4160z00_1862;obj_t BgL_arg4161z00_1863;
BgL_arg4160z00_1862 = 
CNST_TABLE_REF(((long)27)); 
{ /* Expand/object.scm 747 */
obj_t BgL_arg4164z00_1864;obj_t BgL_arg4165z00_1865;
BgL_arg4164z00_1864 = 
CNST_TABLE_REF(((long)36)); 
{ /* Expand/object.scm 747 */
obj_t BgL_auxz00_4598;
BgL_auxz00_4598 = 
CNST_TABLE_REF(((long)29)); 
BgL_arg4165z00_1865 = 
MAKE_PAIR(BgL_auxz00_4598, BNIL); } 
BgL_arg4161z00_1863 = 
MAKE_PAIR(BgL_arg4164z00_1864, BgL_arg4165z00_1865); } 
BgL_arg4156z00_1860 = 
MAKE_PAIR(BgL_arg4160z00_1862, BgL_arg4161z00_1863); } 
{ /* Expand/object.scm 748 */
obj_t BgL_arg4170z00_1866;
{ /* Expand/object.scm 748 */
obj_t BgL_arg4174z00_1868;obj_t BgL_arg4175z00_1869;
{ /* Expand/object.scm 748 */
obj_t BgL_arg4178z00_1870;obj_t BgL_arg4179z00_1871;
BgL_arg4178z00_1870 = 
CNST_TABLE_REF(((long)27)); 
{ /* Expand/object.scm 748 */
obj_t BgL_arg4182z00_1872;obj_t BgL_arg4183z00_1873;
BgL_arg4182z00_1872 = 
CNST_TABLE_REF(((long)37)); 
{ /* Expand/object.scm 748 */
obj_t BgL_auxz00_4605;
BgL_auxz00_4605 = 
CNST_TABLE_REF(((long)29)); 
BgL_arg4183z00_1873 = 
MAKE_PAIR(BgL_auxz00_4605, BNIL); } 
BgL_arg4179z00_1871 = 
MAKE_PAIR(BgL_arg4182z00_1872, BgL_arg4183z00_1873); } 
BgL_arg4174z00_1868 = 
MAKE_PAIR(BgL_arg4178z00_1870, BgL_arg4179z00_1871); } 
BgL_arg4175z00_1869 = 
MAKE_PAIR(BgL_newoz00_1764, BNIL); 
BgL_arg4170z00_1866 = 
MAKE_PAIR(BgL_arg4174z00_1868, BgL_arg4175z00_1869); } 
BgL_arg4157z00_1861 = 
MAKE_PAIR(BgL_arg4170z00_1866, BNIL); } 
BgL_arg4152z00_1858 = 
MAKE_PAIR(BgL_arg4156z00_1860, BgL_arg4157z00_1861); } 
BgL_arg4140z00_1853 = 
MAKE_PAIR(BgL_arg4152z00_1858, BNIL); } 
BgL_arg4135z00_1850 = 
MAKE_PAIR(BgL_arg4139z00_1852, BgL_arg4140z00_1853); } 
BgL_arg4132z00_1849 = 
MAKE_PAIR(BgL_arg4135z00_1850, BNIL); } 
BgL_arg4120z00_1844 = 
MAKE_PAIR(BgL_newoz00_1764, BgL_arg4132z00_1849); } 
BgL_arg4115z00_1841 = 
MAKE_PAIR(BgL_arg4119z00_1843, BgL_arg4120z00_1844); } 
{ /* Expand/object.scm 749 */
obj_t BgL_arg4188z00_1874;obj_t BgL_arg4189z00_1875;
{ /* Expand/object.scm 749 */
obj_t BgL_arg4192z00_1876;obj_t BgL_arg4193z00_1877;
BgL_arg4192z00_1876 = 
CNST_TABLE_REF(((long)26)); 
{ /* Expand/object.scm 749 */
obj_t BgL_arg4196z00_1878;
BgL_arg4196z00_1878 = 
MAKE_PAIR(BFALSE, BNIL); 
BgL_arg4193z00_1877 = 
MAKE_PAIR(BgL_newoz00_1764, BgL_arg4196z00_1878); } 
BgL_arg4188z00_1874 = 
MAKE_PAIR(BgL_arg4192z00_1876, BgL_arg4193z00_1877); } 
BgL_arg4189z00_1875 = 
MAKE_PAIR(BgL_newoz00_1764, BNIL); 
BgL_arg4116z00_1842 = 
MAKE_PAIR(BgL_arg4188z00_1874, BgL_arg4189z00_1875); } 
BgL_arg4112z00_1840 = 
MAKE_PAIR(BgL_arg4115z00_1841, BgL_arg4116z00_1842); } 
BgL_arg4107z00_1837 = 
MAKE_PAIR(BgL_arg4111z00_1839, BgL_arg4112z00_1840); } 
{ /* Expand/object.scm 751 */
obj_t BgL_arg4201z00_1879;
{ /* Expand/object.scm 751 */
obj_t BgL_arg4205z00_1881;obj_t BgL_arg4206z00_1882;
BgL_arg4205z00_1881 = 
CNST_TABLE_REF(((long)38)); 
{ /* Expand/object.scm 751 */
obj_t BgL_arg4210z00_1884;
{ /* Expand/object.scm 751 */
obj_t BgL_arg4214z00_1886;
BgL_arg4214z00_1886 = 
MAKE_PAIR(BgL_newoz00_1764, BNIL); 
BgL_arg4210z00_1884 = 
MAKE_PAIR(BGl_string4866z00zzexpand_objectz00, BgL_arg4214z00_1886); } 
BgL_arg4206z00_1882 = 
MAKE_PAIR(BGl_string4867z00zzexpand_objectz00, BgL_arg4210z00_1884); } 
BgL_arg4201z00_1879 = 
MAKE_PAIR(BgL_arg4205z00_1881, BgL_arg4206z00_1882); } 
BgL_arg4108z00_1838 = 
MAKE_PAIR(BgL_arg4201z00_1879, BNIL); } 
BgL_arg4099z00_1834 = 
MAKE_PAIR(BgL_arg4107z00_1837, BgL_arg4108z00_1838); } 
BgL_arg4095z00_1832 = 
MAKE_PAIR(BgL_arg4098z00_1833, BgL_arg4099z00_1834); } 
BgL_arg4090z00_1829 = 
MAKE_PAIR(BgL_arg4094z00_1831, BgL_arg4095z00_1832); } 
{ /* Expand/object.scm 752 */
obj_t BgL_arg4218z00_1887;
{ /* Expand/object.scm 752 */
obj_t BgL_arg4222z00_1889;obj_t BgL_arg4223z00_1890;
BgL_arg4222z00_1889 = 
CNST_TABLE_REF(((long)38)); 
{ /* Expand/object.scm 752 */
obj_t BgL_arg4227z00_1892;
{ /* Expand/object.scm 752 */
obj_t BgL_arg4231z00_1894;
BgL_arg4231z00_1894 = 
MAKE_PAIR(BgL_newoz00_1764, BNIL); 
BgL_arg4227z00_1892 = 
MAKE_PAIR(BGl_string4866z00zzexpand_objectz00, BgL_arg4231z00_1894); } 
BgL_arg4223z00_1890 = 
MAKE_PAIR(BGl_string4867z00zzexpand_objectz00, BgL_arg4227z00_1892); } 
BgL_arg4218z00_1887 = 
MAKE_PAIR(BgL_arg4222z00_1889, BgL_arg4223z00_1890); } 
BgL_arg4091z00_1830 = 
MAKE_PAIR(BgL_arg4218z00_1887, BNIL); } 
BgL_arg4082z00_1826 = 
MAKE_PAIR(BgL_arg4090z00_1829, BgL_arg4091z00_1830); } 
BgL_arg4078z00_1824 = 
MAKE_PAIR(BgL_arg4081z00_1825, BgL_arg4082z00_1826); } 
BgL_arg4073z00_1821 = 
MAKE_PAIR(BgL_arg4077z00_1823, BgL_arg4078z00_1824); } 
BgL_arg4057z00_1815 = 
MAKE_PAIR(BgL_arg4073z00_1821, BNIL); } 
BgL_arg4053z00_1813 = 
MAKE_PAIR(BgL_arg4056z00_1814, BgL_arg4057z00_1815); } 
return 
MAKE_PAIR(BgL_arg4052z00_1812, BgL_arg4053z00_1813);} } } 
}



/* make-virtual-set */
obj_t BGl_makezd2virtualzd2setz00zzexpand_objectz00(obj_t BgL_slotz00_48, obj_t BgL_valuez00_49, obj_t BgL_varz00_50, obj_t BgL_classz00_51, obj_t BgL_formz00_52, char * BgL_alloczd2kindzd2_53)
{ AN_OBJECT;
{ /* Expand/object.scm 757 */
{ /* Expand/object.scm 758 */
bool_t BgL_testz00_4648;
{ /* Expand/object.scm 758 */
BgL_slotz00_bglt BgL_obj1752z00_2620;
BgL_obj1752z00_2620 = 
(BgL_slotz00_bglt)(BgL_slotz00_48); 
BgL_testz00_4648 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1752z00_2620))->BgL_readzd2onlyzf3z21); } 
if(BgL_testz00_4648)
{ /* Expand/object.scm 760 */
obj_t BgL_arg4240z00_1897;
{ /* Expand/object.scm 760 */
obj_t BgL_arg4245z00_1900;
{ /* Expand/object.scm 761 */
obj_t BgL_auxz00_4651;
{ /* Expand/object.scm 761 */
BgL_slotz00_bglt BgL_obj1747z00_2621;
BgL_obj1747z00_2621 = 
(BgL_slotz00_bglt)(BgL_slotz00_48); 
BgL_auxz00_4651 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1747z00_2621))->BgL_idz00); } 
BgL_arg4245z00_1900 = 
SYMBOL_TO_STRING(BgL_auxz00_4651); } 
{ /* Expand/object.scm 760 */
obj_t BgL_list4248z00_1902;
{ /* Expand/object.scm 760 */
obj_t BgL_arg4250z00_1903;
{ /* Expand/object.scm 760 */
obj_t BgL_arg4253z00_1904;
{ /* Expand/object.scm 760 */
obj_t BgL_arg4256z00_1905;
{ /* Expand/object.scm 760 */
obj_t BgL_arg4259z00_1906;
BgL_arg4259z00_1906 = 
MAKE_PAIR(BGl_string4851z00zzexpand_objectz00, BNIL); 
BgL_arg4256z00_1905 = 
MAKE_PAIR(BgL_arg4245z00_1900, BgL_arg4259z00_1906); } 
BgL_arg4253z00_1904 = 
MAKE_PAIR(BGl_string4868z00zzexpand_objectz00, BgL_arg4256z00_1905); } 
{ /* Expand/object.scm 760 */
obj_t BgL_auxz00_4658;
BgL_auxz00_4658 = 
string_to_bstring(BgL_alloczd2kindzd2_53); 
BgL_arg4250z00_1903 = 
MAKE_PAIR(BgL_auxz00_4658, BgL_arg4253z00_1904); } } 
BgL_list4248z00_1902 = 
MAKE_PAIR(BGl_string4869z00zzexpand_objectz00, BgL_arg4250z00_1903); } 
BgL_arg4240z00_1897 = 
BGl_stringzd2appendzd2zz__r4_strings_6_7z00(BgL_list4248z00_1902); } } 
FAILURE(BFALSE,BgL_arg4240z00_1897,BgL_formz00_52);}  else 
{ /* Expand/object.scm 765 */
obj_t BgL_arg4267z00_1908;
{ /* Expand/object.scm 765 */
obj_t BgL_arg4270z00_1909;obj_t BgL_arg4271z00_1910;
{ /* Expand/object.scm 765 */
obj_t BgL_arg4274z00_1911;obj_t BgL_arg4275z00_1912;obj_t BgL_arg4276z00_1913;
{ /* Expand/object.scm 765 */
BgL_typez00_bglt BgL_obj1626z00_2626;
BgL_obj1626z00_2626 = 
(BgL_typez00_bglt)(BgL_classz00_51); 
BgL_arg4274z00_1911 = 
(((BgL_typez00_bglt)CREF(BgL_obj1626z00_2626))->BgL_idz00); } 
BgL_arg4275z00_1912 = 
CNST_TABLE_REF(((long)4)); 
{ /* Expand/object.scm 765 */
BgL_slotz00_bglt BgL_obj1747z00_2627;
BgL_obj1747z00_2627 = 
(BgL_slotz00_bglt)(BgL_slotz00_48); 
BgL_arg4276z00_1913 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1747z00_2627))->BgL_idz00); } 
{ /* Expand/object.scm 765 */
obj_t BgL_list4279z00_1915;
{ /* Expand/object.scm 765 */
obj_t BgL_arg4281z00_1916;
{ /* Expand/object.scm 765 */
obj_t BgL_arg4284z00_1917;
{ /* Expand/object.scm 765 */
obj_t BgL_arg4287z00_1918;
{ /* Expand/object.scm 765 */
obj_t BgL_auxz00_4669;
BgL_auxz00_4669 = 
CNST_TABLE_REF(((long)8)); 
BgL_arg4287z00_1918 = 
MAKE_PAIR(BgL_auxz00_4669, BNIL); } 
BgL_arg4284z00_1917 = 
MAKE_PAIR(BgL_arg4276z00_1913, BgL_arg4287z00_1918); } 
BgL_arg4281z00_1916 = 
MAKE_PAIR(BgL_arg4275z00_1912, BgL_arg4284z00_1917); } 
BgL_list4279z00_1915 = 
MAKE_PAIR(BgL_arg4274z00_1911, BgL_arg4281z00_1916); } 
BgL_arg4270z00_1909 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list4279z00_1915); } } 
{ /* Expand/object.scm 765 */
obj_t BgL_arg4293z00_1919;
BgL_arg4293z00_1919 = 
MAKE_PAIR(BgL_valuez00_49, BNIL); 
BgL_arg4271z00_1910 = 
MAKE_PAIR(BgL_varz00_50, BgL_arg4293z00_1919); } 
BgL_arg4267z00_1908 = 
MAKE_PAIR(BgL_arg4270z00_1909, BgL_arg4271z00_1910); } 
return 
BGl_objectzd2epairifyzd2zzexpand_objectz00(BgL_arg4267z00_1908, BgL_valuez00_49);} } } 
}



/* object-epairify */
obj_t BGl_objectzd2epairifyzd2zzexpand_objectz00(obj_t BgL_objz00_54, obj_t BgL_epairz00_55)
{ AN_OBJECT;
{ /* Expand/object.scm 773 */
BGl_objectzd2epairifyzd2zzexpand_objectz00:
{ /* Expand/object.scm 774 */
bool_t BgL_test4297z00_1920;
BgL_test4297z00_1920 = 
EXTENDED_PAIRP(BgL_epairz00_55); 
if(BgL_test4297z00_1920)
{ /* Expand/object.scm 774 */
if(
PAIRP(BgL_objz00_54))
{ /* Expand/object.scm 776 */
obj_t BgL_res4548z00_2636;
{ /* Expand/object.scm 776 */
obj_t BgL_auxz00_4688;obj_t BgL_auxz00_4686;obj_t BgL_auxz00_4684;
BgL_auxz00_4688 = 
CER(BgL_epairz00_55); 
BgL_auxz00_4686 = 
CDR(BgL_objz00_54); 
BgL_auxz00_4684 = 
CAR(BgL_objz00_54); 
BgL_res4548z00_2636 = 
MAKE_EXTENDED_PAIR(BgL_auxz00_4684, BgL_auxz00_4686, BgL_auxz00_4688); } 
return BgL_res4548z00_2636;}  else 
{ /* Expand/object.scm 777 */
obj_t BgL_arg4308z00_1925;
{ /* Expand/object.scm 777 */
obj_t BgL_arg4311z00_1926;obj_t BgL_arg4312z00_1927;
BgL_arg4311z00_1926 = 
CNST_TABLE_REF(((long)18)); 
BgL_arg4312z00_1927 = 
MAKE_PAIR(BgL_objz00_54, BNIL); 
BgL_arg4308z00_1925 = 
MAKE_PAIR(BgL_arg4311z00_1926, BgL_arg4312z00_1927); } 
{ 
obj_t BgL_objz00_4694;
BgL_objz00_4694 = BgL_arg4308z00_1925; 
BgL_objz00_54 = BgL_objz00_4694; 
goto BGl_objectzd2epairifyzd2zzexpand_objectz00;} } }  else 
{ /* Expand/object.scm 774 */
return BgL_objz00_54;} } } 
}



/* find-slot-offset */
obj_t BGl_findzd2slotzd2offsetz00zzexpand_objectz00(obj_t BgL_slotsz00_56, obj_t BgL_namez00_57, obj_t BgL_formz00_58, obj_t BgL_sexpz00_59)
{ AN_OBJECT;
{ /* Expand/object.scm 783 */
{ 
obj_t BgL_slotsz00_1928;long BgL_iz00_1929;
BgL_slotsz00_1928 = BgL_slotsz00_56; 
BgL_iz00_1929 = ((long)0); 
BgL_loopz00_1930:
if(
NULLP(BgL_slotsz00_1928))
{ /* Expand/object.scm 787 */
{ /* Expand/object.scm 789 */
obj_t BgL_arg4320z00_1932;
{ /* Expand/object.scm 789 */
obj_t BgL_arg4325z00_1935;
BgL_arg4325z00_1935 = 
SYMBOL_TO_STRING(BgL_namez00_57); 
{ /* Expand/object.scm 789 */
obj_t BgL_list4328z00_1937;
{ /* Expand/object.scm 789 */
obj_t BgL_arg4330z00_1938;
{ /* Expand/object.scm 789 */
obj_t BgL_arg4333z00_1939;
{ /* Expand/object.scm 789 */
obj_t BgL_arg4336z00_1940;
{ /* Expand/object.scm 789 */
obj_t BgL_arg4339z00_1941;
BgL_arg4339z00_1941 = 
MAKE_PAIR(BGl_string4851z00zzexpand_objectz00, BNIL); 
BgL_arg4336z00_1940 = 
MAKE_PAIR(BgL_arg4325z00_1935, BgL_arg4339z00_1941); } 
BgL_arg4333z00_1939 = 
MAKE_PAIR(BGl_string4870z00zzexpand_objectz00, BgL_arg4336z00_1940); } 
BgL_arg4330z00_1938 = 
MAKE_PAIR(BgL_formz00_58, BgL_arg4333z00_1939); } 
BgL_list4328z00_1937 = 
MAKE_PAIR(BGl_string4869z00zzexpand_objectz00, BgL_arg4330z00_1938); } 
BgL_arg4320z00_1932 = 
BGl_stringzd2appendzd2zz__r4_strings_6_7z00(BgL_list4328z00_1937); } } 
FAILURE(BFALSE,BgL_arg4320z00_1932,BgL_sexpz00_59);} }  else 
{ /* Expand/object.scm 793 */
bool_t BgL_testz00_4705;
{ /* Expand/object.scm 793 */
obj_t BgL_auxz00_4706;
{ /* Expand/object.scm 793 */
BgL_slotz00_bglt BgL_obj1747z00_2643;
{ /* Expand/object.scm 793 */
obj_t BgL_auxz00_4707;
BgL_auxz00_4707 = 
CAR(BgL_slotsz00_1928); 
BgL_obj1747z00_2643 = 
(BgL_slotz00_bglt)(BgL_auxz00_4707); } 
BgL_auxz00_4706 = 
(((BgL_slotz00_bglt)CREF(BgL_obj1747z00_2643))->BgL_idz00); } 
BgL_testz00_4705 = 
(BgL_auxz00_4706==BgL_namez00_57); } 
if(BgL_testz00_4705)
{ /* Expand/object.scm 793 */
return 
BINT(BgL_iz00_1929);}  else 
{ /* Expand/object.scm 793 */
{ 
long BgL_iz00_4715;obj_t BgL_slotsz00_4713;
BgL_slotsz00_4713 = 
CDR(BgL_slotsz00_1928); 
BgL_iz00_4715 = 
(BgL_iz00_1929+((long)1)); 
BgL_iz00_1929 = BgL_iz00_4715; 
BgL_slotsz00_1928 = BgL_slotsz00_4713; 
goto BgL_loopz00_1930;} } } } } 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzexpand_objectz00()
{ AN_OBJECT;
{ /* Expand/object.scm 15 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzexpand_objectz00()
{ AN_OBJECT;
{ /* Expand/object.scm 15 */
BGl_modulezd2initializa7ationz75zztools_argsz00(((long)54833), "expand_object"); 
BGl_modulezd2initializa7ationz75zztools_prognz00(((long)55621), "expand_object"); 
BGl_modulezd2initializa7ationz75zztools_miscz00(((long)63966), "expand_object"); 
BGl_modulezd2initializa7ationz75zztools_locationz00(((long)30714), "expand_object"); 
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19010), "expand_object"); 
BGl_modulezd2initializa7ationz75zztype_envz00(((long)25262), "expand_object"); 
BGl_modulezd2initializa7ationz75zzexpand_epsz00(((long)13864), "expand_object"); 
BGl_modulezd2initializa7ationz75zzengine_paramz00(((long)189840), "expand_object"); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)28259), "expand_object"); 
BGl_modulezd2initializa7ationz75zzast_identz00(((long)52188), "expand_object"); 
BGl_modulezd2initializa7ationz75zzast_privatez00(((long)10040), "expand_object"); 
BGl_modulezd2initializa7ationz75zzobject_classz00(((long)19348), "expand_object"); 
return 
BGl_modulezd2initializa7ationz75zzobject_slotsz00(((long)83931), "expand_object");} 
}

