/*===========================================================================*/
/*   (Inline/recursion.scm)                                                  */
/*   Bigloo (2.5b)                                                           */
/*   Manuel Serrano (c)       Fri Sep 6 09:43:28 CEST 2002                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_nodez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
} *BgL_nodez00_bglt;

typedef struct BgL_nodezf2effectzf2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
} *BgL_nodezf2effectzf2_bglt;

typedef struct BgL_atomz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_atomz00_bglt;

typedef struct BgL_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_varz00_bglt;

typedef struct BgL_closurez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_closurez00_bglt;

typedef struct BgL_kwotez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_kwotez00_bglt;

typedef struct BgL_sequencez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_nodesz00;
} *BgL_sequencez00_bglt;

typedef struct BgL_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
} *BgL_appz00_bglt;

typedef struct BgL_appzd2lyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_appzd2lyzd2_bglt;

typedef struct BgL_funcallz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_strengthz00;
} *BgL_funcallz00_bglt;

typedef struct BgL_externz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_externz00_bglt;

typedef struct BgL_pragmaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_formatz00;
} *BgL_pragmaz00_bglt;

typedef struct BgL_getfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_getfieldz00_bglt;

typedef struct BgL_setfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_setfieldz00_bglt;

typedef struct BgL_newz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_newz00_bglt;

typedef struct BgL_vallocz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2heapzd2formatz00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_vallocz00_bglt;

typedef struct BgL_vrefz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vrefz00_bglt;

typedef struct BgL_vsetz12z12_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vsetz12z12_bglt;

typedef struct BgL_vlengthz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vlengthz00_bglt;

typedef struct BgL_isaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   struct BgL_typez00_bgl * BgL_classz00;
} *BgL_isaz00_bglt;

typedef struct BgL_castz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_castz00_bglt;

typedef struct BgL_setqz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_setqz00_bglt;

typedef struct BgL_conditionalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   struct BgL_nodez00_bgl * BgL_truez00;
   struct BgL_nodez00_bgl * BgL_falsez00;
} *BgL_conditionalz00_bglt;

typedef struct BgL_failz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_procz00;
   struct BgL_nodez00_bgl * BgL_msgz00;
   struct BgL_nodez00_bgl * BgL_objz00;
} *BgL_failz00_bglt;

typedef struct BgL_selectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   obj_t BgL_clausesz00;
   struct BgL_typez00_bgl * BgL_itemzd2typezd2;
} *BgL_selectz00_bglt;

typedef struct BgL_letzd2funzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_localsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_letzd2funzd2_bglt;

typedef struct BgL_letzd2varzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_bindingsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
   bool_t BgL_removablezf3zf3;
} *BgL_letzd2varzd2_bglt;

typedef struct BgL_setzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_setzd2exzd2itz00_bglt;

typedef struct BgL_jumpzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_exitz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_jumpzd2exzd2itz00_bglt;

typedef struct BgL_makezd2boxzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_makezd2boxzd2_bglt;

typedef struct BgL_boxzd2refzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_varz00;
} *BgL_boxzd2refzd2_bglt;

typedef struct BgL_boxzd2setz12zc0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_boxzd2setz12zc0_bglt;

typedef struct BgL_isfunz00_bgl {
   struct BgL_nodez00_bgl * BgL_originalzd2bodyzd2;
   obj_t BgL_recursivezd2callszd2;
} *BgL_isfunz00_bglt;

typedef struct BgL_localzf2variantzf2_bgl {
   bool_t BgL_variantz00;
} *BgL_localzf2variantzf2_bglt;


extern BgL_localz00_bglt BGl_clonezd2localzd2zzast_localz00(BgL_localz00_bglt, BgL_valuez00_bglt);
static obj_t BGl_findzd2recursivezd2callszd2boxzd2setz122854z12zzinline_recursionz00(obj_t, obj_t, obj_t);
extern obj_t BGl_za2optimzd2unrollzd2loopzf3za2zf3zzengine_paramz00;
static obj_t BGl_methodzd2initzd2zzinline_recursionz00();
extern obj_t open_input_string(obj_t);
extern long BGl_classzd2numzd2zz__objectz00(obj_t);
extern obj_t BGl_letzd2funzd2zzast_nodez00;
extern obj_t BGl_sfunz00zzast_varz00;
static obj_t BGl_findzd2recursivezd2callsz00zzinline_recursionz00(BgL_nodez00_bglt, BgL_variablez00_bglt);
extern obj_t BGl_readz00zz__readerz00(obj_t);
extern obj_t BGl_za2verboseza2z00zzengine_paramz00;
extern bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
static obj_t BGl_findzd2recursivezd2callszd2setzd2exzd2it2846zd2zzinline_recursionz00(obj_t, obj_t, obj_t);
static obj_t BGl_findzd2recursivezd2callszd2fail2838zd2zzinline_recursionz00(obj_t, obj_t, obj_t);
extern obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
extern obj_t BGl_letzd2varzd2zzast_nodez00;
static obj_t BGl_inlinezd2appzd2labelsz00zzinline_recursionz00(BgL_nodez00_bglt, long, obj_t);
extern obj_t BGl_svarz00zzast_varz00;
static obj_t BGl_findzd2recursivezd2callszd2select2840zd2zzinline_recursionz00(obj_t, obj_t, obj_t);
extern BgL_appz00_bglt BGl_removezd2invariantzd2argsz12z12zzinline_variantz00(BgL_appz00_bglt);
static BgL_letzd2funzd2_bglt BGl_plainzd2callzd2zzinline_recursionz00(BgL_variablez00_bglt, BgL_nodez00_bglt, BgL_localz00_bglt, BgL_appz00_bglt, obj_t);
static obj_t BGl_findzd2recursivezd2callszd2app2824zd2zzinline_recursionz00(obj_t, obj_t, obj_t);
extern obj_t BGl_globalz00zzast_varz00;
extern bool_t BGl_innerzd2loopzf3z21zzinline_loopz00(BgL_variablez00_bglt);
static obj_t BGl_findzd2recursivezd2callsza2za2zzinline_recursionz00(obj_t, obj_t);
extern bool_t BGl_iszd2loopzf3z21zzinline_loopz00(BgL_variablez00_bglt);
extern obj_t BGl_castz00zzast_nodez00;
static obj_t BGl__findzd2recursivezd2calls4065z00zzinline_recursionz00(obj_t, obj_t, obj_t);
extern obj_t BGl_shrinkzd2argsz12zc0zzinline_variantz00(BgL_variablez00_bglt);
extern obj_t BGl_boxzd2refzd2zzast_nodez00;
static obj_t BGl_findzd2recursivezd2callszd2appzd2ly2826z00zzinline_recursionz00(obj_t, obj_t, obj_t);
extern bool_t BGl_iszd2recursivezf3z21zzinline_recursionz00(BgL_variablez00_bglt);
extern obj_t BGl_varz00zzast_nodez00;
static obj_t BGl_cnstzd2initzd2zzinline_recursionz00();
static obj_t BGl_findzd2recursivezd2callszd2funcall2828zd2zzinline_recursionz00(obj_t, obj_t, obj_t);
extern obj_t BGl_failz00zzast_nodez00;
extern obj_t BGl_funcallz00zzast_nodez00;
extern BgL_nodez00_bglt BGl_inlinezd2appzd2recursivez00zzinline_recursionz00(BgL_nodez00_bglt, long, obj_t);
extern BgL_nodez00_bglt BGl_nestzd2loopz12zc0zzinline_loopz00(BgL_nodez00_bglt, BgL_localz00_bglt, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zzinline_recursionz00();
extern obj_t BGl_nodezd2csez12zc0zzreduce_csez00(BgL_nodez00_bglt, obj_t);
extern obj_t BGl_makezd2boxzd2zzast_nodez00;
extern obj_t BGl_invariantzd2argszd2zzinline_variantz00(BgL_variablez00_bglt, obj_t);
extern obj_t BGl_inlinezd2sfunz12zc0zzinline_inlinez00(BgL_variablez00_bglt, long, obj_t);
extern obj_t BGl_currentzd2functionzd2zztools_errorz00();
extern obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
static obj_t BGl_findzd2recursivezd2callszd2makezd2box2850z00zzinline_recursionz00(obj_t, obj_t, obj_t);
static obj_t BGl_findzd2recursivezd2callszd2conditional2836zd2zzinline_recursionz00(obj_t, obj_t, obj_t);
extern obj_t BGl_selectz00zzast_nodez00;
static obj_t BGl_toplevelzd2initzd2zzinline_recursionz00();
extern obj_t BGl_appzd2lyzd2zzast_nodez00;
extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
extern obj_t BGl_modulezd2initializa7ationz75zzinline_recursionz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_localz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_alphatiza7eza7(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzinline_inlinez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzinline_simplez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzinline_variantz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzinline_loopz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzinline_appz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzreduce_csez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
static obj_t BGl_zc3anonymousza33099ze3z83zzinline_recursionz00(obj_t, obj_t);
static obj_t BGl_findzd2recursivezd2callszd2jumpzd2exzd2it2848zd2zzinline_recursionz00(obj_t, obj_t, obj_t);
extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
extern long bgl_list_length(obj_t);
static obj_t BGl_unrollzd2callzd2zzinline_recursionz00(BgL_variablez00_bglt, BgL_nodez00_bglt, BgL_localz00_bglt, obj_t, BgL_appz00_bglt, obj_t);
static obj_t BGl_findzd2recursivezd2callszd2setq2834zd2zzinline_recursionz00(obj_t, obj_t, obj_t);
extern obj_t BGl_variantzd2argszd2zzinline_variantz00(BgL_variablez00_bglt);
extern bool_t BGl_zc3zd3z10zz__r4_numbers_6_5z00(obj_t, obj_t, obj_t);
extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
extern obj_t BGl_shapez00zztools_shapez00(obj_t);
extern BgL_localz00_bglt BGl_makezd2localzd2sfunz00zzast_localz00(obj_t, BgL_typez00_bglt, BgL_sfunz00_bglt);
static obj_t BGl__inlinezd2appzd2recursive4059z00zzinline_recursionz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_findzd2recursivezd2callszd2letzd2var2844z00zzinline_recursionz00(obj_t, obj_t, obj_t);
extern obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
extern obj_t BGl_externz00zzast_nodez00;
extern obj_t BGl_conditionalz00zzast_nodez00;
extern obj_t BGl_sequencez00zzast_nodez00;
static obj_t BGl_findzd2recursivezd2callszd2letzd2fun2842z00zzinline_recursionz00(obj_t, obj_t, obj_t);
static obj_t BGl_findzd2recursivezd2callszd2boxzd2ref2852z00zzinline_recursionz00(obj_t, obj_t, obj_t);
static obj_t BGl_findzd2recursivezd2callszd2extern2830zd2zzinline_recursionz00(obj_t, obj_t, obj_t);
extern BgL_nodez00_bglt BGl_alphatiza7eza7zzast_alphatiza7eza7(obj_t, obj_t, obj_t, BgL_nodez00_bglt);
static obj_t BGl__iszd2recursivezf34063z21zzinline_recursionz00(obj_t, obj_t);
extern BgL_nodez00_bglt BGl_inlinezd2appzd2simplez00zzinline_simplez00(BgL_nodez00_bglt, long, obj_t, obj_t);
extern obj_t BGl_appz00zzast_nodez00;
extern obj_t BGl_localz00zzast_varz00;
extern bool_t BGl_inlinezd2appzf3z21zzinline_appz00(BgL_variablez00_bglt, long, long, obj_t);
static obj_t BGl_findzd2recursivezd2callszd2cast2832zd2zzinline_recursionz00(obj_t, obj_t, obj_t);
extern obj_t BGl_za2inliningzd2reducezd2kfactorza2z00zzengine_paramz00;
extern obj_t BGl_isfunz00zzinline_inlinez00;
extern obj_t bgl_append2(obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zzinline_recursionz00 = BUNSPEC;
static obj_t BGl_findzd2recursivezd2callszd2sequence2822zd2zzinline_recursionz00(obj_t, obj_t, obj_t);
static obj_t BGl_findzd2recursivezd2callszd2default2818zd2zzinline_recursionz00(BgL_nodez00_bglt, BgL_variablez00_bglt);
extern obj_t BGl_appendz00zz__r4_pairs_and_lists_6_3z00(obj_t);
extern obj_t BGl_substitutionsz00zzinline_variantz00(BgL_variablez00_bglt, obj_t, obj_t);
static obj_t BGl__findzd2recursivezd2callszd2default2818zd2zzinline_recursionz00(obj_t, obj_t, obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zzinline_recursionz00();
extern obj_t BGl_setqz00zzast_nodez00;
static obj_t __cnst[ 2 ] ;

DEFINE_STATIC_PROCEDURE( BGl_findzd2recursivezd2callszd2default2818zd2envz00zzinline_recursionz00, BgL_bgl__findza7d2recursiveza7d2callsza7d2default2818za7d2za7za7inline_recursionza7004663za7, BGl__findzd2recursivezd2callszd2default2818zd2zzinline_recursionz00, 0L, 2 );
DEFINE_STATIC_GENERIC( BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_bgl__findza7d2recursiveza7d2calls4065za700za7za7inline_recursionza7004664z00, BGl__findzd2recursivezd2calls4065z00zzinline_recursionz00, 0L, 2 );
DEFINE_STRING( BGl_string4635z00zzinline_recursionz00, BgL_bgl_string4635za700za7za7inline_recursionza7004665z00, "(sifun sgfun) sfun ", 19 );
DEFINE_STRING( BGl_string4617z00zzinline_recursionz00, BgL_bgl_string4617za700za7za7inline_recursionza7004666z00, "unrolling", 9 );
DEFINE_STRING( BGl_string4616z00zzinline_recursionz00, BgL_bgl_string4616za700za7za7inline_recursionza7004667z00, "         ", 9 );
DEFINE_STRING( BGl_string4615z00zzinline_recursionz00, BgL_bgl_string4615za700za7za7inline_recursionza7004668z00, " --> ", 5 );
DEFINE_STRING( BGl_string4614z00zzinline_recursionz00, BgL_bgl_string4614za700za7za7inline_recursionza7004669z00, " (recursive)", 12 );
DEFINE_STRING( BGl_string4613z00zzinline_recursionz00, BgL_bgl_string4613za700za7za7inline_recursionza7004670z00, "simple", 6 );
DEFINE_STATIC_PROCEDURE( BGl_proc4618z00zzinline_recursionz00, BgL_bgl_findza7d2recursiveza7d2callsza7d2sequence2822za7d2za7za7inline_recursionza7004671za7, BGl_findzd2recursivezd2callszd2sequence2822zd2zzinline_recursionz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc4620z00zzinline_recursionz00, BgL_bgl_findza7d2recursiveza7d2callsza7d2appza7d2ly2826za700za7za7inline_recursionza7004672z00, BGl_findzd2recursivezd2callszd2appzd2ly2826z00zzinline_recursionz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc4619z00zzinline_recursionz00, BgL_bgl_findza7d2recursiveza7d2callsza7d2app2824za7d2za7za7inline_recursionza7004673za7, BGl_findzd2recursivezd2callszd2app2824zd2zzinline_recursionz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc4621z00zzinline_recursionz00, BgL_bgl_findza7d2recursiveza7d2callsza7d2funcall2828za7d2za7za7inline_recursionza7004674za7, BGl_findzd2recursivezd2callszd2funcall2828zd2zzinline_recursionz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc4622z00zzinline_recursionz00, BgL_bgl_findza7d2recursiveza7d2callsza7d2extern2830za7d2za7za7inline_recursionza7004675za7, BGl_findzd2recursivezd2callszd2extern2830zd2zzinline_recursionz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc4623z00zzinline_recursionz00, BgL_bgl_findza7d2recursiveza7d2callsza7d2cast2832za7d2za7za7inline_recursionza7004676za7, BGl_findzd2recursivezd2callszd2cast2832zd2zzinline_recursionz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc4624z00zzinline_recursionz00, BgL_bgl_findza7d2recursiveza7d2callsza7d2setq2834za7d2za7za7inline_recursionza7004677za7, BGl_findzd2recursivezd2callszd2setq2834zd2zzinline_recursionz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc4625z00zzinline_recursionz00, BgL_bgl_findza7d2recursiveza7d2callsza7d2conditional2836za7d2za7za7inline_recursionza7004678za7, BGl_findzd2recursivezd2callszd2conditional2836zd2zzinline_recursionz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc4626z00zzinline_recursionz00, BgL_bgl_findza7d2recursiveza7d2callsza7d2fail2838za7d2za7za7inline_recursionza7004679za7, BGl_findzd2recursivezd2callszd2fail2838zd2zzinline_recursionz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc4627z00zzinline_recursionz00, BgL_bgl_findza7d2recursiveza7d2callsza7d2select2840za7d2za7za7inline_recursionza7004680za7, BGl_findzd2recursivezd2callszd2select2840zd2zzinline_recursionz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc4628z00zzinline_recursionz00, BgL_bgl_findza7d2recursiveza7d2callsza7d2letza7d2fun2842za700za7za7inline_recursionza7004681z00, BGl_findzd2recursivezd2callszd2letzd2fun2842z00zzinline_recursionz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc4630z00zzinline_recursionz00, BgL_bgl_findza7d2recursiveza7d2callsza7d2setza7d2exza7d2it2846za7d2za7za7inline_recursionza7004682za7, BGl_findzd2recursivezd2callszd2setzd2exzd2it2846zd2zzinline_recursionz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc4629z00zzinline_recursionz00, BgL_bgl_findza7d2recursiveza7d2callsza7d2letza7d2var2844za700za7za7inline_recursionza7004683z00, BGl_findzd2recursivezd2callszd2letzd2var2844z00zzinline_recursionz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc4631z00zzinline_recursionz00, BgL_bgl_findza7d2recursiveza7d2callsza7d2jumpza7d2exza7d2it2848za7d2za7za7inline_recursionza7004684za7, BGl_findzd2recursivezd2callszd2jumpzd2exzd2it2848zd2zzinline_recursionz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc4632z00zzinline_recursionz00, BgL_bgl_findza7d2recursiveza7d2callsza7d2makeza7d2box2850za700za7za7inline_recursionza7004685z00, BGl_findzd2recursivezd2callszd2makezd2box2850z00zzinline_recursionz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc4633z00zzinline_recursionz00, BgL_bgl_findza7d2recursiveza7d2callsza7d2boxza7d2ref2852za700za7za7inline_recursionza7004686z00, BGl_findzd2recursivezd2callszd2boxzd2ref2852z00zzinline_recursionz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc4634z00zzinline_recursionz00, BgL_bgl_findza7d2recursiveza7d2callsza7d2boxza7d2setza7122854za712za7za7inline_recursionza7004687za7, BGl_findzd2recursivezd2callszd2boxzd2setz122854z12zzinline_recursionz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_iszd2recursivezf3zd2envzf3zzinline_recursionz00, BgL_bgl__isza7d2recursiveza7f34063za721za7za7inline_recursionza7004688z00, BGl__iszd2recursivezf34063z21zzinline_recursionz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl_inlinezd2appzd2recursivezd2envzd2zzinline_recursionz00, BgL_bgl__inlineza7d2appza7d2recursive4059za700za7za7inline_recursionza7004689z00, BGl__inlinezd2appzd2recursive4059z00zzinline_recursionz00, 0L, 3 );



/* module-initialization */
obj_t BGl_modulezd2initializa7ationz75zzinline_recursionz00(long BgL_checksumz00_3881, char * BgL_fromz00_3882)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzinline_recursionz00))
{ 
BGl_requirezd2initializa7ationz75zzinline_recursionz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzinline_recursionz00(); 
BGl_cnstzd2initzd2zzinline_recursionz00(); 
BGl_importedzd2moduleszd2initz00zzinline_recursionz00(); 
BGl_methodzd2initzd2zzinline_recursionz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzinline_recursionz00()
{ AN_OBJECT;
{ /* Inline/recursion.scm 15 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "inline_recursion"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "inline_recursion"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "inline_recursion"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "inline_recursion"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzinline_recursionz00()
{ AN_OBJECT;
{ /* Inline/recursion.scm 15 */
{ /* Inline/recursion.scm 15 */
obj_t BgL_cportz00_3874;
BgL_cportz00_3874 = 
open_input_string(BGl_string4635z00zzinline_recursionz00); 
{ 
long BgL_iz00_3875;
BgL_iz00_3875 = ((long)1); 
BgL_loopz00_3876:
if(
(BgL_iz00_3875==((long)-1)))
{ /* Inline/recursion.scm 15 */
return BUNSPEC;}  else 
{ /* Inline/recursion.scm 15 */
{ /* Inline/recursion.scm 15 */
obj_t BgL_arg4639z00_3878;
{ /* Inline/recursion.scm 15 */
obj_t BgL_list4642z00_3879;
BgL_list4642z00_3879 = 
MAKE_PAIR(BgL_cportz00_3874, BNIL); 
BgL_arg4639z00_3878 = 
BGl_readz00zz__readerz00(BgL_list4642z00_3879); } 
{ /* Inline/recursion.scm 15 */
int BgL_auxz00_3899;
BgL_auxz00_3899 = 
(int)(BgL_iz00_3875); 
CNST_TABLE_SET(BgL_auxz00_3899, BgL_arg4639z00_3878); } } 
{ 
long BgL_iz00_3902;
{ /* Inline/recursion.scm 15 */
int BgL_auxz00_3903;
{ /* Inline/recursion.scm 15 */
long BgL_auxz00_3904;
BgL_auxz00_3904 = 
(BgL_iz00_3875-((long)1)); 
BgL_auxz00_3903 = 
(int)(BgL_auxz00_3904); } 
BgL_iz00_3902 = 
(long)(BgL_auxz00_3903); } 
BgL_iz00_3875 = BgL_iz00_3902; 
goto BgL_loopz00_3876;} } } } } 
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zzinline_recursionz00()
{ AN_OBJECT;
{ /* Inline/recursion.scm 15 */
return BUNSPEC;} 
}



/* inline-app-recursive */
BgL_nodez00_bglt BGl_inlinezd2appzd2recursivez00zzinline_recursionz00(BgL_nodez00_bglt BgL_nodez00_1, long BgL_kfactorz00_2, obj_t BgL_stackz00_3)
{ AN_OBJECT;
{ /* Inline/recursion.scm 40 */
{ /* Inline/recursion.scm 43 */
bool_t BgL_testz00_3908;
{ /* Inline/recursion.scm 43 */
obj_t BgL_auxz00_3909;
{ /* Inline/recursion.scm 43 */
obj_t BgL_auxz00_3910;
{ /* Inline/recursion.scm 43 */
BgL_variablez00_bglt BgL_auxz00_3911;
{ /* Inline/recursion.scm 42 */
BgL_varz00_bglt BgL_arg2861z00_1384;
{ /* Inline/recursion.scm 42 */
BgL_appz00_bglt BgL_obj1723z00_2159;
BgL_obj1723z00_2159 = 
(BgL_appz00_bglt)(BgL_nodez00_1); 
BgL_arg2861z00_1384 = 
(((BgL_appz00_bglt)CREF(BgL_obj1723z00_2159))->BgL_funz00); } 
BgL_auxz00_3911 = 
(((BgL_varz00_bglt)CREF(BgL_arg2861z00_1384))->BgL_variablez00); } 
BgL_auxz00_3910 = 
(obj_t)(BgL_auxz00_3911); } 
BgL_auxz00_3909 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_auxz00_3910, BgL_stackz00_3); } 
BgL_testz00_3908 = 
CBOOL(BgL_auxz00_3909); } 
if(BgL_testz00_3908)
{ /* Inline/recursion.scm 43 */
return 
BGl_inlinezd2appzd2simplez00zzinline_simplez00(BgL_nodez00_1, BgL_kfactorz00_2, BgL_stackz00_3, BGl_string4613z00zzinline_recursionz00);}  else 
{ /* Inline/recursion.scm 43 */
{ /* Inline/recursion.scm 52 */
obj_t BgL_labelszd2nodezd2_1383;
BgL_labelszd2nodezd2_1383 = 
BGl_inlinezd2appzd2labelsz00zzinline_recursionz00(BgL_nodez00_1, BgL_kfactorz00_2, BgL_stackz00_3); 
return 
(BgL_nodez00_bglt)(BgL_labelszd2nodezd2_1383);} } } } 
}



/* _inline-app-recursive4059 */
obj_t BGl__inlinezd2appzd2recursive4059z00zzinline_recursionz00(obj_t BgL_envz00_3789, obj_t BgL_nodez00_3790, obj_t BgL_kfactorz00_3791, obj_t BgL_stackz00_3792)
{ AN_OBJECT;
{ /* Inline/recursion.scm 40 */
{ /* Inline/recursion.scm 41 */
BgL_nodez00_bglt BgL_auxz00_3921;
BgL_auxz00_3921 = 
BGl_inlinezd2appzd2recursivez00zzinline_recursionz00(
(BgL_nodez00_bglt)(BgL_nodez00_3790), 
(long)CINT(BgL_kfactorz00_3791), BgL_stackz00_3792); 
return 
(obj_t)(BgL_auxz00_3921);} } 
}



/* inline-app-labels */
obj_t BGl_inlinezd2appzd2labelsz00zzinline_recursionz00(BgL_nodez00_bglt BgL_nodez00_4, long BgL_kfactorz00_5, obj_t BgL_stackz00_6)
{ AN_OBJECT;
{ /* Inline/recursion.scm 60 */
{ /* Inline/recursion.scm 61 */
BgL_variablez00_bglt BgL_variablez00_1385;
{ /* Inline/recursion.scm 61 */
BgL_varz00_bglt BgL_arg3064z00_1501;
{ /* Inline/recursion.scm 61 */
BgL_appz00_bglt BgL_obj1723z00_2161;
BgL_obj1723z00_2161 = 
(BgL_appz00_bglt)(BgL_nodez00_4); 
BgL_arg3064z00_1501 = 
(((BgL_appz00_bglt)CREF(BgL_obj1723z00_2161))->BgL_funz00); } 
BgL_variablez00_1385 = 
(((BgL_varz00_bglt)CREF(BgL_arg3064z00_1501))->BgL_variablez00); } 
{ /* Inline/recursion.scm 61 */
long BgL_callzd2siza7ez75_1386;
{ /* Inline/recursion.scm 62 */
long BgL_auxz00_3929;
{ /* Inline/recursion.scm 62 */
obj_t BgL_auxz00_3930;
{ /* Inline/recursion.scm 62 */
BgL_appz00_bglt BgL_obj1726z00_2163;
BgL_obj1726z00_2163 = 
(BgL_appz00_bglt)(BgL_nodez00_4); 
BgL_auxz00_3930 = 
(((BgL_appz00_bglt)CREF(BgL_obj1726z00_2163))->BgL_argsz00); } 
BgL_auxz00_3929 = 
bgl_list_length(BgL_auxz00_3930); } 
BgL_callzd2siza7ez75_1386 = 
(((long)1)+BgL_auxz00_3929); } 
{ /* Inline/recursion.scm 62 */
BgL_localz00_bglt BgL_localz00_1387;
{ /* Inline/recursion.scm 63 */
BgL_sfunz00_bglt BgL_auxz00_3935;
{ /* Inline/recursion.scm 65 */
BgL_valuez00_bglt BgL_auxz00_3938;
BgL_auxz00_3938 = 
(((BgL_variablez00_bglt)CREF(BgL_variablez00_1385))->BgL_valuez00); 
BgL_auxz00_3935 = 
(BgL_sfunz00_bglt)(BgL_auxz00_3938); } 
BgL_localz00_1387 = 
BGl_makezd2localzd2sfunz00zzast_localz00(
(((BgL_variablez00_bglt)CREF(BgL_variablez00_1385))->BgL_idz00), 
(((BgL_variablez00_bglt)CREF(BgL_variablez00_1385))->BgL_typez00), BgL_auxz00_3935); } 
{ /* Inline/recursion.scm 63 */
BgL_valuez00_bglt BgL_oldzd2sfunzd2_1388;
BgL_oldzd2sfunzd2_1388 = 
(((BgL_variablez00_bglt)CREF(BgL_variablez00_1385))->BgL_valuez00); 
{ /* Inline/recursion.scm 66 */
obj_t BgL_reczd2callszd2_1389;
{ /* Inline/recursion.scm 67 */
BgL_isfunz00_bglt BgL_obj2685z00_2170;
BgL_obj2685z00_2170 = 
(BgL_isfunz00_bglt)(BgL_oldzd2sfunzd2_1388); 
{ 
obj_t BgL_auxz00_3944;
{ /* Inline/recursion.scm 67 */
BgL_objectz00_bglt BgL_auxz00_3945;
BgL_auxz00_3945 = 
(BgL_objectz00_bglt)(BgL_obj2685z00_2170); 
BgL_auxz00_3944 = 
BGL_OBJECT_WIDENING(BgL_auxz00_3945); } 
BgL_reczd2callszd2_1389 = 
(((BgL_isfunz00_bglt)CREF(BgL_auxz00_3944))->BgL_recursivezd2callszd2); } } 
{ /* Inline/recursion.scm 67 */
obj_t BgL_oldzd2argszd2_1390;
{ /* Inline/recursion.scm 68 */
BgL_sfunz00_bglt BgL_obj1370z00_2171;
BgL_obj1370z00_2171 = 
(BgL_sfunz00_bglt)(BgL_oldzd2sfunzd2_1388); 
BgL_oldzd2argszd2_1390 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1370z00_2171))->BgL_argsz00); } 
{ /* Inline/recursion.scm 68 */
obj_t BgL_invzd2argszd2_1391;
BgL_invzd2argszd2_1391 = 
BGl_invariantzd2argszd2zzinline_variantz00(BgL_variablez00_1385, BgL_reczd2callszd2_1389); 
{ /* Inline/recursion.scm 69 */
obj_t BgL_varzd2argszd2_1392;
BgL_varzd2argszd2_1392 = 
BGl_variantzd2argszd2zzinline_variantz00(BgL_variablez00_1385); 
{ /* Inline/recursion.scm 70 */
obj_t BgL_newzd2argszd2_1393;
if(
NULLP(BgL_varzd2argszd2_1392))
{ /* Inline/recursion.scm 71 */
BgL_newzd2argszd2_1393 = BNIL; }  else 
{ /* Inline/recursion.scm 71 */
obj_t BgL_head2779z00_1481;
BgL_head2779z00_1481 = 
MAKE_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l2777z00_1482;obj_t BgL_tail2780z00_1483;
BgL_l2777z00_1482 = BgL_varzd2argszd2_1392; 
BgL_tail2780z00_1483 = BgL_head2779z00_1481; 
BgL_lname2778z00_1484:
if(
NULLP(BgL_l2777z00_1482))
{ /* Inline/recursion.scm 71 */
BgL_newzd2argszd2_1393 = 
CDR(BgL_head2779z00_1481); }  else 
{ /* Inline/recursion.scm 72 */
obj_t BgL_newtail2781z00_1486;
{ /* Inline/recursion.scm 72 */
BgL_localz00_bglt BgL_arg3027z00_1488;
{ /* Inline/recursion.scm 72 */
obj_t BgL_lz00_1490;
BgL_lz00_1490 = 
CAR(BgL_l2777z00_1482); 
{ /* Inline/recursion.scm 74 */
BgL_svarz00_bglt BgL_arg3031z00_1491;
{ /* Inline/recursion.scm 74 */
BgL_svarz00_bglt BgL_duplicated2782z00_1492;
{ /* Inline/recursion.scm 74 */
BgL_localz00_bglt BgL_obj1256z00_2178;
BgL_obj1256z00_2178 = 
(BgL_localz00_bglt)(BgL_lz00_1490); 
{ /* Inline/recursion.scm 74 */
BgL_valuez00_bglt BgL_auxz00_3961;
BgL_auxz00_3961 = 
(((BgL_localz00_bglt)CREF(BgL_obj1256z00_2178))->BgL_valuez00); 
BgL_duplicated2782z00_1492 = 
(BgL_svarz00_bglt)(BgL_auxz00_3961); } } 
{ /* Inline/recursion.scm 74 */
BgL_svarz00_bglt BgL_new2783z00_1493;
{ /* Inline/recursion.scm 74 */
obj_t BgL_arg3034z00_1494;
BgL_arg3034z00_1494 = 
(((BgL_svarz00_bglt)CREF(BgL_duplicated2782z00_1492))->BgL_locz00); 
{ /* Inline/recursion.scm 74 */
BgL_svarz00_bglt BgL_res3975z00_2192;
{ /* Inline/recursion.scm 74 */
BgL_svarz00_bglt BgL_new1496z00_2181;
{ /* Inline/recursion.scm 74 */
BgL_svarz00_bglt BgL_res3973z00_2187;
{ /* Inline/recursion.scm 74 */
BgL_svarz00_bglt BgL_new1498z00_2182;
BgL_new1498z00_2182 = 
((BgL_svarz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_svarz00_bgl) ))); 
{ /* Inline/recursion.scm 74 */
long BgL_arg3546z00_2183;
BgL_arg3546z00_2183 = 
BGl_classzd2numzd2zz__objectz00(BGl_svarz00zzast_varz00); 
{ /* Inline/recursion.scm 74 */
BgL_objectz00_bglt BgL_auxz00_3967;
BgL_auxz00_3967 = 
(BgL_objectz00_bglt)(BgL_new1498z00_2182); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_3967, BgL_arg3546z00_2183); } } 
{ /* Inline/recursion.scm 74 */
BgL_objectz00_bglt BgL_auxz00_3970;
BgL_auxz00_3970 = 
(BgL_objectz00_bglt)(BgL_new1498z00_2182); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_3970, BFALSE); } 
{ /* Inline/recursion.scm 74 */
obj_t BgL_auxz00_3973;
BgL_auxz00_3973 = 
(obj_t)(BgL_new1498z00_2182); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_3973); } BUNSPEC; 
BgL_res3973z00_2187 = BgL_new1498z00_2182; } 
BgL_new1496z00_2181 = BgL_res3973z00_2187; } 
{ /* Inline/recursion.scm 74 */
BgL_svarz00_bglt BgL_res3974z00_2191;
((((BgL_svarz00_bglt)CREF(BgL_new1496z00_2181))->BgL_locz00) = ((obj_t)BgL_arg3034z00_1494), BUNSPEC); 
BgL_res3974z00_2191 = BgL_new1496z00_2181; BgL_res3974z00_2191; } 
BgL_res3975z00_2192 = BgL_new1496z00_2181; } 
BgL_new2783z00_1493 = BgL_res3975z00_2192; } } 
{ /* Inline/recursion.scm 74 */

BgL_arg3031z00_1491 = BgL_new2783z00_1493; } } } 
BgL_arg3027z00_1488 = 
BGl_clonezd2localzd2zzast_localz00(
(BgL_localz00_bglt)(BgL_lz00_1490), 
(BgL_valuez00_bglt)(BgL_arg3031z00_1491)); } } 
{ /* Inline/recursion.scm 71 */
obj_t BgL_auxz00_3980;
BgL_auxz00_3980 = 
(obj_t)(BgL_arg3027z00_1488); 
BgL_newtail2781z00_1486 = 
MAKE_PAIR(BgL_auxz00_3980, BNIL); } } 
SET_CDR(BgL_tail2780z00_1483, BgL_newtail2781z00_1486); 
{ 
obj_t BgL_tail2780z00_3986;obj_t BgL_l2777z00_3984;
BgL_l2777z00_3984 = 
CDR(BgL_l2777z00_1482); 
BgL_tail2780z00_3986 = BgL_newtail2781z00_1486; 
BgL_tail2780z00_1483 = BgL_tail2780z00_3986; 
BgL_l2777z00_1482 = BgL_l2777z00_3984; 
goto BgL_lname2778z00_1484;} } } } 
{ /* Inline/recursion.scm 71 */
obj_t BgL_substitutez00_1394;
{ /* Inline/recursion.scm 76 */
obj_t BgL_auxz00_3987;
{ /* Inline/recursion.scm 76 */
BgL_appz00_bglt BgL_obj1726z00_2198;
BgL_obj1726z00_2198 = 
(BgL_appz00_bglt)(BgL_nodez00_4); 
BgL_auxz00_3987 = 
(((BgL_appz00_bglt)CREF(BgL_obj1726z00_2198))->BgL_argsz00); } 
BgL_substitutez00_1394 = 
BGl_substitutionsz00zzinline_variantz00(BgL_variablez00_1385, BgL_auxz00_3987, BgL_newzd2argszd2_1393); } 
{ /* Inline/recursion.scm 76 */
obj_t BgL_oldzd2bodyzd2_1395;
{ /* Inline/recursion.scm 77 */
bool_t BgL_test3009z00_1477;
BgL_test3009z00_1477 = 
BGl_iszd2azf3z21zz__objectz00(
(obj_t)(BgL_oldzd2sfunzd2_1388), BGl_isfunz00zzinline_inlinez00); 
if(BgL_test3009z00_1477)
{ /* Inline/recursion.scm 78 */
BgL_isfunz00_bglt BgL_obj2684z00_2200;
BgL_obj2684z00_2200 = 
(BgL_isfunz00_bglt)(BgL_oldzd2sfunzd2_1388); 
{ /* Inline/recursion.scm 78 */
BgL_nodez00_bglt BgL_auxz00_3995;
{ 
obj_t BgL_auxz00_3996;
{ /* Inline/recursion.scm 78 */
BgL_objectz00_bglt BgL_auxz00_3997;
BgL_auxz00_3997 = 
(BgL_objectz00_bglt)(BgL_obj2684z00_2200); 
BgL_auxz00_3996 = 
BGL_OBJECT_WIDENING(BgL_auxz00_3997); } 
BgL_auxz00_3995 = 
(((BgL_isfunz00_bglt)CREF(BgL_auxz00_3996))->BgL_originalzd2bodyzd2); } 
BgL_oldzd2bodyzd2_1395 = 
(obj_t)(BgL_auxz00_3995); } }  else 
{ /* Inline/recursion.scm 79 */
BgL_sfunz00_bglt BgL_obj1373z00_2201;
BgL_obj1373z00_2201 = 
(BgL_sfunz00_bglt)(BgL_oldzd2sfunzd2_1388); 
BgL_oldzd2bodyzd2_1395 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1373z00_2201))->BgL_bodyz00); } } 
{ /* Inline/recursion.scm 77 */
obj_t BgL_svgzd2callszd2argsz00_1396;
if(
NULLP(BgL_reczd2callszd2_1389))
{ /* Inline/recursion.scm 80 */
BgL_svgzd2callszd2argsz00_1396 = BNIL; }  else 
{ /* Inline/recursion.scm 80 */
obj_t BgL_head2786z00_1467;
BgL_head2786z00_1467 = 
MAKE_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l2784z00_1468;obj_t BgL_tail2787z00_1469;
BgL_l2784z00_1468 = BgL_reczd2callszd2_1389; 
BgL_tail2787z00_1469 = BgL_head2786z00_1467; 
BgL_lname2785z00_1470:
if(
NULLP(BgL_l2784z00_1468))
{ /* Inline/recursion.scm 80 */
BgL_svgzd2callszd2argsz00_1396 = 
CDR(BgL_head2786z00_1467); }  else 
{ /* Inline/recursion.scm 80 */
obj_t BgL_newtail2788z00_1472;
{ /* Inline/recursion.scm 80 */
obj_t BgL_auxz00_4010;
{ /* Inline/recursion.scm 80 */
BgL_appz00_bglt BgL_obj1726z00_2208;
{ /* Inline/recursion.scm 80 */
obj_t BgL_auxz00_4011;
BgL_auxz00_4011 = 
CAR(BgL_l2784z00_1468); 
BgL_obj1726z00_2208 = 
(BgL_appz00_bglt)(BgL_auxz00_4011); } 
BgL_auxz00_4010 = 
(((BgL_appz00_bglt)CREF(BgL_obj1726z00_2208))->BgL_argsz00); } 
BgL_newtail2788z00_1472 = 
MAKE_PAIR(BgL_auxz00_4010, BNIL); } 
SET_CDR(BgL_tail2787z00_1469, BgL_newtail2788z00_1472); 
{ 
obj_t BgL_tail2787z00_4019;obj_t BgL_l2784z00_4017;
BgL_l2784z00_4017 = 
CDR(BgL_l2784z00_1468); 
BgL_tail2787z00_4019 = BgL_newtail2788z00_1472; 
BgL_tail2787z00_1469 = BgL_tail2787z00_4019; 
BgL_l2784z00_1468 = BgL_l2784z00_4017; 
goto BgL_lname2785z00_1470;} } } } 
{ /* Inline/recursion.scm 80 */
bool_t BgL_removez12z12_1397;
{ 
obj_t BgL_l2789z00_1460;
BgL_l2789z00_1460 = BgL_reczd2callszd2_1389; 
BgL_lname2790z00_1461:
if(
PAIRP(BgL_l2789z00_1460))
{ /* Inline/recursion.scm 81 */
{ /* Inline/recursion.scm 81 */
BgL_appz00_bglt BgL_auxz00_4022;
{ /* Inline/recursion.scm 81 */
obj_t BgL_auxz00_4023;
BgL_auxz00_4023 = 
CAR(BgL_l2789z00_1460); 
BgL_auxz00_4022 = 
(BgL_appz00_bglt)(BgL_auxz00_4023); } 
BGl_removezd2invariantzd2argsz12z12zzinline_variantz00(BgL_auxz00_4022); } 
{ 
obj_t BgL_l2789z00_4027;
BgL_l2789z00_4027 = 
CDR(BgL_l2789z00_1460); 
BgL_l2789z00_1460 = BgL_l2789z00_4027; 
goto BgL_lname2790z00_1461;} }  else 
{ /* Inline/recursion.scm 81 */
BgL_removez12z12_1397 = ((bool_t)1); } } 
{ /* Inline/recursion.scm 81 */
BgL_nodez00_bglt BgL_newzd2bodyzd2_1398;
{ /* Inline/recursion.scm 82 */
obj_t BgL_arg2971z00_1457;obj_t BgL_arg2972z00_1458;obj_t BgL_arg2973z00_1459;
{ /* Inline/recursion.scm 82 */
obj_t BgL_auxz00_4029;
BgL_auxz00_4029 = 
(obj_t)(BgL_variablez00_1385); 
BgL_arg2971z00_1457 = 
MAKE_PAIR(BgL_auxz00_4029, BgL_oldzd2argszd2_1390); } 
{ /* Inline/recursion.scm 83 */
obj_t BgL_auxz00_4032;
BgL_auxz00_4032 = 
(obj_t)(BgL_localz00_1387); 
BgL_arg2972z00_1458 = 
MAKE_PAIR(BgL_auxz00_4032, BgL_substitutez00_1394); } 
BgL_arg2973z00_1459 = 
(((BgL_nodez00_bglt)CREF(BgL_nodez00_4))->BgL_locz00); 
BgL_newzd2bodyzd2_1398 = 
BGl_alphatiza7eza7zzast_alphatiza7eza7(BgL_arg2971z00_1457, BgL_arg2972z00_1458, BgL_arg2973z00_1459, 
(BgL_nodez00_bglt)(BgL_oldzd2bodyzd2_1395)); } 
{ /* Inline/recursion.scm 82 */
bool_t BgL_restorez12z12_1399;
{ 
obj_t BgL_ll2791z00_1449;obj_t BgL_ll2792z00_1450;
BgL_ll2791z00_1449 = BgL_reczd2callszd2_1389; 
BgL_ll2792z00_1450 = BgL_svgzd2callszd2argsz00_1396; 
BgL_lname2793z00_1451:
if(
NULLP(BgL_ll2791z00_1449))
{ /* Inline/recursion.scm 86 */
BgL_restorez12z12_1399 = ((bool_t)1); }  else 
{ /* Inline/recursion.scm 86 */
{ /* Inline/recursion.scm 87 */
obj_t BgL_argsz00_1454;
BgL_argsz00_1454 = 
CAR(BgL_ll2792z00_1450); 
{ /* Inline/recursion.scm 87 */
BgL_appz00_bglt BgL_obj1728z00_2221;
{ /* Inline/recursion.scm 87 */
obj_t BgL_auxz00_4041;
BgL_auxz00_4041 = 
CAR(BgL_ll2791z00_1449); 
BgL_obj1728z00_2221 = 
(BgL_appz00_bglt)(BgL_auxz00_4041); } 
((((BgL_appz00_bglt)CREF(BgL_obj1728z00_2221))->BgL_argsz00) = ((obj_t)BgL_argsz00_1454), BUNSPEC); } } 
{ 
obj_t BgL_ll2792z00_4047;obj_t BgL_ll2791z00_4045;
BgL_ll2791z00_4045 = 
CDR(BgL_ll2791z00_1449); 
BgL_ll2792z00_4047 = 
CDR(BgL_ll2792z00_1450); 
BgL_ll2792z00_1450 = BgL_ll2792z00_4047; 
BgL_ll2791z00_1449 = BgL_ll2791z00_4045; 
goto BgL_lname2793z00_1451;} } } 
{ /* Inline/recursion.scm 86 */
BgL_sfunz00_bglt BgL_newzd2sfunzd2_1400;
{ /* Inline/recursion.scm 90 */
BgL_sfunz00_bglt BgL_duplicated2794z00_1435;
BgL_duplicated2794z00_1435 = 
(BgL_sfunz00_bglt)(BgL_oldzd2sfunzd2_1388); 
{ /* Inline/recursion.scm 90 */
BgL_sfunz00_bglt BgL_new2795z00_1436;
{ /* Inline/recursion.scm 90 */
long BgL_arg2936z00_1437;obj_t BgL_arg2937z00_1438;obj_t BgL_arg2938z00_1439;obj_t BgL_arg2939z00_1440;bool_t BgL_arg2940z00_1441;obj_t BgL_arg2941z00_1442;obj_t BgL_arg2942z00_1443;obj_t BgL_arg2943z00_1444;obj_t BgL_arg2945z00_1446;obj_t BgL_arg2946z00_1447;obj_t BgL_arg2947z00_1448;
BgL_arg2936z00_1437 = 
(((BgL_sfunz00_bglt)CREF(BgL_duplicated2794z00_1435))->BgL_arityz00); 
BgL_arg2937z00_1438 = 
(((BgL_sfunz00_bglt)CREF(BgL_duplicated2794z00_1435))->BgL_sidezd2effectzf3z21); 
BgL_arg2938z00_1439 = 
(((BgL_sfunz00_bglt)CREF(BgL_duplicated2794z00_1435))->BgL_predicatezd2ofzd2); 
BgL_arg2939z00_1440 = 
(((BgL_sfunz00_bglt)CREF(BgL_duplicated2794z00_1435))->BgL_stackzd2allocatorzd2); 
BgL_arg2940z00_1441 = 
(((BgL_sfunz00_bglt)CREF(BgL_duplicated2794z00_1435))->BgL_topzf3zf3); 
BgL_arg2941z00_1442 = 
(((BgL_sfunz00_bglt)CREF(BgL_duplicated2794z00_1435))->BgL_thezd2closurezd2); 
BgL_arg2942z00_1443 = 
(((BgL_sfunz00_bglt)CREF(BgL_duplicated2794z00_1435))->BgL_propertyz00); 
BgL_arg2943z00_1444 = BgL_newzd2argszd2_1393; 
BgL_arg2945z00_1446 = 
CNST_TABLE_REF(((long)0)); 
BgL_arg2946z00_1447 = 
(((BgL_sfunz00_bglt)CREF(BgL_duplicated2794z00_1435))->BgL_dssslzd2keywordszd2); 
BgL_arg2947z00_1448 = 
(((BgL_sfunz00_bglt)CREF(BgL_duplicated2794z00_1435))->BgL_locz00); 
{ /* Inline/recursion.scm 90 */
BgL_sfunz00_bglt BgL_res3978z00_2279;
{ /* Inline/recursion.scm 90 */
obj_t BgL_body1420z00_2242;
{ /* Inline/recursion.scm 90 */
BgL_nodez00_bglt BgL_auxz00_4060;
BgL_auxz00_4060 = BgL_newzd2bodyzd2_1398; 
BgL_body1420z00_2242 = 
(obj_t)(BgL_auxz00_4060); } 
{ /* Inline/recursion.scm 90 */
BgL_sfunz00_bglt BgL_new1424z00_2246;
{ /* Inline/recursion.scm 90 */
BgL_sfunz00_bglt BgL_res3976z00_2252;
{ /* Inline/recursion.scm 90 */
BgL_sfunz00_bglt BgL_new1426z00_2247;
BgL_new1426z00_2247 = 
((BgL_sfunz00_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_sfunz00_bgl) ))); 
{ /* Inline/recursion.scm 90 */
long BgL_arg3564z00_2248;
BgL_arg3564z00_2248 = 
BGl_classzd2numzd2zz__objectz00(BGl_sfunz00zzast_varz00); 
{ /* Inline/recursion.scm 90 */
BgL_objectz00_bglt BgL_auxz00_4064;
BgL_auxz00_4064 = 
(BgL_objectz00_bglt)(BgL_new1426z00_2247); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4064, BgL_arg3564z00_2248); } } 
{ /* Inline/recursion.scm 90 */
BgL_objectz00_bglt BgL_auxz00_4067;
BgL_auxz00_4067 = 
(BgL_objectz00_bglt)(BgL_new1426z00_2247); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4067, BFALSE); } 
{ /* Inline/recursion.scm 90 */
obj_t BgL_auxz00_4070;
BgL_auxz00_4070 = 
(obj_t)(BgL_new1426z00_2247); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4070); } BUNSPEC; 
BgL_res3976z00_2252 = BgL_new1426z00_2247; } 
BgL_new1424z00_2246 = BgL_res3976z00_2252; } 
{ /* Inline/recursion.scm 90 */
BgL_sfunz00_bglt BgL_res3977z00_2278;
((((BgL_sfunz00_bglt)CREF(BgL_new1424z00_2246))->BgL_arityz00) = ((long)BgL_arg2936z00_1437), BUNSPEC); 
((((BgL_sfunz00_bglt)CREF(BgL_new1424z00_2246))->BgL_sidezd2effectzf3z21) = ((obj_t)BgL_arg2937z00_1438), BUNSPEC); 
((((BgL_sfunz00_bglt)CREF(BgL_new1424z00_2246))->BgL_predicatezd2ofzd2) = ((obj_t)BgL_arg2938z00_1439), BUNSPEC); 
((((BgL_sfunz00_bglt)CREF(BgL_new1424z00_2246))->BgL_stackzd2allocatorzd2) = ((obj_t)BgL_arg2939z00_1440), BUNSPEC); 
((((BgL_sfunz00_bglt)CREF(BgL_new1424z00_2246))->BgL_topzf3zf3) = ((bool_t)BgL_arg2940z00_1441), BUNSPEC); 
((((BgL_sfunz00_bglt)CREF(BgL_new1424z00_2246))->BgL_thezd2closurezd2) = ((obj_t)BgL_arg2941z00_1442), BUNSPEC); 
((((BgL_sfunz00_bglt)CREF(BgL_new1424z00_2246))->BgL_propertyz00) = ((obj_t)BgL_arg2942z00_1443), BUNSPEC); 
((((BgL_sfunz00_bglt)CREF(BgL_new1424z00_2246))->BgL_argsz00) = ((obj_t)BgL_arg2943z00_1444), BUNSPEC); 
((((BgL_sfunz00_bglt)CREF(BgL_new1424z00_2246))->BgL_bodyz00) = ((obj_t)BgL_body1420z00_2242), BUNSPEC); 
((((BgL_sfunz00_bglt)CREF(BgL_new1424z00_2246))->BgL_classz00) = ((obj_t)BgL_arg2945z00_1446), BUNSPEC); 
((((BgL_sfunz00_bglt)CREF(BgL_new1424z00_2246))->BgL_dssslzd2keywordszd2) = ((obj_t)BgL_arg2946z00_1447), BUNSPEC); 
((((BgL_sfunz00_bglt)CREF(BgL_new1424z00_2246))->BgL_locz00) = ((obj_t)BgL_arg2947z00_1448), BUNSPEC); 
BgL_res3977z00_2278 = BgL_new1424z00_2246; BgL_res3977z00_2278; } 
BgL_res3978z00_2279 = BgL_new1424z00_2246; } } 
BgL_new2795z00_1436 = BgL_res3978z00_2279; } } 
{ /* Inline/recursion.scm 90 */

BgL_newzd2sfunzd2_1400 = BgL_new2795z00_1436; } } } 
{ /* Inline/recursion.scm 90 */
obj_t BgL_newzd2kfactorzd2_1401;
BgL_newzd2kfactorzd2_1401 = 
PROCEDURE_ENTRY(BGl_za2inliningzd2reducezd2kfactorza2z00zzengine_paramz00)(BGl_za2inliningzd2reducezd2kfactorza2z00zzengine_paramz00, 
BINT(BgL_kfactorz00_5), BEOA); 
{ /* Inline/recursion.scm 94 */

{ 
obj_t BgL_ll2796z00_1402;obj_t BgL_ll2797z00_1403;
BgL_ll2796z00_1402 = BgL_newzd2argszd2_1393; 
BgL_ll2797z00_1403 = BgL_oldzd2argszd2_1390; 
BgL_lname2798z00_1404:
if(
NULLP(BgL_ll2796z00_1402))
{ /* Inline/recursion.scm 96 */((bool_t)1); }  else 
{ /* Inline/recursion.scm 96 */
{ /* Inline/recursion.scm 97 */
bool_t BgL_arg2867z00_1408;
{ /* Inline/recursion.scm 97 */
BgL_localz00_bglt BgL_obj1271z00_2283;
{ /* Inline/recursion.scm 97 */
obj_t BgL_auxz00_4090;
BgL_auxz00_4090 = 
CAR(BgL_ll2797z00_1403); 
BgL_obj1271z00_2283 = 
(BgL_localz00_bglt)(BgL_auxz00_4090); } 
BgL_arg2867z00_1408 = 
(((BgL_localz00_bglt)CREF(BgL_obj1271z00_2283))->BgL_userzf3zf3); } 
{ /* Inline/recursion.scm 97 */
BgL_localz00_bglt BgL_obj1273z00_2284;
{ /* Inline/recursion.scm 97 */
obj_t BgL_auxz00_4094;
BgL_auxz00_4094 = 
CAR(BgL_ll2796z00_1402); 
BgL_obj1273z00_2284 = 
(BgL_localz00_bglt)(BgL_auxz00_4094); } 
((((BgL_localz00_bglt)CREF(BgL_obj1273z00_2284))->BgL_userzf3zf3) = ((bool_t)BgL_arg2867z00_1408), BUNSPEC); } } 
{ 
obj_t BgL_ll2797z00_4100;obj_t BgL_ll2796z00_4098;
BgL_ll2796z00_4098 = 
CDR(BgL_ll2796z00_1402); 
BgL_ll2797z00_4100 = 
CDR(BgL_ll2797z00_1403); 
BgL_ll2797z00_1403 = BgL_ll2797z00_4100; 
BgL_ll2796z00_1402 = BgL_ll2796z00_4098; 
goto BgL_lname2798z00_1404;} } } 
{ /* Inline/recursion.scm 102 */
bool_t BgL_arg2880z00_1411;
{ /* Inline/recursion.scm 102 */
bool_t BgL_test2882z00_1412;
BgL_test2882z00_1412 = 
BGl_iszd2azf3z21zz__objectz00(
(obj_t)(BgL_variablez00_1385), BGl_globalz00zzast_varz00); 
if(BgL_test2882z00_1412)
{ /* Inline/recursion.scm 102 */
{ /* Inline/recursion.scm 103 */
BgL_globalz00_bglt BgL_obj1183z00_2289;
BgL_obj1183z00_2289 = 
(BgL_globalz00_bglt)(BgL_variablez00_1385); 
BgL_arg2880z00_1411 = 
(((BgL_globalz00_bglt)CREF(BgL_obj1183z00_2289))->BgL_userzf3zf3); } }  else 
{ /* Inline/recursion.scm 104 */
bool_t BgL_test2884z00_1413;
BgL_test2884z00_1413 = 
BGl_iszd2azf3z21zz__objectz00(
(obj_t)(BgL_variablez00_1385), BGl_localz00zzast_varz00); 
if(BgL_test2884z00_1413)
{ /* Inline/recursion.scm 104 */
{ /* Inline/recursion.scm 105 */
BgL_localz00_bglt BgL_obj1271z00_2291;
BgL_obj1271z00_2291 = 
(BgL_localz00_bglt)(BgL_variablez00_1385); 
BgL_arg2880z00_1411 = 
(((BgL_localz00_bglt)CREF(BgL_obj1271z00_2291))->BgL_userzf3zf3); } }  else 
{ /* Inline/recursion.scm 104 */
BgL_arg2880z00_1411 = ((bool_t)0); } } } 
((((BgL_localz00_bglt)CREF(BgL_localz00_1387))->BgL_userzf3zf3) = ((bool_t)BgL_arg2880z00_1411), BUNSPEC); } 
{ /* Inline/recursion.scm 108 */
BgL_valuez00_bglt BgL_val1257z00_2295;
BgL_val1257z00_2295 = 
(BgL_valuez00_bglt)(BgL_newzd2sfunzd2_1400); 
((((BgL_localz00_bglt)CREF(BgL_localz00_1387))->BgL_valuez00) = ((BgL_valuez00_bglt)BgL_val1257z00_2295), BUNSPEC); } 
{ /* Inline/recursion.scm 117 */
bool_t BgL_testz00_4115;
{ /* Inline/recursion.scm 117 */
obj_t BgL_auxz00_4116;
{ /* Inline/recursion.scm 117 */
obj_t BgL_auxz00_4117;
{ /* Inline/recursion.scm 117 */
BgL_sfunz00_bglt BgL_obj1377z00_2296;
BgL_obj1377z00_2296 = 
(BgL_sfunz00_bglt)(BgL_oldzd2sfunzd2_1388); 
BgL_auxz00_4117 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1377z00_2296))->BgL_classz00); } 
BgL_auxz00_4116 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_auxz00_4117, 
CNST_TABLE_REF(((long)1))); } 
BgL_testz00_4115 = 
CBOOL(BgL_auxz00_4116); } 
if(BgL_testz00_4115)
{ /* Inline/recursion.scm 117 */BFALSE; }  else 
{ /* Inline/recursion.scm 118 */
bool_t BgL_test2890z00_1416;
BgL_test2890z00_1416 = 
BGl_zc3zd3z10zz__r4_numbers_6_5z00(
BINT(((long)3)), BGl_za2verboseza2z00zzengine_paramz00, BNIL); 
if(BgL_test2890z00_1416)
{ /* Inline/recursion.scm 118 */
obj_t BgL_arg2893z00_1418;obj_t BgL_arg2895z00_1420;
BgL_arg2893z00_1418 = 
BGl_shapez00zztools_shapez00(
(obj_t)(BgL_variablez00_1385)); 
BgL_arg2895z00_1420 = 
BGl_currentzd2functionzd2zztools_errorz00(); 
{ /* Inline/recursion.scm 118 */
obj_t BgL_list2898z00_1422;
{ /* Inline/recursion.scm 118 */
obj_t BgL_arg2900z00_1423;
{ /* Inline/recursion.scm 118 */
obj_t BgL_arg2903z00_1424;
{ /* Inline/recursion.scm 118 */
obj_t BgL_arg2906z00_1425;
{ /* Inline/recursion.scm 118 */
obj_t BgL_arg2909z00_1426;
{ /* Inline/recursion.scm 118 */
obj_t BgL_arg2912z00_1427;
{ /* Inline/recursion.scm 118 */
obj_t BgL_auxz00_4129;
BgL_auxz00_4129 = 
BCHAR(((unsigned char)'\n')); 
BgL_arg2912z00_1427 = 
MAKE_PAIR(BgL_auxz00_4129, BNIL); } 
BgL_arg2909z00_1426 = 
MAKE_PAIR(BGl_string4614z00zzinline_recursionz00, BgL_arg2912z00_1427); } 
BgL_arg2906z00_1425 = 
MAKE_PAIR(BgL_arg2895z00_1420, BgL_arg2909z00_1426); } 
BgL_arg2903z00_1424 = 
MAKE_PAIR(BGl_string4615z00zzinline_recursionz00, BgL_arg2906z00_1425); } 
BgL_arg2900z00_1423 = 
MAKE_PAIR(BgL_arg2893z00_1418, BgL_arg2903z00_1424); } 
BgL_list2898z00_1422 = 
MAKE_PAIR(BGl_string4616z00zzinline_recursionz00, BgL_arg2900z00_1423); } 
BGl_verbosez00zztools_speekz00(
BINT(((long)3)), BgL_list2898z00_1422); } }  else 
{ /* Inline/recursion.scm 118 */BUNSPEC; } } } 
BGl_inlinezd2sfunz12zc0zzinline_inlinez00(
(BgL_variablez00_bglt)(BgL_localz00_1387), 
(long)CINT(BgL_newzd2kfactorzd2_1401), BgL_stackz00_6); 
{ /* Inline/recursion.scm 128 */
BgL_appz00_bglt BgL_newzd2callzd2_1431;
BgL_newzd2callzd2_1431 = 
BGl_removezd2invariantzd2argsz12z12zzinline_variantz00(
(BgL_appz00_bglt)(BgL_nodez00_4)); 
{ /* Inline/recursion.scm 129 */
bool_t BgL_test2925z00_1432;
if(
CBOOL(BGl_za2optimzd2unrollzd2loopzf3za2zf3zzengine_paramz00))
{ /* Inline/recursion.scm 130 */
bool_t BgL_test2928z00_1433;
BgL_test2928z00_1433 = 
BGl_iszd2loopzf3z21zzinline_loopz00(BgL_variablez00_1385); 
if(BgL_test2928z00_1433)
{ /* Inline/recursion.scm 133 */
bool_t BgL_test2929z00_1434;
BgL_test2929z00_1434 = 
BGl_innerzd2loopzf3z21zzinline_loopz00(BgL_variablez00_1385); 
if(BgL_test2929z00_1434)
{ /* Inline/recursion.scm 133 */
BgL_test2925z00_1432 = ((bool_t)0); }  else 
{ /* Inline/recursion.scm 133 */
BgL_test2925z00_1432 = 
BGl_inlinezd2appzf3z21zzinline_appz00(
(BgL_variablez00_bglt)(BgL_localz00_1387), 
(long)CINT(BgL_newzd2kfactorzd2_1401), BgL_callzd2siza7ez75_1386, BgL_stackz00_6); } }  else 
{ /* Inline/recursion.scm 130 */
BgL_test2925z00_1432 = ((bool_t)0); } }  else 
{ /* Inline/recursion.scm 129 */
BgL_test2925z00_1432 = ((bool_t)0); } 
if(BgL_test2925z00_1432)
{ /* Inline/recursion.scm 129 */
return 
BGl_unrollzd2callzd2zzinline_recursionz00(BgL_variablez00_1385, BgL_nodez00_4, BgL_localz00_1387, BgL_newzd2kfactorzd2_1401, BgL_newzd2callzd2_1431, BgL_stackz00_6);}  else 
{ /* Inline/recursion.scm 136 */
BgL_letzd2funzd2_bglt BgL_auxz00_4155;
BgL_auxz00_4155 = 
BGl_plainzd2callzd2zzinline_recursionz00(BgL_variablez00_1385, BgL_nodez00_4, BgL_localz00_1387, BgL_newzd2callzd2_1431, BgL_stackz00_6); 
return 
(obj_t)(BgL_auxz00_4155);} } } } } } } } } } } } } } } } } } } } } } 
}



/* plain-call */
BgL_letzd2funzd2_bglt BGl_plainzd2callzd2zzinline_recursionz00(BgL_variablez00_bglt BgL_variablez00_7, BgL_nodez00_bglt BgL_nodez00_8, BgL_localz00_bglt BgL_localz00_9, BgL_appz00_bglt BgL_newzd2callzd2_10, obj_t BgL_stackz00_11)
{ AN_OBJECT;
{ /* Inline/recursion.scm 141 */
BGl_shrinkzd2argsz12zc0zzinline_variantz00(BgL_variablez00_7); 
{ /* Inline/recursion.scm 151 */
obj_t BgL_locz00_1502;
BgL_locz00_1502 = 
(((BgL_nodez00_bglt)CREF(BgL_nodez00_8))->BgL_locz00); 
{ /* Inline/recursion.scm 153 */
obj_t BgL_arg3069z00_1503;BgL_typez00_bglt BgL_arg3070z00_1504;obj_t BgL_arg3072z00_1506;BgL_nodez00_bglt BgL_arg3073z00_1507;
BgL_arg3069z00_1503 = BgL_locz00_1502; 
BgL_arg3070z00_1504 = 
(((BgL_nodez00_bglt)CREF(BgL_nodez00_8))->BgL_typez00); 
{ /* Inline/recursion.scm 155 */
obj_t BgL_list3077z00_1508;
{ /* Inline/recursion.scm 155 */
obj_t BgL_auxz00_4161;
BgL_auxz00_4161 = 
(obj_t)(BgL_localz00_9); 
BgL_list3077z00_1508 = 
MAKE_PAIR(BgL_auxz00_4161, BNIL); } 
BgL_arg3072z00_1506 = BgL_list3077z00_1508; } 
{ /* Inline/recursion.scm 156 */
obj_t BgL_arg3080z00_1509;obj_t BgL_arg3081z00_1510;
{ /* Inline/recursion.scm 156 */
obj_t BgL_list3084z00_1511;
{ /* Inline/recursion.scm 156 */
obj_t BgL_auxz00_4164;
BgL_auxz00_4164 = 
(obj_t)(BgL_variablez00_7); 
BgL_list3084z00_1511 = 
MAKE_PAIR(BgL_auxz00_4164, BNIL); } 
BgL_arg3080z00_1509 = BgL_list3084z00_1511; } 
{ /* Inline/recursion.scm 156 */
obj_t BgL_list3087z00_1512;
{ /* Inline/recursion.scm 156 */
obj_t BgL_auxz00_4167;
BgL_auxz00_4167 = 
(obj_t)(BgL_localz00_9); 
BgL_list3087z00_1512 = 
MAKE_PAIR(BgL_auxz00_4167, BNIL); } 
BgL_arg3081z00_1510 = BgL_list3087z00_1512; } 
BgL_arg3073z00_1507 = 
BGl_alphatiza7eza7zzast_alphatiza7eza7(BgL_arg3080z00_1509, BgL_arg3081z00_1510, BgL_locz00_1502, 
(BgL_nodez00_bglt)(BgL_newzd2callzd2_10)); } 
{ /* Inline/recursion.scm 152 */
BgL_letzd2funzd2_bglt BgL_res3984z00_2332;
{ /* Inline/recursion.scm 152 */
obj_t BgL_key2450z00_2308;
BgL_key2450z00_2308 = 
BINT(((long)-1)); 
{ /* Inline/recursion.scm 152 */
BgL_letzd2funzd2_bglt BgL_new2453z00_2311;
{ /* Inline/recursion.scm 152 */
BgL_letzd2funzd2_bglt BgL_res3982z00_2317;
{ /* Inline/recursion.scm 152 */
BgL_letzd2funzd2_bglt BgL_new2455z00_2312;
BgL_new2455z00_2312 = 
((BgL_letzd2funzd2_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_letzd2funzd2_bgl) ))); 
{ /* Inline/recursion.scm 152 */
long BgL_arg3283z00_2313;
BgL_arg3283z00_2313 = 
BGl_classzd2numzd2zz__objectz00(BGl_letzd2funzd2zzast_nodez00); 
{ /* Inline/recursion.scm 152 */
BgL_objectz00_bglt BgL_auxz00_4175;
BgL_auxz00_4175 = 
(BgL_objectz00_bglt)(BgL_new2455z00_2312); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4175, BgL_arg3283z00_2313); } } 
{ /* Inline/recursion.scm 152 */
BgL_objectz00_bglt BgL_auxz00_4178;
BgL_auxz00_4178 = 
(BgL_objectz00_bglt)(BgL_new2455z00_2312); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4178, BFALSE); } 
{ /* Inline/recursion.scm 152 */
obj_t BgL_auxz00_4181;
BgL_auxz00_4181 = 
(obj_t)(BgL_new2455z00_2312); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4181); } BUNSPEC; 
BgL_res3982z00_2317 = BgL_new2455z00_2312; } 
BgL_new2453z00_2311 = BgL_res3982z00_2317; } 
{ /* Inline/recursion.scm 152 */
BgL_letzd2funzd2_bglt BgL_res3983z00_2331;
((((BgL_letzd2funzd2_bglt)CREF(BgL_new2453z00_2311))->BgL_locz00) = ((obj_t)BgL_arg3069z00_1503), BUNSPEC); 
((((BgL_letzd2funzd2_bglt)CREF(BgL_new2453z00_2311))->BgL_typez00) = ((BgL_typez00_bglt)BgL_arg3070z00_1504), BUNSPEC); 
((((BgL_letzd2funzd2_bglt)CREF(BgL_new2453z00_2311))->BgL_sidezd2effectzf3z21) = ((obj_t)BUNSPEC), BUNSPEC); 
((((BgL_letzd2funzd2_bglt)CREF(BgL_new2453z00_2311))->BgL_keyz00) = ((obj_t)BgL_key2450z00_2308), BUNSPEC); 
((((BgL_letzd2funzd2_bglt)CREF(BgL_new2453z00_2311))->BgL_localsz00) = ((obj_t)BgL_arg3072z00_1506), BUNSPEC); 
((((BgL_letzd2funzd2_bglt)CREF(BgL_new2453z00_2311))->BgL_bodyz00) = ((BgL_nodez00_bglt)BgL_arg3073z00_1507), BUNSPEC); 
BgL_res3983z00_2331 = BgL_new2453z00_2311; BgL_res3983z00_2331; } 
BgL_res3984z00_2332 = BgL_new2453z00_2311; } } 
return BgL_res3984z00_2332;} } } } 
}



/* unroll-call */
obj_t BGl_unrollzd2callzd2zzinline_recursionz00(BgL_variablez00_bglt BgL_variablez00_12, BgL_nodez00_bglt BgL_nodez00_13, BgL_localz00_bglt BgL_localz00_14, obj_t BgL_kfactorz00_15, BgL_appz00_bglt BgL_callz00_16, obj_t BgL_stackz00_17)
{ AN_OBJECT;
{ /* Inline/recursion.scm 161 */
{ /* Inline/recursion.scm 167 */
obj_t BgL_locz00_1513;
{ /* Inline/recursion.scm 167 */
BgL_nodez00_bglt BgL_obj1550z00_2333;
BgL_obj1550z00_2333 = 
(BgL_nodez00_bglt)(BgL_callz00_16); 
BgL_locz00_1513 = 
(((BgL_nodez00_bglt)CREF(BgL_obj1550z00_2333))->BgL_locz00); } 
{ /* Inline/recursion.scm 167 */
BgL_nodez00_bglt BgL_newzd2callzd2_1514;
{ /* Inline/recursion.scm 168 */
obj_t BgL_arg3121z00_1534;obj_t BgL_arg3122z00_1535;
{ /* Inline/recursion.scm 168 */
obj_t BgL_list3125z00_1536;
{ /* Inline/recursion.scm 168 */
obj_t BgL_auxz00_4192;
BgL_auxz00_4192 = 
(obj_t)(BgL_variablez00_12); 
BgL_list3125z00_1536 = 
MAKE_PAIR(BgL_auxz00_4192, BNIL); } 
BgL_arg3121z00_1534 = BgL_list3125z00_1536; } 
{ /* Inline/recursion.scm 168 */
obj_t BgL_list3128z00_1537;
{ /* Inline/recursion.scm 168 */
obj_t BgL_auxz00_4195;
BgL_auxz00_4195 = 
(obj_t)(BgL_localz00_14); 
BgL_list3128z00_1537 = 
MAKE_PAIR(BgL_auxz00_4195, BNIL); } 
BgL_arg3122z00_1535 = BgL_list3128z00_1537; } 
BgL_newzd2callzd2_1514 = 
BGl_alphatiza7eza7zzast_alphatiza7eza7(BgL_arg3121z00_1534, BgL_arg3122z00_1535, BgL_locz00_1513, 
(BgL_nodez00_bglt)(BgL_callz00_16)); } 
{ /* Inline/recursion.scm 169 */
BgL_nodez00_bglt BgL_newzd2bodyzd2_1516;
{ /* Inline/recursion.scm 172 */
obj_t BgL_arg3112z00_1531;
{ /* Inline/recursion.scm 172 */
obj_t BgL_auxz00_4200;
BgL_auxz00_4200 = 
(obj_t)(BgL_localz00_14); 
BgL_arg3112z00_1531 = 
MAKE_PAIR(BgL_auxz00_4200, BgL_stackz00_17); } 
BgL_newzd2bodyzd2_1516 = 
BGl_inlinezd2appzd2simplez00zzinline_simplez00(BgL_newzd2callzd2_1514, 
(long)CINT(BgL_kfactorz00_15), BgL_arg3112z00_1531, BGl_string4617z00zzinline_recursionz00); } 
{ /* Inline/recursion.scm 170 */

BGl_shrinkzd2argsz12zc0zzinline_variantz00(BgL_variablez00_12); 
{ /* Inline/recursion.scm 181 */
obj_t BgL__z00_1517;
{ /* Inline/recursion.scm 186 */
BgL_nodez00_bglt BgL_arg3093z00_1519;
{ /* Inline/recursion.scm 186 */
obj_t BgL_zc3anonymousza33099ze3z83_3793;
{ 
int BgL_auxz00_4208;int BgL_auxz00_4206;
BgL_auxz00_4208 = 
(int)(((long)2)); 
BgL_auxz00_4206 = 
(int)(((long)1)); 
BgL_zc3anonymousza33099ze3z83_3793 = 
make_fx_procedure(BGl_zc3anonymousza33099ze3z83zzinline_recursionz00, BgL_auxz00_4206, BgL_auxz00_4208); } 
{ /* Inline/recursion.scm 186 */
int BgL_auxz00_4211;
BgL_auxz00_4211 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza33099ze3z83_3793, BgL_auxz00_4211, BgL_locz00_1513); } 
{ /* Inline/recursion.scm 186 */
obj_t BgL_auxz00_4216;int BgL_auxz00_4214;
BgL_auxz00_4216 = 
(obj_t)(BgL_localz00_14); 
BgL_auxz00_4214 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_zc3anonymousza33099ze3z83_3793, BgL_auxz00_4214, BgL_auxz00_4216); } 
BgL_arg3093z00_1519 = 
BGl_nestzd2loopz12zc0zzinline_loopz00(BgL_newzd2bodyzd2_1516, BgL_localz00_14, BgL_zc3anonymousza33099ze3z83_3793); } 
BgL__z00_1517 = 
BGl_nodezd2csez12zc0zzreduce_csez00(BgL_arg3093z00_1519, BNIL); } 
{ /* Inline/recursion.scm 181 */
obj_t BgL_nodez00_1518;
{ /* Inline/recursion.scm 181 */
int BgL_auxz00_4221;
BgL_auxz00_4221 = 
(int)(((long)1)); 
BgL_nodez00_1518 = 
BGL_GET_MVALUES_VAL(BgL_auxz00_4221); } 
return BgL_nodez00_1518;} } } } } } } 
}



/* <anonymous:3099> */
obj_t BGl_zc3anonymousza33099ze3z83zzinline_recursionz00(obj_t BgL_envz00_3794, obj_t BgL_nodez00_3797)
{ AN_OBJECT;
{ /* Inline/recursion.scm 184 */
{ /* Inline/recursion.scm 186 */
obj_t BgL_locz00_3795;obj_t BgL_localz00_3796;
{ /* Inline/recursion.scm 186 */
int BgL_auxz00_4224;
BgL_auxz00_4224 = 
(int)(((long)0)); 
BgL_locz00_3795 = 
PROCEDURE_REF(BgL_envz00_3794, BgL_auxz00_4224); } 
{ /* Inline/recursion.scm 186 */
int BgL_auxz00_4227;
BgL_auxz00_4227 = 
(int)(((long)1)); 
BgL_localz00_3796 = 
PROCEDURE_REF(BgL_envz00_3794, BgL_auxz00_4227); } 
{ 
obj_t BgL_nodez00_1522;
{ /* Inline/recursion.scm 186 */
BgL_letzd2funzd2_bglt BgL_auxz00_4230;
BgL_nodez00_1522 = BgL_nodez00_3797; 
{ /* Inline/recursion.scm 186 */
obj_t BgL_arg3101z00_1524;BgL_typez00_bglt BgL_arg3102z00_1525;obj_t BgL_arg3104z00_1527;obj_t BgL_arg3105z00_1528;
BgL_arg3101z00_1524 = BgL_locz00_3795; 
{ /* Inline/recursion.scm 187 */
BgL_nodez00_bglt BgL_obj1551z00_2340;
BgL_obj1551z00_2340 = 
(BgL_nodez00_bglt)(BgL_nodez00_1522); 
BgL_arg3102z00_1525 = 
(((BgL_nodez00_bglt)CREF(BgL_obj1551z00_2340))->BgL_typez00); } 
{ /* Inline/recursion.scm 189 */
obj_t BgL_list3109z00_1529;
BgL_list3109z00_1529 = 
MAKE_PAIR(BgL_localz00_3796, BNIL); 
BgL_arg3104z00_1527 = BgL_list3109z00_1529; } 
BgL_arg3105z00_1528 = BgL_nodez00_1522; 
{ /* Inline/recursion.scm 185 */
BgL_letzd2funzd2_bglt BgL_res3990z00_2370;
{ /* Inline/recursion.scm 185 */
obj_t BgL_key2450z00_2346;BgL_nodez00_bglt BgL_body2452z00_2348;
BgL_key2450z00_2346 = 
BINT(((long)-1)); 
BgL_body2452z00_2348 = 
(BgL_nodez00_bglt)(BgL_arg3105z00_1528); 
{ /* Inline/recursion.scm 185 */
BgL_letzd2funzd2_bglt BgL_new2453z00_2349;
{ /* Inline/recursion.scm 185 */
BgL_letzd2funzd2_bglt BgL_res3988z00_2355;
{ /* Inline/recursion.scm 185 */
BgL_letzd2funzd2_bglt BgL_new2455z00_2350;
BgL_new2455z00_2350 = 
((BgL_letzd2funzd2_bglt)BREF( GC_MALLOC ( sizeof(struct BgL_letzd2funzd2_bgl) ))); 
{ /* Inline/recursion.scm 185 */
long BgL_arg3283z00_2351;
BgL_arg3283z00_2351 = 
BGl_classzd2numzd2zz__objectz00(BGl_letzd2funzd2zzast_nodez00); 
{ /* Inline/recursion.scm 185 */
BgL_objectz00_bglt BgL_auxz00_4238;
BgL_auxz00_4238 = 
(BgL_objectz00_bglt)(BgL_new2455z00_2350); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4238, BgL_arg3283z00_2351); } } 
{ /* Inline/recursion.scm 185 */
BgL_objectz00_bglt BgL_auxz00_4241;
BgL_auxz00_4241 = 
(BgL_objectz00_bglt)(BgL_new2455z00_2350); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4241, BFALSE); } 
{ /* Inline/recursion.scm 185 */
obj_t BgL_auxz00_4244;
BgL_auxz00_4244 = 
(obj_t)(BgL_new2455z00_2350); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4244); } BUNSPEC; 
BgL_res3988z00_2355 = BgL_new2455z00_2350; } 
BgL_new2453z00_2349 = BgL_res3988z00_2355; } 
{ /* Inline/recursion.scm 185 */
BgL_letzd2funzd2_bglt BgL_res3989z00_2369;
((((BgL_letzd2funzd2_bglt)CREF(BgL_new2453z00_2349))->BgL_locz00) = ((obj_t)BgL_arg3101z00_1524), BUNSPEC); 
((((BgL_letzd2funzd2_bglt)CREF(BgL_new2453z00_2349))->BgL_typez00) = ((BgL_typez00_bglt)BgL_arg3102z00_1525), BUNSPEC); 
((((BgL_letzd2funzd2_bglt)CREF(BgL_new2453z00_2349))->BgL_sidezd2effectzf3z21) = ((obj_t)BUNSPEC), BUNSPEC); 
((((BgL_letzd2funzd2_bglt)CREF(BgL_new2453z00_2349))->BgL_keyz00) = ((obj_t)BgL_key2450z00_2346), BUNSPEC); 
((((BgL_letzd2funzd2_bglt)CREF(BgL_new2453z00_2349))->BgL_localsz00) = ((obj_t)BgL_arg3104z00_1527), BUNSPEC); 
((((BgL_letzd2funzd2_bglt)CREF(BgL_new2453z00_2349))->BgL_bodyz00) = ((BgL_nodez00_bglt)BgL_body2452z00_2348), BUNSPEC); 
BgL_res3989z00_2369 = BgL_new2453z00_2349; BgL_res3989z00_2369; } 
BgL_res3990z00_2370 = BgL_new2453z00_2349; } } 
BgL_auxz00_4230 = BgL_res3990z00_2370; } } 
return 
(obj_t)(BgL_auxz00_4230);} } } } 
}



/* is-recursive? */
bool_t BGl_iszd2recursivezf3z21zzinline_recursionz00(BgL_variablez00_bglt BgL_varz00_18)
{ AN_OBJECT;
{ /* Inline/recursion.scm 196 */
{ /* Inline/recursion.scm 198 */
BgL_valuez00_bglt BgL_sfunz00_1538;
BgL_sfunz00_1538 = 
(((BgL_variablez00_bglt)CREF(BgL_varz00_18))->BgL_valuez00); 
{ /* Inline/recursion.scm 199 */
bool_t BgL_test3131z00_1539;
BgL_test3131z00_1539 = 
BGl_iszd2azf3z21zz__objectz00(
(obj_t)(BgL_sfunz00_1538), BGl_isfunz00zzinline_inlinez00); 
if(BgL_test3131z00_1539)
{ /* Inline/recursion.scm 205 */
bool_t BgL_testz00_4258;
{ /* Inline/recursion.scm 206 */
obj_t BgL_auxz00_4259;
{ /* Inline/recursion.scm 206 */
BgL_isfunz00_bglt BgL_obj2685z00_2374;
BgL_obj2685z00_2374 = 
(BgL_isfunz00_bglt)(BgL_sfunz00_1538); 
{ 
obj_t BgL_auxz00_4261;
{ /* Inline/recursion.scm 206 */
BgL_objectz00_bglt BgL_auxz00_4262;
BgL_auxz00_4262 = 
(BgL_objectz00_bglt)(BgL_obj2685z00_2374); 
BgL_auxz00_4261 = 
BGL_OBJECT_WIDENING(BgL_auxz00_4262); } 
BgL_auxz00_4259 = 
(((BgL_isfunz00_bglt)CREF(BgL_auxz00_4261))->BgL_recursivezd2callszd2); } } 
BgL_testz00_4258 = 
PAIRP(BgL_auxz00_4259); } 
if(BgL_testz00_4258)
{ /* Inline/recursion.scm 205 */
return ((bool_t)1);}  else 
{ /* Inline/recursion.scm 210 */
bool_t BgL_testz00_4267;
{ /* Inline/recursion.scm 211 */
obj_t BgL_auxz00_4268;
{ /* Inline/recursion.scm 208 */
BgL_isfunz00_bglt BgL_obj2685z00_2376;
BgL_obj2685z00_2376 = 
(BgL_isfunz00_bglt)(BgL_sfunz00_1538); 
{ 
obj_t BgL_auxz00_4270;
{ /* Inline/recursion.scm 208 */
BgL_objectz00_bglt BgL_auxz00_4271;
BgL_auxz00_4271 = 
(BgL_objectz00_bglt)(BgL_obj2685z00_2376); 
BgL_auxz00_4270 = 
BGL_OBJECT_WIDENING(BgL_auxz00_4271); } 
BgL_auxz00_4268 = 
(((BgL_isfunz00_bglt)CREF(BgL_auxz00_4270))->BgL_recursivezd2callszd2); } } 
BgL_testz00_4267 = 
NULLP(BgL_auxz00_4268); } 
if(BgL_testz00_4267)
{ /* Inline/recursion.scm 210 */
return ((bool_t)0);}  else 
{ /* Inline/recursion.scm 210 */
{ /* Inline/recursion.scm 211 */
obj_t BgL_callsz00_1542;
{ /* Inline/recursion.scm 211 */
BgL_nodez00_bglt BgL_arg3137z00_1543;
{ /* Inline/recursion.scm 211 */
BgL_isfunz00_bglt BgL_obj2684z00_2378;
BgL_obj2684z00_2378 = 
(BgL_isfunz00_bglt)(BgL_sfunz00_1538); 
{ 
obj_t BgL_auxz00_4277;
{ /* Inline/recursion.scm 211 */
BgL_objectz00_bglt BgL_auxz00_4278;
BgL_auxz00_4278 = 
(BgL_objectz00_bglt)(BgL_obj2684z00_2378); 
BgL_auxz00_4277 = 
BGL_OBJECT_WIDENING(BgL_auxz00_4278); } 
BgL_arg3137z00_1543 = 
(((BgL_isfunz00_bglt)CREF(BgL_auxz00_4277))->BgL_originalzd2bodyzd2); } } 
{ /* Inline/recursion.scm 211 */
obj_t BgL_method2819z00_2381;
{ /* Inline/recursion.scm 211 */
long BgL_objzd2classzd2numz00_2383;
{ /* Inline/recursion.scm 211 */
BgL_objectz00_bglt BgL_auxz00_4282;
BgL_auxz00_4282 = 
(BgL_objectz00_bglt)(BgL_arg3137z00_1543); 
BgL_objzd2classzd2numz00_2383 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4282); } 
{ /* Inline/recursion.scm 211 */
obj_t BgL_arg1904z00_2384;
{ /* Inline/recursion.scm 211 */
int BgL_auxz00_4285;
BgL_auxz00_4285 = 
(int)(((long)1)); 
BgL_arg1904z00_2384 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_4285); } 
{ /* Inline/recursion.scm 211 */
long BgL_offsetz00_2388;
{ /* Inline/recursion.scm 211 */
long BgL_auxz00_4288;
{ /* Inline/recursion.scm 211 */
int BgL_auxz00_4289;
BgL_auxz00_4289 = 
(int)(BgL_objzd2classzd2numz00_2383); 
BgL_auxz00_4288 = 
(long)(BgL_auxz00_4289); } 
BgL_offsetz00_2388 = 
(BgL_auxz00_4288-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 211 */
long BgL_modz00_2389;
{ /* Inline/recursion.scm 211 */
long BgL_auxz00_4293;
{ /* Inline/recursion.scm 211 */
int BgL_auxz00_4294;
BgL_auxz00_4294 = 
(int)(((long)8)); 
BgL_auxz00_4293 = 
(long)(BgL_auxz00_4294); } 
BgL_modz00_2389 = 
(BgL_offsetz00_2388/BgL_auxz00_4293); } 
{ /* Inline/recursion.scm 211 */
long BgL_restz00_2391;
{ /* Inline/recursion.scm 211 */
long BgL_auxz00_4298;
{ /* Inline/recursion.scm 211 */
int BgL_auxz00_4299;
BgL_auxz00_4299 = 
(int)(((long)8)); 
BgL_auxz00_4298 = 
(long)(BgL_auxz00_4299); } 
BgL_restz00_2391 = 
(BgL_offsetz00_2388%BgL_auxz00_4298); } 
{ /* Inline/recursion.scm 211 */

{ /* Inline/recursion.scm 211 */
obj_t BgL_bucketz00_2393;
{ /* Inline/recursion.scm 211 */
int BgL_kz00_2403;
BgL_kz00_2403 = 
(int)(BgL_modz00_2389); 
BgL_bucketz00_2393 = 
VECTOR_REF(BgL_arg1904z00_2384,BgL_kz00_2403); } 
{ /* Inline/recursion.scm 211 */
int BgL_kz00_2405;
BgL_kz00_2405 = 
(int)(BgL_restz00_2391); 
BgL_method2819z00_2381 = 
VECTOR_REF(BgL_bucketz00_2393,BgL_kz00_2405); } } } } } } } } 
BgL_callsz00_1542 = 
PROCEDURE_ENTRY(BgL_method2819z00_2381)(BgL_method2819z00_2381, 
(obj_t)(BgL_arg3137z00_1543), 
(obj_t)(BgL_varz00_18), BEOA); } } 
{ /* Inline/recursion.scm 213 */
BgL_isfunz00_bglt BgL_obj2687z00_2406;
BgL_obj2687z00_2406 = 
(BgL_isfunz00_bglt)(BgL_sfunz00_1538); 
{ 
obj_t BgL_auxz00_4312;
{ /* Inline/recursion.scm 213 */
BgL_objectz00_bglt BgL_auxz00_4313;
BgL_auxz00_4313 = 
(BgL_objectz00_bglt)(BgL_obj2687z00_2406); 
BgL_auxz00_4312 = 
BGL_OBJECT_WIDENING(BgL_auxz00_4313); } 
((((BgL_isfunz00_bglt)CREF(BgL_auxz00_4312))->BgL_recursivezd2callszd2) = ((obj_t)BgL_callsz00_1542), BUNSPEC); } } 
return 
PAIRP(BgL_callsz00_1542);} } } }  else 
{ /* Inline/recursion.scm 200 */
obj_t BgL_callsz00_1546;
{ /* Inline/recursion.scm 200 */
BgL_nodez00_bglt BgL_nodez00_2410;
{ /* Inline/recursion.scm 200 */
obj_t BgL_auxz00_4318;
{ /* Inline/recursion.scm 200 */
BgL_sfunz00_bglt BgL_obj1373z00_2409;
BgL_obj1373z00_2409 = 
(BgL_sfunz00_bglt)(BgL_sfunz00_1538); 
BgL_auxz00_4318 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1373z00_2409))->BgL_bodyz00); } 
BgL_nodez00_2410 = 
(BgL_nodez00_bglt)(BgL_auxz00_4318); } 
{ /* Inline/recursion.scm 200 */
obj_t BgL_method2819z00_2412;
{ /* Inline/recursion.scm 200 */
long BgL_objzd2classzd2numz00_2414;
{ /* Inline/recursion.scm 200 */
BgL_objectz00_bglt BgL_auxz00_4322;
BgL_auxz00_4322 = 
(BgL_objectz00_bglt)(BgL_nodez00_2410); 
BgL_objzd2classzd2numz00_2414 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4322); } 
{ /* Inline/recursion.scm 200 */
obj_t BgL_arg1904z00_2415;
{ /* Inline/recursion.scm 200 */
int BgL_auxz00_4325;
BgL_auxz00_4325 = 
(int)(((long)1)); 
BgL_arg1904z00_2415 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_4325); } 
{ /* Inline/recursion.scm 200 */
long BgL_offsetz00_2419;
{ /* Inline/recursion.scm 200 */
long BgL_auxz00_4328;
{ /* Inline/recursion.scm 200 */
int BgL_auxz00_4329;
BgL_auxz00_4329 = 
(int)(BgL_objzd2classzd2numz00_2414); 
BgL_auxz00_4328 = 
(long)(BgL_auxz00_4329); } 
BgL_offsetz00_2419 = 
(BgL_auxz00_4328-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 200 */
long BgL_modz00_2420;
{ /* Inline/recursion.scm 200 */
long BgL_auxz00_4333;
{ /* Inline/recursion.scm 200 */
int BgL_auxz00_4334;
BgL_auxz00_4334 = 
(int)(((long)8)); 
BgL_auxz00_4333 = 
(long)(BgL_auxz00_4334); } 
BgL_modz00_2420 = 
(BgL_offsetz00_2419/BgL_auxz00_4333); } 
{ /* Inline/recursion.scm 200 */
long BgL_restz00_2422;
{ /* Inline/recursion.scm 200 */
long BgL_auxz00_4338;
{ /* Inline/recursion.scm 200 */
int BgL_auxz00_4339;
BgL_auxz00_4339 = 
(int)(((long)8)); 
BgL_auxz00_4338 = 
(long)(BgL_auxz00_4339); } 
BgL_restz00_2422 = 
(BgL_offsetz00_2419%BgL_auxz00_4338); } 
{ /* Inline/recursion.scm 200 */

{ /* Inline/recursion.scm 200 */
obj_t BgL_bucketz00_2424;
{ /* Inline/recursion.scm 200 */
int BgL_kz00_2434;
BgL_kz00_2434 = 
(int)(BgL_modz00_2420); 
BgL_bucketz00_2424 = 
VECTOR_REF(BgL_arg1904z00_2415,BgL_kz00_2434); } 
{ /* Inline/recursion.scm 200 */
int BgL_kz00_2436;
BgL_kz00_2436 = 
(int)(BgL_restz00_2422); 
BgL_method2819z00_2412 = 
VECTOR_REF(BgL_bucketz00_2424,BgL_kz00_2436); } } } } } } } } 
BgL_callsz00_1546 = 
PROCEDURE_ENTRY(BgL_method2819z00_2412)(BgL_method2819z00_2412, 
(obj_t)(BgL_nodez00_2410), 
(obj_t)(BgL_varz00_18), BEOA); } } 
{ /* Inline/recursion.scm 201 */
BgL_isfunz00_bglt BgL_obj2802z00_1547;
BgL_obj2802z00_1547 = 
((BgL_isfunz00_bglt)BgL_sfunz00_1538); 
{ /* Inline/recursion.scm 202 */
BgL_isfunz00_bglt BgL_arg3149z00_1548;
{ /* Inline/recursion.scm 202 */
obj_t BgL_arg3153z00_1550;
BgL_arg3153z00_1550 = BgL_callsz00_1546; 
{ /* Inline/recursion.scm 201 */
BgL_isfunz00_bglt BgL_res3996z00_2447;
{ /* Inline/recursion.scm 201 */
BgL_nodez00_bglt BgL_originalzd2body2655zd2_2438;
{ /* Inline/recursion.scm 201 */
obj_t BgL_auxz00_4352;
{ /* Inline/recursion.scm 202 */
BgL_sfunz00_bglt BgL_obj1373z00_2437;
BgL_obj1373z00_2437 = 
(BgL_sfunz00_bglt)(BgL_sfunz00_1538); 
BgL_auxz00_4352 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1373z00_2437))->BgL_bodyz00); } 
BgL_originalzd2body2655zd2_2438 = 
(BgL_nodez00_bglt)(BgL_auxz00_4352); } 
{ /* Inline/recursion.scm 201 */
BgL_isfunz00_bglt BgL_new2657z00_2440;
BgL_new2657z00_2440 = 
((BgL_isfunz00_bglt)BREF( GC_MALLOC (sizeof(struct BgL_isfunz00_bgl)))); 
{ /* Inline/recursion.scm 201 */
BgL_isfunz00_bglt BgL_res3995z00_2446;
((((BgL_isfunz00_bglt)CREF(BgL_new2657z00_2440))->BgL_originalzd2bodyzd2) = ((BgL_nodez00_bglt)BgL_originalzd2body2655zd2_2438), BUNSPEC); 
((((BgL_isfunz00_bglt)CREF(BgL_new2657z00_2440))->BgL_recursivezd2callszd2) = ((obj_t)BgL_arg3153z00_1550), BUNSPEC); 
BgL_res3995z00_2446 = BgL_new2657z00_2440; BgL_res3995z00_2446; } 
BgL_res3996z00_2447 = BgL_new2657z00_2440; } } 
BgL_arg3149z00_1548 = BgL_res3996z00_2447; } } 
{ /* Inline/recursion.scm 201 */
obj_t BgL_auxz00_4361;BgL_objectz00_bglt BgL_auxz00_4359;
BgL_auxz00_4361 = 
(obj_t)(BgL_arg3149z00_1548); 
BgL_auxz00_4359 = 
(BgL_objectz00_bglt)(BgL_obj2802z00_1547); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4359, BgL_auxz00_4361); } } 
{ /* Inline/recursion.scm 201 */
long BgL_arg3157z00_1551;
BgL_arg3157z00_1551 = 
BGl_classzd2numzd2zz__objectz00(BGl_isfunz00zzinline_inlinez00); 
{ /* Inline/recursion.scm 201 */
BgL_objectz00_bglt BgL_auxz00_4365;
BgL_auxz00_4365 = 
(BgL_objectz00_bglt)(BgL_obj2802z00_1547); 
BGL_OBJECT_CLASS_NUM_SET(BgL_auxz00_4365, BgL_arg3157z00_1551); } } 
{ /* Inline/recursion.scm 201 */
obj_t BgL_auxz00_4368;
BgL_auxz00_4368 = 
(obj_t)(BgL_obj2802z00_1547); 
BGL_HEAP_DEBUG_MARK_OBJ(BgL_auxz00_4368); } BUNSPEC; BgL_obj2802z00_1547; } 
return 
PAIRP(BgL_callsz00_1546);} } } } 
}



/* _is-recursive?4063 */
obj_t BGl__iszd2recursivezf34063z21zzinline_recursionz00(obj_t BgL_envz00_3798, obj_t BgL_varz00_3799)
{ AN_OBJECT;
{ /* Inline/recursion.scm 196 */
{ /* Inline/recursion.scm 197 */
bool_t BgL_auxz00_4372;
BgL_auxz00_4372 = 
BGl_iszd2recursivezf3z21zzinline_recursionz00(
(BgL_variablez00_bglt)(BgL_varz00_3799)); 
return 
BBOOL(BgL_auxz00_4372);} } 
}



/* find-recursive-calls* */
obj_t BGl_findzd2recursivezd2callsza2za2zzinline_recursionz00(obj_t BgL_nodeza2za2_57, obj_t BgL_varz00_58)
{ AN_OBJECT;
{ /* Inline/recursion.scm 365 */
{ 
obj_t BgL_nodeza2za2_1553;obj_t BgL_callsz00_1554;
BgL_nodeza2za2_1553 = BgL_nodeza2za2_57; 
BgL_callsz00_1554 = BNIL; 
BgL_loopz00_1555:
if(
NULLP(BgL_nodeza2za2_1553))
{ /* Inline/recursion.scm 368 */
return BgL_callsz00_1554;}  else 
{ /* Inline/recursion.scm 370 */
obj_t BgL_arg3171z00_1557;obj_t BgL_arg3172z00_1558;
BgL_arg3171z00_1557 = 
CDR(BgL_nodeza2za2_1553); 
{ /* Inline/recursion.scm 371 */
obj_t BgL_arg3176z00_1559;
{ /* Inline/recursion.scm 371 */
BgL_nodez00_bglt BgL_nodez00_2455;BgL_variablez00_bglt BgL_varz00_2456;
{ /* Inline/recursion.scm 371 */
obj_t BgL_auxz00_4379;
BgL_auxz00_4379 = 
CAR(BgL_nodeza2za2_1553); 
BgL_nodez00_2455 = 
(BgL_nodez00_bglt)(BgL_auxz00_4379); } 
BgL_varz00_2456 = 
(BgL_variablez00_bglt)(BgL_varz00_58); 
{ /* Inline/recursion.scm 371 */
obj_t BgL_method2819z00_2457;
{ /* Inline/recursion.scm 371 */
long BgL_objzd2classzd2numz00_2459;
{ /* Inline/recursion.scm 371 */
BgL_objectz00_bglt BgL_auxz00_4383;
BgL_auxz00_4383 = 
(BgL_objectz00_bglt)(BgL_nodez00_2455); 
BgL_objzd2classzd2numz00_2459 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4383); } 
{ /* Inline/recursion.scm 371 */
obj_t BgL_arg1904z00_2460;
{ /* Inline/recursion.scm 371 */
int BgL_auxz00_4386;
BgL_auxz00_4386 = 
(int)(((long)1)); 
BgL_arg1904z00_2460 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_4386); } 
{ /* Inline/recursion.scm 371 */
long BgL_offsetz00_2464;
{ /* Inline/recursion.scm 371 */
long BgL_auxz00_4389;
{ /* Inline/recursion.scm 371 */
int BgL_auxz00_4390;
BgL_auxz00_4390 = 
(int)(BgL_objzd2classzd2numz00_2459); 
BgL_auxz00_4389 = 
(long)(BgL_auxz00_4390); } 
BgL_offsetz00_2464 = 
(BgL_auxz00_4389-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 371 */
long BgL_modz00_2465;
{ /* Inline/recursion.scm 371 */
long BgL_auxz00_4394;
{ /* Inline/recursion.scm 371 */
int BgL_auxz00_4395;
BgL_auxz00_4395 = 
(int)(((long)8)); 
BgL_auxz00_4394 = 
(long)(BgL_auxz00_4395); } 
BgL_modz00_2465 = 
(BgL_offsetz00_2464/BgL_auxz00_4394); } 
{ /* Inline/recursion.scm 371 */
long BgL_restz00_2467;
{ /* Inline/recursion.scm 371 */
long BgL_auxz00_4399;
{ /* Inline/recursion.scm 371 */
int BgL_auxz00_4400;
BgL_auxz00_4400 = 
(int)(((long)8)); 
BgL_auxz00_4399 = 
(long)(BgL_auxz00_4400); } 
BgL_restz00_2467 = 
(BgL_offsetz00_2464%BgL_auxz00_4399); } 
{ /* Inline/recursion.scm 371 */

{ /* Inline/recursion.scm 371 */
obj_t BgL_bucketz00_2469;
{ /* Inline/recursion.scm 371 */
int BgL_kz00_2479;
BgL_kz00_2479 = 
(int)(BgL_modz00_2465); 
BgL_bucketz00_2469 = 
VECTOR_REF(BgL_arg1904z00_2460,BgL_kz00_2479); } 
{ /* Inline/recursion.scm 371 */
int BgL_kz00_2481;
BgL_kz00_2481 = 
(int)(BgL_restz00_2467); 
BgL_method2819z00_2457 = 
VECTOR_REF(BgL_bucketz00_2469,BgL_kz00_2481); } } } } } } } } 
BgL_arg3176z00_1559 = 
PROCEDURE_ENTRY(BgL_method2819z00_2457)(BgL_method2819z00_2457, 
(obj_t)(BgL_nodez00_2455), 
(obj_t)(BgL_varz00_2456), BEOA); } } 
BgL_arg3172z00_1558 = 
bgl_append2(BgL_arg3176z00_1559, BgL_callsz00_1554); } 
{ 
obj_t BgL_callsz00_4414;obj_t BgL_nodeza2za2_4413;
BgL_nodeza2za2_4413 = BgL_arg3171z00_1557; 
BgL_callsz00_4414 = BgL_arg3172z00_1558; 
BgL_callsz00_1554 = BgL_callsz00_4414; 
BgL_nodeza2za2_1553 = BgL_nodeza2za2_4413; 
goto BgL_loopz00_1555;} } } } 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzinline_recursionz00()
{ AN_OBJECT;
{ /* Inline/recursion.scm 15 */
BGl_addzd2genericz12zc0zz__objectz00(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BGl_findzd2recursivezd2callszd2default2818zd2envz00zzinline_recursionz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BGl_sequencez00zzast_nodez00, BGl_proc4618z00zzinline_recursionz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BGl_appz00zzast_nodez00, BGl_proc4619z00zzinline_recursionz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BGl_appzd2lyzd2zzast_nodez00, BGl_proc4620z00zzinline_recursionz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BGl_funcallz00zzast_nodez00, BGl_proc4621z00zzinline_recursionz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BGl_externz00zzast_nodez00, BGl_proc4622z00zzinline_recursionz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BGl_castz00zzast_nodez00, BGl_proc4623z00zzinline_recursionz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BGl_setqz00zzast_nodez00, BGl_proc4624z00zzinline_recursionz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BGl_conditionalz00zzast_nodez00, BGl_proc4625z00zzinline_recursionz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BGl_failz00zzast_nodez00, BGl_proc4626z00zzinline_recursionz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BGl_selectz00zzast_nodez00, BGl_proc4627z00zzinline_recursionz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BGl_letzd2funzd2zzast_nodez00, BGl_proc4628z00zzinline_recursionz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BGl_letzd2varzd2zzast_nodez00, BGl_proc4629z00zzinline_recursionz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc4630z00zzinline_recursionz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc4631z00zzinline_recursionz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BGl_makezd2boxzd2zzast_nodez00, BGl_proc4632z00zzinline_recursionz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BGl_boxzd2refzd2zzast_nodez00, BGl_proc4633z00zzinline_recursionz00); 
return 
BGl_addzd2methodz12zc0zz__objectz00(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc4634z00zzinline_recursionz00);} 
}



/* find-recursive-calls-box-set!2854 */
obj_t BGl_findzd2recursivezd2callszd2boxzd2setz122854z12zzinline_recursionz00(obj_t BgL_envz00_3820, obj_t BgL_nodez00_3821, obj_t BgL_vz00_3822)
{ AN_OBJECT;
{ /* Inline/recursion.scm 358 */
{ 
BgL_boxzd2setz12zc0_bglt BgL_nodez00_2146;obj_t BgL_vz00_2147;
BgL_nodez00_2146 = 
(BgL_boxzd2setz12zc0_bglt)(BgL_nodez00_3821); 
BgL_vz00_2147 = BgL_vz00_3822; 
{ /* Inline/recursion.scm 360 */
obj_t BgL_arg3937z00_2151;obj_t BgL_arg3938z00_2152;
{ /* Inline/recursion.scm 360 */
BgL_nodez00_bglt BgL_nodez00_3709;BgL_variablez00_bglt BgL_varz00_3710;
{ /* Inline/recursion.scm 360 */
BgL_varz00_bglt BgL_auxz00_4433;
BgL_auxz00_4433 = 
(((BgL_boxzd2setz12zc0_bglt)CREF(BgL_nodez00_2146))->BgL_varz00); 
BgL_nodez00_3709 = 
(BgL_nodez00_bglt)(BgL_auxz00_4433); } 
BgL_varz00_3710 = 
(BgL_variablez00_bglt)(BgL_vz00_2147); 
{ /* Inline/recursion.scm 360 */
obj_t BgL_method2819z00_3711;
{ /* Inline/recursion.scm 360 */
long BgL_objzd2classzd2numz00_3713;
{ /* Inline/recursion.scm 360 */
BgL_objectz00_bglt BgL_auxz00_4437;
BgL_auxz00_4437 = 
(BgL_objectz00_bglt)(BgL_nodez00_3709); 
BgL_objzd2classzd2numz00_3713 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4437); } 
{ /* Inline/recursion.scm 360 */
obj_t BgL_arg1904z00_3714;
{ /* Inline/recursion.scm 360 */
int BgL_auxz00_4440;
BgL_auxz00_4440 = 
(int)(((long)1)); 
BgL_arg1904z00_3714 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_4440); } 
{ /* Inline/recursion.scm 360 */
long BgL_offsetz00_3718;
{ /* Inline/recursion.scm 360 */
long BgL_auxz00_4443;
{ /* Inline/recursion.scm 360 */
int BgL_auxz00_4444;
BgL_auxz00_4444 = 
(int)(BgL_objzd2classzd2numz00_3713); 
BgL_auxz00_4443 = 
(long)(BgL_auxz00_4444); } 
BgL_offsetz00_3718 = 
(BgL_auxz00_4443-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 360 */
long BgL_modz00_3719;
{ /* Inline/recursion.scm 360 */
long BgL_auxz00_4448;
{ /* Inline/recursion.scm 360 */
int BgL_auxz00_4449;
BgL_auxz00_4449 = 
(int)(((long)8)); 
BgL_auxz00_4448 = 
(long)(BgL_auxz00_4449); } 
BgL_modz00_3719 = 
(BgL_offsetz00_3718/BgL_auxz00_4448); } 
{ /* Inline/recursion.scm 360 */
long BgL_restz00_3721;
{ /* Inline/recursion.scm 360 */
long BgL_auxz00_4453;
{ /* Inline/recursion.scm 360 */
int BgL_auxz00_4454;
BgL_auxz00_4454 = 
(int)(((long)8)); 
BgL_auxz00_4453 = 
(long)(BgL_auxz00_4454); } 
BgL_restz00_3721 = 
(BgL_offsetz00_3718%BgL_auxz00_4453); } 
{ /* Inline/recursion.scm 360 */

{ /* Inline/recursion.scm 360 */
obj_t BgL_bucketz00_3723;
{ /* Inline/recursion.scm 360 */
int BgL_kz00_3733;
BgL_kz00_3733 = 
(int)(BgL_modz00_3719); 
BgL_bucketz00_3723 = 
VECTOR_REF(BgL_arg1904z00_3714,BgL_kz00_3733); } 
{ /* Inline/recursion.scm 360 */
int BgL_kz00_3735;
BgL_kz00_3735 = 
(int)(BgL_restz00_3721); 
BgL_method2819z00_3711 = 
VECTOR_REF(BgL_bucketz00_3723,BgL_kz00_3735); } } } } } } } } 
BgL_arg3937z00_2151 = 
PROCEDURE_ENTRY(BgL_method2819z00_3711)(BgL_method2819z00_3711, 
(obj_t)(BgL_nodez00_3709), 
(obj_t)(BgL_varz00_3710), BEOA); } } 
{ /* Inline/recursion.scm 360 */
BgL_nodez00_bglt BgL_arg3946z00_2154;
BgL_arg3946z00_2154 = 
(((BgL_boxzd2setz12zc0_bglt)CREF(BgL_nodez00_2146))->BgL_valuez00); 
{ /* Inline/recursion.scm 360 */
BgL_variablez00_bglt BgL_varz00_3738;
BgL_varz00_3738 = 
(BgL_variablez00_bglt)(BgL_vz00_2147); 
{ /* Inline/recursion.scm 360 */
obj_t BgL_method2819z00_3739;
{ /* Inline/recursion.scm 360 */
long BgL_objzd2classzd2numz00_3741;
{ /* Inline/recursion.scm 360 */
BgL_objectz00_bglt BgL_auxz00_4468;
BgL_auxz00_4468 = 
(BgL_objectz00_bglt)(BgL_arg3946z00_2154); 
BgL_objzd2classzd2numz00_3741 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4468); } 
{ /* Inline/recursion.scm 360 */
obj_t BgL_arg1904z00_3742;
{ /* Inline/recursion.scm 360 */
int BgL_auxz00_4471;
BgL_auxz00_4471 = 
(int)(((long)1)); 
BgL_arg1904z00_3742 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_4471); } 
{ /* Inline/recursion.scm 360 */
long BgL_offsetz00_3746;
{ /* Inline/recursion.scm 360 */
long BgL_auxz00_4474;
{ /* Inline/recursion.scm 360 */
int BgL_auxz00_4475;
BgL_auxz00_4475 = 
(int)(BgL_objzd2classzd2numz00_3741); 
BgL_auxz00_4474 = 
(long)(BgL_auxz00_4475); } 
BgL_offsetz00_3746 = 
(BgL_auxz00_4474-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 360 */
long BgL_modz00_3747;
{ /* Inline/recursion.scm 360 */
long BgL_auxz00_4479;
{ /* Inline/recursion.scm 360 */
int BgL_auxz00_4480;
BgL_auxz00_4480 = 
(int)(((long)8)); 
BgL_auxz00_4479 = 
(long)(BgL_auxz00_4480); } 
BgL_modz00_3747 = 
(BgL_offsetz00_3746/BgL_auxz00_4479); } 
{ /* Inline/recursion.scm 360 */
long BgL_restz00_3749;
{ /* Inline/recursion.scm 360 */
long BgL_auxz00_4484;
{ /* Inline/recursion.scm 360 */
int BgL_auxz00_4485;
BgL_auxz00_4485 = 
(int)(((long)8)); 
BgL_auxz00_4484 = 
(long)(BgL_auxz00_4485); } 
BgL_restz00_3749 = 
(BgL_offsetz00_3746%BgL_auxz00_4484); } 
{ /* Inline/recursion.scm 360 */

{ /* Inline/recursion.scm 360 */
obj_t BgL_bucketz00_3751;
{ /* Inline/recursion.scm 360 */
int BgL_kz00_3761;
BgL_kz00_3761 = 
(int)(BgL_modz00_3747); 
BgL_bucketz00_3751 = 
VECTOR_REF(BgL_arg1904z00_3742,BgL_kz00_3761); } 
{ /* Inline/recursion.scm 360 */
int BgL_kz00_3763;
BgL_kz00_3763 = 
(int)(BgL_restz00_3749); 
BgL_method2819z00_3739 = 
VECTOR_REF(BgL_bucketz00_3751,BgL_kz00_3763); } } } } } } } } 
BgL_arg3938z00_2152 = 
PROCEDURE_ENTRY(BgL_method2819z00_3739)(BgL_method2819z00_3739, 
(obj_t)(BgL_arg3946z00_2154), 
(obj_t)(BgL_varz00_3738), BEOA); } } } 
return 
bgl_append2(BgL_arg3937z00_2151, BgL_arg3938z00_2152);} } } 
}



/* find-recursive-calls-box-ref2852 */
obj_t BGl_findzd2recursivezd2callszd2boxzd2ref2852z00zzinline_recursionz00(obj_t BgL_envz00_3823, obj_t BgL_nodez00_3824, obj_t BgL_varz00_3825)
{ AN_OBJECT;
{ /* Inline/recursion.scm 352 */
{ 
BgL_boxzd2refzd2_bglt BgL_nodez00_2139;obj_t BgL_varz00_2140;
BgL_nodez00_2139 = 
(BgL_boxzd2refzd2_bglt)(BgL_nodez00_3824); 
BgL_varz00_2140 = BgL_varz00_3825; 
{ /* Inline/recursion.scm 353 */
BgL_nodez00_bglt BgL_nodez00_3681;BgL_variablez00_bglt BgL_varz00_3682;
{ /* Inline/recursion.scm 353 */
BgL_varz00_bglt BgL_auxz00_4499;
BgL_auxz00_4499 = 
(((BgL_boxzd2refzd2_bglt)CREF(BgL_nodez00_2139))->BgL_varz00); 
BgL_nodez00_3681 = 
(BgL_nodez00_bglt)(BgL_auxz00_4499); } 
BgL_varz00_3682 = 
(BgL_variablez00_bglt)(BgL_varz00_2140); 
{ /* Inline/recursion.scm 353 */
obj_t BgL_method2819z00_3683;
{ /* Inline/recursion.scm 353 */
long BgL_objzd2classzd2numz00_3685;
{ /* Inline/recursion.scm 353 */
BgL_objectz00_bglt BgL_auxz00_4503;
BgL_auxz00_4503 = 
(BgL_objectz00_bglt)(BgL_nodez00_3681); 
BgL_objzd2classzd2numz00_3685 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4503); } 
{ /* Inline/recursion.scm 353 */
obj_t BgL_arg1904z00_3686;
{ /* Inline/recursion.scm 353 */
int BgL_auxz00_4506;
BgL_auxz00_4506 = 
(int)(((long)1)); 
BgL_arg1904z00_3686 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_4506); } 
{ /* Inline/recursion.scm 353 */
long BgL_offsetz00_3690;
{ /* Inline/recursion.scm 353 */
long BgL_auxz00_4509;
{ /* Inline/recursion.scm 353 */
int BgL_auxz00_4510;
BgL_auxz00_4510 = 
(int)(BgL_objzd2classzd2numz00_3685); 
BgL_auxz00_4509 = 
(long)(BgL_auxz00_4510); } 
BgL_offsetz00_3690 = 
(BgL_auxz00_4509-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 353 */
long BgL_modz00_3691;
{ /* Inline/recursion.scm 353 */
long BgL_auxz00_4514;
{ /* Inline/recursion.scm 353 */
int BgL_auxz00_4515;
BgL_auxz00_4515 = 
(int)(((long)8)); 
BgL_auxz00_4514 = 
(long)(BgL_auxz00_4515); } 
BgL_modz00_3691 = 
(BgL_offsetz00_3690/BgL_auxz00_4514); } 
{ /* Inline/recursion.scm 353 */
long BgL_restz00_3693;
{ /* Inline/recursion.scm 353 */
long BgL_auxz00_4519;
{ /* Inline/recursion.scm 353 */
int BgL_auxz00_4520;
BgL_auxz00_4520 = 
(int)(((long)8)); 
BgL_auxz00_4519 = 
(long)(BgL_auxz00_4520); } 
BgL_restz00_3693 = 
(BgL_offsetz00_3690%BgL_auxz00_4519); } 
{ /* Inline/recursion.scm 353 */

{ /* Inline/recursion.scm 353 */
obj_t BgL_bucketz00_3695;
{ /* Inline/recursion.scm 353 */
int BgL_kz00_3705;
BgL_kz00_3705 = 
(int)(BgL_modz00_3691); 
BgL_bucketz00_3695 = 
VECTOR_REF(BgL_arg1904z00_3686,BgL_kz00_3705); } 
{ /* Inline/recursion.scm 353 */
int BgL_kz00_3707;
BgL_kz00_3707 = 
(int)(BgL_restz00_3693); 
BgL_method2819z00_3683 = 
VECTOR_REF(BgL_bucketz00_3695,BgL_kz00_3707); } } } } } } } } 
return 
PROCEDURE_ENTRY(BgL_method2819z00_3683)(BgL_method2819z00_3683, 
(obj_t)(BgL_nodez00_3681), 
(obj_t)(BgL_varz00_3682), BEOA);} } } } 
}



/* find-recursive-calls-make-box2850 */
obj_t BGl_findzd2recursivezd2callszd2makezd2box2850z00zzinline_recursionz00(obj_t BgL_envz00_3826, obj_t BgL_nodez00_3827, obj_t BgL_varz00_3828)
{ AN_OBJECT;
{ /* Inline/recursion.scm 346 */
{ 
BgL_makezd2boxzd2_bglt BgL_nodez00_2132;obj_t BgL_varz00_2133;
BgL_nodez00_2132 = 
(BgL_makezd2boxzd2_bglt)(BgL_nodez00_3827); 
BgL_varz00_2133 = BgL_varz00_3828; 
{ /* Inline/recursion.scm 347 */
BgL_nodez00_bglt BgL_arg3917z00_3650;
BgL_arg3917z00_3650 = 
(((BgL_makezd2boxzd2_bglt)CREF(BgL_nodez00_2132))->BgL_valuez00); 
{ /* Inline/recursion.scm 347 */
BgL_variablez00_bglt BgL_varz00_3653;
BgL_varz00_3653 = 
(BgL_variablez00_bglt)(BgL_varz00_2133); 
{ /* Inline/recursion.scm 347 */
obj_t BgL_method2819z00_3654;
{ /* Inline/recursion.scm 347 */
long BgL_objzd2classzd2numz00_3656;
{ /* Inline/recursion.scm 347 */
BgL_objectz00_bglt BgL_auxz00_4535;
BgL_auxz00_4535 = 
(BgL_objectz00_bglt)(BgL_arg3917z00_3650); 
BgL_objzd2classzd2numz00_3656 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4535); } 
{ /* Inline/recursion.scm 347 */
obj_t BgL_arg1904z00_3657;
{ /* Inline/recursion.scm 347 */
int BgL_auxz00_4538;
BgL_auxz00_4538 = 
(int)(((long)1)); 
BgL_arg1904z00_3657 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_4538); } 
{ /* Inline/recursion.scm 347 */
long BgL_offsetz00_3661;
{ /* Inline/recursion.scm 347 */
long BgL_auxz00_4541;
{ /* Inline/recursion.scm 347 */
int BgL_auxz00_4542;
BgL_auxz00_4542 = 
(int)(BgL_objzd2classzd2numz00_3656); 
BgL_auxz00_4541 = 
(long)(BgL_auxz00_4542); } 
BgL_offsetz00_3661 = 
(BgL_auxz00_4541-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 347 */
long BgL_modz00_3662;
{ /* Inline/recursion.scm 347 */
long BgL_auxz00_4546;
{ /* Inline/recursion.scm 347 */
int BgL_auxz00_4547;
BgL_auxz00_4547 = 
(int)(((long)8)); 
BgL_auxz00_4546 = 
(long)(BgL_auxz00_4547); } 
BgL_modz00_3662 = 
(BgL_offsetz00_3661/BgL_auxz00_4546); } 
{ /* Inline/recursion.scm 347 */
long BgL_restz00_3664;
{ /* Inline/recursion.scm 347 */
long BgL_auxz00_4551;
{ /* Inline/recursion.scm 347 */
int BgL_auxz00_4552;
BgL_auxz00_4552 = 
(int)(((long)8)); 
BgL_auxz00_4551 = 
(long)(BgL_auxz00_4552); } 
BgL_restz00_3664 = 
(BgL_offsetz00_3661%BgL_auxz00_4551); } 
{ /* Inline/recursion.scm 347 */

{ /* Inline/recursion.scm 347 */
obj_t BgL_bucketz00_3666;
{ /* Inline/recursion.scm 347 */
int BgL_kz00_3676;
BgL_kz00_3676 = 
(int)(BgL_modz00_3662); 
BgL_bucketz00_3666 = 
VECTOR_REF(BgL_arg1904z00_3657,BgL_kz00_3676); } 
{ /* Inline/recursion.scm 347 */
int BgL_kz00_3678;
BgL_kz00_3678 = 
(int)(BgL_restz00_3664); 
BgL_method2819z00_3654 = 
VECTOR_REF(BgL_bucketz00_3666,BgL_kz00_3678); } } } } } } } } 
return 
PROCEDURE_ENTRY(BgL_method2819z00_3654)(BgL_method2819z00_3654, 
(obj_t)(BgL_arg3917z00_3650), 
(obj_t)(BgL_varz00_3653), BEOA);} } } } } 
}



/* find-recursive-calls-jump-ex-it2848 */
obj_t BGl_findzd2recursivezd2callszd2jumpzd2exzd2it2848zd2zzinline_recursionz00(obj_t BgL_envz00_3829, obj_t BgL_nodez00_3830, obj_t BgL_vz00_3831)
{ AN_OBJECT;
{ /* Inline/recursion.scm 339 */
{ 
BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_2121;obj_t BgL_vz00_2122;
BgL_nodez00_2121 = 
(BgL_jumpzd2exzd2itz00_bglt)(BgL_nodez00_3830); 
BgL_vz00_2122 = BgL_vz00_3831; 
{ /* Inline/recursion.scm 341 */
obj_t BgL_arg3899z00_2126;obj_t BgL_arg3900z00_2127;
{ /* Inline/recursion.scm 341 */
BgL_nodez00_bglt BgL_arg3903z00_2128;
BgL_arg3903z00_2128 = 
(((BgL_jumpzd2exzd2itz00_bglt)CREF(BgL_nodez00_2121))->BgL_exitz00); 
{ /* Inline/recursion.scm 341 */
BgL_variablez00_bglt BgL_varz00_3596;
BgL_varz00_3596 = 
(BgL_variablez00_bglt)(BgL_vz00_2122); 
{ /* Inline/recursion.scm 341 */
obj_t BgL_method2819z00_3597;
{ /* Inline/recursion.scm 341 */
long BgL_objzd2classzd2numz00_3599;
{ /* Inline/recursion.scm 341 */
BgL_objectz00_bglt BgL_auxz00_4567;
BgL_auxz00_4567 = 
(BgL_objectz00_bglt)(BgL_arg3903z00_2128); 
BgL_objzd2classzd2numz00_3599 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4567); } 
{ /* Inline/recursion.scm 341 */
obj_t BgL_arg1904z00_3600;
{ /* Inline/recursion.scm 341 */
int BgL_auxz00_4570;
BgL_auxz00_4570 = 
(int)(((long)1)); 
BgL_arg1904z00_3600 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_4570); } 
{ /* Inline/recursion.scm 341 */
long BgL_offsetz00_3604;
{ /* Inline/recursion.scm 341 */
long BgL_auxz00_4573;
{ /* Inline/recursion.scm 341 */
int BgL_auxz00_4574;
BgL_auxz00_4574 = 
(int)(BgL_objzd2classzd2numz00_3599); 
BgL_auxz00_4573 = 
(long)(BgL_auxz00_4574); } 
BgL_offsetz00_3604 = 
(BgL_auxz00_4573-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 341 */
long BgL_modz00_3605;
{ /* Inline/recursion.scm 341 */
long BgL_auxz00_4578;
{ /* Inline/recursion.scm 341 */
int BgL_auxz00_4579;
BgL_auxz00_4579 = 
(int)(((long)8)); 
BgL_auxz00_4578 = 
(long)(BgL_auxz00_4579); } 
BgL_modz00_3605 = 
(BgL_offsetz00_3604/BgL_auxz00_4578); } 
{ /* Inline/recursion.scm 341 */
long BgL_restz00_3607;
{ /* Inline/recursion.scm 341 */
long BgL_auxz00_4583;
{ /* Inline/recursion.scm 341 */
int BgL_auxz00_4584;
BgL_auxz00_4584 = 
(int)(((long)8)); 
BgL_auxz00_4583 = 
(long)(BgL_auxz00_4584); } 
BgL_restz00_3607 = 
(BgL_offsetz00_3604%BgL_auxz00_4583); } 
{ /* Inline/recursion.scm 341 */

{ /* Inline/recursion.scm 341 */
obj_t BgL_bucketz00_3609;
{ /* Inline/recursion.scm 341 */
int BgL_kz00_3619;
BgL_kz00_3619 = 
(int)(BgL_modz00_3605); 
BgL_bucketz00_3609 = 
VECTOR_REF(BgL_arg1904z00_3600,BgL_kz00_3619); } 
{ /* Inline/recursion.scm 341 */
int BgL_kz00_3621;
BgL_kz00_3621 = 
(int)(BgL_restz00_3607); 
BgL_method2819z00_3597 = 
VECTOR_REF(BgL_bucketz00_3609,BgL_kz00_3621); } } } } } } } } 
BgL_arg3899z00_2126 = 
PROCEDURE_ENTRY(BgL_method2819z00_3597)(BgL_method2819z00_3597, 
(obj_t)(BgL_arg3903z00_2128), 
(obj_t)(BgL_varz00_3596), BEOA); } } } 
{ /* Inline/recursion.scm 341 */
BgL_nodez00_bglt BgL_arg3907z00_2129;
BgL_arg3907z00_2129 = 
(((BgL_jumpzd2exzd2itz00_bglt)CREF(BgL_nodez00_2121))->BgL_valuez00); 
{ /* Inline/recursion.scm 341 */
BgL_variablez00_bglt BgL_varz00_3624;
BgL_varz00_3624 = 
(BgL_variablez00_bglt)(BgL_vz00_2122); 
{ /* Inline/recursion.scm 341 */
obj_t BgL_method2819z00_3625;
{ /* Inline/recursion.scm 341 */
long BgL_objzd2classzd2numz00_3627;
{ /* Inline/recursion.scm 341 */
BgL_objectz00_bglt BgL_auxz00_4598;
BgL_auxz00_4598 = 
(BgL_objectz00_bglt)(BgL_arg3907z00_2129); 
BgL_objzd2classzd2numz00_3627 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4598); } 
{ /* Inline/recursion.scm 341 */
obj_t BgL_arg1904z00_3628;
{ /* Inline/recursion.scm 341 */
int BgL_auxz00_4601;
BgL_auxz00_4601 = 
(int)(((long)1)); 
BgL_arg1904z00_3628 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_4601); } 
{ /* Inline/recursion.scm 341 */
long BgL_offsetz00_3632;
{ /* Inline/recursion.scm 341 */
long BgL_auxz00_4604;
{ /* Inline/recursion.scm 341 */
int BgL_auxz00_4605;
BgL_auxz00_4605 = 
(int)(BgL_objzd2classzd2numz00_3627); 
BgL_auxz00_4604 = 
(long)(BgL_auxz00_4605); } 
BgL_offsetz00_3632 = 
(BgL_auxz00_4604-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 341 */
long BgL_modz00_3633;
{ /* Inline/recursion.scm 341 */
long BgL_auxz00_4609;
{ /* Inline/recursion.scm 341 */
int BgL_auxz00_4610;
BgL_auxz00_4610 = 
(int)(((long)8)); 
BgL_auxz00_4609 = 
(long)(BgL_auxz00_4610); } 
BgL_modz00_3633 = 
(BgL_offsetz00_3632/BgL_auxz00_4609); } 
{ /* Inline/recursion.scm 341 */
long BgL_restz00_3635;
{ /* Inline/recursion.scm 341 */
long BgL_auxz00_4614;
{ /* Inline/recursion.scm 341 */
int BgL_auxz00_4615;
BgL_auxz00_4615 = 
(int)(((long)8)); 
BgL_auxz00_4614 = 
(long)(BgL_auxz00_4615); } 
BgL_restz00_3635 = 
(BgL_offsetz00_3632%BgL_auxz00_4614); } 
{ /* Inline/recursion.scm 341 */

{ /* Inline/recursion.scm 341 */
obj_t BgL_bucketz00_3637;
{ /* Inline/recursion.scm 341 */
int BgL_kz00_3647;
BgL_kz00_3647 = 
(int)(BgL_modz00_3633); 
BgL_bucketz00_3637 = 
VECTOR_REF(BgL_arg1904z00_3628,BgL_kz00_3647); } 
{ /* Inline/recursion.scm 341 */
int BgL_kz00_3649;
BgL_kz00_3649 = 
(int)(BgL_restz00_3635); 
BgL_method2819z00_3625 = 
VECTOR_REF(BgL_bucketz00_3637,BgL_kz00_3649); } } } } } } } } 
BgL_arg3900z00_2127 = 
PROCEDURE_ENTRY(BgL_method2819z00_3625)(BgL_method2819z00_3625, 
(obj_t)(BgL_arg3907z00_2129), 
(obj_t)(BgL_varz00_3624), BEOA); } } } 
return 
bgl_append2(BgL_arg3899z00_2126, BgL_arg3900z00_2127);} } } 
}



/* find-recursive-calls-set-ex-it2846 */
obj_t BGl_findzd2recursivezd2callszd2setzd2exzd2it2846zd2zzinline_recursionz00(obj_t BgL_envz00_3832, obj_t BgL_nodez00_3833, obj_t BgL_varz00_3834)
{ AN_OBJECT;
{ /* Inline/recursion.scm 333 */
{ 
BgL_setzd2exzd2itz00_bglt BgL_nodez00_2114;obj_t BgL_varz00_2115;
BgL_nodez00_2114 = 
(BgL_setzd2exzd2itz00_bglt)(BgL_nodez00_3833); 
BgL_varz00_2115 = BgL_varz00_3834; 
{ /* Inline/recursion.scm 334 */
BgL_nodez00_bglt BgL_arg3889z00_3565;
BgL_arg3889z00_3565 = 
(((BgL_setzd2exzd2itz00_bglt)CREF(BgL_nodez00_2114))->BgL_bodyz00); 
{ /* Inline/recursion.scm 334 */
BgL_variablez00_bglt BgL_varz00_3568;
BgL_varz00_3568 = 
(BgL_variablez00_bglt)(BgL_varz00_2115); 
{ /* Inline/recursion.scm 334 */
obj_t BgL_method2819z00_3569;
{ /* Inline/recursion.scm 334 */
long BgL_objzd2classzd2numz00_3571;
{ /* Inline/recursion.scm 334 */
BgL_objectz00_bglt BgL_auxz00_4631;
BgL_auxz00_4631 = 
(BgL_objectz00_bglt)(BgL_arg3889z00_3565); 
BgL_objzd2classzd2numz00_3571 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4631); } 
{ /* Inline/recursion.scm 334 */
obj_t BgL_arg1904z00_3572;
{ /* Inline/recursion.scm 334 */
int BgL_auxz00_4634;
BgL_auxz00_4634 = 
(int)(((long)1)); 
BgL_arg1904z00_3572 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_4634); } 
{ /* Inline/recursion.scm 334 */
long BgL_offsetz00_3576;
{ /* Inline/recursion.scm 334 */
long BgL_auxz00_4637;
{ /* Inline/recursion.scm 334 */
int BgL_auxz00_4638;
BgL_auxz00_4638 = 
(int)(BgL_objzd2classzd2numz00_3571); 
BgL_auxz00_4637 = 
(long)(BgL_auxz00_4638); } 
BgL_offsetz00_3576 = 
(BgL_auxz00_4637-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 334 */
long BgL_modz00_3577;
{ /* Inline/recursion.scm 334 */
long BgL_auxz00_4642;
{ /* Inline/recursion.scm 334 */
int BgL_auxz00_4643;
BgL_auxz00_4643 = 
(int)(((long)8)); 
BgL_auxz00_4642 = 
(long)(BgL_auxz00_4643); } 
BgL_modz00_3577 = 
(BgL_offsetz00_3576/BgL_auxz00_4642); } 
{ /* Inline/recursion.scm 334 */
long BgL_restz00_3579;
{ /* Inline/recursion.scm 334 */
long BgL_auxz00_4647;
{ /* Inline/recursion.scm 334 */
int BgL_auxz00_4648;
BgL_auxz00_4648 = 
(int)(((long)8)); 
BgL_auxz00_4647 = 
(long)(BgL_auxz00_4648); } 
BgL_restz00_3579 = 
(BgL_offsetz00_3576%BgL_auxz00_4647); } 
{ /* Inline/recursion.scm 334 */

{ /* Inline/recursion.scm 334 */
obj_t BgL_bucketz00_3581;
{ /* Inline/recursion.scm 334 */
int BgL_kz00_3591;
BgL_kz00_3591 = 
(int)(BgL_modz00_3577); 
BgL_bucketz00_3581 = 
VECTOR_REF(BgL_arg1904z00_3572,BgL_kz00_3591); } 
{ /* Inline/recursion.scm 334 */
int BgL_kz00_3593;
BgL_kz00_3593 = 
(int)(BgL_restz00_3579); 
BgL_method2819z00_3569 = 
VECTOR_REF(BgL_bucketz00_3581,BgL_kz00_3593); } } } } } } } } 
return 
PROCEDURE_ENTRY(BgL_method2819z00_3569)(BgL_method2819z00_3569, 
(obj_t)(BgL_arg3889z00_3565), 
(obj_t)(BgL_varz00_3568), BEOA);} } } } } 
}



/* find-recursive-calls-let-var2844 */
obj_t BGl_findzd2recursivezd2callszd2letzd2var2844z00zzinline_recursionz00(obj_t BgL_envz00_3835, obj_t BgL_nodez00_3836, obj_t BgL_varz00_3837)
{ AN_OBJECT;
{ /* Inline/recursion.scm 321 */
{ 
BgL_letzd2varzd2_bglt BgL_nodez00_2096;obj_t BgL_varz00_2097;
BgL_nodez00_2096 = 
(BgL_letzd2varzd2_bglt)(BgL_nodez00_3836); 
BgL_varz00_2097 = BgL_varz00_3837; 
{ 
obj_t BgL_bindingsz00_2100;obj_t BgL_callsz00_2101;
{ /* Inline/recursion.scm 322 */
obj_t BgL_arg3857z00_2103;obj_t BgL_arg3858z00_2104;
BgL_arg3857z00_2103 = 
(((BgL_letzd2varzd2_bglt)CREF(BgL_nodez00_2096))->BgL_bindingsz00); 
{ /* Inline/recursion.scm 323 */
BgL_nodez00_bglt BgL_arg3862z00_2105;
BgL_arg3862z00_2105 = 
(((BgL_letzd2varzd2_bglt)CREF(BgL_nodez00_2096))->BgL_bodyz00); 
{ /* Inline/recursion.scm 323 */
BgL_variablez00_bglt BgL_varz00_3508;
BgL_varz00_3508 = 
(BgL_variablez00_bglt)(BgL_varz00_2097); 
{ /* Inline/recursion.scm 323 */
obj_t BgL_method2819z00_3509;
{ /* Inline/recursion.scm 323 */
long BgL_objzd2classzd2numz00_3511;
{ /* Inline/recursion.scm 323 */
BgL_objectz00_bglt BgL_auxz00_4664;
BgL_auxz00_4664 = 
(BgL_objectz00_bglt)(BgL_arg3862z00_2105); 
BgL_objzd2classzd2numz00_3511 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4664); } 
{ /* Inline/recursion.scm 323 */
obj_t BgL_arg1904z00_3512;
{ /* Inline/recursion.scm 323 */
int BgL_auxz00_4667;
BgL_auxz00_4667 = 
(int)(((long)1)); 
BgL_arg1904z00_3512 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_4667); } 
{ /* Inline/recursion.scm 323 */
long BgL_offsetz00_3516;
{ /* Inline/recursion.scm 323 */
long BgL_auxz00_4670;
{ /* Inline/recursion.scm 323 */
int BgL_auxz00_4671;
BgL_auxz00_4671 = 
(int)(BgL_objzd2classzd2numz00_3511); 
BgL_auxz00_4670 = 
(long)(BgL_auxz00_4671); } 
BgL_offsetz00_3516 = 
(BgL_auxz00_4670-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 323 */
long BgL_modz00_3517;
{ /* Inline/recursion.scm 323 */
long BgL_auxz00_4675;
{ /* Inline/recursion.scm 323 */
int BgL_auxz00_4676;
BgL_auxz00_4676 = 
(int)(((long)8)); 
BgL_auxz00_4675 = 
(long)(BgL_auxz00_4676); } 
BgL_modz00_3517 = 
(BgL_offsetz00_3516/BgL_auxz00_4675); } 
{ /* Inline/recursion.scm 323 */
long BgL_restz00_3519;
{ /* Inline/recursion.scm 323 */
long BgL_auxz00_4680;
{ /* Inline/recursion.scm 323 */
int BgL_auxz00_4681;
BgL_auxz00_4681 = 
(int)(((long)8)); 
BgL_auxz00_4680 = 
(long)(BgL_auxz00_4681); } 
BgL_restz00_3519 = 
(BgL_offsetz00_3516%BgL_auxz00_4680); } 
{ /* Inline/recursion.scm 323 */

{ /* Inline/recursion.scm 323 */
obj_t BgL_bucketz00_3521;
{ /* Inline/recursion.scm 323 */
int BgL_kz00_3531;
BgL_kz00_3531 = 
(int)(BgL_modz00_3517); 
BgL_bucketz00_3521 = 
VECTOR_REF(BgL_arg1904z00_3512,BgL_kz00_3531); } 
{ /* Inline/recursion.scm 323 */
int BgL_kz00_3533;
BgL_kz00_3533 = 
(int)(BgL_restz00_3519); 
BgL_method2819z00_3509 = 
VECTOR_REF(BgL_bucketz00_3521,BgL_kz00_3533); } } } } } } } } 
BgL_arg3858z00_2104 = 
PROCEDURE_ENTRY(BgL_method2819z00_3509)(BgL_method2819z00_3509, 
(obj_t)(BgL_arg3862z00_2105), 
(obj_t)(BgL_varz00_3508), BEOA); } } } 
BgL_bindingsz00_2100 = BgL_arg3857z00_2103; 
BgL_callsz00_2101 = BgL_arg3858z00_2104; 
BgL_loopz00_2102:
if(
NULLP(BgL_bindingsz00_2100))
{ /* Inline/recursion.scm 324 */
return BgL_callsz00_2101;}  else 
{ /* Inline/recursion.scm 326 */
obj_t BgL_arg3867z00_2107;obj_t BgL_arg3868z00_2108;
BgL_arg3867z00_2107 = 
CDR(BgL_bindingsz00_2100); 
{ /* Inline/recursion.scm 328 */
obj_t BgL_arg3872z00_2109;
{ /* Inline/recursion.scm 328 */
BgL_nodez00_bglt BgL_nodez00_3538;BgL_variablez00_bglt BgL_varz00_3539;
{ /* Inline/recursion.scm 328 */
obj_t BgL_auxz00_4696;
{ /* Inline/recursion.scm 328 */
obj_t BgL_auxz00_4697;
BgL_auxz00_4697 = 
CAR(BgL_bindingsz00_2100); 
BgL_auxz00_4696 = 
CDR(BgL_auxz00_4697); } 
BgL_nodez00_3538 = 
(BgL_nodez00_bglt)(BgL_auxz00_4696); } 
BgL_varz00_3539 = 
(BgL_variablez00_bglt)(BgL_varz00_2097); 
{ /* Inline/recursion.scm 328 */
obj_t BgL_method2819z00_3540;
{ /* Inline/recursion.scm 328 */
long BgL_objzd2classzd2numz00_3542;
{ /* Inline/recursion.scm 328 */
BgL_objectz00_bglt BgL_auxz00_4702;
BgL_auxz00_4702 = 
(BgL_objectz00_bglt)(BgL_nodez00_3538); 
BgL_objzd2classzd2numz00_3542 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4702); } 
{ /* Inline/recursion.scm 328 */
obj_t BgL_arg1904z00_3543;
{ /* Inline/recursion.scm 328 */
int BgL_auxz00_4705;
BgL_auxz00_4705 = 
(int)(((long)1)); 
BgL_arg1904z00_3543 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_4705); } 
{ /* Inline/recursion.scm 328 */
long BgL_offsetz00_3547;
{ /* Inline/recursion.scm 328 */
long BgL_auxz00_4708;
{ /* Inline/recursion.scm 328 */
int BgL_auxz00_4709;
BgL_auxz00_4709 = 
(int)(BgL_objzd2classzd2numz00_3542); 
BgL_auxz00_4708 = 
(long)(BgL_auxz00_4709); } 
BgL_offsetz00_3547 = 
(BgL_auxz00_4708-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 328 */
long BgL_modz00_3548;
{ /* Inline/recursion.scm 328 */
long BgL_auxz00_4713;
{ /* Inline/recursion.scm 328 */
int BgL_auxz00_4714;
BgL_auxz00_4714 = 
(int)(((long)8)); 
BgL_auxz00_4713 = 
(long)(BgL_auxz00_4714); } 
BgL_modz00_3548 = 
(BgL_offsetz00_3547/BgL_auxz00_4713); } 
{ /* Inline/recursion.scm 328 */
long BgL_restz00_3550;
{ /* Inline/recursion.scm 328 */
long BgL_auxz00_4718;
{ /* Inline/recursion.scm 328 */
int BgL_auxz00_4719;
BgL_auxz00_4719 = 
(int)(((long)8)); 
BgL_auxz00_4718 = 
(long)(BgL_auxz00_4719); } 
BgL_restz00_3550 = 
(BgL_offsetz00_3547%BgL_auxz00_4718); } 
{ /* Inline/recursion.scm 328 */

{ /* Inline/recursion.scm 328 */
obj_t BgL_bucketz00_3552;
{ /* Inline/recursion.scm 328 */
int BgL_kz00_3562;
BgL_kz00_3562 = 
(int)(BgL_modz00_3548); 
BgL_bucketz00_3552 = 
VECTOR_REF(BgL_arg1904z00_3543,BgL_kz00_3562); } 
{ /* Inline/recursion.scm 328 */
int BgL_kz00_3564;
BgL_kz00_3564 = 
(int)(BgL_restz00_3550); 
BgL_method2819z00_3540 = 
VECTOR_REF(BgL_bucketz00_3552,BgL_kz00_3564); } } } } } } } } 
BgL_arg3872z00_2109 = 
PROCEDURE_ENTRY(BgL_method2819z00_3540)(BgL_method2819z00_3540, 
(obj_t)(BgL_nodez00_3538), 
(obj_t)(BgL_varz00_3539), BEOA); } } 
BgL_arg3868z00_2108 = 
bgl_append2(BgL_callsz00_2101, BgL_arg3872z00_2109); } 
{ 
obj_t BgL_callsz00_4733;obj_t BgL_bindingsz00_4732;
BgL_bindingsz00_4732 = BgL_arg3867z00_2107; 
BgL_callsz00_4733 = BgL_arg3868z00_2108; 
BgL_callsz00_2101 = BgL_callsz00_4733; 
BgL_bindingsz00_2100 = BgL_bindingsz00_4732; 
goto BgL_loopz00_2102;} } } } } } 
}



/* find-recursive-calls-let-fun2842 */
obj_t BGl_findzd2recursivezd2callszd2letzd2fun2842z00zzinline_recursionz00(obj_t BgL_envz00_3838, obj_t BgL_nodez00_3839, obj_t BgL_varz00_3840)
{ AN_OBJECT;
{ /* Inline/recursion.scm 307 */
{ 
BgL_letzd2funzd2_bglt BgL_nodez00_2077;obj_t BgL_varz00_2078;
BgL_nodez00_2077 = 
(BgL_letzd2funzd2_bglt)(BgL_nodez00_3839); 
BgL_varz00_2078 = BgL_varz00_3840; 
{ 
obj_t BgL_localsz00_2081;obj_t BgL_callsz00_2082;
{ /* Inline/recursion.scm 308 */
obj_t BgL_arg3822z00_2084;obj_t BgL_arg3823z00_2085;
BgL_arg3822z00_2084 = 
(((BgL_letzd2funzd2_bglt)CREF(BgL_nodez00_2077))->BgL_localsz00); 
{ /* Inline/recursion.scm 309 */
BgL_nodez00_bglt BgL_arg3827z00_2086;
BgL_arg3827z00_2086 = 
(((BgL_letzd2funzd2_bglt)CREF(BgL_nodez00_2077))->BgL_bodyz00); 
{ /* Inline/recursion.scm 309 */
BgL_variablez00_bglt BgL_varz00_3447;
BgL_varz00_3447 = 
(BgL_variablez00_bglt)(BgL_varz00_2078); 
{ /* Inline/recursion.scm 309 */
obj_t BgL_method2819z00_3448;
{ /* Inline/recursion.scm 309 */
long BgL_objzd2classzd2numz00_3450;
{ /* Inline/recursion.scm 309 */
BgL_objectz00_bglt BgL_auxz00_4738;
BgL_auxz00_4738 = 
(BgL_objectz00_bglt)(BgL_arg3827z00_2086); 
BgL_objzd2classzd2numz00_3450 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4738); } 
{ /* Inline/recursion.scm 309 */
obj_t BgL_arg1904z00_3451;
{ /* Inline/recursion.scm 309 */
int BgL_auxz00_4741;
BgL_auxz00_4741 = 
(int)(((long)1)); 
BgL_arg1904z00_3451 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_4741); } 
{ /* Inline/recursion.scm 309 */
long BgL_offsetz00_3455;
{ /* Inline/recursion.scm 309 */
long BgL_auxz00_4744;
{ /* Inline/recursion.scm 309 */
int BgL_auxz00_4745;
BgL_auxz00_4745 = 
(int)(BgL_objzd2classzd2numz00_3450); 
BgL_auxz00_4744 = 
(long)(BgL_auxz00_4745); } 
BgL_offsetz00_3455 = 
(BgL_auxz00_4744-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 309 */
long BgL_modz00_3456;
{ /* Inline/recursion.scm 309 */
long BgL_auxz00_4749;
{ /* Inline/recursion.scm 309 */
int BgL_auxz00_4750;
BgL_auxz00_4750 = 
(int)(((long)8)); 
BgL_auxz00_4749 = 
(long)(BgL_auxz00_4750); } 
BgL_modz00_3456 = 
(BgL_offsetz00_3455/BgL_auxz00_4749); } 
{ /* Inline/recursion.scm 309 */
long BgL_restz00_3458;
{ /* Inline/recursion.scm 309 */
long BgL_auxz00_4754;
{ /* Inline/recursion.scm 309 */
int BgL_auxz00_4755;
BgL_auxz00_4755 = 
(int)(((long)8)); 
BgL_auxz00_4754 = 
(long)(BgL_auxz00_4755); } 
BgL_restz00_3458 = 
(BgL_offsetz00_3455%BgL_auxz00_4754); } 
{ /* Inline/recursion.scm 309 */

{ /* Inline/recursion.scm 309 */
obj_t BgL_bucketz00_3460;
{ /* Inline/recursion.scm 309 */
int BgL_kz00_3470;
BgL_kz00_3470 = 
(int)(BgL_modz00_3456); 
BgL_bucketz00_3460 = 
VECTOR_REF(BgL_arg1904z00_3451,BgL_kz00_3470); } 
{ /* Inline/recursion.scm 309 */
int BgL_kz00_3472;
BgL_kz00_3472 = 
(int)(BgL_restz00_3458); 
BgL_method2819z00_3448 = 
VECTOR_REF(BgL_bucketz00_3460,BgL_kz00_3472); } } } } } } } } 
BgL_arg3823z00_2085 = 
PROCEDURE_ENTRY(BgL_method2819z00_3448)(BgL_method2819z00_3448, 
(obj_t)(BgL_arg3827z00_2086), 
(obj_t)(BgL_varz00_3447), BEOA); } } } 
BgL_localsz00_2081 = BgL_arg3822z00_2084; 
BgL_callsz00_2082 = BgL_arg3823z00_2085; 
BgL_loopz00_2083:
if(
NULLP(BgL_localsz00_2081))
{ /* Inline/recursion.scm 310 */
return BgL_callsz00_2082;}  else 
{ /* Inline/recursion.scm 312 */
obj_t BgL_arg3832z00_2088;obj_t BgL_arg3833z00_2089;
BgL_arg3832z00_2088 = 
CDR(BgL_localsz00_2081); 
{ /* Inline/recursion.scm 315 */
obj_t BgL_arg3837z00_2090;
{ /* Inline/recursion.scm 314 */
BgL_nodez00_bglt BgL_nodez00_3478;BgL_variablez00_bglt BgL_varz00_3479;
{ /* Inline/recursion.scm 315 */
obj_t BgL_auxz00_4770;
{ /* Inline/recursion.scm 315 */
BgL_sfunz00_bglt BgL_obj1373z00_3477;
{ /* Inline/recursion.scm 315 */
BgL_valuez00_bglt BgL_auxz00_4771;
{ /* Inline/recursion.scm 315 */
BgL_localz00_bglt BgL_obj1256z00_3476;
{ /* Inline/recursion.scm 315 */
obj_t BgL_auxz00_4772;
BgL_auxz00_4772 = 
CAR(BgL_localsz00_2081); 
BgL_obj1256z00_3476 = 
(BgL_localz00_bglt)(BgL_auxz00_4772); } 
BgL_auxz00_4771 = 
(((BgL_localz00_bglt)CREF(BgL_obj1256z00_3476))->BgL_valuez00); } 
BgL_obj1373z00_3477 = 
(BgL_sfunz00_bglt)(BgL_auxz00_4771); } 
BgL_auxz00_4770 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1373z00_3477))->BgL_bodyz00); } 
BgL_nodez00_3478 = 
(BgL_nodez00_bglt)(BgL_auxz00_4770); } 
BgL_varz00_3479 = 
(BgL_variablez00_bglt)(BgL_varz00_2078); 
{ /* Inline/recursion.scm 314 */
obj_t BgL_method2819z00_3480;
{ /* Inline/recursion.scm 314 */
long BgL_objzd2classzd2numz00_3482;
{ /* Inline/recursion.scm 314 */
BgL_objectz00_bglt BgL_auxz00_4780;
BgL_auxz00_4780 = 
(BgL_objectz00_bglt)(BgL_nodez00_3478); 
BgL_objzd2classzd2numz00_3482 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4780); } 
{ /* Inline/recursion.scm 314 */
obj_t BgL_arg1904z00_3483;
{ /* Inline/recursion.scm 314 */
int BgL_auxz00_4783;
BgL_auxz00_4783 = 
(int)(((long)1)); 
BgL_arg1904z00_3483 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_4783); } 
{ /* Inline/recursion.scm 314 */
long BgL_offsetz00_3487;
{ /* Inline/recursion.scm 314 */
long BgL_auxz00_4786;
{ /* Inline/recursion.scm 314 */
int BgL_auxz00_4787;
BgL_auxz00_4787 = 
(int)(BgL_objzd2classzd2numz00_3482); 
BgL_auxz00_4786 = 
(long)(BgL_auxz00_4787); } 
BgL_offsetz00_3487 = 
(BgL_auxz00_4786-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 314 */
long BgL_modz00_3488;
{ /* Inline/recursion.scm 314 */
long BgL_auxz00_4791;
{ /* Inline/recursion.scm 314 */
int BgL_auxz00_4792;
BgL_auxz00_4792 = 
(int)(((long)8)); 
BgL_auxz00_4791 = 
(long)(BgL_auxz00_4792); } 
BgL_modz00_3488 = 
(BgL_offsetz00_3487/BgL_auxz00_4791); } 
{ /* Inline/recursion.scm 314 */
long BgL_restz00_3490;
{ /* Inline/recursion.scm 314 */
long BgL_auxz00_4796;
{ /* Inline/recursion.scm 314 */
int BgL_auxz00_4797;
BgL_auxz00_4797 = 
(int)(((long)8)); 
BgL_auxz00_4796 = 
(long)(BgL_auxz00_4797); } 
BgL_restz00_3490 = 
(BgL_offsetz00_3487%BgL_auxz00_4796); } 
{ /* Inline/recursion.scm 314 */

{ /* Inline/recursion.scm 314 */
obj_t BgL_bucketz00_3492;
{ /* Inline/recursion.scm 314 */
int BgL_kz00_3502;
BgL_kz00_3502 = 
(int)(BgL_modz00_3488); 
BgL_bucketz00_3492 = 
VECTOR_REF(BgL_arg1904z00_3483,BgL_kz00_3502); } 
{ /* Inline/recursion.scm 314 */
int BgL_kz00_3504;
BgL_kz00_3504 = 
(int)(BgL_restz00_3490); 
BgL_method2819z00_3480 = 
VECTOR_REF(BgL_bucketz00_3492,BgL_kz00_3504); } } } } } } } } 
BgL_arg3837z00_2090 = 
PROCEDURE_ENTRY(BgL_method2819z00_3480)(BgL_method2819z00_3480, 
(obj_t)(BgL_nodez00_3478), 
(obj_t)(BgL_varz00_3479), BEOA); } } 
BgL_arg3833z00_2089 = 
bgl_append2(BgL_callsz00_2082, BgL_arg3837z00_2090); } 
{ 
obj_t BgL_callsz00_4811;obj_t BgL_localsz00_4810;
BgL_localsz00_4810 = BgL_arg3832z00_2088; 
BgL_callsz00_4811 = BgL_arg3833z00_2089; 
BgL_callsz00_2082 = BgL_callsz00_4811; 
BgL_localsz00_2081 = BgL_localsz00_4810; 
goto BgL_loopz00_2083;} } } } } } 
}



/* find-recursive-calls-select2840 */
obj_t BGl_findzd2recursivezd2callszd2select2840zd2zzinline_recursionz00(obj_t BgL_envz00_3841, obj_t BgL_nodez00_3842, obj_t BgL_varz00_3843)
{ AN_OBJECT;
{ /* Inline/recursion.scm 295 */
{ 
BgL_selectz00_bglt BgL_nodez00_2059;obj_t BgL_varz00_2060;
BgL_nodez00_2059 = 
(BgL_selectz00_bglt)(BgL_nodez00_3842); 
BgL_varz00_2060 = BgL_varz00_3843; 
{ 
obj_t BgL_clausesz00_2063;obj_t BgL_callsz00_2064;
{ /* Inline/recursion.scm 296 */
obj_t BgL_arg3790z00_2066;obj_t BgL_arg3791z00_2067;
BgL_arg3790z00_2066 = 
(((BgL_selectz00_bglt)CREF(BgL_nodez00_2059))->BgL_clausesz00); 
{ /* Inline/recursion.scm 297 */
BgL_nodez00_bglt BgL_arg3795z00_2068;
BgL_arg3795z00_2068 = 
(((BgL_selectz00_bglt)CREF(BgL_nodez00_2059))->BgL_testz00); 
{ /* Inline/recursion.scm 297 */
BgL_variablez00_bglt BgL_varz00_3387;
BgL_varz00_3387 = 
(BgL_variablez00_bglt)(BgL_varz00_2060); 
{ /* Inline/recursion.scm 297 */
obj_t BgL_method2819z00_3388;
{ /* Inline/recursion.scm 297 */
long BgL_objzd2classzd2numz00_3390;
{ /* Inline/recursion.scm 297 */
BgL_objectz00_bglt BgL_auxz00_4816;
BgL_auxz00_4816 = 
(BgL_objectz00_bglt)(BgL_arg3795z00_2068); 
BgL_objzd2classzd2numz00_3390 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4816); } 
{ /* Inline/recursion.scm 297 */
obj_t BgL_arg1904z00_3391;
{ /* Inline/recursion.scm 297 */
int BgL_auxz00_4819;
BgL_auxz00_4819 = 
(int)(((long)1)); 
BgL_arg1904z00_3391 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_4819); } 
{ /* Inline/recursion.scm 297 */
long BgL_offsetz00_3395;
{ /* Inline/recursion.scm 297 */
long BgL_auxz00_4822;
{ /* Inline/recursion.scm 297 */
int BgL_auxz00_4823;
BgL_auxz00_4823 = 
(int)(BgL_objzd2classzd2numz00_3390); 
BgL_auxz00_4822 = 
(long)(BgL_auxz00_4823); } 
BgL_offsetz00_3395 = 
(BgL_auxz00_4822-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 297 */
long BgL_modz00_3396;
{ /* Inline/recursion.scm 297 */
long BgL_auxz00_4827;
{ /* Inline/recursion.scm 297 */
int BgL_auxz00_4828;
BgL_auxz00_4828 = 
(int)(((long)8)); 
BgL_auxz00_4827 = 
(long)(BgL_auxz00_4828); } 
BgL_modz00_3396 = 
(BgL_offsetz00_3395/BgL_auxz00_4827); } 
{ /* Inline/recursion.scm 297 */
long BgL_restz00_3398;
{ /* Inline/recursion.scm 297 */
long BgL_auxz00_4832;
{ /* Inline/recursion.scm 297 */
int BgL_auxz00_4833;
BgL_auxz00_4833 = 
(int)(((long)8)); 
BgL_auxz00_4832 = 
(long)(BgL_auxz00_4833); } 
BgL_restz00_3398 = 
(BgL_offsetz00_3395%BgL_auxz00_4832); } 
{ /* Inline/recursion.scm 297 */

{ /* Inline/recursion.scm 297 */
obj_t BgL_bucketz00_3400;
{ /* Inline/recursion.scm 297 */
int BgL_kz00_3410;
BgL_kz00_3410 = 
(int)(BgL_modz00_3396); 
BgL_bucketz00_3400 = 
VECTOR_REF(BgL_arg1904z00_3391,BgL_kz00_3410); } 
{ /* Inline/recursion.scm 297 */
int BgL_kz00_3412;
BgL_kz00_3412 = 
(int)(BgL_restz00_3398); 
BgL_method2819z00_3388 = 
VECTOR_REF(BgL_bucketz00_3400,BgL_kz00_3412); } } } } } } } } 
BgL_arg3791z00_2067 = 
PROCEDURE_ENTRY(BgL_method2819z00_3388)(BgL_method2819z00_3388, 
(obj_t)(BgL_arg3795z00_2068), 
(obj_t)(BgL_varz00_3387), BEOA); } } } 
BgL_clausesz00_2063 = BgL_arg3790z00_2066; 
BgL_callsz00_2064 = BgL_arg3791z00_2067; 
BgL_loopz00_2065:
if(
NULLP(BgL_clausesz00_2063))
{ /* Inline/recursion.scm 298 */
return BgL_callsz00_2064;}  else 
{ /* Inline/recursion.scm 300 */
obj_t BgL_arg3800z00_2070;obj_t BgL_arg3801z00_2071;
BgL_arg3800z00_2070 = 
CDR(BgL_clausesz00_2063); 
{ /* Inline/recursion.scm 301 */
obj_t BgL_arg3805z00_2072;
{ /* Inline/recursion.scm 301 */
BgL_nodez00_bglt BgL_nodez00_3417;BgL_variablez00_bglt BgL_varz00_3418;
{ /* Inline/recursion.scm 301 */
obj_t BgL_auxz00_4848;
{ /* Inline/recursion.scm 301 */
obj_t BgL_auxz00_4849;
BgL_auxz00_4849 = 
CAR(BgL_clausesz00_2063); 
BgL_auxz00_4848 = 
CDR(BgL_auxz00_4849); } 
BgL_nodez00_3417 = 
(BgL_nodez00_bglt)(BgL_auxz00_4848); } 
BgL_varz00_3418 = 
(BgL_variablez00_bglt)(BgL_varz00_2060); 
{ /* Inline/recursion.scm 301 */
obj_t BgL_method2819z00_3419;
{ /* Inline/recursion.scm 301 */
long BgL_objzd2classzd2numz00_3421;
{ /* Inline/recursion.scm 301 */
BgL_objectz00_bglt BgL_auxz00_4854;
BgL_auxz00_4854 = 
(BgL_objectz00_bglt)(BgL_nodez00_3417); 
BgL_objzd2classzd2numz00_3421 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4854); } 
{ /* Inline/recursion.scm 301 */
obj_t BgL_arg1904z00_3422;
{ /* Inline/recursion.scm 301 */
int BgL_auxz00_4857;
BgL_auxz00_4857 = 
(int)(((long)1)); 
BgL_arg1904z00_3422 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_4857); } 
{ /* Inline/recursion.scm 301 */
long BgL_offsetz00_3426;
{ /* Inline/recursion.scm 301 */
long BgL_auxz00_4860;
{ /* Inline/recursion.scm 301 */
int BgL_auxz00_4861;
BgL_auxz00_4861 = 
(int)(BgL_objzd2classzd2numz00_3421); 
BgL_auxz00_4860 = 
(long)(BgL_auxz00_4861); } 
BgL_offsetz00_3426 = 
(BgL_auxz00_4860-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 301 */
long BgL_modz00_3427;
{ /* Inline/recursion.scm 301 */
long BgL_auxz00_4865;
{ /* Inline/recursion.scm 301 */
int BgL_auxz00_4866;
BgL_auxz00_4866 = 
(int)(((long)8)); 
BgL_auxz00_4865 = 
(long)(BgL_auxz00_4866); } 
BgL_modz00_3427 = 
(BgL_offsetz00_3426/BgL_auxz00_4865); } 
{ /* Inline/recursion.scm 301 */
long BgL_restz00_3429;
{ /* Inline/recursion.scm 301 */
long BgL_auxz00_4870;
{ /* Inline/recursion.scm 301 */
int BgL_auxz00_4871;
BgL_auxz00_4871 = 
(int)(((long)8)); 
BgL_auxz00_4870 = 
(long)(BgL_auxz00_4871); } 
BgL_restz00_3429 = 
(BgL_offsetz00_3426%BgL_auxz00_4870); } 
{ /* Inline/recursion.scm 301 */

{ /* Inline/recursion.scm 301 */
obj_t BgL_bucketz00_3431;
{ /* Inline/recursion.scm 301 */
int BgL_kz00_3441;
BgL_kz00_3441 = 
(int)(BgL_modz00_3427); 
BgL_bucketz00_3431 = 
VECTOR_REF(BgL_arg1904z00_3422,BgL_kz00_3441); } 
{ /* Inline/recursion.scm 301 */
int BgL_kz00_3443;
BgL_kz00_3443 = 
(int)(BgL_restz00_3429); 
BgL_method2819z00_3419 = 
VECTOR_REF(BgL_bucketz00_3431,BgL_kz00_3443); } } } } } } } } 
BgL_arg3805z00_2072 = 
PROCEDURE_ENTRY(BgL_method2819z00_3419)(BgL_method2819z00_3419, 
(obj_t)(BgL_nodez00_3417), 
(obj_t)(BgL_varz00_3418), BEOA); } } 
BgL_arg3801z00_2071 = 
bgl_append2(BgL_arg3805z00_2072, BgL_callsz00_2064); } 
{ 
obj_t BgL_callsz00_4885;obj_t BgL_clausesz00_4884;
BgL_clausesz00_4884 = BgL_arg3800z00_2070; 
BgL_callsz00_4885 = BgL_arg3801z00_2071; 
BgL_callsz00_2064 = BgL_callsz00_4885; 
BgL_clausesz00_2063 = BgL_clausesz00_4884; 
goto BgL_loopz00_2065;} } } } } } 
}



/* find-recursive-calls-fail2838 */
obj_t BGl_findzd2recursivezd2callszd2fail2838zd2zzinline_recursionz00(obj_t BgL_envz00_3844, obj_t BgL_nodez00_3845, obj_t BgL_varz00_3846)
{ AN_OBJECT;
{ /* Inline/recursion.scm 286 */
{ 
BgL_failz00_bglt BgL_nodez00_2043;obj_t BgL_varz00_2044;
BgL_nodez00_2043 = 
(BgL_failz00_bglt)(BgL_nodez00_3845); 
BgL_varz00_2044 = BgL_varz00_3846; 
{ /* Inline/recursion.scm 288 */
obj_t BgL_arg3759z00_2048;obj_t BgL_arg3760z00_2049;obj_t BgL_arg3761z00_2050;
{ /* Inline/recursion.scm 288 */
BgL_nodez00_bglt BgL_arg3772z00_2054;
BgL_arg3772z00_2054 = 
(((BgL_failz00_bglt)CREF(BgL_nodez00_2043))->BgL_procz00); 
{ /* Inline/recursion.scm 288 */
BgL_variablez00_bglt BgL_varz00_3302;
BgL_varz00_3302 = 
(BgL_variablez00_bglt)(BgL_varz00_2044); 
{ /* Inline/recursion.scm 288 */
obj_t BgL_method2819z00_3303;
{ /* Inline/recursion.scm 288 */
long BgL_objzd2classzd2numz00_3305;
{ /* Inline/recursion.scm 288 */
BgL_objectz00_bglt BgL_auxz00_4889;
BgL_auxz00_4889 = 
(BgL_objectz00_bglt)(BgL_arg3772z00_2054); 
BgL_objzd2classzd2numz00_3305 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4889); } 
{ /* Inline/recursion.scm 288 */
obj_t BgL_arg1904z00_3306;
{ /* Inline/recursion.scm 288 */
int BgL_auxz00_4892;
BgL_auxz00_4892 = 
(int)(((long)1)); 
BgL_arg1904z00_3306 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_4892); } 
{ /* Inline/recursion.scm 288 */
long BgL_offsetz00_3310;
{ /* Inline/recursion.scm 288 */
long BgL_auxz00_4895;
{ /* Inline/recursion.scm 288 */
int BgL_auxz00_4896;
BgL_auxz00_4896 = 
(int)(BgL_objzd2classzd2numz00_3305); 
BgL_auxz00_4895 = 
(long)(BgL_auxz00_4896); } 
BgL_offsetz00_3310 = 
(BgL_auxz00_4895-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 288 */
long BgL_modz00_3311;
{ /* Inline/recursion.scm 288 */
long BgL_auxz00_4900;
{ /* Inline/recursion.scm 288 */
int BgL_auxz00_4901;
BgL_auxz00_4901 = 
(int)(((long)8)); 
BgL_auxz00_4900 = 
(long)(BgL_auxz00_4901); } 
BgL_modz00_3311 = 
(BgL_offsetz00_3310/BgL_auxz00_4900); } 
{ /* Inline/recursion.scm 288 */
long BgL_restz00_3313;
{ /* Inline/recursion.scm 288 */
long BgL_auxz00_4905;
{ /* Inline/recursion.scm 288 */
int BgL_auxz00_4906;
BgL_auxz00_4906 = 
(int)(((long)8)); 
BgL_auxz00_4905 = 
(long)(BgL_auxz00_4906); } 
BgL_restz00_3313 = 
(BgL_offsetz00_3310%BgL_auxz00_4905); } 
{ /* Inline/recursion.scm 288 */

{ /* Inline/recursion.scm 288 */
obj_t BgL_bucketz00_3315;
{ /* Inline/recursion.scm 288 */
int BgL_kz00_3325;
BgL_kz00_3325 = 
(int)(BgL_modz00_3311); 
BgL_bucketz00_3315 = 
VECTOR_REF(BgL_arg1904z00_3306,BgL_kz00_3325); } 
{ /* Inline/recursion.scm 288 */
int BgL_kz00_3327;
BgL_kz00_3327 = 
(int)(BgL_restz00_3313); 
BgL_method2819z00_3303 = 
VECTOR_REF(BgL_bucketz00_3315,BgL_kz00_3327); } } } } } } } } 
BgL_arg3759z00_2048 = 
PROCEDURE_ENTRY(BgL_method2819z00_3303)(BgL_method2819z00_3303, 
(obj_t)(BgL_arg3772z00_2054), 
(obj_t)(BgL_varz00_3302), BEOA); } } } 
{ /* Inline/recursion.scm 289 */
BgL_nodez00_bglt BgL_arg3776z00_2055;
BgL_arg3776z00_2055 = 
(((BgL_failz00_bglt)CREF(BgL_nodez00_2043))->BgL_msgz00); 
{ /* Inline/recursion.scm 289 */
BgL_variablez00_bglt BgL_varz00_3330;
BgL_varz00_3330 = 
(BgL_variablez00_bglt)(BgL_varz00_2044); 
{ /* Inline/recursion.scm 289 */
obj_t BgL_method2819z00_3331;
{ /* Inline/recursion.scm 289 */
long BgL_objzd2classzd2numz00_3333;
{ /* Inline/recursion.scm 289 */
BgL_objectz00_bglt BgL_auxz00_4920;
BgL_auxz00_4920 = 
(BgL_objectz00_bglt)(BgL_arg3776z00_2055); 
BgL_objzd2classzd2numz00_3333 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4920); } 
{ /* Inline/recursion.scm 289 */
obj_t BgL_arg1904z00_3334;
{ /* Inline/recursion.scm 289 */
int BgL_auxz00_4923;
BgL_auxz00_4923 = 
(int)(((long)1)); 
BgL_arg1904z00_3334 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_4923); } 
{ /* Inline/recursion.scm 289 */
long BgL_offsetz00_3338;
{ /* Inline/recursion.scm 289 */
long BgL_auxz00_4926;
{ /* Inline/recursion.scm 289 */
int BgL_auxz00_4927;
BgL_auxz00_4927 = 
(int)(BgL_objzd2classzd2numz00_3333); 
BgL_auxz00_4926 = 
(long)(BgL_auxz00_4927); } 
BgL_offsetz00_3338 = 
(BgL_auxz00_4926-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 289 */
long BgL_modz00_3339;
{ /* Inline/recursion.scm 289 */
long BgL_auxz00_4931;
{ /* Inline/recursion.scm 289 */
int BgL_auxz00_4932;
BgL_auxz00_4932 = 
(int)(((long)8)); 
BgL_auxz00_4931 = 
(long)(BgL_auxz00_4932); } 
BgL_modz00_3339 = 
(BgL_offsetz00_3338/BgL_auxz00_4931); } 
{ /* Inline/recursion.scm 289 */
long BgL_restz00_3341;
{ /* Inline/recursion.scm 289 */
long BgL_auxz00_4936;
{ /* Inline/recursion.scm 289 */
int BgL_auxz00_4937;
BgL_auxz00_4937 = 
(int)(((long)8)); 
BgL_auxz00_4936 = 
(long)(BgL_auxz00_4937); } 
BgL_restz00_3341 = 
(BgL_offsetz00_3338%BgL_auxz00_4936); } 
{ /* Inline/recursion.scm 289 */

{ /* Inline/recursion.scm 289 */
obj_t BgL_bucketz00_3343;
{ /* Inline/recursion.scm 289 */
int BgL_kz00_3353;
BgL_kz00_3353 = 
(int)(BgL_modz00_3339); 
BgL_bucketz00_3343 = 
VECTOR_REF(BgL_arg1904z00_3334,BgL_kz00_3353); } 
{ /* Inline/recursion.scm 289 */
int BgL_kz00_3355;
BgL_kz00_3355 = 
(int)(BgL_restz00_3341); 
BgL_method2819z00_3331 = 
VECTOR_REF(BgL_bucketz00_3343,BgL_kz00_3355); } } } } } } } } 
BgL_arg3760z00_2049 = 
PROCEDURE_ENTRY(BgL_method2819z00_3331)(BgL_method2819z00_3331, 
(obj_t)(BgL_arg3776z00_2055), 
(obj_t)(BgL_varz00_3330), BEOA); } } } 
{ /* Inline/recursion.scm 290 */
BgL_nodez00_bglt BgL_arg3780z00_2056;
BgL_arg3780z00_2056 = 
(((BgL_failz00_bglt)CREF(BgL_nodez00_2043))->BgL_objz00); 
{ /* Inline/recursion.scm 290 */
BgL_variablez00_bglt BgL_varz00_3358;
BgL_varz00_3358 = 
(BgL_variablez00_bglt)(BgL_varz00_2044); 
{ /* Inline/recursion.scm 290 */
obj_t BgL_method2819z00_3359;
{ /* Inline/recursion.scm 290 */
long BgL_objzd2classzd2numz00_3361;
{ /* Inline/recursion.scm 290 */
BgL_objectz00_bglt BgL_auxz00_4951;
BgL_auxz00_4951 = 
(BgL_objectz00_bglt)(BgL_arg3780z00_2056); 
BgL_objzd2classzd2numz00_3361 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4951); } 
{ /* Inline/recursion.scm 290 */
obj_t BgL_arg1904z00_3362;
{ /* Inline/recursion.scm 290 */
int BgL_auxz00_4954;
BgL_auxz00_4954 = 
(int)(((long)1)); 
BgL_arg1904z00_3362 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_4954); } 
{ /* Inline/recursion.scm 290 */
long BgL_offsetz00_3366;
{ /* Inline/recursion.scm 290 */
long BgL_auxz00_4957;
{ /* Inline/recursion.scm 290 */
int BgL_auxz00_4958;
BgL_auxz00_4958 = 
(int)(BgL_objzd2classzd2numz00_3361); 
BgL_auxz00_4957 = 
(long)(BgL_auxz00_4958); } 
BgL_offsetz00_3366 = 
(BgL_auxz00_4957-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 290 */
long BgL_modz00_3367;
{ /* Inline/recursion.scm 290 */
long BgL_auxz00_4962;
{ /* Inline/recursion.scm 290 */
int BgL_auxz00_4963;
BgL_auxz00_4963 = 
(int)(((long)8)); 
BgL_auxz00_4962 = 
(long)(BgL_auxz00_4963); } 
BgL_modz00_3367 = 
(BgL_offsetz00_3366/BgL_auxz00_4962); } 
{ /* Inline/recursion.scm 290 */
long BgL_restz00_3369;
{ /* Inline/recursion.scm 290 */
long BgL_auxz00_4967;
{ /* Inline/recursion.scm 290 */
int BgL_auxz00_4968;
BgL_auxz00_4968 = 
(int)(((long)8)); 
BgL_auxz00_4967 = 
(long)(BgL_auxz00_4968); } 
BgL_restz00_3369 = 
(BgL_offsetz00_3366%BgL_auxz00_4967); } 
{ /* Inline/recursion.scm 290 */

{ /* Inline/recursion.scm 290 */
obj_t BgL_bucketz00_3371;
{ /* Inline/recursion.scm 290 */
int BgL_kz00_3381;
BgL_kz00_3381 = 
(int)(BgL_modz00_3367); 
BgL_bucketz00_3371 = 
VECTOR_REF(BgL_arg1904z00_3362,BgL_kz00_3381); } 
{ /* Inline/recursion.scm 290 */
int BgL_kz00_3383;
BgL_kz00_3383 = 
(int)(BgL_restz00_3369); 
BgL_method2819z00_3359 = 
VECTOR_REF(BgL_bucketz00_3371,BgL_kz00_3383); } } } } } } } } 
BgL_arg3761z00_2050 = 
PROCEDURE_ENTRY(BgL_method2819z00_3359)(BgL_method2819z00_3359, 
(obj_t)(BgL_arg3780z00_2056), 
(obj_t)(BgL_varz00_3358), BEOA); } } } 
{ /* Inline/recursion.scm 288 */
obj_t BgL_list3763z00_2051;
{ /* Inline/recursion.scm 288 */
obj_t BgL_arg3765z00_2052;
{ /* Inline/recursion.scm 288 */
obj_t BgL_arg3768z00_2053;
BgL_arg3768z00_2053 = 
MAKE_PAIR(BgL_arg3761z00_2050, BNIL); 
BgL_arg3765z00_2052 = 
MAKE_PAIR(BgL_arg3760z00_2049, BgL_arg3768z00_2053); } 
BgL_list3763z00_2051 = 
MAKE_PAIR(BgL_arg3759z00_2048, BgL_arg3765z00_2052); } 
return 
BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list3763z00_2051);} } } } 
}



/* find-recursive-calls-conditional2836 */
obj_t BGl_findzd2recursivezd2callszd2conditional2836zd2zzinline_recursionz00(obj_t BgL_envz00_3847, obj_t BgL_nodez00_3848, obj_t BgL_varz00_3849)
{ AN_OBJECT;
{ /* Inline/recursion.scm 277 */
{ 
BgL_conditionalz00_bglt BgL_nodez00_2027;obj_t BgL_varz00_2028;
BgL_nodez00_2027 = 
(BgL_conditionalz00_bglt)(BgL_nodez00_3848); 
BgL_varz00_2028 = BgL_varz00_3849; 
{ /* Inline/recursion.scm 279 */
obj_t BgL_arg3727z00_2032;obj_t BgL_arg3728z00_2033;obj_t BgL_arg3730z00_2034;
{ /* Inline/recursion.scm 279 */
BgL_nodez00_bglt BgL_arg3741z00_2038;
BgL_arg3741z00_2038 = 
(((BgL_conditionalz00_bglt)CREF(BgL_nodez00_2027))->BgL_testz00); 
{ /* Inline/recursion.scm 279 */
BgL_variablez00_bglt BgL_varz00_3218;
BgL_varz00_3218 = 
(BgL_variablez00_bglt)(BgL_varz00_2028); 
{ /* Inline/recursion.scm 279 */
obj_t BgL_method2819z00_3219;
{ /* Inline/recursion.scm 279 */
long BgL_objzd2classzd2numz00_3221;
{ /* Inline/recursion.scm 279 */
BgL_objectz00_bglt BgL_auxz00_4987;
BgL_auxz00_4987 = 
(BgL_objectz00_bglt)(BgL_arg3741z00_2038); 
BgL_objzd2classzd2numz00_3221 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_4987); } 
{ /* Inline/recursion.scm 279 */
obj_t BgL_arg1904z00_3222;
{ /* Inline/recursion.scm 279 */
int BgL_auxz00_4990;
BgL_auxz00_4990 = 
(int)(((long)1)); 
BgL_arg1904z00_3222 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_4990); } 
{ /* Inline/recursion.scm 279 */
long BgL_offsetz00_3226;
{ /* Inline/recursion.scm 279 */
long BgL_auxz00_4993;
{ /* Inline/recursion.scm 279 */
int BgL_auxz00_4994;
BgL_auxz00_4994 = 
(int)(BgL_objzd2classzd2numz00_3221); 
BgL_auxz00_4993 = 
(long)(BgL_auxz00_4994); } 
BgL_offsetz00_3226 = 
(BgL_auxz00_4993-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 279 */
long BgL_modz00_3227;
{ /* Inline/recursion.scm 279 */
long BgL_auxz00_4998;
{ /* Inline/recursion.scm 279 */
int BgL_auxz00_4999;
BgL_auxz00_4999 = 
(int)(((long)8)); 
BgL_auxz00_4998 = 
(long)(BgL_auxz00_4999); } 
BgL_modz00_3227 = 
(BgL_offsetz00_3226/BgL_auxz00_4998); } 
{ /* Inline/recursion.scm 279 */
long BgL_restz00_3229;
{ /* Inline/recursion.scm 279 */
long BgL_auxz00_5003;
{ /* Inline/recursion.scm 279 */
int BgL_auxz00_5004;
BgL_auxz00_5004 = 
(int)(((long)8)); 
BgL_auxz00_5003 = 
(long)(BgL_auxz00_5004); } 
BgL_restz00_3229 = 
(BgL_offsetz00_3226%BgL_auxz00_5003); } 
{ /* Inline/recursion.scm 279 */

{ /* Inline/recursion.scm 279 */
obj_t BgL_bucketz00_3231;
{ /* Inline/recursion.scm 279 */
int BgL_kz00_3241;
BgL_kz00_3241 = 
(int)(BgL_modz00_3227); 
BgL_bucketz00_3231 = 
VECTOR_REF(BgL_arg1904z00_3222,BgL_kz00_3241); } 
{ /* Inline/recursion.scm 279 */
int BgL_kz00_3243;
BgL_kz00_3243 = 
(int)(BgL_restz00_3229); 
BgL_method2819z00_3219 = 
VECTOR_REF(BgL_bucketz00_3231,BgL_kz00_3243); } } } } } } } } 
BgL_arg3727z00_2032 = 
PROCEDURE_ENTRY(BgL_method2819z00_3219)(BgL_method2819z00_3219, 
(obj_t)(BgL_arg3741z00_2038), 
(obj_t)(BgL_varz00_3218), BEOA); } } } 
{ /* Inline/recursion.scm 280 */
BgL_nodez00_bglt BgL_arg3745z00_2039;
BgL_arg3745z00_2039 = 
(((BgL_conditionalz00_bglt)CREF(BgL_nodez00_2027))->BgL_truez00); 
{ /* Inline/recursion.scm 280 */
BgL_variablez00_bglt BgL_varz00_3246;
BgL_varz00_3246 = 
(BgL_variablez00_bglt)(BgL_varz00_2028); 
{ /* Inline/recursion.scm 280 */
obj_t BgL_method2819z00_3247;
{ /* Inline/recursion.scm 280 */
long BgL_objzd2classzd2numz00_3249;
{ /* Inline/recursion.scm 280 */
BgL_objectz00_bglt BgL_auxz00_5018;
BgL_auxz00_5018 = 
(BgL_objectz00_bglt)(BgL_arg3745z00_2039); 
BgL_objzd2classzd2numz00_3249 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_5018); } 
{ /* Inline/recursion.scm 280 */
obj_t BgL_arg1904z00_3250;
{ /* Inline/recursion.scm 280 */
int BgL_auxz00_5021;
BgL_auxz00_5021 = 
(int)(((long)1)); 
BgL_arg1904z00_3250 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_5021); } 
{ /* Inline/recursion.scm 280 */
long BgL_offsetz00_3254;
{ /* Inline/recursion.scm 280 */
long BgL_auxz00_5024;
{ /* Inline/recursion.scm 280 */
int BgL_auxz00_5025;
BgL_auxz00_5025 = 
(int)(BgL_objzd2classzd2numz00_3249); 
BgL_auxz00_5024 = 
(long)(BgL_auxz00_5025); } 
BgL_offsetz00_3254 = 
(BgL_auxz00_5024-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 280 */
long BgL_modz00_3255;
{ /* Inline/recursion.scm 280 */
long BgL_auxz00_5029;
{ /* Inline/recursion.scm 280 */
int BgL_auxz00_5030;
BgL_auxz00_5030 = 
(int)(((long)8)); 
BgL_auxz00_5029 = 
(long)(BgL_auxz00_5030); } 
BgL_modz00_3255 = 
(BgL_offsetz00_3254/BgL_auxz00_5029); } 
{ /* Inline/recursion.scm 280 */
long BgL_restz00_3257;
{ /* Inline/recursion.scm 280 */
long BgL_auxz00_5034;
{ /* Inline/recursion.scm 280 */
int BgL_auxz00_5035;
BgL_auxz00_5035 = 
(int)(((long)8)); 
BgL_auxz00_5034 = 
(long)(BgL_auxz00_5035); } 
BgL_restz00_3257 = 
(BgL_offsetz00_3254%BgL_auxz00_5034); } 
{ /* Inline/recursion.scm 280 */

{ /* Inline/recursion.scm 280 */
obj_t BgL_bucketz00_3259;
{ /* Inline/recursion.scm 280 */
int BgL_kz00_3269;
BgL_kz00_3269 = 
(int)(BgL_modz00_3255); 
BgL_bucketz00_3259 = 
VECTOR_REF(BgL_arg1904z00_3250,BgL_kz00_3269); } 
{ /* Inline/recursion.scm 280 */
int BgL_kz00_3271;
BgL_kz00_3271 = 
(int)(BgL_restz00_3257); 
BgL_method2819z00_3247 = 
VECTOR_REF(BgL_bucketz00_3259,BgL_kz00_3271); } } } } } } } } 
BgL_arg3728z00_2033 = 
PROCEDURE_ENTRY(BgL_method2819z00_3247)(BgL_method2819z00_3247, 
(obj_t)(BgL_arg3745z00_2039), 
(obj_t)(BgL_varz00_3246), BEOA); } } } 
{ /* Inline/recursion.scm 281 */
BgL_nodez00_bglt BgL_arg3749z00_2040;
BgL_arg3749z00_2040 = 
(((BgL_conditionalz00_bglt)CREF(BgL_nodez00_2027))->BgL_falsez00); 
{ /* Inline/recursion.scm 281 */
BgL_variablez00_bglt BgL_varz00_3274;
BgL_varz00_3274 = 
(BgL_variablez00_bglt)(BgL_varz00_2028); 
{ /* Inline/recursion.scm 281 */
obj_t BgL_method2819z00_3275;
{ /* Inline/recursion.scm 281 */
long BgL_objzd2classzd2numz00_3277;
{ /* Inline/recursion.scm 281 */
BgL_objectz00_bglt BgL_auxz00_5049;
BgL_auxz00_5049 = 
(BgL_objectz00_bglt)(BgL_arg3749z00_2040); 
BgL_objzd2classzd2numz00_3277 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_5049); } 
{ /* Inline/recursion.scm 281 */
obj_t BgL_arg1904z00_3278;
{ /* Inline/recursion.scm 281 */
int BgL_auxz00_5052;
BgL_auxz00_5052 = 
(int)(((long)1)); 
BgL_arg1904z00_3278 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_5052); } 
{ /* Inline/recursion.scm 281 */
long BgL_offsetz00_3282;
{ /* Inline/recursion.scm 281 */
long BgL_auxz00_5055;
{ /* Inline/recursion.scm 281 */
int BgL_auxz00_5056;
BgL_auxz00_5056 = 
(int)(BgL_objzd2classzd2numz00_3277); 
BgL_auxz00_5055 = 
(long)(BgL_auxz00_5056); } 
BgL_offsetz00_3282 = 
(BgL_auxz00_5055-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 281 */
long BgL_modz00_3283;
{ /* Inline/recursion.scm 281 */
long BgL_auxz00_5060;
{ /* Inline/recursion.scm 281 */
int BgL_auxz00_5061;
BgL_auxz00_5061 = 
(int)(((long)8)); 
BgL_auxz00_5060 = 
(long)(BgL_auxz00_5061); } 
BgL_modz00_3283 = 
(BgL_offsetz00_3282/BgL_auxz00_5060); } 
{ /* Inline/recursion.scm 281 */
long BgL_restz00_3285;
{ /* Inline/recursion.scm 281 */
long BgL_auxz00_5065;
{ /* Inline/recursion.scm 281 */
int BgL_auxz00_5066;
BgL_auxz00_5066 = 
(int)(((long)8)); 
BgL_auxz00_5065 = 
(long)(BgL_auxz00_5066); } 
BgL_restz00_3285 = 
(BgL_offsetz00_3282%BgL_auxz00_5065); } 
{ /* Inline/recursion.scm 281 */

{ /* Inline/recursion.scm 281 */
obj_t BgL_bucketz00_3287;
{ /* Inline/recursion.scm 281 */
int BgL_kz00_3297;
BgL_kz00_3297 = 
(int)(BgL_modz00_3283); 
BgL_bucketz00_3287 = 
VECTOR_REF(BgL_arg1904z00_3278,BgL_kz00_3297); } 
{ /* Inline/recursion.scm 281 */
int BgL_kz00_3299;
BgL_kz00_3299 = 
(int)(BgL_restz00_3285); 
BgL_method2819z00_3275 = 
VECTOR_REF(BgL_bucketz00_3287,BgL_kz00_3299); } } } } } } } } 
BgL_arg3730z00_2034 = 
PROCEDURE_ENTRY(BgL_method2819z00_3275)(BgL_method2819z00_3275, 
(obj_t)(BgL_arg3749z00_2040), 
(obj_t)(BgL_varz00_3274), BEOA); } } } 
{ /* Inline/recursion.scm 279 */
obj_t BgL_list3732z00_2035;
{ /* Inline/recursion.scm 279 */
obj_t BgL_arg3734z00_2036;
{ /* Inline/recursion.scm 279 */
obj_t BgL_arg3737z00_2037;
BgL_arg3737z00_2037 = 
MAKE_PAIR(BgL_arg3730z00_2034, BNIL); 
BgL_arg3734z00_2036 = 
MAKE_PAIR(BgL_arg3728z00_2033, BgL_arg3737z00_2037); } 
BgL_list3732z00_2035 = 
MAKE_PAIR(BgL_arg3727z00_2032, BgL_arg3734z00_2036); } 
return 
BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list3732z00_2035);} } } } 
}



/* find-recursive-calls-setq2834 */
obj_t BGl_findzd2recursivezd2callszd2setq2834zd2zzinline_recursionz00(obj_t BgL_envz00_3850, obj_t BgL_nodez00_3851, obj_t BgL_varz00_3852)
{ AN_OBJECT;
{ /* Inline/recursion.scm 271 */
{ 
BgL_setqz00_bglt BgL_nodez00_2020;obj_t BgL_varz00_2021;
BgL_nodez00_2020 = 
(BgL_setqz00_bglt)(BgL_nodez00_3851); 
BgL_varz00_2021 = BgL_varz00_3852; 
{ /* Inline/recursion.scm 272 */
BgL_nodez00_bglt BgL_arg3717z00_3187;
BgL_arg3717z00_3187 = 
(((BgL_setqz00_bglt)CREF(BgL_nodez00_2020))->BgL_valuez00); 
{ /* Inline/recursion.scm 272 */
BgL_variablez00_bglt BgL_varz00_3190;
BgL_varz00_3190 = 
(BgL_variablez00_bglt)(BgL_varz00_2021); 
{ /* Inline/recursion.scm 272 */
obj_t BgL_method2819z00_3191;
{ /* Inline/recursion.scm 272 */
long BgL_objzd2classzd2numz00_3193;
{ /* Inline/recursion.scm 272 */
BgL_objectz00_bglt BgL_auxz00_5085;
BgL_auxz00_5085 = 
(BgL_objectz00_bglt)(BgL_arg3717z00_3187); 
BgL_objzd2classzd2numz00_3193 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_5085); } 
{ /* Inline/recursion.scm 272 */
obj_t BgL_arg1904z00_3194;
{ /* Inline/recursion.scm 272 */
int BgL_auxz00_5088;
BgL_auxz00_5088 = 
(int)(((long)1)); 
BgL_arg1904z00_3194 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_5088); } 
{ /* Inline/recursion.scm 272 */
long BgL_offsetz00_3198;
{ /* Inline/recursion.scm 272 */
long BgL_auxz00_5091;
{ /* Inline/recursion.scm 272 */
int BgL_auxz00_5092;
BgL_auxz00_5092 = 
(int)(BgL_objzd2classzd2numz00_3193); 
BgL_auxz00_5091 = 
(long)(BgL_auxz00_5092); } 
BgL_offsetz00_3198 = 
(BgL_auxz00_5091-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 272 */
long BgL_modz00_3199;
{ /* Inline/recursion.scm 272 */
long BgL_auxz00_5096;
{ /* Inline/recursion.scm 272 */
int BgL_auxz00_5097;
BgL_auxz00_5097 = 
(int)(((long)8)); 
BgL_auxz00_5096 = 
(long)(BgL_auxz00_5097); } 
BgL_modz00_3199 = 
(BgL_offsetz00_3198/BgL_auxz00_5096); } 
{ /* Inline/recursion.scm 272 */
long BgL_restz00_3201;
{ /* Inline/recursion.scm 272 */
long BgL_auxz00_5101;
{ /* Inline/recursion.scm 272 */
int BgL_auxz00_5102;
BgL_auxz00_5102 = 
(int)(((long)8)); 
BgL_auxz00_5101 = 
(long)(BgL_auxz00_5102); } 
BgL_restz00_3201 = 
(BgL_offsetz00_3198%BgL_auxz00_5101); } 
{ /* Inline/recursion.scm 272 */

{ /* Inline/recursion.scm 272 */
obj_t BgL_bucketz00_3203;
{ /* Inline/recursion.scm 272 */
int BgL_kz00_3213;
BgL_kz00_3213 = 
(int)(BgL_modz00_3199); 
BgL_bucketz00_3203 = 
VECTOR_REF(BgL_arg1904z00_3194,BgL_kz00_3213); } 
{ /* Inline/recursion.scm 272 */
int BgL_kz00_3215;
BgL_kz00_3215 = 
(int)(BgL_restz00_3201); 
BgL_method2819z00_3191 = 
VECTOR_REF(BgL_bucketz00_3203,BgL_kz00_3215); } } } } } } } } 
return 
PROCEDURE_ENTRY(BgL_method2819z00_3191)(BgL_method2819z00_3191, 
(obj_t)(BgL_arg3717z00_3187), 
(obj_t)(BgL_varz00_3190), BEOA);} } } } } 
}



/* find-recursive-calls-cast2832 */
obj_t BGl_findzd2recursivezd2callszd2cast2832zd2zzinline_recursionz00(obj_t BgL_envz00_3853, obj_t BgL_nodez00_3854, obj_t BgL_varz00_3855)
{ AN_OBJECT;
{ /* Inline/recursion.scm 265 */
{ 
BgL_castz00_bglt BgL_nodez00_2013;obj_t BgL_varz00_2014;
BgL_nodez00_2013 = 
(BgL_castz00_bglt)(BgL_nodez00_3854); 
BgL_varz00_2014 = BgL_varz00_3855; 
{ /* Inline/recursion.scm 266 */
BgL_nodez00_bglt BgL_arg3707z00_3158;
BgL_arg3707z00_3158 = 
(((BgL_castz00_bglt)CREF(BgL_nodez00_2013))->BgL_argz00); 
{ /* Inline/recursion.scm 266 */
BgL_variablez00_bglt BgL_varz00_3161;
BgL_varz00_3161 = 
(BgL_variablez00_bglt)(BgL_varz00_2014); 
{ /* Inline/recursion.scm 266 */
obj_t BgL_method2819z00_3162;
{ /* Inline/recursion.scm 266 */
long BgL_objzd2classzd2numz00_3164;
{ /* Inline/recursion.scm 266 */
BgL_objectz00_bglt BgL_auxz00_5117;
BgL_auxz00_5117 = 
(BgL_objectz00_bglt)(BgL_arg3707z00_3158); 
BgL_objzd2classzd2numz00_3164 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_5117); } 
{ /* Inline/recursion.scm 266 */
obj_t BgL_arg1904z00_3165;
{ /* Inline/recursion.scm 266 */
int BgL_auxz00_5120;
BgL_auxz00_5120 = 
(int)(((long)1)); 
BgL_arg1904z00_3165 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_5120); } 
{ /* Inline/recursion.scm 266 */
long BgL_offsetz00_3169;
{ /* Inline/recursion.scm 266 */
long BgL_auxz00_5123;
{ /* Inline/recursion.scm 266 */
int BgL_auxz00_5124;
BgL_auxz00_5124 = 
(int)(BgL_objzd2classzd2numz00_3164); 
BgL_auxz00_5123 = 
(long)(BgL_auxz00_5124); } 
BgL_offsetz00_3169 = 
(BgL_auxz00_5123-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 266 */
long BgL_modz00_3170;
{ /* Inline/recursion.scm 266 */
long BgL_auxz00_5128;
{ /* Inline/recursion.scm 266 */
int BgL_auxz00_5129;
BgL_auxz00_5129 = 
(int)(((long)8)); 
BgL_auxz00_5128 = 
(long)(BgL_auxz00_5129); } 
BgL_modz00_3170 = 
(BgL_offsetz00_3169/BgL_auxz00_5128); } 
{ /* Inline/recursion.scm 266 */
long BgL_restz00_3172;
{ /* Inline/recursion.scm 266 */
long BgL_auxz00_5133;
{ /* Inline/recursion.scm 266 */
int BgL_auxz00_5134;
BgL_auxz00_5134 = 
(int)(((long)8)); 
BgL_auxz00_5133 = 
(long)(BgL_auxz00_5134); } 
BgL_restz00_3172 = 
(BgL_offsetz00_3169%BgL_auxz00_5133); } 
{ /* Inline/recursion.scm 266 */

{ /* Inline/recursion.scm 266 */
obj_t BgL_bucketz00_3174;
{ /* Inline/recursion.scm 266 */
int BgL_kz00_3184;
BgL_kz00_3184 = 
(int)(BgL_modz00_3170); 
BgL_bucketz00_3174 = 
VECTOR_REF(BgL_arg1904z00_3165,BgL_kz00_3184); } 
{ /* Inline/recursion.scm 266 */
int BgL_kz00_3186;
BgL_kz00_3186 = 
(int)(BgL_restz00_3172); 
BgL_method2819z00_3162 = 
VECTOR_REF(BgL_bucketz00_3174,BgL_kz00_3186); } } } } } } } } 
return 
PROCEDURE_ENTRY(BgL_method2819z00_3162)(BgL_method2819z00_3162, 
(obj_t)(BgL_arg3707z00_3158), 
(obj_t)(BgL_varz00_3161), BEOA);} } } } } 
}



/* find-recursive-calls-extern2830 */
obj_t BGl_findzd2recursivezd2callszd2extern2830zd2zzinline_recursionz00(obj_t BgL_envz00_3856, obj_t BgL_nodez00_3857, obj_t BgL_varz00_3858)
{ AN_OBJECT;
{ /* Inline/recursion.scm 259 */
{ 
BgL_externz00_bglt BgL_nodez00_2006;obj_t BgL_varz00_2007;
BgL_nodez00_2006 = 
(BgL_externz00_bglt)(BgL_nodez00_3857); 
BgL_varz00_2007 = BgL_varz00_3858; 
return 
BGl_findzd2recursivezd2callsza2za2zzinline_recursionz00(
(((BgL_externz00_bglt)CREF(BgL_nodez00_2006))->BgL_exprza2za2), BgL_varz00_2007);} } 
}



/* find-recursive-calls-funcall2828 */
obj_t BGl_findzd2recursivezd2callszd2funcall2828zd2zzinline_recursionz00(obj_t BgL_envz00_3859, obj_t BgL_nodez00_3860, obj_t BgL_varz00_3861)
{ AN_OBJECT;
{ /* Inline/recursion.scm 251 */
{ 
BgL_funcallz00_bglt BgL_nodez00_1995;obj_t BgL_varz00_1996;
BgL_nodez00_1995 = 
(BgL_funcallz00_bglt)(BgL_nodez00_3860); 
BgL_varz00_1996 = BgL_varz00_3861; 
{ /* Inline/recursion.scm 253 */
obj_t BgL_arg3678z00_2000;obj_t BgL_arg3679z00_2001;
{ /* Inline/recursion.scm 253 */
BgL_nodez00_bglt BgL_arg3683z00_2002;
BgL_arg3683z00_2002 = 
(((BgL_funcallz00_bglt)CREF(BgL_nodez00_1995))->BgL_funz00); 
{ /* Inline/recursion.scm 253 */
BgL_variablez00_bglt BgL_varz00_3129;
BgL_varz00_3129 = 
(BgL_variablez00_bglt)(BgL_varz00_1996); 
{ /* Inline/recursion.scm 253 */
obj_t BgL_method2819z00_3130;
{ /* Inline/recursion.scm 253 */
long BgL_objzd2classzd2numz00_3132;
{ /* Inline/recursion.scm 253 */
BgL_objectz00_bglt BgL_auxz00_5152;
BgL_auxz00_5152 = 
(BgL_objectz00_bglt)(BgL_arg3683z00_2002); 
BgL_objzd2classzd2numz00_3132 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_5152); } 
{ /* Inline/recursion.scm 253 */
obj_t BgL_arg1904z00_3133;
{ /* Inline/recursion.scm 253 */
int BgL_auxz00_5155;
BgL_auxz00_5155 = 
(int)(((long)1)); 
BgL_arg1904z00_3133 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_5155); } 
{ /* Inline/recursion.scm 253 */
long BgL_offsetz00_3137;
{ /* Inline/recursion.scm 253 */
long BgL_auxz00_5158;
{ /* Inline/recursion.scm 253 */
int BgL_auxz00_5159;
BgL_auxz00_5159 = 
(int)(BgL_objzd2classzd2numz00_3132); 
BgL_auxz00_5158 = 
(long)(BgL_auxz00_5159); } 
BgL_offsetz00_3137 = 
(BgL_auxz00_5158-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 253 */
long BgL_modz00_3138;
{ /* Inline/recursion.scm 253 */
long BgL_auxz00_5163;
{ /* Inline/recursion.scm 253 */
int BgL_auxz00_5164;
BgL_auxz00_5164 = 
(int)(((long)8)); 
BgL_auxz00_5163 = 
(long)(BgL_auxz00_5164); } 
BgL_modz00_3138 = 
(BgL_offsetz00_3137/BgL_auxz00_5163); } 
{ /* Inline/recursion.scm 253 */
long BgL_restz00_3140;
{ /* Inline/recursion.scm 253 */
long BgL_auxz00_5168;
{ /* Inline/recursion.scm 253 */
int BgL_auxz00_5169;
BgL_auxz00_5169 = 
(int)(((long)8)); 
BgL_auxz00_5168 = 
(long)(BgL_auxz00_5169); } 
BgL_restz00_3140 = 
(BgL_offsetz00_3137%BgL_auxz00_5168); } 
{ /* Inline/recursion.scm 253 */

{ /* Inline/recursion.scm 253 */
obj_t BgL_bucketz00_3142;
{ /* Inline/recursion.scm 253 */
int BgL_kz00_3152;
BgL_kz00_3152 = 
(int)(BgL_modz00_3138); 
BgL_bucketz00_3142 = 
VECTOR_REF(BgL_arg1904z00_3133,BgL_kz00_3152); } 
{ /* Inline/recursion.scm 253 */
int BgL_kz00_3154;
BgL_kz00_3154 = 
(int)(BgL_restz00_3140); 
BgL_method2819z00_3130 = 
VECTOR_REF(BgL_bucketz00_3142,BgL_kz00_3154); } } } } } } } } 
BgL_arg3678z00_2000 = 
PROCEDURE_ENTRY(BgL_method2819z00_3130)(BgL_method2819z00_3130, 
(obj_t)(BgL_arg3683z00_2002), 
(obj_t)(BgL_varz00_3129), BEOA); } } } 
BgL_arg3679z00_2001 = 
BGl_findzd2recursivezd2callsza2za2zzinline_recursionz00(
(((BgL_funcallz00_bglt)CREF(BgL_nodez00_1995))->BgL_argsz00), BgL_varz00_1996); 
return 
bgl_append2(BgL_arg3678z00_2000, BgL_arg3679z00_2001);} } } 
}



/* find-recursive-calls-app-ly2826 */
obj_t BGl_findzd2recursivezd2callszd2appzd2ly2826z00zzinline_recursionz00(obj_t BgL_envz00_3862, obj_t BgL_nodez00_3863, obj_t BgL_varz00_3864)
{ AN_OBJECT;
{ /* Inline/recursion.scm 244 */
{ 
BgL_appzd2lyzd2_bglt BgL_nodez00_1984;obj_t BgL_varz00_1985;
BgL_nodez00_1984 = 
(BgL_appzd2lyzd2_bglt)(BgL_nodez00_3863); 
BgL_varz00_1985 = BgL_varz00_3864; 
{ /* Inline/recursion.scm 246 */
obj_t BgL_arg3660z00_1989;obj_t BgL_arg3661z00_1990;
{ /* Inline/recursion.scm 246 */
BgL_nodez00_bglt BgL_arg3664z00_1991;
BgL_arg3664z00_1991 = 
(((BgL_appzd2lyzd2_bglt)CREF(BgL_nodez00_1984))->BgL_funz00); 
{ /* Inline/recursion.scm 246 */
BgL_variablez00_bglt BgL_varz00_3073;
BgL_varz00_3073 = 
(BgL_variablez00_bglt)(BgL_varz00_1985); 
{ /* Inline/recursion.scm 246 */
obj_t BgL_method2819z00_3074;
{ /* Inline/recursion.scm 246 */
long BgL_objzd2classzd2numz00_3076;
{ /* Inline/recursion.scm 246 */
BgL_objectz00_bglt BgL_auxz00_5187;
BgL_auxz00_5187 = 
(BgL_objectz00_bglt)(BgL_arg3664z00_1991); 
BgL_objzd2classzd2numz00_3076 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_5187); } 
{ /* Inline/recursion.scm 246 */
obj_t BgL_arg1904z00_3077;
{ /* Inline/recursion.scm 246 */
int BgL_auxz00_5190;
BgL_auxz00_5190 = 
(int)(((long)1)); 
BgL_arg1904z00_3077 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_5190); } 
{ /* Inline/recursion.scm 246 */
long BgL_offsetz00_3081;
{ /* Inline/recursion.scm 246 */
long BgL_auxz00_5193;
{ /* Inline/recursion.scm 246 */
int BgL_auxz00_5194;
BgL_auxz00_5194 = 
(int)(BgL_objzd2classzd2numz00_3076); 
BgL_auxz00_5193 = 
(long)(BgL_auxz00_5194); } 
BgL_offsetz00_3081 = 
(BgL_auxz00_5193-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 246 */
long BgL_modz00_3082;
{ /* Inline/recursion.scm 246 */
long BgL_auxz00_5198;
{ /* Inline/recursion.scm 246 */
int BgL_auxz00_5199;
BgL_auxz00_5199 = 
(int)(((long)8)); 
BgL_auxz00_5198 = 
(long)(BgL_auxz00_5199); } 
BgL_modz00_3082 = 
(BgL_offsetz00_3081/BgL_auxz00_5198); } 
{ /* Inline/recursion.scm 246 */
long BgL_restz00_3084;
{ /* Inline/recursion.scm 246 */
long BgL_auxz00_5203;
{ /* Inline/recursion.scm 246 */
int BgL_auxz00_5204;
BgL_auxz00_5204 = 
(int)(((long)8)); 
BgL_auxz00_5203 = 
(long)(BgL_auxz00_5204); } 
BgL_restz00_3084 = 
(BgL_offsetz00_3081%BgL_auxz00_5203); } 
{ /* Inline/recursion.scm 246 */

{ /* Inline/recursion.scm 246 */
obj_t BgL_bucketz00_3086;
{ /* Inline/recursion.scm 246 */
int BgL_kz00_3096;
BgL_kz00_3096 = 
(int)(BgL_modz00_3082); 
BgL_bucketz00_3086 = 
VECTOR_REF(BgL_arg1904z00_3077,BgL_kz00_3096); } 
{ /* Inline/recursion.scm 246 */
int BgL_kz00_3098;
BgL_kz00_3098 = 
(int)(BgL_restz00_3084); 
BgL_method2819z00_3074 = 
VECTOR_REF(BgL_bucketz00_3086,BgL_kz00_3098); } } } } } } } } 
BgL_arg3660z00_1989 = 
PROCEDURE_ENTRY(BgL_method2819z00_3074)(BgL_method2819z00_3074, 
(obj_t)(BgL_arg3664z00_1991), 
(obj_t)(BgL_varz00_3073), BEOA); } } } 
{ /* Inline/recursion.scm 246 */
BgL_nodez00_bglt BgL_arg3668z00_1992;
BgL_arg3668z00_1992 = 
(((BgL_appzd2lyzd2_bglt)CREF(BgL_nodez00_1984))->BgL_argz00); 
{ /* Inline/recursion.scm 246 */
BgL_variablez00_bglt BgL_varz00_3101;
BgL_varz00_3101 = 
(BgL_variablez00_bglt)(BgL_varz00_1985); 
{ /* Inline/recursion.scm 246 */
obj_t BgL_method2819z00_3102;
{ /* Inline/recursion.scm 246 */
long BgL_objzd2classzd2numz00_3104;
{ /* Inline/recursion.scm 246 */
BgL_objectz00_bglt BgL_auxz00_5218;
BgL_auxz00_5218 = 
(BgL_objectz00_bglt)(BgL_arg3668z00_1992); 
BgL_objzd2classzd2numz00_3104 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_5218); } 
{ /* Inline/recursion.scm 246 */
obj_t BgL_arg1904z00_3105;
{ /* Inline/recursion.scm 246 */
int BgL_auxz00_5221;
BgL_auxz00_5221 = 
(int)(((long)1)); 
BgL_arg1904z00_3105 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_5221); } 
{ /* Inline/recursion.scm 246 */
long BgL_offsetz00_3109;
{ /* Inline/recursion.scm 246 */
long BgL_auxz00_5224;
{ /* Inline/recursion.scm 246 */
int BgL_auxz00_5225;
BgL_auxz00_5225 = 
(int)(BgL_objzd2classzd2numz00_3104); 
BgL_auxz00_5224 = 
(long)(BgL_auxz00_5225); } 
BgL_offsetz00_3109 = 
(BgL_auxz00_5224-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 246 */
long BgL_modz00_3110;
{ /* Inline/recursion.scm 246 */
long BgL_auxz00_5229;
{ /* Inline/recursion.scm 246 */
int BgL_auxz00_5230;
BgL_auxz00_5230 = 
(int)(((long)8)); 
BgL_auxz00_5229 = 
(long)(BgL_auxz00_5230); } 
BgL_modz00_3110 = 
(BgL_offsetz00_3109/BgL_auxz00_5229); } 
{ /* Inline/recursion.scm 246 */
long BgL_restz00_3112;
{ /* Inline/recursion.scm 246 */
long BgL_auxz00_5234;
{ /* Inline/recursion.scm 246 */
int BgL_auxz00_5235;
BgL_auxz00_5235 = 
(int)(((long)8)); 
BgL_auxz00_5234 = 
(long)(BgL_auxz00_5235); } 
BgL_restz00_3112 = 
(BgL_offsetz00_3109%BgL_auxz00_5234); } 
{ /* Inline/recursion.scm 246 */

{ /* Inline/recursion.scm 246 */
obj_t BgL_bucketz00_3114;
{ /* Inline/recursion.scm 246 */
int BgL_kz00_3124;
BgL_kz00_3124 = 
(int)(BgL_modz00_3110); 
BgL_bucketz00_3114 = 
VECTOR_REF(BgL_arg1904z00_3105,BgL_kz00_3124); } 
{ /* Inline/recursion.scm 246 */
int BgL_kz00_3126;
BgL_kz00_3126 = 
(int)(BgL_restz00_3112); 
BgL_method2819z00_3102 = 
VECTOR_REF(BgL_bucketz00_3114,BgL_kz00_3126); } } } } } } } } 
BgL_arg3661z00_1990 = 
PROCEDURE_ENTRY(BgL_method2819z00_3102)(BgL_method2819z00_3102, 
(obj_t)(BgL_arg3668z00_1992), 
(obj_t)(BgL_varz00_3101), BEOA); } } } 
return 
bgl_append2(BgL_arg3660z00_1989, BgL_arg3661z00_1990);} } } 
}



/* find-recursive-calls-app2824 */
obj_t BGl_findzd2recursivezd2callszd2app2824zd2zzinline_recursionz00(obj_t BgL_envz00_3865, obj_t BgL_nodez00_3866, obj_t BgL_varz00_3867)
{ AN_OBJECT;
{ /* Inline/recursion.scm 234 */
{ 
BgL_appz00_bglt BgL_nodez00_1970;obj_t BgL_varz00_1971;
BgL_nodez00_1970 = 
(BgL_appz00_bglt)(BgL_nodez00_3866); 
BgL_varz00_1971 = BgL_varz00_3867; 
{ /* Inline/recursion.scm 236 */
obj_t BgL_argszd2callszd2_1975;
BgL_argszd2callszd2_1975 = 
BGl_findzd2recursivezd2callsza2za2zzinline_recursionz00(
(((BgL_appz00_bglt)CREF(BgL_nodez00_1970))->BgL_argsz00), BgL_varz00_1971); 
{ /* Inline/recursion.scm 237 */
bool_t BgL_test3635z00_1976;
{ /* Inline/recursion.scm 237 */
bool_t BgL_test3637z00_1977;
{ /* Inline/recursion.scm 237 */
obj_t BgL_auxz00_5251;
{ /* Inline/recursion.scm 237 */
BgL_varz00_bglt BgL_auxz00_5252;
BgL_auxz00_5252 = 
(((BgL_appz00_bglt)CREF(BgL_nodez00_1970))->BgL_funz00); 
BgL_auxz00_5251 = 
(obj_t)(BgL_auxz00_5252); } 
BgL_test3637z00_1977 = 
BGl_iszd2azf3z21zz__objectz00(BgL_auxz00_5251, BGl_varz00zzast_nodez00); } 
if(BgL_test3637z00_1977)
{ /* Inline/recursion.scm 237 */
obj_t BgL_auxz00_5257;
{ /* Inline/recursion.scm 237 */
BgL_variablez00_bglt BgL_auxz00_5258;
{ /* Inline/recursion.scm 237 */
BgL_varz00_bglt BgL_arg3642z00_1979;
BgL_arg3642z00_1979 = 
(((BgL_appz00_bglt)CREF(BgL_nodez00_1970))->BgL_funz00); 
BgL_auxz00_5258 = 
(((BgL_varz00_bglt)CREF(BgL_arg3642z00_1979))->BgL_variablez00); } 
BgL_auxz00_5257 = 
(obj_t)(BgL_auxz00_5258); } 
BgL_test3635z00_1976 = 
(BgL_auxz00_5257==BgL_varz00_1971); }  else 
{ /* Inline/recursion.scm 237 */
BgL_test3635z00_1976 = ((bool_t)0); } } 
if(BgL_test3635z00_1976)
{ /* Inline/recursion.scm 238 */
obj_t BgL_auxz00_5264;
BgL_auxz00_5264 = 
(obj_t)(BgL_nodez00_1970); 
return 
MAKE_PAIR(BgL_auxz00_5264, BgL_argszd2callszd2_1975);}  else 
{ /* Inline/recursion.scm 237 */
return BgL_argszd2callszd2_1975;} } } } } 
}



/* find-recursive-calls-sequence2822 */
obj_t BGl_findzd2recursivezd2callszd2sequence2822zd2zzinline_recursionz00(obj_t BgL_envz00_3868, obj_t BgL_nodez00_3869, obj_t BgL_varz00_3870)
{ AN_OBJECT;
{ /* Inline/recursion.scm 225 */
{ 
BgL_sequencez00_bglt BgL_nodez00_1963;obj_t BgL_varz00_1964;
BgL_nodez00_1963 = 
(BgL_sequencez00_bglt)(BgL_nodez00_3869); 
BgL_varz00_1964 = BgL_varz00_3870; 
return 
BGl_findzd2recursivezd2callsza2za2zzinline_recursionz00(
(((BgL_sequencez00_bglt)CREF(BgL_nodez00_1963))->BgL_nodesz00), BgL_varz00_1964);} } 
}



/* find-recursive-calls */
obj_t BGl_findzd2recursivezd2callsz00zzinline_recursionz00(BgL_nodez00_bglt BgL_nodez00_19, BgL_variablez00_bglt BgL_varz00_20)
{ AN_OBJECT;
{ /* Inline/recursion.scm 219 */
{ /* Inline/recursion.scm 219 */
obj_t BgL_method2819z00_3764;
{ /* Inline/recursion.scm 219 */
long BgL_objzd2classzd2numz00_3766;
{ /* Inline/recursion.scm 219 */
BgL_objectz00_bglt BgL_auxz00_5271;
BgL_auxz00_5271 = 
(BgL_objectz00_bglt)(BgL_nodez00_19); 
BgL_objzd2classzd2numz00_3766 = 
BGL_OBJECT_CLASS_NUM(BgL_auxz00_5271); } 
{ /* Inline/recursion.scm 219 */
obj_t BgL_arg1904z00_3767;
{ /* Inline/recursion.scm 219 */
int BgL_auxz00_5274;
BgL_auxz00_5274 = 
(int)(((long)1)); 
BgL_arg1904z00_3767 = 
PROCEDURE_REF(BGl_findzd2recursivezd2callszd2envzd2zzinline_recursionz00, BgL_auxz00_5274); } 
{ /* Inline/recursion.scm 219 */
long BgL_offsetz00_3771;
{ /* Inline/recursion.scm 219 */
long BgL_auxz00_5277;
{ /* Inline/recursion.scm 219 */
int BgL_auxz00_5278;
BgL_auxz00_5278 = 
(int)(BgL_objzd2classzd2numz00_3766); 
BgL_auxz00_5277 = 
(long)(BgL_auxz00_5278); } 
BgL_offsetz00_3771 = 
(BgL_auxz00_5277-OBJECT_TYPE); } 
{ /* Inline/recursion.scm 219 */
long BgL_modz00_3772;
{ /* Inline/recursion.scm 219 */
long BgL_auxz00_5282;
{ /* Inline/recursion.scm 219 */
int BgL_auxz00_5283;
BgL_auxz00_5283 = 
(int)(((long)8)); 
BgL_auxz00_5282 = 
(long)(BgL_auxz00_5283); } 
BgL_modz00_3772 = 
(BgL_offsetz00_3771/BgL_auxz00_5282); } 
{ /* Inline/recursion.scm 219 */
long BgL_restz00_3774;
{ /* Inline/recursion.scm 219 */
long BgL_auxz00_5287;
{ /* Inline/recursion.scm 219 */
int BgL_auxz00_5288;
BgL_auxz00_5288 = 
(int)(((long)8)); 
BgL_auxz00_5287 = 
(long)(BgL_auxz00_5288); } 
BgL_restz00_3774 = 
(BgL_offsetz00_3771%BgL_auxz00_5287); } 
{ /* Inline/recursion.scm 219 */

{ /* Inline/recursion.scm 219 */
obj_t BgL_bucketz00_3776;
{ /* Inline/recursion.scm 219 */
int BgL_kz00_3786;
BgL_kz00_3786 = 
(int)(BgL_modz00_3772); 
BgL_bucketz00_3776 = 
VECTOR_REF(BgL_arg1904z00_3767,BgL_kz00_3786); } 
{ /* Inline/recursion.scm 219 */
int BgL_kz00_3788;
BgL_kz00_3788 = 
(int)(BgL_restz00_3774); 
BgL_method2819z00_3764 = 
VECTOR_REF(BgL_bucketz00_3776,BgL_kz00_3788); } } } } } } } } 
return 
PROCEDURE_ENTRY(BgL_method2819z00_3764)(BgL_method2819z00_3764, 
(obj_t)(BgL_nodez00_19), 
(obj_t)(BgL_varz00_20), BEOA);} } 
}



/* _find-recursive-calls4065 */
obj_t BGl__findzd2recursivezd2calls4065z00zzinline_recursionz00(obj_t BgL_envz00_3800, obj_t BgL_nodez00_3801, obj_t BgL_varz00_3802)
{ AN_OBJECT;
{ /* Inline/recursion.scm 219 */
return 
BGl_findzd2recursivezd2callsz00zzinline_recursionz00(
(BgL_nodez00_bglt)(BgL_nodez00_3801), 
(BgL_variablez00_bglt)(BgL_varz00_3802));} 
}



/* find-recursive-calls-default2818 */
obj_t BGl_findzd2recursivezd2callszd2default2818zd2zzinline_recursionz00(BgL_nodez00_bglt BgL_nodez00_21, BgL_variablez00_bglt BgL_varz00_22)
{ AN_OBJECT;
{ /* Inline/recursion.scm 15 */
return BNIL;} 
}



/* _find-recursive-calls-default2818 */
obj_t BGl__findzd2recursivezd2callszd2default2818zd2zzinline_recursionz00(obj_t BgL_envz00_3871, obj_t BgL_nodez00_3872, obj_t BgL_varz00_3873)
{ AN_OBJECT;
{ /* Inline/recursion.scm 15 */
return 
BGl_findzd2recursivezd2callszd2default2818zd2zzinline_recursionz00(
(BgL_nodez00_bglt)(BgL_nodez00_3872), 
(BgL_variablez00_bglt)(BgL_varz00_3873));} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzinline_recursionz00()
{ AN_OBJECT;
{ /* Inline/recursion.scm 15 */
BGl_modulezd2initializa7ationz75zztools_tracez00(((long)64647), "inline_recursion"); 
BGl_modulezd2initializa7ationz75zzengine_paramz00(((long)189840), "inline_recursion"); 
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19010), "inline_recursion"); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)28259), "inline_recursion"); 
BGl_modulezd2initializa7ationz75zzast_nodez00(((long)49436), "inline_recursion"); 
BGl_modulezd2initializa7ationz75zzast_localz00(((long)106367), "inline_recursion"); 
BGl_modulezd2initializa7ationz75zzast_alphatiza7eza7(((long)21983), "inline_recursion"); 
BGl_modulezd2initializa7ationz75zzast_sexpz00(((long)26966), "inline_recursion"); 
BGl_modulezd2initializa7ationz75zztools_speekz00(((long)23545), "inline_recursion"); 
BGl_modulezd2initializa7ationz75zztools_shapez00(((long)30825), "inline_recursion"); 
BGl_modulezd2initializa7ationz75zztools_errorz00(((long)17886), "inline_recursion"); 
BGl_modulezd2initializa7ationz75zzinline_inlinez00(((long)63028), "inline_recursion"); 
BGl_modulezd2initializa7ationz75zzinline_simplez00(((long)2013), "inline_recursion"); 
BGl_modulezd2initializa7ationz75zzinline_variantz00(((long)64429), "inline_recursion"); 
BGl_modulezd2initializa7ationz75zzinline_loopz00(((long)57154), "inline_recursion"); 
BGl_modulezd2initializa7ationz75zzinline_appz00(((long)11814), "inline_recursion"); 
return 
BGl_modulezd2initializa7ationz75zzreduce_csez00(((long)15567), "inline_recursion");} 
}

