/*===========================================================================*/
/*   (Jvm/instr.scm)                                                         */
/*   Bigloo (2.5b)                                                           */
/*   Manuel Serrano (c)       Fri Sep 6 09:43:28 CEST 2002                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_nodez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
} *BgL_nodez00_bglt;

typedef struct BgL_nodezf2effectzf2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
} *BgL_nodezf2effectzf2_bglt;

typedef struct BgL_atomz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_atomz00_bglt;

typedef struct BgL_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_varz00_bglt;

typedef struct BgL_closurez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_closurez00_bglt;

typedef struct BgL_kwotez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_kwotez00_bglt;

typedef struct BgL_sequencez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_nodesz00;
} *BgL_sequencez00_bglt;

typedef struct BgL_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
} *BgL_appz00_bglt;

typedef struct BgL_appzd2lyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_appzd2lyzd2_bglt;

typedef struct BgL_funcallz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_strengthz00;
} *BgL_funcallz00_bglt;

typedef struct BgL_externz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_externz00_bglt;

typedef struct BgL_pragmaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_formatz00;
} *BgL_pragmaz00_bglt;

typedef struct BgL_getfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_getfieldz00_bglt;

typedef struct BgL_setfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_setfieldz00_bglt;

typedef struct BgL_newz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_newz00_bglt;

typedef struct BgL_vallocz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2heapzd2formatz00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_vallocz00_bglt;

typedef struct BgL_vrefz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vrefz00_bglt;

typedef struct BgL_vsetz12z12_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vsetz12z12_bglt;

typedef struct BgL_vlengthz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vlengthz00_bglt;

typedef struct BgL_isaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   struct BgL_typez00_bgl * BgL_classz00;
} *BgL_isaz00_bglt;

typedef struct BgL_castz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_castz00_bglt;

typedef struct BgL_setqz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_setqz00_bglt;

typedef struct BgL_conditionalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   struct BgL_nodez00_bgl * BgL_truez00;
   struct BgL_nodez00_bgl * BgL_falsez00;
} *BgL_conditionalz00_bglt;

typedef struct BgL_failz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_procz00;
   struct BgL_nodez00_bgl * BgL_msgz00;
   struct BgL_nodez00_bgl * BgL_objz00;
} *BgL_failz00_bglt;

typedef struct BgL_selectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   obj_t BgL_clausesz00;
   struct BgL_typez00_bgl * BgL_itemzd2typezd2;
} *BgL_selectz00_bglt;

typedef struct BgL_letzd2funzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_localsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_letzd2funzd2_bglt;

typedef struct BgL_letzd2varzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_bindingsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
   bool_t BgL_removablezf3zf3;
} *BgL_letzd2varzd2_bglt;

typedef struct BgL_setzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_setzd2exzd2itz00_bglt;

typedef struct BgL_jumpzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_exitz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_jumpzd2exzd2itz00_bglt;

typedef struct BgL_makezd2boxzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_makezd2boxzd2_bglt;

typedef struct BgL_boxzd2refzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_varz00;
} *BgL_boxzd2refzd2_bglt;

typedef struct BgL_boxzd2setz12zc0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_boxzd2setz12zc0_bglt;

typedef struct BgL_tclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   struct BgL_globalz00_bgl * BgL_holderz00;
   obj_t BgL_wideningz00;
   long BgL_depthz00;
   bool_t BgL_finalzf3zf3;
   obj_t BgL_constructorz00;
   obj_t BgL_virtualzd2slotszd2numberz00;
   bool_t BgL_abstractzf3zf3;
} *BgL_tclassz00_bglt;

typedef struct BgL_jclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   obj_t BgL_packagez00;
} *BgL_jclassz00_bglt;

typedef struct BgL_envz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_declarationsz00;
   obj_t BgL_declaredtypez00;
   obj_t BgL_declaredclassz00;
   obj_t BgL_declaredmodulez00;
   obj_t BgL_currentzd2modulezd2;
   obj_t BgL_declaredfieldsz00;
   obj_t BgL_declaredglobalz00;
   obj_t BgL_libdeclaredz00;
   obj_t BgL_proceduresz00;
   obj_t BgL_clinitzd2codezd2;
   obj_t BgL_currentzd2methodzd2;
   obj_t BgL_vcountz00;
   obj_t BgL_localsz00;
   obj_t BgL_freelocalsz00;
   obj_t BgL_maplocalsz00;
   obj_t BgL_stackz00;
   obj_t BgL_codez00;
} *BgL_envz00_bglt;


static obj_t BGl___ddivz00zzjvm_instrz00(obj_t, obj_t);
extern obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl___arraylengthz00zzjvm_instrz00(obj_t, obj_t);
extern obj_t BGl__ixorz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl_methodzd2initzd2zzjvm_instrz00();
static obj_t BGl___newz00zzjvm_instrz00(obj_t, obj_t, obj_t);
extern obj_t BGl__iorz00zzjvm_instrz00(BgL_envz00_bglt);
static bool_t BGl_envzd2codez12zc0zzjvm_instrz00(BgL_envz00_bglt, obj_t);
static obj_t BGl___invokestaticz00zzjvm_instrz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl___getstaticz00zzjvm_instrz00(obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
static obj_t BGl___aconst_nullz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___dremz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl_zc3anonymousza33599ze3z83zzjvm_instrz00(obj_t, obj_t, obj_t);
static obj_t BGl___store_namez00zzjvm_instrz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_splitzd2stringzd2zzjvm_instrz00(obj_t, obj_t, long, obj_t);
static obj_t BGl___storez00zzjvm_instrz00(obj_t, obj_t, obj_t);
extern obj_t BGl__d2fz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl__d2iz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl__newarrayz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl__iaddz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl__d2lz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl__dcmpgz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl__instanceofz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl__dcmplz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl_ppz00zz__ppz00(obj_t, obj_t);
extern obj_t BGl_readz00zz__readerz00(obj_t);
extern obj_t BGl__dsubz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl___gotoz00zzjvm_instrz00(obj_t, obj_t, obj_t);
static obj_t BGl_pushz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl__invokespecialz00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t, obj_t);
extern obj_t BGl__invokestaticz00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t, obj_t);
extern obj_t BGl__if_icmpz00zzjvm_instrz00(obj_t, BgL_envz00_bglt, obj_t);
static obj_t BGl___swapz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___linez00zzjvm_instrz00(obj_t, obj_t, obj_t);
static bool_t BGl_envzd2newzd2labelz12z12zzjvm_instrz00(BgL_envz00_bglt, obj_t);
static obj_t BGl_flatz00zzjvm_instrz00(obj_t, obj_t);
extern obj_t BGl__inegz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl__arraylengthz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl__lxorz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl___i2bz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___i2dz00zzjvm_instrz00(obj_t, obj_t);
extern bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
extern obj_t BGl__dup2z00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl___ifz00zzjvm_instrz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl___i2lz00zzjvm_instrz00(obj_t, obj_t);
extern obj_t BGl__aconst_nullz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl__iandz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl_compilezd2typezd2zzjvm_envz00(obj_t, BgL_envz00_bglt);
static obj_t BGl___commentz00zzjvm_instrz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl___lushrz00zzjvm_instrz00(obj_t, obj_t);
extern obj_t BGl__imulz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl___ixorz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___putfieldz00zzjvm_instrz00(obj_t, obj_t, obj_t);
extern obj_t BGl__laddz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl__f2dz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl___getstatic2z00zzjvm_instrz00(obj_t, obj_t, obj_t);
static obj_t BGl__createzd2stringzd2zzjvm_instrz00(obj_t, obj_t, obj_t);
extern obj_t BGl__lorz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl___popz00zzjvm_instrz00(obj_t, obj_t, obj_t);
extern obj_t BGl__lnegz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl___iaddz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___handlerz00zzjvm_instrz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl__putfieldz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(obj_t);
extern obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl___dsubz00zzjvm_instrz00(obj_t, obj_t);
extern obj_t BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(obj_t);
extern obj_t BGl__aloadz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl__loadz00zzjvm_instrz00(BgL_envz00_bglt, BgL_localz00_bglt);
static obj_t BGl_cnstzd2initzd2zzjvm_instrz00();
static obj_t BGl___inegz00zzjvm_instrz00(obj_t, obj_t);
extern obj_t BGl__landz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl_simplezd2typezd2zzjvm_instrz00(obj_t);
extern obj_t BGl__lmulz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl___lxorz00zzjvm_instrz00(obj_t, obj_t);
extern obj_t c_substring(obj_t, int, int);
static obj_t BGl___invokevirtualz00zzjvm_instrz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl__newz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
static obj_t BGl___dup2z00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___iandz00zzjvm_instrz00(obj_t, obj_t);
extern obj_t BGl__iushrz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl_displayzd22zd2zz__r4_output_6_10_3z00(obj_t, obj_t);
static obj_t BGl___dupz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zzjvm_instrz00();
static obj_t BGl___imulz00zzjvm_instrz00(obj_t, obj_t);
extern obj_t BGl__idivz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl___if_icmpz00zzjvm_instrz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl___newarrayz00zzjvm_instrz00(obj_t, obj_t, obj_t);
extern obj_t BGl_createzd2stringzd2zzjvm_instrz00(obj_t, obj_t);
extern obj_t BGl__store_namez00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t);
static obj_t BGl___l2dz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___laddz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___l2iz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___push5545z00zzjvm_instrz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl__astorez00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl__if_acmpz00zzjvm_instrz00(obj_t, BgL_envz00_bglt, obj_t);
extern long BGl_zb2fxzb2zz__r4_numbers_6_5_fixnumz00(long, long);
static obj_t BGl_cpopz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
static obj_t BGl___lnegz00zzjvm_instrz00(obj_t, obj_t);
extern obj_t BGl__checkcastz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl__load_namez00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t);
extern obj_t BGl__switchz00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t);
extern obj_t BGl__iremz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl__invokevirtualz00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t, obj_t);
extern obj_t BGl__lcmpz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl__storez00zzjvm_instrz00(BgL_envz00_bglt, BgL_localz00_bglt);
extern obj_t BGl__i2bz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl__i2dz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl_toplevelzd2initzd2zzjvm_instrz00();
extern obj_t BGl_2zb2zb2zz__r4_numbers_6_5z00(obj_t, obj_t);
static obj_t BGl___loadz00zzjvm_instrz00(obj_t, obj_t, obj_t);
extern obj_t BGl__i2lz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl_2zd2zd2zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_2zf2zf2zz__r4_numbers_6_5z00(obj_t, obj_t);
static obj_t BGl___landz00zzjvm_instrz00(obj_t, obj_t);
extern bool_t BGl_2zc3zc3zz__r4_numbers_6_5z00(obj_t, obj_t);
extern bool_t BGl_2zd3zd3zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl__returnz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
extern bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_instrz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
extern obj_t BGl__athrowz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl___lmulz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___invokeinterfacez00zzjvm_instrz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_za2lastzd2lineza2zd2zzjvm_instrz00 = BUNSPEC;
extern obj_t BGl__putstaticz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl__ldivz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl__daddz00zzjvm_instrz00(BgL_envz00_bglt);
extern long bgl_list_length(obj_t);
static obj_t BGl___localvarz00zzjvm_instrz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl__ifz00zzjvm_instrz00(obj_t, BgL_envz00_bglt, obj_t);
extern obj_t BGl__ishlz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl__ishrz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl___idivz00zzjvm_instrz00(obj_t, obj_t);
extern obj_t BGl__getstatic2z00zzjvm_instrz00(BgL_envz00_bglt, BgL_globalz00_bglt);
extern obj_t BGl__dnegz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl___labelz00zzjvm_instrz00(obj_t, obj_t, obj_t);
extern obj_t BGl__lushrz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl__popz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
extern obj_t bgl_reverse(obj_t);
extern obj_t BGl__lremz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl___iremz00zzjvm_instrz00(obj_t, obj_t);
extern obj_t BGl__dmulz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl___invokespecial_initz00zzjvm_instrz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl__simplezd2typezd2zzjvm_instrz00(obj_t, obj_t);
extern obj_t BGl__invokespecial_initz00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t, obj_t);
static obj_t BGl___lcmpz00zzjvm_instrz00(obj_t, obj_t);
extern obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
extern obj_t BGl__isubz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl__dupz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl__lshlz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl___invokespecialz00zzjvm_instrz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl__getfieldz00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t);
static obj_t BGl___if_acmpz00zzjvm_instrz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl__lshrz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl___dcmpgz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___ldivz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___dcmplz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___daddz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___iorz00zzjvm_instrz00(obj_t, obj_t);
extern obj_t BGl__l2dz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl__l2iz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl___ishlz00zzjvm_instrz00(obj_t, obj_t);
extern obj_t BGl__getstaticz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
static obj_t BGl___ishrz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___checkcastz00zzjvm_instrz00(obj_t, obj_t, obj_t);
static obj_t BGl___load_namez00zzjvm_instrz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl___dnegz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___lremz00zzjvm_instrz00(obj_t, obj_t);
extern obj_t BGl_sortz00zz__r4_vectors_6_8z00(obj_t, obj_t);
static obj_t BGl___d2fz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___d2iz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___instanceofz00zzjvm_instrz00(obj_t, obj_t, obj_t);
static obj_t BGl___d2lz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl_za2simplezd2pushzd2instructionsza2z00zzjvm_instrz00 = BUNSPEC;
static obj_t BGl___getfieldz00zzjvm_instrz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl__pushz00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t);
extern obj_t BGl__lsubz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl___dmulz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___putstaticz00zzjvm_instrz00(obj_t, obj_t, obj_t);
extern obj_t BGl_getzd2globalzd2namez00zzjvm_envz00(BgL_envz00_bglt, BgL_globalz00_bglt);
extern obj_t BGl__ddivz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl___isubz00zzjvm_instrz00(obj_t, obj_t);
extern bool_t BGl_zd3fxzd3zz__r4_numbers_6_5_fixnumz00(long, long);
static obj_t BGl___lshlz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___lshrz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___astorez00zzjvm_instrz00(obj_t, obj_t, obj_t);
extern obj_t BGl__dremz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl_requirezd2initializa7ationz75zzjvm_instrz00 = BUNSPEC;
extern obj_t BGl__commentz00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t);
static obj_t BGl___aloadz00zzjvm_instrz00(obj_t, obj_t, obj_t);
extern obj_t BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_bglt, obj_t);
static obj_t BGl___switchz00zzjvm_instrz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl__gotoz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
static obj_t BGl___f2dz00zzjvm_instrz00(obj_t, obj_t);
extern obj_t BGl__swapz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl__localvarz00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_popz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl__linez00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
static obj_t BGl___lorz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zzjvm_instrz00();
extern obj_t BGl__labelz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
static obj_t BGl___iushrz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___lsubz00zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl___returnz00zzjvm_instrz00(obj_t, obj_t, obj_t);
extern obj_t BGl__invokeinterfacez00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t, obj_t);
static obj_t BGl___athrowz00zzjvm_instrz00(obj_t, obj_t);
extern obj_t BGl__handlerz00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[ 165 ] ;

DEFINE_EXPORT_PROCEDURE( BGl_createzd2stringzd2envz00zzjvm_instrz00, BgL_bgl__createza7d2stringza7d2za7za7jvm_instrza7005899za7, BGl__createzd2stringzd2zzjvm_instrz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl__iandzd2envzd2zzjvm_instrz00, BgL_bgl___iandza700za7za7jvm_instrza7005900z00, BGl___iandz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__ishlzd2envzd2zzjvm_instrz00, BgL_bgl___ishlza700za7za7jvm_instrza7005901z00, BGl___ishlz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__load_namezd2envzd2zzjvm_instrz00, BgL_bgl___load_nameza700za7za7jvm_instrza7005902z00, BGl___load_namez00zzjvm_instrz00, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( BGl__daddzd2envzd2zzjvm_instrz00, BgL_bgl___daddza700za7za7jvm_instrza7005903z00, BGl___daddz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__l2izd2envzd2zzjvm_instrz00, BgL_bgl___l2iza700za7za7jvm_instrza7005904z00, BGl___l2iz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__getfieldzd2envzd2zzjvm_instrz00, BgL_bgl___getfieldza700za7za7jvm_instrza7005905z00, BGl___getfieldz00zzjvm_instrz00, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( BGl__i2dzd2envzd2zzjvm_instrz00, BgL_bgl___i2dza700za7za7jvm_instrza7005906z00, BGl___i2dz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__ixorzd2envzd2zzjvm_instrz00, BgL_bgl___ixorza700za7za7jvm_instrza7005907z00, BGl___ixorz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__lushrzd2envzd2zzjvm_instrz00, BgL_bgl___lushrza700za7za7jvm_instrza7005908z00, BGl___lushrz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__lremzd2envzd2zzjvm_instrz00, BgL_bgl___lremza700za7za7jvm_instrza7005909z00, BGl___lremz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__if_acmpzd2envzd2zzjvm_instrz00, BgL_bgl___if_acmpza700za7za7jvm_instrza7005910z00, BGl___if_acmpz00zzjvm_instrz00, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( BGl__inegzd2envzd2zzjvm_instrz00, BgL_bgl___inegza700za7za7jvm_instrza7005911z00, BGl___inegz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__lshrzd2envzd2zzjvm_instrz00, BgL_bgl___lshrza700za7za7jvm_instrza7005912z00, BGl___lshrz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__newarrayzd2envzd2zzjvm_instrz00, BgL_bgl___newarrayza700za7za7jvm_instrza7005913z00, BGl___newarrayz00zzjvm_instrz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl__f2dzd2envzd2zzjvm_instrz00, BgL_bgl___f2dza700za7za7jvm_instrza7005914z00, BGl___f2dz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__ifzd2envzd2zzjvm_instrz00, BgL_bgl___ifza700za7za7jvm_instrza7005915z00, BGl___ifz00zzjvm_instrz00, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( BGl_simplezd2typezd2envz00zzjvm_instrz00, BgL_bgl__simpleza7d2typeza7d2za7za7jvm_instrza7005916za7, BGl__simplezd2typezd2zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__dremzd2envzd2zzjvm_instrz00, BgL_bgl___dremza700za7za7jvm_instrza7005917z00, BGl___dremz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__aloadzd2envzd2zzjvm_instrz00, BgL_bgl___aloadza700za7za7jvm_instrza7005918z00, BGl___aloadz00zzjvm_instrz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl__if_icmpzd2envzd2zzjvm_instrz00, BgL_bgl___if_icmpza700za7za7jvm_instrza7005919z00, BGl___if_icmpz00zzjvm_instrz00, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( BGl__d2izd2envzd2zzjvm_instrz00, BgL_bgl___d2iza700za7za7jvm_instrza7005920z00, BGl___d2iz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__putstaticzd2envzd2zzjvm_instrz00, BgL_bgl___putstaticza700za7za7jvm_instrza7005921z00, BGl___putstaticz00zzjvm_instrz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl__lsubzd2envzd2zzjvm_instrz00, BgL_bgl___lsubza700za7za7jvm_instrza7005922z00, BGl___lsubz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__dcmplzd2envzd2zzjvm_instrz00, BgL_bgl___dcmplza700za7za7jvm_instrza7005923z00, BGl___dcmplz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__i2bzd2envzd2zzjvm_instrz00, BgL_bgl___i2bza700za7za7jvm_instrza7005924z00, BGl___i2bz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__athrowzd2envzd2zzjvm_instrz00, BgL_bgl___athrowza700za7za7jvm_instrza7005925z00, BGl___athrowz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__dsubzd2envzd2zzjvm_instrz00, BgL_bgl___dsubza700za7za7jvm_instrza7005926z00, BGl___dsubz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__dcmpgzd2envzd2zzjvm_instrz00, BgL_bgl___dcmpgza700za7za7jvm_instrza7005927z00, BGl___dcmpgz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__lorzd2envzd2zzjvm_instrz00, BgL_bgl___lorza700za7za7jvm_instrza7005928z00, BGl___lorz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__localvarzd2envzd2zzjvm_instrz00, BgL_bgl___localvarza700za7za7jvm_instrza7005929z00, BGl___localvarz00zzjvm_instrz00, 0L, 6 );
DEFINE_EXPORT_PROCEDURE( BGl__i2lzd2envzd2zzjvm_instrz00, BgL_bgl___i2lza700za7za7jvm_instrza7005930z00, BGl___i2lz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__invokevirtualzd2envzd2zzjvm_instrz00, BgL_bgl___invokevirtualza700za7za7jvm_instrza7005931z00, BGl___invokevirtualz00zzjvm_instrz00, 0L, 4 );
DEFINE_EXPORT_PROCEDURE( BGl__iorzd2envzd2zzjvm_instrz00, BgL_bgl___iorza700za7za7jvm_instrza7005932z00, BGl___iorz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__getstatic2zd2envzd2zzjvm_instrz00, BgL_bgl___getstatic2za700za7za7jvm_instrza7005933z00, BGl___getstatic2z00zzjvm_instrz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl__dup2zd2envzd2zzjvm_instrz00, BgL_bgl___dup2za700za7za7jvm_instrza7005934z00, BGl___dup2z00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__lmulzd2envzd2zzjvm_instrz00, BgL_bgl___lmulza700za7za7jvm_instrza7005935z00, BGl___lmulz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__d2lzd2envzd2zzjvm_instrz00, BgL_bgl___d2lza700za7za7jvm_instrza7005936z00, BGl___d2lz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__iaddzd2envzd2zzjvm_instrz00, BgL_bgl___iaddza700za7za7jvm_instrza7005937z00, BGl___iaddz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__handlerzd2envzd2zzjvm_instrz00, BgL_bgl___handlerza700za7za7jvm_instrza7005938z00, BGl___handlerz00zzjvm_instrz00, 0L, 5 );
DEFINE_EXPORT_PROCEDURE( BGl__popzd2envzd2zzjvm_instrz00, BgL_bgl___popza700za7za7jvm_instrza7005939z00, BGl___popz00zzjvm_instrz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc5863z00zzjvm_instrz00, BgL_bgl_za7c3anonymousza7a33599za7e3za783za7za7jvm_instrza7005940za7, BGl_zc3anonymousza33599ze3z83zzjvm_instrz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl__dmulzd2envzd2zzjvm_instrz00, BgL_bgl___dmulza700za7za7jvm_instrza7005941z00, BGl___dmulz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__checkcastzd2envzd2zzjvm_instrz00, BgL_bgl___checkcastza700za7za7jvm_instrza7005942z00, BGl___checkcastz00zzjvm_instrz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl__instanceofzd2envzd2zzjvm_instrz00, BgL_bgl___instanceofza700za7za7jvm_instrza7005943z00, BGl___instanceofz00zzjvm_instrz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl__commentzd2envzd2zzjvm_instrz00, BgL_bgl___commentza700za7za7jvm_instrza7005944z00, BGl___commentz00zzjvm_instrz00, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( BGl__iremzd2envzd2zzjvm_instrz00, BgL_bgl___iremza700za7za7jvm_instrza7005945z00, BGl___iremz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__ishrzd2envzd2zzjvm_instrz00, BgL_bgl___ishrza700za7za7jvm_instrza7005946z00, BGl___ishrz00zzjvm_instrz00, 0L, 1 );
DEFINE_STRING( BGl_string5867z00zzjvm_instrz00, BgL_bgl_string5867za700za7za7jvm_instrza7005947z00, "(ad ad) concat (ad) getbytes line comment handler (athrow) (areturn) (dreturn) (freturn) (lreturn) (ireturn) invokeinterface invokevirtual localvar dup invokespecial invokestatic (arraylength) (aastore) (dastore) (fastore) (lastore) (iastore) (sastore) (castore) (bastore) (aaload) (daload) (faload) (laload) (iaload) (saload) short (caload) char (baload) (boolean byte) anewarray newarray (boolean byte char short int long float double) putfield getfield checkcast (void boolean byte char short int long float double jobject) instanceof new tableswitch lookupswitch if_acmp if_acmpne if_acmpeq if_icmp if_icmplt if_icmpgt if_icmple if_icmpge if_icmpne if_icmpeq if iflt lt ifgt gt ifle le ifge ge ifne ne ifeq eq (f2d) (d2f) (d2l) (d2i) (l2d) (l2i) (i2d) (i2b) (i2l) (dcmpl) (dcmpg) (lcmp) (dneg) (drem) (ddiv) (dmul) (dsub) (dadd) (lushr) (lshr) (lshl) (lxor) (land) (lor) (lneg) (lrem) (ldiv) (lmul) (lsub) (ladd) (iushr) (ishr) (ishl) (ixor) (iand) (ior) (ineg) (irem) (idiv) (imul) (isub) (iadd) putstatic getstatic ast"
"ore dstore fstore lstore istore aload dload fload lload iload (pop) (pop2) ok (swap) (dup2) (dup) _push string (dconst_1) (dconst_0) (fconst_2) (fconst_1) (fconst_0) ldc2_w (lconst_1) (lconst_0) (iconst_5) (iconst_4) (iconst_3) (iconst_2) (iconst_1) (iconst_0) (iconst_m1) ldc sipush bipush (booolean byte char short int) (aconst_null) goto ad double float long int (boolean byte char short int) unknown void (iconst_m1 iconst_0 iconst_1 iconst_2 iconst_3 iconst_4 iconst_5 bipush sipush ldc lconst_0 lconst_1 ldc2_w fconst_0 fconst_1 fconst_2 dconst_0 dconst_1 ldc2_w aconst_null aload iload lload dload fload getstatic) ", 1646 );
DEFINE_EXPORT_PROCEDURE( BGl__getstaticzd2envzd2zzjvm_instrz00, BgL_bgl___getstaticza700za7za7jvm_instrza7005948z00, BGl___getstaticz00zzjvm_instrz00, 0L, 2 );
DEFINE_STRING( BGl_string5866z00zzjvm_instrz00, BgL_bgl_string5866za700za7za7jvm_instrza7005949z00, "type ", 5 );
DEFINE_STRING( BGl_string5865z00zzjvm_instrz00, BgL_bgl_string5865za700za7za7jvm_instrza7005950z00, "fail to reach the new instruction for <init> ", 45 );
DEFINE_STRING( BGl_string5862z00zzjvm_instrz00, BgL_bgl_string5862za700za7za7jvm_instrza7005951z00, "unknown operation", 17 );
DEFINE_STRING( BGl_string5861z00zzjvm_instrz00, BgL_bgl_string5861za700za7za7jvm_instrza7005952z00, "bad type", 8 );
DEFINE_STRING( BGl_string5857z00zzjvm_instrz00, BgL_bgl_string5857za700za7za7jvm_instrza7005953z00, "unexpected type in stack", 24 );
DEFINE_EXPORT_PROCEDURE( BGl__iushrzd2envzd2zzjvm_instrz00, BgL_bgl___iushrza700za7za7jvm_instrza7005954z00, BGl___iushrz00zzjvm_instrz00, 0L, 1 );
DEFINE_STRING( BGl_string5856z00zzjvm_instrz00, BgL_bgl_string5856za700za7za7jvm_instrza7005955z00, "is empty", 8 );
DEFINE_STRING( BGl_string5855z00zzjvm_instrz00, BgL_bgl_string5855za700za7za7jvm_instrza7005956z00, "stack", 5 );
DEFINE_EXPORT_PROCEDURE( BGl__putfieldzd2envzd2zzjvm_instrz00, BgL_bgl___putfieldza700za7za7jvm_instrza7005957z00, BGl___putfieldz00zzjvm_instrz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl__gotozd2envzd2zzjvm_instrz00, BgL_bgl___gotoza700za7za7jvm_instrza7005958z00, BGl___gotoz00zzjvm_instrz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl__dupzd2envzd2zzjvm_instrz00, BgL_bgl___dupza700za7za7jvm_instrza7005959z00, BGl___dupz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__astorezd2envzd2zzjvm_instrz00, BgL_bgl___astoreza700za7za7jvm_instrza7005960z00, BGl___astorez00zzjvm_instrz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl__ldivzd2envzd2zzjvm_instrz00, BgL_bgl___ldivza700za7za7jvm_instrza7005961z00, BGl___ldivz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__isubzd2envzd2zzjvm_instrz00, BgL_bgl___isubza700za7za7jvm_instrza7005962z00, BGl___isubz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__labelzd2envzd2zzjvm_instrz00, BgL_bgl___labelza700za7za7jvm_instrza7005963z00, BGl___labelz00zzjvm_instrz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl__store_namezd2envzd2zzjvm_instrz00, BgL_bgl___store_nameza700za7za7jvm_instrza7005964z00, BGl___store_namez00zzjvm_instrz00, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( BGl__newzd2envzd2zzjvm_instrz00, BgL_bgl___newza700za7za7jvm_instrza7005965z00, BGl___newz00zzjvm_instrz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl__swapzd2envzd2zzjvm_instrz00, BgL_bgl___swapza700za7za7jvm_instrza7005966z00, BGl___swapz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__landzd2envzd2zzjvm_instrz00, BgL_bgl___landza700za7za7jvm_instrza7005967z00, BGl___landz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__lshlzd2envzd2zzjvm_instrz00, BgL_bgl___lshlza700za7za7jvm_instrza7005968z00, BGl___lshlz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__ddivzd2envzd2zzjvm_instrz00, BgL_bgl___ddivza700za7za7jvm_instrza7005969z00, BGl___ddivz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__lxorzd2envzd2zzjvm_instrz00, BgL_bgl___lxorza700za7za7jvm_instrza7005970z00, BGl___lxorz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__lnegzd2envzd2zzjvm_instrz00, BgL_bgl___lnegza700za7za7jvm_instrza7005971z00, BGl___lnegz00zzjvm_instrz00, 0L, 1 );
DEFINE_REAL( BGl_real5858z00zzjvm_instrz00, BgL_bgl_real5858za700za7za7jvm_instrza7005972z00, 0.0 );
DEFINE_REAL( BGl_real5860z00zzjvm_instrz00, BgL_bgl_real5860za700za7za7jvm_instrza7005973z00, 2.0 );
DEFINE_REAL( BGl_real5859z00zzjvm_instrz00, BgL_bgl_real5859za700za7za7jvm_instrza7005974z00, 1.0 );
DEFINE_REAL( BGl_real5864z00zzjvm_instrz00, BgL_bgl_real5864za700za7za7jvm_instrza7005975z00, 0.75 );
DEFINE_EXPORT_PROCEDURE( BGl__invokestaticzd2envzd2zzjvm_instrz00, BgL_bgl___invokestaticza700za7za7jvm_instrza7005976z00, BGl___invokestaticz00zzjvm_instrz00, 0L, 4 );
DEFINE_EXPORT_PROCEDURE( BGl__invokespecial_initzd2envzd2zzjvm_instrz00, BgL_bgl___invokespecial_initza700za7za7jvm_instrza7005977z00, BGl___invokespecial_initz00zzjvm_instrz00, 0L, 4 );
DEFINE_EXPORT_PROCEDURE( BGl__dnegzd2envzd2zzjvm_instrz00, BgL_bgl___dnegza700za7za7jvm_instrza7005978z00, BGl___dnegz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__imulzd2envzd2zzjvm_instrz00, BgL_bgl___imulza700za7za7jvm_instrza7005979z00, BGl___imulz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__pushzd2envzd2zzjvm_instrz00, BgL_bgl___push5545za700za7za7jvm_instrza7005980z00, BGl___push5545z00zzjvm_instrz00, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( BGl__invokeinterfacezd2envzd2zzjvm_instrz00, BgL_bgl___invokeinterfaceza700za7za7jvm_instrza7005981z00, BGl___invokeinterfacez00zzjvm_instrz00, 0L, 4 );
DEFINE_EXPORT_PROCEDURE( BGl__arraylengthzd2envzd2zzjvm_instrz00, BgL_bgl___arraylengthza700za7za7jvm_instrza7005982z00, BGl___arraylengthz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__loadzd2envzd2zzjvm_instrz00, BgL_bgl___loadza700za7za7jvm_instrza7005983z00, BGl___loadz00zzjvm_instrz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl__switchzd2envzd2zzjvm_instrz00, BgL_bgl___switchza700za7za7jvm_instrza7005984z00, BGl___switchz00zzjvm_instrz00, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( BGl__storezd2envzd2zzjvm_instrz00, BgL_bgl___storeza700za7za7jvm_instrza7005985z00, BGl___storez00zzjvm_instrz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl__returnzd2envzd2zzjvm_instrz00, BgL_bgl___returnza700za7za7jvm_instrza7005986z00, BGl___returnz00zzjvm_instrz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl__lcmpzd2envzd2zzjvm_instrz00, BgL_bgl___lcmpza700za7za7jvm_instrza7005987z00, BGl___lcmpz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__aconst_nullzd2envzd2zzjvm_instrz00, BgL_bgl___aconst_nullza700za7za7jvm_instrza7005988z00, BGl___aconst_nullz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__invokespecialzd2envzd2zzjvm_instrz00, BgL_bgl___invokespecialza700za7za7jvm_instrza7005989z00, BGl___invokespecialz00zzjvm_instrz00, 0L, 4 );
DEFINE_EXPORT_PROCEDURE( BGl__linezd2envzd2zzjvm_instrz00, BgL_bgl___lineza700za7za7jvm_instrza7005990z00, BGl___linez00zzjvm_instrz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl__d2fzd2envzd2zzjvm_instrz00, BgL_bgl___d2fza700za7za7jvm_instrza7005991z00, BGl___d2fz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__laddzd2envzd2zzjvm_instrz00, BgL_bgl___laddza700za7za7jvm_instrza7005992z00, BGl___laddz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__idivzd2envzd2zzjvm_instrz00, BgL_bgl___idivza700za7za7jvm_instrza7005993z00, BGl___idivz00zzjvm_instrz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl__l2dzd2envzd2zzjvm_instrz00, BgL_bgl___l2dza700za7za7jvm_instrza7005994z00, BGl___l2dz00zzjvm_instrz00, 0L, 1 );



/* module-initialization */
obj_t BGl_modulezd2initializa7ationz75zzjvm_instrz00(long BgL_checksumz00_4713, char * BgL_fromz00_4714)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzjvm_instrz00))
{ 
BGl_requirezd2initializa7ationz75zzjvm_instrz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzjvm_instrz00(); 
BGl_cnstzd2initzd2zzjvm_instrz00(); 
BGl_importedzd2moduleszd2initz00zzjvm_instrz00(); 
BGl_toplevelzd2initzd2zzjvm_instrz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzjvm_instrz00()
{ AN_OBJECT;
{ /* Jvm/instr.scm 2 */
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "jvm_instr"); 
BGl_modulezd2initializa7ationz75zz__ppz00(((long)0), "jvm_instr"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "jvm_instr"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "jvm_instr"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "jvm_instr"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "jvm_instr"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "jvm_instr"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "jvm_instr"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzjvm_instrz00()
{ AN_OBJECT;
{ /* Jvm/instr.scm 2 */
{ /* Jvm/instr.scm 2 */
obj_t BgL_cportz00_4706;
BgL_cportz00_4706 = 
open_input_string(BGl_string5867z00zzjvm_instrz00); 
{ 
long BgL_iz00_4707;
BgL_iz00_4707 = ((long)164); 
BgL_loopz00_4708:
if(
(BgL_iz00_4707==((long)-1)))
{ /* Jvm/instr.scm 2 */
return BUNSPEC;}  else 
{ /* Jvm/instr.scm 2 */
{ /* Jvm/instr.scm 2 */
obj_t BgL_arg5871z00_4710;
{ /* Jvm/instr.scm 2 */
obj_t BgL_list5874z00_4711;
BgL_list5874z00_4711 = 
MAKE_PAIR(BgL_cportz00_4706, BNIL); 
BgL_arg5871z00_4710 = 
BGl_readz00zz__readerz00(BgL_list5874z00_4711); } 
{ /* Jvm/instr.scm 2 */
int BgL_auxz00_4735;
BgL_auxz00_4735 = 
(int)(BgL_iz00_4707); 
CNST_TABLE_SET(BgL_auxz00_4735, BgL_arg5871z00_4710); } } 
{ 
long BgL_iz00_4738;
{ /* Jvm/instr.scm 2 */
int BgL_auxz00_4739;
{ /* Jvm/instr.scm 2 */
long BgL_auxz00_4740;
BgL_auxz00_4740 = 
(BgL_iz00_4707-((long)1)); 
BgL_auxz00_4739 = 
(int)(BgL_auxz00_4740); } 
BgL_iz00_4738 = 
(long)(BgL_auxz00_4739); } 
BgL_iz00_4707 = BgL_iz00_4738; 
goto BgL_loopz00_4708;} } } } } 
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zzjvm_instrz00()
{ AN_OBJECT;
{ /* Jvm/instr.scm 2 */
BGl_za2simplezd2pushzd2instructionsza2z00zzjvm_instrz00 = 
CNST_TABLE_REF(((long)0)); 
return ( 
BGl_za2lastzd2lineza2zd2zzjvm_instrz00 = 
BINT(((long)-1)), BUNSPEC) ;} 
}



/* push */
obj_t BGl_pushz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_1, obj_t BgL_typez00_2)
{ AN_OBJECT;
{ /* Jvm/instr.scm 94 */
{ /* Jvm/instr.scm 95 */
bool_t BgL_testz00_4746;
{ /* Jvm/instr.scm 95 */
obj_t BgL_auxz00_4747;
BgL_auxz00_4747 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_4746 = 
(BgL_typez00_2==BgL_auxz00_4747); } 
if(BgL_testz00_4746)
{ /* Jvm/instr.scm 95 */
return BFALSE;}  else 
{ /* Jvm/instr.scm 96 */
obj_t BgL_arg3000z00_1648;
{ /* Jvm/instr.scm 96 */
obj_t BgL_auxz00_4750;
BgL_auxz00_4750 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_1))->BgL_stackz00); 
BgL_arg3000z00_1648 = 
MAKE_PAIR(BgL_typez00_2, BgL_auxz00_4750); } 
return 
((((BgL_envz00_bglt)CREF(BgL_envz00_1))->BgL_stackz00) = ((obj_t)BgL_arg3000z00_1648), BUNSPEC);} } } 
}



/* pop */
obj_t BGl_popz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_3)
{ AN_OBJECT;
{ /* Jvm/instr.scm 98 */
{ /* Jvm/instr.scm 99 */
obj_t BgL_lz00_1650;
BgL_lz00_1650 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_3))->BgL_stackz00); 
if(
NULLP(BgL_lz00_1650))
{ /* Jvm/instr.scm 100 */
BGl_ppz00zz__ppz00(
bgl_reverse(
(((BgL_envz00_bglt)CREF(BgL_envz00_3))->BgL_codez00)), BNIL); 
{ 
obj_t BgL_auxz00_4760;
BgL_auxz00_4760 = 
bgl_reverse(
(((BgL_envz00_bglt)CREF(BgL_envz00_3))->BgL_codez00)); 
FAILURE(BGl_string5855z00zzjvm_instrz00,BGl_string5856z00zzjvm_instrz00,BgL_auxz00_4760);} }  else 
{ /* Jvm/instr.scm 100 */BFALSE; } 
{ /* Jvm/instr.scm 104 */
obj_t BgL_arg3030z00_1659;
BgL_arg3030z00_1659 = 
CDR(BgL_lz00_1650); 
((((BgL_envz00_bglt)CREF(BgL_envz00_3))->BgL_stackz00) = ((obj_t)BgL_arg3030z00_1659), BUNSPEC); } 
return 
CAR(BgL_lz00_1650);} } 
}



/* cpop */
obj_t BGl_cpopz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_4, obj_t BgL_tyz00_5)
{ AN_OBJECT;
{ /* Jvm/instr.scm 107 */
{ /* Jvm/instr.scm 108 */
obj_t BgL_rtyz00_1660;
BgL_rtyz00_1660 = 
BGl_popz00zzjvm_instrz00(BgL_envz00_4); 
{ /* Jvm/instr.scm 109 */
bool_t BgL_testz00_4768;
if(
(BgL_tyz00_5==BgL_rtyz00_1660))
{ /* Jvm/instr.scm 109 */
BgL_testz00_4768 = ((bool_t)1)
; }  else 
{ /* Jvm/instr.scm 109 */
obj_t BgL_auxz00_4771;
BgL_auxz00_4771 = 
CNST_TABLE_REF(((long)2)); 
BgL_testz00_4768 = 
(BgL_rtyz00_1660==BgL_auxz00_4771); } 
if(BgL_testz00_4768)
{ /* Jvm/instr.scm 109 */
return BgL_tyz00_5;}  else 
{ /* Jvm/instr.scm 109 */
BGl_ppz00zz__ppz00(
bgl_reverse(
(((BgL_envz00_bglt)CREF(BgL_envz00_4))->BgL_codez00)), BNIL); 
{ /* Jvm/instr.scm 113 */
obj_t BgL_arg3047z00_1667;
{ /* Jvm/instr.scm 114 */
obj_t BgL_arg3050z00_1668;
{ /* Jvm/instr.scm 114 */
obj_t BgL_auxz00_4777;
BgL_auxz00_4777 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_4))->BgL_stackz00); 
BgL_arg3050z00_1668 = 
MAKE_PAIR(BgL_rtyz00_1660, BgL_auxz00_4777); } 
{ /* Jvm/instr.scm 114 */
obj_t BgL_list3052z00_1669;
{ /* Jvm/instr.scm 114 */
obj_t BgL_arg3054z00_1670;
BgL_arg3054z00_1670 = 
MAKE_PAIR(BgL_arg3050z00_1668, BNIL); 
BgL_list3052z00_1669 = 
MAKE_PAIR(BgL_tyz00_5, BgL_arg3054z00_1670); } 
BgL_arg3047z00_1667 = BgL_list3052z00_1669; } } 
FAILURE(BGl_string5855z00zzjvm_instrz00,BGl_string5857z00zzjvm_instrz00,BgL_arg3047z00_1667);} } } } } 
}



/* simple-type */
obj_t BGl_simplezd2typezd2zzjvm_instrz00(obj_t BgL_typez00_6)
{ AN_OBJECT;
{ /* Jvm/instr.scm 116 */
{ /* Jvm/instr.scm 117 */
bool_t BgL_testz00_4783;
{ /* Jvm/instr.scm 117 */
obj_t BgL_auxz00_4784;
BgL_auxz00_4784 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_4783 = 
(BgL_typez00_6==BgL_auxz00_4784); } 
if(BgL_testz00_4783)
{ /* Jvm/instr.scm 117 */
return 
CNST_TABLE_REF(((long)1));}  else 
{ /* Jvm/instr.scm 117 */
bool_t BgL_testz00_4788;
{ /* Jvm/instr.scm 117 */
obj_t BgL_auxz00_4789;
BgL_auxz00_4789 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_typez00_6, 
CNST_TABLE_REF(((long)3))); 
BgL_testz00_4788 = 
CBOOL(BgL_auxz00_4789); } 
if(BgL_testz00_4788)
{ /* Jvm/instr.scm 117 */
return 
CNST_TABLE_REF(((long)4));}  else 
{ /* Jvm/instr.scm 117 */
bool_t BgL_testz00_4794;
{ /* Jvm/instr.scm 117 */
obj_t BgL_auxz00_4795;
BgL_auxz00_4795 = 
CNST_TABLE_REF(((long)5)); 
BgL_testz00_4794 = 
(BgL_typez00_6==BgL_auxz00_4795); } 
if(BgL_testz00_4794)
{ /* Jvm/instr.scm 117 */
return 
CNST_TABLE_REF(((long)5));}  else 
{ /* Jvm/instr.scm 117 */
bool_t BgL_testz00_4799;
{ /* Jvm/instr.scm 117 */
obj_t BgL_auxz00_4800;
BgL_auxz00_4800 = 
CNST_TABLE_REF(((long)6)); 
BgL_testz00_4799 = 
(BgL_typez00_6==BgL_auxz00_4800); } 
if(BgL_testz00_4799)
{ /* Jvm/instr.scm 117 */
return 
CNST_TABLE_REF(((long)6));}  else 
{ /* Jvm/instr.scm 117 */
bool_t BgL_testz00_4804;
{ /* Jvm/instr.scm 117 */
obj_t BgL_auxz00_4805;
BgL_auxz00_4805 = 
CNST_TABLE_REF(((long)7)); 
BgL_testz00_4804 = 
(BgL_typez00_6==BgL_auxz00_4805); } 
if(BgL_testz00_4804)
{ /* Jvm/instr.scm 117 */
return 
CNST_TABLE_REF(((long)7));}  else 
{ /* Jvm/instr.scm 117 */
return 
CNST_TABLE_REF(((long)8));} } } } } } } 
}



/* _simple-type */
obj_t BGl__simplezd2typezd2zzjvm_instrz00(obj_t BgL_envz00_4476, obj_t BgL_typez00_4477)
{ AN_OBJECT;
{ /* Jvm/instr.scm 116 */
return 
BGl_simplezd2typezd2zzjvm_instrz00(BgL_typez00_4477);} 
}



/* env-code! */
bool_t BGl_envzd2codez12zc0zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_7, obj_t BgL_insz00_8)
{ AN_OBJECT;
{ /* Jvm/instr.scm 125 */
{ /* Jvm/instr.scm 126 */
obj_t BgL_arg3076z00_2974;
{ /* Jvm/instr.scm 126 */
obj_t BgL_auxz00_4811;
BgL_auxz00_4811 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_7))->BgL_codez00); 
BgL_arg3076z00_2974 = 
MAKE_PAIR(BgL_insz00_8, BgL_auxz00_4811); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_7))->BgL_codez00) = ((obj_t)BgL_arg3076z00_2974), BUNSPEC); } 
return ((bool_t)1);} 
}



/* env-new-label! */
bool_t BGl_envzd2newzd2labelz12z12zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_9, obj_t BgL_labelz00_10)
{ AN_OBJECT;
{ /* Jvm/instr.scm 130 */
{ /* Jvm/instr.scm 132 */
obj_t BgL_ezd2102zd2_1686;
BgL_ezd2102zd2_1686 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_9))->BgL_codez00); 
if(
PAIRP(BgL_ezd2102zd2_1686))
{ /* Jvm/instr.scm 132 */
obj_t BgL_carzd2107zd2_1688;
BgL_carzd2107zd2_1688 = 
CAR(BgL_ezd2102zd2_1686); 
if(
PAIRP(BgL_carzd2107zd2_1688))
{ /* Jvm/instr.scm 132 */
obj_t BgL_cdrzd2111zd2_1690;
BgL_cdrzd2111zd2_1690 = 
CDR(BgL_carzd2107zd2_1688); 
{ /* Jvm/instr.scm 132 */
bool_t BgL_testz00_4822;
{ /* Jvm/instr.scm 132 */
obj_t BgL_auxz00_4825;obj_t BgL_auxz00_4823;
BgL_auxz00_4825 = 
CNST_TABLE_REF(((long)9)); 
BgL_auxz00_4823 = 
CAR(BgL_carzd2107zd2_1688); 
BgL_testz00_4822 = 
(BgL_auxz00_4823==BgL_auxz00_4825); } 
if(BgL_testz00_4822)
{ /* Jvm/instr.scm 132 */
if(
PAIRP(BgL_cdrzd2111zd2_1690))
{ /* Jvm/instr.scm 132 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2111zd2_1690), BNIL))
{ /* Jvm/instr.scm 132 */
obj_t BgL_arg3089z00_1695;
BgL_arg3089z00_1695 = 
CDR(BgL_ezd2102zd2_1686); 
{ /* Jvm/instr.scm 132 */
bool_t BgL_testz00_4834;
{ /* Jvm/instr.scm 132 */
obj_t BgL_auxz00_4835;
BgL_auxz00_4835 = 
CAR(BgL_cdrzd2111zd2_1690); 
BgL_testz00_4834 = 
(BgL_auxz00_4835==BgL_labelz00_10); } 
if(BgL_testz00_4834)
{ /* Jvm/instr.scm 132 */
((((BgL_envz00_bglt)CREF(BgL_envz00_9))->BgL_codez00) = ((obj_t)BgL_arg3089z00_1695), BUNSPEC); }  else 
{ /* Jvm/instr.scm 132 */BFALSE; } } }  else 
{ /* Jvm/instr.scm 132 */BFALSE; } }  else 
{ /* Jvm/instr.scm 132 */BFALSE; } }  else 
{ /* Jvm/instr.scm 132 */BFALSE; } } }  else 
{ /* Jvm/instr.scm 132 */BFALSE; } }  else 
{ /* Jvm/instr.scm 132 */BFALSE; } } 
{ /* Jvm/instr.scm 136 */
obj_t BgL_arg3113z00_1701;
{ /* Jvm/instr.scm 136 */
obj_t BgL_auxz00_4839;
BgL_auxz00_4839 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_9))->BgL_codez00); 
BgL_arg3113z00_1701 = 
MAKE_PAIR(BgL_labelz00_10, BgL_auxz00_4839); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_9))->BgL_codez00) = ((obj_t)BgL_arg3113z00_1701), BUNSPEC); } 
return ((bool_t)1);} 
}



/* _aconst_null */
obj_t BGl__aconst_nullz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_11)
{ AN_OBJECT;
{ /* Jvm/instr.scm 140 */
{ /* Jvm/instr.scm 141 */
obj_t BgL_arg3076z00_3003;
{ /* Jvm/instr.scm 141 */
obj_t BgL_auxz00_4845;obj_t BgL_auxz00_4843;
BgL_auxz00_4845 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_11))->BgL_codez00); 
BgL_auxz00_4843 = 
CNST_TABLE_REF(((long)10)); 
BgL_arg3076z00_3003 = 
MAKE_PAIR(BgL_auxz00_4843, BgL_auxz00_4845); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_11))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3003), BUNSPEC); } ((bool_t)1); 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_11, 
CNST_TABLE_REF(((long)8)));} 
}



/* __aconst_null */
obj_t BGl___aconst_nullz00zzjvm_instrz00(obj_t BgL_envz00_4478, obj_t BgL_envz00_4479)
{ AN_OBJECT;
{ /* Jvm/instr.scm 140 */
return 
BGl__aconst_nullz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4479));} 
}



/* _push */
obj_t BGl__pushz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_12, obj_t BgL_typez00_13, obj_t BgL_nz00_14)
{ AN_OBJECT;
{ /* Jvm/instr.scm 144 */
{ /* Jvm/instr.scm 146 */
obj_t BgL_arg3122z00_1703;
{ /* Jvm/instr.scm 146 */
bool_t BgL_testz00_4853;
{ /* Jvm/instr.scm 146 */
obj_t BgL_auxz00_4854;
BgL_auxz00_4854 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_typez00_13, 
CNST_TABLE_REF(((long)11))); 
BgL_testz00_4853 = 
CBOOL(BgL_auxz00_4854); } 
if(BgL_testz00_4853)
{ 

if(
INTEGERP(BgL_nz00_14))
{ /* Jvm/instr.scm 148 */
switch( 
(long)CINT(BgL_nz00_14)) { case ((long)-1) : 

BgL_arg3122z00_1703 = 
CNST_TABLE_REF(((long)15)); break;case ((long)0) : 

BgL_arg3122z00_1703 = 
CNST_TABLE_REF(((long)16)); break;case ((long)1) : 

BgL_arg3122z00_1703 = 
CNST_TABLE_REF(((long)17)); break;case ((long)2) : 

BgL_arg3122z00_1703 = 
CNST_TABLE_REF(((long)18)); break;case ((long)3) : 

BgL_arg3122z00_1703 = 
CNST_TABLE_REF(((long)19)); break;case ((long)4) : 

BgL_arg3122z00_1703 = 
CNST_TABLE_REF(((long)20)); break;case ((long)5) : 

BgL_arg3122z00_1703 = 
CNST_TABLE_REF(((long)21)); break;
default: 
BgL_case_else2969z00_1706:
{ /* Jvm/instr.scm 157 */
bool_t BgL_testz00_4867;
if(
BGl_2ze3ze3zz__r4_numbers_6_5z00(BgL_nz00_14, 
BINT(((long)-129))))
{ /* Jvm/instr.scm 157 */
BgL_testz00_4867 = 
BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_nz00_14, 
BINT(((long)128)))
; }  else 
{ /* Jvm/instr.scm 157 */
BgL_testz00_4867 = ((bool_t)0)
; } 
if(BgL_testz00_4867)
{ /* Jvm/instr.scm 157 */
{ /* Jvm/instr.scm 157 */
obj_t BgL_arg3131z00_1710;obj_t BgL_arg3132z00_1711;
BgL_arg3131z00_1710 = 
CNST_TABLE_REF(((long)12)); 
BgL_arg3132z00_1711 = 
MAKE_PAIR(BgL_nz00_14, BNIL); 
BgL_arg3122z00_1703 = 
MAKE_PAIR(BgL_arg3131z00_1710, BgL_arg3132z00_1711); } }  else 
{ /* Jvm/instr.scm 158 */
bool_t BgL_testz00_4876;
if(
BGl_2ze3ze3zz__r4_numbers_6_5z00(BgL_nz00_14, 
BINT(((long)-32769))))
{ /* Jvm/instr.scm 158 */
BgL_testz00_4876 = 
BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_nz00_14, 
BINT(((long)32768)))
; }  else 
{ /* Jvm/instr.scm 158 */
BgL_testz00_4876 = ((bool_t)0)
; } 
if(BgL_testz00_4876)
{ /* Jvm/instr.scm 158 */
{ /* Jvm/instr.scm 158 */
obj_t BgL_arg3137z00_1713;obj_t BgL_arg3138z00_1714;
BgL_arg3137z00_1713 = 
CNST_TABLE_REF(((long)13)); 
BgL_arg3138z00_1714 = 
MAKE_PAIR(BgL_nz00_14, BNIL); 
BgL_arg3122z00_1703 = 
MAKE_PAIR(BgL_arg3137z00_1713, BgL_arg3138z00_1714); } }  else 
{ /* Jvm/instr.scm 158 */
{ /* Jvm/instr.scm 159 */
obj_t BgL_arg3142z00_1715;obj_t BgL_arg3143z00_1716;
BgL_arg3142z00_1715 = 
CNST_TABLE_REF(((long)14)); 
BgL_arg3143z00_1716 = 
MAKE_PAIR(BgL_nz00_14, BNIL); 
BgL_arg3122z00_1703 = 
MAKE_PAIR(BgL_arg3142z00_1715, BgL_arg3143z00_1716); } } } } } }  else 
{ /* Jvm/instr.scm 148 */
goto BgL_case_else2969z00_1706;} }  else 
{ /* Jvm/instr.scm 146 */
bool_t BgL_testz00_4890;
{ /* Jvm/instr.scm 146 */
obj_t BgL_auxz00_4891;
BgL_auxz00_4891 = 
CNST_TABLE_REF(((long)5)); 
BgL_testz00_4890 = 
(BgL_typez00_13==BgL_auxz00_4891); } 
if(BgL_testz00_4890)
{ /* Jvm/instr.scm 146 */
if(
BGl_2zd3zd3zz__r4_numbers_6_5z00(BgL_nz00_14, 
BINT(((long)0))))
{ /* Jvm/instr.scm 161 */
BgL_arg3122z00_1703 = 
CNST_TABLE_REF(((long)22)); }  else 
{ /* Jvm/instr.scm 161 */
if(
BGl_2zd3zd3zz__r4_numbers_6_5z00(BgL_nz00_14, 
BINT(((long)1))))
{ /* Jvm/instr.scm 162 */
BgL_arg3122z00_1703 = 
CNST_TABLE_REF(((long)23)); }  else 
{ /* Jvm/instr.scm 162 */
{ /* Jvm/instr.scm 163 */
obj_t BgL_arg3156z00_1722;obj_t BgL_arg3157z00_1723;
BgL_arg3156z00_1722 = 
CNST_TABLE_REF(((long)24)); 
BgL_arg3157z00_1723 = 
MAKE_PAIR(BgL_nz00_14, BNIL); 
BgL_arg3122z00_1703 = 
MAKE_PAIR(BgL_arg3156z00_1722, BgL_arg3157z00_1723); } } } }  else 
{ /* Jvm/instr.scm 146 */
bool_t BgL_testz00_4905;
{ /* Jvm/instr.scm 146 */
obj_t BgL_auxz00_4906;
BgL_auxz00_4906 = 
CNST_TABLE_REF(((long)6)); 
BgL_testz00_4905 = 
(BgL_typez00_13==BgL_auxz00_4906); } 
if(BgL_testz00_4905)
{ /* Jvm/instr.scm 146 */
if(
BGl_2zd3zd3zz__r4_numbers_6_5z00(BgL_nz00_14, BGl_real5858z00zzjvm_instrz00))
{ /* Jvm/instr.scm 165 */
BgL_arg3122z00_1703 = 
CNST_TABLE_REF(((long)25)); }  else 
{ /* Jvm/instr.scm 165 */
if(
BGl_2zd3zd3zz__r4_numbers_6_5z00(BgL_nz00_14, BGl_real5859z00zzjvm_instrz00))
{ /* Jvm/instr.scm 166 */
BgL_arg3122z00_1703 = 
CNST_TABLE_REF(((long)26)); }  else 
{ /* Jvm/instr.scm 166 */
if(
BGl_2zd3zd3zz__r4_numbers_6_5z00(BgL_nz00_14, BGl_real5860z00zzjvm_instrz00))
{ /* Jvm/instr.scm 167 */
BgL_arg3122z00_1703 = 
CNST_TABLE_REF(((long)27)); }  else 
{ /* Jvm/instr.scm 167 */
{ /* Jvm/instr.scm 168 */
obj_t BgL_arg3167z00_1728;obj_t BgL_arg3168z00_1729;
BgL_arg3167z00_1728 = 
CNST_TABLE_REF(((long)14)); 
BgL_arg3168z00_1729 = 
MAKE_PAIR(BgL_nz00_14, BNIL); 
BgL_arg3122z00_1703 = 
MAKE_PAIR(BgL_arg3167z00_1728, BgL_arg3168z00_1729); } } } } }  else 
{ /* Jvm/instr.scm 146 */
bool_t BgL_testz00_4921;
{ /* Jvm/instr.scm 146 */
obj_t BgL_auxz00_4922;
BgL_auxz00_4922 = 
CNST_TABLE_REF(((long)7)); 
BgL_testz00_4921 = 
(BgL_typez00_13==BgL_auxz00_4922); } 
if(BgL_testz00_4921)
{ /* Jvm/instr.scm 146 */
if(
BGl_2zd3zd3zz__r4_numbers_6_5z00(BgL_nz00_14, BGl_real5858z00zzjvm_instrz00))
{ /* Jvm/instr.scm 170 */
BgL_arg3122z00_1703 = 
CNST_TABLE_REF(((long)28)); }  else 
{ /* Jvm/instr.scm 170 */
if(
BGl_2zd3zd3zz__r4_numbers_6_5z00(BgL_nz00_14, BGl_real5859z00zzjvm_instrz00))
{ /* Jvm/instr.scm 171 */
BgL_arg3122z00_1703 = 
CNST_TABLE_REF(((long)29)); }  else 
{ /* Jvm/instr.scm 171 */
{ /* Jvm/instr.scm 172 */
obj_t BgL_arg3178z00_1733;obj_t BgL_arg3179z00_1734;
BgL_arg3178z00_1733 = 
CNST_TABLE_REF(((long)24)); 
BgL_arg3179z00_1734 = 
MAKE_PAIR(BgL_nz00_14, BNIL); 
BgL_arg3122z00_1703 = 
MAKE_PAIR(BgL_arg3178z00_1733, BgL_arg3179z00_1734); } } } }  else 
{ /* Jvm/instr.scm 146 */
bool_t BgL_testz00_4934;
{ /* Jvm/instr.scm 146 */
obj_t BgL_auxz00_4935;
BgL_auxz00_4935 = 
CNST_TABLE_REF(((long)30)); 
BgL_testz00_4934 = 
(BgL_typez00_13==BgL_auxz00_4935); } 
if(BgL_testz00_4934)
{ /* Jvm/instr.scm 174 */
obj_t BgL_arg3186z00_1736;obj_t BgL_arg3187z00_1737;
BgL_arg3186z00_1736 = 
CNST_TABLE_REF(((long)14)); 
BgL_arg3187z00_1737 = 
MAKE_PAIR(BgL_nz00_14, BNIL); 
BgL_arg3122z00_1703 = 
MAKE_PAIR(BgL_arg3186z00_1736, BgL_arg3187z00_1737); }  else 
{ 
obj_t BgL_auxz00_4941;
BgL_auxz00_4941 = 
CNST_TABLE_REF(((long)31)); 
FAILURE(BgL_auxz00_4941,BGl_string5861z00zzjvm_instrz00,BgL_typez00_13);} } } } } } 
{ /* Jvm/instr.scm 145 */
obj_t BgL_arg3076z00_3014;
{ /* Jvm/instr.scm 145 */
obj_t BgL_auxz00_4944;
BgL_auxz00_4944 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_12))->BgL_codez00); 
BgL_arg3076z00_3014 = 
MAKE_PAIR(BgL_arg3122z00_1703, BgL_auxz00_4944); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_12))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3014), BUNSPEC); } ((bool_t)1); } 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_12, 
BGl_simplezd2typezd2zzjvm_instrz00(BgL_typez00_13));} 
}



/* __push5545 */
obj_t BGl___push5545z00zzjvm_instrz00(obj_t BgL_envz00_4480, obj_t BgL_envz00_4481, obj_t BgL_typez00_4482, obj_t BgL_nz00_4483)
{ AN_OBJECT;
{ /* Jvm/instr.scm 144 */
return 
BGl__pushz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4481), BgL_typez00_4482, BgL_nz00_4483);} 
}



/* _dup */
obj_t BGl__dupz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_15)
{ AN_OBJECT;
{ /* Jvm/instr.scm 178 */
{ /* Jvm/instr.scm 179 */
obj_t BgL_arg3076z00_3022;
{ /* Jvm/instr.scm 179 */
obj_t BgL_auxz00_4954;obj_t BgL_auxz00_4952;
BgL_auxz00_4954 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_15))->BgL_codez00); 
BgL_auxz00_4952 = 
CNST_TABLE_REF(((long)32)); 
BgL_arg3076z00_3022 = 
MAKE_PAIR(BgL_auxz00_4952, BgL_auxz00_4954); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_15))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3022), BUNSPEC); } ((bool_t)1); 
{ /* Jvm/instr.scm 180 */
obj_t BgL_tyz00_1739;
BgL_tyz00_1739 = 
BGl_popz00zzjvm_instrz00(BgL_envz00_15); 
BGl_pushz00zzjvm_instrz00(BgL_envz00_15, BgL_tyz00_1739); 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_15, BgL_tyz00_1739);} } 
}



/* __dup */
obj_t BGl___dupz00zzjvm_instrz00(obj_t BgL_envz00_4484, obj_t BgL_envz00_4485)
{ AN_OBJECT;
{ /* Jvm/instr.scm 178 */
return 
BGl__dupz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4485));} 
}



/* _dup2 */
obj_t BGl__dup2z00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_16)
{ AN_OBJECT;
{ /* Jvm/instr.scm 184 */
{ /* Jvm/instr.scm 185 */
obj_t BgL_arg3076z00_3030;
{ /* Jvm/instr.scm 185 */
obj_t BgL_auxz00_4965;obj_t BgL_auxz00_4963;
BgL_auxz00_4965 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_16))->BgL_codez00); 
BgL_auxz00_4963 = 
CNST_TABLE_REF(((long)33)); 
BgL_arg3076z00_3030 = 
MAKE_PAIR(BgL_auxz00_4963, BgL_auxz00_4965); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_16))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3030), BUNSPEC); } ((bool_t)1); 
{ /* Jvm/instr.scm 186 */
obj_t BgL_ty1z00_1740;
BgL_ty1z00_1740 = 
BGl_popz00zzjvm_instrz00(BgL_envz00_16); 
{ /* Jvm/instr.scm 187 */
obj_t BgL_ty2z00_1741;
BgL_ty2z00_1741 = 
BGl_popz00zzjvm_instrz00(BgL_envz00_16); 
BGl_pushz00zzjvm_instrz00(BgL_envz00_16, BgL_ty2z00_1741); 
BGl_pushz00zzjvm_instrz00(BgL_envz00_16, BgL_ty1z00_1740); 
BGl_pushz00zzjvm_instrz00(BgL_envz00_16, BgL_ty2z00_1741); 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_16, BgL_ty1z00_1740);} } } 
}



/* __dup2 */
obj_t BGl___dup2z00zzjvm_instrz00(obj_t BgL_envz00_4486, obj_t BgL_envz00_4487)
{ AN_OBJECT;
{ /* Jvm/instr.scm 184 */
return 
BGl__dup2z00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4487));} 
}



/* _swap */
obj_t BGl__swapz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_17)
{ AN_OBJECT;
{ /* Jvm/instr.scm 193 */
{ /* Jvm/instr.scm 194 */
obj_t BgL_arg3076z00_3038;
{ /* Jvm/instr.scm 194 */
obj_t BgL_auxz00_4979;obj_t BgL_auxz00_4977;
BgL_auxz00_4979 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_17))->BgL_codez00); 
BgL_auxz00_4977 = 
CNST_TABLE_REF(((long)34)); 
BgL_arg3076z00_3038 = 
MAKE_PAIR(BgL_auxz00_4977, BgL_auxz00_4979); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_17))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3038), BUNSPEC); } ((bool_t)1); 
{ /* Jvm/instr.scm 195 */
obj_t BgL_ty1z00_1742;
BgL_ty1z00_1742 = 
BGl_popz00zzjvm_instrz00(BgL_envz00_17); 
{ /* Jvm/instr.scm 196 */
obj_t BgL_ty2z00_1743;
BgL_ty2z00_1743 = 
BGl_popz00zzjvm_instrz00(BgL_envz00_17); 
BGl_pushz00zzjvm_instrz00(BgL_envz00_17, BgL_ty1z00_1742); 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_17, BgL_ty2z00_1743);} } } 
}



/* __swap */
obj_t BGl___swapz00zzjvm_instrz00(obj_t BgL_envz00_4488, obj_t BgL_envz00_4489)
{ AN_OBJECT;
{ /* Jvm/instr.scm 193 */
return 
BGl__swapz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4489));} 
}



/* _pop */
obj_t BGl__popz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_18, obj_t BgL_typez00_19)
{ AN_OBJECT;
{ /* Jvm/instr.scm 200 */
{ /* Jvm/instr.scm 201 */
bool_t BgL_testz00_4989;
{ /* Jvm/instr.scm 201 */
obj_t BgL_auxz00_4990;
BgL_auxz00_4990 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_4989 = 
(BgL_typez00_19==BgL_auxz00_4990); } 
if(BgL_testz00_4989)
{ /* Jvm/instr.scm 201 */
return 
CNST_TABLE_REF(((long)35));}  else 
{ /* Jvm/instr.scm 201 */
{ /* Jvm/instr.scm 203 */
obj_t BgL_arg3076z00_3046;
{ /* Jvm/instr.scm 203 */
obj_t BgL_auxz00_5005;obj_t BgL_auxz00_4994;
BgL_auxz00_5005 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_18))->BgL_codez00); 
{ /* Jvm/instr.scm 204 */
bool_t BgL_testz00_4995;
{ /* Jvm/instr.scm 204 */
bool_t BgL_testz00_4996;
{ /* Jvm/instr.scm 204 */
obj_t BgL_auxz00_4997;
BgL_auxz00_4997 = 
CNST_TABLE_REF(((long)7)); 
BgL_testz00_4996 = 
(BgL_typez00_19==BgL_auxz00_4997); } 
if(BgL_testz00_4996)
{ /* Jvm/instr.scm 204 */
BgL_testz00_4995 = ((bool_t)1)
; }  else 
{ /* Jvm/instr.scm 204 */
obj_t BgL_auxz00_5000;
BgL_auxz00_5000 = 
CNST_TABLE_REF(((long)5)); 
BgL_testz00_4995 = 
(BgL_typez00_19==BgL_auxz00_5000); } } 
if(BgL_testz00_4995)
{ /* Jvm/instr.scm 204 */
BgL_auxz00_4994 = 
CNST_TABLE_REF(((long)36))
; }  else 
{ /* Jvm/instr.scm 204 */
BgL_auxz00_4994 = 
CNST_TABLE_REF(((long)37))
; } } 
BgL_arg3076z00_3046 = 
MAKE_PAIR(BgL_auxz00_4994, BgL_auxz00_5005); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_18))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3046), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_18, 
BGl_simplezd2typezd2zzjvm_instrz00(BgL_typez00_19));} } } 
}



/* __pop */
obj_t BGl___popz00zzjvm_instrz00(obj_t BgL_envz00_4490, obj_t BgL_envz00_4491, obj_t BgL_typez00_4492)
{ AN_OBJECT;
{ /* Jvm/instr.scm 200 */
return 
BGl__popz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4491), BgL_typez00_4492);} 
}



/* _load */
obj_t BGl__loadz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_22, BgL_localz00_bglt BgL_varz00_23)
{ AN_OBJECT;
{ /* Jvm/instr.scm 218 */
{ /* Jvm/instr.scm 219 */
obj_t BgL_arg3235z00_3056;obj_t BgL_arg3236z00_3057;
BgL_arg3235z00_3056 = 
(((BgL_localz00_bglt)CREF(BgL_varz00_23))->BgL_namez00); 
{ /* Jvm/instr.scm 219 */
obj_t BgL_auxz00_5014;
{ /* Jvm/instr.scm 219 */
BgL_typez00_bglt BgL_auxz00_5015;
BgL_auxz00_5015 = 
(((BgL_localz00_bglt)CREF(BgL_varz00_23))->BgL_typez00); 
BgL_auxz00_5014 = 
(obj_t)(BgL_auxz00_5015); } 
BgL_arg3236z00_3057 = 
BGl_compilezd2typezd2zzjvm_envz00(BgL_auxz00_5014, BgL_envz00_22); } 
return 
BGl__load_namez00zzjvm_instrz00(BgL_envz00_22, BgL_arg3235z00_3056, BgL_arg3236z00_3057);} } 
}



/* __load */
obj_t BGl___loadz00zzjvm_instrz00(obj_t BgL_envz00_4493, obj_t BgL_envz00_4494, obj_t BgL_varz00_4495)
{ AN_OBJECT;
{ /* Jvm/instr.scm 218 */
return 
BGl__loadz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4494), 
(BgL_localz00_bglt)(BgL_varz00_4495));} 
}



/* _load_name */
obj_t BGl__load_namez00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_24, obj_t BgL_namez00_25, obj_t BgL_typez00_26)
{ AN_OBJECT;
{ /* Jvm/instr.scm 221 */
{ /* Jvm/instr.scm 222 */
obj_t BgL_namez00_1755;
{ /* Jvm/instr.scm 222 */
obj_t BgL_slotz00_3064;
BgL_slotz00_3064 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_namez00_25, 
(((BgL_envz00_bglt)CREF(BgL_envz00_24))->BgL_maplocalsz00)); 
if(
CBOOL(BgL_slotz00_3064))
{ /* Jvm/instr.scm 222 */
BgL_namez00_1755 = 
CDR(BgL_slotz00_3064); }  else 
{ /* Jvm/instr.scm 222 */
BgL_namez00_1755 = BgL_namez00_25; } } 
{ /* Jvm/instr.scm 224 */
obj_t BgL_arg3244z00_1756;
{ /* Jvm/instr.scm 224 */
bool_t BgL_testz00_5028;
{ /* Jvm/instr.scm 224 */
obj_t BgL_auxz00_5029;
BgL_auxz00_5029 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_typez00_26, 
CNST_TABLE_REF(((long)3))); 
BgL_testz00_5028 = 
CBOOL(BgL_auxz00_5029); } 
if(BgL_testz00_5028)
{ /* Jvm/instr.scm 225 */
obj_t BgL_arg3248z00_1759;obj_t BgL_arg3249z00_1760;
BgL_arg3248z00_1759 = 
CNST_TABLE_REF(((long)38)); 
BgL_arg3249z00_1760 = 
MAKE_PAIR(BgL_namez00_1755, BNIL); 
BgL_arg3244z00_1756 = 
MAKE_PAIR(BgL_arg3248z00_1759, BgL_arg3249z00_1760); }  else 
{ /* Jvm/instr.scm 224 */
bool_t BgL_testz00_5036;
{ /* Jvm/instr.scm 224 */
obj_t BgL_auxz00_5037;
BgL_auxz00_5037 = 
CNST_TABLE_REF(((long)5)); 
BgL_testz00_5036 = 
(BgL_typez00_26==BgL_auxz00_5037); } 
if(BgL_testz00_5036)
{ /* Jvm/instr.scm 226 */
obj_t BgL_arg3254z00_1762;obj_t BgL_arg3255z00_1763;
BgL_arg3254z00_1762 = 
CNST_TABLE_REF(((long)39)); 
BgL_arg3255z00_1763 = 
MAKE_PAIR(BgL_namez00_1755, BNIL); 
BgL_arg3244z00_1756 = 
MAKE_PAIR(BgL_arg3254z00_1762, BgL_arg3255z00_1763); }  else 
{ /* Jvm/instr.scm 224 */
bool_t BgL_testz00_5043;
{ /* Jvm/instr.scm 224 */
obj_t BgL_auxz00_5044;
BgL_auxz00_5044 = 
CNST_TABLE_REF(((long)6)); 
BgL_testz00_5043 = 
(BgL_typez00_26==BgL_auxz00_5044); } 
if(BgL_testz00_5043)
{ /* Jvm/instr.scm 227 */
obj_t BgL_arg3260z00_1765;obj_t BgL_arg3261z00_1766;
BgL_arg3260z00_1765 = 
CNST_TABLE_REF(((long)40)); 
BgL_arg3261z00_1766 = 
MAKE_PAIR(BgL_namez00_1755, BNIL); 
BgL_arg3244z00_1756 = 
MAKE_PAIR(BgL_arg3260z00_1765, BgL_arg3261z00_1766); }  else 
{ /* Jvm/instr.scm 224 */
bool_t BgL_testz00_5050;
{ /* Jvm/instr.scm 224 */
obj_t BgL_auxz00_5051;
BgL_auxz00_5051 = 
CNST_TABLE_REF(((long)7)); 
BgL_testz00_5050 = 
(BgL_typez00_26==BgL_auxz00_5051); } 
if(BgL_testz00_5050)
{ /* Jvm/instr.scm 228 */
obj_t BgL_arg3266z00_1768;obj_t BgL_arg3267z00_1769;
BgL_arg3266z00_1768 = 
CNST_TABLE_REF(((long)41)); 
BgL_arg3267z00_1769 = 
MAKE_PAIR(BgL_namez00_1755, BNIL); 
BgL_arg3244z00_1756 = 
MAKE_PAIR(BgL_arg3266z00_1768, BgL_arg3267z00_1769); }  else 
{ /* Jvm/instr.scm 229 */
obj_t BgL_arg3271z00_1770;obj_t BgL_arg3272z00_1771;
BgL_arg3271z00_1770 = 
CNST_TABLE_REF(((long)42)); 
BgL_arg3272z00_1771 = 
MAKE_PAIR(BgL_namez00_1755, BNIL); 
BgL_arg3244z00_1756 = 
MAKE_PAIR(BgL_arg3271z00_1770, BgL_arg3272z00_1771); } } } } } 
{ /* Jvm/instr.scm 223 */
obj_t BgL_arg3076z00_3071;
{ /* Jvm/instr.scm 223 */
obj_t BgL_auxz00_5060;
BgL_auxz00_5060 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_24))->BgL_codez00); 
BgL_arg3076z00_3071 = 
MAKE_PAIR(BgL_arg3244z00_1756, BgL_auxz00_5060); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_24))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3071), BUNSPEC); } ((bool_t)1); } 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_24, 
BGl_simplezd2typezd2zzjvm_instrz00(BgL_typez00_26));} } 
}



/* __load_name */
obj_t BGl___load_namez00zzjvm_instrz00(obj_t BgL_envz00_4496, obj_t BgL_envz00_4497, obj_t BgL_namez00_4498, obj_t BgL_typez00_4499)
{ AN_OBJECT;
{ /* Jvm/instr.scm 221 */
return 
BGl__load_namez00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4497), BgL_namez00_4498, BgL_typez00_4499);} 
}



/* _store */
obj_t BGl__storez00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_27, BgL_localz00_bglt BgL_varz00_28)
{ AN_OBJECT;
{ /* Jvm/instr.scm 232 */
{ /* Jvm/instr.scm 233 */
obj_t BgL_arg3285z00_3076;obj_t BgL_arg3286z00_3077;
BgL_arg3285z00_3076 = 
(((BgL_localz00_bglt)CREF(BgL_varz00_28))->BgL_namez00); 
{ /* Jvm/instr.scm 233 */
obj_t BgL_auxz00_5069;
{ /* Jvm/instr.scm 233 */
BgL_typez00_bglt BgL_auxz00_5070;
BgL_auxz00_5070 = 
(((BgL_localz00_bglt)CREF(BgL_varz00_28))->BgL_typez00); 
BgL_auxz00_5069 = 
(obj_t)(BgL_auxz00_5070); } 
BgL_arg3286z00_3077 = 
BGl_compilezd2typezd2zzjvm_envz00(BgL_auxz00_5069, BgL_envz00_27); } 
return 
BGl__store_namez00zzjvm_instrz00(BgL_envz00_27, BgL_arg3285z00_3076, BgL_arg3286z00_3077);} } 
}



/* __store */
obj_t BGl___storez00zzjvm_instrz00(obj_t BgL_envz00_4500, obj_t BgL_envz00_4501, obj_t BgL_varz00_4502)
{ AN_OBJECT;
{ /* Jvm/instr.scm 232 */
return 
BGl__storez00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4501), 
(BgL_localz00_bglt)(BgL_varz00_4502));} 
}



/* _store_name */
obj_t BGl__store_namez00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_29, obj_t BgL_namez00_30, obj_t BgL_typez00_31)
{ AN_OBJECT;
{ /* Jvm/instr.scm 235 */
{ /* Jvm/instr.scm 236 */
obj_t BgL_namez00_1776;
{ /* Jvm/instr.scm 236 */
obj_t BgL_slotz00_3084;
BgL_slotz00_3084 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_namez00_30, 
(((BgL_envz00_bglt)CREF(BgL_envz00_29))->BgL_maplocalsz00)); 
if(
CBOOL(BgL_slotz00_3084))
{ /* Jvm/instr.scm 236 */
BgL_namez00_1776 = 
CDR(BgL_slotz00_3084); }  else 
{ /* Jvm/instr.scm 236 */
BgL_namez00_1776 = BgL_namez00_30; } } 
{ /* Jvm/instr.scm 238 */
obj_t BgL_arg3294z00_1777;
{ /* Jvm/instr.scm 238 */
bool_t BgL_testz00_5083;
{ /* Jvm/instr.scm 238 */
obj_t BgL_auxz00_5084;
BgL_auxz00_5084 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_typez00_31, 
CNST_TABLE_REF(((long)3))); 
BgL_testz00_5083 = 
CBOOL(BgL_auxz00_5084); } 
if(BgL_testz00_5083)
{ /* Jvm/instr.scm 239 */
obj_t BgL_arg3298z00_1780;obj_t BgL_arg3299z00_1781;
BgL_arg3298z00_1780 = 
CNST_TABLE_REF(((long)43)); 
BgL_arg3299z00_1781 = 
MAKE_PAIR(BgL_namez00_1776, BNIL); 
BgL_arg3294z00_1777 = 
MAKE_PAIR(BgL_arg3298z00_1780, BgL_arg3299z00_1781); }  else 
{ /* Jvm/instr.scm 238 */
bool_t BgL_testz00_5091;
{ /* Jvm/instr.scm 238 */
obj_t BgL_auxz00_5092;
BgL_auxz00_5092 = 
CNST_TABLE_REF(((long)5)); 
BgL_testz00_5091 = 
(BgL_typez00_31==BgL_auxz00_5092); } 
if(BgL_testz00_5091)
{ /* Jvm/instr.scm 240 */
obj_t BgL_arg3304z00_1783;obj_t BgL_arg3305z00_1784;
BgL_arg3304z00_1783 = 
CNST_TABLE_REF(((long)44)); 
BgL_arg3305z00_1784 = 
MAKE_PAIR(BgL_namez00_1776, BNIL); 
BgL_arg3294z00_1777 = 
MAKE_PAIR(BgL_arg3304z00_1783, BgL_arg3305z00_1784); }  else 
{ /* Jvm/instr.scm 238 */
bool_t BgL_testz00_5098;
{ /* Jvm/instr.scm 238 */
obj_t BgL_auxz00_5099;
BgL_auxz00_5099 = 
CNST_TABLE_REF(((long)6)); 
BgL_testz00_5098 = 
(BgL_typez00_31==BgL_auxz00_5099); } 
if(BgL_testz00_5098)
{ /* Jvm/instr.scm 241 */
obj_t BgL_arg3310z00_1786;obj_t BgL_arg3311z00_1787;
BgL_arg3310z00_1786 = 
CNST_TABLE_REF(((long)45)); 
BgL_arg3311z00_1787 = 
MAKE_PAIR(BgL_namez00_1776, BNIL); 
BgL_arg3294z00_1777 = 
MAKE_PAIR(BgL_arg3310z00_1786, BgL_arg3311z00_1787); }  else 
{ /* Jvm/instr.scm 238 */
bool_t BgL_testz00_5105;
{ /* Jvm/instr.scm 238 */
obj_t BgL_auxz00_5106;
BgL_auxz00_5106 = 
CNST_TABLE_REF(((long)7)); 
BgL_testz00_5105 = 
(BgL_typez00_31==BgL_auxz00_5106); } 
if(BgL_testz00_5105)
{ /* Jvm/instr.scm 242 */
obj_t BgL_arg3316z00_1789;obj_t BgL_arg3317z00_1790;
BgL_arg3316z00_1789 = 
CNST_TABLE_REF(((long)46)); 
BgL_arg3317z00_1790 = 
MAKE_PAIR(BgL_namez00_1776, BNIL); 
BgL_arg3294z00_1777 = 
MAKE_PAIR(BgL_arg3316z00_1789, BgL_arg3317z00_1790); }  else 
{ /* Jvm/instr.scm 243 */
obj_t BgL_arg3321z00_1791;obj_t BgL_arg3322z00_1792;
BgL_arg3321z00_1791 = 
CNST_TABLE_REF(((long)47)); 
BgL_arg3322z00_1792 = 
MAKE_PAIR(BgL_namez00_1776, BNIL); 
BgL_arg3294z00_1777 = 
MAKE_PAIR(BgL_arg3321z00_1791, BgL_arg3322z00_1792); } } } } } 
{ /* Jvm/instr.scm 237 */
obj_t BgL_arg3076z00_3091;
{ /* Jvm/instr.scm 237 */
obj_t BgL_auxz00_5115;
BgL_auxz00_5115 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_29))->BgL_codez00); 
BgL_arg3076z00_3091 = 
MAKE_PAIR(BgL_arg3294z00_1777, BgL_auxz00_5115); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_29))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3091), BUNSPEC); } ((bool_t)1); } 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_29, 
BGl_simplezd2typezd2zzjvm_instrz00(BgL_typez00_31));} } 
}



/* __store_name */
obj_t BGl___store_namez00zzjvm_instrz00(obj_t BgL_envz00_4503, obj_t BgL_envz00_4504, obj_t BgL_namez00_4505, obj_t BgL_typez00_4506)
{ AN_OBJECT;
{ /* Jvm/instr.scm 235 */
return 
BGl__store_namez00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4504), BgL_namez00_4505, BgL_typez00_4506);} 
}



/* _getstatic */
obj_t BGl__getstaticz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_32, obj_t BgL_varz00_33)
{ AN_OBJECT;
{ /* Jvm/instr.scm 247 */
{ /* Jvm/instr.scm 248 */
obj_t BgL_arg3335z00_1794;
{ /* Jvm/instr.scm 248 */
obj_t BgL_arg3338z00_1795;obj_t BgL_arg3339z00_1796;
BgL_arg3338z00_1795 = 
CNST_TABLE_REF(((long)48)); 
BgL_arg3339z00_1796 = 
MAKE_PAIR(BgL_varz00_33, BNIL); 
BgL_arg3335z00_1794 = 
MAKE_PAIR(BgL_arg3338z00_1795, BgL_arg3339z00_1796); } 
{ /* Jvm/instr.scm 248 */
obj_t BgL_arg3076z00_3099;
{ /* Jvm/instr.scm 248 */
obj_t BgL_auxz00_5126;
BgL_auxz00_5126 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_32))->BgL_codez00); 
BgL_arg3076z00_3099 = 
MAKE_PAIR(BgL_arg3335z00_1794, BgL_auxz00_5126); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_32))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3099), BUNSPEC); } ((bool_t)1); } 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_32, 
CNST_TABLE_REF(((long)8)));} 
}



/* __getstatic */
obj_t BGl___getstaticz00zzjvm_instrz00(obj_t BgL_envz00_4507, obj_t BgL_envz00_4508, obj_t BgL_varz00_4509)
{ AN_OBJECT;
{ /* Jvm/instr.scm 247 */
return 
BGl__getstaticz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4508), BgL_varz00_4509);} 
}



/* _getstatic2 */
obj_t BGl__getstatic2z00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_34, BgL_globalz00_bglt BgL_varz00_35)
{ AN_OBJECT;
{ /* Jvm/instr.scm 251 */
{ /* Jvm/instr.scm 252 */
obj_t BgL_arg3344z00_1797;
{ /* Jvm/instr.scm 252 */
obj_t BgL_arg3347z00_1798;obj_t BgL_arg3348z00_1799;
BgL_arg3347z00_1798 = 
CNST_TABLE_REF(((long)48)); 
{ /* Jvm/instr.scm 252 */
obj_t BgL_arg3351z00_1800;
BgL_arg3351z00_1800 = 
BGl_getzd2globalzd2namez00zzjvm_envz00(BgL_envz00_34, BgL_varz00_35); 
BgL_arg3348z00_1799 = 
MAKE_PAIR(BgL_arg3351z00_1800, BNIL); } 
BgL_arg3344z00_1797 = 
MAKE_PAIR(BgL_arg3347z00_1798, BgL_arg3348z00_1799); } 
{ /* Jvm/instr.scm 252 */
obj_t BgL_arg3076z00_3107;
{ /* Jvm/instr.scm 252 */
obj_t BgL_auxz00_5138;
BgL_auxz00_5138 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_34))->BgL_codez00); 
BgL_arg3076z00_3107 = 
MAKE_PAIR(BgL_arg3344z00_1797, BgL_auxz00_5138); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_34))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3107), BUNSPEC); } ((bool_t)1); } 
{ /* Jvm/instr.scm 253 */
obj_t BgL_arg3356z00_1802;
{ /* Jvm/instr.scm 253 */
obj_t BgL_arg3359z00_1803;
{ /* Jvm/instr.scm 253 */
obj_t BgL_auxz00_5142;
{ /* Jvm/instr.scm 253 */
BgL_typez00_bglt BgL_auxz00_5143;
{ /* Jvm/instr.scm 253 */
BgL_variablez00_bglt BgL_obj1101z00_3112;
BgL_obj1101z00_3112 = 
(BgL_variablez00_bglt)(BgL_varz00_35); 
BgL_auxz00_5143 = 
(((BgL_variablez00_bglt)CREF(BgL_obj1101z00_3112))->BgL_typez00); } 
BgL_auxz00_5142 = 
(obj_t)(BgL_auxz00_5143); } 
BgL_arg3359z00_1803 = 
BGl_compilezd2typezd2zzjvm_envz00(BgL_auxz00_5142, BgL_envz00_34); } 
BgL_arg3356z00_1802 = 
BGl_simplezd2typezd2zzjvm_instrz00(BgL_arg3359z00_1803); } 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_34, BgL_arg3356z00_1802);} } 
}



/* __getstatic2 */
obj_t BGl___getstatic2z00zzjvm_instrz00(obj_t BgL_envz00_4510, obj_t BgL_envz00_4511, obj_t BgL_varz00_4512)
{ AN_OBJECT;
{ /* Jvm/instr.scm 251 */
return 
BGl__getstatic2z00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4511), 
(BgL_globalz00_bglt)(BgL_varz00_4512));} 
}



/* _putstatic */
obj_t BGl__putstaticz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_36, obj_t BgL_varz00_37)
{ AN_OBJECT;
{ /* Jvm/instr.scm 255 */
{ /* Jvm/instr.scm 256 */
obj_t BgL_arg3366z00_1805;
{ /* Jvm/instr.scm 256 */
obj_t BgL_arg3369z00_1806;obj_t BgL_arg3370z00_1807;
BgL_arg3369z00_1806 = 
CNST_TABLE_REF(((long)49)); 
BgL_arg3370z00_1807 = 
MAKE_PAIR(BgL_varz00_37, BNIL); 
BgL_arg3366z00_1805 = 
MAKE_PAIR(BgL_arg3369z00_1806, BgL_arg3370z00_1807); } 
{ /* Jvm/instr.scm 256 */
obj_t BgL_arg3076z00_3116;
{ /* Jvm/instr.scm 256 */
obj_t BgL_auxz00_5156;
BgL_auxz00_5156 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_36))->BgL_codez00); 
BgL_arg3076z00_3116 = 
MAKE_PAIR(BgL_arg3366z00_1805, BgL_auxz00_5156); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_36))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3116), BUNSPEC); } ((bool_t)1); } 
return 
BGl_popz00zzjvm_instrz00(BgL_envz00_36);} 
}



/* __putstatic */
obj_t BGl___putstaticz00zzjvm_instrz00(obj_t BgL_envz00_4513, obj_t BgL_envz00_4514, obj_t BgL_varz00_4515)
{ AN_OBJECT;
{ /* Jvm/instr.scm 255 */
return 
BGl__putstaticz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4514), BgL_varz00_4515);} 
}



/* _iadd */
obj_t BGl__iaddz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_38)
{ AN_OBJECT;
{ /* Jvm/instr.scm 260 */
{ /* Jvm/instr.scm 260 */
obj_t BgL_arg3076z00_3124;
{ /* Jvm/instr.scm 260 */
obj_t BgL_auxz00_5165;obj_t BgL_auxz00_5163;
BgL_auxz00_5165 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_38))->BgL_codez00); 
BgL_auxz00_5163 = 
CNST_TABLE_REF(((long)50)); 
BgL_arg3076z00_3124 = 
MAKE_PAIR(BgL_auxz00_5163, BgL_auxz00_5165); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_38))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3124), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_38, 
CNST_TABLE_REF(((long)4)));} 
}



/* __iadd */
obj_t BGl___iaddz00zzjvm_instrz00(obj_t BgL_envz00_4516, obj_t BgL_envz00_4517)
{ AN_OBJECT;
{ /* Jvm/instr.scm 260 */
return 
BGl__iaddz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4517));} 
}



/* _isub */
obj_t BGl__isubz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_39)
{ AN_OBJECT;
{ /* Jvm/instr.scm 261 */
{ /* Jvm/instr.scm 261 */
obj_t BgL_arg3076z00_3132;
{ /* Jvm/instr.scm 261 */
obj_t BgL_auxz00_5175;obj_t BgL_auxz00_5173;
BgL_auxz00_5175 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_39))->BgL_codez00); 
BgL_auxz00_5173 = 
CNST_TABLE_REF(((long)51)); 
BgL_arg3076z00_3132 = 
MAKE_PAIR(BgL_auxz00_5173, BgL_auxz00_5175); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_39))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3132), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_39, 
CNST_TABLE_REF(((long)4)));} 
}



/* __isub */
obj_t BGl___isubz00zzjvm_instrz00(obj_t BgL_envz00_4518, obj_t BgL_envz00_4519)
{ AN_OBJECT;
{ /* Jvm/instr.scm 261 */
return 
BGl__isubz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4519));} 
}



/* _imul */
obj_t BGl__imulz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_40)
{ AN_OBJECT;
{ /* Jvm/instr.scm 262 */
{ /* Jvm/instr.scm 262 */
obj_t BgL_arg3076z00_3140;
{ /* Jvm/instr.scm 262 */
obj_t BgL_auxz00_5185;obj_t BgL_auxz00_5183;
BgL_auxz00_5185 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_40))->BgL_codez00); 
BgL_auxz00_5183 = 
CNST_TABLE_REF(((long)52)); 
BgL_arg3076z00_3140 = 
MAKE_PAIR(BgL_auxz00_5183, BgL_auxz00_5185); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_40))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3140), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_40, 
CNST_TABLE_REF(((long)4)));} 
}



/* __imul */
obj_t BGl___imulz00zzjvm_instrz00(obj_t BgL_envz00_4520, obj_t BgL_envz00_4521)
{ AN_OBJECT;
{ /* Jvm/instr.scm 262 */
return 
BGl__imulz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4521));} 
}



/* _idiv */
obj_t BGl__idivz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_41)
{ AN_OBJECT;
{ /* Jvm/instr.scm 263 */
{ /* Jvm/instr.scm 263 */
obj_t BgL_arg3076z00_3148;
{ /* Jvm/instr.scm 263 */
obj_t BgL_auxz00_5195;obj_t BgL_auxz00_5193;
BgL_auxz00_5195 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_41))->BgL_codez00); 
BgL_auxz00_5193 = 
CNST_TABLE_REF(((long)53)); 
BgL_arg3076z00_3148 = 
MAKE_PAIR(BgL_auxz00_5193, BgL_auxz00_5195); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_41))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3148), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_41, 
CNST_TABLE_REF(((long)4)));} 
}



/* __idiv */
obj_t BGl___idivz00zzjvm_instrz00(obj_t BgL_envz00_4522, obj_t BgL_envz00_4523)
{ AN_OBJECT;
{ /* Jvm/instr.scm 263 */
return 
BGl__idivz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4523));} 
}



/* _irem */
obj_t BGl__iremz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_42)
{ AN_OBJECT;
{ /* Jvm/instr.scm 264 */
{ /* Jvm/instr.scm 264 */
obj_t BgL_arg3076z00_3156;
{ /* Jvm/instr.scm 264 */
obj_t BgL_auxz00_5205;obj_t BgL_auxz00_5203;
BgL_auxz00_5205 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_42))->BgL_codez00); 
BgL_auxz00_5203 = 
CNST_TABLE_REF(((long)54)); 
BgL_arg3076z00_3156 = 
MAKE_PAIR(BgL_auxz00_5203, BgL_auxz00_5205); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_42))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3156), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_42, 
CNST_TABLE_REF(((long)4)));} 
}



/* __irem */
obj_t BGl___iremz00zzjvm_instrz00(obj_t BgL_envz00_4524, obj_t BgL_envz00_4525)
{ AN_OBJECT;
{ /* Jvm/instr.scm 264 */
return 
BGl__iremz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4525));} 
}



/* _ineg */
obj_t BGl__inegz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_43)
{ AN_OBJECT;
{ /* Jvm/instr.scm 265 */
{ /* Jvm/instr.scm 265 */
obj_t BgL_arg3076z00_3164;
{ /* Jvm/instr.scm 265 */
obj_t BgL_auxz00_5215;obj_t BgL_auxz00_5213;
BgL_auxz00_5215 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_43))->BgL_codez00); 
BgL_auxz00_5213 = 
CNST_TABLE_REF(((long)55)); 
BgL_arg3076z00_3164 = 
MAKE_PAIR(BgL_auxz00_5213, BgL_auxz00_5215); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_43))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3164), BUNSPEC); } 
return BTRUE;} 
}



/* __ineg */
obj_t BGl___inegz00zzjvm_instrz00(obj_t BgL_envz00_4526, obj_t BgL_envz00_4527)
{ AN_OBJECT;
{ /* Jvm/instr.scm 265 */
return 
BGl__inegz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4527));} 
}



/* _ior */
obj_t BGl__iorz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_44)
{ AN_OBJECT;
{ /* Jvm/instr.scm 266 */
{ /* Jvm/instr.scm 266 */
obj_t BgL_arg3076z00_3172;
{ /* Jvm/instr.scm 266 */
obj_t BgL_auxz00_5223;obj_t BgL_auxz00_5221;
BgL_auxz00_5223 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_44))->BgL_codez00); 
BgL_auxz00_5221 = 
CNST_TABLE_REF(((long)56)); 
BgL_arg3076z00_3172 = 
MAKE_PAIR(BgL_auxz00_5221, BgL_auxz00_5223); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_44))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3172), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_44, 
CNST_TABLE_REF(((long)4)));} 
}



/* __ior */
obj_t BGl___iorz00zzjvm_instrz00(obj_t BgL_envz00_4528, obj_t BgL_envz00_4529)
{ AN_OBJECT;
{ /* Jvm/instr.scm 266 */
return 
BGl__iorz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4529));} 
}



/* _iand */
obj_t BGl__iandz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_45)
{ AN_OBJECT;
{ /* Jvm/instr.scm 267 */
{ /* Jvm/instr.scm 267 */
obj_t BgL_arg3076z00_3180;
{ /* Jvm/instr.scm 267 */
obj_t BgL_auxz00_5233;obj_t BgL_auxz00_5231;
BgL_auxz00_5233 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_45))->BgL_codez00); 
BgL_auxz00_5231 = 
CNST_TABLE_REF(((long)57)); 
BgL_arg3076z00_3180 = 
MAKE_PAIR(BgL_auxz00_5231, BgL_auxz00_5233); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_45))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3180), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_45, 
CNST_TABLE_REF(((long)4)));} 
}



/* __iand */
obj_t BGl___iandz00zzjvm_instrz00(obj_t BgL_envz00_4530, obj_t BgL_envz00_4531)
{ AN_OBJECT;
{ /* Jvm/instr.scm 267 */
return 
BGl__iandz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4531));} 
}



/* _ixor */
obj_t BGl__ixorz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_46)
{ AN_OBJECT;
{ /* Jvm/instr.scm 268 */
{ /* Jvm/instr.scm 268 */
obj_t BgL_arg3076z00_3188;
{ /* Jvm/instr.scm 268 */
obj_t BgL_auxz00_5243;obj_t BgL_auxz00_5241;
BgL_auxz00_5243 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_46))->BgL_codez00); 
BgL_auxz00_5241 = 
CNST_TABLE_REF(((long)58)); 
BgL_arg3076z00_3188 = 
MAKE_PAIR(BgL_auxz00_5241, BgL_auxz00_5243); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_46))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3188), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_46, 
CNST_TABLE_REF(((long)4)));} 
}



/* __ixor */
obj_t BGl___ixorz00zzjvm_instrz00(obj_t BgL_envz00_4532, obj_t BgL_envz00_4533)
{ AN_OBJECT;
{ /* Jvm/instr.scm 268 */
return 
BGl__ixorz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4533));} 
}



/* _ishl */
obj_t BGl__ishlz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_47)
{ AN_OBJECT;
{ /* Jvm/instr.scm 269 */
{ /* Jvm/instr.scm 269 */
obj_t BgL_arg3076z00_3196;
{ /* Jvm/instr.scm 269 */
obj_t BgL_auxz00_5253;obj_t BgL_auxz00_5251;
BgL_auxz00_5253 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_47))->BgL_codez00); 
BgL_auxz00_5251 = 
CNST_TABLE_REF(((long)59)); 
BgL_arg3076z00_3196 = 
MAKE_PAIR(BgL_auxz00_5251, BgL_auxz00_5253); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_47))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3196), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_47, 
CNST_TABLE_REF(((long)4)));} 
}



/* __ishl */
obj_t BGl___ishlz00zzjvm_instrz00(obj_t BgL_envz00_4534, obj_t BgL_envz00_4535)
{ AN_OBJECT;
{ /* Jvm/instr.scm 269 */
return 
BGl__ishlz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4535));} 
}



/* _ishr */
obj_t BGl__ishrz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_48)
{ AN_OBJECT;
{ /* Jvm/instr.scm 270 */
{ /* Jvm/instr.scm 270 */
obj_t BgL_arg3076z00_3204;
{ /* Jvm/instr.scm 270 */
obj_t BgL_auxz00_5263;obj_t BgL_auxz00_5261;
BgL_auxz00_5263 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_48))->BgL_codez00); 
BgL_auxz00_5261 = 
CNST_TABLE_REF(((long)60)); 
BgL_arg3076z00_3204 = 
MAKE_PAIR(BgL_auxz00_5261, BgL_auxz00_5263); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_48))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3204), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_48, 
CNST_TABLE_REF(((long)4)));} 
}



/* __ishr */
obj_t BGl___ishrz00zzjvm_instrz00(obj_t BgL_envz00_4536, obj_t BgL_envz00_4537)
{ AN_OBJECT;
{ /* Jvm/instr.scm 270 */
return 
BGl__ishrz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4537));} 
}



/* _iushr */
obj_t BGl__iushrz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_49)
{ AN_OBJECT;
{ /* Jvm/instr.scm 271 */
{ /* Jvm/instr.scm 271 */
obj_t BgL_arg3076z00_3212;
{ /* Jvm/instr.scm 271 */
obj_t BgL_auxz00_5273;obj_t BgL_auxz00_5271;
BgL_auxz00_5273 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_49))->BgL_codez00); 
BgL_auxz00_5271 = 
CNST_TABLE_REF(((long)61)); 
BgL_arg3076z00_3212 = 
MAKE_PAIR(BgL_auxz00_5271, BgL_auxz00_5273); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_49))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3212), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_49, 
CNST_TABLE_REF(((long)4)));} 
}



/* __iushr */
obj_t BGl___iushrz00zzjvm_instrz00(obj_t BgL_envz00_4538, obj_t BgL_envz00_4539)
{ AN_OBJECT;
{ /* Jvm/instr.scm 271 */
return 
BGl__iushrz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4539));} 
}



/* _ladd */
obj_t BGl__laddz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_50)
{ AN_OBJECT;
{ /* Jvm/instr.scm 273 */
{ /* Jvm/instr.scm 273 */
obj_t BgL_arg3076z00_3220;
{ /* Jvm/instr.scm 273 */
obj_t BgL_auxz00_5283;obj_t BgL_auxz00_5281;
BgL_auxz00_5283 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_50))->BgL_codez00); 
BgL_auxz00_5281 = 
CNST_TABLE_REF(((long)62)); 
BgL_arg3076z00_3220 = 
MAKE_PAIR(BgL_auxz00_5281, BgL_auxz00_5283); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_50))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3220), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_50, 
CNST_TABLE_REF(((long)5)));} 
}



/* __ladd */
obj_t BGl___laddz00zzjvm_instrz00(obj_t BgL_envz00_4540, obj_t BgL_envz00_4541)
{ AN_OBJECT;
{ /* Jvm/instr.scm 273 */
return 
BGl__laddz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4541));} 
}



/* _lsub */
obj_t BGl__lsubz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_51)
{ AN_OBJECT;
{ /* Jvm/instr.scm 274 */
{ /* Jvm/instr.scm 274 */
obj_t BgL_arg3076z00_3228;
{ /* Jvm/instr.scm 274 */
obj_t BgL_auxz00_5293;obj_t BgL_auxz00_5291;
BgL_auxz00_5293 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_51))->BgL_codez00); 
BgL_auxz00_5291 = 
CNST_TABLE_REF(((long)63)); 
BgL_arg3076z00_3228 = 
MAKE_PAIR(BgL_auxz00_5291, BgL_auxz00_5293); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_51))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3228), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_51, 
CNST_TABLE_REF(((long)5)));} 
}



/* __lsub */
obj_t BGl___lsubz00zzjvm_instrz00(obj_t BgL_envz00_4542, obj_t BgL_envz00_4543)
{ AN_OBJECT;
{ /* Jvm/instr.scm 274 */
return 
BGl__lsubz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4543));} 
}



/* _lmul */
obj_t BGl__lmulz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_52)
{ AN_OBJECT;
{ /* Jvm/instr.scm 275 */
{ /* Jvm/instr.scm 275 */
obj_t BgL_arg3076z00_3236;
{ /* Jvm/instr.scm 275 */
obj_t BgL_auxz00_5303;obj_t BgL_auxz00_5301;
BgL_auxz00_5303 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_52))->BgL_codez00); 
BgL_auxz00_5301 = 
CNST_TABLE_REF(((long)64)); 
BgL_arg3076z00_3236 = 
MAKE_PAIR(BgL_auxz00_5301, BgL_auxz00_5303); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_52))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3236), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_52, 
CNST_TABLE_REF(((long)5)));} 
}



/* __lmul */
obj_t BGl___lmulz00zzjvm_instrz00(obj_t BgL_envz00_4544, obj_t BgL_envz00_4545)
{ AN_OBJECT;
{ /* Jvm/instr.scm 275 */
return 
BGl__lmulz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4545));} 
}



/* _ldiv */
obj_t BGl__ldivz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_53)
{ AN_OBJECT;
{ /* Jvm/instr.scm 276 */
{ /* Jvm/instr.scm 276 */
obj_t BgL_arg3076z00_3244;
{ /* Jvm/instr.scm 276 */
obj_t BgL_auxz00_5313;obj_t BgL_auxz00_5311;
BgL_auxz00_5313 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_53))->BgL_codez00); 
BgL_auxz00_5311 = 
CNST_TABLE_REF(((long)65)); 
BgL_arg3076z00_3244 = 
MAKE_PAIR(BgL_auxz00_5311, BgL_auxz00_5313); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_53))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3244), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_53, 
CNST_TABLE_REF(((long)5)));} 
}



/* __ldiv */
obj_t BGl___ldivz00zzjvm_instrz00(obj_t BgL_envz00_4546, obj_t BgL_envz00_4547)
{ AN_OBJECT;
{ /* Jvm/instr.scm 276 */
return 
BGl__ldivz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4547));} 
}



/* _lrem */
obj_t BGl__lremz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_54)
{ AN_OBJECT;
{ /* Jvm/instr.scm 277 */
{ /* Jvm/instr.scm 277 */
obj_t BgL_arg3076z00_3252;
{ /* Jvm/instr.scm 277 */
obj_t BgL_auxz00_5323;obj_t BgL_auxz00_5321;
BgL_auxz00_5323 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_54))->BgL_codez00); 
BgL_auxz00_5321 = 
CNST_TABLE_REF(((long)66)); 
BgL_arg3076z00_3252 = 
MAKE_PAIR(BgL_auxz00_5321, BgL_auxz00_5323); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_54))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3252), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_54, 
CNST_TABLE_REF(((long)5)));} 
}



/* __lrem */
obj_t BGl___lremz00zzjvm_instrz00(obj_t BgL_envz00_4548, obj_t BgL_envz00_4549)
{ AN_OBJECT;
{ /* Jvm/instr.scm 277 */
return 
BGl__lremz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4549));} 
}



/* _lneg */
obj_t BGl__lnegz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_55)
{ AN_OBJECT;
{ /* Jvm/instr.scm 278 */
{ /* Jvm/instr.scm 278 */
obj_t BgL_arg3076z00_3260;
{ /* Jvm/instr.scm 278 */
obj_t BgL_auxz00_5333;obj_t BgL_auxz00_5331;
BgL_auxz00_5333 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_55))->BgL_codez00); 
BgL_auxz00_5331 = 
CNST_TABLE_REF(((long)67)); 
BgL_arg3076z00_3260 = 
MAKE_PAIR(BgL_auxz00_5331, BgL_auxz00_5333); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_55))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3260), BUNSPEC); } 
return BTRUE;} 
}



/* __lneg */
obj_t BGl___lnegz00zzjvm_instrz00(obj_t BgL_envz00_4550, obj_t BgL_envz00_4551)
{ AN_OBJECT;
{ /* Jvm/instr.scm 278 */
return 
BGl__lnegz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4551));} 
}



/* _lor */
obj_t BGl__lorz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_56)
{ AN_OBJECT;
{ /* Jvm/instr.scm 279 */
{ /* Jvm/instr.scm 279 */
obj_t BgL_arg3076z00_3268;
{ /* Jvm/instr.scm 279 */
obj_t BgL_auxz00_5341;obj_t BgL_auxz00_5339;
BgL_auxz00_5341 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_56))->BgL_codez00); 
BgL_auxz00_5339 = 
CNST_TABLE_REF(((long)68)); 
BgL_arg3076z00_3268 = 
MAKE_PAIR(BgL_auxz00_5339, BgL_auxz00_5341); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_56))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3268), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_56, 
CNST_TABLE_REF(((long)5)));} 
}



/* __lor */
obj_t BGl___lorz00zzjvm_instrz00(obj_t BgL_envz00_4552, obj_t BgL_envz00_4553)
{ AN_OBJECT;
{ /* Jvm/instr.scm 279 */
return 
BGl__lorz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4553));} 
}



/* _land */
obj_t BGl__landz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_57)
{ AN_OBJECT;
{ /* Jvm/instr.scm 280 */
{ /* Jvm/instr.scm 280 */
obj_t BgL_arg3076z00_3276;
{ /* Jvm/instr.scm 280 */
obj_t BgL_auxz00_5351;obj_t BgL_auxz00_5349;
BgL_auxz00_5351 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_57))->BgL_codez00); 
BgL_auxz00_5349 = 
CNST_TABLE_REF(((long)69)); 
BgL_arg3076z00_3276 = 
MAKE_PAIR(BgL_auxz00_5349, BgL_auxz00_5351); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_57))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3276), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_57, 
CNST_TABLE_REF(((long)5)));} 
}



/* __land */
obj_t BGl___landz00zzjvm_instrz00(obj_t BgL_envz00_4554, obj_t BgL_envz00_4555)
{ AN_OBJECT;
{ /* Jvm/instr.scm 280 */
return 
BGl__landz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4555));} 
}



/* _lxor */
obj_t BGl__lxorz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_58)
{ AN_OBJECT;
{ /* Jvm/instr.scm 281 */
{ /* Jvm/instr.scm 281 */
obj_t BgL_arg3076z00_3284;
{ /* Jvm/instr.scm 281 */
obj_t BgL_auxz00_5361;obj_t BgL_auxz00_5359;
BgL_auxz00_5361 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_58))->BgL_codez00); 
BgL_auxz00_5359 = 
CNST_TABLE_REF(((long)70)); 
BgL_arg3076z00_3284 = 
MAKE_PAIR(BgL_auxz00_5359, BgL_auxz00_5361); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_58))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3284), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_58, 
CNST_TABLE_REF(((long)5)));} 
}



/* __lxor */
obj_t BGl___lxorz00zzjvm_instrz00(obj_t BgL_envz00_4556, obj_t BgL_envz00_4557)
{ AN_OBJECT;
{ /* Jvm/instr.scm 281 */
return 
BGl__lxorz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4557));} 
}



/* _lshl */
obj_t BGl__lshlz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_59)
{ AN_OBJECT;
{ /* Jvm/instr.scm 282 */
{ /* Jvm/instr.scm 282 */
obj_t BgL_arg3076z00_3292;
{ /* Jvm/instr.scm 282 */
obj_t BgL_auxz00_5371;obj_t BgL_auxz00_5369;
BgL_auxz00_5371 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_59))->BgL_codez00); 
BgL_auxz00_5369 = 
CNST_TABLE_REF(((long)71)); 
BgL_arg3076z00_3292 = 
MAKE_PAIR(BgL_auxz00_5369, BgL_auxz00_5371); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_59))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3292), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_59, 
CNST_TABLE_REF(((long)5)));} 
}



/* __lshl */
obj_t BGl___lshlz00zzjvm_instrz00(obj_t BgL_envz00_4558, obj_t BgL_envz00_4559)
{ AN_OBJECT;
{ /* Jvm/instr.scm 282 */
return 
BGl__lshlz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4559));} 
}



/* _lshr */
obj_t BGl__lshrz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_60)
{ AN_OBJECT;
{ /* Jvm/instr.scm 283 */
{ /* Jvm/instr.scm 283 */
obj_t BgL_arg3076z00_3300;
{ /* Jvm/instr.scm 283 */
obj_t BgL_auxz00_5381;obj_t BgL_auxz00_5379;
BgL_auxz00_5381 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_60))->BgL_codez00); 
BgL_auxz00_5379 = 
CNST_TABLE_REF(((long)72)); 
BgL_arg3076z00_3300 = 
MAKE_PAIR(BgL_auxz00_5379, BgL_auxz00_5381); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_60))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3300), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_60, 
CNST_TABLE_REF(((long)5)));} 
}



/* __lshr */
obj_t BGl___lshrz00zzjvm_instrz00(obj_t BgL_envz00_4560, obj_t BgL_envz00_4561)
{ AN_OBJECT;
{ /* Jvm/instr.scm 283 */
return 
BGl__lshrz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4561));} 
}



/* _lushr */
obj_t BGl__lushrz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_61)
{ AN_OBJECT;
{ /* Jvm/instr.scm 284 */
{ /* Jvm/instr.scm 284 */
obj_t BgL_arg3076z00_3308;
{ /* Jvm/instr.scm 284 */
obj_t BgL_auxz00_5391;obj_t BgL_auxz00_5389;
BgL_auxz00_5391 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_61))->BgL_codez00); 
BgL_auxz00_5389 = 
CNST_TABLE_REF(((long)73)); 
BgL_arg3076z00_3308 = 
MAKE_PAIR(BgL_auxz00_5389, BgL_auxz00_5391); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_61))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3308), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_61, 
CNST_TABLE_REF(((long)5)));} 
}



/* __lushr */
obj_t BGl___lushrz00zzjvm_instrz00(obj_t BgL_envz00_4562, obj_t BgL_envz00_4563)
{ AN_OBJECT;
{ /* Jvm/instr.scm 284 */
return 
BGl__lushrz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4563));} 
}



/* _dadd */
obj_t BGl__daddz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_62)
{ AN_OBJECT;
{ /* Jvm/instr.scm 286 */
{ /* Jvm/instr.scm 286 */
obj_t BgL_arg3076z00_3316;
{ /* Jvm/instr.scm 286 */
obj_t BgL_auxz00_5401;obj_t BgL_auxz00_5399;
BgL_auxz00_5401 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_62))->BgL_codez00); 
BgL_auxz00_5399 = 
CNST_TABLE_REF(((long)74)); 
BgL_arg3076z00_3316 = 
MAKE_PAIR(BgL_auxz00_5399, BgL_auxz00_5401); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_62))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3316), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_62, 
CNST_TABLE_REF(((long)7)));} 
}



/* __dadd */
obj_t BGl___daddz00zzjvm_instrz00(obj_t BgL_envz00_4564, obj_t BgL_envz00_4565)
{ AN_OBJECT;
{ /* Jvm/instr.scm 286 */
return 
BGl__daddz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4565));} 
}



/* _dsub */
obj_t BGl__dsubz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_63)
{ AN_OBJECT;
{ /* Jvm/instr.scm 287 */
{ /* Jvm/instr.scm 287 */
obj_t BgL_arg3076z00_3324;
{ /* Jvm/instr.scm 287 */
obj_t BgL_auxz00_5411;obj_t BgL_auxz00_5409;
BgL_auxz00_5411 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_63))->BgL_codez00); 
BgL_auxz00_5409 = 
CNST_TABLE_REF(((long)75)); 
BgL_arg3076z00_3324 = 
MAKE_PAIR(BgL_auxz00_5409, BgL_auxz00_5411); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_63))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3324), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_63, 
CNST_TABLE_REF(((long)7)));} 
}



/* __dsub */
obj_t BGl___dsubz00zzjvm_instrz00(obj_t BgL_envz00_4566, obj_t BgL_envz00_4567)
{ AN_OBJECT;
{ /* Jvm/instr.scm 287 */
return 
BGl__dsubz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4567));} 
}



/* _dmul */
obj_t BGl__dmulz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_64)
{ AN_OBJECT;
{ /* Jvm/instr.scm 288 */
{ /* Jvm/instr.scm 288 */
obj_t BgL_arg3076z00_3332;
{ /* Jvm/instr.scm 288 */
obj_t BgL_auxz00_5421;obj_t BgL_auxz00_5419;
BgL_auxz00_5421 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_64))->BgL_codez00); 
BgL_auxz00_5419 = 
CNST_TABLE_REF(((long)76)); 
BgL_arg3076z00_3332 = 
MAKE_PAIR(BgL_auxz00_5419, BgL_auxz00_5421); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_64))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3332), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_64, 
CNST_TABLE_REF(((long)7)));} 
}



/* __dmul */
obj_t BGl___dmulz00zzjvm_instrz00(obj_t BgL_envz00_4568, obj_t BgL_envz00_4569)
{ AN_OBJECT;
{ /* Jvm/instr.scm 288 */
return 
BGl__dmulz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4569));} 
}



/* _ddiv */
obj_t BGl__ddivz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_65)
{ AN_OBJECT;
{ /* Jvm/instr.scm 289 */
{ /* Jvm/instr.scm 289 */
obj_t BgL_arg3076z00_3340;
{ /* Jvm/instr.scm 289 */
obj_t BgL_auxz00_5431;obj_t BgL_auxz00_5429;
BgL_auxz00_5431 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_65))->BgL_codez00); 
BgL_auxz00_5429 = 
CNST_TABLE_REF(((long)77)); 
BgL_arg3076z00_3340 = 
MAKE_PAIR(BgL_auxz00_5429, BgL_auxz00_5431); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_65))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3340), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_65, 
CNST_TABLE_REF(((long)7)));} 
}



/* __ddiv */
obj_t BGl___ddivz00zzjvm_instrz00(obj_t BgL_envz00_4570, obj_t BgL_envz00_4571)
{ AN_OBJECT;
{ /* Jvm/instr.scm 289 */
return 
BGl__ddivz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4571));} 
}



/* _drem */
obj_t BGl__dremz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_66)
{ AN_OBJECT;
{ /* Jvm/instr.scm 290 */
{ /* Jvm/instr.scm 290 */
obj_t BgL_arg3076z00_3348;
{ /* Jvm/instr.scm 290 */
obj_t BgL_auxz00_5441;obj_t BgL_auxz00_5439;
BgL_auxz00_5441 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_66))->BgL_codez00); 
BgL_auxz00_5439 = 
CNST_TABLE_REF(((long)78)); 
BgL_arg3076z00_3348 = 
MAKE_PAIR(BgL_auxz00_5439, BgL_auxz00_5441); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_66))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3348), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_66, 
CNST_TABLE_REF(((long)7)));} 
}



/* __drem */
obj_t BGl___dremz00zzjvm_instrz00(obj_t BgL_envz00_4572, obj_t BgL_envz00_4573)
{ AN_OBJECT;
{ /* Jvm/instr.scm 290 */
return 
BGl__dremz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4573));} 
}



/* _dneg */
obj_t BGl__dnegz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_67)
{ AN_OBJECT;
{ /* Jvm/instr.scm 291 */
{ /* Jvm/instr.scm 291 */
obj_t BgL_arg3076z00_3356;
{ /* Jvm/instr.scm 291 */
obj_t BgL_auxz00_5451;obj_t BgL_auxz00_5449;
BgL_auxz00_5451 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_67))->BgL_codez00); 
BgL_auxz00_5449 = 
CNST_TABLE_REF(((long)79)); 
BgL_arg3076z00_3356 = 
MAKE_PAIR(BgL_auxz00_5449, BgL_auxz00_5451); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_67))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3356), BUNSPEC); } 
return BTRUE;} 
}



/* __dneg */
obj_t BGl___dnegz00zzjvm_instrz00(obj_t BgL_envz00_4574, obj_t BgL_envz00_4575)
{ AN_OBJECT;
{ /* Jvm/instr.scm 291 */
return 
BGl__dnegz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4575));} 
}



/* _lcmp */
obj_t BGl__lcmpz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_68)
{ AN_OBJECT;
{ /* Jvm/instr.scm 293 */
{ /* Jvm/instr.scm 294 */
obj_t BgL_arg3076z00_3364;
{ /* Jvm/instr.scm 294 */
obj_t BgL_auxz00_5459;obj_t BgL_auxz00_5457;
BgL_auxz00_5459 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_68))->BgL_codez00); 
BgL_auxz00_5457 = 
CNST_TABLE_REF(((long)80)); 
BgL_arg3076z00_3364 = 
MAKE_PAIR(BgL_auxz00_5457, BgL_auxz00_5459); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_68))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3364), BUNSPEC); } ((bool_t)1); 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_68, 
CNST_TABLE_REF(((long)5))); 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_68, 
CNST_TABLE_REF(((long)5))); 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_68, 
CNST_TABLE_REF(((long)4)));} 
}



/* __lcmp */
obj_t BGl___lcmpz00zzjvm_instrz00(obj_t BgL_envz00_4576, obj_t BgL_envz00_4577)
{ AN_OBJECT;
{ /* Jvm/instr.scm 293 */
return 
BGl__lcmpz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4577));} 
}



/* _dcmpg */
obj_t BGl__dcmpgz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_69)
{ AN_OBJECT;
{ /* Jvm/instr.scm 299 */
{ /* Jvm/instr.scm 300 */
obj_t BgL_arg3076z00_3372;
{ /* Jvm/instr.scm 300 */
obj_t BgL_auxz00_5473;obj_t BgL_auxz00_5471;
BgL_auxz00_5473 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_69))->BgL_codez00); 
BgL_auxz00_5471 = 
CNST_TABLE_REF(((long)81)); 
BgL_arg3076z00_3372 = 
MAKE_PAIR(BgL_auxz00_5471, BgL_auxz00_5473); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_69))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3372), BUNSPEC); } ((bool_t)1); 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_69, 
CNST_TABLE_REF(((long)7))); 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_69, 
CNST_TABLE_REF(((long)7))); 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_69, 
CNST_TABLE_REF(((long)4)));} 
}



/* __dcmpg */
obj_t BGl___dcmpgz00zzjvm_instrz00(obj_t BgL_envz00_4578, obj_t BgL_envz00_4579)
{ AN_OBJECT;
{ /* Jvm/instr.scm 299 */
return 
BGl__dcmpgz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4579));} 
}



/* _dcmpl */
obj_t BGl__dcmplz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_70)
{ AN_OBJECT;
{ /* Jvm/instr.scm 305 */
{ /* Jvm/instr.scm 306 */
obj_t BgL_arg3076z00_3380;
{ /* Jvm/instr.scm 306 */
obj_t BgL_auxz00_5487;obj_t BgL_auxz00_5485;
BgL_auxz00_5487 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_70))->BgL_codez00); 
BgL_auxz00_5485 = 
CNST_TABLE_REF(((long)82)); 
BgL_arg3076z00_3380 = 
MAKE_PAIR(BgL_auxz00_5485, BgL_auxz00_5487); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_70))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3380), BUNSPEC); } ((bool_t)1); 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_70, 
CNST_TABLE_REF(((long)7))); 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_70, 
CNST_TABLE_REF(((long)7))); 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_70, 
CNST_TABLE_REF(((long)4)));} 
}



/* __dcmpl */
obj_t BGl___dcmplz00zzjvm_instrz00(obj_t BgL_envz00_4580, obj_t BgL_envz00_4581)
{ AN_OBJECT;
{ /* Jvm/instr.scm 305 */
return 
BGl__dcmplz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4581));} 
}



/* _i2l */
obj_t BGl__i2lz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_71)
{ AN_OBJECT;
{ /* Jvm/instr.scm 311 */
{ /* Jvm/instr.scm 311 */
obj_t BgL_tfromz00_3387;obj_t BgL_ttoz00_3388;
BgL_tfromz00_3387 = 
CNST_TABLE_REF(((long)4)); 
BgL_ttoz00_3388 = 
CNST_TABLE_REF(((long)5)); 
BGl_envzd2codez12zc0zzjvm_instrz00(BgL_envz00_71, 
CNST_TABLE_REF(((long)83))); 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_71, BgL_tfromz00_3387); 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_71, BgL_ttoz00_3388);} } 
}



/* __i2l */
obj_t BGl___i2lz00zzjvm_instrz00(obj_t BgL_envz00_4582, obj_t BgL_envz00_4583)
{ AN_OBJECT;
{ /* Jvm/instr.scm 311 */
return 
BGl__i2lz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4583));} 
}



/* _i2b */
obj_t BGl__i2bz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_72)
{ AN_OBJECT;
{ /* Jvm/instr.scm 312 */
{ /* Jvm/instr.scm 312 */
obj_t BgL_tfromz00_3391;obj_t BgL_ttoz00_3392;
BgL_tfromz00_3391 = 
CNST_TABLE_REF(((long)4)); 
BgL_ttoz00_3392 = 
CNST_TABLE_REF(((long)4)); 
BGl_envzd2codez12zc0zzjvm_instrz00(BgL_envz00_72, 
CNST_TABLE_REF(((long)84))); 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_72, BgL_tfromz00_3391); 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_72, BgL_ttoz00_3392);} } 
}



/* __i2b */
obj_t BGl___i2bz00zzjvm_instrz00(obj_t BgL_envz00_4584, obj_t BgL_envz00_4585)
{ AN_OBJECT;
{ /* Jvm/instr.scm 312 */
return 
BGl__i2bz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4585));} 
}



/* _i2d */
obj_t BGl__i2dz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_73)
{ AN_OBJECT;
{ /* Jvm/instr.scm 313 */
{ /* Jvm/instr.scm 313 */
obj_t BgL_tfromz00_3395;obj_t BgL_ttoz00_3396;
BgL_tfromz00_3395 = 
CNST_TABLE_REF(((long)4)); 
BgL_ttoz00_3396 = 
CNST_TABLE_REF(((long)7)); 
BGl_envzd2codez12zc0zzjvm_instrz00(BgL_envz00_73, 
CNST_TABLE_REF(((long)85))); 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_73, BgL_tfromz00_3395); 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_73, BgL_ttoz00_3396);} } 
}



/* __i2d */
obj_t BGl___i2dz00zzjvm_instrz00(obj_t BgL_envz00_4586, obj_t BgL_envz00_4587)
{ AN_OBJECT;
{ /* Jvm/instr.scm 313 */
return 
BGl__i2dz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4587));} 
}



/* _l2i */
obj_t BGl__l2iz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_74)
{ AN_OBJECT;
{ /* Jvm/instr.scm 314 */
{ /* Jvm/instr.scm 314 */
obj_t BgL_tfromz00_3399;obj_t BgL_ttoz00_3400;
BgL_tfromz00_3399 = 
CNST_TABLE_REF(((long)5)); 
BgL_ttoz00_3400 = 
CNST_TABLE_REF(((long)4)); 
BGl_envzd2codez12zc0zzjvm_instrz00(BgL_envz00_74, 
CNST_TABLE_REF(((long)86))); 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_74, BgL_tfromz00_3399); 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_74, BgL_ttoz00_3400);} } 
}



/* __l2i */
obj_t BGl___l2iz00zzjvm_instrz00(obj_t BgL_envz00_4588, obj_t BgL_envz00_4589)
{ AN_OBJECT;
{ /* Jvm/instr.scm 314 */
return 
BGl__l2iz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4589));} 
}



/* _l2d */
obj_t BGl__l2dz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_75)
{ AN_OBJECT;
{ /* Jvm/instr.scm 315 */
{ /* Jvm/instr.scm 315 */
obj_t BgL_tfromz00_3403;obj_t BgL_ttoz00_3404;
BgL_tfromz00_3403 = 
CNST_TABLE_REF(((long)5)); 
BgL_ttoz00_3404 = 
CNST_TABLE_REF(((long)7)); 
BGl_envzd2codez12zc0zzjvm_instrz00(BgL_envz00_75, 
CNST_TABLE_REF(((long)87))); 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_75, BgL_tfromz00_3403); 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_75, BgL_ttoz00_3404);} } 
}



/* __l2d */
obj_t BGl___l2dz00zzjvm_instrz00(obj_t BgL_envz00_4590, obj_t BgL_envz00_4591)
{ AN_OBJECT;
{ /* Jvm/instr.scm 315 */
return 
BGl__l2dz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4591));} 
}



/* _d2i */
obj_t BGl__d2iz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_76)
{ AN_OBJECT;
{ /* Jvm/instr.scm 316 */
{ /* Jvm/instr.scm 316 */
obj_t BgL_tfromz00_3407;obj_t BgL_ttoz00_3408;
BgL_tfromz00_3407 = 
CNST_TABLE_REF(((long)7)); 
BgL_ttoz00_3408 = 
CNST_TABLE_REF(((long)4)); 
BGl_envzd2codez12zc0zzjvm_instrz00(BgL_envz00_76, 
CNST_TABLE_REF(((long)88))); 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_76, BgL_tfromz00_3407); 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_76, BgL_ttoz00_3408);} } 
}



/* __d2i */
obj_t BGl___d2iz00zzjvm_instrz00(obj_t BgL_envz00_4592, obj_t BgL_envz00_4593)
{ AN_OBJECT;
{ /* Jvm/instr.scm 316 */
return 
BGl__d2iz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4593));} 
}



/* _d2l */
obj_t BGl__d2lz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_77)
{ AN_OBJECT;
{ /* Jvm/instr.scm 317 */
{ /* Jvm/instr.scm 317 */
obj_t BgL_tfromz00_3411;obj_t BgL_ttoz00_3412;
BgL_tfromz00_3411 = 
CNST_TABLE_REF(((long)7)); 
BgL_ttoz00_3412 = 
CNST_TABLE_REF(((long)5)); 
BGl_envzd2codez12zc0zzjvm_instrz00(BgL_envz00_77, 
CNST_TABLE_REF(((long)89))); 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_77, BgL_tfromz00_3411); 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_77, BgL_ttoz00_3412);} } 
}



/* __d2l */
obj_t BGl___d2lz00zzjvm_instrz00(obj_t BgL_envz00_4594, obj_t BgL_envz00_4595)
{ AN_OBJECT;
{ /* Jvm/instr.scm 317 */
return 
BGl__d2lz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4595));} 
}



/* _d2f */
obj_t BGl__d2fz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_78)
{ AN_OBJECT;
{ /* Jvm/instr.scm 318 */
{ /* Jvm/instr.scm 318 */
obj_t BgL_tfromz00_3415;obj_t BgL_ttoz00_3416;
BgL_tfromz00_3415 = 
CNST_TABLE_REF(((long)7)); 
BgL_ttoz00_3416 = 
CNST_TABLE_REF(((long)6)); 
BGl_envzd2codez12zc0zzjvm_instrz00(BgL_envz00_78, 
CNST_TABLE_REF(((long)90))); 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_78, BgL_tfromz00_3415); 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_78, BgL_ttoz00_3416);} } 
}



/* __d2f */
obj_t BGl___d2fz00zzjvm_instrz00(obj_t BgL_envz00_4596, obj_t BgL_envz00_4597)
{ AN_OBJECT;
{ /* Jvm/instr.scm 318 */
return 
BGl__d2fz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4597));} 
}



/* _f2d */
obj_t BGl__f2dz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_79)
{ AN_OBJECT;
{ /* Jvm/instr.scm 319 */
{ /* Jvm/instr.scm 319 */
obj_t BgL_tfromz00_3419;obj_t BgL_ttoz00_3420;
BgL_tfromz00_3419 = 
CNST_TABLE_REF(((long)6)); 
BgL_ttoz00_3420 = 
CNST_TABLE_REF(((long)7)); 
BGl_envzd2codez12zc0zzjvm_instrz00(BgL_envz00_79, 
CNST_TABLE_REF(((long)91))); 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_79, BgL_tfromz00_3419); 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_79, BgL_ttoz00_3420);} } 
}



/* __f2d */
obj_t BGl___f2dz00zzjvm_instrz00(obj_t BgL_envz00_4598, obj_t BgL_envz00_4599)
{ AN_OBJECT;
{ /* Jvm/instr.scm 319 */
return 
BGl__f2dz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4599));} 
}



/* _label */
obj_t BGl__labelz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_84, obj_t BgL_labz00_85)
{ AN_OBJECT;
{ /* Jvm/instr.scm 327 */
{ /* Jvm/instr.scm 328 */
bool_t BgL_auxz00_5571;
BgL_auxz00_5571 = 
BGl_envzd2newzd2labelz12z12zzjvm_instrz00(BgL_envz00_84, BgL_labz00_85); 
return 
BBOOL(BgL_auxz00_5571);} } 
}



/* __label */
obj_t BGl___labelz00zzjvm_instrz00(obj_t BgL_envz00_4600, obj_t BgL_envz00_4601, obj_t BgL_labz00_4602)
{ AN_OBJECT;
{ /* Jvm/instr.scm 327 */
return 
BGl__labelz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4601), BgL_labz00_4602);} 
}



/* _if */
obj_t BGl__ifz00zzjvm_instrz00(obj_t BgL_opz00_86, BgL_envz00_bglt BgL_envz00_87, obj_t BgL_labz00_88)
{ AN_OBJECT;
{ /* Jvm/instr.scm 332 */
{ /* Jvm/instr.scm 334 */
obj_t BgL_arg3457z00_1808;
{ /* Jvm/instr.scm 334 */
bool_t BgL_testz00_5576;
{ /* Jvm/instr.scm 334 */
obj_t BgL_auxz00_5577;
BgL_auxz00_5577 = 
CNST_TABLE_REF(((long)92)); 
BgL_testz00_5576 = 
(BgL_opz00_86==BgL_auxz00_5577); } 
if(BgL_testz00_5576)
{ /* Jvm/instr.scm 335 */
obj_t BgL_arg3461z00_1811;obj_t BgL_arg3462z00_1812;
BgL_arg3461z00_1811 = 
CNST_TABLE_REF(((long)93)); 
BgL_arg3462z00_1812 = 
MAKE_PAIR(BgL_labz00_88, BNIL); 
BgL_arg3457z00_1808 = 
MAKE_PAIR(BgL_arg3461z00_1811, BgL_arg3462z00_1812); }  else 
{ /* Jvm/instr.scm 334 */
bool_t BgL_testz00_5583;
{ /* Jvm/instr.scm 334 */
obj_t BgL_auxz00_5584;
BgL_auxz00_5584 = 
CNST_TABLE_REF(((long)94)); 
BgL_testz00_5583 = 
(BgL_opz00_86==BgL_auxz00_5584); } 
if(BgL_testz00_5583)
{ /* Jvm/instr.scm 336 */
obj_t BgL_arg3467z00_1814;obj_t BgL_arg3468z00_1815;
BgL_arg3467z00_1814 = 
CNST_TABLE_REF(((long)95)); 
BgL_arg3468z00_1815 = 
MAKE_PAIR(BgL_labz00_88, BNIL); 
BgL_arg3457z00_1808 = 
MAKE_PAIR(BgL_arg3467z00_1814, BgL_arg3468z00_1815); }  else 
{ /* Jvm/instr.scm 334 */
bool_t BgL_testz00_5590;
{ /* Jvm/instr.scm 334 */
obj_t BgL_auxz00_5591;
BgL_auxz00_5591 = 
CNST_TABLE_REF(((long)96)); 
BgL_testz00_5590 = 
(BgL_opz00_86==BgL_auxz00_5591); } 
if(BgL_testz00_5590)
{ /* Jvm/instr.scm 337 */
obj_t BgL_arg3473z00_1817;obj_t BgL_arg3474z00_1818;
BgL_arg3473z00_1817 = 
CNST_TABLE_REF(((long)97)); 
BgL_arg3474z00_1818 = 
MAKE_PAIR(BgL_labz00_88, BNIL); 
BgL_arg3457z00_1808 = 
MAKE_PAIR(BgL_arg3473z00_1817, BgL_arg3474z00_1818); }  else 
{ /* Jvm/instr.scm 334 */
bool_t BgL_testz00_5597;
{ /* Jvm/instr.scm 334 */
obj_t BgL_auxz00_5598;
BgL_auxz00_5598 = 
CNST_TABLE_REF(((long)98)); 
BgL_testz00_5597 = 
(BgL_opz00_86==BgL_auxz00_5598); } 
if(BgL_testz00_5597)
{ /* Jvm/instr.scm 338 */
obj_t BgL_arg3479z00_1820;obj_t BgL_arg3480z00_1821;
BgL_arg3479z00_1820 = 
CNST_TABLE_REF(((long)99)); 
BgL_arg3480z00_1821 = 
MAKE_PAIR(BgL_labz00_88, BNIL); 
BgL_arg3457z00_1808 = 
MAKE_PAIR(BgL_arg3479z00_1820, BgL_arg3480z00_1821); }  else 
{ /* Jvm/instr.scm 334 */
bool_t BgL_testz00_5604;
{ /* Jvm/instr.scm 334 */
obj_t BgL_auxz00_5605;
BgL_auxz00_5605 = 
CNST_TABLE_REF(((long)100)); 
BgL_testz00_5604 = 
(BgL_opz00_86==BgL_auxz00_5605); } 
if(BgL_testz00_5604)
{ /* Jvm/instr.scm 339 */
obj_t BgL_arg3485z00_1823;obj_t BgL_arg3486z00_1824;
BgL_arg3485z00_1823 = 
CNST_TABLE_REF(((long)101)); 
BgL_arg3486z00_1824 = 
MAKE_PAIR(BgL_labz00_88, BNIL); 
BgL_arg3457z00_1808 = 
MAKE_PAIR(BgL_arg3485z00_1823, BgL_arg3486z00_1824); }  else 
{ /* Jvm/instr.scm 334 */
bool_t BgL_testz00_5611;
{ /* Jvm/instr.scm 334 */
obj_t BgL_auxz00_5612;
BgL_auxz00_5612 = 
CNST_TABLE_REF(((long)102)); 
BgL_testz00_5611 = 
(BgL_opz00_86==BgL_auxz00_5612); } 
if(BgL_testz00_5611)
{ /* Jvm/instr.scm 340 */
obj_t BgL_arg3491z00_1826;obj_t BgL_arg3492z00_1827;
BgL_arg3491z00_1826 = 
CNST_TABLE_REF(((long)103)); 
BgL_arg3492z00_1827 = 
MAKE_PAIR(BgL_labz00_88, BNIL); 
BgL_arg3457z00_1808 = 
MAKE_PAIR(BgL_arg3491z00_1826, BgL_arg3492z00_1827); }  else 
{ 
obj_t BgL_auxz00_5618;
BgL_auxz00_5618 = 
CNST_TABLE_REF(((long)104)); 
FAILURE(BgL_auxz00_5618,BGl_string5862z00zzjvm_instrz00,BgL_opz00_86);} } } } } } } 
{ /* Jvm/instr.scm 333 */
obj_t BgL_arg3076z00_3435;
{ /* Jvm/instr.scm 333 */
obj_t BgL_auxz00_5621;
BgL_auxz00_5621 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_87))->BgL_codez00); 
BgL_arg3076z00_3435 = 
MAKE_PAIR(BgL_arg3457z00_1808, BgL_auxz00_5621); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_87))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3435), BUNSPEC); } ((bool_t)1); } 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_87, 
CNST_TABLE_REF(((long)4)));} 
}



/* __if */
obj_t BGl___ifz00zzjvm_instrz00(obj_t BgL_envz00_4603, obj_t BgL_opz00_4604, obj_t BgL_envz00_4605, obj_t BgL_labz00_4606)
{ AN_OBJECT;
{ /* Jvm/instr.scm 332 */
return 
BGl__ifz00zzjvm_instrz00(BgL_opz00_4604, 
(BgL_envz00_bglt)(BgL_envz00_4605), BgL_labz00_4606);} 
}



/* _if_icmp */
obj_t BGl__if_icmpz00zzjvm_instrz00(obj_t BgL_opz00_89, BgL_envz00_bglt BgL_envz00_90, obj_t BgL_labz00_91)
{ AN_OBJECT;
{ /* Jvm/instr.scm 344 */
{ /* Jvm/instr.scm 346 */
obj_t BgL_arg3504z00_1828;
{ /* Jvm/instr.scm 346 */
bool_t BgL_testz00_5629;
{ /* Jvm/instr.scm 346 */
obj_t BgL_auxz00_5630;
BgL_auxz00_5630 = 
CNST_TABLE_REF(((long)92)); 
BgL_testz00_5629 = 
(BgL_opz00_89==BgL_auxz00_5630); } 
if(BgL_testz00_5629)
{ /* Jvm/instr.scm 347 */
obj_t BgL_arg3508z00_1831;obj_t BgL_arg3510z00_1832;
BgL_arg3508z00_1831 = 
CNST_TABLE_REF(((long)105)); 
BgL_arg3510z00_1832 = 
MAKE_PAIR(BgL_labz00_91, BNIL); 
BgL_arg3504z00_1828 = 
MAKE_PAIR(BgL_arg3508z00_1831, BgL_arg3510z00_1832); }  else 
{ /* Jvm/instr.scm 346 */
bool_t BgL_testz00_5636;
{ /* Jvm/instr.scm 346 */
obj_t BgL_auxz00_5637;
BgL_auxz00_5637 = 
CNST_TABLE_REF(((long)94)); 
BgL_testz00_5636 = 
(BgL_opz00_89==BgL_auxz00_5637); } 
if(BgL_testz00_5636)
{ /* Jvm/instr.scm 348 */
obj_t BgL_arg3515z00_1834;obj_t BgL_arg3516z00_1835;
BgL_arg3515z00_1834 = 
CNST_TABLE_REF(((long)106)); 
BgL_arg3516z00_1835 = 
MAKE_PAIR(BgL_labz00_91, BNIL); 
BgL_arg3504z00_1828 = 
MAKE_PAIR(BgL_arg3515z00_1834, BgL_arg3516z00_1835); }  else 
{ /* Jvm/instr.scm 346 */
bool_t BgL_testz00_5643;
{ /* Jvm/instr.scm 346 */
obj_t BgL_auxz00_5644;
BgL_auxz00_5644 = 
CNST_TABLE_REF(((long)96)); 
BgL_testz00_5643 = 
(BgL_opz00_89==BgL_auxz00_5644); } 
if(BgL_testz00_5643)
{ /* Jvm/instr.scm 349 */
obj_t BgL_arg3521z00_1837;obj_t BgL_arg3522z00_1838;
BgL_arg3521z00_1837 = 
CNST_TABLE_REF(((long)107)); 
BgL_arg3522z00_1838 = 
MAKE_PAIR(BgL_labz00_91, BNIL); 
BgL_arg3504z00_1828 = 
MAKE_PAIR(BgL_arg3521z00_1837, BgL_arg3522z00_1838); }  else 
{ /* Jvm/instr.scm 346 */
bool_t BgL_testz00_5650;
{ /* Jvm/instr.scm 346 */
obj_t BgL_auxz00_5651;
BgL_auxz00_5651 = 
CNST_TABLE_REF(((long)98)); 
BgL_testz00_5650 = 
(BgL_opz00_89==BgL_auxz00_5651); } 
if(BgL_testz00_5650)
{ /* Jvm/instr.scm 350 */
obj_t BgL_arg3527z00_1840;obj_t BgL_arg3528z00_1841;
BgL_arg3527z00_1840 = 
CNST_TABLE_REF(((long)108)); 
BgL_arg3528z00_1841 = 
MAKE_PAIR(BgL_labz00_91, BNIL); 
BgL_arg3504z00_1828 = 
MAKE_PAIR(BgL_arg3527z00_1840, BgL_arg3528z00_1841); }  else 
{ /* Jvm/instr.scm 346 */
bool_t BgL_testz00_5657;
{ /* Jvm/instr.scm 346 */
obj_t BgL_auxz00_5658;
BgL_auxz00_5658 = 
CNST_TABLE_REF(((long)100)); 
BgL_testz00_5657 = 
(BgL_opz00_89==BgL_auxz00_5658); } 
if(BgL_testz00_5657)
{ /* Jvm/instr.scm 351 */
obj_t BgL_arg3533z00_1843;obj_t BgL_arg3534z00_1844;
BgL_arg3533z00_1843 = 
CNST_TABLE_REF(((long)109)); 
BgL_arg3534z00_1844 = 
MAKE_PAIR(BgL_labz00_91, BNIL); 
BgL_arg3504z00_1828 = 
MAKE_PAIR(BgL_arg3533z00_1843, BgL_arg3534z00_1844); }  else 
{ /* Jvm/instr.scm 346 */
bool_t BgL_testz00_5664;
{ /* Jvm/instr.scm 346 */
obj_t BgL_auxz00_5665;
BgL_auxz00_5665 = 
CNST_TABLE_REF(((long)102)); 
BgL_testz00_5664 = 
(BgL_opz00_89==BgL_auxz00_5665); } 
if(BgL_testz00_5664)
{ /* Jvm/instr.scm 352 */
obj_t BgL_arg3539z00_1846;obj_t BgL_arg3540z00_1847;
BgL_arg3539z00_1846 = 
CNST_TABLE_REF(((long)110)); 
BgL_arg3540z00_1847 = 
MAKE_PAIR(BgL_labz00_91, BNIL); 
BgL_arg3504z00_1828 = 
MAKE_PAIR(BgL_arg3539z00_1846, BgL_arg3540z00_1847); }  else 
{ 
obj_t BgL_auxz00_5671;
BgL_auxz00_5671 = 
CNST_TABLE_REF(((long)111)); 
FAILURE(BgL_auxz00_5671,BGl_string5862z00zzjvm_instrz00,BgL_opz00_89);} } } } } } } 
{ /* Jvm/instr.scm 345 */
obj_t BgL_arg3076z00_3446;
{ /* Jvm/instr.scm 345 */
obj_t BgL_auxz00_5674;
BgL_auxz00_5674 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_90))->BgL_codez00); 
BgL_arg3076z00_3446 = 
MAKE_PAIR(BgL_arg3504z00_1828, BgL_auxz00_5674); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_90))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3446), BUNSPEC); } ((bool_t)1); } 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_90, 
CNST_TABLE_REF(((long)4))); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_90, 
CNST_TABLE_REF(((long)4)));} 
}



/* __if_icmp */
obj_t BGl___if_icmpz00zzjvm_instrz00(obj_t BgL_envz00_4607, obj_t BgL_opz00_4608, obj_t BgL_envz00_4609, obj_t BgL_labz00_4610)
{ AN_OBJECT;
{ /* Jvm/instr.scm 344 */
return 
BGl__if_icmpz00zzjvm_instrz00(BgL_opz00_4608, 
(BgL_envz00_bglt)(BgL_envz00_4609), BgL_labz00_4610);} 
}



/* _if_acmp */
obj_t BGl__if_acmpz00zzjvm_instrz00(obj_t BgL_opz00_92, BgL_envz00_bglt BgL_envz00_93, obj_t BgL_labz00_94)
{ AN_OBJECT;
{ /* Jvm/instr.scm 357 */
{ /* Jvm/instr.scm 359 */
obj_t BgL_arg3553z00_1848;
{ /* Jvm/instr.scm 359 */
bool_t BgL_testz00_5684;
{ /* Jvm/instr.scm 359 */
obj_t BgL_auxz00_5685;
BgL_auxz00_5685 = 
CNST_TABLE_REF(((long)92)); 
BgL_testz00_5684 = 
(BgL_opz00_92==BgL_auxz00_5685); } 
if(BgL_testz00_5684)
{ /* Jvm/instr.scm 360 */
obj_t BgL_arg3557z00_1851;obj_t BgL_arg3558z00_1852;
BgL_arg3557z00_1851 = 
CNST_TABLE_REF(((long)112)); 
BgL_arg3558z00_1852 = 
MAKE_PAIR(BgL_labz00_94, BNIL); 
BgL_arg3553z00_1848 = 
MAKE_PAIR(BgL_arg3557z00_1851, BgL_arg3558z00_1852); }  else 
{ /* Jvm/instr.scm 359 */
bool_t BgL_testz00_5691;
{ /* Jvm/instr.scm 359 */
obj_t BgL_auxz00_5692;
BgL_auxz00_5692 = 
CNST_TABLE_REF(((long)94)); 
BgL_testz00_5691 = 
(BgL_opz00_92==BgL_auxz00_5692); } 
if(BgL_testz00_5691)
{ /* Jvm/instr.scm 361 */
obj_t BgL_arg3563z00_1854;obj_t BgL_arg3564z00_1855;
BgL_arg3563z00_1854 = 
CNST_TABLE_REF(((long)113)); 
BgL_arg3564z00_1855 = 
MAKE_PAIR(BgL_labz00_94, BNIL); 
BgL_arg3553z00_1848 = 
MAKE_PAIR(BgL_arg3563z00_1854, BgL_arg3564z00_1855); }  else 
{ 
obj_t BgL_auxz00_5698;
BgL_auxz00_5698 = 
CNST_TABLE_REF(((long)114)); 
FAILURE(BgL_auxz00_5698,BGl_string5862z00zzjvm_instrz00,BgL_opz00_92);} } } 
{ /* Jvm/instr.scm 358 */
obj_t BgL_arg3076z00_3457;
{ /* Jvm/instr.scm 358 */
obj_t BgL_auxz00_5701;
BgL_auxz00_5701 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_93))->BgL_codez00); 
BgL_arg3076z00_3457 = 
MAKE_PAIR(BgL_arg3553z00_1848, BgL_auxz00_5701); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_93))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3457), BUNSPEC); } ((bool_t)1); } 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_93, 
CNST_TABLE_REF(((long)8))); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_93, 
CNST_TABLE_REF(((long)8)));} 
}



/* __if_acmp */
obj_t BGl___if_acmpz00zzjvm_instrz00(obj_t BgL_envz00_4611, obj_t BgL_opz00_4612, obj_t BgL_envz00_4613, obj_t BgL_labz00_4614)
{ AN_OBJECT;
{ /* Jvm/instr.scm 357 */
return 
BGl__if_acmpz00zzjvm_instrz00(BgL_opz00_4612, 
(BgL_envz00_bglt)(BgL_envz00_4613), BgL_labz00_4614);} 
}



/* _goto */
obj_t BGl__gotoz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_95, obj_t BgL_labz00_96)
{ AN_OBJECT;
{ /* Jvm/instr.scm 366 */
{ /* Jvm/instr.scm 367 */
obj_t BgL_arg3573z00_3462;
{ /* Jvm/instr.scm 367 */
obj_t BgL_arg3576z00_3463;obj_t BgL_arg3577z00_3464;
BgL_arg3576z00_3463 = 
CNST_TABLE_REF(((long)9)); 
BgL_arg3577z00_3464 = 
MAKE_PAIR(BgL_labz00_96, BNIL); 
BgL_arg3573z00_3462 = 
MAKE_PAIR(BgL_arg3576z00_3463, BgL_arg3577z00_3464); } 
{ /* Jvm/instr.scm 367 */
obj_t BgL_arg3076z00_3468;
{ /* Jvm/instr.scm 367 */
obj_t BgL_auxz00_5714;
BgL_auxz00_5714 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_95))->BgL_codez00); 
BgL_arg3076z00_3468 = 
MAKE_PAIR(BgL_arg3573z00_3462, BgL_auxz00_5714); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_95))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3468), BUNSPEC); } 
return BTRUE;} } 
}



/* __goto */
obj_t BGl___gotoz00zzjvm_instrz00(obj_t BgL_envz00_4615, obj_t BgL_envz00_4616, obj_t BgL_labz00_4617)
{ AN_OBJECT;
{ /* Jvm/instr.scm 366 */
return 
BGl__gotoz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4616), BgL_labz00_4617);} 
}



/* _switch */
obj_t BGl__switchz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_97, obj_t BgL_ldefz00_98, obj_t BgL_num2labz00_99)
{ AN_OBJECT;
{ /* Jvm/instr.scm 369 */
{ /* Jvm/instr.scm 371 */
bool_t BgL_test3580z00_1859;
{ /* Jvm/instr.scm 371 */
obj_t BgL_objz00_3473;
BgL_objz00_3473 = BgL_num2labz00_99; 
BgL_test3580z00_1859 = 
NULLP(BgL_objz00_3473); } 
if(BgL_test3580z00_1859)
{ /* Jvm/instr.scm 371 */
BGl__popz00zzjvm_instrz00(BgL_envz00_97, 
CNST_TABLE_REF(((long)4))); 
{ /* Jvm/instr.scm 373 */
obj_t BgL_arg3573z00_3476;
{ /* Jvm/instr.scm 373 */
obj_t BgL_arg3576z00_3477;obj_t BgL_arg3577z00_3478;
BgL_arg3576z00_3477 = 
CNST_TABLE_REF(((long)9)); 
BgL_arg3577z00_3478 = 
MAKE_PAIR(BgL_ldefz00_98, BNIL); 
BgL_arg3573z00_3476 = 
MAKE_PAIR(BgL_arg3576z00_3477, BgL_arg3577z00_3478); } 
{ /* Jvm/instr.scm 373 */
bool_t BgL_auxz00_5727;
BgL_auxz00_5727 = 
BGl_envzd2codez12zc0zzjvm_instrz00(BgL_envz00_97, BgL_arg3573z00_3476); 
return 
BBOOL(BgL_auxz00_5727);} } }  else 
{ /* Jvm/instr.scm 374 */
bool_t BgL_test3583z00_1860;
{ /* Jvm/instr.scm 374 */
obj_t BgL_arg3685z00_1909;
{ /* Jvm/instr.scm 374 */
obj_t BgL_pairz00_3479;
BgL_pairz00_3479 = BgL_num2labz00_99; 
BgL_arg3685z00_1909 = 
CDR(BgL_pairz00_3479); } 
BgL_test3583z00_1860 = 
NULLP(BgL_arg3685z00_1909); } 
if(BgL_test3583z00_1860)
{ /* Jvm/instr.scm 374 */
{ /* Jvm/instr.scm 375 */
obj_t BgL_arg3588z00_1862;
{ /* Jvm/instr.scm 375 */
obj_t BgL_pairz00_3481;
BgL_pairz00_3481 = BgL_num2labz00_99; 
{ /* Jvm/instr.scm 375 */
obj_t BgL_auxz00_5733;
BgL_auxz00_5733 = 
CAR(BgL_pairz00_3481); 
BgL_arg3588z00_1862 = 
CAR(BgL_auxz00_5733); } } 
BGl__pushz00zzjvm_instrz00(BgL_envz00_97, 
CNST_TABLE_REF(((long)4)), BgL_arg3588z00_1862); } 
BGl__if_icmpz00zzjvm_instrz00(
CNST_TABLE_REF(((long)94)), BgL_envz00_97, BgL_ldefz00_98); 
{ /* Jvm/instr.scm 377 */
obj_t BgL_arg3593z00_1863;
{ /* Jvm/instr.scm 377 */
obj_t BgL_pairz00_3485;
BgL_pairz00_3485 = BgL_num2labz00_99; 
{ /* Jvm/instr.scm 377 */
obj_t BgL_auxz00_5740;
BgL_auxz00_5740 = 
CAR(BgL_pairz00_3485); 
BgL_arg3593z00_1863 = 
CDR(BgL_auxz00_5740); } } 
{ /* Jvm/instr.scm 377 */
obj_t BgL_arg3573z00_3491;
{ /* Jvm/instr.scm 377 */
obj_t BgL_arg3576z00_3492;obj_t BgL_arg3577z00_3493;
BgL_arg3576z00_3492 = 
CNST_TABLE_REF(((long)9)); 
BgL_arg3577z00_3493 = 
MAKE_PAIR(BgL_arg3593z00_1863, BNIL); 
BgL_arg3573z00_3491 = 
MAKE_PAIR(BgL_arg3576z00_3492, BgL_arg3577z00_3493); } 
{ /* Jvm/instr.scm 377 */
bool_t BgL_auxz00_5746;
BgL_auxz00_5746 = 
BGl_envzd2codez12zc0zzjvm_instrz00(BgL_envz00_97, BgL_arg3573z00_3491); 
return 
BBOOL(BgL_auxz00_5746);} } } }  else 
{ /* Jvm/instr.scm 374 */
BgL_num2labz00_99 = 
BGl_sortz00zz__r4_vectors_6_8z00(BgL_num2labz00_99, BGl_proc5863z00zzjvm_instrz00); 
{ /* Jvm/instr.scm 380 */
obj_t BgL_numsz00_1871;
{ /* Jvm/instr.scm 380 */
obj_t BgL_l2973z00_1893;
BgL_l2973z00_1893 = BgL_num2labz00_99; 
if(
NULLP(BgL_l2973z00_1893))
{ /* Jvm/instr.scm 380 */
BgL_numsz00_1871 = BNIL; }  else 
{ /* Jvm/instr.scm 380 */
obj_t BgL_head2975z00_1895;
{ /* Jvm/instr.scm 380 */
obj_t BgL_auxz00_5752;
{ /* Jvm/instr.scm 380 */
obj_t BgL_auxz00_5753;
BgL_auxz00_5753 = 
CAR(BgL_l2973z00_1893); 
BgL_auxz00_5752 = 
CAR(BgL_auxz00_5753); } 
BgL_head2975z00_1895 = 
MAKE_PAIR(BgL_auxz00_5752, BNIL); } 
{ 
obj_t BgL_l2973z00_1896;obj_t BgL_tail2976z00_1897;
BgL_l2973z00_1896 = 
CDR(BgL_l2973z00_1893); 
BgL_tail2976z00_1897 = BgL_head2975z00_1895; 
BgL_lname2974z00_1898:
if(
NULLP(BgL_l2973z00_1896))
{ /* Jvm/instr.scm 380 */
BgL_numsz00_1871 = BgL_head2975z00_1895; }  else 
{ /* Jvm/instr.scm 380 */
obj_t BgL_newtail2977z00_1901;
{ /* Jvm/instr.scm 380 */
obj_t BgL_auxz00_5759;
{ /* Jvm/instr.scm 380 */
obj_t BgL_auxz00_5760;
BgL_auxz00_5760 = 
CAR(BgL_l2973z00_1896); 
BgL_auxz00_5759 = 
CAR(BgL_auxz00_5760); } 
BgL_newtail2977z00_1901 = 
MAKE_PAIR(BgL_auxz00_5759, BNIL); } 
SET_CDR(BgL_tail2976z00_1897, BgL_newtail2977z00_1901); 
{ 
obj_t BgL_tail2976z00_5767;obj_t BgL_l2973z00_5765;
BgL_l2973z00_5765 = 
CDR(BgL_l2973z00_1896); 
BgL_tail2976z00_5767 = BgL_newtail2977z00_1901; 
BgL_tail2976z00_1897 = BgL_tail2976z00_5767; 
BgL_l2973z00_1896 = BgL_l2973z00_5765; 
goto BgL_lname2974z00_1898;} } } } } 
{ /* Jvm/instr.scm 380 */
obj_t BgL_minz00_1872;
BgL_minz00_1872 = 
CAR(BgL_numsz00_1871); 
{ /* Jvm/instr.scm 383 */

{ /* Jvm/instr.scm 384 */
bool_t BgL_testz00_5770;
{ /* Jvm/instr.scm 384 */
obj_t BgL_auxz00_5771;
{ /* Jvm/instr.scm 384 */
obj_t BgL_auxz00_5776;obj_t BgL_auxz00_5772;
{ /* Jvm/instr.scm 384 */
long BgL_auxz00_5777;
{ /* Jvm/instr.scm 384 */
long BgL_auxz00_5778;
{ /* Jvm/instr.scm 384 */
long BgL_auxz00_5785;long BgL_auxz00_5779;
BgL_auxz00_5785 = 
(long)CINT(BgL_minz00_1872); 
{ /* Jvm/instr.scm 384 */
obj_t BgL_auxz00_5780;
{ /* Jvm/instr.scm 382 */
obj_t BgL_auxz00_5781;
BgL_auxz00_5781 = 
BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(BgL_numsz00_1871); 
BgL_auxz00_5780 = 
CAR(BgL_auxz00_5781); } 
BgL_auxz00_5779 = 
(long)CINT(BgL_auxz00_5780); } 
BgL_auxz00_5778 = 
(BgL_auxz00_5779-BgL_auxz00_5785); } 
BgL_auxz00_5777 = 
(((long)1)+BgL_auxz00_5778); } 
BgL_auxz00_5776 = 
BINT(BgL_auxz00_5777); } 
{ /* Jvm/instr.scm 384 */
long BgL_auxz00_5773;
BgL_auxz00_5773 = 
bgl_list_length(BgL_numsz00_1871); 
BgL_auxz00_5772 = 
BINT(BgL_auxz00_5773); } 
BgL_auxz00_5771 = 
BGl_2zf2zf2zz__r4_numbers_6_5z00(BgL_auxz00_5772, BgL_auxz00_5776); } 
BgL_testz00_5770 = 
BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_auxz00_5771, BGl_real5864z00zzjvm_instrz00); } 
if(BgL_testz00_5770)
{ /* Jvm/instr.scm 385 */
obj_t BgL_arg3608z00_1876;
{ /* Jvm/instr.scm 385 */
obj_t BgL_arg3611z00_1877;obj_t BgL_arg3612z00_1878;
BgL_arg3611z00_1877 = 
CNST_TABLE_REF(((long)115)); 
{ /* Jvm/instr.scm 385 */
obj_t BgL_arg3615z00_1879;
BgL_arg3615z00_1879 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_num2labz00_99, BNIL); 
BgL_arg3612z00_1878 = 
MAKE_PAIR(BgL_ldefz00_98, BgL_arg3615z00_1879); } 
BgL_arg3608z00_1876 = 
MAKE_PAIR(BgL_arg3611z00_1877, BgL_arg3612z00_1878); } 
{ /* Jvm/instr.scm 385 */
obj_t BgL_arg3076z00_3523;
{ /* Jvm/instr.scm 385 */
obj_t BgL_auxz00_5796;
BgL_auxz00_5796 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_97))->BgL_codez00); 
BgL_arg3076z00_3523 = 
MAKE_PAIR(BgL_arg3608z00_1876, BgL_auxz00_5796); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_97))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3523), BUNSPEC); } ((bool_t)1); }  else 
{ /* Jvm/instr.scm 386 */
obj_t BgL_arg3619z00_1880;
{ /* Jvm/instr.scm 386 */
obj_t BgL_arg3622z00_1881;obj_t BgL_arg3623z00_1882;
BgL_arg3622z00_1881 = 
CNST_TABLE_REF(((long)116)); 
{ /* Jvm/instr.scm 387 */
obj_t BgL_arg3626z00_1883;
{ /* Jvm/instr.scm 387 */
obj_t BgL_arg3629z00_1884;
{ /* Jvm/instr.scm 387 */
obj_t BgL_arg3632z00_1885;
BgL_arg3632z00_1885 = 
BGl_flatz00zzjvm_instrz00(BgL_num2labz00_99, BgL_ldefz00_98); 
BgL_arg3629z00_1884 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg3632z00_1885, BNIL); } 
BgL_arg3626z00_1883 = 
MAKE_PAIR(BgL_minz00_1872, BgL_arg3629z00_1884); } 
BgL_arg3623z00_1882 = 
MAKE_PAIR(BgL_ldefz00_98, BgL_arg3626z00_1883); } 
BgL_arg3619z00_1880 = 
MAKE_PAIR(BgL_arg3622z00_1881, BgL_arg3623z00_1882); } 
{ /* Jvm/instr.scm 386 */
obj_t BgL_arg3076z00_3531;
{ /* Jvm/instr.scm 386 */
obj_t BgL_auxz00_5806;
BgL_auxz00_5806 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_97))->BgL_codez00); 
BgL_arg3076z00_3531 = 
MAKE_PAIR(BgL_arg3619z00_1880, BgL_auxz00_5806); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_97))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3531), BUNSPEC); } ((bool_t)1); } } 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_97, 
CNST_TABLE_REF(((long)4)));} } } } } } } 
}



/* __switch */
obj_t BGl___switchz00zzjvm_instrz00(obj_t BgL_envz00_4619, obj_t BgL_envz00_4620, obj_t BgL_ldefz00_4621, obj_t BgL_num2labz00_4622)
{ AN_OBJECT;
{ /* Jvm/instr.scm 369 */
return 
BGl__switchz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4620), BgL_ldefz00_4621, BgL_num2labz00_4622);} 
}



/* <anonymous:3599> */
obj_t BGl_zc3anonymousza33599ze3z83zzjvm_instrz00(obj_t BgL_envz00_4623, obj_t BgL_xz00_4624, obj_t BgL_yz00_4625)
{ AN_OBJECT;
{ /* Jvm/instr.scm 379 */
{ 
obj_t BgL_xz00_1865;obj_t BgL_yz00_1866;
{ /* Jvm/instr.scm 379 */
bool_t BgL_auxz00_5814;
BgL_xz00_1865 = BgL_xz00_4624; 
BgL_yz00_1866 = BgL_yz00_4625; 
{ /* Jvm/instr.scm 379 */
long BgL_auxz00_5819;long BgL_auxz00_5815;
{ /* Jvm/instr.scm 379 */
obj_t BgL_auxz00_5820;
BgL_auxz00_5820 = 
CAR(BgL_yz00_1866); 
BgL_auxz00_5819 = 
(long)CINT(BgL_auxz00_5820); } 
{ /* Jvm/instr.scm 379 */
obj_t BgL_auxz00_5816;
BgL_auxz00_5816 = 
CAR(BgL_xz00_1865); 
BgL_auxz00_5815 = 
(long)CINT(BgL_auxz00_5816); } 
BgL_auxz00_5814 = 
(BgL_auxz00_5815<BgL_auxz00_5819); } 
return 
BBOOL(BgL_auxz00_5814);} } } 
}



/* flat */
obj_t BGl_flatz00zzjvm_instrz00(obj_t BgL_alz00_100, obj_t BgL_ldefz00_101)
{ AN_OBJECT;
{ /* Jvm/instr.scm 390 */
{ 
obj_t BgL_alz00_1914;obj_t BgL_iz00_1915;obj_t BgL_rz00_1916;
{ /* Jvm/instr.scm 396 */
obj_t BgL_rz00_1911;
BgL_alz00_1914 = BgL_alz00_100; 
{ /* Jvm/instr.scm 396 */
obj_t BgL_auxz00_5858;
BgL_auxz00_5858 = 
CAR(BgL_alz00_100); 
BgL_iz00_1915 = 
CAR(BgL_auxz00_5858); } 
BgL_rz00_1916 = BNIL; 
BgL_zc3anonymousza33694ze3z83_1917:
if(
NULLP(BgL_alz00_1914))
{ /* Jvm/instr.scm 393 */
BgL_rz00_1911 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_rz00_1916); }  else 
{ /* Jvm/instr.scm 394 */
bool_t BgL_testz00_5828;
{ /* Jvm/instr.scm 394 */
long BgL_auxz00_5831;long BgL_auxz00_5829;
{ /* Jvm/instr.scm 394 */
obj_t BgL_auxz00_5832;
{ /* Jvm/instr.scm 394 */
obj_t BgL_auxz00_5833;
BgL_auxz00_5833 = 
CAR(BgL_alz00_1914); 
BgL_auxz00_5832 = 
CAR(BgL_auxz00_5833); } 
BgL_auxz00_5831 = 
(long)CINT(BgL_auxz00_5832); } 
BgL_auxz00_5829 = 
(long)CINT(BgL_iz00_1915); 
BgL_testz00_5828 = 
(BgL_auxz00_5829==BgL_auxz00_5831); } 
if(BgL_testz00_5828)
{ /* Jvm/instr.scm 394 */
{ /* Jvm/instr.scm 394 */
obj_t BgL_arg3699z00_1920;long BgL_arg3700z00_1921;obj_t BgL_arg3701z00_1922;
BgL_arg3699z00_1920 = 
CDR(BgL_alz00_1914); 
{ /* Jvm/instr.scm 394 */
long BgL_auxz00_5839;
BgL_auxz00_5839 = 
(long)CINT(BgL_iz00_1915); 
BgL_arg3700z00_1921 = 
(BgL_auxz00_5839+((long)1)); } 
{ /* Jvm/instr.scm 394 */
obj_t BgL_auxz00_5842;
{ /* Jvm/instr.scm 394 */
obj_t BgL_auxz00_5843;
BgL_auxz00_5843 = 
CAR(BgL_alz00_1914); 
BgL_auxz00_5842 = 
CDR(BgL_auxz00_5843); } 
BgL_arg3701z00_1922 = 
MAKE_PAIR(BgL_auxz00_5842, BgL_rz00_1916); } 
{ 
obj_t BgL_rz00_5850;obj_t BgL_iz00_5848;obj_t BgL_alz00_5847;
BgL_alz00_5847 = BgL_arg3699z00_1920; 
BgL_iz00_5848 = 
BINT(BgL_arg3700z00_1921); 
BgL_rz00_5850 = BgL_arg3701z00_1922; 
BgL_rz00_1916 = BgL_rz00_5850; 
BgL_iz00_1915 = BgL_iz00_5848; 
BgL_alz00_1914 = BgL_alz00_5847; 
goto BgL_zc3anonymousza33694ze3z83_1917;} } }  else 
{ /* Jvm/instr.scm 394 */
{ /* Jvm/instr.scm 395 */
long BgL_arg3710z00_1924;obj_t BgL_arg3711z00_1925;
{ /* Jvm/instr.scm 395 */
long BgL_auxz00_5851;
BgL_auxz00_5851 = 
(long)CINT(BgL_iz00_1915); 
BgL_arg3710z00_1924 = 
(BgL_auxz00_5851+((long)1)); } 
BgL_arg3711z00_1925 = 
MAKE_PAIR(BgL_ldefz00_101, BgL_rz00_1916); 
{ 
obj_t BgL_rz00_5857;obj_t BgL_iz00_5855;
BgL_iz00_5855 = 
BINT(BgL_arg3710z00_1924); 
BgL_rz00_5857 = BgL_arg3711z00_1925; 
BgL_rz00_1916 = BgL_rz00_5857; 
BgL_iz00_1915 = BgL_iz00_5855; 
goto BgL_zc3anonymousza33694ze3z83_1917;} } } } 
return BgL_rz00_1911;} } } 
}



/* _new */
obj_t BGl__newz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_102, obj_t BgL_typez00_103)
{ AN_OBJECT;
{ /* Jvm/instr.scm 400 */
{ /* Jvm/instr.scm 401 */
obj_t BgL_arg3721z00_1928;
{ /* Jvm/instr.scm 401 */
obj_t BgL_arg3724z00_1929;obj_t BgL_arg3725z00_1930;
BgL_arg3724z00_1929 = 
CNST_TABLE_REF(((long)117)); 
BgL_arg3725z00_1930 = 
MAKE_PAIR(BgL_typez00_103, BNIL); 
BgL_arg3721z00_1928 = 
MAKE_PAIR(BgL_arg3724z00_1929, BgL_arg3725z00_1930); } 
{ /* Jvm/instr.scm 401 */
obj_t BgL_arg3076z00_3559;
{ /* Jvm/instr.scm 401 */
obj_t BgL_auxz00_5864;
BgL_auxz00_5864 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_102))->BgL_codez00); 
BgL_arg3076z00_3559 = 
MAKE_PAIR(BgL_arg3721z00_1928, BgL_auxz00_5864); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_102))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3559), BUNSPEC); } ((bool_t)1); } 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_102, 
CNST_TABLE_REF(((long)8)));} 
}



/* __new */
obj_t BGl___newz00zzjvm_instrz00(obj_t BgL_envz00_4626, obj_t BgL_envz00_4627, obj_t BgL_typez00_4628)
{ AN_OBJECT;
{ /* Jvm/instr.scm 400 */
return 
BGl__newz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4627), BgL_typez00_4628);} 
}



/* _instanceof */
obj_t BGl__instanceofz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_104, obj_t BgL_typez00_105)
{ AN_OBJECT;
{ /* Jvm/instr.scm 404 */
{ /* Jvm/instr.scm 405 */
obj_t BgL_arg3730z00_1931;
{ /* Jvm/instr.scm 405 */
obj_t BgL_arg3733z00_1932;obj_t BgL_arg3734z00_1933;
BgL_arg3733z00_1932 = 
CNST_TABLE_REF(((long)118)); 
BgL_arg3734z00_1933 = 
MAKE_PAIR(BgL_typez00_105, BNIL); 
BgL_arg3730z00_1931 = 
MAKE_PAIR(BgL_arg3733z00_1932, BgL_arg3734z00_1933); } 
{ /* Jvm/instr.scm 405 */
obj_t BgL_arg3076z00_3567;
{ /* Jvm/instr.scm 405 */
obj_t BgL_auxz00_5875;
BgL_auxz00_5875 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_104))->BgL_codez00); 
BgL_arg3076z00_3567 = 
MAKE_PAIR(BgL_arg3730z00_1931, BgL_auxz00_5875); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_104))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3567), BUNSPEC); } ((bool_t)1); } 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_104, 
CNST_TABLE_REF(((long)8))); 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_104, 
CNST_TABLE_REF(((long)4)));} 
}



/* __instanceof */
obj_t BGl___instanceofz00zzjvm_instrz00(obj_t BgL_envz00_4629, obj_t BgL_envz00_4630, obj_t BgL_typez00_4631)
{ AN_OBJECT;
{ /* Jvm/instr.scm 404 */
return 
BGl__instanceofz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4630), BgL_typez00_4631);} 
}



/* _checkcast */
obj_t BGl__checkcastz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_106, obj_t BgL_typez00_107)
{ AN_OBJECT;
{ /* Jvm/instr.scm 409 */
{ /* Jvm/instr.scm 410 */
bool_t BgL_testz00_5885;
{ /* Jvm/instr.scm 410 */
obj_t BgL_auxz00_5886;
BgL_auxz00_5886 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_typez00_107, 
CNST_TABLE_REF(((long)119))); 
BgL_testz00_5885 = 
CBOOL(BgL_auxz00_5886); } 
if(BgL_testz00_5885)
{ /* Jvm/instr.scm 410 */
return BFALSE;}  else 
{ /* Jvm/instr.scm 412 */
obj_t BgL_arg3741z00_1935;
{ /* Jvm/instr.scm 412 */
obj_t BgL_arg3744z00_1936;obj_t BgL_arg3745z00_1937;
BgL_arg3744z00_1936 = 
CNST_TABLE_REF(((long)120)); 
BgL_arg3745z00_1937 = 
MAKE_PAIR(BgL_typez00_107, BNIL); 
BgL_arg3741z00_1935 = 
MAKE_PAIR(BgL_arg3744z00_1936, BgL_arg3745z00_1937); } 
{ /* Jvm/instr.scm 412 */
obj_t BgL_arg3076z00_3575;
{ /* Jvm/instr.scm 412 */
obj_t BgL_auxz00_5893;
BgL_auxz00_5893 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_106))->BgL_codez00); 
BgL_arg3076z00_3575 = 
MAKE_PAIR(BgL_arg3741z00_1935, BgL_auxz00_5893); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_106))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3575), BUNSPEC); } 
return BTRUE;} } } 
}



/* __checkcast */
obj_t BGl___checkcastz00zzjvm_instrz00(obj_t BgL_envz00_4632, obj_t BgL_envz00_4633, obj_t BgL_typez00_4634)
{ AN_OBJECT;
{ /* Jvm/instr.scm 409 */
return 
BGl__checkcastz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4633), BgL_typez00_4634);} 
}



/* _getfield */
obj_t BGl__getfieldz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_108, obj_t BgL_tyz00_109, obj_t BgL_varz00_110)
{ AN_OBJECT;
{ /* Jvm/instr.scm 414 */
{ /* Jvm/instr.scm 415 */
obj_t BgL_arg3750z00_1938;
{ /* Jvm/instr.scm 415 */
obj_t BgL_arg3753z00_1939;obj_t BgL_arg3754z00_1940;
BgL_arg3753z00_1939 = 
CNST_TABLE_REF(((long)121)); 
BgL_arg3754z00_1940 = 
MAKE_PAIR(BgL_varz00_110, BNIL); 
BgL_arg3750z00_1938 = 
MAKE_PAIR(BgL_arg3753z00_1939, BgL_arg3754z00_1940); } 
{ /* Jvm/instr.scm 415 */
obj_t BgL_arg3076z00_3583;
{ /* Jvm/instr.scm 415 */
obj_t BgL_auxz00_5902;
BgL_auxz00_5902 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_108))->BgL_codez00); 
BgL_arg3076z00_3583 = 
MAKE_PAIR(BgL_arg3750z00_1938, BgL_auxz00_5902); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_108))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3583), BUNSPEC); } ((bool_t)1); } 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_108, 
CNST_TABLE_REF(((long)8))); 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_108, 
BGl_simplezd2typezd2zzjvm_instrz00(BgL_tyz00_109));} 
}



/* __getfield */
obj_t BGl___getfieldz00zzjvm_instrz00(obj_t BgL_envz00_4635, obj_t BgL_envz00_4636, obj_t BgL_tyz00_4637, obj_t BgL_varz00_4638)
{ AN_OBJECT;
{ /* Jvm/instr.scm 414 */
return 
BGl__getfieldz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4636), BgL_tyz00_4637, BgL_varz00_4638);} 
}



/* _putfield */
obj_t BGl__putfieldz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_111, obj_t BgL_varz00_112)
{ AN_OBJECT;
{ /* Jvm/instr.scm 419 */
{ /* Jvm/instr.scm 420 */
obj_t BgL_arg3764z00_1942;
{ /* Jvm/instr.scm 420 */
obj_t BgL_arg3767z00_1943;obj_t BgL_arg3768z00_1944;
BgL_arg3767z00_1943 = 
CNST_TABLE_REF(((long)122)); 
BgL_arg3768z00_1944 = 
MAKE_PAIR(BgL_varz00_112, BNIL); 
BgL_arg3764z00_1942 = 
MAKE_PAIR(BgL_arg3767z00_1943, BgL_arg3768z00_1944); } 
{ /* Jvm/instr.scm 420 */
obj_t BgL_arg3076z00_3591;
{ /* Jvm/instr.scm 420 */
obj_t BgL_auxz00_5915;
BgL_auxz00_5915 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_111))->BgL_codez00); 
BgL_arg3076z00_3591 = 
MAKE_PAIR(BgL_arg3764z00_1942, BgL_auxz00_5915); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_111))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3591), BUNSPEC); } ((bool_t)1); } 
BGl_popz00zzjvm_instrz00(BgL_envz00_111); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_111, 
CNST_TABLE_REF(((long)8)));} 
}



/* __putfield */
obj_t BGl___putfieldz00zzjvm_instrz00(obj_t BgL_envz00_4639, obj_t BgL_envz00_4640, obj_t BgL_varz00_4641)
{ AN_OBJECT;
{ /* Jvm/instr.scm 419 */
return 
BGl__putfieldz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4640), BgL_varz00_4641);} 
}



/* _newarray */
obj_t BGl__newarrayz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_113, obj_t BgL_typez00_114)
{ AN_OBJECT;
{ /* Jvm/instr.scm 425 */
{ /* Jvm/instr.scm 427 */
obj_t BgL_arg3774z00_1945;
{ /* Jvm/instr.scm 427 */
bool_t BgL_testz00_5924;
{ /* Jvm/instr.scm 427 */
obj_t BgL_auxz00_5925;
BgL_auxz00_5925 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_typez00_114, 
CNST_TABLE_REF(((long)123))); 
BgL_testz00_5924 = 
CBOOL(BgL_auxz00_5925); } 
if(BgL_testz00_5924)
{ /* Jvm/instr.scm 429 */
obj_t BgL_arg3778z00_1948;obj_t BgL_arg3779z00_1949;
BgL_arg3778z00_1948 = 
CNST_TABLE_REF(((long)124)); 
BgL_arg3779z00_1949 = 
MAKE_PAIR(BgL_typez00_114, BNIL); 
BgL_arg3774z00_1945 = 
MAKE_PAIR(BgL_arg3778z00_1948, BgL_arg3779z00_1949); }  else 
{ /* Jvm/instr.scm 430 */
obj_t BgL_arg3783z00_1950;obj_t BgL_arg3784z00_1951;
BgL_arg3783z00_1950 = 
CNST_TABLE_REF(((long)125)); 
BgL_arg3784z00_1951 = 
MAKE_PAIR(BgL_typez00_114, BNIL); 
BgL_arg3774z00_1945 = 
MAKE_PAIR(BgL_arg3783z00_1950, BgL_arg3784z00_1951); } } 
{ /* Jvm/instr.scm 426 */
obj_t BgL_arg3076z00_3599;
{ /* Jvm/instr.scm 426 */
obj_t BgL_auxz00_5935;
BgL_auxz00_5935 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_113))->BgL_codez00); 
BgL_arg3076z00_3599 = 
MAKE_PAIR(BgL_arg3774z00_1945, BgL_auxz00_5935); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_113))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3599), BUNSPEC); } ((bool_t)1); } 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_113, 
CNST_TABLE_REF(((long)4))); 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_113, 
CNST_TABLE_REF(((long)8)));} 
}



/* __newarray */
obj_t BGl___newarrayz00zzjvm_instrz00(obj_t BgL_envz00_4642, obj_t BgL_envz00_4643, obj_t BgL_typez00_4644)
{ AN_OBJECT;
{ /* Jvm/instr.scm 425 */
return 
BGl__newarrayz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4643), BgL_typez00_4644);} 
}



/* _aload */
obj_t BGl__aloadz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_115, obj_t BgL_typez00_116)
{ AN_OBJECT;
{ /* Jvm/instr.scm 434 */
{ /* Jvm/instr.scm 435 */
obj_t BgL_arg3076z00_3607;
{ /* Jvm/instr.scm 435 */
obj_t BgL_auxz00_5983;obj_t BgL_auxz00_5945;
BgL_auxz00_5983 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_115))->BgL_codez00); 
{ /* Jvm/instr.scm 436 */
bool_t BgL_testz00_5946;
{ /* Jvm/instr.scm 436 */
obj_t BgL_auxz00_5947;
BgL_auxz00_5947 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_typez00_116, 
CNST_TABLE_REF(((long)126))); 
BgL_testz00_5946 = 
CBOOL(BgL_auxz00_5947); } 
if(BgL_testz00_5946)
{ /* Jvm/instr.scm 436 */
BgL_auxz00_5945 = 
CNST_TABLE_REF(((long)127))
; }  else 
{ /* Jvm/instr.scm 436 */
bool_t BgL_testz00_5952;
{ /* Jvm/instr.scm 436 */
obj_t BgL_auxz00_5953;
BgL_auxz00_5953 = 
CNST_TABLE_REF(((long)128)); 
BgL_testz00_5952 = 
(BgL_typez00_116==BgL_auxz00_5953); } 
if(BgL_testz00_5952)
{ /* Jvm/instr.scm 436 */
BgL_auxz00_5945 = 
CNST_TABLE_REF(((long)129))
; }  else 
{ /* Jvm/instr.scm 436 */
bool_t BgL_testz00_5957;
{ /* Jvm/instr.scm 436 */
obj_t BgL_auxz00_5958;
BgL_auxz00_5958 = 
CNST_TABLE_REF(((long)130)); 
BgL_testz00_5957 = 
(BgL_typez00_116==BgL_auxz00_5958); } 
if(BgL_testz00_5957)
{ /* Jvm/instr.scm 436 */
BgL_auxz00_5945 = 
CNST_TABLE_REF(((long)131))
; }  else 
{ /* Jvm/instr.scm 436 */
bool_t BgL_testz00_5962;
{ /* Jvm/instr.scm 436 */
obj_t BgL_auxz00_5963;
BgL_auxz00_5963 = 
CNST_TABLE_REF(((long)4)); 
BgL_testz00_5962 = 
(BgL_typez00_116==BgL_auxz00_5963); } 
if(BgL_testz00_5962)
{ /* Jvm/instr.scm 436 */
BgL_auxz00_5945 = 
CNST_TABLE_REF(((long)132))
; }  else 
{ /* Jvm/instr.scm 436 */
bool_t BgL_testz00_5967;
{ /* Jvm/instr.scm 436 */
obj_t BgL_auxz00_5968;
BgL_auxz00_5968 = 
CNST_TABLE_REF(((long)5)); 
BgL_testz00_5967 = 
(BgL_typez00_116==BgL_auxz00_5968); } 
if(BgL_testz00_5967)
{ /* Jvm/instr.scm 436 */
BgL_auxz00_5945 = 
CNST_TABLE_REF(((long)133))
; }  else 
{ /* Jvm/instr.scm 436 */
bool_t BgL_testz00_5972;
{ /* Jvm/instr.scm 436 */
obj_t BgL_auxz00_5973;
BgL_auxz00_5973 = 
CNST_TABLE_REF(((long)6)); 
BgL_testz00_5972 = 
(BgL_typez00_116==BgL_auxz00_5973); } 
if(BgL_testz00_5972)
{ /* Jvm/instr.scm 436 */
BgL_auxz00_5945 = 
CNST_TABLE_REF(((long)134))
; }  else 
{ /* Jvm/instr.scm 436 */
bool_t BgL_testz00_5977;
{ /* Jvm/instr.scm 436 */
obj_t BgL_auxz00_5978;
BgL_auxz00_5978 = 
CNST_TABLE_REF(((long)7)); 
BgL_testz00_5977 = 
(BgL_typez00_116==BgL_auxz00_5978); } 
if(BgL_testz00_5977)
{ /* Jvm/instr.scm 436 */
BgL_auxz00_5945 = 
CNST_TABLE_REF(((long)135))
; }  else 
{ /* Jvm/instr.scm 436 */
BgL_auxz00_5945 = 
CNST_TABLE_REF(((long)136))
; } } } } } } } } 
BgL_arg3076z00_3607 = 
MAKE_PAIR(BgL_auxz00_5945, BgL_auxz00_5983); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_115))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3607), BUNSPEC); } ((bool_t)1); 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_115, 
CNST_TABLE_REF(((long)4))); 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_115, 
CNST_TABLE_REF(((long)8))); 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_115, 
BGl_simplezd2typezd2zzjvm_instrz00(BgL_typez00_116));} 
}



/* __aload */
obj_t BGl___aloadz00zzjvm_instrz00(obj_t BgL_envz00_4645, obj_t BgL_envz00_4646, obj_t BgL_typez00_4647)
{ AN_OBJECT;
{ /* Jvm/instr.scm 434 */
return 
BGl__aloadz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4646), BgL_typez00_4647);} 
}



/* _astore */
obj_t BGl__astorez00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_117, obj_t BgL_typez00_118)
{ AN_OBJECT;
{ /* Jvm/instr.scm 449 */
{ /* Jvm/instr.scm 450 */
obj_t BgL_arg3076z00_3615;
{ /* Jvm/instr.scm 450 */
obj_t BgL_auxz00_6033;obj_t BgL_auxz00_5995;
BgL_auxz00_6033 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_117))->BgL_codez00); 
{ /* Jvm/instr.scm 451 */
bool_t BgL_testz00_5996;
{ /* Jvm/instr.scm 451 */
obj_t BgL_auxz00_5997;
BgL_auxz00_5997 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_typez00_118, 
CNST_TABLE_REF(((long)126))); 
BgL_testz00_5996 = 
CBOOL(BgL_auxz00_5997); } 
if(BgL_testz00_5996)
{ /* Jvm/instr.scm 451 */
BgL_auxz00_5995 = 
CNST_TABLE_REF(((long)137))
; }  else 
{ /* Jvm/instr.scm 451 */
bool_t BgL_testz00_6002;
{ /* Jvm/instr.scm 451 */
obj_t BgL_auxz00_6003;
BgL_auxz00_6003 = 
CNST_TABLE_REF(((long)128)); 
BgL_testz00_6002 = 
(BgL_typez00_118==BgL_auxz00_6003); } 
if(BgL_testz00_6002)
{ /* Jvm/instr.scm 451 */
BgL_auxz00_5995 = 
CNST_TABLE_REF(((long)138))
; }  else 
{ /* Jvm/instr.scm 451 */
bool_t BgL_testz00_6007;
{ /* Jvm/instr.scm 451 */
obj_t BgL_auxz00_6008;
BgL_auxz00_6008 = 
CNST_TABLE_REF(((long)130)); 
BgL_testz00_6007 = 
(BgL_typez00_118==BgL_auxz00_6008); } 
if(BgL_testz00_6007)
{ /* Jvm/instr.scm 451 */
BgL_auxz00_5995 = 
CNST_TABLE_REF(((long)139))
; }  else 
{ /* Jvm/instr.scm 451 */
bool_t BgL_testz00_6012;
{ /* Jvm/instr.scm 451 */
obj_t BgL_auxz00_6013;
BgL_auxz00_6013 = 
CNST_TABLE_REF(((long)4)); 
BgL_testz00_6012 = 
(BgL_typez00_118==BgL_auxz00_6013); } 
if(BgL_testz00_6012)
{ /* Jvm/instr.scm 451 */
BgL_auxz00_5995 = 
CNST_TABLE_REF(((long)140))
; }  else 
{ /* Jvm/instr.scm 451 */
bool_t BgL_testz00_6017;
{ /* Jvm/instr.scm 451 */
obj_t BgL_auxz00_6018;
BgL_auxz00_6018 = 
CNST_TABLE_REF(((long)5)); 
BgL_testz00_6017 = 
(BgL_typez00_118==BgL_auxz00_6018); } 
if(BgL_testz00_6017)
{ /* Jvm/instr.scm 451 */
BgL_auxz00_5995 = 
CNST_TABLE_REF(((long)141))
; }  else 
{ /* Jvm/instr.scm 451 */
bool_t BgL_testz00_6022;
{ /* Jvm/instr.scm 451 */
obj_t BgL_auxz00_6023;
BgL_auxz00_6023 = 
CNST_TABLE_REF(((long)6)); 
BgL_testz00_6022 = 
(BgL_typez00_118==BgL_auxz00_6023); } 
if(BgL_testz00_6022)
{ /* Jvm/instr.scm 451 */
BgL_auxz00_5995 = 
CNST_TABLE_REF(((long)142))
; }  else 
{ /* Jvm/instr.scm 451 */
bool_t BgL_testz00_6027;
{ /* Jvm/instr.scm 451 */
obj_t BgL_auxz00_6028;
BgL_auxz00_6028 = 
CNST_TABLE_REF(((long)7)); 
BgL_testz00_6027 = 
(BgL_typez00_118==BgL_auxz00_6028); } 
if(BgL_testz00_6027)
{ /* Jvm/instr.scm 451 */
BgL_auxz00_5995 = 
CNST_TABLE_REF(((long)143))
; }  else 
{ /* Jvm/instr.scm 451 */
BgL_auxz00_5995 = 
CNST_TABLE_REF(((long)144))
; } } } } } } } } 
BgL_arg3076z00_3615 = 
MAKE_PAIR(BgL_auxz00_5995, BgL_auxz00_6033); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_117))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3615), BUNSPEC); } ((bool_t)1); 
BGl_popz00zzjvm_instrz00(BgL_envz00_117); 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_117, 
CNST_TABLE_REF(((long)4))); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_117, 
CNST_TABLE_REF(((long)8)));} 
}



/* __astore */
obj_t BGl___astorez00zzjvm_instrz00(obj_t BgL_envz00_4648, obj_t BgL_envz00_4649, obj_t BgL_typez00_4650)
{ AN_OBJECT;
{ /* Jvm/instr.scm 449 */
return 
BGl__astorez00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4649), BgL_typez00_4650);} 
}



/* _arraylength */
obj_t BGl__arraylengthz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_119)
{ AN_OBJECT;
{ /* Jvm/instr.scm 464 */
{ /* Jvm/instr.scm 465 */
obj_t BgL_arg3076z00_3623;
{ /* Jvm/instr.scm 465 */
obj_t BgL_auxz00_6046;obj_t BgL_auxz00_6044;
BgL_auxz00_6046 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_119))->BgL_codez00); 
BgL_auxz00_6044 = 
CNST_TABLE_REF(((long)145)); 
BgL_arg3076z00_3623 = 
MAKE_PAIR(BgL_auxz00_6044, BgL_auxz00_6046); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_119))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3623), BUNSPEC); } ((bool_t)1); 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_119, 
CNST_TABLE_REF(((long)8))); 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_119, 
CNST_TABLE_REF(((long)4)));} 
}



/* __arraylength */
obj_t BGl___arraylengthz00zzjvm_instrz00(obj_t BgL_envz00_4651, obj_t BgL_envz00_4652)
{ AN_OBJECT;
{ /* Jvm/instr.scm 464 */
return 
BGl__arraylengthz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4652));} 
}



/* _invokestatic */
obj_t BGl__invokestaticz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_120, obj_t BgL_varz00_121, obj_t BgL_targsz00_122, obj_t BgL_trz00_123)
{ AN_OBJECT;
{ /* Jvm/instr.scm 470 */
{ /* Jvm/instr.scm 471 */
obj_t BgL_arg3837z00_1971;
{ /* Jvm/instr.scm 471 */
obj_t BgL_arg3840z00_1972;obj_t BgL_arg3841z00_1973;
BgL_arg3840z00_1972 = 
CNST_TABLE_REF(((long)146)); 
BgL_arg3841z00_1973 = 
MAKE_PAIR(BgL_varz00_121, BNIL); 
BgL_arg3837z00_1971 = 
MAKE_PAIR(BgL_arg3840z00_1972, BgL_arg3841z00_1973); } 
{ /* Jvm/instr.scm 471 */
obj_t BgL_arg3076z00_3631;
{ /* Jvm/instr.scm 471 */
obj_t BgL_auxz00_6059;
BgL_auxz00_6059 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_120))->BgL_codez00); 
BgL_arg3076z00_3631 = 
MAKE_PAIR(BgL_arg3837z00_1971, BgL_auxz00_6059); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_120))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3631), BUNSPEC); } ((bool_t)1); } 
{ 
obj_t BgL_l2978z00_1974;
BgL_l2978z00_1974 = 
bgl_reverse(BgL_targsz00_122); 
BgL_lname2979z00_1975:
if(
PAIRP(BgL_l2978z00_1974))
{ /* Jvm/instr.scm 472 */
BGl_cpopz00zzjvm_instrz00(BgL_envz00_120, 
BGl_simplezd2typezd2zzjvm_instrz00(
CAR(BgL_l2978z00_1974))); 
{ 
obj_t BgL_l2978z00_6068;
BgL_l2978z00_6068 = 
CDR(BgL_l2978z00_1974); 
BgL_l2978z00_1974 = BgL_l2978z00_6068; 
goto BgL_lname2979z00_1975;} }  else 
{ /* Jvm/instr.scm 472 */((bool_t)1); } } 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_120, 
BGl_simplezd2typezd2zzjvm_instrz00(BgL_trz00_123));} 
}



/* __invokestatic */
obj_t BGl___invokestaticz00zzjvm_instrz00(obj_t BgL_envz00_4653, obj_t BgL_envz00_4654, obj_t BgL_varz00_4655, obj_t BgL_targsz00_4656, obj_t BgL_trz00_4657)
{ AN_OBJECT;
{ /* Jvm/instr.scm 470 */
return 
BGl__invokestaticz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4654), BgL_varz00_4655, BgL_targsz00_4656, BgL_trz00_4657);} 
}



/* _invokespecial */
obj_t BGl__invokespecialz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_124, obj_t BgL_varz00_125, obj_t BgL_targsz00_126, obj_t BgL_trz00_127)
{ AN_OBJECT;
{ /* Jvm/instr.scm 477 */
{ /* Jvm/instr.scm 478 */
obj_t BgL_arg3864z00_1982;
{ /* Jvm/instr.scm 478 */
obj_t BgL_arg3867z00_1983;obj_t BgL_arg3868z00_1984;
BgL_arg3867z00_1983 = 
CNST_TABLE_REF(((long)147)); 
BgL_arg3868z00_1984 = 
MAKE_PAIR(BgL_varz00_125, BNIL); 
BgL_arg3864z00_1982 = 
MAKE_PAIR(BgL_arg3867z00_1983, BgL_arg3868z00_1984); } 
{ /* Jvm/instr.scm 478 */
obj_t BgL_arg3076z00_3642;
{ /* Jvm/instr.scm 478 */
obj_t BgL_auxz00_6078;
BgL_auxz00_6078 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_124))->BgL_codez00); 
BgL_arg3076z00_3642 = 
MAKE_PAIR(BgL_arg3864z00_1982, BgL_auxz00_6078); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_124))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3642), BUNSPEC); } ((bool_t)1); } 
{ 
obj_t BgL_l2980z00_1985;
BgL_l2980z00_1985 = 
bgl_reverse(BgL_targsz00_126); 
BgL_lname2981z00_1986:
if(
PAIRP(BgL_l2980z00_1985))
{ /* Jvm/instr.scm 479 */
BGl_cpopz00zzjvm_instrz00(BgL_envz00_124, 
BGl_simplezd2typezd2zzjvm_instrz00(
CAR(BgL_l2980z00_1985))); 
{ 
obj_t BgL_l2980z00_6087;
BgL_l2980z00_6087 = 
CDR(BgL_l2980z00_1985); 
BgL_l2980z00_1985 = BgL_l2980z00_6087; 
goto BgL_lname2981z00_1986;} }  else 
{ /* Jvm/instr.scm 479 */((bool_t)1); } } 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_124, 
BGl_simplezd2typezd2zzjvm_instrz00(BgL_trz00_127));} 
}



/* __invokespecial */
obj_t BGl___invokespecialz00zzjvm_instrz00(obj_t BgL_envz00_4658, obj_t BgL_envz00_4659, obj_t BgL_varz00_4660, obj_t BgL_targsz00_4661, obj_t BgL_trz00_4662)
{ AN_OBJECT;
{ /* Jvm/instr.scm 477 */
return 
BGl__invokespecialz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4659), BgL_varz00_4660, BgL_targsz00_4661, BgL_trz00_4662);} 
}



/* _invokespecial_init */
obj_t BGl__invokespecial_initz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_128, obj_t BgL_varz00_129, obj_t BgL_targsz00_130, obj_t BgL_trz00_131)
{ AN_OBJECT;
{ /* Jvm/instr.scm 490 */
{ /* Jvm/instr.scm 492 */
obj_t BgL_argsz00_1994;obj_t BgL_ptrz00_1995;
BgL_argsz00_1994 = BNIL; 
BgL_ptrz00_1995 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_128))->BgL_codez00); 
{ 
obj_t BgL_l2984z00_1996;
BgL_l2984z00_1996 = 
CDR(BgL_targsz00_130); 
BgL_lname2985z00_1997:
if(
PAIRP(BgL_l2984z00_1996))
{ /* Jvm/instr.scm 493 */
{ /* Jvm/instr.scm 495 */
bool_t BgL_test3896z00_2001;
{ /* Jvm/instr.scm 495 */
bool_t BgL_test3902z00_2003;
{ /* Jvm/instr.scm 495 */
obj_t BgL_arg3909z00_2006;
{ /* Jvm/instr.scm 495 */
obj_t BgL_pairz00_3654;
BgL_pairz00_3654 = BgL_ptrz00_1995; 
BgL_arg3909z00_2006 = 
CAR(BgL_pairz00_3654); } 
BgL_test3902z00_2003 = 
PAIRP(BgL_arg3909z00_2006); } 
if(BgL_test3902z00_2003)
{ /* Jvm/instr.scm 495 */
obj_t BgL_arg3904z00_2004;
{ /* Jvm/instr.scm 495 */
obj_t BgL_pairz00_3656;
BgL_pairz00_3656 = BgL_ptrz00_1995; 
{ /* Jvm/instr.scm 495 */
obj_t BgL_auxz00_6100;
BgL_auxz00_6100 = 
CAR(BgL_pairz00_3656); 
BgL_arg3904z00_2004 = 
CAR(BgL_auxz00_6100); } } 
{ /* Jvm/instr.scm 495 */
obj_t BgL_auxz00_6103;
BgL_auxz00_6103 = 
CNST_TABLE_REF(((long)120)); 
BgL_test3896z00_2001 = 
(BgL_arg3904z00_2004==BgL_auxz00_6103); } }  else 
{ /* Jvm/instr.scm 495 */
BgL_test3896z00_2001 = ((bool_t)0); } } 
if(BgL_test3896z00_2001)
{ /* Jvm/instr.scm 495 */
{ /* Jvm/instr.scm 496 */
obj_t BgL_arg3898z00_2002;
{ /* Jvm/instr.scm 496 */
obj_t BgL_pairz00_3660;
BgL_pairz00_3660 = BgL_ptrz00_1995; 
BgL_arg3898z00_2002 = 
CAR(BgL_pairz00_3660); } 
BgL_argsz00_1994 = 
MAKE_PAIR(BgL_arg3898z00_2002, BgL_argsz00_1994); } 
{ /* Jvm/instr.scm 497 */
obj_t BgL_pairz00_3661;
BgL_pairz00_3661 = BgL_ptrz00_1995; 
BgL_ptrz00_1995 = 
CDR(BgL_pairz00_3661); } }  else 
{ /* Jvm/instr.scm 495 */BFALSE; } } 
{ /* Jvm/instr.scm 498 */
bool_t BgL_test3912z00_2007;
{ /* Jvm/instr.scm 498 */
bool_t BgL_test3918z00_2009;
{ /* Jvm/instr.scm 498 */
obj_t BgL_arg3924z00_2011;
{ /* Jvm/instr.scm 498 */
obj_t BgL_pairz00_3662;
BgL_pairz00_3662 = BgL_ptrz00_1995; 
BgL_arg3924z00_2011 = 
CAR(BgL_pairz00_3662); } 
BgL_test3918z00_2009 = 
PAIRP(BgL_arg3924z00_2011); } 
if(BgL_test3918z00_2009)
{ /* Jvm/instr.scm 499 */
obj_t BgL_arg3920z00_2010;
{ /* Jvm/instr.scm 499 */
obj_t BgL_pairz00_3664;
BgL_pairz00_3664 = BgL_ptrz00_1995; 
{ /* Jvm/instr.scm 499 */
obj_t BgL_auxz00_6113;
BgL_auxz00_6113 = 
CAR(BgL_pairz00_3664); 
BgL_arg3920z00_2010 = 
CAR(BgL_auxz00_6113); } } 
{ /* Jvm/instr.scm 499 */
obj_t BgL_auxz00_6116;
BgL_auxz00_6116 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg3920z00_2010, BGl_za2simplezd2pushzd2instructionsza2z00zzjvm_instrz00); 
BgL_test3912z00_2007 = 
CBOOL(BgL_auxz00_6116); } }  else 
{ /* Jvm/instr.scm 498 */
BgL_test3912z00_2007 = ((bool_t)0); } } 
if(BgL_test3912z00_2007)
{ /* Jvm/instr.scm 498 */
{ /* Jvm/instr.scm 500 */
obj_t BgL_arg3914z00_2008;
{ /* Jvm/instr.scm 500 */
obj_t BgL_pairz00_3668;
BgL_pairz00_3668 = BgL_ptrz00_1995; 
BgL_arg3914z00_2008 = 
CAR(BgL_pairz00_3668); } 
BgL_argsz00_1994 = 
MAKE_PAIR(BgL_arg3914z00_2008, BgL_argsz00_1994); } 
{ /* Jvm/instr.scm 501 */
obj_t BgL_pairz00_3669;
BgL_pairz00_3669 = BgL_ptrz00_1995; 
BgL_ptrz00_1995 = 
CDR(BgL_pairz00_3669); } }  else 
{ /* Jvm/instr.scm 498 */BFALSE; } } 
{ 
obj_t BgL_l2984z00_6123;
BgL_l2984z00_6123 = 
CDR(BgL_l2984z00_1996); 
BgL_l2984z00_1996 = BgL_l2984z00_6123; 
goto BgL_lname2985z00_1997;} }  else 
{ /* Jvm/instr.scm 493 */((bool_t)1); } } 
{ /* Jvm/instr.scm 503 */
bool_t BgL_test3933z00_2013;
{ /* Jvm/instr.scm 503 */
bool_t BgL_test3935z00_2014;
{ /* Jvm/instr.scm 503 */
obj_t BgL_arg3942z00_2017;
{ /* Jvm/instr.scm 503 */
obj_t BgL_pairz00_3671;
BgL_pairz00_3671 = BgL_ptrz00_1995; 
BgL_arg3942z00_2017 = 
CAR(BgL_pairz00_3671); } 
BgL_test3935z00_2014 = 
PAIRP(BgL_arg3942z00_2017); } 
if(BgL_test3935z00_2014)
{ /* Jvm/instr.scm 503 */
obj_t BgL_arg3937z00_2015;
{ /* Jvm/instr.scm 503 */
obj_t BgL_pairz00_3673;
BgL_pairz00_3673 = BgL_ptrz00_1995; 
{ /* Jvm/instr.scm 503 */
obj_t BgL_auxz00_6129;
BgL_auxz00_6129 = 
CAR(BgL_pairz00_3673); 
BgL_arg3937z00_2015 = 
CAR(BgL_auxz00_6129); } } 
{ /* Jvm/instr.scm 503 */
obj_t BgL_auxz00_6132;
BgL_auxz00_6132 = 
CNST_TABLE_REF(((long)120)); 
BgL_test3933z00_2013 = 
(BgL_arg3937z00_2015==BgL_auxz00_6132); } }  else 
{ /* Jvm/instr.scm 503 */
BgL_test3933z00_2013 = ((bool_t)0); } } 
if(BgL_test3933z00_2013)
{ /* Jvm/instr.scm 504 */
obj_t BgL_pairz00_3677;
BgL_pairz00_3677 = BgL_ptrz00_1995; 
BgL_ptrz00_1995 = 
CDR(BgL_pairz00_3677); }  else 
{ /* Jvm/instr.scm 503 */BFALSE; } } 
{ 
obj_t BgL_xz00_2022;obj_t BgL_fromz00_2023;obj_t BgL_tz00_2024;obj_t BgL_restz00_2025;obj_t BgL_xz00_2018;obj_t BgL_tz00_2019;obj_t BgL_restz00_2020;
{ /* Jvm/instr.scm 505 */
obj_t BgL_ezd2120zd2_2028;
BgL_ezd2120zd2_2028 = BgL_ptrz00_1995; 
if(
PAIRP(BgL_ezd2120zd2_2028))
{ /* Jvm/instr.scm 505 */
obj_t BgL_carzd2128zd2_2030;obj_t BgL_cdrzd2129zd2_2031;
BgL_carzd2128zd2_2030 = 
CAR(BgL_ezd2120zd2_2028); 
BgL_cdrzd2129zd2_2031 = 
CDR(BgL_ezd2120zd2_2028); 
if(
PAIRP(BgL_carzd2128zd2_2030))
{ /* Jvm/instr.scm 505 */
obj_t BgL_cdrzd2132zd2_2033;
BgL_cdrzd2132zd2_2033 = 
CDR(BgL_carzd2128zd2_2030); 
{ /* Jvm/instr.scm 505 */
bool_t BgL_testz00_6144;
{ /* Jvm/instr.scm 505 */
obj_t BgL_auxz00_6147;obj_t BgL_auxz00_6145;
BgL_auxz00_6147 = 
CNST_TABLE_REF(((long)42)); 
BgL_auxz00_6145 = 
CAR(BgL_carzd2128zd2_2030); 
BgL_testz00_6144 = 
(BgL_auxz00_6145==BgL_auxz00_6147); } 
if(BgL_testz00_6144)
{ /* Jvm/instr.scm 505 */
if(
PAIRP(BgL_cdrzd2132zd2_2033))
{ /* Jvm/instr.scm 505 */
obj_t BgL_xz00_2036;
BgL_xz00_2036 = 
CAR(BgL_cdrzd2132zd2_2033); 
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2132zd2_2033), BNIL))
{ /* Jvm/instr.scm 505 */
if(
PAIRP(BgL_cdrzd2129zd2_2031))
{ /* Jvm/instr.scm 505 */
obj_t BgL_carzd2140zd2_2039;obj_t BgL_cdrzd2141zd2_2040;
BgL_carzd2140zd2_2039 = 
CAR(BgL_cdrzd2129zd2_2031); 
BgL_cdrzd2141zd2_2040 = 
CDR(BgL_cdrzd2129zd2_2031); 
if(
PAIRP(BgL_carzd2140zd2_2039))
{ /* Jvm/instr.scm 505 */
obj_t BgL_cdrzd2144zd2_2042;
BgL_cdrzd2144zd2_2042 = 
CDR(BgL_carzd2140zd2_2039); 
{ /* Jvm/instr.scm 505 */
bool_t BgL_testz00_6163;
{ /* Jvm/instr.scm 505 */
obj_t BgL_auxz00_6166;obj_t BgL_auxz00_6164;
BgL_auxz00_6166 = 
CNST_TABLE_REF(((long)47)); 
BgL_auxz00_6164 = 
CAR(BgL_carzd2140zd2_2039); 
BgL_testz00_6163 = 
(BgL_auxz00_6164==BgL_auxz00_6166); } 
if(BgL_testz00_6163)
{ /* Jvm/instr.scm 505 */
if(
PAIRP(BgL_cdrzd2144zd2_2042))
{ /* Jvm/instr.scm 505 */
bool_t BgL_testz00_6171;
{ /* Jvm/instr.scm 505 */
obj_t BgL_auxz00_6172;
BgL_auxz00_6172 = 
CAR(BgL_cdrzd2144zd2_2042); 
BgL_testz00_6171 = 
(BgL_xz00_2036==BgL_auxz00_6172); } 
if(BgL_testz00_6171)
{ /* Jvm/instr.scm 505 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2144zd2_2042), BNIL))
{ /* Jvm/instr.scm 505 */
if(
PAIRP(BgL_cdrzd2141zd2_2040))
{ /* Jvm/instr.scm 505 */
obj_t BgL_carzd2151zd2_2048;
BgL_carzd2151zd2_2048 = 
CAR(BgL_cdrzd2141zd2_2040); 
if(
PAIRP(BgL_carzd2151zd2_2048))
{ /* Jvm/instr.scm 505 */
obj_t BgL_cdrzd2155zd2_2050;
BgL_cdrzd2155zd2_2050 = 
CDR(BgL_carzd2151zd2_2048); 
{ /* Jvm/instr.scm 505 */
bool_t BgL_testz00_6184;
{ /* Jvm/instr.scm 505 */
obj_t BgL_auxz00_6187;obj_t BgL_auxz00_6185;
BgL_auxz00_6187 = 
CNST_TABLE_REF(((long)117)); 
BgL_auxz00_6185 = 
CAR(BgL_carzd2151zd2_2048); 
BgL_testz00_6184 = 
(BgL_auxz00_6185==BgL_auxz00_6187); } 
if(BgL_testz00_6184)
{ /* Jvm/instr.scm 505 */
if(
PAIRP(BgL_cdrzd2155zd2_2050))
{ /* Jvm/instr.scm 505 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2155zd2_2050), BNIL))
{ /* Jvm/instr.scm 505 */
BgL_xz00_2018 = BgL_xz00_2036; 
BgL_tz00_2019 = 
CAR(BgL_cdrzd2155zd2_2050); 
BgL_restz00_2020 = 
CDR(BgL_cdrzd2141zd2_2040); 
{ /* Jvm/instr.scm 507 */
obj_t BgL_arg4256z00_2168;
{ /* Jvm/instr.scm 507 */
obj_t BgL_arg4259z00_2169;obj_t BgL_arg4260z00_2170;
{ /* Jvm/instr.scm 507 */
obj_t BgL_arg4263z00_2171;obj_t BgL_arg4264z00_2172;
BgL_arg4263z00_2171 = 
CNST_TABLE_REF(((long)47)); 
BgL_arg4264z00_2172 = 
MAKE_PAIR(BgL_xz00_2018, BNIL); 
BgL_arg4259z00_2169 = 
MAKE_PAIR(BgL_arg4263z00_2171, BgL_arg4264z00_2172); } 
{ /* Jvm/instr.scm 508 */
obj_t BgL_arg4268z00_2173;obj_t BgL_arg4269z00_2174;
{ /* Jvm/instr.scm 508 */
obj_t BgL_arg4272z00_2175;obj_t BgL_arg4273z00_2176;
BgL_arg4272z00_2175 = 
CNST_TABLE_REF(((long)147)); 
BgL_arg4273z00_2176 = 
MAKE_PAIR(BgL_varz00_129, BNIL); 
BgL_arg4268z00_2173 = 
MAKE_PAIR(BgL_arg4272z00_2175, BgL_arg4273z00_2176); } 
{ /* Jvm/instr.scm 509 */
obj_t BgL_arg4277z00_2177;obj_t BgL_arg4278z00_2178;
BgL_arg4277z00_2177 = 
bgl_reverse(BgL_argsz00_1994); 
{ /* Jvm/instr.scm 510 */
obj_t BgL_arg4282z00_2179;obj_t BgL_arg4283z00_2180;
{ /* Jvm/instr.scm 510 */
obj_t BgL_auxz00_6202;
BgL_auxz00_6202 = 
CNST_TABLE_REF(((long)148)); 
BgL_arg4282z00_2179 = 
MAKE_PAIR(BgL_auxz00_6202, BNIL); } 
{ /* Jvm/instr.scm 511 */
obj_t BgL_arg4287z00_2181;obj_t BgL_arg4288z00_2182;
{ /* Jvm/instr.scm 511 */
obj_t BgL_arg4291z00_2183;obj_t BgL_arg4292z00_2184;
BgL_arg4291z00_2183 = 
CNST_TABLE_REF(((long)117)); 
BgL_arg4292z00_2184 = 
MAKE_PAIR(BgL_tz00_2019, BNIL); 
BgL_arg4287z00_2181 = 
MAKE_PAIR(BgL_arg4291z00_2183, BgL_arg4292z00_2184); } 
BgL_arg4288z00_2182 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_restz00_2020, BNIL); 
BgL_arg4283z00_2180 = 
MAKE_PAIR(BgL_arg4287z00_2181, BgL_arg4288z00_2182); } 
BgL_arg4278z00_2178 = 
MAKE_PAIR(BgL_arg4282z00_2179, BgL_arg4283z00_2180); } 
BgL_arg4269z00_2174 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg4277z00_2177, BgL_arg4278z00_2178); } 
BgL_arg4260z00_2170 = 
MAKE_PAIR(BgL_arg4268z00_2173, BgL_arg4269z00_2174); } 
BgL_arg4256z00_2168 = 
MAKE_PAIR(BgL_arg4259z00_2169, BgL_arg4260z00_2170); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_128))->BgL_codez00) = ((obj_t)BgL_arg4256z00_2168), BUNSPEC); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6217;
BgL_tagzd2119zd2_2027:
{ /* Jvm/instr.scm 522 */
obj_t BgL_arg4339z00_2203;
BgL_arg4339z00_2203 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string5865z00zzjvm_instrz00, BgL_arg4339z00_2203); } 
{ /* Jvm/instr.scm 522 */
obj_t BgL_arg4343z00_2204;obj_t BgL_arg4344z00_2205;
BgL_arg4343z00_2204 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_128))->BgL_codez00); 
BgL_arg4344z00_2205 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg4343z00_2204, BgL_arg4344z00_2205); } 
{ /* Jvm/instr.scm 522 */
obj_t BgL_arg4349z00_2206;
BgL_arg4349z00_2206 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg4349z00_2206); } 
{ /* Jvm/instr.scm 523 */
obj_t BgL_arg4354z00_2208;
BgL_arg4354z00_2208 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string5866z00zzjvm_instrz00, BgL_arg4354z00_2208); } 
{ /* Jvm/instr.scm 523 */
obj_t BgL_arg4358z00_2209;
BgL_arg4358z00_2209 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_targsz00_130, BgL_arg4358z00_2209); } 
{ /* Jvm/instr.scm 523 */
obj_t BgL_arg4362z00_2210;
BgL_arg4362z00_2210 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg4362z00_2210); } 
{ /* Jvm/instr.scm 524 */
obj_t BgL_arg4366z00_2211;
{ /* Jvm/instr.scm 524 */
obj_t BgL_arg4369z00_2212;obj_t BgL_arg4370z00_2213;
BgL_arg4369z00_2212 = 
CNST_TABLE_REF(((long)147)); 
BgL_arg4370z00_2213 = 
MAKE_PAIR(BgL_varz00_129, BNIL); 
BgL_arg4366z00_2211 = 
MAKE_PAIR(BgL_arg4369z00_2212, BgL_arg4370z00_2213); } 
{ /* Jvm/instr.scm 524 */
obj_t BgL_arg3076z00_3790;
{ /* Jvm/instr.scm 524 */
obj_t BgL_auxz00_6234;
BgL_auxz00_6234 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_128))->BgL_codez00); 
BgL_arg3076z00_3790 = 
MAKE_PAIR(BgL_arg4366z00_2211, BgL_auxz00_6234); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_128))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3790), BUNSPEC); } 
BgL_auxz00_6217 = ((bool_t)1); } 
BBOOL(BgL_auxz00_6217); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6239;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6239); } }  else 
{ /* Jvm/instr.scm 505 */
obj_t BgL_xz00_2059;
{ /* Jvm/instr.scm 505 */
obj_t BgL_auxz00_6241;
{ /* Jvm/instr.scm 505 */
obj_t BgL_auxz00_6242;
BgL_auxz00_6242 = 
CAR(BgL_ezd2120zd2_2028); 
BgL_auxz00_6241 = 
CDR(BgL_auxz00_6242); } 
BgL_xz00_2059 = 
CAR(BgL_auxz00_6241); } 
{ /* Jvm/instr.scm 505 */
obj_t BgL_cdrzd2206zd2_2060;
BgL_cdrzd2206zd2_2060 = 
CDR(BgL_cdrzd2129zd2_2031); 
{ /* Jvm/instr.scm 505 */
bool_t BgL_testz00_6247;
{ /* Jvm/instr.scm 505 */
obj_t BgL_auxz00_6248;
{ /* Jvm/instr.scm 505 */
obj_t BgL_auxz00_6249;
{ /* Jvm/instr.scm 505 */
obj_t BgL_auxz00_6250;
BgL_auxz00_6250 = 
CAR(BgL_cdrzd2129zd2_2031); 
BgL_auxz00_6249 = 
CDR(BgL_auxz00_6250); } 
BgL_auxz00_6248 = 
CAR(BgL_auxz00_6249); } 
BgL_testz00_6247 = 
(BgL_xz00_2059==BgL_auxz00_6248); } 
if(BgL_testz00_6247)
{ /* Jvm/instr.scm 505 */
obj_t BgL_carzd2221zd2_2062;obj_t BgL_cdrzd2222zd2_2063;
BgL_carzd2221zd2_2062 = 
CAR(BgL_cdrzd2206zd2_2060); 
BgL_cdrzd2222zd2_2063 = 
CDR(BgL_cdrzd2206zd2_2060); 
{ /* Jvm/instr.scm 505 */
obj_t BgL_cdrzd2226zd2_2064;
BgL_cdrzd2226zd2_2064 = 
CDR(BgL_carzd2221zd2_2062); 
{ /* Jvm/instr.scm 505 */
bool_t BgL_testz00_6258;
{ /* Jvm/instr.scm 505 */
obj_t BgL_auxz00_6261;obj_t BgL_auxz00_6259;
BgL_auxz00_6261 = 
CNST_TABLE_REF(((long)149)); 
BgL_auxz00_6259 = 
CAR(BgL_carzd2221zd2_2062); 
BgL_testz00_6258 = 
(BgL_auxz00_6259==BgL_auxz00_6261); } 
if(BgL_testz00_6258)
{ /* Jvm/instr.scm 505 */
if(
PAIRP(BgL_cdrzd2226zd2_2064))
{ /* Jvm/instr.scm 505 */
obj_t BgL_cdrzd2230zd2_2067;
BgL_cdrzd2230zd2_2067 = 
CDR(BgL_cdrzd2226zd2_2064); 
{ /* Jvm/instr.scm 505 */
obj_t BgL_fromz00_2068;
BgL_fromz00_2068 = 
CAR(BgL_cdrzd2226zd2_2064); 
if(
PAIRP(BgL_cdrzd2230zd2_2067))
{ /* Jvm/instr.scm 505 */
obj_t BgL_cdrzd2234zd2_2070;
BgL_cdrzd2234zd2_2070 = 
CDR(BgL_cdrzd2230zd2_2067); 
if(
PAIRP(BgL_cdrzd2234zd2_2070))
{ /* Jvm/instr.scm 505 */
obj_t BgL_cdrzd2237zd2_2072;
BgL_cdrzd2237zd2_2072 = 
CDR(BgL_cdrzd2234zd2_2070); 
if(
PAIRP(BgL_cdrzd2237zd2_2072))
{ /* Jvm/instr.scm 505 */
obj_t BgL_cdrzd2240zd2_2074;
BgL_cdrzd2240zd2_2074 = 
CDR(BgL_cdrzd2237zd2_2072); 
if(
PAIRP(BgL_cdrzd2240zd2_2074))
{ /* Jvm/instr.scm 505 */
bool_t BgL_testz00_6279;
{ /* Jvm/instr.scm 505 */
obj_t BgL_auxz00_6280;
BgL_auxz00_6280 = 
CAR(BgL_cdrzd2240zd2_2074); 
BgL_testz00_6279 = 
(BgL_xz00_2059==BgL_auxz00_6280); } 
if(BgL_testz00_6279)
{ /* Jvm/instr.scm 505 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2240zd2_2074), BNIL))
{ /* Jvm/instr.scm 505 */
if(
PAIRP(BgL_cdrzd2222zd2_2063))
{ /* Jvm/instr.scm 505 */
obj_t BgL_cdrzd2249zd2_2079;
BgL_cdrzd2249zd2_2079 = 
CDR(BgL_cdrzd2222zd2_2063); 
{ /* Jvm/instr.scm 505 */
bool_t BgL_testz00_6289;
{ /* Jvm/instr.scm 505 */
obj_t BgL_auxz00_6290;
BgL_auxz00_6290 = 
CAR(BgL_cdrzd2222zd2_2063); 
BgL_testz00_6289 = 
(BgL_fromz00_2068==BgL_auxz00_6290); } 
if(BgL_testz00_6289)
{ /* Jvm/instr.scm 505 */
if(
PAIRP(BgL_cdrzd2249zd2_2079))
{ /* Jvm/instr.scm 505 */
obj_t BgL_carzd2253zd2_2082;
BgL_carzd2253zd2_2082 = 
CAR(BgL_cdrzd2249zd2_2079); 
if(
PAIRP(BgL_carzd2253zd2_2082))
{ /* Jvm/instr.scm 505 */
obj_t BgL_cdrzd2257zd2_2084;
BgL_cdrzd2257zd2_2084 = 
CDR(BgL_carzd2253zd2_2082); 
{ /* Jvm/instr.scm 505 */
bool_t BgL_testz00_6299;
{ /* Jvm/instr.scm 505 */
obj_t BgL_auxz00_6302;obj_t BgL_auxz00_6300;
BgL_auxz00_6302 = 
CNST_TABLE_REF(((long)117)); 
BgL_auxz00_6300 = 
CAR(BgL_carzd2253zd2_2082); 
BgL_testz00_6299 = 
(BgL_auxz00_6300==BgL_auxz00_6302); } 
if(BgL_testz00_6299)
{ /* Jvm/instr.scm 505 */
if(
PAIRP(BgL_cdrzd2257zd2_2084))
{ /* Jvm/instr.scm 505 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2257zd2_2084), BNIL))
{ /* Jvm/instr.scm 505 */
BgL_xz00_2022 = BgL_xz00_2059; 
BgL_fromz00_2023 = BgL_fromz00_2068; 
BgL_tz00_2024 = 
CAR(BgL_cdrzd2257zd2_2084); 
BgL_restz00_2025 = 
CDR(BgL_cdrzd2249zd2_2079); 
BgL_tagzd2118zd2_2026:
{ /* Jvm/instr.scm 515 */
obj_t BgL_arg4297z00_2185;
{ /* Jvm/instr.scm 515 */
obj_t BgL_arg4300z00_2186;obj_t BgL_arg4301z00_2187;
{ /* Jvm/instr.scm 515 */
obj_t BgL_arg4304z00_2188;obj_t BgL_arg4305z00_2189;
BgL_arg4304z00_2188 = 
CNST_TABLE_REF(((long)47)); 
BgL_arg4305z00_2189 = 
MAKE_PAIR(BgL_xz00_2022, BNIL); 
BgL_arg4300z00_2186 = 
MAKE_PAIR(BgL_arg4304z00_2188, BgL_arg4305z00_2189); } 
{ /* Jvm/instr.scm 516 */
obj_t BgL_arg4309z00_2190;obj_t BgL_arg4310z00_2191;
{ /* Jvm/instr.scm 516 */
obj_t BgL_arg4313z00_2192;obj_t BgL_arg4314z00_2193;
BgL_arg4313z00_2192 = 
CNST_TABLE_REF(((long)147)); 
BgL_arg4314z00_2193 = 
MAKE_PAIR(BgL_varz00_129, BNIL); 
BgL_arg4309z00_2190 = 
MAKE_PAIR(BgL_arg4313z00_2192, BgL_arg4314z00_2193); } 
{ /* Jvm/instr.scm 517 */
obj_t BgL_arg4318z00_2194;obj_t BgL_arg4319z00_2195;
BgL_arg4318z00_2194 = 
bgl_reverse(BgL_argsz00_1994); 
{ /* Jvm/instr.scm 518 */
obj_t BgL_arg4323z00_2196;obj_t BgL_arg4324z00_2197;
{ /* Jvm/instr.scm 518 */
obj_t BgL_auxz00_6317;
BgL_auxz00_6317 = 
CNST_TABLE_REF(((long)148)); 
BgL_arg4323z00_2196 = 
MAKE_PAIR(BgL_auxz00_6317, BNIL); } 
{ /* Jvm/instr.scm 519 */
obj_t BgL_arg4328z00_2198;obj_t BgL_arg4329z00_2199;
{ /* Jvm/instr.scm 519 */
obj_t BgL_arg4332z00_2200;obj_t BgL_arg4333z00_2201;
BgL_arg4332z00_2200 = 
CNST_TABLE_REF(((long)117)); 
BgL_arg4333z00_2201 = 
MAKE_PAIR(BgL_tz00_2024, BNIL); 
BgL_arg4328z00_2198 = 
MAKE_PAIR(BgL_arg4332z00_2200, BgL_arg4333z00_2201); } 
BgL_arg4329z00_2199 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_restz00_2025, BNIL); 
BgL_arg4324z00_2197 = 
MAKE_PAIR(BgL_arg4328z00_2198, BgL_arg4329z00_2199); } 
BgL_arg4319z00_2195 = 
MAKE_PAIR(BgL_arg4323z00_2196, BgL_arg4324z00_2197); } 
BgL_arg4310z00_2191 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg4318z00_2194, BgL_arg4319z00_2195); } 
BgL_arg4301z00_2187 = 
MAKE_PAIR(BgL_arg4309z00_2190, BgL_arg4310z00_2191); } 
BgL_arg4297z00_2185 = 
MAKE_PAIR(BgL_arg4300z00_2186, BgL_arg4301z00_2187); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_128))->BgL_codez00) = ((obj_t)BgL_arg4297z00_2185), BUNSPEC); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6332;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6332); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6334;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6334); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6336;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6336); } } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6338;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6338); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6340;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6340); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6342;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6342); } } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6344;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6344); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6346;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6346); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6348;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6348); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6350;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6350); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6352;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6352); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6354;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6354); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6356;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6356); } } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6358;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6358); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6360;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6360); } } } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6362;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6362); } } } } } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6364;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6364); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6366;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6366); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6368;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6368); } }  else 
{ /* Jvm/instr.scm 505 */
obj_t BgL_xz00_2110;
{ /* Jvm/instr.scm 505 */
obj_t BgL_auxz00_6370;
{ /* Jvm/instr.scm 505 */
obj_t BgL_auxz00_6371;
BgL_auxz00_6371 = 
CAR(BgL_ezd2120zd2_2028); 
BgL_auxz00_6370 = 
CDR(BgL_auxz00_6371); } 
BgL_xz00_2110 = 
CAR(BgL_auxz00_6370); } 
{ /* Jvm/instr.scm 505 */
obj_t BgL_cdrzd2317zd2_2111;
BgL_cdrzd2317zd2_2111 = 
CDR(BgL_cdrzd2129zd2_2031); 
{ /* Jvm/instr.scm 505 */
obj_t BgL_cdrzd2320zd2_2112;
{ /* Jvm/instr.scm 505 */
obj_t BgL_auxz00_6376;
BgL_auxz00_6376 = 
CAR(BgL_cdrzd2129zd2_2031); 
BgL_cdrzd2320zd2_2112 = 
CDR(BgL_auxz00_6376); } 
{ /* Jvm/instr.scm 505 */
bool_t BgL_testz00_6379;
{ /* Jvm/instr.scm 505 */
obj_t BgL_auxz00_6380;
BgL_auxz00_6380 = 
CAR(BgL_cdrzd2320zd2_2112); 
BgL_testz00_6379 = 
(BgL_xz00_2110==BgL_auxz00_6380); } 
if(BgL_testz00_6379)
{ /* Jvm/instr.scm 505 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2320zd2_2112), BNIL))
{ /* Jvm/instr.scm 505 */
if(
PAIRP(BgL_cdrzd2317zd2_2111))
{ /* Jvm/instr.scm 505 */
obj_t BgL_carzd2329zd2_2116;obj_t BgL_cdrzd2330zd2_2117;
BgL_carzd2329zd2_2116 = 
CAR(BgL_cdrzd2317zd2_2111); 
BgL_cdrzd2330zd2_2117 = 
CDR(BgL_cdrzd2317zd2_2111); 
if(
PAIRP(BgL_carzd2329zd2_2116))
{ /* Jvm/instr.scm 505 */
obj_t BgL_cdrzd2334zd2_2119;
BgL_cdrzd2334zd2_2119 = 
CDR(BgL_carzd2329zd2_2116); 
{ /* Jvm/instr.scm 505 */
bool_t BgL_testz00_6393;
{ /* Jvm/instr.scm 505 */
obj_t BgL_auxz00_6396;obj_t BgL_auxz00_6394;
BgL_auxz00_6396 = 
CNST_TABLE_REF(((long)149)); 
BgL_auxz00_6394 = 
CAR(BgL_carzd2329zd2_2116); 
BgL_testz00_6393 = 
(BgL_auxz00_6394==BgL_auxz00_6396); } 
if(BgL_testz00_6393)
{ /* Jvm/instr.scm 505 */
if(
PAIRP(BgL_cdrzd2334zd2_2119))
{ /* Jvm/instr.scm 505 */
obj_t BgL_cdrzd2338zd2_2122;
BgL_cdrzd2338zd2_2122 = 
CDR(BgL_cdrzd2334zd2_2119); 
{ /* Jvm/instr.scm 505 */
obj_t BgL_fromz00_2123;
BgL_fromz00_2123 = 
CAR(BgL_cdrzd2334zd2_2119); 
if(
PAIRP(BgL_cdrzd2338zd2_2122))
{ /* Jvm/instr.scm 505 */
obj_t BgL_cdrzd2342zd2_2125;
BgL_cdrzd2342zd2_2125 = 
CDR(BgL_cdrzd2338zd2_2122); 
if(
PAIRP(BgL_cdrzd2342zd2_2125))
{ /* Jvm/instr.scm 505 */
obj_t BgL_cdrzd2345zd2_2127;
BgL_cdrzd2345zd2_2127 = 
CDR(BgL_cdrzd2342zd2_2125); 
if(
PAIRP(BgL_cdrzd2345zd2_2127))
{ /* Jvm/instr.scm 505 */
obj_t BgL_cdrzd2348zd2_2129;
BgL_cdrzd2348zd2_2129 = 
CDR(BgL_cdrzd2345zd2_2127); 
if(
PAIRP(BgL_cdrzd2348zd2_2129))
{ /* Jvm/instr.scm 505 */
bool_t BgL_testz00_6414;
{ /* Jvm/instr.scm 505 */
obj_t BgL_auxz00_6415;
BgL_auxz00_6415 = 
CAR(BgL_cdrzd2348zd2_2129); 
BgL_testz00_6414 = 
(BgL_xz00_2110==BgL_auxz00_6415); } 
if(BgL_testz00_6414)
{ /* Jvm/instr.scm 505 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2348zd2_2129), BNIL))
{ /* Jvm/instr.scm 505 */
if(
PAIRP(BgL_cdrzd2330zd2_2117))
{ /* Jvm/instr.scm 505 */
obj_t BgL_cdrzd2357zd2_2134;
BgL_cdrzd2357zd2_2134 = 
CDR(BgL_cdrzd2330zd2_2117); 
{ /* Jvm/instr.scm 505 */
bool_t BgL_testz00_6424;
{ /* Jvm/instr.scm 505 */
obj_t BgL_auxz00_6425;
BgL_auxz00_6425 = 
CAR(BgL_cdrzd2330zd2_2117); 
BgL_testz00_6424 = 
(BgL_fromz00_2123==BgL_auxz00_6425); } 
if(BgL_testz00_6424)
{ /* Jvm/instr.scm 505 */
if(
PAIRP(BgL_cdrzd2357zd2_2134))
{ /* Jvm/instr.scm 505 */
obj_t BgL_carzd2361zd2_2137;
BgL_carzd2361zd2_2137 = 
CAR(BgL_cdrzd2357zd2_2134); 
if(
PAIRP(BgL_carzd2361zd2_2137))
{ /* Jvm/instr.scm 505 */
obj_t BgL_cdrzd2365zd2_2139;
BgL_cdrzd2365zd2_2139 = 
CDR(BgL_carzd2361zd2_2137); 
{ /* Jvm/instr.scm 505 */
bool_t BgL_testz00_6434;
{ /* Jvm/instr.scm 505 */
obj_t BgL_auxz00_6437;obj_t BgL_auxz00_6435;
BgL_auxz00_6437 = 
CNST_TABLE_REF(((long)117)); 
BgL_auxz00_6435 = 
CAR(BgL_carzd2361zd2_2137); 
BgL_testz00_6434 = 
(BgL_auxz00_6435==BgL_auxz00_6437); } 
if(BgL_testz00_6434)
{ /* Jvm/instr.scm 505 */
if(
PAIRP(BgL_cdrzd2365zd2_2139))
{ /* Jvm/instr.scm 505 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2365zd2_2139), BNIL))
{ 
obj_t BgL_restz00_6449;obj_t BgL_tz00_6447;obj_t BgL_fromz00_6446;obj_t BgL_xz00_6445;
BgL_xz00_6445 = BgL_xz00_2110; 
BgL_fromz00_6446 = BgL_fromz00_2123; 
BgL_tz00_6447 = 
CAR(BgL_cdrzd2365zd2_2139); 
BgL_restz00_6449 = 
CDR(BgL_cdrzd2357zd2_2134); 
BgL_restz00_2025 = BgL_restz00_6449; 
BgL_tz00_2024 = BgL_tz00_6447; 
BgL_fromz00_2023 = BgL_fromz00_6446; 
BgL_xz00_2022 = BgL_xz00_6445; 
goto BgL_tagzd2118zd2_2026;}  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6451;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6451); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6453;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6453); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6455;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6455); } } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6457;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6457); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6459;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6459); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6461;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6461); } } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6463;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6463); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6465;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6465); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6467;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6467); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6469;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6469); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6471;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6471); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6473;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6473); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6475;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6475); } } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6477;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6477); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6479;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6479); } } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6481;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6481); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6483;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6483); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6485;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6485); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6487;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6487); } } } } } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6489;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6489); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6491;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6491); } } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6493;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6493); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6495;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6495); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6497;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6497); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6499;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6499); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6501;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6501); } } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6503;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6503); } }  else 
{ /* Jvm/instr.scm 505 */
bool_t BgL_auxz00_6505;
goto BgL_tagzd2119zd2_2027;
BBOOL(BgL_auxz00_6505); } } } 
{ 
obj_t BgL_l2986z00_2214;
BgL_l2986z00_2214 = 
bgl_reverse(BgL_targsz00_130); 
BgL_lname2987z00_2215:
if(
PAIRP(BgL_l2986z00_2214))
{ /* Jvm/instr.scm 525 */
BGl_cpopz00zzjvm_instrz00(BgL_envz00_128, 
BGl_simplezd2typezd2zzjvm_instrz00(
CAR(BgL_l2986z00_2214))); 
{ 
obj_t BgL_l2986z00_6512;
BgL_l2986z00_6512 = 
CDR(BgL_l2986z00_2214); 
BgL_l2986z00_2214 = BgL_l2986z00_6512; 
goto BgL_lname2987z00_2215;} }  else 
{ /* Jvm/instr.scm 525 */((bool_t)1); } } 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_128, 
BGl_simplezd2typezd2zzjvm_instrz00(BgL_trz00_131));} } 
}



/* __invokespecial_init */
obj_t BGl___invokespecial_initz00zzjvm_instrz00(obj_t BgL_envz00_4663, obj_t BgL_envz00_4664, obj_t BgL_varz00_4665, obj_t BgL_targsz00_4666, obj_t BgL_trz00_4667)
{ AN_OBJECT;
{ /* Jvm/instr.scm 490 */
return 
BGl__invokespecial_initz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4664), BgL_varz00_4665, BgL_targsz00_4666, BgL_trz00_4667);} 
}



/* _invokevirtual */
obj_t BGl__invokevirtualz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_136, obj_t BgL_varz00_137, obj_t BgL_targsz00_138, obj_t BgL_trz00_139)
{ AN_OBJECT;
{ /* Jvm/instr.scm 570 */
{ /* Jvm/instr.scm 571 */
obj_t BgL_arg4899z00_2452;
{ /* Jvm/instr.scm 571 */
obj_t BgL_arg4902z00_2453;obj_t BgL_arg4903z00_2454;
BgL_arg4902z00_2453 = 
CNST_TABLE_REF(((long)150)); 
BgL_arg4903z00_2454 = 
MAKE_PAIR(BgL_varz00_137, BNIL); 
BgL_arg4899z00_2452 = 
MAKE_PAIR(BgL_arg4902z00_2453, BgL_arg4903z00_2454); } 
{ /* Jvm/instr.scm 571 */
obj_t BgL_arg3076z00_3801;
{ /* Jvm/instr.scm 571 */
obj_t BgL_auxz00_6522;
BgL_auxz00_6522 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_136))->BgL_codez00); 
BgL_arg3076z00_3801 = 
MAKE_PAIR(BgL_arg4899z00_2452, BgL_auxz00_6522); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_136))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3801), BUNSPEC); } ((bool_t)1); } 
{ 
obj_t BgL_l2994z00_2455;
BgL_l2994z00_2455 = 
bgl_reverse(BgL_targsz00_138); 
BgL_lname2995z00_2456:
if(
PAIRP(BgL_l2994z00_2455))
{ /* Jvm/instr.scm 572 */
BGl_cpopz00zzjvm_instrz00(BgL_envz00_136, 
BGl_simplezd2typezd2zzjvm_instrz00(
CAR(BgL_l2994z00_2455))); 
{ 
obj_t BgL_l2994z00_6531;
BgL_l2994z00_6531 = 
CDR(BgL_l2994z00_2455); 
BgL_l2994z00_2455 = BgL_l2994z00_6531; 
goto BgL_lname2995z00_2456;} }  else 
{ /* Jvm/instr.scm 572 */((bool_t)1); } } 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_136, 
BGl_simplezd2typezd2zzjvm_instrz00(BgL_trz00_139));} 
}



/* __invokevirtual */
obj_t BGl___invokevirtualz00zzjvm_instrz00(obj_t BgL_envz00_4668, obj_t BgL_envz00_4669, obj_t BgL_varz00_4670, obj_t BgL_targsz00_4671, obj_t BgL_trz00_4672)
{ AN_OBJECT;
{ /* Jvm/instr.scm 570 */
return 
BGl__invokevirtualz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4669), BgL_varz00_4670, BgL_targsz00_4671, BgL_trz00_4672);} 
}



/* _invokeinterface */
obj_t BGl__invokeinterfacez00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_140, obj_t BgL_varz00_141, obj_t BgL_targsz00_142, obj_t BgL_trz00_143)
{ AN_OBJECT;
{ /* Jvm/instr.scm 577 */
{ /* Jvm/instr.scm 578 */
obj_t BgL_arg4927z00_2463;
{ /* Jvm/instr.scm 578 */
obj_t BgL_arg4930z00_2464;obj_t BgL_arg4931z00_2465;
BgL_arg4930z00_2464 = 
CNST_TABLE_REF(((long)151)); 
BgL_arg4931z00_2465 = 
MAKE_PAIR(BgL_varz00_141, BNIL); 
BgL_arg4927z00_2463 = 
MAKE_PAIR(BgL_arg4930z00_2464, BgL_arg4931z00_2465); } 
{ /* Jvm/instr.scm 578 */
obj_t BgL_arg3076z00_3812;
{ /* Jvm/instr.scm 578 */
obj_t BgL_auxz00_6541;
BgL_auxz00_6541 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_140))->BgL_codez00); 
BgL_arg3076z00_3812 = 
MAKE_PAIR(BgL_arg4927z00_2463, BgL_auxz00_6541); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_140))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3812), BUNSPEC); } ((bool_t)1); } 
{ 
obj_t BgL_l2996z00_2466;
BgL_l2996z00_2466 = 
bgl_reverse(BgL_targsz00_142); 
BgL_lname2997z00_2467:
if(
PAIRP(BgL_l2996z00_2466))
{ /* Jvm/instr.scm 579 */
BGl_cpopz00zzjvm_instrz00(BgL_envz00_140, 
BGl_simplezd2typezd2zzjvm_instrz00(
CAR(BgL_l2996z00_2466))); 
{ 
obj_t BgL_l2996z00_6550;
BgL_l2996z00_6550 = 
CDR(BgL_l2996z00_2466); 
BgL_l2996z00_2466 = BgL_l2996z00_6550; 
goto BgL_lname2997z00_2467;} }  else 
{ /* Jvm/instr.scm 579 */((bool_t)1); } } 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_140, 
BGl_simplezd2typezd2zzjvm_instrz00(BgL_trz00_143));} 
}



/* __invokeinterface */
obj_t BGl___invokeinterfacez00zzjvm_instrz00(obj_t BgL_envz00_4673, obj_t BgL_envz00_4674, obj_t BgL_varz00_4675, obj_t BgL_targsz00_4676, obj_t BgL_trz00_4677)
{ AN_OBJECT;
{ /* Jvm/instr.scm 577 */
return 
BGl__invokeinterfacez00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4674), BgL_varz00_4675, BgL_targsz00_4676, BgL_trz00_4677);} 
}



/* _return */
obj_t BGl__returnz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_144, obj_t BgL_typez00_145)
{ AN_OBJECT;
{ /* Jvm/instr.scm 584 */
{ /* Jvm/instr.scm 585 */
obj_t BgL_arg3076z00_3823;
{ /* Jvm/instr.scm 585 */
obj_t BgL_auxz00_6580;obj_t BgL_auxz00_6557;
BgL_auxz00_6580 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_144))->BgL_codez00); 
{ /* Jvm/instr.scm 586 */
bool_t BgL_testz00_6558;
{ /* Jvm/instr.scm 586 */
obj_t BgL_auxz00_6559;
BgL_auxz00_6559 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_typez00_145, 
CNST_TABLE_REF(((long)3))); 
BgL_testz00_6558 = 
CBOOL(BgL_auxz00_6559); } 
if(BgL_testz00_6558)
{ /* Jvm/instr.scm 586 */
BgL_auxz00_6557 = 
CNST_TABLE_REF(((long)152))
; }  else 
{ /* Jvm/instr.scm 586 */
bool_t BgL_testz00_6564;
{ /* Jvm/instr.scm 586 */
obj_t BgL_auxz00_6565;
BgL_auxz00_6565 = 
CNST_TABLE_REF(((long)5)); 
BgL_testz00_6564 = 
(BgL_typez00_145==BgL_auxz00_6565); } 
if(BgL_testz00_6564)
{ /* Jvm/instr.scm 586 */
BgL_auxz00_6557 = 
CNST_TABLE_REF(((long)153))
; }  else 
{ /* Jvm/instr.scm 586 */
bool_t BgL_testz00_6569;
{ /* Jvm/instr.scm 586 */
obj_t BgL_auxz00_6570;
BgL_auxz00_6570 = 
CNST_TABLE_REF(((long)6)); 
BgL_testz00_6569 = 
(BgL_typez00_145==BgL_auxz00_6570); } 
if(BgL_testz00_6569)
{ /* Jvm/instr.scm 586 */
BgL_auxz00_6557 = 
CNST_TABLE_REF(((long)154))
; }  else 
{ /* Jvm/instr.scm 586 */
bool_t BgL_testz00_6574;
{ /* Jvm/instr.scm 586 */
obj_t BgL_auxz00_6575;
BgL_auxz00_6575 = 
CNST_TABLE_REF(((long)7)); 
BgL_testz00_6574 = 
(BgL_typez00_145==BgL_auxz00_6575); } 
if(BgL_testz00_6574)
{ /* Jvm/instr.scm 586 */
BgL_auxz00_6557 = 
CNST_TABLE_REF(((long)155))
; }  else 
{ /* Jvm/instr.scm 586 */
BgL_auxz00_6557 = 
CNST_TABLE_REF(((long)156))
; } } } } } 
BgL_arg3076z00_3823 = 
MAKE_PAIR(BgL_auxz00_6557, BgL_auxz00_6580); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_144))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3823), BUNSPEC); } ((bool_t)1); 
return 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_144, 
BGl_simplezd2typezd2zzjvm_instrz00(BgL_typez00_145));} 
}



/* __return */
obj_t BGl___returnz00zzjvm_instrz00(obj_t BgL_envz00_4678, obj_t BgL_envz00_4679, obj_t BgL_typez00_4680)
{ AN_OBJECT;
{ /* Jvm/instr.scm 584 */
return 
BGl__returnz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4679), BgL_typez00_4680);} 
}



/* _athrow */
obj_t BGl__athrowz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_146)
{ AN_OBJECT;
{ /* Jvm/instr.scm 595 */
{ /* Jvm/instr.scm 596 */
obj_t BgL_arg3076z00_3831;
{ /* Jvm/instr.scm 596 */
obj_t BgL_auxz00_6590;obj_t BgL_auxz00_6588;
BgL_auxz00_6590 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_146))->BgL_codez00); 
BgL_auxz00_6588 = 
CNST_TABLE_REF(((long)157)); 
BgL_arg3076z00_3831 = 
MAKE_PAIR(BgL_auxz00_6588, BgL_auxz00_6590); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_146))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3831), BUNSPEC); } ((bool_t)1); 
BGl_cpopz00zzjvm_instrz00(BgL_envz00_146, 
CNST_TABLE_REF(((long)8))); 
return 
BGl_pushz00zzjvm_instrz00(BgL_envz00_146, 
CNST_TABLE_REF(((long)2)));} 
}



/* __athrow */
obj_t BGl___athrowz00zzjvm_instrz00(obj_t BgL_envz00_4681, obj_t BgL_envz00_4682)
{ AN_OBJECT;
{ /* Jvm/instr.scm 595 */
return 
BGl__athrowz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4682));} 
}



/* _handler */
obj_t BGl__handlerz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_147, obj_t BgL_bz00_148, obj_t BgL_ez00_149, obj_t BgL_pcz00_150, obj_t BgL_tagz00_151)
{ AN_OBJECT;
{ /* Jvm/instr.scm 600 */
{ /* Jvm/instr.scm 601 */
obj_t BgL_arg4972z00_3836;
{ /* Jvm/instr.scm 601 */
obj_t BgL_arg4975z00_3837;obj_t BgL_arg4976z00_3838;
BgL_arg4975z00_3837 = 
CNST_TABLE_REF(((long)158)); 
{ /* Jvm/instr.scm 601 */
obj_t BgL_arg4979z00_3839;
{ /* Jvm/instr.scm 601 */
obj_t BgL_arg4982z00_3840;
{ /* Jvm/instr.scm 601 */
obj_t BgL_arg4985z00_3841;
BgL_arg4985z00_3841 = 
MAKE_PAIR(BgL_tagz00_151, BNIL); 
BgL_arg4982z00_3840 = 
MAKE_PAIR(BgL_pcz00_150, BgL_arg4985z00_3841); } 
BgL_arg4979z00_3839 = 
MAKE_PAIR(BgL_ez00_149, BgL_arg4982z00_3840); } 
BgL_arg4976z00_3838 = 
MAKE_PAIR(BgL_bz00_148, BgL_arg4979z00_3839); } 
BgL_arg4972z00_3836 = 
MAKE_PAIR(BgL_arg4975z00_3837, BgL_arg4976z00_3838); } 
{ /* Jvm/instr.scm 601 */
obj_t BgL_arg3076z00_3845;
{ /* Jvm/instr.scm 601 */
obj_t BgL_auxz00_6606;
BgL_auxz00_6606 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_147))->BgL_codez00); 
BgL_arg3076z00_3845 = 
MAKE_PAIR(BgL_arg4972z00_3836, BgL_auxz00_6606); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_147))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3845), BUNSPEC); } 
return BTRUE;} } 
}



/* __handler */
obj_t BGl___handlerz00zzjvm_instrz00(obj_t BgL_envz00_4683, obj_t BgL_envz00_4684, obj_t BgL_bz00_4685, obj_t BgL_ez00_4686, obj_t BgL_pcz00_4687, obj_t BgL_tagz00_4688)
{ AN_OBJECT;
{ /* Jvm/instr.scm 600 */
return 
BGl__handlerz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4684), BgL_bz00_4685, BgL_ez00_4686, BgL_pcz00_4687, BgL_tagz00_4688);} 
}



/* _comment */
obj_t BGl__commentz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_152, obj_t BgL_namez00_153, obj_t BgL_vz00_154)
{ AN_OBJECT;
{ /* Jvm/instr.scm 604 */
{ /* Jvm/instr.scm 605 */
obj_t BgL_arg4989z00_3850;
{ /* Jvm/instr.scm 605 */
obj_t BgL_arg4992z00_3851;obj_t BgL_arg4993z00_3852;
BgL_arg4992z00_3851 = 
CNST_TABLE_REF(((long)159)); 
{ /* Jvm/instr.scm 605 */
obj_t BgL_arg4996z00_3853;
BgL_arg4996z00_3853 = 
MAKE_PAIR(BgL_vz00_154, BNIL); 
BgL_arg4993z00_3852 = 
MAKE_PAIR(BgL_namez00_153, BgL_arg4996z00_3853); } 
BgL_arg4989z00_3850 = 
MAKE_PAIR(BgL_arg4992z00_3851, BgL_arg4993z00_3852); } 
{ /* Jvm/instr.scm 605 */
obj_t BgL_arg3076z00_3857;
{ /* Jvm/instr.scm 605 */
obj_t BgL_auxz00_6616;
BgL_auxz00_6616 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_152))->BgL_codez00); 
BgL_arg3076z00_3857 = 
MAKE_PAIR(BgL_arg4989z00_3850, BgL_auxz00_6616); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_152))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3857), BUNSPEC); } 
return BTRUE;} } 
}



/* __comment */
obj_t BGl___commentz00zzjvm_instrz00(obj_t BgL_envz00_4689, obj_t BgL_envz00_4690, obj_t BgL_namez00_4691, obj_t BgL_vz00_4692)
{ AN_OBJECT;
{ /* Jvm/instr.scm 604 */
return 
BGl__commentz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4690), BgL_namez00_4691, BgL_vz00_4692);} 
}



/* _line */
obj_t BGl__linez00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_155, obj_t BgL_nz00_156)
{ AN_OBJECT;
{ /* Jvm/instr.scm 608 */
{ /* Jvm/instr.scm 609 */
bool_t BgL_test4999z00_2491;
{ /* Jvm/instr.scm 609 */
long BgL_n1z00_3862;long BgL_n2z00_3863;
BgL_n1z00_3862 = 
(long)CINT(BgL_nz00_156); 
BgL_n2z00_3863 = 
(long)CINT(BGl_za2lastzd2lineza2zd2zzjvm_instrz00); 
BgL_test4999z00_2491 = 
(BgL_n1z00_3862==BgL_n2z00_3863); } 
if(BgL_test4999z00_2491)
{ /* Jvm/instr.scm 609 */
return 
CNST_TABLE_REF(((long)35));}  else 
{ /* Jvm/instr.scm 609 */
{ /* Jvm/instr.scm 611 */
obj_t BgL_arg5001z00_2492;
{ /* Jvm/instr.scm 611 */
obj_t BgL_arg5004z00_2493;obj_t BgL_arg5005z00_2494;
BgL_arg5004z00_2493 = 
CNST_TABLE_REF(((long)160)); 
BgL_arg5005z00_2494 = 
MAKE_PAIR(BgL_nz00_156, BNIL); 
BgL_arg5001z00_2492 = 
MAKE_PAIR(BgL_arg5004z00_2493, BgL_arg5005z00_2494); } 
{ /* Jvm/instr.scm 611 */
obj_t BgL_arg3076z00_3867;
{ /* Jvm/instr.scm 611 */
obj_t BgL_auxz00_6630;
BgL_auxz00_6630 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_155))->BgL_codez00); 
BgL_arg3076z00_3867 = 
MAKE_PAIR(BgL_arg5001z00_2492, BgL_auxz00_6630); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_155))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3867), BUNSPEC); } ((bool_t)1); } 
return ( 
BGl_za2lastzd2lineza2zd2zzjvm_instrz00 = BgL_nz00_156, BUNSPEC) ;} } } 
}



/* __line */
obj_t BGl___linez00zzjvm_instrz00(obj_t BgL_envz00_4693, obj_t BgL_envz00_4694, obj_t BgL_nz00_4695)
{ AN_OBJECT;
{ /* Jvm/instr.scm 608 */
return 
BGl__linez00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4694), BgL_nz00_4695);} 
}



/* _localvar */
obj_t BGl__localvarz00zzjvm_instrz00(BgL_envz00_bglt BgL_envz00_157, obj_t BgL_fromz00_158, obj_t BgL_toz00_159, obj_t BgL_unamez00_160, obj_t BgL_typez00_161, obj_t BgL_namez00_162)
{ AN_OBJECT;
{ /* Jvm/instr.scm 614 */
{ /* Jvm/instr.scm 615 */
obj_t BgL_arg5010z00_3873;
{ /* Jvm/instr.scm 615 */
obj_t BgL_arg5013z00_3874;obj_t BgL_arg5014z00_3875;
BgL_arg5013z00_3874 = 
CNST_TABLE_REF(((long)149)); 
{ /* Jvm/instr.scm 615 */
obj_t BgL_arg5017z00_3876;
{ /* Jvm/instr.scm 615 */
obj_t BgL_arg5020z00_3877;
{ /* Jvm/instr.scm 615 */
obj_t BgL_arg5023z00_3878;
{ /* Jvm/instr.scm 615 */
obj_t BgL_arg5026z00_3879;
{ /* Jvm/instr.scm 615 */
obj_t BgL_auxz00_6637;
{ /* Jvm/instr.scm 615 */
obj_t BgL_slotz00_3883;
BgL_slotz00_3883 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_namez00_162, 
(((BgL_envz00_bglt)CREF(BgL_envz00_157))->BgL_maplocalsz00)); 
if(
CBOOL(BgL_slotz00_3883))
{ /* Jvm/instr.scm 615 */
BgL_auxz00_6637 = 
CDR(BgL_slotz00_3883)
; }  else 
{ /* Jvm/instr.scm 615 */
BgL_auxz00_6637 = BgL_namez00_162
; } } 
BgL_arg5026z00_3879 = 
MAKE_PAIR(BgL_auxz00_6637, BNIL); } 
BgL_arg5023z00_3878 = 
MAKE_PAIR(BgL_typez00_161, BgL_arg5026z00_3879); } 
BgL_arg5020z00_3877 = 
MAKE_PAIR(BgL_unamez00_160, BgL_arg5023z00_3878); } 
BgL_arg5017z00_3876 = 
MAKE_PAIR(BgL_toz00_159, BgL_arg5020z00_3877); } 
BgL_arg5014z00_3875 = 
MAKE_PAIR(BgL_fromz00_158, BgL_arg5017z00_3876); } 
BgL_arg5010z00_3873 = 
MAKE_PAIR(BgL_arg5013z00_3874, BgL_arg5014z00_3875); } 
{ /* Jvm/instr.scm 615 */
obj_t BgL_arg3076z00_3890;
{ /* Jvm/instr.scm 615 */
obj_t BgL_auxz00_6649;
BgL_auxz00_6649 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_157))->BgL_codez00); 
BgL_arg3076z00_3890 = 
MAKE_PAIR(BgL_arg5010z00_3873, BgL_auxz00_6649); } 
((((BgL_envz00_bglt)CREF(BgL_envz00_157))->BgL_codez00) = ((obj_t)BgL_arg3076z00_3890), BUNSPEC); } 
return BTRUE;} } 
}



/* __localvar */
obj_t BGl___localvarz00zzjvm_instrz00(obj_t BgL_envz00_4696, obj_t BgL_envz00_4697, obj_t BgL_fromz00_4698, obj_t BgL_toz00_4699, obj_t BgL_unamez00_4700, obj_t BgL_typez00_4701, obj_t BgL_namez00_4702)
{ AN_OBJECT;
{ /* Jvm/instr.scm 614 */
return 
BGl__localvarz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_4697), BgL_fromz00_4698, BgL_toz00_4699, BgL_unamez00_4700, BgL_typez00_4701, BgL_namez00_4702);} 
}



/* create-string */
obj_t BGl_createzd2stringzd2zzjvm_instrz00(obj_t BgL_envz00_163, obj_t BgL_strz00_164)
{ AN_OBJECT;
{ /* Jvm/instr.scm 618 */
{ /* Jvm/instr.scm 619 */
obj_t BgL_auxz00_6655;
{ /* Jvm/instr.scm 619 */
int BgL_auxz00_6656;
BgL_auxz00_6656 = 
STRING_LENGTH(BgL_strz00_164); 
BgL_auxz00_6655 = 
BINT(BgL_auxz00_6656); } 
BGl_splitzd2stringzd2zzjvm_instrz00(BgL_envz00_163, BgL_strz00_164, ((long)0), BgL_auxz00_6655); } 
{ /* Jvm/instr.scm 620 */
obj_t BgL_arg5036z00_2505;obj_t BgL_arg5037z00_2506;obj_t BgL_arg5038z00_2507;
BgL_arg5036z00_2505 = 
BGl_jlibzd2declarezd2zzjvm_envz00(
(BgL_envz00_bglt)(BgL_envz00_163), 
CNST_TABLE_REF(((long)161))); 
BgL_arg5037z00_2506 = 
CNST_TABLE_REF(((long)162)); 
BgL_arg5038z00_2507 = 
CNST_TABLE_REF(((long)8)); 
return 
BGl__invokevirtualz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_163), BgL_arg5036z00_2505, BgL_arg5037z00_2506, BgL_arg5038z00_2507);} } 
}



/* _create-string */
obj_t BGl__createzd2stringzd2zzjvm_instrz00(obj_t BgL_envz00_4703, obj_t BgL_envz00_4704, obj_t BgL_strz00_4705)
{ AN_OBJECT;
{ /* Jvm/instr.scm 618 */
return 
BGl_createzd2stringzd2zzjvm_instrz00(BgL_envz00_4704, BgL_strz00_4705);} 
}



/* split-string */
obj_t BGl_splitzd2stringzd2zzjvm_instrz00(obj_t BgL_envz00_165, obj_t BgL_strz00_166, long BgL_iz00_167, obj_t BgL_nz00_168)
{ AN_OBJECT;
{ /* Jvm/instr.scm 622 */
if(
BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_nz00_168, 
BINT(((long)65536))))
{ /* Jvm/instr.scm 624 */
obj_t BgL_arg5043z00_2509;obj_t BgL_arg5044z00_2510;
BgL_arg5043z00_2509 = 
CNST_TABLE_REF(((long)30)); 
if(
BGl_zd3fxzd3zz__r4_numbers_6_5_fixnumz00(BgL_iz00_167, ((long)0)))
{ /* Jvm/instr.scm 624 */
BgL_arg5044z00_2510 = BgL_strz00_166; }  else 
{ /* Jvm/instr.scm 624 */
int BgL_auxz00_6676;int BgL_auxz00_6674;
{ /* Jvm/instr.scm 624 */
obj_t BgL_auxz00_6677;
BgL_auxz00_6677 = 
BGl_2zb2zb2zz__r4_numbers_6_5z00(
BINT(BgL_iz00_167), BgL_nz00_168); 
BgL_auxz00_6676 = 
CINT(BgL_auxz00_6677); } 
BgL_auxz00_6674 = 
(int)(BgL_iz00_167); 
BgL_arg5044z00_2510 = 
c_substring(BgL_strz00_166, BgL_auxz00_6674, BgL_auxz00_6676); } 
return 
BGl__pushz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_165), BgL_arg5043z00_2509, BgL_arg5044z00_2510);}  else 
{ /* Jvm/instr.scm 623 */
{ /* Jvm/instr.scm 626 */
obj_t BgL_arg5053z00_2513;obj_t BgL_arg5054z00_2514;
BgL_arg5053z00_2513 = 
CNST_TABLE_REF(((long)30)); 
{ /* Jvm/instr.scm 626 */
int BgL_auxz00_6687;int BgL_auxz00_6685;
{ /* Jvm/instr.scm 626 */
long BgL_auxz00_6688;
BgL_auxz00_6688 = 
BGl_zb2fxzb2zz__r4_numbers_6_5_fixnumz00(BgL_iz00_167, ((long)65535)); 
BgL_auxz00_6687 = 
(int)(BgL_auxz00_6688); } 
BgL_auxz00_6685 = 
(int)(BgL_iz00_167); 
BgL_arg5054z00_2514 = 
c_substring(BgL_strz00_166, BgL_auxz00_6685, BgL_auxz00_6687); } 
BGl__pushz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_165), BgL_arg5053z00_2513, BgL_arg5054z00_2514); } 
BGl_splitzd2stringzd2zzjvm_instrz00(BgL_envz00_165, BgL_strz00_166, 
BGl_zb2fxzb2zz__r4_numbers_6_5_fixnumz00(BgL_iz00_167, ((long)65535)), 
BGl_2zd2zd2zz__r4_numbers_6_5z00(BgL_nz00_168, 
BINT(((long)65535)))); 
{ /* Jvm/instr.scm 628 */
obj_t BgL_arg5067z00_2518;obj_t BgL_arg5068z00_2519;obj_t BgL_arg5069z00_2520;
BgL_arg5067z00_2518 = 
BGl_jlibzd2declarezd2zzjvm_envz00(
(BgL_envz00_bglt)(BgL_envz00_165), 
CNST_TABLE_REF(((long)163))); 
BgL_arg5068z00_2519 = 
CNST_TABLE_REF(((long)164)); 
BgL_arg5069z00_2520 = 
CNST_TABLE_REF(((long)8)); 
return 
BGl__invokevirtualz00zzjvm_instrz00(
(BgL_envz00_bglt)(BgL_envz00_165), BgL_arg5067z00_2518, BgL_arg5068z00_2519, BgL_arg5069z00_2520);} } } 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzjvm_instrz00()
{ AN_OBJECT;
{ /* Jvm/instr.scm 2 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzjvm_instrz00()
{ AN_OBJECT;
{ /* Jvm/instr.scm 2 */
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19010), "jvm_instr"); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)28259), "jvm_instr"); 
BGl_modulezd2initializa7ationz75zzast_nodez00(((long)49436), "jvm_instr"); 
BGl_modulezd2initializa7ationz75zzobject_classz00(((long)19348), "jvm_instr"); 
return 
BGl_modulezd2initializa7ationz75zzjvm_envz00(((long)47084), "jvm_instr");} 
}

