/*===========================================================================*/
/*   (Jvm/jld.scm)                                                           */
/*   Bigloo (2.5b)                                                           */
/*   Manuel Serrano (c)       Fri Sep 6 09:43:28 CEST 2002                   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_ccompz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_producerz00;
   obj_t BgL_consumerz00;
   obj_t BgL_finaliza7erza7;
} *BgL_ccompz00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;


extern obj_t BGl_modulezd2initializa7ationz75zzjvm_ldz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_configurez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_linkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzread_readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_externz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
extern obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
extern obj_t BGl_withzd2outputzd2tozd2filezd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zzjvm_ldz00();
extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
extern obj_t BGl_findzd2filezf2pathz20zz__osz00(obj_t, obj_t);
static obj_t BGl_jvmzd2classpathzd2zzjvm_ldz00();
extern obj_t BGl_withzd2inputzd2fromzd2filezd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
static obj_t BGl_loop_3241z00zzjvm_ldz00(obj_t, obj_t);
extern obj_t BGl_za2jvmzd2envza2zd2zzengine_paramz00;
extern obj_t open_input_string(obj_t);
extern bool_t BGl_chmodz00zz__osz00(obj_t, obj_t);
extern obj_t BGl_za2jvmzd2javaza2zd2zzengine_paramz00;
extern obj_t BGl_za2srczd2filesza2zd2zzengine_paramz00;
extern obj_t BGl_za2libzd2dirza2zd2zzengine_paramz00;
extern obj_t string_to_symbol(char *);
extern obj_t BGl_makezd2filezd2namez00zz__osz00(obj_t, obj_t);
extern obj_t BGl_dynamiczd2windzd2zz__r4_control_features_6_9z00(obj_t, obj_t, obj_t);
static obj_t BGl_zc3anonymousza31787ze3z83zzjvm_ldz00(obj_t);
extern obj_t bgl_reverse(obj_t);
extern obj_t BGl_findzd2srczd2filez00zzengine_linkz00(obj_t, obj_t);
extern obj_t BGl_readz00zz__readerz00(obj_t);
static obj_t BGl_zc3anonymousza31789ze3z83zzjvm_ldz00(obj_t);
extern obj_t BGl_za2unsafezd2libraryza2zd2zzengine_paramz00;
extern bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
extern obj_t BGl_za2ozd2filesza2zd2zzengine_paramz00;
extern obj_t string_append(obj_t, obj_t);
static obj_t BGl_listzd2ze3pathzd2stringze3zzjvm_ldz00(obj_t, char *);
static obj_t BGl_zc3anonymousza31802ze3z83zzjvm_ldz00(obj_t);
static obj_t BGl_objectszd2ze3classesz31zzjvm_ldz00(obj_t);
static obj_t BGl_zc3anonymousza32668ze3z83zzjvm_ldz00(obj_t);
extern obj_t BGl_za2jvmzd2jarpathza2zd2zzengine_paramz00;
static obj_t BGl_libraryzd2ze3za7ipz96zzjvm_ldz00(obj_t);
static obj_t BGl_generatezd2jvmzd2manifestz00zzjvm_ldz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_zc3anonymousza31943ze3z83zzjvm_ldz00(obj_t);
extern obj_t BGl_filterz00zz__r4_control_features_6_9z00(obj_t, obj_t);
static bool_t BGl_generatezd2jvmzd2shzd2scriptzd2zzjvm_ldz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
static obj_t BGl_zc3anonymousza32818ze3z83zzjvm_ldz00(obj_t);
extern bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
extern obj_t BGl_za2jvmzd2jarzf3za2z21zzengine_paramz00;
extern obj_t string_to_bstring(char *);
static obj_t BGl_makezd2manifestzd2namez00zzjvm_ldz00();
static obj_t BGl_zc3anonymousza31799ze3z83zzjvm_ldz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_za2mainza2z00zzmodule_modulez00;
static obj_t BGl_jvmzd2jarzd2zzjvm_ldz00(obj_t, obj_t, obj_t);
static obj_t BGl_stringzd2replacez12zc0zzjvm_ldz00(obj_t, unsigned char, unsigned char);
static obj_t BGl_findzd2jvmzd2mainz00zzjvm_ldz00(obj_t);
extern obj_t BGl_globalz00zzast_varz00;
static obj_t BGl_escape_3223z00zzjvm_ldz00(obj_t, obj_t);
extern obj_t BGl_za2destza2z00zzengine_paramz00;
static obj_t BGl_zc3anonymousza31952ze3z83zzjvm_ldz00(obj_t);
static obj_t BGl_escapez00zzjvm_ldz00(obj_t, obj_t);
static obj_t BGl_zc3anonymousza31954ze3z83zzjvm_ldz00(obj_t);
extern obj_t BGl_za2bigloozd2nameza2zd2zzengine_paramz00;
static obj_t BGl_userzd2libraryzd2zzjvm_ldz00(obj_t);
static obj_t BGl_loopz00zzjvm_ldz00(obj_t, obj_t);
extern obj_t BGl_jvmzd2ldzd2zzjvm_ldz00();
static obj_t BGl_zc3anonymousza31820ze3z83zzjvm_ldz00(obj_t);
static obj_t BGl_generatezd2shzd2jvmzd2manifestzd2zzjvm_ldz00(obj_t, obj_t, obj_t);
extern obj_t BGl_removezd2errorzd2handlerz12z12zz__errorz00();
extern obj_t BGl_za2jvmzd2shellza2zd2zzengine_paramz00;
static obj_t BGl_generatezd2msdoszd2jvmzd2manifestzd2zzjvm_ldz00(obj_t, obj_t, obj_t);
extern obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_zc3anonymousza31960ze3z83zzjvm_ldz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_generatezd2jvmzd2env_3240z00zzjvm_ldz00();
extern obj_t BGl_systemz00zz__osz00(obj_t);
static obj_t BGl_handling_function2137z00zzjvm_ldz00(obj_t, obj_t);
extern obj_t BGl_za2jvmzd2purifyza2zd2zzengine_paramz00;
static obj_t BGl_cnstzd2initzd2zzjvm_ldz00();
extern obj_t BGl_za2jvmzd2classpathza2zd2zzengine_paramz00;
extern obj_t BGl_basenamez00zz__osz00(obj_t);
static obj_t BGl_zc3anonymousza31963ze3z83zzjvm_ldz00(obj_t);
extern bool_t bigloo_strcmp(obj_t, obj_t);
extern obj_t BGl_dirnamez00zz__osz00(obj_t);
extern bool_t fexists(char *);
extern obj_t c_substring(obj_t, int, int);
extern obj_t BGl_jvmzd2classzd2manglez00zzjvm_externz00(obj_t, obj_t);
static obj_t BGl_zc3anonymousza32349ze3z83zzjvm_ldz00(obj_t);
extern obj_t BGl_suffixz00zz__osz00(obj_t);
extern obj_t bgl_append2(obj_t, obj_t);
extern obj_t BGl_displayzd22zd2zz__r4_output_6_10_3z00(obj_t, obj_t);
static obj_t BGl__jvmzd2ldzd2zzjvm_ldz00(obj_t);
static bool_t BGl_generatezd2jvmzd2scriptz00zzjvm_ldz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_handling_function1944z00zzjvm_ldz00(obj_t, obj_t, obj_t);
extern obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zzjvm_ldz00();
extern obj_t BGl_warningz00zz__errorz00(obj_t);
static obj_t BGl_findzd2pathzd2zzjvm_ldz00(obj_t);
extern obj_t BGl_za2additionalzd2bigloozd2librariesza2z00zzengine_paramz00;
static obj_t BGl_zc3anonymousza31689ze3z83zzjvm_ldz00(obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zzjvm_ldz00 = BUNSPEC;
static obj_t BGl_generatezd2jvmzd2envz00zzjvm_ldz00();
extern obj_t BGl_appendz00zz__r4_pairs_and_lists_6_3z00(obj_t);
static obj_t BGl_zc3anonymousza32222ze3z83zzjvm_ldz00(obj_t);
extern obj_t BGl_prefixz00zz__osz00(obj_t);
extern obj_t BGl_za2additionalzd2bigloozd2za7ipsza2za7zzengine_paramz00;
extern obj_t BGl_valzd2fromzd2exitzf3zf3zz__bexitz00(obj_t);
extern obj_t BGl_compilerzd2readzd2zzread_readerz00(obj_t);
extern obj_t BGl_exitz00zz__errorz00(obj_t);
extern obj_t BGl_notifyzd2errorzd2zz__errorz00(obj_t, obj_t, obj_t);
extern obj_t BGl_za2jvmzd2optionsza2zd2zzengine_paramz00;
static obj_t BGl_libraryzd2moduleszd2initz00zzjvm_ldz00();
extern obj_t BGl_addzd2errorzd2handlerz12z12zz__errorz00(obj_t, obj_t);
extern obj_t BGl_memberz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_zc3anonymousza32303ze3z83zzjvm_ldz00(obj_t);
static obj_t BGl_zc3anonymousza32514ze3z83zzjvm_ldz00(obj_t);
static bool_t BGl_generatezd2jvmzd2msdoszd2scriptzd2zzjvm_ldz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t string_append_3(obj_t, obj_t, obj_t);
extern obj_t BGl_unprofzd2srczd2namez00zzengine_linkz00(obj_t);
static obj_t BGl_handling_function1779z00zzjvm_ldz00(obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[ 11 ] ;

DEFINE_STRING( BGl_string3561z00zzjvm_ldz00, BgL_bgl_string3561za700za7za7jvm_ldza7003595z00, "execute write read static export wide-class final-class abstract-class class main module ", 89 );
DEFINE_STRING( BGl_string3560z00zzjvm_ldz00, BgL_bgl_string3560za700za7za7jvm_ldza7003596z00, "generate-jvm-script", 19 );
DEFINE_STRING( BGl_string3559z00zzjvm_ldz00, BgL_bgl_string3559za700za7za7jvm_ldza7003597z00, " %*", 3 );
DEFINE_STRING( BGl_string3558z00zzjvm_ldz00, BgL_bgl_string3558za700za7za7jvm_ldza7003598z00, " -cp %BIGLOO_CLASSPATH% ", 24 );
DEFINE_STRING( BGl_string3557z00zzjvm_ldz00, BgL_bgl_string3557za700za7za7jvm_ldza7003599z00, " %BIGLOOJAVAOPT% ", 17 );
DEFINE_STRING( BGl_string3556z00zzjvm_ldz00, BgL_bgl_string3556za700za7za7jvm_ldza7003600z00, "\\", 1 );
DEFINE_STRING( BGl_string3555z00zzjvm_ldz00, BgL_bgl_string3555za700za7za7jvm_ldza7003601z00, "set BIGLOO_CLASSPATH=", 21 );
DEFINE_STRING( BGl_string3554z00zzjvm_ldz00, BgL_bgl_string3554za700za7za7jvm_ldza7003602z00, "@echo off", 9 );
DEFINE_STRING( BGl_string3553z00zzjvm_ldz00, BgL_bgl_string3553za700za7za7jvm_ldza7003603z00, " $*", 3 );
DEFINE_STRING( BGl_string3552z00zzjvm_ldz00, BgL_bgl_string3552za700za7za7jvm_ldza7003604z00, ".", 1 );
DEFINE_STRING( BGl_string3551z00zzjvm_ldz00, BgL_bgl_string3551za700za7za7jvm_ldza7003605z00, "$BIGLOOCLASSPATH:$BUGLOOCLASSPATH", 33 );
DEFINE_STRING( BGl_string3550z00zzjvm_ldz00, BgL_bgl_string3550za700za7za7jvm_ldza7003606z00, "CLASSPATH=", 10 );
DEFINE_STRING( BGl_string3549z00zzjvm_ldz00, BgL_bgl_string3549za700za7za7jvm_ldza7003607z00, ".jar $*", 7 );
DEFINE_STRING( BGl_string3548z00zzjvm_ldz00, BgL_bgl_string3548za700za7za7jvm_ldza7003608z00, " $0`", 4 );
DEFINE_STRING( BGl_string3547z00zzjvm_ldz00, BgL_bgl_string3547za700za7za7jvm_ldza7003609z00, "`", 1 );
DEFINE_STRING( BGl_string3546z00zzjvm_ldz00, BgL_bgl_string3546za700za7za7jvm_ldza7003610z00, " -jar ", 6 );
DEFINE_STRING( BGl_string3545z00zzjvm_ldz00, BgL_bgl_string3545za700za7za7jvm_ldza7003611z00, " $BIGLOOJAVAOPT $BUGLOOJAVAOPT ", 31 );
DEFINE_STRING( BGl_string3544z00zzjvm_ldz00, BgL_bgl_string3544za700za7za7jvm_ldza7003612z00, "export CLASSPATH", 16 );
DEFINE_STRING( BGl_string3543z00zzjvm_ldz00, BgL_bgl_string3543za700za7za7jvm_ldza7003613z00, "CLASSPATH=.:$BUGLOOCLASSPATH", 28 );
DEFINE_STRING( BGl_string3542z00zzjvm_ldz00, BgL_bgl_string3542za700za7za7jvm_ldza7003614z00, "#!/bin/sh", 9 );
DEFINE_STRING( BGl_string3541z00zzjvm_ldz00, BgL_bgl_string3541za700za7za7jvm_ldza7003615z00, "-Dbigloo.", 9 );
DEFINE_STRING( BGl_string3540z00zzjvm_ldz00, BgL_bgl_string3540za700za7za7jvm_ldza7003616z00, "=$", 2 );
DEFINE_STRING( BGl_string3539z00zzjvm_ldz00, BgL_bgl_string3539za700za7za7jvm_ldza7003617z00, "Created-By: ", 12 );
DEFINE_STRING( BGl_string3538z00zzjvm_ldz00, BgL_bgl_string3538za700za7za7jvm_ldza7003618z00, "Class-Path: . ", 14 );
DEFINE_STRING( BGl_string3537z00zzjvm_ldz00, BgL_bgl_string3537za700za7za7jvm_ldza7003619z00, "Main-Class: ", 12 );
DEFINE_STRING( BGl_string3536z00zzjvm_ldz00, BgL_bgl_string3536za700za7za7jvm_ldza7003620z00, "Manifest-Version: 1.0", 21 );
DEFINE_STRING( BGl_string3535z00zzjvm_ldz00, BgL_bgl_string3535za700za7za7jvm_ldza7003621z00, "generate-jvm-manifest", 21 );
DEFINE_STRING( BGl_string3534z00zzjvm_ldz00, BgL_bgl_string3534za700za7za7jvm_ldza7003622z00, "Illegal shell `", 15 );
DEFINE_STRING( BGl_string3533z00zzjvm_ldz00, BgL_bgl_string3533za700za7za7jvm_ldza7003623z00, "' -- using `sh'", 15 );
DEFINE_STRING( BGl_string3532z00zzjvm_ldz00, BgL_bgl_string3532za700za7za7jvm_ldza7003624z00, "msdos", 5 );
DEFINE_STRING( BGl_string3531z00zzjvm_ldz00, BgL_bgl_string3531za700za7za7jvm_ldza7003625z00, "sh", 2 );
DEFINE_STRING( BGl_string3530z00zzjvm_ldz00, BgL_bgl_string3530za700za7za7jvm_ldza7003626z00, "Manifest", 8 );
DEFINE_STRING( BGl_string3529z00zzjvm_ldz00, BgL_bgl_string3529za700za7za7jvm_ldza7003627z00, "X", 1 );
DEFINE_STRING( BGl_string3528z00zzjvm_ldz00, BgL_bgl_string3528za700za7za7jvm_ldza7003628z00, "Can't create jar file", 21 );
DEFINE_STRING( BGl_string3527z00zzjvm_ldz00, BgL_bgl_string3527za700za7za7jvm_ldza7003629z00, "      [", 7 );
DEFINE_STRING( BGl_string3526z00zzjvm_ldz00, BgL_bgl_string3526za700za7za7jvm_ldza7003630z00, "]\n", 2 );
DEFINE_STRING( BGl_string3525z00zzjvm_ldz00, BgL_bgl_string3525za700za7za7jvm_ldza7003631z00, " ", 1 );
DEFINE_STRING( BGl_string3524z00zzjvm_ldz00, BgL_bgl_string3524za700za7za7jvm_ldza7003632z00, "mco", 3 );
DEFINE_STRING( BGl_string3523z00zzjvm_ldz00, BgL_bgl_string3523za700za7za7jvm_ldza7003633z00, "Can't find Main JVM class", 25 );
DEFINE_STRING( BGl_string3522z00zzjvm_ldz00, BgL_bgl_string3522za700za7za7jvm_ldza7003634z00, "No main clause found", 20 );
DEFINE_STRING( BGl_string3521z00zzjvm_ldz00, BgL_bgl_string3521za700za7za7jvm_ldza7003635z00, "jar", 3 );
DEFINE_STRING( BGl_string3520z00zzjvm_ldz00, BgL_bgl_string3520za700za7za7jvm_ldza7003636z00, "", 0 );
DEFINE_STRING( BGl_string3519z00zzjvm_ldz00, BgL_bgl_string3519za700za7za7jvm_ldza7003637z00, "ld:", 3 );
DEFINE_STRING( BGl_string3518z00zzjvm_ldz00, BgL_bgl_string3518za700za7za7jvm_ldza7003638z00, "Can't find zip file for library -- ", 35 );
DEFINE_STRING( BGl_string3517z00zzjvm_ldz00, BgL_bgl_string3517za700za7za7jvm_ldza7003639z00, ".zip", 4 );
DEFINE_STRING( BGl_string3516z00zzjvm_ldz00, BgL_bgl_string3516za700za7za7jvm_ldza7003640z00, ".class", 6 );
DEFINE_STRING( BGl_string3515z00zzjvm_ldz00, BgL_bgl_string3515za700za7za7jvm_ldza7003641z00, " (", 2 );
DEFINE_STRING( BGl_string3514z00zzjvm_ldz00, BgL_bgl_string3514za700za7za7jvm_ldza7003642z00, ")", 1 );
DEFINE_STRING( BGl_string3513z00zzjvm_ldz00, BgL_bgl_string3513za700za7za7jvm_ldza7003643z00, "   . ld", 7 );
DEFINE_STRING( BGl_string3511z00zzjvm_ldz00, BgL_bgl_string3511za700za7za7jvm_ldza7003644z00, ".jar", 4 );
DEFINE_STATIC_PROCEDURE( BGl_proc3512z00zzjvm_ldz00, BgL_bgl_za7c3anonymousza7a31689za7e3za783za7za7jvm_ldza7003645za7, BGl_zc3anonymousza31689ze3z83zzjvm_ldz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl_jvmzd2ldzd2envz00zzjvm_ldz00, BgL_bgl__jvmza7d2ldza7d2za7za7jvm_ldza7003646za7, BGl__jvmzd2ldzd2zzjvm_ldz00, 0L, 0 );



/* module-initialization */
obj_t BGl_modulezd2initializa7ationz75zzjvm_ldz00(long BgL_checksumz00_1845, char * BgL_fromz00_1846)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzjvm_ldz00))
{ 
BGl_requirezd2initializa7ationz75zzjvm_ldz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzjvm_ldz00(); 
BGl_cnstzd2initzd2zzjvm_ldz00(); 
BGl_importedzd2moduleszd2initz00zzjvm_ldz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzjvm_ldz00()
{ AN_OBJECT;
{ /* Jvm/jld.scm 16 */
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "jvm_ld"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "jvm_ld"); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)0), "jvm_ld"); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)0), "jvm_ld"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "jvm_ld"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "jvm_ld"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "jvm_ld"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "jvm_ld"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "jvm_ld"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "jvm_ld"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "jvm_ld"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzjvm_ldz00()
{ AN_OBJECT;
{ /* Jvm/jld.scm 16 */
{ /* Jvm/jld.scm 16 */
obj_t BgL_cportz00_1838;
BgL_cportz00_1838 = 
open_input_string(BGl_string3561z00zzjvm_ldz00); 
{ 
long BgL_iz00_1839;
BgL_iz00_1839 = ((long)10); 
BgL_loopz00_1840:
if(
(BgL_iz00_1839==((long)-1)))
{ /* Jvm/jld.scm 16 */
return BUNSPEC;}  else 
{ /* Jvm/jld.scm 16 */
{ /* Jvm/jld.scm 16 */
obj_t BgL_arg3565z00_1842;
{ /* Jvm/jld.scm 16 */
obj_t BgL_list3568z00_1843;
BgL_list3568z00_1843 = 
MAKE_PAIR(BgL_cportz00_1838, BNIL); 
BgL_arg3565z00_1842 = 
BGl_readz00zz__readerz00(BgL_list3568z00_1843); } 
{ /* Jvm/jld.scm 16 */
int BgL_auxz00_1869;
BgL_auxz00_1869 = 
(int)(BgL_iz00_1839); 
CNST_TABLE_SET(BgL_auxz00_1869, BgL_arg3565z00_1842); } } 
{ 
long BgL_iz00_1872;
{ /* Jvm/jld.scm 16 */
int BgL_auxz00_1873;
{ /* Jvm/jld.scm 16 */
long BgL_auxz00_1874;
BgL_auxz00_1874 = 
(BgL_iz00_1839-((long)1)); 
BgL_auxz00_1873 = 
(int)(BgL_auxz00_1874); } 
BgL_iz00_1872 = 
(long)(BgL_auxz00_1873); } 
BgL_iz00_1839 = BgL_iz00_1872; 
goto BgL_loopz00_1840;} } } } } 
}



/* jvm-ld */
obj_t BGl_jvmzd2ldzd2zzjvm_ldz00()
{ AN_OBJECT;
{ /* Jvm/jld.scm 32 */
{ /* Jvm/jld.scm 33 */
obj_t BgL_targetz00_470;
{ /* Jvm/jld.scm 33 */
bool_t BgL_test1725z00_527;
{ /* Jvm/jld.scm 33 */
obj_t BgL_objz00_1316;
BgL_objz00_1316 = BGl_za2destza2z00zzengine_paramz00; 
BgL_test1725z00_527 = 
STRINGP(BgL_objz00_1316); } 
if(BgL_test1725z00_527)
{ /* Jvm/jld.scm 33 */
BgL_targetz00_470 = BGl_za2destza2z00zzengine_paramz00; }  else 
{ /* Jvm/jld.scm 33 */
BgL_targetz00_470 = 
string_to_bstring(BGL_DEFAULT_A_BAT); } } 
{ /* Jvm/jld.scm 33 */
obj_t BgL_pathz00_471;
BgL_pathz00_471 = 
BGl_findzd2pathzd2zzjvm_ldz00(BGl_za2ozd2filesza2zd2zzengine_paramz00); 
{ /* Jvm/jld.scm 36 */
obj_t BgL_jarnamez00_472;
{ /* Jvm/jld.scm 37 */
obj_t BgL_arg1720z00_525;
BgL_arg1720z00_525 = 
BGl_prefixz00zz__osz00(BgL_targetz00_470); 
BgL_jarnamez00_472 = 
string_append(BgL_arg1720z00_525, BGl_string3511z00zzjvm_ldz00); } 
{ /* Jvm/jld.scm 37 */
obj_t BgL_za7ipsza7_473;
{ /* Jvm/jld.scm 38 */
obj_t BgL_arg1678z00_501;
{ /* Jvm/jld.scm 38 */
obj_t BgL_arg1683z00_503;
{ /* Jvm/jld.scm 38 */
obj_t BgL_arg1687z00_505;
{ /* Jvm/jld.scm 39 */
obj_t BgL_l1572z00_508;
BgL_l1572z00_508 = BGl_za2additionalzd2bigloozd2librariesza2z00zzengine_paramz00; 
if(
NULLP(BgL_l1572z00_508))
{ /* Jvm/jld.scm 39 */
BgL_arg1687z00_505 = BNIL; }  else 
{ /* Jvm/jld.scm 39 */
obj_t BgL_head1574z00_510;
{ /* Jvm/jld.scm 39 */
obj_t BgL_arg1711z00_521;
BgL_arg1711z00_521 = 
BGl_libraryzd2ze3za7ipz96zzjvm_ldz00(
CAR(BgL_l1572z00_508)); 
BgL_head1574z00_510 = 
MAKE_PAIR(BgL_arg1711z00_521, BNIL); } 
{ 
obj_t BgL_l1572z00_511;obj_t BgL_tail1575z00_512;
BgL_l1572z00_511 = 
CDR(BgL_l1572z00_508); 
BgL_tail1575z00_512 = BgL_head1574z00_510; 
BgL_lname1573z00_513:
if(
NULLP(BgL_l1572z00_511))
{ /* Jvm/jld.scm 39 */
BgL_arg1687z00_505 = BgL_head1574z00_510; }  else 
{ /* Jvm/jld.scm 39 */
obj_t BgL_newtail1576z00_516;
{ /* Jvm/jld.scm 39 */
obj_t BgL_arg1702z00_518;
BgL_arg1702z00_518 = 
BGl_libraryzd2ze3za7ipz96zzjvm_ldz00(
CAR(BgL_l1572z00_511)); 
BgL_newtail1576z00_516 = 
MAKE_PAIR(BgL_arg1702z00_518, BNIL); } 
SET_CDR(BgL_tail1575z00_512, BgL_newtail1576z00_516); 
{ 
obj_t BgL_tail1575z00_1897;obj_t BgL_l1572z00_1895;
BgL_l1572z00_1895 = 
CDR(BgL_l1572z00_511); 
BgL_tail1575z00_1897 = BgL_newtail1576z00_516; 
BgL_tail1575z00_512 = BgL_tail1575z00_1897; 
BgL_l1572z00_511 = BgL_l1572z00_1895; 
goto BgL_lname1573z00_513;} } } } } 
BgL_arg1683z00_503 = 
BGl_filterz00zz__r4_control_features_6_9z00(BGl_proc3512z00zzjvm_ldz00, BgL_arg1687z00_505); } 
BgL_arg1678z00_501 = 
bgl_append2(BgL_arg1683z00_503, BGl_za2additionalzd2bigloozd2za7ipsza2za7zzengine_paramz00); } 
{ /* Jvm/jld.scm 38 */
obj_t BgL_list1680z00_502;
BgL_list1680z00_502 = 
MAKE_PAIR(BgL_arg1678z00_501, BNIL); 
BgL_za7ipsza7_473 = 
BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list1680z00_502); } } 
{ /* Jvm/jld.scm 38 */

{ /* Jvm/jld.scm 42 */
obj_t BgL_list1620z00_474;
BgL_list1620z00_474 = 
MAKE_PAIR(BGl_string3513z00zzjvm_ldz00, BNIL); 
BGl_verbosez00zztools_speekz00(
BINT(((long)1)), BgL_list1620z00_474); } 
{ /* Jvm/jld.scm 43 */
obj_t BgL_list1623z00_475;
{ /* Jvm/jld.scm 43 */
obj_t BgL_arg1627z00_477;
{ /* Jvm/jld.scm 43 */
obj_t BgL_arg1630z00_478;
BgL_arg1630z00_478 = 
MAKE_PAIR(BGl_string3514z00zzjvm_ldz00, BNIL); 
BgL_arg1627z00_477 = 
MAKE_PAIR(BgL_targetz00_470, BgL_arg1630z00_478); } 
BgL_list1623z00_475 = 
MAKE_PAIR(BGl_string3515z00zzjvm_ldz00, BgL_arg1627z00_477); } 
BGl_verbosez00zztools_speekz00(
BINT(((long)2)), BgL_list1623z00_475); } 
{ /* Jvm/jld.scm 44 */
obj_t BgL_list1634z00_479;
{ /* Jvm/jld.scm 44 */
obj_t BgL_auxz00_1911;
BgL_auxz00_1911 = 
BCHAR(((unsigned char)'\n')); 
BgL_list1634z00_479 = 
MAKE_PAIR(BgL_auxz00_1911, BNIL); } 
BGl_verbosez00zztools_speekz00(
BINT(((long)1)), BgL_list1634z00_479); } 
if(
CBOOL(BGl_za2jvmzd2jarzf3za2z21zzengine_paramz00))
{ /* Jvm/jld.scm 46 */
obj_t BgL_manifestz00_480;
BgL_manifestz00_480 = 
BGl_makezd2manifestzd2namez00zzjvm_ldz00(); 
{ /* Jvm/jld.scm 46 */
obj_t BgL_ozd2fileszd2_481;
{ /* Jvm/jld.scm 47 */
obj_t BgL_arg1644z00_484;
{ /* Jvm/jld.scm 47 */
obj_t BgL_l1577z00_485;
BgL_l1577z00_485 = BGl_za2srczd2filesza2zd2zzengine_paramz00; 
if(
NULLP(BgL_l1577z00_485))
{ /* Jvm/jld.scm 47 */
BgL_arg1644z00_484 = BNIL; }  else 
{ /* Jvm/jld.scm 47 */
obj_t BgL_head1579z00_487;
BgL_head1579z00_487 = 
MAKE_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1577z00_488;obj_t BgL_tail1580z00_489;
BgL_l1577z00_488 = BgL_l1577z00_485; 
BgL_tail1580z00_489 = BgL_head1579z00_487; 
BgL_lname1578z00_490:
if(
NULLP(BgL_l1577z00_488))
{ /* Jvm/jld.scm 47 */
BgL_arg1644z00_484 = 
CDR(BgL_head1579z00_487); }  else 
{ /* Jvm/jld.scm 48 */
obj_t BgL_newtail1581z00_492;
{ /* Jvm/jld.scm 48 */
obj_t BgL_arg1657z00_494;
{ /* Jvm/jld.scm 48 */
obj_t BgL_arg1661z00_497;
BgL_arg1661z00_497 = 
BGl_prefixz00zz__osz00(
CAR(BgL_l1577z00_488)); 
BgL_arg1657z00_494 = 
string_append(BgL_arg1661z00_497, BGl_string3516z00zzjvm_ldz00); } 
BgL_newtail1581z00_492 = 
MAKE_PAIR(BgL_arg1657z00_494, BNIL); } 
SET_CDR(BgL_tail1580z00_489, BgL_newtail1581z00_492); 
{ 
obj_t BgL_tail1580z00_1932;obj_t BgL_l1577z00_1930;
BgL_l1577z00_1930 = 
CDR(BgL_l1577z00_488); 
BgL_tail1580z00_1932 = BgL_newtail1581z00_492; 
BgL_tail1580z00_489 = BgL_tail1580z00_1932; 
BgL_l1577z00_488 = BgL_l1577z00_1930; 
goto BgL_lname1578z00_490;} } } } } 
BgL_ozd2fileszd2_481 = 
bgl_append2(BgL_arg1644z00_484, BGl_za2ozd2filesza2zd2zzengine_paramz00); } 
{ /* Jvm/jld.scm 47 */
obj_t BgL_allzd2objectszd2_482;
BgL_allzd2objectszd2_482 = 
BGl_objectszd2ze3classesz31zzjvm_ldz00(BgL_ozd2fileszd2_481); 
{ /* Jvm/jld.scm 51 */

{ /* Jvm/jld.scm 53 */
obj_t BgL_arg1638z00_483;
BgL_arg1638z00_483 = 
BGl_findzd2jvmzd2mainz00zzjvm_ldz00(BgL_ozd2fileszd2_481); 
BGl_generatezd2jvmzd2manifestz00zzjvm_ldz00(BgL_manifestz00_480, BgL_arg1638z00_483, BgL_jarnamez00_472, BgL_za7ipsza7_473); } 
BGl_jvmzd2jarzd2zzjvm_ldz00(BgL_jarnamez00_472, BgL_manifestz00_480, BgL_allzd2objectszd2_482); } } } }  else 
{ /* Jvm/jld.scm 45 */BFALSE; } 
{ /* Jvm/jld.scm 58 */
obj_t BgL_arg1671z00_499;
{ /* Jvm/jld.scm 58 */
obj_t BgL_arg1674z00_500;
{ /* Jvm/jld.scm 58 */
obj_t BgL_pairz00_1340;
BgL_pairz00_1340 = BGl_za2srczd2filesza2zd2zzengine_paramz00; 
BgL_arg1674z00_500 = 
CAR(BgL_pairz00_1340); } 
BgL_arg1671z00_499 = 
BGl_prefixz00zz__osz00(BgL_arg1674z00_500); } 
{ /* Jvm/jld.scm 57 */
bool_t BgL_auxz00_1940;
BgL_auxz00_1940 = 
BGl_generatezd2jvmzd2scriptz00zzjvm_ldz00(BgL_targetz00_470, BgL_arg1671z00_499, BgL_pathz00_471, BgL_jarnamez00_472, BgL_za7ipsza7_473); 
return 
BBOOL(BgL_auxz00_1940);} } } } } } } } 
}



/* _jvm-ld */
obj_t BGl__jvmzd2ldzd2zzjvm_ldz00(obj_t BgL_envz00_1739)
{ AN_OBJECT;
{ /* Jvm/jld.scm 32 */
return 
BGl_jvmzd2ldzd2zzjvm_ldz00();} 
}



/* <anonymous:1689> */
obj_t BGl_zc3anonymousza31689ze3z83zzjvm_ldz00(obj_t BgL_envz00_1740, obj_t BgL_xz00_1741)
{ AN_OBJECT;
{ /* Jvm/jld.scm 38 */
{ 
obj_t BgL_xz00_506;
BgL_xz00_506 = BgL_xz00_1741; 
return BgL_xz00_506;} } 
}



/* library->zip */
obj_t BGl_libraryzd2ze3za7ipz96zzjvm_ldz00(obj_t BgL_libz00_1)
{ AN_OBJECT;
{ /* Jvm/jld.scm 66 */
{ /* Jvm/jld.scm 67 */
obj_t BgL_fz00_528;
{ /* Jvm/jld.scm 67 */
obj_t BgL_arg1743z00_535;
BgL_arg1743z00_535 = 
string_append(BgL_libz00_1, BGl_string3517z00zzjvm_ldz00); 
BgL_fz00_528 = 
BGl_findzd2filezf2pathz20zz__osz00(BgL_arg1743z00_535, BGl_za2libzd2dirza2zd2zzengine_paramz00); } 
if(
STRINGP(BgL_fz00_528))
{ /* Jvm/jld.scm 68 */
return BgL_fz00_528;}  else 
{ /* Jvm/jld.scm 68 */
{ /* Jvm/jld.scm 71 */
obj_t BgL_list1730z00_530;
{ /* Jvm/jld.scm 71 */
obj_t BgL_arg1734z00_532;
{ /* Jvm/jld.scm 71 */
obj_t BgL_arg1738z00_534;
BgL_arg1738z00_534 = 
MAKE_PAIR(BgL_libz00_1, BNIL); 
BgL_arg1734z00_532 = 
MAKE_PAIR(BGl_string3518z00zzjvm_ldz00, BgL_arg1738z00_534); } 
BgL_list1730z00_530 = 
MAKE_PAIR(BGl_string3519z00zzjvm_ldz00, BgL_arg1734z00_532); } 
BGl_warningz00zz__errorz00(BgL_list1730z00_530); } 
return BFALSE;} } } 
}



/* find-path */
obj_t BGl_findzd2pathzd2zzjvm_ldz00(obj_t BgL_ozd2fileszd2_2)
{ AN_OBJECT;
{ /* Jvm/jld.scm 77 */
{ 
obj_t BgL_ozd2fileszd2_536;obj_t BgL_resz00_537;
BgL_ozd2fileszd2_536 = BgL_ozd2fileszd2_2; 
BgL_resz00_537 = BNIL; 
BgL_loopz00_538:
if(
NULLP(BgL_ozd2fileszd2_536))
{ /* Jvm/jld.scm 80 */
return BgL_resz00_537;}  else 
{ /* Jvm/jld.scm 82 */
obj_t BgL_dirz00_540;
BgL_dirz00_540 = 
BGl_dirnamez00zz__osz00(
CAR(BgL_ozd2fileszd2_536)); 
{ /* Jvm/jld.scm 84 */
bool_t BgL_test1748z00_541;
BgL_test1748z00_541 = 
bigloo_strcmp(BgL_dirz00_540, BGl_string3520z00zzjvm_ldz00); 
if(BgL_test1748z00_541)
{ /* Jvm/jld.scm 84 */
{ 
obj_t BgL_ozd2fileszd2_1958;
BgL_ozd2fileszd2_1958 = 
CDR(BgL_ozd2fileszd2_536); 
BgL_ozd2fileszd2_536 = BgL_ozd2fileszd2_1958; 
goto BgL_loopz00_538;} }  else 
{ /* Jvm/jld.scm 87 */
bool_t BgL_testz00_1960;
{ /* Jvm/jld.scm 87 */
obj_t BgL_auxz00_1961;
BgL_auxz00_1961 = 
BGl_memberz00zz__r4_pairs_and_lists_6_3z00(BgL_dirz00_540, BgL_resz00_537); 
BgL_testz00_1960 = 
CBOOL(BgL_auxz00_1961); } 
if(BgL_testz00_1960)
{ /* Jvm/jld.scm 87 */
{ 
obj_t BgL_ozd2fileszd2_1964;
BgL_ozd2fileszd2_1964 = 
CDR(BgL_ozd2fileszd2_536); 
BgL_ozd2fileszd2_536 = BgL_ozd2fileszd2_1964; 
goto BgL_loopz00_538;} }  else 
{ /* Jvm/jld.scm 87 */
{ /* Jvm/jld.scm 91 */
obj_t BgL_arg1761z00_545;obj_t BgL_arg1763z00_546;
BgL_arg1761z00_545 = 
CDR(BgL_ozd2fileszd2_536); 
BgL_arg1763z00_546 = 
MAKE_PAIR(BgL_dirz00_540, BgL_resz00_537); 
{ 
obj_t BgL_resz00_1969;obj_t BgL_ozd2fileszd2_1968;
BgL_ozd2fileszd2_1968 = BgL_arg1761z00_545; 
BgL_resz00_1969 = BgL_arg1763z00_546; 
BgL_resz00_537 = BgL_resz00_1969; 
BgL_ozd2fileszd2_536 = BgL_ozd2fileszd2_1968; 
goto BgL_loopz00_538;} } } } } } } } 
}



/* find-jvm-main */
obj_t BGl_findzd2jvmzd2mainz00zzjvm_ldz00(obj_t BgL_ozd2fileszd2_3)
{ AN_OBJECT;
{ /* Jvm/jld.scm 97 */
{ /* Jvm/jld.scm 98 */
bool_t BgL_test1774z00_548;
{ /* Jvm/jld.scm 98 */
obj_t BgL_obj1182z00_1349;
BgL_obj1182z00_1349 = BGl_za2mainza2z00zzmodule_modulez00; 
BgL_test1774z00_548 = 
BGl_iszd2azf3z21zz__objectz00(BgL_obj1182z00_1349, BGl_globalz00zzast_varz00); } 
if(BgL_test1774z00_548)
{ /* Jvm/jld.scm 99 */
obj_t BgL_arg1776z00_549;
{ /* Jvm/jld.scm 99 */
obj_t BgL_pairz00_1350;
BgL_pairz00_1350 = BGl_za2srczd2filesza2zd2zzengine_paramz00; 
BgL_arg1776z00_549 = 
CAR(BgL_pairz00_1350); } 
return 
BGl_prefixz00zz__osz00(BgL_arg1776z00_549);}  else 
{ /* Jvm/jld.scm 100 */
obj_t BgL_armed1585z00_550;
BgL_armed1585z00_550 = 
MAKE_CELL(BUNSPEC); 
{ /* Jvm/jld.scm 117 */
obj_t BgL_zc3anonymousza31802ze3z83_1744;obj_t BgL_zc3anonymousza31799ze3z83_1746;
{ 
int BgL_auxz00_1976;int BgL_auxz00_1974;
BgL_auxz00_1976 = 
(int)(((long)1)); 
BgL_auxz00_1974 = 
(int)(((long)0)); 
BgL_zc3anonymousza31802ze3z83_1744 = 
make_fx_procedure(BGl_zc3anonymousza31802ze3z83zzjvm_ldz00, BgL_auxz00_1974, BgL_auxz00_1976); } 
{ 
int BgL_auxz00_1981;int BgL_auxz00_1979;
BgL_auxz00_1981 = 
(int)(((long)2)); 
BgL_auxz00_1979 = 
(int)(((long)4)); 
BgL_zc3anonymousza31799ze3z83_1746 = 
make_fx_procedure(BGl_zc3anonymousza31799ze3z83zzjvm_ldz00, BgL_auxz00_1979, BgL_auxz00_1981); } 
{ /* Jvm/jld.scm 117 */
int BgL_auxz00_1984;
BgL_auxz00_1984 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31802ze3z83_1744, BgL_auxz00_1984, BgL_ozd2fileszd2_3); } 
{ /* Jvm/jld.scm 117 */
int BgL_auxz00_1987;
BgL_auxz00_1987 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31799ze3z83_1746, BgL_auxz00_1987, BgL_armed1585z00_550); } 
{ /* Jvm/jld.scm 117 */
int BgL_auxz00_1990;
BgL_auxz00_1990 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_zc3anonymousza31799ze3z83_1746, BgL_auxz00_1990, BgL_ozd2fileszd2_3); } 
CELL_SET(BgL_armed1585z00_550, BTRUE); 
return 
BGl_handling_function1779z00zzjvm_ldz00(BgL_zc3anonymousza31802ze3z83_1744, BgL_zc3anonymousza31799ze3z83_1746, BgL_ozd2fileszd2_3, BgL_armed1585z00_550);} } } } 
}



/* handling_function1779 */
obj_t BGl_handling_function1779z00zzjvm_ldz00(obj_t BgL_zc3anonymousza31802ze3z83_1837, obj_t BgL_zc3anonymousza31799ze3z83_1836, obj_t BgL_ozd2fileszd2_1835, obj_t BgL_armed1585z00_1834)
{ AN_OBJECT;
{ /* Jvm/jld.scm 116 */
jmp_buf jmpbuf; 
obj_t BgL_an_exit1587z00_555;
if( SET_EXIT(BgL_an_exit1587z00_555) ) { RESTORE_TRACE(); 
return 
_exit_value_;
} else {
BgL_an_exit1587z00_555 = 
(obj_t)jmpbuf; 
{ /* Jvm/jld.scm 116 */

PUSH_EXIT(BgL_an_exit1587z00_555, ((bool_t)1)); 
{ /* Jvm/jld.scm 116 */
obj_t BgL_an_exitd1588z00_556;
BgL_an_exitd1588z00_556 = 
BGL_GET_EXITD_TOP(); 
{ /* Jvm/jld.scm 116 */
obj_t BgL_escapez00_1745;
{ 
int BgL_auxz00_2000;int BgL_auxz00_1998;
BgL_auxz00_2000 = 
(int)(((long)1)); 
BgL_auxz00_1998 = 
(int)(((long)1)); 
BgL_escapez00_1745 = 
make_fx_procedure(BGl_escapez00zzjvm_ldz00, BgL_auxz00_1998, BgL_auxz00_2000); } 
{ /* Jvm/jld.scm 116 */
int BgL_auxz00_2003;
BgL_auxz00_2003 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_escapez00_1745, BgL_auxz00_2003, BgL_an_exitd1588z00_556); } 
{ /* Jvm/jld.scm 116 */
obj_t BgL_res1590z00_559;
{ /* Jvm/jld.scm 116 */
obj_t BgL_zc3anonymousza31789ze3z83_1742;obj_t BgL_zc3anonymousza31787ze3z83_1747;
{ 
int BgL_auxz00_2008;int BgL_auxz00_2006;
BgL_auxz00_2008 = 
(int)(((long)1)); 
BgL_auxz00_2006 = 
(int)(((long)0)); 
BgL_zc3anonymousza31789ze3z83_1742 = 
make_fx_procedure(BGl_zc3anonymousza31789ze3z83zzjvm_ldz00, BgL_auxz00_2006, BgL_auxz00_2008); } 
{ 
int BgL_auxz00_2013;int BgL_auxz00_2011;
BgL_auxz00_2013 = 
(int)(((long)5)); 
BgL_auxz00_2011 = 
(int)(((long)0)); 
BgL_zc3anonymousza31787ze3z83_1747 = 
make_fx_procedure(BGl_zc3anonymousza31787ze3z83zzjvm_ldz00, BgL_auxz00_2011, BgL_auxz00_2013); } 
{ /* Jvm/jld.scm 116 */
int BgL_auxz00_2016;
BgL_auxz00_2016 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31789ze3z83_1742, BgL_auxz00_2016, BgL_armed1585z00_1834); } 
{ /* Jvm/jld.scm 116 */
int BgL_auxz00_2019;
BgL_auxz00_2019 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31787ze3z83_1747, BgL_auxz00_2019, BgL_an_exitd1588z00_556); } 
{ /* Jvm/jld.scm 116 */
int BgL_auxz00_2022;
BgL_auxz00_2022 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_zc3anonymousza31787ze3z83_1747, BgL_auxz00_2022, BgL_armed1585z00_1834); } 
{ /* Jvm/jld.scm 116 */
int BgL_auxz00_2025;
BgL_auxz00_2025 = 
(int)(((long)2)); 
PROCEDURE_SET(BgL_zc3anonymousza31787ze3z83_1747, BgL_auxz00_2025, BgL_ozd2fileszd2_1835); } 
{ /* Jvm/jld.scm 116 */
int BgL_auxz00_2028;
BgL_auxz00_2028 = 
(int)(((long)3)); 
PROCEDURE_SET(BgL_zc3anonymousza31787ze3z83_1747, BgL_auxz00_2028, BgL_zc3anonymousza31799ze3z83_1836); } 
{ /* Jvm/jld.scm 116 */
int BgL_auxz00_2031;
BgL_auxz00_2031 = 
(int)(((long)4)); 
PROCEDURE_SET(BgL_zc3anonymousza31787ze3z83_1747, BgL_auxz00_2031, BgL_escapez00_1745); } 
BgL_res1590z00_559 = 
BGl_dynamiczd2windzd2zz__r4_control_features_6_9z00(BgL_zc3anonymousza31787ze3z83_1747, BgL_zc3anonymousza31802ze3z83_1837, BgL_zc3anonymousza31789ze3z83_1742); } 
POP_EXIT(); 
return BgL_res1590z00_559;} } } } 
} } 
}



/* <anonymous:1789> */
obj_t BGl_zc3anonymousza31789ze3z83zzjvm_ldz00(obj_t BgL_envz00_1748)
{ AN_OBJECT;
{ /* Jvm/jld.scm 116 */
{ /* Jvm/jld.scm 116 */
obj_t BgL_armed1585z00_1749;
{ /* Jvm/jld.scm 116 */
int BgL_auxz00_2036;
BgL_auxz00_2036 = 
(int)(((long)0)); 
BgL_armed1585z00_1749 = 
PROCEDURE_REF(BgL_envz00_1748, BgL_auxz00_2036); } 
{ 

{ /* Jvm/jld.scm 116 */
bool_t BgL_testz00_2039;
{ /* Jvm/jld.scm 116 */
obj_t BgL_auxz00_2040;
BgL_auxz00_2040 = 
CELL_REF(BgL_armed1585z00_1749); 
BgL_testz00_2039 = 
CBOOL(BgL_auxz00_2040); } 
if(BgL_testz00_2039)
{ /* Jvm/jld.scm 116 */
CELL_SET(BgL_armed1585z00_1749, BFALSE); 
return 
BGl_removezd2errorzd2handlerz12z12zz__errorz00();}  else 
{ /* Jvm/jld.scm 116 */
return BFALSE;} } } } } 
}



/* <anonymous:1802> */
obj_t BGl_zc3anonymousza31802ze3z83zzjvm_ldz00(obj_t BgL_envz00_1751)
{ AN_OBJECT;
{ /* Jvm/jld.scm 116 */
{ /* Jvm/jld.scm 100 */
obj_t BgL_ozd2fileszd2_1752;
{ /* Jvm/jld.scm 100 */
int BgL_auxz00_2043;
BgL_auxz00_2043 = 
(int)(((long)0)); 
BgL_ozd2fileszd2_1752 = 
PROCEDURE_REF(BgL_envz00_1751, BgL_auxz00_2043); } 
{ 

{ 
obj_t BgL_ozd2fileszd2_578;
BgL_ozd2fileszd2_578 = BgL_ozd2fileszd2_1752; 
BgL_loopz00_579:
if(
NULLP(BgL_ozd2fileszd2_578))
{ /* Jvm/jld.scm 101 */
FAILURE(BGl_string3521z00zzjvm_ldz00,BGl_string3522z00zzjvm_ldz00,BgL_ozd2fileszd2_578);}  else 
{ /* Jvm/jld.scm 103 */
obj_t BgL_prefz00_581;
{ /* Jvm/jld.scm 103 */
obj_t BgL_arg1896z00_623;
BgL_arg1896z00_623 = 
BGl_prefixz00zz__osz00(
CAR(BgL_ozd2fileszd2_578)); 
BgL_prefz00_581 = 
BGl_unprofzd2srczd2namez00zzengine_linkz00(BgL_arg1896z00_623); } 
{ /* Jvm/jld.scm 103 */
obj_t BgL_bprefz00_582;
BgL_bprefz00_582 = 
BGl_basenamez00zz__osz00(BgL_prefz00_581); 
{ /* Jvm/jld.scm 104 */
obj_t BgL_scmzd2filezd2_583;
BgL_scmzd2filezd2_583 = 
BGl_findzd2srczd2filez00zzengine_linkz00(BgL_prefz00_581, BgL_bprefz00_582); 
{ /* Jvm/jld.scm 105 */

{ /* Jvm/jld.scm 106 */
bool_t BgL_test1806z00_584;
if(
STRINGP(BgL_scmzd2filezd2_583))
{ /* Jvm/jld.scm 107 */
bool_t BgL_test1890z00_622;
{ /* Jvm/jld.scm 107 */
char * BgL_auxz00_2056;
BgL_auxz00_2056 = 
BSTRING_TO_STRING(BgL_scmzd2filezd2_583); 
BgL_test1890z00_622 = 
fexists(BgL_auxz00_2056); } 
if(BgL_test1890z00_622)
{ /* Jvm/jld.scm 107 */
BgL_test1806z00_584 = ((bool_t)0); }  else 
{ /* Jvm/jld.scm 107 */
BgL_test1806z00_584 = ((bool_t)1); } }  else 
{ /* Jvm/jld.scm 106 */
BgL_test1806z00_584 = ((bool_t)1); } 
if(BgL_test1806z00_584)
{ 
obj_t BgL_ozd2fileszd2_2061;
BgL_ozd2fileszd2_2061 = 
CDR(BgL_ozd2fileszd2_578); 
BgL_ozd2fileszd2_578 = BgL_ozd2fileszd2_2061; 
goto BgL_loopz00_579;}  else 
{ /* Jvm/jld.scm 109 */
obj_t BgL__ortest_1586z00_586;
{ /* Jvm/jld.scm 110 */
obj_t BgL_zc3anonymousza31820ze3z83_1743;
{ 
int BgL_auxz00_2065;int BgL_auxz00_2063;
BgL_auxz00_2065 = 
(int)(((long)1)); 
BgL_auxz00_2063 = 
(int)(((long)0)); 
BgL_zc3anonymousza31820ze3z83_1743 = 
make_fx_procedure(BGl_zc3anonymousza31820ze3z83zzjvm_ldz00, BgL_auxz00_2063, BgL_auxz00_2065); } 
{ /* Jvm/jld.scm 110 */
int BgL_auxz00_2068;
BgL_auxz00_2068 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31820ze3z83_1743, BgL_auxz00_2068, BgL_scmzd2filezd2_583); } 
BgL__ortest_1586z00_586 = 
BGl_withzd2inputzd2fromzd2filezd2zz__r4_ports_6_10_1z00(BgL_scmzd2filezd2_583, BgL_zc3anonymousza31820ze3z83_1743); } 
if(
CBOOL(BgL__ortest_1586z00_586))
{ /* Jvm/jld.scm 115 */
return BgL__ortest_1586z00_586;}  else 
{ 
obj_t BgL_ozd2fileszd2_2074;
BgL_ozd2fileszd2_2074 = 
CDR(BgL_ozd2fileszd2_578); 
BgL_ozd2fileszd2_578 = BgL_ozd2fileszd2_2074; 
goto BgL_loopz00_579;} } } } } } } } } } } 
}



/* <anonymous:1787> */
obj_t BGl_zc3anonymousza31787ze3z83zzjvm_ldz00(obj_t BgL_envz00_1753)
{ AN_OBJECT;
{ /* Jvm/jld.scm 116 */
{ /* Jvm/jld.scm 116 */
obj_t BgL_zc3anonymousza31799ze3z83_1757;obj_t BgL_escapez00_1758;
{ /* Jvm/jld.scm 116 */
int BgL_auxz00_2076;
BgL_auxz00_2076 = 
(int)(((long)3)); 
BgL_zc3anonymousza31799ze3z83_1757 = 
PROCEDURE_REF(BgL_envz00_1753, BgL_auxz00_2076); } 
{ /* Jvm/jld.scm 116 */
int BgL_auxz00_2079;
BgL_auxz00_2079 = 
(int)(((long)4)); 
BgL_escapez00_1758 = 
PROCEDURE_REF(BgL_envz00_1753, BgL_auxz00_2079); } 
{ 

return 
BGl_addzd2errorzd2handlerz12z12zz__errorz00(BgL_zc3anonymousza31799ze3z83_1757, BgL_escapez00_1758);} } } 
}



/* escape */
obj_t BGl_escapez00zzjvm_ldz00(obj_t BgL_envz00_1759, obj_t BgL_val1589z00_1761)
{ AN_OBJECT;
{ /* Jvm/jld.scm 116 */
{ /* Jvm/jld.scm 116 */
obj_t BgL_an_exitd1588z00_1760;
{ /* Jvm/jld.scm 116 */
int BgL_auxz00_2083;
BgL_auxz00_2083 = 
(int)(((long)0)); 
BgL_an_exitd1588z00_1760 = 
PROCEDURE_REF(BgL_envz00_1759, BgL_auxz00_2083); } 
{ 
obj_t BgL_val1589z00_557;
BgL_val1589z00_557 = BgL_val1589z00_1761; 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1588z00_1760, BgL_val1589z00_557);} } } 
}



/* <anonymous:1799> */
obj_t BGl_zc3anonymousza31799ze3z83zzjvm_ldz00(obj_t BgL_envz00_1762, obj_t BgL_escz00_1765, obj_t BgL_objz00_1766, obj_t BgL_procz00_1767, obj_t BgL_msgz00_1768)
{ AN_OBJECT;
{ /* Jvm/jld.scm 116 */
{ /* Jvm/jld.scm 116 */
obj_t BgL_armed1585z00_1763;obj_t BgL_ozd2fileszd2_1764;
{ /* Jvm/jld.scm 116 */
int BgL_auxz00_2087;
BgL_auxz00_2087 = 
(int)(((long)0)); 
BgL_armed1585z00_1763 = 
PROCEDURE_REF(BgL_envz00_1762, BgL_auxz00_2087); } 
{ /* Jvm/jld.scm 116 */
int BgL_auxz00_2090;
BgL_auxz00_2090 = 
(int)(((long)1)); 
BgL_ozd2fileszd2_1764 = 
PROCEDURE_REF(BgL_envz00_1762, BgL_auxz00_2090); } 
{ 
obj_t BgL_escz00_572;obj_t BgL_objz00_573;obj_t BgL_procz00_574;obj_t BgL_msgz00_575;
BgL_escz00_572 = BgL_escz00_1765; 
BgL_objz00_573 = BgL_objz00_1766; 
BgL_procz00_574 = BgL_procz00_1767; 
BgL_msgz00_575 = BgL_msgz00_1768; 
CELL_SET(BgL_armed1585z00_1763, BFALSE); 
BGl_removezd2errorzd2handlerz12z12zz__errorz00(); 
BGl_notifyzd2errorzd2zz__errorz00(BgL_objz00_573, BgL_procz00_574, BgL_msgz00_575); 
FAILURE(BGl_string3521z00zzjvm_ldz00,BGl_string3523z00zzjvm_ldz00,BgL_ozd2fileszd2_1764);} } } 
}



/* <anonymous:1820> */
obj_t BGl_zc3anonymousza31820ze3z83zzjvm_ldz00(obj_t BgL_envz00_1770)
{ AN_OBJECT;
{ /* Jvm/jld.scm 110 */
{ /* Jvm/jld.scm 111 */
obj_t BgL_scmzd2filezd2_1771;
{ /* Jvm/jld.scm 111 */
int BgL_auxz00_2100;
BgL_auxz00_2100 = 
(int)(((long)0)); 
BgL_scmzd2filezd2_1771 = 
PROCEDURE_REF(BgL_envz00_1770, BgL_auxz00_2100); } 
{ 

{ /* Jvm/jld.scm 111 */
obj_t BgL_ezd2105zd2_592;
BgL_ezd2105zd2_592 = 
BGl_compilerzd2readzd2zzread_readerz00(BNIL); 
if(
PAIRP(BgL_ezd2105zd2_592))
{ /* Jvm/jld.scm 110 */
obj_t BgL_cdrzd2107zd2_594;
BgL_cdrzd2107zd2_594 = 
CDR(BgL_ezd2105zd2_592); 
{ /* Jvm/jld.scm 110 */
bool_t BgL_testz00_2107;
{ /* Jvm/jld.scm 110 */
obj_t BgL_auxz00_2110;obj_t BgL_auxz00_2108;
BgL_auxz00_2110 = 
CNST_TABLE_REF(((long)0)); 
BgL_auxz00_2108 = 
CAR(BgL_ezd2105zd2_592); 
BgL_testz00_2107 = 
(BgL_auxz00_2108==BgL_auxz00_2110); } 
if(BgL_testz00_2107)
{ /* Jvm/jld.scm 110 */
if(
PAIRP(BgL_cdrzd2107zd2_594))
{ 
obj_t BgL_gzd2110zd2_599;
BgL_gzd2110zd2_599 = 
CDR(BgL_cdrzd2107zd2_594); 
BgL_zc3anonymousza31829ze3z83_600:
if(
PAIRP(BgL_gzd2110zd2_599))
{ /* Jvm/jld.scm 110 */
obj_t BgL_carzd2112zd2_602;
BgL_carzd2112zd2_602 = 
CAR(BgL_gzd2110zd2_599); 
if(
PAIRP(BgL_carzd2112zd2_602))
{ /* Jvm/jld.scm 110 */
obj_t BgL_cdrzd2115zd2_604;
BgL_cdrzd2115zd2_604 = 
CDR(BgL_carzd2112zd2_602); 
{ /* Jvm/jld.scm 110 */
bool_t BgL_testz00_2121;
{ /* Jvm/jld.scm 110 */
obj_t BgL_auxz00_2124;obj_t BgL_auxz00_2122;
BgL_auxz00_2124 = 
CNST_TABLE_REF(((long)1)); 
BgL_auxz00_2122 = 
CAR(BgL_carzd2112zd2_602); 
BgL_testz00_2121 = 
(BgL_auxz00_2122==BgL_auxz00_2124); } 
if(BgL_testz00_2121)
{ /* Jvm/jld.scm 110 */
if(
PAIRP(BgL_cdrzd2115zd2_604))
{ /* Jvm/jld.scm 110 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
CDR(BgL_cdrzd2115zd2_604), BNIL))
{ /* Jvm/jld.scm 110 */
return 
BGl_prefixz00zz__osz00(BgL_scmzd2filezd2_1771);}  else 
{ 
obj_t BgL_gzd2110zd2_2133;
BgL_gzd2110zd2_2133 = 
CDR(BgL_gzd2110zd2_599); 
BgL_gzd2110zd2_599 = BgL_gzd2110zd2_2133; 
goto BgL_zc3anonymousza31829ze3z83_600;} }  else 
{ 
obj_t BgL_gzd2110zd2_2135;
BgL_gzd2110zd2_2135 = 
CDR(BgL_gzd2110zd2_599); 
BgL_gzd2110zd2_599 = BgL_gzd2110zd2_2135; 
goto BgL_zc3anonymousza31829ze3z83_600;} }  else 
{ 
obj_t BgL_gzd2110zd2_2137;
BgL_gzd2110zd2_2137 = 
CDR(BgL_gzd2110zd2_599); 
BgL_gzd2110zd2_599 = BgL_gzd2110zd2_2137; 
goto BgL_zc3anonymousza31829ze3z83_600;} } }  else 
{ 
obj_t BgL_gzd2110zd2_2139;
BgL_gzd2110zd2_2139 = 
CDR(BgL_gzd2110zd2_599); 
BgL_gzd2110zd2_599 = BgL_gzd2110zd2_2139; 
goto BgL_zc3anonymousza31829ze3z83_600;} }  else 
{ /* Jvm/jld.scm 110 */
return BFALSE;} }  else 
{ /* Jvm/jld.scm 110 */
return BFALSE;} }  else 
{ /* Jvm/jld.scm 110 */
return BFALSE;} } }  else 
{ /* Jvm/jld.scm 110 */
return BFALSE;} } } } } 
}



/* objects->classes */
obj_t BGl_objectszd2ze3classesz31zzjvm_ldz00(obj_t BgL_objectsz00_4)
{ AN_OBJECT;
{ /* Jvm/jld.scm 124 */
{ 
obj_t BgL_sourcez00_649;
{ 
obj_t BgL_objectsz00_632;obj_t BgL_classesz00_633;
BgL_objectsz00_632 = BgL_objectsz00_4; 
BgL_classesz00_633 = BNIL; 
BgL_loopz00_634:
if(
NULLP(BgL_objectsz00_632))
{ /* Jvm/jld.scm 185 */
return BgL_classesz00_633;}  else 
{ /* Jvm/jld.scm 187 */
obj_t BgL_objectz00_636;
BgL_objectz00_636 = 
CAR(BgL_objectsz00_632); 
{ /* Jvm/jld.scm 187 */
obj_t BgL_prefz00_637;
{ /* Jvm/jld.scm 188 */
obj_t BgL_arg1933z00_648;
BgL_arg1933z00_648 = 
BGl_prefixz00zz__osz00(BgL_objectz00_636); 
BgL_prefz00_637 = 
BGl_unprofzd2srczd2namez00zzengine_linkz00(BgL_arg1933z00_648); } 
{ /* Jvm/jld.scm 188 */
obj_t BgL_bprefz00_638;
BgL_bprefz00_638 = 
BGl_basenamez00zz__osz00(BgL_prefz00_637); 
{ /* Jvm/jld.scm 189 */
obj_t BgL_scmzd2filezd2_639;
BgL_scmzd2filezd2_639 = 
BGl_findzd2srczd2filez00zzengine_linkz00(BgL_prefz00_637, BgL_bprefz00_638); 
{ /* Jvm/jld.scm 190 */

{ /* Jvm/jld.scm 191 */
bool_t BgL_test1906z00_640;
if(
STRINGP(BgL_scmzd2filezd2_639))
{ /* Jvm/jld.scm 191 */
char * BgL_auxz00_2151;
BgL_auxz00_2151 = 
BSTRING_TO_STRING(BgL_scmzd2filezd2_639); 
BgL_test1906z00_640 = 
fexists(BgL_auxz00_2151); }  else 
{ /* Jvm/jld.scm 191 */
BgL_test1906z00_640 = ((bool_t)0); } 
if(BgL_test1906z00_640)
{ /* Jvm/jld.scm 192 */
obj_t BgL_arg1908z00_641;obj_t BgL_arg1909z00_642;
BgL_arg1908z00_641 = 
CDR(BgL_objectsz00_632); 
{ /* Jvm/jld.scm 194 */
obj_t BgL_arg1913z00_643;
{ /* Jvm/jld.scm 194 */
obj_t BgL_arg1917z00_644;
BgL_sourcez00_649 = BgL_scmzd2filezd2_639; 
{ /* Jvm/jld.scm 171 */
bool_t BgL_test1939z00_651;
{ /* Jvm/jld.scm 171 */
bool_t BgL_test1994z00_701;
{ /* Jvm/jld.scm 171 */
obj_t BgL_arg1997z00_702;
BgL_arg1997z00_702 = 
BGl_suffixz00zz__osz00(BgL_sourcez00_649); 
BgL_test1994z00_701 = 
bigloo_strcmp(BgL_arg1997z00_702, BGl_string3524z00zzjvm_ldz00); } 
if(BgL_test1994z00_701)
{ /* Jvm/jld.scm 171 */
BgL_test1939z00_651 = ((bool_t)0); }  else 
{ /* Jvm/jld.scm 172 */
char * BgL_auxz00_2159;
BgL_auxz00_2159 = 
BSTRING_TO_STRING(BgL_sourcez00_649); 
BgL_test1939z00_651 = 
fexists(BgL_auxz00_2159); } } 
if(BgL_test1939z00_651)
{ /* Jvm/jld.scm 175 */
obj_t BgL_zc3anonymousza31943ze3z83_1778;
{ 
int BgL_auxz00_2165;int BgL_auxz00_2163;
BgL_auxz00_2165 = 
(int)(((long)1)); 
BgL_auxz00_2163 = 
(int)(((long)0)); 
BgL_zc3anonymousza31943ze3z83_1778 = 
make_fx_procedure(BGl_zc3anonymousza31943ze3z83zzjvm_ldz00, BgL_auxz00_2163, BgL_auxz00_2165); } 
{ /* Jvm/jld.scm 175 */
int BgL_auxz00_2168;
BgL_auxz00_2168 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31943ze3z83_1778, BgL_auxz00_2168, BgL_sourcez00_649); } 
BgL_arg1917z00_644 = 
BGl_withzd2inputzd2fromzd2filezd2zz__r4_ports_6_10_1z00(BgL_sourcez00_649, BgL_zc3anonymousza31943ze3z83_1778); }  else 
{ /* Jvm/jld.scm 171 */
BgL_arg1917z00_644 = BNIL; } } 
BgL_arg1913z00_643 = 
bgl_append2(BgL_arg1917z00_644, BgL_classesz00_633); } 
BgL_arg1909z00_642 = 
MAKE_PAIR(BgL_objectz00_636, BgL_arg1913z00_643); } 
{ 
obj_t BgL_classesz00_2175;obj_t BgL_objectsz00_2174;
BgL_objectsz00_2174 = BgL_arg1908z00_641; 
BgL_classesz00_2175 = BgL_arg1909z00_642; 
BgL_classesz00_633 = BgL_classesz00_2175; 
BgL_objectsz00_632 = BgL_objectsz00_2174; 
goto BgL_loopz00_634;} }  else 
{ /* Jvm/jld.scm 195 */
obj_t BgL_arg1921z00_645;obj_t BgL_arg1923z00_646;
BgL_arg1921z00_645 = 
CDR(BgL_objectsz00_632); 
BgL_arg1923z00_646 = 
MAKE_PAIR(BgL_objectz00_636, BgL_classesz00_633); 
{ 
obj_t BgL_classesz00_2179;obj_t BgL_objectsz00_2178;
BgL_objectsz00_2178 = BgL_arg1921z00_645; 
BgL_classesz00_2179 = BgL_arg1923z00_646; 
BgL_classesz00_633 = BgL_classesz00_2179; 
BgL_objectsz00_632 = BgL_objectsz00_2178; 
goto BgL_loopz00_634;} } } } } } } } } } } 
}



/* <anonymous:1943> */
obj_t BGl_zc3anonymousza31943ze3z83zzjvm_ldz00(obj_t BgL_envz00_1779)
{ AN_OBJECT;
{ /* Jvm/jld.scm 174 */
{ /* Jvm/jld.scm 175 */
obj_t BgL_sourcez00_1780;
{ /* Jvm/jld.scm 175 */
int BgL_auxz00_2180;
BgL_auxz00_2180 = 
(int)(((long)0)); 
BgL_sourcez00_1780 = 
PROCEDURE_REF(BgL_envz00_1779, BgL_auxz00_2180); } 
{ 

{ /* Jvm/jld.scm 175 */
obj_t BgL_armed1594z00_654;
BgL_armed1594z00_654 = 
MAKE_CELL(BUNSPEC); 
{ /* Jvm/jld.scm 181 */
obj_t BgL_zc3anonymousza31963ze3z83_1776;obj_t BgL_zc3anonymousza31960ze3z83_1774;
{ 
int BgL_auxz00_2185;int BgL_auxz00_2183;
BgL_auxz00_2185 = 
(int)(((long)1)); 
BgL_auxz00_2183 = 
(int)(((long)0)); 
BgL_zc3anonymousza31963ze3z83_1776 = 
make_fx_procedure(BGl_zc3anonymousza31963ze3z83zzjvm_ldz00, BgL_auxz00_2183, BgL_auxz00_2185); } 
{ 
int BgL_auxz00_2190;int BgL_auxz00_2188;
BgL_auxz00_2190 = 
(int)(((long)1)); 
BgL_auxz00_2188 = 
(int)(((long)4)); 
BgL_zc3anonymousza31960ze3z83_1774 = 
make_fx_procedure(BGl_zc3anonymousza31960ze3z83zzjvm_ldz00, BgL_auxz00_2188, BgL_auxz00_2190); } 
{ /* Jvm/jld.scm 181 */
int BgL_auxz00_2193;
BgL_auxz00_2193 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31963ze3z83_1776, BgL_auxz00_2193, BgL_sourcez00_1780); } 
{ /* Jvm/jld.scm 181 */
int BgL_auxz00_2196;
BgL_auxz00_2196 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31960ze3z83_1774, BgL_auxz00_2196, BgL_armed1594z00_654); } 
CELL_SET(BgL_armed1594z00_654, BTRUE); 
return 
BGl_handling_function1944z00zzjvm_ldz00(BgL_zc3anonymousza31963ze3z83_1776, BgL_zc3anonymousza31960ze3z83_1774, BgL_armed1594z00_654);} } } } } 
}



/* handling_function1944 */
obj_t BGl_handling_function1944z00zzjvm_ldz00(obj_t BgL_zc3anonymousza31963ze3z83_1833, obj_t BgL_zc3anonymousza31960ze3z83_1832, obj_t BgL_armed1594z00_1831)
{ AN_OBJECT;
{ /* Jvm/jld.scm 175 */
jmp_buf jmpbuf; 
obj_t BgL_an_exit1595z00_659;
if( SET_EXIT(BgL_an_exit1595z00_659) ) { RESTORE_TRACE(); 
return 
_exit_value_;
} else {
BgL_an_exit1595z00_659 = 
(obj_t)jmpbuf; 
{ /* Jvm/jld.scm 175 */

PUSH_EXIT(BgL_an_exit1595z00_659, ((bool_t)1)); 
{ /* Jvm/jld.scm 175 */
obj_t BgL_an_exitd1596z00_660;
BgL_an_exitd1596z00_660 = 
BGL_GET_EXITD_TOP(); 
{ /* Jvm/jld.scm 175 */
obj_t BgL_escapez00_1773;
{ 
int BgL_auxz00_2206;int BgL_auxz00_2204;
BgL_auxz00_2206 = 
(int)(((long)1)); 
BgL_auxz00_2204 = 
(int)(((long)1)); 
BgL_escapez00_1773 = 
make_fx_procedure(BGl_escape_3223z00zzjvm_ldz00, BgL_auxz00_2204, BgL_auxz00_2206); } 
{ /* Jvm/jld.scm 175 */
int BgL_auxz00_2209;
BgL_auxz00_2209 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_escapez00_1773, BgL_auxz00_2209, BgL_an_exitd1596z00_660); } 
{ /* Jvm/jld.scm 175 */
obj_t BgL_res1598z00_663;
{ /* Jvm/jld.scm 175 */
obj_t BgL_zc3anonymousza31954ze3z83_1777;obj_t BgL_zc3anonymousza31952ze3z83_1775;
{ 
int BgL_auxz00_2214;int BgL_auxz00_2212;
BgL_auxz00_2214 = 
(int)(((long)1)); 
BgL_auxz00_2212 = 
(int)(((long)0)); 
BgL_zc3anonymousza31954ze3z83_1777 = 
make_fx_procedure(BGl_zc3anonymousza31954ze3z83zzjvm_ldz00, BgL_auxz00_2212, BgL_auxz00_2214); } 
{ 
int BgL_auxz00_2219;int BgL_auxz00_2217;
BgL_auxz00_2219 = 
(int)(((long)4)); 
BgL_auxz00_2217 = 
(int)(((long)0)); 
BgL_zc3anonymousza31952ze3z83_1775 = 
make_fx_procedure(BGl_zc3anonymousza31952ze3z83zzjvm_ldz00, BgL_auxz00_2217, BgL_auxz00_2219); } 
{ /* Jvm/jld.scm 175 */
int BgL_auxz00_2222;
BgL_auxz00_2222 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31954ze3z83_1777, BgL_auxz00_2222, BgL_armed1594z00_1831); } 
{ /* Jvm/jld.scm 175 */
int BgL_auxz00_2225;
BgL_auxz00_2225 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza31952ze3z83_1775, BgL_auxz00_2225, BgL_an_exitd1596z00_660); } 
{ /* Jvm/jld.scm 175 */
int BgL_auxz00_2228;
BgL_auxz00_2228 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_zc3anonymousza31952ze3z83_1775, BgL_auxz00_2228, BgL_armed1594z00_1831); } 
{ /* Jvm/jld.scm 175 */
int BgL_auxz00_2231;
BgL_auxz00_2231 = 
(int)(((long)2)); 
PROCEDURE_SET(BgL_zc3anonymousza31952ze3z83_1775, BgL_auxz00_2231, BgL_zc3anonymousza31960ze3z83_1832); } 
{ /* Jvm/jld.scm 175 */
int BgL_auxz00_2234;
BgL_auxz00_2234 = 
(int)(((long)3)); 
PROCEDURE_SET(BgL_zc3anonymousza31952ze3z83_1775, BgL_auxz00_2234, BgL_escapez00_1773); } 
BgL_res1598z00_663 = 
BGl_dynamiczd2windzd2zz__r4_control_features_6_9z00(BgL_zc3anonymousza31952ze3z83_1775, BgL_zc3anonymousza31963ze3z83_1833, BgL_zc3anonymousza31954ze3z83_1777); } 
POP_EXIT(); 
return BgL_res1598z00_663;} } } } 
} } 
}



/* <anonymous:1954> */
obj_t BGl_zc3anonymousza31954ze3z83zzjvm_ldz00(obj_t BgL_envz00_1782)
{ AN_OBJECT;
{ /* Jvm/jld.scm 175 */
{ /* Jvm/jld.scm 175 */
obj_t BgL_armed1594z00_1783;
{ /* Jvm/jld.scm 175 */
int BgL_auxz00_2239;
BgL_auxz00_2239 = 
(int)(((long)0)); 
BgL_armed1594z00_1783 = 
PROCEDURE_REF(BgL_envz00_1782, BgL_auxz00_2239); } 
{ 

{ /* Jvm/jld.scm 175 */
bool_t BgL_testz00_2242;
{ /* Jvm/jld.scm 175 */
obj_t BgL_auxz00_2243;
BgL_auxz00_2243 = 
CELL_REF(BgL_armed1594z00_1783); 
BgL_testz00_2242 = 
CBOOL(BgL_auxz00_2243); } 
if(BgL_testz00_2242)
{ /* Jvm/jld.scm 175 */
CELL_SET(BgL_armed1594z00_1783, BFALSE); 
return 
BGl_removezd2errorzd2handlerz12z12zz__errorz00();}  else 
{ /* Jvm/jld.scm 175 */
return BFALSE;} } } } } 
}



/* <anonymous:1963> */
obj_t BGl_zc3anonymousza31963ze3z83zzjvm_ldz00(obj_t BgL_envz00_1785)
{ AN_OBJECT;
{ /* Jvm/jld.scm 175 */
{ /* Jvm/jld.scm 175 */
obj_t BgL_sourcez00_1786;
{ /* Jvm/jld.scm 175 */
int BgL_auxz00_2246;
BgL_auxz00_2246 = 
(int)(((long)0)); 
BgL_sourcez00_1786 = 
PROCEDURE_REF(BgL_envz00_1785, BgL_auxz00_2246); } 
{ 

{ 
obj_t BgL_modz00_704;obj_t BgL_basez00_705;obj_t BgL_clausesz00_706;obj_t BgL_idz00_753;
{ /* Jvm/jld.scm 175 */
obj_t BgL_ezd2151zd2_685;
{ /* Jvm/jld.scm 175 */
obj_t BgL_arg1985z00_694;
BgL_arg1985z00_694 = 
GET_CURRENT_INPUT_PORT(); 
{ /* Jvm/jld.scm 175 */
obj_t BgL_list1987z00_695;
BgL_list1987z00_695 = 
MAKE_PAIR(BgL_arg1985z00_694, BNIL); 
BgL_ezd2151zd2_685 = 
BGl_readz00zz__readerz00(BgL_list1987z00_695); } } 
if(
PAIRP(BgL_ezd2151zd2_685))
{ /* Jvm/jld.scm 175 */
obj_t BgL_cdrzd2157zd2_687;
BgL_cdrzd2157zd2_687 = 
CDR(BgL_ezd2151zd2_685); 
{ /* Jvm/jld.scm 175 */
bool_t BgL_testz00_2255;
{ /* Jvm/jld.scm 175 */
obj_t BgL_auxz00_2258;obj_t BgL_auxz00_2256;
BgL_auxz00_2258 = 
CNST_TABLE_REF(((long)0)); 
BgL_auxz00_2256 = 
CAR(BgL_ezd2151zd2_685); 
BgL_testz00_2255 = 
(BgL_auxz00_2256==BgL_auxz00_2258); } 
if(BgL_testz00_2255)
{ /* Jvm/jld.scm 175 */
if(
PAIRP(BgL_cdrzd2157zd2_687))
{ /* Jvm/jld.scm 175 */
obj_t BgL_arg1968z00_690;obj_t BgL_arg1969z00_691;
BgL_arg1968z00_690 = 
CAR(BgL_cdrzd2157zd2_687); 
BgL_arg1969z00_691 = 
CDR(BgL_cdrzd2157zd2_687); 
{ /* Jvm/jld.scm 175 */
obj_t BgL_arg1991z00_1409;
BgL_arg1991z00_1409 = 
BGl_dirnamez00zz__osz00(BgL_sourcez00_1786); 
BgL_modz00_704 = BgL_arg1968z00_690; 
BgL_basez00_705 = BgL_arg1991z00_1409; 
BgL_clausesz00_706 = BgL_arg1969z00_691; 
{ 
obj_t BgL_clausesz00_708;obj_t BgL_classesz00_709;
BgL_clausesz00_708 = BgL_clausesz00_706; 
BgL_classesz00_709 = BNIL; 
BgL_loopz00_710:
if(
NULLP(BgL_clausesz00_708))
{ /* Jvm/jld.scm 145 */
return BgL_classesz00_709;}  else 
{ 
obj_t BgL_statexpz00_712;
{ /* Jvm/jld.scm 147 */
obj_t BgL_ezd2128zd2_715;
BgL_ezd2128zd2_715 = 
CAR(BgL_clausesz00_708); 
if(
PAIRP(BgL_ezd2128zd2_715))
{ /* Jvm/jld.scm 147 */
obj_t BgL_carzd2131zd2_717;
BgL_carzd2131zd2_717 = 
CAR(BgL_ezd2128zd2_715); 
{ 

{ /* Jvm/jld.scm 147 */
bool_t BgL_testz00_2272;
{ /* Jvm/jld.scm 147 */
obj_t BgL_auxz00_2273;
BgL_auxz00_2273 = 
CNST_TABLE_REF(((long)6)); 
BgL_testz00_2272 = 
(BgL_carzd2131zd2_717==BgL_auxz00_2273); } 
if(BgL_testz00_2272)
{ /* Jvm/jld.scm 147 */
BgL_kapzd2133zd2_718:
BgL_statexpz00_712 = 
CDR(BgL_ezd2128zd2_715); 
{ 
obj_t BgL_statexpz00_722;obj_t BgL_classesz00_723;
BgL_statexpz00_722 = BgL_statexpz00_712; 
BgL_classesz00_723 = BgL_classesz00_709; 
BgL_liipz00_724:
if(
NULLP(BgL_statexpz00_722))
{ 
obj_t BgL_classesz00_2280;obj_t BgL_clausesz00_2278;
BgL_clausesz00_2278 = 
CDR(BgL_clausesz00_708); 
BgL_classesz00_2280 = BgL_classesz00_723; 
BgL_classesz00_709 = BgL_classesz00_2280; 
BgL_clausesz00_708 = BgL_clausesz00_2278; 
goto BgL_loopz00_710;}  else 
{ 
obj_t BgL_identz00_727;
{ /* Jvm/jld.scm 154 */
obj_t BgL_ezd2137zd2_730;
BgL_ezd2137zd2_730 = 
CAR(BgL_statexpz00_722); 
if(
PAIRP(BgL_ezd2137zd2_730))
{ /* Jvm/jld.scm 154 */
obj_t BgL_carzd2140zd2_732;obj_t BgL_cdrzd2141zd2_733;
BgL_carzd2140zd2_732 = 
CAR(BgL_ezd2137zd2_730); 
BgL_cdrzd2141zd2_733 = 
CDR(BgL_ezd2137zd2_730); 
{ 

{ /* Jvm/jld.scm 154 */
bool_t BgL_testz00_2286;
{ /* Jvm/jld.scm 154 */
obj_t BgL_auxz00_2287;
BgL_auxz00_2287 = 
CNST_TABLE_REF(((long)2)); 
BgL_testz00_2286 = 
(BgL_carzd2140zd2_732==BgL_auxz00_2287); } 
if(BgL_testz00_2286)
{ /* Jvm/jld.scm 154 */
BgL_kapzd2142zd2_734:
if(
PAIRP(BgL_cdrzd2141zd2_733))
{ /* Jvm/jld.scm 154 */
BgL_identz00_727 = 
CAR(BgL_cdrzd2141zd2_733); 
{ /* Jvm/jld.scm 157 */
obj_t BgL_idz00_741;
BgL_idz00_753 = BgL_identz00_727; 
{ /* Jvm/jld.scm 126 */
obj_t BgL_stringz00_755;
BgL_stringz00_755 = 
SYMBOL_TO_STRING(BgL_idz00_753); 
{ /* Jvm/jld.scm 126 */
int BgL_lenz00_756;
BgL_lenz00_756 = 
STRING_LENGTH(BgL_stringz00_755); 
{ /* Jvm/jld.scm 127 */

{ 
long BgL_walkerz00_757;
BgL_walkerz00_757 = ((long)0); 
BgL_loopz00_758:
{ /* Jvm/jld.scm 130 */
bool_t BgL_testz00_2294;
{ /* Jvm/jld.scm 130 */
long BgL_auxz00_2295;
BgL_auxz00_2295 = 
(long)(BgL_lenz00_756); 
BgL_testz00_2294 = 
(BgL_walkerz00_757==BgL_auxz00_2295); } 
if(BgL_testz00_2294)
{ /* Jvm/jld.scm 130 */
BgL_idz00_741 = BgL_idz00_753; }  else 
{ /* Jvm/jld.scm 132 */
bool_t BgL_testz00_2298;
{ /* Jvm/jld.scm 132 */
bool_t BgL_testz00_2299;
{ /* Jvm/jld.scm 132 */
unsigned char BgL_auxz00_2300;
{ /* Jvm/jld.scm 132 */
int BgL_auxz00_2301;
BgL_auxz00_2301 = 
(int)(BgL_walkerz00_757); 
BgL_auxz00_2300 = 
STRING_REF(BgL_stringz00_755, BgL_auxz00_2301); } 
BgL_testz00_2299 = 
(BgL_auxz00_2300==((unsigned char)':')); } 
if(BgL_testz00_2299)
{ /* Jvm/jld.scm 133 */
bool_t BgL_testz00_2305;
{ /* Jvm/jld.scm 133 */
long BgL_auxz00_2306;
{ /* Jvm/jld.scm 133 */
long BgL_auxz00_2307;
BgL_auxz00_2307 = 
(long)(BgL_lenz00_756); 
BgL_auxz00_2306 = 
(BgL_auxz00_2307-((long)1)); } 
BgL_testz00_2305 = 
(BgL_walkerz00_757<BgL_auxz00_2306); } 
if(BgL_testz00_2305)
{ /* Jvm/jld.scm 134 */
unsigned char BgL_auxz00_2311;
{ /* Jvm/jld.scm 134 */
int BgL_auxz00_2312;
{ /* Jvm/jld.scm 134 */
long BgL_auxz00_2313;
BgL_auxz00_2313 = 
(BgL_walkerz00_757+((long)1)); 
BgL_auxz00_2312 = 
(int)(BgL_auxz00_2313); } 
BgL_auxz00_2311 = 
STRING_REF(BgL_stringz00_755, BgL_auxz00_2312); } 
BgL_testz00_2298 = 
(BgL_auxz00_2311==((unsigned char)':')); }  else 
{ /* Jvm/jld.scm 133 */
BgL_testz00_2298 = ((bool_t)0)
; } }  else 
{ /* Jvm/jld.scm 132 */
BgL_testz00_2298 = ((bool_t)0)
; } } 
if(BgL_testz00_2298)
{ /* Jvm/jld.scm 132 */
{ /* Jvm/jld.scm 135 */
obj_t BgL_arg2091z00_761;
{ /* Jvm/jld.scm 135 */
int BgL_auxz00_2320;int BgL_auxz00_2318;
BgL_auxz00_2320 = 
(int)(BgL_walkerz00_757); 
BgL_auxz00_2318 = 
(int)(((long)0)); 
BgL_arg2091z00_761 = 
c_substring(BgL_stringz00_755, BgL_auxz00_2318, BgL_auxz00_2320); } 
{ /* Jvm/jld.scm 135 */
char * BgL_auxz00_2323;
BgL_auxz00_2323 = 
BSTRING_TO_STRING(BgL_arg2091z00_761); 
BgL_idz00_741 = 
string_to_symbol(BgL_auxz00_2323); } } }  else 
{ /* Jvm/jld.scm 132 */
{ 
long BgL_walkerz00_2326;
BgL_walkerz00_2326 = 
(BgL_walkerz00_757+((long)1)); 
BgL_walkerz00_757 = BgL_walkerz00_2326; 
goto BgL_loopz00_758;} } } } } } } } 
{ /* Jvm/jld.scm 157 */
obj_t BgL_mglz00_742;
{ /* Jvm/jld.scm 159 */
obj_t BgL_arg2067z00_747;
BgL_arg2067z00_747 = 
BGl_jvmzd2classzd2manglez00zzjvm_externz00(BgL_idz00_741, BgL_modz00_704); 
BgL_mglz00_742 = 
SYMBOL_TO_STRING(BgL_arg2067z00_747); } 
{ /* Jvm/jld.scm 158 */

{ /* Jvm/jld.scm 160 */
obj_t BgL_arg2054z00_743;obj_t BgL_arg2055z00_744;
BgL_arg2054z00_743 = 
CDR(BgL_statexpz00_722); 
{ /* Jvm/jld.scm 163 */
obj_t BgL_arg2059z00_745;
{ /* Jvm/jld.scm 163 */
obj_t BgL_arg2063z00_746;
BgL_arg2063z00_746 = 
string_append(BgL_mglz00_742, BGl_string3516z00zzjvm_ldz00); 
BgL_arg2059z00_745 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_basez00_705, BgL_arg2063z00_746); } 
BgL_arg2055z00_744 = 
MAKE_PAIR(BgL_arg2059z00_745, BgL_classesz00_723); } 
{ 
obj_t BgL_classesz00_2335;obj_t BgL_statexpz00_2334;
BgL_statexpz00_2334 = BgL_arg2054z00_743; 
BgL_classesz00_2335 = BgL_arg2055z00_744; 
BgL_classesz00_723 = BgL_classesz00_2335; 
BgL_statexpz00_722 = BgL_statexpz00_2334; 
goto BgL_liipz00_724;} } } } } }  else 
{ /* Jvm/jld.scm 154 */
BgL_tagzd2136zd2_729:
{ 
obj_t BgL_statexpz00_2337;
BgL_statexpz00_2337 = 
CDR(BgL_statexpz00_722); 
BgL_statexpz00_722 = BgL_statexpz00_2337; 
goto BgL_liipz00_724;} } }  else 
{ /* Jvm/jld.scm 154 */
bool_t BgL_testz00_2339;
{ /* Jvm/jld.scm 154 */
obj_t BgL_auxz00_2340;
BgL_auxz00_2340 = 
CNST_TABLE_REF(((long)3)); 
BgL_testz00_2339 = 
(BgL_carzd2140zd2_732==BgL_auxz00_2340); } 
if(BgL_testz00_2339)
{ /* Jvm/jld.scm 154 */
goto BgL_kapzd2142zd2_734;}  else 
{ /* Jvm/jld.scm 154 */
bool_t BgL_testz00_2343;
{ /* Jvm/jld.scm 154 */
obj_t BgL_auxz00_2344;
BgL_auxz00_2344 = 
CNST_TABLE_REF(((long)4)); 
BgL_testz00_2343 = 
(BgL_carzd2140zd2_732==BgL_auxz00_2344); } 
if(BgL_testz00_2343)
{ /* Jvm/jld.scm 154 */
goto BgL_kapzd2142zd2_734;}  else 
{ /* Jvm/jld.scm 154 */
bool_t BgL_testz00_2347;
{ /* Jvm/jld.scm 154 */
obj_t BgL_auxz00_2348;
BgL_auxz00_2348 = 
CNST_TABLE_REF(((long)5)); 
BgL_testz00_2347 = 
(BgL_carzd2140zd2_732==BgL_auxz00_2348); } 
if(BgL_testz00_2347)
{ /* Jvm/jld.scm 154 */
goto BgL_kapzd2142zd2_734;}  else 
{ /* Jvm/jld.scm 154 */
goto BgL_tagzd2136zd2_729;} } } } } } }  else 
{ /* Jvm/jld.scm 154 */
goto BgL_tagzd2136zd2_729;} } } } }  else 
{ /* Jvm/jld.scm 147 */
bool_t BgL_testz00_2352;
{ /* Jvm/jld.scm 147 */
obj_t BgL_auxz00_2353;
BgL_auxz00_2353 = 
CNST_TABLE_REF(((long)7)); 
BgL_testz00_2352 = 
(BgL_carzd2131zd2_717==BgL_auxz00_2353); } 
if(BgL_testz00_2352)
{ /* Jvm/jld.scm 147 */
goto BgL_kapzd2133zd2_718;}  else 
{ /* Jvm/jld.scm 147 */
BgL_tagzd2127zd2_714:
{ 
obj_t BgL_clausesz00_2356;
BgL_clausesz00_2356 = 
CDR(BgL_clausesz00_708); 
BgL_clausesz00_708 = BgL_clausesz00_2356; 
goto BgL_loopz00_710;} } } } } }  else 
{ /* Jvm/jld.scm 147 */
goto BgL_tagzd2127zd2_714;} } } } } }  else 
{ /* Jvm/jld.scm 175 */
return BNIL;} }  else 
{ /* Jvm/jld.scm 175 */
return BNIL;} } }  else 
{ /* Jvm/jld.scm 175 */
return BNIL;} } } } } } 
}



/* <anonymous:1952> */
obj_t BGl_zc3anonymousza31952ze3z83zzjvm_ldz00(obj_t BgL_envz00_1787)
{ AN_OBJECT;
{ /* Jvm/jld.scm 175 */
{ /* Jvm/jld.scm 175 */
obj_t BgL_zc3anonymousza31960ze3z83_1790;obj_t BgL_escapez00_1791;
{ /* Jvm/jld.scm 175 */
int BgL_auxz00_2358;
BgL_auxz00_2358 = 
(int)(((long)2)); 
BgL_zc3anonymousza31960ze3z83_1790 = 
PROCEDURE_REF(BgL_envz00_1787, BgL_auxz00_2358); } 
{ /* Jvm/jld.scm 175 */
int BgL_auxz00_2361;
BgL_auxz00_2361 = 
(int)(((long)3)); 
BgL_escapez00_1791 = 
PROCEDURE_REF(BgL_envz00_1787, BgL_auxz00_2361); } 
{ 

return 
BGl_addzd2errorzd2handlerz12z12zz__errorz00(BgL_zc3anonymousza31960ze3z83_1790, BgL_escapez00_1791);} } } 
}



/* escape_3223 */
obj_t BGl_escape_3223z00zzjvm_ldz00(obj_t BgL_envz00_1792, obj_t BgL_val1597z00_1794)
{ AN_OBJECT;
{ /* Jvm/jld.scm 175 */
{ /* Jvm/jld.scm 175 */
obj_t BgL_an_exitd1596z00_1793;
{ /* Jvm/jld.scm 175 */
int BgL_auxz00_2365;
BgL_auxz00_2365 = 
(int)(((long)0)); 
BgL_an_exitd1596z00_1793 = 
PROCEDURE_REF(BgL_envz00_1792, BgL_auxz00_2365); } 
{ 
obj_t BgL_val1597z00_661;
BgL_val1597z00_661 = BgL_val1597z00_1794; 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1596z00_1793, BgL_val1597z00_661);} } } 
}



/* <anonymous:1960> */
obj_t BGl_zc3anonymousza31960ze3z83zzjvm_ldz00(obj_t BgL_envz00_1795, obj_t BgL_escz00_1797, obj_t BgL_objz00_1798, obj_t BgL_procz00_1799, obj_t BgL_msgz00_1800)
{ AN_OBJECT;
{ /* Jvm/jld.scm 175 */
{ /* Jvm/jld.scm 175 */
obj_t BgL_armed1594z00_1796;
{ /* Jvm/jld.scm 175 */
int BgL_auxz00_2369;
BgL_auxz00_2369 = 
(int)(((long)0)); 
BgL_armed1594z00_1796 = 
PROCEDURE_REF(BgL_envz00_1795, BgL_auxz00_2369); } 
{ 
obj_t BgL_escz00_675;obj_t BgL_objz00_676;obj_t BgL_procz00_677;obj_t BgL_msgz00_678;
BgL_escz00_675 = BgL_escz00_1797; 
BgL_objz00_676 = BgL_objz00_1798; 
BgL_procz00_677 = BgL_procz00_1799; 
BgL_msgz00_678 = BgL_msgz00_1800; 
CELL_SET(BgL_armed1594z00_1796, BFALSE); 
BGl_removezd2errorzd2handlerz12z12zz__errorz00(); 
return 
PROCEDURE_ENTRY(BgL_escz00_675)(BgL_escz00_675, BNIL, BEOA);} } } 
}



/* jvm-jar */
obj_t BGl_jvmzd2jarzd2zzjvm_ldz00(obj_t BgL_targetz00_5, obj_t BgL_manifestz00_6, obj_t BgL_objectsz00_7)
{ AN_OBJECT;
{ /* Jvm/jld.scm 201 */
{ /* Jvm/jld.scm 202 */
obj_t BgL_cmdz00_773;
{ 
obj_t BgL_objectsz00_789;obj_t BgL_cmdz00_790;
BgL_objectsz00_789 = BgL_objectsz00_7; 
BgL_cmdz00_790 = BGl_string3520z00zzjvm_ldz00; 
BgL_loopz00_791:
if(
NULLP(BgL_objectsz00_789))
{ /* Jvm/jld.scm 205 */
obj_t BgL_list2153z00_793;
{ /* Jvm/jld.scm 205 */
obj_t BgL_arg2155z00_794;
{ /* Jvm/jld.scm 205 */
obj_t BgL_arg2159z00_796;
{ /* Jvm/jld.scm 205 */
obj_t BgL_arg2162z00_797;
{ /* Jvm/jld.scm 205 */
obj_t BgL_arg2166z00_799;
{ /* Jvm/jld.scm 205 */
obj_t BgL_arg2169z00_800;
{ /* Jvm/jld.scm 205 */
obj_t BgL_arg2173z00_802;
BgL_arg2173z00_802 = 
MAKE_PAIR(BgL_cmdz00_790, BNIL); 
BgL_arg2169z00_800 = 
MAKE_PAIR(BGl_string3525z00zzjvm_ldz00, BgL_arg2173z00_802); } 
BgL_arg2166z00_799 = 
MAKE_PAIR(BgL_targetz00_5, BgL_arg2169z00_800); } 
BgL_arg2162z00_797 = 
MAKE_PAIR(BGl_string3525z00zzjvm_ldz00, BgL_arg2166z00_799); } 
BgL_arg2159z00_796 = 
MAKE_PAIR(BgL_manifestz00_6, BgL_arg2162z00_797); } 
BgL_arg2155z00_794 = 
MAKE_PAIR(BGl_string3525z00zzjvm_ldz00, BgL_arg2159z00_796); } 
{ /* Jvm/jld.scm 205 */
obj_t BgL_auxz00_2383;
BgL_auxz00_2383 = 
string_to_bstring(BGL_JAR); 
BgL_list2153z00_793 = 
MAKE_PAIR(BgL_auxz00_2383, BgL_arg2155z00_794); } } 
BgL_cmdz00_773 = 
BGl_stringzd2appendzd2zz__r4_strings_6_7z00(BgL_list2153z00_793); }  else 
{ /* Jvm/jld.scm 208 */
obj_t BgL_arg2177z00_803;obj_t BgL_arg2178z00_804;
BgL_arg2177z00_803 = 
CDR(BgL_objectsz00_789); 
{ /* Jvm/jld.scm 209 */
obj_t BgL_auxz00_2388;
BgL_auxz00_2388 = 
CAR(BgL_objectsz00_789); 
BgL_arg2178z00_804 = 
string_append_3(BgL_auxz00_2388, BGl_string3525z00zzjvm_ldz00, BgL_cmdz00_790); } 
{ 
obj_t BgL_cmdz00_2392;obj_t BgL_objectsz00_2391;
BgL_objectsz00_2391 = BgL_arg2177z00_803; 
BgL_cmdz00_2392 = BgL_arg2178z00_804; 
BgL_cmdz00_790 = BgL_cmdz00_2392; 
BgL_objectsz00_789 = BgL_objectsz00_2391; 
goto BgL_loopz00_791;} } } 
{ /* Jvm/jld.scm 210 */
obj_t BgL_list2119z00_774;
{ /* Jvm/jld.scm 210 */
obj_t BgL_arg2122z00_776;
{ /* Jvm/jld.scm 210 */
obj_t BgL_arg2125z00_777;
BgL_arg2125z00_777 = 
MAKE_PAIR(BGl_string3526z00zzjvm_ldz00, BNIL); 
BgL_arg2122z00_776 = 
MAKE_PAIR(BgL_cmdz00_773, BgL_arg2125z00_777); } 
BgL_list2119z00_774 = 
MAKE_PAIR(BGl_string3527z00zzjvm_ldz00, BgL_arg2122z00_776); } 
BGl_verbosez00zztools_speekz00(
BINT(((long)2)), BgL_list2119z00_774); } 
{ /* Jvm/jld.scm 211 */
obj_t BgL_val1599z00_778;
BgL_val1599z00_778 = 
BGl_handling_function2137z00zzjvm_ldz00(BgL_targetz00_5, BgL_cmdz00_773); 
{ /* Jvm/jld.scm 215 */
char * BgL_auxz00_2399;
BgL_auxz00_2399 = 
BSTRING_TO_STRING(BgL_manifestz00_6); 
unlink(BgL_auxz00_2399); } 
{ /* Jvm/jld.scm 215 */
bool_t BgL_test2129z00_779;
{ /* Jvm/jld.scm 215 */
obj_t BgL_auxz00_2402;
BgL_auxz00_2402 = 
BGl_valzd2fromzd2exitzf3zf3zz__bexitz00(BgL_val1599z00_778); 
BgL_test2129z00_779 = 
CBOOL(BgL_auxz00_2402); } 
if(BgL_test2129z00_779)
{ /* Jvm/jld.scm 215 */
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(
CAR(BgL_val1599z00_778), 
CDR(BgL_val1599z00_778));}  else 
{ /* Jvm/jld.scm 215 */
return BgL_val1599z00_778;} } } } } 
}



/* handling_function2137 */
obj_t BGl_handling_function2137z00zzjvm_ldz00(obj_t BgL_targetz00_1830, obj_t BgL_cmdz00_1829)
{ AN_OBJECT;
{ /* Jvm/jld.scm 215 */
jmp_buf jmpbuf; 
obj_t BgL_an_exit1600z00_783;
if( SET_EXIT(BgL_an_exit1600z00_783) ) { RESTORE_TRACE(); 
return 
_exit_value_;
} else {
BgL_an_exit1600z00_783 = 
(obj_t)jmpbuf; 
{ /* Jvm/jld.scm 215 */

PUSH_EXIT(BgL_an_exit1600z00_783, ((bool_t)0)); 
{ /* Jvm/jld.scm 212 */
obj_t BgL_val1601z00_784;
{ /* Jvm/jld.scm 212 */
bool_t BgL_test2141z00_785;
{ /* Jvm/jld.scm 212 */
obj_t BgL_arg2144z00_786;
{ /* Jvm/jld.scm 212 */
obj_t BgL_list2148z00_788;
BgL_list2148z00_788 = 
MAKE_PAIR(BgL_cmdz00_1829, BNIL); 
BgL_arg2144z00_786 = 
BGl_systemz00zz__osz00(BgL_list2148z00_788); } 
{ /* Jvm/jld.scm 212 */
long BgL_auxz00_2414;
BgL_auxz00_2414 = 
(long)CINT(BgL_arg2144z00_786); 
BgL_test2141z00_785 = 
(BgL_auxz00_2414==((long)0)); } } 
if(BgL_test2141z00_785)
{ /* Jvm/jld.scm 212 */
BgL_val1601z00_784 = BTRUE; }  else 
{ 
obj_t BgL_auxz00_2418;
BgL_auxz00_2418 = 
string_to_bstring(BGL_JAR); 
FAILURE(BgL_auxz00_2418,BGl_string3528z00zzjvm_ldz00,BgL_targetz00_1830);} } 
POP_EXIT(); 
return BgL_val1601z00_784;} } 
} } 
}



/* make-manifest-name */
obj_t BGl_makezd2manifestzd2namez00zzjvm_ldz00()
{ AN_OBJECT;
{ /* Jvm/jld.scm 220 */
{ 
obj_t BgL_namez00_807;
BgL_namez00_807 = BGl_string3530z00zzjvm_ldz00; 
BgL_loopz00_808:
{ /* Jvm/jld.scm 222 */
bool_t BgL_test2188z00_809;
{ /* Jvm/jld.scm 222 */
char * BgL_auxz00_2422;
BgL_auxz00_2422 = 
BSTRING_TO_STRING(BgL_namez00_807); 
BgL_test2188z00_809 = 
fexists(BgL_auxz00_2422); } 
if(BgL_test2188z00_809)
{ /* Jvm/jld.scm 224 */
obj_t BgL_arg2190z00_810;
BgL_arg2190z00_810 = 
string_append(BgL_namez00_807, BGl_string3529z00zzjvm_ldz00); 
{ 
obj_t BgL_namez00_2427;
BgL_namez00_2427 = BgL_arg2190z00_810; 
BgL_namez00_807 = BgL_namez00_2427; 
goto BgL_loopz00_808;} }  else 
{ /* Jvm/jld.scm 222 */
return BgL_namez00_807;} } } } 
}



/* jvm-classpath */
obj_t BGl_jvmzd2classpathzd2zzjvm_ldz00()
{ AN_OBJECT;
{ /* Jvm/jld.scm 229 */
{ /* Jvm/jld.scm 230 */
bool_t BgL_test2194z00_811;
{ /* Jvm/jld.scm 230 */
obj_t BgL_objz00_1464;
BgL_objz00_1464 = BGl_za2jvmzd2classpathza2zd2zzengine_paramz00; 
BgL_test2194z00_811 = 
STRINGP(BgL_objz00_1464); } 
if(BgL_test2194z00_811)
{ /* Jvm/jld.scm 230 */
return BGl_za2jvmzd2classpathza2zd2zzengine_paramz00;}  else 
{ /* Jvm/jld.scm 230 */
return 
string_to_bstring(ZIP_DIRECTORY);} } } 
}



/* generate-jvm-manifest */
obj_t BGl_generatezd2jvmzd2manifestz00zzjvm_ldz00(obj_t BgL_fnamez00_9, obj_t BgL_mainz00_10, obj_t BgL_jarnamez00_11, obj_t BgL_za7ipsza7_12)
{ AN_OBJECT;
{ /* Jvm/jld.scm 245 */
{ /* Jvm/jld.scm 247 */
bool_t BgL_test2198z00_813;
{ /* Jvm/jld.scm 247 */
obj_t BgL_string1z00_1467;
BgL_string1z00_1467 = BGl_za2jvmzd2shellza2zd2zzengine_paramz00; 
BgL_test2198z00_813 = 
bigloo_strcmp(BgL_string1z00_1467, BGl_string3531z00zzjvm_ldz00); } 
if(BgL_test2198z00_813)
{ /* Jvm/jld.scm 247 */
return 
BGl_generatezd2shzd2jvmzd2manifestzd2zzjvm_ldz00(BgL_fnamez00_9, BgL_mainz00_10, BgL_za7ipsza7_12);}  else 
{ /* Jvm/jld.scm 249 */
bool_t BgL_test2200z00_814;
{ /* Jvm/jld.scm 249 */
obj_t BgL_string1z00_1469;
BgL_string1z00_1469 = BGl_za2jvmzd2shellza2zd2zzengine_paramz00; 
BgL_test2200z00_814 = 
bigloo_strcmp(BgL_string1z00_1469, BGl_string3532z00zzjvm_ldz00); } 
if(BgL_test2200z00_814)
{ /* Jvm/jld.scm 249 */
return 
BGl_generatezd2msdoszd2jvmzd2manifestzd2zzjvm_ldz00(BgL_fnamez00_9, BgL_mainz00_10, BgL_jarnamez00_11);}  else 
{ /* Jvm/jld.scm 249 */
{ /* Jvm/jld.scm 252 */
obj_t BgL_list2203z00_815;
{ /* Jvm/jld.scm 252 */
obj_t BgL_arg2206z00_817;
{ /* Jvm/jld.scm 252 */
obj_t BgL_arg2210z00_819;
{ /* Jvm/jld.scm 252 */
obj_t BgL_arg2213z00_820;
BgL_arg2213z00_820 = 
MAKE_PAIR(BGl_string3533z00zzjvm_ldz00, BNIL); 
BgL_arg2210z00_819 = 
MAKE_PAIR(BGl_za2jvmzd2shellza2zd2zzengine_paramz00, BgL_arg2213z00_820); } 
BgL_arg2206z00_817 = 
MAKE_PAIR(BGl_string3534z00zzjvm_ldz00, BgL_arg2210z00_819); } 
BgL_list2203z00_815 = 
MAKE_PAIR(BGl_string3535z00zzjvm_ldz00, BgL_arg2206z00_817); } 
BGl_warningz00zz__errorz00(BgL_list2203z00_815); } 
return 
BGl_generatezd2shzd2jvmzd2manifestzd2zzjvm_ldz00(BgL_fnamez00_9, BgL_mainz00_10, BgL_za7ipsza7_12);} } } } 
}



/* generate-sh-jvm-manifest */
obj_t BGl_generatezd2shzd2jvmzd2manifestzd2zzjvm_ldz00(obj_t BgL_fnamez00_13, obj_t BgL_mainz00_14, obj_t BgL_za7ipsza7_15)
{ AN_OBJECT;
{ /* Jvm/jld.scm 259 */
{ /* Jvm/jld.scm 261 */
obj_t BgL_zc3anonymousza32222ze3z83_1802;
{ 
int BgL_auxz00_2445;int BgL_auxz00_2443;
BgL_auxz00_2445 = 
(int)(((long)2)); 
BgL_auxz00_2443 = 
(int)(((long)0)); 
BgL_zc3anonymousza32222ze3z83_1802 = 
make_fx_procedure(BGl_zc3anonymousza32222ze3z83zzjvm_ldz00, BgL_auxz00_2443, BgL_auxz00_2445); } 
{ /* Jvm/jld.scm 261 */
int BgL_auxz00_2448;
BgL_auxz00_2448 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32222ze3z83_1802, BgL_auxz00_2448, BgL_mainz00_14); } 
{ /* Jvm/jld.scm 261 */
int BgL_auxz00_2451;
BgL_auxz00_2451 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_zc3anonymousza32222ze3z83_1802, BgL_auxz00_2451, BgL_za7ipsza7_15); } 
return 
BGl_withzd2outputzd2tozd2filezd2zz__r4_ports_6_10_1z00(BgL_fnamez00_13, BgL_zc3anonymousza32222ze3z83_1802);} } 
}



/* <anonymous:2222> */
obj_t BGl_zc3anonymousza32222ze3z83zzjvm_ldz00(obj_t BgL_envz00_1803)
{ AN_OBJECT;
{ /* Jvm/jld.scm 261 */
{ /* Jvm/jld.scm 261 */
obj_t BgL_mainz00_1804;obj_t BgL_za7ipsza7_1805;
{ /* Jvm/jld.scm 261 */
int BgL_auxz00_2455;
BgL_auxz00_2455 = 
(int)(((long)0)); 
BgL_mainz00_1804 = 
PROCEDURE_REF(BgL_envz00_1803, BgL_auxz00_2455); } 
{ /* Jvm/jld.scm 261 */
int BgL_auxz00_2458;
BgL_auxz00_2458 = 
(int)(((long)1)); 
BgL_za7ipsza7_1805 = 
PROCEDURE_REF(BgL_envz00_1803, BgL_auxz00_2458); } 
{ 

{ /* Jvm/jld.scm 261 */
unsigned char BgL_auxz00_2461;
{ /* Jvm/jld.scm 262 */
obj_t BgL_arg2225z00_824;
BgL_arg2225z00_824 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3536z00zzjvm_ldz00, BgL_arg2225z00_824); } 
{ /* Jvm/jld.scm 262 */
obj_t BgL_arg2229z00_825;
BgL_arg2229z00_825 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2229z00_825); } 
{ /* Jvm/jld.scm 263 */
obj_t BgL_arg2234z00_827;
BgL_arg2234z00_827 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3537z00zzjvm_ldz00, BgL_arg2234z00_827); } 
{ /* Jvm/jld.scm 263 */
obj_t BgL_arg2238z00_828;
BgL_arg2238z00_828 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_mainz00_1804, BgL_arg2238z00_828); } 
{ /* Jvm/jld.scm 263 */
obj_t BgL_arg2242z00_829;
BgL_arg2242z00_829 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2242z00_829); } 
{ /* Jvm/jld.scm 264 */
obj_t BgL_arg2247z00_831;
BgL_arg2247z00_831 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3538z00zzjvm_ldz00, BgL_arg2247z00_831); } 
{ /* Jvm/jld.scm 265 */
obj_t BgL_arg2251z00_832;obj_t BgL_arg2252z00_833;
{ /* Jvm/jld.scm 265 */
obj_t BgL_arg2255z00_834;char * BgL_arg2256z00_835;
BgL_arg2255z00_834 = 
BGl_jvmzd2classpathzd2zzjvm_ldz00(); 
if(
CBOOL(BGl_za2unsafezd2libraryza2zd2zzengine_paramz00))
{ /* Jvm/jld.scm 266 */
BgL_arg2256z00_835 = "bigloo_u.zip"; }  else 
{ /* Jvm/jld.scm 266 */
BgL_arg2256z00_835 = "bigloo.zip"; } 
BgL_arg2251z00_832 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_arg2255z00_834, 
string_to_bstring(BgL_arg2256z00_835)); } 
BgL_arg2252z00_833 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg2251z00_832, BgL_arg2252z00_833); } 
{ 
obj_t BgL_l1602z00_836;
BgL_l1602z00_836 = BgL_za7ipsza7_1805; 
BgL_lname1603z00_837:
if(
PAIRP(BgL_l1602z00_836))
{ /* Jvm/jld.scm 269 */
{ /* Jvm/jld.scm 270 */
obj_t BgL_lz00_839;
BgL_lz00_839 = 
CAR(BgL_l1602z00_836); 
{ /* Jvm/jld.scm 270 */
obj_t BgL_arg2264z00_841;
BgL_arg2264z00_841 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3525z00zzjvm_ldz00, BgL_arg2264z00_841); } 
{ /* Jvm/jld.scm 271 */
obj_t BgL_arg2268z00_842;obj_t BgL_arg2269z00_843;
BgL_arg2268z00_842 = 
BGl_userzd2libraryzd2zzjvm_ldz00(BgL_lz00_839); 
BgL_arg2269z00_843 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg2268z00_842, BgL_arg2269z00_843); } } 
{ 
obj_t BgL_l1602z00_2489;
BgL_l1602z00_2489 = 
CDR(BgL_l1602z00_836); 
BgL_l1602z00_836 = BgL_l1602z00_2489; 
goto BgL_lname1603z00_837;} }  else 
{ /* Jvm/jld.scm 269 */((bool_t)1); } } 
{ /* Jvm/jld.scm 273 */
obj_t BgL_arg2280z00_845;
BgL_arg2280z00_845 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2280z00_845); } 
{ /* Jvm/jld.scm 274 */
obj_t BgL_arg2285z00_847;
BgL_arg2285z00_847 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3539z00zzjvm_ldz00, BgL_arg2285z00_847); } 
{ /* Jvm/jld.scm 274 */
obj_t BgL_arg2289z00_848;
BgL_arg2289z00_848 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_za2bigloozd2nameza2zd2zzengine_paramz00, BgL_arg2289z00_848); } 
{ /* Jvm/jld.scm 274 */
obj_t BgL_arg2293z00_849;
BgL_arg2293z00_849 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2293z00_849); } 
{ /* Jvm/jld.scm 275 */
obj_t BgL_arg2297z00_850;
BgL_arg2297z00_850 = 
GET_CURRENT_OUTPUT_PORT(); 
BgL_auxz00_2461 = 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2297z00_850); } 
return 
BCHAR(BgL_auxz00_2461);} } } } 
}



/* generate-msdos-jvm-manifest */
obj_t BGl_generatezd2msdoszd2jvmzd2manifestzd2zzjvm_ldz00(obj_t BgL_fnamez00_16, obj_t BgL_mainz00_17, obj_t BgL_jarnamez00_18)
{ AN_OBJECT;
{ /* Jvm/jld.scm 280 */
{ /* Jvm/jld.scm 282 */
obj_t BgL_zc3anonymousza32303ze3z83_1806;
{ 
int BgL_auxz00_2504;int BgL_auxz00_2502;
BgL_auxz00_2504 = 
(int)(((long)1)); 
BgL_auxz00_2502 = 
(int)(((long)0)); 
BgL_zc3anonymousza32303ze3z83_1806 = 
make_fx_procedure(BGl_zc3anonymousza32303ze3z83zzjvm_ldz00, BgL_auxz00_2502, BgL_auxz00_2504); } 
{ /* Jvm/jld.scm 282 */
int BgL_auxz00_2507;
BgL_auxz00_2507 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32303ze3z83_1806, BgL_auxz00_2507, BgL_mainz00_17); } 
return 
BGl_withzd2outputzd2tozd2filezd2zz__r4_ports_6_10_1z00(BgL_fnamez00_16, BgL_zc3anonymousza32303ze3z83_1806);} } 
}



/* <anonymous:2303> */
obj_t BGl_zc3anonymousza32303ze3z83zzjvm_ldz00(obj_t BgL_envz00_1807)
{ AN_OBJECT;
{ /* Jvm/jld.scm 282 */
{ /* Jvm/jld.scm 282 */
obj_t BgL_mainz00_1808;
{ /* Jvm/jld.scm 282 */
int BgL_auxz00_2511;
BgL_auxz00_2511 = 
(int)(((long)0)); 
BgL_mainz00_1808 = 
PROCEDURE_REF(BgL_envz00_1807, BgL_auxz00_2511); } 
{ 

{ /* Jvm/jld.scm 282 */
unsigned char BgL_auxz00_2514;
{ /* Jvm/jld.scm 283 */
obj_t BgL_arg2306z00_855;
BgL_arg2306z00_855 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3536z00zzjvm_ldz00, BgL_arg2306z00_855); } 
{ /* Jvm/jld.scm 283 */
obj_t BgL_arg2310z00_856;
BgL_arg2310z00_856 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2310z00_856); } 
{ /* Jvm/jld.scm 284 */
obj_t BgL_arg2315z00_858;
BgL_arg2315z00_858 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3537z00zzjvm_ldz00, BgL_arg2315z00_858); } 
{ /* Jvm/jld.scm 284 */
obj_t BgL_arg2319z00_859;
BgL_arg2319z00_859 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_mainz00_1808, BgL_arg2319z00_859); } 
{ /* Jvm/jld.scm 284 */
obj_t BgL_arg2323z00_860;
BgL_arg2323z00_860 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2323z00_860); } 
{ /* Jvm/jld.scm 285 */
obj_t BgL_arg2328z00_862;
BgL_arg2328z00_862 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3539z00zzjvm_ldz00, BgL_arg2328z00_862); } 
{ /* Jvm/jld.scm 285 */
obj_t BgL_arg2332z00_863;
BgL_arg2332z00_863 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_za2bigloozd2nameza2zd2zzengine_paramz00, BgL_arg2332z00_863); } 
{ /* Jvm/jld.scm 285 */
obj_t BgL_arg2336z00_864;
BgL_arg2336z00_864 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2336z00_864); } 
{ /* Jvm/jld.scm 286 */
obj_t BgL_arg2340z00_865;
BgL_arg2340z00_865 = 
GET_CURRENT_OUTPUT_PORT(); 
BgL_auxz00_2514 = 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2340z00_865); } 
return 
BCHAR(BgL_auxz00_2514);} } } } 
}



/* generate-jvm-sh-script */
bool_t BGl_generatezd2jvmzd2shzd2scriptzd2zzjvm_ldz00(obj_t BgL_targetz00_19, obj_t BgL_mainzd2classzd2_20, obj_t BgL_pathz00_21, obj_t BgL_za7ipsza7_22)
{ AN_OBJECT;
{ /* Jvm/jld.scm 291 */
{ 

if(
CBOOL(BGl_za2jvmzd2jarzf3za2z21zzengine_paramz00))
{ /* Jvm/jld.scm 347 */
{ /* Jvm/jld.scm 302 */
obj_t BgL_zc3anonymousza32514ze3z83_1811;
{ 
int BgL_auxz00_2538;int BgL_auxz00_2536;
BgL_auxz00_2538 = 
(int)(((long)1)); 
BgL_auxz00_2536 = 
(int)(((long)0)); 
BgL_zc3anonymousza32514ze3z83_1811 = 
make_fx_procedure(BGl_zc3anonymousza32514ze3z83zzjvm_ldz00, BgL_auxz00_2536, BgL_auxz00_2538); } 
{ /* Jvm/jld.scm 302 */
int BgL_auxz00_2541;
BgL_auxz00_2541 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32514ze3z83_1811, BgL_auxz00_2541, BgL_targetz00_19); } 
BGl_withzd2outputzd2tozd2filezd2zz__r4_ports_6_10_1z00(BgL_targetz00_19, BgL_zc3anonymousza32514ze3z83_1811); } 
{ /* Jvm/jld.scm 320 */
obj_t BgL_list2617z00_975;
{ /* Jvm/jld.scm 320 */
obj_t BgL_arg2619z00_976;obj_t BgL_arg2620z00_977;
BgL_arg2619z00_976 = 
CNST_TABLE_REF(((long)8)); 
{ /* Jvm/jld.scm 320 */
obj_t BgL_arg2623z00_978;obj_t BgL_arg2624z00_979;
BgL_arg2623z00_978 = 
CNST_TABLE_REF(((long)9)); 
{ /* Jvm/jld.scm 320 */
obj_t BgL_auxz00_2547;
BgL_auxz00_2547 = 
CNST_TABLE_REF(((long)10)); 
BgL_arg2624z00_979 = 
MAKE_PAIR(BgL_auxz00_2547, BNIL); } 
BgL_arg2620z00_977 = 
MAKE_PAIR(BgL_arg2623z00_978, BgL_arg2624z00_979); } 
BgL_list2617z00_975 = 
MAKE_PAIR(BgL_arg2619z00_976, BgL_arg2620z00_977); } 
return 
BGl_chmodz00zz__osz00(BgL_targetz00_19, BgL_list2617z00_975);} }  else 
{ /* Jvm/jld.scm 347 */
{ /* Jvm/jld.scm 323 */
obj_t BgL_zc3anonymousza32349ze3z83_1812;
{ 
int BgL_auxz00_2555;int BgL_auxz00_2553;
BgL_auxz00_2555 = 
(int)(((long)3)); 
BgL_auxz00_2553 = 
(int)(((long)0)); 
BgL_zc3anonymousza32349ze3z83_1812 = 
make_fx_procedure(BGl_zc3anonymousza32349ze3z83zzjvm_ldz00, BgL_auxz00_2553, BgL_auxz00_2555); } 
{ /* Jvm/jld.scm 323 */
int BgL_auxz00_2558;
BgL_auxz00_2558 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32349ze3z83_1812, BgL_auxz00_2558, BgL_za7ipsza7_22); } 
{ /* Jvm/jld.scm 323 */
int BgL_auxz00_2561;
BgL_auxz00_2561 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_zc3anonymousza32349ze3z83_1812, BgL_auxz00_2561, BgL_pathz00_21); } 
{ /* Jvm/jld.scm 323 */
int BgL_auxz00_2564;
BgL_auxz00_2564 = 
(int)(((long)2)); 
PROCEDURE_SET(BgL_zc3anonymousza32349ze3z83_1812, BgL_auxz00_2564, BgL_mainzd2classzd2_20); } 
BGl_withzd2outputzd2tozd2filezd2zz__r4_ports_6_10_1z00(BgL_targetz00_19, BgL_zc3anonymousza32349ze3z83_1812); } 
{ /* Jvm/jld.scm 346 */
obj_t BgL_list2500z00_933;
{ /* Jvm/jld.scm 346 */
obj_t BgL_arg2502z00_934;obj_t BgL_arg2503z00_935;
BgL_arg2502z00_934 = 
CNST_TABLE_REF(((long)8)); 
{ /* Jvm/jld.scm 346 */
obj_t BgL_arg2506z00_936;obj_t BgL_arg2507z00_937;
BgL_arg2506z00_936 = 
CNST_TABLE_REF(((long)9)); 
{ /* Jvm/jld.scm 346 */
obj_t BgL_auxz00_2570;
BgL_auxz00_2570 = 
CNST_TABLE_REF(((long)10)); 
BgL_arg2507z00_937 = 
MAKE_PAIR(BgL_auxz00_2570, BNIL); } 
BgL_arg2503z00_935 = 
MAKE_PAIR(BgL_arg2506z00_936, BgL_arg2507z00_937); } 
BgL_list2500z00_933 = 
MAKE_PAIR(BgL_arg2502z00_934, BgL_arg2503z00_935); } 
return 
BGl_chmodz00zz__osz00(BgL_targetz00_19, BgL_list2500z00_933);} } } } 
}



/* generate-jvm-env */
obj_t BGl_generatezd2jvmzd2envz00zzjvm_ldz00()
{ AN_OBJECT;
{ /* Jvm/jld.scm 299 */
return 
BGl_loopz00zzjvm_ldz00(BGl_za2jvmzd2envza2zd2zzengine_paramz00, BGl_string3520z00zzjvm_ldz00);} 
}



/* loop */
obj_t BGl_loopz00zzjvm_ldz00(obj_t BgL_envz00_981, obj_t BgL_resz00_982)
{ AN_OBJECT;
{ /* Jvm/jld.scm 293 */
BGl_loopz00zzjvm_ldz00:
if(
NULLP(BgL_envz00_981))
{ /* Jvm/jld.scm 295 */
return BgL_resz00_982;}  else 
{ /* Jvm/jld.scm 297 */
obj_t BgL_arg2631z00_985;obj_t BgL_arg2632z00_986;
BgL_arg2631z00_985 = 
CDR(BgL_envz00_981); 
{ /* Jvm/jld.scm 298 */
obj_t BgL_arg2637z00_988;obj_t BgL_arg2639z00_990;
BgL_arg2637z00_988 = 
CAR(BgL_envz00_981); 
BgL_arg2639z00_990 = 
CAR(BgL_envz00_981); 
{ /* Jvm/jld.scm 298 */
obj_t BgL_list2642z00_992;
{ /* Jvm/jld.scm 298 */
obj_t BgL_arg2644z00_993;
{ /* Jvm/jld.scm 298 */
obj_t BgL_arg2647z00_994;
{ /* Jvm/jld.scm 298 */
obj_t BgL_arg2650z00_995;
{ /* Jvm/jld.scm 298 */
obj_t BgL_arg2653z00_996;
{ /* Jvm/jld.scm 298 */
obj_t BgL_arg2656z00_997;
BgL_arg2656z00_997 = 
MAKE_PAIR(BgL_resz00_982, BNIL); 
BgL_arg2653z00_996 = 
MAKE_PAIR(BGl_string3525z00zzjvm_ldz00, BgL_arg2656z00_997); } 
BgL_arg2650z00_995 = 
MAKE_PAIR(BgL_arg2639z00_990, BgL_arg2653z00_996); } 
BgL_arg2647z00_994 = 
MAKE_PAIR(BGl_string3540z00zzjvm_ldz00, BgL_arg2650z00_995); } 
BgL_arg2644z00_993 = 
MAKE_PAIR(BgL_arg2637z00_988, BgL_arg2647z00_994); } 
BgL_list2642z00_992 = 
MAKE_PAIR(BGl_string3541z00zzjvm_ldz00, BgL_arg2644z00_993); } 
BgL_arg2632z00_986 = 
BGl_stringzd2appendzd2zz__r4_strings_6_7z00(BgL_list2642z00_992); } } 
{ 
obj_t BgL_resz00_2590;obj_t BgL_envz00_2589;
BgL_envz00_2589 = BgL_arg2631z00_985; 
BgL_resz00_2590 = BgL_arg2632z00_986; 
BgL_resz00_982 = BgL_resz00_2590; 
BgL_envz00_981 = BgL_envz00_2589; 
goto BGl_loopz00zzjvm_ldz00;} } } 
}



/* <anonymous:2514> */
obj_t BGl_zc3anonymousza32514ze3z83zzjvm_ldz00(obj_t BgL_envz00_1813)
{ AN_OBJECT;
{ /* Jvm/jld.scm 302 */
{ /* Jvm/jld.scm 302 */
obj_t BgL_targetz00_1814;
{ /* Jvm/jld.scm 302 */
int BgL_auxz00_2591;
BgL_auxz00_2591 = 
(int)(((long)0)); 
BgL_targetz00_1814 = 
PROCEDURE_REF(BgL_envz00_1813, BgL_auxz00_2591); } 
{ 

{ /* Jvm/jld.scm 302 */
unsigned char BgL_auxz00_2594;
{ /* Jvm/jld.scm 303 */
obj_t BgL_arg2517z00_942;
BgL_arg2517z00_942 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3542z00zzjvm_ldz00, BgL_arg2517z00_942); } 
{ /* Jvm/jld.scm 303 */
obj_t BgL_arg2521z00_943;
BgL_arg2521z00_943 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2521z00_943); } 
{ /* Jvm/jld.scm 304 */
obj_t BgL_arg2525z00_944;
BgL_arg2525z00_944 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2525z00_944); } 
{ /* Jvm/jld.scm 305 */
obj_t BgL_arg2530z00_946;
BgL_arg2530z00_946 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3543z00zzjvm_ldz00, BgL_arg2530z00_946); } 
{ /* Jvm/jld.scm 305 */
obj_t BgL_arg2534z00_947;
BgL_arg2534z00_947 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2534z00_947); } 
{ /* Jvm/jld.scm 306 */
obj_t BgL_arg2539z00_949;
BgL_arg2539z00_949 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3544z00zzjvm_ldz00, BgL_arg2539z00_949); } 
{ /* Jvm/jld.scm 306 */
obj_t BgL_arg2543z00_950;
BgL_arg2543z00_950 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2543z00_950); } 
{ /* Jvm/jld.scm 307 */
obj_t BgL_arg2547z00_951;
BgL_arg2547z00_951 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2547z00_951); } 
{ /* Jvm/jld.scm 308 */
obj_t BgL_arg2551z00_952;
BgL_arg2551z00_952 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_za2jvmzd2javaza2zd2zzengine_paramz00, BgL_arg2551z00_952); } 
{ /* Jvm/jld.scm 308 */
obj_t BgL_arg2557z00_954;
BgL_arg2557z00_954 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3545z00zzjvm_ldz00, BgL_arg2557z00_954); } 
{ /* Jvm/jld.scm 308 */
obj_t BgL_arg2561z00_955;
BgL_arg2561z00_955 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(
string_to_bstring(BGL_JAVA_OPT), BgL_arg2561z00_955); } 
{ /* Jvm/jld.scm 309 */
char * BgL_arg2565z00_956;obj_t BgL_arg2566z00_957;
if(
CBOOL(BGl_za2jvmzd2purifyza2zd2zzengine_paramz00))
{ /* Jvm/jld.scm 309 */
BgL_arg2565z00_956 = ""; }  else 
{ /* Jvm/jld.scm 309 */
BgL_arg2565z00_956 = BGL_JAVA_VOPT; } 
BgL_arg2566z00_957 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(
string_to_bstring(BgL_arg2565z00_956), BgL_arg2566z00_957); } 
{ /* Jvm/jld.scm 308 */
obj_t BgL_arg2571z00_959;
BgL_arg2571z00_959 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3546z00zzjvm_ldz00, BgL_arg2571z00_959); } 
{ /* Jvm/jld.scm 308 */
obj_t BgL_arg2575z00_960;
BgL_arg2575z00_960 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_za2jvmzd2optionsza2zd2zzengine_paramz00, BgL_arg2575z00_960); } 
{ /* Jvm/jld.scm 308 */
obj_t BgL_arg2580z00_962;
BgL_arg2580z00_962 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3525z00zzjvm_ldz00, BgL_arg2580z00_962); } 
{ /* Jvm/jld.scm 312 */
obj_t BgL_arg2584z00_963;obj_t BgL_arg2585z00_964;
BgL_arg2584z00_963 = 
BGl_generatezd2jvmzd2envz00zzjvm_ldz00(); 
BgL_arg2585z00_964 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg2584z00_963, BgL_arg2585z00_964); } 
{ /* Jvm/jld.scm 313 */
obj_t BgL_arg2590z00_965;obj_t BgL_arg2591z00_966;
{ /* Jvm/jld.scm 313 */
bool_t BgL_test2593z00_967;
{ /* Jvm/jld.scm 313 */
obj_t BgL_auxz00_2632;
BgL_auxz00_2632 = 
string_to_bstring(DIRNAME_CMD); 
BgL_test2593z00_967 = 
bigloo_strcmp(BgL_auxz00_2632, BGl_string3520z00zzjvm_ldz00); } 
if(BgL_test2593z00_967)
{ /* Jvm/jld.scm 313 */
BgL_arg2590z00_965 = 
BGl_prefixz00zz__osz00(BgL_targetz00_1814); }  else 
{ /* Jvm/jld.scm 314 */
obj_t BgL_arg2596z00_968;obj_t BgL_arg2597z00_969;
{ /* Jvm/jld.scm 314 */
obj_t BgL_auxz00_2637;
BgL_auxz00_2637 = 
string_to_bstring(DIRNAME_CMD); 
BgL_arg2596z00_968 = 
string_append_3(BGl_string3547z00zzjvm_ldz00, BgL_auxz00_2637, BGl_string3548z00zzjvm_ldz00); } 
{ /* Jvm/jld.scm 317 */
obj_t BgL_arg2601z00_970;
BgL_arg2601z00_970 = 
BGl_basenamez00zz__osz00(BgL_targetz00_1814); 
BgL_arg2597z00_969 = 
BGl_prefixz00zz__osz00(BgL_arg2601z00_970); } 
BgL_arg2590z00_965 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_arg2596z00_968, BgL_arg2597z00_969); } } 
BgL_arg2591z00_966 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg2590z00_965, BgL_arg2591z00_966); } 
{ /* Jvm/jld.scm 308 */
obj_t BgL_arg2609z00_972;
BgL_arg2609z00_972 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3549z00zzjvm_ldz00, BgL_arg2609z00_972); } 
{ /* Jvm/jld.scm 308 */
obj_t BgL_arg2613z00_973;
BgL_arg2613z00_973 = 
GET_CURRENT_OUTPUT_PORT(); 
BgL_auxz00_2594 = 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2613z00_973); } 
return 
BCHAR(BgL_auxz00_2594);} } } } 
}



/* <anonymous:2349> */
obj_t BGl_zc3anonymousza32349ze3z83zzjvm_ldz00(obj_t BgL_envz00_1815)
{ AN_OBJECT;
{ /* Jvm/jld.scm 323 */
{ /* Jvm/jld.scm 323 */
obj_t BgL_za7ipsza7_1816;obj_t BgL_pathz00_1817;obj_t BgL_mainzd2classzd2_1818;
{ /* Jvm/jld.scm 323 */
int BgL_auxz00_2650;
BgL_auxz00_2650 = 
(int)(((long)0)); 
BgL_za7ipsza7_1816 = 
PROCEDURE_REF(BgL_envz00_1815, BgL_auxz00_2650); } 
{ /* Jvm/jld.scm 323 */
int BgL_auxz00_2653;
BgL_auxz00_2653 = 
(int)(((long)1)); 
BgL_pathz00_1817 = 
PROCEDURE_REF(BgL_envz00_1815, BgL_auxz00_2653); } 
{ /* Jvm/jld.scm 323 */
int BgL_auxz00_2656;
BgL_auxz00_2656 = 
(int)(((long)2)); 
BgL_mainzd2classzd2_1818 = 
PROCEDURE_REF(BgL_envz00_1815, BgL_auxz00_2656); } 
{ 

{ /* Jvm/jld.scm 323 */
unsigned char BgL_auxz00_2659;
{ /* Jvm/jld.scm 324 */
obj_t BgL_arg2352z00_874;
BgL_arg2352z00_874 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3542z00zzjvm_ldz00, BgL_arg2352z00_874); } 
{ /* Jvm/jld.scm 324 */
obj_t BgL_arg2356z00_875;
BgL_arg2356z00_875 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2356z00_875); } 
{ /* Jvm/jld.scm 325 */
obj_t BgL_arg2360z00_876;
BgL_arg2360z00_876 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2360z00_876); } 
{ /* Jvm/jld.scm 326 */
obj_t BgL_arg2365z00_878;
BgL_arg2365z00_878 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3550z00zzjvm_ldz00, BgL_arg2365z00_878); } 
{ /* Jvm/jld.scm 328 */
obj_t BgL_arg2369z00_879;obj_t BgL_arg2370z00_880;
{ /* Jvm/jld.scm 328 */
obj_t BgL_arg2373z00_881;
{ /* Jvm/jld.scm 328 */
obj_t BgL_arg2377z00_883;
{ /* Jvm/jld.scm 328 */
obj_t BgL_arg2380z00_884;
{ /* Jvm/jld.scm 328 */
obj_t BgL_arg2384z00_886;
{ /* Jvm/jld.scm 331 */
obj_t BgL_arg2387z00_887;obj_t BgL_arg2388z00_888;
{ /* Jvm/jld.scm 331 */
obj_t BgL_arg2391z00_889;char * BgL_arg2392z00_890;
BgL_arg2391z00_889 = 
BGl_jvmzd2classpathzd2zzjvm_ldz00(); 
if(
CBOOL(BGl_za2unsafezd2libraryza2zd2zzengine_paramz00))
{ /* Jvm/jld.scm 332 */
BgL_arg2392z00_890 = "bigloo_u.zip"; }  else 
{ /* Jvm/jld.scm 332 */
BgL_arg2392z00_890 = "bigloo.zip"; } 
BgL_arg2387z00_887 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_arg2391z00_889, 
string_to_bstring(BgL_arg2392z00_890)); } 
{ /* Jvm/jld.scm 335 */
obj_t BgL_arg2396z00_891;
if(
NULLP(BgL_za7ipsza7_1816))
{ /* Jvm/jld.scm 335 */
BgL_arg2396z00_891 = BNIL; }  else 
{ /* Jvm/jld.scm 335 */
obj_t BgL_head1606z00_895;
{ /* Jvm/jld.scm 335 */
obj_t BgL_arg2420z00_906;
BgL_arg2420z00_906 = 
BGl_userzd2libraryzd2zzjvm_ldz00(
CAR(BgL_za7ipsza7_1816)); 
BgL_head1606z00_895 = 
MAKE_PAIR(BgL_arg2420z00_906, BNIL); } 
{ 
obj_t BgL_l1604z00_896;obj_t BgL_tail1607z00_897;
BgL_l1604z00_896 = 
CDR(BgL_za7ipsza7_1816); 
BgL_tail1607z00_897 = BgL_head1606z00_895; 
BgL_lname1605z00_898:
if(
NULLP(BgL_l1604z00_896))
{ /* Jvm/jld.scm 335 */
BgL_arg2396z00_891 = BgL_head1606z00_895; }  else 
{ /* Jvm/jld.scm 335 */
obj_t BgL_newtail1608z00_901;
{ /* Jvm/jld.scm 335 */
obj_t BgL_arg2411z00_903;
BgL_arg2411z00_903 = 
BGl_userzd2libraryzd2zzjvm_ldz00(
CAR(BgL_l1604z00_896)); 
BgL_newtail1608z00_901 = 
MAKE_PAIR(BgL_arg2411z00_903, BNIL); } 
SET_CDR(BgL_tail1607z00_897, BgL_newtail1608z00_901); 
{ 
obj_t BgL_tail1607z00_2686;obj_t BgL_l1604z00_2684;
BgL_l1604z00_2684 = 
CDR(BgL_l1604z00_896); 
BgL_tail1607z00_2686 = BgL_newtail1608z00_901; 
BgL_tail1607z00_897 = BgL_tail1607z00_2686; 
BgL_l1604z00_896 = BgL_l1604z00_2684; 
goto BgL_lname1605z00_898;} } } } 
BgL_arg2388z00_888 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2396z00_891, BNIL); } 
BgL_arg2384z00_886 = 
MAKE_PAIR(BgL_arg2387z00_887, BgL_arg2388z00_888); } 
BgL_arg2380z00_884 = 
MAKE_PAIR(BGl_string3551z00zzjvm_ldz00, BgL_arg2384z00_886); } 
BgL_arg2377z00_883 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_pathz00_1817, BgL_arg2380z00_884); } 
BgL_arg2373z00_881 = 
MAKE_PAIR(BGl_string3552z00zzjvm_ldz00, BgL_arg2377z00_883); } 
BgL_arg2369z00_879 = 
BGl_listzd2ze3pathzd2stringze3zzjvm_ldz00(BgL_arg2373z00_881, ":"); } 
BgL_arg2370z00_880 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg2369z00_879, BgL_arg2370z00_880); } 
{ /* Jvm/jld.scm 326 */
obj_t BgL_arg2430z00_909;
BgL_arg2430z00_909 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2430z00_909); } 
{ /* Jvm/jld.scm 336 */
obj_t BgL_arg2435z00_911;
BgL_arg2435z00_911 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3544z00zzjvm_ldz00, BgL_arg2435z00_911); } 
{ /* Jvm/jld.scm 336 */
obj_t BgL_arg2439z00_912;
BgL_arg2439z00_912 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2439z00_912); } 
{ /* Jvm/jld.scm 337 */
obj_t BgL_arg2443z00_913;
BgL_arg2443z00_913 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2443z00_913); } 
{ /* Jvm/jld.scm 338 */
obj_t BgL_arg2447z00_914;
BgL_arg2447z00_914 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_za2jvmzd2javaza2zd2zzengine_paramz00, BgL_arg2447z00_914); } 
{ /* Jvm/jld.scm 338 */
obj_t BgL_arg2452z00_916;
BgL_arg2452z00_916 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3545z00zzjvm_ldz00, BgL_arg2452z00_916); } 
{ /* Jvm/jld.scm 338 */
obj_t BgL_arg2456z00_917;
BgL_arg2456z00_917 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(
string_to_bstring(BGL_JAVA_OPT), BgL_arg2456z00_917); } 
{ /* Jvm/jld.scm 340 */
char * BgL_arg2460z00_918;obj_t BgL_arg2461z00_919;
if(
CBOOL(BGl_za2jvmzd2purifyza2zd2zzengine_paramz00))
{ /* Jvm/jld.scm 340 */
BgL_arg2460z00_918 = ""; }  else 
{ /* Jvm/jld.scm 340 */
BgL_arg2460z00_918 = BGL_JAVA_VOPT; } 
BgL_arg2461z00_919 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(
string_to_bstring(BgL_arg2460z00_918), BgL_arg2461z00_919); } 
{ /* Jvm/jld.scm 338 */
obj_t BgL_arg2466z00_921;
BgL_arg2466z00_921 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3525z00zzjvm_ldz00, BgL_arg2466z00_921); } 
{ /* Jvm/jld.scm 338 */
obj_t BgL_arg2470z00_922;
BgL_arg2470z00_922 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_za2jvmzd2optionsza2zd2zzengine_paramz00, BgL_arg2470z00_922); } 
{ /* Jvm/jld.scm 338 */
obj_t BgL_arg2475z00_924;
BgL_arg2475z00_924 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3525z00zzjvm_ldz00, BgL_arg2475z00_924); } 
{ /* Jvm/jld.scm 343 */
obj_t BgL_arg2479z00_925;obj_t BgL_arg2480z00_926;
BgL_arg2479z00_925 = 
BGl_generatezd2jvmzd2envz00zzjvm_ldz00(); 
BgL_arg2480z00_926 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg2479z00_925, BgL_arg2480z00_926); } 
{ /* Jvm/jld.scm 344 */
obj_t BgL_arg2485z00_927;obj_t BgL_arg2486z00_928;
BgL_arg2485z00_927 = 
BGl_stringzd2replacez12zc0zzjvm_ldz00(BgL_mainzd2classzd2_1818, ((unsigned char)'/'), ((unsigned char)'.')); 
BgL_arg2486z00_928 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg2485z00_927, BgL_arg2486z00_928); } 
{ /* Jvm/jld.scm 338 */
obj_t BgL_arg2492z00_930;
BgL_arg2492z00_930 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3553z00zzjvm_ldz00, BgL_arg2492z00_930); } 
{ /* Jvm/jld.scm 338 */
obj_t BgL_arg2496z00_931;
BgL_arg2496z00_931 = 
GET_CURRENT_OUTPUT_PORT(); 
BgL_auxz00_2659 = 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2496z00_931); } 
return 
BCHAR(BgL_auxz00_2659);} } } } 
}



/* generate-jvm-msdos-script */
bool_t BGl_generatezd2jvmzd2msdoszd2scriptzd2zzjvm_ldz00(obj_t BgL_targetz00_23, obj_t BgL_mainzd2classzd2_24, obj_t BgL_pathz00_25, obj_t BgL_jarnamez00_26, obj_t BgL_za7ipsza7_27)
{ AN_OBJECT;
{ /* Jvm/jld.scm 354 */
{ 

if(
CBOOL(BGl_za2jvmzd2jarzf3za2z21zzengine_paramz00))
{ /* Jvm/jld.scm 418 */
{ /* Jvm/jld.scm 365 */
obj_t BgL_zc3anonymousza32818ze3z83_1821;
{ 
int BgL_auxz00_2737;int BgL_auxz00_2735;
BgL_auxz00_2737 = 
(int)(((long)2)); 
BgL_auxz00_2735 = 
(int)(((long)0)); 
BgL_zc3anonymousza32818ze3z83_1821 = 
make_fx_procedure(BGl_zc3anonymousza32818ze3z83zzjvm_ldz00, BgL_auxz00_2735, BgL_auxz00_2737); } 
{ /* Jvm/jld.scm 365 */
int BgL_auxz00_2740;
BgL_auxz00_2740 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32818ze3z83_1821, BgL_auxz00_2740, BgL_jarnamez00_26); } 
{ /* Jvm/jld.scm 365 */
int BgL_auxz00_2743;
BgL_auxz00_2743 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_zc3anonymousza32818ze3z83_1821, BgL_auxz00_2743, BgL_mainzd2classzd2_24); } 
BGl_withzd2outputzd2tozd2filezd2zz__r4_ports_6_10_1z00(BgL_targetz00_23, BgL_zc3anonymousza32818ze3z83_1821); } 
{ /* Jvm/jld.scm 389 */
obj_t BgL_list2958z00_1125;
{ /* Jvm/jld.scm 389 */
obj_t BgL_arg2960z00_1126;obj_t BgL_arg2961z00_1127;
BgL_arg2960z00_1126 = 
CNST_TABLE_REF(((long)8)); 
{ /* Jvm/jld.scm 389 */
obj_t BgL_arg2964z00_1128;obj_t BgL_arg2965z00_1129;
BgL_arg2964z00_1128 = 
CNST_TABLE_REF(((long)9)); 
{ /* Jvm/jld.scm 389 */
obj_t BgL_auxz00_2749;
BgL_auxz00_2749 = 
CNST_TABLE_REF(((long)10)); 
BgL_arg2965z00_1129 = 
MAKE_PAIR(BgL_auxz00_2749, BNIL); } 
BgL_arg2961z00_1127 = 
MAKE_PAIR(BgL_arg2964z00_1128, BgL_arg2965z00_1129); } 
BgL_list2958z00_1125 = 
MAKE_PAIR(BgL_arg2960z00_1126, BgL_arg2961z00_1127); } 
return 
BGl_chmodz00zz__osz00(BgL_targetz00_23, BgL_list2958z00_1125);} }  else 
{ /* Jvm/jld.scm 418 */
{ /* Jvm/jld.scm 392 */
obj_t BgL_zc3anonymousza32668ze3z83_1822;
{ 
int BgL_auxz00_2757;int BgL_auxz00_2755;
BgL_auxz00_2757 = 
(int)(((long)2)); 
BgL_auxz00_2755 = 
(int)(((long)0)); 
BgL_zc3anonymousza32668ze3z83_1822 = 
make_fx_procedure(BGl_zc3anonymousza32668ze3z83zzjvm_ldz00, BgL_auxz00_2755, BgL_auxz00_2757); } 
{ /* Jvm/jld.scm 392 */
int BgL_auxz00_2760;
BgL_auxz00_2760 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32668ze3z83_1822, BgL_auxz00_2760, BgL_pathz00_25); } 
{ /* Jvm/jld.scm 392 */
int BgL_auxz00_2763;
BgL_auxz00_2763 = 
(int)(((long)1)); 
PROCEDURE_SET(BgL_zc3anonymousza32668ze3z83_1822, BgL_auxz00_2763, BgL_mainzd2classzd2_24); } 
BGl_withzd2outputzd2tozd2filezd2zz__r4_ports_6_10_1z00(BgL_targetz00_23, BgL_zc3anonymousza32668ze3z83_1822); } 
{ /* Jvm/jld.scm 417 */
obj_t BgL_list2804z00_1061;
{ /* Jvm/jld.scm 417 */
obj_t BgL_arg2806z00_1062;obj_t BgL_arg2807z00_1063;
BgL_arg2806z00_1062 = 
CNST_TABLE_REF(((long)8)); 
{ /* Jvm/jld.scm 417 */
obj_t BgL_arg2810z00_1064;obj_t BgL_arg2811z00_1065;
BgL_arg2810z00_1064 = 
CNST_TABLE_REF(((long)9)); 
{ /* Jvm/jld.scm 417 */
obj_t BgL_auxz00_2769;
BgL_auxz00_2769 = 
CNST_TABLE_REF(((long)10)); 
BgL_arg2811z00_1065 = 
MAKE_PAIR(BgL_auxz00_2769, BNIL); } 
BgL_arg2807z00_1063 = 
MAKE_PAIR(BgL_arg2810z00_1064, BgL_arg2811z00_1065); } 
BgL_list2804z00_1061 = 
MAKE_PAIR(BgL_arg2806z00_1062, BgL_arg2807z00_1063); } 
return 
BGl_chmodz00zz__osz00(BgL_targetz00_23, BgL_list2804z00_1061);} } } } 
}



/* generate-jvm-env_3240 */
obj_t BGl_generatezd2jvmzd2env_3240z00zzjvm_ldz00()
{ AN_OBJECT;
{ /* Jvm/jld.scm 362 */
return 
BGl_loop_3241z00zzjvm_ldz00(BGl_za2jvmzd2envza2zd2zzengine_paramz00, BGl_string3520z00zzjvm_ldz00);} 
}



/* loop_3241 */
obj_t BGl_loop_3241z00zzjvm_ldz00(obj_t BgL_envz00_1131, obj_t BgL_resz00_1132)
{ AN_OBJECT;
{ /* Jvm/jld.scm 356 */
BGl_loop_3241z00zzjvm_ldz00:
if(
NULLP(BgL_envz00_1131))
{ /* Jvm/jld.scm 358 */
return BgL_resz00_1132;}  else 
{ /* Jvm/jld.scm 360 */
obj_t BgL_arg2972z00_1135;obj_t BgL_arg2973z00_1136;
BgL_arg2972z00_1135 = 
CDR(BgL_envz00_1131); 
{ /* Jvm/jld.scm 361 */
obj_t BgL_arg2978z00_1138;obj_t BgL_arg2980z00_1140;
BgL_arg2978z00_1138 = 
CAR(BgL_envz00_1131); 
BgL_arg2980z00_1140 = 
CAR(BgL_envz00_1131); 
{ /* Jvm/jld.scm 361 */
obj_t BgL_list2985z00_1142;
{ /* Jvm/jld.scm 361 */
obj_t BgL_arg2987z00_1143;
{ /* Jvm/jld.scm 361 */
obj_t BgL_arg2990z00_1144;
{ /* Jvm/jld.scm 361 */
obj_t BgL_arg2993z00_1145;
{ /* Jvm/jld.scm 361 */
obj_t BgL_arg2996z00_1146;
{ /* Jvm/jld.scm 361 */
obj_t BgL_arg2999z00_1147;
BgL_arg2999z00_1147 = 
MAKE_PAIR(BgL_resz00_1132, BNIL); 
BgL_arg2996z00_1146 = 
MAKE_PAIR(BGl_string3525z00zzjvm_ldz00, BgL_arg2999z00_1147); } 
BgL_arg2993z00_1145 = 
MAKE_PAIR(BgL_arg2980z00_1140, BgL_arg2996z00_1146); } 
BgL_arg2990z00_1144 = 
MAKE_PAIR(BGl_string3540z00zzjvm_ldz00, BgL_arg2993z00_1145); } 
BgL_arg2987z00_1143 = 
MAKE_PAIR(BgL_arg2978z00_1138, BgL_arg2990z00_1144); } 
BgL_list2985z00_1142 = 
MAKE_PAIR(BGl_string3541z00zzjvm_ldz00, BgL_arg2987z00_1143); } 
BgL_arg2973z00_1136 = 
BGl_stringzd2appendzd2zz__r4_strings_6_7z00(BgL_list2985z00_1142); } } 
{ 
obj_t BgL_resz00_2789;obj_t BgL_envz00_2788;
BgL_envz00_2788 = BgL_arg2972z00_1135; 
BgL_resz00_2789 = BgL_arg2973z00_1136; 
BgL_resz00_1132 = BgL_resz00_2789; 
BgL_envz00_1131 = BgL_envz00_2788; 
goto BGl_loop_3241z00zzjvm_ldz00;} } } 
}



/* <anonymous:2818> */
obj_t BGl_zc3anonymousza32818ze3z83zzjvm_ldz00(obj_t BgL_envz00_1823)
{ AN_OBJECT;
{ /* Jvm/jld.scm 365 */
{ /* Jvm/jld.scm 365 */
obj_t BgL_jarnamez00_1824;obj_t BgL_mainzd2classzd2_1825;
{ /* Jvm/jld.scm 365 */
int BgL_auxz00_2790;
BgL_auxz00_2790 = 
(int)(((long)0)); 
BgL_jarnamez00_1824 = 
PROCEDURE_REF(BgL_envz00_1823, BgL_auxz00_2790); } 
{ /* Jvm/jld.scm 365 */
int BgL_auxz00_2793;
BgL_auxz00_2793 = 
(int)(((long)1)); 
BgL_mainzd2classzd2_1825 = 
PROCEDURE_REF(BgL_envz00_1823, BgL_auxz00_2793); } 
{ 

{ /* Jvm/jld.scm 365 */
unsigned char BgL_auxz00_2796;
{ /* Jvm/jld.scm 366 */
obj_t BgL_arg2821z00_1070;
BgL_arg2821z00_1070 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3554z00zzjvm_ldz00, BgL_arg2821z00_1070); } 
{ /* Jvm/jld.scm 366 */
obj_t BgL_arg2825z00_1071;
BgL_arg2825z00_1071 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2825z00_1071); } 
{ /* Jvm/jld.scm 367 */
obj_t BgL_arg2829z00_1072;
BgL_arg2829z00_1072 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2829z00_1072); } 
{ /* Jvm/jld.scm 368 */
obj_t BgL_arg2834z00_1074;
BgL_arg2834z00_1074 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3555z00zzjvm_ldz00, BgL_arg2834z00_1074); } 
{ /* Jvm/jld.scm 370 */
obj_t BgL_arg2838z00_1075;obj_t BgL_arg2839z00_1076;
{ /* Jvm/jld.scm 370 */
obj_t BgL_arg2842z00_1077;
{ /* Jvm/jld.scm 370 */
obj_t BgL_arg2845z00_1078;obj_t BgL_arg2846z00_1079;
{ /* Jvm/jld.scm 370 */
obj_t BgL_arg2849z00_1080;obj_t BgL_arg2852z00_1082;
{ /* Jvm/jld.scm 370 */
obj_t BgL_arg2855z00_1083;
BgL_arg2855z00_1083 = 
BGl_dirnamez00zz__osz00(BgL_jarnamez00_1824); 
{ /* Jvm/jld.scm 370 */
bool_t BgL_test2196z00_1534;
{ /* Jvm/jld.scm 370 */
obj_t BgL_objz00_1535;
BgL_objz00_1535 = BGl_za2jvmzd2jarpathza2zd2zzengine_paramz00; 
BgL_test2196z00_1534 = 
STRINGP(BgL_objz00_1535); } 
if(BgL_test2196z00_1534)
{ /* Jvm/jld.scm 370 */
BgL_arg2849z00_1080 = BGl_za2jvmzd2jarpathza2zd2zzengine_paramz00; }  else 
{ /* Jvm/jld.scm 370 */
BgL_arg2849z00_1080 = BgL_arg2855z00_1083; } } } 
BgL_arg2852z00_1082 = 
BGl_basenamez00zz__osz00(BgL_jarnamez00_1824); 
BgL_arg2845z00_1078 = 
string_append_3(BgL_arg2849z00_1080, BGl_string3556z00zzjvm_ldz00, BgL_arg2852z00_1082); } 
{ /* Jvm/jld.scm 374 */
obj_t BgL_arg2860z00_1084;obj_t BgL_arg2861z00_1085;
{ /* Jvm/jld.scm 374 */
obj_t BgL_arg2864z00_1086;char * BgL_arg2865z00_1087;
{ /* Jvm/jld.scm 374 */
obj_t BgL_arg2868z00_1088;
BgL_arg2868z00_1088 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(
BGl_jvmzd2classpathzd2zzjvm_ldz00()); 
BgL_arg2864z00_1086 = 
BGl_stringzd2replacez12zc0zzjvm_ldz00(BgL_arg2868z00_1088, ((unsigned char)'/'), ((unsigned char)'\\')); } 
if(
CBOOL(BGl_za2unsafezd2libraryza2zd2zzengine_paramz00))
{ /* Jvm/jld.scm 376 */
BgL_arg2865z00_1087 = "\\bigloo_u.zip"; }  else 
{ /* Jvm/jld.scm 376 */
BgL_arg2865z00_1087 = "\\bigloo.zip"; } 
{ /* Jvm/jld.scm 373 */
obj_t BgL_auxz00_2815;
BgL_auxz00_2815 = 
string_to_bstring(BgL_arg2865z00_1087); 
BgL_arg2860z00_1084 = 
string_append(BgL_arg2864z00_1086, BgL_auxz00_2815); } } 
{ /* Jvm/jld.scm 379 */
obj_t BgL_arg2875z00_1090;
{ /* Jvm/jld.scm 379 */
obj_t BgL_l1609z00_1092;
BgL_l1609z00_1092 = BGl_za2additionalzd2bigloozd2za7ipsza2za7zzengine_paramz00; 
if(
NULLP(BgL_l1609z00_1092))
{ /* Jvm/jld.scm 379 */
BgL_arg2875z00_1090 = BNIL; }  else 
{ /* Jvm/jld.scm 379 */
obj_t BgL_head1611z00_1094;
BgL_head1611z00_1094 = 
MAKE_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1609z00_1095;obj_t BgL_tail1612z00_1096;
BgL_l1609z00_1095 = BgL_l1609z00_1092; 
BgL_tail1612z00_1096 = BgL_head1611z00_1094; 
BgL_lname1610z00_1097:
if(
NULLP(BgL_l1609z00_1095))
{ /* Jvm/jld.scm 379 */
BgL_arg2875z00_1090 = 
CDR(BgL_head1611z00_1094); }  else 
{ /* Jvm/jld.scm 380 */
obj_t BgL_newtail1613z00_1099;
{ /* Jvm/jld.scm 380 */
obj_t BgL_arg2888z00_1101;
{ /* Jvm/jld.scm 380 */
obj_t BgL_arg2892z00_1104;
BgL_arg2892z00_1104 = 
BGl_userzd2libraryzd2zzjvm_ldz00(
CAR(BgL_l1609z00_1095)); 
BgL_arg2888z00_1101 = 
BGl_stringzd2replacez12zc0zzjvm_ldz00(BgL_arg2892z00_1104, ((unsigned char)'/'), ((unsigned char)'\\')); } 
BgL_newtail1613z00_1099 = 
MAKE_PAIR(BgL_arg2888z00_1101, BNIL); } 
SET_CDR(BgL_tail1612z00_1096, BgL_newtail1613z00_1099); 
{ 
obj_t BgL_tail1612z00_2831;obj_t BgL_l1609z00_2829;
BgL_l1609z00_2829 = 
CDR(BgL_l1609z00_1095); 
BgL_tail1612z00_2831 = BgL_newtail1613z00_1099; 
BgL_tail1612z00_1096 = BgL_tail1612z00_2831; 
BgL_l1609z00_1095 = BgL_l1609z00_2829; 
goto BgL_lname1610z00_1097;} } } } } 
BgL_arg2861z00_1085 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2875z00_1090, BNIL); } 
BgL_arg2846z00_1079 = 
MAKE_PAIR(BgL_arg2860z00_1084, BgL_arg2861z00_1085); } 
BgL_arg2842z00_1077 = 
MAKE_PAIR(BgL_arg2845z00_1078, BgL_arg2846z00_1079); } 
BgL_arg2838z00_1075 = 
BGl_listzd2ze3pathzd2stringze3zzjvm_ldz00(BgL_arg2842z00_1077, ";"); } 
BgL_arg2839z00_1076 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg2838z00_1075, BgL_arg2839z00_1076); } 
{ /* Jvm/jld.scm 368 */
obj_t BgL_arg2901z00_1105;
BgL_arg2901z00_1105 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2901z00_1105); } 
{ /* Jvm/jld.scm 382 */
obj_t BgL_arg2905z00_1106;
BgL_arg2905z00_1106 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_za2jvmzd2javaza2zd2zzengine_paramz00, BgL_arg2905z00_1106); } 
{ /* Jvm/jld.scm 382 */
obj_t BgL_arg2910z00_1108;
BgL_arg2910z00_1108 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3557z00zzjvm_ldz00, BgL_arg2910z00_1108); } 
{ /* Jvm/jld.scm 382 */
obj_t BgL_arg2914z00_1109;
BgL_arg2914z00_1109 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(
string_to_bstring(BGL_JAVA_OPT), BgL_arg2914z00_1109); } 
{ /* Jvm/jld.scm 383 */
char * BgL_arg2918z00_1110;obj_t BgL_arg2919z00_1111;
if(
CBOOL(BGl_za2jvmzd2purifyza2zd2zzengine_paramz00))
{ /* Jvm/jld.scm 383 */
BgL_arg2918z00_1110 = ""; }  else 
{ /* Jvm/jld.scm 383 */
BgL_arg2918z00_1110 = BGL_JAVA_VOPT; } 
BgL_arg2919z00_1111 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(
string_to_bstring(BgL_arg2918z00_1110), BgL_arg2919z00_1111); } 
{ /* Jvm/jld.scm 382 */
obj_t BgL_arg2924z00_1113;
BgL_arg2924z00_1113 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3558z00zzjvm_ldz00, BgL_arg2924z00_1113); } 
{ /* Jvm/jld.scm 382 */
obj_t BgL_arg2928z00_1114;
BgL_arg2928z00_1114 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_za2jvmzd2optionsza2zd2zzengine_paramz00, BgL_arg2928z00_1114); } 
{ /* Jvm/jld.scm 382 */
obj_t BgL_arg2933z00_1116;
BgL_arg2933z00_1116 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3525z00zzjvm_ldz00, BgL_arg2933z00_1116); } 
{ /* Jvm/jld.scm 386 */
obj_t BgL_arg2937z00_1117;obj_t BgL_arg2938z00_1118;
BgL_arg2937z00_1117 = 
BGl_generatezd2jvmzd2env_3240z00zzjvm_ldz00(); 
BgL_arg2938z00_1118 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg2937z00_1117, BgL_arg2938z00_1118); } 
{ /* Jvm/jld.scm 387 */
obj_t BgL_arg2943z00_1119;obj_t BgL_arg2944z00_1120;
BgL_arg2943z00_1119 = 
BGl_stringzd2replacez12zc0zzjvm_ldz00(BgL_mainzd2classzd2_1825, ((unsigned char)'/'), ((unsigned char)'.')); 
BgL_arg2944z00_1120 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg2943z00_1119, BgL_arg2944z00_1120); } 
{ /* Jvm/jld.scm 382 */
obj_t BgL_arg2950z00_1122;
BgL_arg2950z00_1122 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3559z00zzjvm_ldz00, BgL_arg2950z00_1122); } 
{ /* Jvm/jld.scm 382 */
obj_t BgL_arg2954z00_1123;
BgL_arg2954z00_1123 = 
GET_CURRENT_OUTPUT_PORT(); 
BgL_auxz00_2796 = 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2954z00_1123); } 
return 
BCHAR(BgL_auxz00_2796);} } } } 
}



/* <anonymous:2668> */
obj_t BGl_zc3anonymousza32668ze3z83zzjvm_ldz00(obj_t BgL_envz00_1826)
{ AN_OBJECT;
{ /* Jvm/jld.scm 392 */
{ /* Jvm/jld.scm 392 */
obj_t BgL_pathz00_1827;obj_t BgL_mainzd2classzd2_1828;
{ /* Jvm/jld.scm 392 */
int BgL_auxz00_2869;
BgL_auxz00_2869 = 
(int)(((long)0)); 
BgL_pathz00_1827 = 
PROCEDURE_REF(BgL_envz00_1826, BgL_auxz00_2869); } 
{ /* Jvm/jld.scm 392 */
int BgL_auxz00_2872;
BgL_auxz00_2872 = 
(int)(((long)1)); 
BgL_mainzd2classzd2_1828 = 
PROCEDURE_REF(BgL_envz00_1826, BgL_auxz00_2872); } 
{ 

{ /* Jvm/jld.scm 392 */
unsigned char BgL_auxz00_2875;
{ /* Jvm/jld.scm 393 */
obj_t BgL_arg2671z00_1008;
BgL_arg2671z00_1008 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3554z00zzjvm_ldz00, BgL_arg2671z00_1008); } 
{ /* Jvm/jld.scm 393 */
obj_t BgL_arg2675z00_1009;
BgL_arg2675z00_1009 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2675z00_1009); } 
{ /* Jvm/jld.scm 394 */
obj_t BgL_arg2679z00_1010;
BgL_arg2679z00_1010 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2679z00_1010); } 
{ /* Jvm/jld.scm 395 */
obj_t BgL_arg2684z00_1012;
BgL_arg2684z00_1012 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3555z00zzjvm_ldz00, BgL_arg2684z00_1012); } 
{ /* Jvm/jld.scm 397 */
obj_t BgL_arg2688z00_1013;obj_t BgL_arg2689z00_1014;
{ /* Jvm/jld.scm 397 */
obj_t BgL_arg2692z00_1015;
{ /* Jvm/jld.scm 397 */
obj_t BgL_arg2696z00_1017;
{ /* Jvm/jld.scm 400 */
obj_t BgL_arg2699z00_1018;
{ /* Jvm/jld.scm 400 */
obj_t BgL_arg2702z00_1019;obj_t BgL_arg2703z00_1020;
{ /* Jvm/jld.scm 400 */
obj_t BgL_arg2706z00_1021;char * BgL_arg2707z00_1022;
{ /* Jvm/jld.scm 400 */
obj_t BgL_arg2710z00_1023;
BgL_arg2710z00_1023 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(
BGl_jvmzd2classpathzd2zzjvm_ldz00()); 
BgL_arg2706z00_1021 = 
BGl_stringzd2replacez12zc0zzjvm_ldz00(BgL_arg2710z00_1023, ((unsigned char)'/'), ((unsigned char)'\\')); } 
if(
CBOOL(BGl_za2unsafezd2libraryza2zd2zzengine_paramz00))
{ /* Jvm/jld.scm 402 */
BgL_arg2707z00_1022 = "\\bigloo_u.zip"; }  else 
{ /* Jvm/jld.scm 402 */
BgL_arg2707z00_1022 = "\\bigloo.zip"; } 
{ /* Jvm/jld.scm 399 */
obj_t BgL_auxz00_2889;
BgL_auxz00_2889 = 
string_to_bstring(BgL_arg2707z00_1022); 
BgL_arg2702z00_1019 = 
string_append(BgL_arg2706z00_1021, BgL_auxz00_2889); } } 
{ /* Jvm/jld.scm 405 */
obj_t BgL_arg2717z00_1025;
{ /* Jvm/jld.scm 405 */
obj_t BgL_l1614z00_1027;
BgL_l1614z00_1027 = BGl_za2additionalzd2bigloozd2za7ipsza2za7zzengine_paramz00; 
if(
NULLP(BgL_l1614z00_1027))
{ /* Jvm/jld.scm 405 */
BgL_arg2717z00_1025 = BNIL; }  else 
{ /* Jvm/jld.scm 405 */
obj_t BgL_head1616z00_1029;
BgL_head1616z00_1029 = 
MAKE_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1614z00_1030;obj_t BgL_tail1617z00_1031;
BgL_l1614z00_1030 = BgL_l1614z00_1027; 
BgL_tail1617z00_1031 = BgL_head1616z00_1029; 
BgL_lname1615z00_1032:
if(
NULLP(BgL_l1614z00_1030))
{ /* Jvm/jld.scm 405 */
BgL_arg2717z00_1025 = 
CDR(BgL_head1616z00_1029); }  else 
{ /* Jvm/jld.scm 406 */
obj_t BgL_newtail1618z00_1034;
{ /* Jvm/jld.scm 406 */
obj_t BgL_arg2730z00_1036;
{ /* Jvm/jld.scm 406 */
obj_t BgL_arg2734z00_1039;
BgL_arg2734z00_1039 = 
BGl_userzd2libraryzd2zzjvm_ldz00(
CAR(BgL_l1614z00_1030)); 
BgL_arg2730z00_1036 = 
BGl_stringzd2replacez12zc0zzjvm_ldz00(BgL_arg2734z00_1039, ((unsigned char)'/'), ((unsigned char)'\\')); } 
BgL_newtail1618z00_1034 = 
MAKE_PAIR(BgL_arg2730z00_1036, BNIL); } 
SET_CDR(BgL_tail1617z00_1031, BgL_newtail1618z00_1034); 
{ 
obj_t BgL_tail1617z00_2905;obj_t BgL_l1614z00_2903;
BgL_l1614z00_2903 = 
CDR(BgL_l1614z00_1030); 
BgL_tail1617z00_2905 = BgL_newtail1618z00_1034; 
BgL_tail1617z00_1031 = BgL_tail1617z00_2905; 
BgL_l1614z00_1030 = BgL_l1614z00_2903; 
goto BgL_lname1615z00_1032;} } } } } 
BgL_arg2703z00_1020 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2717z00_1025, BNIL); } 
BgL_arg2699z00_1018 = 
MAKE_PAIR(BgL_arg2702z00_1019, BgL_arg2703z00_1020); } 
BgL_arg2696z00_1017 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_pathz00_1827, BgL_arg2699z00_1018); } 
BgL_arg2692z00_1015 = 
MAKE_PAIR(BGl_string3552z00zzjvm_ldz00, BgL_arg2696z00_1017); } 
BgL_arg2688z00_1013 = 
BGl_listzd2ze3pathzd2stringze3zzjvm_ldz00(BgL_arg2692z00_1015, ";"); } 
BgL_arg2689z00_1014 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg2688z00_1013, BgL_arg2689z00_1014); } 
{ /* Jvm/jld.scm 395 */
obj_t BgL_arg2743z00_1040;
BgL_arg2743z00_1040 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2743z00_1040); } 
{ /* Jvm/jld.scm 408 */
obj_t BgL_arg2747z00_1041;
BgL_arg2747z00_1041 = 
GET_CURRENT_OUTPUT_PORT(); 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2747z00_1041); } 
{ /* Jvm/jld.scm 409 */
obj_t BgL_arg2751z00_1042;
BgL_arg2751z00_1042 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_za2jvmzd2javaza2zd2zzengine_paramz00, BgL_arg2751z00_1042); } 
{ /* Jvm/jld.scm 409 */
obj_t BgL_arg2756z00_1044;
BgL_arg2756z00_1044 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3557z00zzjvm_ldz00, BgL_arg2756z00_1044); } 
{ /* Jvm/jld.scm 409 */
obj_t BgL_arg2760z00_1045;
BgL_arg2760z00_1045 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(
string_to_bstring(BGL_JAVA_OPT), BgL_arg2760z00_1045); } 
{ /* Jvm/jld.scm 410 */
char * BgL_arg2764z00_1046;obj_t BgL_arg2765z00_1047;
if(
CBOOL(BGl_za2jvmzd2purifyza2zd2zzengine_paramz00))
{ /* Jvm/jld.scm 410 */
BgL_arg2764z00_1046 = ""; }  else 
{ /* Jvm/jld.scm 410 */
BgL_arg2764z00_1046 = BGL_JAVA_VOPT; } 
BgL_arg2765z00_1047 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(
string_to_bstring(BgL_arg2764z00_1046), BgL_arg2765z00_1047); } 
{ /* Jvm/jld.scm 409 */
obj_t BgL_arg2770z00_1049;
BgL_arg2770z00_1049 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3525z00zzjvm_ldz00, BgL_arg2770z00_1049); } 
{ /* Jvm/jld.scm 409 */
obj_t BgL_arg2774z00_1050;
BgL_arg2774z00_1050 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_za2jvmzd2optionsza2zd2zzengine_paramz00, BgL_arg2774z00_1050); } 
{ /* Jvm/jld.scm 409 */
obj_t BgL_arg2779z00_1052;
BgL_arg2779z00_1052 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3558z00zzjvm_ldz00, BgL_arg2779z00_1052); } 
{ /* Jvm/jld.scm 414 */
obj_t BgL_arg2783z00_1053;obj_t BgL_arg2784z00_1054;
BgL_arg2783z00_1053 = 
BGl_generatezd2jvmzd2env_3240z00zzjvm_ldz00(); 
BgL_arg2784z00_1054 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg2783z00_1053, BgL_arg2784z00_1054); } 
{ /* Jvm/jld.scm 415 */
obj_t BgL_arg2789z00_1055;obj_t BgL_arg2790z00_1056;
BgL_arg2789z00_1055 = 
BGl_stringzd2replacez12zc0zzjvm_ldz00(BgL_mainzd2classzd2_1828, ((unsigned char)'/'), ((unsigned char)'.')); 
BgL_arg2790z00_1056 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg2789z00_1055, BgL_arg2790z00_1056); } 
{ /* Jvm/jld.scm 409 */
obj_t BgL_arg2796z00_1058;
BgL_arg2796z00_1058 = 
GET_CURRENT_OUTPUT_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_string3559z00zzjvm_ldz00, BgL_arg2796z00_1058); } 
{ /* Jvm/jld.scm 409 */
obj_t BgL_arg2800z00_1059;
BgL_arg2800z00_1059 = 
GET_CURRENT_OUTPUT_PORT(); 
BgL_auxz00_2875 = 
WRITE_CHAR(((unsigned char)'\n'), BgL_arg2800z00_1059); } 
return 
BCHAR(BgL_auxz00_2875);} } } } 
}



/* generate-jvm-script */
bool_t BGl_generatezd2jvmzd2scriptz00zzjvm_ldz00(obj_t BgL_targetz00_28, obj_t BgL_mainzd2classzd2_29, obj_t BgL_pathz00_30, obj_t BgL_jarnamez00_31, obj_t BgL_za7ipsza7_32)
{ AN_OBJECT;
{ /* Jvm/jld.scm 425 */
{ /* Jvm/jld.scm 427 */
bool_t BgL_test3005z00_1151;
{ /* Jvm/jld.scm 427 */
obj_t BgL_string1z00_1554;
BgL_string1z00_1554 = BGl_za2jvmzd2shellza2zd2zzengine_paramz00; 
BgL_test3005z00_1151 = 
bigloo_strcmp(BgL_string1z00_1554, BGl_string3531z00zzjvm_ldz00); } 
if(BgL_test3005z00_1151)
{ /* Jvm/jld.scm 427 */
return 
BGl_generatezd2jvmzd2shzd2scriptzd2zzjvm_ldz00(BgL_targetz00_28, BgL_mainzd2classzd2_29, BgL_pathz00_30, BgL_za7ipsza7_32);}  else 
{ /* Jvm/jld.scm 429 */
bool_t BgL_test3007z00_1152;
{ /* Jvm/jld.scm 429 */
obj_t BgL_string1z00_1556;
BgL_string1z00_1556 = BGl_za2jvmzd2shellza2zd2zzengine_paramz00; 
BgL_test3007z00_1152 = 
bigloo_strcmp(BgL_string1z00_1556, BGl_string3532z00zzjvm_ldz00); } 
if(BgL_test3007z00_1152)
{ /* Jvm/jld.scm 429 */
return 
BGl_generatezd2jvmzd2msdoszd2scriptzd2zzjvm_ldz00(BgL_targetz00_28, BgL_mainzd2classzd2_29, BgL_pathz00_30, BgL_jarnamez00_31, BgL_za7ipsza7_32);}  else 
{ /* Jvm/jld.scm 429 */
{ /* Jvm/jld.scm 432 */
obj_t BgL_list3010z00_1153;
{ /* Jvm/jld.scm 432 */
obj_t BgL_arg3013z00_1155;
{ /* Jvm/jld.scm 432 */
obj_t BgL_arg3017z00_1157;
{ /* Jvm/jld.scm 432 */
obj_t BgL_arg3020z00_1158;
BgL_arg3020z00_1158 = 
MAKE_PAIR(BGl_string3533z00zzjvm_ldz00, BNIL); 
BgL_arg3017z00_1157 = 
MAKE_PAIR(BGl_za2jvmzd2shellza2zd2zzengine_paramz00, BgL_arg3020z00_1158); } 
BgL_arg3013z00_1155 = 
MAKE_PAIR(BGl_string3534z00zzjvm_ldz00, BgL_arg3017z00_1157); } 
BgL_list3010z00_1153 = 
MAKE_PAIR(BGl_string3560z00zzjvm_ldz00, BgL_arg3013z00_1155); } 
BGl_warningz00zz__errorz00(BgL_list3010z00_1153); } 
return 
BGl_generatezd2jvmzd2shzd2scriptzd2zzjvm_ldz00(BgL_targetz00_28, BgL_mainzd2classzd2_29, BgL_pathz00_30, BgL_za7ipsza7_32);} } } } 
}



/* user-library */
obj_t BGl_userzd2libraryzd2zzjvm_ldz00(obj_t BgL_libz00_33)
{ AN_OBJECT;
{ /* Jvm/jld.scm 439 */
{ 
obj_t BgL_libz00_1162;
{ /* Jvm/jld.scm 450 */
bool_t BgL_testz00_2958;
BgL_libz00_1162 = BgL_libz00_33; 
{ /* Jvm/jld.scm 441 */
int BgL_lenz00_1164;
BgL_lenz00_1164 = 
STRING_LENGTH(BgL_libz00_1162); 
{ 
long BgL_iz00_1165;
BgL_iz00_1165 = ((long)0); 
BgL_loopz00_1166:
{ /* Jvm/jld.scm 444 */
bool_t BgL_testz00_2960;
{ /* Jvm/jld.scm 444 */
long BgL_auxz00_2961;
BgL_auxz00_2961 = 
(long)(BgL_lenz00_1164); 
BgL_testz00_2960 = 
(BgL_iz00_1165==BgL_auxz00_2961); } 
if(BgL_testz00_2960)
{ /* Jvm/jld.scm 444 */
BgL_testz00_2958 = ((bool_t)0); }  else 
{ /* Jvm/jld.scm 446 */
bool_t BgL_testz00_2964;
{ /* Jvm/jld.scm 446 */
unsigned char BgL_auxz00_2965;
{ /* Jvm/jld.scm 446 */
int BgL_auxz00_2966;
BgL_auxz00_2966 = 
(int)(BgL_iz00_1165); 
BgL_auxz00_2965 = 
STRING_REF(BgL_libz00_1162, BgL_auxz00_2966); } 
BgL_testz00_2964 = 
(BgL_auxz00_2965==((unsigned char)'/')); } 
if(BgL_testz00_2964)
{ /* Jvm/jld.scm 446 */
BgL_testz00_2958 = ((bool_t)1); }  else 
{ /* Jvm/jld.scm 446 */
{ 
long BgL_iz00_2970;
BgL_iz00_2970 = 
(BgL_iz00_1165+((long)1)); 
BgL_iz00_1165 = BgL_iz00_2970; 
goto BgL_loopz00_1166;} } } } } } 
if(BgL_testz00_2958)
{ /* Jvm/jld.scm 450 */
return BgL_libz00_33;}  else 
{ /* Jvm/jld.scm 450 */
return 
BGl_makezd2filezd2namez00zz__osz00(
BGl_jvmzd2classpathzd2zzjvm_ldz00(), BgL_libz00_33);} } } } 
}



/* list->path-string */
obj_t BGl_listzd2ze3pathzd2stringze3zzjvm_ldz00(obj_t BgL_pathz00_34, char * BgL_separatorz00_35)
{ AN_OBJECT;
{ /* Jvm/jld.scm 457 */
{ /* Jvm/jld.scm 458 */
obj_t BgL_rpathz00_1172;
BgL_rpathz00_1172 = 
bgl_reverse(BgL_pathz00_34); 
{ 
obj_t BgL_pathz00_1173;obj_t BgL_resz00_1174;
BgL_pathz00_1173 = 
CDR(BgL_rpathz00_1172); 
BgL_resz00_1174 = 
CAR(BgL_rpathz00_1172); 
BgL_loopz00_1175:
if(
NULLP(BgL_pathz00_1173))
{ /* Jvm/jld.scm 461 */
return BgL_resz00_1174;}  else 
{ /* Jvm/jld.scm 463 */
obj_t BgL_arg3054z00_1179;obj_t BgL_arg3055z00_1180;
BgL_arg3054z00_1179 = 
CDR(BgL_pathz00_1173); 
{ /* Jvm/jld.scm 463 */
obj_t BgL_auxz00_2980;obj_t BgL_auxz00_2978;
BgL_auxz00_2980 = 
string_to_bstring(BgL_separatorz00_35); 
BgL_auxz00_2978 = 
CAR(BgL_pathz00_1173); 
BgL_arg3055z00_1180 = 
string_append_3(BgL_auxz00_2978, BgL_auxz00_2980, BgL_resz00_1174); } 
{ 
obj_t BgL_resz00_2984;obj_t BgL_pathz00_2983;
BgL_pathz00_2983 = BgL_arg3054z00_1179; 
BgL_resz00_2984 = BgL_arg3055z00_1180; 
BgL_resz00_1174 = BgL_resz00_2984; 
BgL_pathz00_1173 = BgL_pathz00_2983; 
goto BgL_loopz00_1175;} } } } } 
}



/* string-replace! */
obj_t BGl_stringzd2replacez12zc0zzjvm_ldz00(obj_t BgL_strz00_38, unsigned char BgL_fromz00_39, unsigned char BgL_toz00_40)
{ AN_OBJECT;
{ /* Jvm/jld.scm 480 */
{ /* Jvm/jld.scm 481 */
int BgL_lenz00_1182;
BgL_lenz00_1182 = 
STRING_LENGTH(BgL_strz00_38); 
{ 
long BgL_iz00_1183;
BgL_iz00_1183 = ((long)0); 
BgL_loopz00_1184:
{ /* Jvm/jld.scm 484 */
bool_t BgL_testz00_2988;
{ /* Jvm/jld.scm 484 */
long BgL_auxz00_2989;
BgL_auxz00_2989 = 
(long)(BgL_lenz00_1182); 
BgL_testz00_2988 = 
(BgL_iz00_1183==BgL_auxz00_2989); } 
if(BgL_testz00_2988)
{ /* Jvm/jld.scm 484 */
return BgL_strz00_38;}  else 
{ /* Jvm/jld.scm 486 */
bool_t BgL_testz00_2992;
{ /* Jvm/jld.scm 486 */
unsigned char BgL_auxz00_2993;
{ /* Jvm/jld.scm 486 */
int BgL_auxz00_2994;
BgL_auxz00_2994 = 
(int)(BgL_iz00_1183); 
BgL_auxz00_2993 = 
STRING_REF(BgL_strz00_38, BgL_auxz00_2994); } 
BgL_testz00_2992 = 
(BgL_auxz00_2993==BgL_fromz00_39); } 
if(BgL_testz00_2992)
{ /* Jvm/jld.scm 486 */
{ /* Jvm/jld.scm 487 */
int BgL_auxz00_2998;
BgL_auxz00_2998 = 
(int)(BgL_iz00_1183); 
STRING_SET(BgL_strz00_38, BgL_auxz00_2998, BgL_toz00_40); } 
{ 
long BgL_iz00_3001;
BgL_iz00_3001 = 
(BgL_iz00_1183+((long)1)); 
BgL_iz00_1183 = BgL_iz00_3001; 
goto BgL_loopz00_1184;} }  else 
{ /* Jvm/jld.scm 486 */
{ 
long BgL_iz00_3003;
BgL_iz00_3003 = 
(BgL_iz00_1183+((long)1)); 
BgL_iz00_1183 = BgL_iz00_3003; 
goto BgL_loopz00_1184;} } } } } } } 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzjvm_ldz00()
{ AN_OBJECT;
{ /* Jvm/jld.scm 16 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzjvm_ldz00()
{ AN_OBJECT;
{ /* Jvm/jld.scm 16 */
BGl_modulezd2initializa7ationz75zzengine_paramz00(((long)189840), "jvm_ld"); 
BGl_modulezd2initializa7ationz75zzengine_configurez00(((long)41063), "jvm_ld"); 
BGl_modulezd2initializa7ationz75zzengine_linkz00(((long)35235), "jvm_ld"); 
BGl_modulezd2initializa7ationz75zztools_speekz00(((long)23545), "jvm_ld"); 
BGl_modulezd2initializa7ationz75zztools_errorz00(((long)17886), "jvm_ld"); 
BGl_modulezd2initializa7ationz75zzread_readerz00(((long)36963), "jvm_ld"); 
BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long)12859), "jvm_ld"); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)28259), "jvm_ld"); 
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19010), "jvm_ld"); 
return 
BGl_modulezd2initializa7ationz75zzjvm_externz00(((long)54304), "jvm_ld");} 
}

